/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/base/common/types","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/base/common/resources","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/extensions/common/extensions","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ae=function(Z){for(var e=[],k=0,i=Z.length;k<i;k++)e[k]=oe[Z[k]];return e};define(oe[51],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(T,R)=>` ${R} `).trim():""}e.getCodiconAriaLabel=k;class i{constructor(T,R,P){this.id=T,this.definition=R,this.description=P,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}e.Codicon=i,i.a=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.commentDraft=new i("comment-draft",{fontCharacter:"\\ec0e"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var D;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function R(I){if(I instanceof i)return["codicon","codicon-"+I.id];const C=T.exec(I.id);if(!C)return R(i.error);const[,w,y]=C,h=["codicon","codicon-"+w];return y&&h.push("codicon-modifier-"+y.substring(1)),h}A.asClassNameArray=R;function P(I){return R(I).join(" ")}A.asClassName=P;function b(I){return"."+R(I).join(".")}A.asCSSSelector=b})(D=e.CSSIcon||(e.CSSIcon={}))}),define(oe[63],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(T){return(R,P,b)=>{let I=null,C=null;if(typeof b.value=="function"?(I="value",C=b.value):typeof b.get=="function"&&(I="get",C=b.get),!C)throw new Error("not supported");b[I]=T(C,P)}}function i(T,R,P){let b=null,I=null;if(typeof P.value=="function"?(b="value",I=P.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(b="get",I=P.get),!I)throw new Error("not supported");const C=`$memoize$${R}`;P[b]=function(...w){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,w)}),this[C]}}e.memoize=i;function D(T,R,P){return k((b,I)=>{const C=`$debounce$${I}`,w=`$debounce$result$${I}`;return function(...y){this[w]||(this[w]=P?P():void 0),clearTimeout(this[C]),R&&(this[w]=R(this[w],...y),y=[this[w]]),this[C]=setTimeout(()=>{b.apply(this,y),this[w]=P?P():void 0},T)}})}e.debounce=D;function A(T,R,P){return k((b,I)=>{const C=`$throttle$timer$${I}`,w=`$throttle$result$${I}`,y=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...m){if(this[w]||(this[w]=P?P():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),R&&(this[w]=R(this[w],...m)),this[h])return;const g=this[y]+T;g<=Date.now()?(this[y]=Date.now(),b.apply(this,[this[w]]),this[w]=P?P():void 0):(this[h]=!0,this[C]=setTimeout(()=>{this[h]=!1,this[y]=Date.now(),b.apply(this,[this[w]]),this[w]=P?P():void 0},g-Date.now()))}})}e.throttle=A}),define(oe[9],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?p.isErrorNoTelemetry(n)?new p(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(r=>{r(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=k,e.errorHandler=new k;function i(d){e.errorHandler.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=i;function D(d){P(d)||e.errorHandler.onUnexpectedError(d)}e.onUnexpectedError=D;function A(d){P(d)||e.errorHandler.onUnexpectedExternalError(d)}e.onUnexpectedExternalError=A;function T(d){if(d instanceof Error){const{name:n,message:r}=d,t=d.stacktrace||d.stack;return{$isError:!0,name:n,message:r,stack:t,noTelemetry:p.isErrorNoTelemetry(d)}}return d}e.transformErrorForSerialization=T;const R="Canceled";function P(d){return d instanceof b?!0:d instanceof Error&&d.name===R&&d.message===R}e.isCancellationError=P;class b extends Error{constructor(){super(R),this.name=this.message}}e.CancellationError=b;function I(){const d=new Error(R);return d.name=d.message,d}e.canceled=I;function C(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.illegalArgument=C;function w(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.illegalState=w;function y(d){return d?new Error(`readonly property '${d} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function h(d){const n=new Error(`${d} has been disposed`);return n.name="DISPOSED",n}e.disposed=h;function m(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.getErrorMessage=m;class g extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=g;class l extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=l;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=f;class p extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof p)return n;const r=new p;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=p;class v extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,v.prototype);debugger}}e.BugIndicatingError=v}),define(oe[20],ae([0,1,9]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function i(J,_=0){return J[J.length-(1+_)]}e.tail=i;function D(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}e.tail2=D;function A(J,_,re=(ue,le)=>ue===le){if(J===_)return!0;if(!J||!_||J.length!==_.length)return!1;for(let ue=0,le=J.length;ue<le;ue++)if(!re(J[ue],_[ue]))return!1;return!0}e.equals=A;function T(J,_){const re=J.length-1;_<re&&(J[_]=J[re]),J.pop()}e.removeFastWithoutKeepingOrder=T;function R(J,_,re){return P(J.length,ue=>re(J[ue],_))}e.binarySearch=R;function P(J,_){let re=0,ue=J-1;for(;re<=ue;){const le=(re+ue)/2|0,ye=_(le);if(ye<0)re=le+1;else if(ye>0)ue=le-1;else return le}return-(re+1)}e.binarySearch2=P;function b(J,_){let re=0,ue=J.length;if(ue===0)return 0;for(;re<ue;){const le=Math.floor((re+ue)/2);_(J[le])?ue=le:re=le+1}return re}e.findFirstInSorted=b;function I(J,_,re){if(J=J|0,J>=_.length)throw new TypeError("invalid index");const ue=_[Math.floor(_.length*Math.random())],le=[],ye=[],Se=[];for(const be of _){const Ee=re(be,ue);Ee<0?le.push(be):Ee>0?ye.push(be):Se.push(be)}return J<le.length?I(J,le,re):J<le.length+Se.length?Se[0]:I(J-(le.length+Se.length),ye,re)}e.quickSelect=I;function C(J,_){const re=[];let ue;for(const le of J.slice(0).sort(_))!ue||_(ue[0],le)!==0?(ue=[le],re.push(ue)):ue.push(le);return re}e.groupBy=C;function w(J,_,re){const ue=[];function le(be,Ee,Ne){if(Ee===0&&Ne.length===0)return;const Fe=ue[ue.length-1];Fe&&Fe.start+Fe.deleteCount===be?(Fe.deleteCount+=Ee,Fe.toInsert.push(...Ne)):ue.push({start:be,deleteCount:Ee,toInsert:Ne})}let ye=0,Se=0;for(;;){if(ye===J.length){le(ye,0,_.slice(Se));break}if(Se===_.length){le(ye,J.length-ye,[]);break}const be=J[ye],Ee=_[Se],Ne=re(be,Ee);Ne===0?(ye+=1,Se+=1):Ne<0?(le(ye,1,[]),ye+=1):Ne>0&&(le(ye,0,[Ee]),Se+=1)}return ue}e.sortedDiff=w;function y(J,_,re){const ue=w(J,_,re),le=[],ye=[];for(const Se of ue)le.push(...J.slice(Se.start,Se.start+Se.deleteCount)),ye.push(...Se.toInsert);return{removed:le,added:ye}}e.delta=y;function h(J,_,re){if(re===0)return[];const ue=J.slice(0,re).sort(_);return g(J,_,ue,re,J.length),ue}e.top=h;function m(J,_,re,ue,le){return re===0?Promise.resolve([]):new Promise((ye,Se)=>{(async()=>{const be=J.length,Ee=J.slice(0,re).sort(_);for(let Ne=re,Fe=Math.min(re+ue,be);Ne<be;Ne=Fe,Fe=Math.min(Fe+ue,be)){if(Ne>re&&await new Promise(Ye=>setTimeout(Ye)),le&&le.isCancellationRequested)throw new k.CancellationError;g(J,_,Ee,Ne,Fe)}return Ee})().then(ye,Se)})}e.topAsync=m;function g(J,_,re,ue,le){for(const ye=re.length;ue<le;ue++){const Se=J[ue];if(_(Se,re[ye-1])<0){re.pop();const be=b(re,Ee=>_(Se,Ee)<0);re.splice(be,0,Se)}}}function l(J){return J.filter(_=>!!_)}e.coalesce=l;function f(J){let _=0;for(let re=0;re<J.length;re++)J[re]&&(J[_]=J[re],_+=1);J.length=_}e.coalesceInPlace=f;function p(J,_,re){J.splice(re,0,J.splice(_,1)[0])}e.move=p;function v(J){return!Array.isArray(J)||J.length===0}e.isFalsyOrEmpty=v;function d(J){return Array.isArray(J)&&J.length>0}e.isNonEmptyArray=d;function n(J,_=re=>re){const re=new Set;return J.filter(ue=>{const le=_(ue);return re.has(le)?!1:(re.add(le),!0)})}e.distinct=n;function r(J){const _=new Set;return re=>{const ue=J(re);return _.has(ue)?!1:(_.add(ue),!0)}}e.uniqueFilter=r;function t(J,_){const re=s(J,_);if(re!==-1)return J[re]}e.findLast=t;function s(J,_){for(let re=J.length-1;re>=0;re--){const ue=J[re];if(_(ue))return re}return-1}e.lastIndex=s;function a(J,_){return J.length>0?J[0]:_}e.firstOrDefault=a;function c(J,_){return J.length>0?J[J.length-1]:_}e.lastOrDefault=c;function o(J,_,re=(ue,le)=>ue===le){let ue=0;for(let le=0,ye=Math.min(J.length,_.length);le<ye&&re(J[le],_[le]);le++)ue++;return ue}e.commonPrefixLength=o;function u(J){return[].concat(...J)}e.flatten=u;function S(J,_){let re=typeof _=="number"?J:0;typeof _=="number"?re=J:(re=0,_=J);const ue=[];if(re<=_)for(let le=re;le<_;le++)ue.push(le);else for(let le=re;le>_;le--)ue.push(le);return ue}e.range=S;function E(J,_,re){return J.reduce((ue,le)=>(ue[_(le)]=re?re(le):le,ue),Object.create(null))}e.index=E;function M(J,_){return J.push(_),()=>N(J,_)}e.insert=M;function N(J,_){const re=J.indexOf(_);if(re>-1)return J.splice(re,1),_}e.remove=N;function j(J,_,re){const ue=J.slice(0,_),le=J.slice(_);return ue.concat(re,le)}e.arrayInsert=j;function $(J,_){let re;if(typeof _=="number"){let ue=_;re=()=>{const le=Math.sin(ue++)*179426549;return le-Math.floor(le)}}else re=Math.random;for(let ue=J.length-1;ue>0;ue-=1){const le=Math.floor(re()*(ue+1)),ye=J[ue];J[ue]=J[le],J[le]=ye}}e.shuffle=$;function L(J,_){const re=J.indexOf(_);re>-1&&(J.splice(re,1),J.unshift(_))}e.pushToStart=L;function F(J,_){const re=J.indexOf(_);re>-1&&(J.splice(re,1),J.push(_))}e.pushToEnd=F;function z(J,_){for(const re of _)J.push(re)}e.pushMany=z;function W(J,_){return Array.isArray(J)?J.map(_):_(J)}e.mapArrayOrNot=W;function H(J){return Array.isArray(J)?J:[J]}e.asArray=H;function Q(J){return J[Math.floor(Math.random()*J.length)]}e.getRandomElement=Q;function K(J,_){for(const re of J){const ue=_(re);if(ue!==void 0)return ue}}e.mapFind=K;function V(J,_,re){const ue=x(J,_),le=J.length,ye=re.length;J.length=le+ye;for(let Se=le-1;Se>=ue;Se--)J[Se+ye]=J[Se];for(let Se=0;Se<ye;Se++)J[Se+ue]=re[Se]}e.insertInto=V;function G(J,_,re,ue){const le=x(J,_),ye=J.splice(le,re);return V(J,le,ue),ye}e.splice=G;function x(J,_){return _<0?Math.max(_+J.length,0):Math.min(_,J.length)}var ne;(function(J){function _(le){return le<0}J.isLessThan=_;function re(le){return le>0}J.isGreaterThan=re;function ue(le){return le===0}J.isNeitherLessOrGreaterThan=ue,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(ne=e.CompareResult||(e.CompareResult={}));function se(J,_){return(re,ue)=>_(J(re),J(ue))}e.compareBy=se;function ie(...J){return(_,re)=>{for(const ue of J){const le=ue(_,re);if(!ne.isNeitherLessOrGreaterThan(le))return le}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=ie;const O=(J,_)=>J-_;e.numberComparator=O;function U(J,_){if(J.length===0)return;let re=J[0];for(let ue=1;ue<J.length;ue++){const le=J[ue];_(le,re)>0&&(re=le)}return re}e.findMaxBy=U;function q(J,_){if(J.length===0)return;let re=J[0];for(let ue=1;ue<J.length;ue++){const le=J[ue];_(le,re)>=0&&(re=le)}return re}e.findLastMaxBy=q;function B(J,_){return U(J,(re,ue)=>-_(re,ue))}e.findMinBy=B;class X{constructor(_){this.f=_,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(_){let re=this.c;for(;re<this.f.length&&_(this.f[re]);)re++;const ue=re===this.c?null:this.f.slice(this.c,re);return this.c=re,ue}takeFromEndWhile(_){let re=this.d;for(;re>=0&&_(this.f[re]);)re--;const ue=re===this.d?null:this.f.slice(re+1,this.d+1);return this.d=re,ue}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const _=this.f[this.c];return this.c++,_}removeLast(){const _=this.f[this.d];return this.d--,_}takeCount(_){const re=this.f.slice(this.c,this.c+_);return this.c+=_,re}}e.ArrayQueue=X;class ee{constructor(_){this.iterate=_}forEach(_){this.iterate(re=>(_(re),!0))}toArray(){const _=[];return this.iterate(re=>(_.push(re),!0)),_}filter(_){return new ee(re=>this.iterate(ue=>_(ue)?re(ue):!0))}map(_){return new ee(re=>this.iterate(ue=>re(_(ue))))}some(_){let re=!1;return this.iterate(ue=>(re=_(ue),!re)),re}findFirst(_){let re;return this.iterate(ue=>_(ue)?(re=ue,!1):!0),re}findLast(_){let re;return this.iterate(ue=>(_(ue)&&(re=ue),!0)),re}findLastMaxBy(_){let re,ue=!0;return this.iterate(le=>((ue||ne.isGreaterThan(_(le,re)))&&(ue=!1,re=le),!0)),re}}e.CallbackIterable=ee,ee.empty=new ee(J=>{})}),define(oe[126],ae([0,1,9]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function i(P,b){if(!P)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=i;function D(P,b="Unreachable"){throw new Error(b)}e.assertNever=D;function A(P){if(!P)throw new k.BugIndicatingError("Assertion Failed")}e.assert=A;function T(P){if(!P()){debugger;P(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function R(P,b){let I=0;for(;I<P.length-1;){const C=P[I],w=P[I+1];if(!b(C,w))return!1;I++}return!0}e.checkAdjacentItems=R}),define(oe[82],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(i){const D=this;let A=!1,T;return function(){return A||(A=!0,T=i.apply(D,arguments)),T}}e.once=k}),define(oe[64],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(i){function D(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}i.is=D;const A=Object.freeze([]);function T(){return A}i.empty=T;function*R(v){yield v}i.single=R;function P(v){return D(v)?v:R(v)}i.wrap=P;function b(v){return v||A}i.from=b;function I(v){return!v||v[Symbol.iterator]().next().done===!0}i.isEmpty=I;function C(v){return v[Symbol.iterator]().next().value}i.first=C;function w(v,d){for(const n of v)if(d(n))return!0;return!1}i.some=w;function y(v,d){for(const n of v)if(d(n))return n}i.find=y;function*h(v,d){for(const n of v)d(n)&&(yield n)}i.filter=h;function*m(v,d){let n=0;for(const r of v)yield d(r,n++)}i.map=m;function*g(...v){for(const d of v)for(const n of d)yield n}i.concat=g;function l(v,d,n){let r=n;for(const t of v)r=d(r,t);return r}i.reduce=l;function*f(v,d,n=v.length){for(d<0&&(d+=v.length),n<0?n+=v.length:n>v.length&&(n=v.length);d<n;d++)yield v[d]}i.slice=f;function p(v,d=Number.POSITIVE_INFINITY){const n=[];if(d===0)return[n,v];const r=v[Symbol.iterator]();for(let t=0;t<d;t++){const s=r.next();if(s.done)return[n,i.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return r}}]}i.consume=p})(k=e.Iterable||(e.Iterable={}))}),define(oe[35],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var i;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(n){n.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function T(n,r=!1){let t=0;const s=n.length;let a="",c=0,o=16,u=0;function S(F){let z=0,W=0;for(;z<F;){const H=n.charCodeAt(t);if(H>=48&&H<=57)W=W*16+H-48;else if(H>=65&&H<=70)W=W*16+H-65+10;else if(H>=97&&H<=102)W=W*16+H-97+10;else break;t++,z++}return z<F&&(W=-1),W}function E(F){t=F,a="",c=0,o=16,u=0}function M(){const F=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&b(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&b(n.charCodeAt(t)))for(t++;t<n.length&&b(n.charCodeAt(t));)t++;else return u=3,n.substring(F,t);let z=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&b(n.charCodeAt(t))){for(t++;t<n.length&&b(n.charCodeAt(t));)t++;z=t}else u=3;return n.substring(F,z)}function N(){let F="",z=t;for(;;){if(t>=s){F+=n.substring(z,t),u=2;break}const W=n.charCodeAt(t);if(W===34){F+=n.substring(z,t),t++;break}if(W===92){if(F+=n.substring(z,t),t++,t>=s){u=2;break}switch(n.charCodeAt(t++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const Q=S(4);Q>=0?F+=String.fromCharCode(Q):u=4;break}default:u=5}z=t;continue}if(W>=0&&W<=31)if(P(W)){F+=n.substring(z,t),u=2;break}else u=6;t++}return F}function j(){if(a="",u=0,c=t,t>=s)return c=s,o=17;let F=n.charCodeAt(t);if(R(F)){do t++,a+=String.fromCharCode(F),F=n.charCodeAt(t);while(R(F));return o=15}if(P(F))return t++,a+=String.fromCharCode(F),F===13&&n.charCodeAt(t)===10&&(t++,a+=`
`),o=14;switch(F){case 123:return t++,o=1;case 125:return t++,o=2;case 91:return t++,o=3;case 93:return t++,o=4;case 58:return t++,o=6;case 44:return t++,o=5;case 34:return t++,a=N(),o=10;case 47:{const z=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<s&&!P(n.charCodeAt(t));)t++;return a=n.substring(z,t),o=12}if(n.charCodeAt(t+1)===42){t+=2;const W=s-1;let H=!1;for(;t<W;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,H=!0;break}t++}return H||(t++,u=1),a=n.substring(z,t),o=13}return a+=String.fromCharCode(F),t++,o=16}case 45:if(a+=String.fromCharCode(F),t++,t===s||!b(n.charCodeAt(t)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=M(),o=11;default:for(;t<s&&$(F);)t++,F=n.charCodeAt(t);if(c!==t){switch(a=n.substring(c,t),a){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return a+=String.fromCharCode(F),t++,o=16}}function $(F){if(R(F)||P(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let F;do F=j();while(F>=12&&F<=15);return F}return{setPosition:E,getPosition:()=>t,scan:r?L:j,getToken:()=>o,getTokenValue:()=>a,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>u}}e.createScanner=T;function R(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function P(n){return n===10||n===13||n===8232||n===8233}function b(n){return n>=48&&n<=57}var I;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(I||(I={}));function C(n,r){const t=[],s=new Object;let a;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function u(S,E,M,N){c.value=S,c.offset=E,c.length=M,c.type=N,c.colonOffset=void 0,a=c}try{p(n,{onObjectBegin:(S,E)=>{if(r<=S)throw s;a=void 0,o=r>S,t.push("")},onObjectProperty:(S,E,M)=>{if(r<E||(u(S,E,M,"property"),t[t.length-1]=S,r<=E+M))throw s},onObjectEnd:(S,E)=>{if(r<=S)throw s;a=void 0,t.pop()},onArrayBegin:(S,E)=>{if(r<=S)throw s;a=void 0,t.push(0)},onArrayEnd:(S,E)=>{if(r<=S)throw s;a=void 0,t.pop()},onLiteralValue:(S,E,M)=>{if(r<E||(u(S,E,M,d(S)),r<=E+M))throw s},onSeparator:(S,E,M)=>{if(r<=E)throw s;if(S===":"&&a&&a.type==="property")a.colonOffset=E,o=!1,a=void 0;else if(S===","){const N=t[t.length-1];typeof N=="number"?t[t.length-1]=N+1:(o=!0,t[t.length-1]=""),a=void 0}}})}catch(S){if(S!==s)throw S}return{path:t,previousNode:a,isAtPropertyKey:o,matches:S=>{let E=0;for(let M=0;E<S.length&&M<t.length;M++)if(S[E]===t[M]||S[E]==="*")E++;else if(S[E]!=="**")return!1;return E===S.length}}}e.getLocation=C;function w(n,r=[],t=A.DEFAULT){let s=null,a=[];const c=[];function o(S){Array.isArray(a)?a.push(S):s!==null&&(a[s]=S)}return p(n,{onObjectBegin:()=>{const S={};o(S),c.push(a),a=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const S=[];o(S),c.push(a),a=S,s=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:o,onError:(S,E,M)=>{r.push({error:S,offset:E,length:M})}},t),a[0]}e.parse=w;function y(n,r=[],t=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(S){s.type==="property"&&(s.length=S-s.offset,s=s.parent)}function c(S){return s.children.push(S),S}p(n,{onObjectBegin:S=>{s=c({type:"object",offset:S,length:-1,parent:s,children:[]})},onObjectProperty:(S,E,M)=>{s=c({type:"property",offset:E,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:S,offset:E,length:M,parent:s})},onObjectEnd:(S,E)=>{s.length=S+E-s.offset,s=s.parent,a(S+E)},onArrayBegin:(S,E)=>{s=c({type:"array",offset:S,length:-1,parent:s,children:[]})},onArrayEnd:(S,E)=>{s.length=S+E-s.offset,s=s.parent,a(S+E)},onLiteralValue:(S,E,M)=>{c({type:d(S),offset:E,length:M,parent:s,value:S}),a(E+M)},onSeparator:(S,E,M)=>{s.type==="property"&&(S===":"?s.colonOffset=E:S===","&&a(E))},onError:(S,E,M)=>{r.push({error:S,offset:E,length:M})}},t);const u=s.children[0];return u&&delete u.parent,u}e.parseTree=y;function h(n,r){if(!n)return;let t=n;for(const s of r)if(typeof s=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let a=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===s){t=c.children[1],a=!0;break}if(!a)return}else{const a=s;if(t.type!=="array"||a<0||!Array.isArray(t.children)||a>=t.children.length)return;t=t.children[a]}return t}e.findNodeAtLocation=h;function m(n){if(!n.parent||!n.parent.children)return[];const r=m(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}e.getNodePath=m;function g(n){switch(n.type){case"array":return n.children.map(g);case"object":{const r=Object.create(null);for(const t of n.children){const s=t.children[1];s&&(r[t.children[0].value]=g(s))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=g;function l(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}e.contains=l;function f(n,r,t=!1){if(l(n,r,t)){const s=n.children;if(Array.isArray(s))for(let a=0;a<s.length&&s[a].offset<=r;a++){const c=f(s[a],r,t);if(c)return c}return n}}e.findNodeAtOffset=f;function p(n,r,t=A.DEFAULT){const s=T(n,!1);function a(se){return se?()=>se(s.getTokenOffset(),s.getTokenLength()):()=>!0}function c(se){return se?ie=>se(ie,s.getTokenOffset(),s.getTokenLength()):()=>!0}const o=a(r.onObjectBegin),u=c(r.onObjectProperty),S=a(r.onObjectEnd),E=a(r.onArrayBegin),M=a(r.onArrayEnd),N=c(r.onLiteralValue),j=c(r.onSeparator),$=a(r.onComment),L=c(r.onError),F=t&&t.disallowComments,z=t&&t.allowTrailingComma;function W(){for(;;){const se=s.scan();switch(s.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:F||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(se){case 12:case 13:F?H(10):$();break;case 16:H(1);break;case 15:case 14:break;default:return se}}}function H(se,ie=[],O=[]){if(L(se),ie.length+O.length>0){let U=s.getToken();for(;U!==17;){if(ie.indexOf(U)!==-1){W();break}else if(O.indexOf(U)!==-1)break;U=W()}}}function Q(se){const ie=s.getTokenValue();return se?N(ie):u(ie),W(),!0}function K(){switch(s.getToken()){case 11:{let se=0;try{se=JSON.parse(s.getTokenValue()),typeof se!="number"&&(H(2),se=0)}catch{H(2)}N(se);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return W(),!0}function V(){return s.getToken()!==10?(H(3,[],[2,5]),!1):(Q(!1),s.getToken()===6?(j(":"),W(),ne()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function G(){o(),W();let se=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(se||H(4,[],[]),j(","),W(),s.getToken()===2&&z)break}else se&&H(6,[],[]);V()||H(4,[],[2,5]),se=!0}return S(),s.getToken()!==2?H(7,[2],[]):W(),!0}function x(){E(),W();let se=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(se||H(4,[],[]),j(","),W(),s.getToken()===4&&z)break}else se&&H(6,[],[]);ne()||H(4,[],[4,5]),se=!0}return M(),s.getToken()!==4?H(8,[4],[]):W(),!0}function ne(){switch(s.getToken()){case 3:return x();case 1:return G();case 10:return Q(!0);default:return K()}}return W(),s.getToken()===17?t.allowEmptyContent?!0:(H(4,[],[]),!1):ne()?(s.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=p;function v(n,r){const t=T(n),s=[];let a,c=0,o;do switch(o=t.getPosition(),a=t.scan(),a){case 12:case 13:case 17:c!==o&&s.push(n.substring(c,o)),r!==void 0&&s.push(t.getTokenValue().replace(/[^\r\n]/g,r)),c=t.getPosition();break}while(a!==17);return s.join("")}e.stripComments=v;function d(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),define(oe[43],ae([0,1,35]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(b,I,C){let w,y,h,m,g;if(I){for(m=I.offset,g=m+I.length,h=m;h>0&&!P(b,h-1);)h--;let o=g;for(;o<b.length&&!P(b,o);)o++;y=b.substring(h,o),w=T(y,C)}else y=b,w=0,h=0,m=0,g=b.length;const l=R(C,b);let f=!1,p=0,v;C.insertSpaces?v=A(" ",C.tabSize||4):v="	";const d=(0,k.createScanner)(y,!1);let n=!1;function r(){return l+A(v,w+p)}function t(){let o=d.scan();for(f=!1;o===15||o===14;)f=f||o===14,o=d.scan();return n=o===16||d.getTokenError()!==0,o}const s=[];function a(o,u,S){!n&&u<g&&S>m&&b.substring(u,S)!==o&&s.push({offset:u,length:S-u,content:o})}let c=t();if(c!==17){const o=d.getTokenOffset()+h,u=A(v,w);a(u,h,o)}for(;c!==17;){let o=d.getTokenOffset()+d.getTokenLength()+h,u=t(),S="";for(;!f&&(u===12||u===13);){const M=d.getTokenOffset()+h;a(" ",o,M),o=d.getTokenOffset()+d.getTokenLength()+h,S=u===12?r():"",u=t()}if(u===2)c!==1&&(p--,S=r());else if(u===4)c!==3&&(p--,S=r());else{switch(c){case 3:case 1:p++,S=r();break;case 5:case 12:S=r();break;case 13:f?S=r():S=" ";break;case 6:S=" ";break;case 10:if(u===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?S=" ":u!==5&&u!==17&&(n=!0);break;case 16:n=!0;break}f&&(u===12||u===13)&&(S=r())}const E=d.getTokenOffset()+h;a(S,o,E),c=u}return s}e.format=i;function D(b,I){const C=JSON.stringify(b,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?C.replace(/\r\n|\r|\n/g,I.eol):C}e.toFormattedString=D;function A(b,I){let C="";for(let w=0;w<I;w++)C+=b;return C}function T(b,I){let C=0,w=0;const y=I.tabSize||4;for(;C<b.length;){const h=b.charAt(C);if(h===" ")w++;else if(h==="	")w+=y;else break;C++}return Math.floor(w/y)}function R(b,I){for(let C=0;C<I.length;C++){const w=I.charAt(C);if(w==="\r")return C+1<I.length&&I.charAt(C+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=R;function P(b,I){return`\r
`.indexOf(b.charAt(I))!==-1}e.isEOL=P}),define(oe[83],ae([0,1,35,43]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(b,I,C){return A(b,I,void 0,C)}e.removeProperty=D;function A(b,I,C,w,y){const h=I.slice(),m=[],g=(0,k.parseTree)(b,m);let l,f;for(;h.length>0&&(f=h.pop(),l=(0,k.findNodeAtLocation)(g,h),l===void 0&&C!==void 0);)typeof f=="string"?C={[f]:C}:C=[C];if(l)if(l.type==="object"&&typeof f=="string"&&Array.isArray(l.children)){const p=(0,k.findNodeAtLocation)(l,[f]);if(p!==void 0)if(C===void 0){if(!p.parent)throw new Error("Malformed AST");const v=l.children.indexOf(p.parent);let d,n=p.parent.offset+p.parent.length;if(v>0){const r=l.children[v-1];d=r.offset+r.length}else d=l.offset+1,l.children.length>1&&(n=l.children[1].offset);return T(b,{offset:d,length:n-d,content:""},w)}else return T(b,{offset:p.offset,length:p.length,content:JSON.stringify(C)},w);else{if(C===void 0)return[];const v=`${JSON.stringify(f)}: ${JSON.stringify(C)}`,d=y?y(l.children.map(r=>r.children[0].value)):l.children.length;let n;if(d>0){const r=l.children[d-1];n={offset:r.offset+r.length,length:0,content:","+v}}else l.children.length===0?n={offset:l.offset+1,length:0,content:v}:n={offset:l.offset+1,length:0,content:v+","};return T(b,n,w)}}else if(l.type==="array"&&typeof f=="number"&&Array.isArray(l.children))if(C!==void 0){const p=`${JSON.stringify(C)}`;let v;if(l.children.length===0||f===0)v={offset:l.offset+1,length:0,content:l.children.length===0?p:p+","};else{const d=f===-1||f>l.children.length?l.children.length:f,n=l.children[d-1];v={offset:n.offset+n.length,length:0,content:","+p}}return T(b,v,w)}else{const p=f,v=l.children[p];let d;if(l.children.length===1)d={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===p){const n=l.children[p-1],r=n.offset+n.length,t=l.offset+l.length;d={offset:r,length:t-2-r,content:""}}else d={offset:v.offset,length:l.children[p+1].offset-v.offset,content:""};return T(b,d,w)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${l.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return T(b,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(C)},w)}}e.setProperty=A;function T(b,I,C){let w=R(b,I),y=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;y>0&&!(0,i.isEOL)(w,y-1);)y--;for(;h<w.length&&!(0,i.isEOL)(w,h);)h++}const m=(0,i.format)(w,{offset:y,length:h-y},C);for(let l=m.length-1;l>=0;l--){const f=m[l];w=R(w,f),y=Math.min(y,f.offset),h=Math.max(h,f.offset+f.length),h+=f.content.length-f.length}const g=b.length-(w.length-h)-y;return[{offset:y,length:g,content:w.substring(y,h)}]}e.withFormatting=T;function R(b,I){return b.substring(0,I.offset)+I.content+b.substring(I.offset+I.length)}e.applyEdit=R;function P(b,I){const C=I.slice(0).sort((y,h)=>{const m=y.offset-h.offset;return m===0?y.length-h.length:m});let w=b.length;for(let y=C.length-1;y>=0;y--){const h=C[y];if(h.offset+h.length<=w)b=R(b,h);else throw new Error("Overlapping edit");w=h.offset}return b}e.applyEdits=P}),define(oe[127],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(D){this.d=D,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(D){return new k(()=>D(this.getValue()))}}e.Lazy=k}),define(oe[2],ae([0,1,82,64]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let A=null;function T(c){A=c}if(e.setDisposableTracker=T,D){const c="__is_disposable_tracked__";T(new class{trackDisposable(o){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(u)},3e3)}setParent(o,u){if(o&&o!==f.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==f.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function R(c){return A?.trackDisposable(c),c}function P(c){A?.markAsDisposed(c)}function b(c,o){A?.setParent(c,o)}function I(c,o){if(!!A)for(const u of c)A.setParent(u,o)}function C(c){return A?.markAsSingleton(c),c}e.markAsSingleton=C;function w(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=w;function y(c){if(i.Iterable.is(c)){const o=[];for(const u of c)if(u)try{u.dispose()}catch(S){o.push(S)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=y;function h(c){for(const o of c)w(o)&&o.dispose();return[]}e.disposeIfDisposable=h;function m(...c){const o=g(()=>y(c));return I(c,o),o}e.combinedDisposable=m;function g(c){const o=R({dispose:(0,k.once)(()=>{P(o),c()})});return o}e.toDisposable=g;class l{constructor(){this.c=new Set,this.f=!1,R(this)}dispose(){this.f||(P(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{y(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return b(o,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this.q=new l,R(this),b(this.q,this)}dispose(){P(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}e.Disposable=f,f.None=Object.freeze({dispose(){}});class p{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&b(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,P(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&b(o,null),o}}e.MutableDisposable=p;class v{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=v;class d{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(o){let u=o;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,P(this))},this}}e.SafeDisposable=d;class n{constructor(){this.a=new Map}acquire(o,...u){let S=this.a.get(o);S||(S={counter:0,object:this.b(o,...u)},this.a.set(o,S));const{object:E}=S,M=(0,k.once)(()=>{--S.counter===0&&(this.c(o,S.object),this.a.delete(o))});return S.counter++,{object:E,dispose:M}}}e.ReferenceCollection=n;class r{constructor(o){this.a=o}async acquire(o,...u){const S=this.a.acquire(o,...u);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(E){throw S.dispose(),E}}}e.AsyncReferenceCollection=r;class t{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=t;function s(c){const o=new l;try{c(o)}finally{o.dispose()}}e.disposeOnReturn=s;class a{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){P(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{y(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,u,S=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),S||this.a.get(o)?.dispose(),this.a.set(o,u)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=a}),define(oe[84],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(A){this.element=A,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class i{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let A=this.a;for(;A!==k.Undefined;){const T=A.next;A.prev=k.Undefined,A.next=k.Undefined,A=T}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,T){const R=new k(A);if(this.a===k.Undefined)this.a=R,this.b=R;else if(T){const b=this.b;this.b=R,R.prev=b,b.next=R}else{const b=this.a;this.a=R,R.next=b,b.prev=R}this.c+=1;let P=!1;return()=>{P||(P=!0,this.e(R))}}shift(){if(this.a!==k.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==k.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==k.Undefined&&A.next!==k.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===k.Undefined&&A.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):A.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):A.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==k.Undefined;)yield A.element,A=A.next}}e.LinkedList=i}),define(oe[37],ae([0,1]),function(Z,e){"use strict";var k,i,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(h,m,g){let l=h.get(m);return l===void 0&&(l=g,h.set(m,l)),l}e.getOrSet=A;function T(h){const m=[];return h.forEach((g,l)=>{m.push(`${l} => ${g}`)}),`Map(${h.size}) {${m.join(", ")}}`}e.mapToString=T;function R(h){const m=[];return h.forEach(g=>{m.push(g)}),`Set(${h.size}) {${m.join(", ")}}`}e.setToString=R;class P{constructor(m,g){this.uri=m,this.value=g}}class b{constructor(m,g){this[k]="ResourceMap",m instanceof b?(this.b=new Map(m.b),this.c=g??b.a):(this.b=new Map,this.c=m??b.a)}set(m,g){return this.b.set(this.c(m),new P(m,g)),this}get(m){return this.b.get(this.c(m))?.value}has(m){return this.b.has(this.c(m))}get size(){return this.b.size}clear(){this.b.clear()}delete(m){return this.b.delete(this.c(m))}forEach(m,g){typeof g<"u"&&(m=m.bind(g));for(const[l,f]of this.b)m(f.value,f.uri,this)}*values(){for(const m of this.b.values())yield m.value}*keys(){for(const m of this.b.values())yield m.uri}*entries(){for(const m of this.b.values())yield[m.uri,m.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,m]of this.b)yield[m.uri,m.value]}}e.ResourceMap=b,b.a=h=>h.toString();class I{constructor(m,g){this[i]="ResourceSet",!m||typeof m=="function"?this.a=new b(m):(this.a=new b(g),m.forEach(this.add,this))}get size(){return this.a.size}add(m){return this.a.set(m,m),this}clear(){this.a.clear()}delete(m){return this.a.delete(m)}forEach(m,g){this.a.forEach((l,f)=>m.call(g,f,f,this))}has(m){return this.a.has(m)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var C;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(C=e.Touch||(e.Touch={}));class w{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(m){return this.a.has(m)}get(m,g=0){const l=this.a.get(m);if(!!l)return g!==0&&this.j(l,g),l.value}set(m,g,l=0){let f=this.a.get(m);if(f)f.value=g,l!==0&&this.j(f,l);else{switch(f={key:m,value:g,next:void 0,previous:void 0},l){case 0:this.h(f);break;case 1:this.g(f);break;case 2:this.h(f);break;default:this.h(f);break}this.a.set(m,f),this.d++}return this}delete(m){return!!this.remove(m)}remove(m){const g=this.a.get(m);if(!!g)return this.a.delete(m),this.i(g),this.d--,g.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const m=this.b;return this.a.delete(m.key),this.i(m),this.d--,m.value}forEach(m,g){const l=this.e;let f=this.b;for(;f;){if(g?m.bind(g)(f.value,f.key,this):m(f.value,f.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const m=this,g=this.e;let l=this.b;const f={[Symbol.iterator](){return f},next(){if(m.e!==g)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:l.key,done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return f}values(){const m=this,g=this.e;let l=this.b;const f={[Symbol.iterator](){return f},next(){if(m.e!==g)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:l.value,done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return f}entries(){const m=this,g=this.e;let l=this.b;const f={[Symbol.iterator](){return f},next(){if(m.e!==g)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:[l.key,l.value],done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return f}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(m){if(m>=this.size)return;if(m===0){this.clear();return}let g=this.b,l=this.size;for(;g&&l>m;)this.a.delete(g.key),g=g.next,l--;this.b=g,this.d=l,g&&(g.previous=void 0),this.e++}g(m){if(!this.b&&!this.c)this.c=m;else if(this.b)m.next=this.b,this.b.previous=m;else throw new Error("Invalid list");this.b=m,this.e++}h(m){if(!this.b&&!this.c)this.b=m;else if(this.c)m.previous=this.c,this.c.next=m;else throw new Error("Invalid list");this.c=m,this.e++}i(m){if(m===this.b&&m===this.c)this.b=void 0,this.c=void 0;else if(m===this.b){if(!m.next)throw new Error("Invalid list");m.next.previous=void 0,this.b=m.next}else if(m===this.c){if(!m.previous)throw new Error("Invalid list");m.previous.next=void 0,this.c=m.previous}else{const g=m.next,l=m.previous;if(!g||!l)throw new Error("Invalid list");g.previous=l,l.next=g}m.next=void 0,m.previous=void 0,this.e++}j(m,g){if(!this.b||!this.c)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(m===this.b)return;const l=m.next,f=m.previous;m===this.c?(f.next=void 0,this.c=f):(l.previous=f,f.next=l),m.previous=void 0,m.next=this.b,this.b.previous=m,this.b=m,this.e++}else if(g===2){if(m===this.c)return;const l=m.next,f=m.previous;m===this.b?(l.previous=void 0,this.b=l):(l.previous=f,f.next=l),m.next=void 0,m.previous=this.c,this.c.next=m,this.c=m,this.e++}}}toJSON(){const m=[];return this.forEach((g,l)=>{m.push([l,g])}),m}fromJSON(m){this.clear();for(const[g,l]of m)this.set(g,l)}}e.LinkedMap=w;class y extends w{constructor(m,g=1){super(),this.k=m,this.l=Math.min(Math.max(0,g),1)}get limit(){return this.k}set limit(m){this.k=m,this.m()}get ratio(){return this.l}set ratio(m){this.l=Math.min(Math.max(0,m),1),this.m()}get(m,g=2){return super.get(m,g)}peek(m){return super.get(m,0)}set(m,g){return super.set(m,g,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=y}),define(oe[85],ae([0,1,37]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new k.LRUCache(1e4);function D(b){return P(b,"NFC",i)}e.normalizeNFC=D;const A=new k.LRUCache(1e4);function T(b){return P(b,"NFD",A)}e.normalizeNFD=T;const R=/[^\u0000-\u0080]/;function P(b,I,C){if(!b)return b;const w=C.get(b);if(w)return w;let y;return R.test(b)?y=b.normalize(I):y=b,C.set(b,y),y}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(I){return T(I).replace(b,"")}}()}),define(oe[128],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function k(R,P,b){return Math.min(Math.max(R,P),b)}e.clamp=k;function i(R,P){return(P+R%P)%P}e.rot=i;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class A{constructor(){this.a=1,this.b=0}update(P){return this.b=this.b+(P-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class T{constructor(P){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(P),this.c.fill(0,0,P)}update(P){const b=this.c[this.d];return this.c[this.d]=P,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=P,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=T}),function(){function Z(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function T(P){A.push(P,Date.now())}function R(){const P=[];for(let b=0;b<A.length;b+=2)P.push({name:A[b],startTime:A[b+1]});return P}return{mark:T,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(D+T.startTime)});return A}};if(typeof process=="object"){const D=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function k(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=k(i))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var i in k)(typeof exports=="object"?exports:Z)[i]=k[i]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function k(i){if(e[i])return e[i].exports;var D=e[i]={i,l:!1,exports:{}};return Z[i].call(D.exports,D,D.exports,k),D.l=!0,D.exports}return k.m=Z,k.c=e,k.d=function(i,D,A){k.o(i,D)||Object.defineProperty(i,D,{enumerable:!0,get:A})},k.r=function(i){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},k.t=function(i,D){if(1&D&&(i=k(i)),8&D||4&D&&typeof i=="object"&&i&&i.__esModule)return i;var A=Object.create(null);if(k.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:i}),2&D&&typeof i!="string")for(var T in i)k.d(A,T,function(R){return i[R]}.bind(null,T));return A},k.n=function(i){var D=i&&i.__esModule?function(){return i.default}:function(){return i};return k.d(D,"a",D),D},k.o=function(i,D){return Object.prototype.hasOwnProperty.call(i,D)},k.p="",k(k.s=0)}([function(Z,e,k){(function(i){var D;e=Z.exports=O,D=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],P=e.src=[],b=0,I=b++;P[I]="0|[1-9]\\d*";var C=b++;P[C]="[0-9]+";var w=b++;P[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=b++;P[y]="("+P[I]+")\\.("+P[I]+")\\.("+P[I]+")";var h=b++;P[h]="("+P[C]+")\\.("+P[C]+")\\.("+P[C]+")";var m=b++;P[m]="(?:"+P[I]+"|"+P[w]+")";var g=b++;P[g]="(?:"+P[C]+"|"+P[w]+")";var l=b++;P[l]="(?:-("+P[m]+"(?:\\."+P[m]+")*))";var f=b++;P[f]="(?:-?("+P[g]+"(?:\\."+P[g]+")*))";var p=b++;P[p]="[0-9A-Za-z-]+";var v=b++;P[v]="(?:\\+("+P[p]+"(?:\\."+P[p]+")*))";var d=b++,n="v?"+P[y]+P[l]+"?"+P[v]+"?";P[d]="^"+n+"$";var r="[v=\\s]*"+P[h]+P[f]+"?"+P[v]+"?",t=b++;P[t]="^"+r+"$";var s=b++;P[s]="((?:<|>)?=?)";var a=b++;P[a]=P[C]+"|x|X|\\*";var c=b++;P[c]=P[I]+"|x|X|\\*";var o=b++;P[o]="[v=\\s]*("+P[c]+")(?:\\.("+P[c]+")(?:\\.("+P[c]+")(?:"+P[l]+")?"+P[v]+"?)?)?";var u=b++;P[u]="[v=\\s]*("+P[a]+")(?:\\.("+P[a]+")(?:\\.("+P[a]+")(?:"+P[f]+")?"+P[v]+"?)?)?";var S=b++;P[S]="^"+P[s]+"\\s*"+P[o]+"$";var E=b++;P[E]="^"+P[s]+"\\s*"+P[u]+"$";var M=b++;P[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=b++;P[N]="(?:~>?)";var j=b++;P[j]="(\\s*)"+P[N]+"\\s+",R[j]=new RegExp(P[j],"g");var $=b++;P[$]="^"+P[N]+P[o]+"$";var L=b++;P[L]="^"+P[N]+P[u]+"$";var F=b++;P[F]="(?:\\^)";var z=b++;P[z]="(\\s*)"+P[F]+"\\s+",R[z]=new RegExp(P[z],"g");var W=b++;P[W]="^"+P[F]+P[o]+"$";var H=b++;P[H]="^"+P[F]+P[u]+"$";var Q=b++;P[Q]="^"+P[s]+"\\s*("+r+")$|^$";var K=b++;P[K]="^"+P[s]+"\\s*("+n+")$|^$";var V=b++;P[V]="(\\s*)"+P[s]+"\\s*("+r+"|"+P[o]+")",R[V]=new RegExp(P[V],"g");var G=b++;P[G]="^\\s*("+P[o]+")\\s+-\\s+("+P[o]+")\\s*$";var x=b++;P[x]="^\\s*("+P[u]+")\\s+-\\s+("+P[u]+")\\s*$";var ne=b++;P[ne]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)D(se,P[se]),R[se]||(R[se]=new RegExp(P[se]));function ie(ce,de){if(ce instanceof O)return ce;if(typeof ce!="string"||ce.length>A||!(de?R[t]:R[d]).test(ce))return null;try{return new O(ce,de)}catch{return null}}function O(ce,de){if(ce instanceof O){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof O))return new O(ce,de);D("SemVer",ce,de),this.loose=de;var ge=ce.trim().match(de?R[t]:R[d]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<T)return Pe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ie,e.valid=function(ce,de){var ge=ie(ce,de);return ge?ge.version:null},e.clean=function(ce,de){var ge=ie(ce.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof O||(ce=new O(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},O.prototype.compareMain=function(ce){return ce instanceof O||(ce=new O(ce,this.loose)),q(this.major,ce.major)||q(this.minor,ce.minor)||q(this.patch,ce.patch)},O.prototype.comparePre=function(ce){if(ce instanceof O||(ce=new O(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ce=ce.prerelease[de];if(D("prerelease compare",de,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return q(ge,Ce)}while(++de)},O.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new O(ce,ge).inc(de,Ce).version}catch{return null}},e.diff=function(ce,de){if(J(ce,de))return null;var ge=ie(ce),Ce=ie(de);if(ge.prerelease.length||Ce.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=q;var U=/^[0-9]+$/;function q(ce,de){var ge=U.test(ce),Ce=U.test(de);return ge&&Ce&&(ce=+ce,de=+de),ge&&!Ce?-1:Ce&&!ge?1:ce<de?-1:ce>de?1:0}function B(ce,de,ge){return new O(ce,ge).compare(new O(de,ge))}function X(ce,de,ge){return B(ce,de,ge)>0}function ee(ce,de,ge){return B(ce,de,ge)<0}function J(ce,de,ge){return B(ce,de,ge)===0}function _(ce,de,ge){return B(ce,de,ge)!==0}function re(ce,de,ge){return B(ce,de,ge)>=0}function ue(ce,de,ge){return B(ce,de,ge)<=0}function le(ce,de,ge,Ce){var Pe;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=J(ce,ge,Ce);break;case"!=":Pe=_(ce,ge,Ce);break;case">":Pe=X(ce,ge,Ce);break;case">=":Pe=re(ce,ge,Ce);break;case"<":Pe=ee(ce,ge,Ce);break;case"<=":Pe=ue(ce,ge,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function ye(ce,de){if(ce instanceof ye){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof ye))return new ye(ce,de);D("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,de){return q(de,ce)},e.major=function(ce,de){return new O(ce,de).major},e.minor=function(ce,de){return new O(ce,de).minor},e.patch=function(ce,de){return new O(ce,de).patch},e.compare=B,e.compareLoose=function(ce,de){return B(ce,de,!0)},e.rcompare=function(ce,de,ge){return B(de,ce,ge)},e.sort=function(ce,de){return ce.sort(function(ge,Ce){return e.compare(ge,Ce,de)})},e.rsort=function(ce,de){return ce.sort(function(ge,Ce){return e.rcompare(ge,Ce,de)})},e.gt=X,e.lt=ee,e.eq=J,e.neq=_,e.gte=re,e.lte=ue,e.cmp=le,e.Comparator=ye;var Se={};function be(ce,de){if(ce instanceof be)return ce.loose===de?ce:new be(ce.raw,de);if(ce instanceof ye)return new be(ce.value,de);if(!(this instanceof be))return new be(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ee(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Ne(ce,de,ge,Ce,Pe,Ae,De,je,Te,Ue,Be,ke,Oe){return((de=Ee(ge)?"":Ee(Ce)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ce+".0":">="+de)+" "+(je=Ee(Te)?"":Ee(Ue)?"<"+(+Te+1)+".0.0":Ee(Be)?"<"+Te+"."+(+Ue+1)+".0":ke?"<="+Te+"."+Ue+"."+Be+"-"+ke:"<="+je)).trim()}function Fe(ce,de){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<ce.length;ge++)if(D(ce[ge].semver),ce[ge].semver!==Se&&ce[ge].semver.prerelease.length>0){var Ce=ce[ge].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ye(ce,de,ge){try{de=new be(de,ge)}catch{return!1}return de.test(ce)}function ze(ce,de,ge,Ce){var Pe,Ae,De,je,Te;switch(ce=new O(ce,Ce),de=new be(de,Ce),ge){case">":Pe=X,Ae=ue,De=ee,je=">",Te=">=";break;case"<":Pe=ee,Ae=re,De=X,je="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ce,de,Ce))return!1;for(var Ue=0;Ue<de.set.length;++Ue){var Be=de.set[Ue],ke=null,Oe=null;if(Be.forEach(function(te){te.semver===Se&&(te=new ye(">=0.0.0")),ke=ke||te,Oe=Oe||te,Pe(te.semver,ke.semver,Ce)?ke=te:De(te.semver,Oe.semver,Ce)&&(Oe=te)}),ke.operator===je||ke.operator===Te||(!Oe.operator||Oe.operator===je)&&Ae(ce,Oe.semver)||Oe.operator===Te&&De(ce,Oe.semver))return!1}return!0}ye.prototype.parse=function(ce){var de=this.loose?R[Q]:R[K],ge=ce.match(de);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new O(ge[2],this.loose):this.semver=Se},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===Se||(typeof ce=="string"&&(ce=new O(ce,this.loose)),le(ce,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(ce,de){if(!(ce instanceof ye))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,de),Ye(this.value,ge,de);if(ce.operator==="")return ge=new be(this.value,de),Ye(ce.semver,ge,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ae=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=le(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Te=le(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ce||Pe||Ae&&De||je||Te},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),D("range",ce,de);var ge=de?R[x]:R[G];ce=ce.replace(ge,Ne),D("hyphen replace",ce),ce=ce.replace(R[V],"$1$2$3"),D("comparator trim",ce,R[V]),ce=(ce=(ce=ce.replace(R[j],"$1~")).replace(R[z],"$1^")).split(/\s+/).join(" ");var Ce=de?R[Q]:R[K],Pe=ce.split(" ").map(function(Ae){return function(De,je){return D("comp",De),De=function(Te,Ue){return Te.trim().split(/\s+/).map(function(Be){return function(ke,Oe){D("caret",ke,Oe);var te=Oe?R[H]:R[W];return ke.replace(te,function(he,fe,me,we,Ie){var Re;return D("caret",ke,he,fe,me,we,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(we)?Re=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+Ie+" <"+(+fe+1)+".0.0"):(D("no pr"),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+" <"+(+fe+1)+".0.0"),D("caret return",Re),Re})}(Be,Ue)}).join(" ")}(De,je),D("caret",De),De=function(Te,Ue){return Te.trim().split(/\s+/).map(function(Be){return function(ke,Oe){var te=Oe?R[L]:R[$];return ke.replace(te,function(he,fe,me,we,Ie){var Re;return D("tilde",ke,he,fe,me,we,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(we)?Re=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0"):Re=">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0",D("tilde return",Re),Re})}(Be,Ue)}).join(" ")}(De,je),D("tildes",De),De=function(Te,Ue){return D("replaceXRanges",Te,Ue),Te.split(/\s+/).map(function(Be){return function(ke,Oe){ke=ke.trim();var te=Oe?R[E]:R[S];return ke.replace(te,function(he,fe,me,we,Ie,Re){D("xRange",ke,he,fe,me,we,Ie,Re);var He=Ee(me),$e=He||Ee(we),Le=$e||Ee(Ie);return fe==="="&&Le&&(fe=""),He?he=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Le?($e&&(we=0),Le&&(Ie=0),fe===">"?(fe=">=",$e?(me=+me+1,we=0,Ie=0):Le&&(we=+we+1,Ie=0)):fe==="<="&&(fe="<",$e?me=+me+1:we=+we+1),he=fe+me+"."+we+"."+Ie):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Le&&(he=">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0"),D("xRange return",he),he})}(Be,Ue)}).join(" ")}(De,je),D("xrange",De),De=function(Te,Ue){return D("replaceStars",Te,Ue),Te.trim().replace(R[ne],"")}(De,je),D("stars",De),De}(Ae,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ae){return!!Ae.match(Ce)})),Pe=Pe.map(function(Ae){return new ye(Ae,de)})},be.prototype.intersects=function(ce,de){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ce.set.some(function(Pe){return Pe.every(function(Ae){return Ce.intersects(Ae,de)})})})})},e.toComparators=function(ce,de){return new be(ce,de).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new O(ce,this.loose));for(var de=0;de<this.set.length;de++)if(Fe(this.set[de],ce))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==-1||(Pe=new O(Ce=De,ge)))}),Ce},e.minSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==1||(Pe=new O(Ce=De,ge)))}),Ce},e.validRange=function(ce,de){try{return new be(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,ge){return ze(ce,de,"<",ge)},e.gtr=function(ce,de,ge){return ze(ce,de,">",ge)},e.outside=ze,e.prerelease=function(ce,de){var ge=ie(ce,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,de,ge){return ce=new be(ce,ge),de=new be(de,ge),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof O)return ce;if(typeof ce!="string")return null;var de=ce.match(R[M]);return de==null?null:ie((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,k(1))},function(Z,e){var k,i,D=Z.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(g){if(k===setTimeout)return setTimeout(g,0);if((k===A||!k)&&setTimeout)return k=setTimeout,setTimeout(g,0);try{return k(g,0)}catch{try{return k.call(null,g,0)}catch{return k.call(this,g,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:A}catch{k=A}try{i=typeof clearTimeout=="function"?clearTimeout:T}catch{i=T}})();var P,b=[],I=!1,C=-1;function w(){I&&P&&(I=!1,P.length?b=P.concat(b):C=-1,b.length&&y())}function y(){if(!I){var g=R(w);I=!0;for(var l=b.length;l;){for(P=b,b=[];++C<l;)P&&P[C].run();C=-1,l=b.length}P=null,I=!1,function(f){if(i===clearTimeout)return clearTimeout(f);if((i===T||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(f);try{i(f)}catch{try{return i.call(null,f)}catch{return i.call(this,f)}}}(g)}}function h(g,l){this.fun=g,this.array=l}function m(){}D.nextTick=function(g){var l=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)l[f-1]=arguments[f];b.push(new h(g,l)),b.length!==1||I||R(y)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=m,D.addListener=m,D.once=m,D.off=m,D.removeListener=m,D.removeAllListeners=m,D.emit=m,D.prependListener=m,D.prependOnceListener=m,D.listeners=function(g){return[]},D.binding=function(g){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(g){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(oe[129],ae([0,1]),function(Z,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(R,P,b){this.level=R,this.key=P,this.value=b,this.forward=[]}}const D=void 0;class A{constructor(R,P=2**16){this.comparator=R,this[k]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(P)|0),this.e=new i(this.c,D,D)}get size(){return this.f}clear(){this.e=new i(this.c,D,D)}has(R){return Boolean(A.g(this,R,this.comparator))}get(R){return A.g(this,R,this.comparator)?.value}set(R,P){return A.h(this,R,P,this.comparator)&&(this.f+=1),this}delete(R){const P=A.k(this,R,this.comparator);return P&&(this.f-=1),P}forEach(R,P){let b=this.e.forward[0];for(;b;)R.call(P,b.value,b.key,this),b=b.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",P=this.e.forward[0];for(;P;)R+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return R}static g(R,P,b){let I=R.e;for(let C=R.d-1;C>=0;C--)for(;I.forward[C]&&b(I.forward[C].key,P)<0;)I=I.forward[C];if(I=I.forward[0],I&&b(I.key,P)===0)return I}static h(R,P,b,I){const C=[];let w=R.e;for(let y=R.d-1;y>=0;y--){for(;w.forward[y]&&I(w.forward[y].key,P)<0;)w=w.forward[y];C[y]=w}if(w=w.forward[0],w&&I(w.key,P)===0)return w.value=b,!1;{const y=A.j(R);if(y>R.d){for(let h=R.d;h<y;h++)C[h]=R.e;R.d=y}w=new i(y,P,b);for(let h=0;h<y;h++)w.forward[h]=C[h].forward[h],C[h].forward[h]=w;return!0}}static j(R,P=.5){let b=1;for(;Math.random()<P&&b<R.c;)b+=1;return b}static k(R,P,b){const I=[];let C=R.e;for(let w=R.d-1;w>=0;w--){for(;C.forward[w]&&b(C.forward[w].key,P)<0;)C=C.forward[w];I[w]=C}if(C=C.forward[0],!C||b(C.key,P)!==0)return!1;for(let w=0;w<R.d&&I[w].forward[w]===C;w++)I[w].forward[w]=C.forward[w];for(;R.d>0&&R.e.forward[R.d-1]===D;)R.d-=1;return!0}}e.SkipList=A}),define(oe[44],ae([0,1,9,2]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(v){const d=v;return d?typeof d.read=="function":!1}e.isReadable=D;function A(v){const d=v;return d?[d.on,d.pause,d.resume,d.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=A;function T(v){const d=v;return d?A(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=T;function R(v,d){return new P(v,d)}e.newWriteableStream=R;class P{constructor(d,n){this.e=d,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(n=>n(d))}h(d){this.c.error.length===0?(0,k.onUnexpectedError)(d):this.c.error.slice(0).forEach(n=>n(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,n){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(d,n){if(this.a.destroyed)return;let r;switch(d){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(v,d){const n=[];let r;for(;(r=v.read())!==null;)n.push(r);return d(n)}e.consumeReadable=b;function I(v,d,n){const r=[];let t;for(;(t=v.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?d(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const s=t;return t=void 0,s}return v.read()}}}e.peekReadable=I;function C(v,d){return new Promise((n,r)=>{const t=[];w(v,{onData:s=>{d&&t.push(s)},onError:s=>{d?r(s):n(void 0)},onEnd:()=>{n(d?d(t):void 0)}})})}e.consumeStream=C;function w(v,d){let n=!1;return v.on("error",r=>{n||d.onError(r)}),v.on("end",()=>{n||d.onEnd()}),v.on("data",r=>{n||d.onData(r)}),(0,i.toDisposable)(()=>n=!0)}e.listenStream=w;function y(v,d){return new Promise((n,r)=>{const t=new i.DisposableStore,s=[],a=u=>{if(s.push(u),s.length>d)return t.dispose(),v.pause(),n({stream:v,buffer:s,ended:!1})},c=u=>r(u),o=()=>n({stream:v,buffer:s,ended:!0});t.add((0,i.toDisposable)(()=>v.removeListener("error",c))),v.on("error",c),t.add((0,i.toDisposable)(()=>v.removeListener("end",o))),v.on("end",o),t.add((0,i.toDisposable)(()=>v.removeListener("data",a))),v.on("data",a)})}e.peekStream=y;function h(v,d){const n=R(d);return n.end(v),n}e.toStream=h;function m(){const v=R(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=m;function g(v){let d=!1;return{read:()=>d?null:(d=!0,v)}}e.toReadable=g;function l(v,d,n){const r=R(n);return w(v,{onData:t=>r.write(d.data(t)),onError:t=>r.error(d.error?d.error(t):t),onEnd:()=>r.end()}),r}e.transform=l;function f(v,d,n){let r=!1;return{read:()=>{const t=d.read();return r?t:(r=!0,t!==null?n([v,t]):v)}}}e.prefixedReadable=f;function p(v,d,n){let r=!1;const t=R(n);return w(d,{onData:s=>r?t.write(s):(r=!0,t.write(n([v,s]))),onError:s=>t.error(s),onEnd:()=>{r||(r=!0,t.write(v)),t.end()}}),t}e.prefixedStream=p}),define(oe[17],ae([0,1,44]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer<"u";let D,A;class T{static alloc(u){return i?new T(Buffer.allocUnsafe(u)):new T(new Uint8Array(u))}static wrap(u){return i&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new T(u)}static fromString(u,S){return!(S?.dontUseNodeBuffer||!1)&&i?new T(Buffer.from(u)):(D||(D=new TextEncoder),new T(D.encode(u)))}static fromByteArray(u){const S=T.alloc(u.length);for(let E=0,M=u.length;E<M;E++)S.buffer[E]=u[E];return S}static concat(u,S){if(typeof S>"u"){S=0;for(let N=0,j=u.length;N<j;N++)S+=u[N].byteLength}const E=T.alloc(S);let M=0;for(let N=0,j=u.length;N<j;N++){const $=u[N];E.set($,M),M+=$.byteLength}return E}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=T.alloc(this.byteLength);return u.set(this),u}toString(){return i?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(u,S){return new T(this.buffer.subarray(u,S))}set(u,S){if(u instanceof T)this.buffer.set(u.buffer,S);else if(u instanceof Uint8Array)this.buffer.set(u,S);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),S);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return b(this.buffer,u)}writeUInt32BE(u,S){I(this.buffer,u,S)}readUInt32LE(u){return C(this.buffer,u)}writeUInt32LE(u,S){w(this.buffer,u,S)}readUInt8(u){return y(this.buffer,u)}writeUInt8(u,S){h(this.buffer,u,S)}}e.VSBuffer=T;function R(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0}e.readUInt16LE=R;function P(o,u,S){o[S+0]=u&255,u=u>>>8,o[S+1]=u&255}e.writeUInt16LE=P;function b(o,u){return o[u]*2**24+o[u+1]*2**16+o[u+2]*2**8+o[u+3]}e.readUInt32BE=b;function I(o,u,S){o[S+3]=u,u=u>>>8,o[S+2]=u,u=u>>>8,o[S+1]=u,u=u>>>8,o[S]=u}e.writeUInt32BE=I;function C(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0|o[u+2]<<16>>>0|o[u+3]<<24>>>0}e.readUInt32LE=C;function w(o,u,S){o[S+0]=u&255,u=u>>>8,o[S+1]=u&255,u=u>>>8,o[S+2]=u&255,u=u>>>8,o[S+3]=u&255}e.writeUInt32LE=w;function y(o,u){return o[u]}e.readUInt8=y;function h(o,u,S){o[S]=u}e.writeUInt8=h;function m(o){return k.consumeReadable(o,u=>T.concat(u))}e.readableToBuffer=m;function g(o){return k.toReadable(o)}e.bufferToReadable=g;function l(o){return k.consumeStream(o,u=>T.concat(u))}e.streamToBuffer=l;async function f(o){return o.ended?T.concat(o.buffer):T.concat([...o.buffer,await l(o.stream)])}e.bufferedStreamToBuffer=f;function p(o){return k.toStream(o,u=>T.concat(u))}e.bufferToStream=p;function v(o){return k.transform(o,{data:u=>typeof u=="string"?T.fromString(u):T.wrap(u)},u=>T.concat(u))}e.streamToBufferReadableStream=v;function d(o){return k.newWriteableStream(u=>T.concat(u),o)}e.newWriteableBufferStream=d;function n(o,u){return k.prefixedReadable(o,u,S=>T.concat(S))}e.prefixedBufferReadable=n;function r(o,u){return k.prefixedStream(o,u,S=>T.concat(S))}e.prefixedBufferStream=r;function t(o){let u=0,S=0,E=0;const M=new Uint8Array(Math.floor(o.length/4*3)),N=$=>{switch(S){case 3:M[E++]=u|$,S=0;break;case 2:M[E++]=u|$>>>2,u=$<<6,S=3;break;case 1:M[E++]=u|$>>>4,u=$<<4,S=2;break;default:u=$<<2,S=1}};for(let $=0;$<o.length;$++){const L=o.charCodeAt($);if(L>=65&&L<=90)N(L-65);else if(L>=97&&L<=122)N(L-97+26);else if(L>=48&&L<=57)N(L-48+52);else if(L===43||L===45)N(62);else if(L===47||L===95)N(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${o[$]}`)}}const j=E;for(;S>0;)N(0);return T.wrap(M).slice(0,j)}e.decodeBase64=t;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},u=!0,S=!1){const E=S?a:s;let M="";const N=o.byteLength%3;let j=0;for(;j<o.byteLength-N;j+=3){const $=o[j+0],L=o[j+1],F=o[j+2];M+=E[$>>>2],M+=E[($<<4|L>>>4)&63],M+=E[(L<<2|F>>>6)&63],M+=E[F&63]}if(N===1){const $=o[j+0];M+=E[$>>>2],M+=E[$<<4&63],u&&(M+="==")}else if(N===2){const $=o[j+0],L=o[j+1];M+=E[$>>>2],M+=E[($<<4|L>>>4)&63],M+=E[L<<2&63],u&&(M+="=")}return M}e.encodeBase64=c}),define(oe[13],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(r){return typeof r=="string"}e.isString=k;function i(r){return Array.isArray(r)&&r.every(t=>k(t))}e.isStringArray=i;function D(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=D;function A(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=A;function T(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=T;function R(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=R;function P(r){return r===!0||r===!1}e.isBoolean=P;function b(r){return typeof r>"u"}e.isUndefined=b;function I(r){return!C(r)}e.isDefined=I;function C(r){return b(r)||r===null}e.isUndefinedOrNull=C;function w(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=w;function y(r){if(C(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=y;function h(...r){const t=[];for(let s=0;s<r.length;s++){const a=r[s];if(C(a))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(a)}return t}e.assertAllDefined=h;const m=Object.prototype.hasOwnProperty;function g(r){if(!D(r))return!1;for(const t in r)if(m.call(r,t))return!1;return!0}e.isEmptyObject=g;function l(r){return typeof r=="function"}e.isFunction=l;function f(...r){return r.length>0&&r.every(l)}e.areFunctions=f;function p(r,t){const s=Math.min(r.length,t.length);for(let a=0;a<s;a++)v(r[a],t[a])}e.validateConstraints=p;function v(r,t){if(k(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if(r instanceof t)return}catch{}if(!C(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=v;function d(r){return r===null?void 0:r}e.withNullAsUndefined=d;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(oe[32],ae([0,1,13]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const f=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([p,v])=>{f[p]=v&&typeof v=="object"?i(v):v}),f}e.deepClone=i;function D(l){if(!l||typeof l!="object")return l;const f=[l];for(;f.length>0;){const p=f.shift();Object.freeze(p);for(const v in p)if(A.call(p,v)){const d=p[v];typeof d=="object"&&!Object.isFrozen(d)&&!(0,k.isTypedArray)(d)&&f.push(d)}}return l}e.deepFreeze=D;const A=Object.prototype.hasOwnProperty;function T(l,f){return R(l,f,new Set)}e.cloneAndChange=T;function R(l,f,p){if((0,k.isUndefinedOrNull)(l))return l;const v=f(l);if(typeof v<"u")return v;if(Array.isArray(l)){const d=[];for(const n of l)d.push(R(n,f,p));return d}if((0,k.isObject)(l)){if(p.has(l))throw new Error("Cannot clone recursive data-structure");p.add(l);const d={};for(const n in l)A.call(l,n)&&(d[n]=R(l[n],f,p));return p.delete(l),d}return l}function P(l,f,p=!0){return(0,k.isObject)(l)?((0,k.isObject)(f)&&Object.keys(f).forEach(v=>{v in l?p&&((0,k.isObject)(l[v])&&(0,k.isObject)(f[v])?P(l[v],f[v],p):l[v]=f[v]):l[v]=f[v]}),l):f}e.mixin=P;function b(l,f){if(l===f)return!0;if(l==null||f===null||f===void 0||typeof l!=typeof f||typeof l!="object"||Array.isArray(l)!==Array.isArray(f))return!1;let p,v;if(Array.isArray(l)){if(l.length!==f.length)return!1;for(p=0;p<l.length;p++)if(!b(l[p],f[p]))return!1}else{const d=[];for(v in l)d.push(v);d.sort();const n=[];for(v in f)n.push(v);if(n.sort(),!b(d,n))return!1;for(p=0;p<d.length;p++)if(!b(l[d[p]],f[d[p]]))return!1}return!0}e.equals=b;function I(l){const f=new Set;return JSON.stringify(l,(p,v)=>{if((0,k.isObject)(v)||Array.isArray(v)){if(f.has(v))return"[Circular]";f.add(v)}return v})}e.safeStringify=I;function C(l,f){const p=Object.create(null);return!l||!f||Object.keys(f).forEach(d=>{const n=l[d],r=f[d];b(n,r)||(p[d]=r)}),p}e.distinct=C;function w(l,f){const p=f.toLowerCase(),v=Object.keys(l).find(d=>d.toLowerCase()===p);return v?l[v]:l[f]}e.getCaseInsensitive=w;function y(l,f){const p=Object.create(null);for(const[v,d]of Object.entries(l))f(v,d)&&(p[v]=d);return p}e.filter=y;function h(l){let f=[],p=Object.getPrototypeOf(l);for(;Object.prototype!==p;)f=f.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return f}e.getAllPropertyNames=h;function m(l){const f=[];for(const p of h(l))typeof l[p]=="function"&&f.push(p);return f}e.getAllMethodNames=m;function g(l,f){const p=d=>function(){const n=Array.prototype.slice.call(arguments,0);return f(d,n)},v={};for(const d of l)v[d]=p(d);return v}e.createProxyObject=g}),define(oe[31],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(D){return k.test(D)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let P=0;P<R.length;P++)R[P]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),T=[];for(let R=0;R<256;R++)T.push(R.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let P=0,b="";return b+=T[A[P++]],b+=T[A[P++]],b+=T[A[P++]],b+=T[A[P++]],b+="-",b+=T[A[P++]],b+=T[A[P++]],b+="-",b+=T[A[P++]],b+=T[A[P++]],b+="-",b+=T[A[P++]],b+=T[A[P++]],b+="-",b+=T[A[P++]],b+=T[A[P++]],b+=T[A[P++]],b+=T[A[P++]],b+=T[A[P++]],b+=T[A[P++]],b}}()}),define(oe[130],ae([0,1,34]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(T){const R=T.replace(/\-/g,":").toLowerCase();return!i.has(R)}function A(){const T=(0,k.networkInterfaces)();for(const R in T){const P=T[R];if(P){for(const{mac:b}of P)if(D(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(oe[131],ae([0,1,86]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(R,P,b,I=1){let C=!1;return new Promise(w=>{const y=setTimeout(()=>{if(!C)return C=!0,w(0)},b);D(R,P,I,h=>{if(!C)return C=!0,clearTimeout(y),w(h)})})}e.findFreePort=i;function D(R,P,b,I){if(P===0)return I(0);const C=new k.Socket;C.once("connect",()=>(T(C),D(R+b,P-1,b,I))),C.once("data",()=>{}),C.once("error",w=>(T(C),w.code!=="ECONNREFUSED"?D(R+b,P-1,b,I):I(R))),C.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,P,b,I="127.0.0.1"){let C=!1,w,y=1;const h=k.createServer({pauseOnConnect:!0});function m(g,l){C||(C=!0,h.removeAllListeners(),h.close(),w&&clearTimeout(w),l(g))}return new Promise(g=>{w=setTimeout(()=>{m(0,g)},b),h.on("listening",()=>{m(R,g)}),h.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&y<P?(R++,y++,h.listen(R,I)):m(0,g)}),h.on("close",()=>{m(0,g)}),h.listen(R,I)})}e.findFreePortFaster=A;function T(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(P){console.error(P)}}}),define(oe[132],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function i(A){return A instanceof D?!0:A instanceof Error&&A.name===k&&A.message===k}e.isOfflineError=i;class D extends Error{constructor(){super(k),this.name=this.message}}e.OfflineError=D}),define(oe[133],ae([0,1,17,9,132]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(P,b){if(!navigator.onLine)throw new D.OfflineError;P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const I=new XMLHttpRequest;return new Promise((C,w)=>{I.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(I,P),I.responseType="arraybuffer",I.onerror=y=>w(new Error(I.statusText&&"XHR failed: "+I.statusText||"XHR failed")),I.onload=y=>{C({res:{statusCode:I.status,headers:R(I)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(I.response)))})},I.ontimeout=y=>w(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(I.timeout=P.timeout),I.send(P.data),b.onCancellationRequested(()=>{I.abort(),w((0,i.canceled)())})})}e.request=A;function T(P,b){if(b.headers){e:for(const I in b.headers){switch(I){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(I,b.headers[I])}}}function R(P){const b=Object.create(null);for(const I of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(I){const C=I.indexOf(":");b[I.substr(0,C).trim().toLowerCase()]=I.substr(C+1).trim()}return b}}),define(oe[134],ae([10,11]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(oe[65],ae([0,1,134]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,D=i*60,A=D*24,T=A*7,R=A*30,P=A*365;function b(C,w,y){typeof C!="number"&&(C=C.getTime());const h=Math.round((new Date().getTime()-C)/1e3);if(h<-30)return(0,k.localize)(0,null,b(new Date().getTime()+h*1e3,!1));if(h<30)return(0,k.localize)(1,null);let m;return h<i?(m=h,w?m===1?y?(0,k.localize)(2,null,m):(0,k.localize)(3,null,m):y?(0,k.localize)(4,null,m):(0,k.localize)(5,null,m):m===1?y?(0,k.localize)(6,null,m):(0,k.localize)(7,null,m):y?(0,k.localize)(8,null,m):(0,k.localize)(9,null,m)):h<D?(m=Math.floor(h/i),w?m===1?y?(0,k.localize)(10,null,m):(0,k.localize)(11,null,m):y?(0,k.localize)(12,null,m):(0,k.localize)(13,null,m):m===1?y?(0,k.localize)(14,null,m):(0,k.localize)(15,null,m):y?(0,k.localize)(16,null,m):(0,k.localize)(17,null,m)):h<A?(m=Math.floor(h/D),w?m===1?y?(0,k.localize)(18,null,m):(0,k.localize)(19,null,m):y?(0,k.localize)(20,null,m):(0,k.localize)(21,null,m):m===1?y?(0,k.localize)(22,null,m):(0,k.localize)(23,null,m):y?(0,k.localize)(24,null,m):(0,k.localize)(25,null,m)):h<T?(m=Math.floor(h/A),w?m===1?(0,k.localize)(26,null,m):(0,k.localize)(27,null,m):m===1?(0,k.localize)(28,null,m):(0,k.localize)(29,null,m)):h<R?(m=Math.floor(h/T),w?m===1?y?(0,k.localize)(30,null,m):(0,k.localize)(31,null,m):y?(0,k.localize)(32,null,m):(0,k.localize)(33,null,m):m===1?y?(0,k.localize)(34,null,m):(0,k.localize)(35,null,m):y?(0,k.localize)(36,null,m):(0,k.localize)(37,null,m)):h<P?(m=Math.floor(h/R),w?m===1?y?(0,k.localize)(38,null,m):(0,k.localize)(39,null,m):y?(0,k.localize)(40,null,m):(0,k.localize)(41,null,m):m===1?y?(0,k.localize)(42,null,m):(0,k.localize)(43,null,m):y?(0,k.localize)(44,null,m):(0,k.localize)(45,null,m)):(m=Math.floor(h/P),w?m===1?y?(0,k.localize)(46,null,m):(0,k.localize)(47,null,m):y?(0,k.localize)(48,null,m):(0,k.localize)(49,null,m):m===1?y?(0,k.localize)(50,null,m):(0,k.localize)(51,null,m):y?(0,k.localize)(52,null,m):(0,k.localize)(53,null,m))}e.fromNow=b;function I(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(oe[135],ae([10,11]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,20,13,135]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(C,w){return w&&(C.stack||C.stacktrace)?D.localize(0,null,R(C),T(C.stack)||T(C.stacktrace)):R(C)}function T(C){return Array.isArray(C)?C.join(`
`):C}function R(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?D.localize(1,null,C.message):C.message||D.localize(2,null)}function P(C=null,w=!1){if(!C)return D.localize(3,null);if(Array.isArray(C)){const y=k.coalesce(C),h=P(y[0],w);return y.length>1?D.localize(4,null,h,y.length):h}if(i.isString(C))return C;if(C.detail){const y=C.detail;if(y.error)return A(y.error,w);if(y.exception)return A(y.exception,w)}return C.stack?A(C,w):C.message?C.message:D.localize(5,null)}e.toErrorMessage=P;function b(C){const w=C;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=b;function I(C,w){let y;return typeof C=="string"?y=new Error(C):y=C,y.actions=w,y}e.createErrorWithActions=I}),define(oe[136],ae([10,11]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(oe[137],ae([0,1,136]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(D){switch(D){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(oe[138],ae([10,11]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,138]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let i=!1,D=!1,A=!1,T=!1,R=!1,P=!1,b=!1,I=!1,C=!1,w=!1,y,h=e.LANGUAGE_DEFAULT,m,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const f=typeof l?.versions?.electron=="string",p=f&&l?.type==="renderer";if(typeof navigator=="object"&&!p)g=navigator.userAgent,i=g.indexOf("Windows")>=0,D=g.indexOf("Macintosh")>=0,I=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,w=g?.indexOf("Mobi")>=0,P=!0,y=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,h=y;else if(typeof l=="object"){i=l.platform==="win32",D=l.platform==="darwin",A=l.platform==="linux",T=A&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,b=f,C=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT;const o=l.env.VSCODE_NLS_CONFIG;if(o)try{const u=JSON.parse(o),S=u.availableLanguages["*"];y=u.locale,h=S||e.LANGUAGE_DEFAULT,m=u._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var v;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function d(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=d;let n=0;D?n=1:i?n=3:A&&(n=2),e.isWindows=i,e.isMacintosh=D,e.isLinux=A,e.isLinuxSnap=T,e.isNative=R,e.isElectron=b,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=w,e.isCI=C,e.platform=n,e.userAgent=g,e.language=h;var r;(function(o){function u(){return e.language}o.value=u;function S(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=S;function E(){return e.language==="en"}o.isDefault=E})(r=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let E=0,M=o.length;E<M;E++){const N=o[E];if(N.id===S.data.vscodeScheduleAsyncWork){o.splice(E,1),N.callback();return}}});let u=0;return S=>{const E=++u;o.push({id:E,callback:S}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return o=>setTimeout(o)})();var t;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||I?2:i?1:3;let s=!0,a=!1;function c(){if(!a){a=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,s=new Uint16Array(o.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[36],ae([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.process<"u"){const D=k.globals.vscode.process;i={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(oe[12],ae([0,1,36]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,D=97,A=90,T=122,R=46,P=47,b=92,I=58,C=63;class w extends Error{constructor(r,t,s){let a;typeof t=="string"&&t.indexOf("not ")===0?(a="must not be",t=t.replace(/^not /,"")):a="must be";const c=r.indexOf(".")!==-1?"property":"argument";let o=`The "${r}" ${c} ${a} of type ${t}`;o+=`. Received type ${typeof s}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function y(n,r){if(n===null||typeof n!="object")throw new w(r,"Object",n)}function h(n,r){if(typeof n!="string")throw new w(r,"string",n)}const m=k.platform==="win32";function g(n){return n===P||n===b}function l(n){return n===P}function f(n){return n>=i&&n<=A||n>=D&&n<=T}function p(n,r,t,s){let a="",c=0,o=-1,u=0,S=0;for(let E=0;E<=n.length;++E){if(E<n.length)S=n.charCodeAt(E);else{if(s(S))break;S=P}if(s(S)){if(!(o===E-1||u===1))if(u===2){if(a.length<2||c!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const M=a.lastIndexOf(t);M===-1?(a="",c=0):(a=a.slice(0,M),c=a.length-1-a.lastIndexOf(t)),o=E,u=0;continue}else if(a.length!==0){a="",c=0,o=E,u=0;continue}}r&&(a+=a.length>0?`${t}..`:"..",c=2)}else a.length>0?a+=`${t}${n.slice(o+1,E)}`:a=n.slice(o+1,E),c=E-o-1;o=E,u=0}else S===R&&u!==-1?++u:u=-1}return a}function v(n,r){y(r,"pathObject");const t=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return t?t===r.root?`${t}${s}`:`${t}${n}${s}`:s}e.win32={resolve(...n){let r="",t="",s=!1;for(let a=n.length-1;a>=-1;a--){let c;if(a>=0){if(c=n[a],h(c,"path"),c.length===0)continue}else r.length===0?c=k.cwd():(c=k.env[`=${r}`]||k.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==r.toLowerCase()&&c.charCodeAt(2)===b)&&(c=`${r}\\`));const o=c.length;let u=0,S="",E=!1;const M=c.charCodeAt(0);if(o===1)g(M)&&(u=1,E=!0);else if(g(M))if(E=!0,g(c.charCodeAt(1))){let N=2,j=N;for(;N<o&&!g(c.charCodeAt(N));)N++;if(N<o&&N!==j){const $=c.slice(j,N);for(j=N;N<o&&g(c.charCodeAt(N));)N++;if(N<o&&N!==j){for(j=N;N<o&&!g(c.charCodeAt(N));)N++;(N===o||N!==j)&&(S=`\\\\${$}\\${c.slice(j,N)}`,u=N)}}}else u=1;else f(M)&&c.charCodeAt(1)===I&&(S=c.slice(0,2),u=2,o>2&&g(c.charCodeAt(2))&&(E=!0,u=3));if(S.length>0)if(r.length>0){if(S.toLowerCase()!==r.toLowerCase())continue}else r=S;if(s){if(r.length>0)break}else if(t=`${c.slice(u)}\\${t}`,s=E,E&&r.length>0)break}return t=p(t,!s,"\\",g),s?`${r}\\${t}`:`${r}${t}`||"."},normalize(n){h(n,"path");const r=n.length;if(r===0)return".";let t=0,s,a=!1;const c=n.charCodeAt(0);if(r===1)return l(c)?"\\":n;if(g(c))if(a=!0,g(n.charCodeAt(1))){let u=2,S=u;for(;u<r&&!g(n.charCodeAt(u));)u++;if(u<r&&u!==S){const E=n.slice(S,u);for(S=u;u<r&&g(n.charCodeAt(u));)u++;if(u<r&&u!==S){for(S=u;u<r&&!g(n.charCodeAt(u));)u++;if(u===r)return`\\\\${E}\\${n.slice(S)}\\`;u!==S&&(s=`\\\\${E}\\${n.slice(S,u)}`,t=u)}}}else t=1;else f(c)&&n.charCodeAt(1)===I&&(s=n.slice(0,2),t=2,r>2&&g(n.charCodeAt(2))&&(a=!0,t=3));let o=t<r?p(n.slice(t),!a,"\\",g):"";return o.length===0&&!a&&(o="."),o.length>0&&g(n.charCodeAt(r-1))&&(o+="\\"),s===void 0?a?`\\${o}`:o:a?`${s}\\${o}`:`${s}${o}`},isAbsolute(n){h(n,"path");const r=n.length;if(r===0)return!1;const t=n.charCodeAt(0);return g(t)||r>2&&f(t)&&n.charCodeAt(1)===I&&g(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let r,t;for(let c=0;c<n.length;++c){const o=n[c];h(o,"path"),o.length>0&&(r===void 0?r=t=o:r+=`\\${o}`)}if(r===void 0)return".";let s=!0,a=0;if(typeof t=="string"&&g(t.charCodeAt(0))){++a;const c=t.length;c>1&&g(t.charCodeAt(1))&&(++a,c>2&&(g(t.charCodeAt(2))?++a:s=!1))}if(s){for(;a<r.length&&g(r.charCodeAt(a));)a++;a>=2&&(r=`\\${r.slice(a)}`)}return e.win32.normalize(r)},relative(n,r){if(h(n,"from"),h(r,"to"),n===r)return"";const t=e.win32.resolve(n),s=e.win32.resolve(r);if(t===s||(n=t.toLowerCase(),r=s.toLowerCase(),n===r))return"";let a=0;for(;a<n.length&&n.charCodeAt(a)===b;)a++;let c=n.length;for(;c-1>a&&n.charCodeAt(c-1)===b;)c--;const o=c-a;let u=0;for(;u<r.length&&r.charCodeAt(u)===b;)u++;let S=r.length;for(;S-1>u&&r.charCodeAt(S-1)===b;)S--;const E=S-u,M=o<E?o:E;let N=-1,j=0;for(;j<M;j++){const L=n.charCodeAt(a+j);if(L!==r.charCodeAt(u+j))break;L===b&&(N=j)}if(j!==M){if(N===-1)return s}else{if(E>M){if(r.charCodeAt(u+j)===b)return s.slice(u+j+1);if(j===2)return s.slice(u+j)}o>M&&(n.charCodeAt(a+j)===b?N=j:j===2&&(N=3)),N===-1&&(N=0)}let $="";for(j=a+N+1;j<=c;++j)(j===c||n.charCodeAt(j)===b)&&($+=$.length===0?"..":"\\..");return u+=N,$.length>0?`${$}${s.slice(u,S)}`:(s.charCodeAt(u)===b&&++u,s.slice(u,S))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const r=e.win32.resolve(n);if(r.length<=2)return n;if(r.charCodeAt(0)===b){if(r.charCodeAt(1)===b){const t=r.charCodeAt(2);if(t!==C&&t!==R)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(f(r.charCodeAt(0))&&r.charCodeAt(1)===I&&r.charCodeAt(2)===b)return`\\\\?\\${r}`;return n},dirname(n){h(n,"path");const r=n.length;if(r===0)return".";let t=-1,s=0;const a=n.charCodeAt(0);if(r===1)return g(a)?n:".";if(g(a)){if(t=s=1,g(n.charCodeAt(1))){let u=2,S=u;for(;u<r&&!g(n.charCodeAt(u));)u++;if(u<r&&u!==S){for(S=u;u<r&&g(n.charCodeAt(u));)u++;if(u<r&&u!==S){for(S=u;u<r&&!g(n.charCodeAt(u));)u++;if(u===r)return n;u!==S&&(t=s=u+1)}}}}else f(a)&&n.charCodeAt(1)===I&&(t=r>2&&g(n.charCodeAt(2))?3:2,s=t);let c=-1,o=!0;for(let u=r-1;u>=s;--u)if(g(n.charCodeAt(u))){if(!o){c=u;break}}else o=!1;if(c===-1){if(t===-1)return".";c=t}return n.slice(0,c)},basename(n,r){r!==void 0&&h(r,"ext"),h(n,"path");let t=0,s=-1,a=!0,c;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===I&&(t=2),r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let o=r.length-1,u=-1;for(c=n.length-1;c>=t;--c){const S=n.charCodeAt(c);if(g(S)){if(!a){t=c+1;break}}else u===-1&&(a=!1,u=c+1),o>=0&&(S===r.charCodeAt(o)?--o===-1&&(s=c):(o=-1,s=u))}return t===s?s=u:s===-1&&(s=n.length),n.slice(t,s)}for(c=n.length-1;c>=t;--c)if(g(n.charCodeAt(c))){if(!a){t=c+1;break}}else s===-1&&(a=!1,s=c+1);return s===-1?"":n.slice(t,s)},extname(n){h(n,"path");let r=0,t=-1,s=0,a=-1,c=!0,o=0;n.length>=2&&n.charCodeAt(1)===I&&f(n.charCodeAt(0))&&(r=s=2);for(let u=n.length-1;u>=r;--u){const S=n.charCodeAt(u);if(g(S)){if(!c){s=u+1;break}continue}a===-1&&(c=!1,a=u+1),S===R?t===-1?t=u:o!==1&&(o=1):t!==-1&&(o=-1)}return t===-1||a===-1||o===0||o===1&&t===a-1&&t===s+1?"":n.slice(t,a)},format:v.bind(null,"\\"),parse(n){h(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const t=n.length;let s=0,a=n.charCodeAt(0);if(t===1)return g(a)?(r.root=r.dir=n,r):(r.base=r.name=n,r);if(g(a)){if(s=1,g(n.charCodeAt(1))){let N=2,j=N;for(;N<t&&!g(n.charCodeAt(N));)N++;if(N<t&&N!==j){for(j=N;N<t&&g(n.charCodeAt(N));)N++;if(N<t&&N!==j){for(j=N;N<t&&!g(n.charCodeAt(N));)N++;N===t?s=N:N!==j&&(s=N+1)}}}}else if(f(a)&&n.charCodeAt(1)===I){if(t<=2)return r.root=r.dir=n,r;if(s=2,g(n.charCodeAt(2))){if(t===3)return r.root=r.dir=n,r;s=3}}s>0&&(r.root=n.slice(0,s));let c=-1,o=s,u=-1,S=!0,E=n.length-1,M=0;for(;E>=s;--E){if(a=n.charCodeAt(E),g(a)){if(!S){o=E+1;break}continue}u===-1&&(S=!1,u=E+1),a===R?c===-1?c=E:M!==1&&(M=1):c!==-1&&(M=-1)}return u!==-1&&(c===-1||M===0||M===1&&c===u-1&&c===o+1?r.base=r.name=n.slice(o,u):(r.name=n.slice(o,c),r.base=n.slice(o,u),r.ext=n.slice(c,u))),o>0&&o!==s?r.dir=n.slice(0,o-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(m){const n=/\\/g;return()=>{const r=k.cwd().replace(n,"/");return r.slice(r.indexOf("/"))}}return()=>k.cwd()})();e.posix={resolve(...n){let r="",t=!1;for(let s=n.length-1;s>=-1&&!t;s--){const a=s>=0?n[s]:d();h(a,"path"),a.length!==0&&(r=`${a}/${r}`,t=a.charCodeAt(0)===P)}return r=p(r,!t,"/",l),t?`/${r}`:r.length>0?r:"."},normalize(n){if(h(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===P,t=n.charCodeAt(n.length-1)===P;return n=p(n,!r,"/",l),n.length===0?r?"/":t?"./":".":(t&&(n+="/"),r?`/${n}`:n)},isAbsolute(n){return h(n,"path"),n.length>0&&n.charCodeAt(0)===P},join(...n){if(n.length===0)return".";let r;for(let t=0;t<n.length;++t){const s=n[t];h(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.posix.normalize(r)},relative(n,r){if(h(n,"from"),h(r,"to"),n===r||(n=e.posix.resolve(n),r=e.posix.resolve(r),n===r))return"";const t=1,s=n.length,a=s-t,c=1,o=r.length-c,u=a<o?a:o;let S=-1,E=0;for(;E<u;E++){const N=n.charCodeAt(t+E);if(N!==r.charCodeAt(c+E))break;N===P&&(S=E)}if(E===u)if(o>u){if(r.charCodeAt(c+E)===P)return r.slice(c+E+1);if(E===0)return r.slice(c+E)}else a>u&&(n.charCodeAt(t+E)===P?S=E:E===0&&(S=0));let M="";for(E=t+S+1;E<=s;++E)(E===s||n.charCodeAt(E)===P)&&(M+=M.length===0?"..":"/..");return`${M}${r.slice(c+S)}`},toNamespacedPath(n){return n},dirname(n){if(h(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===P;let t=-1,s=!0;for(let a=n.length-1;a>=1;--a)if(n.charCodeAt(a)===P){if(!s){t=a;break}}else s=!1;return t===-1?r?"/":".":r&&t===1?"//":n.slice(0,t)},basename(n,r){r!==void 0&&h(r,"ext"),h(n,"path");let t=0,s=-1,a=!0,c;if(r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let o=r.length-1,u=-1;for(c=n.length-1;c>=0;--c){const S=n.charCodeAt(c);if(S===P){if(!a){t=c+1;break}}else u===-1&&(a=!1,u=c+1),o>=0&&(S===r.charCodeAt(o)?--o===-1&&(s=c):(o=-1,s=u))}return t===s?s=u:s===-1&&(s=n.length),n.slice(t,s)}for(c=n.length-1;c>=0;--c)if(n.charCodeAt(c)===P){if(!a){t=c+1;break}}else s===-1&&(a=!1,s=c+1);return s===-1?"":n.slice(t,s)},extname(n){h(n,"path");let r=-1,t=0,s=-1,a=!0,c=0;for(let o=n.length-1;o>=0;--o){const u=n.charCodeAt(o);if(u===P){if(!a){t=o+1;break}continue}s===-1&&(a=!1,s=o+1),u===R?r===-1?r=o:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||s===-1||c===0||c===1&&r===s-1&&r===t+1?"":n.slice(r,s)},format:v.bind(null,"/"),parse(n){h(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const t=n.charCodeAt(0)===P;let s;t?(r.root="/",s=1):s=0;let a=-1,c=0,o=-1,u=!0,S=n.length-1,E=0;for(;S>=s;--S){const M=n.charCodeAt(S);if(M===P){if(!u){c=S+1;break}continue}o===-1&&(u=!1,o=S+1),M===R?a===-1?a=S:E!==1&&(E=1):a!==-1&&(E=-1)}if(o!==-1){const M=c===0&&t?1:c;a===-1||E===0||E===1&&a===o-1&&a===c+1?r.base=r.name=n.slice(M,o):(r.name=n.slice(M,a),r.base=n.slice(M,o),r.ext=n.slice(a,o))}return c>0?r.dir=n.slice(0,c-1):t&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m?e.win32.normalize:e.posix.normalize,e.isAbsolute=m?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m?e.win32.join:e.posix.join,e.resolve=m?e.win32.resolve:e.posix.resolve,e.relative=m?e.win32.relative:e.posix.relative,e.dirname=m?e.win32.dirname:e.posix.dirname,e.basename=m?e.win32.basename:e.posix.basename,e.extname=m?e.win32.extname:e.posix.extname,e.format=m?e.win32.format:e.posix.format,e.parse=m?e.win32.parse:e.posix.parse,e.toNamespacedPath=m?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m?e.win32.sep:e.posix.sep,e.delimiter=m?e.win32.delimiter:e.posix.delimiter}),define(oe[139],ae([0,1,12]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const C=(0,k.extname)(I),w=i[C.toLowerCase()];return w!==void 0?w:T(I)}e.getMediaOrTextMime=A;function T(I){const C=(0,k.extname)(I);return D[C.toLowerCase()]}e.getMediaMime=T;function R(I){for(const C in D)if(D[C]===I)return C}e.getExtensionForMimeType=R;const P=/^(.+)\/(.+?)(;.+)?$/;function b(I,C){const w=P.exec(I);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:C?void 0:I}e.normalizeMimeType=b}),define(oe[87],ae([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(R,...P){const b=P.reduce((w,y)=>(w[y]=!0,w),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(w=>!b[w]).forEach(w=>{for(let y=0;y<I.length;y++)if(w.search(I[y])!==-1){delete R[w];break}})}e.sanitizeProcessEnvironment=A;function T(R){!R||(delete R.DEBUG,k.isMacintosh&&delete R.DYLD_LIBRARY_PATH,k.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(oe[140],ae([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=k.globals.performance&&typeof k.globals.performance.now=="function";class D{static create(T=!0){return new D(T)}constructor(T){this.a=i&&T,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?k.globals.performance.now():Date.now()}}e.StopWatch=D}),define(oe[3],ae([0,1,9,82,2,84,140]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,P=!1;var b;(function(c){c.None=()=>D.Disposable.None;function o(B){if(P){const{onDidAddListener:X}=B,ee=h.create();let J=0;B.onDidAddListener=()=>{++J===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),X?.()}}}function u(B,X){return z(B,()=>{},0,void 0,void 0,X)}c.defer=u;function S(B){return(X,ee=null,J)=>{let _=!1,re;return re=B(ue=>{if(!_)return re?re.dispose():_=!0,X.call(ee,ue)},null,J),_&&re.dispose(),re}}c.once=S;function E(B,X,ee){return F((J,_=null,re)=>B(ue=>J.call(_,X(ue)),null,re),ee)}c.map=E;function M(B,X,ee){return F((J,_=null,re)=>B(ue=>{X(ue),J.call(_,ue)},null,re),ee)}c.forEach=M;function N(B,X,ee){return F((J,_=null,re)=>B(ue=>X(ue)&&J.call(_,ue),null,re),ee)}c.filter=N;function j(B){return B}c.signal=j;function $(...B){return(X,ee=null,J)=>(0,D.combinedDisposable)(...B.map(_=>_(re=>X.call(ee,re),null,J)))}c.any=$;function L(B,X,ee,J){let _=ee;return E(B,re=>(_=X(_,re),_),J)}c.reduce=L;function F(B,X){let ee;const J={onWillAddFirstListener(){ee=B(_.fire,_)},onDidRemoveLastListener(){ee?.dispose()}};X||o(J);const _=new g(J);return X?.add(_),_.event}function z(B,X,ee=100,J=!1,_,re){let ue,le,ye,Se=0;const be={leakWarningThreshold:_,onWillAddFirstListener(){ue=B(Ne=>{Se++,le=X(le,Ne),J&&!ye&&(Ee.fire(le),le=void 0),clearTimeout(ye),ye=setTimeout(()=>{const Fe=le;le=void 0,ye=void 0,(!J||Se>1)&&Ee.fire(Fe),Se=0},ee)})},onDidRemoveLastListener(){ue.dispose()}};re||o(be);const Ee=new g(be);return re?.add(Ee),Ee.event}c.debounce=z;function W(B,X=0,ee){return c.debounce(B,(J,_)=>J?(J.push(_),J):[_],X,void 0,void 0,ee)}c.accumulate=W;function H(B,X=(J,_)=>J===_,ee){let J=!0,_;return N(B,re=>{const ue=J||!X(re,_);return J=!1,_=re,ue},ee)}c.latch=H;function Q(B,X,ee){return[c.filter(B,X,ee),c.filter(B,J=>!X(J),ee)]}c.split=Q;function K(B,X=!1,ee=[]){let J=ee.slice(),_=B(le=>{J?J.push(le):ue.fire(le)});const re=()=>{J?.forEach(le=>ue.fire(le)),J=null},ue=new g({onWillAddFirstListener(){_||(_=B(le=>ue.fire(le)))},onDidAddFirstListener(){J&&(X?setTimeout(re):re())},onDidRemoveLastListener(){_&&_.dispose(),_=null}});return ue.event}c.buffer=K;class V{constructor(X){this.event=X,this.c=new D.DisposableStore}map(X){return new V(E(this.event,X,this.c))}forEach(X){return new V(M(this.event,X,this.c))}filter(X){return new V(N(this.event,X,this.c))}reduce(X,ee){return new V(L(this.event,X,ee,this.c))}latch(){return new V(H(this.event,void 0,this.c))}debounce(X,ee=100,J=!1,_){return new V(z(this.event,X,ee,J,_,this.c))}on(X,ee,J){return this.event(X,ee,J)}once(X,ee,J){return S(this.event)(X,ee,J)}dispose(){this.c.dispose()}}function G(B){return new V(B)}c.chain=G;function x(B,X,ee=J=>J){const J=(...le)=>ue.fire(ee(...le)),_=()=>B.on(X,J),re=()=>B.removeListener(X,J),ue=new g({onWillAddFirstListener:_,onDidRemoveLastListener:re});return ue.event}c.fromNodeEventEmitter=x;function ne(B,X,ee=J=>J){const J=(...le)=>ue.fire(ee(...le)),_=()=>B.addEventListener(X,J),re=()=>B.removeEventListener(X,J),ue=new g({onWillAddFirstListener:_,onDidRemoveLastListener:re});return ue.event}c.fromDOMEventEmitter=ne;function se(B){return new Promise(X=>S(B)(X))}c.toPromise=se;function ie(B,X){return X(void 0),B(ee=>X(ee))}c.runAndSubscribe=ie;function O(B,X){let ee=null;function J(re){ee?.dispose(),ee=new D.DisposableStore,X(re,ee)}J(void 0);const _=B(re=>J(re));return(0,D.toDisposable)(()=>{_.dispose(),ee?.dispose()})}c.runAndSubscribeWithStore=O;class U{constructor(X,ee){this.obs=X,this.c=0,this.d=!1;const J={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};ee||o(J),this.emitter=new g(J),ee&&ee.add(this.emitter)}beginUpdate(X){this.c++}handleChange(X,ee){this.d=!0}endUpdate(X){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function q(B,X){return new U(B,X).emitter.event}c.fromObservable=q})(b=e.Event||(e.Event={}));class I{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${I.c++}`,I.all.add(this)}start(o){this.d=new T.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=I,I.all=new Set,I.c=0;let C=-1;function w(c){const o=C;return C=c,{dispose(){C=o}}}e.setGlobalLeakWarningThreshold=w;class y{constructor(o,u=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=u,this.d=0}dispose(){this.c?.clear()}check(o,u){const S=this.threshold;if(S<=0||u<S)return;this.c||(this.c=new Map);const E=this.c.get(o.value)||0;if(this.c.set(o.value,E+1),this.d-=1,this.d<=0){this.d=S*.5;let M,N=0;for(const[j,$]of this.c)(!M||N<$)&&(M=j,N=$);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${N}):`),console.warn(M)}return()=>{const M=this.c.get(o.value)||0;this.c.set(o.value,M-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(o,u,S){this.callback=o,this.callbackThis=u,this.stack=S,this.subscription=new D.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class g{constructor(o){this.j=!1,this.d=o,this.f=C>0||this.d?.leakWarningThreshold?new y(this.d?.leakWarningThreshold??C):void 0,this.g=this.d?._profName?new I(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(R){const o=Array.from(this.q);queueMicrotask(()=>{for(const u of o)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,u,S)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let M,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=h.create(),M=this.f.check(N,this.q.size+1)),R&&(N=N??h.create());const j=new m(o,u,N),$=this.q.push(j);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,u);const L=j.subscription.set(()=>{M?.(),this.j||($(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return S instanceof D.DisposableStore?S.add(L):Array.isArray(S)&&S.push(L),L}),this.l}fire(o){if(this.q){this.m||(this.m=new f);for(const u of this.q)this.m.push(this,u,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=g;class l{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(o,u,S){this.c.push(new p(o,u,S))}clear(o){const u=new A.LinkedList;for(const S of this.c)S.emitter!==o&&u.push(S);this.c=u}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(u){(0,k.onUnexpectedError)(u)}}}}e.EventDeliveryQueue=l;class f extends l{clear(o){this.c.clear()}}class p{constructor(o,u,S){this.emitter=o,this.listener=u,this.event=S}}class v extends g{async fireAsync(o,u,S){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const E of this.q)this.c.push([E,o]);for(;this.c.size>0&&!u.isCancellationRequested;){const[E,M]=this.c.shift(),N=[],j={...M,token:u,waitUntil:$=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");S&&($=S($,E.callback)),N.push($)}};try{E.invoke(j)}catch($){(0,k.onUnexpectedError)($);continue}Object.freeze(N),await Promise.allSettled(N).then($=>{for(const L of $)L.status==="rejected"&&(0,k.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=v;class d extends g{constructor(o){super(o),this.h=0,this.s=new A.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=d;class n extends d{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=n;class r extends g{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.d=!1,this.f=[],this.c=new g({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const u={event:o,listener:null};this.f.push(u),this.d&&this.j(u);const S=()=>{this.d&&this.k(u);const E=this.f.indexOf(u);this.f.splice(E,1)};return(0,D.toDisposable)((0,i.once)(S))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(u=>this.c.fire(u))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class s{constructor(){this.c=[]}wrapEvent(o){return(u,S,E)=>o(M=>{const N=this.c[this.c.length-1];N?N.push(()=>u.call(S,M)):u.call(S,M)},void 0,E)}bufferEvents(o){const u=[];this.c.push(u);const S=o();return this.c.pop(),u.forEach(E=>E()),S}}e.EventBufferer=s;class a{constructor(){this.c=!1,this.d=b.None,this.f=D.Disposable.None,this.g=new g({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=a}),define(oe[24],ae([0,1,3]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(R,P){const b=setTimeout(R.bind(P),0);return{dispose(){clearTimeout(b)}}});var D;(function(R){function P(b){return b===R.None||b===R.Cancelled||b instanceof A?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}R.isCancellationToken=P,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(D=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new k.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(P){this.a=void 0,this.b=void 0,this.b=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=D.Cancelled}dispose(P=!1){P&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=D.None}}e.CancellationTokenSource=T}),define(oe[141],ae([0,1,24]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new k.CancellationTokenSource,P=this.b(R.token);return this.a={promise:P,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.Cache=i;class D{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const P=JSON.stringify(R);return this.b!==P&&(this.b=P,this.a=this.c(R)),this.a}}e.LRUCachedFunction=D;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const P=this.b(R);return this.a.set(R,P),P}}e.CachedFunction=A}),define(oe[27],ae([0,1,141,127]),function(Z,e,k,i){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=A;const T=/{(\d+)}/g;function R(te,...he){return he.length===0?te:te.replace(T,function(fe,me){const we=parseInt(me,10);return isNaN(we)||we<0||we>=he.length?fe:he[we]})}e.format=R;const P=/{([^}]+)}/g;function b(te,he){return te.replace(P,(fe,me)=>he[me]??fe)}e.format2=b;function I(te){return te.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=I;function C(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function w(te,he){let fe=0;const me=he.charCodeAt(0);for(let we=te.length-1;we>=0;we--)te.charCodeAt(we)===me&&fe++;return fe}e.count=w;function y(te,he,fe="\u2026"){return te.length<=he?te:`${te.substr(0,he)}${fe}`}e.truncate=y;function h(te,he=" "){const fe=m(te,he);return g(fe,he)}e.trim=h;function m(te,he){if(!te||!he)return te;const fe=he.length;if(fe===0||te.length===0)return te;let me=0;for(;te.indexOf(he,me)===me;)me=me+fe;return te.substring(me)}e.ltrim=m;function g(te,he){if(!te||!he)return te;const fe=he.length,me=te.length;if(fe===0||me===0)return te;let we=me,Ie=-1;for(;Ie=te.lastIndexOf(he,we-1),!(Ie===-1||Ie+fe!==we);){if(Ie===0)return"";we=Ie}return te.substring(0,we)}e.rtrim=g;function l(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function f(te){return te.replace(/\*/g,"")}e.stripWildcards=f;function p(te,he,fe={}){if(!te)throw new Error("Cannot create regex from empty string");he||(te=C(te)),fe.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(te,me)}e.createRegExp=p;function v(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function d(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=d;function n(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=n;function r(te){return te.split(/\r\n|\r|\n/)}e.splitLines=r;function t(te){for(let he=0,fe=te.length;he<fe;he++){const me=te.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function s(te,he=0,fe=te.length){for(let me=he;me<fe;me++){const we=te.charCodeAt(me);if(we!==32&&we!==9)return te.substring(he,me)}return te.substring(he,fe)}e.getLeadingWhitespace=s;function a(te,he=te.length-1){for(let fe=he;fe>=0;fe--){const me=te.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=a;function c(te,he,fe){const me=[];let we=0;for(const Ie of te.matchAll(he)){if(me.push(te.slice(we,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");we=Ie.index+Ie[0].length,me.push(fe(Ie[0],...Ie.slice(1),Ie.index,te,Ie.groups))}return me.push(te.slice(we)),Promise.all(me).then(Ie=>Ie.join(""))}e.replaceAsync=c;function o(te,he){return te<he?-1:te>he?1:0}e.compare=o;function u(te,he,fe=0,me=te.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){const $e=te.charCodeAt(fe),Le=he.charCodeAt(we);if($e<Le)return-1;if($e>Le)return 1}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstring=u;function S(te,he){return E(te,he,0,te.length,0,he.length)}e.compareIgnoreCase=S;function E(te,he,fe=0,me=te.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){let $e=te.charCodeAt(fe),Le=he.charCodeAt(we);if($e===Le)continue;if($e>=128||Le>=128)return u(te.toLowerCase(),he.toLowerCase(),fe,me,we,Ie);N($e)&&($e-=32),N(Le)&&(Le-=32);const qe=$e-Le;if(qe!==0)return qe}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstringIgnoreCase=E;function M(te){return te>=48&&te<=57}e.isAsciiDigit=M;function N(te){return te>=97&&te<=122}e.isLowerAsciiLetter=N;function j(te){return te>=65&&te<=90}e.isUpperAsciiLetter=j;function $(te,he){return te.length===he.length&&E(te,he)===0}e.equalsIgnoreCase=$;function L(te,he){const fe=he.length;return he.length>te.length?!1:E(te,he,0,fe)===0}e.startsWithIgnoreCase=L;function F(te,he){const fe=Math.min(te.length,he.length);let me;for(me=0;me<fe;me++)if(te.charCodeAt(me)!==he.charCodeAt(me))return me;return fe}e.commonPrefixLength=F;function z(te,he){const fe=Math.min(te.length,he.length);let me;const we=te.length-1,Ie=he.length-1;for(me=0;me<fe;me++)if(te.charCodeAt(we-me)!==he.charCodeAt(Ie-me))return me;return fe}e.commonSuffixLength=z;function W(te){return 55296<=te&&te<=56319}e.isHighSurrogate=W;function H(te){return 56320<=te&&te<=57343}e.isLowSurrogate=H;function Q(te,he){return(te-55296<<10)+(he-56320)+65536}e.computeCodePoint=Q;function K(te,he,fe){const me=te.charCodeAt(fe);if(W(me)&&fe+1<he){const we=te.charCodeAt(fe+1);if(H(we))return Q(me,we)}return me}e.getNextCodePoint=K;function V(te,he){const fe=te.charCodeAt(he-1);if(H(fe)&&he>1){const me=te.charCodeAt(he-2);if(W(me))return Q(me,fe)}return fe}class G{get offset(){return this.e}constructor(he,fe=0){this.c=he,this.d=he.length,this.e=fe}setOffset(he){this.e=he}prevCodePoint(){const he=V(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=K(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=G;class x{get offset(){return this.c.offset}constructor(he,fe=0){this.c=new G(he,fe)}nextGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.nextCodePoint());if(Ce(we,Re)){fe.setOffset(Ie);break}we=Re}return fe.offset-me}prevGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.prevCodePoint());if(Ce(Re,we)){fe.setOffset(Ie);break}we=Re}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=x;function ne(te,he){return new x(te,he).nextGraphemeLength()}e.nextCharLength=ne;function se(te,he){return new x(te,he).prevGraphemeLength()}e.prevCharLength=se;function ie(te,he){he>0&&H(te.charCodeAt(he))&&he--;const fe=he+ne(te,he);return[fe-se(te,fe),fe]}e.getCharContainingOffset=ie;function O(te){const he=new x(te);let fe=0;for(;!he.eol();)fe++,he.nextGraphemeLength();return fe}e.charCount=O;let U;function q(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(te){return U||(U=q()),U.test(te)}e.containsRTL=B;const X=/^[\t\n\r\x20-\x7E]*$/;function ee(te){return X.test(te)}e.isBasicASCII=ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function J(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=J;function _(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=_;function re(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=re;function ue(te,he){if(te.length<he)return te;const fe=/\b/g;let me=0;for(;fe.test(te)&&!(te.length-fe.lastIndex<he);)me=fe.lastIndex,fe.lastIndex+=1;return te.substring(me).replace(/^\s/,"")}e.lcut=ue;const le=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,Se=/\x1b\[0?m/g;function be(te){return te&&(te=te.replace(le,""),te=te.replace(ye,""),te=te.replace(Se,"")),te}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ne(te){return Ee(te)?te.substr(1):te}e.stripUTF8BOM=Ne;function Fe(te,he){if(!te||!he||te.length<he.length)return!1;const fe=he.length,me=te.toLowerCase();let we=0,Ie=-1;for(;we<fe;){const Re=me.indexOf(he[we],Ie+1);if(Re<0)return!1;Ie=Re,we++}return!0}e.fuzzyContains=Fe;function Ye(te,he=!1){return te?(he&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=Ye;function ze(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=ze;function ce(te,he=1){if(he===0)return"";let fe=-1;do fe=te.indexOf(`
`,fe+1),he--;while(he>0&&fe>=0);return fe===-1?te:(te[fe-1]==="\r"&&fe--,te.substr(0,fe))}e.getNLines=ce;function de(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}e.singleLetterHash=de;function ge(te){return Ae.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=ge;function Ce(te,he){return te===0?he!==5&&he!==7:te===2&&he===3?!1:te===4||te===2||te===3||he===4||he===2||he===3?!0:!(te===8&&(he===8||he===9||he===11||he===12)||(te===11||te===9)&&(he===9||he===10)||(te===12||te===10)&&he===10||he===5||he===13||he===7||te===1||te===13&&he===14||te===6&&he===6)}var Pe;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const fe=this.d,me=fe.length/3;let we=1;for(;we<=me;)if(he<fe[3*we])we=2*we;else if(he>fe[3*we+1])we=2*we+1;else return fe[3*we+2];return 0}}Ae.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(te,he){if(te===0)return 0;const fe=Te(te,he);if(fe!==void 0)return fe;const me=new G(he,te);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=je;function Te(te,he){const fe=new G(he,te);let me=fe.prevCodePoint();for(;Ue(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!re(me))return;let we=fe.offset;return we>0&&fe.prevCodePoint()===8205&&(we=fe.offset),we}function Ue(te){return 127995<=te&&te<=127999}var Be;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.d.get(Array.from(he))}static getLocales(){return ke.e.getValue()}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=ke,D=ke,ke.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.d=new k.LRUCachedFunction(te=>{function he(Le){const qe=new Map;for(let Ge=0;Ge<Le.length;Ge+=2)qe.set(Le[Ge],Le[Ge+1]);return qe}function fe(Le,qe){const Ge=new Map(Le);for(const[et,ot]of qe)Ge.set(et,ot);return Ge}function me(Le,qe){if(!Le)return qe;const Ge=new Map;for(const[et,ot]of Le)qe.has(et)&&Ge.set(et,ot);return Ge}const we=D.c.getValue();let Ie=te.filter(Le=>!Le.startsWith("_")&&Le in we);Ie.length===0&&(Ie=["_default"]);let Re;for(const Le of Ie){const qe=he(we[Le]);Re=me(Re,qe)}const He=he(we._common),$e=fe(He,Re);return new ke($e)}),ke.e=new i.Lazy(()=>Object.keys(ke.c.getValue()).filter(te=>!te.startsWith("_")));class Oe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Oe.c())),this.d}static isInvisibleCharacter(he){return Oe.e().has(he)}static get codePoints(){return Oe.e()}}e.InvisibleCharacters=Oe,Oe.d=void 0}),define(oe[48],ae([0,1,12,5,27,13]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(a){return a===47||a===92}e.isPathSeparator=T;function R(a){return a.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function P(a){return a.indexOf("/")===-1&&(a=R(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=P;function b(a,c=k.posix.sep){if(!a)return"";const o=a.length,u=a.charCodeAt(0);if(T(u)){if(T(a.charCodeAt(1))&&!T(a.charCodeAt(2))){let E=3;const M=E;for(;E<o&&!T(a.charCodeAt(E));E++);if(M!==E&&!T(a.charCodeAt(E+1))){for(E+=1;E<o;E++)if(T(a.charCodeAt(E)))return a.slice(0,E+1).replace(/[\\/]/g,c)}}return c}else if(l(u)&&a.charCodeAt(1)===58)return T(a.charCodeAt(2))?a.slice(0,2)+c:a.slice(0,2);let S=a.indexOf("://");if(S!==-1){for(S+=3;S<o;S++)if(T(a.charCodeAt(S)))return a.slice(0,S+1)}return""}e.getRoot=b;function I(a){if(!i.isWindows||!a||a.length<5)return!1;let c=a.charCodeAt(0);if(c!==92||(c=a.charCodeAt(1),c!==92))return!1;let o=2;const u=o;for(;o<a.length&&(c=a.charCodeAt(o),c!==92);o++);return!(u===o||(c=a.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=I;const C=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(a,c=i.isWindows){const o=c?C:w;return!(!a||a.length===0||/^\s+$/.test(a)||(o.lastIndex=0,o.test(a))||c&&y.test(a)||a==="."||a===".."||c&&a[a.length-1]==="."||c&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=h;function m(a,c,o){const u=a===c;return!o||u?u:!a||!c?!1:(0,D.equalsIgnoreCase)(a,c)}e.isEqual=m;function g(a,c,o,u=k.sep){if(a===c)return!0;if(!a||!c||c.length>a.length)return!1;if(o){if(!(0,D.startsWithIgnoreCase)(a,c))return!1;if(c.length===a.length)return!0;let E=c.length;return c.charAt(c.length-1)===u&&E--,a.charAt(E)===u}return c.charAt(c.length-1)!==u&&(c+=u),a.indexOf(c)===0}e.isEqualOrParent=g;function l(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=l;function f(a,c){return i.isWindows&&a.endsWith(":")&&(a+=k.sep),(0,k.isAbsolute)(a)||(a=(0,k.join)(c,a)),a=(0,k.normalize)(a),i.isWindows?(a=(0,D.rtrim)(a,k.sep),a.endsWith(":")&&(a+=k.sep)):(a=(0,D.rtrim)(a,k.sep),a||(a=k.sep)),a}e.sanitizeFilePath=f;function p(a){const c=(0,k.normalize)(a);return i.isWindows?a.length>3?!1:v(c)&&(a.length===2||c.charCodeAt(2)===92):c===k.posix.sep}e.isRootOrDriveLetter=p;function v(a,c=i.isWindows){return c?l(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function d(a){return v(a)?a[0]:void 0}e.getDriveLetter=d;function n(a,c,o){return c.length>a.length?-1:a===c?0:(o&&(a=a.toLowerCase(),c=c.toLowerCase()),a.indexOf(c))}e.indexOfPath=n;function r(a){const c=a.split(":");let o,u,S;for(const E of c){const M=Number(E);(0,A.isNumber)(M)?u===void 0?u=M:S===void 0&&(S=M):o=o?[o,E].join(":"):E}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:u!==void 0?u:void 0,column:S!==void 0?S:u!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(a,c,o=8){let u="";for(let E=0;E<o;E++)u+=t.charAt(Math.floor(Math.random()*t.length));let S;return c?S=`${c}-${u}`:S=u,a?(0,k.join)(a,S):S}e.randomPath=s}),define(oe[66],ae([0,1,27]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(l){return D(l,0)}e.hash=i;function D(l,f){switch(typeof l){case"object":return l===null?A(349,f):Array.isArray(l)?P(l,f):b(l,f);case"string":return R(l,f);case"boolean":return T(l,f);case"number":return A(l,f);case"undefined":return A(937,f);default:return A(617,f)}}e.doHash=D;function A(l,f){return(f<<5)-f+l|0}e.numberHash=A;function T(l,f){return A(l?433:863,f)}function R(l,f){f=A(149417,f);for(let p=0,v=l.length;p<v;p++)f=A(l.charCodeAt(p),f);return f}e.stringHash=R;function P(l,f){return f=A(104579,f),l.reduce((p,v)=>D(v,p),f)}function b(l,f){return f=A(181387,f),Object.keys(l).sort().reduce((p,v)=>(p=R(v,p),D(l[v],p)),f)}class I{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=D(f,this.g),this.g}}e.Hasher=I;var C;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function w(l,f,p=32){const v=p-f,d=~((1<<v)-1);return(l<<f|(d&l)>>>v)>>>0}function y(l,f=0,p=l.byteLength,v=0){for(let d=0;d<p;d++)l[f+d]=v}function h(l,f,p="0"){for(;l.length<f;)l=p+l;return l}function m(l,f=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(p=>p.toString(16).padStart(2,"0")).join(""):h((l>>>0).toString(16),f/4)}e.toHexString=m;class g{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const p=f.length;if(p===0)return;const v=this.p;let d=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=f.charCodeAt(0),t=0);;){let s=r;if(k.isHighSurrogate(r))if(t+1<p){const a=f.charCodeAt(t+1);k.isLowSurrogate(a)?(t++,s=k.computeCodePoint(r,a)):s=65533}else{n=r;break}else k.isLowSurrogate(r)&&(s=65533);if(d=this.w(v,d,s),t++,t<p)r=f.charCodeAt(t);else break}this.r=d,this.u=n}w(f,p,v){return v<128?f[p++]=v:v<2048?(f[p++]=192|(v&1984)>>>6,f[p++]=128|(v&63)>>>0):v<65536?(f[p++]=224|(v&61440)>>>12,f[p++]=128|(v&4032)>>>6,f[p++]=128|(v&63)>>>0):(f[p++]=240|(v&1835008)>>>18,f[p++]=128|(v&258048)>>>12,f[p++]=128|(v&4032)>>>6,f[p++]=128|(v&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=g.g,p=this.q;for(let o=0;o<64;o+=4)f.setUint32(o,p.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)f.setUint32(o,w(f.getUint32(o-12,!1)^f.getUint32(o-32,!1)^f.getUint32(o-56,!1)^f.getUint32(o-64,!1),1),!1);let v=this.h,d=this.l,n=this.m,r=this.n,t=this.o,s,a,c;for(let o=0;o<80;o++)o<20?(s=d&n|~d&r,a=1518500249):o<40?(s=d^n^r,a=1859775393):o<60?(s=d&n|d&r|n&r,a=2400959708):(s=d^n^r,a=3395469782),c=w(v,5)+s+t+a+f.getUint32(o*4,!1)&4294967295,t=r,r=n,n=w(d,30),d=v,v=c;this.h=this.h+v&4294967295,this.l=this.l+d&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=g,g.g=new DataView(new ArrayBuffer(320))}),define(oe[88],ae([0,1,27]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(i||(i={})),function(D){const A="error",T="warning",R="warn",P="info",b="ignore";function I(w){return w?k.equalsIgnoreCase(A,w)?D.Error:k.equalsIgnoreCase(T,w)||k.equalsIgnoreCase(R,w)?D.Warning:k.equalsIgnoreCase(P,w)?D.Info:D.Ignore:D.Ignore}D.fromValue=I;function C(w){switch(w){case D.Error:return A;case D.Warning:return T;case D.Info:return P;default:return b}}D.toString=C}(i||(i={})),e.default=i}),define(oe[49],ae([0,1,20,27]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const h=y.charCodeAt(0),m=this.b.charCodeAt(this.c);return h-m}value(){return this.b[this.c]}}e.StringIterator=D;class A{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,i.compareSubstring)(y,this.b,0,y.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class T{constructor(y=!0,h=!0){this.f=y,this.g=h}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let h=y.length-1;h>=0;h--,this.c--){const m=this.b.charCodeAt(h);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===47||this.f&&h===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,i.compareSubstring)(y,this.b,0,y.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=T;var R;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(R||(R={}));class P{constructor(y,h){this.f=y,this.g=h,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new T(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(y,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,i.compare)(y,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=P;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(I||(I={}));class C{static forUris(y=()=>!1,h=()=>!1){return new C(new P(y,h))}static forPaths(y=!1){return new C(new T(void 0,!y))}static forStrings(){return new C(new D)}static forConfigKeys(){return new C(new A)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,h){if(h){const m=h.slice(0);(0,k.shuffle)(m);for(const g of m)this.set(g,y)}else{const m=y.slice(0);(0,k.shuffle)(m);for(const g of m)this.set(g[0],g[1])}}set(y,h){const m=this.b.reset(y);let g;this.c||(this.c=new b,this.c.segment=m.value());const l=[];for(g=this.c;;){const p=m.cmp(g.segment);if(p>0)g.left||(g.left=new b,g.left.segment=m.value()),l.push([-1,g]),g=g.left;else if(p<0)g.right||(g.right=new b,g.right.segment=m.value()),l.push([1,g]),g=g.right;else if(m.hasNext())m.next(),g.mid||(g.mid=new b,g.mid.segment=m.value()),l.push([0,g]),g=g.mid;else break}const f=g.value;g.value=h,g.key=y;for(let p=l.length-1;p>=0;p--){const v=l[p][1];v.updateHeight();const d=v.balanceFactor();if(d<-1||d>1){const n=l[p][0],r=l[p+1][0];if(n===1&&r===1)l[p][1]=v.rotateLeft();else if(n===-1&&r===-1)l[p][1]=v.rotateRight();else if(n===1&&r===-1)v.right=l[p+1][1]=l[p+1][1].rotateRight(),l[p][1]=v.rotateLeft();else if(n===-1&&r===1)v.left=l[p+1][1]=l[p+1][1].rotateLeft(),l[p][1]=v.rotateRight();else throw new Error;if(p>0)switch(l[p-1][0]){case-1:l[p-1][1].left=l[p][1];break;case 1:l[p-1][1].right=l[p][1];break;case 0:l[p-1][1].mid=l[p][1];break}else this.c=l[0][1]}}return f}get(y){return this.d(y)?.value}d(y){const h=this.b.reset(y);let m=this.c;for(;m;){const g=h.cmp(m.segment);if(g>0)m=m.left;else if(g<0)m=m.right;else if(h.hasNext())h.next(),m=m.mid;else break}return m}has(y){const h=this.d(y);return!(h?.value===void 0&&h?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,h){const m=this.b.reset(y),g=[];let l=this.c;for(;l;){const f=m.cmp(l.segment);if(f>0)g.push([-1,l]),l=l.left;else if(f<0)g.push([1,l]),l=l.right;else if(m.hasNext())m.next(),g.push([0,l]),l=l.mid;else break}if(!!l){if(h?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const f=this.f(l.right);if(f.key){const{key:p,value:v,segment:d}=f;this.e(f.key,!1),l.key=p,l.value=v,l.segment=d}}else{const f=l.left??l.right;if(g.length>0){const[p,v]=g[g.length-1];switch(p){case-1:v.left=f;break;case 0:v.mid=f;break;case 1:v.right=f;break}}else this.c=f}for(let f=g.length-1;f>=0;f--){const p=g[f][1];p.updateHeight();const v=p.balanceFactor();if(v>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),g[f][1]=p.rotateLeft()):v<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),g[f][1]=p.rotateRight()),f>0)switch(g[f-1][0]){case-1:g[f-1][1].left=g[f][1];break;case 1:g[f-1][1].right=g[f][1];break;case 0:g[f-1][1].mid=g[f][1];break}else this.c=g[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const h=this.b.reset(y);let m=this.c,g;for(;m;){const l=h.cmp(m.segment);if(l>0)m=m.left;else if(l<0)m=m.right;else if(h.hasNext())h.next(),g=m.value||g,m=m.mid;else break}return m&&m.value||g}findSuperstr(y){return this.g(y,!1)}g(y,h){const m=this.b.reset(y);let g=this.c;for(;g;){const l=m.cmp(g.segment);if(l>0)g=g.left;else if(l<0)g=g.right;else if(m.hasNext())m.next(),g=g.mid;else return g.mid?this.h(g.mid):h?g.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[h,m]of this)y(m,h)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const h=[];return this.j(y,h),h[Symbol.iterator]()}j(y,h){!y||(y.left&&this.j(y.left,h),y.value&&h.push([y.key,y.value]),y.mid&&this.j(y.mid,h),y.right&&this.j(y.right,h))}_isBalanced(){const y=h=>{if(!h)return!0;const m=h.balanceFactor();return m<-1||m>1?!1:y(h.left)&&y(h.right)};return y(this.c)}}e.TernarySearchTree=C}),define(oe[7],ae([0,1,12,5]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,A=/^\//,T=/^\/\//;function R(t,s){if(!t.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!D.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!A.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(t,s){return!t&&!s?"file":t}function b(t,s){switch(t){case"https":case"http":case"file":s?s[0]!==C&&(s=C+s):s=C;break}return s}const I="",C="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(s){return s instanceof y?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,a,c,o,u,S=!1){typeof s=="object"?(this.scheme=s.scheme||I,this.authority=s.authority||I,this.path=s.path||I,this.query=s.query||I,this.fragment=s.fragment||I):(this.scheme=P(s,S),this.authority=a||I,this.path=b(this.scheme,c||I),this.query=o||I,this.fragment=u||I,R(this,S))}get fsPath(){return p(this,!1)}with(s){if(!s)return this;let{scheme:a,authority:c,path:o,query:u,fragment:S}=s;return a===void 0?a=this.scheme:a===null&&(a=I),c===void 0?c=this.authority:c===null&&(c=I),o===void 0?o=this.path:o===null&&(o=I),u===void 0?u=this.query:u===null&&(u=I),S===void 0?S=this.fragment:S===null&&(S=I),a===this.scheme&&c===this.authority&&o===this.path&&u===this.query&&S===this.fragment?this:new m(a,c,o,u,S)}static parse(s,a=!1){const c=w.exec(s);return c?new m(c[2]||I,r(c[4]||I),r(c[5]||I),r(c[7]||I),r(c[9]||I),a):new m(I,I,I,I,I)}static file(s){let a=I;if(i.isWindows&&(s=s.replace(/\\/g,C)),s[0]===C&&s[1]===C){const c=s.indexOf(C,2);c===-1?(a=s.substring(2),s=C):(a=s.substring(2,c),s=s.substring(c)||C)}return new m("file",a,s,I,I)}static from(s){const a=new m(s.scheme,s.authority,s.path,s.query,s.fragment);return R(a,!0),a}static joinPath(s,...a){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return i.isWindows&&s.scheme==="file"?c=y.file(k.win32.join(p(s,!0),...a)).path:c=k.posix.join(s.path,...a),s.with({path:c})}toString(s=!1){return v(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof y)return s;{const a=new m(s);return a._formatted=s.external,a._fsPath=s._sep===h?s.fsPath:null,a}}else return s}}e.URI=y;const h=i.isWindows?1:void 0;class m extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(s=!1){return s?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=h),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(t,s,a){let c,o=-1;for(let u=0;u<t.length;u++){const S=t.charCodeAt(u);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||s&&S===47||a&&S===91||a&&S===93||a&&S===58)o!==-1&&(c+=encodeURIComponent(t.substring(o,u)),o=-1),c!==void 0&&(c+=t.charAt(u));else{c===void 0&&(c=t.substr(0,u));const E=g[S];E!==void 0?(o!==-1&&(c+=encodeURIComponent(t.substring(o,u)),o=-1),c+=E):o===-1&&(o=u)}}return o!==-1&&(c+=encodeURIComponent(t.substring(o))),c!==void 0?c:t}function f(t){let s;for(let a=0;a<t.length;a++){const c=t.charCodeAt(a);c===35||c===63?(s===void 0&&(s=t.substr(0,a)),s+=g[c]):s!==void 0&&(s+=t[a])}return s!==void 0?s:t}function p(t,s){let a;return t.authority&&t.path.length>1&&t.scheme==="file"?a=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?s?a=t.path.substr(1):a=t.path[1].toLowerCase()+t.path.substr(2):a=t.path,i.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=p;function v(t,s){const a=s?f:l;let c="",{scheme:o,authority:u,path:S,query:E,fragment:M}=t;if(o&&(c+=o,c+=":"),(u||o==="file")&&(c+=C,c+=C),u){let N=u.indexOf("@");if(N!==-1){const j=u.substr(0,N);u=u.substr(N+1),N=j.lastIndexOf(":"),N===-1?c+=a(j,!1,!1):(c+=a(j.substr(0,N),!1,!1),c+=":",c+=a(j.substr(N+1),!1,!0)),c+="@"}u=u.toLowerCase(),N=u.lastIndexOf(":"),N===-1?c+=a(u,!1,!0):(c+=a(u.substr(0,N),!1,!0),c+=u.substr(N))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const N=S.charCodeAt(1);N>=65&&N<=90&&(S=`/${String.fromCharCode(N+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const N=S.charCodeAt(0);N>=65&&N<=90&&(S=`${String.fromCharCode(N+32)}:${S.substr(2)}`)}c+=a(S,!0,!1)}return E&&(c+="?",c+=a(E,!1,!1)),M&&(c+="#",c+=s?M:l(M,!1,!1)),c}function d(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+d(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(n)?t.replace(n,s=>d(s)):t}}),define(oe[142],ae([0,1,7]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(b){const I=b;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=i;function D(b){const I=[];let C;try{const w=JSON.parse(b.arguments),y=w[w.length-1];y&&y.__$stack&&(w.pop(),C=y.__$stack),I.push(...w)}catch{I.push("Unable to log remote console arguments",b.arguments)}return{args:I,stack:C}}e.parse=D;function A(b){if(typeof b!="string")return A(D(b).stack);const I=b;if(I){const C=T(I),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(w&&w.length===4)return{uri:k.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=A;function T(b){if(!b)return b;const I=b.indexOf(`
`);return I===-1?b:b.substring(0,I)}function R(b,I){const{args:C,stack:w}=D(b),y=typeof C[0]=="string"&&C.length===1;let h=T(w);h&&(h=`(${h.trim()})`);let m=[];if(typeof C[0]=="string"?h&&y?m=[`%c[${I}] %c${C[0]} %c${h}`,P("blue"),P(""),P("grey")]:m=[`%c[${I}] %c${C[0]}`,P("blue"),P(""),...C.slice(1)]:m=[`%c[${I}]%`,P("blue"),...C],h&&!y&&m.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,m)}e.log=R;function P(b){return`color: ${b}`}}),define(oe[67],ae([0,1,17,27,7]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(b){return JSON.stringify(b,R)}e.stringify=A;function T(b){let I=JSON.parse(b);return I=P(I),I}e.parse=T;function R(b,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,i.regExpFlags)(I)}:I}function P(b,I=0){if(!b||I>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 16:return new Date(b.source)}if(b instanceof k.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let C=0;C<b.length;++C)b[C]=P(b[C],I+1);else for(const C in b)Object.hasOwnProperty.call(b,C)&&(b[C]=P(b[C],I+1))}return b}e.revive=P}),define(oe[22],ae([0,1,5,7]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls",P.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b){this.f=`${b}/${D.vscodeRemoteResource}`}set(b,I,C){this.a[b]=I,this.b[b]=C}setConnectionToken(b,I){this.c[b]=I}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)return this.e(b);const I=b.authority;let C=this.a[I];C&&C.indexOf(":")!==-1&&C.indexOf("[")===-1&&(C=`[${C}]`);const w=this.b[I],y=this.c[I];let h=`path=${encodeURIComponent(b.path)}`;return typeof y=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),i.URI.from({scheme:k.isWeb?this.d:D.vscodeRemoteResource,authority:`${C}:${w}`,path:this.f,query:h})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class T{asBrowserUri(b){const I=this.b(b,Z);return this.uriToBrowserUri(I)}uriToBrowserUri(b){return b.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===D.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${D.vscodeFileResource}://${T.a}`)?b.with({scheme:D.vscodeFileResource,authority:b.authority||T.a,query:null,fragment:null}):b}asFileUri(b){const I=this.b(b,Z);return this.uriToFileUri(I)}uriToFileUri(b){return b.scheme===D.vscodeFileResource?b.with({scheme:D.file,authority:b.authority!==T.a?b.authority:null,query:null,fragment:null}):b}b(b,I){return i.URI.isUri(b)?b:i.URI.parse(I.toUrl(b))}}T.a="vscode-app",e.FileAccess=new T;var R;(function(P){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);P.CoopAndCoep=Object.freeze(b.get("3"));const I="vscode-coi";function C(y){let h;typeof y=="string"?h=new URL(y).searchParams:y instanceof URL?h=y.searchParams:i.URI.isUri(y)&&(h=new URL(y.toString(!0)).searchParams);const m=h?.get(I);if(!!m)return b.get(m)}P.getHeadersFromQuery=C;function w(y,h,m){if(!globalThis.crossOriginIsolated)return;const g=h&&m?"3":m?"2":"1";y instanceof URLSearchParams?y.set(I,g):y[I]=g}P.addSearchParam=w})(R=e.COI||(e.COI={}))}),define(oe[23],ae([0,1,48,22,12,5,27,7]),function(Z,e,k,i,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(y){return(0,R.uriToFsPath)(y,!0)}e.originalFSPath=P;class b{constructor(h){this.a=h}compare(h,m,g=!1){return h===m?0:(0,T.compare)(this.getComparisonKey(h,g),this.getComparisonKey(m,g))}isEqual(h,m,g=!1){return h===m?!0:!h||!m?!1:this.getComparisonKey(h,g)===this.getComparisonKey(m,g)}getComparisonKey(h,m=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,m,g=!1){if(h.scheme===m.scheme){if(h.scheme===i.Schemas.file)return k.isEqualOrParent(P(h),P(m),this.a(h))&&h.query===m.query&&(g||h.fragment===m.fragment);if((0,e.isEqualAuthority)(h.authority,m.authority))return k.isEqualOrParent(h.path,m.path,this.a(h),"/")&&h.query===m.query&&(g||h.fragment===m.fragment)}return!1}joinPath(h,...m){return R.URI.joinPath(h,...m)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let m;return h.scheme===i.Schemas.file?m=R.URI.file(D.dirname(P(h))).path:(m=D.posix.dirname(h.path),h.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),m="/")),h.with({path:m})}normalizePath(h){if(!h.path.length)return h;let m;return h.scheme===i.Schemas.file?m=R.URI.file(D.normalize(P(h))).path:m=D.posix.normalize(h.path),h.with({path:m})}relativePath(h,m){if(h.scheme!==m.scheme||!(0,e.isEqualAuthority)(h.authority,m.authority))return;if(h.scheme===i.Schemas.file){const f=D.relative(P(h),P(m));return A.isWindows?k.toSlashes(f):f}let g=h.path||"/";const l=m.path||"/";if(this.a(h)){let f=0;for(const p=Math.min(g.length,l.length);f<p&&!(g.charCodeAt(f)!==l.charCodeAt(f)&&g.charAt(f).toLowerCase()!==l.charAt(f).toLowerCase());f++);g=l.substr(0,f)+g.substr(f)}return D.posix.relative(g,l)}resolvePath(h,m){if(h.scheme===i.Schemas.file){const g=R.URI.file(D.resolve(P(h),m));return h.with({authority:g.authority,path:g.path})}return m=k.toPosixPath(m),h.with({path:D.posix.resolve(h.path,m)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,m){return h===m||h!==void 0&&m!==void 0&&(0,T.equalsIgnoreCase)(h,m)}hasTrailingPathSeparator(h,m=D.sep){if(h.scheme===i.Schemas.file){const g=P(h);return g.length>k.getRoot(g).length&&g[g.length-1]===m}else{const g=h.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,m=D.sep){return(0,e.hasTrailingPathSeparator)(h,m)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,m=D.sep){let g=!1;if(h.scheme===i.Schemas.file){const l=P(h);g=l!==void 0&&l.length===k.getRoot(l).length&&l[l.length-1]===m}else{m="/";const l=h.path;g=l.length===1&&l.charCodeAt(l.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(h,m)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(y=>y.scheme===i.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new b(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(y,h){const m=[];for(let g=0;g<y.length;g++){const l=h(y[g]);y.some((f,p)=>p===g?!1:(0,e.isEqualOrParent)(l,h(f)))||m.push(y[g])}return m}e.distinctParents=I;var C;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function h(m){const g=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(p=>{const[v,d]=p.split(":");v&&d&&g.set(v,d)});const f=m.path.substring(0,m.path.indexOf(";"));return f&&g.set(y.META_DATA_MIME,f),g}y.parseMetaData=h})(C=e.DataUri||(e.DataUri={}));function w(y,h,m){if(h){let g=y.path;return g&&g[0]!==D.posix.sep&&(g=D.posix.sep+g),y.with({scheme:m,authority:h,path:g})}return y.with({scheme:m})}e.toLocalResource=w}),define(oe[6],ae([0,1,24,9,3,2,23,5]),function(Z,e,k,i,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(ie){return!!ie&&typeof ie.then=="function"}e.isThenable=P;function b(ie){const O=new k.CancellationTokenSource,U=ie(O.token),q=new Promise((B,X)=>{const ee=O.token.onCancellationRequested(()=>{ee.dispose(),O.dispose(),X(new i.CancellationError)});Promise.resolve(U).then(J=>{ee.dispose(),O.dispose(),B(J)},J=>{ee.dispose(),O.dispose(),X(J)})});return new class{cancel(){O.cancel()}then(B,X){return q.then(B,X)}catch(B){return this.then(void 0,B)}finally(B){return q.finally(B)}}}e.createCancelablePromise=b;function I(ie,O,U){return new Promise((q,B)=>{const X=O.onCancellationRequested(()=>{X.dispose(),q(U)});ie.then(q,B).finally(()=>X.dispose())})}e.raceCancellation=I;function C(ie,O){return new Promise((U,q)=>{const B=O.onCancellationRequested(()=>{B.dispose(),q(new i.CancellationError)});ie.then(U,q).finally(()=>B.dispose())})}e.raceCancellationError=C;async function w(ie){let O=-1;const U=ie.map((B,X)=>B.then(ee=>(O=X,ee))),q=await Promise.race(U);return ie.forEach((B,X)=>{X!==O&&B.cancel()}),q}e.raceCancellablePromises=w;function y(ie,O,U){let q;const B=setTimeout(()=>{q?.(void 0),U?.()},O);return Promise.race([ie.finally(()=>clearTimeout(B)),new Promise(X=>q=X)])}e.raceTimeout=y;function h(ie){return new Promise((O,U)=>{const q=ie();P(q)?q.then(O,U):O(q)})}e.asPromise=h;class m{constructor(){this.a=null,this.b=null,this.d=null}queue(O){if(this.a){if(this.d=O,!this.b){const U=()=>{this.b=null;const q=this.queue(this.d);return this.d=null,q};this.b=new Promise(q=>{this.a.then(U,U).then(q)})}return new Promise((U,q)=>{this.b.then(U,q)})}return this.a=O(),new Promise((U,q)=>{this.a.then(B=>{this.a=null,U(B)},B=>{this.a=null,q(B)})})}}e.Throttler=m;class g{constructor(){this.a=Promise.resolve(null)}queue(O){return this.a=this.a.then(()=>O(),()=>O())}}e.Sequencer=g;class l{constructor(){this.a=new Map}queue(O,U){const B=(this.a.get(O)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(O)===B&&this.a.delete(O)});return this.a.set(O,B),B}}e.SequencerByKey=l;const f=(ie,O)=>{let U=!0;const q=setTimeout(()=>{U=!1,O()},ie);return{isTriggered:()=>U,dispose:()=>{clearTimeout(q),U=!1}}},p=ie=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,ie())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class v{constructor(O){this.defaultDelay=O,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(O,U=this.defaultDelay){this.g=O,this.h(),this.b||(this.b=new Promise((B,X)=>{this.d=B,this.f=X}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const q=()=>{this.a=null,this.d?.(null)};return this.a=U===e.MicrotaskDelay?p(q):f(U,q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class d{constructor(O){this.a=new v(O),this.b=new m}trigger(O,U){return this.a.trigger(()=>this.b.queue(O),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=d;class n{constructor(){this.a=!1,this.b=new Promise((O,U)=>{this.d=O})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class r extends n{constructor(O){super(),this.f=setTimeout(()=>this.open(),O)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function t(ie,O){return O?new Promise((U,q)=>{const B=setTimeout(()=>{X.dispose(),U()},ie),X=O.onCancellationRequested(()=>{clearTimeout(B),X.dispose(),q(new i.CancellationError)})}):b(U=>t(ie,U))}e.timeout=t;function s(ie,O=0){const U=setTimeout(ie,O);return(0,A.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=s;function a(ie){const O=[];let U=0;const q=ie.length;function B(){return U<q?ie[U++]():null}function X(ee){ee!=null&&O.push(ee);const J=B();return J?J.then(X):Promise.resolve(O)}return Promise.resolve(null).then(X)}e.sequence=a;function c(ie,O=q=>!!q,U=null){let q=0;const B=ie.length,X=()=>{if(q>=B)return Promise.resolve(U);const ee=ie[q++];return Promise.resolve(ee()).then(_=>O(_)?Promise.resolve(_):X())};return X()}e.first=c;function o(ie,O=q=>!!q,U=null){if(ie.length===0)return Promise.resolve(U);let q=ie.length;const B=()=>{q=-1;for(const X of ie)X.cancel?.()};return new Promise((X,ee)=>{for(const J of ie)J.then(_=>{--q>=0&&O(_)?(B(),X(_)):q===0&&X(U)}).catch(_=>{--q>=0&&(B(),ee(_))})})}e.firstParallel=o;class u{constructor(O){this.a=0,this.d=O,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(O){return this.a++,new Promise((U,q)=>{this.f.push({factory:O,c:U,e:q}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const O=this.f.shift();this.b++;const U=O.factory();U.then(O.c,O.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=u;class S extends u{constructor(){super(1)}}e.Queue=S;class E{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const O=new K;return this.b.add(O),O.p}d(){for(const[,O]of this.a)if(O.size>0)return!1;return!0}queueFor(O,U=T.extUri){const q=U.getComparisonKey(O);let B=this.a.get(q);return B||(B=new S,D.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(q),this.f()}),this.a.set(q,B)),B}f(){!this.d()||this.g()}g(){for(const O of this.b)O.complete();this.b.clear()}dispose(){for(const[,O]of this.a)O.dispose();this.a.clear(),this.g()}}e.ResourceQueue=E;class M{constructor(O,U){this.a=-1,typeof O=="function"&&typeof U=="number"&&this.setIfNotSet(O,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(O,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,O()},U)}setIfNotSet(O,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,O()},U))}}e.TimeoutTimer=M;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(O,U){this.cancel(),this.a=setInterval(()=>{O()},U)}}e.IntervalTimer=N;class j{constructor(O,U){this.b=-1,this.a=O,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(O=this.d){this.cancel(),this.b=setTimeout(this.f,O)}get delay(){return this.d}set delay(O){this.d=O}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=j;class ${constructor(O,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=O,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(O=this.b){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(O/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=$;class L extends j{constructor(O,U){super(O,U),this.j=[]}work(O){this.j.push(O),this.isScheduled()||this.schedule()}h(){const O=this.j;this.j=[],this.a?.(O)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=L;class F extends A.Disposable{constructor(O,U){super(),this.g=O,this.h=U,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(O){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+O.length>this.g.maxBufferedWork)return!1}else if(this.pending+O.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of O)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ie=>{(0,R.setTimeout0)(()=>{if(O)return;const U=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(ie,O)=>{const U=requestIdleCallback(ie,typeof O=="number"?{timeout:O}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(U))}}}}();class z{constructor(O){this.d=!1,this.a=()=>{try{this.f=O()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=z;async function W(ie,O,U){let q;for(let B=0;B<U;B++)try{return await ie()}catch(X){q=X,await t(O)}throw q}e.retry=W;class H{hasPending(O){return this.a?typeof O=="number"?this.a.taskId===O:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(O,U,q){return this.a={taskId:O,cancel:()=>q?.(),promise:U},U.then(()=>this.d(O),()=>this.d(O)),U}d(O){this.a&&O===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const O=this.b;this.b=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this.b)this.b.run=O;else{let U,q;const B=new Promise((X,ee)=>{U=X,q=ee});this.b={run:O,promise:B,promiseResolve:U,promiseReject:q}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=H;class Q{constructor(O,U=()=>Date.now()){this.d=O,this.f=U,this.a=0,this.b=0}increment(){const O=this.f();return O-this.a>this.d&&(this.a=O,this.b=0),this.b++,this.b}}e.IntervalCounter=Q;class K{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((O,U)=>{this.a=O,this.b=U})}complete(O){return new Promise(U=>{this.a(O),this.f=!0,U()})}error(O){return new Promise(U=>{this.b(O),this.d=!0,U()})}cancel(){new Promise(O=>{this.b(new i.CancellationError),this.d=!0,O()})}}e.DeferredPromise=K;var V;(function(ie){async function O(q){let B;const X=await Promise.all(q.map(ee=>ee.then(J=>J,J=>{B||(B=J)})));if(typeof B<"u")throw B;return X}ie.settled=O;function U(q){return new Promise(async(B,X)=>{try{await q(B,X)}catch(ee){X(ee)}})}ie.withAsyncBody=U})(V=e.Promises||(e.Promises={}));var G;(function(ie){ie[ie.Initial=0]="Initial",ie[ie.DoneOK=1]="DoneOK",ie[ie.DoneError=2]="DoneError"})(G||(G={}));class x{static fromArray(O){return new x(U=>{U.emitMany(O)})}static fromPromise(O){return new x(async U=>{U.emitMany(await O)})}static fromPromises(O){return new x(async U=>{await Promise.all(O.map(async q=>U.emitOne(await q)))})}static merge(O){return new x(async U=>{await Promise.all(O.map(async q=>{for await(const B of q)U.emitOne(B)}))})}constructor(O){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const U={emitOne:q=>this.g(q),emitMany:q=>this.h(q),reject:q=>this.k(q)};try{await Promise.resolve(O(U)),this.j()}catch(q){this.k(q)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(O<this.b.length)return{done:!1,value:this.b[O++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(O,U){return new x(async q=>{for await(const B of O)q.emitOne(U(B))})}map(O){return x.map(this,O)}static filter(O,U){return new x(async q=>{for await(const B of O)U(B)&&q.emitOne(B)})}filter(O){return x.filter(this,O)}static coalesce(O){return x.filter(O,U=>!!U)}coalesce(){return x.coalesce(this)}static async toPromise(O){const U=[];for await(const q of O)U.push(q);return U}toPromise(){return x.toPromise(this)}g(O){this.a===0&&(this.b.push(O),this.f.fire())}h(O){this.a===0&&(this.b=this.b.concat(O),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(O){this.a===0&&(this.a=2,this.d=O,this.f.fire())}}e.AsyncIterableObject=x,x.EMPTY=x.fromArray([]);class ne extends x{constructor(O,U){super(U),this.l=O}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ne;function se(ie){const O=new k.CancellationTokenSource,U=ie(O.token);return new ne(O,async q=>{const B=O.token.onCancellationRequested(()=>{B.dispose(),O.dispose(),q.reject(new i.CancellationError)});try{for await(const X of U){if(O.token.isCancellationRequested)return;q.emitOne(X)}B.dispose(),O.dispose()}catch(X){B.dispose(),O.dispose(),q.reject(X)}})}e.createCancelableAsyncIterable=se}),define(oe[89],ae([0,1,20,6,48,37,12,5,27]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",C="[^/\\\\]",w=/\//g;function y(K,V){switch(K){case 0:return"";case 1:return`${C}*?`;default:return`(?:${I}|${C}+${I}${V?`|${I}${C}+`:""})*?`}}function h(K,V){if(!K)return[];const G=[];let x=!1,ne=!1,se="";for(const ie of K){switch(ie){case V:if(!x&&!ne){G.push(se),se="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}se+=ie}return se&&G.push(se),G}e.splitGlobAware=h;function m(K){if(!K)return"";let V="";const G=h(K,e.GLOB_SPLIT);if(G.every(x=>x===e.GLOBSTAR))V=".*";else{let x=!1;G.forEach((ne,se)=>{if(ne===e.GLOBSTAR){if(x)return;V+=y(2,se===G.length-1)}else{let ie=!1,O="",U=!1,q="";for(const B of ne){if(B!=="}"&&ie){O+=B;continue}if(U&&(B!=="]"||!q)){let X;B==="-"?X=B:(B==="^"||B==="!")&&!q?X="^":B===e.GLOB_SPLIT?X="":X=(0,P.escapeRegExpCharacters)(B),q+=X;continue}switch(B){case"{":ie=!0;continue;case"[":U=!0;continue;case"}":{V+=`(?:${h(O,",").map(J=>m(J)).join("|")})`,ie=!1,O="";break}case"]":{V+="["+q+"]",U=!1,q="";break}case"?":V+=C;continue;case"*":V+=y(1);continue;default:V+=(0,P.escapeRegExpCharacters)(B)}}se<G.length-1&&(G[se+1]!==e.GLOBSTAR||se+2<G.length)&&(V+=I)}x=ne===e.GLOBSTAR})}return V}const g=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new A.LRUCache(1e4),r=function(){return!1},t=function(){return null};function s(K,V){if(!K)return t;let G;typeof K!="string"?G=K.pattern:G=K,G=G.trim();const x=`${G}_${!!V.trimForExclusions}`;let ne=n.get(x);if(ne)return a(ne,K);let se;return g.test(G)?ne=o(G.substr(4),G):(se=l.exec(c(G,V)))?ne=u(se[1],G):(V.trimForExclusions?p:f).test(G)?ne=S(G,V):(se=v.exec(c(G,V)))?ne=E(se[1].substr(1),G,!0):(se=d.exec(c(G,V)))?ne=E(se[1],G,!1):ne=M(G),n.set(x,ne),a(ne,K)}function a(K,V){if(typeof V=="string")return K;const G=function(x,ne){return(0,D.isEqualOrParent)(x,V.base,!R.isLinux)?K((0,P.ltrim)(x.substr(V.base.length),T.sep),ne):null};return G.allBasenames=K.allBasenames,G.allPaths=K.allPaths,G.basenames=K.basenames,G.patterns=K.patterns,G}function c(K,V){return V.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function o(K,V){return function(G,x){return typeof G=="string"&&G.endsWith(K)?V:null}}function u(K,V){const G=`/${K}`,x=`\\${K}`,ne=function(ie,O){return typeof ie!="string"?null:O?O===K?V:null:ie===K||ie.endsWith(G)||ie.endsWith(x)?V:null},se=[K];return ne.basenames=se,ne.patterns=[V],ne.allBasenames=se,ne}function S(K,V){const G=H(K.slice(1,-1).split(",").map(O=>s(O,V)).filter(O=>O!==t),K),x=G.length;if(!x)return t;if(x===1)return G[0];const ne=function(O,U){for(let q=0,B=G.length;q<B;q++)if(G[q](O,U))return K;return null},se=G.find(O=>!!O.allBasenames);se&&(ne.allBasenames=se.allBasenames);const ie=G.reduce((O,U)=>U.allPaths?O.concat(U.allPaths):O,[]);return ie.length&&(ne.allPaths=ie),ne}function E(K,V,G){const x=T.sep===T.posix.sep,ne=x?K:K.replace(w,T.sep),se=T.sep+ne,ie=T.posix.sep+K;let O;return G?O=function(U,q){return typeof U=="string"&&(U===ne||U.endsWith(se)||!x&&(U===K||U.endsWith(ie)))?V:null}:O=function(U,q){return typeof U=="string"&&(U===ne||!x&&U===K)?V:null},O.allPaths=[(G?"*/":"./")+K],O}function M(K){try{const V=new RegExp(`^${m(K)}$`);return function(G){return V.lastIndex=0,typeof G=="string"&&V.test(G)?K:null}}catch{return t}}function N(K,V,G){return!K||typeof V!="string"?!1:j(K)(V,void 0,G)}e.match=N;function j(K,V={}){if(!K)return r;if(typeof K=="string"||$(K)){const G=s(K,V);if(G===t)return r;const x=function(ne,se){return!!G(ne,se)};return G.allBasenames&&(x.allBasenames=G.allBasenames),G.allPaths&&(x.allPaths=G.allPaths),x}return z(K,V)}e.parse=j;function $(K){const V=K;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=$;function L(K){return K.allBasenames||[]}e.getBasenameTerms=L;function F(K){return K.allPaths||[]}e.getPathTerms=F;function z(K,V){const G=H(Object.getOwnPropertyNames(K).map(O=>W(O,K[O],V)).filter(O=>O!==t)),x=G.length;if(!x)return t;if(!G.some(O=>!!O.requiresSiblings)){if(x===1)return G[0];const O=function(B,X){let ee;for(let J=0,_=G.length;J<_;J++){const re=G[J](B,X);if(typeof re=="string")return re;(0,i.isThenable)(re)&&(ee||(ee=[]),ee.push(re))}return ee?(async()=>{for(const J of ee){const _=await J;if(typeof _=="string")return _}return null})():null},U=G.find(B=>!!B.allBasenames);U&&(O.allBasenames=U.allBasenames);const q=G.reduce((B,X)=>X.allPaths?B.concat(X.allPaths):B,[]);return q.length&&(O.allPaths=q),O}const ne=function(O,U,q){let B,X;for(let ee=0,J=G.length;ee<J;ee++){const _=G[ee];_.requiresSiblings&&q&&(U||(U=(0,T.basename)(O)),B||(B=U.substr(0,U.length-(0,T.extname)(O).length)));const re=_(O,U,B,q);if(typeof re=="string")return re;(0,i.isThenable)(re)&&(X||(X=[]),X.push(re))}return X?(async()=>{for(const ee of X){const J=await ee;if(typeof J=="string")return J}return null})():null},se=G.find(O=>!!O.allBasenames);se&&(ne.allBasenames=se.allBasenames);const ie=G.reduce((O,U)=>U.allPaths?O.concat(U.allPaths):O,[]);return ie.length&&(ne.allPaths=ie),ne}function W(K,V,G){if(V===!1)return t;const x=s(K,G);if(x===t)return t;if(typeof V=="boolean")return x;if(V){const ne=V.when;if(typeof ne=="string"){const se=(ie,O,U,q)=>{if(!q||!x(ie,O))return null;const B=ne.replace("$(basename)",()=>U),X=q(B);return(0,i.isThenable)(X)?X.then(ee=>ee?K:null):X?K:null};return se.requiresSiblings=!0,se}}return x}function H(K,V){const G=K.filter(O=>!!O.basenames);if(G.length<2)return K;const x=G.reduce((O,U)=>{const q=U.basenames;return q?O.concat(q):O},[]);let ne;if(V){ne=[];for(let O=0,U=x.length;O<U;O++)ne.push(V)}else ne=G.reduce((O,U)=>{const q=U.patterns;return q?O.concat(q):O},[]);const se=function(O,U){if(typeof O!="string")return null;if(!U){let B;for(B=O.length;B>0;B--){const X=O.charCodeAt(B-1);if(X===47||X===92)break}U=O.substr(B)}const q=x.indexOf(U);return q!==-1?ne[q]:null};se.basenames=x,se.patterns=ne,se.allBasenames=x;const ie=K.filter(O=>!O.basenames);return ie.push(se),ie}function Q(K,V){return(0,k.equals)(K,V,(G,x)=>typeof G=="string"&&typeof x=="string"?G===x:typeof G!="string"&&typeof x!="string"?G.base===x.base&&G.pattern===x.pattern:!1)}e.patternsEquals=Q}),define(oe[143],ae([0,1,7]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(I){return I.toJSON()}class D{constructor(C){this.a=C}transformIncoming(C){const w=this.a.transformIncoming(C);return w===C?C:i(k.URI.from(w))}transformOutgoing(C){const w=this.a.transformOutgoing(C);return w===C?C:i(k.URI.from(w))}transformOutgoingURI(C){const w=this.a.transformOutgoing(C);return w===C?C:k.URI.from(w)}transformOutgoingScheme(C){return this.a.transformOutgoingScheme(C)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,C,w){if(!I||w>200)return null;if(typeof I=="object"){if(I instanceof k.URI)return C.transformOutgoing(I);for(const y in I)if(Object.hasOwnProperty.call(I,y)){const h=A(I[y],C,w+1);h!==null&&(I[y]=h)}}return null}function T(I,C){const w=A(I,C,0);return w===null?I:w}e.transformOutgoingURIs=T;function R(I,C,w,y){if(!I||y>200)return null;if(typeof I=="object"){if(I.$mid===1)return w?k.URI.revive(C.transformIncoming(I)):C.transformIncoming(I);for(const h in I)if(Object.hasOwnProperty.call(I,h)){const m=R(I[h],C,w,y+1);m!==null&&(I[h]=m)}}return null}function P(I,C){const w=R(I,C,!1,0);return w===null?I:w}e.transformIncomingURIs=P;function b(I,C){const w=R(I,C,!0,0);return w===null?I:w}e.transformAndReviveIncomingURIs=b}),define(oe[144],ae([0,1,34,9,49,31,130]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(I){return this.a||(this.a=D.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(I)}value(){if(this.b===void 0){let I=0,C=0;const w=(0,k.networkInterfaces)();for(const y in w){const h=w[y];if(h)for(const{mac:m,internal:g}of h)g||(C+=1,this.c(m.toUpperCase())&&(I+=1))}this.b=C>0?I/C:0}return this.b}};let R;async function P(){return R||(R=(async()=>await b()||A.generateUuid())()),R}e.getMachineId=P;async function b(){try{const I=await new Promise((w,y)=>{Z(["crypto"],w,y)}),C=(0,T.getMac)();return I.createHash("sha256").update(C,"utf8").digest("hex")}catch(I){i.onUnexpectedError(I);return}}}),define(oe[28],ae([0,1,52,34,283,6,48,85,12,5,23,7]),function(Z,e,k,i,D,A,T,R,P,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function y(z,W=w.UNLINK){if((0,T.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return W===w.UNLINK?m(z):h(z)}async function h(z){try{const W=(0,T.randomPath)((0,i.tmpdir)());try{await k.promises.rename(z,W)}catch(H){return H.code==="ENOENT"?void 0:m(z)}m(W).catch(H=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function m(z){return(0,D.promisify)(k.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function g(z){if((0,T.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function l(z,W){return v(await(W?f(z):(0,D.promisify)(k.readdir)(z)))}async function f(z){try{return await(0,D.promisify)(k.readdir)(z,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const W=[],H=await l(z);for(const Q of H){let K=!1,V=!1,G=!1;try{const x=await e.Promises.lstat((0,P.join)(z,Q));K=x.isFile(),V=x.isDirectory(),G=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}W.push({name:Q,isFile:()=>K,isDirectory:()=>V,isSymbolicLink:()=>G})}return W}function p(z){return v(k.readdirSync(z))}e.readdirSync=p;function v(z){return z.map(W=>typeof W=="string"?b.isMacintosh?(0,R.normalizeNFC)(W):W:(W.name=b.isMacintosh?(0,R.normalizeNFC)(W.name):W.name,W))}async function d(z){const W=await l(z),H=[];for(const Q of W)await r.existsDirectory((0,P.join)(z,Q))&&H.push(Q);return H}function n(z,W=1e3){return new Promise(H=>{let Q=!1;const K=setInterval(()=>{Q||(Q=!0,k.access(z,V=>{Q=!1,V&&(clearInterval(K),H(void 0))}))},W)})}e.whenDeleted=n;var r;(function(z){async function W(K){let V;try{if(V=await e.Promises.lstat(K),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(b.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw x}throw G}}z.stat=W;async function H(K){try{const{stat:V,symbolicLink:G}=await z.stat(K);return V.isFile()&&G?.dangling!==!0}catch{}return!1}z.existsFile=H;async function Q(K){try{const{stat:V,symbolicLink:G}=await z.stat(K);return V.isDirectory()&&G?.dangling!==!0}catch{}return!1}z.existsDirectory=Q})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new A.ResourceQueue;function s(z,W,H){return t.queueFor(C.URI.file(z),I.extUriBiasedIgnorePathCase).queue(()=>{const Q=S(H);return new Promise((K,V)=>o(z,W,Q,G=>G?V(G):K()))})}let a=!0;function c(z){a=z}e.configureFlushOnWrite=c;function o(z,W,H,Q){if(!a)return k.writeFile(z,W,{mode:H.mode,flag:H.flag},Q);k.open(z,H.flag,H.mode,(K,V)=>{if(K)return Q(K);k.writeFile(V,W,G=>{if(G)return k.close(V,()=>Q(G));k.fdatasync(V,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),c(!1)),k.close(V,ne=>Q(ne))))})})}function u(z,W,H){const Q=S(H);if(!a)return k.writeFileSync(z,W,{mode:Q.mode,flag:Q.flag});const K=k.openSync(z,Q.flag,Q.mode);try{k.writeFileSync(K,W);try{k.fdatasyncSync(K)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),c(!1)}}finally{k.closeSync(K)}}e.writeFileSync=u;function S(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function E(z,W){if(z!==W)try{await e.Promises.rename(z,W)}catch(H){if(z.toLowerCase()!==W.toLowerCase()&&H.code==="EXDEV"||z.endsWith("."))await M(z,W,{preserveSymlinks:!1}),await y(z,w.MOVE);else throw H}}async function M(z,W,H){return j(z,W,{root:{source:z,target:W},options:H,handledSourcePaths:new Set})}const N=511;async function j(z,W,H){if(H.handledSourcePaths.has(z))return;H.handledSourcePaths.add(z);const{stat:Q,symbolicLink:K}=await r.stat(z);if(K){if(H.options.preserveSymlinks)try{return await F(z,W,H)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(K.dangling)return}return Q.isDirectory()?$(z,W,Q.mode&N,H):L(z,W,Q.mode&N)}async function $(z,W,H,Q){await e.Promises.mkdir(W,{recursive:!0,mode:H});const K=await l(z);for(const V of K)await j((0,P.join)(z,V),(0,P.join)(W,V),Q)}async function L(z,W,H){await e.Promises.copyFile(z,W),await e.Promises.chmod(W,H)}async function F(z,W,H){let Q=await e.Promises.readlink(z);(0,T.isEqualOrParent)(Q,H.root.source,!b.isLinux)&&(Q=(0,P.join)(H.root.target,Q.substr(H.root.source.length+1))),await e.Promises.symlink(Q,W)}e.Promises=new class{get access(){return(0,D.promisify)(k.access)}get stat(){return(0,D.promisify)(k.stat)}get lstat(){return(0,D.promisify)(k.lstat)}get utimes(){return(0,D.promisify)(k.utimes)}get read(){return(z,W,H,Q,K)=>new Promise((V,G)=>{k.read(z,W,H,Q,K,(x,ne,se)=>x?G(x):V({bytesRead:ne,buffer:se}))})}get readFile(){return(0,D.promisify)(k.readFile)}get write(){return(z,W,H,Q,K)=>new Promise((V,G)=>{k.write(z,W,H,Q,K,(x,ne,se)=>x?G(x):V({bytesWritten:ne,buffer:se}))})}get appendFile(){return(0,D.promisify)(k.appendFile)}get fdatasync(){return(0,D.promisify)(k.fdatasync)}get truncate(){return(0,D.promisify)(k.truncate)}get rename(){return(0,D.promisify)(k.rename)}get copyFile(){return(0,D.promisify)(k.copyFile)}get open(){return(0,D.promisify)(k.open)}get close(){return(0,D.promisify)(k.close)}get symlink(){return(0,D.promisify)(k.symlink)}get readlink(){return(0,D.promisify)(k.readlink)}get chmod(){return(0,D.promisify)(k.chmod)}get mkdir(){return(0,D.promisify)(k.mkdir)}get unlink(){return(0,D.promisify)(k.unlink)}get rmdir(){return(0,D.promisify)(k.rmdir)}get realpath(){return(0,D.promisify)(k.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return d}get writeFile(){return s}get rm(){return y}get move(){return E}get copy(){return M}}}),define(oe[145],ae([0,1,52,12,5,27,28]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(w){if(D.isLinux)return w;const y=(0,i.dirname)(w);if(w===y)return w;const h=((0,i.basename)(w)||w).toLowerCase();try{const g=(0,T.readdirSync)(y).filter(l=>l.toLowerCase()===h);if(g.length===1){const l=R(y);if(l)return(0,i.join)(l,g[0])}else if(g.length>1){const l=g.indexOf(h);if(l>=0){const f=R(y);if(f)return(0,i.join)(f,g[l])}}}catch{}return null}e.realcaseSync=R;async function P(w){if(D.isLinux)return w;const y=(0,i.dirname)(w);if(w===y)return w;const h=((0,i.basename)(w)||w).toLowerCase();try{const g=(await T.Promises.readdir(y)).filter(l=>l.toLowerCase()===h);if(g.length===1){const l=await P(y);if(l)return(0,i.join)(l,g[0])}else if(g.length>1){const l=g.indexOf(h);if(l>=0){const f=await P(y);if(f)return(0,i.join)(f,g[l])}}}catch{}return null}e.realcase=P;async function b(w){try{return await T.Promises.realpath(w)}catch{const h=C(w);return await T.Promises.access(h,k.constants.R_OK),h}}e.realpath=b;function I(w){try{return k.realpathSync(w)}catch{const h=C(w);return k.accessSync(h,k.constants.R_OK),h}}e.realpathSync=I;function C(w){return(0,A.rtrim)((0,i.normalize)(w),i.sep)}}),define(oe[90],ae([0,1,34,12,28]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var P;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(P||(P={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class C{constructor(d,n,r){this.exePath=d,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:v=!1}={}){return v?b===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:v=!1,findPreview:d=!1}={}){const n=w({useAlternateBitness:v});if(!n)return null;const r=i.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(r))return null;let t=-1,s=null;for(const o of await D.Promises.readdir(r)){let u=-1;if(d){const E=o.indexOf("-");if(E<0)continue;const M=o.substring(0,E);if(!A.test(M)||o.substring(E+1)!=="preview")continue;u=parseInt(M,10)}else{if(!A.test(o))continue;u=parseInt(o,10)}if(u<=t)continue;const S=i.join(r,o,"pwsh.exe");!await D.SymlinkSupport.existsFile(S)||(s=S,t=u)}if(!s)return null;const a=n.includes("x86")?" (x86)":"",c=d?" Preview":"";return new C(s,`PowerShell${c}${a}`,!0)}async function h({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const d=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(d))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=v?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(d))if(n.test(t)){const s=i.join(d,t,"pwsh.exe");return new C(s,r)}return null}function m(){const v=i.join(k.homedir(),".dotnet","tools","pwsh.exe");return new C(v,".NET Core PowerShell Global Tool")}function g(){const v=i.join(process.env.windir,b===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(v,"Windows PowerShell",!0)}async function*l(){let v=await y();v&&(yield v),v=await y({useAlternateBitness:!0}),v&&(yield v),v=await h(),v&&(yield v),v=m(),v&&(yield v),v=await y({findPreview:!0}),v&&(yield v),v=await h({findPreview:!0}),v&&(yield v),v=await y({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=g(),v&&(yield v)}async function*f(){for await(const v of l())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=f;async function p(){for await(const v of f())return v;return null}e.getFirstAvailablePowerShellInstallation=p}),define(oe[91],ae([0,1,12,5,36,87,13,28]),function(Z,e,k,i,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function P(C=D.env){return C.comspec||"cmd.exe"}e.getWindowsShell=P;function b(C){let w=[],y=!1;const h=function(m){if(y){w.push(m);return}(!C.send(m,l=>{if(l&&console.error(l),y=!1,w.length>0){const f=w.slice(0);w=[],f.forEach(p=>h(p))}})||i.isWindows)&&(y=!0)};return{send:h}}e.createQueuedSender=b;var I;(function(C){async function w(y,h,m){if(k.isAbsolute(y))return y;if(h===void 0&&(h=D.cwd()),k.dirname(y)!=="."||(m===void 0&&T.isString(D.env.PATH)&&(m=D.env.PATH.split(k.delimiter)),m===void 0||m.length===0))return k.join(h,y);async function l(f){if(await R.Promises.exists(f)){let p;try{p=await R.Promises.stat(f)}catch(v){v.message.startsWith("EACCES")&&(p=await R.Promises.lstat(f))}return p?!p.isDirectory():!1}return!1}for(const f of m){let p;if(k.isAbsolute(f)?p=k.join(f,y):p=k.join(h,f,y),await l(p))return p;let v=p+".com";if(await l(v)||(v=p+".exe",await l(v)))return v}return k.join(h,y)}C.findExecutable=w})(I=e.win32||(e.win32={}))}),define(oe[146],ae([0,1,50,22]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(T){return new Promise((R,P)=>{let b;const I=new Map;function C(y,h,m,g,l){const f=I.get(h);if(y===T||f){const p={name:w(m),cmd:m,pid:y,ppid:h,load:g,mem:l};I.set(y,p),y===T&&(b=p),f&&(f.children||(f.children=[]),f.children.push(p),f.children.length>1&&(f.children=f.children.sort((v,d)=>v.pid-d.pid)))}}function w(y){const h=/--vscode-window-kind=shared-process/,m=/--vscode-window-kind=issue-reporter/,g=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,f=/--utility-sub-type=node.mojom.NodeService/,p=/--crashes-directory/,v=/\\pipe\\winpty-control/,d=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(p.exec(y))return"electron-crash-reporter";if(v.exec(y))return"winpty-process";if(d.exec(y))return"console-window-host (Windows internal process)";let r=n.exec(y);if(r&&r.length===2){if(r[1]==="renderer")return h.exec(y)?"shared-process":m.exec(y)?"issue-reporter":g.exec(y)?"process-explorer":"window";if(r[1]==="utility"){if(l.exec(y))return"utility-network-service";if(f.exec(y))return"extension-host"}return r[1]}const t=/[a-zA-Z-]+\.js/g;let s="";do r=t.exec(y),r&&(s+=r+" ");while(r);return s&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${s}`:y}if(process.platform==="win32"){const y=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,m)=>{Z(["windows-process-tree"],h,m)}).then(h=>{h.getProcessList(T,m=>{if(!m){P(new Error(`Root process ${T} not found`));return}h.getProcessCpuUsage(m,g=>{const l=new Map;g.forEach(f=>{const p=y(f.commandLine||"");l.set(f.pid,{name:w(p),cmd:p,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),b=l.get(T),b?(l.forEach(f=>{const p=l.get(f.ppid);p&&(p.children||(p.children=[]),p.children.push(f))}),l.forEach(f=>{f.children&&(f.children=f.children.sort((p,v)=>p.pid-v.pid))}),R(b)):P(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let y=function(){let h=[b];const m=[];for(;h.length;){const l=h.shift();l&&(m.push(l.pid),l.children&&(h=h.concat(l.children)))}let g=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+m.join(" "),(0,k.exec)(g,{},(l,f,p)=>{if(l||p)P(l||new Error(p.toString()));else{const v=f.toString().split(`
`);for(let d=0;d<m.length;d++){const n=I.get(m[d]);n.load=parseFloat(v[d])}if(!b){P(new Error(`Root process ${T} not found`));return}R(b)}})};(0,k.exec)("which ps",{},(h,m,g)=>{if(h||g)if(process.platform!=="linux")P(h||new Error(g.toString()));else{const l=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(l,{},(f,p,v)=>{f||v?P(f||new Error(v.toString())):(A(p,C),y())})}else{const l=m.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${l} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,v,d)=>{p||d&&!d.includes("screen size is bogus")?P(p||new Error(d.toString())):(A(v,C),process.platform==="linux"?y():b?R(b):P(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=D;function A(T,R){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=T.toString().split(`
`);for(const I of b){const C=P.exec(I.trim());C&&C.length===6&&R(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(oe[147],ae([0,1,34,5,90,91]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function T(C,w){return C===1?i.isWindows?I():A.getWindowsShell(w):P(C,w)}e.getSystemShell=T;let R=null;function P(C,w){if(i.isLinux&&C===2||i.isMacintosh&&C===3)return"/bin/bash";if(!R){let y;if(i.isWindows)y="/bin/bash";else{if(y=w.SHELL,!y)try{y=(0,k.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}R=y}return R}let b=null;async function I(){return b||(b=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),b}});var pe=this&&this.__decorate||function(Z,e,k,i){var D=arguments.length,A=D<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,k):i,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Z,e,k,i);else for(var R=Z.length-1;R>=0;R--)(T=Z[R])&&(A=(D<3?T(A):D>3?T(e,k,A):T(e,k))||A);return D>3&&A&&Object.defineProperty(e,k,A),A};define(oe[39],ae([0,1,20,6,17,24,63,9,3,2,67,27,13]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var y;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(y||(y={}));function h(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(m||(m={}));function g(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(l||(l={}));function f(V){let G=0;for(let x=0;;x+=7){const ne=V.read(1);if(G|=(ne.buffer[0]&127)<<x,!(ne.buffer[0]&128))return G}}const p=t(0);function v(V,G){if(G===0){V.write(p);return}let x=0;for(let se=G;se!==0;se=se>>>7)x++;const ne=D.VSBuffer.alloc(x);for(let se=0;G!==0;se++)ne.buffer[se]=G&127,G=G>>>7,G>0&&(ne.buffer[se]|=128);V.write(ne)}class d{constructor(G){this.b=G,this.a=0}read(G){const x=this.b.slice(this.a,this.a+G);return this.a+=x.byteLength,x}}e.BufferReader=d;class n{constructor(){this.a=[]}get buffer(){return D.VSBuffer.concat(this.a)}write(G){this.a.push(G)}}e.BufferWriter=n;var r;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(r||(r={}));function t(V){const G=D.VSBuffer.alloc(1);return G.writeUInt8(V,0),G}const s={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},a=typeof Buffer<"u";function c(V,G){if(typeof G>"u")V.write(s.Undefined);else if(typeof G=="string"){const x=D.VSBuffer.fromString(G);V.write(s.String),v(V,x.byteLength),V.write(x)}else if(a&&Buffer.isBuffer(G)){const x=D.VSBuffer.wrap(G);V.write(s.Buffer),v(V,x.byteLength),V.write(x)}else if(G instanceof D.VSBuffer)V.write(s.VSBuffer),v(V,G.byteLength),V.write(G);else if(Array.isArray(G)){V.write(s.Array),v(V,G.length);for(const x of G)c(V,x)}else if(typeof G=="number"&&(G|0)===G)V.write(s.Uint),v(V,G);else{const x=D.VSBuffer.fromString(JSON.stringify(G));V.write(s.Object),v(V,x.byteLength),V.write(x)}}e.serialize=c;function o(V){switch(V.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return V.read(f(V)).toString();case r.Buffer:return V.read(f(V)).buffer;case r.VSBuffer:return V.read(f(V));case r.Array:{const x=f(V),ne=[];for(let se=0;se<x;se++)ne.push(o(V));return ne}case r.Object:return JSON.parse(V.read(f(V)).toString());case r.Int:return f(V)}}e.deserialize=o;class u{constructor(G,x,ne=null,se=1e3){this.h=G,this.j=x,this.k=ne,this.l=se,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ie=>this.q(ie)),this.m({type:200})}registerChannel(G,x){this.b.set(G,x),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const x=this.o([G.type]);this.k?.logOutgoing(x,0,1,g(G.type));return}case 201:case 202:case 204:case 203:{const x=this.o([G.type,G.id],G.data);this.k?.logOutgoing(x,G.id,1,g(G.type),G.data);return}}}o(G,x=void 0){const ne=new n;return c(ne,G),c(ne,x),this.p(ne.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const x=new d(G),ne=o(x),se=o(x),ie=ne[0];switch(ie){case 100:return this.k?.logIncoming(G.byteLength,ne[1],1,`${h(ie)}: ${ne[2]}.${ne[3]}`,se),this.s({type:ie,id:ne[1],channelName:ne[2],name:ne[3],arg:se});case 102:return this.k?.logIncoming(G.byteLength,ne[1],1,`${h(ie)}: ${ne[2]}.${ne[3]}`,se),this.t({type:ie,id:ne[1],channelName:ne[2],name:ne[3],arg:se});case 101:return this.k?.logIncoming(G.byteLength,ne[1],1,`${h(ie)}`),this.u({type:ie,id:ne[1]});case 103:return this.k?.logIncoming(G.byteLength,ne[1],1,`${h(ie)}`),this.u({type:ie,id:ne[1]})}}s(G){const x=this.b.get(G.channelName);if(!x){this.v(G);return}const ne=new A.CancellationTokenSource;let se;try{se=x.call(this.j,G.name,G.arg,ne.token)}catch(U){se=Promise.reject(U)}const ie=G.id;se.then(U=>{this.m({id:ie,data:U,type:201}),this.d.delete(G.id)},U=>{U instanceof Error?this.m({id:ie,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:ie,data:U,type:203}),this.d.delete(G.id)});const O=(0,b.toDisposable)(()=>ne.cancel());this.d.set(G.id,O)}t(G){const x=this.b.get(G.channelName);if(!x){this.v(G);return}const ne=G.id,ie=x.listen(this.j,G.name,G.arg)(O=>this.m({id:ne,data:O,type:204}));this.d.set(G.id,ie)}u(G){const x=this.d.get(G.id);x&&(x.dispose(),this.d.delete(G.id))}v(G){let x=this.g.get(G.channelName);x||(x=[],this.g.set(G.channelName,x));const ne=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:G,timeoutTimer:ne})}w(G){const x=this.g.get(G);if(x){for(const ne of x)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=u;var S;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(G,x=null){this.l=G,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new P.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=x}getChannel(G){const x=this;return{call(ne,se,ie){return x.a?Promise.reject(new R.CancellationError):x.m(G,ne,se,ie)},listen(ne,se){return x.a?P.Event.None:x.o(G,ne,se)}}}m(G,x,ne,se=A.CancellationToken.None){const ie=this.g++,U={id:ie,type:100,channelName:G,name:x,arg:ne};if(se.isCancellationRequested)return Promise.reject(new R.CancellationError);let q;return new Promise((X,ee)=>{if(se.isCancellationRequested)return ee(new R.CancellationError);const J=()=>{const le=ye=>{switch(ye.type){case 201:this.f.delete(ie),X(ye.data);break;case 202:{this.f.delete(ie);const Se=new Error(ye.data.message);Se.stack=Array.isArray(ye.data.stack)?ye.data.stack.join(`
`):ye.data.stack,Se.name=ye.data.name,ee(Se);break}case 203:this.f.delete(ie),ee(ye.data);break}};this.f.set(ie,le),this.p(U)};let _=null;this.b===l.Idle?J():(_=(0,i.createCancelablePromise)(le=>this.u()),_.then(()=>{_=null,J()}));const re=()=>{_?(_.cancel(),_=null):this.p({id:ie,type:101}),ee(new R.CancellationError)},ue=se.onCancellationRequested(re);q=(0,b.combinedDisposable)((0,b.toDisposable)(re),ue),this.d.add(q)}).finally(()=>{this.d.delete(q)})}o(G,x,ne){const se=this.g++,O={id:se,type:102,channelName:G,name:x,arg:ne};let U=null;const q=new P.Emitter({onWillAddFirstListener:()=>{U=(0,i.createCancelablePromise)(X=>this.u()),U.then(()=>{U=null,this.d.add(q),this.p(O)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(q),this.p({id:se,type:103}))}}),B=X=>q.fire(X.data);return this.f.set(se,B),q.event}p(G){switch(G.type){case 100:case 102:{const x=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(x,G.id,0,`${h(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const x=this.q([G.type,G.id]);this.j?.logOutgoing(x,G.id,0,h(G.type));return}}}q(G,x=void 0){const ne=new n;return c(ne,G),c(ne,x),this.r(ne.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const x=new d(G),ne=o(x),se=o(x),ie=ne[0];switch(ie){case 200:return this.j?.logIncoming(G.byteLength,0,0,g(ie)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,ne[1],0,g(ie),se),this.t({type:ne[0],id:ne[1],data:se})}}t(G){if(G.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.dispose)(this.d.values()),this.d.clear()}}pe([T.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class M{get connections(){const G=[];return this.f.forEach(x=>G.push(x)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new P.Emitter,this.onDidAddConnection=this.g.event,this.h=new P.Emitter,this.onDidRemoveConnection=this.h.event,G(({protocol:x,onDidClientDisconnect:ne})=>{P.Event.once(x.onMessage)(ie=>{const O=new d(ie),U=o(O),q=new u(x,U),B=new E(x);this.a.forEach((ee,J)=>q.registerChannel(J,ee));const X={channelServer:q,channelClient:B,ctx:U};this.f.add(X),this.g.fire(X),ne(()=>{q.dispose(),B.dispose(),this.f.delete(X),this.h.fire(X)})})})}getChannel(G,x){const ne=this;return{call(se,ie,O){let U;if((0,w.isFunction)(x)){const B=(0,k.getRandomElement)(ne.connections.filter(x));U=B?Promise.resolve(B):P.Event.toPromise(P.Event.filter(ne.onDidAddConnection,x))}else U=x.routeCall(ne,se,ie);const q=U.then(B=>B.channelClient.getChannel(G));return j(q).call(se,ie,O)},listen(se,ie){if((0,w.isFunction)(x))return ne.j(G,x,se,ie);const O=x.routeEvent(ne,se,ie).then(U=>U.channelClient.getChannel(G));return j(O).listen(se,ie)}}}j(G,x,ne,se){const ie=this;let O=new b.DisposableStore;const U=new P.Emitter({onWillAddFirstListener:()=>{O=new b.DisposableStore;const q=new P.EventMultiplexer,B=new Map,X=J=>{const re=J.channelClient.getChannel(G).listen(ne,se),ue=q.add(re);B.set(J,ue)},ee=J=>{const _=B.get(J);!_||(_.dispose(),B.delete(J))};ie.connections.filter(x).forEach(X),P.Event.filter(ie.onDidAddConnection,x)(X,void 0,O),ie.onDidRemoveConnection(ee,void 0,O),q.event(U.fire,U,O),O.add(q)},onDidRemoveLastListener:()=>{O.dispose()}});return U.event}registerChannel(G,x){this.a.set(G,x),this.f.forEach(ne=>{ne.channelServer.registerChannel(G,x)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=M;class N{constructor(G,x,ne=null){const se=new n;c(se,x),G.send(se.buffer),this.a=new E(G,ne),this.d=new u(G,x,ne)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,x){this.d.registerChannel(G,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function j(V){return{call(G,x,ne){return V.then(se=>se.call(G,x,ne))},listen(G,x){const ne=new P.Relay;return V.then(se=>ne.input=se.listen(G,x)),ne.event}}}e.getDelayedChannel=j;function $(V){let G=!1;return{call(x,ne,se){return G?V.call(x,ne,se):(0,i.timeout)(0).then(()=>G=!0).then(()=>V.call(x,ne,se))},listen(x,ne){if(G)return V.listen(x,ne);const se=new P.Relay;return(0,i.timeout)(0).then(()=>G=!0).then(()=>se.input=V.listen(x,ne)),se.event}}}e.getNextTickChannel=$;class L{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const x of G.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await P.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.StaticRouter=L;var F;(function(V){function G(ie,O){const U=ie,q=O&&O.disableMarshalling,B=new Map;for(const X in U)ne(X)&&B.set(X,P.Event.buffer(U[X],!0));return new class{listen(X,ee,J){const _=B.get(ee);if(_)return _;if(se(ee)){const re=U[ee];if(typeof re=="function")return re.call(U,J)}throw new Error(`Event not found: ${ee}`)}call(X,ee,J){const _=U[ee];if(typeof _=="function"){if(!q&&Array.isArray(J))for(let re=0;re<J.length;re++)J[re]=(0,I.revive)(J[re]);return _.apply(U,J)}throw new Error(`Method not found: ${ee}`)}}}V.fromService=G;function x(ie,O){const U=O&&O.disableMarshalling;return new Proxy({},{get(q,B){if(typeof B=="string")return O?.properties?.has(B)?O.properties.get(B):se(B)?function(X){return ie.listen(B,X)}:ne(B)?ie.listen(B):async function(...X){let ee;O&&!(0,w.isUndefinedOrNull)(O.context)?ee=[O.context,...X]:ee=X;const J=await ie.call(B,ee);return U?J:(0,I.revive)(J)};throw new Error(`Property not found: ${String(B)}`)}})}V.toService=x;function ne(ie){return ie[0]==="o"&&ie[1]==="n"&&C.isUpperAsciiLetter(ie.charCodeAt(2))}function se(ie){return/^onDynamic/.test(ie)&&C.isUpperAsciiLetter(ie.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const G=V.toString();if(G!=="[object Object]")return G}return V}function H(V){return Array.isArray(V)?V.map(W):W(V)}function Q(V,G,x,ne,se,ie,O){O=H(O);const U=z[se],q=U[ne%U.length];let B=[`%c[${V}]%c[${String(G).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(ie)?(B=B.concat(O),B.push(")")):B.push(O),console.log.apply(console,B)}class K{constructor(G,x){this.d=G,this.f=x,this.a=0,this.b=0}logOutgoing(G,x,ne,se,ie){this.b+=G,Q(this.d,this.b,G,x,ne,se,ie)}logIncoming(G,x,ne,se,ie){this.a+=G,Q(this.f,this.a,G,x,ne,se,ie)}}e.IPCLogger=K}),define(oe[148],ae([0,1,17,3,39]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(P){this.a=P,this.onMessage=i.Event.fromDOMEventEmitter(this.a,"message",b=>k.VSBuffer.wrap(b.data)),P.start()}send(P){this.a.postMessage(P.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class T extends D.IPCClient{constructor(P,b){const I=new A(P);super(I,b),this.b=I}dispose(){this.b.disconnect()}}e.Client=T}),define(oe[92],ae([0,1,6,17,3,2,39]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(E){E.enableDiagnostics=!1,E.records=[];const M=new WeakMap;let N=0;function j(L,F){if(!M.has(L)){const z=String(++N);M.set(L,z)}return M.get(L)}function $(L,F,z,W){if(!E.enableDiagnostics)return;const H=j(L,F);if(W instanceof i.VSBuffer||W instanceof Uint8Array||W instanceof ArrayBuffer||ArrayBuffer.isView(W)){const Q=i.VSBuffer.alloc(W.byteLength);Q.set(W),E.records.push({timestamp:Date.now(),id:H,label:F,type:z,buff:Q})}else E.records.push({timestamp:Date.now(),id:H,label:F,type:z,data:W})}E.traceSocketEvent=$})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function C(){return I||(I=i.VSBuffer.alloc(0)),I}class w{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(M){this.a.push(M),this.b+=M.byteLength}read(M){return this.c(M,!0)}peek(M){return this.c(M,!1)}c(M,N){if(M===0)return C();if(M>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===M){const F=this.a[0];return N&&(this.a.shift(),this.b-=M),F}if(this.a[0].byteLength>M){const F=this.a[0].slice(0,M);return N&&(this.a[0]=this.a[0].slice(M),this.b-=M),F}const j=i.VSBuffer.alloc(M);let $=0,L=0;for(;M>0;){const F=this.a[L];if(F.byteLength>M){const z=F.slice(0,M);j.set(z,$),$+=M,N&&(this.a[L]=F.slice(M),this.b-=M),M-=M}else j.set(F,$),$+=F.byteLength,N?(this.a.shift(),this.b-=F.byteLength):L++,M-=F.byteLength}return j}}e.ChunkStream=w;var y;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(y||(y={}));function h(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var m;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(M,N,j,$){this.type=M,this.id=N,this.ack=j,this.data=$,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends A.Disposable{constructor(M){super(),this.f=this.B(new D.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=M,this.b=!1,this.c=new w,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(M){if(!(!M||M.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(M);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const j=this.g.messageType,$=this.g.id,L=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new g(j,$,L,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(M){this.k=null,this.a=!1,this.b=!1,this.c=M,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(M){if(this.a)return;M.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=i.VSBuffer.alloc(13);N.writeUInt8(M.type,0),N.writeUInt32BE(M.id,1),N.writeUInt32BE(M.ack,5),N.writeUInt32BE(M.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(M.type),id:M.id,ack:M.ack,messageSize:M.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",M.data),this.j(N,M.data)}g(M,N){const j=this.f===0;return this.d.push(M,N),this.f+=M.byteLength+N.byteLength,j}h(){const M=i.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,M}j(M,N){this.g(M,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const M=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:M.byteLength}),this.c.write(M)}}class p extends A.Disposable{constructor(M){super(),this.f=new D.Emitter,this.onMessage=this.f.event,this.g=new D.Emitter,this.onDidDispose=this.g.event,this.a=M,this.b=this.B(new f(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(M){this.b.write(new g(1,0,0,M))}}e.Protocol=p;class v extends T.IPCClient{static fromSocket(M,N){return new v(new p(M),N)}get onDidDispose(){return this.b.onDidDispose}constructor(M,N,j=null){super(M,N,j),this.b=M}dispose(){super.dispose();const M=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),M.end()}}e.Client=v;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(M){this.b?this.d.length>0?this.d.push(M):this.a.fire(M):this.d.push(M)}flushBuffer(){this.d=[]}}e.BufferedEmitter=d;class n{constructor(M){this.data=M,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let M=0,N=this.a;for(;N;)N=N.next,M++;return M}peek(){return this.a?this.a.data:null}toArray(){const M=[];let N=0,j=this.a;for(;j;)M[N++]=j.data,j=j.next;return M}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(M){const N=new n(M);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const M=Date.now();for(let N=0;N<t.a;N++)this.c[N]=M-1e3*N;setInterval(()=>{for(let N=t.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const M=Date.now(),N=(1+t.a)*1e3;let j=0;for(let $=0;$<t.a;$++)M-this.c[$]<=N&&j++;return 1-j/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var s;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(s=e.ConnectionHealth||(e.ConnectionHealth={}));function a(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=a;class c{constructor(M){this.connectionHealth=M}}e.ConnectionHealthChangedEvent=c;class o{constructor(M,N){this.roundTripTime=M,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=o;class u{get unacknowledgedCount(){return this.c-this.d}constructor(M){this.x=new d,this.onControlMessage=this.x.event,this.y=new d,this.onMessage=this.y.event,this.z=new d,this.onDidDispose=this.z.event,this.A=new d,this.onSocketClose=this.A.event,this.B=new d,this.onSocketTimeout=this.B.event,this.C=new d,this.onHighRoundTripTime=this.C.event,this.D=new d,this.onDidChangeConnectionHealth=this.D.event,this.u=M.loadEstimator??t.getInstance(),this.v=M.measureRoundTripTime??!1,this.w=M.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new A.DisposableStore,this.o=M.socket,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new S),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),M.initialChunk&&this.q.acceptChunk(M.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const M=new g(5,0,0,C());this.p.write(M),this.p.flush()}sendPause(){const M=new g(7,0,0,C());this.p.write(M)}sendResume(){const M=new g(8,0,0,C());this.p.write(M)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(M,N){this.a=!0,this.t.dispose(),this.t=new A.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=M,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(j=>this.E(j))),this.t.add(this.o.onClose(j=>this.A.fire(j))),this.r=this.t.add(new S),this.t.add(this.r.onSendLatencyRequest(j=>this.J(j))),this.t.add(this.r.onHighRoundTripTime(j=>this.C.fire(j))),this.t.add(this.r.onDidChangeConnectionHealth(j=>this.D.fire(j))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const M=new g(3,0,this.h,C());this.p.write(M);const N=this.b.toArray();for(let j=0,$=N.length;j<$;j++)this.p.write(N[j]);this.G()}acceptDisconnect(){this.z.fire()}E(M){if(M.ack>this.d){this.d=M.ack;do{const N=this.b.peek();if(N&&N.id<=M.ack)this.b.pop();else break}while(!0)}switch(M.type){case 0:break;case 1:{if(M.id>this.g)if(M.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new g(6,0,0,C())))}else this.g=M.id,this.j=Date.now(),this.F(),this.y.fire(M.data);break}case 2:{this.x.fire(M.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let j=0,$=N.length;j<$;j++)this.p.write(N[j]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(M.data);break}case 11:{this.r.handleResponse(M.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(M){const N=++this.c;this.h=this.g;const j=new g(1,N,this.h,M);this.b.push(j),this.a||(this.p.write(j),this.G())}sendControl(M){const N=new g(2,0,0,M);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const M=Date.now()-this.j;if(M>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-M+5)}G(){if(this.c<=this.d||this.f||this.a)return;const M=this.b.peek(),N=Date.now()-M.writtenTime,j=Date.now()-this.q.lastReadTime,$=Date.now()-this.n;if(N>=2e4&&j>=2e4&&$>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:j});return}const L=Math.max(2e4-N,2e4-j,2e4-$,500);this.f=setTimeout(()=>{this.f=null,this.G()},L)}H(){if(this.g<=this.h)return;this.h=this.g;const M=new g(3,0,this.h,C());this.p.write(M)}I(){this.h=this.g;const M=new g(9,0,this.h,C());this.p.write(M)}J(M){this.h=this.g;const N=new g(10,0,this.h,M);this.p.write(N)}K(M){this.h=this.g;const N=new g(11,0,this.h,M);this.p.write(N)}}e.PersistentProtocol=u;class S extends A.Disposable{constructor(){super(),this.a=this.B(new D.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new D.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new D.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new k.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},M=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const M=++this.h,N=i.VSBuffer.alloc(4);N.writeUInt32BE(M,0),this.a.fire(N)},6e4)}handleResponse(M){if(M.byteLength!==4)return;const N=M.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const j=Date.now()-this.g,$=this.k++;this.j[$%this.j.length]=j;const L=this.l,F=this.j.filter(z=>z>=1e3).length;this.l=F>=3?1:0,j>1e3&&this.b.fire(new o(j,F)),L!==this.l&&this.c.fire(this.l)}}}),define(oe[149],ae([0,1,93,3,39,148]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends D.IPCServer{static b(){const P=i.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(b,I)=>I);return i.Event.map(P,b=>{const{port1:I,port2:C}=new MessageChannel,y={protocol:new A.Protocol(I),onDidClientDisconnect:i.Event.fromDOMEventEmitter(I,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[C]),y})}constructor(){super(T.b())}}e.Server=T}),define(oe[68],ae([0,1,50,6,17,24,142,9,3,2,32,91,87,39]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends y.ChannelServer{constructor(l){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",f=>D.VSBuffer.wrap(Buffer.from(f,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=h;class m{constructor(l,f){this.i=l,this.j=f,this.c=new Set,this.g=new Map,this.h=new P.Emitter,this.onDidProcessExit=this.h.event;const p=f&&f.timeout?f.timeout:6e4;this.b=new i.Delayer(p),this.d=null,this.f=null}getChannel(l){const f=this;return{call(p,v,d){return f.k(l,p,v,d)},listen(p,v){return f.l(l,p,v)}}}k(l,f,p,v=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(R.canceled());this.b.cancel();const d=this.n(l),n=(0,i.createCancelablePromise)(s=>d.call(f,p,s)),r=v.onCancellationRequested(()=>n.cancel()),t=(0,b.toDisposable)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(l,f,p){if(!this.b)return P.Event.None;this.b.cancel();let v;const d=new P.Emitter({onWillAddFirstListener:()=>{v=this.n(l).listen(f,p)(d.fire,d),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return d.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),(0,w.removeDangerousEnvVariables)(f.env),this.d=(0,k.fork)(this.i,l,f);const p=new P.Emitter;P.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,T.isRemoteConsoleLog)(a)){(0,T.log)(a,`IPC Library: ${this.j.serverName}`);return}p.fire(D.VSBuffer.wrap(Buffer.from(a,"base64")))});const d=this.j.useQueue?(0,C.createQueuedSender)(this.d):this.d,n=a=>this.d&&this.d.connected&&d.send(a.buffer.toString("base64")),r=p.event,t={send:n,onMessage:r};this.f=new y.ChannelClient(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,c)=>{process.removeListener("exit",s),this.c.forEach(o=>(0,b.dispose)(o)),this.c.clear(),a!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:c})})}return this.f}n(l){let f=this.g.get(l);return f||(f=this.m.getChannel(l),this.g.set(l,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=m}),define(oe[150],ae([0,1,17,9,3,2,12,5,31,39,92]),function(Z,e,k,i,D,A,T,R,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function C(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class w{traceSocketEvent(o,u){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,u)}constructor(o,u=""){this.f=!0,this.debugLabel=u,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=S=>{if(this.traceSocketEvent("error",{code:S?.code,message:S?.message}),S){if(S.code==="EPIPE")return;(0,i.onUnexpectedError)(S)}},this.socket.on("error",this.a),this.b=S=>{this.traceSocketEvent("close",{hadError:S}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const u=S=>{this.traceSocketEvent("read",S),o(k.VSBuffer.wrap(S))};return this.socket.on("data",u),{dispose:()=>this.socket.off("data",u)}}onClose(o){const u=S=>{o({type:0,hadError:S,error:void 0})};return this.socket.on("close",u),{dispose:()=>this.socket.off("close",u)}}onEnd(o){const u=()=>{o()};return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,u=>{if(u){if(u.code==="EPIPE")return;(0,i.onUnexpectedError)(u)}})}catch(u){if(u.code==="EPIPE")return;(0,i.onUnexpectedError)(u)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,u)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const S=()=>{this.socket.off("close",S),this.socket.off("end",S),this.socket.off("error",S),this.socket.off("timeout",S),this.socket.off("drain",S),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",S),this.socket.on("end",S),this.socket.on("error",S),this.socket.on("timeout",S),this.socket.on("drain",S)})}}e.NodeSocket=w;var y;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var h;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(h||(h={}));class m extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,u){this.socket.traceSocketEvent(o,u)}constructor(o,u,S,E){super(),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:u,inflateBytesLength:S?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new g(this,u,S,E,this.f,(M,N)=>this.k(M,N))),this.B(this.a.onError(M=>{console.error(M),(0,i.onUnexpectedError)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new I.ChunkStream,this.B(this.socket.onData(M=>this.l(M))),this.B(this.socket.onClose(M=>this.g.fire(M)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this.a.writeMessage(o)}k(o,u){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let S=2;o.byteLength<126?S+=0:o.byteLength<2**16?S+=2:S+=8;const E=k.VSBuffer.alloc(S);if(u?E.writeUInt8(194,0):E.writeUInt8(130,0),o.byteLength<126)E.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){E.writeUInt8(126,1);let M=1;E.writeUInt8(o.byteLength>>>8&255,++M),E.writeUInt8(o.byteLength>>>0&255,++M)}else{E.writeUInt8(127,1);let M=1;E.writeUInt8(0,++M),E.writeUInt8(0,++M),E.writeUInt8(0,++M),E.writeUInt8(0,++M),E.writeUInt8(o.byteLength>>>24&255,++M),E.writeUInt8(o.byteLength>>>16&255,++M),E.writeUInt8(o.byteLength>>>8&255,++M),E.writeUInt8(o.byteLength>>>0&255,++M)}this.socket.write(k.VSBuffer.concat([E,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const u=this.b.peek(this.j.readLen),S=u.readUInt8(0),E=(S&128)>>>7,M=(S&64)>>>6,N=u.readUInt8(1),j=(N&128)>>>7,$=N&127;this.j.state=2,this.j.readLen=2+(j?4:0)+($===126?2:0)+($===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(M)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const u=this.b.read(this.j.readLen),S=u.readUInt8(1),E=(S&128)>>>7;let M=S&127,N=1;M===126?M=u.readUInt8(++N)*2**8+u.readUInt8(++N):M===127&&(M=u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*2**24+u.readUInt8(++N)*2**16+u.readUInt8(++N)*2**8+u.readUInt8(++N));let j=0;E&&(j=u.readUInt8(++N)*2**24+u.readUInt8(++N)*2**16+u.readUInt8(++N)*2**8+u.readUInt8(++N)),this.j.state=3,this.j.readLen=M,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const u=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",u),p(u,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",u),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(u,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await D.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=m;class g extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(o,u,S,E,M,N){super(),this.k=o,this.l=M,this.m=N,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new D.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,u?(this.b=this.B(new l(this.k,E,S,{windowBits:15})),this.f=this.B(new f(this.k,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const u=await this.r(this.f,o);this.m(u,!0)}else this.m(o,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(o,u){return new Promise((S,E)=>{o.write(u),o.flush(M=>S(M))})}acceptFrame(o,u,S){this.h.push({data:o,isCompressed:u,isLastFrameOfMessage:S}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const u=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.l.fire(u)}else this.l.fire(o.data)}this.s=!1}}u(o,u,S){return new Promise((E,M)=>{o.write(u),S&&o.write(k.VSBuffer.fromByteArray([0,0,255,255])),o.flush(N=>E(N))})}}class l extends A.Disposable{get recordedInflateBytes(){return this.j?k.VSBuffer.concat(this.f):k.VSBuffer.alloc(0)}constructor(o,u,S,E){super(),this.h=o,this.j=u,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=C().zlib.createInflateRaw(E),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(k.VSBuffer.wrap(M))}),S&&(this.h.traceSocketEvent("zlibInflateInitialWrite",S.buffer),this.b.write(S.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const u=k.VSBuffer.concat(this.g);this.g.length=0,o(u)})}}class f extends A.Disposable{constructor(o,u){super(),this.g=o,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.b=C().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",S=>{this.g.traceSocketEvent("zlibDeflateError",{message:S?.message,code:S?.code}),this.a.fire(S)}),this.b.on("data",S=>{this.g.traceSocketEvent("zlibDeflateData",S),this.f.push(k.VSBuffer.wrap(S))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let u=k.VSBuffer.concat(this.f);this.f.length=0,u=u.slice(0,u.byteLength-4),o(u)})}}function p(c,o){if(o===0)return;const u=c.byteLength>>>2;for(let $=0;$<u;$++){const L=c.readUInt32BE($*4);c.writeUInt32BE(L^o,$*4)}const S=u*4,E=c.byteLength-S,M=o>>>24&255,N=o>>>16&255,j=o>>>8&255;E>=1&&c.writeUInt8(c.readUInt8(S)^M,S),E>=2&&c.writeUInt8(c.readUInt8(S+1)^N,S+1),E>=3&&c.writeUInt8(c.readUInt8(S+2)^j,S+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const v={[2]:107,[1]:103};function d(){const c=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):o=(0,T.join)(C().os.tmpdir(),`vscode-ipc-${c}.sock`),r(o),o}e.createRandomIPCHandle=d;function n(c,o,u){const S=C().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${S}-${u}-${o}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${S.substr(0,8)}-${u}-${o}.sock`):E=(0,T.join)(c,`${u}-${o}.sock`),r(E),E}e.createStaticIPCHandle=n;function r(c){const o=v[R.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class t extends b.IPCServer{static b(o){const u=D.Event.fromNodeEventEmitter(o,"connection");return D.Event.map(u,S=>({protocol:new I.Protocol(new w(S,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(S,"close"))}))}constructor(o){super(t.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function s(c){return new Promise((o,u)=>{const S=C().net.createServer();S.on("error",u),S.listen(c,()=>{S.removeListener("error",u),o(new t(S))})})}e.serve=s;function a(c,o){return new Promise((u,S)=>{const E=C().net.createConnection(c,()=>{E.removeListener("error",S),u(I.Client.fromSocket(new w(E,`ipc-client${o}`),o))});E.once("error",S)})}e.connect=a}),define(oe[69],ae([0,1,6,3,2,13]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",C[C.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T=e.StorageHint||(e.StorageHint={}));function R(C){const w=C;return w?.changed instanceof Map||w?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var P;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(P=e.StorageState||(e.StorageState={}));class b extends D.Disposable{constructor(w,y=Object.create(null)){super(),this.m=w,this.n=y,this.b=this.B(new i.Emitter),this.onDidChangeStorage=this.b.event,this.c=P.None,this.f=new Map,this.g=new k.ThrottledDelayer(b.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(w=>this.r(w)))}r(w){w.changed?.forEach((y,h)=>this.s(h,y)),w.deleted?.forEach(y=>this.s(y,void 0))}s(w,y){if(this.c===P.Closed)return;let h=!1;(0,A.isUndefinedOrNull)(y)?h=this.f.delete(w):this.f.get(w)!==y&&(this.f.set(w,y),h=!0),h&&this.b.fire(w)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===P.None&&(this.c=P.Initialized,this.n.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(w,y){const h=this.f.get(w);return(0,A.isUndefinedOrNull)(h)?y:h}getBoolean(w,y){const h=this.get(w);return(0,A.isUndefinedOrNull)(h)?y:h==="true"}getNumber(w,y){const h=this.get(w);return(0,A.isUndefinedOrNull)(h)?y:parseInt(h,10)}async set(w,y){if(this.c===P.Closed)return;if((0,A.isUndefinedOrNull)(y))return this.delete(w);const h=String(y);if(this.f.get(w)!==h)return this.f.set(w,h),this.j.set(w,h),this.h.delete(w),this.b.fire(w),this.w()}async delete(w){if(!(this.c===P.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire(w),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=P.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(w).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(w){if(!!this.u)return this.w(w)}async w(w){return this.g.trigger(()=>this.v(),w)}async whenFlushed(){if(!!this.u)return new Promise(w=>this.l.push(w))}isInMemory(){return this.n.hint===T.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=b,b.a=100;class I{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((y,h)=>this.a.set(h,y)),w.delete?.forEach(y=>this.a.delete(y))}async close(){}}e.InMemoryStorageDatabase=I}),define(oe[151],ae([10,11]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(oe[152],ae([10,11]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[153],ae([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(oe[154],ae([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(oe[155],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[156],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[157],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[158],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[159],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(oe[160],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[161],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[162],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[163],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(oe[164],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(oe[165],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(oe[166],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[167],ae([10,11]),function(Z,e){return Z.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[168],ae([10,11]),function(Z,e){return Z.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(oe[169],ae([10,11]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(oe[170],ae([10,11]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(oe[171],ae([10,11]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[172],ae([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[173],ae([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[174],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[175],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[176],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[177],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[178],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[179],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[180],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[181],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[182],ae([10,11]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(oe[94],ae([0,1,65,63,22,12,36,23,7]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class b{get appRoot(){return(0,A.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return P.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.b.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return P.URI.file((0,A.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(P.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=T.env.VSCODE_PORTABLE;return h?P.URI.file((0,A.join)(h,"argv.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.resolve)(h):(0,A.normalize)((0,A.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?P.URI.file((0,A.resolve)(h)):P.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.resolve)(h);const m=T.env.VSCODE_EXTENSIONS;if(m)return m;const g=T.env.VSCODE_PORTABLE;return g?(0,A.join)(g,"extensions"):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(m=>/^[^:/?#]+?:\/\//.test(m)?P.URI.parse(m):P.URI.file((0,A.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file((0,A.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const m of this.args.log||[]){const g=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(m);g&&g[1]&&g[2]&&h.push([g[1],g[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return P.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=T.env.VSCODE_PORTABLE;return h?P.URI.file((0,A.join)(h,"policy.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,m,g){this.a=h,this.b=m,this.c=g,this.editSessionId=this.args.editSessionId}}pe([i.memoize],b.prototype,"appRoot",null),pe([i.memoize],b.prototype,"userHome",null),pe([i.memoize],b.prototype,"userDataPath",null),pe([i.memoize],b.prototype,"appSettingsHome",null),pe([i.memoize],b.prototype,"tmpDir",null),pe([i.memoize],b.prototype,"cacheHome",null),pe([i.memoize],b.prototype,"stateResource",null),pe([i.memoize],b.prototype,"userRoamingDataHome",null),pe([i.memoize],b.prototype,"userDataSyncHome",null),pe([i.memoize],b.prototype,"userDataSyncLogResource",null),pe([i.memoize],b.prototype,"editSessionsLogResource",null),pe([i.memoize],b.prototype,"sync",null),pe([i.memoize],b.prototype,"machineSettingsResource",null),pe([i.memoize],b.prototype,"workspaceStorageHome",null),pe([i.memoize],b.prototype,"localHistoryHome",null),pe([i.memoize],b.prototype,"keyboardLayoutResource",null),pe([i.memoize],b.prototype,"argvResource",null),pe([i.memoize],b.prototype,"isExtensionDevelopment",null),pe([i.memoize],b.prototype,"untitledWorkspacesHome",null),pe([i.memoize],b.prototype,"installSourcePath",null),pe([i.memoize],b.prototype,"builtinExtensionsPath",null),pe([i.memoize],b.prototype,"extensionsPath",null),pe([i.memoize],b.prototype,"extensionDevelopmentLocationURI",null),pe([i.memoize],b.prototype,"extensionDevelopmentKind",null),pe([i.memoize],b.prototype,"extensionTestsLocationURI",null),pe([i.memoize],b.prototype,"debugExtensionHost",null),pe([i.memoize],b.prototype,"logLevel",null),pe([i.memoize],b.prototype,"extensionLogLevel",null),pe([i.memoize],b.prototype,"serviceMachineIdResource",null),pe([i.memoize],b.prototype,"telemetryLogResource",null),pe([i.memoize],b.prototype,"disableWorkspaceTrust",null),pe([i.memoize],b.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=b;function I(y,h){return w(y["inspect-extensions"],y["inspect-brk-extensions"],5870,h,y.debugId,y.extensionEnvironment)}e.parseExtensionHostPort=I;function C(y,h){return w(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,h,y.extensionEnvironment)}e.parsePtyHostPort=C;function w(y,h,m,g,l,f){const v=Number(h||y)||(g?null:m),d=v?Boolean(!!h):!1;let n;if(f)try{n=JSON.parse(f)}catch{}return{port:v,break:d,debugId:l,env:n}}}),define(oe[183],ae([0,1,284,5,153]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,D.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},category:{type:"string",cat:"e",description:(0,D.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,D.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,D.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(m,g,l=T){const f=m.find(c=>c.length>0&&c[0]!=="-"),p={},v=["_"],d=[],n={};let r;for(const c in g){const o=g[c];o.type==="subcommand"?c===f&&(r=o):(o.alias&&(p[c]=o.alias),o.type==="string"||o.type==="string[]"?(v.push(c),o.deprecates&&v.push(...o.deprecates)):o.type==="boolean"&&(d.push(c),o.deprecates&&d.push(...o.deprecates)),o.global&&(n[c]=o))}if(r&&f){const c=n;for(const E in r.options)c[E]=r.options[E];const o=m.filter(E=>E!==f),u=l.getSubcommandReporter?l.getSubcommandReporter(f):void 0,S=R(o,c,u);return{[f]:S,_:[]}}const t=k(m,{string:v,boolean:d,alias:p}),s={},a=t;s._=t._.map(c=>String(c)).filter(c=>c.length>0),delete a._;for(const c in g){const o=g[c];if(o.type==="subcommand")continue;o.alias&&delete a[o.alias];let u=a[c];if(o.deprecates)for(const S of o.deprecates)a.hasOwnProperty(S)&&(u||(u=a[S],u&&l.onDeprecatedOption(S,o.deprecationMessage||(0,D.localize)(36,null,c))),delete a[S]);if(typeof u<"u"){if(o.type==="string[]"){if(Array.isArray(u)||(u=[u]),!o.allowEmptyValue){const S=u.filter(E=>E.length>0);S.length!==u.length&&(l.onEmptyValue(c),u=S.length>0?S:void 0)}}else o.type==="string"&&(Array.isArray(u)?(u=u.pop(),l.onMultipleValues(c,u)):!u&&!o.allowEmptyValue&&(l.onEmptyValue(c),u=void 0));s[c]=u,o.deprecationMessage&&l.onDeprecatedOption(c,o.deprecationMessage)}delete a[c]}for(const c in a)l.onUnknownOption(c);return s}e.parseArgs=R;function P(m,g){let l="";return g.args&&(Array.isArray(g.args)?l=` <${g.args.join("> <")}>`:l=` <${g.args}>`),g.alias?`-${g.alias} --${m}${l}`:`--${m}${l}`}function b(m,g){const l=[];for(const f in m){const p=m[f],v=P(f,p);l.push([v,p.description])}return I(l,g)}e.formatOptions=b;function I(m,g){const f=m.reduce((d,n)=>Math.max(d,n[0].length),12)+2+1;if(g-f<25)return m.reduce((d,n)=>d.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const p=g-f-1,v=[];for(const d of m){const n=d[0],r=w(d[1],p),t=C(f-n.length-2);v.push("  "+n+t+r[0]);for(let s=1;s<r.length;s++)v.push(C(f)+r[s])}return v}function C(m){return" ".repeat(m)}function w(m,g){const l=[];for(;m.length;){const f=m.length<g?m.length:m.lastIndexOf(" ",g),p=m.slice(0,f).trim();m=m.slice(f),l.push(p)}return l}function y(m,g,l,f,p){const v=process.stdout.isTTY&&process.stdout.columns||80,d=p?.noInputFiles!==!0?`[${(0,D.localize)(37,null)}...]`:"",n=[`${m} ${l}`];n.push(""),n.push(`${(0,D.localize)(38,null)}: ${g} [${(0,D.localize)(39,null)}]${d}`),n.push(""),p?.noPipe!==!0&&(i.isWindows?n.push((0,D.localize)(40,null,g)):n.push((0,D.localize)(41,null,g)),n.push(""));const r={},t=[];for(const s in f){const a=f[s];if(a.type==="subcommand")a.description&&t.push({command:s,description:a.description});else if(a.description&&a.cat){let c=r[a.cat];c||(r[a.cat]=c={}),c[s]=a}}for(const s in r){const a=s,c=r[a];c&&(n.push(A[a]),n.push(...b(c,v)),n.push(""))}return t.length&&(n.push((0,D.localize)(42,null)),n.push(...I(t.map(s=>[s.command,s.description]),v)),n.push("")),n.join(`
`)}e.buildHelpMessage=y;function h(m,g){return`${m||(0,D.localize)(43,null)}
${g||(0,D.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=h}),define(oe[184],ae([0,1,285,154,183]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function T(w,y){const h=(v,d)=>{console.warn((0,i.localize)(0,null,v,d))},m=v=>{console.warn((0,i.localize)(1,null,v))},g=(v,d)=>{console.warn((0,i.localize)(2,null,v,d))},l=v=>({onUnknownOption:d=>{v!=="tunnel"&&console.warn((0,i.localize)(3,null,d,v))},onMultipleValues:h,onEmptyValue:m,onDeprecatedOption:g,getSubcommandReporter:v!=="tunnel"?l:void 0}),f={onUnknownOption:v=>{console.warn((0,i.localize)(4,null,v))},onMultipleValues:h,onEmptyValue:m,onDeprecatedOption:g,getSubcommandReporter:l},p=(0,D.parseArgs)(w,D.OPTIONS,y?f:void 0);return p.goto&&p._.forEach(v=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,i.localize)(5,null))),p["max-memory"]&&k(parseInt(p["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),p}function R(w){const y=w.findIndex(h=>!/^-/.test(h));if(y>-1)return[...w.slice(0,y),...w.slice(y+1)]}function P(w){let[,...y]=w;process.env.VSCODE_DEV&&(y=R(y)||[]);const h=!C(process.env);return T(y,h)}e.parseMainProcessArgv=P;function b(w){let[,,...y]=w;return process.env.VSCODE_DEV&&(y=R(y)||[]),T(y,!0)}e.parseCLIProcessArgv=b;function I(w,...y){const h=w.indexOf("--");return h===-1?w.push(...y):w.splice(h,0,...y),w}e.addArg=I;function C(w){return w.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),function(){"use strict";function Z(e,k,i){function D(T,R){const P=A(T,R),b=[P];return e.isAbsolute(P)||b.unshift(i),e.resolve(...b)}function A(T,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,R);const I=T["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(C,"AppData","Roaming")}break;case"darwin":b=e.join(k.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,R)}return{getUserDataPath:D}}if(typeof define=="function")define(oe[185],ae([286,34,36]),function(e,k,i){return Z(e,k,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=Z(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[186],ae([0,1,34,94,185]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends i.AbstractNativeEnvironmentService{constructor(R,P){super(R,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,D.getUserDataPath)(R,P.nameShort)},P)}}e.NativeEnvironmentService=A}),define(oe[187],ae([0,1,7]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,P=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(g){const l=g.match(T);return l?l[1]:null}function I(g){if(g.indexOf("://")===-1){const l=g.match(i);return l?b(l[2]):null}try{const l=k.URI.parse(g);if(l.authority)return b(l.authority)}catch{}return null}function C(g,l){const f=new Set;let p;for(;p=R.exec(g);){const d=I(p[1]);d&&f.add(d)}const v=new Set(l);return Array.from(f).map(d=>v.has(d)?d:d.replace(P,"a"))}e.getDomainsOfRemotes=C;function w(g){const l=g.match(A);return l?l[2]:null}function y(g,l,f){return g&&l?(f&&l.endsWith(".git")&&(l=l.substr(0,l.length-4)),l.indexOf("/")===0?`${g}${l}`:`${g}/${l}`):null}function h(g,l){if(g.indexOf("://")===-1){const f=g.match(D);if(f)return y(f[2],f[3],l)}try{const f=k.URI.parse(g);if(f.authority)return y(w(f.authority),f.path,l)}catch{}return null}function m(g,l=!1){const f=[];let p;for(;p=R.exec(g);){const v=h(p[1],l);v&&f.push(v)}return f}e.getRemotes=m}),define(oe[188],ae([0,1,13,157]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(T,R,P){try{A(T,R,P)}catch(b){console.error(b?.message??b)}return T}e.localizeManifest=D;function A(T,R,P){const b=(I,C,w)=>{const y=I[C];if((0,k.isString)(y)){const h=y,m=h.length;if(m>1&&h[0]==="%"&&h[m-1]==="%"){const g=h.substr(1,m-2);let l=R[g];l===void 0&&P&&(l=P[g]);const f=typeof l=="string"?l:l?.message,p=P?.[g],v=typeof p=="string"?p:p?.message;if(!f){v||console.warn(`[${T.name}]: ${(0,i.localize)(0,null,g)}`);return}if(w&&(C==="title"||C==="category")&&v&&v!==f){const d={value:f,original:v};I[C]=d}else I[C]=f}}else if((0,k.isObject)(y))for(const h in y)y.hasOwnProperty(h)&&(h==="commands"?b(y,h,!0):b(y,h,w));else if(Array.isArray(y))for(let h=0;h<y.length;h++)b(y,h,w)};for(const I in T)T.hasOwnProperty(I)&&b(T,I)}}),define(oe[189],ae([0,1,9]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class i{constructor(){this.a=new Map}register(A,T){this.a.set(A,T)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const T in A.contributes){const R=this.a.get(T);if(!R)continue;const P=A.contributes[T],b=Array.isArray(P)?P:[P];try{R(b,A.activationEvents)}catch(I){(0,k.onUnexpectedError)(I)}}}}e.ImplicitActivationEventsImpl=i,e.ImplicitActivationEvents=new i}),define(oe[190],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,T,R,P){return this.a.call("promptImportantExtensionsInstallNotification",[A,T,R,P])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class i{constructor(A){this.a=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,R){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(oe[70],ae([0,1,23,88,162,53]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function P(l){return l=l.trim(),l==="*"||T.test(l)}e.isValidVersionStr=P;function b(l){if(!P(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=l.match(T);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=b;function I(l){if(!l)return null;const f=l.majorBase,p=l.majorMustEqual,v=l.minorBase;let d=l.minorMustEqual;const n=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(f===0||(d=!1),r=!1);let t=0;if(l.preRelease){const s=R.exec(l.preRelease);if(s){const[,a,c,o]=s;t=Date.UTC(Number(a),Number(c)-1,Number(o))}}return{majorBase:f,majorMustEqual:p,minorBase:v,minorMustEqual:d,patchBase:n,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=I;function C(l,f,p){let v;typeof l=="string"?v=I(b(l)):v=l;let d;f instanceof Date?d=f.getTime():typeof f=="string"&&(d=new Date(f).getTime());let n;if(typeof p=="string"?n=I(b(p)):n=p,!v||!n)return!1;const r=v.majorBase,t=v.minorBase,s=v.patchBase;let a=n.majorBase,c=n.minorBase,o=n.patchBase;const u=n.notBefore;let S=n.majorMustEqual,E=n.minorMustEqual,M=n.patchMustEqual;return n.isMinimum?r>a?!0:r<a?!1:t>c?!0:t<c||d&&d<u?!1:s>=o:(r===1&&a===0&&(!S||!E||!M)&&(a=1,c=0,o=0,S=!0,E=!1,M=!1),r<a?!1:r>a?!S:t<c?!1:t>c?!E:s<o?!1:s>o?!M:!(d&&d<u))}e.isValidVersion=C;function w(l,f,p,v,d){const n=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return n.push([i.default.Error,D.localize(0,null)]),n;if(typeof v.name!="string")return n.push([i.default.Error,D.localize(1,null,"name")]),n;if(typeof v.version!="string")return n.push([i.default.Error,D.localize(2,null,"version")]),n;if(!v.engines)return n.push([i.default.Error,D.localize(3,null,"engines")]),n;if(typeof v.engines.vscode!="string")return n.push([i.default.Error,D.localize(4,null,"engines.vscode")]),n;if(typeof v.extensionDependencies<"u"&&!g(v.extensionDependencies))return n.push([i.default.Error,D.localize(5,null,"extensionDependencies")]),n;if(typeof v.activationEvents<"u"){if(!g(v.activationEvents))return n.push([i.default.Error,D.localize(6,null,"activationEvents")]),n;if(typeof v.main>"u"&&typeof v.browser>"u")return n.push([i.default.Error,D.localize(7,null,"activationEvents","main")]),n}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&n.push([i.default.Warning,D.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return n.push([i.default.Error,D.localize(9,null,"main")]),n;{const s=(0,k.joinPath)(p,v.main);(0,k.isEqualOrParent)(s,p)||n.push([i.default.Warning,D.localize(10,null,s.path,p.path)])}if(typeof v.activationEvents>"u")return n.push([i.default.Error,D.localize(11,null,"activationEvents","main")]),n}if(typeof v.browser<"u"){if(typeof v.browser!="string")return n.push([i.default.Error,D.localize(12,null,"browser")]),n;{const s=(0,k.joinPath)(p,v.browser);(0,k.isEqualOrParent)(s,p)||n.push([i.default.Warning,D.localize(13,null,s.path,p.path)])}if(typeof v.activationEvents>"u")return n.push([i.default.Error,D.localize(14,null,"activationEvents","browser")]),n}if(!A.valid(v.version))return n.push([i.default.Error,D.localize(15,null)]),n;const r=[];if(!y(l,f,v,d,r))for(const s of r)n.push([i.default.Error,s]);return n}e.validateExtensionManifest=w;function y(l,f,p,v,d){return v||typeof p.main>"u"&&typeof p.browser>"u"?!0:m(l,f,p.engines.vscode,d)}e.isValidExtensionVersion=y;function h(l,f,p){return l==="*"||m(f,p,l)}e.isEngineValid=h;function m(l,f,p,v=[]){const d=I(b(p));if(!d)return v.push(D.localize(16,null,p)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return v.push(D.localize(17,null,p)),!1}else if(!d.majorMustEqual)return v.push(D.localize(18,null,p)),!1;return C(l,f,d)?!0:(v.push(D.localize(19,null,l,p)),!1)}function g(l){if(!Array.isArray(l))return!1;for(let f=0,p=l.length;f<p;f++)if(typeof l[f]!="string")return!1;return!0}}),define(oe[45],ae([0,1,17,31]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(A,T,R){let P=R&&R.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const I=(await T.readFile(A.serviceMachineIdResource)).value.toString();P=(0,i.isUUID)(I)?I:null}catch{P=null}if(!P){P=(0,i.generateUuid)();try{await T.writeFile(A.serviceMachineIdResource,k.VSBuffer.fromString(P))}catch{}}return R?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=D}),define(oe[54],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(D,A=[],T=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=k}),define(oe[71],ae([0,1,54]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const i=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function A(R,P,b){P instanceof k.SyncDescriptor||(P=new k.SyncDescriptor(P,[],Boolean(b))),i.push([R,P])}e.registerSingleton=A;function T(){return i}e.getSingletonServiceDescriptors=T}),define(oe[191],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class i{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const T of this.a.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const R=this.lookupOrInsertNode(A),P=this.lookupOrInsertNode(T);R.outgoing.set(P.key,P),P.incoming.set(R.key,R)}removeNode(A){const T=this.b(A);this.a.delete(T);for(const R of this.a.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(A){const T=this.b(A);let R=this.a.get(T);return R||(R=new k(T,A),this.a.set(T,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[T,R]of this.a)A.push(`${T}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this.a){const R=new Set([A]),P=this.c(T,R);if(P)return P}}c(A,T){for(const[R,P]of A.outgoing){if(T.has(R))return[...T,R].join(" -> ");T.add(R);const b=this.c(P,T);if(b)return b;T.delete(R)}}}e.Graph=i}),define(oe[4],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function R(P){return P[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=R})(k=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function i(T,R,P){R[k.DI_TARGET]===R?R[k.DI_DEPENDENCIES].push({id:T,index:P}):(R[k.DI_DEPENDENCIES]=[{id:T,index:P}],R[k.DI_TARGET]=R)}function D(T){if(k.serviceIds.has(T))return k.serviceIds.get(T);const R=function(P,b,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(R,P,I)};return R.toString=()=>T,k.serviceIds.set(T,R),R}e.createDecorator=D;function A(T){return T}e.refineServiceDecorator=A}),define(oe[192],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(oe[16],ae([0,1,13,7,4]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof i.URI)}e.isConfigurationOverrides=A;function T(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=T;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function b(l,f){const p=Object.create(null);for(const v in l)I(p,v,l[v],f);return p}e.toValuesTree=b;function I(l,f,p,v){const d=f.split("."),n=d.pop();let r=l;for(let t=0;t<d.length;t++){const s=d[t];let a=r[s];switch(typeof a){case"undefined":a=r[s]=Object.create(null);break;case"object":break;default:v(`Ignoring ${f} as ${d.slice(0,t+1).join(".")} is ${JSON.stringify(a)}`);return}r=a}if(typeof r=="object"&&r!==null)try{r[n]=p}catch{v(`Ignoring ${f} as ${d.join(".")} is ${JSON.stringify(r)}`)}else v(`Ignoring ${f} as ${d.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=I;function C(l,f){const p=f.split(".");w(l,p)}e.removeFromValueTree=C;function w(l,f){const p=f.shift();if(f.length===0){delete l[p];return}if(Object.keys(l).indexOf(p)!==-1){const v=l[p];typeof v=="object"&&!Array.isArray(v)&&(w(v,f),Object.keys(v).length===0&&delete l[p])}}function y(l,f,p){function v(r,t){let s=r;for(const a of t){if(typeof s!="object"||s===null)return;s=s[a]}return s}const d=f.split("."),n=v(l,d);return typeof n>"u"?p:n}e.getConfigurationValue=y;function h(l,f,p){Object.keys(f).forEach(v=>{v!=="__proto__"&&(v in l?k.isObject(l[v])&&k.isObject(f[v])?h(l[v],f[v],p):p&&(l[v]=f[v]):l[v]=f[v])})}e.merge=h;function m(l,f,p){const v=l.inspect(f),d=l.inspect(p);return typeof v.userValue<"u"||typeof v.workspaceValue<"u"||typeof v.workspaceFolderValue<"u"?v.value:typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:v.defaultValue}e.getMigratedSettingValue=m;function g(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(oe[193],ae([0,1,5,27,4]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",k.isMacintosh),A.set("isLinux",k.isLinux),A.set("isWindows",k.isWindows),A.set("isWeb",k.isWeb),A.set("isMacNative",k.isMacintosh&&!k.isWeb),A.set("isEdge",k.isEdge),A.set("isFirefox",k.isFirefox),A.set("isChrome",k.isChrome),A.set("isSafari",k.isSafari);const T=Object.prototype.hasOwnProperty;var R;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return C.INSTANCE}static true(){return w.INSTANCE}static has(L){return y.create(L)}static equals(L,F){return h.create(L,F)}static notEquals(L,F){return l.create(L,F)}static regex(L,F){return t.create(L,F)}static in(L,F){return m.create(L,F)}static notIn(L,F){return g.create(L,F)}static not(L){return f.create(L)}static and(...L){return c.create(L,null,!0)}static or(...L){return o.create(L,null,!0)}static greater(L,F){return v.create(L,F)}static greaterEquals(L,F){return d.create(L,F)}static smaller(L,F){return n.create(L,F)}static smallerEquals(L,F){return r.create(L,F)}static deserialize(L,F=!1){if(!!L)return this.c(L,F)}static c(L,F){const z=L.split("||");return o.create(z.map(W=>this.d(W,F)),null,!0)}static d(L,F){const z=L.split("&&");return c.create(z.map(W=>this.f(W,F)),null,!0)}static f(L,F){if(L=L.trim(),L.indexOf("!=")>=0){const z=L.split("!=");return l.create(z[0].trim(),this.g(z[1],F))}if(L.indexOf("==")>=0){const z=L.split("==");return h.create(z[0].trim(),this.g(z[1],F))}if(L.indexOf("=~")>=0){const z=L.split("=~");return t.create(z[0].trim(),this.h(z[1],F))}if(L.indexOf(" not in ")>=0){const z=L.split(" not in ");return g.create(z[0].trim(),this.g(z[1],F))}if(L.indexOf(" in ")>=0){const z=L.split(" in ");return m.create(z[0].trim(),this.g(z[1],F))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const z=L.split(">=");return d.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const z=L.split(">");return v.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const z=L.split("<=");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const z=L.split("<");return n.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(L)?f.create(L.substr(1).trim()):y.create(L)}static g(L,F){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const z=/^'([^']*)'$/.exec(L);return z?z[1].trim():L}static h(L,F){if((0,i.isFalsyOrWhitespace)(L)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const z=L.indexOf("/"),W=L.lastIndexOf("/");if(z===W||z<0){if(F)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const H=L.slice(z+1,W),Q=L[W+1]==="i"?"i":"";try{return new RegExp(H,Q)}catch(K){if(F)throw new Error(`bad regexp-value '${L}', parse error: ${K}`);return console.warn(`bad regexp-value '${L}', parse error: ${K}`),null}}}e.ContextKeyExpr=P;function b($,L){const F=$?$.substituteConstants():void 0,z=L?L.substituteConstants():void 0;return!F&&!z?!0:!F||!z?!1:F.equals(z)}e.expressionsAreEqualWithConstantSubstitution=b;function I($,L){return $.cmp(L)}class C{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class w{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class y{static create(L,F=null){const z=A.get(L);return typeof z=="boolean"?z?w.INSTANCE:C.INSTANCE:new y(L,F)}constructor(L,F){this.key=L,this.c=F,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:S(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=A.get(this.key);return typeof L=="boolean"?L?w.INSTANCE:C.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=f.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=y;class h{static create(L,F,z=null){if(typeof F=="boolean")return F?y.create(L,z):f.create(L,z);const W=A.get(L);return typeof W=="boolean"?F===(W?"true":"false")?w.INSTANCE:C.INSTANCE:new h(L,F,z)}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:E(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const F=L?"true":"false";return this.d===F?w.INSTANCE:C.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class m{static create(L,F){return new m(L,F)}constructor(L,F){this.d=L,this.f=F,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:E(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const F=L.getValue(this.f),z=L.getValue(this.d);return Array.isArray(F)?F.includes(z):typeof z=="string"&&typeof F=="object"&&F!==null?T.call(F,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=m;class g{static create(L,F){return new g(L,F)}constructor(L,F){this.d=L,this.f=F,this.type=11,this.c=m.create(L,F)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=g;class l{static create(L,F,z=null){if(typeof F=="boolean")return F?f.create(L,z):y.create(L,z);const W=A.get(L);return typeof W=="boolean"?F===(W?"true":"false")?C.INSTANCE:w.INSTANCE:new l(L,F,z)}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:E(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const F=L?"true":"false";return this.d===F?C.INSTANCE:w.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class f{static create(L,F=null){const z=A.get(L);return typeof z=="boolean"?z?C.INSTANCE:w.INSTANCE:new f(L,F)}constructor(L,F){this.c=L,this.d=F,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:S(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=A.get(this.c);return typeof L=="boolean"?L?C.INSTANCE:w.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.ContextKeyNotExpr=f;function p($,L){if(typeof $=="string"){const F=parseFloat($);isNaN(F)||($=F)}return typeof $=="string"||typeof $=="number"?L($):C.INSTANCE}class v{static create(L,F,z=null){return p(F,W=>new v(L,W,z))}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:E(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=v;class d{static create(L,F,z=null){return p(F,W=>new d(L,W,z))}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:E(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=d;class n{static create(L,F,z=null){return p(F,W=>new n(L,W,z))}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:E(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class r{static create(L,F,z=null){return p(F,W=>new r(L,W,z))}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:E(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class t{static create(L,F){return new t(L,F)}constructor(L,F){this.d=L,this.f=F,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const F=this.f?this.f.source:"",z=L.f?L.f.source:"";return F<z?-1:F>z?1:0}equals(L){if(L.type===this.type){const F=this.f?this.f.source:"",z=L.f?L.f.source:"";return this.d===L.d&&F===z}return!1}substituteConstants(){return this}evaluate(L){const F=L.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=s.create(this)),this.c}}e.ContextKeyRegexExpr=t;class s{static create(L){return new s(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(L){return new s(this.c.map(L))}negate(){return this.c}}e.ContextKeyNotRegexExpr=s;function a($){let L=null;for(let F=0,z=$.length;F<z;F++){const W=$[F].substituteConstants();if($[F]!==W&&L===null){L=[];for(let H=0;H<F;H++)L[H]=$[H]}L!==null&&(L[F]=W)}return L===null?$:L}class c{static create(L,F,z){return c.d(L,F,z)}constructor(L,F){this.expr=L,this.c=F,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let F=0,z=this.expr.length;F<z;F++){const W=I(this.expr[F],L.expr[F]);if(W!==0)return W}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].equals(L.expr[F]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:c.create(L,this.c,!1)}evaluate(L){for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].evaluate(L))return!1;return!0}static d(L,F,z){const W=[];let H=!1;for(const Q of L)if(!!Q){if(Q.type===1){H=!0;continue}if(Q.type===0)return C.INSTANCE;if(Q.type===6){W.push(...Q.expr);continue}W.push(Q)}if(W.length===0&&H)return w.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(I);for(let Q=1;Q<W.length;Q++)W[Q-1].equals(W[Q])&&(W.splice(Q,1),Q--);if(W.length===1)return W[0];for(;W.length>1;){const Q=W[W.length-1];if(Q.type!==9)break;W.pop();const K=W.pop(),V=W.length===0,G=o.create(Q.expr.map(x=>c.create([x,K],null,z)),null,V);G&&(W.push(G),W.sort(I))}if(W.length===1)return W[0];if(z){for(let Q=0;Q<W.length;Q++)for(let K=Q+1;K<W.length;K++)if(W[Q].negate().equals(W[K]))return C.INSTANCE;if(W.length===1)return W[0]}return new c(W,F)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const F of this.expr)L.push(...F.keys());return L}map(L){return new c(this.expr.map(F=>F.map(L)),null)}negate(){if(!this.c){const L=[];for(const F of this.expr)L.push(F.negate());this.c=o.create(L,this,!0)}return this.c}}class o{static create(L,F,z){return o.d(L,F,z)}constructor(L,F){this.expr=L,this.c=F,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let F=0,z=this.expr.length;F<z;F++){const W=I(this.expr[F],L.expr[F]);if(W!==0)return W}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].equals(L.expr[F]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:o.create(L,this.c,!1)}evaluate(L){for(let F=0,z=this.expr.length;F<z;F++)if(this.expr[F].evaluate(L))return!0;return!1}static d(L,F,z){let W=[],H=!1;if(L){for(let Q=0,K=L.length;Q<K;Q++){const V=L[Q];if(!!V){if(V.type===0){H=!0;continue}if(V.type===1)return w.INSTANCE;if(V.type===9){W=W.concat(V.expr);continue}W.push(V)}}if(W.length===0&&H)return C.INSTANCE;W.sort(I)}if(W.length!==0){if(W.length===1)return W[0];for(let Q=1;Q<W.length;Q++)W[Q-1].equals(W[Q])&&(W.splice(Q,1),Q--);if(W.length===1)return W[0];if(z){for(let Q=0;Q<W.length;Q++)for(let K=Q+1;K<W.length;K++)if(W[Q].negate().equals(W[K]))return w.INSTANCE;if(W.length===1)return W[0]}return new o(W,F)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const F of this.expr)L.push(...F.keys());return L}map(L){return new o(this.expr.map(F=>F.map(L)),null)}negate(){if(!this.c){const L=[];for(const F of this.expr)L.push(F.negate());for(;L.length>1;){const F=L.shift(),z=L.shift(),W=[];for(const H of j(F))for(const Q of j(z))W.push(c.create([H,Q],null,!1));L.unshift(o.create(W,null,!1))}this.c=o.create(L,this,!0)}return this.c}}class u extends y{static all(){return u.d.values()}constructor(L,F,z){super(L,null),this.f=F,typeof z=="object"?u.d.push({...z,key:L}):z!==!0&&u.d.push({key:L,description:z,type:F!=null?typeof F:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return h.create(this.key,L)}notEqualsTo(L){return l.create(this.key,L)}}e.RawContextKey=u,u.d=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function S($,L){return $<L?-1:$>L?1:0}function E($,L,F,z){return $<F?-1:$>F?1:L<z?-1:L>z?1:0}function M($,L){if($.type===0||L.type===1)return!0;if($.type===9)return L.type===9?N($.expr,L.expr):!1;if(L.type===9){for(const F of L.expr)if(M($,F))return!0;return!1}if($.type===6){if(L.type===6)return N(L.expr,$.expr);for(const F of $.expr)if(M(F,L))return!0;return!1}return $.equals(L)}e.implies=M;function N($,L){let F=0,z=0;for(;F<$.length&&z<L.length;){const W=$[F].cmp(L[z]);if(W<0)return!1;W===0&&F++,z++}return F===$.length}function j($){return $.type===9?$.expr:[$]}}),define(oe[95],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function i(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=i;class D{async getPerformanceInfo(T,R){return{}}async getSystemInfo(T,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,R){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=D}),define(oe[96],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(oe[15],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[29],ae([0,1,156,4]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function T(l,f){switch(l){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function R(l,f){return f==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function P(l,f,p){return R(f,p)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===p?!0:b(p).includes(l)}e.isTargetPlatformCompatible=P;function b(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function I(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=I;var C;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var w;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(w=e.SortOrder||(e.SortOrder={}));var y;(function(l){l.Install="install",l.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var h;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var m;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class g extends Error{constructor(f,p){super(f),this.code=p,this.name=p}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(oe[194],ae([0,1,3,2,67,32,7,143,29]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(g,l){return T.URI.revive(l?l.transformIncoming(g):g)}function I(g,l){return l?l.transformOutgoingURI(g):g}function C(g,l){l=l||R.DefaultURITransformer;const f=g.manifest;return{...(0,R.transformAndReviveIncomingURIs)({...g,manifest:void 0},l),manifest:f}}function w(g,l){return l?(0,A.cloneAndChange)(g,f=>f instanceof T.URI?l.transformOutgoingURI(f):void 0):g}class y{constructor(l,f){this.a=l,this.b=f,this.onInstallExtension=k.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(l.onDidUninstallExtension,!0)}listen(l,f){const p=this.b(l);switch(f){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,v=>v.map(d=>({...d,local:d.local?w(d.local,p):d.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(l,f,p){const v=this.b(l);switch(f){case"zip":return this.a.zip(C(p[0],v)).then(d=>I(d,v));case"unzip":return this.a.unzip(b(p[0],v));case"install":return this.a.install(b(p[0],v),(0,D.revive)(p[1]));case"installFromLocation":return this.a.installFromLocation(b(p[0],v),T.URI.revive(p[1]));case"getManifest":return this.a.getManifest(b(p[0],v));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(p[0]);case"installFromGallery":return this.a.installFromGallery(p[0],(0,D.revive)(p[1]));case"uninstall":return this.a.uninstall(C(p[0],v),(0,D.revive)(p[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(p[0],v));case"getInstalled":return this.a.getInstalled(p[0],T.URI.revive(p[1])).then(d=>d.map(n=>w(n,v)));case"getMetadata":return this.a.getMetadata(C(p[0],v));case"updateMetadata":return this.a.updateMetadata(C(p[0],v),p[1]).then(d=>w(d,v));case"updateExtensionScope":return this.a.updateExtensionScope(C(p[0],v),p[1]).then(d=>w(d,v));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(p[0],p[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class h extends i.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}constructor(l){super(),this.j=l,this.c=this.B(new k.Emitter),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=this.B(new k.Emitter),this.B(this.j.listen("onInstallExtension")(f=>this.c.fire({identifier:f.identifier,source:this.k(f.source)?T.URI.revive(f.source):f.source,profileLocation:T.URI.revive(f.profileLocation)}))),this.B(this.j.listen("onDidInstallExtensions")(f=>this.f.fire(f.map(p=>({...p,local:p.local?C(p.local,null):p.local,source:this.k(p.source)?T.URI.revive(p.source):p.source,profileLocation:T.URI.revive(p.profileLocation)}))))),this.B(this.j.listen("onUninstallExtension")(f=>this.g.fire({identifier:f.identifier,profileLocation:T.URI.revive(f.profileLocation)}))),this.B(this.j.listen("onDidUninstallExtension")(f=>this.h.fire({...f,profileLocation:T.URI.revive(f.profileLocation)})))}k(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.l||(this.l=this.j.call("getTargetPlatform")),this.l}async canInstall(l){const f=await this.getTargetPlatform();return l.allTargetPlatforms.some(p=>(0,P.isTargetPlatformCompatible)(p,l.allTargetPlatforms,f))}zip(l){return Promise.resolve(this.j.call("zip",[l]).then(f=>T.URI.revive(f)))}unzip(l){return Promise.resolve(this.j.call("unzip",[l]))}install(l,f){return Promise.resolve(this.j.call("install",[l,f])).then(p=>C(p,null))}installFromLocation(l,f){return Promise.resolve(this.j.call("installFromLocation",[l,f])).then(p=>C(p,null))}getManifest(l){return Promise.resolve(this.j.call("getManifest",[l]))}installFromGallery(l,f){return Promise.resolve(this.j.call("installFromGallery",[l,f])).then(p=>C(p,null))}uninstall(l,f){return Promise.resolve(this.j.call("uninstall",[l,f]))}reinstallFromGallery(l){return Promise.resolve(this.j.call("reinstallFromGallery",[l]))}getInstalled(l=null,f){return Promise.resolve(this.j.call("getInstalled",[l,f])).then(p=>p.map(v=>C(v,null)))}getMetadata(l){return Promise.resolve(this.j.call("getMetadata",[l]))}updateMetadata(l,f){return Promise.resolve(this.j.call("updateMetadata",[l,f])).then(p=>C(p,null))}updateExtensionScope(l,f){return Promise.resolve(this.j.call("updateExtensionScope",[l,f])).then(p=>C(p,null))}getExtensionsControlManifest(){return Promise.resolve(this.j.call("getExtensionsControlManifest"))}async download(l,f){const p=await this.j.call("download",[l,f]);return T.URI.revive(p)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class m{constructor(l){this.a=l}listen(l,f){throw new Error("Invalid listen")}call(l,f,p){switch(f){case"getConfigBasedTips":return this.a.getConfigBasedTips(T.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=m}),define(oe[97],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class i{b(){return this.a||(this.a=new Promise((A,T)=>Z(["node-vsce-sign"],async R=>A(R),T))),this.a}async verify(A,T){let R;try{R=await this.b()}catch{return!1}return R.verify(A,T)}}e.ExtensionSignatureVerificationService=i}),define(oe[98],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function D(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var A;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[14],ae([0,1,49,12,27,13,7,164,4]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function b(H){return H.create===!0}e.isFileOpenForWriteOptions=b;var I;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var C;(function(H){H[H.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var w;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=y;function h(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=h;function m(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=m;function g(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function l(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=l;function f(H){return y(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=f;var p;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(Q,K){super(Q),this.code=K}}e.FileSystemProviderError=v;function d(H,Q){const K=new v(H.toString(),Q);return r(K,Q),K}e.createFileSystemProviderError=d;function n(H){return H||d((0,R.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=n;function r(H,Q){return H.name=Q?`${Q} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=r;function t(H){if(!H)return p.Unknown;if(H instanceof v)return H.code;const Q=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!Q)return p.Unknown;switch(Q[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=t;function s(H){if(H instanceof E)return H.fileOperationResult;switch(t(H)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var a;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class c{constructor(Q,K,V){this.resource=Q,this.operation=K,this.target=V}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=c;var o;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class u{constructor(Q,K){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const V=new Map;for(const G of Q){const x=V.get(G.type);switch(x?x.push([G.resource,G]):V.set(G.type,[[G.resource,G]]),G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}}for(const[G,x]of V)switch(G){case 1:this.a=k.TernarySearchTree.forUris(()=>K),this.a.fill(x);break;case 0:this.b=k.TernarySearchTree.forUris(()=>K),this.b.fill(x);break;case 2:this.c=k.TernarySearchTree.forUris(()=>K),this.c.fill(x);break}}contains(Q,...K){return this.d(Q,{includeChildren:!1},...K)}affects(Q,...K){return this.d(Q,{includeChildren:!0},...K)}d(Q,K,...V){if(!Q)return!1;const G=V.length>0;return!!((!G||V.includes(1))&&(this.a?.get(Q)||K.includeChildren&&this.a?.findSuperstr(Q))||(!G||V.includes(0))&&(this.b?.get(Q)||K.includeChildren&&this.b?.findSuperstr(Q))||(!G||V.includes(2))&&(this.c?.findSubstr(Q)||K.includeChildren&&this.c?.findSuperstr(Q)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=u;function S(H,Q,K){return!H||!Q||H===Q||Q.length>H.length?!1:(Q.charAt(Q.length-1)!==i.sep&&(Q+=i.sep),K?(0,D.startsWithIgnoreCase)(H,Q):H.indexOf(Q)===0)}e.isParent=S;class E extends Error{constructor(Q,K,V){super(Q),this.fileOperationResult=K,this.options=V}}e.FileOperationError=E;class M extends E{constructor(Q,K,V){super(Q,2,V),this.stat=K}}e.NotModifiedSinceFileOperationError=M;var N;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(N=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var j;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(j=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=$;async function L(H,Q){if(!Q.hasProvider(T.URI.from({scheme:H.scheme})))return new Promise(K=>{const V=Q.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===H.scheme&&G.added&&(V.dispose(),K())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(Q){return(0,A.isNumber)(Q)||(Q=0),Q<F.KB?(0,R.localize)(1,null,Q.toFixed(0)):Q<F.MB?(0,R.localize)(2,null,(Q/F.KB).toFixed(2)):Q<F.GB?(0,R.localize)(3,null,(Q/F.MB).toFixed(2)):Q<F.TB?(0,R.localize)(4,null,(Q/F.GB).toFixed(2)):(0,R.localize)(5,null,(Q/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var z;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function W(H){return{maxFileSize:H===0?300*F.MB:16*F.GB,maxHeapSize:H===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=W});var Y=this&&this.__param||function(Z,e){return function(k,i){e(k,i,Z)}};define(oe[195],ae([0,1,99,44,14]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const P=(await this.a.readFileStream(R)).value;return new Promise((b,I)=>{const C=(0,k.createHash)("md5");(0,i.listenStream)(P,{onData:w=>C.update(w.buffer),onError:w=>I(w),onEnd:()=>b(C.digest("base64").replace(/=+$/,""))})})}};A=pe([Y(0,D.IFileService)],A),e.ChecksumService=A}),define(oe[196],ae([0,1,17,38,9,3,2,44,7,31,14]),function(Z,e,k,i,D,A,T,R,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends T.Disposable{constructor(y,h){super(),this.a=y,this.b=h,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,b.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(y){return this.a.call("stat",[y])}readdir(y){return this.a.call("readdir",[y])}async readFile(y,h){const{buffer:m}=await this.a.call("readFile",[y,h]);return m}readFileStream(y,h,m){const g=(0,R.newWriteableStream)(f=>k.VSBuffer.concat(f.map(p=>k.VSBuffer.wrap(p))).buffer),l=this.a.listen("readFileStream",[y,h])(f=>{if(f instanceof k.VSBuffer)g.write(f.buffer);else{if(f==="end")g.end();else{let p;if(f instanceof Error)p=f;else{const v=f;p=(0,I.createFileSystemProviderError)(v.message??(0,i.toErrorMessage)(v),v.code??I.FileSystemProviderErrorCode.Unknown)}g.error(p),g.end()}l.dispose()}});return m.onCancellationRequested(()=>{g.error((0,D.canceled)()),g.end(),l.dispose()}),g}writeFile(y,h,m){return this.a.call("writeFile",[y,k.VSBuffer.wrap(h),m])}open(y,h){return this.a.call("open",[y,h])}close(y){return this.a.call("close",[y])}async read(y,h,m,g,l){const[f,p]=await this.a.call("read",[y,h,l]);return m.set(f.buffer.slice(0,p),g),p}write(y,h,m,g,l){return this.a.call("write",[y,h,k.VSBuffer.wrap(m),g,l])}mkdir(y){return this.a.call("mkdir",[y])}delete(y,h){return this.a.call("delete",[y,h])}rename(y,h,m){return this.a.call("rename",[y,h,m])}copy(y,h,m){return this.a.call("copy",[y,h,m])}cloneFile(y,h){return this.a.call("cloneFile",[y,h])}i(){this.B(this.a.listen("fileChange",[this.h])(y=>{if(Array.isArray(y)){const h=y;this.f.fire(h.map(m=>({resource:P.URI.revive(m.resource),type:m.type})))}else{const h=y;this.g.fire(h)}}))}watch(y,h){const m=(0,b.generateUuid)();return this.a.call("watch",[this.h,m,y,h]),(0,T.toDisposable)(()=>this.a.call("unwatch",[this.h,m]))}}e.DiskFileSystemProviderClient=C}),define(oe[100],ae([0,1,17,9,165,14]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(I,C,w,y,h,m){let g;try{await R(I,C,w,y,h,m)}catch(l){g=l}finally{g&&h.errorTransformer&&(g=h.errorTransformer(g)),typeof g<"u"&&w.error(g),w.end()}}e.readFileIntoStream=T;async function R(I,C,w,y,h,m){P(m);const g=await I.open(C,{create:!1});try{P(m);let l=0,f=0,p=h&&typeof h.length=="number"?h.length:void 0,v=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof p=="number"?p:h.bufferSize)),d=h&&typeof h.position=="number"?h.position:0,n=0;do f=await I.read(g,d,v.buffer,n,v.byteLength-n),d+=f,n+=f,l+=f,typeof p=="number"&&(p-=f),n===v.byteLength&&(await w.write(y(v)),v=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof p=="number"?p:h.bufferSize)),n=0);while(f>0&&(typeof p!="number"||p>0)&&P(m)&&b(l,h));if(n>0){let r=n;typeof p=="number"&&(r=Math.min(n,p)),w.write(y(v.slice(0,r)))}}catch(l){throw(0,A.ensureFileSystemProviderError)(l)}finally{await I.close(g)}}function P(I){if(I.isCancellationRequested)throw(0,i.canceled)();return!0}function b(I,C){if(C?.limits){if(typeof C.limits.memory=="number"&&I>C.limits.memory)throw(0,A.createFileSystemProviderError)((0,D.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&I>C.limits.size)throw(0,A.createFileSystemProviderError)((0,D.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(oe[55],ae([0,1,89,2,12,5,7,14]),function(Z,e,k,i,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(l){return l.recursive===!0}e.isRecursiveWatchRequest=P;class b extends i.Disposable{constructor(f,p,v,d){super(),this.h=f,this.i=p,this.j=v,this.k=d,this.c=this.B(new i.MutableDisposable),this.f=void 0,this.g=0}m(){const f=new i.DisposableStore;this.c.value=f,this.b=this.l(f),this.b.setVerboseLogging(this.j),f.add(this.b.onDidChangeFile(p=>this.h(p))),f.add(this.b.onDidLogMessage(p=>this.i(p))),f.add(this.b.onDidError(p=>this.n(p)))}n(f){this.k.restartOnError?this.g<b.a&&this.f?(this.r(`restarting watcher after error: ${f}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${f}`):this.r(f)}p(f){this.g++,this.m(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.j=f,await this.b?.setVerboseLogging(f)}r(f){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.a=5;class I extends b{constructor(f,p,v){super(f,p,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class C extends b{constructor(f,p,v){super(f,p,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function w(l){return l.map(f=>({type:f.type,resource:T.URI.file(f.path)}))}e.toFileChanges=w;function y(l){const f=new g;for(const p of l)f.processEvent(p);return f.coalesce()}e.coalesceEvents=y;function h(l,f){return typeof f=="string"&&!f.startsWith(k.GLOBSTAR)&&!(0,D.isAbsolute)(f)?{base:l,pattern:f}:f}e.normalizeWatcherPattern=h;function m(l,f){const p=[];for(const v of f)p.push((0,k.parse)(h(l,v)));return p}e.parseWatcherPatterns=m;class g{constructor(){this.a=new Set,this.b=new Map}c(f){return A.isLinux?f.path:f.path.toLowerCase()}processEvent(f){const p=this.b.get(this.c(f));let v=!1;if(p){const d=p.type,n=f.type;p.path!==f.path&&(f.type===2||f.type===1)?v=!0:d===1&&n===2?(this.b.delete(this.c(f)),this.a.delete(p)):d===2&&n===1?p.type=0:d===1&&n===0||(p.type=n)}else v=!0;v&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],p=[];return Array.from(this.a).filter(v=>v.type!==2?(f.push(v),!1):!0).sort((v,d)=>v.path.length-d.path.length).filter(v=>p.some(d=>(0,R.isParent)(v.path,d,!A.isLinux))?!1:(p.push(v.path),!0)).concat(f)}}}),define(oe[197],ae([0,1,52,6,24,48,2,85,12,5,145,28,55]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends T.Disposable{constructor(g,l,f,p){super(),this.j=g,this.k=l,this.l=f,this.m=p,this.c=this.B(new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},v=>this.k(v))),this.f=this.B(new i.RunOnceWorker(v=>this.u(v),y.b)),this.g=(0,w.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,w.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new D.CancellationTokenSource,this.ready=this.n()}async n(){try{const g=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const l=await C.Promises.stat(g);this.B(await this.s(g,l.isDirectory()))}catch(g){g.code!=="ENOENT"?this.w(g):this.z(g)}}async r(g){let l=g.path;try{l=await C.Promises.realpath(g.path),g.path===l&&(l=await(0,I.realcase)(g.path)??g.path),g.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${l})`)}catch{}return l}async s(g,l){if(b.isMacintosh&&(0,A.isEqualOrParent)(g,"/Volumes/",!0))return this.w(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const f=new D.CancellationTokenSource(this.i.token),p=new T.DisposableStore;try{const v=(0,P.basename)(g),d=(0,k.watch)(g);p.add((0,T.toDisposable)(()=>{d.removeAllListeners(),d.close()})),this.z(`Started watching: '${g}'`);const n=new Set;if(l)try{for(const t of await C.Promises.readdir(g))n.add(t)}catch(t){this.w(t)}const r=new Map;p.add((0,T.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),d.on("error",(t,s)=>{this.w(`Failed to watch ${g} for changes using fs.watch() (${t}, ${s})`),this.dispose()}),d.on("change",(t,s)=>{if(f.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${s}`);let a="";if(s&&(a=s.toString(),b.isMacintosh&&(a=(0,R.normalizeNFC)(a))),!(!a||t!=="change"&&t!=="rename"))if(l)if(t==="rename"){r.get(a)?.dispose();const c=setTimeout(async()=>{if(r.delete(a),a===v&&!await C.Promises.exists(g)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,P.join)(g,a));if(f.token.isCancellationRequested)return;let u;o?n.has(a)?u=0:(u=1,n.add(a)):(n.delete(a),u=2),this.t({path:(0,P.join)(this.j.path,a),type:u})},y.a);r.set(a,(0,T.toDisposable)(()=>clearTimeout(c)))}else{let c;n.has(a)?c=0:(c=1,n.add(a)),this.t({path:(0,P.join)(this.j.path,a),type:c})}else if(t==="rename"||a!==v){const c=setTimeout(async()=>{const o=await C.Promises.exists(g);f.token.isCancellationRequested||(o?(this.t({path:this.j.path,type:0},!0),p.add(await this.s(g,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},y.a);p.clear(),p.add((0,T.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(v){await C.Promises.exists(g)&&!f.token.isCancellationRequested&&this.w(`Failed to watch ${g} for changes using fs.watch() (${v.toString()})`)}return(0,T.toDisposable)(()=>{f.dispose(!0),p.dispose()})}t(g,l=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),!l&&this.g.some(f=>f(g.path))?this.m&&this.z(` >> ignored (excluded) ${g.path}`):!l&&this.h&&this.h.length>0&&!this.h.some(f=>f(g.path))?this.m&&this.z(` >> ignored (not included) ${g.path}`):this.f.work(g))}u(g){const l=(0,w.coalesceEvents)(g);if(l.length>0){if(this.m)for(const p of l)this.z(`>> normalized ${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`);this.c.work(l)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(g){if(b.isLinux)return C.Promises.exists(g);try{const l=(0,P.basename)(g);return(await C.Promises.readdir((0,P.dirname)(g))).some(p=>p===l)}catch(l){return this.z(l),!1}}setVerboseLogging(g){this.m=g}w(g){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}y(g){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}z(g){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.a=100,y.b=75;async function h(m,g,l,f,p=512){const v=await C.Promises.open(m,"r"),d=Buffer.allocUnsafe(p),n=new D.CancellationTokenSource(f);let r,t=!1;const s={path:m,excludes:[],recursive:!1},a=new y(s,c=>{(async()=>{for(const{type:o}of c)if(o===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:u}=await C.Promises.read(v,d,0,p,null);if(!u||n.token.isCancellationRequested)break;g(d.slice(0,u))}}catch(u){r=new Error(u),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,l(),new Promise((c,o)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await C.Promises.close(v)}catch(u){r=new Error(u)}r?o(r):c()})})}e.watchFileContents=h}),define(oe[198],ae([0,1,3,89,2,5,197]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new k.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=k.Event.None,this.c=new Map,this.f=!1}async watch(b){const I=this.i(b),C=I.filter(y=>{const h=this.c.get(y.path);return h?!(0,i.patternsEquals)(h.request.excludes,y.excludes)||!(0,i.patternsEquals)(h.request.includes,y.includes):!0}),w=Array.from(this.c.values()).filter(({request:y})=>!I.find(h=>h.path===y.path&&(0,i.patternsEquals)(h.excludes,y.excludes)&&(0,i.patternsEquals)(h.includes,y.includes))).map(({request:y})=>y.path);C.length&&this.j(`Request to start watching: ${C.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),w.length&&this.j(`Request to stop watching: ${w.join(",")}`);for(const y of w)this.h(y);for(const y of C)this.g(y)}g(b){const I=new T.NodeJSFileWatcherLibrary(b,w=>this.a.fire(w),w=>this.b.fire(w),this.f),C={request:b,instance:I};this.c.set(b.path,C)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const I=this.c.get(b);I&&(this.c.delete(b),I.instance.dispose())}i(b){const I=new Map;for(const C of b){const w=A.isLinux?C.path:C.path.toLowerCase();I.set(w,C)}return Array.from(I.values())}async setVerboseLogging(b){this.f=b;for(const[,I]of this.c)I.instance.setVerboseLogging(b)}j(b){this.f&&this.b.fire({type:"trace",message:this.k(b)})}k(b,I){return I?`[File Watcher (node.js)] ${b} (path: ${I.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=R}),define(oe[199],ae([0,1,55,198]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends k.AbstractNonRecursiveWatcherClient{constructor(T,R,P){super(T,R,P),this.m()}l(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(oe[200],ae([0,1,22,39,68,55]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(P,b,I){super(P,b,I),this.m()}l(P){const b=P.add(new D.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(b.onDidProcessExit(({code:I,signal:C})=>this.n(`terminated by itself with code ${I}, signal: ${C}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(oe[72],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...D){this.a=new Map;for(const[A,T]of D)this.set(A,T)}set(D,A){const T=this.a.get(D);return this.a.set(D,A),T}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=k}),define(oe[201],ae([0,1,6,9,2,54,191,4,72,84]),function(Z,e,k,i,D,A,T,R,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class C extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class w{constructor(g=new P.ServiceCollection,l=!1,f,p=I){this.f=g,this.g=l,this.h=f,this.i=p,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=p?f?._globalGraph??new T.Graph(v=>v):void 0}createChild(g){return new w(g,this.g,this,this.i)}invokeFunction(g,...l){const f=h.traceInvocation(this.i,g);let p=!1;try{return g({get:d=>{if(p)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(d,f);if(!n)throw new Error(`[invokeFunction] unknown service '${d}'`);return n}},...l)}finally{p=!0,f.stop()}}createInstance(g,...l){let f,p;return g instanceof A.SyncDescriptor?(f=h.traceCreation(this.i,g.ctor),p=this.j(g.ctor,g.staticArguments.concat(l),f)):(f=h.traceCreation(this.i,g),p=this.j(g,l,f)),f.stop(),p}j(g,l=[],f){const p=R._util.getServiceDependencies(g).sort((n,r)=>n.index-r.index),v=[];for(const n of p){const r=this.m(n.id,f);r||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${n.id}.`,!1),v.push(r)}const d=p.length>0?p[0].index:l.length;if(l.length!==d){console.trace(`[createInstance] First service dependency of ${g.name} at position ${d+1} conflicts with ${l.length} static arguments`);const n=d-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,d)}return Reflect.construct(g,l.concat(v))}k(g,l){if(this.f.get(g)instanceof A.SyncDescriptor)this.f.set(g,l);else if(this.h)this.h.k(g,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const l=this.f.get(g);return!l&&this.h?this.h.l(g):l}m(g,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const f=this.l(g);return f instanceof A.SyncDescriptor?this.q(g,f,l.branch(g,!0)):(l.branch(g,!1),f)}q(g,l,f){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,l,f)}finally{this.o.delete(g)}}r(g,l,f){const p=new T.Graph(n=>n.id.toString());let v=0;const d=[{id:g,desc:l,_trace:f}];for(;d.length;){const n=d.pop();if(p.lookupOrInsertNode(n),v++>1e3)throw new C(p);for(const r of R._util.getServiceDependencies(n.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof A.SyncDescriptor){const s={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};p.insertEdge(n,s),d.push(s)}}}for(;;){const n=p.roots();if(n.length===0){if(!p.isEmpty())throw new C(p);break}for(const{data:r}of n){if(this.l(r.id)instanceof A.SyncDescriptor){const s=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,s)}p.removeNode(r)}}return this.l(g)}s(g,l,f=[],p,v){if(this.f.get(g)instanceof A.SyncDescriptor)return this.t(g,l,f,p,v);if(this.h)return this.h.s(g,l,f,p,v);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(g,l,f=[],p,v){if(p){const d=new w(void 0,this.g,this,this.i);d.c=String(g);const n=new Map,r=new k.IdleValue(()=>{const t=d.j(l,f,v);for(const[s,a]of n){const c=t[s];if(typeof c=="function")for(const o of a)c.apply(t,o)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let o=n.get(s);return o||(o=new b.LinkedList,n.set(s,o)),(S,E,M)=>{const N=o.push([S,E,M]);return(0,D.toDisposable)(N)}}if(s in t)return t[s];const a=r.value;let c=a[s];return typeof c!="function"||(c=c.bind(a),t[s]=c),c},set(t,s,a){return r.value[s]=a,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,f,v)}u(g,l){if(l&&console.warn(g),this.g)throw new Error(g)}}e.InstantiationService=w;var y;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(y||(y={}));class h{static traceInvocation(g,l){return g?new h(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(g,l){return g?new h(1,l.name):h.c}constructor(g,l){this.type=g,this.name=l,this.g=Date.now(),this.h=[]}branch(g,l){const f=new h(3,g.toString());return this.h.push([g,l,f]),f}stop(){const g=Date.now()-this.g;h.f+=g;let l=!1;function f(v,d){const n=[],r=new Array(v+1).join("	");for(const[t,s,a]of d.h)if(s&&a){l=!0,n.push(`${r}CREATES -> ${t}`);const c=f(v+1,a);c&&n.push(c)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(g>2||l)&&h.all.add(p.join(`
`))}}e.Trace=h,h.all=new Set,h.c=new class extends h{constructor(){super(0,null)}stop(){}branch(){return this}},h.f=0}),define(oe[202],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(D,A){this.a=D,this.b=A}getChannel(D){return this.a.getChannel(D,this.b)}registerChannel(D,A){this.a.registerChannel(D,A)}}e.MessagePortMainProcessService=k}),define(oe[56],ae([0,1,39,54,71,4]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(y,h,m,g){const l=m.getChannel(y);return R(h)?g.createInstance(new i.SyncDescriptor(h.channelClientCtor,[l])):k.ProxyChannel.toService(l,h?.proxyOptions)}}function R(w){return!!w?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let P=class extends T{constructor(y,h,m,g){super(y,h,m,g)}};P=pe([Y(2,e.IMainProcessService),Y(3,A.IInstantiationService)],P);function b(w,y,h){(0,D.registerSingleton)(w,new i.SyncDescriptor(P,[y,h],!0))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let I=class extends T{constructor(y,h,m,g){super(y,h,m,g)}};I=pe([Y(2,e.ISharedProcessService),Y(3,A.IInstantiationService)],I);function C(w,y,h){(0,D.registerSingleton)(w,new i.SyncDescriptor(I,[y,h],!0))}e.registerSharedProcessRemoteService=C}),define(oe[73],ae([0,1,24,2,5,167,29,4]),function(Z,e,k,i,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function P(I){return I.tags.find(C=>C.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=P,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let b=class extends i.Disposable{constructor(C){super(),this.c=C}async getAvailableLanguages(){const C=new k.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const h=w.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(g=>g.startsWith("lp-"))).map(m=>{const g=m.properties.localizedLanguages?.[0],l=P(m);return{...this.f(l,g,m),extensionId:m.identifier.id,galleryExtension:m}});return h.push({...this.f("en","English"),extensionId:"default"}),h}f(C,w,y){const h=w??C;let m;if(h!==C&&(m=`(${C})`),C.toLowerCase()===D.language.toLowerCase()&&(m??="",m+=(0,A.localize)(0,null)),y?.installCount){m??="";const g=y.installCount;let l;g>1e6?l=`${Math.floor(g/1e5)/10}M`:g>1e3?l=`${Math.floor(g/1e3)}K`:l=String(g),m+=` $(cloud-download) ${l}`}return{id:C,label:h,description:m}}};b=pe([Y(0,T.IExtensionGalleryService)],b),e.LanguagePackBaseService=b}),define(oe[203],ae([0,1,2,73]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends k.Disposable{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};D=pe([Y(0,i.ILanguagePackService)],D),e.LocalizationsUpdater=D}),define(oe[8],ae([0,1,38,3,2,37,5,7,4]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function b(){return new Date().toISOString()}var I;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(I=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=I.Info;function C(c,o,u){switch(o){case I.Trace:c.trace(u);break;case I.Debug:c.debug(u);break;case I.Info:c.info(u);break;case I.Warning:c.warn(u);break;case I.Error:c.error(u);break;case I.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=C;function w(c){let o="";for(let u=0;u<c.length;u++){let S=c[u];if(typeof S=="object")try{S=JSON.stringify(S)}catch{}o+=(u>0?" ":"")+S}return o}e.format=w;class y extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new i.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}f(o){return this.b!==I.Off&&this.b<=o}}e.AbstractLogger=y;class h extends y{constructor(o){super(),this.h=o}f(o){return this.h||super.f(o)}trace(o,...u){this.f(I.Trace)&&this.g(I.Trace,w([o,...u]))}debug(o,...u){this.f(I.Debug)&&this.g(I.Debug,w([o,...u]))}info(o,...u){this.f(I.Info)&&this.g(I.Info,w([o,...u]))}warn(o,...u){this.f(I.Warning)&&this.g(I.Warning,w([o,...u]))}error(o,...u){if(this.f(I.Error))if(o instanceof Error){const S=Array.prototype.slice.call(arguments);S[0]=o.stack,this.g(I.Error,w(S))}else this.g(I.Error,w([o,...u]))}flush(){}}e.AbstractMessageLogger=h;class m extends y{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.g=!T.isWindows}trace(o,...u){this.f(I.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,o,...u):console.log(`[main ${b()}]`,o,...u))}debug(o,...u){this.f(I.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,o,...u):console.log(`[main ${b()}]`,o,...u))}info(o,...u){this.f(I.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,o,...u):console.log(`[main ${b()}]`,o,...u))}warn(o,...u){this.f(I.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,o,...u):console.warn(`[main ${b()}]`,o,...u))}error(o,...u){this.f(I.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,o,...u):console.error(`[main ${b()}]`,o,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class g extends y{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...u){this.f(I.Trace)&&console.log("%cTRACE","color: #888",o,...u)}debug(o,...u){this.f(I.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",o,...u)}info(o,...u){this.f(I.Info)&&console.log("%c INFO","color: #33f",o,...u)}warn(o,...u){this.f(I.Warning)&&console.log("%c WARN","color: #993",o,...u)}error(o,...u){this.f(I.Error)&&console.log("%c  ERR","color: #f33",o,...u)}dispose(){}flush(){}}e.ConsoleLogger=g;class l extends y{constructor(o,u=e.DEFAULT_LOG_LEVEL){super(),this.g=o,this.setLevel(u)}trace(o,...u){this.f(I.Trace)&&this.g.log(I.Trace,[this.h(o),...u])}debug(o,...u){this.f(I.Debug)&&this.g.log(I.Debug,[this.h(o),...u])}info(o,...u){this.f(I.Info)&&this.g.log(I.Info,[this.h(o),...u])}warn(o,...u){this.f(I.Warning)&&this.g.log(I.Warning,[this.h(o),...u])}error(o,...u){this.f(I.Error)&&this.g.log(I.Error,[this.h(o),...u])}h(o){return typeof o=="string"?o:(0,k.toErrorMessage)(o,this.f(I.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class f extends y{constructor(o){super(),this.g=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const u of this.g)u.setLevel(o);super.setLevel(o)}trace(o,...u){for(const S of this.g)S.trace(o,...u)}debug(o,...u){for(const S of this.g)S.debug(o,...u)}info(o,...u){for(const S of this.g)S.info(o,...u)}warn(o,...u){for(const S of this.g)S.warn(o,...u)}error(o,...u){for(const S of this.g)S.error(o,...u)}flush(){for(const o of this.g)o.flush()}dispose(){for(const o of this.g)o.dispose()}}e.MultiplexLogService=f;class p extends D.Disposable{constructor(o){super(),this.b=o,this.B(o)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(o){this.b.setLevel(o)}getLevel(){return this.b.getLevel()}trace(o,...u){this.b.trace(o,...u)}debug(o,...u){this.b.debug(o,...u)}info(o,...u){this.b.info(o,...u)}warn(o,...u){this.b.warn(o,...u)}error(o,...u){this.b.error(o,...u)}flush(){this.b.flush()}}e.LogService=p;class v extends D.Disposable{constructor(o,u){super(),this.c=o,this.b=new A.ResourceMap,this.B(u(S=>this.setLevel(S)))}getLoggers(){return[...this.b.values()].map(({logger:o})=>o)}getLogger(o){return this.b.get(o)?.logger}createLogger(o,u,S){let E=this.b.get(o)?.logger;return E||(S=u?.always?I.Trace:S,E=this.f(o,S??this.c,u),this.b.set(o,{logger:E,logLevel:S})),E}setLevel(o,u){const S=R.URI.isUri(o)?o:void 0,E=S?u:o;if(S){const M=this.b.get(S);M&&M.logLevel!==E&&(M.logLevel=E,M.logger.setLevel(E))}else this.c=E,this.b.forEach(({logLevel:M,logger:N})=>{M===void 0&&N.setLevel(this.c)})}getLogLevel(o){return this.b.get(o)?.logLevel}dispose(){this.b.forEach(({logger:o})=>o.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=v;class d{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(o){}getLevel(){return I.Info}trace(o,...u){}debug(o,...u){}info(o,...u){}warn(o,...u){}error(o,...u){}critical(o,...u){}dispose(){}flush(){}}e.NullLogger=d;class n extends d{}e.NullLogService=n;class r extends v{constructor(){super(I.Info,i.Event.None)}f(o,u,S){return new d}}e.NullLoggerService=r;function t(c){if(c.verbose)return I.Trace;if(typeof c.logLevel=="string"){const o=a(c.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function s(c){switch(c){case I.Trace:return"trace";case I.Debug:return"debug";case I.Info:return"info";case I.Warning:return"warn";case I.Error:return"error";case I.Off:return"off"}}e.LogLevelToString=s;function a(c){switch(c){case"trace":return I.Trace;case"debug":return I.Debug;case"info":return I.Info;case"warn":return I.Warning;case"error":return I.Error;case"critical":return I.Error;case"off":return I.Off}}e.parseLogLevel=a}),define(oe[204],ae([0,1,6,9,2,12,28,15,8]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends D.Disposable{constructor(C,w){super(),this.a=C,this.b=w,this.B(new k.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,A.basename)(this.a.logsPath),w=(0,A.dirname)(this.a.logsPath),m=(await T.Promises.readdir(w)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==C),g=m.slice(0,Math.max(0,m.length-9));g.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${g.join(", ")}'`),await Promise.all(g.map(l=>T.Promises.rm((0,A.join)(w,l)))))}catch(C){(0,i.onUnexpectedError)(C)}}};b=pe([Y(0,R.IEnvironmentService),Y(1,P.ILogService)],b),e.LogsDataCleaner=b}),define(oe[205],ae([0,1,20,6,9,3,2,12,55,8]),function(Z,e,k,i,D,A,T,R,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends T.Disposable{constructor(w,y){super(),this.a=w,this.b=y,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new i.ThrottledDelayer(0)),this.s=[],this.t=this.B(new i.ThrottledDelayer(0))}watch(w,y){return y.recursive||this.b?.watcher?.forceUniversal?this.l(w,y):this.u(w,y)}l(w,y){const h={path:this.C(w),excludes:y.excludes,includes:y.includes,recursive:y.recursive},m=(0,k.insert)(this.j,h);return this.m(),(0,T.toDisposable)(()=>{m(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(w=>(0,D.onUnexpectedError)(w))}n(){this.h||(this.h=this.B(this.p(y=>this.c.fire((0,P.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const y of this.j)(0,P.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const y of this.j)(0,P.isRecursiveWatchRequest)(y)&&w.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(w,y){const h={path:this.C(w),excludes:y.excludes,includes:y.includes,recursive:!1},m=(0,k.insert)(this.s,h);return this.v(),(0,T.toDisposable)(()=>{m(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(w=>(0,D.onUnexpectedError)(w))}w(){return this.r||(this.r=this.B(this.y(w=>this.c.fire((0,P.toFileChanges)(w)),w=>this.z(w),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.r.watch(this.s)}z(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}C(w){return(0,R.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(oe[206],ae([0,1,20,6,17,24,3,66,64,2,49,22,207,23,44,163,14,100,8]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=class extends b.Disposable{constructor(d){super(),this.b=d,this.a=256*1024,this.c=this.B(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new T.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new T.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new T.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new i.ResourceQueue)}registerProvider(d,n){if(this.h.has(d))throw new Error(`A filesystem provider for the scheme '${d}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${d}`);const r=new b.DisposableStore;return this.h.set(d,n),this.c.fire({added:!0,scheme:d,provider:n}),r.add(n.onDidChangeFile(t=>this.Q.fire(new g.FileChangesEvent(t,!this.N(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(t=>this.R.fire(new Error(t)))),r.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:d}))),(0,b.toDisposable)(()=>{this.c.fire({added:!1,scheme:d,provider:n}),this.h.delete(d),(0,b.dispose)(r)})}getProvider(d){return this.h.get(d)}async activateProvider(d){const n=[];this.f.fire({scheme:d,join(r){n.push(r)}}),!this.h.has(d)&&await i.Promises.settled(n)}async canHandleResource(d){return await this.activateProvider(d.scheme),this.hasProvider(d)}hasProvider(d){return this.h.has(d.scheme)}hasCapability(d,n){const r=this.h.get(d.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return P.Iterable.map(this.h,([d,n])=>({scheme:d,capabilities:n.capabilities}))}async j(d){if(!(0,y.isAbsolutePath)(d))throw new g.FileOperationError((0,m.localize)(0,null,this.mb(d)),8);await this.activateProvider(d.scheme);const n=this.h.get(d.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,m.localize)(1,null,d.toString()),r}return n}async k(d){const n=await this.j(d);if((0,g.hasOpenReadWriteCloseCapability)(n)||(0,g.hasReadWriteCapability)(n)||(0,g.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${d.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(d){const n=await this.j(d);if((0,g.hasOpenReadWriteCloseCapability)(n)||(0,g.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${d.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(d,n){try{return await this.n(d,n)}catch(r){throw(0,g.toFileSystemProviderErrorCode)(r)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,m.localize)(2,null,this.mb(d)),1):(0,g.ensureFileSystemProviderError)(r)}}async n(d,n){const r=await this.j(d),t=this.N(r),s=n?.resolveTo,a=n?.resolveSingleChildDescendants,c=n?.resolveMetadata,o=await r.stat(d);let u;return this.p(r,d,o,void 0,!!c,(S,E)=>(u||(u=I.TernarySearchTree.forUris(()=>!t),u.set(d,!0),s&&u.fill(!0,s)),u.get(S.resource)||u.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&a?E===1:!1))}async p(d,n,r,t,s,a){const{providerExtUri:c}=this.M(d),o={resource:n,name:c.basename(n),isFile:(r.type&g.FileType.File)!==0,isDirectory:(r.type&g.FileType.Directory)!==0,isSymbolicLink:(r.type&g.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&g.FilePermission.Readonly)||Boolean(d.capabilities&2048),etag:(0,g.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(o.isDirectory&&a(o,t)){try{const u=await d.readdir(n),S=await i.Promises.settled(u.map(async([E,M])=>{try{const N=c.joinPath(n,E),j=s?await d.stat(N):{type:M};return await this.p(d,N,j,u.length,s,a)}catch(N){return this.b.trace(N),null}}));o.children=(0,k.coalesce)(S)}catch(u){this.b.trace(u),o.children=[]}return o}return o}async resolveAll(d){return i.Promises.settled(d.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(d){const n=await this.j(d),r=await n.stat(d);return this.p(n,d,r,void 0,!0,()=>!1)}async exists(d){const n=await this.j(d);try{return!!await n.stat(d)}catch{return!1}}async canCreateFile(d,n){try{await this.r(d,n)}catch(r){return r}return!0}async r(d,n){if(!n?.overwrite&&await this.exists(d))throw new g.FileOperationError((0,m.localize)(3,null,this.mb(d)),3,n)}async createFile(d,n=D.VSBuffer.fromString(""),r){await this.r(d,r);const t=await this.writeFile(d,n);return this.m.fire(new g.FileOperationEvent(d,0,t)),t}async writeFile(d,n,r){const t=this.kb(await this.l(d),d),{providerExtUri:s}=this.M(t);try{await this.s(t,d,r)||await this.O(t,s.dirname(d));let c;if((0,g.hasReadWriteCapability)(t)&&!(n instanceof D.VSBuffer))if((0,h.isReadableStream)(n)){const o=await(0,h.peekStream)(n,3);o.ended?c=D.VSBuffer.concat(o.buffer):c=o}else c=(0,h.peekReadable)(n,o=>D.VSBuffer.concat(o),3);else c=n;!(0,g.hasOpenReadWriteCloseCapability)(t)||(0,g.hasReadWriteCapability)(t)&&c instanceof D.VSBuffer?await this.bb(t,d,r,c):await this.X(t,d,r,c instanceof D.VSBuffer?(0,D.bufferToReadable)(c):c),this.m.fire(new g.FileOperationEvent(d,4))}catch(a){throw new g.FileOperationError((0,m.localize)(4,null,this.mb(d),(0,g.ensureFileSystemProviderError)(a).toString()),(0,g.toFileOperationResult)(a),r)}return this.resolve(d,{resolveMetadata:!0})}async s(d,n,r){if(!!r?.unlock&&!(d.capabilities&8192))throw new Error((0,m.localize)(5,null,this.mb(n)));let s;try{s=await d.stat(n)}catch{return}if((s.type&g.FileType.Directory)!==0)throw new g.FileOperationError((0,m.localize)(6,null,this.mb(n)),0,r);if(this.lb(n,s),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==g.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&r.mtime<s.mtime&&r.etag!==(0,g.etag)({mtime:r.mtime,size:s.size}))throw new g.FileOperationError((0,m.localize)(7,null),3,r);return s}async readFile(d,n,r){const t=await this.k(d);return n?.atomic?this.t(t,d,n,r):this.u(t,d,n,r)}async t(d,n,r,t){return new Promise((s,a)=>{this.W.queueFor(n,this.M(d).providerExtUri).queue(async()=>{try{const c=await this.u(d,n,r,t);s(c)}catch(c){a(c)}})})}async u(d,n,r,t){const s=await this.v(d,n,{...r,preferUnbuffered:!0},t);return{...s,value:await(0,D.streamToBuffer)(s.value)}}async readFileStream(d,n,r){const t=await this.k(d);return this.v(t,d,n,r)}async v(d,n,r,t){const s=new A.CancellationTokenSource(t),a=this.D(n,r).then(o=>o,o=>{throw s.cancel(),o});let c;try{return typeof r?.etag=="string"&&r.etag!==g.ETAG_DISABLED&&await a,r?.atomic&&(0,g.hasFileAtomicReadCapability)(d)||!((0,g.hasOpenReadWriteCloseCapability)(d)||(0,g.hasFileReadStreamCapability)(d))||(0,g.hasReadWriteCapability)(d)&&r?.preferUnbuffered?c=this.C(d,n,r):(0,g.hasFileReadStreamCapability)(d)?c=this.w(d,n,s.token,r):c=this.z(d,n,s.token,r),{...await a,value:c}}catch(o){c&&await(0,h.consumeStream)(c);const u=(0,m.localize)(8,null,this.mb(n),(0,g.ensureFileSystemProviderError)(o).toString());throw o instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(u,o.stat,r):new g.FileOperationError(u,(0,g.toFileOperationResult)(o),r)}}w(d,n,r,t=Object.create(null)){const s=d.readFileStream(n,t,r);return(0,h.transform)(s,{data:a=>a instanceof D.VSBuffer?a:D.VSBuffer.wrap(a),error:a=>new g.FileOperationError((0,m.localize)(9,null,this.mb(n),(0,g.ensureFileSystemProviderError)(a).toString()),(0,g.toFileOperationResult)(a),t)},a=>D.VSBuffer.concat(a))}z(d,n,r,t=Object.create(null)){const s=(0,D.newWriteableBufferStream)();return(0,l.readFileIntoStream)(d,n,s,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>new g.FileOperationError((0,m.localize)(10,null,this.mb(n),(0,g.ensureFileSystemProviderError)(a).toString()),(0,g.toFileOperationResult)(a),t)},r),s}C(d,n,r){const t=(0,h.newWriteableStream)(s=>D.VSBuffer.concat(s));return(async()=>{try{let s;r?.atomic&&(0,g.hasFileAtomicReadCapability)(d)?s=await d.readFile(n,{atomic:!0}):s=await d.readFile(n),typeof r?.position=="number"&&(s=s.slice(r.position)),typeof r?.length=="number"&&(s=s.slice(0,r.length)),this.F(n,s.byteLength,r),t.end(D.VSBuffer.wrap(s))}catch(s){t.error(s),t.end()}})(),t}async D(d,n){const r=await this.resolve(d,{resolveMetadata:!0});if(r.isDirectory)throw new g.FileOperationError((0,m.localize)(11,null,this.mb(d)),0,n);if(typeof n?.etag=="string"&&n.etag!==g.ETAG_DISABLED&&n.etag===r.etag)throw new g.NotModifiedSinceFileOperationError((0,m.localize)(12,null),r,n);return this.F(d,r.size,n),r}F(d,n,r){if(r?.limits){let t;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(t=9),typeof r.limits.size=="number"&&n>r.limits.size&&(t=7),typeof t=="number")throw new g.FileOperationError((0,m.localize)(13,null,this.mb(d)),t)}}async canMove(d,n,r){return this.G(d,n,"move",r)}async canCopy(d,n,r){return this.G(d,n,"copy",r)}async G(d,n,r,t){if(d.toString()!==n.toString())try{const s=r==="move"?this.kb(await this.l(d),d):await this.k(d),a=this.kb(await this.l(n),n);await this.L(s,d,a,n,r,t)}catch(s){return s}return!0}async move(d,n,r){const t=this.kb(await this.l(d),d),s=this.kb(await this.l(n),n),a=await this.H(t,d,s,n,"move",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new g.FileOperationEvent(d,a==="move"?2:3,c)),c}async copy(d,n,r){const t=await this.k(d),s=this.kb(await this.l(n),n),a=await this.H(t,d,s,n,"copy",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new g.FileOperationEvent(d,a==="copy"?3:2,c)),c}async H(d,n,r,t,s,a){if(n.toString()===t.toString())return s;const{exists:c,isSameResourceWithDifferentPathCase:o}=await this.L(d,n,r,t,s,a);if(c&&!o&&a&&await this.del(t,{recursive:!0}),await this.O(r,this.M(r).providerExtUri.dirname(t)),s==="copy"){if(d===r&&(0,g.hasFileFolderCopyCapability)(d))await d.copy(n,t,{overwrite:a});else{const u=await this.resolve(n);u.isDirectory?await this.J(d,u,r,t):await this.I(d,n,r,t)}return s}else return d===r?(await d.rename(n,t,{overwrite:a}),s):(await this.H(d,n,r,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async I(d,n,r,t){if((0,g.hasOpenReadWriteCloseCapability)(d)&&(0,g.hasOpenReadWriteCloseCapability)(r))return this.db(d,n,r,t);if((0,g.hasOpenReadWriteCloseCapability)(d)&&(0,g.hasReadWriteCapability)(r))return this.jb(d,n,r,t);if((0,g.hasReadWriteCapability)(d)&&(0,g.hasOpenReadWriteCloseCapability)(r))return this.hb(d,n,r,t);if((0,g.hasReadWriteCapability)(d)&&(0,g.hasReadWriteCapability)(r))return this.fb(d,n,r,t)}async J(d,n,r,t){await r.mkdir(t),Array.isArray(n.children)&&await i.Promises.settled(n.children.map(async s=>{const a=this.M(r).providerExtUri.joinPath(t,s.name);return s.isDirectory?this.J(d,await this.resolve(s.resource),r,a):this.I(d,s.resource,r,a)}))}async L(d,n,r,t,s,a){let c=!1;if(d===r){const{providerExtUri:u,isPathCaseSensitive:S}=this.M(d);if(S||(c=u.isEqual(n,t)),c&&s==="copy")throw new Error((0,m.localize)(14,null,this.mb(n),this.mb(t)));if(!c&&u.isEqualOrParent(t,n))throw new Error((0,m.localize)(15,null,this.mb(n),this.mb(t)))}const o=await this.exists(t);if(o&&!c){if(!a)throw new g.FileOperationError((0,m.localize)(16,null,this.mb(n),this.mb(t)),4);if(d===r){const{providerExtUri:u}=this.M(d);if(u.isEqualOrParent(n,t))throw new Error((0,m.localize)(17,null,this.mb(n),this.mb(t)))}}return{exists:o,isSameResourceWithDifferentPathCase:c}}M(d){const n=this.N(d);return{providerExtUri:n?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:n}}N(d){return!!(d.capabilities&1024)}async createFolder(d){const n=this.kb(await this.j(d),d);await this.O(n,d);const r=await this.resolve(d,{resolveMetadata:!0});return this.m.fire(new g.FileOperationEvent(d,0,r)),r}async O(d,n){const r=[],{providerExtUri:t}=this.M(d);for(;!t.isEqual(n,t.dirname(n));)try{if(((await d.stat(n)).type&g.FileType.Directory)===0)throw new Error((0,m.localize)(18,null,this.mb(n)));break}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileNotFound)throw s;r.push(t.basename(n)),n=t.dirname(n)}for(let s=r.length-1;s>=0;s--){n=t.joinPath(n,r[s]);try{await d.mkdir(n)}catch(a){if((0,g.toFileSystemProviderErrorCode)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(d,n){try{await this.P(d,n)}catch(r){return r}return!0}async P(d,n){const r=this.kb(await this.j(d),d);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,m.localize)(19,null,this.mb(d)));let s;try{s=await r.stat(d)}catch{}if(s)this.lb(d,s);else throw new g.FileOperationError((0,m.localize)(20,null,this.mb(d)),1);if(!!!n?.recursive){const c=await this.resolve(d);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,m.localize)(21,null,this.mb(d)))}return r}async del(d,n){const r=await this.P(d,n),t=!!n?.useTrash,s=!!n?.recursive;await r.delete(d,{recursive:s,useTrash:t}),this.m.fire(new g.FileOperationEvent(d,1))}async cloneFile(d,n){const r=await this.j(d),t=this.kb(await this.l(n),n);if(r===t&&this.M(r).providerExtUri.isEqual(d,n))return;if(r===t&&(0,g.hasFileCloneCapability)(r))return r.cloneFile(d,n);await this.O(t,this.M(t).providerExtUri.dirname(n));const s=this.W.queueFor(d,this.M(r).providerExtUri);return r===t&&(0,g.hasFileFolderCopyCapability)(r)?s.queue(()=>r.copy(d,n,{overwrite:!0})):s.queue(()=>this.I(r,d,t,n))}watch(d,n={recursive:!1,excludes:[]}){const r=new b.DisposableStore;let t=!1,s=()=>{t=!0};return r.add((0,b.toDisposable)(()=>s())),(async()=>{try{const a=await this.U(d,n);t?(0,b.dispose)(a):s=()=>(0,b.dispose)(a)}catch(a){this.b.error(a)}})(),r}async U(d,n){const r=await this.j(d),t=(0,R.hash)([this.M(r).providerExtUri.getComparisonKey(d),n]);let s=this.S.get(t);return s||(s={count:0,disposable:r.watch(d,n)},this.S.set(t,s)),s.count+=1,(0,b.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,b.dispose)(s.disposable),this.S.delete(t)))})}dispose(){super.dispose();for(const[,d]of this.S)(0,b.dispose)(d.disposable);this.S.clear()}async X(d,n,r,t){return this.W.queueFor(n,this.M(d).providerExtUri).queue(async()=>{const s=await d.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,h.isReadableStream)(t)||(0,h.isReadableBufferedStream)(t)?await this.Y(d,s,t):await this.Z(d,s,t)}catch(a){throw(0,g.ensureFileSystemProviderError)(a)}finally{await d.close(s)}})}async Y(d,n,r){let t=0,s;if((0,h.isReadableBufferedStream)(r)){if(r.buffer.length>0){const a=D.VSBuffer.concat(r.buffer);await this.ab(d,n,a,a.byteLength,t,0),t+=a.byteLength}if(r.ended)return;s=r.stream}else s=r;return new Promise((a,c)=>{(0,h.listenStream)(s,{onData:async o=>{s.pause();try{await this.ab(d,n,o,o.byteLength,t,0)}catch(u){return c(u)}t+=o.byteLength,setTimeout(()=>s.resume())},onError:o=>c(o),onEnd:()=>a()})})}async Z(d,n,r){let t=0,s;for(;(s=r.read())!==null;)await this.ab(d,n,s,s.byteLength,t,0),t+=s.byteLength}async ab(d,n,r,t,s,a){let c=0;for(;c<t;)c+=await d.write(n,s+c,r.buffer,a+c,t-c)}async bb(d,n,r,t){return this.W.queueFor(n,this.M(d).providerExtUri).queue(()=>this.cb(d,n,r,t))}async cb(d,n,r,t){let s;t instanceof D.VSBuffer?s=t:(0,h.isReadableStream)(t)?s=await(0,D.streamToBuffer)(t):(0,h.isReadableBufferedStream)(t)?s=await(0,D.bufferedStreamToBuffer)(t):s=(0,D.readableToBuffer)(t),await d.writeFile(n,s.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async db(d,n,r,t){return this.W.queueFor(t,this.M(r).providerExtUri).queue(()=>this.eb(d,n,r,t))}async eb(d,n,r,t){let s,a;try{s=await d.open(n,{create:!1}),a=await r.open(t,{create:!0,unlock:!1});const c=D.VSBuffer.alloc(this.a);let o=0,u=0,S=0;do S=await d.read(s,o,c.buffer,u,c.byteLength-u),await this.ab(r,a,c,S,o,u),o+=S,u+=S,u===c.byteLength&&(u=0);while(S>0)}catch(c){throw(0,g.ensureFileSystemProviderError)(c)}finally{await i.Promises.settled([typeof s=="number"?d.close(s):Promise.resolve(),typeof a=="number"?r.close(a):Promise.resolve()])}}async fb(d,n,r,t){return this.W.queueFor(t,this.M(r).providerExtUri).queue(()=>this.gb(d,n,r,t))}async gb(d,n,r,t){return r.writeFile(t,await d.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async hb(d,n,r,t){return this.W.queueFor(t,this.M(r).providerExtUri).queue(()=>this.ib(d,n,r,t))}async ib(d,n,r,t){const s=await r.open(t,{create:!0,unlock:!1});try{const a=await d.readFile(n);await this.ab(r,s,D.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,g.ensureFileSystemProviderError)(a)}finally{await r.close(s)}}async jb(d,n,r,t){const s=await(0,D.streamToBuffer)(this.z(d,n,A.CancellationToken.None));await this.bb(r,t,void 0,s)}kb(d,n){if(d.capabilities&2048)throw new g.FileOperationError((0,m.localize)(22,null,this.mb(n)),6);return d}lb(d,n){if((n.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,m.localize)(23,null,this.mb(d)),6)}mb(d){return d.scheme===C.Schemas.file?d.fsPath:d.toString(!0)}};p=pe([Y(0,f.ILogService)],p),e.FileService=p}),define(oe[208],ae([0,1,52,287,6,37,17,3,48,2,12,5,23,44,28,166,14,100,205,38,200,199]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(k)}catch(r){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(r)}`)}})();class n extends f.AbstractDiskFileSystemProvider{constructor(t,s){super(t,s),this.onDidChangeCapabilities=R.Event.None,this.H=new A.ResourceMap(a=>w.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,C.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:s,symbolicLink:a}=await h.SymlinkSupport.stat(this.C(t));return{type:this.G(s,a),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.Y(s)}}async readdir(t){try{const s=await h.Promises.readdir(this.C(t),{withFileTypes:!0}),a=[];return await Promise.all(s.map(async c=>{try{let o;c.isSymbolicLink()?o=(await this.stat((0,w.joinPath)(t,c.name))).type:o=this.G(c),a.push([c.name,o])}catch(o){this.a.trace(o)}})),a}catch(s){throw this.Y(s)}}G(t,s){let a;return s?.dangling?a=g.FileType.Unknown:t.isFile()?a=g.FileType.File:t.isDirectory()?a=g.FileType.Directory:a=g.FileType.Unknown,s&&(a|=g.FileType.SymbolicLink),a}async I(t){const s=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let a;for(;a=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await a.wait();const c=new D.Barrier;return this.H.set(t,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,b.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.H.get(t)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),c.open()})}async readFile(t,s){let a;try{s?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),a=await this.I(t));const c=this.C(t);return await h.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{a?.dispose()}}J(t){n.D&&this.a.trace(t)}readFileStream(t,s,a){const c=(0,y.newWriteableStream)(o=>T.VSBuffer.concat(o.map(u=>T.VSBuffer.wrap(u))).buffer);return(0,l.readFileIntoStream)(this,t,c,o=>o.buffer,{...s,bufferSize:256*1024},a),c}async writeFile(t,s,a){let c;try{const o=this.C(t);if(!a.create||!a.overwrite){if(await h.Promises.exists(o)){if(!a.overwrite)throw(0,g.createFileSystemProviderError)((0,m.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,g.createFileSystemProviderError)((0,m.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:a.unlock}),await this.write(c,0,s,0,s.byteLength)}catch(o){throw await this.Z(t,o)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){n.O=t}async open(t,s){const a=this.C(t);let c;(0,g.isFileOpenForWriteOptions)(s)&&(c=await this.I(t));let o;try{if((0,g.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:S}=await h.SymlinkSupport.stat(a);S.mode&128||await h.Promises.chmod(a,S.mode|128)}catch(S){this.a.trace(S)}let u;if((0,g.isFileOpenForWriteOptions)(s)){if(C.isWindows)try{await h.Promises.truncate(a,0),u="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}u||(u="w")}else u="r";o=await h.Promises.open(a,u)}catch(u){throw c?.dispose(),(0,g.isFileOpenForWriteOptions)(s)?await this.Z(t,u):this.Y(u)}if(this.L.set(o,0),(0,g.isFileOpenForWriteOptions)(s)&&this.N.set(o,t),c){const u=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${a})`),this.M.set(o,c),u&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${a})`),u.dispose())}return o}async close(t){const s=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&n.O)try{await h.Promises.fdatasync(t)}catch(a){n.configureFlushOnWrite(!1),this.a.error(a)}return await h.Promises.close(t)}catch(a){throw this.Y(a)}finally{s&&(this.M.get(t)===s&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),s.dispose())}}async read(t,s,a,c,o){const u=this.P(t,s);let S=null;try{S=(await h.Promises.read(t,a,c,o,u)).bytesRead}catch(E){throw this.Y(E)}finally{this.Q(t,u,S)}return S}P(t,s){return s===this.L.get(t)?null:s}Q(t,s,a){const c=this.L.get(t);typeof c=="number"&&(typeof s=="number"||(typeof a=="number"?this.L.set(t,c+a):this.L.delete(t)))}async write(t,s,a,c,o){return(0,D.retry)(()=>this.R(t,s,a,c,o),100,3)}async R(t,s,a,c,o){const u=this.P(t,s);let S=null;try{S=(await h.Promises.write(t,a,c,o,u)).bytesWritten}catch(E){throw await this.Z(this.N.get(t),E)}finally{this.Q(t,u,S)}return S}async mkdir(t){try{await h.Promises.mkdir(this.C(t))}catch(s){throw this.Y(s)}}async delete(t,s){try{const a=this.C(t);s.recursive?await h.Promises.rm(a,h.RimRafMode.MOVE):await h.Promises.unlink(a)}catch(a){throw this.Y(a)}}async rename(t,s,a){const c=this.C(t),o=this.C(s);if(c!==o)try{await this.S(t,s,"move",a.overwrite),await h.Promises.move(c,o)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,m.localize)(2,null,(0,I.basename)(c),(0,I.basename)((0,I.dirname)(o)),u.toString()))),this.Y(u)}}async copy(t,s,a){const c=this.C(t),o=this.C(s);if(c!==o)try{await this.S(t,s,"copy",a.overwrite),await h.Promises.copy(c,o,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,m.localize)(3,null,(0,I.basename)(c),(0,I.basename)((0,I.dirname)(o)),u.toString()))),this.Y(u)}}async S(t,s,a,c){const o=this.C(t),u=this.C(s);let S=!1;if(!!(this.capabilities&1024)||(S=(0,P.isEqual)(o,u,!0)),S&&a==="copy")throw(0,g.createFileSystemProviderError)((0,m.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(!S&&await h.Promises.exists(u)){if(!c)throw(0,g.createFileSystemProviderError)((0,m.localize)(5,null),g.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(t,s){return this.U(t,s,!1)}async U(t,s,a){const c=this.C(t),o=this.C(s),u=!!(this.capabilities&1024);if((0,P.isEqual)(c,o,!u))return;const S=new b.DisposableStore;try{const[E,M]=await Promise.all([this.I(t),this.I(s)]);S.add(E),S.add(M),a&&await h.Promises.mkdir((0,I.dirname)(o),{recursive:!0}),await h.Promises.copyFile(c,o)}catch(E){if(E.code==="ENOENT"&&!a)return this.U(t,s,!0);throw this.Y(E)}finally{S.dispose()}}p(t,s,a){return new v.UniversalWatcherClient(c=>t(c),c=>s(c),a)}y(t,s,a){return new d.NodeJSWatcherClient(c=>t(c),c=>s(c),a)}Y(t){if(t instanceof g.FileSystemProviderError)return t;let s;switch(t.code){case"ENOENT":s=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=g.FileSystemProviderErrorCode.NoPermissions;break;default:s=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(t,s)}async Z(t,s){let a=this.Y(s);if(t&&a.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await h.SymlinkSupport.stat(this.C(t));c.mode&128||(a=(0,g.createFileSystemProviderError)(s,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return a}}e.DiskFileSystemProvider=n,n.D=!1,n.O=!0}),define(oe[101],ae([0,1,6,3,2,4,8]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("lifecycleSharedProcessService");let R=class extends D.Disposable{constructor(b){super(),this.c=b,this.a=void 0,this.b=this.B(new i.Emitter),this.onWillShutdown=this.b.event}fireOnWillShutdown(){if(this.a)return this.a;this.c.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this.b.fire({join(I){b.push(I)}}),this.a=(async()=>{try{await k.Promises.settled(b)}catch(I){this.c.error(I)}})(),this.a}};R=pe([Y(0,T.ILogService)],R),e.SharedProcessLifecycleService=R}),define(oe[102],ae([0,1,3,7,8]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(w,y){this.a=w,this.b=y,this.onDidChangeLogLevel=k.Event.buffer(w.onDidChangeLogLevel,!0)}listen(w,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(w,y,h){switch(y){case"setLevel":return h[1]?this.b.setLevel(i.URI.revive(h[1]),h[0]):this.a.setLevel(h[0])}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=A;class T{constructor(w){this.a=w}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(w,y){T.setLevel(this.a,w,y)}static setLevel(w,y,h){return w.call("setLevel",[y,h])}}e.LogLevelChannelClient=T;class R{constructor(w){this.b=w,this.a=new Map}listen(w,y){throw new Error(`Event not found: ${y}`)}async call(w,y,h){switch(y){case"createLogger":this.c(i.URI.revive(h[0]),h[1]);return;case"log":return this.e(i.URI.revive(h[0]),h[1]);case"consoleLog":return this.d(h[0],h[1])}throw new Error(`Call not found: ${y}`)}c(w,y){this.a.set(w.toString(),this.b.createLogger(w,y))}d(w,y){let h=console.log;switch(w){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...y)}e(w,y){const h=this.a.get(w.toString());if(!h)throw new Error("Create the logger before logging");for(const[m,g]of y)(0,D.log)(h,m,g)}}e.LoggerChannel=R;class P extends D.AbstractLoggerService{constructor(w,y,h){super(w,y),this.g=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(w,y)=>{this.g.call("consoleLog",[w,y])}})}f(w,y,h){return new b(this.g,w,y,h)}}e.LoggerChannelClient=P;class b extends D.AbstractMessageLogger{constructor(w,y,h,m){super(m?.always),this.m=w,this.n=y,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[y,m]).then(()=>{this.r(this.l),this.k=!0})}g(w,y){const h=[[w,y]];this.k?this.r(h):this.l.push(...h)}r(w){this.m.call("log",[this.n,w])}}class I extends D.LogService{constructor(w,y){super(y),this.c=w,this.B(w.onDidChangeLogLevel(h=>y.setLevel(h)))}setLevel(w){super.setLevel(w),this.c.setLevel(w)}}e.FollowerLogService=I}),define(oe[57],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(oe[58],ae([0,1,3,64,2,4]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class T extends D.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new k.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const I=Object.keys(this.f).length;return this.f={...b,...this.f},I!==Object.keys(this.f).length&&await this.i(b),i.Iterable.reduce(this.g.entries(),(C,[w,y])=>({...C,[w]:y}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return i.Iterable.reduce(Object.entries(this.f),(b,[I,C])=>({...b,[I]:{definition:C,value:this.g.get(I)}}),{})}}e.AbstractPolicyService=T;class R{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(oe[209],ae([0,1,3,2,58]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(P){this.b=P,this.a=new i.DisposableStore}listen(P,b){switch(b){case"onDidChange":return k.Event.map(this.b.onDidChange,I=>I.reduce((C,w)=>({...C,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${b}`)}call(P,b,I){switch(b){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(I)}throw new Error(`Call not found: ${b}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class T extends D.AbstractPolicyService{constructor(P,b){super(),this.a=b;for(const I in P){const{definition:C,value:w}=P[I];this.f[I]=C,w!==void 0&&this.g.set(I,w)}this.a.listen("onDidChange")(I=>{for(const C in I){const w=I[C];w===null?this.g.delete(C):this.g.set(C,w)}this.h.fire(Object.keys(I))})}async i(P){const b=await this.a.call("updatePolicyDefinitions",P);for(const I in b)this.g.set(I,b[I])}}e.PolicyChannelClient=T}),define(oe[103],ae([0,1,5,36]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.context<"u"){const A=k.globals.vscode.context.configuration();if(A)D=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:A.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(oe[25],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[210],ae([0,1,6,9,2,12,28,8,25]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends D.Disposable{constructor(C,w,y){super(),this.b=w,this.c=y,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this.B(new k.RunOnceScheduler(()=>{this.f(C)},3e4)).schedule()}async f(C){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),y=(0,A.dirname)(C),h=(0,A.basename)(C),m=await T.Promises.readdir(y);await Promise.all(m.map(async g=>{if(g===h)return;const l=(0,A.join)(y,g),f=await T.Promises.stat(l);if(f.isDirectory()&&w-f.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${g}.`),T.Promises.rm(l)}))}catch(w){(0,i.onUnexpectedError)(w)}}};b=pe([Y(1,P.IProductService),Y(2,R.ILogService)],b),e.CodeCacheCleaner=b}),define(oe[211],ae([0,1,6,9,2,12,28,15,8,25]),function(Z,e,k,i,D,A,T,R,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends D.Disposable{constructor(w,y,h){super(),this.b=w,this.c=y,this.f=h,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new k.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),y=JSON.parse(await T.Promises.readFile((0,A.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(y)){const p=y[f];w[`${p.hash}.${f}`]=!0}const h=(0,A.join)(this.b.userDataPath,"clp");if(!await T.Promises.exists(h))return;const g=await T.Promises.readdir(h);for(const f of g){if(w[f]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await T.Promises.rm((0,A.join)(h,f))}const l=Date.now();for(const f of Object.keys(w)){const p=(0,A.join)(h,f),v=await T.Promises.readdir(p);for(const d of v){if(d==="tcf.json")continue;const n=(0,A.join)(p,d),r=await T.Promises.stat(n);r.isDirectory()&&l-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(f,d)}`),await T.Promises.rm(n))}}}catch(w){(0,i.onUnexpectedError)(w)}}};I=pe([Y(0,R.INativeEnvironmentService),Y(1,P.ILogService),Y(2,b.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(oe[212],ae([0,1,20,2,23,187,14,25]),function(Z,e,k,i,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let P=class extends i.Disposable{constructor(I,C){super(),this.b=I,this.c=C,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,w])=>this.a.set(w.configPath,w))}getConfigBasedTips(I){return this.f(I)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(I){const C=[];for(const[w,y]of this.a)if(!(y.configScheme&&y.configScheme!==I.scheme))try{const h=await this.b.readFile((0,D.joinPath)(I,w)),m=new Map;Object.entries(y.recommendations).forEach(([l,f])=>{if((0,k.isNonEmptyArray)(f.remotes))for(const p of f.remotes)m.set(p,{extensionId:l,extensionName:f.name,configName:y.configName,important:!!f.important,isExtensionPack:!!f.isExtensionPack,whenNotInstalled:f.whenNotInstalled});else C.push({extensionId:l,extensionName:f.name,configName:y.configName,important:!!f.important,isExtensionPack:!!f.isExtensionPack,whenNotInstalled:f.whenNotInstalled})});const g=(0,A.getDomainsOfRemotes)(h.value.toString(),[...m.keys()]);for(const l of g){const f=m.get(l);f&&C.push(f)}}catch{}return C}};P=pe([Y(0,T.IFileService),Y(1,R.IProductService)],P),e.ExtensionTipsService=P}),define(oe[213],ae([0,1,12,4]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var D;(function(A){function T(P){return Boolean(P.samples&&P.timeDeltas)}A.isValidProfile=T;function R(P,b="noAbsolutePaths"){for(const I of P.nodes)I.callFrame&&I.callFrame.url&&((0,k.isAbsolute)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(I.callFrame.url))&&(I.callFrame.url=(0,k.join)(b,(0,k.basename)(I.callFrame.url)));return P}A.rewriteAbsolutePaths=R})(D=e.Utils||(e.Utils={}))}),define(oe[214],ae([0,1,31]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise((b,I)=>{Z(["v8-inspect-profiler"],b,I)})).startProfiling({port:A.port,checkForPaused:!0}),P=(0,k.generateUuid)();return this.a.set(P,R),P}async stopProfiling(A){const T=this.a.get(A);if(!T)throw new Error(`UNKNOWN session '${A}'`);const R=await T.stop();return this.a.delete(A),R.profile}}e.InspectProfilingService=i}),define(oe[40],ae([0,1,126,13]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(T,R){k.ok(i.isString(T)),k.ok(i.isObject(R)),k.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,R)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.Registry=new D}),define(oe[104],ae([0,1,3,40]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new k.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(P,b){this.a[D(P)]=b,this.b.fire(P)}notifySchemaChanged(P){this.b.fire(P)}getSchemaContributions(){return{schemas:this.a}}}const T=new A;i.Registry.add(e.Extensions.JSONContribution,T)}),define(oe[46],ae([0,1,20,3,13,152,16,104,40]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=P.Registry.as(R.Extensions.JSONContribution);class w{constructor(){this.h=new Set,this.i=new i.Emitter,this.onDidSchemaChange=this.i.event,this.j=new i.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=new Set;this.n(n,r,t),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=new Set;this.o(n,r),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=new Set;this.o(r,t),this.n(n,!1,t),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const t=[];for(const{overrides:s,source:a}of n)for(const c in s)if(r.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.a.get(c),u=o?.valuesSources??new Map;if(a)for(const N of Object.keys(s[c]))u.set(N,a);const S={...o?.value||{},...s[c]};this.a.set(c,{source:a,value:S,valuesSources:u});const E=(0,T.getLanguageTagSettingPlainKey)(c),M={type:"object",default:S,description:A.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:D.isString(a)?void 0:a,defaultValueSource:a};t.push(...m(c)),this.d[c]=M,this.b.properties[c]=M}else{this.a.set(c,{value:s[c],source:a});const o=this.d[c];o&&(this.w(c,o),this.r(c,o))}this.m(t)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:t,source:s}of n)for(const a in t){const c=this.a.get(a),o=D.isString(s)?s:s?.id,u=D.isString(c?.source)?c?.source:c?.source?.id;if(o===u)if(r.add(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const S=this.d[a];S&&(this.w(a,S),this.r(a,S))}}this.u()}deltaConfiguration(n){let r=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,t){n.forEach(s=>{this.p(s,r,s.extensionInfo,s.restrictedProperties,void 0,t),this.c.push(s),this.q(s)})}o(n,r){const t=s=>{if(s.properties)for(const a in s.properties){r.add(a);const c=this.d[a];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[a],this.s(a,s.properties[a])}s.allOf?.forEach(a=>t(a))};for(const s of n){t(s);const a=this.c.indexOf(s);a!==-1&&this.c.splice(a,1)}}p(n,r=!0,t,s,a=3,c){a=D.isUndefinedOrNull(n.scope)?a:n.scope;const o=n.properties;if(o)for(const S in o){const E=o[S];if(r&&p(S,E)){delete o[S];continue}if(E.source=t,E.defaultDefaultValue=o[S].default,this.w(S,E),e.OVERRIDE_PROPERTY_REGEX.test(S)?E.scope=void 0:(E.scope=D.isUndefinedOrNull(E.scope)?a:E.scope,E.restricted=D.isUndefinedOrNull(E.restricted)?!!s?.includes(S):E.restricted),o[S].hasOwnProperty("included")&&!o[S].included){this.f[S]=o[S],delete o[S];continue}else this.d[S]=o[S],o[S].policy?.name&&this.e.set(o[S].policy.name,S);!o[S].deprecationMessage&&o[S].markdownDeprecationMessage&&(o[S].deprecationMessage=o[S].markdownDeprecationMessage),c.add(S)}const u=n.allOf;if(u)for(const S of u)this.p(S,r,t,s,a,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=t=>{const s=t.properties;if(s)for(const c in s)this.r(c,s[c]);t.allOf?.forEach(r)};r(n)}r(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}}v(){const n={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}w(n,r){const t=this.a.get(n);let s=t?.value,a=t?.source;D.isUndefined(s)&&(s=r.defaultDefaultValue,a=void 0),D.isUndefined(s)&&(s=l(r.type)),r.default=s,r.defaultValueSource=a}}const y="\\[([^\\]]+)\\]",h=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function m(d){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(d)){let r=h.exec(d);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=h.exec(d)}}return(0,k.distinct)(n)}e.overrideIdentifiersFromKey=m;function g(d){return d.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=g;function l(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const f=new w;P.Registry.add(e.Extensions.Configuration,f);function p(d,n){return d.trim()?e.OVERRIDE_PROPERTY_REGEX.test(d)?A.localize(7,null,d):f.getConfigurationProperties()[d]!==void 0?A.localize(8,null,d):n.policy?.name&&f.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(9,null,d,n.policy?.name,f.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(6,null)}e.validateProperty=p;function v(){const d=[],n=f.getConfigurationProperties();for(const r of Object.keys(n))d.push([r,n[r].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.getScopes=v}),define(oe[74],ae([0,1,20,3,35,2,37,32,13,7,16,46,40]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(r={},t=[],s=[],a){this.c=r,this.d=t,this.f=s,this.raw=a,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof y)return t;const s=new h("");return s.parseRaw(t),s.configurationModel});this.g=r.reduce((t,s)=>s===t?s:t.merge(s),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,I.getConfigurationValue)(this.contents,r):this.contents}inspect(r,t){const s=this.rawConfiguration.getValue(r),a=t?this.rawConfiguration.getOverrideValue(r,t):void 0,c=t?this.rawConfiguration.override(t).getValue(r):s;return{value:s,override:a,merged:c}}getOverrideValue(r,t){const s=this.l(t);return s?r?(0,I.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const s of this.overrides)s.identifiers.includes(r)&&t.push(...s.keys);return k.distinct(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return k.distinct(r)}override(r){let t=this.b.get(r);return t||(t=this.h(r),this.b.set(r,t)),t}merge(...r){const t=R.deepClone(this.contents),s=R.deepClone(this.overrides),a=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const o of r)if(c.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.j(t,o.contents);for(const u of o.overrides){const[S]=s.filter(E=>k.equals(E.identifiers,u.identifiers));S?(this.j(S.contents,u.contents),S.keys.push(...u.keys),S.keys=k.distinct(S.keys)):s.push(R.deepClone(u))}for(const u of o.keys)a.indexOf(u)===-1&&a.push(u)}return new y(t,a,s,c.every(o=>o instanceof y)?void 0:c)}freeze(){return this.a=!0,this}h(r){const t=this.l(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const s={};for(const a of k.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[a];const o=t[a];o&&(typeof c=="object"&&typeof o=="object"?(c=R.deepClone(c),this.j(c,o)):c=o),s[a]=c}return new y(s,this.keys,this.overrides)}j(r,t){for(const s of Object.keys(t)){if(s in r&&P.isObject(r[s])&&P.isObject(t[s])){this.j(r[s],t[s]);continue}r[s]=R.deepClone(t[s])}}k(r){return this.a&&!Object.isFrozen(r)?R.deepFreeze(r):r}l(r){let t=null,s=null;const a=c=>{c&&(s?this.j(s,c):s=R.deepClone(c))};for(const c of this.overrides)k.equals(c.identifiers,[r])?t=c.contents:c.identifiers.includes(r)&&a(c.contents);return a(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,t){this.m(r),(0,I.addToValueTree)(this.contents,r,t,s=>{throw new Error(s)})}removeValue(r){this.n(r)&&(0,I.removeFromValueTree)(this.contents,r)}m(r){let t=this.keys.length;for(let s=0;s<t;s++)r.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,r)}n(r){const t=this.keys.indexOf(r);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=y;class h{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!P.isUndefinedOrNull(r)){const s=this.g(r);this.parseRaw(s,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:s,keys:a,overrides:c,restricted:o,hasExcludedProperties:u}=this.h(r,t);this.b=new y(s,a,c,u?[r]:void 0),this.c=o||[]}g(r){let t={},s=null,a=[];const c=[],o=[];function u(E){Array.isArray(a)?a.push(E):s!==null&&(a[s]=E)}const S={onObjectBegin:()=>{const E={};u(E),c.push(a),a=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const E=[];u(E),c.push(a),a=E,s=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:u,onError:(E,M,N)=>{o.push({error:E,offset:M,length:N})}};if(r)try{D.visit(r,S),t=a[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return t}h(r,t){const s=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),a=this.j(r,s,!0,t);r=a.raw;const c=(0,I.toValuesTree)(r,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),o=Object.keys(r),u=this.l(r,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:c,keys:o,overrides:u,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}j(r,t,s,a){let c=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const o={},u=[];for(const S in r)if(C.OVERRIDE_PROPERTY_REGEX.test(S)&&s){const E=this.j(r[S],t,!1,a);o[S]=E.raw,c=c||E.hasExcludedProperties,u.push(...E.restricted)}else{const E=t[S],M=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&u.push(S),(M===void 0||a.scopes===void 0||a.scopes.includes(M))&&!(a.skipRestricted&&E?.restricted)?o[S]=r[S]:c=!0}return{raw:o,restricted:u,hasExcludedProperties:c}}l(r,t){const s=[];for(const a of Object.keys(r))if(C.OVERRIDE_PROPERTY_REGEX.test(a)){const c={};for(const o in r[a])c[o]=r[a][o];s.push({identifiers:(0,C.overrideIdentifiersFromKey)(a),keys:Object.keys(c),contents:(0,I.toValuesTree)(c,t)})}return s}}e.ConfigurationModelParser=h;class m extends A.Disposable{constructor(r,t,s,a){super(),this.f=r,this.g=t,this.h=a,this.c=this.B(new i.Emitter),this.onDidChange=this.c.event,this.a=new h(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(i.Event.any(i.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),i.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=m;class g{constructor(r,t,s,a,c,o,u,S,E,M,N,j,$){this.a=r,this.b=t,this.value=s,this.overrideIdentifiers=a,this.c=c,this.d=o,this.f=u,this.g=S,this.h=E,this.j=M,this.k=N,this.l=j,this.m=$}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(r,t,s,a,c=new y,o=new y,u=new T.ResourceMap,S=new y,E=new T.ResourceMap,M=!0){this.c=r,this.d=t,this.f=s,this.g=a,this.h=c,this.j=o,this.l=u,this.m=S,this.n=E,this.p=M,this.a=null,this.b=new T.ResourceMap,this.q=null}getValue(r,t,s){return this.s(r,t,s).getValue(r)}updateValue(r,t,s={}){let a;s.resource?(a=this.n.get(s.resource),a||(a=new y,this.n.set(s.resource,a))):a=this.m,t===void 0?a.removeValue(r):a.setValue(r,t),s.resource||(this.a=null)}inspect(r,t,s){const a=this.s(r,t,s),c=this.w(t.resource,s),o=t.resource?this.n.get(t.resource)||this.m:this.m,u=new Set;for(const S of a.overrides)for(const E of S.identifiers)a.getOverrideValue(r,E)!==void 0&&u.add(E);return new g(r,t,a.getValue(r),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),s?this.j.freeze():void 0,c?c.freeze():void 0,o.inspect(r,t.overrideIdentifier))}keys(r){const t=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.l.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const s=[];if(!t){const{added:a,updated:c,removed:o}=v(this.c,r);t=[...a,...c,...o]}for(const a of t)for(const c of(0,C.overrideIdentifiersFromKey)(a)){const o=this.c.getKeysForOverrideIdentifier(c),u=r.getKeysForOverrideIdentifier(c),S=[...u.filter(E=>o.indexOf(E)===-1),...o.filter(E=>u.indexOf(E)===-1),...o.filter(E=>!R.equals(this.c.override(c).getValue(E),r.override(c).getValue(E)))];s.push([c,S])}return this.updateDefaultConfiguration(r),{keys:t,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:s,removed:a}=v(this.d,r),c=[...t,...s,...a];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:s,removed:a,overrides:c}=v(this.applicationConfiguration,r),o=[...t,...s,...a];return o.length&&this.updateApplicationConfiguration(r),{keys:o,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:s,removed:a,overrides:c}=v(this.localUserConfiguration,r),o=[...t,...s,...a];return o.length&&this.updateLocalUserConfiguration(r),{keys:o,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:s,removed:a,overrides:c}=v(this.remoteUserConfiguration,r),o=[...t,...s,...a];return o.length&&this.updateRemoteUserConfiguration(r),{keys:o,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:s,removed:a,overrides:c}=v(this.workspaceConfiguration,r),o=[...t,...s,...a];return o.length&&this.updateWorkspaceConfiguration(r),{keys:o,overrides:c}}compareAndUpdateFolderConfiguration(r,t){const s=this.r.get(r),{added:a,updated:c,removed:o,overrides:u}=v(s,t),S=[...a,...c,...o];return(S.length||!s)&&this.updateFolderConfiguration(r,t),{keys:S,overrides:u}}compareAndDeleteFolderConfiguration(r){const t=this.r.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:a,removed:c,overrides:o}=v(t,void 0);return{keys:[...s,...a,...c],overrides:o}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,t,s){let a=this.t(t,s);return t.overrideIdentifier&&(a=a.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(a=a.merge(this.d)),a}t({resource:r},t){let s=this.u();if(t&&r){const a=t.getFolder(r);a&&(s=this.v(a.uri)||s);const c=this.n.get(r);c&&(s=s.merge(c))}return s}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let t=this.b.get(r);if(!t){const s=this.u(),a=this.l.get(r);a?(t=s.merge(a),this.p&&(t=t.freeze()),this.b.set(r,t)):t=s}return t}w(r,t){if(t&&r){const s=t.getFolder(r);if(s)return this.l.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,t)=>{const{contents:s,overrides:a,keys:c}=this.l.get(t);return r.push([t,{contents:s,overrides:a,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(t=>r.add(t)),this.userConfiguration.freeze().keys.forEach(t=>r.add(t)),this.j.freeze().keys.forEach(t=>r.add(t)),this.l.forEach(t=>t.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.l.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}y(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s)),this.j.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s)),this.l.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(a=>t.add(a))),[...t.values()]}static parse(r){const t=this.z(r.defaults),s=this.z(r.policy),a=this.z(r.application),c=this.z(r.user),o=this.z(r.workspace),u=r.folders.reduce((S,E)=>(S.set(b.URI.revive(E[0]),this.z(E[1])),S),new T.ResourceMap);return new l(t,s,a,c,new y,o,u,new y,new T.ResourceMap,!1)}static z(r){return new y(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=l;function f(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,t=new Map;for(const a of n)a.keys.forEach(c=>r.add(c)),a.overrides.forEach(([c,o])=>{const u=(0,T.getOrSet)(t,c,new Set);o.forEach(S=>u.add(S))});const s=[];return t.forEach((a,c)=>s.push([c,[...a.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=f;class p{constructor(r,t,s,a){this.change=r,this.f=t,this.g=s,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const o of c)this.affectedKeys.add(o);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=l.parse(this.f.data)),this.j}affectsConfiguration(r,t){const s=this.a+r,a=this.d.indexOf(s);if(a<0)return!1;const c=a+s.length;if(c>=this.d.length)return!1;const o=this.d.charCodeAt(c);if(o!==this.b&&o!==this.c)return!1;if(t){const u=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.f?.workspace):void 0,S=this.g.getValue(r,t,this.h);return!R.equals(u,S)}return!0}}e.ConfigurationChangeEvent=p;function v(n,r){const{added:t,removed:s,updated:a}=d(r?.rawConfiguration,n?.rawConfiguration),c=[],o=n?.getAllOverrideIdentifiers()||[],u=r?.getAllOverrideIdentifiers()||[];if(r){const S=u.filter(E=>!o.includes(E));for(const E of S)c.push([E,r.getKeysForOverrideIdentifier(E)])}if(n){const S=o.filter(E=>!u.includes(E));for(const E of S)c.push([E,n.getKeysForOverrideIdentifier(E)])}if(r&&n){for(const S of o)if(u.includes(S)){const E=d({contents:n.getOverrideValue(void 0,S)||{},keys:n.getKeysForOverrideIdentifier(S)},{contents:r.getOverrideValue(void 0,S)||{},keys:r.getKeysForOverrideIdentifier(S)});c.push([S,[...E.added,...E.removed,...E.updated]])}}return{added:t,removed:s,updated:a,overrides:c}}function d(n,r){const t=n?r?n.keys.filter(c=>r.keys.indexOf(c)===-1):[...n.keys]:[],s=r?n?r.keys.filter(c=>n.keys.indexOf(c)===-1):[...r.keys]:[],a=[];if(n&&r){for(const c of r.keys)if(n.keys.indexOf(c)!==-1){const o=(0,I.getConfigurationValue)(r.contents,c),u=(0,I.getConfigurationValue)(n.contents,c);R.equals(o,u)||a.push(c)}}return{added:t,removed:s,updated:a}}}),define(oe[215],ae([0,1,20,3,2,32,13,16,74,46,8,58,40]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new h(this.f())),this.b}async initialize(){return this.b=void 0,this.B(w.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:p})=>this.c(Array.from(f),p))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(f,p){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:f})}f(){return{}}}e.DefaultConfiguration=y;class h extends P.ConfigurationModel{constructor(f={}){const p=w.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),v=Object.keys(p),d=Object.create(null),n=[];for(const r in p){const t=f[r],s=t!==void 0?t:p[r].default;(0,R.addToValueTree)(d,r,s,a=>console.error(`Conflict in default settings: ${a}`))}for(const r of Object.keys(d))b.OVERRIDE_PROPERTY_REGEX.test(r)&&n.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(d[r]),contents:(0,R.toValuesTree)(d[r],t=>console.error(`Conflict in default settings file: ${t}`))});super(d,v,n)}}e.DefaultConfigurationModel=h;class m{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let g=class extends D.Disposable{get configurationModel(){return this.b}constructor(f,p,v){super(),this.c=f,this.f=p,this.g=v,this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(f=>this.i(f))),this.B(this.c.onDidChangeConfiguration(async({properties:f})=>this.j(await this.h(f),!0))),this.b}async h(f){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",f);const p={},v=[],d=w.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const n of f){const r=d[n];if(!r){v.push(n);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}v.push(n),p[r.policy.name]={type:r.type}}}return(0,T.isEmptyObject)(p)||await this.f.updatePolicyDefinitions(p),v}i(f){this.g.trace("PolicyConfiguration#onDidChangePolicies",f);const p=w.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),v=(0,k.coalesce)(f.map(d=>p.get(d)));this.j(v,!0)}j(f,p){this.g.trace("PolicyConfiguration#update",f);const v=w.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),d=[],n=this.b.isEmpty();for(const r of f){const t=v[r]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(n?s!==void 0:!(0,A.equals)(this.b.getValue(r),s))&&d.push([r,s])}else this.b.getValue(r)!==void 0&&d.push([r,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const r=this.b;this.b=new P.ConfigurationModel;for(const t of r.keys)this.b.setValue(t,r.getValue(t));for(const[t,s]of d)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);p&&this.a.fire(this.b)}}};g=pe([Y(1,C.IPolicyService),Y(2,I.ILogService)],g),e.PolicyConfiguration=g}),define(oe[216],ae([0,1,6,3,2,23,16,74,215,58]),function(Z,e,k,i,D,A,T,R,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends D.Disposable{constructor(w,y,h,m){super(),this.i=w,this.h=this.B(new i.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new P.DefaultConfiguration),this.c=h instanceof b.NullPolicyService?new P.NullPolicyConfiguration:this.B(new P.PolicyConfiguration(this.b,h,m)),this.f=this.B(new R.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,y)),this.a=new R.Configuration(this.b.configurationModel,this.c.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.g=this.B(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:g,properties:l})=>this.k(g,l))),this.B(this.c.onDidChangeConfiguration(g=>this.l(g))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[w,y,h]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.Configuration(w,y,new R.ConfigurationModel,h)}getConfigurationData(){return this.a.toData()}getValue(w,y){const h=typeof w=="string"?w:void 0,m=(0,T.isConfigurationOverrides)(w)?w:(0,T.isConfigurationOverrides)(y)?y:{};return this.a.getValue(h,m,void 0)}updateValue(w,y,h,m){return Promise.reject(new Error("not supported"))}inspect(w){return this.a.inspect(w,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const w=await this.f.loadConfiguration();this.j(w)}j(w){const y=this.a.toData(),h=this.a.compareAndUpdateLocalUserConfiguration(w);this.m(h,y,2)}k(w,y){const h=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(w,y);this.m(m,h,7)}l(w){const y=this.a.toData(),h=this.a.compareAndUpdatePolicyConfiguration(w);this.m(h,y,7)}m(w,y,h){const m=new R.ConfigurationChangeEvent(w,{data:y},this.a);m.source=h,m.sourceConfig=this.n(h),this.h.fire(m)}n(w){switch(w){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(oe[217],ae([0,1,9,4]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var D;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends k.ErrorNoTelemetry{static isNotAvailable(R){return R instanceof A&&R._code===D.NotAvailable}static isTemporarilyNotAvailable(R){return R instanceof A&&R._code===D.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof A&&R._code===D.NoResolverFound}static isHandled(R){return R instanceof A&&R.isHandled}constructor(R,P=D.Unknown,b){super(R),this._message=R,this._code=P,this._detail=b,this.isHandled=P===D.NotAvailable&&b===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(oe[75],ae([0,1,22]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(b){return b.scheme===k.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=i;function D(b){if(!b)return;const I=b.indexOf("+");return I<0?b:b.substr(0,I)}e.getRemoteName=D;function A(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.getRemoteServerRootPath=A;function T(b){const{host:I,port:C}=P(b);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:C}}e.parseAuthorityWithPort=T;function R(b,I){let{host:C,port:w}=P(b);return typeof w>"u"&&(w=I),{host:C,port:w}}e.parseAuthorityWithOptionalPort=R;function P(b){const I=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const C=b.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const w=b.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:b,port:void 0}}}),define(oe[42],ae([0,1,27,4,75]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=A;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var P;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class b{constructor(m){this.value=m,this.c=m.toLowerCase()}static equals(m,g){if(typeof m>"u"||m===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof m=="string"||typeof g=="string"){const l=typeof m=="string"?m:m.value,f=typeof g=="string"?g:g.value;return k.equalsIgnoreCase(l,f)}return m.c===g.c}static toKey(m){return typeof m=="string"?m.toLowerCase():m.c}}e.ExtensionIdentifier=b;function I(h){return C(h)}e.isApplicationScopedExtension=I;function C(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function w(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function y(h,m){if(m){const g=`onResolveRemoteAuthority:${(0,D.getRemoteName)(m)}`;return h.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[218],ae([0,1,2,12,28,42]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends k.Disposable{constructor(P,b){super(),this.b=P,this.a=(0,i.join)(this.b.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this.B(b.onDidInstallExtensions(I=>this.c(I))),this.B(b.onDidUninstallExtension(I=>this.f(I)))}c(P){P.some(b=>!!b.local)&&this.invalidate()}f(P){P.error||this.invalidate()}invalidate(){D.Promises.rm(this.a,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(oe[219],ae([0,1,6,17,24,9,3,2,31,92,217,75]),function(Z,e,k,i,D,A,T,R,P,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const w=30*1e3;var y;(function(O){O[O.Management=1]="Management",O[O.ExtensionHost=2]="ExtensionHost",O[O.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function h(O){switch(O){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function m(O){const U=new D.CancellationTokenSource;return setTimeout(()=>U.cancel(),O),U.token}function g(O,U){if(O.isCancellationRequested||U.isCancellationRequested)return D.CancellationToken.Cancelled;const q=new D.CancellationTokenSource;return O.onCancellationRequested(()=>q.cancel()),U.onCancellationRequested(()=>q.cancel()),q.token}class l{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new R.DisposableStore,this.promise=new Promise((q,B)=>{this.f=q,this.g=B}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function f(O,U){const q=new l(U);return q.registerDisposable(O.onControlMessage(B=>{const X=JSON.parse(B.toString()),ee=V(X);ee?q.reject(ee):q.resolve(X)})),q.promise}function p(O,U,q,B,X,ee,J,_){const re=new l(_);return U.connect(q,B,X,ee,J,(ue,le)=>{re.didTimeout?(ue&&O.error(ue),le?.dispose()):ue||!le?re.reject(ue):re.resolve(le)}),re.promise}function v(O,U){const q=new l(U);return O.then(B=>{q.didTimeout||q.resolve(B)},B=>{q.didTimeout||q.reject(B)}),q.promise}async function d(O,U,q,B){const X=se(O,U);O.logService.trace(`${X} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await p(O.logService,O.socketFactory,O.host,O.port,(0,C.getRemoteServerRootPath)(O),`reconnectionToken=${O.reconnectionToken}&reconnection=${O.reconnectionProtocol?"true":"false"}`,`renderer-${h(U)}-${O.reconnectionToken}`,B)}catch(le){throw O.logService.error(`${X} socketFactory.connect() failed or timed out. Error:`),O.logService.error(le),le}O.logService.trace(`${X} 2/6. socketFactory.connect() was successful.`);let J,_;O.reconnectionProtocol?(O.reconnectionProtocol.beginAcceptReconnection(ee,null),J=O.reconnectionProtocol,_=!1):(J=new b.PersistentProtocol({socket:ee,measureRoundTripTime:!0}),_=!0),O.logService.trace(`${X} 3/6. sending AuthRequest control message.`);const re=await v(O.signService.createNewMessage((0,P.generateUuid)()),B),ue={type:"auth",auth:O.connectionToken||"00000000000000000000",data:re.data};J.sendControl(i.VSBuffer.fromString(JSON.stringify(ue)));try{const le=await f(J,g(B,m(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(O.logService.trace(`${X} 4/6. received SignRequest control message.`),!await v(O.signService.validate(re,le.signedData),B)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const Se=await v(O.signService.sign(le.data),B),be={type:"connectionType",commit:O.commit,signedData:Se,desiredConnectionType:U};return q&&(be.args=q),O.logService.trace(`${X} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(i.VSBuffer.fromString(JSON.stringify(be))),{protocol:J,ownsProtocol:_}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(O.logService.error(`${X} the handshake timed out. Error:`),O.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(O.logService.error(`${X} received error control message when negotiating connection. Error:`),O.logService.error(le)),_&&K(J),le}}async function n(O,U,q,B){const X=Date.now(),ee=se(O,U),{protocol:J,ownsProtocol:_}=await d(O,U,q,B),re=new l(B);return re.registerDisposable(J.onControlMessage(ue=>{const le=JSON.parse(ue.toString()),ye=V(le);ye?(O.logService.error(`${ee} received error control message when negotiating connection. Error:`),O.logService.error(ye),_&&K(J),re.reject(ye)):(O.reconnectionProtocol?.endAcceptReconnection(),O.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${ie(X)}!`),re.resolve({protocol:J,firstMessage:le}))})),re.promise}async function r(O,U){const{protocol:q}=await n(O,1,void 0,U);return{protocol:q}}async function t(O,U,q){const{protocol:B,firstMessage:X}=await n(O,2,U,q),ee=X&&X.debugPort;return{protocol:B,debugPort:ee}}async function s(O,U,q){const B=Date.now(),X=se(O,3),{protocol:ee}=await d(O,3,U,q);return O.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${ie(B)}!`),ee}async function a(O,U,q){const{host:B,port:X,connectionToken:ee}=await O.addressProvider.getAddress();return{commit:O.commit,quality:O.quality,host:B,port:X,connectionToken:ee,reconnectionToken:U,reconnectionProtocol:q,socketFactory:O.socketFactory,signService:O.signService,logService:O.logService}}async function c(O,U,q){return u(O,async B=>{const{protocol:X}=await r(B,D.CancellationToken.None);return new H(O,U,q,B.reconnectionToken,X)})}e.connectRemoteAgentManagement=c;async function o(O,U){return u(O,async q=>{const{protocol:B,debugPort:X}=await t(q,U,D.CancellationToken.None);return new Q(O,U,q.reconnectionToken,B,X)})}e.connectRemoteAgentExtensionHost=o;async function u(O,U){for(let B=1;;B++)try{const X=(0,P.generateUuid)(),ee=await a(O,X,null);return await U(ee)}catch(X){if(B<5)O.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),O.logService.error(X);else throw O.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),O.logService.error(X),W.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(X)),X}}async function S(O,U,q){const B=await a(O,(0,P.generateUuid)(),null);return await s(B,{host:U,port:q},D.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function E(O){return(0,k.createCancelablePromise)(U=>new Promise((q,B)=>{const X=setTimeout(q,O*1e3);U.onCancellationRequested(()=>{clearTimeout(X),q()})}))}var M;(function(O){O[O.ConnectionLost=0]="ConnectionLost",O[O.ReconnectionWait=1]="ReconnectionWait",O[O.ReconnectionRunning=2]="ReconnectionRunning",O[O.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",O[O.ConnectionGain=4]="ConnectionGain",O[O.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(M=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class N{constructor(U,q){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.type=0}}e.ConnectionLostEvent=N;class j{constructor(U,q,B,X){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.durationSeconds=B,this.c=X,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=j;class ${constructor(U,q,B){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=$;class L{constructor(U,q,B){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=B,this.type=4}}e.ConnectionGainEvent=L;class F{constructor(U,q){this.reconnectionToken=U,this.connectionHealth=q,this.type=5}}e.ConnectionHealthChangedEvent=F;class z{constructor(U,q,B,X){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=B,this.handled=X,this.type=3}}e.ReconnectionPermanentFailureEvent=z;class W extends R.Disposable{static triggerPermanentFailure(U,q,B){this._permanentFailure=!0,this.f=U,this.g=q,this.h=B,this.i.forEach(X=>X.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(U=>U.r())}static debugPauseSocketWriting(){this.i.forEach(U=>U.v())}get k(){return this.c||W._permanentFailure}constructor(U,q,B,X,ee){super(),this.m=U,this.n=q,this.reconnectionToken=B,this.protocol=X,this.p=ee,this.j=this.B(new T.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new L(this.reconnectionToken,0,0)),this.B(X.onSocketClose(J=>{const _=ne(this.m,this.reconnectionToken,!0);J?J.type===0?(this.n.logService.info(`${_} received socket close event (hadError: ${J.hadError}).`),J.error&&this.n.logService.error(J.error)):(this.n.logService.info(`${_} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.n.logService.error(J.event)):this.n.logService.info(`${_} received socket close event.`),this.r()})),this.B(X.onSocketTimeout(J=>{const _=ne(this.m,this.reconnectionToken,!0);this.n.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(X.onHighRoundTripTime(J=>{const _=x(this.m,this.reconnectionToken);this.n.logService.info(`${_} high roundtrip time: ${J.roundTripTime}ms (${J.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(X.onDidChangeConnectionHealth(J=>{this.j.fire(new F(this.reconnectionToken,J))})),W.i.push(this),this.B((0,R.toDisposable)(()=>{const J=W.i.indexOf(this);J>=0&&W.i.splice(J,1)})),this.k&&this.u(W.f,W.g,W.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const U=ne(this.m,this.reconnectionToken,!0);this.n.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const q=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const X=B<q.length?q[B]:q[q.length-1];try{if(X>0){const J=E(X);this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X,J)),this.n.logService.info(`${U} waiting for ${X} seconds before reconnecting...`);try{await J}catch{}}if(this.k){this.n.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.n.logService.info(`${U} resolving connection...`);const ee=await a(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${U} connecting to ${ee.host}:${ee.port}...`),await this.w(ee,m(w)),this.n.logService.info(`${U} reconnected!`),this.j.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(ee),this.t(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.n.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(ee),this.t(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ee)){this.n.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this.n.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(ee);continue}if((0,A.isCancellationError)(ee)){this.n.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(ee);continue}if(ee instanceof I.RemoteAuthorityResolverError){this.n.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(ee),this.t(this.protocol.getMillisSinceLastIncomingData(),B+1,I.RemoteAuthorityResolverError.isHandled(ee));break}this.n.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(ee),this.t(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.k)}t(U,q,B){this.p?W.triggerPermanentFailure(U,q,B):this.u(U,q,B)}u(U,q,B){this.j.fire(new z(this.reconnectionToken,U,q,B)),K(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=W,W._permanentFailure=!1,W.f=0,W.g=0,W.h=!1,W.i=[];class H extends W{constructor(U,q,B,X,ee){super(1,U,X,ee,!0),this.client=this.B(new b.Client(ee,{remoteAuthority:q,clientId:B},U.ipcLogger))}async w(U,q){await r(U,q)}}e.ManagementPersistentConnection=H;class Q extends W{constructor(U,q,B,X,ee){super(2,U,B,X,!1),this.y=q,this.debugPort=ee}async w(U,q){await t(U,this.y,q)}}e.ExtensionHostPersistentConnection=Q;function K(O){try{O.acceptDisconnect();const U=O.getSocket();O.dispose(),U.dispose()}catch(U){(0,A.onUnexpectedError)(U)}}function V(O){if(O&&O.type==="error"){const U=new Error(`Connection error: ${O.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function G(O,U){for(;O.length<U;)O+=" ";return O}function x(O,U){return`[remote-connection][${G(h(O),13)}][${U.substr(0,5)}\u2026]`}function ne(O,U,q){return`${x(O,U)}[${q?"reconnect":"initial"}]`}function se(O,U){return`${ne(U,O.reconnectionToken,!!O.reconnectionProtocol)}[${O.host}:${O.port}]`}function ie(O){return`${Date.now()-O} ms`}}),define(oe[220],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[221],ae([0,1,86,150]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,A,T,R,P,b){const I=w=>b(w,void 0),C=k.createConnection({host:D,port:A},()=>{C.removeListener("error",I);const w=Buffer.alloc(16);for(let g=0;g<16;g++)w[g]=Math.round(Math.random()*256);const y=w.toString("base64"),h=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${A}${T}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];C.write(h.join(`\r
`)+`\r
\r
`);const m=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",m),b(void 0,new i.NodeSocket(C,P)))};C.on("data",m)});C.setNoDelay(!0),C.once("error",I)}}}),define(oe[105],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService");var i;(function(D){D.disconnected={type:"disconnected"},D.uninitialized={type:"uninitialized"},D.connected=A=>({type:"connected",info:A}),D.connecting=A=>({type:"connecting",progress:A})})(i=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME="remoteTunnelService",e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(oe[222],ae([0,1,133,16,8]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(R,P){this.a=R,this.b=P}async request(R,P){this.b.trace("RequestService#request (browser) - begin",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const b=await(0,k.request)(R,P);return this.b.trace("RequestService#request (browser) - success",R.url),b}catch(b){throw this.b.error("RequestService#request (browser) - error",R.url,b),b}}async resolveProxy(R){}};A=pe([Y(0,i.IConfigurationService),Y(1,D.ILogService)],A),e.RequestService=A}),define(oe[59],ae([0,1,17,169,46,4,40]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function R(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.isSuccess=R;function P(m){return m.res.statusCode===204}async function b(m){return P(m)?null:(await(0,k.streamToBuffer)(m.stream)).toString()}e.asText=b;async function I(m){if(!R(m))throw new Error("Server returned "+m.res.statusCode);return b(m)}e.asTextOrError=I;async function C(m){if(!R(m))throw new Error("Server returned "+m.res.statusCode);if(P(m))return null;const l=(await(0,k.streamToBuffer)(m.stream)).toString();try{return JSON.parse(l)}catch(f){throw f.message+=`:
`+l,f}}e.asJson=C;function w(m){h(m)}e.updateProxyConfigurationsScope=w;let y;function h(m){const g=T.Registry.as(D.Extensions.Configuration),l=y;y={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[y],remove:l?[l]:[]})}h(2)}),define(oe[223],ae([0,1,24,22,14,59]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(P,b){this.a=P,this.b=b}async download(P,b,I=k.CancellationToken.None){if(P.scheme===i.Schemas.file||P.scheme===i.Schemas.vscodeRemote){await this.b.copy(P,b);return}const C={type:"GET",url:P.toString(!0)},w=await this.a.request(C,I);if(w.res.statusCode===200)await this.b.writeFile(b,w.stream);else{const y=await(0,A.asTextOrError)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${y}`)}}};T=pe([Y(0,A.IRequestService),Y(1,D.IFileService)],T),e.DownloadService=T}),define(oe[224],ae([0,1,17,24]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(R){this.a=R}listen(R,P){throw new Error("Invalid listen")}call(R,P,b,I=i.CancellationToken.None){switch(P){case"request":return this.a.request(b[0],I).then(async({res:C,stream:w})=>{const y=await(0,k.streamToBuffer)(w);return[{statusCode:C.statusCode,headers:C.headers},y]});case"resolveProxy":return this.a.resolveProxy(b[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class A{constructor(R){this.a=R}async request(R,P){const[b,I]=await this.a.call("request",[R],P);return{res:b,stream:(0,k.bufferToStream)(I)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.RequestChannelClient=A}),define(oe[225],ae([0,1,13,222,224]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class A{constructor(R,P,b,I){this.c=P,this.d=b,this.e=I,this.a=new i.RequestService(P,I),this.b=new D.RequestChannelClient(R.getChannel("request"))}request(R,P){return this.f().request(R,P)}async resolveProxy(R){return this.f().resolveProxy(R)}f(){return this.g()?(this.e.trace("Using main request service"),this.b):(this.e.trace("Using browser request service"),this.a)}g(){const R=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,k.isBoolean)(R)?R:this.d.quality!=="stable"}}e.SharedProcessRequestService=A}),define(oe[106],ae([0,1,66,4]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(A){return(0,k.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(oe[226],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(oe[227],ae([0,1,93,6,24,3,2,22,31,8,106,226]),function(Z,e,k,i,D,A,T,R,P,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let w=class{constructor(m){this.d=m,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(m){const g=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${g})`);const l=(0,I.hash)(m);this.b.has(l)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${g})`),this.f(m));const f=new D.CancellationTokenSource;let p,v,d;this.b.set(l,s=>{f.dispose(!0),p?.terminate(m,D.CancellationToken.None),v?.close(),d?.close(),this.b.delete(l);const a=this.c.get(l);a&&(this.c.delete(l),a({reason:s}))}),p=await this.e(m);const n=new Promise(s=>{this.c.set(l,s)});if(f.token.isCancellationRequested)return n;const{port1:r,port2:t}=new MessageChannel;return v=r,d=t,await p.spawn(m,d,f.token),f.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${g})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",m,[v])),n}e(m){let g=this.a.get(m.process.moduleId);if(!g){this.d.trace(`SharedProcess: creating new web worker (${m.process.moduleId})`);const l=new y(m.process.type,this.d);g=l.init(),l.onDidProcessSelfTerminate(({configuration:f,reason:p})=>{this.f(f,p)}),this.a.set(m.process.moduleId,g)}return g}async disposeWorker(m){return this.f(m)}f(m,g){const l=this.b.get((0,I.hash)(m));l&&(this.d.trace(`SharedProcess: disposeWorker (window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),l(g))}};w=pe([Y(0,b.ILogService)],w),e.SharedProcessWorkerService=w;class y extends T.Disposable{constructor(m,g){super(),this.f=m,this.g=g,this.a=this.B(new A.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const m=new i.DeferredPromise,g=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return g.onerror=l=>{this.g.error(`SharedProcess: worker error (${this.f})`,l.message)},g.onmessageerror=l=>{this.g.error(`SharedProcess: worker message error (${this.f})`,l)},g.onmessage=l=>{const{id:f,message:p,configuration:v,nonce:d}=l.data;switch(f){case C.SharedProcessWorkerMessages.Ready:m.complete(g);break;case C.SharedProcessWorkerMessages.Ack:if(d){const n=this.c.get(d);n&&(this.c.delete(d),n())}break;case C.SharedProcessWorkerMessages.SelfTerminated:v&&p&&this.a.fire({configuration:v,reason:JSON.parse(p)});break;case C.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,p);break;case C.SharedProcessWorkerMessages.Info:p&&this.g.info(p);break;case C.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,p);break;case C.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,p);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,l)}},g.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),m.p}async i(m,g,l){const f=await this.b;if(!g.isCancellationRequested)return new Promise(p=>{const v=(0,P.generateUuid)();this.c.set(v,p);const d={...m,nonce:v};l?f.postMessage(d,[l]):f.postMessage(d),g.onCancellationRequested(()=>{this.c.delete(v)&&p()})})}spawn(m,g,l){const f={id:C.SharedProcessWorkerMessages.Spawn,configuration:m,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(f,l,g)}terminate(m,g){const l={id:C.SharedProcessWorkerMessages.Terminate,configuration:m};return this.i(l,g)}}}),define(oe[228],ae([0,1,63,22,186]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}pe([k.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(oe[229],ae([0,1,50,12,170,24,38,9,5,31,147,184,6,128]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let h;async function m(l,f,p,v){return p["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(v)&&!p["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(v)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=w.Promises.withAsyncBody(async(d,n)=>{const r=new A.CancellationTokenSource;let t=1e4;const s=l.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(t=(0,y.clamp)(s,1,120)*1e3);const a=setTimeout(()=>{r.dispose(!0),n(new Error((0,D.localize)(0,null)))},t);try{d(await g(f,r.token))}catch(c){!(0,R.isCancellationError)(c)&&!r.token.isCancellationRequested?n(new Error((0,D.localize)(1,null,(0,T.toErrorMessage)(c)))):d({})}finally{clearTimeout(a),r.dispose()}})),h)}e.getResolvedShellEnv=m;async function g(l,f){const p=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",p);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",v);const d=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(d+"({.*})"+d),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",r);const t=await(0,I.getSystemShell)(P.OS,r);return l.trace("getUnixShellEnvironment#shell",t),new Promise((s,a)=>{if(f.isCancellationRequested)return a(new R.CancellationError);const c=(0,i.basename)(t);let o,u;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(o=`& '${process.execPath}' ${S} -p '''${d}'' + JSON.stringify(process.env) + ''${d}'''`,u=["-Login","-Command"]):(o=`'${process.execPath}' ${S} -p '"${d}" + JSON.stringify(process.env) + "${d}"'`,c==="tcsh"?u=["-ic"]:u=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),o);const E=(0,k.spawn)(t,[...u,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});f.onCancellationRequested(()=>(E.kill(),a(new R.CancellationError))),E.on("error",j=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(j)),a(j)});const M=[];E.stdout.on("data",j=>M.push(j));const N=[];E.stderr.on("data",j=>N.push(j)),E.on("close",(j,$)=>{const L=Buffer.concat(M).toString("utf8");l.trace("getUnixShellEnvironment#raw",L);const F=Buffer.concat(N).toString("utf8");if(F.trim()&&l.trace("getUnixShellEnvironment#stderr",F),j||$)return a(new Error((0,D.localize)(2,null,j,$)));const z=n.exec(L),W=z?z[1]:"{}";try{const H=JSON.parse(W);p?H.ELECTRON_RUN_AS_NODE=p:delete H.ELECTRON_RUN_AS_NODE,v?H.ELECTRON_NO_ATTACH_CONSOLE=v:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.VSCODE_RESOLVING_ENVIRONMENT,delete H.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",H),s(H)}catch(H){l.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(H)),a(H)}})})}}),define(oe[107],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[230],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.b=new Map}c(){return new Promise((D,A)=>Z(["vsda"],D,A))}async createNewMessage(D){try{const A=await this.c(),T=new A.validator;if(T){const R=String(k.a++);return this.b.set(R,T),{id:R,data:T.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,A){if(!D.id)return!0;const T=this.b.get(D.id);if(!T)return!1;this.b.delete(D.id);try{return T.validate(A)==="ok"}catch{return!1}}async sign(D){try{const A=await this.c(),T=new A.signer;if(T)return T.sign(D)}catch{}return D}}e.SignService=k,k.a=1}),define(oe[76],ae([0,1,3,2]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class D extends i.Disposable{constructor(C,w,y){super(),this.a=C,this.b=w,this.c=y}async getItems(){const C={profile:this.b,workspace:this.c},w=await this.a.call("getItems",C);return new Map(w)}updateItems(C){const w={profile:this.b,workspace:this.c};return C.insert&&(w.insert=Array.from(C.insert.entries())),C.delete&&(w.delete=Array.from(C.delete.values())),this.a.call("updateItems",w)}}class A extends D{constructor(C,w){super(C,w,void 0),this.f=this.B(new k.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(C=>this.h(C)))}h(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this.f.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}}class T extends A{constructor(C){super(C,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class R extends A{constructor(C,w){super(C,w)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class P extends D{constructor(C,w){super(C,void 0,w),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P;class b{constructor(C){this.a=C}isUsed(C){const w={payload:C,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.StorageClient=b}),define(oe[108],ae([0,1,5,36,7,31]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(b){if(k.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function R(b,I,C,w,y,h,m,g,l,f){const p=Object.create(null);p["common.machineId"]=m,p.sessionID=(0,A.generateUuid)()+Date.now(),p.commitHash=y,p.version=h,p["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,k.PlatformToString)(k.platform),p["common.nodePlatform"]=i.platform,p["common.nodeArch"]=w,p["common.product"]=f||"desktop",g&&(p["common.msftInternal"]=g);let v=0;const d=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),k.isLinuxSnap&&(p["common.snap"]="true");const n=T(C);n&&(p["common.platformDetail"]=n);try{const r=await b.readFile(D.URI.file(l));p["common.source"]=r.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=R;function P(b){const I=i.env.USERDNSDOMAIN;if(!I)return!1;const C=I.toLowerCase();return b.some(w=>C===w)}e.verifyMicrosoftInternalDomain=P}),define(oe[21],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(oe[231],ae([0,1,34,6,35,22,12,5,7,144,28,146,95,14,25,21]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const g=new Map;async function l(n,r){const t=`${n}::${r.join(":")}`,s=g.get(t);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,o=new Map,u=2e4;function S(M,N,j,$){const L=N.substring(M.length+1);return i.Promises.withAsyncBody(async F=>{let z;try{z=await I.Promises.readdir(N,{withFileTypes:!0})}catch{F();return}if($.count>=u){$.count+=z.length,$.maxReached=!0,F();return}let W=z.length;if(W===0){F();return}let H=z;$.count+z.length>u&&($.maxReached=!0,W=u-$.count,H=z.slice(0,W)),$.count+=z.length;for(const Q of H)if(Q.isDirectory()){if(j.includes(Q.name)||await S(M,(0,T.join)(N,Q.name),j,$),--W===0){F();return}}else{const K=Q.name.lastIndexOf(".");if(K>=0){const V=Q.name.substring(K+1);V&&c.set(V,(c.get(V)??0)+1)}for(const V of a)V.relativePathPattern?.test(L)!==!1&&V.filePattern.test(Q.name)&&o.set(V.tag,(o.get(V.tag)??0)+1);if(--W===0){F();return}}})}const E=i.Promises.withAsyncBody(async M=>{const N={count:0,maxReached:!1};await S(n,n,r,N);const j=await v(n);M({configFiles:f(o),fileTypes:f(c),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:j})});return g.set(t,E),E}e.collectWorkspaceStats=l;function f(n){return Array.from(n.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function p(){const n={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},r=k.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=p;async function v(n){try{const r=new Map,t=(0,T.join)(n,".vscode","launch.json"),s=await I.Promises.readFile(t),a=[],c=(0,D.parse)(s.toString(),a);if(a.length)return console.log(`Unable to parse ${t}`),[];if((0,D.getNodeType)(c)==="object"&&c.configurations)for(const o of c.configurations){const u=o.type;u&&(r.has(u)?r.set(u,r.get(u)+1):r.set(u,1))}return f(r)}catch{return[]}}e.collectLaunchConfigs=v;let d=class{constructor(r,t){this.c=r,this.d=t}f(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}g(r){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const s=k.cpus();return s&&s.length>0&&t.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),t.push(`Memory (System):  ${(k.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||t.push(`Load (avg):       ${k.loadavg().map(a=>Math.round(a)).join(", ")}`),t.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,C.listProcesses)(r.mainPID),this.k(r)]).then(async s=>{let[a,c]=s,o=this.m(r,a);return t.forEach(u=>{if((0,w.isRemoteDiagnosticError)(u))o+=`
${u.errorMessage}`,c+=`
${u.errorMessage}`;else if(o+=`

Remote: ${u.hostName}`,u.processes&&(o+=`
${this.m(r,u.processes)}`),u.workspaceMetadata){c+=`
|  Remote: ${u.hostName}`;for(const S of Object.keys(u.workspaceMetadata)){const E=u.workspaceMetadata[S];let M=`${E.fileCount} files`;E.maxFilesReached&&(M=`more than ${M}`),c+=`|    Folder (${S}): ${M}`,c+=this.h(E)}}}),{processInfo:o,workspaceInfo:c}})}async getSystemInfo(r,t){const{memory:s,vmHint:a,os:c,cpus:o}=p(),u={os:c,memory:s,cpus:o,vmHint:a,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return R.isWindows||(u.load=`${k.loadavg().map(S=>Math.round(S)).join(", ")}`),R.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(r,t){const s=[];return(0,C.listProcesses)(r.mainPID).then(async a=>(s.push(""),s.push(this.g(r)),s.push(""),s.push(this.m(r,a)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(r))),t.forEach(c=>{if((0,w.isRemoteDiagnosticError)(c))s.push(`
${c.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${c.hostName}`),s.push(this.f(c.machineInfo)),c.processes&&s.push(this.m(r,c.processes)),c.workspaceMetadata)for(const o of Object.keys(c.workspaceMetadata)){const u=c.workspaceMetadata[o];let S=`${u.fileCount} files`;u.maxFilesReached&&(S=`more than ${S}`),s.push(`Folder (${o}): ${S}`),s.push(this.h(u))}}),s.push(""),s.push(""),s.join(`
`)))}h(r){const t=[];let a=0;const c=(E,M)=>{const N=` ${E}(${M})`;a+N.length>60?(t.push(o),o="|                 ",a=o.length):a+=N.length,o+=N};let o="|      File types:";const u=10,S=r.fileTypes.length>u?u:r.fileTypes.length;for(let E=0;E<S;E++){const M=r.fileTypes[E];c(M.name,M.count)}if(t.push(o),r.configFiles.length>=0&&(o="|      Conf files:",a=0,r.configFiles.forEach(E=>{c(E.name,E.count)}),t.push(o)),r.launchConfigFiles.length>0){let E="|      Launch Configs:";r.launchConfigFiles.forEach(M=>{E+=M.count>1?` ${M.name}(${M.count})`:` ${M.name}`}),t.push(E)}return t.join(`
`)}j(r){const t=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(t-s.length)}  ${r[s]}`).join(`
                  `)}k(r){const t=[],s=[];return r.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(t.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const o=P.URI.revive(c);if(o.scheme===A.Schemas.file){const u=o.fsPath;s.push(l(u,["node_modules",".git"]).then(S=>{let E=`${S.fileCount} files`;S.maxFilesReached&&(E=`more than ${E}`),t.push(`|    Folder (${(0,T.basename)(u)}): ${E}`),t.push(this.h(S))}).catch(S=>{t.push(`|      Error: Unable to collect workspace stats for folder ${u} (${S.toString()})`)}))}else t.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>t.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(r,t){const s=new Map;r.windows.forEach(c=>s.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),t&&this.n(r.mainPID,s,a,t,0),a.join(`
`)}n(r,t,s,a,c){const o=c===0;let u;o?u=a.pid===r?`${this.d.applicationName} main`:"remote agent":(u=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(u=`${u} (${t.get(a.pid)})`));const S=process.platform==="win32"?a.mem:k.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(S/y.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(a.children)&&a.children.forEach(E=>this.n(r,t,s,E,c+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:s}of r.folders){const a=P.URI.revive(s);if(a.scheme!==A.Schemas.file)continue;const c=a.fsPath;try{(await l(c,["node_modules",".git"])).fileTypes.forEach(u=>t.add(u.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const s=P.URI.revive(t);if(s.scheme!==A.Schemas.file)continue;const a=s.fsPath;try{const c=await l(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),c.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),c.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};d=pe([Y(0,m.ITelemetryService),Y(1,h.IProductService)],d),e.DiagnosticsService=d}),define(oe[232],ae([0,1,105,3,21,15,2,8,12,50,25,5,6,101,16,168,34,7]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let f=class extends T.Disposable{constructor(v,d,n,r,t,s){super(),this.p=v,this.r=d,this.s=n,this.t=s,this.b=new i.Emitter,this.onDidTokenFailed=this.b.event,this.c=new i.Emitter,this.onDidChangeTunnelStatus=this.c.event,this.f=new i.Emitter,this.onDidChangeAccount=this.f.event,this.j=k.TunnelStates.disconnected;const a=l.URI.file((0,P.join)(n.logsPath,k.LOG_FILE_NAME));this.g=this.B(r.createLogger(a,{name:k.LOGGER_NAME})),this.k=new w.Delayer(100),this.B(this.g.onDidChangeLogLevel(c=>this.g.info("Log level changed to "+(0,R.LogLevelToString)(c)))),this.B(t.onWillShutdown(c=>{this.i&&(this.i.cancel(),this.i=void 0),this.dispose()})),this.B(s.onDidChangeConfiguration(c=>{c.affectsConfiguration(k.CONFIGURATION_KEY_HOST_NAME)&&this.k.trigger(()=>this.v())}))}async getAccount(){return this.h}async updateAccount(v){if(v&&this.h?v.token!==this.h.token||v.providerId!==this.h.providerId:v!==this.h){this.h=v,this.f.fire(v),v?this.g.info(`Account updated: ${v.accountLabel} (${v.providerId})`):this.g.info("Account reset"),this.p.publicLog2("remoteTunnel.enablement",{enabled:!!v});try{await this.k.trigger(()=>this.v())}catch(d){this.g.error(d)}}return this.j}u(){if(!this.n){let v;C.isMacintosh?v=this.s.appRoot:v=(0,P.dirname)((0,P.dirname)(this.s.appRoot)),this.n=(0,P.join)(v,"bin",`${this.r.tunnelApplicationName}${C.isWindows?".exe":""}`)}return this.n}async v(){if(this.i&&(this.i.cancel(),this.i=void 0),!this.h){this.w(k.TunnelStates.disconnected);return}const{token:v,providerId:d,accountLabel:n}=this.h;this.w(k.TunnelStates.connecting((0,m.localize)(0,null,n,d)));const r=(o,u)=>{o=o.replaceAll(v,"*".repeat(4)),u?this.g.error(o):this.g.info(o),!this.s.isBuilt&&o.startsWith("   Compiling")&&this.w(k.TunnelStates.connecting((0,m.localize)(1,null)))},t=this.y("login",["user","login","--provider",d,"--access-token",v,"--log",(0,R.LogLevelToString)(this.g.getLevel())],r);this.i=t;try{if(await t,this.i!==t)return}catch(o){this.g.error(o),this.i=void 0,this.b.fire(!0),this.w(k.TunnelStates.disconnected);return}const s=this.z();s?this.w(k.TunnelStates.connecting((0,m.localize)(2,null,s))):this.w(k.TunnelStates.connecting((0,m.localize)(3,null)));const a=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this.g.getLevel())];s?a.push("--name",s):a.push("--random-name");const c=this.y("tunnel",a,(o,u)=>{u?this.g.error(o):this.g.info(o);const S=o.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(S){const E={link:S[1],domain:S[2],hostName:S[4]};this.w(k.TunnelStates.connected(E))}else o.match(/error refreshing token/)&&(c.cancel(),this.b.fire(!0),this.w(k.TunnelStates.disconnected))});this.i=c,c.finally(()=>{c===this.i&&(this.g.info("tunnel process terminated"),this.i=void 0,this.h=void 0,this.w(k.TunnelStates.disconnected))})}async getTunnelStatus(){return this.j}w(v){this.j=v,this.c.fire(v)}y(v,d,n=()=>{}){return(0,w.createCancelablePromise)(r=>new Promise((t,s)=>{r.isCancellationRequested&&t();let a;if(r.onCancellationRequested(()=>{a&&(this.g.info(`${v} terminating(${a.pid})`),a.kill())}),!this.s.isBuilt)n("Building tunnel CLI from sources and run",!1),n(`${v} Spawning: cargo run -- tunnel ${d.join(" ")}`,!1),a=(0,b.spawn)("cargo",["run","--","tunnel",...d],{cwd:(0,P.join)(this.s.appRoot,"cli")});else{n("Running tunnel CLI",!1);const c=this.u();n(`${v} Spawning: ${c} tunnel ${d.join(" ")}`,!1),a=(0,b.spawn)(c,["tunnel",...d],{cwd:(0,g.homedir)()})}a.stdout.on("data",c=>{if(a){const o=c.toString();n(o,!1)}}),a.stderr.on("data",c=>{if(a){const o=c.toString();n(o,!0)}}),a.on("exit",c=>{a&&(n(`${v} exit(${a.pid}): + ${c} `,!1),a=void 0,c===0?t():s())}),a.on("error",c=>{a&&(n(`${v} error(${a.pid}): + ${c} `,!0),a=void 0,s())})}))}async getHostName(){return this.z()}z(){let v=this.t.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,g.hostname)();return v=v.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),v||void 0}};f=pe([Y(0,D.ITelemetryService),Y(1,I.IProductService),Y(2,A.INativeEnvironmentService),Y(3,R.ILoggerService),Y(4,y.ISharedProcessLifecycleService),Y(5,h.IConfigurationService)],f),e.RemoteTunnelService=f}),define(oe[109],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(A){this.b=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,{eventName:R,data:P}){return this.b.forEach(b=>b.log(R,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class i{constructor(A){this.b=A}log(A,T){return this.b.call("log",{eventName:A,data:T}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(oe[47],ae([0,1,32,13,3,16,75,108,21]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class b{constructor(o){this.value=o}}e.TrustedTelemetryValue=b;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,u){return Promise.resolve(void 0)}publicLog2(o,u){return this.publicLog(o,u)}publicLogError(o,u){return Promise.resolve(void 0)}publicLogError2(o,u){return this.publicLogError(o,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class C{async publicLog(o,u,S){}async publicLogError(o,u,S){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(c,o){return D.Event.debounce(o.onDidChangeConfiguration,(S,E)=>{const M=S?new Set([...S.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:M}},1e3,!0)(S=>{S.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(S.source),configurationKeys:v(S.affectedKeys)})})}e.configurationTelemetry=w;function y(c,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!c.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=y;function h(c,o){return!(o.isBuilt||o.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=h;function m(c){const o=c.getValue(P.TELEMETRY_SETTING_ID),u=c.getValue(P.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function g(c){const o={},u={},S={};p(c,S);for(let E in S){E=E.length>150?E.substr(E.length-149):E;const M=S[E];typeof M=="number"?u[E]=M:typeof M=="boolean"?u[E]=M?1:0:typeof M=="string"?(M.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${M.length}`),o[E]=M.substring(0,8191)):typeof M<"u"&&M!==null&&(o[E]=M)}return{properties:o,measurements:u}}e.validateTelemetryData=g;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function f(c){if(!c)return"none";const o=(0,T.getRemoteName)(c);return l.has(o)?o:"other"}e.cleanRemoteAuthority=f;function p(c,o,u=0,S){if(!!c)for(const E of Object.getOwnPropertyNames(c)){const M=c[E],N=S?S+E:E;Array.isArray(M)?o[N]=(0,k.safeStringify)(M):M instanceof Date?o[N]=M.toISOString():(0,i.isObject)(M)?u<2?p(M,o,u+1,N+"."):o[N]=(0,k.safeStringify)(M):o[N]=M}}function v(c){if(!c)return[];const o=[];return d(o,"",c),o}function d(c,o,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(S=>d(c,o?`${o}.${S}`:S,u[S])):c.push(o)}function n(c,o){const u=c.msftInternalDomains||[],S=o.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(u)||S}e.isInternalTelemetry=n;function r(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=r;function t(c,o){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let u=c;const S=[];for(const j of o)for(;;){const $=j.exec(c);if(!$)break;S.push([$.index,j.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,M=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(u="";;){const j=M.exec(c);if(!j)break;const $=S.some(([L,F])=>j.index<F&&L<M.lastIndex);!E.test(j[0])&&!$&&(u+=c.substring(N,j.index)+"<REDACTED: user-file-path>",N=M.lastIndex)}return N<c.length&&(u+=c.substr(N)),u}function s(c){if(!c)return c;const o=c.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const S of u)if(S.regex.test(o))return`<REDACTED: ${S.label}>`;return c}function a(c,o){return(0,k.cloneAndChange)(c,u=>{if(u instanceof b)return u.value;if(typeof u=="string"){let S=u.replaceAll("%20"," ");S=t(S,o);for(const E of o)S=S.replace(E,"");return S=s(S),S}})}e.cleanData=a}),define(oe[33],ae([0,1,27,29,42,5,7,9,36,47]),function(Z,e,k,i,D,A,T,R,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(t,s){return t.uuid&&s.uuid?t.uuid===s.uuid:t.id===s.id?!0:(0,k.compareIgnoreCase)(t.id,s.id)===0}e.areSameExtensions=I;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(s){const a=s.manifest?s.manifest.version:s.version,c=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new w(s.identifier,a,c)}static parse(s){const a=C.exec(s);return a&&a[1]&&a[2]?new w({id:a[1]},a[2],a[4]||void 0):null}constructor(s,a,c="undefined"){this.version=a,this.targetPlatform=c,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof w?I(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=w;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(t){const s=y.exec(t);return s&&s[1]?[g(s[1]),s[2]]:[g(t),void 0]}e.getIdAndVersion=h;function m(t,s){return`${t}.${s}`}e.getExtensionId=m;function g(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function l(t,s){return g(m(t,s))}e.getGalleryExtensionId=l;function f(t,s){const a=[],c=o=>{for(const u of a)if(u.some(S=>I(s(S),s(o))))return u;return null};for(const o of t){const u=c(o);u?u.push(o):a.push([o])}return a}e.groupByExtension=f;function p(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function v(t){return{id:new b.TrustedTelemetryValue(t.identifier.id),name:new b.TrustedTelemetryValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function d(t,s){const a=[],c=s.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const o=c.shift();if(o&&a.every(u=>!I(u.identifier,{id:o}))){const u=t.filter(S=>I(S.identifier,{id:o}));u.length===1&&(a.push(u[0]),c.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=d;async function n(t,s){if(!A.isLinux)return!1;let a;try{a=(await t.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await t.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){s.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(o))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=n;async function r(t,s){const a=await n(t,s),c=(0,i.getTargetPlatform)(a?"alpine":A.platform,P.arch);return s.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=r}),define(oe[233],ae([0,1,24,33]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function D(A,T,R,P,b){try{const I=await A.getExtensionsControlManifest();if(!I.deprecated)return;const C=await A.getInstalled(1);for(const[w,y]of Object.entries(I.deprecated)){if(!y?.extension)continue;const{id:h,autoMigrate:m,preRelease:g}=y.extension;if(!m)continue;const l=C.find(p=>(0,i.areSameExtensions)(p.identifier,{id:w}));if(!l)continue;const f=(await T.getExtensions([{id:h,preRelease:g}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!f){b.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{b.info(`Migrating '${l.identifier.id}' extension to '${h}' extension...`);const p=!P.getDisabledExtensions().some(d=>(0,i.areSameExtensions)(d,l.identifier));await A.uninstall(l),b.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let v=C.find(d=>(0,i.areSameExtensions)(d.identifier,{id:h}));(!v||!v.isPreReleaseVersion&&p)&&(v=await A.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${v.identifier.id}'`),p||(await P.disableExtension(v.identifier),b.info(`Disabled the pre-release extension '${v.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),m.storage&&(R.addToMigrationList((0,i.getExtensionId)(l.manifest.publisher,l.manifest.name),(0,i.getExtensionId)(v.manifest.publisher,v.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${l.identifier.id}' extension to '${h}' extension.`)}catch(p){b.error(p)}}}catch(I){b.error(I)}}e.migrateUnsupportedExtensions=D}),define(oe[234],ae([0,1,6,9,2,22,5,23,53,13,31,28,16,15,29,33,97,14,8,25]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class yt extends D.Disposable{constructor(n,r,t,s,a,c,o,u){super(),this.h=n,this.i=t,this.j=s,this.k=a,this.l=c,this.m=o,this.n=u,this.extensionsDownloadDir=r.extensionsDownloadLocation,this.f=20,this.g=this.w()}async download(n,r){await this.g;const t=(0,R.joinPath)(this.extensionsDownloadDir,this.y(n));try{await this.u(n,t,a=>this.j.download(n,a,r))}catch(a){throw new h.ExtensionManagementError(a.message,h.ExtensionManagementErrorCode.Download)}let s=!1;if(await this.r(n)){const a=await this.t(n);try{s=await this.m.verify(t.fsPath,a.fsPath),this.n.info(`Verified extension: ${n.identifier.id}`,s)}catch(c){throw await this.delete(a),await this.delete(t),new h.ExtensionManagementError(c.code,h.ExtensionManagementErrorCode.Signature)}}return{location:t,verified:s}}async r(n){if(!n.isSigned||await this.h==="linux-armhf")return!1;const t=this.k.getValue("extensions.verifySignature");return(0,b.isBoolean)(t)?t:this.l.quality!=="stable"}async t(n){await this.g;const r=(0,R.joinPath)(this.extensionsDownloadDir,`${this.y(n)}${yt.c}`);return await this.u(n,r,t=>this.j.downloadSignatureArchive(n,t)),r}async u(n,r,t){if(await this.i.exists(r))return;if(r.scheme!==A.Schemas.file){await t(r);return}const s=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.i.exists(s)||await t(s);try{await this.v(s,r,Date.now()+2*60*1e3)}catch(a){try{await this.i.del(s)}catch{}if(a.code==="ENOTEMPTY")this.n.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.n.info(`Rename failed because of ${(0,i.getErrorMessage)(a)}. Deleted the file from downloaded location`,s.path),a}}async delete(n){await this.g,await this.i.del(n)}async v(n,r,t){try{await C.Promises.rename(n.fsPath,r.fsPath)}catch(s){if(T.isWindows&&s&&s.code==="EPERM"&&Date.now()<t)return this.n.info(`Failed renaming ${n} to ${r} with 'EPERM' error. Trying again...`),this.v(n,r,t);throw s}}async w(){try{if(!await this.i.exists(this.extensionsDownloadDir)){this.n.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.i.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],t=[],s=[];for(const o of n.children)if(o.name.endsWith(yt.c))s.push(o.resource);else{const u=m.ExtensionKey.parse(o.name);u&&t.push([u,o])}const a=(0,m.groupByExtension)(t,([o])=>o),c=[];for(const o of a)o.sort((u,S)=>P.rcompare(u[0].version,S[0].version)),r.push(...o.slice(1).map(u=>u[1].resource)),c.push(o[0][1]);c.sort((o,u)=>o.mtime-u.mtime),r.push(...c.slice(0,Math.max(0,c.length-this.f)).map(o=>o.resource)),r.push(...s),await k.Promises.settled(r.map(o=>(this.n.trace("Deleting from cache",o.path),this.i.del(o))))}}catch(n){this.n.error(n)}}y(n){return this.f?m.ExtensionKey.create(n).toString().toLowerCase():(0,I.generateUuid)()}};v.c=".sigzip",v=pe([Y(1,y.INativeEnvironmentService),Y(2,l.IFileService),Y(3,h.IExtensionGalleryService),Y(4,w.IConfigurationService),Y(5,p.IProductService),Y(6,g.IExtensionSignatureVerificationService),Y(7,f.ILogService)],v),e.ExtensionsDownloader=v}),define(oe[235],ae([0,1,3,2,37,33,42]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends i.Disposable{constructor(b,I,C,w,y,h,m){super(),this.f=b,this.g=I,this.h=C,this.i=w,this.j=y,this.k=h,this.l=m,this.a=this.B(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new i.DisposableMap),this.m().then(null,g=>m.error(g))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(b=>this.p(b.added,b.removed))),this.B(this.i.onAddExtensions(b=>this.r(b))),this.B(this.i.onDidAddExtensions(b=>this.s(b))),this.B(this.i.onRemoveExtensions(b=>this.t(b))),this.B(this.i.onDidRemoveExtensions(b=>this.u(b))),this.B(this.k.onDidFilesChange(b=>this.v(b)))}async p(b,I){try{await Promise.all(I.map(C=>(this.c.deleteAndDispose(C.id),this.z(C.extensionsResource)))),b.length&&await Promise.all(b.map(C=>(this.c.set(C.id,(0,i.combinedDisposable)(this.k.watch(this.j.extUri.dirname(C.extensionsResource)),this.k.watch(C.extensionsResource))),this.y(C.extensionsResource))))}catch(C){throw this.l.error(C),C}}async r(b){for(const I of b.extensions)this.D(this.G(I.identifier,I.version),b.profileLocation)}async s(b){for(const I of b.extensions){const C=this.G(I.identifier,I.version);b.error?this.F(C,b.profileLocation):this.D(C,b.profileLocation)}}async t(b){for(const I of b.extensions)this.F(this.G(I.identifier,I.version),b.profileLocation)}async u(b){let I=!1;for(const C of b.extensions){const w=this.G(C.identifier,C.version);b.error?this.D(w,b.profileLocation):(this.F(w,b.profileLocation),I=I||!this.b.has(w))}I&&await this.C()}v(b){for(const I of this.h.profiles)b.contains(I.extensionsResource,0,1)&&this.w(I.extensionsResource)}async w(b){const I=[],C=[],w=await this.i.scanProfileExtensions(b),y=new Set,h=new Set;for(const[m,g]of this.b)g.has(b)&&h.add(m);for(const m of w){const g=this.G(m.identifier,m.version);y.add(g),h.has(g)||(I.push(m.identifier),this.D(g,b))}for(const m of h)if(!y.has(m)){const g=this.H(m);g&&(C.push(g.identifier),this.F(m,b))}(I.length||C.length)&&this.a.fire({added:I.length?{extensions:I,profileLocation:b}:void 0,removed:C.length?{extensions:C,profileLocation:b}:void 0})}async y(b){const I=await this.i.scanProfileExtensions(b);for(const C of I)this.D(this.G(C.identifier,C.version),b)}async z(b){for(const I of[...this.b.keys()])this.F(I,b);await this.C()}async C(){const I=(await this.f.getAllUserInstalled()).filter(C=>C.installedTimestamp&&!this.b.has(this.G(C.identifier,C.manifest.version)));I.length&&await this.f.markAsUninstalled(...I)}D(b,I){let C=this.b.get(b);C||this.b.set(b,C=new D.ResourceSet(w=>this.j.extUri.getComparisonKey(w))),C.add(I)}F(b,I){const C=this.b.get(b);C&&C.delete(I),C?.size||this.b.delete(b)}G(b,I){return`${T.ExtensionIdentifier.toKey(b.id)}@${I}`}H(b){const[I,C]=(0,A.getIdAndVersion)(b);return C?{identifier:{id:I},version:C}:void 0}}e.ExtensionsWatcher=R}),define(oe[236],ae([0,1,45,47]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(A,T,R,P,b,I,C){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${T.nameShort})`};if((0,i.supportsTelemetry)(T,R)&&(0,i.getTelemetryLevel)(P)===3){const y=await(0,k.getServiceMachineId)(R,b,I),{machineId:h}=await C.getTelemetryInfo();w["X-Market-User-Id"]=y,w["VSCode-SessionId"]=h||y}return w}e.resolveMarketplaceHeaders=D}),define(oe[237],ae([0,1,99,20,6,2,22,12,28,15,29,33,8,73,5,7]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let g=class extends y.LanguagePackBaseService{constructor(v,d,n,r){super(n),this.h=v,this.i=r,this.g=this.B(new l(d,r)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(v){const n=(await this.g.getLanguagePacks())[h.Language.value()];if(!n){this.i.warn(`No language pack found for ${h.Language.value()}`);return}const r=n.translations[v];return r?m.URI.file(r):void 0}async getInstalledLanguages(){const v=await this.g.getLanguagePacks(),d=Object.keys(v).map(n=>{const r=v[n];return{...this.f(n,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return d.push({...this.f("en","English"),extensionId:"default"}),d.sort((n,r)=>n.label.localeCompare(r.label)),d}async j(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",v.identifier.id),await this.update())}async k(v){const d=await this.g.getLanguagePacks();Object.keys(d).some(n=>d[n]&&d[n].extensions.some(r=>(0,C.areSameExtensions)(r.extensionIdentifier,v.identifier)))&&(this.i.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,d]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),n=await this.g.update(d);return!(0,i.equals)(Object.keys(v),Object.keys(n))}};g=pe([Y(0,I.IExtensionManagementService),Y(1,b.INativeEnvironmentService),Y(2,I.IExtensionGalleryService),Y(3,w.ILogService)],g),e.NativeLanguagePackService=g;let l=class extends A.Disposable{constructor(v,d){super(),this.i=d,this.c={},this.f=(0,R.join)(v.userDataPath,"languagepacks.json"),this.g=new D.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(v){return this.m(d=>{Object.keys(d).forEach(n=>delete d[n]),this.j(d,...v)}).then(()=>this.c)}j(v,...d){for(const n of d)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.k(v,n);Object.keys(v).forEach(n=>this.l(v[n]))}k(v,d){const n=d.identifier,r=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const t of r)if(d.location.scheme===T.Schemas.file&&f(t)){let s=v[t.languageId];s||(s={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},v[t.languageId]=s);const a=s.extensions.filter(c=>(0,C.areSameExtensions)(c.extensionIdentifier,n))[0];a?a.version=d.manifest.version:s.extensions.push({extensionIdentifier:n,version:d.manifest.version});for(const c of t.translations)s.translations[c.id]=(0,R.join)(d.location.fsPath,c.path)}}l(v){if(v){const d=(0,k.createHash)("md5");for(const n of v.extensions)d.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);v.hash=d.digest("hex")}}m(v=()=>null){return this.g.queue(()=>{let d=null;return P.Promises.readFile(this.f,"utf8").then(void 0,n=>n.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(n)).then(n=>{try{return JSON.parse(n)}catch{return{}}}).then(n=>(d=v(n),n)).then(n=>{for(const t of Object.keys(n))n[t]||delete n[t];this.c=n,this.h=!0;const r=JSON.stringify(this.c);return this.i.debug("Writing language packs",r),P.Promises.writeFile(this.f,r)}).then(()=>d,n=>this.i.error(n))})}};l=pe([Y(0,b.INativeEnvironmentService),Y(1,w.ILogService)],l);function f(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const v of p.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(oe[238],ae([0,1,9,32,47]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",T="https://mobile.events.data.microsoft.com/ping";async function R(b,I,C){const w=await new Promise((l,f)=>{Z(["@microsoft/1ds-core-js"],l,f)}),y=await new Promise((l,f)=>{Z(["@microsoft/1ds-post-js"],l,f)}),h=new w.AppInsightsCore,m=new y.PostChannel,g={instrumentationKey:b,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(C){g.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:C};g.extensionConfig[m.identifier]=l}return h.initialize(g,[]),h.addTelemetryInitializer(l=>{I&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),h}class P{constructor(I,C,w,y,h){this.e=I,this.f=C,this.g=w,this.h=h,this.c=A,this.d=T,this.g||(this.g={}),typeof y=="function"?this.a=y():this.a=y,this.b=null}i(I){if(!!this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(C=>{I(C)},C=>{(0,k.onUnexpectedError)(C),console.error(C)})}}log(I,C){if(!this.a)return;C=(0,i.mixin)(C,this.g),C=(0,D.validateTelemetryData)(C);const w=this.f+"/"+I;try{this.i(y=>{y.pluginVersionString=C?.properties.version??"Unknown",y.track({name:w,baseData:{name:w,properties:C?.properties,measurements:C?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(C=>{C.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(oe[110],ae([0,1,2,15,8,47]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends k.Disposable{constructor(P,b,I=""){super(),this.b=I;const C=P.getLogger(b.telemetryLogResource);C?this.a=this.B(C):(this.a=this.B(P.createLogger(b.telemetryLogResource)),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(P,b){this.a.trace(`${this.b}telemetry/${P}`,(0,A.validateTelemetryData)(b))}};T=pe([Y(0,D.ILoggerService),Y(1,i.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(oe[111],ae([0,1,2,32,5,27,171,16,46,103,25,40,21,47]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{constructor(l,f,p){this.k=f,this.l=p,this.d={},this.i=new k.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(w.TELEMETRY_SETTING_ID)||v.affectsConfiguration(w.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(w.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(l,f){this.d[l]=f}m(){let l=(0,y.getTelemetryLevel)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const p=f.usage?3:f.error?2:0;l=Math.min(l,p)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,f=l.sessionID,p=l["common.machineId"],v=l["common.firstSessionDate"],d=l["common.msftInternal"];return{sessionId:f,machineId:p,firstSessionDate:v,msftInternal:d}}dispose(){this.i.dispose()}n(l,f,p){return this.g<f?Promise.resolve(void 0):this.c.then(v=>{p=(0,i.mixin)(p,this.d),p=(0,y.cleanData)(p,this.j),p=(0,i.mixin)(p,v),this.b.forEach(d=>d.log(l,p))},v=>{console.error(v)})}publicLog(l,f){return this.n(l,3,f)}publicLog2(l,f){return this.publicLog(l,f)}publicLogError(l,f){return this.h?this.n(l,2,f):Promise.resolve(void 0)}publicLogError2(l,f){return this.publicLogError(l,f)}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=pe([Y(1,R.IConfigurationService),Y(2,I.IProductService)],h),e.TelemetryService=h;function m(){const g=(0,T.localize)(0,null,b.default.nameLong),l=b.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=D.isWeb?"":(0,T.localize)(3,null),p=(0,T.localize)(4,null),v=(0,T.localize)(5,null),d=(0,T.localize)(6,null),n=(0,T.localize)(7,null),r=`
|       | ${p} | ${v} | ${d} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,T.localize)(8,null);return`
${g} ${l} ${f}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}C.Registry.as(P.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(P.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,T.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,T.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[239],ae([0,1,288,238]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends i.AbstractOneDataSystemAppender{constructor(T,R,P,b){const I={sendPOST:(C,w)=>{const y={method:"POST",headers:{...C.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(C.data)}};try{const h=k.request(C.urlString,y,m=>{m.on("data",function(g){w(m.statusCode??200,m.headers,g.toString())}),m.on("error",function(g){w(0,{})})});h.write(C.data),h.end()}catch{w(0,{})}}};super(T,R,P,b,I)}}e.OneDataSystemAppender=D}),define(oe[240],ae([0,1,22,68,16,15,8,25,21,109,110,111]),function(Z,e,k,i,D,A,T,R,P,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let w=class{constructor(h,m,g,l,f){this.b=h,this.c=m,this.d=g,this.e=l,this.f=f,this.a=new Map}async g(h){if(!this.a.has(h.id)){const{machineId:m,sessionId:g}=await this.c.getTelemetryInfo(),l=Object.create(null);l["common.vscodemachineid"]=m,l["common.vscodesessionid"]=g;const f=[h.id,JSON.stringify(l),h.aiKey],v=new i.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:f,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),d=[new b.TelemetryAppenderClient(v),new I.TelemetryLogAppender(this.d,this.e,`[${h.id}] `)];this.a.set(h.id,new C.TelemetryService({appenders:d,sendErrorTelemetry:h.sendErrorTelemetry},this.b,this.f))}return this.a.get(h.id)}async publicLog(h,m,g){await(await this.g(h)).publicLog(m,g)}async publicLogError(h,m,g){await(await this.g(h)).publicLogError(m,g)}};w=pe([Y(0,D.IConfigurationService),Y(1,P.ITelemetryService),Y(2,T.ILoggerService),Y(3,A.IEnvironmentService),Y(4,R.IProductService)],w),e.CustomEndpointTelemetryService=w}),define(oe[241],ae([0,1,6,24,3,2,8]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends A.Disposable{constructor(b,I){super(),this.h=I,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new D.Emitter),this.onCreateRequest=this.g.event,this.b=b===void 0?15e3:b}createRequest(b){return new Promise((I,C)=>{const w=++this.a;this.c.set(w,I),this.g.fire({requestId:w,...b});const y=new i.CancellationTokenSource;(0,k.timeout)(this.b,y.token).then(()=>C(`Request ${w} timed out (${this.b}ms)`)),this.f.set(w,[(0,A.toDisposable)(()=>y.cancel())])})}acceptReply(b,I){const C=this.c.get(b);C?(this.c.delete(b),(0,A.dispose)(this.f.get(b)||[]),this.f.delete(b),C(I)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};R=pe([Y(1,T.ILogService)],R),e.RequestStore=R}),define(oe[112],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(p){p.Shell="terminal.integrated.shell.",p.ShellArgs="terminal.integrated.shellArgs.",p.DefaultProfile="terminal.integrated.defaultProfile.",p.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(p){p.ShellLinux="terminal.integrated.shell.linux",p.ShellMacOs="terminal.integrated.shell.osx",p.ShellWindows="terminal.integrated.shell.windows",p.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",p.AutomationShellLinux="terminal.integrated.automationShell.linux",p.AutomationShellMacOs="terminal.integrated.automationShell.osx",p.AutomationShellWindows="terminal.integrated.automationShell.windows",p.AutomationProfileLinux="terminal.integrated.automationProfile.linux",p.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",p.AutomationProfileWindows="terminal.integrated.automationProfile.windows",p.ShellArgsLinux="terminal.integrated.shellArgs.linux",p.ShellArgsMacOs="terminal.integrated.shellArgs.osx",p.ShellArgsWindows="terminal.integrated.shellArgs.windows",p.ProfilesWindows="terminal.integrated.profiles.windows",p.ProfilesMacOs="terminal.integrated.profiles.osx",p.ProfilesLinux="terminal.integrated.profiles.linux",p.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",p.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",p.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",p.UseWslProfiles="terminal.integrated.useWslProfiles",p.TabsDefaultColor="terminal.integrated.tabs.defaultColor",p.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",p.TabsEnabled="terminal.integrated.tabs.enabled",p.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",p.TabsHideCondition="terminal.integrated.tabs.hideCondition",p.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",p.TabsShowActions="terminal.integrated.tabs.showActions",p.TabsLocation="terminal.integrated.tabs.location",p.TabsFocusMode="terminal.integrated.tabs.focusMode",p.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",p.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",p.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",p.CopyOnSelection="terminal.integrated.copyOnSelection",p.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",p.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",p.FontFamily="terminal.integrated.fontFamily",p.FontSize="terminal.integrated.fontSize",p.LetterSpacing="terminal.integrated.letterSpacing",p.LineHeight="terminal.integrated.lineHeight",p.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",p.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",p.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",p.BellDuration="terminal.integrated.bellDuration",p.FontWeight="terminal.integrated.fontWeight",p.FontWeightBold="terminal.integrated.fontWeightBold",p.CursorBlinking="terminal.integrated.cursorBlinking",p.CursorStyle="terminal.integrated.cursorStyle",p.CursorWidth="terminal.integrated.cursorWidth",p.Scrollback="terminal.integrated.scrollback",p.DetectLocale="terminal.integrated.detectLocale",p.DefaultLocation="terminal.integrated.defaultLocation",p.GpuAcceleration="terminal.integrated.gpuAcceleration",p.TerminalTitleSeparator="terminal.integrated.tabs.separator",p.TerminalTitle="terminal.integrated.tabs.title",p.TerminalDescription="terminal.integrated.tabs.description",p.RightClickBehavior="terminal.integrated.rightClickBehavior",p.Cwd="terminal.integrated.cwd",p.ConfirmOnExit="terminal.integrated.confirmOnExit",p.ConfirmOnKill="terminal.integrated.confirmOnKill",p.EnableBell="terminal.integrated.enableBell",p.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",p.AllowChords="terminal.integrated.allowChords",p.AllowMnemonics="terminal.integrated.allowMnemonics",p.EnvMacOs="terminal.integrated.env.osx",p.EnvLinux="terminal.integrated.env.linux",p.EnvWindows="terminal.integrated.env.windows",p.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",p.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",p.ShowExitAlert="terminal.integrated.showExitAlert",p.SplitCwd="terminal.integrated.splitCwd",p.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",p.WordSeparators="terminal.integrated.wordSeparators",p.EnableFileLinks="terminal.integrated.enableFileLinks",p.UnicodeVersion="terminal.integrated.unicodeVersion",p.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",p.LocalEchoEnabled="terminal.integrated.localEchoEnabled",p.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",p.LocalEchoStyle="terminal.integrated.localEchoStyle",p.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",p.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",p.CustomGlyphs="terminal.integrated.customGlyphs",p.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",p.InheritEnv="terminal.integrated.inheritEnv",p.ShowLinkHover="terminal.integrated.showLinkHover",p.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",p.AutoReplies="terminal.integrated.autoReplies",p.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",p.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",p.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",p.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",p.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(p){p.FileName="ptyhost"})(A=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(p){p.PowerShell="pwsh",p.Bash="bash",p.Fish="fish",p.Sh="sh",p.Csh="csh",p.Ksh="ksh",p.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var R;(function(p){p.CommandPrompt="cmd",p.PowerShell="pwsh",p.Wsl="wsl",p.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(p){p[p.Api=0]="Api",p[p.Process=1]="Process",p[p.Sequence=2]="Sequence",p[p.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var b;(function(p){p.LocalPty="localPty",p.PtyHost="ptyHost",p.Log="log",p.Heartbeat="heartbeat"})(b=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var I;(function(p){p.Cwd="cwd",p.InitialCwd="initialCwd",p.FixedDimensions="fixedDimensions",p.Title="title",p.ShellType="shellType",p.HasChildProcesses="hasChildProcesses",p.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",p.OverrideDimensions="overrideDimensions",p.FailedShellIntegrationActivation="failedShellIntegrationActivation",p.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(I=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(p){p[p.BeatInterval=5e3]="BeatInterval",p[p.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",p[p.SecondWaitMultiplier=1]="SecondWaitMultiplier",p[p.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(p){p[p.Panel=1]="Panel",p[p.Editor=2]="Editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var y;(function(p){p.TerminalView="view",p.Editor="editor"})(y=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(p){p[p.GraceTime=6e4]="GraceTime",p[p.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var m;(function(p){p[p.HighWatermarkChars=1e5]="HighWatermarkChars",p[p.LowWatermarkChars=5e3]="LowWatermarkChars",p[p.CharCountAckSize=5e3]="CharCountAckSize"})(m=e.FlowControlConstants||(e.FlowControlConstants={}));var g;(function(p){p.GitBash="Git Bash",p.Pwsh="PowerShell"})(g=e.ProfileSource||(e.ProfileSource={}));var l;(function(p){p[p.Off=0]="Off",p[p.FinalTerm=1]="FinalTerm",p[p.VSCode=2]="VSCode"})(l=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var f;(function(p){p[p.Unknown=0]="Unknown",p[p.Shutdown=1]="Shutdown",p[p.Process=2]="Process",p[p.User=3]="User",p[p.Extension=4]="Extension"})(f=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(oe[242],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(oe[243],ae([0,1,34,22,32,12,5,36,27,13,28]),function(Z,e,k,i,D,A,T,R,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let n=0;return d&&d.length===4&&(n=parseInt(d[3])),n}e.getWindowsBuildNumber=C;async function w(d,n,r,t=R.env,s=I.Promises.exists){if(A.isAbsolute(d))return await s(d)?d:void 0;if(n===void 0&&(n=R.cwd()),A.dirname(d)!=="."){const u=A.join(n,d);return await s(u)?u:void 0}const c=(0,D.getCaseInsensitive)(t,"PATH");if(r===void 0&&(0,b.isString)(c)&&(r=c.split(A.delimiter)),r===void 0||r.length===0){const u=A.join(n,d);return await s(u)?u:void 0}for(const u of r){let S;if(A.isAbsolute(u)?S=A.join(u,d):S=A.join(n,u,d),await s(S))return S;if(T.isWindows){let E=S+".com";if(await s(E)||(E=S+".exe",await s(E)))return E}}const o=A.join(n,d);return await s(o)?o:void 0}e.findExecutable=w;function y(d,n,r,t,s){if(!n.shellIntegration.enabled||!d.executable||d.isFeatureTerminal||d.hideFromUser||d.ignoreShellIntegration||T.isWindows&&!n.windowsEnableConpty)return;const a=d.args,c=R.platform==="win32"?A.basename(d.executable).toLowerCase():A.basename(d.executable),o=A.dirname(i.FileAccess.asFileUri("").fsPath);let u;const S={VSCODE_INJECTION:"1"};if(T.isWindows){if(c==="pwsh.exe"||c==="powershell.exe")return!a||p(a)?u=m.get(h.WindowsPwsh):f(a)&&(u=m.get(h.WindowsPwshLogin)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],o,""),{newArgs:u,envMixin:S}):void 0;t.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args);return}switch(c){case"bash":return!a||a.length===0?u=m.get(h.Bash):v(a)&&(S.VSCODE_SHELL_LOGIN="1",u=m.get(h.Bash)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],o),{newArgs:u,envMixin:S}):void 0;case"fish":{const E=r?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",M=A.join(o,"out/vs/workbench/contrib/xdg_data");return S.XDG_DATA_DIRS=`${E}:${M}`,{newArgs:void 0,envMixin:S}}case"pwsh":return!a||p(a)?u=m.get(h.Pwsh):f(a)&&(u=m.get(h.PwshLogin)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],o,""),{newArgs:u,envMixin:S}):void 0;case"zsh":{if(!a||a.length===0?u=m.get(h.Zsh):v(a)?u=m.get(h.ZshLogin):(a===m.get(h.Zsh)||a===m.get(h.ZshLogin))&&(u=a),!u)return;u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],o);let E;try{E=k.userInfo().username}catch{E="unknown"}const M=A.join(k.tmpdir(),`${E}-${s.applicationName}-zsh`);S.ZDOTDIR=M;const N=r?.ZDOTDIR??k.homedir()??"~";S.USER_ZDOTDIR=N;const j=[];return j.push({source:A.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(M,".zshrc")}),j.push({source:A.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(M,".zprofile")}),j.push({source:A.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(M,".zshenv")}),j.push({source:A.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(M,".zlogin")}),{newArgs:u,envMixin:S,filesToCopy:j}}}t.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args)}e.getShellIntegrationInjection=y;var h;(function(d){d.WindowsPwsh="windows-pwsh",d.WindowsPwshLogin="windows-pwsh-login",d.Pwsh="pwsh",d.PwshLogin="pwsh-login",d.Zsh="zsh",d.ZshLogin="zsh-login",d.Bash="bash"})(h||(h={}));const m=new Map;m.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),m.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),m.set(h.Zsh,["-i"]),m.set(h.ZshLogin,["-il"]),m.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const g=["-login","-l"],l=["-nol","-nologo"];function f(d){return typeof d=="string"?g.includes(d.toLowerCase()):d.length===1&&g.includes(d[0].toLowerCase())||d.length===2&&(g.includes(d[0].toLowerCase())||g.includes(d[1].toLowerCase()))&&(l.includes(d[0].toLowerCase())||l.includes(d[1].toLowerCase()))}function p(d){return typeof d=="string"?l.includes(d.toLowerCase()):d.length===0||d?.length===1&&l.includes(d[0].toLowerCase())}function v(d){return d==="string"&&g.includes(d.toLowerCase())||typeof d!="string"&&d.length===1&&g.includes(d[0].toLowerCase())}}),define(oe[244],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var k;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(k=e.ColorScheme||(e.ColorScheme={}));function i(A){return A===k.HIGH_CONTRAST_DARK||A===k.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function D(A){return A===k.DARK||A===k.HIGH_CONTRAST_DARK}e.isDark=D}),define(oe[113],ae([0,1,51,3,2,4,40,244]),function(Z,e,k,i,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var P;(function(g){function l(f){return f&&typeof f=="object"&&typeof f.id=="string"}g.isThemeColor=l})(P=e.ThemeColor||(e.ThemeColor={}));function b(g){return{id:g}}e.themeColorFromId=b;var I;(function(g){function l(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||P.isThemeColor(s.color))}g.isThemeIcon=l;const f=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function p(s){const a=f.exec(s);if(!a)return;const[,c]=a;return{id:c}}g.fromString=p;function v(s){return{id:s}}g.fromId=v;function d(s,a){let c=s.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),a&&(c=`${c}~${a}`),{id:c}}g.modify=d;function n(s){const a=s.id.lastIndexOf("~");if(a!==-1)return s.id.substring(a+1)}g.getModifier=n;function r(s,a){return s.id===a.id&&s.color?.id===a.color?.id}g.isEqual=r;function t(s,a){return{id:s.id,color:a?b(a):void 0}}g.asThemeIcon=t,g.asClassNameArray=k.CSSIcon.asClassNameArray,g.asClassName=k.CSSIcon.asClassName,g.asCSSSelector=k.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function C(g){switch(g){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case R.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,D.toDisposable)(()=>{const f=this.a.indexOf(l);this.a.splice(f,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const y=new w;T.Registry.add(e.Extensions.ThemingContribution,y);function h(g){return y.onColorThemeChange(g)}e.registerThemingParticipant=h;class m extends D.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(f=>this.n(f)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,f){let p=this.h.getColor(l);return p&&f&&(p=f(p,this.h)),p?p.toString():null}}e.Themable=m}),define(oe[245],ae([0,1,51,7,173,113]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(w,y){const h=[{name:null,description:(0,D.localize)(0,null)}];return h.push(...w.map(m=>({name:m.profileName,description:R(m)}))),y&&h.push(...y.map(m=>({name:m.title,description:P(m)}))),{values:h.map(m=>m.name),markdownDescriptions:h.map(m=>m.description)}}e.createProfileSchemaEnums=T;function R(w){let y=`$(${A.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:k.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?y+=`
- args: "${w.args}"`:y+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(y+=`
- overrideName: ${w.overrideName}`),w.color&&(y+=`
- color: ${w.color}`),w.env&&(y+=`
- env: ${JSON.stringify(w.env)}`),y}function P(w){return`$(${A.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:k.Codicon.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function b(w,y){if(!w&&!y)return!0;if(typeof w=="string"&&typeof y=="string")return w===y;if(Array.isArray(w)&&Array.isArray(y)){if(w.length!==y.length)return!1;for(let h=0;h<w.length;h++)if(w[h]!==y[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function I(w,y){if(!w&&!y)return!0;if(!w||!y)return!1;if(A.ThemeIcon.isThemeIcon(w)&&A.ThemeIcon.isThemeIcon(y))return w.id===y.id&&w.color===y.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof y=="object"&&"light"in y&&"dark"in y){const h=w,m=y;if((i.URI.isUri(h.light)||C(h.light))&&(i.URI.isUri(h.dark)||C(h.dark))&&(i.URI.isUri(m.light)||C(m.light))&&(i.URI.isUri(m.dark)||C(m.dark)))return h.light.path===m.light.path&&h.dark.path===m.dark.path}if(i.URI.isUri(w)&&i.URI.isUri(y)||C(w)||C(y)){const h=w,m=y;return h.path===m.path&&h.scheme===m.scheme}return!1}e.terminalIconsEqual=I;function C(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.isUriComponents=C}),define(oe[246],ae([0,1,51,172,46,40,245]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(k.Codicon.getAll(),v=>v.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),v=>`$(${v.id})`)};const R={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),...e.terminalIconSchema},color:{description:(0,i.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},P={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},b={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...R}},I=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),w=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),m=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),g={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:w},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){A.Registry.as(D.Extensions.Configuration).registerConfiguration(g),p()}e.registerTerminalPlatformConfiguration=l;let f;function p(v,d){const n=A.Registry.as(D.Extensions.Configuration);let r;v&&(r=(0,T.createProfileSchemaEnums)(v?.profiles,d));const t=f;f={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:v?.os===3?r?.values:void 0,markdownEnumDescriptions:v?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:v?.os===2?r?.values:void 0,markdownEnumDescriptions:v?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:v?.os===1?r?.values:void 0,markdownEnumDescriptions:v?.os===1?r?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[f],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(oe[247],ae([0,1,50,51,12,5,28,90,243,113]),function(Z,e,k,i,D,A,T,R,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,C=!0;function w(r,t,s,a,c=process.env,o,u,S,E){return o=o||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},A.isWindows?y(s,o,c,u,a.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:a.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:a.getValue("terminal.integrated.defaultProfile.windows"),E,S):v(o,u,s,r&&typeof r=="object"?{...r}:a.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:a.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),E,S,c)}e.detectAvailableProfiles=w;async function y(r,t,s,a,c,o,u,S,E){const M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),N=`${process.env.windir}\\${M?"Sysnative":"System32"}`;let j=!1;(0,P.getWindowsBuildNumber)()>=16299&&(j=!0),await g(S);const $=new Map;r&&($.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${N}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Command Prompt",{path:`${N}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),d(o,$);const L=await h($.entries(),u,t,s,a,E);if(r||c)try{const F=await f(`${N}\\${j?"wsl":"bash"}.exe`,u);for(const z of F)(!o||!(z.profileName in o))&&L.push(z)}catch{C&&(a?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return L}async function h(r,t,s,a=process.env,c,o){const u=[];for(const[S,E]of r){if(E===null)continue;let M,N,j;if("source"in E){const F=I?.get(E.source);if(!F)continue;M=F.paths,N=E.args||F.args,E.icon?j=m(E.icon):F.icon&&(j=F.icon)}else M=Array.isArray(E.path)?E.path:[E.path],N=A.isWindows||Array.isArray(E.args)?E.args:void 0,j=m(E.icon);const $=await o?.(M)||M.slice(),L=await n(S,t,$,s,a,N,E.env,E.overrideName,E.isAutoDetected,c);L?(L.isAutoDetected=E.isAutoDetected,L.icon=j,L.color=E.color,u.push(L)):c?.debug("Terminal profile not validated",S,M)}return c?.debug("Validated terminal profiles",u),u}function m(r){return typeof r=="string"?{id:r}:r}async function g(r){I&&!r||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),I.set("PowerShell",{profileName:"PowerShell",paths:r||await l(),icon:b.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function l(){const r=[];for await(const t of(0,R.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function f(r,t){const s=[],a=await new Promise((u,S)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(E,M)=>{if(E)return S("Problem occurred when getting wsl distros");u(M)})});if(!a)return[];const c=new RegExp(/[\r?\n]/),o=a.split(c).filter(u=>u.trim().length>0&&u!=="");for(const u of o){if(u===""||u.startsWith("docker-desktop"))continue;const S=`${u} (WSL)`,E={profileName:S,path:r,args:["-d",`${u}`],isDefault:S===t,icon:p(u),isAutoDetected:!1};s.push(E)}return s}function p(r){return r.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):r.includes("Debian")?b.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function v(r,t,s,a,c,o,u,S){const E=new Map;if(s){const M=(await r.readFile("/etc/shells")).toString(),N=o||M.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),j=new Map;for(const $ of N){let L=(0,D.basename)($),F=j.get(L)||0;F++,F>1&&(L=`${L} (${F})`),j.set(L,F),E.set(L,{path:$,isAutoDetected:!0})}}return d(a,E),await h(E.entries(),c,r,S,t,u)}function d(r,t){if(!!r)for(const[s,a]of Object.entries(r))a===null||!("path"in a)&&!("source"in a)?t.delete(s):(a.icon=a.icon||t.get(s)?.icon,t.set(s,a))}async function n(r,t,s,a,c,o,u,S,E,M){if(s.length===0)return Promise.resolve(void 0);const N=s.shift();if(N==="")return n(r,t,s,a,c,o,u,S,E);const j={profileName:r,path:N,args:o,env:u,overrideName:S,isAutoDetected:E,isDefault:r===t};if((0,D.basename)(N)===N){const L=c.PATH?c.PATH.split(D.delimiter):void 0,F=await(0,P.findExecutable)(N,void 0,L,void 0,a.existsFile);return F?(j.path=F,j.isFromPath=!0,j):n(r,t,s,a,c,o)}return await a.existsFile((0,D.normalize)(N))?j:n(r,t,s,a,c,o,u,S,E)}}),define(oe[248],ae([0,1,3,2,22,5,39,68,16,15,94,229,8,102,241,112,246,247]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let p=0,v=class extends i.Disposable{constructor(n,r,t,s){super(),this.C=n,this.D=r,this.F=t,this.G=s,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new k.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new k.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new k.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new k.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new k.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new k.Emitter),this.onProcessData=this.s.event,this.t=this.B(new k.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new k.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new k.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new k.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new k.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new k.Emitter),this.onProcessExit=this.z.event,(0,g.registerTerminalPlatformConfiguration)(),this.c=this.J(),this.B((0,i.toDisposable)(()=>this.M())),this.f=this.B(new h.RequestStore(void 0,this.G)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.L(),this.B(this.D.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.I()}))}initialize(){this.I()}get H(){return this.D.getValue("terminal.integrated.ignoreProcessNames")}async I(){return this.b.refreshIgnoreProcessNames?.(this.H)}async J(){if(A.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this.D,this.G,{_:[]},process.env)}catch(n){return this.G.error("ptyHost was unable to resolve shell environment",n),{}}}L(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.F.logsPath],env:{VSCODE_LAST_PTY_ID:p,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},r=(0,I.parsePtyHostPort)(this.F.args,this.F.isBuilt);r&&(r.break&&r.port?n.debugBrk=r.port:!r.break&&r.port&&(n.debug=r.port));const t=new R.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this.m.fire(),T.ProxyChannel.toService(t.getChannel(m.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.N()),this.N(),this.B(t.onDidProcessExit(o=>{this.l.fire(o.code),this.i||(this.g<=f.MaxRestarts?(this.G.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.g++,this.restartPtyHost()):this.G.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const a=t.getChannel(m.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(a,this.G.getLevel()),this.B(this.G.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(a,this.G.getLevel())}));const c=T.ProxyChannel.toService(t.getChannel(m.TerminalIpcChannels.PtyHost));return this.B(c.onProcessData(o=>this.s.fire(o))),this.B(c.onProcessReady(o=>this.t.fire(o))),this.B(c.onProcessExit(o=>this.z.fire(o))),this.B(c.onDidChangeProperty(o=>this.y.fire(o))),this.B(c.onProcessReplay(o=>this.u.fire(o))),this.B(c.onProcessOrphanQuestion(o=>this.v.fire(o))),this.B(c.onDidRequestDetach(o=>this.w.fire(o))),[t,c]}dispose(){this.i=!0,super.dispose()}async createProcess(n,r,t,s,a,c,o,u,S,E,M){const N=setTimeout(()=>this.Q(),m.HeartbeatConstants.CreateProcessTimeout),j=await this.b.createProcess(n,r,t,s,a,c,o,u,S,E,M);return clearTimeout(N),p=Math.max(p,j),j}updateTitle(n,r,t){return this.b.updateTitle(n,r,t)}updateIcon(n,r,t,s){return this.b.updateIcon(n,r,t,s)}attachToProcess(n){return this.b.attachToProcess(n)}detachFromProcess(n,r){return this.b.detachFromProcess(n,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(n){return this.b.start(n)}shutdown(n,r){return this.b.shutdown(n,r)}input(n,r){return this.b.input(n,r)}processBinary(n,r){return this.b.processBinary(n,r)}resize(n,r,t){return this.b.resize(n,r,t)}acknowledgeDataEvent(n,r){return this.b.acknowledgeDataEvent(n,r)}setUnicodeVersion(n,r){return this.b.setUnicodeVersion(n,r)}getInitialCwd(n){return this.b.getInitialCwd(n)}getCwd(n){return this.b.getCwd(n)}getLatency(n){return this.b.getLatency(n)}orphanQuestionReply(n){return this.b.orphanQuestionReply(n)}installAutoReply(n,r){return this.b.installAutoReply(n,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(n){return this.b.uninstallAutoReply(n)}getDefaultSystemShell(n){return this.b.getDefaultSystemShell(n)}async getProfiles(n,r,t,s=!1){const a=await this.c;return(0,l.detectAvailableProfiles)(r,t,s,this.D,a,void 0,this.G,this.S.bind(this,n))}getEnvironment(){return this.b.getEnvironment()}getWslPath(n,r){return this.b.getWslPath(n,r)}getRevivedPtyNewId(n){return this.b.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this.b.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this.b.getTerminalLayoutInfo(n)}async requestDetachInstance(n,r){return this.b.requestDetachInstance(n,r)}async acceptDetachInstanceReply(n,r){return this.b.acceptDetachInstanceReply(n,r)}async freePortKillProcess(n){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(n)}async serializeTerminalState(n){return this.b.serializeTerminalState(n)}async reviveTerminalProcesses(n,r){return this.b.reviveTerminalProcesses(n,r)}async refreshProperty(n,r){return this.b.refreshProperty(n,r)}async updateProperty(n,r,t){return this.b.updateProperty(n,r,t)}async restartPtyHost(){this.h=!0,this.M(),[this.a,this.b]=this.L()}M(){this.b.shutdownAll?.(),this.a.dispose()}N(){this.R(),this.j=setTimeout(()=>this.O(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}O(){this.G.warn(`No ptyHost heartbeat after ${m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.P(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.SecondWaitMultiplier)}P(){this.G.error(`No ptyHost heartbeat after ${(m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier+m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}Q(){this.R(),this.G.error(`No ptyHost response to createProcess after ${m.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}R(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}S(n,r){return this.f.createRequest({workspaceId:n,originalText:r})}async acceptPtyHostResolvedVariables(n,r){this.f.acceptReply(n,r)}};v=pe([Y(1,P.IConfigurationService),Y(2,b.IEnvironmentService),Y(3,w.ILogService)],v),e.PtyHostService=v}),define(oe[77],ae([0,1,3,16,4,8]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var T;(function(m){m.Http="http",m.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var P;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=C;function w(m,g,l,f){if(l===1)return!1;if(l===2&&C(g)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(p?.length===4&&parseInt(p[1])>=18)return!1}return m<1024}e.isPortPrivileged=w;class y{constructor(g,l,f){this.remoteAddress=g,this.localAddress=l,this.b=f,this.a=new k.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=y;let h=class{constructor(g,l){this.i=g,this.j=l,this.a=new k.Emitter,this.onTunnelOpened=this.a.event,this.b=new k.Emitter,this.onTunnelClosed=this.b.event,this.c=new k.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const g=this.j.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.e=g,g?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.f=g.elevation,this.g=g.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const g=[],l=Array.from(this.d.values());for(const f of l){const p=Array.from(f.values());for(const v of p){const d=await v.value;d&&g.push(d)}}return g}async dispose(){for(const g of this.d.values()){for(const{value:l}of g.values())await l.then(f=>f?.dispose());g.clear()}this.d.clear()}setEnvironmentTunnel(g,l,f,p,v){this.o(g,l,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:l,localAddress:f,privacy:p,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,l){(C(g)||I(g))&&(g=e.LOCALHOST_ADDRESSES[0]);const f=this.q(g,l);if(f)return++f.refcount,f.value}openTunnel(g,l,f,p,v=!1,d,n){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${f} on local port ${p}.`),!g)return;if(l||(l="localhost"),this.e&&this.h.has(f)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(g,l,f,p,v,d,n);return r?r.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,f);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(t);return(t.tunnelRemoteHost!==l||t.tunnelRemotePort!==f)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const l=this.d.get(g.tunnelRemoteHost);if(l){const f=l.get(g.tunnelRemotePort);f&&(f.refcount--,await this.n(g.tunnelRemoteHost,g.tunnelRemotePort,f))}}}}async n(g,l,f){if(f.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${l}.`);const p=f.value.then(async v=>{v&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.d.has(g)&&this.d.get(g).delete(l),p}}async closeTunnel(g,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${l} `);const f=this.d.get(g);if(f&&f.has(l)){const p=f.get(l);p.refcount=0,await this.n(g,l,p)}}o(g,l,f){this.d.has(g)||this.d.set(g,new Map),this.d.get(g).set(l,{refcount:1,value:f})}async p(g,l){const f=this.d.get(g);f&&(await f.get(l)||f.delete(l),f.size===0&&this.d.delete(g))}q(g,l){const f=[g];I(g)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):C(g)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const p=f.map(v=>this.d.get(v));for(const v of p){const d=v?.get(l);if(d)return d}}canTunnel(g){return!!b(g)}s(g,l,f,p,v,d,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${f} on local port ${p}.`);const r=f;this.h.add(r);const t=p===void 0?f:p,s={elevationRequired:v?this.isPortPrivileged(t):!1},a={remoteAddress:{host:l,port:f},localAddressPort:p,privacy:d,public:d?d!==R.Private:void 0,protocol:n},c=g.forwardPort(a,s);return c?(this.o(l,f,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),c}};h=pe([Y(0,A.ILogService),Y(1,i.IConfigurationService)],h),e.AbstractTunnelService=h}),define(oe[249],ae([0,1,8,77,2,9,6]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends D.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.DeferredPromise),this.b.p)}setAddress(I){this.a=I,this.b&&(this.b.complete(I),this.b=null)}setTunnel(I){this.B(I)}}let P=class kt extends D.Disposable{constructor(I,C){super(),this.f=I,this.g=C,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++kt.a)}}async startTunnel(I,C,w,y,h,m){const g=new R,l=await Promise.resolve(this.f.openTunnel(I,g,w,y,h,m));if(!l)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${w}:${y} (remote).`),g.dispose(),new Error("Could not create tunnel");if(this.c.has(C))throw this.c.delete(C),g.dispose(),await l.dispose(),(0,A.canceled)();return g.setTunnel(l),this.b.set(C,g),this.g.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${l.localAddress} (local) to ${w}:${y} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(I,C){const w=this.b.get(I);!w||w.setAddress(C)}async destroyTunnel(I){const C=this.b.get(I);if(C){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this.b.delete(I),await C.dispose();return}this.c.add(I)}};P.a=0,P=pe([Y(0,i.ISharedTunnelsService),Y(1,k.ILogService)],P),e.SharedProcessTunnelService=P}),define(oe[250],ae([0,1,86,34,131,221,6,2,16,8,25,219,77,107,5]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function m(v,d,n,r,t){let s;for(let a=3;a&&(s?.dispose(),s=await new g(v,d,n,r,t).waitForReady(),!(t&&D.BROWSER_RESTRICTED_PORTS[t]||!D.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));a--);return s}class g extends R.Disposable{constructor(d,n,r,t,s){super(),this.j=n,this.k=s,this.privacy=w.TunnelPrivacyId.Private,this.i=new Map,this.a=d,this.b=k.createServer(),this.c=new T.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.l(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const d=this.k??this.tunnelRemotePort,n=(0,w.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,D.findFreePortFaster)(d,2,1e3,n),t=null;return this.b.listen(r,this.j),await this.c.wait(),t=this.b.address(),t||(r=0,this.b.listen(r,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(d){d.pause();const n=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,C.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),t=r.getSocket().socket,s=r.readEntireBuffer();r.dispose(),s.byteLength>0&&d.write(s.buffer),d.on("end",()=>{d.localAddress&&this.i.delete(d.localAddress),t.end()}),d.on("close",()=>t.end()),d.on("error",()=>{d.localAddress&&this.i.delete(d.localAddress),t.destroy()}),t.on("end",()=>d.end()),t.on("close",()=>d.end()),t.on("error",()=>{d.destroy()}),d.pipe(t),t.pipe(d),d.localAddress&&this.i.set(d.localAddress,()=>{d.end(),t.end()})}}let l=class extends w.AbstractTunnelService{constructor(d,n,r,t,s){super(n,s),this.t=d,this.u=r,this.v=t}isPortPrivileged(d){return(0,w.isPortPrivileged)(d,this.k,h.OS,i.release())}r(d,n,r,t,s,a,c){const o=this.q(n,r);if(o)return++o.refcount,o.value;if(this.e)return this.s(this.e,n,r,t,s,a,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${t}.`);const u={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:d,signService:this.u,logService:this.i,ipcLogger:null},S=m(u,this.k,n,r,t);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,r,S),S}}};l=pe([Y(1,b.ILogService),Y(2,y.ISignService),Y(3,I.IProductService),Y(4,P.IConfigurationService)],l),e.BaseTunnelService=l;let f=class extends l{constructor(d,n,r,t){super(A.nodeSocketFactory,d,n,r,t)}};f=pe([Y(0,b.ILogService),Y(1,y.ISignService),Y(2,I.IProductService),Y(3,P.IConfigurationService)],f),e.TunnelService=f;let p=class extends R.Disposable{constructor(d,n,r,t){super(),this.b=d,this.c=n,this.f=r,this.g=t,this.a=new Map}async openTunnel(d,n,r,t,s,a,c,o){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${s}.`),!this.a.has(d)){const u=new f(this.b,this.f,this.c,this.g);this.B(u),this.a.set(d,u),u.onTunnelClosed(async()=>{(await u.tunnels).length===0&&(u.dispose(),this.a.delete(d))})}return this.a.get(d).openTunnel(n,r,t,s,a,c,o)}};p=pe([Y(0,b.ILogService),Y(1,I.IProductService),Y(2,y.ISignService),Y(3,P.IConfigurationService)],p),e.SharedTunnelsService=p}),define(oe[30],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(oe[251],ae([0,1,30,71,14,23,129,3,2]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(w){this.uri=w,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let I=class{constructor(w){this.g=w,this.c=new P.DisposableStore,this.f=2**16;const y=new Map,h=m=>{let g=y.get(m.scheme);return g===void 0&&(g=w.hasProvider(m)&&!this.g.hasCapability(m,1024),y.set(m.scheme,g)),g};this.c.add(R.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(m=>{y.delete(m.scheme)})),this.extUri=new A.ExtUri(h),this.d=new T.SkipList((m,g)=>this.extUri.compare(m,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,A.normalizePath)(w));const y=this.d.get(w);return y?y.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new b(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((h,m)=>h[1].touch<m[1].touch?1:h[1].touch>m[1].touch?-1:0);b._clock=0,this.d.clear();const y=this.f*.5;for(let h=0;h<y;h++)this.d.set(w[h][0],w[h][1].touch())}};I=pe([Y(0,D.IFileService)],I),e.UriIdentityService=I,(0,i.registerSingleton)(k.IUriIdentityService,I,1)}),define(oe[252],ae([0,1,3,2,14,44,49,17]),function(Z,e,k,i,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends i.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(I,C,w,y){super(),this.c=I,this.f=C,this.g=w,this.h=y,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(h=>this.i(h)))}watch(I,C){this.b.set(I,I);const w=this.f.watch(this.j(I),C);return(0,i.toDisposable)(()=>{this.b.delete(I),w.dispose()})}stat(I){return this.f.stat(this.j(I))}mkdir(I){return this.f.mkdir(this.j(I))}rename(I,C,w){return this.f.rename(this.j(I),this.j(C),w)}readFile(I){return this.f.readFile(this.j(I),{atomic:!0})}readFileStream(I,C,w){const y=(0,A.newWriteableStream)(h=>R.VSBuffer.concat(h.map(m=>R.VSBuffer.wrap(m))).buffer);return(async()=>{try{const h=await this.readFile(I);y.end(h)}catch(h){y.error(h),y.end()}})(),y}readdir(I){return this.f.readdir(this.j(I))}writeFile(I,C,w){return this.f.writeFile(this.j(I),C,w)}delete(I,C){return this.f.delete(this.j(I),C)}copy(I,C,w){if((0,D.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(I),this.j(C),w);throw new Error("copy not supported")}i(I){const C=[];for(const w of I){if(w.resource.scheme!==this.c)continue;const y=this.k(w.resource);this.b.findSubstr(y)&&C.push({resource:y,type:w.type})}C.length&&(this.h.debug("User data changed"),this.a.fire(C))}j(I){return I.with({scheme:this.c})}k(I){return I.with({scheme:this.g})}}e.FileUserDataProvider=P}),define(oe[60],ae([0,1,83]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(T,R,P,b){const I=(0,k.setProperty)(T,R,P,b)[0];return I&&(T=T.substring(0,I.offset)+I.content+T.substring(I.offset+I.length)),T}e.edit=i;function D(T,R,P){let b=P;for(;b>=0;){if(T.charAt(b)===R.charAt(R.length-1)&&R.length===1)return b+1;if(b--,R.length===2&&b>=0&&T.charAt(b)===R.charAt(0))return b+2}return 0}e.getLineStartOffset=D;function A(T,R,P){let b=P;for(;b>=0;)if(T.charAt(b)===R.charAt(R.length-1)&&R.length===1||(b++,R.length===2&&b>=0&&T.charAt(b)===R.charAt(1)))return b;return T.length-1}e.getLineEndOffset=A}),define(oe[253],ae([0,1,32,53,13]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(y,h,m,g,l,f){const p=[],v=[],d=[];if(!h){const F=y.filter(({identifier:z})=>l.every(W=>W.toLowerCase()!==z.id.toLowerCase()));return{local:{added:p,removed:v,updated:d},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}y=y.map(C),h=h.map(C),m=m?m.map(C):null;const n=new Map,r=F=>{F.uuid&&n.set(F.id.toLowerCase(),F.uuid)};y.forEach(({identifier:F})=>r(F)),h.forEach(({identifier:F})=>r(F)),m?.forEach(({identifier:F})=>r(F));const t=F=>{const z=F.identifier.uuid||n.get(F.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${F.identifier.id.toLowerCase()}`},s=(F,z)=>(F.set(t(z),z),F),a=y.reduce(s,new Map),c=h.reduce(s,new Map),o=h.reduce((F,z)=>s(F,(0,k.deepClone)(z)),new Map),u=m?m.reduce(s,new Map):null,S=g.reduce(s,new Map),E=l.reduce((F,z)=>{const W=n.get(z.toLowerCase());return F.add(W?`uuid:${W}`:`id:${z.toLowerCase()}`)},new Set),M=f.reduce((F,{id:z,uuid:W})=>(W=W??n.get(z.toLowerCase()),F.add(W?`uuid:${W}`:`id:${z.toLowerCase()}`)),new Set),N=T(a,c,E,!1);if(N.added.size>0||N.removed.size>0||N.updated.size>0){const F=T(u,a,E,!1),z=T(u,c,E,!0),W=(H,Q,K,V)=>({...V,installed:Q.installed||K.installed,version:K.version&&(!Q.installed||i.gt(K.version,Q.version))?K.version:Q.version,state:P(Q,K,u?.get(H)),preRelease:(Q.installed?V.preRelease:K.preRelease)??Q.preRelease});for(const H of z.removed.values()){const Q=a.get(H);if(!Q)continue;const K=(0,D.assertIsDefined)(u?.get(H)),V=!M.has(H)&&K.installed;Q.installed&&V?v.push(Q.identifier):o.set(H,Q)}for(const H of z.added.values()){const Q=(0,D.assertIsDefined)(c.get(H)),K=a.get(H);if(K){if(N.updated.has(H)){const V=W(H,K,Q,Q);R(K,Q,!1,!1)||d.push(w(V,H)),o.set(H,V)}}else Q.installed&&p.push(w(Q,H))}for(const H of z.updated.values()){const Q=(0,D.assertIsDefined)(c.get(H)),K=(0,D.assertIsDefined)(u?.get(H)),V=a.get(H);if(V)if(!M.has(H)&&K.installed&&V.installed&&!Q.installed)v.push(V.identifier);else{const x=W(H,V,Q,Q);d.push(w(x,H)),o.set(H,x)}else Q.installed&&p.push(w(Q,H))}for(const H of F.added.values())z.added.has(H)||o.set(H,(0,D.assertIsDefined)(a.get(H)));for(const H of F.updated.values()){if(z.removed.has(H)||z.updated.has(H))continue;const Q=(0,D.assertIsDefined)(a.get(H)),K=(0,D.assertIsDefined)(c.get(H));o.set(H,W(H,Q,K,Q))}for(const H of F.removed.values())z.updated.has(H)||z.removed.has(H)||S.has(H)||!(0,D.assertIsDefined)(c.get(H)).installed||M.has(H)||!(0,D.assertIsDefined)(u?.get(H)).installed||o.delete(H)}const j=[],$=T(c,o,new Set,!0),L=$.added.size>0||$.updated.size>0||$.removed.size>0;return L&&o.forEach((F,z)=>j.push(w(F,z))),{local:{added:p,removed:v,updated:d},remote:L?{added:[...$.added].map(F=>o.get(F)),updated:[...$.updated].map(F=>o.get(F)),removed:[...$.removed].map(F=>c.get(F)),all:j}:null}}e.merge=A;function T(y,h,m,g){const l=y?[...y.keys()].filter(n=>!m.has(n)):[],f=[...h.keys()].filter(n=>!m.has(n)),p=f.filter(n=>l.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),v=l.filter(n=>f.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),d=new Set;for(const n of l){if(v.has(n))continue;const r=y.get(n),t=h.get(n);(!t||!R(r,t,g,!0))&&d.add(n)}return{added:p,removed:v,updated:d}}function R(y,h,m,g){return!(y.disabled!==h.disabled||g&&y.installed!==h.installed||y.installed&&h.installed&&y.preRelease!==h.preRelease||!I(y.state,h.state)||m&&y.version!==h.version)}function P(y,h,m){const g=y.state,l=h.state,f=m?.state;if(!h.version||g&&i.gt(y.version,h.version))return g;if(l&&i.gt(h.version,y.version)||!g)return l;if(!l)return g;const p=(0,k.deepClone)(g),v=f?b(f,l):{added:Object.keys(l).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set},d=f?b(f,g):{added:Object.keys(g).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set};for(const n of[...v.added.values(),...v.updated.values()])p[n]=l[n];for(const n of v.removed.values())d.updated.has(n)||delete p[n];return p}function b(y,h){const m=Object.keys(y),g=Object.keys(h),l=g.filter(v=>m.indexOf(v)===-1).reduce((v,d)=>(v.add(d),v),new Set),f=m.filter(v=>g.indexOf(v)===-1).reduce((v,d)=>(v.add(d),v),new Set),p=new Set;for(const v of m){if(f.has(v))continue;const d=y[v],n=h[v];(0,k.equals)(d,n)||p.add(v)}return{added:l,removed:f,updated:p}}function I(y={},h={}){const{added:m,removed:g,updated:l}=b(y,h);return m.size===0&&g.size===0&&l.size===0}function C(y){return{...y,disabled:!!y.disabled,installed:!!y.installed}}function w(y,h){const m={identifier:{id:y.identifier.id,uuid:h.startsWith("uuid:")?h.substring(5):void 0},preRelease:!!y.preRelease};return y.version&&(m.version=y.version),y.disabled&&(m.disabled=!0),y.installed&&(m.installed=!0),y.state&&(m.state=y.state),m}}),define(oe[114],ae([0,1,20,16,4]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,P){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==R&&I!==`-${R}`),P&&b.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}updateSynchronizedExtensions(R,P){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==R&&I!==`-${R}`),P&&b.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}getIgnoredExtensions(R){const P=R.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),b=this.b().map(w=>w.toLowerCase()),I=[],C=[];if(Array.isArray(b))for(const w of b)w.startsWith("-")?C.push(w.substring(1)):I.push(w);return(0,k.distinct)([...P,...I].filter(w=>C.indexOf(w)===-1))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};A=pe([Y(0,i.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(oe[254],ae([0,1,20,35,32,193,60]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(v){return(0,i.parse)(v)||[]}e.parseKeybindings=R;async function P(v,d,n,r,t){const s=R(v),a=R(d),c=n?R(n):null,o=[...s,...a,...c||[]].map(W=>W.key),u=await t.resolveUserBindings(o),S=I(s,a,c,u);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:v,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};const E=w(s),M=w(a),N=c?w(c):null,j=h(E,M,u),$=N?h(N,E,u):{added:[...E.keys()].reduce((W,H)=>(W.add(H),W),new Set),removed:new Set,updated:new Set},L=N?h(N,M,u):{added:[...M.keys()].reduce((W,H)=>(W.add(H),W),new Set),removed:new Set,updated:new Set},F=b(j,$,L);let z=v;for(const W of F.removed.values())F.conflicts.has(W)||(z=f(z,W,r));for(const W of F.added.values()){if(F.conflicts.has(W))continue;const H=M.get(W);if(H.some(Q=>Q.command!==`-${W}`&&S.conflicts.has(u[Q.key]))){F.conflicts.add(W);continue}z=l(z,H,r)}for(const W of F.updated.values()){if(F.conflicts.has(W))continue;const H=M.get(W);if(H.some(Q=>Q.command!==`-${W}`&&S.conflicts.has(u[Q.key]))){F.conflicts.add(W);continue}z=p(z,W,H,r)}return{mergeContent:z,hasChanges:!0,hasConflicts:F.conflicts.size>0}}e.merge=P;function b(v,d,n){const r=new Set,t=new Set,s=new Set,a=new Set;for(const c of d.removed.values())n.updated.has(c)&&a.add(c);for(const c of n.removed.values())a.has(c)||(d.updated.has(c)?a.add(c):t.add(c));for(const c of d.added.values())a.has(c)||n.added.has(c)&&v.updated.has(c)&&a.add(c);for(const c of n.added.values())a.has(c)||(d.added.has(c)?v.updated.has(c)&&a.add(c):r.add(c));for(const c of d.updated.values())a.has(c)||n.updated.has(c)&&v.updated.has(c)&&a.add(c);for(const c of n.updated.values())a.has(c)||(d.updated.has(c)?v.updated.has(c)&&a.add(c):s.add(c));return{added:r,removed:t,updated:s,conflicts:a}}function I(v,d,n,r){const t=new Set,s=C(v,r),a=C(d,r),c=n?C(n,r):null,o=y(s,a);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const u=c?y(c,s):{added:[...s.keys()].reduce(($,L)=>($.add(L),$),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const S=c?y(c,a):{added:[...a.keys()].reduce(($,L)=>($.add(L),$),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:E,removed:M,updated:N,conflicts:j}=b(o,u,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:E,removed:M,updated:N,conflicts:j}}function C(v,d){const n=new Map;for(const r of v){const t=d[r.key];let s=n.get(t);s||(s=[],n.set(t,s)),s.push(r)}return n}function w(v){const d=new Map;for(const n of v){const r=n.command[0]==="-"?n.command.substring(1):n.command;let t=d.get(r);t||(t=[],d.set(r,t)),t.push(n)}return d}function y(v,d){const n=[...v.keys()],r=[...d.keys()],t=r.filter(c=>n.indexOf(c)===-1).reduce((c,o)=>(c.add(o),c),new Set),s=n.filter(c=>r.indexOf(c)===-1).reduce((c,o)=>(c.add(o),c),new Set),a=new Set;for(const c of n){if(s.has(c))continue;const o=v.get(c).map(S=>({...S,key:c})),u=d.get(c).map(S=>({...S,key:c}));(0,k.equals)(o,u,(S,E)=>g(S,E))||a.add(c)}return{added:t,removed:s,updated:a}}function h(v,d,n){const r=[...v.keys()],t=[...d.keys()],s=t.filter(o=>r.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),a=r.filter(o=>t.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),c=new Set;for(const o of r){if(a.has(o))continue;const u=v.get(o).map(E=>({...E,key:n[E.key]})),S=d.get(o).map(E=>({...E,key:n[E.key]}));m(u,S)||c.add(o)}return{added:s,removed:a,updated:c}}function m(v,d){return!(!(0,k.equals)(v.filter(({command:n})=>n[0]!=="-"),d.filter(({command:n})=>n[0]!=="-"),(n,r)=>g(n,r))||!(0,k.equals)(v.filter(({command:n})=>n[0]==="-"),d.filter(({command:n})=>n[0]==="-"),(n,r)=>g(n,r)))}function g(v,d){if(v.command!==d.command||v.key!==d.key)return!1;const n=A.ContextKeyExpr.deserialize(v.when),r=A.ContextKeyExpr.deserialize(d.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!D.equals(v.args,d.args))}function l(v,d,n){for(const r of d)v=T.edit(v,[-1],r,n);return v}function f(v,d,n){const r=R(v);for(let t=r.length-1;t>=0;t--)(r[t].command===d||r[t].command===`-${d}`)&&(v=T.edit(v,[t],void 0,n));return v}function p(v,d,n,r){const t=R(v),s=t.findIndex(a=>a.command===d||a.command===`-${d}`);for(let a=t.length-1;a>=0;a--)(t[a].command===d||t[a].command===`-${d}`)&&(v=T.edit(v,[a],void 0,r));for(let a=n.length-1;a>=0;a--)v=T.edit(v,[s],n[a],r);return v}}),define(oe[255],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(A,T,R){const P={},b={},I=new Set;if(!T)return{local:{added:P,updated:b,removed:[...I.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const C=i(A,T);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:P,updated:b,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=i(R,A),y=i(R,T),h={},m={},g=new Set,l=new Set;for(const f of w.removed.values())y.updated.has(f)?P[f]=T[f]:g.add(f);for(const f of y.removed.values())l.has(f)||(w.updated.has(f)?l.add(f):I.add(f));for(const f of w.updated.values())l.has(f)||(y.updated.has(f)?C.updated.has(f)&&l.add(f):m[f]=A[f]);for(const f of y.updated.values())l.has(f)||(w.updated.has(f)?C.updated.has(f)&&l.add(f):A[f]!==void 0&&(b[f]=T[f]));for(const f of w.added.values())l.has(f)||(y.added.has(f)?C.updated.has(f)&&l.add(f):h[f]=A[f]);for(const f of y.added.values())l.has(f)||(w.added.has(f)?C.updated.has(f)&&l.add(f):P[f]=T[f]);return{local:{added:P,removed:[...I.values()],updated:b},remote:{added:h,removed:[...g.values()],updated:m},conflicts:[...l.values()]}}e.merge=k;function i(A,T){const R=A?Object.keys(A):[],P=T?Object.keys(T):[],b=P.filter(w=>R.indexOf(w)===-1).reduce((w,y)=>(w.add(y),w),new Set),I=R.filter(w=>P.indexOf(w)===-1).reduce((w,y)=>(w.add(y),w),new Set),C=new Set;for(const w of R){if(I.has(w))continue;const y=A[w],h=T[w];y!==h&&C.add(w)}return{added:b,removed:I,updated:C}}function D(A,T){const{added:R,removed:P,updated:b}=i(A,T);return R.size===0&&P.size===0&&b.size===0}e.areSame=D}),define(oe[256],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(D,A,T,R){const P={added:[],removed:[],updated:[]};let b={added:[],removed:[],updated:[]};if(!A){const C=D.filter(({id:w})=>!R.includes(w));return C.length?b.added=C:b=null,{local:P,remote:b}}const I=i(D,A,R);if(I.added.length>0||I.removed.length>0||I.updated.length>0){const C=i(T,D,R),w=i(T,A,R);for(const y of w.removed){const h=D.find(m=>m.id===y);h&&P.removed.push(h)}for(const y of w.added){const h=A.find(m=>m.id===y);C.added.includes(y)?I.updated.includes(y)&&P.updated.push(h):P.added.push(h)}for(const y of w.updated)P.updated.push(A.find(h=>h.id===y));for(const y of C.added)w.added.includes(y)||b.added.push(D.find(h=>h.id===y));for(const y of C.updated)w.removed.includes(y)||w.updated.includes(y)||b.updated.push(D.find(h=>h.id===y));for(const y of C.removed){const h=A.find(m=>m.id===y);h&&b.removed.push(h)}}return b.added.length===0&&b.removed.length===0&&b.updated.length===0&&(b=null),{local:P,remote:b}}e.merge=k;function i(D,A,T){D=D?D.filter(({id:w})=>!T.includes(w)):[],A=A.filter(({id:w})=>!T.includes(w));const R=D.map(({id:w})=>w),P=A.map(({id:w})=>w),b=P.filter(w=>R.indexOf(w)===-1),I=R.filter(w=>P.indexOf(w)===-1),C=[];for(const{id:w,name:y,shortName:h}of D){if(I.includes(w))continue;const m=A.find(g=>g.id===w);(!m||m.name!==y||m.shortName!==h)&&C.push(w)}return{added:b,removed:I,updated:C}}}),define(oe[26],ae([0,1,20,13,179,46,29,4,104,40]),function(Z,e,k,i,D,A,T,R,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const a=b.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(a).filter(c=>!!a[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function C(){const a=b.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(a).filter(S=>!!a[S].ignoreSync),o=Object.keys(a).filter(S=>a[S].scope===2||a[S].scope===6),u=I();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...o,...u])}e.getDefaultIgnoredSettings=C,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function w(){const a="vscode://schemas/ignoredSettings",c=b.Registry.as(A.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=b.Registry.as(P.Extensions.JSONContribution),u=()=>{const S=I(),E=C().filter($=>$!==e.CONFIGURATION_SYNC_STORE_KEY),M=Object.keys(A.allSettings.properties).filter($=>E.indexOf($)===-1),N=E.filter($=>S.indexOf($)===-1),j={items:{type:"string",enum:[...M,...N.map($=>`-${$}`)]}};o.registerSchema(a,j)};return c.onDidUpdateConfiguration(()=>u())}e.registerConfiguration=w;function y(a){return a&&(0,i.isObject)(a)&&(0,i.isString)(a.id)&&Array.isArray(a.scopes)}e.isAuthenticationProvider=y;var h;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Tasks="tasks",a.Extensions="extensions",a.GlobalState="globalState",a.Profiles="profiles"})(h=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function m(a,...c){return a?[a,...c]:c}e.getPathSegments=m;function g(a,c,o,u){return u.joinPath(o.userDataSyncHome,...m(a,c,`lastSync${c}.json`))}e.getLastSyncResourceUri=g,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function l(a){const c={};return c[e.HEADER_EXECUTION_ID]=a,c}e.createSyncHeaders=l;var f;(function(a){a.Unauthorized="Unauthorized",a.NotFound="NotFound",a.MethodNotFound="MethodNotFound",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.RequestProtocolNotSupported="RequestProtocolNotSupported",a.RequestPathNotEscaped="RequestPathNotEscaped",a.RequestHeadersNotObject="RequestHeadersNotObject",a.NoCollection="NoCollection",a.NoRef="NoRef",a.EmptyResponse="EmptyResponse",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyProfiles="LocalTooManyProfiles",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.Unknown="Unknown"})(f=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(c,o,u,S){super(c),this.code=o,this.resource=u,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class v extends p{constructor(c,o,u,S,E){super(c,u,void 0,E),this.url=o,this.serverCode=S}}e.UserDataSyncStoreError=v;class d extends p{constructor(c,o){super(c,o)}}e.UserDataAutoSyncError=d,function(a){function c(o){if(o instanceof a)return o;const u=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(u&&u[1]){const S=u[2]==="unknown"?void 0:u[2],E=u[3]==="unknown"?void 0:u[3];return new a(o.message,u[1],S,E)}return new a(o.message,"Unknown")}a.toUserDataSyncError=c}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var r;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(a){return`sync.enable.${a}`}e.getEnablementKey=s,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(oe[257],ae([0,1,32,26]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(T,R,P,b,I){if(!R)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const C=A(T,R);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=P?A(P,R):{added:Object.keys(R).reduce((f,p)=>(f.add(p),f),new Set),removed:new Set,updated:new Set},y=P?A(P,T):{added:Object.keys(T).reduce((f,p)=>(f.add(p),f),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},m=k.deepClone(R),g=!P;for(const f of y.added.values())f!==i.SYNC_SERVICE_URL_TYPE&&g&&w.added.has(f)||(m[f]=T[f]);for(const f of y.updated.values())m[f]=T[f];for(const f of y.removed.values())b.unregistered.includes(f)||delete m[f];for(const f of w.added.values()){const p=R[f];if(b.machine.includes(f)){I.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(P&&y.added.has(f))continue;const v=T[f];v&&v.value===p.value||f===i.SYNC_SERVICE_URL_TYPE&&g&&y.added.has(f)||(v?h.updated[f]=p:h.added[f]=p)}for(const f of w.updated.values()){const p=R[f];if(b.machine.includes(f)){I.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(y.updated.has(f)||y.removed.has(f))continue;const v=T[f];v&&v.value===p.value||(h.updated[f]=p)}for(const f of w.removed.values()){if(b.machine.includes(f)){I.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}y.updated.has(f)||y.removed.has(f)||h.removed.push(f)}const l=A(R,m);return{local:h,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:m}}}e.merge=D;function A(T,R){const P=Object.keys(T),b=Object.keys(R),I=b.filter(y=>P.indexOf(y)===-1).reduce((y,h)=>(y.add(h),y),new Set),C=P.filter(y=>b.indexOf(y)===-1).reduce((y,h)=>(y.add(h),y),new Set),w=new Set;for(const y of P){if(C.has(y))continue;const h=T[y],m=R[y];k.equals(h,m)||w.add(y)}return{added:I,removed:C,updated:w}}}),define(oe[258],ae([0,1,20,35,83,43,32,60,26]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function b(o,u,S){let E=[];S?E=C(S):E=I(u);const M=[],N=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const j of E)j.startsWith("-")?N.push(j.substring(1)):M.push(j);return(0,k.distinct)([...o,...M].filter(j=>N.indexOf(j)===-1))}e.getIgnoredSettings=b;function I(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function C(o){const u=(0,i.parse)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function w(o,u){const S=(0,i.parse)(o)||{};let E="{}";for(const M of Object.keys(S)){const N=(0,D.setProperty)(E,[M],S[M],u);E=(0,D.applyEdits)(E,N)}return E}e.removeComments=w;function y(o,u,S,E){if(S.length){const M=c(u),N=(0,i.parse)(u)||{},j=(0,i.parse)(o);if(!j)return o;const $=[];for(const L of S){const F=N[L],z=j[L];F===void 0?o=R.edit(o,[L],void 0,E):z!==void 0?o=R.edit(o,[L],F,E):$.push(n(L,M))}$.sort((L,F)=>L.startOffset-F.startOffset),$.forEach(L=>o=f(L.setting.key,u,o,E))}return o}e.updateIgnoredSettings=y;function h(o,u,S,E,M,N){const j=y(o,u,E,N),$=S!==j,L=S!==u;if(!$&&!L)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if($&&!L)return{conflictsSettings:[],localContent:null,remoteContent:j,hasConflicts:!1};if(L&&!$)return{conflictsSettings:[],localContent:y(u,o,E,N),remoteContent:null,hasConflicts:!1};if(S===null&&g(o)){const B=m(o,u,E)?null:y(u,o,E,N);return{conflictsSettings:[],localContent:B,remoteContent:null,hasConflicts:!1}}let F=o,z=u;const W=(0,i.parse)(o),H=(0,i.parse)(u),Q=S?(0,i.parse)(S):null,K=E.reduce((B,X)=>(B.add(X),B),new Set),V=l(W,H,K),G=l(Q,W,K),x=l(Q,H,K),ne=new Map,se=new Set,ie=B=>{se.add(B);const X=M.filter(({key:ee})=>ee===B)[0];X?(F=R.edit(F,[B],X.value,N),z=R.edit(z,[B],X.value,N)):ne.set(B,{key:B,localValue:W[B],remoteValue:H[B]})};for(const B of G.removed.values())x.updated.has(B)?ie(B):z=R.edit(z,[B],void 0,N);for(const B of x.removed.values())se.has(B)||(G.updated.has(B)?ie(B):F=R.edit(F,[B],void 0,N));for(const B of G.updated.values())se.has(B)||(x.updated.has(B)?V.updated.has(B)&&ie(B):z=R.edit(z,[B],W[B],N));for(const B of x.updated.values())se.has(B)||(G.updated.has(B)?V.updated.has(B)&&ie(B):F=R.edit(F,[B],H[B],N));for(const B of G.added.values())se.has(B)||(x.added.has(B)?V.updated.has(B)&&ie(B):z=f(B,F,z,N));for(const B of x.added.values())se.has(B)||(G.added.has(B)?V.updated.has(B)&&ie(B):F=f(B,z,F,N));const O=ne.size>0||!m(F,z,E),U=O||!m(F,o,[]),q=O||!m(z,u,[]);return{localContent:U?F:null,remoteContent:q?z:null,conflictsSettings:[...ne.values()],hasConflicts:O}}e.merge=h;function m(o,u,S){if(o===u)return!0;const E=(0,i.parse)(o),M=(0,i.parse)(u),N=S.reduce((L,F)=>(L.add(F),L),new Set),j=c(o).filter(L=>!(L.setting&&N.has(L.setting.key))),$=c(u).filter(L=>!(L.setting&&N.has(L.setting.key)));if(j.length!==$.length)return!1;for(let L=0;L<j.length;L++){const F=j[L],z=$[L];if(F.setting&&z.setting){if(F.setting.key!==z.setting.key||!T.equals(E[F.setting.key],M[F.setting.key]))return!1}else if(!F.setting&&!z.setting){if(F.value!==z.value)return!1}else return!1}return!0}e.areSame=m;function g(o){return o?c(o).length===0:!0}e.isEmpty=g;function l(o,u,S){const E=o?Object.keys(o).filter(L=>!S.has(L)):[],M=Object.keys(u).filter(L=>!S.has(L)),N=M.filter(L=>E.indexOf(L)===-1).reduce((L,F)=>(L.add(F),L),new Set),j=E.filter(L=>M.indexOf(L)===-1).reduce((L,F)=>(L.add(F),L),new Set),$=new Set;if(o)for(const L of E){if(j.has(L))continue;const F=o[L],z=u[L];T.equals(F,z)||$.add(L)}return{added:N,removed:j,updated:$}}function f(o,u,S,E){const M=(0,i.parse)(u),N=c(u),j=c(S),$=p(o,N,j);return v(S,o,M[o],$,j,E)}e.addSetting=f;function p(o,u,S){const E=u.findIndex(N=>N.setting?.key===o),M=u[E-1];if(M){if(M.setting){const j=n(M.setting.key,S);if(j)return{index:S.indexOf(j),insertAfter:!0}}else{const j=r(E,u);if(j){const $=n(j.setting.key,S);if($){const L=t(S.indexOf($),S),F=s(u,j,u[E]);if(L){const z=s(S,$,L),W=a(F,z);return W?{index:S.indexOf(W),insertAfter:!0}:{index:S.indexOf(L),insertAfter:!1}}else{const z=s(S,$,S[S.length-1]),W=a(F,z);return W?{index:S.indexOf(W),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const N=u[E+1];if(N)if(N.setting){const j=n(N.setting.key,S);if(j)return{index:S.indexOf(j),insertAfter:!1}}else{const j=t(E,u);if(j){const $=n(j.setting.key,S);if($){const L=r(S.indexOf($),S),F=s(u,u[E],j);if(L){const z=s(S,L,$),W=a(F.reverse(),z.reverse());return W?{index:S.indexOf(W),insertAfter:!1}:{index:S.indexOf(L),insertAfter:!0}}else{const z=s(S,S[0],$),W=a(F.reverse(),z.reverse());return W?{index:S.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function v(o,u,S,E,M,N){let j;return E.index===-1?j=(0,D.setProperty)(o,[u],S,N):j=d(o,u,S,E,M,N).map($=>(0,D.withFormatting)(o,$,N)[0]),(0,D.applyEdits)(o,j)}function d(o,u,S,E,M,N){const j=`${JSON.stringify(u)}: ${JSON.stringify(S)}`,$=(0,A.getEOL)(N,o),L=M[E.index];if(E.insertAfter){const F=[];if(L.setting)F.push({offset:L.endOffset,length:0,content:","+j});else{const z=t(E.index,M),W=r(E.index,M),H=W?.setting?.commaOffset;W&&H===void 0&&F.push({offset:W.endOffset,length:0,content:","});const Q=H!==void 0&&H>L.endOffset;F.push({offset:Q?H+1:L.endOffset,length:0,content:z?$+j+",":$+j})}return F}else{if(L.setting)return[{offset:L.startOffset,length:0,content:j+","}];const F=(M[E.index-1]&&!M[E.index-1].setting?$:"")+j+(t(E.index,M)?",":"")+$;return[{offset:L.startOffset,length:0,content:F}]}}function n(o,u){return u.filter(S=>S.setting?.key===o)[0]}function r(o,u){for(let S=o-1;S>=0;S--)if(u[S].setting)return u[S]}function t(o,u){for(let S=o+1;S<u.length;S++)if(u[S].setting)return u[S]}function s(o,u,S){const E=o.indexOf(u),M=o.indexOf(S);return o.filter((N,j)=>E<j&&j<M)}function a(o,u){if(o.length&&u.length){let S=0;for(;S<u.length&&S<o.length;S++)if(o[S].value!==u[S].value)return u[S-1];return u[S-1]}}function c(o){const u=[];let S=-1,E,M;const N={onObjectBegin:j=>{S++},onObjectProperty:(j,$,L)=>{S===0&&(E=$,M=j)},onObjectEnd:(j,$)=>{S--,S===0&&u.push({startOffset:E,endOffset:j+$,value:o.substring(E,j+$),setting:{key:M,commaOffset:void 0}})},onArrayBegin:(j,$)=>{S++},onArrayEnd:(j,$)=>{S--,S===0&&u.push({startOffset:E,endOffset:j+$,value:o.substring(E,j+$),setting:{key:M,commaOffset:void 0}})},onLiteralValue:(j,$,L)=>{S===0&&u.push({startOffset:E,endOffset:$+L,value:o.substring(E,$+L),setting:{key:M,commaOffset:void 0}})},onSeparator:(j,$,L)=>{if(S===0&&j===","){let F=u.length-1;for(;F>=0&&!u[F].setting;F--);const z=u[F];z&&u.splice(F,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:$}})}},onComment:(j,$)=>{S===0&&u.push({startOffset:j,endOffset:j+$,value:o.substring(j,j+$)})}};return(0,i.visit)(o,N),u}}),define(oe[78],ae([0,1,3,2,4,26]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let T=class extends i.Disposable{get account(){return this.a}constructor(P,b){super(),this.g=P,this.h=b,this.b=this.B(new k.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new k.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(P.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(P.onTokenSucceed(()=>this.f=!1))}async updateAccount(P){(P&&this.a?P.token!==this.a.token||P.authenticationProviderId!==this.a.authenticationProviderId:P!==this.a)&&(this.a=P,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(P))}};T=pe([Y(0,A.IUserDataSyncStoreService),Y(1,A.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(oe[259],ae([0,1,2,7]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(w){this.a=w}listen(w,y){switch(y){case"onError":return this.a.onError}throw new Error(`Event not found: ${y}`)}call(w,y,h){switch(y){case"triggerSync":return this.a.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class A{constructor(w){this.a=w}listen(w,y){throw new Error(`Event not found: ${y}`)}call(w,y,h){switch(y){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(i.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class T{constructor(w){this.a=w}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(w){return this.a.call("resolveUserKeybindings",[w])}async resolveFormattingOptions(w){return this.a.call("resolveFormattingOptions",[w])}}e.UserDataSyncUtilServiceClient=T;class R{constructor(w){this.a=w}listen(w,y){switch(y){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${y}`)}async call(w,y,h){switch(y){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(h[0],h[1]);case"setEnablements":return this.a.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class P{constructor(w){this.a=w}listen(w,y){switch(y){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(w,y,h){switch(y){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class b{constructor(w){this.a=w}listen(w,y){switch(y){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(w,y,h){switch(y){case"switch":return this.a.switch(h[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class I extends k.Disposable{constructor(w){super(),this.a=w,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(w){return this.a.call("switch",[w])}async getPreviousUserDataSyncStore(){const w=await this.a.call("getPreviousUserDataSyncStore");return this.b(w)}b(w){return{url:i.URI.revive(w.url),type:w.type,defaultUrl:i.URI.revive(w.defaultUrl),insidersUrl:i.URI.revive(w.insidersUrl),stableUrl:i.URI.revive(w.stableUrl),canSwitch:w.canSwitch,authenticationProviders:w.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(oe[260],ae([0,1,15,8]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends i.AbstractLogger{constructor(T,R){super(),this.g=this.B(T.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...R){this.g.trace(T,...R)}debug(T,...R){this.g.debug(T,...R)}info(T,...R){this.g.info(T,...R)}warn(T,...R){this.g.warn(T,...R)}error(T,...R){this.g.error(T,...R)}flush(){this.g.flush()}};D=pe([Y(0,i.ILoggerService),Y(1,k.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(oe[261],ae([0,1,6,3,2]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends D.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:P,getActiveWindowId:b}){super(),this.a=this.B(new D.DisposableStore),i.Event.latch(i.Event.any(R,P))(this.f,this,this.a),this.b=(0,k.createCancelablePromise)(()=>b()),(async()=>{try{const C=await this.b;this.c=typeof this.c=="number"?this.c:C}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(oe[115],ae([0,1,182,12,49,23,7,4,22]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function b(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=b;function I(t){return typeof t?.id=="string"&&!b(t)&&!w(t)}e.isEmptyWorkspaceIdentifier=I,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function C(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,i.basename)(t)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=t;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=C;function w(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=w;function y(t){const s=t;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const a=t;if(a?.configPath)return{id:a.id,configPath:T.URI.revive(a.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=y;var h;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(h=e.WorkbenchState||(e.WorkbenchState={}));function m(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=m;function g(t){const s=t;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=g;class l{constructor(s,a,c,o,u){this.h=s,this.j=c,this.k=o,this.l=u,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class f{constructor(s,a){this.raw=a,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function p(t){return new f({uri:t,index:0,name:(0,A.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(t,s){return A.extUriBiasedIgnorePathCase.isEqualOrParent(t,s.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function d(t){let s;return T.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=d;function n(t,s){return!v(t,s)&&!d(t)}e.isSavedWorkspace=n;function r(t){return(typeof t=="string"?(0,i.extname)(t):(0,A.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(oe[18],ae([0,1,66,3,2,23,7,174,15,14,4,8,115,37,30,6,31,27,13]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function p(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&T.URI.isUri(s.location)&&T.URI.isUri(s.globalStorageHome)&&T.URI.isUri(s.settingsResource)&&T.URI.isUri(s.keybindingsResource)&&T.URI.isUri(s.tasksResource)&&T.URI.isUri(s.snippetsHome)&&T.URI.isUri(s.extensionsResource))}e.isUserDataProfile=p,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function v(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:T.URI.revive(t.location).with({scheme:s}),globalStorageHome:T.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:T.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:T.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:T.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:T.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:T.URI.revive(t.extensionsResource)?.with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=v;function d(t,s,a,c){return{id:t,name:s,location:a,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,A.joinPath)(a,"globalStorage"),settingsResource:(0,A.joinPath)(a,"settings.json"),keybindingsResource:(0,A.joinPath)(a,"keybindings.json"),tasksResource:(0,A.joinPath)(a,"tasks.json"),snippetsHome:(0,A.joinPath)(a,"snippets"),extensionsResource:(0,A.joinPath)(a,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=d;let n=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(s,a,c,o){super(),this.m=s,this.n=a,this.r=c,this.s=o,this.f=!1,this.g=this.B(new i.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new i.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new i.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new i.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new y.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(s){this.f!==s&&(this.t=void 0,this.f=s)}isEnabled(){return this.f}get u(){if(!this.t){const s=[];if(this.f)for(const u of this.G()){if(!u.name||!(0,f.isString)(u.name)||!u.location){this.s.warn("Skipping the invalid stored profile",u.location||u.name);continue}s.push(d((0,A.basename)(u.location),u.name,u.location,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}))}const a=new y.ResourceMap,c=new Map,o=d((0,k.hash)(this.m.userRoamingDataHome.path).toString(16),(0,R.localize)(0,null),this.m.userRoamingDataHome);if(s.unshift({...o,extensionsResource:this.L()??o.extensionsResource,isDefault:!0}),s.length){const u=this.I();if(u.workspaces)for(const[S,E]of Object.entries(u.workspaces)){const M=T.URI.parse(S),N=T.URI.parse(E),j=s.find($=>this.r.extUri.isEqual($.location,N));j&&a.set(M,j)}if(u.emptyWindows)for(const[S,E]of Object.entries(u.emptyWindows)){const M=T.URI.parse(E),N=s.find(j=>this.r.extUri.isEqual(j.location,M));N&&c.set(S,N)}}this.t={profiles:s,workspaces:a,emptyWindows:c}}return this.t}async createTransientProfile(s){const a="Temp",c=new RegExp(`${(0,l.escapeRegExpCharacters)(a)}\\s(\\d+)`);let o=0;for(const S of this.profiles){const E=c.exec(S.name),M=E?parseInt(E[1]):0;o=M>o?M:o}const u=`${a} ${o+1}`;return this.createProfile((0,k.hash)((0,g.generateUuid)()).toString(16),u,{transient:!0},s)}async createNamedProfile(s,a,c){return this.createProfile((0,k.hash)((0,g.generateUuid)()).toString(16),s,a,c)}async createProfile(s,a,c,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.v(s,a,c);return o&&await this.setProfileForWorkspace(o,u),u}async v(s,a,c){if(!(0,f.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(a);return o||(o=(async()=>{try{const u=this.profiles.find(M=>M.name===a||M.id===s);if(u)return u;const S=d(s,a,(0,A.joinPath)(this.profilesHome,s),c);await this.n.createFolder(S.location);const E=[];return this.h.fire({profile:S,join(M){E.push(M)}}),await m.Promises.settled(E),this.z([S],[],[]),S}finally{this.k.delete(a)}})(),this.k.set(a,o)),o}async updateProfile(s,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(o=>o.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);return c=d(c.id,a.name??c.name,c.location,{shortName:a.shortName??c.shortName,transient:a.transient??c.isTransient,useDefaultFlags:a.useDefaultFlags??c.useDefaultFlags}),this.z([],[],[c]),c}async removeProfile(s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(s.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(o=>o.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);const c=[];this.i.fire({profile:a,join(o){c.push(o)}});try{await Promise.allSettled(c)}catch(o){this.s.error(o)}for(const o of[...this.u.emptyWindows.keys()])a.id===this.u.emptyWindows.get(o)?.id&&this.u.emptyWindows.delete(o);for(const o of[...this.u.workspaces.keys()])a.id===this.u.workspaces.get(o)?.id&&this.u.workspaces.delete(o);this.F(),this.z([],[a],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(a.location,{recursive:!0})}catch(o){this.s.error(o)}}async setProfileForWorkspace(s,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(o=>o.id===a.id);if(!c)throw new Error(`Profile '${a.name}' does not exist`);this.D(s,c)}unsetWorkspace(s,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(s,void 0,a)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const s=await this.n.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(a=>a.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,a.resource))).map(a=>this.n.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.l.profiles.filter(a=>!this.y(a));await Promise.allSettled(s.map(a=>this.removeProfile(a)))}getProfileForWorkspace(s){const a=this.w(s);return T.URI.isUri(a)?this.l.workspaces.get(a)??this.u.workspaces.get(a):this.l.emptyWindows.get(a)??this.u.emptyWindows.get(a)}w(s){return(0,w.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,w.isWorkspaceIdentifier)(s)?s.configPath:s.id}y(s){return!!([...this.l.emptyWindows.values()].some(a=>this.r.extUri.isEqual(a.location,s.location))||[...this.l.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,s.location))||[...this.u.emptyWindows.values()].some(a=>this.r.extUri.isEqual(a.location,s.location))||[...this.u.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,s.location)))}z(s,a,c){const o=[...this.profiles,...s],u=[];this.l.profiles=[];for(let S of o)S.isDefault||a.some(E=>S.id===E.id)||(S=c.find(E=>S.id===E.id)??S,S.isTransient?this.l.profiles.push(S):u.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.H(u),this.t=void 0,this.C(s,a,c)}C(s,a,c){this.g.fire({added:s,removed:a,updated:c,all:this.profiles})}D(s,a,c){c=a?.isTransient?!0:c,c||this.D(s,void 0,!0);const o=this.w(s),u=c?this.l:this.u;T.URI.isUri(o)?(u.workspaces.delete(o),a&&u.workspaces.set(o,a)):(u.emptyWindows.delete(o),a&&u.emptyWindows.set(o,a)),c||this.F()}F(){const s={};for(const[c,o]of this.u.workspaces.entries())s[c.toString()]=o.location.toString();const a={};for(const[c,o]of this.u.emptyWindows.entries())a[c.toString()]=o.location.toString();this.J({workspaces:s,emptyWindows:a}),this.t=void 0}G(){return[]}H(s){throw new Error("not implemented")}I(){return{}}J(s){throw new Error("not implemented")}L(){}};n.b="userDataProfiles",n.c="profileAssociations",n=pe([Y(0,P.IEnvironmentService),Y(1,b.IFileService),Y(2,h.IUriIdentityService),Y(3,C.ILogService)],n),e.UserDataProfilesService=n;class r extends n{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(s){this.a=s}I(){return this.O}J(s){this.O=s}}e.InMemoryUserDataProfilesService=r}),define(oe[262],ae([0,1,6,2,18]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends i.Disposable{constructor(R){super(),this.B(new k.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};A=pe([Y(0,D.IUserDataProfilesService)],A),e.UserDataProfilesCleaner=A}),define(oe[263],ae([0,1,20,6,24,9,3,2,5,7,155,29,33,42,8,25,21,18]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=class extends R.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,s,a,c,o){super(),this.t=t,this.u=s,this.v=a,this.w=c,this.y=o,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new T.Emitter),this.m=this.B(new T.Emitter),this.n=this.B(new T.Emitter),this.p=this.B(new T.Emitter),this.s=[],this.B((0,R.toDisposable)(()=>{this.j.forEach(({task:u})=>u.cancel()),this.k.forEach(u=>u.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const s=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,C.isTargetPlatformCompatible)(a,t.allTargetPlatforms,s))}async installFromGallery(t,s={}){try{if(!this.t.isEnabled())throw new C.ExtensionManagementError(I.localize(0,null),C.ExtensionManagementErrorCode.Internal);const a=await this.G(t,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.z(a.manifest,a.extension,s)}catch(a){throw d(this.u,"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(t),error:a}),this.v.error("Failed to install extension.",t.identifier.id),this.v.error(a),v(a)}}async uninstall(t,s={}){return this.v.trace("ExtensionManagementService#uninstall",t.identifier.id),this.I(t,s)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.O(),this.h=t),this.g}registerParticipant(t){this.s.push(t)}async z(t,s,a){const c={...a,installOnlyNewlyAddedFromExtensionPack:b.URI.isUri(s)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,y.isApplicationScopedExtension)(t)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},o=j=>`${w.ExtensionKey.create(j).toString()}${c.profileLocation?`-${c.profileLocation.toString()}`:""}`;if(!b.URI.isUri(s)){const j=this.j.get(o(s));if(j){this.v.info("Extensions is already requested to install",s.identifier.id);const{local:$}=await j.task.waitUntilTaskIsFinished();return $}}const u=[],S=[],E=[],M=this.Q(t,s,c);b.URI.isUri(s)||this.j.set(o(s),{task:M,waitingTasks:[]}),this.l.fire({identifier:M.identifier,source:s,profileLocation:c.profileLocation}),this.v.info("Installing extension:",M.identifier.id),u.push({task:M,manifest:t});let N=!1;try{if(c.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const $=await this.F(M.identifier,t,!!c.installOnlyNewlyAddedFromExtensionPack,!!c.installPreReleaseVersion,c.profileLocation),L=await this.getInstalled(void 0,c.profileLocation);for(const{gallery:F,manifest:z}of(0,k.distinct)($,({gallery:W})=>W.identifier.id)){N=N||!!z.extensionDependencies?.some(Q=>(0,w.areSameExtensions)({id:Q},M.identifier));const W=o(F),H=this.j.get(W);if(H){if(this.C(M,H.task)){const Q=H.task.identifier;this.v.info("Waiting for already requested installing extension",Q.id,M.identifier.id),H.waitingTasks.push(M),S.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,K=>K.some(V=>(0,w.areSameExtensions)(V.identifier,Q)))).then(K=>{if(this.v.info("Finished waiting for already requested installing extension",Q.id,M.identifier.id),!K.find(G=>(0,w.areSameExtensions)(G.identifier,Q))?.local)throw new Error(`Extension ${Q.id} is not installed`)}))}}else if(!L.some(({identifier:Q})=>(0,w.areSameExtensions)(Q,F.identifier))){const Q=this.Q(z,F,{...c,donotIncludePackAndDependencies:!0});this.j.set(W,{task:Q,waitingTasks:[M]}),this.l.fire({identifier:Q.identifier,source:F,profileLocation:c.profileLocation}),this.v.info("Installing extension:",Q.identifier.id,M.identifier.id),u.push({task:Q,manifest:z})}}}catch($){if(b.URI.isUri(M.source))(0,k.isNonEmptyArray)(t.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",M.identifier.id,$.message),(0,k.isNonEmptyArray)(t.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",M.identifier.id,$.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),$}const j=u.reduce(($,{task:L,manifest:F})=>($.set(L.identifier.id.toLowerCase(),{task:L,manifest:F}),$),new Map);for(;j.size;){let $;const L=[...j.values()].filter(({manifest:F})=>!F.extensionDependencies?.some(z=>j.has(z.toLowerCase())));L.length?$=j.size===1?L:L.filter(({task:F})=>!(F===M&&!N)):(this.v.info("Found extensions with circular dependencies",L.map(({task:F})=>F.identifier.id)),$=[...j.values()]),await this.D($.map(async({task:F})=>{const z=new Date().getTime();try{const{local:W}=await F.run();if(await this.D(this.s.map(H=>H.postInstall(W,F.source,c,D.CancellationToken.None))),!b.URI.isUri(F.source)){const H=F.operation===3,Q=H?void 0:(new Date().getTime()-F.source.lastUpdated)/1e3;if(d(this.u,H?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(F.source),wasVerified:F.wasVerified,duration:new Date().getTime()-z,durationSinceUpdate:Q}),P.isWeb&&F.operation!==3)try{await this.t.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch{}}E.push({local:W,identifier:F.identifier,operation:F.operation,source:F.source,context:c.context,profileLocation:c.profileLocation,applicationScoped:W.isApplicationScoped})}catch(W){throw b.URI.isUri(F.source)||d(this.u,F.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(F.source),wasVerified:F.wasVerified,duration:new Date().getTime()-z,error:W}),this.v.error("Error while installing the extension:",F.identifier.id),W}finally{j.delete(F.identifier.id.toLowerCase())}}))}return S.length&&await this.D(S),E.forEach(({identifier:$})=>this.v.info("Extension installed successfully:",$.id)),this.m.fire(E),E.filter(({identifier:$})=>(0,w.areSameExtensions)($,M.identifier))[0].local}catch(j){if(u.forEach(({task:$})=>$.cancel()),E.length)try{const $=await Promise.allSettled(E.map(({local:L})=>this.R(L,{versionOnly:!0,profileLocation:c.profileLocation}).run()));for(let L=0;L<$.length;L++){const F=$[L],{identifier:z}=E[L];F.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",z.id):this.v.warn("Rollback: Error while uninstalling extension",z.id,(0,A.getErrorMessage)(F.reason))}}catch($){this.v.warn("Error while rolling back extensions",(0,A.getErrorMessage)($),E.map(({identifier:L})=>L.id))}throw this.m.fire(u.map(({task:$})=>({identifier:$.identifier,operation:2,source:$.source,context:c.context,profileLocation:c.profileLocation}))),j}finally{for(const{task:j}of u)j.source&&!b.URI.isUri(j.source)&&this.j.delete(o(j.source))}}C(t,s){for(const[,{task:a,waitingTasks:c}]of this.j.entries())if(a===t&&(c.includes(s)||c.some(o=>this.C(o,s)))||a===s&&c[0]&&!this.C(t,c[0]))return!1;return!0}async D(t){const s=[],a=[],c=await Promise.allSettled(t);for(const o of c)o.status==="fulfilled"?s.push(o.value):a.push(o.reason);if(a.length)throw p(a);return s}async F(t,s,a,c,o){if(!this.t.isEnabled())return[];const u=await this.getInstalled(void 0,o),S=[],E=[],M=async(N,j)=>{S.push(N);const $=j.extensionDependencies||[],L=[...$];if(j.extensionPack){const F=a?u.find(z=>(0,w.areSameExtensions)(z.identifier,N)):void 0;for(const z of j.extensionPack)F&&F.manifest.extensionPack&&F.manifest.extensionPack.some(W=>(0,w.areSameExtensions)({id:W},{id:z}))||L.every(W=>!(0,w.areSameExtensions)({id:W},{id:z}))&&L.push(z)}if(L.length){const F=L.filter(z=>S.every(W=>!(0,w.areSameExtensions)(W,{id:z})));if(F.length){const z=await this.t.getExtensions(F.map(W=>({id:W,preRelease:c})),D.CancellationToken.None);for(const W of z){if(S.find(K=>(0,w.areSameExtensions)(K,W.identifier)))continue;const H=$.some(K=>(0,w.areSameExtensions)({id:K},W.identifier));let Q;try{Q=await this.G(W,!1,c)}catch(K){if(K instanceof C.ExtensionManagementError&&K.code===C.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!H){this.v.info("Skipping the packed extension as it cannot be installed",W.identifier.id);continue}else throw K}E.push({gallery:Q.extension,manifest:Q.manifest}),await M(Q.extension.identifier,Q.manifest)}}}};return await M(t,s),E}async G(t,s,a){if((await this.getExtensionsControlManifest()).malicious.some(S=>(0,w.areSameExtensions)(t.identifier,S)))throw new C.ExtensionManagementError(I.localize(1,null,t.identifier.id),C.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const S=await this.getTargetPlatform();throw new C.ExtensionManagementError(I.localize(2,null,t.identifier.id,this.w.nameLong,(0,C.TargetPlatformToString)(S)),C.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.H(t,s,a);if(o){if(a&&!s&&t.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new C.ExtensionManagementError(I.localize(3,null,t.identifier.id,this.w.nameLong,this.w.version),C.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&t.properties.isPreReleaseVersion&&(await this.t.getExtensions([t.identifier],D.CancellationToken.None))[0]?new C.ExtensionManagementError(I.localize(4,null,t.identifier.id),C.ExtensionManagementErrorCode.ReleaseVersionNotFound):new C.ExtensionManagementError(I.localize(5,null,t.identifier.id,this.w.nameLong,this.w.version),C.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",o.identifier.id);const u=await this.t.getManifest(o,D.CancellationToken.None);if(u===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);if(u.version!==o.version)throw new C.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,C.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:u}}async H(t,s,a){const c=await this.getTargetPlatform();let o=null;return!s&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(o=(await this.t.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:c,compatible:!0},D.CancellationToken.None))[0]||null),!o&&await this.t.isExtensionCompatible(t,a,c)&&(o=t),o||(s?o=(await this.t.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},D.CancellationToken.None))[0]||null:o=await this.t.getCompatibleExtension(t,a,c)),o}async I(t,s){const a={...s,profileLocation:t.isApplicationScoped?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},c=N=>`${N.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,o=this.k.get(c(t.identifier));if(o)return this.v.info("Extensions is already requested to uninstall",t.identifier.id),o.waitUntilTaskIsFinished();const u=N=>{const j=this.R(N,a);return this.k.set(c(j.extension.identifier),j),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${N.identifier.id}@${N.manifest.version}`),this.n.fire({identifier:N.identifier,profileLocation:a.profileLocation,applicationScoped:N.isApplicationScoped}),j},S=(N,j)=>{j?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,a.profileLocation.toString(),j.message):this.v.error("Failed to uninstall extension:",`${N.identifier.id}@${N.manifest.version}`,j.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${N.identifier.id}@${N.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${N.identifier.id}@${N.manifest.version}`),d(this.u,"extensionGallery:uninstall",{extensionData:(0,w.getLocalExtensionTelemetryData)(N),error:j}),this.p.fire({identifier:N.identifier,error:j?.code,profileLocation:a.profileLocation,applicationScoped:N.isApplicationScoped})},E=[],M=[];try{E.push(u(t));const N=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const j=this.M(t,N);for(const $ of j)this.k.has(c($.identifier))?this.v.info("Extensions is already requested to uninstall",$.identifier.id):E.push(u($))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.J(E.map(j=>j.extension),N,t),await this.D(E.map(async j=>{try{if(await j.run(),await this.D(this.s.map($=>$.postUninstall(j.extension,a,D.CancellationToken.None))),j.extension.identifier.uuid)try{await this.t.reportStatistic(j.extension.manifest.publisher,j.extension.manifest.name,j.extension.manifest.version,"uninstall")}catch{}S(j.extension)}catch($){const L=$ instanceof C.ExtensionManagementError?$:new C.ExtensionManagementError((0,A.getErrorMessage)($),C.ExtensionManagementErrorCode.Internal);throw S(j.extension,L),L}finally{M.push(j)}}))}catch(N){const j=N instanceof C.ExtensionManagementError?N:new C.ExtensionManagementError((0,A.getErrorMessage)(N),C.ExtensionManagementErrorCode.Internal);for(const $ of E){try{$.cancel()}catch{}M.includes($)||S($.extension,j)}throw j}finally{for(const N of E)this.k.delete(c(N.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",N.extension.identifier.id)}}J(t,s,a){for(const c of t){const o=this.N(c,s);if(o.length){const u=o.filter(S=>!t.some(E=>(0,w.areSameExtensions)(E.identifier,S.identifier)));if(u.length)throw new Error(this.L(c,u,a))}}}L(t,s,a){return a===t?s.length===1?I.localize(6,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?I.localize(7,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):I.localize(8,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?I.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?I.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):I.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}M(t,s,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const o=s.filter(S=>!S.isBuiltin&&c.some(E=>(0,w.areSameExtensions)({id:E},S.identifier))),u=[];for(const S of o)u.push(...this.M(S,s,a));return[...o,...u]}return[]}N(t,s){return s.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(c=>(0,w.areSameExtensions)({id:c},t.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const t=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};f=pe([Y(0,C.IExtensionGalleryService),Y(1,g.ITelemetryService),Y(2,h.ILogService),Y(3,m.IProductService),Y(4,l.IUserDataProfilesService)],f),e.AbstractExtensionManagementService=f;function p(r){const t=Array.isArray(r)?r:[r];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=p;function v(r){if(r instanceof C.ExtensionManagementError)return r;const t=new C.ExtensionManagementError(r.message,C.ExtensionManagementErrorCode.Internal);return t.stack=r.stack,t}function d(r,t,{extensionData:s,wasVerified:a,duration:c,error:o,durationSinceUpdate:u}){let S,E;o&&(o instanceof C.ExtensionManagementError?(S=o.code,o.code===C.ExtensionManagementErrorCode.Signature&&(E=o.message)):S=C.ExtensionManagementErrorCode.Internal),r.publicLog(t,{...s,wasVerified:a,success:!o,duration:c,errorcode:S,errorcodeDetail:E,durationSinceUpdate:u})}e.reportTelemetry=d;class n{constructor(){this.d=new i.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,i.createCancelablePromise)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,i.createCancelablePromise)(t=>new Promise((s,a)=>{const c=t.onCancellationRequested(()=>{c.dispose(),a(new A.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=n}),define(oe[61],ae([0,1,6,17,2,3,37,7,33,42,14,4,8,18,30,13,22,9,21]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(t){t.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",t.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class v extends Error{constructor(s,a){super(s),this.code=a}}e.ExtensionsProfileScanningError=v,e.IExtensionsProfileScannerService=(0,C.createDecorator)("IExtensionsProfileScannerService");let d=class extends D.Disposable{constructor(s,a,c,o,u){super(),this.h=s,this.i=a,this.j=c,this.k=o,this.l=u,this.a=this.B(new A.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new A.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new T.ResourceMap}scanProfileExtensions(s,a){return this.m(s,void 0,a)}async addExtensionsToProfile(s,a){const c=[],o=[];try{return await this.m(a,u=>{const S=[];for(const E of u)s.some(([M])=>(0,P.areSameExtensions)(M.identifier,E.identifier)&&M.manifest.version!==E.version)?c.push(E):S.push(E);for(const[E,M]of s)if(!S.some(N=>(0,P.areSameExtensions)(N.identifier,E.identifier)&&N.version===E.manifest.version)){const N={identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:M};o.push(N),S.push(N)}return o.length&&this.a.fire({extensions:o,profileLocation:a}),c.length&&this.c.fire({extensions:c,profileLocation:a}),S}),o.length&&this.b.fire({extensions:o,profileLocation:a}),c.length&&this.f.fire({extensions:c,profileLocation:a}),o}catch(u){throw o.length&&this.b.fire({extensions:o,error:u,profileLocation:a}),c.length&&this.f.fire({extensions:c,error:u,profileLocation:a}),u}}async removeExtensionFromProfile(s,a){const c=[];this.c.fire({extensions:c,profileLocation:a});try{await this.m(a,o=>{const u=[];for(const S of o)(0,P.areSameExtensions)(S.identifier,s.identifier)?c.push(S):u.push(S);return c.length&&this.c.fire({extensions:c,profileLocation:a}),u}),c.length&&this.f.fire({extensions:c,profileLocation:a})}catch(o){throw c.length&&this.f.fire({extensions:c,error:o,profileLocation:a}),o}}async m(s,a,c){return this.u(s).queue(async()=>{let o=[],u;try{const S=await this.h.readFile(s);u=JSON.parse(S.value.toString())}catch(S){if((0,I.toFileOperationResult)(S)!==1)throw S;if(this.j.extUri.isEqual(s,this.i.defaultProfile.extensionsResource)&&(u=await this.t()),!u&&c?.bailOutWhenFileNotFound)throw new v((0,l.getErrorMessage)(S),"ERROR_PROFILE_NOT_FOUND")}if(u){Array.isArray(u)||this.n(s);let S=!1;for(const E of u){n(E)||this.n(s);let M;if((0,m.isString)(E.location))M=this.r(s,E.location);else{M=R.URI.revive(E.location);const N=this.p(s,M);N&&(S=!0,E.location=N)}o.push({identifier:E.identifier,location:M,version:E.version,metadata:E.metadata})}S&&await this.h.writeFile(s,i.VSBuffer.fromString(JSON.stringify(u)))}if(a){o=a(o);const S=o.map(E=>({identifier:E.identifier,version:E.version,location:this.p(s,E.location)??E.location.toJSON(),metadata:E.metadata}));await this.h.writeFile(s,i.VSBuffer.fromString(JSON.stringify(S)))}return o})}n(s){const a=new v(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.k.publicLogError2("extensionsProfileScanningError",{code:a.code}),a}p(s,a){const c=this.j.extUri.dirname(s).with({scheme:g.Schemas.file});if(this.j.extUri.isEqualOrParent(a,c))return this.j.extUri.relativePath(c,a)}r(s,a){return this.j.extUri.joinPath(this.j.extUri.dirname(s),a).with({scheme:g.Schemas.file})}async t(){return this.s||(this.s=(async()=>{const s=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let a;try{a=(await this.h.readFile(s)).value.toString()}catch(o){if((0,I.toFileOperationResult)(o)===1)return;throw o}this.l.info("Migrating extensions from old default profile location",s.toString());let c;try{const o=JSON.parse(a);Array.isArray(o)&&o.every(u=>n(u))?c=o:this.l.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.l.error(o)}if(c)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,i.VSBuffer.fromString(JSON.stringify(c)),{overwrite:!1}),this.l.info("Migrated extensions from old default profile location to new location",s.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(o){if((0,I.toFileOperationResult)(o)===3)this.l.info("Migration from old default profile location to new location is done by another window",s.toString(),this.i.defaultProfile.extensionsResource.toString());else throw o}try{await this.h.del(s)}catch(o){(0,I.toFileOperationResult)(o)!==1&&this.l.error(o)}return c})()),this.s}u(s){let a=this.g.get(s);return a||(a=new k.Queue,this.g.set(s,a)),a}};d=pe([Y(0,I.IFileService),Y(1,y.IUserDataProfilesService),Y(2,h.IUriIdentityService),Y(3,f.ITelemetryService),Y(4,w.ILogService)],d),e.ExtensionsProfileScannerService=d;function n(t){return(0,m.isObject)(t)&&(0,b.isIExtensionIdentifier)(t.identifier)&&(r(t.location)||(0,m.isString)(t.location))&&t.version&&(0,m.isString)(t.version)}function r(t){return t?(0,m.isString)(t.path)&&(0,m.isString)(t.scheme):!1}}),define(oe[79],ae([0,1,20,6,32,17,9,35,137,2,22,12,5,23,53,88,13,7,158,15,33,42,70,14,4,8,25,3,67,61,18,30,188,189]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p,v,d,n,r,t,s,a,c,o,u,S,E,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var j;(function(Q){function K(V,G){if(V===G)return!0;const x=Object.keys(V),ne=new Set;for(const se of Object.keys(G))ne.add(se);if(x.length!==ne.size)return!1;for(const se of x){if(V[se]!==G[se])return!1;ne.delete(se)}return ne.size===0}Q.equals=K})(j=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let $=class extends b.Disposable{constructor(K,V,G,x,ne,se,ie,O,U,q,B,X){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=V,this.l=G,this.m=x,this.n=ne,this.p=se,this.r=ie,this.s=O,this.t=U,this.u=q,this.v=B,this.w=X,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(z,(0,y.joinPath)(this.m,d.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(z,(0,y.joinPath)(this.m,d.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(F,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,v.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(K,V,G){const[x,ne]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(V)]),se=G?await this.scanExtensionsUnderDevelopment(K,[...x,...ne]):[];return this.F(x,ne,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const V=[];V.push(this.G(!!K.useCache,K.language)),V.push(this.H(K.language,!!K.checkControlFile));const[G,x]=await Promise.all(V);return this.D([...G,...x],0,K,!1)}async scanUserExtensions(K){const V=K.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",V);const G=this.v.extUri.isEqual(K.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,x=await this.J(V,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,G),ne=K.useCache&&!x.devMode&&x.excludeObsolete?this.j:this.k;let se;try{se=await ne.scanExtensions(x)}catch(ie){if(ie instanceof u.ExtensionsProfileScanningError&&ie.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),se=await ne.scanExtensions(x);else throw ie}return se=await this.D(se,1,K,!0),this.s.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(K,V){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const G=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(x=>x.scheme===I.Schemas.file).map(async x=>{const ne=await this.J(x,!1,1,!0,K.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ne)).map(ie=>(ie.type=V.find(O=>(0,v.areSameExtensions)(O.identifier,ie.identifier))?.type??ie.type,this.k.validate(ie,ne)))}))).flat();return this.D(G,"development",K,!0)}return[]}async scanExistingExtension(K,V,G){const x=await this.J(K,!1,V,!0,G.language,!0,void 0),ne=await this.k.scanExtension(x);return!ne||!G.includeInvalid&&!ne.isValid?null:ne}async scanOneOrMultipleExtensions(K,V,G){const x=await this.J(K,!1,V,!0,G.language,!0,void 0),ne=await this.k.scanOneOrMultipleExtensions(x);return this.D(ne,V,G,!0)}async scanMetadata(K){const V=(0,y.joinPath)(K,"package.json"),G=(await this.r.readFile(V)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(K,V){const G=(0,y.joinPath)(K,"package.json"),x=(await this.r.readFile(G)).value.toString(),ne=JSON.parse(x);V.isMachineScoped=V.isMachineScoped||void 0,V.isBuiltin=V.isBuiltin||void 0,V.installedTimestamp=V.installedTimestamp||void 0,ne.__metadata={...ne.__metadata,...V},await this.r.writeFile((0,y.joinPath)(K,"package.json"),A.VSBuffer.fromString(JSON.stringify(ne,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof u.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw K}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.p.addExtensionsToProfile(K.map(V=>[V,V.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(V){(0,r.toFileOperationResult)(V)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(V))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.s.error(K)}finally{this.z=void 0}})()),this.z}async D(K,V,G,x){return G.includeAllVersions||(K=this.F(V===0?K:void 0,V===1?K:void 0,V==="development"?K:void 0,await this.getTargetPlatform(),x)),G.includeInvalid||(K=K.filter(ne=>ne.isValid)),K.sort((ne,se)=>{const ie=C.basename(ne.location.fsPath),O=C.basename(se.location.fsPath);return ie<O?-1:ie>O?1:0})}F(K,V,G,x,ne){const se=(O,U,q)=>{if(O.isValid&&!U.isValid)return!1;if(O.isValid===U.isValid){if(ne&&h.gt(O.manifest.version,U.manifest.version))return this.s.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${O.location.path} with version ${O.manifest.version}`),!1;if(h.eq(O.manifest.version,U.manifest.version)){if(O.type===0)return this.s.debug(`Skipping extension ${U.location.path} in favour of system extension ${O.location.path} with same version`),!1;if(O.targetPlatform===x)return this.s.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return q?this.s.warn(`Overwriting user extension ${O.location.path} with ${U.location.path}.`):this.s.debug(`Overwriting user extension ${O.location.path} with ${U.location.path}.`),!0},ie=new Map;return K?.forEach(O=>{const U=d.ExtensionIdentifier.toKey(O.identifier.id),q=ie.get(U);(!q||se(q,O,!1))&&ie.set(U,O)}),V?.forEach(O=>{const U=d.ExtensionIdentifier.toKey(O.identifier.id),q=ie.get(U);if(!q&&K&&O.type===0){this.s.debug(`Skipping obsolete system extension ${O.location.path}.`);return}(!q||se(q,O,!1))&&ie.set(U,O)}),G?.forEach(O=>{const U=d.ExtensionIdentifier.toKey(O.identifier.id),q=ie.get(U);(!q||se(q,O,!0))&&ie.set(U,O),ie.set(U,O)}),[...ie.values()]}async G(K,V){this.s.trace("Started scanning system extensions");const G=await this.J(this.systemExtensionsLocation,!1,0,!0,V,!0,void 0),ne=await(K&&!G.devMode?this.i:this.k).scanExtensions(G);return this.s.trace("Scanned system extensions:",ne.length),ne}async H(K,V){const G=this.t.isBuilt?[]:this.u.builtInExtensions;if(!G?.length)return[];this.s.trace("Started scanning dev system extensions");const x=V?await this.I():{},ne=[],se=l.URI.file(C.normalize(C.join(I.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const O of G){const U=x[O.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":ne.push((0,y.joinPath)(se,O.name));break;default:ne.push(l.URI.file(U));break}}const ie=await Promise.all(ne.map(async O=>this.k.scanExtension(await this.J(O,!1,0,!0,K,!0,void 0))));return this.s.trace("Scanned dev system extensions:",ie.length),(0,k.coalesce)(ie)}async I(){try{const K=await this.r.readFile(this.l);return JSON.parse(K.value.toString())}catch{return{}}}async J(K,V,G,x,ne,se,ie){const O=await this.f(ne??w.language),U=await this.L(K),q=V&&!this.v.extUri.isEqual(K,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,B=q?await this.L(q):void 0;return new L(K,U,q,B,V,ie,G,x,se,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,ne,O)}async L(K){try{const V=await this.r.stat(K);if(typeof V.mtime=="number")return V.mtime}catch{}}};$=pe([Y(4,S.IUserDataProfilesService),Y(5,u.IExtensionsProfileScannerService),Y(6,r.IFileService),Y(7,s.ILogService),Y(8,p.IEnvironmentService),Y(9,a.IProductService),Y(10,E.IUriIdentityService),Y(11,t.IInstantiationService)],$),e.AbstractExtensionsScannerService=$;class L{constructor(K,V,G,x,ne,se,ie,O,U,q,B,X,ee,J,_){this.location=K,this.mtime=V,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=x,this.profile=ne,this.profileScanOptions=se,this.type=ie,this.excludeObsolete=O,this.validate=U,this.productVersion=q,this.productDate=B,this.productCommit=X,this.devMode=ee,this.language=J,this.translations=_}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,V){return(0,y.isEqual)(K.location,V.location)&&K.mtime===V.mtime&&(0,y.isEqual)(K.applicationExtensionslocation,V.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===V.applicationExtensionslocationMtime&&K.profile===V.profile&&K.profileScanOptions===V.profileScanOptions&&K.type===V.type&&K.excludeObsolete===V.excludeObsolete&&K.validate===V.validate&&K.productVersion===V.productVersion&&K.productDate===V.productDate&&K.productCommit===V.productCommit&&K.devMode===V.devMode&&K.language===V.language&&j.equals(K.translations,V.translations)}}let F=class extends b.Disposable{constructor(K,V,G,x,ne){super(),this.f=K,this.g=V,this.h=G,this.i=x,this.j=ne}async scanExtensions(K){const V=K.profile?await this.l(K):await this.k(K);let G={};if(K.excludeObsolete&&K.type===1)try{const x=(await this.i.readFile(this.f)).value.toString();G=JSON.parse(x)}catch{}return(0,g.isEmptyObject)(G)?V:V.filter(x=>!G[v.ExtensionKey.create(x).toString()])}async k(K){const V=await this.i.resolve(K.location);if(!V.children?.length)return[];const G=await Promise.all(V.children.map(async x=>{if(!x.isDirectory||K.type===1&&(0,y.basename)(x.resource).indexOf(".")===0)return null;const ne=new L(x.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(ne)}));return(0,k.coalesce)(G).sort((x,ne)=>x.location.path<ne.location.path?-1:1)}async l(K){let V=await this.m(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){V=V.filter(x=>!x.metadata?.isApplicationScoped);const G=await this.m(K.applicationExtensionslocation,x=>!!x.metadata?.isApplicationScoped,K);V.push(...G)}return V}async m(K,V,G){const x=await this.g.scanProfileExtensions(K,G.profileScanOptions);if(!x.length)return[];const ne=await Promise.all(x.map(async se=>{if(V(se)){const ie=new L(se.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(ie,se.metadata)}return null}));return(0,k.coalesce)(ne)}async scanOneOrMultipleExtensions(K){try{if(await this.i.exists((0,y.joinPath)(K.location,"package.json"))){const V=await this.scanExtension(K);return V?[V]:[]}else return await this.scanExtensions(K)}catch(V){return this.j.error(`Error scanning extensions at ${K.location.path}:`,(0,T.getErrorMessage)(V)),[]}}async scanExtension(K,V){try{let G=await this.scanExtensionManifest(K.location);if(G){G.publisher||(G.publisher=d.UNDEFINED_PUBLISHER),V=V??G.__metadata,delete G.__metadata;const x=(0,v.getGalleryExtensionId)(G.publisher,G.name),ne=V?.id?{id:x,uuid:V.id}:{id:x},se=V?.isSystem?0:K.type,ie=se===0||!!V?.isBuiltin;N.ImplicitActivationEvents.updateManifest(G),G=await this.n(K.location,G,L.createNlsConfiguration(K));const O={type:se,identifier:ne,manifest:G,location:K.location,isBuiltin:ie,targetPlatform:V?.targetPlatform??"undefined",metadata:V,isValid:!0,validations:[]};return K.validate?this.validate(O,K):O}}catch(G){K.type!==0&&this.j.error(G)}return null}validate(K,V){let G=!0;const x=(0,n.validateExtensionManifest)(V.productVersion,V.productDate,V.location,K.manifest,K.isBuiltin);for(const[ne,se]of x)ne===m.default.Error&&(G=!1,this.j.error(this.t(V.location,se)));return K.isValid=G,K.validations=x,K}async scanExtensionManifest(K){const V=(0,y.joinPath)(K,"package.json");let G;try{G=(await this.i.readFile(V)).value.toString()}catch(ne){return(0,r.toFileOperationResult)(ne)!==1&&this.j.error(this.t(K,(0,f.localize)(0,null,V.path,ne.message))),null}let x;try{x=JSON.parse(G)}catch{const se=[];(0,R.parse)(G,se);for(const ie of se)this.j.error(this.t(K,(0,f.localize)(1,null,V.path,ie.offset,ie.length,(0,P.getParseErrorMessage)(ie.error))));return null}return(0,R.getNodeType)(x)!=="object"?(this.j.error(this.t(K,(0,f.localize)(2,null,V.path))),null):x}async n(K,V,G){const x=await this.p(K,V,G);if(x)try{const ne=[],se=await this.r(x.default,ne);if(ne.length>0)return ne.forEach(O=>{this.j.error(this.t(K,(0,f.localize)(3,null,x.default?.path,(0,P.getParseErrorMessage)(O.error))))}),V;if((0,R.getNodeType)(x)!=="object")return this.j.error(this.t(K,(0,f.localize)(4,null,x.default?.path))),V;const ie=x.values||Object.create(null);return(0,M.localizeManifest)(V,ie,se)}catch{}return V}async p(K,V,G){const x=(0,y.joinPath)(K,"package.nls.json"),ne=(U,q)=>{q.forEach(B=>{this.j.error(this.t(K,(0,f.localize)(5,null,U?.path,(0,P.getParseErrorMessage)(B.error))))})},se=U=>{this.j.error(this.t(K,(0,f.localize)(6,null,U?.path)))},ie=`${V.publisher}.${V.name}`,O=G.translations[ie];if(O)try{const U=l.URI.file(O),q=(await this.i.readFile(U)).value.toString(),B=[],X=(0,R.parse)(q,B);return B.length>0?(ne(U,B),{values:void 0,default:x}):(0,R.getNodeType)(X)!=="object"?(se(U),{values:void 0,default:x}):{values:X.contents?X.contents.package:void 0,default:x}}catch{return{values:void 0,default:x}}else{if(!await this.i.exists(x))return;let q;try{q=await this.s(K,G)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const B=(await this.i.readFile(q.localized)).value.toString(),X=[],ee=(0,R.parse)(B,X);return X.length>0?(ne(q.localized,X),{values:void 0,default:q.original}):(0,R.getNodeType)(ee)!=="object"?(se(q.localized),{values:void 0,default:q.original}):{values:ee,default:q.original}}catch{return{values:void 0,default:q.original}}}}async r(K,V){if(K)try{const G=(await this.i.readFile(K)).value.toString();return(0,R.parse)(G,V)}catch{}}s(K,V){return new Promise((G,x)=>{const ne=se=>{const ie=(0,y.joinPath)(K,`package.nls.${se}.json`);this.i.exists(ie).then(O=>{O&&G({localized:ie,original:(0,y.joinPath)(K,"package.nls.json")});const U=se.lastIndexOf("-");U===-1?G({localized:(0,y.joinPath)(K,"package.nls.json"),original:null}):(se=se.substring(0,U),ne(se))})};if(V.devMode||V.pseudo||!V.language)return G({localized:(0,y.joinPath)(K,"package.nls.json"),original:null});ne(V.language)})}t(K,V){return`[${K.path}]: ${V}`}};F=pe([Y(1,u.IExtensionsProfileScannerService),Y(2,E.IUriIdentityService),Y(3,r.IFileService),Y(4,s.ILogService)],F);let z=class extends F{constructor(K,V,G,x,ne,se){super(V,G,x,ne,se),this.y=K,this.v=this.B(new i.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(K){const V=await this.z();if(this.u=K,V&&V.input&&L.equals(V.input,this.u))return this.v.trigger(()=>this.D()),V.result.map(x=>(x.location=l.URI.revive(x.location),x));const G=await super.scanExtensions(K);return await this.C({input:K,result:G}),G}async z(){try{const K=await this.i.readFile(this.y),V=JSON.parse(K.value.toString());return{result:V.result,input:(0,o.revive)(V.input)}}catch(K){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,T.getErrorMessage)(K))}return null}async C(K){try{await this.i.writeFile(this.y,A.VSBuffer.fromString(JSON.stringify(K)))}catch(V){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,T.getErrorMessage)(V))}}async D(){if(!this.u)return;const K=await this.z();if(!K)return;const V=K.result,G=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!D.equals(G,V))try{await this.i.del(this.y),this.w.fire()}catch(x){this.j.error(x)}}};z=pe([Y(2,u.IExtensionsProfileScannerService),Y(3,E.IUriIdentityService),Y(4,r.IFileService),Y(5,s.ILogService)],z);function W(Q,K){const V=(0,v.getExtensionId)(Q.manifest.publisher,Q.manifest.name);return{id:V,identifier:new d.ExtensionIdentifier(V),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:K,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,...Q.manifest}}e.toExtensionDescription=W;class H extends ${constructor(K,V,G,x,ne,se,ie,O,U,q,B,X){super(K,V,(0,y.joinPath)(G,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(x,d.MANIFEST_CACHE_FOLDER),ne,se,ie,O,U,q,B,X),this.M=(async()=>{if(w.translationsConfigFile)try{const ee=await this.r.readFile(l.URI.file(w.translationsConfigFile));return JSON.parse(ee.value.toString())}catch{}return Object.create(null)})()}f(K){return this.M}}e.NativeExtensionsScannerService=H}),define(oe[264],ae([0,1,50,6,38,3,2,22,12,28,8,18]),function(Z,e,k,i,D,A,T,R,P,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let w=class extends T.Disposable{constructor(h,m){super(),this.b=h,this.f=m,this.a=new i.Limiter(5)}async postUninstall(h){const m=this.g(h,"uninstall");return m&&(this.f.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(m.script,"uninstall",m.args,!0,h).then(()=>this.f.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),g=>this.f.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${g}`)))),b.Promises.rm(this.j(h)).then(void 0,g=>this.f.error("Error while removing extension storage path",g))}g(h,m){const g=`vscode:${m}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[g]=="string"){const l=h.manifest.scripts[g].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(h.identifier.id,h.manifest.version,`${g} should be a node script`),null):{script:(0,P.join)(h.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(h,m,g,l,f){return new Promise((p,v)=>{const d=this.i(h,m,g,f);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?v(t):p(void 0)};d.on("error",t=>{r((0,D.toErrorMessage)(t)||"Unknown")}),d.on("exit",(t,s)=>{r(t?`post-${m} process exited with code ${t}`:void 0)}),l&&(n=setTimeout(()=>{n=null,d.kill(),v("timed out")},5e3))})}i(h,m,g,l){const f={silent:!0,execArgv:void 0},p=(0,k.fork)(h,[`--type=extension-post-${m}`,...g],f);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const v=A.Event.fromNodeEventEmitter(p.stdout,"data"),d=A.Event.fromNodeEventEmitter(p.stderr,"data");v(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${m}`,t)),d(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${m}`,t));const n=A.Event.any(A.Event.map(v,t=>({data:`%c${t}`,format:[""]})),A.Event.map(d,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(n,(t,s)=>t?{data:t.data+s.data,format:[...t.format,...s.format]}:{data:s.data,format:s.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),p}j(h){return(0,P.join)(this.b.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};w=pe([Y(0,C.IUserDataProfilesService),Y(1,I.ILogService)],w),e.ExtensionsLifecycle=w}),define(oe[265],ae([0,1,7,15,61,79,14,4,8,25,30,18]),function(Z,e,k,i,D,A,T,R,P,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends A.NativeExtensionsScannerService{constructor(h,m,g,l,f,p,v,d){super(k.URI.file(f.builtinExtensionsPath),k.URI.file(f.extensionsPath),f.userHome,k.URI.file(f.userDataPath),h,m,g,l,f,p,v,d)}};w=pe([Y(0,C.IUserDataProfilesService),Y(1,D.IExtensionsProfileScannerService),Y(2,T.IFileService),Y(3,P.ILogService),Y(4,i.INativeEnvironmentService),Y(5,b.IProductService),Y(6,I.IUriIdentityService),Y(7,R.IInstantiationService)],w),e.ExtensionsScannerService=w}),define(oe[19],ae([0,1,6,3,2,207,13,69,4,18]),function(Z,e,k,i,D,A,T,R,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,P.createDecorator)("storageService");var I;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var w;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(w=e.StorageTarget||(e.StorageTarget={}));function y(f){const p=f.get(e.TARGET_KEY);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.loadKeyTargets=y;class h extends D.Disposable{constructor(p={flushInterval:h.a}){super(),this.j=p,this.b=this.B(new i.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new i.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new i.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new k.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,k.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(p,v){if(v===e.TARGET_KEY){switch(p){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:v,target:this.F(p)[v]})}r(p){this.f.fire({reason:p})}get(p,v,d){return this.L(v)?.get(p,d)}getBoolean(p,v,d){return this.L(v)?.getBoolean(p,d)}getNumber(p,v,d){return this.L(v)?.getNumber(p,d)}store(p,v,d,n){if((0,T.isUndefinedOrNull)(v)){this.remove(p,d);return}this.t(()=>{this.u(p,d,n),this.L(d)?.set(p,v)})}remove(p,v){this.t(()=>{this.u(p,v,void 0),this.L(v)?.delete(p)})}t(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,v){const d=[],n=this.F(p);for(const r of Object.keys(n))n[r]===v&&d.push(r);return d}u(p,v,d){const n=this.F(v);typeof d=="number"?n[p]!==d&&(n[p]=d,this.L(v)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[p]=="number"&&(delete n[p],this.L(v)?.set(e.TARGET_KEY,JSON.stringify(n)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(p){switch(p){case-1:return this.D;case 0:return this.z;default:return this.w}}G(p){const v=this.L(p);return v?y(v):Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=I.NONE){this.f.fire({reason:p});const v=this.L(-1),d=this.L(0),n=this.L(1);switch(p){case I.NONE:await k.Promises.settled([v?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await k.Promises.settled([v?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.L(-1)?.items??new Map,v=this.L(0)?.items??new Map,d=this.L(1)?.items??new Map;return l(p,v,d,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(p,v){return this.r(I.NONE),(0,b.isUserDataProfile)(p)?this.N(p,v):this.O(p,v)}H(p,v){return!(p.id===v.id||m(v)&&m(p))}I(p,v,d,n){this.t(()=>{if(n)for(const[r,t]of p)v.set(r,t);else{const r=new Set;for(const[t,s]of p)r.add(t),v.get(t)!==s&&this.n(d,t);for(const[t]of v.items)r.has(t)||this.n(d,t)}})}}e.AbstractStorageService=h,h.a=60*1e3;function m(f){return f.isDefault||!!f.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=m;class g extends h{constructor(){super(),this.p=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(p=>this.n(1,p))),this.B(this.P.onDidChangeStorage(p=>this.n(0,p))),this.B(this.p.onDidChangeStorage(p=>this.n(-1,p)))}L(p){switch(p){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(p){return!1}}e.InMemoryStorageService=g;async function l(f,p,v,d,n,r){const t=N=>{try{return JSON.parse(N)}catch{return N}},s=new Map,a=new Map;f.forEach((N,j)=>{s.set(j,N),a.set(j,t(N))});const c=new Map,o=new Map;p.forEach((N,j)=>{c.set(j,N),o.set(j,t(N))});const u=new Map,S=new Map;v.forEach((N,j)=>{u.set(j,N),S.set(j,t(N))}),console.group(d!==n?`Storage: Application (path: ${d})`:`Storage: Application & Profile (path: ${d}, default profile)`);const E=[];if(s.forEach((N,j)=>{E.push({key:j,value:N})}),console.table(E),console.groupEnd(),console.log(a),d!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const N=[];c.forEach((j,$)=>{N.push({key:$,value:j})}),console.table(N),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${r})`);const M=[];u.forEach((N,j)=>{M.push({key:j,value:N})}),console.table(M),console.groupEnd(),console.log(S)}e.logStorage=l}),define(oe[116],ae([0,1,3,2,13,29,33,19]),function(Z,e,k,i,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends i.Disposable{constructor(C,w){super(),this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new b(C)),this.B(this.b.onDidChange(y=>this.a.fire({extensions:y,source:"storage"}))),this.B(w.onDidInstallExtensions(y=>y.forEach(({local:h,operation:m})=>{h&&m===4&&this.f(h.identifier)})))}async enableExtension(C,w){return this.f(C)?(this.a.fire({extensions:[C],source:w}),!0):!1}async disableExtension(C,w){return this.c(C)?(this.a.fire({extensions:[C],source:w}),!0):!1}getDisabledExtensions(){return this.h(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(C){const w=this.getDisabledExtensions();return w.every(y=>!(0,T.areSameExtensions)(y,C))?(w.push(C),this.g(w),!0):!1}f(C){const w=this.getDisabledExtensions();for(let y=0;y<w.length;y++){const h=w[y];if((0,T.areSameExtensions)(h,C))return w.splice(y,1),this.g(w),!0}return!1}g(C){this.i(A.DISABLED_EXTENSIONS_STORAGE_PATH,C)}h(C){return this.b.get(C,0)}i(C,w){this.b.set(C,w,0)}};P=pe([Y(0,R.IStorageService),Y(1,A.IExtensionManagementService)],P),e.GlobalExtensionEnablementService=P;class b extends i.Disposable{constructor(C){super(),this.c=C,this.a=Object.create(null),this.b=this.B(new k.Emitter),this.onDidChange=this.b.event,this.B(C.onDidChangeValue(w=>this.f(w)))}get(C,w){let y;return w===0?((0,D.isUndefinedOrNull)(this.a[C])&&(this.a[C]=this.g(C,w)),y=this.a[C]):y=this.g(C,w),JSON.parse(y)}set(C,w,y){const h=JSON.stringify(w.map(({id:g,uuid:l})=>({id:g,uuid:l})));this.g(C,y)!==h&&(y===0&&(w.length?this.a[C]=h:delete this.a[C]),this.h(C,w.length?h:void 0,y))}f(C){if(C.scope===0&&!(0,D.isUndefinedOrNull)(this.a[C.key])&&this.g(C.key,C.scope)!==this.a[C.key]){const y=this.get(C.key,C.scope);delete this.a[C.key];const h=this.get(C.key,C.scope),m=y.filter(l=>!h.some(f=>(0,T.areSameExtensions)(l,f))),g=h.filter(l=>!y.some(f=>(0,T.areSameExtensions)(f,l)));(m.length||g.length)&&this.b.fire([...m,...g])}}g(C,w){return this.c.get(C,w,"[]")}h(C,w,y){w?this.c.store(C,w,y,1):this.c.remove(C,y)}}e.StorageManager=b}),define(oe[266],ae([0,1,20,24,9,5,36,13,7,16,15,29,33,70,14,8,25,59,236,19,21]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const d=A.isWeb?"web":(0,C.getTargetPlatform)(A.platform,T.arch);var n;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function r(...O){return String(O.reduce((U,q)=>U|q,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class u{constructor(U=o){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,q=this.d.pageSize){return new u({...this.d,pageNumber:U,pageSize:q})}withFilter(U,...q){const B=[...this.d.criteria,...q.length?q.map(X=>({filterType:U,value:X})):[{filterType:U}]];return new u({...this.d,criteria:B})}withSortBy(U){return new u({...this.d,sortBy:U})}withSortOrder(U){return new u({...this.d,sortOrder:U})}withFlags(...U){return new u({...this.d,flags:U.reduce((q,B)=>q|B,0)})}withAssetTypes(...U){return new u({...this.d,assetTypes:U})}withSource(U){return new u({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:q,pageSize:B,sortBy:X,sortOrder:ee,flags:J,assetTypes:_}=this.d;return{filters:[{criteria:U,pageNumber:q,pageSize:B,sortBy:X,sortOrder:ee}],assetTypes:_,flags:J}}get searchText(){const U=this.d.criteria.filter(q=>q.filterType===t.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function S(O,U){const q=(O||[]).filter(B=>B.statisticName===U)[0];return q?q.value:0}function E(O){const U="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(B=>B.assetType.indexOf(U)===0).reduce((B,X)=>{const ee=j(O,X.assetType);return ee&&B.push([X.assetType.substring(U.length),ee]),B},[])}function M(O){if(O.properties){const U=O.properties.filter(X=>X.key===s.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=U.filter(X=>q.test(X.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return j(O,s.Repository)}function N(O){return{uri:`${O.fallbackAssetUri}/${s.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${s.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function j(O,U){return O.files.filter(B=>B.assetType===U)[0]?{uri:`${O.assetUri}/${U}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${U}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function $(O,U){const q=O.properties?O.properties.filter(X=>X.key===U):[],B=q.length>0&&q[0].value;return B?B.split(",").map(X=>(0,w.adoptToGalleryExtensionId)(X)):[]}function L(O){const U=O.properties?O.properties.filter(q=>q.key===a.Engine):[];return U.length>0&&U[0].value||""}function F(O){const U=O.properties?O.properties.filter(q=>q.key===a.PreRelease):[];return U.length>0&&U[0].value==="true"}function z(O){const U=O.properties?O.properties.filter(B=>B.key===a.LocalizedLanguages):[],q=U.length>0&&U[0].value||"";return q?q.split(","):[]}function W(O){return O.properties?.find(U=>U.key===a.SponsorLink)?.value}function H(O){return O.indexOf("preview")!==-1}function Q(O){return O.targetPlatform?(0,C.toTargetPlatform)(O.targetPlatform):"undefined"}function K(O){const U=(0,k.distinct)(O.versions.map(Q)),q=!!O.tags?.includes(C.WEB_EXTENSION_TAG),B=U.indexOf("web");return q?B===-1&&U.push("web"):B!==-1&&U.splice(B,1),U}function V(O,U){const q=(0,C.getFallbackTargetPlarforms)(U);for(let B=0;B<O.length;B++){const X=O[B];if(X.version===O[B-1]?.version){let ee=B;const J=Q(X);if(J===U)for(;ee>0&&O[ee-1].version===X.version;)ee--;else if(q.includes(J))for(;ee>0&&O[ee-1].version===X.version&&Q(O[ee-1])!==U;)ee--;ee!==B&&(O.splice(B,1),O.splice(ee,0,X))}}return O}e.sortExtensionVersions=V;function G(O,U,q){O.telemetryData={index:U,querySource:q}}function x(O,U,q){const B=O.versions[0],X={manifest:j(U,s.Manifest),readme:j(U,s.Details),changelog:j(U,s.Changelog),license:j(U,s.License),repository:M(U),download:N(U),icon:j(U,s.Icon),signature:j(U,s.Signature),coreTranslations:E(U)};return{identifier:{id:(0,w.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:U.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(B),description:O.shortDescription||"",installCount:S(O.statistics,"install"),rating:S(O.statistics,"averagerating"),ratingCount:S(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:q,assets:X,properties:{dependencies:$(U,a.Dependency),extensionPack:$(U,a.ExtensionPack),engine:L(U),localizedLanguages:z(U),targetPlatform:Q(U),isPreReleaseVersion:F(U)},hasPreReleaseVersion:F(B),hasReleaseVersion:!0,preview:H(O.flags),isSigned:!!X.signature}}let ne=class{constructor(U,q,B,X,ee,J,_,re){this.k=q,this.l=B,this.n=X,this.o=ee,this.q=J,this.u=_,this.w=re;const ue=_.extensionsGallery,le=ue?.servicePPEUrl&&re.getValue("_extensionsGallery.enablePPE");this.d=le?ue.servicePPEUrl:ue?.serviceUrl,this.g=le?void 0:ue?.searchUrl,this.h=ue?.controlUrl,this.j=(0,f.resolveMarketplaceHeaders)(_.version,_,this.n,this.w,this.q,U,this.o)}x(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,q,B){const X=i.CancellationToken.isCancellationToken(q)?{}:q,ee=i.CancellationToken.isCancellationToken(q)?q:B,J=[],_=[],re=[],ue=[];let le=!0;for(const be of U){be.uuid?_.push(be.uuid):J.push(be.id);const Ee=!!(be.version||be.preRelease);re.push({id:be.id,uuid:be.uuid,includePreRelease:Ee}),be.version&&ue.push({id:be.id,uuid:be.uuid,version:be.version}),le=le&&!!be.hasPreRelease&&!Ee}if(!_.length&&!J.length)return[];let ye=new u().withPage(1,U.length);_.length&&(ye=ye.withFilter(t.ExtensionId,..._)),J.length&&(ye=ye.withFilter(t.ExtensionName,...J)),(X.queryAllVersions||le)&&(ye=ye.withFlags(ye.flags,n.IncludeVersions)),X.source&&(ye=ye.withSource(X.source));const{extensions:Se}=await this.z(ye,{targetPlatform:X.targetPlatform??d,includePreRelease:re,versions:ue,compatible:!!X.compatible},ee);return X.source&&Se.forEach((be,Ee)=>G(be,Ee,X.source)),Se}async getCompatibleExtension(U,q,B){if((0,C.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(U,q,B))return U;const X=new u().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,U.identifier.uuid),{extensions:ee}=await this.z(X,{targetPlatform:B,compatible:!0,includePreRelease:q},i.CancellationToken.None);return ee[0]||null}async isExtensionCompatible(U,q,B){if(!(0,C.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,B)||!q&&U.properties.isPreReleaseVersion)return!1;let X=U.properties.engine;if(!X){const ee=await this.getManifest(U,i.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");X=ee.engines.vscode}return(0,y.isEngineValid)(X,this.u.version,this.u.date)}async y(U,q,B,X,ee){if(!(0,C.isTargetPlatformCompatible)(Q(U),X,ee)||q!=="any"&&F(U)!==(q==="prerelease"))return!1;if(B)try{const J=await this.E(U);if(!(0,y.isEngineValid)(J,this.u.version,this.u.date))return!1}catch(J){return this.l.error(`Error while getting the engine for the version ${U.version}.`,(0,D.getErrorMessage)(J)),!1}return!0}async query(U,q){let B=U.text||"";const X=U.pageSize??50;let ee=new u().withPage(1,X);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ye,Se)=>(ee=ee.withFilter(t.Category,Se||ye),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ye,Se)=>(ee=ee.withFilter(t.Tag,Se||ye),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(t.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),ee=ee.withFilter(t.SearchText,B)),ee=ee.withSortBy(0)):U.ids?ee=ee.withFilter(t.ExtensionId,...U.ids):U.names?ee=ee.withFilter(t.ExtensionName,...U.names):ee=ee.withSortBy(4),typeof U.sortBy=="number"&&(ee=ee.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(ee=ee.withSortOrder(U.sortOrder)),U.source&&(ee=ee.withSource(U.source));const J=async(le,ye)=>{const{extensions:Se,total:be}=await this.z(le,{targetPlatform:d,compatible:!1,includePreRelease:!!U.includePreRelease},ye);return Se.forEach((Ee,Ne)=>G(Ee,(le.pageNumber-1)*le.pageSize+Ne,U.source)),{extensions:Se,total:be}},{extensions:_,total:re}=await J(ee,q),ue=async(le,ye)=>{if(ye.isCancellationRequested)throw new D.CancellationError;const{extensions:Se}=await J(ee.withPage(le+1),ye);return Se};return{firstPage:_,total:re,pageSize:ee.pageSize,getPage:ue}}async z(U,q,B){const X=U.flags;!!(U.flags&n.IncludeLatestVersionOnly)&&!!(U.flags&n.IncludeVersions)&&(U=U.withFlags(U.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(U.flags&n.IncludeLatestVersionOnly)&&!(U.flags&n.IncludeVersions)&&(U=U.withFlags(U.flags,n.IncludeLatestVersionOnly)),q.versions?.length&&(U=U.withFlags(U.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),U=U.withFlags(U.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:ee,total:J}=await this.B(U,B);if(!(U.flags&n.IncludeLatestVersionOnly)){const le=[];for(const ye of ee){const Se=await this.A(ye,q);Se&&le.push(Se)}return{extensions:le,total:J}}const re=[],ue=new Map;for(let le=0;le<ee.length;le++){const ye=ee[le],Se={id:(0,w.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},be=(0,R.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Ne=>(0,w.areSameExtensions)(Ne,Se))?.includePreRelease;if(q.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(K(ye),q.targetPlatform))continue;const Ee=await this.A(ye,q);!Ee||Ee.properties.isPreReleaseVersion&&(!be||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==q.targetPlatform&&Ee.hasPreReleaseVersion?ue.set(ye.extensionId,le):re.push([le,Ee])}if(ue.size){const le=new Date().getTime(),ye=new u().withFlags(X&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,ue.size).withFilter(t.ExtensionId,...ue.keys()),{extensions:Se}=await this.z(ye,q,B);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-le,count:ue.size});for(const be of Se){const Ee=ue.get(be.identifier.uuid);re.push([Ee,be])}}return{extensions:re.sort((le,ye)=>le[0]-ye[0]).map(([,le])=>le),total:J}}async A(U,q){const B={id:(0,w.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},X=q.versions?.find(re=>(0,w.areSameExtensions)(re,B))?.version,ee=(0,R.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(re=>(0,w.areSameExtensions)(re,B))?.includePreRelease,J=K(U),_=V(U.versions,q.targetPlatform);if(q.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(J,q.targetPlatform))return null;for(let re=0;re<_.length;re++){const ue=_[re];if(!(X&&ue.version!==X)){if(await this.y(ue,ee?"any":"release",q.compatible,J,q.targetPlatform))return x(U,ue,J);if(X&&ue.version===X)return null}}return X||q.compatible?null:x(U,U.versions[0],J)}async B(U,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(n.Unpublished));const B=await this.j,X=JSON.stringify(U.raw),ee={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},J=new Date().getTime();let _,re,ue=0;try{if(_=await this.k.request({type:"POST",url:this.g&&U.criteria.some(ye=>ye.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:X,headers:ee},q),_.res.statusCode&&_.res.statusCode>=400&&_.res.statusCode<500)return{galleryExtensions:[],total:ue};const le=await(0,l.asJson)(_);if(le){const ye=le.results[0],Se=ye.extensions,be=ye.resultMetadata&&ye.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ue=be&&be.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:ue}}return{galleryExtensions:[],total:ue}}catch(le){throw re=le,le}finally{this.o.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(X.length),duration:new Date().getTime()-J,success:!!_&&(0,l.isSuccess)(_),responseBodySize:_?.res.headers["Content-Length"],statusCode:_?String(_.res.statusCode):void 0,errorCode:re?(0,D.isCancellationError)(re)?"canceled":(0,D.getErrorMessage)(re).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(U,q,B,X){if(!this.isEnabled())return;const ee=A.isWeb?this.x(`/itemName/${U}.${q}/version/${B}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${U}/extensions/${q}/${B}/stats?statType=${X}`),J=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",re={...await this.j,Accept:J};try{await this.k.request({type:"POST",url:ee,headers:re},i.CancellationToken.None)}catch{}}async download(U,q,B){this.l.trace("ExtensionGalleryService#download",U.identifier.id);const X=(0,w.getGalleryExtensionTelemetryData)(U),ee=new Date().getTime(),J=le=>this.o.publicLog("galleryService:downloadVSIX",{...X,duration:le}),_=B===2?"install":B===3?"update":"",re=_?{uri:`${U.assets.download.uri}${P.URI.parse(U.assets.download.uri).query?"&":"?"}${_}=true`,fallbackUri:`${U.assets.download.fallbackUri}${P.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${_}=true`}:U.assets.download,ue=await this.D(re);await this.q.writeFile(q,ue.stream),J(new Date().getTime()-ee)}async downloadSignatureArchive(U,q){if(!U.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const B=await this.D(U.assets.signature);await this.q.writeFile(q,B.stream)}async getReadme(U,q){if(U.assets.readme){const B=await this.D(U.assets.readme,{},q);return await(0,l.asTextOrError)(B)||""}return""}async getManifest(U,q){if(U.assets.manifest){const B=await this.D(U.assets.manifest,{},q),X=await(0,l.asTextOrError)(B);return X?JSON.parse(X):null}return null}async C(U,q){const B=j(U,s.Manifest);if(!B)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},ee=await this.D(B,{headers:X});return await(0,l.asJson)(ee)}async getCoreTranslation(U,q){const B=U.assets.coreTranslations.filter(X=>X[0]===q.toUpperCase())[0];if(B){const X=await this.D(B[1]),ee=await(0,l.asTextOrError)(X);return ee?JSON.parse(ee):null}return null}async getChangelog(U,q){if(U.assets.changelog){const B=await this.D(U.assets.changelog,{},q);return await(0,l.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(U,q,B){let X=new u().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?X=X.withFilter(t.ExtensionId,U.identifier.uuid):X=X.withFilter(t.ExtensionName,U.identifier.id);const{galleryExtensions:ee}=await this.B(X,i.CancellationToken.None);if(!ee.length)return[];const J=K(ee[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(J,B))return[];const _=[];await Promise.all(ee[0].versions.map(async le=>{try{await this.y(le,q?"any":"release",!0,J,B)&&_.push(le)}catch{}}));const re=[],ue=new Set;for(const le of V(_,B))ue.has(le.version)||(ue.add(le.version),re.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:F(le)}));return re}async D(U,q={},B=i.CancellationToken.None){const X=await this.j,ee={type:"GET"},J={...X,...q.headers||{}};q={...q,...ee,headers:J};const _=U.uri,re=U.fallbackUri,ue={...q,url:_};try{const le=await this.k.request(ue,B);if(le.res.statusCode===200)return le;const ye=await(0,l.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${ye}`)}catch(le){if((0,D.isCancellationError)(le))throw le;const ye=(0,D.getErrorMessage)(le);this.o.publicLog2("galleryService:cdnFallback",{url:_,message:ye});const Se={...q,url:re};return this.k.request(Se,B)}}async E(U){let q=L(U);if(!q){const B=await this.C(U,i.CancellationToken.None);if(!B)throw new Error("Manifest was not found");q=B.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const U=await this.k.request({type:"GET",url:this.h},i.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,l.asJson)(U),B=[],X={};if(q){for(const ee of q.malicious)B.push({id:ee});if(q.migrateToPreRelease)for(const[ee,J]of Object.entries(q.migrateToPreRelease))(!J.engine||(0,y.isEngineValid)(J.engine,this.u.version,this.u.date))&&(X[ee.toLowerCase()]={disallowInstall:!0,extension:{id:J.id,displayName:J.displayName,autoMigrate:{storage:!!J.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[ee,J]of Object.entries(q.deprecated))J&&(X[ee.toLowerCase()]=(0,R.isBoolean)(J)?{}:J)}return{malicious:B,deprecated:X}}};ne=pe([Y(1,l.IRequestService),Y(2,m.ILogService),Y(3,I.IEnvironmentService),Y(4,v.ITelemetryService),Y(5,h.IFileService),Y(6,g.IProductService),Y(7,b.IConfigurationService)],ne);let se=class extends ne{constructor(U,q,B,X,ee,J,_,re){super(U,q,B,X,ee,J,_,re)}};se=pe([Y(0,p.IStorageService),Y(1,l.IRequestService),Y(2,m.ILogService),Y(3,I.IEnvironmentService),Y(4,v.ITelemetryService),Y(5,h.IFileService),Y(6,g.IProductService),Y(7,b.IConfigurationService)],se),e.ExtensionGalleryService=se;let ie=class extends ne{constructor(U,q,B,X,ee,J,_){super(void 0,U,q,B,X,ee,J,_)}};ie=pe([Y(0,l.IRequestService),Y(1,m.ILogService),Y(2,I.IEnvironmentService),Y(3,v.ITelemetryService),Y(4,h.IFileService),Y(5,g.IProductService),Y(6,b.IConfigurationService)],ie),e.ExtensionGalleryServiceWithNoStorageService=ie}),define(oe[80],ae([0,1,4,3,2,19,33,25,20,8,13]),function(Z,e,k,i,D,A,T,R,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let w=class Ze extends D.Disposable{static b(h){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static c(h){const m=C.exec(h);if(m&&m[1])return{id:m[1],version:m[2]}}static async removeOutdatedExtensionVersions(h,m){const g=await h.getInstalled(),l=[];for(const[f,p]of Ze.f(m)){const v=g.find(d=>(0,T.areSameExtensions)(d.identifier,{id:f}))?.manifest.version;for(const d of p)v!==d&&l.push(Ze.b({id:f,version:d}))}for(const f of l)m.remove(f,0)}static f(h){const m=new Map,g=h.keys(0,1);for(const l of g){const f=Ze.c(l);if(f){let p=m.get(f.id.toLowerCase());p||m.set(f.id.toLowerCase(),p=[]),p.push(f.version)}}return m}constructor(h,m,g){super(),this.i=h,this.j=m,this.k=g,this.g=this.B(new i.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Ze.f(h),this.B(this.i.onDidChangeValue(l=>this.l(l)))}l(h){if(h.scope!==0)return;if(this.h.has(h.key.toLowerCase())){this.g.fire();return}const m=Ze.c(h.key);if(m){if(this.i.get(h.key,0)===void 0)this.h.delete(m.id.toLowerCase());else{let g=this.h.get(m.id.toLowerCase());g||this.h.set(m.id.toLowerCase(),g=[]),g.push(m.version),this.g.fire()}return}}m(h){if((0,I.isString)(h))return h;const m=h.manifest?h.manifest.publisher:h.publisher,g=h.manifest?h.manifest.name:h.name;return(0,T.getExtensionId)(m,g)}getExtensionState(h,m){const g=this.m(h),l=this.getExtensionStateRaw(h,m);if(l)try{return JSON.parse(l)}catch(f){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${m}): ${f}`)}}getExtensionStateRaw(h,m){const g=this.m(h),l=this.i.get(g,m?0:1);return l&&l?.length>Ze.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${g}, global: ${m}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(h,m,g){const l=this.m(h);m===void 0?this.i.remove(l,g?0:1):this.i.store(l,JSON.stringify(m),g?0:1,1)}setKeysForSync(h,m){this.i.store(Ze.b(h),JSON.stringify(m),0,1)}getKeysForSync(h){const m=this.j.extensionSyncedKeys?.[h.id.toLowerCase()],g=this.i.get(Ze.b(h),0),l=g?JSON.parse(g):void 0;return l&&m?(0,P.distinct)([...l,...m]):l||m}addToMigrationList(h,m){if(h!==m){const g=this.n.filter(l=>!l.includes(h)&&!l.includes(m));g.push([h,m]),this.n=g}}getSourceExtensionToMigrate(h){const m=this.n.find(([,g])=>h===g);return m?m[0]:void 0}get n(){const h=this.i.get("extensionStorage.migrationList",-1,"[]");try{const m=JSON.parse(h);if(Array.isArray(m))return m}catch{}return[]}set n(h){h.length?this.i.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};w.a=512*1024,w=pe([Y(0,A.IStorageService),Y(1,R.IProductService),Y(2,b.ILogService)],w),e.ExtensionStorageService=w}),define(oe[267],ae([0,1,20,6,3,12,5,36,7,159,15,29,33,212,98,14,57,25,19,21]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const v="extensionTips/promptedExecutableTips",d="extensionTips/lastPromptedMediumImpExeTime";let n=class extends y.ExtensionTipsService{constructor(t,s,a,c,o,u,S,E){super(S,E),this.m=t,this.n=s,this.p=a,this.r=c,this.s=o,this.t=u,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,E.exeBasedExtensionTips&&Object.entries(E.exeBasedExtensionTips).forEach(([M,N])=>{const j=[],$=[],L=[];Object.entries(N.recommendations).forEach(([F,z])=>{z.important?N.important?j.push({extensionId:F,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):$.push({extensionId:F,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):L.push({extensionId:F,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),j.length&&this.g.set(M,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:j}),$.length&&this.h.set(M,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:$}),L.length&&this.j.set(M,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:L})}),(0,i.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const t=await this.I(this.g),s=await this.I(this.h);return[...t,...s]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const t=await this.I(this.g),s=await this.I(this.h),a=await this.p.getInstalled();this.k=this.v(t,a),this.l=this.v(s,a)}v(t,s){const a=new Map;t.forEach(E=>a.set(E.extensionId.toLowerCase(),E));const{installed:c,uninstalled:o}=this.H([...a.keys()],s);for(const E of c){const M=a.get(E);M&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:E,exeName:M.exeName})}for(const E of o){const M=a.get(E);M&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:E,exeName:M.exeName})}const u=this.F(),S=new Map;for(const E of o){const M=a.get(E);if(M&&(!u[M.exeName]||!u[M.exeName].includes(M.extensionId))){let N=S.get(M.exeName);N||(N=[],S.set(M.exeName,N)),N.push(M)}}return S}w(){if(this.k.size===0)return;const[t,s]=[...this.k.entries()][0];this.z(s).then(a=>{switch(a){case"reacted":this.G(s[0].exeName,s);break;case"ignored":this.k.delete(t);break;case"incompatibleWindow":{const c=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(c(()=>this.w()));break}case"toomany":{const c=this.B((0,i.disposableTimeout)(()=>{c.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const t=this.C(),s=Date.now()-t,a=7*24*60*60*1e3;if(s<a){const u=this.B((0,i.disposableTimeout)(()=>{u.dispose(),this.y()},a-s));return}const[c,o]=[...this.l.entries()][0];this.z(o).then(u=>{switch(u){case"reacted":{this.D(Date.now()),this.l.delete(c),this.G(o[0].exeName,o);const S=this.B((0,i.disposableTimeout)(()=>{S.dispose(),this.y()},a));break}case"ignored":this.l.delete(c),this.y();break;case"incompatibleWindow":{const S=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(S(()=>this.y()));break}case"toomany":{const S=this.B((0,i.disposableTimeout)(()=>{S.dispose(),this.y()},36e5));break}}})}async z(t){const s=await this.p.getInstalled(1),a=t.filter(o=>!o.whenNotInstalled||o.whenNotInstalled.every(u=>s.every(S=>!(0,w.areSameExtensions)(S.identifier,{id:u})))).map(({extensionId:o})=>o.toLowerCase()),c=(0,b.localize)(0,null,t[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(a,c,`@exe:"${t[0].exeName}"`,3)}C(){let t=this.r.getNumber(d,-1);return t||(t=Date.now(),this.D(t)),t}D(t){this.r.store(d,t,-1,1)}F(){return JSON.parse(this.r.get(v,-1,"{}"))}G(t,s){const a=this.F();a[t]=s.map(({extensionId:c})=>c.toLowerCase()),this.r.store(v,JSON.stringify(a),-1,0)}H(t,s){const a=[],c=[],o=s.reduce((u,S)=>(u.add(S.identifier.id.toLowerCase()),u),new Set);return t.forEach(u=>{o.has(u.toLowerCase())?a.push(u):c.push(u)}),{installed:a,uninstalled:c}}async I(t){const s=[],a=new Map;for(const c of t.keys()){const o=t.get(c);if(!o||!(0,k.isNonEmptyArray)(o.recommendations))continue;const u=[];T.isWindows?o.windowsPath&&u.push(o.windowsPath.replace("%USERPROFILE%",()=>R.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>R.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>R.env.ProgramFiles).replace("%APPDATA%",()=>R.env.APPDATA).replace("%WINDIR%",()=>R.env.WINDIR)):(u.push((0,A.join)("/usr/local/bin",c)),u.push((0,A.join)("/usr/bin",c)),u.push((0,A.join)(this.m.userHome.fsPath,c)));for(const S of u){let E=a.get(S);if(E===void 0&&(E=await this.b.exists(P.URI.file(S)),a.set(S,E)),E)for(const{extensionId:M,extensionName:N,isExtensionPack:j,whenNotInstalled:$}of o.recommendations)s.push({extensionId:M,extensionName:N,isExtensionPack:j,exeName:c,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:$})}}return s}};n=pe([Y(0,I.INativeEnvironmentService),Y(1,p.ITelemetryService),Y(2,C.IExtensionManagementService),Y(3,f.IStorageService),Y(4,g.INativeHostService),Y(5,h.IExtensionRecommendationNotificationService),Y(6,m.IFileService),Y(7,l.IProductService)],n),e.ExtensionTipsService=n}),define(oe[268],ae([0,1,6,2,23,69,19,76,18]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends T.AbstractStorageService{constructor(C,w,y,h){super(),this.X=C,this.Y=w,this.Z=y,this.ab=h,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new i.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new i.DisposableStore),this.W=this.db(this.X)}bb(){const C=this.B(new R.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),w=this.B(new A.Storage(C));return this.B(w.onDidChangeStorage(y=>this.n(-1,y))),w}cb(C){this.Q.clear(),this.P=C;let w;if((0,T.isProfileUsingDefaultStorage)(C))w=this.s;else{const y=this.Q.add(new R.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),C));w=this.Q.add(new A.Storage(y))}return this.Q.add(w.onDidChangeStorage(y=>this.n(0,y))),w}db(C){this.U.clear(),this.S=C?.id;let w;if(C){const y=this.U.add(new R.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),C));w=this.U.add(new A.Storage(y)),this.U.add(w.onDidChangeStorage(h=>this.n(1,h)))}return w}async J(){await k.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(C){switch(C){case-1:return this.s;case 0:return this.R;default:return this.W}}M(C){switch(C){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,D.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(T.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(C,w){if(!this.H(this.P,C))return;const y=this.R,h=y.items;y!==this.s&&await y.close(),this.R=this.cb(C),await this.R.init(),this.I(h,this.R,0,w)}async O(C,w){const y=this.W,h=y?.items??new Map;await y?.close(),this.W=this.db(C),await this.W.init(),this.I(h,this.W,1,w)}hasScope(C){return(0,P.isUserDataProfile)(C)?this.P.id===C.id:this.S===C.id}}e.NativeStorageService=b}),define(oe[62],ae([0,1,2,69,4,19]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,D.createDecorator)("IUserDataProfileStorageService");let T=class extends k.Disposable{constructor(b){super(),this.a=b}async readStorageData(b){return this.withProfileScopedStorageService(b,async I=>this.b(I))}async updateStorageData(b,I,C){return this.withProfileScopedStorageService(b,async w=>this.c(w,I,C))}async withProfileScopedStorageService(b,I){if(this.a.hasScope(b))return I(this.a);const C=await this.createStorageDatabase(b),w=new R(C);try{await w.initialize();const y=await I(w);return await w.flush(),y}finally{w.dispose(),await this.f(C)}}b(b){const I=new Map,C=w=>{for(const y of b.keys(0,w))I.set(y,{value:b.get(y,0),target:w})};return C(0),C(1),I}c(b,I,C){for(const[w,y]of I)b.store(w,y,0,C)}async f(b){try{await b.close()}finally{(0,k.isDisposable)(b)&&b.dispose()}}};T=pe([Y(0,A.IStorageService)],T),e.AbstractUserDataProfileStorageService=T;class R extends A.AbstractStorageService{constructor(b){super({flushInterval:100}),this.p=this.B(new i.Storage(b))}J(){return this.p.init()}L(b){return b===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[269],ae([0,1,3,2,23,15,56,18]),function(Z,e,k,i,D,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let P=class extends i.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(I,C,w){super(),this.b=[],this.c=this.B(new k.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=C.getChannel("userDataProfiles"),this.profilesHome=(0,D.joinPath)(w.userRoamingDataHome,"profiles"),this.b=I.map(y=>(0,R.reviveProfile)(y,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(y=>{const h=y.added.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),m=y.removed.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),g=y.updated.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme));this.b=y.all.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),this.c.fire({added:h,removed:m,updated:g,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(I){this.f=I}isEnabled(){return this.f}async createNamedProfile(I,C,w){const y=await this.a.call("createNamedProfile",[I,C,w]);return(0,R.reviveProfile)(y,this.profilesHome.scheme)}async createProfile(I,C,w,y){const h=await this.a.call("createProfile",[I,C,w,y]);return(0,R.reviveProfile)(h,this.profilesHome.scheme)}async createTransientProfile(I){const C=await this.a.call("createTransientProfile",[I]);return(0,R.reviveProfile)(C,this.profilesHome.scheme)}async setProfileForWorkspace(I,C){await this.a.call("setProfileForWorkspace",[I,C])}removeProfile(I){return this.a.call("removeProfile",[I])}async updateProfile(I,C){const w=await this.a.call("updateProfile",[I,C]);return(0,R.reviveProfile)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};P=pe([Y(1,T.IMainProcessService),Y(2,A.IEnvironmentService)],P),e.UserDataProfilesNativeService=P}),define(oe[270],ae([0,1,3,2,56,8,62,19,76,18,71]),function(Z,e,k,i,D,A,T,R,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let C=class extends T.AbstractUserDataProfileStorageService{constructor(y,h,m,g){super(m),this.h=y;const l=y.getChannel("profileStorageListener"),f=this.B(new i.MutableDisposable);this.g=this.B(new k.Emitter({onWillAddFirstListener:()=>{f.value=l.listen("onDidChange")(p=>{g.trace("profile storage changes",p),this.g.fire({targetChanges:p.targetChanges.map(v=>(0,b.reviveProfile)(v,h.profilesHome.scheme)),valueChanges:p.valueChanges.map(v=>({...v,profile:(0,b.reviveProfile)(v.profile,h.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>f.value=void 0})),this.onDidChange=this.g.event}async createStorageDatabase(y){const h=this.h.getChannel("storage");return(0,R.isProfileUsingDefaultStorage)(y)?new P.ApplicationStorageDatabaseClient(h):new P.ProfileStorageDatabaseClient(h,y)}};C=pe([Y(0,D.IMainProcessService),Y(1,b.IUserDataProfilesService),Y(2,R.IStorageService),Y(3,A.ILogService)],C),e.UserDataProfileStorageService=C,(0,I.registerSingleton)(T.IUserDataProfileStorageService,C,1)}),define(oe[41],ae([0,1,20,6,17,24,3,35,2,27,13,175,16,15,14,8,45,19,21,30,26,18]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(u){return!!(u&&u.ref!==void 0&&typeof u.ref=="string"&&u.ref!==""&&u.syncData!==void 0&&(u.syncData===null||r(u.syncData)))}e.isRemoteUserData=n;function r(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=r;function t(u,S){return`${(0,b.uppercaseFirstLetter)(u)}${S.isDefault?"":` (${S.name})`}`}e.getSyncResourceLogLabel=t;let s=class extends P.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(S,E,M,N,j,$,L,F,z,W,H,Q){super(),this.syncResource=S,this.collection=E,this.C=M,this.D=N,this.F=j,this.G=$,this.H=L,this.I=F,this.J=z,this.L=W,this.M=H,this.c=null,this.k="idle",this.l=this.B(new T.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new T.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new i.ThrottledDelayer(50),this.t=this.B(new T.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(S.syncResource,S.profile),this.h=Q.extUri,this.f=this.h.joinPath(N.userDataSyncHome,...(0,v.getPathSegments)(S.profile.isDefault?void 0:S.profile.id,S.syncResource)),this.g=this.h.joinPath(this.f,v.PREVIEW_DIR_NAME),this.u=(0,v.getLastSyncResourceUri)(S.profile.isDefault?void 0:S.profile.id,S.syncResource,N,this.h),this.j=(0,g.getServiceMachineId)(N,M,j)}triggerLocalChange(){this.s.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const S=await this.c;this.c=null;const E=await this.S(S.remoteUserData,S.lastSyncUserData,!0,this.lb());this.O(E)}else{this.L.trace(`${this.y}: Checking for local changes...`);const S=await this.getLastSyncUserData();(S?await this.rb(S):!0)&&this.t.fire()}}O(S){this.k!==S&&(this.k=S,this.l.fire(S))}async sync(S,E={}){await this.P(S,!0,this.lb(),E)}async preview(S,E,M={}){return this.P(S,!1,E,M)}async apply(S,E={}){try{this.z={...E};const M=await this.X(S);return this.O(M),this.c}finally{this.z={}}}async P(S,E,M,N){try{if(this.z={...N},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let j="idle";try{const $=await this.getLastSyncUserData(),L=await this.R(S,$);return j=await this.S(L,$,E,M),j==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):j==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O(j)}}finally{this.z={}}}async replace(S){const E=this.hb(S);if(!E)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const M=await this.getLastSyncUserData(),N=await this.R(null,M),j=await this.Q(N),$=await this.nb({ref:N.ref,syncData:E},M,j,this.lb(),A.CancellationToken.None),L=[];for(const F of $){const z=await this.pb(F,F.remoteResource,void 0,A.CancellationToken.None),{remoteChange:W}=await this.pb(F,F.previewResource,F.remoteContent,A.CancellationToken.None);L.push([F,{...z,remoteChange:W!==0?W:2}])}await this.qb(N,M,L,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(S){const E=await this.j;return!!S.syncData?.machineId&&S.syncData.machineId===E}async R(S,E){if(E){const M=S?S[this.resource]:void 0;if(E.ref===M||M===void 0&&E.syncData===null)return E}return this.getRemoteUserData(E)}async S(S,E,M,N){if(S.syncData&&S.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new v.UserDataSyncError((0,C.localize)(0,null,this.resource,this.mb,S.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(S,E,M,N)}catch(j){if(j instanceof v.UserDataSyncError)switch(j.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.S(S,E,M,N);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),S=await this.getRemoteUserData(null),E=await this.getLastSyncUserData(),this.S(S,E,M,N)}throw j}}async U(S,E,M,N){try{const j=await this.Q(S),$=!j&&E===null&&this.db()!==void 0,L=M&&!$;this.c||(this.c=(0,i.createCancelablePromise)(z=>this.bb(S,E,j,L,N,z)));let F=await this.c;if(M&&$){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const z of F.resourcePreviews)F=await this.accept(z.remoteResource)||F}return this.Z(F.resourcePreviews),F.resourcePreviews.some(({mergeState:z})=>z==="conflict")?"hasConflicts":M?await this.X(!1):"syncing"}catch(j){throw this.c=null,j}}async merge(S){return await this.W(S,async E=>{const M=await this.ob(E,A.CancellationToken.None);await this.C.writeFile(E.previewResource,D.VSBuffer.fromString(M?.content||""));const N=M&&!M.hasConflicts?await this.pb(E,E.previewResource,void 0,A.CancellationToken.None):void 0;return E.acceptResult=N,E.mergeState=M.hasConflicts?"conflict":N?"accepted":"preview",E.localChange=N?N.localChange:M.localChange,E.remoteChange=N?N.remoteChange:M.remoteChange,E}),this.c}async accept(S,E){return await this.W(S,async M=>{const N=await this.pb(M,S,E,A.CancellationToken.None);return M.acceptResult=N,M.mergeState="accepted",M.localChange=N.localChange,M.remoteChange=N.remoteChange,M}),this.c}async discard(S){return await this.W(S,async E=>{const M=await this.ob(E,A.CancellationToken.None);return await this.C.writeFile(E.previewResource,D.VSBuffer.fromString(M.content||"")),E.acceptResult=void 0,E.mergeState="preview",E.localChange=M.localChange,E.remoteChange=M.remoteChange,E}),this.c}async W(S,E){if(!this.c)return;let M=await this.c;const N=M.resourcePreviews.findIndex(({localResource:j,remoteResource:$,previewResource:L})=>this.h.isEqual(j,S)||this.h.isEqual($,S)||this.h.isEqual(L,S));N!==-1&&(this.c=(0,i.createCancelablePromise)(async j=>{const $=[...M.resourcePreviews];return $[N]=await E($[N]),{...M,resourcePreviews:$}}),M=await this.c,this.Z(M.resourcePreviews),M.resourcePreviews.some(({mergeState:j})=>j==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(S){if(!this.c)return"idle";const E=await this.c;return E.resourcePreviews.some(({mergeState:M})=>M==="conflict")?"hasConflicts":E.resourcePreviews.some(({mergeState:M})=>M!=="accepted")?"syncing":(await this.qb(E.remoteUserData,E.lastSyncUserData,E.resourcePreviews.map(M=>[M,M.acceptResult]),S),this.c=null,await this.Y(),"idle")}async Y(){try{await this.C.del(this.g,{recursive:!0})}catch{}}Z(S){const E=S.filter(({mergeState:M})=>M==="conflict");(0,k.equals)(this.m,E,(M,N)=>this.h.isEqual(M.previewResource,N.previewResource))||(this.m=E,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const S=await this.getLastSyncUserData();return!!S&&S.syncData!==null}async ab(S){const E=this.c?await this.c:null;if(E)for(const M of E.resourcePreviews){if(this.h.isEqual(M.acceptedResource,S))return M.acceptResult?M.acceptResult.content:null;if(this.h.isEqual(M.remoteResource,S))return M.remoteContent;if(this.h.isEqual(M.localResource,S))return M.localContent;if(this.h.isEqual(M.baseResource,S))return M.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(S){(0,h.toFileOperationResult)(S)!==1&&this.L.error(S)}}async bb(S,E,M,N,j,$){const L=await this.nb(S,E,M,j,$),F=[];for(const z of L){const W=z.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)F.push({...z,acceptedResource:W,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const H=N?await this.ob(z,$):void 0;if($.isCancellationRequested)break;await this.C.writeFile(z.previewResource,D.VSBuffer.fromString(H?.content||""));const Q=H&&!H.hasConflicts?await this.pb(z,z.previewResource,void 0,$):void 0;F.push({...z,acceptResult:Q,mergeState:H?.hasConflicts?"conflict":Q?"accepted":"preview",localChange:Q?Q.localChange:H?H.localChange:z.localChange,remoteChange:Q?Q.remoteChange:H?H.remoteChange:z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:S,lastSyncUserData:E,resourcePreviews:F,isLastSyncFromCurrentMachine:M}}async getLastSyncUserData(){let S=this.db();if(S||(S=await this.gb()),!S)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const E=JSON.parse(S),M=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!E.version&&!!M&&E.version!==M,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${E.version} is not compatible with current sync state version ${M}.`),await this.resetLocal(),null;let N,j=1;for(;N===void 0&&j++<6;)try{const $=await this.eb();$&&($.ref===E.ref?N=$.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch($){if($ instanceof h.FileOperationError&&$.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if($ instanceof v.UserDataSyncError)throw $;this.L.error($,j)}}if(N===void 0)try{const $=await this.G.resolveResourceContent(this.resource,E.ref,this.collection,this.z);N=$===null?null:this.hb($),await this.fb({ref:E.ref,syncData:N})}catch($){if($ instanceof v.UserDataSyncError&&$.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw $}return N===void 0?null:{...E,syncData:N}}async cb(S,E={}){if(E.ref||E.version)throw new Error("Cannot have core properties as additional");const M=this.I.getResourceSyncStateVersion(this.resource),N={ref:S.ref,version:M,...E};this.F.store(this.v,JSON.stringify(N),-1,1),await this.fb(S)}db(){return this.F.get(this.v,-1)}async eb(){const S=(await this.C.readFile(this.u)).value.toString();try{const E=S?JSON.parse(S):void 0;if(n(E))return E}catch(E){this.L.error(E)}}async fb(S){await this.C.writeFile(this.u,D.VSBuffer.fromString(JSON.stringify(S)))}async gb(){try{const S=await this.C.readFile(this.u),E=JSON.parse(S.value.toString());await this.C.del(this.u),E.ref&&E.content!==void 0&&(this.F.store(this.v,JSON.stringify({...E,content:void 0}),-1,1),await this.fb({ref:E.ref,syncData:E.content===null?null:JSON.parse(E.content)}))}catch(S){S instanceof h.FileOperationError&&S.fileOperationResult===1?this.L.debug(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(S)}return this.F.get(this.v,-1)}async getRemoteUserData(S){const{ref:E,content:M}=await this.ib(S);let N=null;return M!==null&&(N=this.hb(M)),{ref:E,syncData:N}}hb(S){try{const E=JSON.parse(S);if(r(E))return E}catch(E){this.L.error(E)}throw new v.UserDataSyncError((0,C.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(S){const E=S?{ref:S.ref,content:S.syncData?JSON.stringify(S.syncData):null}:null;return this.G.readResource(this.resource,E,this.collection,this.z)}async jb(S,E){const M=await this.j,N={version:this.mb,machineId:M,content:S};try{return E=await this.G.writeResource(this.resource,JSON.stringify(N),E,this.collection,this.z),{ref:E,syncData:N}}catch(j){throw j instanceof v.UserDataSyncError&&j.code==="TooLarge"&&(j=new v.UserDataSyncError(j.message,j.code,this.resource)),j}}async kb(S){const E={version:this.mb,content:S};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(E))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};s=pe([Y(2,h.IFileService),Y(3,y.IEnvironmentService),Y(4,l.IStorageService),Y(5,v.IUserDataSyncStoreService),Y(6,v.IUserDataSyncBackupStoreService),Y(7,v.IUserDataSyncEnablementService),Y(8,f.ITelemetryService),Y(9,v.IUserDataSyncLogService),Y(10,w.IConfigurationService),Y(11,p.IUriIdentityService)],s),e.AbstractSynchroniser=s;let a=class extends s{constructor(S,E,M,N,j,$,L,F,z,W,H,Q,K){super(E,M,N,j,$,L,F,z,W,H,Q,K),this.i=S,this.B(this.C.watch(this.h.dirname(S))),this.B(this.C.onDidFilesChange(V=>this.tb(V)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(S,E,M){try{E?await this.C.writeFile(this.i,D.VSBuffer.fromString(S),M?void 0:E):await this.C.createFile(this.i,D.VSBuffer.fromString(S),{overwrite:M})}catch(N){throw N instanceof h.FileOperationError&&N.fileOperationResult===1||N instanceof h.FileOperationError&&N.fileOperationResult===3?new v.UserDataSyncError(N.message,"LocalPreconditionFailed"):N}}async sb(){try{await this.C.del(this.i)}catch(S){if(!(S instanceof h.FileOperationError&&S.fileOperationResult===1))throw S}}tb(S){!S.contains(this.i)||this.triggerLocalChange()}};a=pe([Y(3,h.IFileService),Y(4,y.IEnvironmentService),Y(5,l.IStorageService),Y(6,v.IUserDataSyncStoreService),Y(7,v.IUserDataSyncBackupStoreService),Y(8,v.IUserDataSyncEnablementService),Y(9,f.ITelemetryService),Y(10,v.IUserDataSyncLogService),Y(11,w.IConfigurationService),Y(12,p.IUriIdentityService)],a),e.AbstractFileSynchroniser=a;let c=class extends a{constructor(S,E,M,N,j,$,L,F,z,W,H,Q,K,V){super(S,E,M,N,j,$,L,F,z,W,H,K,V),this.ub=Q,this.wb=void 0}vb(S,E){const M=[],N=(0,R.parse)(S,M,{allowEmptyContent:!0,allowTrailingComma:!0});return M.length>0||!(0,I.isUndefined)(N)&&E!==Array.isArray(N)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};c=pe([Y(3,h.IFileService),Y(4,y.IEnvironmentService),Y(5,l.IStorageService),Y(6,v.IUserDataSyncStoreService),Y(7,v.IUserDataSyncBackupStoreService),Y(8,v.IUserDataSyncEnablementService),Y(9,f.ITelemetryService),Y(10,v.IUserDataSyncLogService),Y(11,v.IUserDataSyncUtilService),Y(12,w.IConfigurationService),Y(13,p.IUriIdentityService)],c),e.AbstractJsonFileSynchroniser=c;let o=class{constructor(S,E,M,N,j,$,L){this.resource=S,this.g=E,this.h=M,this.j=N,this.k=j,this.l=$,this.d=L.extUri,this.f=(0,v.getLastSyncResourceUri)(void 0,this.resource,M,this.d)}async initialize({ref:S,content:E}){if(!E){this.j.info("Remote content does not exist.",this.resource);return}const M=this.m(E);if(!!M)try{await this.doInitialize({ref:S,syncData:M})}catch(N){this.j.error(N)}}m(S){try{const E=JSON.parse(S);if(r(E))return E}catch(E){this.j.error(E)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(S,E={}){if(E.ref||E.version)throw new Error("Cannot have core properties as additional");const M={ref:S.ref,version:void 0,...E};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(M),-1,1),await this.k.writeFile(this.f,D.VSBuffer.fromString(JSON.stringify(S)))}};o=pe([Y(1,d.IUserDataProfilesService),Y(2,y.IEnvironmentService),Y(3,m.ILogService),Y(4,h.IFileService),Y(5,l.IStorageService),Y(6,p.IUriIdentityService)],o),e.AbstractInitializer=o}),define(oe[117],ae([0,1,6,24,9,3,43,2,27,16,15,116,29,33,80,14,4,72,8,19,21,30,18,41,253,114,26,62]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p,v,d,n,r,t,s,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function o(j,$){const L=JSON.parse(j.content);if(j.version===1||j.version===2){const F=(await $.getInstalled(0)).filter(z=>z.isBuiltin);for(const z of L)j.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),j.version===2&&F.every(W=>!(0,y.areSameExtensions)(W.identifier,z.identifier))&&(z.installed=!0)}return L}function u(j){return JSON.parse(j.content)}e.parseExtensions=u;function S(j,$){return j.sort((L,F)=>!L.identifier.uuid&&F.identifier.uuid?-1:L.identifier.uuid&&!F.identifier.uuid?1:(0,P.compare)(L.identifier.id,F.identifier.id)),$?(0,T.toFormattedString)(j,{}):JSON.stringify(j)}e.stringify=S;let E=class extends r.AbstractSynchroniser{constructor($,L,F,z,W,H,Q,K,V,G,x,ne,se,ie,O,U,q){super({syncResource:"extensions",profile:$},L,z,F,W,H,Q,ne,se,G,x,O),this.yb=K,this.zb=V,this.Ab=q,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(M),this.B(A.Event.any(A.Event.filter(this.yb.onDidInstallExtensions,B=>B.some(({local:X})=>!!X)),A.Event.filter(this.yb.onDidUninstallExtension,B=>!B.error),A.Event.filter(U.onDidChange,B=>B.valueChanges.some(({profile:X,changes:ee})=>this.syncResource.profile.id===X.id&&ee.some(J=>J.key===w.DISABLED_EXTENSIONS_STORAGE_PATH))),ie.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async nb($,L){const F=$.syncData?await o($.syncData,this.yb):null,z=L?.skippedExtensions||[],W=L?.builtinExtensions||[],H=L?.syncData?await o(L.syncData,this.yb):null,{localExtensions:Q,ignoredExtensions:K}=await this.xb.getLocalExtensions(this.syncResource.profile);F?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:G}=(0,t.merge)(Q,F,H,z,K,W),x={local:V,remote:G,content:this.Db(Q,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:G!==null?2:0},ne=this.Jb(Q,!1);return[{skippedExtensions:z,builtinExtensions:W,baseResource:this.tb,baseContent:H?this.Jb(H,!1):ne,localResource:this.ub,localContent:ne,localExtensions:Q,remoteResource:this.vb,remoteExtensions:F,remoteContent:F?this.Jb(F,!1):null,previewResource:this.sb,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.wb}]}async rb($){const L=$.syncData?await o($.syncData,this.yb):null,{localExtensions:F,ignoredExtensions:z}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:W}=(0,t.merge)(F,L,L,$.skippedExtensions||[],z,$.builtinExtensions||[]);return W!==null}Db($,L,F,z){const W=[...L,...F],H=new Set,Q=K=>{H.add(K.id.toLowerCase()),K.uuid&&H.add(K.uuid)};W.forEach(({identifier:K})=>Q(K)),z.forEach(Q);for(const K of $)H.has(K.identifier.id.toLowerCase())||K.identifier.uuid&&H.has(K.identifier.uuid)||W.push(K);return this.Jb(W,!1)}async ob($,L){return{...$.previewResult,hasConflicts:!1}}async pb($,L,F,z){if(this.h.isEqual(L,this.ub))return this.Gb($);if(this.h.isEqual(L,this.vb))return this.Hb($);if(this.h.isEqual(L,this.sb))return $.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async Gb($){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),F=this.zb.getIgnoredExtensions(L),z=(0,t.merge)($.localExtensions,null,null,$.skippedExtensions,F,$.builtinExtensions),{local:W,remote:H}=z;return{content:$.localContent,local:W,remote:H,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Hb($){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),F=this.zb.getIgnoredExtensions(L),z=$.remoteContent?JSON.parse($.remoteContent):null;if(z!==null){const W=(0,t.merge)($.localExtensions,z,$.localExtensions,[],F,$.builtinExtensions),{local:H,remote:Q}=W;return{content:$.remoteContent,local:H,remote:Q,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:$.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb($,L,F,z){let{skippedExtensions:W,localExtensions:H}=F[0][0];const{local:Q,remote:K,localChange:V,remoteChange:G}=F[0][1];if(V===0&&G===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),V!==0&&(await this.kb(JSON.stringify(H)),W=await this.xb.updateLocalExtensions(Q.added,Q.removed,Q.updated,W,this.syncResource.profile)),K){this.L.trace(`${this.y}: Updating remote extensions...`);const x=JSON.stringify(K.all);$=await this.jb(x,z?null:$.ref),this.L.info(`${this.y}: Updated remote extensions.${K.added.length?` Added: ${JSON.stringify(K.added.map(ne=>ne.identifier.id))}.`:""}${K.updated.length?` Updated: ${JSON.stringify(K.updated.map(ne=>ne.identifier.id))}.`:""}${K.removed.length?` Removed: ${JSON.stringify(K.removed.map(ne=>ne.identifier.id))}.`:""}`)}if(L?.ref!==$.ref){this.L.trace(`${this.y}: Updating last synchronized extensions...`);const x=H.filter(ne=>!ne.installed).map(ne=>ne.identifier);await this.cb($,{skippedExtensions:W,builtinExtensions:x}),this.L.info(`${this.y}: Updated last synchronized extensions.${W.length?` Skipped: ${JSON.stringify(W.map(ne=>ne.identifier.id))}.`:""}`)}}async resolveContent($){if(this.h.isEqual(this.vb,$)||this.h.isEqual(this.tb,$)||this.h.isEqual(this.ub,$)||this.h.isEqual(this.wb,$)){const L=await this.ab($);return L&&this.Jb(JSON.parse(L),!0)}return null}Jb($,L){return S($,L)}async hasLocalData(){try{const{localExtensions:$}=await this.xb.getLocalExtensions(this.syncResource.profile);if($.some(L=>L.installed||L.disabled))return!0}catch{}return!1}};E=pe([Y(2,I.IEnvironmentService),Y(3,m.IFileService),Y(4,p.IStorageService),Y(5,a.IUserDataSyncStoreService),Y(6,a.IUserDataSyncBackupStoreService),Y(7,w.IExtensionManagementService),Y(8,s.IIgnoredExtensionsManagementService),Y(9,a.IUserDataSyncLogService),Y(10,b.IConfigurationService),Y(11,a.IUserDataSyncEnablementService),Y(12,v.ITelemetryService),Y(13,h.IExtensionStorageService),Y(14,d.IUriIdentityService),Y(15,c.IUserDataProfileStorageService),Y(16,g.IInstantiationService)],E),e.ExtensionsSynchroniser=E;let M=class{constructor($,L,F,z,W,H){this.a=$,this.b=L,this.c=F,this.d=z,this.f=W,this.g=H}async getLocalExtensions($){const L=await this.a.getInstalled(void 0,$.extensionsResource),F=this.d.getIgnoredExtensions(L);return{localExtensions:await this.j($,async(W,H)=>{const Q=W.getDisabledExtensions();return L.map(K=>{const{identifier:V,isBuiltin:G,manifest:x,preRelease:ne}=K,se={identifier:V,preRelease:ne,version:x.version};Q.some(ie=>(0,y.areSameExtensions)(ie,V))&&(se.disabled=!0),G||(se.installed=!0);try{const ie=H.getKeysForSync({id:V.id,version:x.version});if(ie){const O=H.getExtensionState(K,!0)||{};se.state=Object.keys(O).reduce((U,q)=>(ie.includes(q)&&(U[q]=O[q]),U),{})}}catch(ie){this.g.info(`${(0,r.getSyncResourceLogLabel)("extensions",$)}: Error while parsing extension state`,(0,D.getErrorMessage)(ie))}return se})}),ignoredExtensions:F}}async updateLocalExtensions($,L,F,z,W){const H=(0,r.getSyncResourceLogLabel)("extensions",W);return this.j(W,async(Q,K)=>{const V=[],G=[],x=await this.a.getInstalled(void 0,W.extensionsResource);if(L.length){const se=x.filter(({identifier:ie,isBuiltin:O})=>!O&&L.some(U=>(0,y.areSameExtensions)(ie,U)));await k.Promises.settled(se.map(async ie=>{this.g.trace(`${H}: Uninstalling local extension...`,ie.identifier.id),await this.a.uninstall(ie,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:W.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,ie.identifier.id),V.push(ie.identifier)}))}($.length||F.length)&&await k.Promises.settled([...$,...F].map(async se=>{const ie=x.find(U=>(0,y.areSameExtensions)(U.identifier,se.identifier));if(ie&&ie.isBuiltin){se.state&&ie.manifest.version===se.version&&this.h(se.state,ie,ie.manifest.version,K),Q.getDisabledExtensions().some(q=>(0,y.areSameExtensions)(q,se.identifier))!==!!se.disabled&&(se.disabled?(this.g.trace(`${H}: Disabling extension...`,se.identifier.id),await Q.disableExtension(se.identifier),this.g.info(`${H}: Disabled extension`,se.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,se.identifier.id),await Q.enableExtension(se.identifier),this.g.info(`${H}: Enabled extension`,se.identifier.id))),V.push(se.identifier);return}const O=(await this.c.getExtensions([{...se.identifier,preRelease:se.preRelease}],i.CancellationToken.None))[0];if(se.state&&(ie?ie.manifest.version===se.version:!!O)&&this.h(se.state,ie||O,ie?.manifest.version,K),O)try{Q.getDisabledExtensions().some(q=>(0,y.areSameExtensions)(q,se.identifier))!==!!se.disabled&&(se.disabled?(this.g.trace(`${H}: Disabling extension...`,se.identifier.id,O.version),await Q.disableExtension(O.identifier),this.g.info(`${H}: Disabled extension`,se.identifier.id,O.version)):(this.g.trace(`${H}: Enabling extension...`,se.identifier.id,O.version),await Q.enableExtension(O.identifier),this.g.info(`${H}: Enabled extension`,se.identifier.id,O.version))),(!ie||ie.preRelease!==se.preRelease)&&(await this.a.canInstall(O)?(this.g.trace(`${H}: Installing extension...`,se.identifier.id,O.version),await this.a.installFromGallery(O,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:se.preRelease,profileLocation:W.extensionsResource}),this.g.info(`${H}: Installed extension.`,se.identifier.id,O.version),V.push(O.identifier)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,O.displayName||O.identifier.id),G.push(se)))}catch(U){G.push(se),U instanceof w.ExtensionManagementError&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatiblePreRelease,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(U.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,O.displayName||O.identifier.id):(this.g.error(U),this.g.info(`${H}: Skipped synchronizing extension`,O.displayName||O.identifier.id))}else G.push(se),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,se.identifier.id)}));const ne=[];for(const se of z)V.some(ie=>(0,y.areSameExtensions)(ie,se.identifier))||ne.push(se);for(const se of G)ne.some(ie=>(0,y.areSameExtensions)(ie.identifier,se.identifier))||ne.push(se);return ne})}h($,L,F,z){const W=z.getExtensionState(L,!0)||{},H=F?z.getKeysForSync({id:L.identifier.id,version:F}):void 0;H?H.forEach(Q=>{W[Q]=$[Q]}):Object.keys($).forEach(Q=>W[Q]=$[Q]),z.setExtensionState(L,W,!0)}async j($,L){return this.b.withProfileScopedStorageService($,async F=>{const z=new R.DisposableStore,W=this.f.createChild(new l.ServiceCollection([p.IStorageService,F])),H=z.add(W.createInstance(C.GlobalExtensionEnablementService)),Q=z.add(W.createInstance(h.ExtensionStorageService));try{return await L(H,Q)}finally{z.dispose()}})}};M=pe([Y(0,w.IExtensionManagementService),Y(1,c.IUserDataProfileStorageService),Y(2,w.IExtensionGalleryService),Y(3,s.IIgnoredExtensionsManagementService),Y(4,g.IInstantiationService),Y(5,a.IUserDataSyncLogService)],M),e.LocalExtensionsProvider=M;let N=class extends r.AbstractInitializer{constructor($,L,F,z,W,H,Q,K){super("extensions",z,W,H,F,Q,K),this.o=$,this.p=L}async q($){return $.syncData?await o($.syncData,this.o):null}t($,L){const F=[],z=[],W=[];for(const H of $){if(this.p.hasToNeverSyncExtension(H.identifier.id))continue;const Q=L.find(K=>(0,y.areSameExtensions)(K.identifier,H.identifier));Q?(F.push(Q),H.disabled&&W.push(H.identifier)):H.installed&&(z.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&W.push(H.identifier))}return{installedExtensions:F,newExtensions:z,disabledExtensions:W,remoteExtensions:$}}};N=pe([Y(0,w.IExtensionManagementService),Y(1,s.IIgnoredExtensionsManagementService),Y(2,m.IFileService),Y(3,n.IUserDataProfilesService),Y(4,I.IEnvironmentService),Y(5,f.ILogService),Y(6,p.IStorageService),Y(7,d.IUriIdentityService)],N),e.AbstractExtensionsInitializer=N}),define(oe[118],ae([0,1,17,9,3,35,43,5,31,16,15,14,8,45,19,21,30,41,60,257,26,18,62,4]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p,v,d,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",s=["locale"];function a(M,N){const j=M.storage?Object.keys(M.storage).sort():[],$={};return j.forEach(L=>$[L]=M.storage[L]),M.storage=$,N?(0,T.toFormattedString)(M,{}):JSON.stringify(M)}e.stringify=a;const c=1;let o=class extends l.AbstractSynchroniser{constructor(N,j,$,L,F,z,W,H,Q,K,V,G,x,ne){super({syncResource:"globalState",profile:N},j,L,H,G,F,z,Q,K,W,V,x),this.wb=$,this.mb=c,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.sb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.tb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.ub=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.vb=ne.createInstance(u),this.B(L.watch(this.h.dirname(this.D.argvResource))),this.B(D.Event.any(D.Event.filter(L.onDidFilesChange,se=>se.contains(this.D.argvResource)),D.Event.filter($.onDidChange,se=>!!(se.targetChanges.some(ie=>this.syncResource.profile.id===ie.id)||se.valueChanges.some(({profile:ie,changes:O})=>this.syncResource.profile.id===ie.id&&O.some(U=>U.target===0)))))(()=>this.triggerLocalChange()))}async nb(N,j,$){const L=N.syncData?JSON.parse(N.syncData.content):null;j=j===null&&$?N:j;const F=j&&j.syncData?JSON.parse(j.syncData.content):null,z=await this.vb.getLocalGlobalState(this.syncResource.profile);L?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const W=await this.Eb(F),{local:H,remote:Q}=(0,p.merge)(z.storage,L?L.storage:null,F?F.storage:null,W,this.L),K={content:null,local:H,remote:Q,localChange:Object.keys(H.added).length>0||Object.keys(H.updated).length>0||H.removed.length>0?2:0,remoteChange:Q.all!==null?2:0},V=a(z,!1);return[{baseResource:this.r,baseContent:F?a(F,!1):V,localResource:this.sb,localContent:V,localUserData:z,remoteResource:this.tb,remoteContent:L?a(L,!1):null,previewResource:this.p,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.ub,storageKeys:W}]}async rb(N){const j=N.syncData?JSON.parse(N.syncData.content):null;if(j===null)return!0;const $=await this.vb.getLocalGlobalState(this.syncResource.profile),L=await this.Eb(j),{remote:F}=(0,p.merge)($.storage,j.storage,j.storage,L,this.L);return F.all!==null}async ob(N,j){return{...N.previewResult,hasConflicts:!1}}async pb(N,j,$,L){if(this.h.isEqual(j,this.sb))return this.Bb(N);if(this.h.isEqual(j,this.tb))return this.Cb(N);if(this.h.isEqual(j,this.p))return N.previewResult;throw new Error(`Invalid Resource: ${j.toString()}`)}async Bb(N){return{content:N.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(N.localUserData.storage),removed:[],updated:[],all:N.localUserData.storage},localChange:0,remoteChange:2}}async Cb(N){if(N.remoteContent!==null){const j=JSON.parse(N.remoteContent),{local:$,remote:L}=(0,p.merge)(N.localUserData.storage,j.storage,null,N.storageKeys,this.L);return{content:N.remoteContent,local:$,remote:L,localChange:Object.keys($.added).length>0||Object.keys($.updated).length>0||$.removed.length>0?2:0,remoteChange:L!==null?2:0}}else return{content:N.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(N,j,$,L){const{localUserData:F}=$[0][0],{local:z,remote:W,localChange:H,remoteChange:Q}=$[0][1];if(H===0&&Q===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),H!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify(F)),await this.vb.writeLocalGlobalState(z,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),Q!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const K=JSON.stringify({storage:W.all});N=await this.jb(K,L?null:N.ref),this.L.info(`${this.y}: Updated remote ui state.${W.added.length?` Added: ${W.added}.`:""}${W.updated.length?` Updated: ${W.updated}.`:""}${W.removed.length?` Removed: ${W.removed}.`:""}`)}j?.ref!==N.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(N),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(N){if(this.h.isEqual(this.tb,N)||this.h.isEqual(this.r,N)||this.h.isEqual(this.sb,N)||this.h.isEqual(this.ub,N)){const j=await this.ab(N);return j&&a(JSON.parse(j),!0)}return null}async hasLocalData(){try{const{storage:N}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(N).length>1||N[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(N){const j=await this.wb.readStorageData(this.syncResource.profile),$=[],L=[];for(const[W,H]of j)H.target===0?$.push(W):H.target===1&&L.push(W);const F=[...$,...L],z=N?.storage?Object.keys(N.storage).filter(W=>!W.startsWith(t)&&!F.includes(W)&&j.get(W)!==void 0):[];if(!R.isWeb){const W=[...v.ALL_SYNC_RESOURCES.map(H=>(0,v.getEnablementKey)(H)),v.SYNC_SERVICE_URL_TYPE];z.push(...W),L.push(...W)}return{user:$,machine:L,unregistered:z}}};o=pe([Y(2,n.IUserDataProfileStorageService),Y(3,C.IFileService),Y(4,v.IUserDataSyncStoreService),Y(5,v.IUserDataSyncBackupStoreService),Y(6,v.IUserDataSyncLogService),Y(7,I.IEnvironmentService),Y(8,v.IUserDataSyncEnablementService),Y(9,m.ITelemetryService),Y(10,b.IConfigurationService),Y(11,h.IStorageService),Y(12,g.IUriIdentityService),Y(13,r.IInstantiationService)],o),e.GlobalStateSynchroniser=o;let u=class{constructor(N,j,$,L){this.a=N,this.b=j,this.c=$,this.d=L}async getLocalGlobalState(N){const j={};if(N.isDefault){const L=await this.f(),F=(0,A.parse)(L);for(const z of s)F[z]!==void 0&&(j[`${t}${z}`]={version:1,value:F[z]})}const $=await this.c.readStorageData(N);for(const[L,F]of $)F.value&&F.target===0&&(j[L]={version:1,value:F.value});return{storage:j}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const N=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),N.value.toString()}catch(N){this.d.debug((0,i.getErrorMessage)(N))}return"{}"}async writeLocalGlobalState({added:N,removed:j,updated:$},L){const F=(0,l.getSyncResourceLogLabel)("globalState",L),z={},W=new Map,H=await this.c.readStorageData(L),Q=(K,V)=>{for(const G of K){if(G.startsWith(t)){z[G.substring(t.length)]=V?V[G].value:void 0;continue}if(V){const x=V[G];x.value!==H.get(G)?.value&&W.set(G,x.value)}else H.get(G)!==void 0&&W.set(G,void 0)}};if(Q(Object.keys(N),N),Q(Object.keys($),$),Q(j),Object.keys(z).length){this.d.trace(`${F}: Updating locale...`);const K=await this.f();let V=K;for(const G of Object.keys(z))V=(0,f.edit)(V,[G],z[G],{});K!==V&&(this.d.trace(`${F}: Updating locale...`),await this.a.writeFile(this.b.argvResource,k.VSBuffer.fromString(V)),this.d.info(`${F}: Updated locale.`)),this.d.info(`${F}: Updated locale`)}W.size&&(this.d.trace(`${F}: Updating global state...`),await this.c.updateStorageData(L,W,0),this.d.info(`${F}: Updated global state`,[...W.keys()]))}};u=pe([Y(0,C.IFileService),Y(1,I.IEnvironmentService),Y(2,n.IUserDataProfileStorageService),Y(3,v.IUserDataSyncLogService)],u),e.LocalGlobalStateProvider=u;let S=class extends l.AbstractInitializer{constructor(N,j,$,L,F,z){super("globalState",$,L,F,j,N,z)}async doInitialize(N){const j=N.syncData?JSON.parse(N.syncData.content):null;if(!j){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const $={},L={};for(const F of Object.keys(j.storage))F.startsWith(t)?$[F.substring(t.length)]=j.storage[F].value:this.l.get(F,0)===void 0&&(L[F]=j.storage[F].value);if(Object.keys($).length){let F="{}";try{F=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const z of Object.keys($))F=(0,f.edit)(F,[z],$[z],{});await this.k.writeFile(this.h.argvResource,k.VSBuffer.fromString(F))}if(Object.keys(L).length)for(const F of Object.keys(L))this.l.store(F,L[F],0,0)}};S=pe([Y(0,h.IStorageService),Y(1,C.IFileService),Y(2,d.IUserDataProfilesService),Y(3,I.IEnvironmentService),Y(4,v.IUserDataSyncLogService),Y(5,g.IUriIdentityService)],S),e.GlobalStateInitializer=S;let E=class{constructor(N,j,$,L,F){this.a=N,this.b=j,this.c=$,this.d=L,this.f=F}getSyncStoreType(N){return this.h(N)?.storage[v.SYNC_SERVICE_URL_TYPE]?.value}async sync(N){const j=(0,v.createSyncHeaders)((0,P.generateUuid)());try{return await this.g(N,j)}catch($){if($ instanceof v.UserDataSyncError)switch($.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(N,j)}throw $}}async g(N,j){const $=await this.a.readResource("globalState",null,void 0,j),L=this.h($)||{storage:{}};L.storage[v.SYNC_SERVICE_URL_TYPE]={value:N,version:c};const F=await(0,y.getServiceMachineId)(this.c,this.d,this.b),z={version:c,machineId:F,content:a(L,!1)};await this.a.writeResource("globalState",JSON.stringify(z),$.ref,void 0,j)}h({content:N}){if(!N)return null;const j=JSON.parse(N);if((0,l.isSyncData)(j))return j?JSON.parse(j.content):null;throw new Error("Invalid remote data")}};E=pe([Y(1,h.IStorageService),Y(2,I.IEnvironmentService),Y(3,C.IFileService),Y(4,w.ILogService)],E),e.UserDataSyncStoreTypeSynchronizer=E}),define(oe[119],ae([0,1,20,17,3,35,5,13,176,16,15,14,19,21,30,18,41,254,26]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function p(n,r,t){try{const s=JSON.parse(n);if(!r)return(0,R.isUndefined)(s.all)?null:s.all;switch(T.OS){case 2:return(0,R.isUndefined)(s.mac)?null:s.mac;case 3:return(0,R.isUndefined)(s.linux)?null:s.linux;case 1:return(0,R.isUndefined)(s.windows)?null:s.windows}}catch(s){return t.error(s),null}}e.getKeybindingsContentFromSyncContent=p;let v=class extends g.AbstractJsonFileSynchroniser{constructor(r,t,s,a,c,o,u,S,E,M,N,j,$){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,S,E,M,s,a,u,j,c,N,o,$),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Bb=this.zb.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Cb=this.zb.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Db=this.zb.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(D.Event.filter(o.onDidChangeConfiguration,L=>L.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async nb(r,t,s,a){const c=r.syncData?p(r.syncData.content,a.keybindingsPerPlatform??this.Lb(),this.L):null;t=t===null&&s?r:t;const o=t?this.Jb(t):null,u=await this.p(),S=await this.xb();let E=null,M=!1,N=!1,j=!1;if(c){let F=u?u.value.toString():"[]";if(F=F||"[]",this.vb(F,!0))throw new f.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==F||o!==c){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const z=await(0,l.merge)(F,c,o,S,this.ub);z.hasChanges&&(E=z.mergeContent,j=z.hasConflicts,M=j||z.mergeContent!==F,N=j||z.mergeContent!==c)}}else u&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),E=u.value.toString(),N=!0);const $={content:j?o:E,localChange:M?u?2:1:0,remoteChange:N?2:0,hasConflicts:j},L=u?u.value.toString():null;return[{fileContent:u,baseResource:this.Ab,baseContent:o,localResource:this.Bb,localContent:L,localChange:$.localChange,remoteResource:this.Cb,remoteContent:c,remoteChange:$.remoteChange,previewResource:this.zb,previewResult:$,acceptedResource:this.Db}]}async rb(r){const t=this.Jb(r);if(t===null)return!0;const s=await this.p(),a=s?s.value.toString():"",c=await this.xb(),o=await(0,l.merge)(a||"[]",t,t,c,this.ub);return o.hasConflicts||o.mergeContent!==t}async ob(r,t){return r.previewResult}async pb(r,t,s,a){if(this.h.isEqual(t,this.Bb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Cb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.zb))return s===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(r,t,s,a){const{fileContent:c}=s[0][0];let{content:o,localChange:u,remoteChange:S}=s[0][1];if(u===0&&S===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.vb(o,!0)))throw new f.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),c&&await this.kb(this.Kb(c.value.toString())),await this.r(o||"[]",c,a),this.L.info(`${this.y}: Updated local keybindings`)),S!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const E=this.Kb(o||"[]",r.syncData?.content);r=await this.jb(E,a?null:r.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(r,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=(0,A.parse)(r.value.toString());if((0,k.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Ab,r)||this.h.isEqual(this.Bb,r)||this.h.isEqual(this.Db,r)?this.ab(r):null}Jb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Lb()?null:p(r.syncData.content,this.Lb(),this.L)}Kb(r,t){let s={};try{s=JSON.parse(t||"{}")}catch(a){this.L.error(a)}switch(this.Lb()?delete s.all:s.all=r,T.OS){case 2:s.mac=r;break;case 3:s.linux=r;break;case 1:s.windows=r;break}return JSON.stringify(s)}Lb(){return!!this.M.getValue(f.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};v=pe([Y(2,f.IUserDataSyncStoreService),Y(3,f.IUserDataSyncBackupStoreService),Y(4,f.IUserDataSyncLogService),Y(5,b.IConfigurationService),Y(6,f.IUserDataSyncEnablementService),Y(7,C.IFileService),Y(8,I.IEnvironmentService),Y(9,w.IStorageService),Y(10,f.IUserDataSyncUtilService),Y(11,y.ITelemetryService),Y(12,h.IUriIdentityService)],v),e.KeybindingsSynchroniser=v;let d=class extends g.AbstractInitializer{constructor(r,t,s,a,c,o){super("keybindings",t,s,a,r,c,o)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,i.VSBuffer.fromString(t)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,A.parse)(r.value.toString());return!(0,k.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}i(r){try{return p(r,!0,this.j)}catch(t){return this.j.error(t),null}}};d=pe([Y(0,C.IFileService),Y(1,m.IUserDataProfilesService),Y(2,I.IEnvironmentService),Y(3,f.IUserDataSyncLogService),Y(4,w.IStorageService),Y(5,h.IUriIdentityService)],d),e.KeybindingsInitializer=d}),define(oe[120],ae([0,1,17,3,177,16,74,15,29,14,19,21,30,18,41,60,258,26]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function p(n){const r=JSON.parse(n);return f(r)?r:{settings:n}}e.parseSettingsSyncContent=p;let v=class extends h.AbstractJsonFileSynchroniser{constructor(r,t,s,a,c,o,u,S,E,M,N,j,$,L){super(r.settingsResource,{syncResource:"settings",profile:r},t,s,a,c,o,u,N,j,S,E,M,L),this.zb=$,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),s=await this.R(r,t),a=this.Gb(s),c=new T.ConfigurationModelParser(l.USER_DATA_SYNC_CONFIGURATION_SCOPE);return a?.settings&&c.parse(a.settings),c.configurationModel.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(r,t,s){const a=await this.p(),c=await this.xb(),o=this.Gb(r);t=t===null&&s?r:t;const u=t?this.Gb(t):null,S=await this.Kb();let E=null,M=!1,N=!1,j=!1;if(o){let z=a?a.value.toString().trim():"{}";z=z||"{}",this.Lb(z),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const W=(0,g.merge)(z,o.settings,u?u.settings:null,S,[],c);E=W.localContent||W.remoteContent,M=W.localContent!==null,N=W.remoteContent!==null,j=W.hasConflicts}else a&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),E=a.value.toString().trim()||"{}",this.Lb(E),N=!0);const $=a?a.value.toString():null,L=u?.settings??null,F={content:j?L:E,localChange:M?2:0,remoteChange:N?2:0,hasConflicts:j};return[{fileContent:a,baseResource:this.baseResource,baseContent:L,localResource:this.localResource,localContent:$,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async rb(r){const t=this.Gb(r);if(t===null)return!0;const s=await this.p(),a=s?s.value.toString().trim():"",c=await this.Kb(),o=await this.xb();return(0,g.merge)(a||"{}",t.settings,t.settings,c,[],o).remoteContent!==null}async ob(r,t){const s=await this.xb(),a=await this.Kb();return{...r.previewResult,content:r.previewResult.content?(0,g.updateIgnoredSettings)(r.previewResult.content,"{}",a,s):null}}async pb(r,t,s,a){const c=await this.xb(),o=await this.Kb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,g.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,c):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,g.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,c):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return s===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:s!==null?(0,g.updateIgnoredSettings)(s,r.fileContent?r.fileContent.value.toString():"{}",o,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(r,t,s,a){const{fileContent:c}=s[0][0];let{content:o,localChange:u,remoteChange:S}=s[0][1];if(u===0&&S===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Lb(o),u!==0&&(this.L.trace(`${this.y}: Updating local settings...`),c&&await this.kb(JSON.stringify(this.Ib(c.value.toString()))),await this.r(o,c,a),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),S!==0){const E=await this.xb(),M=this.Gb(r),N=await this.Kb(o);o=(0,g.updateIgnoredSettings)(o,M?M.settings:"{}",N,E),this.L.trace(`${this.y}: Updating remote settings...`),r=await this.jb(JSON.stringify(this.Ib(o)),a?null:r.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(r),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=await this.xb(),s=(0,m.edit)(r.value.toString(),[l.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,g.isEmpty)(s)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.ab(r):null}async ab(r){let t=await super.ab(r);if(t){const s=await this.xb(),a=await this.Kb();t=(0,g.updateIgnoredSettings)(t,"{}",a,s)}return t}Gb(r){return r.syncData?this.Hb(r.syncData.content):null}Hb(r){try{return p(r)}catch(t){this.L.error(t)}return null}Ib(r){return{settings:r}}async Kb(r){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const s=i.Event.any(i.Event.filter(this.zb.onDidInstallExtensions,a=>a.some(({local:c})=>!!c)),i.Event.filter(this.zb.onDidUninstallExtension,a=>!a.error))(()=>{s.dispose(),this.Jb=void 0})}const t=await this.Jb;return(0,g.getIgnoredSettings)(t,this.M,r)}Lb(r){if(this.vb(r,!1))throw new l.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};v=pe([Y(2,b.IFileService),Y(3,R.IEnvironmentService),Y(4,I.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncLogService),Y(8,l.IUserDataSyncUtilService),Y(9,A.IConfigurationService),Y(10,l.IUserDataSyncEnablementService),Y(11,C.ITelemetryService),Y(12,P.IExtensionManagementService),Y(13,w.IUriIdentityService)],v),e.SettingsSynchroniser=v;let d=class extends h.AbstractInitializer{constructor(r,t,s,a,c,o){super("settings",t,s,a,r,c,o)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,k.VSBuffer.fromString(t.settings)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,g.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}i(r){try{return p(r)}catch(t){this.j.error(t)}return null}};d=pe([Y(0,b.IFileService),Y(1,y.IUserDataProfilesService),Y(2,R.IEnvironmentService),Y(3,l.IUserDataSyncLogService),Y(4,I.IStorageService),Y(5,w.IUriIdentityService)],d),e.SettingsInitializer=d}),define(oe[121],ae([0,1,17,3,32,16,15,14,19,21,30,18,41,255,26]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function m(f){return JSON.parse(f.content)}e.parseSnippets=m;let g=class extends w.AbstractSynchroniser{constructor(p,v,d,n,r,t,s,a,c,o,u,S){super({syncResource:"snippets",profile:p},v,n,d,r,t,s,o,u,a,c,S),this.mb=1,this.p=p.snippetsHome,this.B(this.C.watch(d.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(i.Event.filter(this.C.onDidFilesChange,E=>E.affects(this.p))(()=>this.triggerLocalChange()))}async nb(p,v,d){const n=await this.Cb(),r=this.Bb(n),t=p.syncData?this.Ab(p.syncData):null;v=v===null&&d?p:v;const s=v&&v.syncData?this.Ab(v.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const a=(0,y.merge)(r,t,s);return this.wb(a,n,t||{},s||{})}async rb(p){const v=p.syncData?this.Ab(p.syncData):null;if(v===null)return!0;const d=await this.Cb(),n=this.Bb(d),r=(0,y.merge)(n,v,v);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async ob(p,v){return p.previewResult}async pb(p,v,d,n){if(this.h.isEqualOrParent(v,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:p.fileContent?p.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(v,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:p.remoteContent,localChange:p.remoteContent!==null?p.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(v,this.g))return d===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:d,localChange:d===null?p.fileContent!==null?3:0:2,remoteChange:d===null?p.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async qb(p,v,d,n){const r=d.map(([t,s])=>({...t,acceptResult:s}));r.every(({localChange:t,remoteChange:s})=>t===0&&s===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.xb(r),await this.yb(r,n)),r.some(({remoteChange:t})=>t!==0)&&(p=await this.zb(r,p,n)),v?.ref!==p.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(p),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.C.del(t)}catch{}}wb(p,v,d,n){const r=new Map;for(const t of Object.keys(p.local.added)){const s={content:p.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.local.updated)){const s={content:p.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},a=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:a,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},a=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:a,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.remote.added)){const s={content:p.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},a=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:a,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.remote.updated)){const s={content:p.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},a=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:a,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.conflicts){const s={content:n[t]??null,hasConflicts:!0,localChange:v[t]?2:1,remoteChange:d[t]?2:1},a=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t]||null,localContent:a,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(v))if(!r.has(t)){const s={content:v[t]?v[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},a=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t]||null,localContent:a,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(p){return this.h.isEqualOrParent(p,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(p,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(p,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(p,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(p):null}async hasLocalData(){try{const p=await this.Cb();if(Object.keys(p).length)return!0}catch{}return!1}async xb(p){const v={};for(const d of p)d.fileContent&&(v[this.h.basename(d.localResource)]=d.fileContent);await this.kb(JSON.stringify(this.Bb(v)))}async yb(p,v){for(const{fileContent:d,acceptResult:n,localResource:r,remoteResource:t,localChange:s}of p)if(s!==0){const a=t?this.h.basename(t):this.h.basename(r),c=this.h.joinPath(this.p,a);s===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(c)),await this.C.del(c),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(c))):s===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(c)),await this.C.createFile(c,k.VSBuffer.fromString(n.content),{overwrite:v}),this.L.info(`${this.y}: Created snippet`,this.h.basename(c))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(c)),await this.C.writeFile(c,k.VSBuffer.fromString(n.content),v?void 0:d),this.L.info(`${this.y}: Updated snippet`,this.h.basename(c)))}}async zb(p,v,d){const n=v.syncData?this.Ab(v.syncData):{},r=(0,D.deepClone)(n);for(const{acceptResult:t,localResource:s,remoteResource:a,remoteChange:c}of p)if(c!==0){const o=s?this.h.basename(s):this.h.basename(a);c===3?delete r[o]:r[o]=t.content}return(0,y.areSame)(n,r)||(this.L.trace(`${this.y}: Updating remote snippets...`),v=await this.jb(JSON.stringify(r),d?null:v.ref),this.L.info(`${this.y}: Updated remote snippets`)),v}Ab(p){return m(p)}Bb(p){const v={};for(const d of Object.keys(p))v[d]=p[d].value.toString();return v}async Cb(){const p={};let v;try{v=await this.C.resolve(this.p)}catch(d){if(d instanceof R.FileOperationError&&d.fileOperationResult===1)return p;throw d}for(const d of v.children||[]){const n=d.resource,r=this.h.extname(n);if(r===".json"||r===".code-snippets"){const t=this.h.relativePath(this.p,n),s=await this.C.readFile(n);p[t]=s}}return p}};g=pe([Y(2,T.IEnvironmentService),Y(3,R.IFileService),Y(4,P.IStorageService),Y(5,h.IUserDataSyncStoreService),Y(6,h.IUserDataSyncBackupStoreService),Y(7,h.IUserDataSyncLogService),Y(8,A.IConfigurationService),Y(9,h.IUserDataSyncEnablementService),Y(10,b.ITelemetryService),Y(11,I.IUriIdentityService)],g),e.SnippetsSynchroniser=g;let l=class extends w.AbstractInitializer{constructor(p,v,d,n,r,t){super("snippets",v,d,n,p,r,t)}async doInitialize(p){const v=p.syncData?JSON.parse(p.syncData.content):null;if(!v){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(v)){const r=v[n];if(r){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(t,k.VSBuffer.fromString(r)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(p)}async c(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(p){return p.fileOperationResult===1}}};l=pe([Y(0,R.IFileService),Y(1,C.IUserDataProfilesService),Y(2,T.IEnvironmentService),Y(3,h.IUserDataSyncLogService),Y(4,P.IStorageService),Y(5,I.IUriIdentityService)],l),e.SnippetsInitializer=l}),define(oe[122],ae([0,1,17,16,15,14,19,21,30,18,41,26]),function(Z,e,k,i,D,A,T,R,P,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function w(g,l){try{return JSON.parse(g).tasks??null}catch(f){return l.error(f),null}}e.getTasksContentFromSyncContent=w;let y=class extends I.AbstractFileSynchroniser{constructor(l,f,p,v,d,n,r,t,s,a,c,o){super(l.tasksResource,{syncResource:"tasks",profile:l},f,t,s,a,p,v,r,c,d,n,o),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"base"}),this.xb=this.vb.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"local"}),this.yb=this.vb.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.zb=this.vb.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(l,f,p,v){const d=l.syncData?w(l.syncData.content,this.L):null;f=f===null&&p?l:f;const n=f?.syncData?w(f.syncData.content,this.L):null,r=await this.p();let t=null,s=!1,a=!1,c=!1;if(l.syncData){const S=r?r.value.toString():null;if(!n||n!==S||n!==d){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const E=m(S,d,n);t=E.content,c=E.hasConflicts,s=E.hasLocalChanged,a=E.hasRemoteChanged}}else r&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),a=!0);const o={content:c?n:t,localChange:s?r?2:1:0,remoteChange:a?2:0,hasConflicts:c},u=r?r.value.toString():null;return[{fileContent:r,baseResource:this.wb,baseContent:n,localResource:this.xb,localContent:u,localChange:o.localChange,remoteResource:this.yb,remoteContent:d,remoteChange:o.remoteChange,previewResource:this.vb,previewResult:o,acceptedResource:this.zb}]}async rb(l){const f=l?.syncData?w(l.syncData.content,this.L):null;if(f===null)return!0;const p=await this.p(),v=p?p.value.toString():null,d=m(v,f,f);return d.hasLocalChanged||d.hasRemoteChanged}async ob(l,f){return l.previewResult}async pb(l,f,p,v){if(this.h.isEqual(f,this.xb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(f,this.yb))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(f,this.vb))return p===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:p,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async qb(l,f,p,v){const{fileContent:d}=p[0][0],{content:n,localChange:r,remoteChange:t}=p[0][1];if(r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),r!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),d&&await this.kb(JSON.stringify(this.Fb(d.value.toString()))),n?await this.r(n,d,v):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const s=JSON.stringify(this.Fb(n));l=await this.jb(s,v?null:l.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}f?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(l){return this.h.isEqual(this.yb,l)||this.h.isEqual(this.wb,l)||this.h.isEqual(this.xb,l)||this.h.isEqual(this.zb,l)?this.ab(l):null}Fb(l){return l?{tasks:l}:{}}};y=pe([Y(2,C.IUserDataSyncStoreService),Y(3,C.IUserDataSyncBackupStoreService),Y(4,C.IUserDataSyncLogService),Y(5,i.IConfigurationService),Y(6,C.IUserDataSyncEnablementService),Y(7,A.IFileService),Y(8,D.IEnvironmentService),Y(9,T.IStorageService),Y(10,R.ITelemetryService),Y(11,P.IUriIdentityService)],y),e.TasksSynchroniser=y;let h=class extends I.AbstractInitializer{constructor(l,f,p,v,d,n){super("tasks",f,p,v,l,d,n),this.c=this.g.defaultProfile.tasksResource}async doInitialize(l){const f=l.syncData?w(l.syncData.content,this.j):null;if(!f){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,k.VSBuffer.fromString(f)),await this.n(l)}async i(){return this.k.exists(this.c)}};h=pe([Y(0,A.IFileService),Y(1,b.IUserDataProfilesService),Y(2,D.IEnvironmentService),Y(3,C.IUserDataSyncLogService),Y(4,T.IStorageService),Y(5,P.IUriIdentityService)],h),e.TasksInitializer=h;function m(g,l,f){if(g===null&&l===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(g===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const p=f!==g,v=f!==l;return!p&&!v?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:p&&!v?{content:g,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:v&&!p?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:g,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[123],ae([0,1,43,16,15,14,19,21,30,18,41,256,26]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let y=class extends I.AbstractSynchroniser{constructor(l,f,p,v,d,n,r,t,s,a,c,o,u){super({syncResource:"profiles",profile:l},f,v,d,n,r,t,c,o,s,a,u),this.r=p,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?m(l.syncData):null}async getRemoteSyncedProfiles(l){const f=await this.getLastSyncUserData(),p=await this.R(l,f);return p?.syncData?m(p.syncData):null}async nb(l,f,p){if(!this.r.isEnabled())throw new w.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const v=l.syncData?m(l.syncData):null,d=f?.syncData?m(f.syncData):null,n=this.zb(),{local:r,remote:t}=(0,C.merge)(n,v,d,[]),s={local:r,remote:t,content:d?this.Ab(d):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},a=h(n,!1);return[{baseResource:this.baseResource,baseContent:d?this.Ab(d):null,localResource:this.localResource,localContent:a,remoteResource:this.remoteResource,remoteContent:v?this.Ab(v):null,remoteProfiles:v,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async rb(l){const f=l?.syncData?m(l.syncData):null,p=this.zb(),{remote:v}=(0,C.merge)(p,f,f,[]);return!!v?.added.length||!!v?.removed.length||!!v?.updated.length}async ob(l,f){return{...l.previewResult,hasConflicts:!1}}async pb(l,f,p,v){if(this.h.isEqual(f,this.localResource))return this.wb(l);if(this.h.isEqual(f,this.remoteResource))return this.xb(l);if(this.h.isEqual(f,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async wb(l){const f=this.zb(),p=(0,C.merge)(f,null,null,[]),{local:v,remote:d}=p;return{content:l.localContent,local:v,remote:d,localChange:v.added.length>0||v.removed.length>0||v.updated.length>0?2:0,remoteChange:d!==null?2:0}}async xb(l){const f=l.remoteContent?JSON.parse(l.remoteContent):null,p=[],v=[];for(const d of this.zb()){const n=f?.find(r=>r.id===d.id);n&&(p.push({id:d.id,name:d.name,collection:n.collection}),v.push(d))}if(f!==null){const d=(0,C.merge)(v,f,p,[]),{local:n,remote:r}=d;return{content:l.remoteContent,local:n,remote:r,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(l,f,p,v){const{local:d,remote:n,localChange:r,remoteChange:t}=p[0][1];r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const s=p[0][0].remoteProfiles||[];if(s.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new w.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.kb(h(this.zb(),!1));const a=[];for(const c of d.added)a.push((async()=>{this.L.trace(`${this.y}: Creating '${c.name}' profile...`),await this.r.createProfile(c.id,c.name,{shortName:c.shortName}),this.L.info(`${this.y}: Created profile '${c.name}'.`)})());for(const c of d.removed)a.push((async()=>{this.L.trace(`${this.y}: Removing '${c.name}' profile...`),await this.r.removeProfile(c),this.L.info(`${this.y}: Removed profile '${c.name}'.`)})());for(const c of d.updated){const o=this.r.profiles.find(u=>u.id===c.id);o?a.push((async()=>{this.L.trace(`${this.y}: Updating '${c.name}' profile...`),await this.r.updateProfile(o,{name:c.name,shortName:c.shortName}),this.L.info(`${this.y}: Updated profile '${c.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${c.id}' to update.`)}await Promise.all(a)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const a=[],c=s.length+(n?.added.length??0)<=20;if(c)for(const o of n?.added||[]){const u=await this.G.createCollection(this.z);a.push(u),s.push({id:o.id,name:o.name,collection:u,shortName:o.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const o of n?.removed||[])s.splice(s.findIndex(({id:u})=>o.id===u),1);for(const o of n?.updated||[]){const u=s.find(({id:S})=>o.id===S);u&&s.splice(s.indexOf(u),1,{id:o.id,name:o.name,collection:u.collection,shortName:o.shortName})}try{l=await this.updateRemoteProfiles(s,v?null:l.ref),this.L.info(`${this.y}: Updated remote profiles.${c&&n?.added.length?` Added: ${JSON.stringify(n.added.map(o=>o.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(o=>o.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(o=>o.name))}.`:""}`)}catch(o){if(a.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const u of a)await this.G.deleteCollection(u,this.z)}throw o}for(const o of n?.removed||[])await this.G.deleteCollection(o.collection,this.z)}f?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,f){return this.jb(this.Ab(l),f)}async hasLocalData(){return this.zb().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const f=await this.ab(l);return f&&(0,k.toFormattedString)(JSON.parse(f),{})}return null}zb(){return this.r.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Ab(l){return JSON.stringify([...l].sort((f,p)=>f.name.localeCompare(p.name)))}};y=pe([Y(2,b.IUserDataProfilesService),Y(3,A.IFileService),Y(4,D.IEnvironmentService),Y(5,T.IStorageService),Y(6,w.IUserDataSyncStoreService),Y(7,w.IUserDataSyncBackupStoreService),Y(8,w.IUserDataSyncLogService),Y(9,i.IConfigurationService),Y(10,w.IUserDataSyncEnablementService),Y(11,R.ITelemetryService),Y(12,P.IUriIdentityService)],y),e.UserDataProfilesManifestSynchroniser=y;function h(g,l){const f=[...g].sort((p,v)=>p.name.localeCompare(v.name)).map(p=>({id:p.id,name:p.name}));return l?(0,k.toFormattedString)(f,{}):JSON.stringify(f)}e.stringifyLocalProfiles=h;function m(g){return JSON.parse(g.content)}e.parseUserDataProfilesManifest=m}),define(oe[271],ae([0,1,6,17,65,2,23,16,15,14,18,26]),function(Z,e,k,i,D,A,T,R,P,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends A.Disposable{constructor(h,m,g,l,f){super(),this.a=h,this.b=m,this.c=g,this.f=l,this.g=f;for(const p of this.g.profiles)for(const v of C.ALL_SYNC_RESOURCES)this.i(this.h(p,v))}async getAllRefs(h,m){const g=this.h(h,m),l=await this.b.resolve(g);return l.children?l.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.j(p)})):[]}async resolveContent(h,m,g){const l=this.h(h,m),f=(0,T.joinPath)(l,g);try{return(await this.b.readFile(f)).value.toString()}catch(p){return this.f.error(p),null}}async backup(h,m,g){const l=this.h(h,m),f=(0,T.joinPath)(l,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(f,i.VSBuffer.fromString(g))}catch(p){this.f.error(p)}try{this.i(l)}catch{}}h(h,m){return(0,T.joinPath)(this.a.userDataSyncHome,...h.isDefault?[m]:[h.id,m])}async i(h){try{try{if(!await this.b.exists(h))return}catch{return}const m=await this.b.resolve(h);if(m.children){const g=m.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let f=g.filter(v=>Date.now()-this.j(v)>l);const p=g.length-f.length;p<10&&(f=f.slice(10-p)),await k.Promises.settled(f.map(async v=>{this.f.info("Deleting from backup",v.resource.path),await this.b.del(v.resource)}))}}catch(m){this.f.error(m)}}j(h){return h.ctime||new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};w=pe([Y(0,P.IEnvironmentService),Y(1,b.IFileService),Y(2,R.IConfigurationService),Y(3,C.IUserDataSyncLogService),Y(4,I.IUserDataProfilesService)],w),e.UserDataSyncBackupStoreService=w}),define(oe[272],ae([0,1,3,2,5,15,19,21,26]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const b="sync.enable";let I=class extends i.Disposable{constructor(w,y,h,m){super(),this.c=w,this.f=y,this.g=h,this.h=m,this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new k.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(g=>this.j(g)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(b,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(b,{enabled:w}),this.c.store(b,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,P.getEnablementKey)(w),-1,!0)}setResourceEnablement(w,y){if(this.isResourceEnabled(w)!==y){const h=(0,P.getEnablementKey)(w);this.i(h,y)}}getResourceSyncStateVersion(w){}i(w,y){this.c.store(w,y,-1,D.isWeb?0:1)}j(w){if(w.scope!==-1)return;if(b===w.key){this.a.fire(this.isEnabled());return}const y=P.ALL_SYNC_RESOURCES.filter(h=>(0,P.getEnablementKey)(h)===w.key)[0];if(y){this.b.fire([y,this.isResourceEnabled(y)]);return}}};I=pe([Y(0,T.IStorageService),Y(1,R.ITelemetryService),Y(2,A.IEnvironmentService),Y(3,P.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(oe[81],ae([0,1,3,2,5,27,180,15,14,4,25,45,19,26]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",m="Safari",g="Chrome",l="Edge",f="Firefox",p="Android";function v(r){switch(r){case m:case g:case l:case f:case p:case(0,D.PlatformToString)(0):return!0}return!1}e.isWebPlatform=v;function d(){return D.isSafari?m:D.isChrome?g:D.isEdge?l:D.isFirefox?f:D.isAndroid?p:(0,D.PlatformToString)(D.isWeb?0:D.platform)}let n=class rt extends i.Disposable{constructor(t,s,a,c,o,u){super(),this.h=a,this.i=c,this.j=o,this.k=u,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,C.getServiceMachineId)(t,s,a)}async getMachines(t){const s=await this.f;return(await this.m(t)).machines.map(c=>({...c,isCurrent:c.id===s}))}async addCurrentMachine(t){const s=await this.f,a=await this.m(t);a.machines.some(({id:c})=>c===s)||(a.machines.push({id:s,name:this.l(a.machines),platform:d()}),await this.n(a))}async removeCurrentMachine(t){const s=await this.f,a=await this.m(t),c=a.machines.filter(({id:o})=>o!==s);c.length!==a.machines.length&&(a.machines=c,await this.n(a))}async renameMachine(t,s,a){const c=await this.m(a),o=c.machines.find(({id:u})=>u===t);if(o){o.name=s,await this.n(c);const u=await this.f;t===u&&this.h.store(h,s,-1,1)}}async setEnablements(t){const s=await this.m();for(const[a,c]of t){const o=s.machines.find(u=>u.id===a);o&&(o.disabled=c?void 0:!0)}await this.n(s)}l(t){const s=this.h.get(h,-1);if(s)return s;const a=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${d()} (${this.k.nameShort})`,c=new RegExp(`${(0,A.escapeRegExpCharacters)(a)}\\s#(\\d+)`);let o=0;for(const u of t){const S=c.exec(u.name),E=S?parseInt(S[1]):0;o=E>o?E:o}return`${a} #${o+1}`}async m(t){this.g=await this.p(t);const s=this.r(this.g);if(s.version!==rt.a)throw new Error((0,T.localize)(0,null,this.k.nameLong));return s}async n(t){const s=JSON.stringify(t),a=await this.i.writeResource(rt.b,s,this.g?.ref||null);this.g={ref:a,content:s},this.c.fire()}async p(t){if(this.g){const s=t&&t.latest?t.latest[rt.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.i.readResource(rt.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.j.error(s)}return{version:rt.a,machines:[]}}};n.a=1,n.b="machines",n=pe([Y(0,R.IEnvironmentService),Y(1,P.IFileService),Y(2,w.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncLogService),Y(5,I.IProductService)],n),e.UserDataSyncMachinesService=n}),define(oe[273],ae([0,1,6,65,38,9,3,2,5,23,7,178,25,19,21,26,78,81]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const f="sync.disableMachineEventually",p="sync.sessionId",v="sync.storeUrl",d="sync.productQuality";let n=class extends R.Disposable{get j(){const s=this.z.get(v,-1);return s?I.URI.parse(s):void 0}set j(s){s?this.z.store(v,s.toString(),-1,1):this.z.remove(v,-1)}get l(){return this.z.get(d,-1)}set l(s){s?this.z.store(d,s,-1,1):this.z.remove(d,-1)}constructor(s,a,c,o,u,S,E,M,N,j){super(),this.n=a,this.p=c,this.r=o,this.s=u,this.u=S,this.v=E,this.w=M,this.y=N,this.z=j,this.a=this.B(new R.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new k.ThrottledDelayer(this.O())),this.i=this.j,this.j=a.userDataSyncStore?.url,this.k=this.l,this.l=s.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(a.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.j,a.userDataSyncStore?.url)||(this.i=this.j,this.j=a.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(E.onDidChangeAccount(()=>this.C())),this.B(c.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(u.onDidChangeLocal($=>this.triggerSync([$],!1,!1))),this.B(T.Event.filter(this.r.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:s,message:a}=this.F();s?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(c=>this.I(c))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(a&&this.u.info(a),this.a.clear()):a&&this.r.isEnabled()&&this.u.info(a))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(s,a,c){try{this.v.account&&!c&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(p,-1),s?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(o){if(this.u.error(o),a)this.G(!1);else throw o}}G(s){this.r.isEnabled()!==s&&(this.r.setEnablement(s),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(s){if(!s){this.b=0;return}const a=m.UserDataSyncError.toUserDataSyncError(s);a instanceof m.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:a.code,service:this.n.userDataSyncStore.url.toString()}),a.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):a.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):a.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):a.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):a.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):a.code==="UpgradeRequired"||a.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):a.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${a.resource} content with newer version than of client. Requires client upgrade.`)):a.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${a.resource} content with older version than of client. Requires server reset.`)):a.code==="ServiceChanged"||a.code==="DefaultServiceChanged"?P.isWeb&&a.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(a),this.b++),this.h.fire(a)}async J(){this.z.store(f,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(f,-1,!1)}M(){this.z.remove(f,-1)}async triggerSync(s,a,c){if(this.a.value===void 0)return this.f.cancel();if(a&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...s),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const o=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:o}),this.N=[],this.a.value&&await this.a.value.sync("Activity",c)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};n=pe([Y(0,w.IProductService),Y(1,m.IUserDataSyncStoreManagementService),Y(2,m.IUserDataSyncStoreService),Y(3,m.IUserDataSyncEnablementService),Y(4,m.IUserDataSyncService),Y(5,m.IUserDataSyncLogService),Y(6,g.IUserDataSyncAccountService),Y(7,h.ITelemetryService),Y(8,l.IUserDataSyncMachinesService),Y(9,y.IStorageService)],n),e.UserDataAutoSyncService=n;class r extends R.Disposable{constructor(s,a,c,o,u,S,E,M){super(),this.j=s,this.k=a,this.l=c,this.m=o,this.n=u,this.p=S,this.r=E,this.s=M,this.b=this.B(new R.MutableDisposable),this.c=this.B(new T.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new T.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,R.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}u(){this.b.value=(0,k.disposableTimeout)(()=>this.sync(r.a,!1),this.k)}sync(s,a){const c=(0,k.createCancelablePromise)(async o=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(u){if((0,A.isCancellationError)(u))return}return this.y(s,a,o)});return this.i=c,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,b.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const s=await this.l.getPreviousUserDataSyncStore(),a=this.l.userDataSyncStore;return!!a&&!!s&&(!(0,b.isEqual)(a.defaultUrl,s.defaultUrl)||!(0,b.isEqual)(a.insidersUrl,s.insidersUrl)||!(0,b.isEqual)(a.stableUrl,s.stableUrl))}async y(s,a,c){this.r.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let o;try{await this.z(a,c)}catch(u){if(this.r.error(u),o=u,m.UserDataSyncError.toUserDataSyncError(u).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(a,c),o=void 0}catch(S){this.r.error(S),o=S}}this.f.fire(o)}async z(s,a){if(this.h=await this.n.createSyncTask(this.g,s),a.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new m.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new m.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new m.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const c=this.s.get(p,-1);if(c&&this.g&&c!==this.g.session)throw this.v()?await this.w()?new m.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new m.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new m.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const o=await this.p.getMachines(this.g||void 0);if(a.isCancellationRequested)return;const u=o.find(S=>S.isCurrent);if(u?.disabled)throw new m.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(S){throw new m.UserDataAutoSyncError((0,D.toErrorMessage)(S),S instanceof m.UserDataSyncError?S.code:"Unknown")}this.g&&this.g.session!==c&&this.s.store(p,this.g.session,-1,1),!a.isCancellationRequested&&(u||await this.p.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}r.a="Interval"}),define(oe[274],ae([0,1,7,181,15,14,45,19,30,26,18,41,121,120,119,16,122,117,118,4,123,43]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class Ve{constructor(t,s,a,c,o,u,S,E,M,N){this.e=t,this.f=s,this.g=a,this.h=o,this.i=u,this.j=S,this.k=E,this.l=M,this.m=N,this.d=c.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const s=this.K(t.content,"profiles");return(0,v.parseUserDataProfilesManifest)(s)}return[]}async getRemoteSyncResourceHandles(t,s){return(await this.e.getAllResourceRefs(t,s?.collection)).map(({created:c,ref:o})=>({created:c,uri:this.I({remote:!0,syncResource:t,profile:s?.id??this.k.defaultProfile.id,collection:s?.collection,ref:o,node:void 0})}))}async getLocalSyncResourceHandles(t,s){return(await this.f.getAllRefs(s,t)).map(({created:c,ref:o})=>({created:c,uri:this.I({remote:!1,syncResource:t,profile:s.id,collection:void 0,ref:o,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const s=this.J(t),a=s?this.k.profiles.find(c=>c.id===s.profile):void 0;return s&&a?{profile:a,syncResource:s?.syncResource}:void 0}async getAssociatedResources({uri:t}){const s=this.J(t);if(!s)return[];const a=this.k.profiles.find(c=>c.id===s.profile);switch(s.syncResource){case"settings":return this.r(t,a);case"keybindings":return this.t(t,a);case"tasks":return this.v(t,a);case"snippets":return this.x(t,a);case"globalState":return this.C(t,a);case"extensions":return this.z(t,a);case"profiles":return this.F(t,a)}}async getMachineId({uri:t}){const s=this.J(t);if(!!s){if(s.remote){if(s.ref){const{content:a}=await this.L(s.syncResource,s.ref,s.collection);if(a)return this.K(a,s.syncResource)?.machineId}return}return(0,T.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const s=this.J(t);if(!s||s.node===Ve.a)return null;if(s.ref){const a=await this.n(s.remote,s.syncResource,s.profile,s.collection,s.ref);return s.node&&a?this.o(s.syncResource,a,s.node):a}return!s.remote&&!s.node?this.q(s.syncResource,s.profile):null}async n(t,s,a,c,o){if(t){const{content:S}=await this.L(s,o,c);return S}const u=this.k.profiles.find(S=>S.id===a);return u?this.f.resolveContent(u,s,o):null}o(t,s,a){const c=this.K(s,t);switch(t){case"settings":return this.s(c,a);case"keybindings":return this.u(c,a);case"tasks":return this.w(c,a);case"snippets":return this.y(c,a);case"globalState":return this.D(c,a);case"extensions":return this.A(c,a);case"profiles":return this.G(c,a)}}async q(t,s){const a=this.k.profiles.find(c=>c.id===s);if(!a)return null;switch(t){case"globalState":return this.E(a);case"extensions":return this.B(a);case"profiles":return this.H(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,s){const a=this.d.joinPath(t,"settings.json"),c=s?s.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:a,comparableResource:c}]}s(t,s){switch(s){case"settings.json":return(0,y.parseSettingsSyncContent)(t.content).settings}return null}t(t,s){const a=this.d.joinPath(t,"keybindings.json"),c=s?s.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:a,comparableResource:c}]}u(t,s){switch(s){case"keybindings.json":return(0,h.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(b.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,s){const a=this.d.joinPath(t,"tasks.json"),c=s?s.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:a,comparableResource:c}]}w(t,s){switch(s){case"tasks.json":return(0,g.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,s){const a=await this.resolveContent(t);if(a){const c=this.K(a,"snippets");if(c){const o=(0,w.parseSnippets)(c),u=[];for(const S of Object.keys(o)){const E=this.d.joinPath(t,S),M=s?this.d.joinPath(s.snippetsHome,S):this.d.joinPath(t,Ve.a);u.push({resource:E,comparableResource:M})}return u}}return[]}y(t,s){return(0,w.parseSnippets)(t)[s]||null}z(t,s){const a=this.d.joinPath(t,"extensions.json"),c=s?this.I({remote:!1,syncResource:"extensions",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:a,comparableResource:c}]}A(t,s){switch(s){case"extensions.json":return(0,l.stringify)((0,l.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:s}=await this.m.createInstance(l.LocalExtensionsProvider).getLocalExtensions(t);return(0,l.stringify)(s,!0)}C(t,s){const a=this.d.joinPath(t,"globalState.json"),c=s?this.I({remote:!1,syncResource:"globalState",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:a,comparableResource:c}]}D(t,s){switch(s){case"globalState.json":return(0,f.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const s=await this.m.createInstance(f.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,f.stringify)(s,!0)}F(t,s){const a=this.d.joinPath(t,"profiles.json"),c=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:c}]}G(t,s){switch(s){case"profiles.json":return(0,d.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,v.stringifyLocalProfiles)(this.k.profiles.filter(s=>!s.isDefault&&!s.isTransient),!0)}I(t){const s=t.remote?Ve.b:Ve.c,a=[t.syncResource,t.profile];return t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(k.URI.from({scheme:b.USER_DATA_SYNC_SCHEME,authority:s,path:"/"}),...a)}J(t){if(t.scheme!==b.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const s=[];for(;t.path!=="/";)s.unshift(this.d.basename(t)),t=this.d.dirname(t);if(s.length<2)return;const a=t.authority===Ve.b,c=s.shift(),o=s.shift();let u,S,E;for(;s.length;){const M=s.shift();M.startsWith("collection:")?u=M.substring(11):M.startsWith("ref:")?S=M.substring(4):E=M}return{remote:a,syncResource:c,profile:o,collection:u,ref:S,node:E}}K(t,s){try{const a=JSON.parse(t);if((0,C.isSyncData)(a))return a}catch(a){this.g.error(a)}throw new b.UserDataSyncError((0,i.localize)(0,null),"IncompatibleRemoteContent",s)}async L(t,s,a){const c=await this.e.resolveResourceContent(t,s,a);return{ref:s,content:c}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",n=pe([Y(0,b.IUserDataSyncStoreService),Y(1,b.IUserDataSyncBackupStoreService),Y(2,b.IUserDataSyncLogService),Y(3,P.IUriIdentityService),Y(4,D.IEnvironmentService),Y(5,R.IStorageService),Y(6,A.IFileService),Y(7,I.IUserDataProfilesService),Y(8,m.IConfigurationService),Y(9,p.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(oe[275],ae([0,1,20,6,24,38,3,2,23,13,31,16,29,4,19,21,18,117,118,119,120,121,122,123,26]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p,v,d,n,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let a=class extends R.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(E,M,N,j,$,L,F,z,W){super(),this.v=E,this.w=M,this.y=N,this.z=j,this.C=$,this.D=L,this.F=F,this.G=z,this.H=W,this.f="uninitialized",this.g=this.B(new T.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new T.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new T.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new T.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new T.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new T.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=M.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(s,-1,void 0),this.B((0,R.toDisposable)(()=>this.W()))}async createSyncTask(E,M){this.X(),this.z.info("Sync started.");const N=new Date().getTime(),j=(0,I.generateUuid)();try{const z=(0,t.createSyncHeaders)(j);M&&(z["Cache-Control"]="no-cache"),E=await this.v.manifest(E,z)}catch(z){const W=t.UserDataSyncError.toUserDataSyncError(z);throw u(W,j,this.w,this.C),W}const $=!1,L=this;let F;return{manifest:E,async run(){if($)throw new Error("Can run a task only once");F=(0,i.createCancelablePromise)(z=>L.I(E,!1,j,z)),await F.finally(()=>F=void 0),L.z.info(`Sync done. Took ${new Date().getTime()-N}ms`),L.S()},stop(){return F?.cancel(),L.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const E=new Date().getTime(),M=(0,I.generateUuid)(),N=(0,t.createSyncHeaders)(M);let j;try{j=await this.v.manifest(null,N)}catch(F){const z=t.UserDataSyncError.toUserDataSyncError(F);throw u(z,M,this.w,this.C),z}await this.resetLocal();const $=this,L=new D.CancellationTokenSource;return{id:M,async merge(){return $.I(j,!0,M,L.token)},async apply(){try{try{await $.L(j,M,L.token)}catch(F){if(t.UserDataSyncError.toUserDataSyncError(F).code==="MethodNotFound")$.z.info("Client is making invalid requests. Cleaning up data..."),await $.cleanUpRemoteData(),$.z.info("Applying manual sync again..."),await $.L(j,M,L.token);else throw F}}catch(F){throw $.z.error(F),F}$.z.info(`Sync done. Took ${new Date().getTime()-E}ms`),$.S()},async stop(){L.cancel(),await $.N(),await $.resetLocal()}}}async I(E,M,N,j){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const $=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M($,E,M,N,j));const L=$.enabled.find(F=>F.resource==="profiles");if(L){const F=await L.getLastSyncedProfiles()||[];if(j.isCancellationRequested)return;await this.J(F,E,M,N,j)}}finally{this.l.fire(this.k)}}async J(E,M,N,j,$){for(const L of E){if($.isCancellationRequested)return;const F=this.G.profiles.find(W=>W.id===L.id);if(!F){this.z.error(`Profile with id:${L.id} and name: ${L.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",L.name);const z=this.getOrCreateActiveProfileSynchronizer(F,L);this.k.push(...await this.M(z,M,N,j,$))}for(const[L,F]of this.u.entries())this.G.profiles.some(z=>z.id===F[0].profile.id)||(F[1].dispose(),this.u.delete(L))}async L(E,M,N){const j=this.U();for(const W of j){if(N.isCancellationRequested)return;await W.apply(M,N)}const $=j.find(W=>W.profile.isDefault);if(!$)return;const L=$.enabled.find(W=>W.resource==="profiles");if(!L)return;const z=(await L.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(W=>j.every(H=>H.profile.id!==W.id));z.length&&await this.J(z,E,!1,M,N)}async M(E,M,N,j,$){return(await E.sync(M,N,j,$)).map(([F,z])=>({profile:E.profile,syncResource:F,error:z}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(E=>E.stop()))}async resolveContent(E){const M=await this.H.resolveContent(E);if(M)return M;for(const N of this.U())for(const j of N.enabled){const $=await j.resolveContent(E);if($)return $}return null}async replace(E){this.X();const M=this.H.resolveUserDataSyncResource(E);if(!M)return;const N=await this.resolveContent(E.uri);!N||await this.O(M.profile,async j=>{if(M.syncResource===j.resource)return await j.replace(N),!0})}async accept(E,M,N,j){this.X(),await this.O(E.profile,async $=>{if(E.syncResource===$.resource)return await $.accept(M,N),j&&await $.apply((0,b.isBoolean)(j)?!1:j.force,(0,t.createSyncHeaders)((0,I.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(E,M){return this.H.getRemoteSyncResourceHandles(E,M)}async getLocalSyncResourceHandles(E,M){return this.H.getLocalSyncResourceHandles(E,M??this.G.defaultProfile)}async getAssociatedResources(E){return this.H.getAssociatedResources(E)}async getMachineId(E){return this.H.getMachineId(E)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async M=>{if(M.resource!=="globalState"&&await M.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async M=>{if(await M.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(E){this.z.error(E)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(s,-1);for(const[E]of this.u.values())try{await E.resetLocal()}catch(M){this.z.error(M)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const E=await this.H.getRemoteSyncedProfiles(),M=E.map(L=>L.collection),N=await this.v.getAllCollections(),j=N.filter(L=>!M.includes(L));j.length&&(this.z.info(`Deleting ${j.length} redundant collections on server`),await Promise.allSettled(j.map(L=>this.v.deleteCollection(L))),this.z.info("Deleted redundant collections on server"));const $=E.filter(L=>N.includes(L.collection));if($.length!==E.length){this.z.info("Updating remote profiles with invalid collections on server");const L=this.y.createInstance(r.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await L.updateRemoteProfiles($,null),this.z.info("Updated remote profiles on server")}finally{L.dispose()}}}async O(E,M){const N=new R.DisposableStore;try{const j=this.u.get(E.id);if(j){const W=await this.P(j[0],M,N);return(0,b.isUndefined)(W)?null:W}if(E.isDefault){const W=N.add(this.y.createInstance(c,E,void 0)),H=await this.P(W,M,N);return(0,b.isUndefined)(H)?null:H}if(this.G.isEnabled())return null;const $=N.add(this.y.createInstance(r.UserDataProfilesManifestSynchroniser,E,void 0)),L=await this.v.manifest(null),z=(await $.getRemoteSyncedProfiles(L?.latest??null)||[]).find(W=>W.id===E.id);if(z){const W=N.add(this.y.createInstance(c,E,z.collection)),H=await this.P(W,M,N);return(0,b.isUndefined)(H)?null:H}return null}finally{N.dispose()}}async P(E,M,N){const j=[...E.enabled,...E.disabled.map($=>N.add(E.createSynchronizer($)))];for(const $ of j){const L=await M($);if(!(0,b.isUndefined)(L))return L}}Q(E){const M=this.f;this.f!==E&&(this.f=E,this.g.fire(E),M==="hasConflicts"&&this.S())}R(){const E=this.U().map(M=>M.conflicts).flat();(0,k.equals)(this.i,E,(M,N)=>M.profile.id===N.profile.id&&M.syncResource===N.syncResource&&(0,k.equals)(M.conflicts,N.conflicts,(j,$)=>(0,P.isEqual)(j.previewResource,$.previewResource)))||(this.i=E,this.j.fire(E))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(s,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(E,M){let N=this.u.get(E.id);if(N&&N[0].collection!==M?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.u.delete(E.id)),!N){const j=new R.DisposableStore,$=j.add(this.y.createInstance(c,E,M?.collection));j.add($.onDidChangeStatus(L=>this.Q(L))),j.add($.onDidChangeConflicts(L=>this.R())),j.add($.onDidChangeLocal(L=>this.h.fire(L))),this.u.set(E.id,N=[$,j])}return N[0]}U(){const E=[];for(const[M]of this.u.values())E.push(M);return E}W(){this.u.forEach(([,E])=>E.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};a=pe([Y(0,t.IUserDataSyncStoreService),Y(1,t.IUserDataSyncStoreManagementService),Y(2,y.IInstantiationService),Y(3,t.IUserDataSyncLogService),Y(4,m.ITelemetryService),Y(5,h.IStorageService),Y(6,t.IUserDataSyncEnablementService),Y(7,g.IUserDataProfilesService),Y(8,t.IUserDataSyncResourceProviderService)],a),e.UserDataSyncService=a;let c=class extends R.Disposable{get enabled(){return this.f.sort((E,M)=>E[1]-M[1]).map(([E])=>E)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(E=>!this.l.isResourceEnabled(E))}get status(){return this.g}get conflicts(){return this.j}constructor(E,M,N,j,$,L,F,z,W,H){super(),this.profile=E,this.collection=M,this.l=N,this.m=j,this.n=$,this.r=L,this.t=F,this.u=z,this.v=W,this.w=H,this.f=[],this.g="idle",this.h=this.B(new T.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new T.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new T.Emitter),this.onDidChangeConflicts=this.k.event,this.B(N.onDidChangeResourceEnablement(([Q,K])=>this.y(Q,K))),this.B((0,R.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,Q])=>Q.dispose())));for(const Q of t.ALL_SYNC_RESOURCES)N.isResourceEnabled(Q)&&this.z(Q)}y(E,M){M?this.z(E):this.C(E)}z(E){if(this.f.some(([$])=>$.resource===E))return;if(E==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(E==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const M=new R.DisposableStore,N=M.add(this.createSynchronizer(E));M.add(N.onDidChangeStatus(()=>this.G())),M.add(N.onDidChangeConflicts(()=>this.H())),M.add(N.onDidChangeLocal(()=>this.i.fire(E)));const j=this.I(E);this.f.push([N,j,M])}C(E){const M=this.f.findIndex(([N])=>N.resource===E);if(M!==-1){const[[N,,j]]=this.f.splice(M,1);j.dispose(),this.G(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,$=>this.u.error($))}}createSynchronizer(E){switch(E){case"settings":return this.m.createInstance(v.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(p.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(d.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(f.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(l.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(E,M,N,j){if(j.isCancellationRequested)return[];const $=this.enabled;if(!$.length)return[];try{const L=[],F=(0,t.createSyncHeaders)(N),z=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,W=M?await this.D(z):{};for(const H of $){if(j.isCancellationRequested)return[];if(!this.l.isResourceEnabled(H.resource))return[];try{if(M){const Q=await H.preview(z,W,F);if(Q)for(const K of Q.resourcePreviews)(K.localChange!==0||K.remoteChange!==0)&&K.mergeState==="preview"&&await H.merge(K.previewResource)}else await H.sync(z,F)}catch(Q){const K=t.UserDataSyncError.toUserDataSyncError(Q);if(u(K,N,this.r,this.t),o(Q))throw K;this.u.error(Q),this.u.error(`${H.resource}: ${(0,A.toErrorMessage)(Q)}`),L.push([H.resource,K])}}return L}finally{this.G()}}async apply(E,M){const N=(0,t.createSyncHeaders)(E);for(const j of this.enabled){if(M.isCancellationRequested)return;try{await j.apply(!1,N)}catch($){const L=t.UserDataSyncError.toUserDataSyncError($);if(u(L,E,this.r,this.t),o($))throw L;this.u.error($),this.u.error(`${j.resource}: ${(0,A.toErrorMessage)($)}`)}}}async stop(){for(const E of this.enabled)try{E.status!=="idle"&&await E.stop()}catch(M){this.u.error(M)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(M){this.u.error(`${E.resource}: ${(0,A.toErrorMessage)(M)}`),this.u.error(M)}}async D(E){if(!this.profile.isDefault)return{};const M=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find(j=>j instanceof v.SettingsSynchroniser);if(N){const j=await N.getRemoteUserDataSyncConfiguration(E);return{...M,...j}}return M}F(E){this.g!==E&&(this.g=E,this.h.fire(E))}G(){return this.H(),this.enabled.some(E=>E.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(E=>E.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const E=this.enabled.filter(M=>M.status==="hasConflicts").filter(M=>M.conflicts.conflicts.length>0).map(M=>M.conflicts);(0,k.equals)(this.j,E,(M,N)=>M.syncResource===N.syncResource&&(0,k.equals)(M.conflicts,N.conflicts,(j,$)=>(0,P.isEqual)(j.previewResource,$.previewResource)))||(this.j=E,this.k.fire(E))}I(E){switch(E){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};c=pe([Y(2,t.IUserDataSyncEnablementService),Y(3,y.IInstantiationService),Y(4,w.IExtensionGalleryService),Y(5,t.IUserDataSyncStoreManagementService),Y(6,m.ITelemetryService),Y(7,t.IUserDataSyncLogService),Y(8,g.IUserDataProfilesService),Y(9,C.IConfigurationService)],c);function o(S){if(S instanceof t.UserDataSyncError)switch(S.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function u(S,E,M,N){N.publicLog2("sync/error",{code:S.code,serverCode:S instanceof t.UserDataSyncStoreError?String(S.serverCode):void 0,url:S instanceof t.UserDataSyncStoreError?S.url:void 0,resource:S.resource,executionId:E,service:M.userDataSyncStore.url.toString()})}}),define(oe[276],ae([0,1,3,2,7,18,26]),function(Z,e,k,i,D,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(w,y){return{...w,profile:(0,A.reviveProfile)(w.profile,y.profilesHome.scheme)}}function P(w){return{created:w.created,uri:D.URI.revive(w.uri)}}class b{constructor(y,h,m){this.c=y,this.d=h,this.f=m,this.a=new Map,this.b=new k.Emitter}listen(y,h){switch(h){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${h}`)}async call(y,h,m){try{return await this.g(y,h,m)}catch(g){throw this.f.error(g),g}}async g(y,h,m){switch(h){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(m[0]));case"accept":return this.c.accept(R(m[0],this.d),D.URI.revive(m[1]),m[2],m[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(m[0],(0,A.reviveProfile)(m[1],this.d.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(m[0],m[1]);case"replace":return this.c.replace(P(m[0]));case"getAssociatedResources":return this.c.getAssociatedResources(P(m[0]));case"getMachineId":return this.c.getMachineId(P(m[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(h.startsWith("manualSync/")){const g=h.substring(11),l=m[0],f=this.h(l);switch(m=m.slice(1),g){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.a.delete(this.j(f.id)));case"stop":return f.stop().finally(()=>this.a.delete(this.j(f.id)))}}throw new Error("Invalid call")}h(y){const h=this.a.get(this.j(y));if(!h)throw new Error(`Manual sync taks not found: ${y}`);return h}async i(){const y=await this.c.createManualSyncTask();return this.a.set(this.j(y.id),y),y.id}j(y){return`manualSyncTask-${y}`}}e.UserDataSyncChannel=b;let I=class extends i.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(y,h){super(),this.k=h,this.b="uninitialized",this.c=this.B(new k.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new k.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new k.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new k.Emitter),this.onSyncErrors=this.j.event,this.a={call(m,g,l){return y.call(m,g,l).then(null,f=>{throw T.UserDataSyncError.toUserDataSyncError(f)})},listen(m,g){return y.listen(m,g)}},this.a.call("_getInitialData").then(([m,g,l])=>{this.l(m),this.m(g),l&&this.n(l),this.B(this.a.listen("onDidChangeStatus")(f=>this.l(f))),this.B(this.a.listen("onDidChangeLastSyncTime")(f=>this.n(f)))}),this.B(this.a.listen("onDidChangeConflicts")(m=>this.m(m))),this.B(this.a.listen("onSyncErrors")(m=>this.j.fire(m.map(g=>({...g,error:T.UserDataSyncError.toUserDataSyncError(g.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const y=await this.a.call("createManualSyncTask"),h=this;return new C(y,{async call(g,l,f){return h.a.call(`manualSync/${g}`,[y,...Array.isArray(l)?l:[l]],f)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(y,h,m,g){return this.a.call("accept",[y,h,m,g])}resolveContent(y){return this.a.call("resolveContent",[y])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(y,h){return(await this.a.call("getLocalSyncResourceHandles",[y,h])).map(({created:g,uri:l})=>({created:g,uri:D.URI.revive(l)}))}async getRemoteSyncResourceHandles(y,h){return(await this.a.call("getRemoteSyncResourceHandles",[y,h])).map(({created:g,uri:l})=>({created:g,uri:D.URI.revive(l)}))}async getAssociatedResources(y){return(await this.a.call("getAssociatedResources",[y])).map(({resource:m,comparableResource:g})=>({resource:D.URI.revive(m),comparableResource:D.URI.revive(g)}))}getMachineId(y){return this.a.call("getMachineId",[y])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(y){return this.a.call("replace",[y])}async l(y){this.b=y,this.c.fire(y)}async m(y){this.f=y.map(h=>({syncResource:h.syncResource,profile:(0,A.reviveProfile)(h.profile,this.k.profilesHome.scheme),conflicts:h.conflicts.map(m=>({...m,baseResource:D.URI.revive(m.baseResource),localResource:D.URI.revive(m.localResource),remoteResource:D.URI.revive(m.remoteResource),previewResource:D.URI.revive(m.previewResource)}))})),this.g.fire(this.f)}n(y){this.h!==y&&(this.h=y,this.i.fire(y))}};I=pe([Y(1,A.IUserDataProfilesService)],I),e.UserDataSyncChannelClient=I;class C extends i.Disposable{constructor(y,h){super(),this.id=y,this.a=h}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[277],ae([0,1,6,24,9,3,2,139,5,23,13,7,31,16,15,14,25,59,45,19,26]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const d="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",s=100,a=1e3*60*5;let c=class extends T.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(v.SYNC_SERVICE_URL_TYPE,-1)}set c(N){this.h.store(v.SYNC_SERVICE_URL_TYPE,N,-1,P.isWeb?0:1)}constructor(N,j,$){super(),this.f=N,this.g=j,this.h=$,this.a=this.B(new A.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(A.Event.filter($.onDidChangeValue,L=>L.key===v.SYNC_SERVICE_URL_TYPE&&L.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[v.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(v.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(N,j){N=P.isWeb&&N?.web?{...N,...N.web}:N;const $={...N||{},...j||{}};if($&&(0,I.isString)($.url)&&(0,I.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(L=>Array.isArray($.authenticationProviders[L].scopes))){const L=$,F=!!L.canSwitch&&!j?.url,z=L.url===L.insidersUrl?"insiders":"stable",W=(F?this.c:void 0)||z,H=j?.url||(W==="insiders"?L.insidersUrl:W==="stable"?L.stableUrl:L.url);return{url:C.URI.parse(H),type:W,defaultType:z,defaultUrl:C.URI.parse(L.url),stableUrl:C.URI.parse(L.stableUrl),insidersUrl:C.URI.parse(L.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(L.authenticationProviders).reduce((Q,K)=>(Q.push({id:K,scopes:L.authenticationProviders[K].scopes}),Q),[])}}}};c=pe([Y(0,g.IProductService),Y(1,y.IConfigurationService),Y(2,p.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let o=class extends c{constructor(N,j,$){super(N,j,$);const L=this.h.get(d,-1);L&&(this.k=JSON.parse(L));const F=this.f[v.CONFIGURATION_SYNC_STORE_KEY];F?this.h.store(d,JSON.stringify(F),-1,1):this.h.remove(d,-1)}async switch(N){N!==this.c&&(this.c=N,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};o=pe([Y(0,g.IProductService),Y(1,y.IConfigurationService),Y(2,p.IStorageService)],o),e.UserDataSyncStoreManagementService=o;let u=class extends T.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(N,j,$,L,F,z,W){super(),this.k=$,this.l=L,this.n=W,this.g=this.B(new A.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new A.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(N),this.c=(0,f.getServiceMachineId)(F,z,W).then(H=>{const Q={"X-Client-Name":`${j.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":j.version};return j.commit&&(Q["X-Client-Commit"]=j.commit),Q}),this.f=new E(s,a,this.k,this.l),this.r(),this.B((0,T.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(N,j){this.b={token:N,type:j}}p(N){this.a=N?(0,b.joinPath)(N,"v1"):void 0}r(){const N=this.n.getNumber(n,-1);N&&Date.now()<N&&this.t(new Date(N))}t(N){this.i?.getTime()!==N?.getTime()&&(this.i=N,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(n,this.i.getTime(),-1,1),this.s=(0,k.createCancelablePromise)(j=>(0,k.timeout)(this.i.getTime()-Date.now(),j).then(()=>this.t(void 0))),this.s.then(null,j=>null)):this.n.remove(n,-1),this.j.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,b.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const $=await this.w(j,{type:"GET",headers:N},[],i.CancellationToken.None);return(await(0,l.asJson)($))?.map(({id:L})=>L)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,b.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]=R.Mimes.text;const $=await this.w(j,{type:"POST",headers:N},[],i.CancellationToken.None),L=await(0,l.asTextOrError)($);if(!L)throw new v.UserDataSyncStoreError("Server did not return the collection id",j,"NoCollection",$.res.statusCode,$.res.headers[v.HEADER_OPERATION_ID]);return L}async deleteCollection(N,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=N?(0,b.joinPath)(this.a,"collection",N).toString():(0,b.joinPath)(this.a,"collection").toString();j={...j},await this.w($,{type:"DELETE",headers:j},[],i.CancellationToken.None)}async getAllResourceRefs(N,j){if(!this.a)throw new Error("No settings sync store url configured.");const $=this.u(this.a,j,N),L={},F=await this.w($.toString(),{type:"GET",headers:L},[],i.CancellationToken.None);return(await(0,l.asJson)(F)||[]).map(({url:W,created:H})=>({ref:(0,b.relativePath)($,$.with({path:W})),created:H*1e3}))}async resolveResourceContent(N,j,$,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.u(this.a,$,N),j).toString();L={...L},L["Cache-Control"]="no-cache";const z=await this.w(F,{type:"GET",headers:L},[],i.CancellationToken.None);return await(0,l.asTextOrError)(z)}async deleteResource(N,j,$){if(!this.a)throw new Error("No settings sync store url configured.");const L=j!==null?(0,b.joinPath)(this.u(this.a,$,N),j).toString():this.u(this.a,$,N).toString(),F={};await this.w(L,{type:"DELETE",headers:F},[],i.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.a,"resource").toString(),j={"Content-Type":R.Mimes.text};await this.w(N,{type:"DELETE",headers:j},[],i.CancellationToken.None)}async readResource(N,j,$,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.u(this.a,$,N),"latest").toString();L={...L},L["Cache-Control"]="no-cache",j&&(L["If-None-Match"]=j.ref);const z=await this.w(F,{type:"GET",headers:L},[304],i.CancellationToken.None);let W=null;if(z.res.statusCode===304&&(W=j),W===null){const H=z.res.headers.etag;if(!H)throw new v.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",z.res.statusCode,z.res.headers[v.HEADER_OPERATION_ID]);const Q=await(0,l.asTextOrError)(z);if(!Q&&z.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",F,"EmptyResponse",z.res.statusCode,z.res.headers[v.HEADER_OPERATION_ID]);W={ref:H,content:Q}}return W}async writeResource(N,j,$,L,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.u(this.a,L,N).toString();F={...F},F["Content-Type"]=R.Mimes.text,$&&(F["If-Match"]=$);const W=await this.w(z,{type:"POST",data:j,headers:F},[],i.CancellationToken.None),H=W.res.headers.etag;if(!H)throw new v.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",W.res.statusCode,W.res.headers[v.HEADER_OPERATION_ID]);return H}async manifest(N,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.a,"manifest").toString();j={...j},j["Content-Type"]="application/json",N&&(j["If-None-Match"]=N.ref);const L=await this.w($,{type:"GET",headers:j},[304],i.CancellationToken.None);let F=null;if(L.res.statusCode===304&&(F=N),!F){const W=L.res.headers.etag;if(!W)throw new v.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",L.res.statusCode,L.res.headers[v.HEADER_OPERATION_ID]);const H=await(0,l.asTextOrError)(L);if(!H&&L.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",$,"EmptyResponse",L.res.statusCode,L.res.headers[v.HEADER_OPERATION_ID]);H&&(F={...JSON.parse(H),ref:W})}const z=this.n.get(r,-1);return z&&F&&z!==F.session&&this.v(),F===null&&z&&this.v(),F&&this.n.store(r,F.session,-1,1),F}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(N,j,$){return j?(0,b.joinPath)(N,"collection",j,"resource",$):(0,b.joinPath)(N,"resource",$)}v(){this.n.remove(r,-1),this.n.remove(t,-1)}async w(N,j,$,L){if(!this.b)throw new v.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new v.UserDataSyncStoreError(`${j.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const F=await this.c;j.headers={...j.headers||{},...F,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(j.headers),this.l.trace("Sending request to server",{url:N,type:j.type,headers:{...j.headers,authorization:void 0}});let z;try{z=await this.f.request(N,j,L)}catch(V){if(!(V instanceof v.UserDataSyncStoreError)){let G="RequestFailed";const x=(0,D.getErrorMessage)(V).toLowerCase();x.includes("xhr timeout")?G="RequestTimeout":x.includes("protocol")&&x.includes("not supported")?G="RequestProtocolNotSupported":x.includes("request path contains unescaped characters")?G="RequestPathNotEscaped":x.includes("headers must be an object")?G="RequestHeadersNotObject":(0,D.isCancellationError)(V)&&(G="RequestCanceled"),V=new v.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,G,void 0,void 0)}throw this.l.info("Request failed",N),V}const W=z.res.headers[v.HEADER_OPERATION_ID],H={url:N,status:z.res.statusCode,"execution-id":j.headers[v.HEADER_EXECUTION_ID],"operation-id":W},Q=(0,l.isSuccess)(z)||z.res.statusCode&&$.indexOf(z.res.statusCode)!==-1;let K="";if(Q?this.l.trace("Request succeeded",H):(this.l.info("Request failed",H),K=await(0,l.asText)(z)||""),z.res.statusCode===401)throw this.b=void 0,this.g.fire(),new v.UserDataSyncStoreError(`Request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",z.res.statusCode,W);if(this.h.fire(),z.res.statusCode===404)throw new v.UserDataSyncStoreError(`${j.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",z.res.statusCode,W);if(z.res.statusCode===405)throw new v.UserDataSyncStoreError(`${j.type} request '${N}' failed because the requested endpoint is not found (405). ${K}`,N,"MethodNotFound",z.res.statusCode,W);if(z.res.statusCode===409)throw new v.UserDataSyncStoreError(`${j.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",z.res.statusCode,W);if(z.res.statusCode===410)throw new v.UserDataSyncStoreError(`${j.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",z.res.statusCode,W);if(z.res.statusCode===412)throw new v.UserDataSyncStoreError(`${j.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",z.res.statusCode,W);if(z.res.statusCode===413)throw new v.UserDataSyncStoreError(`${j.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",z.res.statusCode,W);if(z.res.statusCode===426)throw new v.UserDataSyncStoreError(`${j.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",z.res.statusCode,W);if(z.res.statusCode===429){const V=z.res.headers["retry-after"];throw V?(this.t(new Date(Date.now()+parseInt(V)*1e3)),new v.UserDataSyncStoreError(`${j.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",z.res.statusCode,W)):new v.UserDataSyncStoreError(`${j.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",z.res.statusCode,W)}if(!Q)throw new v.UserDataSyncStoreError("Server returned "+z.res.statusCode,N,"Unknown",z.res.statusCode,W);return z}y(N){let j=this.n.get(t,-1);j===void 0&&(j=(0,w.generateUuid)(),this.n.store(t,j,-1,1)),N["X-Machine-Session-Id"]=j;const $=this.n.get(r,-1);$!==void 0&&(N["X-User-Session-Id"]=$)}};u=pe([Y(1,g.IProductService),Y(2,l.IRequestService),Y(3,v.IUserDataSyncLogService),Y(4,h.IEnvironmentService),Y(5,m.IFileService),Y(6,p.IStorageService)],u),e.UserDataSyncStoreClient=u;let S=class extends u{constructor(N,j,$,L,F,z,W){super(N.userDataSyncStore?.url,j,$,L,F,z,W),this.B(N.onDidChangeUserDataSyncStore(()=>this.p(N.userDataSyncStore?.url)))}};S=pe([Y(0,v.IUserDataSyncStoreManagementService),Y(1,g.IProductService),Y(2,l.IRequestService),Y(3,v.IUserDataSyncLogService),Y(4,h.IEnvironmentService),Y(5,m.IFileService),Y(6,p.IStorageService)],S),e.UserDataSyncStoreService=S;class E{constructor(N,j,$,L){this.c=N,this.d=j,this.f=$,this.g=L,this.a=[],this.b=void 0}request(N,j,$){if(this.h()&&this.i(),j.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new v.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(j,$)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=E}),define(oe[278],ae([0,1,3,57,25,19,21,273,26,78,81]),function(Z,e,k,i,D,A,T,R,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends R.UserDataAutoSyncService{constructor(y,h,m,g,l,f,p,v,d,n,r){super(y,h,m,g,l,p,v,d,n,r),this.B(k.Event.debounce(k.Event.any(k.Event.map(f.onDidFocusWindow,()=>"windowFocus"),k.Event.map(f.onDidOpenWindow,()=>"windowOpen")),(t,s)=>t?[...t,s]:[s],1e3)(t=>this.triggerSync(t,!0,!1)))}};C=pe([Y(0,D.IProductService),Y(1,P.IUserDataSyncStoreManagementService),Y(2,P.IUserDataSyncStoreService),Y(3,P.IUserDataSyncEnablementService),Y(4,P.IUserDataSyncService),Y(5,i.INativeHostService),Y(6,P.IUserDataSyncLogService),Y(7,b.IUserDataSyncAccountService),Y(8,T.ITelemetryService),Y(9,I.IUserDataSyncMachinesService),Y(10,A.IStorageService)],C),e.UserDataAutoSyncService=C}),define(oe[279],ae([0,1,99,22,5,23]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(b){function I(){let C=b.scheme===i.Schemas.file?(0,A.originalFSPath)(b):b.toString();return D.isLinux||(C=C.toLowerCase()),(0,k.createHash)("md5").update(C).digest("hex")}return{id:I(),configPath:b}}e.getWorkspaceIdentifier=T;function R(b,I){function C(){if(b.scheme!==i.Schemas.file)return(0,k.createHash)("md5").update(b.toString()).digest("hex");if(!I)return;let y;return D.isLinux?y=I.ino:D.isMacintosh?y=I.birthtime.getTime():D.isWindows&&(typeof I.birthtimeMs=="number"?y=Math.floor(I.birthtimeMs):y=I.birthtime.getTime()),(0,k.createHash)("md5").update(b.fsPath).update(y?String(y):"").digest("hex")}const w=C();if(typeof w=="string")return{id:w,uri:b}}e.getSingleFolderWorkspaceIdentifier=R;function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=P}),define(oe[280],ae([0,1,6,9,2,12,28,15,56,8,57,76,115,279]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends D.Disposable{constructor(g,l,f,p){super(),this.a=g,this.b=l,this.c=f,this.f=p,this.B(new k.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const g=await T.Promises.readdir(this.a.workspaceStorageHome.fsPath),l=new C.StorageClient(this.f.getChannel("storage"));await Promise.all(g.map(async f=>{const p=(0,A.join)(this.a.workspaceStorageHome.fsPath,f);f.length===y.NON_EMPTY_WORKSPACE_ID_LENGTH||f===w.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(n=>n.workspace?.id===f)||await l.isUsed(p)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${f} as it seems to be an unused empty workspace.`),await T.Promises.rm(p))}))}catch(g){(0,i.onUnexpectedError)(g)}}};h=pe([Y(0,R.INativeEnvironmentService),Y(1,b.ILogService),Y(2,I.INativeHostService),Y(3,P.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(oe[124],ae([0,1,52,6,12,13,28,151,289,290]),function(Z,e,k,i,D,A,T,R,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(n,r){let t=r.message;switch(n){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=n,this.cause=r}}e.ExtractError=I;function C(d){const n=d.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,t)=>r+t,n&61440)}function w(d){if(d instanceof I)return d;let n;return/end of central directory record signature not found/.test(d.message)&&(n="CorruptZip"),new I(n,d)}function y(d,n,r,t,s,a){const c=D.dirname(n),o=D.join(t,c);if(!o.startsWith(t))return Promise.reject(new Error(R.localize(0,null,n)));const u=D.join(t,n);let S;return a.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(T.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((E,M)=>{if(!a.isCancellationRequested)try{S=(0,k.createWriteStream)(u,{mode:r}),S.once("close",()=>E()),S.once("error",M),d.once("error",M),d.pipe(S)}catch(N){M(N)}}))}function h(d,n,r,t){let s=(0,i.createCancelablePromise)(()=>Promise.resolve()),a=0;return t.onCancellationRequested(()=>{s.cancel(),d.close()}),new Promise((c,o)=>{const u=new i.Sequencer,S=E=>{E.isCancellationRequested||(a++,d.readEntry())};d.once("error",o),d.once("close",()=>s.then(()=>{t.isCancellationRequested||d.entryCount===a?c():o(new I("Incomplete",new Error(R.localize(1,null,a,d.entryCount))))},o)),d.readEntry(),d.on("entry",E=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(E.fileName)){S(t);return}const M=E.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(M)){const $=D.join(n,M);s=(0,i.createCancelablePromise)(L=>T.Promises.mkdir($,{recursive:!0}).then(()=>S(L)).then(void 0,o));return}const N=g(d,E),j=C(E);s=(0,i.createCancelablePromise)($=>u.queue(()=>N.then(L=>y(L,M,j,n,r,$).then(()=>S($)))).then(null,o))})})}function m(d,n=!1){return new Promise((r,t)=>{(0,P.open)(d,n?{lazyEntries:!0}:void 0,(s,a)=>{s?t(w(s)):r((0,A.assertIsDefined)(a))})})}function g(d,n){return new Promise((r,t)=>{d.openReadStream(n,(s,a)=>{s?t(w(s)):r((0,A.assertIsDefined)(a))})})}function l(d,n){return new Promise((r,t)=>{const s=new b.ZipFile;n.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const a=(0,k.createWriteStream)(d);s.outputStream.pipe(a),s.outputStream.once("error",t),a.once("error",t),a.once("finish",()=>r(d))})}e.zip=l;function f(d,n,r={},t){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let a=m(d,!0);return r.overwrite&&(a=a.then(c=>T.Promises.rm(n).then(()=>c))),a.then(c=>h(c,n,{sourcePathRegex:s},t))}e.extract=f;function p(d,n){return m(d).then(r=>new Promise((t,s)=>{r.on("entry",a=>{a.fileName===n&&g(r,a).then(c=>t(c),c=>s(c))}),r.once("close",()=>s(new Error(R.localize(2,null,n))))}))}function v(d,n){return p(d,n).then(r=>new Promise((t,s)=>{const a=[];r.once("error",s),r.on("data",c=>a.push(c)),r.on("end",()=>t(Buffer.concat(a)))}))}e.buffer=v}),define(oe[281],ae([0,1,124,161]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(A){return(0,k.buffer)(A,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=D}),define(oe[125],ae([0,1,6,24,38,9,3,2,37,22,12,5,23,53,13,7,31,28,124,160,96,15,263,29,33,61,79,234,264,281,218,235,42,70,14,4,8,25,21,30,18]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p,v,d,n,r,t,s,a,c,o,u,S,E,M,N,j,$,L,F,z,W,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,$.refineServiceDecorator)(r.IExtensionManagementService);let Q=class extends n.AbstractExtensionManagementService{constructor(O,U,q,B,X,ee,J,_,re,ue,le,ye){super(O,U,q,ue,ye),this.Y=X,this.Z=ee,this.ab=J,this.bb=re,this.cb=le,this.X=new Map,this.kb=new P.ResourceSet;const Se=this.B(_.createInstance(o.ExtensionsLifecycle));this.S=this.B(_.createInstance(K,Ee=>Se.postUninstall(Ee))),this.U=this.B(new S.ExtensionsManifestCache(B,this)),this.W=this.B(_.createInstance(c.ExtensionsDownloader,this.getTargetPlatform()));const be=this.B(new E.ExtensionsWatcher(this,this.Y,ye,ee,le,re,q));this.B(be.onDidChangeExtensionsByAnotherSource(Ee=>this.jb(Ee))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,t.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(O){this.v.trace("ExtensionManagementService#zip",O.identifier.id);const U=await this.ib(O),q=await(0,f.zip)((0,w.joinPath)(this.W.extensionsDownloadDir,(0,g.generateUuid)()).fsPath,U);return m.URI.file(q)}async unzip(O){return this.v.trace("ExtensionManagementService#unzip",O.toString()),(await this.install(O)).identifier}async getManifest(O){const{location:U,cleanup:q}=await this.eb(O),B=I.resolve(U.fsPath);try{return await(0,u.getManifest)(B)}finally{await q()}}getInstalled(O,U){return this.S.scanExtensions(O??null,U)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(O,U={}){this.v.trace("ExtensionManagementService#install",O.toString());const{location:q,cleanup:B}=await this.eb(O);try{const X=await(0,u.getManifest)(I.resolve(q.fsPath));if(X.engines&&X.engines.vscode&&!(0,N.isEngineValid)(X.engines.vscode,this.w.version,this.w.date))throw new Error(p.localize(0,null,(0,t.getGalleryExtensionId)(X.publisher,X.name),this.w.version));return await this.z(X,q,U)}finally{await B()}}async installFromLocation(O,U){this.v.trace("ExtensionManagementService#installFromLocation",O.toString());const q=await this.S.scanUserExtensionAtLocation(O);if(!q)throw new Error(`Cannot find a valid extension from the location ${O.toString()}`);return await this.nb([q],U),this.v.info("Successfully installed extension",q.identifier.id,U.toString()),q}getMetadata(O){return this.Y.scanMetadata(O.location)}async updateMetadata(O,U){this.v.trace("ExtensionManagementService#updateMetadata",O.identifier.id);const q={...U};return U.isPreReleaseVersion&&(q.preRelease=!0),O=await this.S.updateMetadata(O,q),this.U.invalidate(),O}async updateExtensionScope(O,U){return this.v.trace("ExtensionManagementService#updateExtensionScope",O.identifier.id),O=await this.S.updateMetadata(O,{isMachineScoped:U}),this.U.invalidate(),O}async reinstallFromGallery(O){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",O.identifier.id),!this.t.isEnabled())throw new Error(p.localize(1,null));const U=await this.getTargetPlatform(),[q]=await this.t.getExtensions([{...O.identifier,preRelease:O.preRelease}],{targetPlatform:U,compatible:!0},i.CancellationToken.None);if(!q)throw new Error(p.localize(2,null));await this.S.setUninstalled(O);try{await this.S.removeUninstalledExtension(O)}catch(B){throw new Error(p.localize(3,null,(0,D.toErrorMessage)(B)))}await this.installFromGallery(q)}markAsUninstalled(...O){return this.S.setUninstalled(...O)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(O,U){const{location:q}=await this.W.download(O,U);return q}async eb(O){if(O.scheme===b.Schemas.file)return{location:O,async cleanup(){}};this.v.trace("Downloading extension from",O.toString());const U=(0,w.joinPath)(this.W.extensionsDownloadDir,(0,g.generateUuid)());return await this.ab.download(O,U),this.v.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.bb.del(U)}catch(B){this.v.error(B)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(O,U,q){let B;if(m.URI.isUri(U))B=new x(O,U,q,this.t,this.S,this.v);else{const X=t.ExtensionKey.create(U).toString();B=this.X.get(X),B||(this.X.set(X,B=new G(O,U,q,this.W,this.S,this.v)),B.waitUntilTaskIsFinished().then(()=>this.X.delete(X)))}return new ne(B,q.profileLocation,this.cb,this.y,this.Y,this.Z)}R(O,U){return new se(O,U.profileLocation,this.Z)}async ib(O){const U=async B=>{let X=await l.Promises.readdir(B);X=X.map(_=>I.join(B,_));const ee=await Promise.all(X.map(_=>l.Promises.stat(_)));let J=Promise.resolve([]);return ee.forEach((_,re)=>{const ue=X[re];_.isFile()&&(J=J.then(le=>[...le,ue])),_.isDirectory()&&(J=J.then(le=>U(ue).then(ye=>[...le,...ye])))}),J};return(await U(O.location.fsPath)).map(B=>({path:`extension/${I.relative(O.location.fsPath,B)}`,localPath:B}))}async jb({added:O,removed:U}){if(U)for(const q of U.extensions)this.v.info("Extensions removed from another source",q.id,U.profileLocation.toString()),this.p.fire({identifier:q,profileLocation:U.profileLocation});if(O){const B=(await this.S.scanExtensions(1,O.profileLocation)).filter(X=>O.extensions.some(ee=>(0,t.areSameExtensions)(ee,X.identifier)));this.m.fire(B.map(X=>(this.v.info("Extensions added from another source",X.identifier.id,O.profileLocation.toString()),{identifier:X.identifier,local:X,profileLocation:O.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(U=>this.kb.add(U)));const O=await this.bb.resolve(this.Y.userExtensionsLocation);for(const U of O.children??[])U.isDirectory&&this.kb.add(U.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(U=>this.mb(U)))}async mb(O){if(!O.affects(this.Y.userExtensionsLocation,1))return;const U=[];for(const q of O.rawAdded){if(this.kb.has(q)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(q),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(q,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(q).startsWith(".")||!(await this.bb.stat(q)).isDirectory)continue;const B=await this.S.scanUserExtensionAtLocation(q);B&&B.installedTimestamp===void 0&&(this.kb.add(q),U.push(B))}U.length&&(await this.nb(U,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",U.map(q=>q.identifier.id)))}async nb(O,U){await this.Z.addExtensionsToProfile(O.map(q=>[q,void 0]),U),this.m.fire(O.map(q=>({local:q,identifier:q.identifier,operation:1,profileLocation:U})))}};Q=pe([Y(0,r.IExtensionGalleryService),Y(1,z.ITelemetryService),Y(2,L.ILogService),Y(3,d.INativeEnvironmentService),Y(4,a.IExtensionsScannerService),Y(5,s.IExtensionsProfileScannerService),Y(6,v.IDownloadService),Y(7,$.IInstantiationService),Y(8,j.IFileService),Y(9,F.IProductService),Y(10,W.IUriIdentityService),Y(11,H.IUserDataProfilesService)],Q),e.ExtensionManagementService=Q;let K=class extends R.Disposable{constructor(O,U,q,B){super(),this.j=O,this.k=U,this.l=q,this.m=B,this.h=this.B(new T.Emitter),this.onExtract=this.h.event,this.c=(0,w.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new k.Queue}async cleanUp(){await this.v()}async scanExtensions(O,U){const q={includeInvalid:!0,profileLocation:U};let B=[];return O===null||O===0?B.push(...await this.l.scanAllExtensions({includeInvalid:!0},q,!1)):O===1&&B.push(...await this.l.scanUserExtensions(q)),B=O!==null?B.filter(X=>X.type===O):B,Promise.all(B.map(X=>this.u(X)))}async scanAllUserExtensions(O){const U=await this.l.scanUserExtensions({includeAllVersions:!O,includeInvalid:!0});return Promise.all(U.map(q=>this.u(q)))}async scanUserExtensionAtLocation(O){try{const U=await this.l.scanExistingExtension(O,1,{includeInvalid:!0});if(U)return await this.u(U)}catch(U){this.m.error(U)}return null}async extractUserExtension(O,U,q,B){const X=O.toString(),ee=I.join(this.l.userExtensionsLocation.fsPath,`.${(0,g.generateUuid)()}`),J=I.join(this.l.userExtensionsLocation.fsPath,X);try{await l.Promises.rm(J)}catch{throw new r.ExtensionManagementError(p.localize(4,null,J,O.id),r.ExtensionManagementErrorCode.Delete)}await this.p(O,U,ee,B),await this.l.updateMetadata(m.URI.file(ee),q);try{this.h.fire(m.URI.file(J)),await this.s(O,ee,J,Date.now()+2*60*1e3),this.m.info("Renamed to",J)}catch(_){try{await l.Promises.rm(ee)}catch{}if(_.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",O.id);else throw this.m.info(`Rename failed because of ${(0,A.getErrorMessage)(_)}. Deleted from extracted location`,ee),_}return this.t(m.URI.file(J),1)}async updateMetadata(O,U){return await this.l.updateMetadata(O.location,U),this.t(O.location,O.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...O){const U=O.map(q=>t.ExtensionKey.create(q));await this.n(q=>U.forEach(B=>{q[B.toString()]=!0,this.m.info("Marked extension as uninstalled",B.toString())}))}async setInstalled(O){await this.n(B=>delete B[O.toString()]);const q=(await this.scanAllUserExtensions(!0)).find(B=>t.ExtensionKey.create(B).equals(O))||null;return q?this.updateMetadata(q,{installedTimestamp:Date.now()}):null}async removeExtension(O,U){this.m.trace(`Deleting ${U} extension from disk`,O.identifier.id,O.location.fsPath),await l.Promises.rm(O.location.fsPath),this.m.info("Deleted from disk",O.identifier.id,O.location.fsPath)}async removeUninstalledExtension(O){await this.removeExtension(O,"uninstalled"),await this.n(U=>delete U[t.ExtensionKey.create(O).toString()])}async n(O){return this.g.queue(async()=>{let U;try{U=await l.Promises.readFile(this.c,"utf8")}catch(B){if(B.code!=="ENOENT")throw B}let q={};if(U)try{q=JSON.parse(U)}catch{}return O&&(O(q),Object.keys(q).length?await l.Promises.writeFile(this.c,JSON.stringify(q)):await l.Promises.rm(this.c)),q})}async p(O,U,q,B){this.m.trace(`Started extracting the extension from ${U} to ${q}`);try{await l.Promises.rm(q)}catch(X){throw new r.ExtensionManagementError(this.w(X).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,f.extract)(U,q,{sourcePath:"extension",overwrite:!0},B),this.m.info(`Extracted extension to ${q}:`,O.id)}catch(X){try{await l.Promises.rm(q)}catch{}let ee=r.ExtensionManagementErrorCode.Extract;throw X instanceof f.ExtractError&&(X.type==="CorruptZip"?ee=r.ExtensionManagementErrorCode.CorruptZip:X.type==="Incomplete"&&(ee=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(X.message,ee)}}async s(O,U,q,B){try{await l.Promises.rename(U,q)}catch(X){if(C.isWindows&&X&&X.code==="EPERM"&&Date.now()<B)return this.m.info(`Failed renaming ${U} to ${q} with 'EPERM' error. Trying again...`,O.id),this.s(O,U,q,B);throw new r.ExtensionManagementError(X.message||p.localize(5,null,U,q),X.code||r.ExtensionManagementErrorCode.Rename)}}async t(O,U){const q=await this.l.scanExistingExtension(O,U,{includeInvalid:!0});if(q)return this.u(q);throw new Error(p.localize(6,null,O.path))}async u(O){const U=await this.k.resolve(O.location);let q,B;return U.children&&(q=U.children.find(({name:X})=>/^readme(\.txt|\.md|)$/i.test(X))?.resource,B=U.children.find(({name:X})=>/^changelog(\.txt|\.md|)$/i.test(X))?.resource),{identifier:O.identifier,type:O.type,isBuiltin:O.isBuiltin||!!O.metadata?.isBuiltin,location:O.location,manifest:O.manifest,targetPlatform:O.targetPlatform,validations:O.validations,isValid:O.isValid,readmeUrl:q,changelogUrl:B,publisherDisplayName:O.metadata?.publisherDisplayName||null,publisherId:O.metadata?.publisherId||null,isApplicationScoped:!!O.metadata?.isApplicationScoped,isMachineScoped:!!O.metadata?.isMachineScoped,isPreReleaseVersion:!!O.metadata?.isPreReleaseVersion,preRelease:!!O.metadata?.preRelease,installedTimestamp:O.metadata?.installedTimestamp,updated:!!O.metadata?.updated}}async v(){const O=await this.getUninstalledExtensions(),U=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const ee of U)O[t.ExtensionKey.create(ee).toString()]||q.add(ee.identifier.id.toLowerCase());const B=(0,t.groupByExtension)(U,ee=>ee.identifier);await k.Promises.settled(B.map(async ee=>{const J=ee.sort((_,re)=>y.rcompare(_.manifest.version,re.manifest.version))[0];q.has(J.identifier.id.toLowerCase())||await this.j(await this.u(J))}));const X=U.filter(ee=>ee.metadata&&O[t.ExtensionKey.create(ee).toString()]);await k.Promises.settled(X.map(ee=>this.removeUninstalledExtension(ee)))}w(O){const U=Array.isArray(O)?O:[O];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((q,B)=>new Error(`${q.message}${q.message?",":""}${B instanceof Error?B.message:B}`),new Error(""))}};K=pe([Y(1,j.IFileService),Y(2,a.IExtensionsScannerService),Y(3,L.ILogService)],K),e.ExtensionsScanner=K;class V extends n.AbstractExtensionTask{get operation(){return(0,h.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(O,U,q,B,X){super(),this.identifier=O,this.source=U,this.k=q,this.l=B,this.m=X,this.wasVerified=!1,this.j=2}async n(O,U){try{const q=await this.o(O.key);if(q)return this.l.updateMetadata(q,O.metadata)}catch{throw C.isMacintosh?new r.ExtensionManagementError(p.localize(7,null),r.ExtensionManagementErrorCode.Internal):new r.ExtensionManagementError(p.localize(8,null),r.ExtensionManagementErrorCode.Internal)}return this.q(O,U)}async o(O){if(!await this.p(O))return null;this.m.trace("Removing the extension from uninstalled list:",O.id);const q=await this.l.setInstalled(O);return this.m.info("Removed the extension from uninstalled list:",O.id),q}async p(O){return!!(await this.l.getUninstalledExtensions())[O.toString()]}async q({zipPath:O,key:U,metadata:q},B){const X=await this.l.extractUserExtension(U,O,q,B);return this.m.info("Extracting completed.",U.id),X}}class G extends V{constructor(O,U,q,B,X,ee){super(U.identifier,U,q,X,ee),this.s=O,this.t=U,this.u=B}async h(O){const q=(await this.l.scanExtensions(null,void 0)).find(J=>(0,t.areSameExtensions)(J.identifier,this.t.identifier));q&&(this.j=3);const B={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,M.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||q?.isMachineScoped,isBuiltin:this.k.isBuiltin||q?.isBuiltin,isSystem:q?.type===0?!0:void 0,updated:!!q,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,h.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:q?.preRelease)};if(q?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(q,B),metadata:B};const{location:X,verified:ee}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!ee,this.w(X.fsPath),{local:await this.n({zipPath:X.fsPath,key:t.ExtensionKey.create(this.t),metadata:B},O),metadata:B}}catch(J){try{await this.u.delete(X)}catch(_){this.m.warn("Error while deleting the downloaded file",X.toString(),(0,A.getErrorMessage)(_))}throw J}}async w(O){try{await(0,u.getManifest)(O)}catch(U){throw new r.ExtensionManagementError((0,n.joinErrors)(U).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=G;class x extends V{constructor(O,U,q,B,X,ee){super({id:(0,t.getGalleryExtensionId)(O.publisher,O.name)},U,q,X,ee),this.s=O,this.t=U,this.u=B}async h(O){const U=new t.ExtensionKey(this.identifier,this.s.version),B=(await this.l.scanExtensions(1,void 0)).find(J=>(0,t.areSameExtensions)(this.identifier,J.identifier)),X=await this.w(this.identifier.id,this.s.version,O);if(X.isApplicationScoped=(0,M.isApplicationScopedExtension)(this.s),X.isMachineScoped=this.k.isMachineScoped||B?.isMachineScoped,X.isBuiltin=this.k.isBuiltin||B?.isBuiltin,X.installedTimestamp=Date.now(),B)if(this.j=3,U.equals(new t.ExtensionKey(B.identifier,B.manifest.version)))try{await this.l.removeExtension(B,"existing")}catch{throw new Error(p.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&y.gt(B.manifest.version,this.s.version)&&await this.l.setUninstalled(B);else{const J=await this.o(U);if(J)try{await this.l.removeExtension(J,"existing")}catch{throw new Error(p.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:I.resolve(this.t.fsPath),key:U,metadata:X},O),metadata:X}}async w(O,U,q){try{let[B]=await this.u.getExtensions([{id:O,version:U}],q);if(B||([B]=await this.u.getExtensions([{id:O}],q)),B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class ne{constructor(O,U,q,B,X,ee){this.d=O,this.g=U,this.h=q,this.j=B,this.k=X,this.l=ee,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.m()}async m(){const O=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[O.local,O.metadata]],this.g),O}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class se extends n.AbstractExtensionTask{constructor(O,U,q){super(),this.extension=O,this.j=U,this.k=q}async h(O){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[282],ae([0,1,2,29,80,233,125,8,19]),function(Z,e,k,i,D,A,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let b=class extends k.Disposable{constructor(C,w,y,h,m,g){super(),C.removeUninstalledExtensions(),(0,A.migrateUnsupportedExtensions)(C,w,y,h,g),D.ExtensionStorageService.removeOutdatedExtensionVersions(C,m)}};b=pe([Y(0,T.INativeServerExtensionManagementService),Y(1,i.IExtensionGalleryService),Y(2,D.IExtensionStorageService),Y(3,i.IGlobalExtensionEnablementService),Y(4,P.IStorageService),Y(5,R.ILogService)],b),e.ExtensionsContributions=b}),define(oe[291],ae([0,1,93,34,38,9,2,22,23,7,39,149,210,211,203,204,280,192,195,16,216,95,231,96,223,15,228,116,266,29,97,194,267,125,98,190,14,206,208,54,4,201,72,202,56,73,237,8,102,57,103,25,59,19,268,108,21,109,110,111,47,240,112,242,248,80,114,26,78,271,259,260,81,272,275,276,277,278,270,62,261,107,230,77,250,220,249,106,227,30,251,5,252,196,214,213,79,265,18,61,209,58,269,225,239,262,232,105,101,274,282]),function(Z,e,k,i,D,A,T,R,P,b,I,C,w,y,h,m,g,l,f,p,v,d,n,r,t,s,a,c,o,u,S,E,M,N,j,$,L,F,z,W,H,Q,K,V,G,x,ne,se,ie,O,U,q,B,X,ee,J,_,re,ue,le,ye,Se,be,Ee,Ne,Fe,Ye,ze,ce,de,ge,Ce,Pe,Ae,De,je,Te,Ue,Be,ke,Oe,te,he,fe,me,we,Ie,Re,He,$e,Le,qe,Ge,et,ot,wt,At,Lt,vt,St,Tt,bt,Ot,Nt,Mt,Ut,Ft,Et,Ct,jt,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class zt extends T.Disposable{constructor(ve){super(),this.f=ve,this.a=this.B(new C.Server),this.b=void 0,this.c=void 0,this.g()}g(){const ve=async()=>{this.c&&(await this.c.fireOnWillShutdown(),this.c.dispose(),this.c=void 0),this.dispose()};process.once("exit",ve),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Me="vscode:electron-main->shared-process=disposeWorker",We=(Je,tt)=>{this.h(tt)};k.ipcRenderer.on(Me,We),this.B((0,T.toDisposable)(()=>k.ipcRenderer.removeListener(Me,We)))}h(ve){this.b?.disposeWorker(ve)}async open(){const ve=await this.i();(0,ze.registerConfiguration)(),ve.invokeFunction(Me=>{const We=Me.get(se.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Me),this.k(We)}),this.B((0,T.combinedDisposable)(ve.createInstance(w.CodeCacheCleaner,this.f.codeCachePath),ve.createInstance(y.LanguagePackCachedDataCleaner),ve.createInstance(g.UnusedWorkspaceStorageDataCleaner),ve.createInstance(m.LogsDataCleaner),ve.createInstance(h.LocalizationsUpdater),ve.createInstance($t.ExtensionsContributions),ve.createInstance(Ut.UserDataProfilesCleaner)))}async i(){const ve=new K.ServiceCollection,Me={_serviceBrand:void 0,...U.default};ve.set(q.IProductService,Me);const We=new I.StaticRouter(Qe=>Qe==="main"),Je=new V.MessagePortMainProcessService(this.a,We);ve.set(G.IMainProcessService,Je);const tt=this.f.policiesData?new Tt.PolicyChannelClient(this.f.policiesData,Je.getChannel("policy")):new bt.NullPolicyService;ve.set(bt.IPolicyService,tt);const Ke=new a.SharedProcessEnvironmentService(this.f.args,Me);ve.set(s.INativeEnvironmentService,Ke);const lt=new ie.LogLevelChannelClient(this.a.getChannel("logLevel",We)),it=new ie.LoggerChannelClient(this.f.logLevel,lt.onDidChangeLogLevel,Je.getChannel("logger"));ve.set(se.ILoggerService,it);const ht=this.B(new se.MultiplexLogService([this.B(new se.ConsoleLogger(this.f.logLevel)),this.B(it.createLogger((0,P.joinPath)(b.URI.file(Ke.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Xe=this.B(new ie.FollowerLogService(lt,ht));ve.set(se.ILogService,Xe),this.c=new Ct.SharedProcessLifecycleService(Xe),ve.set(Ct.ISharedProcessLifecycleService,this.c),this.b=new He.SharedProcessWorkerService(Xe),ve.set(Re.ISharedProcessWorkerService,this.b);const _e=this.B(new F.FileService(Xe));ve.set(L.IFileService,_e);const ft=this.B(new z.DiskFileSystemProvider(Xe));_e.registerProvider(R.Schemas.file,ft);const dt=this.B(new Ge.FileUserDataProvider(R.Schemas.file,this.B(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),R.Schemas.vscodeUserData,Xe));_e.registerProvider(R.Schemas.vscodeUserData,dt);const nt=this.B(new Ot.UserDataProfilesNativeService(this.f.profiles,Je,Ke));ve.set(vt.IUserDataProfilesService,nt);const xe=this.B(new v.ConfigurationService(nt.defaultProfile.settingsResource,_e,tt,Xe));ve.set(p.IConfigurationService,xe);const at=new ee.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);ve.set(X.IStorageService,at),this.B((0,T.toDisposable)(()=>at.flush())),await Promise.all([xe.initialize(),at.initialize()]),ve.set($e.IUriIdentityService,new Le.UriIdentityService(_e)),ve.set(B.IRequestService,new Nt.SharedProcessRequestService(Je,xe,Me,Xe)),ve.set(l.IChecksumService,new W.SyncDescriptor(f.ChecksumService,void 0,!1)),ve.set(wt.IV8InspectProfilingService,new W.SyncDescriptor(ot.InspectProfilingService,void 0,!1));const ut=I.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.f.windowId});ve.set(O.INativeHostService,ut),ve.set(r.IDownloadService,new W.SyncDescriptor(t.DownloadService,void 0,!0));const gt=this.B(new Oe.ActiveWindowManager(ut)),mt=new I.StaticRouter(Qe=>gt.getActiveClientId().then(pt=>Qe===pt));ve.set(j.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",mt)));let st;const ct=[],Pt=(0,ye.isInternalTelemetry)(Me,xe);if((0,ye.supportsTelemetry)(Me,Ke)){const Qe=new ue.TelemetryLogAppender(it,Ke);ct.push(Qe);const{installSourcePath:pt}=Ke;if(Me.aiConfig?.ariaKey){const Dt=new Mt.OneDataSystemAppender(Pt,"monacoworkbench",null,Me.aiConfig.ariaKey);this.B((0,T.toDisposable)(()=>Dt.flush())),ct.push(Dt)}st=new le.TelemetryService({appenders:ct,commonProperties:(0,J.resolveCommonProperties)(_e,(0,i.release)(),(0,i.hostname)(),process.arch,Me.commit,Me.version,this.f.machineId,Pt,pt),sendErrorTelemetry:!0,piiPaths:(0,ye.getPiiPathsFromEnvironment)(Ke)},xe,Me)}else{st=ye.NullTelemetryService;const Qe=ye.NullAppender;ct.push(Qe)}this.a.registerChannel("telemetryAppender",new re.TelemetryAppenderChannel(ct)),ve.set(_.ITelemetryService,st);const qt=new Se.CustomEndpointTelemetryService(xe,st,it,Ke,Me);ve.set(_.ICustomEndpointTelemetryService,qt),ve.set(St.IExtensionsProfileScannerService,new W.SyncDescriptor(St.ExtensionsProfileScannerService,void 0,!0)),ve.set(At.IExtensionsScannerService,new W.SyncDescriptor(Lt.ExtensionsScannerService,void 0,!0)),ve.set(S.IExtensionSignatureVerificationService,new W.SyncDescriptor(S.ExtensionSignatureVerificationService,void 0,!0)),ve.set(N.INativeServerExtensionManagementService,new W.SyncDescriptor(N.ExtensionManagementService,void 0,!0)),ve.set(u.IExtensionGalleryService,new W.SyncDescriptor(o.ExtensionGalleryService,void 0,!0)),ve.set(u.IExtensionTipsService,new W.SyncDescriptor(M.ExtensionTipsService,void 0,!1)),ve.set(x.ILanguagePackService,new W.SyncDescriptor(ne.NativeLanguagePackService,void 0,!1)),ve.set(d.IDiagnosticsService,new W.SyncDescriptor(n.DiagnosticsService,void 0,!1)),ve.set(ce.IUserDataSyncAccountService,new W.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),ve.set(ze.IUserDataSyncLogService,new W.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),ve.set(ze.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),ve.set(u.IGlobalExtensionEnablementService,new W.SyncDescriptor(c.GlobalExtensionEnablementService,void 0,!1)),ve.set(Ye.IIgnoredExtensionsManagementService,new W.SyncDescriptor(Ye.IgnoredExtensionsManagementService,void 0,!0)),ve.set(Fe.IExtensionStorageService,new W.SyncDescriptor(Fe.ExtensionStorageService)),ve.set(ze.IUserDataSyncStoreManagementService,new W.SyncDescriptor(Te.UserDataSyncStoreManagementService,void 0,!0)),ve.set(ze.IUserDataSyncStoreService,new W.SyncDescriptor(Te.UserDataSyncStoreService,void 0,!0)),ve.set(Pe.IUserDataSyncMachinesService,new W.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),ve.set(ze.IUserDataSyncBackupStoreService,new W.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),ve.set(ze.IUserDataSyncEnablementService,new W.SyncDescriptor(Ae.UserDataSyncEnablementService,void 0,!0)),ve.set(ze.IUserDataSyncService,new W.SyncDescriptor(De.UserDataSyncService,void 0,!1)),ve.set(ke.IUserDataProfileStorageService,new W.SyncDescriptor(Be.UserDataProfileStorageService,void 0,!0)),ve.set(ze.IUserDataSyncResourceProviderService,new W.SyncDescriptor(jt.UserDataSyncResourceProviderService,void 0,!0));const Rt=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:xe.getValue("terminal.integrated.persistentSessionScrollback")??100},xe,Ke,Xe);return Rt.initialize(),ve.set(Ee.ILocalPtyService,this.B(Rt)),ve.set(te.ISignService,new W.SyncDescriptor(he.SignService,void 0,!1)),ve.set(fe.ISharedTunnelsService,new W.SyncDescriptor(me.SharedTunnelsService)),ve.set(we.ISharedProcessTunnelService,new W.SyncDescriptor(Ie.SharedProcessTunnelService)),ve.set(Et.IRemoteTunnelService,new W.SyncDescriptor(Ft.RemoteTunnelService)),new Q.InstantiationService(ve)}j(ve){const Me=new ie.LogLevelChannel(ve.get(se.ILogService),ve.get(se.ILoggerService));this.a.registerChannel("logLevel",Me);const We=new E.ExtensionManagementChannel(ve.get(u.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",We);const Je=I.ProxyChannel.fromService(ve.get(x.ILanguagePackService));this.a.registerChannel("languagePacks",Je);const tt=I.ProxyChannel.fromService(ve.get(d.IDiagnosticsService));this.a.registerChannel("diagnostics",tt);const Ke=new E.ExtensionTipsChannel(ve.get(u.IExtensionTipsService));this.a.registerChannel("extensionTipsService",Ke);const lt=I.ProxyChannel.fromService(ve.get(l.IChecksumService));this.a.registerChannel("checksum",lt);const it=I.ProxyChannel.fromService(ve.get(wt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",it);const ht=new ge.UserDataSyncMachinesServiceChannel(ve.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ht);const Xe=I.ProxyChannel.fromService(ve.get(_.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",Xe);const _e=new ge.UserDataSyncAccountServiceChannel(ve.get(ce.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",_e);const ft=new ge.UserDataSyncStoreManagementServiceChannel(ve.get(ze.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",ft);const dt=new je.UserDataSyncChannel(ve.get(ze.IUserDataSyncService),ve.get(vt.IUserDataProfilesService),ve.get(se.ILogService));this.a.registerChannel("userDataSync",dt);const nt=this.B(ve.get(H.IInstantiationService).createInstance(Ue.UserDataAutoSyncService)),xe=new ge.UserDataAutoSyncChannel(nt);this.a.registerChannel("userDataAutoSync",xe);const at=ve.get(Ee.ILocalPtyService),ut=I.ProxyChannel.fromService(at);this.a.registerChannel(be.TerminalIpcChannels.LocalPty,ut);const gt=I.ProxyChannel.fromService(ve.get(we.ISharedProcessTunnelService));this.a.registerChannel(we.ipcSharedProcessTunnelChannelName,gt);const mt=I.ProxyChannel.fromService(ve.get(Re.ISharedProcessWorkerService));this.a.registerChannel(Re.ipcSharedProcessWorkerChannelName,mt);const st=I.ProxyChannel.fromService(ve.get(Et.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",st)}k(ve){window.addEventListener("unhandledrejection",Me=>{(0,A.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,A.setUnexpectedErrorHandler)(Me=>{const We=(0,D.toErrorMessage)(Me,!0);!We||ve.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function Bt(It){const ve=new zt(It);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Bt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6ed4d436a9b6ae131732f4e2a723868231f4473a/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
