/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/base/common/extpath","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/platform/policy/common/policy","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/common/objects","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/window/common/window","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],re=function(H){for(var e=[],E=0,t=H.length;E<t;E++)e[E]=ie[H[E]];return e};define(ie[120],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function E(M){return M?M.replace(/\$\((.*?)\)/g,(A,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=E;class t{constructor(A,P,g){this.id=A,this.definition=P,this.description=g,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var k;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function P(b){if(b instanceof t)return["codicon","codicon-"+b.id];const S=A.exec(b.id);if(!S)return P(t.error);const[,y,u]=S,d=["codicon","codicon-"+y];return u&&d.push("codicon-modifier-"+u.substring(1)),d}M.asClassNameArray=P;function g(b){return P(b).join(" ")}M.asClassName=g;function m(b){return"."+P(b).join(".")}M.asCSSSelector=m})(k=e.CSSIcon||(e.CSSIcon={}))}),define(ie[121],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(P,g){const m=Math.pow(10,g);return Math.round(P*m)/m}class t{constructor(g,m,b,S=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=E(Math.max(Math.min(1,S),0),3)}static equals(g,m){return g.r===m.r&&g.g===m.g&&g.b===m.b&&g.a===m.a}}e.RGBA=t;class k{constructor(g,m,b,S){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=E(Math.max(Math.min(1,m),0),3),this.l=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,S),0),3)}static equals(g,m){return g.h===m.h&&g.s===m.s&&g.l===m.l&&g.a===m.a}static fromRGBA(g){const m=g.r/255,b=g.g/255,S=g.b/255,y=g.a,u=Math.max(m,b,S),d=Math.min(m,b,S);let p=0,f=0;const l=(d+u)/2,w=u-d;if(w>0){switch(f=Math.min(l<=.5?w/(2*l):w/(2-2*l),1),u){case m:p=(b-S)/w+(b<S?6:0);break;case b:p=(S-m)/w+2;break;case S:p=(m-b)/w+4;break}p*=60,p=Math.round(p)}return new k(p,f,l,y)}static i(g,m,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?g+(m-g)*6*b:b<1/2?m:b<2/3?g+(m-g)*(2/3-b)*6:g}static toRGBA(g){const m=g.h/360,{s:b,l:S,a:y}=g;let u,d,p;if(b===0)u=d=p=S;else{const f=S<.5?S*(1+b):S+b-S*b,l=2*S-f;u=k.i(l,f,m+1/3),d=k.i(l,f,m),p=k.i(l,f,m-1/3)}return new t(Math.round(u*255),Math.round(d*255),Math.round(p*255),y)}}e.HSLA=k;class M{constructor(g,m,b,S){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=E(Math.max(Math.min(1,m),0),3),this.v=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,S),0),3)}static equals(g,m){return g.h===m.h&&g.s===m.s&&g.v===m.v&&g.a===m.a}static fromRGBA(g){const m=g.r/255,b=g.g/255,S=g.b/255,y=Math.max(m,b,S),u=Math.min(m,b,S),d=y-u,p=y===0?0:d/y;let f;return d===0?f=0:y===m?f=((b-S)/d%6+6)%6:y===b?f=(S-m)/d+2:f=(m-b)/d+4,new M(Math.round(f*60),p,y,g.a)}static toRGBA(g){const{h:m,s:b,v:S,a:y}=g,u=S*b,d=u*(1-Math.abs(m/60%2-1)),p=S-u;let[f,l,w]=[0,0,0];return m<60?(f=u,l=d):m<120?(f=d,l=u):m<180?(l=u,w=d):m<240?(l=d,w=u):m<300?(f=d,w=u):m<=360&&(f=u,w=d),f=Math.round((f+p)*255),l=Math.round((l+p)*255),w=Math.round((w+p)*255),new t(f,l,w,y)}}e.HSVA=M;class A{static fromHex(g){return A.Format.CSS.parseHex(g)||A.red}static equals(g,m){return!g&&!m?!0:!g||!m?!1:g.equals(m)}get hsla(){return this.i?this.i:k.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(g){if(g)if(g instanceof t)this.rgba=g;else if(g instanceof k)this.i=g,this.rgba=k.toRGBA(g);else if(g instanceof M)this.j=g,this.rgba=M.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(g){return!!g&&t.equals(this.rgba,g.rgba)&&k.equals(this.hsla,g.hsla)&&M.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=A.k(this.rgba.r),m=A.k(this.rgba.g),b=A.k(this.rgba.b),S=.2126*g+.7152*m+.0722*b;return E(S,4)}static k(g){const m=g/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(g){const m=this.getRelativeLuminance(),b=g.getRelativeLuminance();return m>b?(m+.05)/(b+.05):(b+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const m=this.getRelativeLuminance(),b=g.getRelativeLuminance();return m>b}isDarkerThan(g){const m=this.getRelativeLuminance(),b=g.getRelativeLuminance();return m<b}lighten(g){return new A(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new A(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:m,g:b,b:S,a:y}=this.rgba;return new A(new t(m,b,S,y*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const m=g.rgba,b=this.rgba.a,S=m.a,y=b+S*(1-b);if(y<1e-6)return A.transparent;const u=this.rgba.r*b/y+m.r*S*(1-b)/y,d=this.rgba.g*b/y+m.g*S*(1-b)/y,p=this.rgba.b*b/y+m.b*S*(1-b)/y;return new A(new t(u,d,p,y))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:m,g:b,b:S,a:y}=this.rgba;return new A(new t(g.rgba.r-y*(g.rgba.r-m),g.rgba.g-y*(g.rgba.g-b),g.rgba.b-y*(g.rgba.b-S),1))}flatten(...g){const m=g.reduceRight((b,S)=>A.o(S,b));return A.o(this,m)}static o(g,m){const b=1-g.rgba.a;return new A(new t(b*m.rgba.r+g.rgba.a*g.rgba.r,b*m.rgba.g+g.rgba.a*g.rgba.g,b*m.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(g,m,b){if(g.isLighterThan(m))return g;b=b||.5;const S=g.getRelativeLuminance(),y=m.getRelativeLuminance();return b=b*(y-S)/y,g.lighten(b)}static getDarkerColor(g,m,b){if(g.isDarkerThan(m))return g;b=b||.5;const S=g.getRelativeLuminance(),y=m.getRelativeLuminance();return b=b*(S-y)/S,g.darken(b)}}e.Color=A,A.white=new A(new t(255,255,255,1)),A.black=new A(new t(0,0,0,1)),A.red=new A(new t(255,0,0,1)),A.blue=new A(new t(0,0,255,1)),A.green=new A(new t(0,255,0,1)),A.cyan=new A(new t(0,255,255,1)),A.lightgrey=new A(new t(211,211,211,1)),A.transparent=new A(new t(0,0,0,0)),function(P){let g;(function(m){let b;(function(S){function y(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:P.Format.CSS.formatRGBA(i)}S.formatRGB=y;function u(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}S.formatRGBA=u;function d(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(i)}S.formatHSL=d;function p(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}S.formatHSLA=p;function f(i){const r=i.toString(16);return r.length!==2?"0"+r:r}function l(i){return`#${f(i.rgba.r)}${f(i.rgba.g)}${f(i.rgba.b)}`}S.formatHex=l;function w(i,r=!1){return r&&i.rgba.a===1?P.Format.CSS.formatHex(i):`#${f(i.rgba.r)}${f(i.rgba.g)}${f(i.rgba.b)}${f(Math.round(i.rgba.a*255))}`}S.formatHexA=w;function C(i){return i.isOpaque()?P.Format.CSS.formatHex(i):P.Format.CSS.formatRGBA(i)}S.format=C;function I(i){const r=i.length;if(r===0||i.charCodeAt(0)!==35)return null;if(r===7){const n=16*v(i.charCodeAt(1))+v(i.charCodeAt(2)),o=16*v(i.charCodeAt(3))+v(i.charCodeAt(4)),a=16*v(i.charCodeAt(5))+v(i.charCodeAt(6));return new P(new t(n,o,a,1))}if(r===9){const n=16*v(i.charCodeAt(1))+v(i.charCodeAt(2)),o=16*v(i.charCodeAt(3))+v(i.charCodeAt(4)),a=16*v(i.charCodeAt(5))+v(i.charCodeAt(6)),c=16*v(i.charCodeAt(7))+v(i.charCodeAt(8));return new P(new t(n,o,a,c/255))}if(r===4){const n=v(i.charCodeAt(1)),o=v(i.charCodeAt(2)),a=v(i.charCodeAt(3));return new P(new t(16*n+n,16*o+o,16*a+a))}if(r===5){const n=v(i.charCodeAt(1)),o=v(i.charCodeAt(2)),a=v(i.charCodeAt(3)),c=v(i.charCodeAt(4));return new P(new t(16*n+n,16*o+o,16*a+a,(16*c+c)/255))}return null}S.parseHex=I;function v(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=m.CSS||(m.CSS={}))})(g=P.Format||(P.Format={}))}(A=e.Color||(e.Color={}))}),define(ie[54],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(A){return(P,g,m)=>{let b=null,S=null;if(typeof m.value=="function"?(b="value",S=m.value):typeof m.get=="function"&&(b="get",S=m.get),!S)throw new Error("not supported");m[b]=A(S,g)}}function t(A,P,g){let m=null,b=null;if(typeof g.value=="function"?(m="value",b=g.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(m="get",b=g.get),!b)throw new Error("not supported");const S=`$memoize$${P}`;g[m]=function(...y){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,y)}),this[S]}}e.memoize=t;function k(A,P,g){return E((m,b)=>{const S=`$debounce$${b}`,y=`$debounce$result$${b}`;return function(...u){this[y]||(this[y]=g?g():void 0),clearTimeout(this[S]),P&&(this[y]=P(this[y],...u),u=[this[y]]),this[S]=setTimeout(()=>{m.apply(this,u),this[y]=g?g():void 0},A)}})}e.debounce=k;function M(A,P,g){return E((m,b)=>{const S=`$throttle$timer$${b}`,y=`$throttle$result$${b}`,u=`$throttle$lastRun$${b}`,d=`$throttle$pending$${b}`;return function(...p){if(this[y]||(this[y]=g?g():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...p)),this[d])return;const f=this[u]+A;f<=Date.now()?(this[u]=Date.now(),m.apply(this,[this[y]]),this[y]=g?g():void 0):(this[d]=!0,this[S]=setTimeout(()=>{this[d]=!1,this[u]=Date.now(),m.apply(this,[this[y]]),this[y]=g?g():void 0},f-Date.now()))}})}e.throttle=M}),define(ie[13],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?C.isErrorNoTelemetry(i)?new C(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(r=>{r(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=E,e.errorHandler=new E;function t(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=t;function k(v){g(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=k;function M(v){g(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=M;function A(v){if(v instanceof Error){const{name:i,message:r}=v,n=v.stacktrace||v.stack;return{$isError:!0,name:i,message:r,stack:n,noTelemetry:C.isErrorNoTelemetry(v)}}return v}e.transformErrorForSerialization=A;const P="Canceled";function g(v){return v instanceof m?!0:v instanceof Error&&v.name===P&&v.message===P}e.isCancellationError=g;class m extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=m;function b(){const v=new Error(P);return v.name=v.message,v}e.canceled=b;function S(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=S;function y(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=y;function u(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=u;function d(v){const i=new Error(`${v} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function p(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=p;class f extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=f;class l extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=l;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=w;class C extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof C)return i;const r=new C;return r.message=i.message,r.stack=i.stack,r}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=C;class I extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,I.prototype);debugger}}e.BugIndicatingError=I}),define(ie[24],re([0,1,13]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(B,Z=0){return B[B.length-(1+Z)]}e.tail=t;function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=k;function M(B,Z,te=(ae,ge)=>ae===ge){if(B===Z)return!0;if(!B||!Z||B.length!==Z.length)return!1;for(let ae=0,ge=B.length;ae<ge;ae++)if(!te(B[ae],Z[ae]))return!1;return!0}e.equals=M;function A(B,Z){const te=B.length-1;Z<te&&(B[Z]=B[te]),B.pop()}e.removeFastWithoutKeepingOrder=A;function P(B,Z,te){return g(B.length,ae=>te(B[ae],Z))}e.binarySearch=P;function g(B,Z){let te=0,ae=B-1;for(;te<=ae;){const ge=(te+ae)/2|0,ke=Z(ge);if(ke<0)te=ge+1;else if(ke>0)ae=ge-1;else return ge}return-(te+1)}e.binarySearch2=g;function m(B,Z){let te=0,ae=B.length;if(ae===0)return 0;for(;te<ae;){const ge=Math.floor((te+ae)/2);Z(B[ge])?ae=ge:te=ge+1}return te}e.findFirstInSorted=m;function b(B,Z,te){if(B=B|0,B>=Z.length)throw new TypeError("invalid index");const ae=Z[Math.floor(Z.length*Math.random())],ge=[],ke=[],Oe=[];for(const De of Z){const Me=te(De,ae);Me<0?ge.push(De):Me>0?ke.push(De):Oe.push(De)}return B<ge.length?b(B,ge,te):B<ge.length+Oe.length?Oe[0]:b(B-(ge.length+Oe.length),ke,te)}e.quickSelect=b;function S(B,Z){const te=[];let ae;for(const ge of B.slice(0).sort(Z))!ae||Z(ae[0],ge)!==0?(ae=[ge],te.push(ae)):ae.push(ge);return te}e.groupBy=S;function y(B,Z,te){const ae=[];function ge(De,Me,ve){if(Me===0&&ve.length===0)return;const we=ae[ae.length-1];we&&we.start+we.deleteCount===De?(we.deleteCount+=Me,we.toInsert.push(...ve)):ae.push({start:De,deleteCount:Me,toInsert:ve})}let ke=0,Oe=0;for(;;){if(ke===B.length){ge(ke,0,Z.slice(Oe));break}if(Oe===Z.length){ge(ke,B.length-ke,[]);break}const De=B[ke],Me=Z[Oe],ve=te(De,Me);ve===0?(ke+=1,Oe+=1):ve<0?(ge(ke,1,[]),ke+=1):ve>0&&(ge(ke,0,[Me]),Oe+=1)}return ae}e.sortedDiff=y;function u(B,Z,te){const ae=y(B,Z,te),ge=[],ke=[];for(const Oe of ae)ge.push(...B.slice(Oe.start,Oe.start+Oe.deleteCount)),ke.push(...Oe.toInsert);return{removed:ge,added:ke}}e.delta=u;function d(B,Z,te){if(te===0)return[];const ae=B.slice(0,te).sort(Z);return f(B,Z,ae,te,B.length),ae}e.top=d;function p(B,Z,te,ae,ge){return te===0?Promise.resolve([]):new Promise((ke,Oe)=>{(async()=>{const De=B.length,Me=B.slice(0,te).sort(Z);for(let ve=te,we=Math.min(te+ae,De);ve<De;ve=we,we=Math.min(we+ae,De)){if(ve>te&&await new Promise(ye=>setTimeout(ye)),ge&&ge.isCancellationRequested)throw new E.CancellationError;f(B,Z,Me,ve,we)}return Me})().then(ke,Oe)})}e.topAsync=p;function f(B,Z,te,ae,ge){for(const ke=te.length;ae<ge;ae++){const Oe=B[ae];if(Z(Oe,te[ke-1])<0){te.pop();const De=m(te,Me=>Z(Oe,Me)<0);te.splice(De,0,Oe)}}}function l(B){return B.filter(Z=>!!Z)}e.coalesce=l;function w(B){let Z=0;for(let te=0;te<B.length;te++)B[te]&&(B[Z]=B[te],Z+=1);B.length=Z}e.coalesceInPlace=w;function C(B,Z,te){B.splice(te,0,B.splice(Z,1)[0])}e.move=C;function I(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=I;function v(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=v;function i(B,Z=te=>te){const te=new Set;return B.filter(ae=>{const ge=Z(ae);return te.has(ge)?!1:(te.add(ge),!0)})}e.distinct=i;function r(B){const Z=new Set;return te=>{const ae=B(te);return Z.has(ae)?!1:(Z.add(ae),!0)}}e.uniqueFilter=r;function n(B,Z){const te=o(B,Z);if(te!==-1)return B[te]}e.findLast=n;function o(B,Z){for(let te=B.length-1;te>=0;te--){const ae=B[te];if(Z(ae))return te}return-1}e.lastIndex=o;function a(B,Z){return B.length>0?B[0]:Z}e.firstOrDefault=a;function c(B,Z){return B.length>0?B[B.length-1]:Z}e.lastOrDefault=c;function s(B,Z,te=(ae,ge)=>ae===ge){let ae=0;for(let ge=0,ke=Math.min(B.length,Z.length);ge<ke&&te(B[ge],Z[ge]);ge++)ae++;return ae}e.commonPrefixLength=s;function h(B){return[].concat(...B)}e.flatten=h;function D(B,Z){let te=typeof Z=="number"?B:0;typeof Z=="number"?te=B:(te=0,Z=B);const ae=[];if(te<=Z)for(let ge=te;ge<Z;ge++)ae.push(ge);else for(let ge=te;ge>Z;ge--)ae.push(ge);return ae}e.range=D;function L(B,Z,te){return B.reduce((ae,ge)=>(ae[Z(ge)]=te?te(ge):ge,ae),Object.create(null))}e.index=L;function T(B,Z){return B.push(Z),()=>F(B,Z)}e.insert=T;function F(B,Z){const te=B.indexOf(Z);if(te>-1)return B.splice(te,1),Z}e.remove=F;function G(B,Z,te){const ae=B.slice(0,Z),ge=B.slice(Z);return ae.concat(te,ge)}e.arrayInsert=G;function V(B,Z){let te;if(typeof Z=="number"){let ae=Z;te=()=>{const ge=Math.sin(ae++)*179426549;return ge-Math.floor(ge)}}else te=Math.random;for(let ae=B.length-1;ae>0;ae-=1){const ge=Math.floor(te()*(ae+1)),ke=B[ae];B[ae]=B[ge],B[ge]=ke}}e.shuffle=V;function K(B,Z){const te=B.indexOf(Z);te>-1&&(B.splice(te,1),B.unshift(Z))}e.pushToStart=K;function _(B,Z){const te=B.indexOf(Z);te>-1&&(B.splice(te,1),B.push(Z))}e.pushToEnd=_;function se(B,Z){for(const te of Z)B.push(te)}e.pushMany=se;function ce(B,Z){return Array.isArray(B)?B.map(Z):Z(B)}e.mapArrayOrNot=ce;function X(B){return Array.isArray(B)?B:[B]}e.asArray=X;function ue(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=ue;function z(B,Z){for(const te of B){const ae=Z(te);if(ae!==void 0)return ae}}e.mapFind=z;function N(B,Z,te){const ae=q(B,Z),ge=B.length,ke=te.length;B.length=ge+ke;for(let Oe=ge-1;Oe>=ae;Oe--)B[Oe+ke]=B[Oe];for(let Oe=0;Oe<ke;Oe++)B[Oe+ae]=te[Oe]}e.insertInto=N;function U(B,Z,te,ae){const ge=q(B,Z),ke=B.splice(ge,te);return N(B,ge,ae),ke}e.splice=U;function q(B,Z){return Z<0?Math.max(Z+B.length,0):Math.min(Z,B.length)}var Q;(function(B){function Z(ge){return ge<0}B.isLessThan=Z;function te(ge){return ge>0}B.isGreaterThan=te;function ae(ge){return ge===0}B.isNeitherLessOrGreaterThan=ae,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function oe(B,Z){return(te,ae)=>Z(B(te),B(ae))}e.compareBy=oe;function x(...B){return(Z,te)=>{for(const ae of B){const ge=ae(Z,te);if(!Q.isNeitherLessOrGreaterThan(ge))return ge}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const R=(B,Z)=>B-Z;e.numberComparator=R;function O(B,Z){if(B.length===0)return;let te=B[0];for(let ae=1;ae<B.length;ae++){const ge=B[ae];Z(ge,te)>0&&(te=ge)}return te}e.findMaxBy=O;function W(B,Z){if(B.length===0)return;let te=B[0];for(let ae=1;ae<B.length;ae++){const ge=B[ae];Z(ge,te)>=0&&(te=ge)}return te}e.findLastMaxBy=W;function j(B,Z){return O(B,(te,ae)=>-Z(te,ae))}e.findMinBy=j;class ${constructor(Z){this.f=Z,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let te=this.c;for(;te<this.f.length&&Z(this.f[te]);)te++;const ae=te===this.c?null:this.f.slice(this.c,te);return this.c=te,ae}takeFromEndWhile(Z){let te=this.d;for(;te>=0&&Z(this.f[te]);)te--;const ae=te===this.d?null:this.f.slice(te+1,this.d+1);return this.d=te,ae}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Z=this.f[this.c];return this.c++,Z}removeLast(){const Z=this.f[this.d];return this.d--,Z}takeCount(Z){const te=this.f.slice(this.c,this.c+Z);return this.c+=Z,te}}e.ArrayQueue=$;class Y{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(te=>(Z(te),!0))}toArray(){const Z=[];return this.iterate(te=>(Z.push(te),!0)),Z}filter(Z){return new Y(te=>this.iterate(ae=>Z(ae)?te(ae):!0))}map(Z){return new Y(te=>this.iterate(ae=>te(Z(ae))))}some(Z){let te=!1;return this.iterate(ae=>(te=Z(ae),!te)),te}findFirst(Z){let te;return this.iterate(ae=>Z(ae)?(te=ae,!1):!0),te}findLast(Z){let te;return this.iterate(ae=>(Z(ae)&&(te=ae),!0)),te}findLastMaxBy(Z){let te,ae=!0;return this.iterate(ge=>((ae||Q.isGreaterThan(Z(ge,te)))&&(ae=!1,te=ge),!0)),te}}e.CallbackIterable=Y,Y.empty=new Y(B=>{})}),define(ie[122],re([0,1,13]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(g,m){if(!g)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=t;function k(g,m="Unreachable"){throw new Error(m)}e.assertNever=k;function M(g){if(!g)throw new E.BugIndicatingError("Assertion Failed")}e.assert=M;function A(g){if(!g()){debugger;g(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function P(g,m){let b=0;for(;b<g.length-1;){const S=g[b],y=g[b+1];if(!m(S,y))return!1;b++}return!0}e.checkAdjacentItems=P}),define(ie[50],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(t){const k=this;let M=!1,A;return function(){return M||(M=!0,A=t.apply(k,arguments)),A}}e.once=E}),define(ie[67],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(t){function k(I){return I&&typeof I=="object"&&typeof I[Symbol.iterator]=="function"}t.is=k;const M=Object.freeze([]);function A(){return M}t.empty=A;function*P(I){yield I}t.single=P;function g(I){return k(I)?I:P(I)}t.wrap=g;function m(I){return I||M}t.from=m;function b(I){return!I||I[Symbol.iterator]().next().done===!0}t.isEmpty=b;function S(I){return I[Symbol.iterator]().next().value}t.first=S;function y(I,v){for(const i of I)if(v(i))return!0;return!1}t.some=y;function u(I,v){for(const i of I)if(v(i))return i}t.find=u;function*d(I,v){for(const i of I)v(i)&&(yield i)}t.filter=d;function*p(I,v){let i=0;for(const r of I)yield v(r,i++)}t.map=p;function*f(...I){for(const v of I)for(const i of v)yield i}t.concat=f;function l(I,v,i){let r=i;for(const n of I)r=v(r,n);return r}t.reduce=l;function*w(I,v,i=I.length){for(v<0&&(v+=I.length),i<0?i+=I.length:i>I.length&&(i=I.length);v<i;v++)yield I[v]}t.slice=w;function C(I,v=Number.POSITIVE_INFINITY){const i=[];if(v===0)return[i,I];const r=I[Symbol.iterator]();for(let n=0;n<v;n++){const o=r.next();if(o.done)return[i,t.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=C})(E=e.Iterable||(e.Iterable={}))}),define(ie[43],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function A(i,r=!1){let n=0;const o=i.length;let a="",c=0,s=16,h=0;function D(_){let se=0,ce=0;for(;se<_;){const X=i.charCodeAt(n);if(X>=48&&X<=57)ce=ce*16+X-48;else if(X>=65&&X<=70)ce=ce*16+X-65+10;else if(X>=97&&X<=102)ce=ce*16+X-97+10;else break;n++,se++}return se<_&&(ce=-1),ce}function L(_){n=_,a="",c=0,s=16,h=0}function T(){const _=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&m(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&m(i.charCodeAt(n)))for(n++;n<i.length&&m(i.charCodeAt(n));)n++;else return h=3,i.substring(_,n);let se=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&m(i.charCodeAt(n))){for(n++;n<i.length&&m(i.charCodeAt(n));)n++;se=n}else h=3;return i.substring(_,se)}function F(){let _="",se=n;for(;;){if(n>=o){_+=i.substring(se,n),h=2;break}const ce=i.charCodeAt(n);if(ce===34){_+=i.substring(se,n),n++;break}if(ce===92){if(_+=i.substring(se,n),n++,n>=o){h=2;break}switch(i.charCodeAt(n++)){case 34:_+='"';break;case 92:_+="\\";break;case 47:_+="/";break;case 98:_+="\b";break;case 102:_+="\f";break;case 110:_+=`
`;break;case 114:_+="\r";break;case 116:_+="	";break;case 117:{const ue=D(4);ue>=0?_+=String.fromCharCode(ue):h=4;break}default:h=5}se=n;continue}if(ce>=0&&ce<=31)if(g(ce)){_+=i.substring(se,n),h=2;break}else h=6;n++}return _}function G(){if(a="",h=0,c=n,n>=o)return c=o,s=17;let _=i.charCodeAt(n);if(P(_)){do n++,a+=String.fromCharCode(_),_=i.charCodeAt(n);while(P(_));return s=15}if(g(_))return n++,a+=String.fromCharCode(_),_===13&&i.charCodeAt(n)===10&&(n++,a+=`
`),s=14;switch(_){case 123:return n++,s=1;case 125:return n++,s=2;case 91:return n++,s=3;case 93:return n++,s=4;case 58:return n++,s=6;case 44:return n++,s=5;case 34:return n++,a=F(),s=10;case 47:{const se=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<o&&!g(i.charCodeAt(n));)n++;return a=i.substring(se,n),s=12}if(i.charCodeAt(n+1)===42){n+=2;const ce=o-1;let X=!1;for(;n<ce;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,X=!0;break}n++}return X||(n++,h=1),a=i.substring(se,n),s=13}return a+=String.fromCharCode(_),n++,s=16}case 45:if(a+=String.fromCharCode(_),n++,n===o||!m(i.charCodeAt(n)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=T(),s=11;default:for(;n<o&&V(_);)n++,_=i.charCodeAt(n);if(c!==n){switch(a=i.substring(c,n),a){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return a+=String.fromCharCode(_),n++,s=16}}function V(_){if(P(_)||g(_))return!1;switch(_){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let _;do _=G();while(_>=12&&_<=15);return _}return{setPosition:L,getPosition:()=>n,scan:r?K:G,getToken:()=>s,getTokenValue:()=>a,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>h}}e.createScanner=A;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var b;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(b||(b={}));function S(i,r){const n=[],o=new Object;let a;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function h(D,L,T,F){c.value=D,c.offset=L,c.length=T,c.type=F,c.colonOffset=void 0,a=c}try{C(i,{onObjectBegin:(D,L)=>{if(r<=D)throw o;a=void 0,s=r>D,n.push("")},onObjectProperty:(D,L,T)=>{if(r<L||(h(D,L,T,"property"),n[n.length-1]=D,r<=L+T))throw o},onObjectEnd:(D,L)=>{if(r<=D)throw o;a=void 0,n.pop()},onArrayBegin:(D,L)=>{if(r<=D)throw o;a=void 0,n.push(0)},onArrayEnd:(D,L)=>{if(r<=D)throw o;a=void 0,n.pop()},onLiteralValue:(D,L,T)=>{if(r<L||(h(D,L,T,v(D)),r<=L+T))throw o},onSeparator:(D,L,T)=>{if(r<=L)throw o;if(D===":"&&a&&a.type==="property")a.colonOffset=L,s=!1,a=void 0;else if(D===","){const F=n[n.length-1];typeof F=="number"?n[n.length-1]=F+1:(s=!0,n[n.length-1]=""),a=void 0}}})}catch(D){if(D!==o)throw D}return{path:n,previousNode:a,isAtPropertyKey:s,matches:D=>{let L=0;for(let T=0;L<D.length&&T<n.length;T++)if(D[L]===n[T]||D[L]==="*")L++;else if(D[L]!=="**")return!1;return L===D.length}}}e.getLocation=S;function y(i,r=[],n=M.DEFAULT){let o=null,a=[];const c=[];function s(D){Array.isArray(a)?a.push(D):o!==null&&(a[o]=D)}return C(i,{onObjectBegin:()=>{const D={};s(D),c.push(a),a=D,o=null},onObjectProperty:D=>{o=D},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const D=[];s(D),c.push(a),a=D,o=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:s,onError:(D,L,T)=>{r.push({error:D,offset:L,length:T})}},n),a[0]}e.parse=y;function u(i,r=[],n=M.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(D){o.type==="property"&&(o.length=D-o.offset,o=o.parent)}function c(D){return o.children.push(D),D}C(i,{onObjectBegin:D=>{o=c({type:"object",offset:D,length:-1,parent:o,children:[]})},onObjectProperty:(D,L,T)=>{o=c({type:"property",offset:L,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:D,offset:L,length:T,parent:o})},onObjectEnd:(D,L)=>{o.length=D+L-o.offset,o=o.parent,a(D+L)},onArrayBegin:(D,L)=>{o=c({type:"array",offset:D,length:-1,parent:o,children:[]})},onArrayEnd:(D,L)=>{o.length=D+L-o.offset,o=o.parent,a(D+L)},onLiteralValue:(D,L,T)=>{c({type:v(D),offset:L,length:T,parent:o,value:D}),a(L+T)},onSeparator:(D,L,T)=>{o.type==="property"&&(D===":"?o.colonOffset=L:D===","&&a(L))},onError:(D,L,T)=>{r.push({error:D,offset:L,length:T})}},n);const h=o.children[0];return h&&delete h.parent,h}e.parseTree=u;function d(i,r){if(!i)return;let n=i;for(const o of r)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===o){n=c.children[1],a=!0;break}if(!a)return}else{const a=o;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}e.findNodeAtLocation=d;function p(i){if(!i.parent||!i.parent.children)return[];const r=p(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;r.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&r.push(n)}return r}e.getNodePath=p;function f(i){switch(i.type){case"array":return i.children.map(f);case"object":{const r=Object.create(null);for(const n of i.children){const o=n.children[1];o&&(r[n.children[0].value]=f(o))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=f;function l(i,r,n=!1){return r>=i.offset&&r<i.offset+i.length||n&&r===i.offset+i.length}e.contains=l;function w(i,r,n=!1){if(l(i,r,n)){const o=i.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=r;a++){const c=w(o[a],r,n);if(c)return c}return i}}e.findNodeAtOffset=w;function C(i,r,n=M.DEFAULT){const o=A(i,!1);function a(oe){return oe?()=>oe(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(oe){return oe?x=>oe(x,o.getTokenOffset(),o.getTokenLength()):()=>!0}const s=a(r.onObjectBegin),h=c(r.onObjectProperty),D=a(r.onObjectEnd),L=a(r.onArrayBegin),T=a(r.onArrayEnd),F=c(r.onLiteralValue),G=c(r.onSeparator),V=a(r.onComment),K=c(r.onError),_=n&&n.disallowComments,se=n&&n.allowTrailingComma;function ce(){for(;;){const oe=o.scan();switch(o.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:_||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(oe){case 12:case 13:_?X(10):V();break;case 16:X(1);break;case 15:case 14:break;default:return oe}}}function X(oe,x=[],R=[]){if(K(oe),x.length+R.length>0){let O=o.getToken();for(;O!==17;){if(x.indexOf(O)!==-1){ce();break}else if(R.indexOf(O)!==-1)break;O=ce()}}}function ue(oe){const x=o.getTokenValue();return oe?F(x):h(x),ce(),!0}function z(){switch(o.getToken()){case 11:{let oe=0;try{oe=JSON.parse(o.getTokenValue()),typeof oe!="number"&&(X(2),oe=0)}catch{X(2)}F(oe);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return ce(),!0}function N(){return o.getToken()!==10?(X(3,[],[2,5]),!1):(ue(!1),o.getToken()===6?(G(":"),ce(),Q()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function U(){s(),ce();let oe=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(oe||X(4,[],[]),G(","),ce(),o.getToken()===2&&se)break}else oe&&X(6,[],[]);N()||X(4,[],[2,5]),oe=!0}return D(),o.getToken()!==2?X(7,[2],[]):ce(),!0}function q(){L(),ce();let oe=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(oe||X(4,[],[]),G(","),ce(),o.getToken()===4&&se)break}else oe&&X(6,[],[]);Q()||X(4,[],[4,5]),oe=!0}return T(),o.getToken()!==4?X(8,[4],[]):ce(),!0}function Q(){switch(o.getToken()){case 3:return q();case 1:return U();case 10:return ue(!0);default:return z()}}return ce(),o.getToken()===17?n.allowEmptyContent?!0:(X(4,[],[]),!1):Q()?(o.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=C;function I(i,r){const n=A(i),o=[];let a,c=0,s;do switch(s=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:c!==s&&o.push(i.substring(c,s)),r!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,r)),c=n.getPosition();break}while(a!==17);return o.join("")}e.stripComments=I;function v(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(ie[123],re([0,1,43]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,b,S){let y,u,d,p,f;if(b){for(p=b.offset,f=p+b.length,d=p;d>0&&!g(m,d-1);)d--;let s=f;for(;s<m.length&&!g(m,s);)s++;u=m.substring(d,s),y=A(u,S)}else u=m,y=0,d=0,p=0,f=m.length;const l=P(S,m);let w=!1,C=0,I;S.insertSpaces?I=M(" ",S.tabSize||4):I="	";const v=(0,E.createScanner)(u,!1);let i=!1;function r(){return l+M(I,y+C)}function n(){let s=v.scan();for(w=!1;s===15||s===14;)w=w||s===14,s=v.scan();return i=s===16||v.getTokenError()!==0,s}const o=[];function a(s,h,D){!i&&h<f&&D>p&&m.substring(h,D)!==s&&o.push({offset:h,length:D-h,content:s})}let c=n();if(c!==17){const s=v.getTokenOffset()+d,h=M(I,y);a(h,d,s)}for(;c!==17;){let s=v.getTokenOffset()+v.getTokenLength()+d,h=n(),D="";for(;!w&&(h===12||h===13);){const T=v.getTokenOffset()+d;a(" ",s,T),s=v.getTokenOffset()+v.getTokenLength()+d,D=h===12?r():"",h=n()}if(h===2)c!==1&&(C--,D=r());else if(h===4)c!==3&&(C--,D=r());else{switch(c){case 3:case 1:C++,D=r();break;case 5:case 12:D=r();break;case 13:w?D=r():D=" ";break;case 6:D=" ";break;case 10:if(h===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?D=" ":h!==5&&h!==17&&(i=!0);break;case 16:i=!0;break}w&&(h===12||h===13)&&(D=r())}const L=v.getTokenOffset()+d;a(D,s,L),c=h}return o}e.format=t;function k(m,b){const S=JSON.stringify(m,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?S.replace(/\r\n|\r|\n/g,b.eol):S}e.toFormattedString=k;function M(m,b){let S="";for(let y=0;y<b;y++)S+=m;return S}function A(m,b){let S=0,y=0;const u=b.tabSize||4;for(;S<m.length;){const d=m.charAt(S);if(d===" ")y++;else if(d==="	")y+=u;else break;S++}return Math.floor(y/u)}function P(m,b){for(let S=0;S<b.length;S++){const y=b.charAt(S);if(y==="\r")return S+1<b.length&&b.charAt(S+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=P;function g(m,b){return`\r
`.indexOf(m.charAt(b))!==-1}e.isEOL=g}),define(ie[124],re([0,1,43,123]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,b,S){return M(m,b,void 0,S)}e.removeProperty=k;function M(m,b,S,y,u){const d=b.slice(),p=[],f=(0,E.parseTree)(m,p);let l,w;for(;d.length>0&&(w=d.pop(),l=(0,E.findNodeAtLocation)(f,d),l===void 0&&S!==void 0);)typeof w=="string"?S={[w]:S}:S=[S];if(l)if(l.type==="object"&&typeof w=="string"&&Array.isArray(l.children)){const C=(0,E.findNodeAtLocation)(l,[w]);if(C!==void 0)if(S===void 0){if(!C.parent)throw new Error("Malformed AST");const I=l.children.indexOf(C.parent);let v,i=C.parent.offset+C.parent.length;if(I>0){const r=l.children[I-1];v=r.offset+r.length}else v=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return A(m,{offset:v,length:i-v,content:""},y)}else return A(m,{offset:C.offset,length:C.length,content:JSON.stringify(S)},y);else{if(S===void 0)return[];const I=`${JSON.stringify(w)}: ${JSON.stringify(S)}`,v=u?u(l.children.map(r=>r.children[0].value)):l.children.length;let i;if(v>0){const r=l.children[v-1];i={offset:r.offset+r.length,length:0,content:","+I}}else l.children.length===0?i={offset:l.offset+1,length:0,content:I}:i={offset:l.offset+1,length:0,content:I+","};return A(m,i,y)}}else if(l.type==="array"&&typeof w=="number"&&Array.isArray(l.children))if(S!==void 0){const C=`${JSON.stringify(S)}`;let I;if(l.children.length===0||w===0)I={offset:l.offset+1,length:0,content:l.children.length===0?C:C+","};else{const v=w===-1||w>l.children.length?l.children.length:w,i=l.children[v-1];I={offset:i.offset+i.length,length:0,content:","+C}}return A(m,I,y)}else{const C=w,I=l.children[C];let v;if(l.children.length===1)v={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===C){const i=l.children[C-1],r=i.offset+i.length,n=l.offset+l.length;v={offset:r,length:n-2-r,content:""}}else v={offset:I.offset,length:l.children[C+1].offset-I.offset,content:""};return A(m,v,y)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${l.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return A(m,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(S)},y)}}e.setProperty=M;function A(m,b,S){let y=P(m,b),u=b.offset,d=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;u>0&&!(0,t.isEOL)(y,u-1);)u--;for(;d<y.length&&!(0,t.isEOL)(y,d);)d++}const p=(0,t.format)(y,{offset:u,length:d-u},S);for(let l=p.length-1;l>=0;l--){const w=p[l];y=P(y,w),u=Math.min(u,w.offset),d=Math.max(d,w.offset+w.length),d+=w.content.length-w.length}const f=m.length-(y.length-d)-u;return[{offset:u,length:f,content:y.substring(u,d)}]}e.withFormatting=A;function P(m,b){return m.substring(0,b.offset)+b.content+m.substring(b.offset+b.length)}e.applyEdit=P;function g(m,b){const S=b.slice(0).sort((u,d)=>{const p=u.offset-d.offset;return p===0?u.length-d.length:p});let y=m.length;for(let u=S.length-1;u>=0;u--){const d=S[u];if(d.offset+d.length<=y)m=P(m,d);else throw new Error("Overlapping edit");y=d.offset}return m}e.applyEdits=g}),define(ie[125],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(k){this.d=k,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(k){return new E(()=>k(this.getValue()))}}e.Lazy=E}),define(ie[2],re([0,1,50,67]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let M=null;function A(c){M=c}if(e.setDisposableTracker=A,k){const c="__is_disposable_tracked__";A(new class{trackDisposable(s){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[c]||console.log(h)},3e3)}setParent(s,h){if(s&&s!==w.None)try{s[c]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[c]=!0}catch{}}markAsSingleton(s){}})}function P(c){return M?.trackDisposable(c),c}function g(c){M?.markAsDisposed(c)}function m(c,s){M?.setParent(c,s)}function b(c,s){if(!!M)for(const h of c)M.setParent(h,s)}function S(c){return M?.markAsSingleton(c),c}e.markAsSingleton=S;function y(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=y;function u(c){if(t.Iterable.is(c)){const s=[];for(const h of c)if(h)try{h.dispose()}catch(D){s.push(D)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=u;function d(c){for(const s of c)y(s)&&s.dispose();return[]}e.disposeIfDisposable=d;function p(...c){const s=f(()=>u(c));return b(c,s),s}e.combinedDisposable=p;function f(c){const s=P({dispose:(0,E.once)(()=>{g(s),c()})});return s}e.toDisposable=f;class l{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(g(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{u(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return m(s,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this.q=new l,P(this),m(this.q,this)}dispose(){g(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class C{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&m(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&m(s,null),s}}e.MutableDisposable=C;class I{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=I;class v{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(s){let h=s;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,g(this))},this}}e.SafeDisposable=v;class i{constructor(){this.a=new Map}acquire(s,...h){let D=this.a.get(s);D||(D={counter:0,object:this.b(s,...h)},this.a.set(s,D));const{object:L}=D,T=(0,E.once)(()=>{--D.counter===0&&(this.c(s,D.object),this.a.delete(s))});return D.counter++,{object:L,dispose:T}}}e.ReferenceCollection=i;class r{constructor(s){this.a=s}async acquire(s,...h){const D=this.a.acquire(s,...h);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(L){throw D.dispose(),L}}}e.AsyncReferenceCollection=r;class n{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=n;function o(c){const s=new l;try{c(s)}finally{s.dispose()}}e.disposeOnReturn=o;class a{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,h,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(s)?.dispose(),this.a.set(s,h)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=a}),define(ie[96],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(M){this.element=M,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class t{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let M=this.a;for(;M!==E.Undefined;){const A=M.next;M.prev=E.Undefined,M.next=E.Undefined,M=A}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,A){const P=new E(M);if(this.a===E.Undefined)this.a=P,this.b=P;else if(A){const m=this.b;this.b=P,P.prev=m,m.next=P}else{const m=this.a;this.a=P,P.next=m,m.prev=P}this.c+=1;let g=!1;return()=>{g||(g=!0,this.e(P))}}shift(){if(this.a!==E.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==E.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==E.Undefined&&M.next!==E.Undefined){const A=M.prev;A.next=M.next,M.next.prev=A}else M.prev===E.Undefined&&M.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):M.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):M.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==E.Undefined;)yield M.element,M=M.next}}e.LinkedList=t}),define(ie[39],re([0,1]),function(H,e){"use strict";var E,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(d,p,f){let l=d.get(p);return l===void 0&&(l=f,d.set(p,l)),l}e.getOrSet=M;function A(d){const p=[];return d.forEach((f,l)=>{p.push(`${l} => ${f}`)}),`Map(${d.size}) {${p.join(", ")}}`}e.mapToString=A;function P(d){const p=[];return d.forEach(f=>{p.push(f)}),`Set(${d.size}) {${p.join(", ")}}`}e.setToString=P;class g{constructor(p,f){this.uri=p,this.value=f}}class m{constructor(p,f){this[E]="ResourceMap",p instanceof m?(this.b=new Map(p.b),this.c=f??m.a):(this.b=new Map,this.c=p??m.a)}set(p,f){return this.b.set(this.c(p),new g(p,f)),this}get(p){return this.b.get(this.c(p))?.value}has(p){return this.b.has(this.c(p))}get size(){return this.b.size}clear(){this.b.clear()}delete(p){return this.b.delete(this.c(p))}forEach(p,f){typeof f<"u"&&(p=p.bind(f));for(const[l,w]of this.b)p(w.value,w.uri,this)}*values(){for(const p of this.b.values())yield p.value}*keys(){for(const p of this.b.values())yield p.uri}*entries(){for(const p of this.b.values())yield[p.uri,p.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.b)yield[p.uri,p.value]}}e.ResourceMap=m,m.a=d=>d.toString();class b{constructor(p,f){this[t]="ResourceSet",!p||typeof p=="function"?this.a=new m(p):(this.a=new m(f),p.forEach(this.add,this))}get size(){return this.a.size}add(p){return this.a.set(p,p),this}clear(){this.a.clear()}delete(p){return this.a.delete(p)}forEach(p,f){this.a.forEach((l,w)=>p.call(f,w,w,this))}has(p){return this.a.has(p)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var S;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class y{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(p){return this.a.has(p)}get(p,f=0){const l=this.a.get(p);if(!!l)return f!==0&&this.j(l,f),l.value}set(p,f,l=0){let w=this.a.get(p);if(w)w.value=f,l!==0&&this.j(w,l);else{switch(w={key:p,value:f,next:void 0,previous:void 0},l){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(p,w),this.d++}return this}delete(p){return!!this.remove(p)}remove(p){const f=this.a.get(p);if(!!f)return this.a.delete(p),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const p=this.b;return this.a.delete(p.key),this.i(p),this.d--,p.value}forEach(p,f){const l=this.e;let w=this.b;for(;w;){if(f?p.bind(f)(w.value,w.key,this):p(w.value,w.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const p=this,f=this.e;let l=this.b;const w={[Symbol.iterator](){return w},next(){if(p.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const C={value:l.key,done:!1};return l=l.next,C}else return{value:void 0,done:!0}}};return w}values(){const p=this,f=this.e;let l=this.b;const w={[Symbol.iterator](){return w},next(){if(p.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const C={value:l.value,done:!1};return l=l.next,C}else return{value:void 0,done:!0}}};return w}entries(){const p=this,f=this.e;let l=this.b;const w={[Symbol.iterator](){return w},next(){if(p.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const C={value:[l.key,l.value],done:!1};return l=l.next,C}else return{value:void 0,done:!0}}};return w}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(p){if(p>=this.size)return;if(p===0){this.clear();return}let f=this.b,l=this.size;for(;f&&l>p;)this.a.delete(f.key),f=f.next,l--;this.b=f,this.d=l,f&&(f.previous=void 0),this.e++}g(p){if(!this.b&&!this.c)this.c=p;else if(this.b)p.next=this.b,this.b.previous=p;else throw new Error("Invalid list");this.b=p,this.e++}h(p){if(!this.b&&!this.c)this.b=p;else if(this.c)p.previous=this.c,this.c.next=p;else throw new Error("Invalid list");this.c=p,this.e++}i(p){if(p===this.b&&p===this.c)this.b=void 0,this.c=void 0;else if(p===this.b){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this.b=p.next}else if(p===this.c){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this.c=p.previous}else{const f=p.next,l=p.previous;if(!f||!l)throw new Error("Invalid list");f.previous=l,l.next=f}p.next=void 0,p.previous=void 0,this.e++}j(p,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(p===this.b)return;const l=p.next,w=p.previous;p===this.c?(w.next=void 0,this.c=w):(l.previous=w,w.next=l),p.previous=void 0,p.next=this.b,this.b.previous=p,this.b=p,this.e++}else if(f===2){if(p===this.c)return;const l=p.next,w=p.previous;p===this.b?(l.previous=void 0,this.b=l):(l.previous=w,w.next=l),p.next=void 0,p.previous=this.c,this.c.next=p,this.c=p,this.e++}}}toJSON(){const p=[];return this.forEach((f,l)=>{p.push([l,f])}),p}fromJSON(p){this.clear();for(const[f,l]of p)this.set(f,l)}}e.LinkedMap=y;class u extends y{constructor(p,f=1){super(),this.k=p,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(p){this.k=p,this.m()}get ratio(){return this.l}set ratio(p){this.l=Math.min(Math.max(0,p),1),this.m()}get(p,f=2){return super.get(p,f)}peek(p){return super.get(p,0)}set(p,f){return super.set(p,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=u}),define(ie[77],re([0,1,39]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new E.LRUCache(1e4);function k(m){return g(m,"NFC",t)}e.normalizeNFC=k;const M=new E.LRUCache(1e4);function A(m){return g(m,"NFD",M)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function g(m,b,S){if(!m)return m;const y=S.get(m);if(y)return y;let u;return P.test(m)?u=m.normalize(b):u=m,S.set(m,u),u}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(b){return A(b).replace(m,"")}}()}),define(ie[126],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(P,g,m){return Math.min(Math.max(P,g),m)}e.clamp=E;function t(P,g){return(g+P%g)%g}e.rot=t;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class M{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class A{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const m=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=A}),function(){function H(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function A(g){M.push(g,Date.now())}function P(){const g=[];for(let m=0;m<M.length;m+=2)g.push({name:M[m],startTime:M[m+1]});return g}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(k+A.startTime)});return M}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function E(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=E(t))}(),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var t in E)(typeof exports=="object"?exports:H)[t]=E[t]}}(typeof self<"u"?self:this,function(){return function(H){var e={};function E(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return H[t].call(k.exports,k,k.exports,E),k.l=!0,k.exports}return E.m=H,E.c=e,E.d=function(t,k,M){E.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:M})},E.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},E.t=function(t,k){if(1&k&&(t=E(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var A in t)E.d(M,A,function(P){return t[P]}.bind(null,A));return M},E.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return E.d(k,"a",k),k},E.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},E.p="",E(E.s=0)}([function(H,e,E){(function(t){var k;e=H.exports=R,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ne=Array.prototype.slice.call(arguments,0);ne.unshift("SEMVER"),console.log.apply(console,ne)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],g=e.src=[],m=0,b=m++;g[b]="0|[1-9]\\d*";var S=m++;g[S]="[0-9]+";var y=m++;g[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=m++;g[u]="("+g[b]+")\\.("+g[b]+")\\.("+g[b]+")";var d=m++;g[d]="("+g[S]+")\\.("+g[S]+")\\.("+g[S]+")";var p=m++;g[p]="(?:"+g[b]+"|"+g[y]+")";var f=m++;g[f]="(?:"+g[S]+"|"+g[y]+")";var l=m++;g[l]="(?:-("+g[p]+"(?:\\."+g[p]+")*))";var w=m++;g[w]="(?:-?("+g[f]+"(?:\\."+g[f]+")*))";var C=m++;g[C]="[0-9A-Za-z-]+";var I=m++;g[I]="(?:\\+("+g[C]+"(?:\\."+g[C]+")*))";var v=m++,i="v?"+g[u]+g[l]+"?"+g[I]+"?";g[v]="^"+i+"$";var r="[v=\\s]*"+g[d]+g[w]+"?"+g[I]+"?",n=m++;g[n]="^"+r+"$";var o=m++;g[o]="((?:<|>)?=?)";var a=m++;g[a]=g[S]+"|x|X|\\*";var c=m++;g[c]=g[b]+"|x|X|\\*";var s=m++;g[s]="[v=\\s]*("+g[c]+")(?:\\.("+g[c]+")(?:\\.("+g[c]+")(?:"+g[l]+")?"+g[I]+"?)?)?";var h=m++;g[h]="[v=\\s]*("+g[a]+")(?:\\.("+g[a]+")(?:\\.("+g[a]+")(?:"+g[w]+")?"+g[I]+"?)?)?";var D=m++;g[D]="^"+g[o]+"\\s*"+g[s]+"$";var L=m++;g[L]="^"+g[o]+"\\s*"+g[h]+"$";var T=m++;g[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=m++;g[F]="(?:~>?)";var G=m++;g[G]="(\\s*)"+g[F]+"\\s+",P[G]=new RegExp(g[G],"g");var V=m++;g[V]="^"+g[F]+g[s]+"$";var K=m++;g[K]="^"+g[F]+g[h]+"$";var _=m++;g[_]="(?:\\^)";var se=m++;g[se]="(\\s*)"+g[_]+"\\s+",P[se]=new RegExp(g[se],"g");var ce=m++;g[ce]="^"+g[_]+g[s]+"$";var X=m++;g[X]="^"+g[_]+g[h]+"$";var ue=m++;g[ue]="^"+g[o]+"\\s*("+r+")$|^$";var z=m++;g[z]="^"+g[o]+"\\s*("+i+")$|^$";var N=m++;g[N]="(\\s*)"+g[o]+"\\s*("+r+"|"+g[s]+")",P[N]=new RegExp(g[N],"g");var U=m++;g[U]="^\\s*("+g[s]+")\\s+-\\s+("+g[s]+")\\s*$";var q=m++;g[q]="^\\s*("+g[h]+")\\s+-\\s+("+g[h]+")\\s*$";var Q=m++;g[Q]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)k(oe,g[oe]),P[oe]||(P[oe]=new RegExp(g[oe]));function x(ne,fe){if(ne instanceof R)return ne;if(typeof ne!="string"||ne.length>M||!(fe?P[n]:P[v]).test(ne))return null;try{return new R(ne,fe)}catch{return null}}function R(ne,fe){if(ne instanceof R){if(ne.loose===fe)return ne;ne=ne.version}else if(typeof ne!="string")throw new TypeError("Invalid Version: "+ne);if(ne.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof R))return new R(ne,fe);k("SemVer",ne,fe),this.loose=fe;var de=ne.trim().match(fe?P[n]:P[v]);if(!de)throw new TypeError("Invalid Version: "+ne);if(this.raw=ne,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Pe=+be;if(Pe>=0&&Pe<A)return Pe}return be}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=x,e.valid=function(ne,fe){var de=x(ne,fe);return de?de.version:null},e.clean=function(ne,fe){var de=x(ne.trim().replace(/^[=v]+/,""),fe);return de?de.version:null},e.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(ne){return k("SemVer.compare",this.version,this.loose,ne),ne instanceof R||(ne=new R(ne,this.loose)),this.compareMain(ne)||this.comparePre(ne)},R.prototype.compareMain=function(ne){return ne instanceof R||(ne=new R(ne,this.loose)),W(this.major,ne.major)||W(this.minor,ne.minor)||W(this.patch,ne.patch)},R.prototype.comparePre=function(ne){if(ne instanceof R||(ne=new R(ne,this.loose)),this.prerelease.length&&!ne.prerelease.length)return-1;if(!this.prerelease.length&&ne.prerelease.length)return 1;if(!this.prerelease.length&&!ne.prerelease.length)return 0;var fe=0;do{var de=this.prerelease[fe],be=ne.prerelease[fe];if(k("prerelease compare",fe,de,be),de===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(de===void 0)return-1;if(de!==be)return W(de,be)}while(++fe)},R.prototype.inc=function(ne,fe){switch(ne){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ne)}return this.format(),this.raw=this.version,this},e.inc=function(ne,fe,de,be){typeof de=="string"&&(be=de,de=void 0);try{return new R(ne,de).inc(fe,be).version}catch{return null}},e.diff=function(ne,fe){if(B(ne,fe))return null;var de=x(ne),be=x(fe);if(de.prerelease.length||be.prerelease.length){for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==be[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==be[Pe])return Pe},e.compareIdentifiers=W;var O=/^[0-9]+$/;function W(ne,fe){var de=O.test(ne),be=O.test(fe);return de&&be&&(ne=+ne,fe=+fe),de&&!be?-1:be&&!de?1:ne<fe?-1:ne>fe?1:0}function j(ne,fe,de){return new R(ne,de).compare(new R(fe,de))}function $(ne,fe,de){return j(ne,fe,de)>0}function Y(ne,fe,de){return j(ne,fe,de)<0}function B(ne,fe,de){return j(ne,fe,de)===0}function Z(ne,fe,de){return j(ne,fe,de)!==0}function te(ne,fe,de){return j(ne,fe,de)>=0}function ae(ne,fe,de){return j(ne,fe,de)<=0}function ge(ne,fe,de,be){var Pe;switch(fe){case"===":typeof ne=="object"&&(ne=ne.version),typeof de=="object"&&(de=de.version),Pe=ne===de;break;case"!==":typeof ne=="object"&&(ne=ne.version),typeof de=="object"&&(de=de.version),Pe=ne!==de;break;case"":case"=":case"==":Pe=B(ne,de,be);break;case"!=":Pe=Z(ne,de,be);break;case">":Pe=$(ne,de,be);break;case">=":Pe=te(ne,de,be);break;case"<":Pe=Y(ne,de,be);break;case"<=":Pe=ae(ne,de,be);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function ke(ne,fe){if(ne instanceof ke){if(ne.loose===fe)return ne;ne=ne.value}if(!(this instanceof ke))return new ke(ne,fe);k("comparator",ne,fe),this.loose=fe,this.parse(ne),this.semver===Oe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ne,fe){return W(fe,ne)},e.major=function(ne,fe){return new R(ne,fe).major},e.minor=function(ne,fe){return new R(ne,fe).minor},e.patch=function(ne,fe){return new R(ne,fe).patch},e.compare=j,e.compareLoose=function(ne,fe){return j(ne,fe,!0)},e.rcompare=function(ne,fe,de){return j(fe,ne,de)},e.sort=function(ne,fe){return ne.sort(function(de,be){return e.compare(de,be,fe)})},e.rsort=function(ne,fe){return ne.sort(function(de,be){return e.rcompare(de,be,fe)})},e.gt=$,e.lt=Y,e.eq=B,e.neq=Z,e.gte=te,e.lte=ae,e.cmp=ge,e.Comparator=ke;var Oe={};function De(ne,fe){if(ne instanceof De)return ne.loose===fe?ne:new De(ne.raw,fe);if(ne instanceof ke)return new De(ne.value,fe);if(!(this instanceof De))return new De(ne,fe);if(this.loose=fe,this.raw=ne,this.set=ne.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ne);this.format()}function Me(ne){return!ne||ne.toLowerCase()==="x"||ne==="*"}function ve(ne,fe,de,be,Pe,We,Te,qe,Ue,je,Xe,$e,Ke){return((fe=Me(de)?"":Me(be)?">="+de+".0.0":Me(Pe)?">="+de+"."+be+".0":">="+fe)+" "+(qe=Me(Ue)?"":Me(je)?"<"+(+Ue+1)+".0.0":Me(Xe)?"<"+Ue+"."+(+je+1)+".0":$e?"<="+Ue+"."+je+"."+Xe+"-"+$e:"<="+qe)).trim()}function we(ne,fe){for(var de=0;de<ne.length;de++)if(!ne[de].test(fe))return!1;if(fe.prerelease.length){for(de=0;de<ne.length;de++)if(k(ne[de].semver),ne[de].semver!==Oe&&ne[de].semver.prerelease.length>0){var be=ne[de].semver;if(be.major===fe.major&&be.minor===fe.minor&&be.patch===fe.patch)return!0}return!1}return!0}function ye(ne,fe,de){try{fe=new De(fe,de)}catch{return!1}return fe.test(ne)}function Re(ne,fe,de,be){var Pe,We,Te,qe,Ue;switch(ne=new R(ne,be),fe=new De(fe,be),de){case">":Pe=$,We=ae,Te=Y,qe=">",Ue=">=";break;case"<":Pe=Y,We=te,Te=$,qe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(ne,fe,be))return!1;for(var je=0;je<fe.set.length;++je){var Xe=fe.set[je],$e=null,Ke=null;if(Xe.forEach(function(J){J.semver===Oe&&(J=new ke(">=0.0.0")),$e=$e||J,Ke=Ke||J,Pe(J.semver,$e.semver,be)?$e=J:Te(J.semver,Ke.semver,be)&&(Ke=J)}),$e.operator===qe||$e.operator===Ue||(!Ke.operator||Ke.operator===qe)&&We(ne,Ke.semver)||Ke.operator===Ue&&Te(ne,Ke.semver))return!1}return!0}ke.prototype.parse=function(ne){var fe=this.loose?P[ue]:P[z],de=ne.match(fe);if(!de)throw new TypeError("Invalid comparator: "+ne);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new R(de[2],this.loose):this.semver=Oe},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(ne){return k("Comparator.test",ne,this.loose),this.semver===Oe||(typeof ne=="string"&&(ne=new R(ne,this.loose)),ge(ne,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(ne,fe){if(!(ne instanceof ke))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new De(ne.value,fe),ye(this.value,de,fe);if(ne.operator==="")return de=new De(this.value,fe),ye(ne.semver,de,fe);var be=!(this.operator!==">="&&this.operator!==">"||ne.operator!==">="&&ne.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ne.operator!=="<="&&ne.operator!=="<"),We=this.semver.version===ne.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ne.operator!==">="&&ne.operator!=="<="),qe=ge(this.semver,"<",ne.semver,fe)&&(this.operator===">="||this.operator===">")&&(ne.operator==="<="||ne.operator==="<"),Ue=ge(this.semver,">",ne.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ne.operator===">="||ne.operator===">");return be||Pe||We&&Te||qe||Ue},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(ne){return ne.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(ne){var fe=this.loose;ne=ne.trim(),k("range",ne,fe);var de=fe?P[q]:P[U];ne=ne.replace(de,ve),k("hyphen replace",ne),ne=ne.replace(P[N],"$1$2$3"),k("comparator trim",ne,P[N]),ne=(ne=(ne=ne.replace(P[G],"$1~")).replace(P[se],"$1^")).split(/\s+/).join(" ");var be=fe?P[ue]:P[z],Pe=ne.split(" ").map(function(We){return function(Te,qe){return k("comp",Te),Te=function(Ue,je){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){k("caret",$e,Ke);var J=Ke?P[X]:P[ce];return $e.replace(J,function(le,he,me,Se,Le){var Be;return k("caret",$e,le,he,me,Se,Le),Me(he)?Be="":Me(me)?Be=">="+he+".0.0 <"+(+he+1)+".0.0":Me(Se)?Be=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Le?(k("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Be=he==="0"?me==="0"?">="+he+"."+me+"."+Se+Le+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+Le+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+Le+" <"+(+he+1)+".0.0"):(k("no pr"),Be=he==="0"?me==="0"?">="+he+"."+me+"."+Se+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+" <"+(+he+1)+".0.0"),k("caret return",Be),Be})}(Xe,je)}).join(" ")}(Te,qe),k("caret",Te),Te=function(Ue,je){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){var J=Ke?P[K]:P[V];return $e.replace(J,function(le,he,me,Se,Le){var Be;return k("tilde",$e,le,he,me,Se,Le),Me(he)?Be="":Me(me)?Be=">="+he+".0.0 <"+(+he+1)+".0.0":Me(Se)?Be=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Le?(k("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Be=">="+he+"."+me+"."+Se+Le+" <"+he+"."+(+me+1)+".0"):Be=">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0",k("tilde return",Be),Be})}(Xe,je)}).join(" ")}(Te,qe),k("tildes",Te),Te=function(Ue,je){return k("replaceXRanges",Ue,je),Ue.split(/\s+/).map(function(Xe){return function($e,Ke){$e=$e.trim();var J=Ke?P[L]:P[D];return $e.replace(J,function(le,he,me,Se,Le,Be){k("xRange",$e,le,he,me,Se,Le,Be);var it=Me(me),xe=it||Me(Se),He=xe||Me(Le);return he==="="&&He&&(he=""),it?le=he===">"||he==="<"?"<0.0.0":"*":he&&He?(xe&&(Se=0),He&&(Le=0),he===">"?(he=">=",xe?(me=+me+1,Se=0,Le=0):He&&(Se=+Se+1,Le=0)):he==="<="&&(he="<",xe?me=+me+1:Se=+Se+1),le=he+me+"."+Se+"."+Le):xe?le=">="+me+".0.0 <"+(+me+1)+".0.0":He&&(le=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),k("xRange return",le),le})}(Xe,je)}).join(" ")}(Te,qe),k("xrange",Te),Te=function(Ue,je){return k("replaceStars",Ue,je),Ue.trim().replace(P[Q],"")}(Te,qe),k("stars",Te),Te}(We,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(We){return!!We.match(be)})),Pe=Pe.map(function(We){return new ke(We,fe)})},De.prototype.intersects=function(ne,fe){if(!(ne instanceof De))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(be){return ne.set.some(function(Pe){return Pe.every(function(We){return be.intersects(We,fe)})})})})},e.toComparators=function(ne,fe){return new De(ne,fe).set.map(function(de){return de.map(function(be){return be.value}).join(" ").trim().split(" ")})},De.prototype.test=function(ne){if(!ne)return!1;typeof ne=="string"&&(ne=new R(ne,this.loose));for(var fe=0;fe<this.set.length;fe++)if(we(this.set[fe],ne))return!0;return!1},e.satisfies=ye,e.maxSatisfying=function(ne,fe,de){var be=null,Pe=null;try{var We=new De(fe,de)}catch{return null}return ne.forEach(function(Te){We.test(Te)&&(be&&Pe.compare(Te)!==-1||(Pe=new R(be=Te,de)))}),be},e.minSatisfying=function(ne,fe,de){var be=null,Pe=null;try{var We=new De(fe,de)}catch{return null}return ne.forEach(function(Te){We.test(Te)&&(be&&Pe.compare(Te)!==1||(Pe=new R(be=Te,de)))}),be},e.validRange=function(ne,fe){try{return new De(ne,fe).range||"*"}catch{return null}},e.ltr=function(ne,fe,de){return Re(ne,fe,"<",de)},e.gtr=function(ne,fe,de){return Re(ne,fe,">",de)},e.outside=Re,e.prerelease=function(ne,fe){var de=x(ne,fe);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(ne,fe,de){return ne=new De(ne,de),fe=new De(fe,de),ne.intersects(fe)},e.coerce=function(ne){if(ne instanceof R)return ne;if(typeof ne!="string")return null;var fe=ne.match(P[T]);return fe==null?null:x((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,E(1))},function(H,e){var E,t,k=H.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(f){if(E===setTimeout)return setTimeout(f,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(f,0);try{return E(f,0)}catch{try{return E.call(null,f,0)}catch{return E.call(this,f,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var g,m=[],b=!1,S=-1;function y(){b&&g&&(b=!1,g.length?m=g.concat(m):S=-1,m.length&&u())}function u(){if(!b){var f=P(y);b=!0;for(var l=m.length;l;){for(g=m,m=[];++S<l;)g&&g[S].run();S=-1,l=m.length}g=null,b=!1,function(w){if(t===clearTimeout)return clearTimeout(w);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(w);try{t(w)}catch{try{return t.call(null,w)}catch{return t.call(this,w)}}}(f)}}function d(f,l){this.fun=f,this.array=l}function p(){}k.nextTick=function(f){var l=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)l[w-1]=arguments[w];m.push(new d(f,l)),m.length!==1||b||P(u)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=p,k.addListener=p,k.once=p,k.off=p,k.removeListener=p,k.removeAllListeners=p,k.emit=p,k.prependListener=p,k.prependOnceListener=p,k.listeners=function(f){return[]},k.binding=function(f){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(f){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ie[127],re([0,1]),function(H,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(P,g,m){this.level=P,this.key=g,this.value=m,this.forward=[]}}const k=void 0;class M{constructor(P,g=2**16){this.comparator=P,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new t(this.c,k,k)}get size(){return this.f}clear(){this.e=new t(this.c,k,k)}has(P){return Boolean(M.g(this,P,this.comparator))}get(P){return M.g(this,P,this.comparator)?.value}set(P,g){return M.h(this,P,g,this.comparator)&&(this.f+=1),this}delete(P){const g=M.k(this,P,this.comparator);return g&&(this.f-=1),g}forEach(P,g){let m=this.e.forward[0];for(;m;)P.call(g,m.value,m.key,this),m=m.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",g=this.e.forward[0];for(;g;)P+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return P}static g(P,g,m){let b=P.e;for(let S=P.d-1;S>=0;S--)for(;b.forward[S]&&m(b.forward[S].key,g)<0;)b=b.forward[S];if(b=b.forward[0],b&&m(b.key,g)===0)return b}static h(P,g,m,b){const S=[];let y=P.e;for(let u=P.d-1;u>=0;u--){for(;y.forward[u]&&b(y.forward[u].key,g)<0;)y=y.forward[u];S[u]=y}if(y=y.forward[0],y&&b(y.key,g)===0)return y.value=m,!1;{const u=M.j(P);if(u>P.d){for(let d=P.d;d<u;d++)S[d]=P.e;P.d=u}y=new t(u,g,m);for(let d=0;d<u;d++)y.forward[d]=S[d].forward[d],S[d].forward[d]=y;return!0}}static j(P,g=.5){let m=1;for(;Math.random()<g&&m<P.c;)m+=1;return m}static k(P,g,m){const b=[];let S=P.e;for(let y=P.d-1;y>=0;y--){for(;S.forward[y]&&m(S.forward[y].key,g)<0;)S=S.forward[y];b[y]=S}if(S=S.forward[0],!S||m(S.key,g)!==0)return!1;for(let y=0;y<P.d&&b[y].forward[y]===S;y++)b[y].forward[y]=S.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===k;)P.d-=1;return!0}}e.SkipList=M}),define(ie[59],re([0,1,13,2]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(I){const v=I;return v?typeof v.read=="function":!1}e.isReadable=k;function M(I){const v=I;return v?[v.on,v.pause,v.resume,v.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=M;function A(I){const v=I;return v?M(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(I,v){return new g(I,v)}e.newWriteableStream=P;class g{constructor(v,i){this.e=v,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(i=>i(v))}h(v){this.c.error.length===0?(0,E.onUnexpectedError)(v):this.c.error.slice(0).forEach(i=>i(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,i){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(v,i){if(this.a.destroyed)return;let r;switch(v){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const n=r.indexOf(i);n>=0&&r.splice(n,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(I,v){const i=[];let r;for(;(r=I.read())!==null;)i.push(r);return v(i)}e.consumeReadable=m;function b(I,v,i){const r=[];let n;for(;(n=I.read())!==null&&r.length<i;)r.push(n);return n===null&&r.length>0?v(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const o=n;return n=void 0,o}return I.read()}}}e.peekReadable=b;function S(I,v){return new Promise((i,r)=>{const n=[];y(I,{onData:o=>{v&&n.push(o)},onError:o=>{v?r(o):i(void 0)},onEnd:()=>{i(v?v(n):void 0)}})})}e.consumeStream=S;function y(I,v){let i=!1;return I.on("error",r=>{i||v.onError(r)}),I.on("end",()=>{i||v.onEnd()}),I.on("data",r=>{i||v.onData(r)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=y;function u(I,v){return new Promise((i,r)=>{const n=new t.DisposableStore,o=[],a=h=>{if(o.push(h),o.length>v)return n.dispose(),I.pause(),i({stream:I,buffer:o,ended:!1})},c=h=>r(h),s=()=>i({stream:I,buffer:o,ended:!0});n.add((0,t.toDisposable)(()=>I.removeListener("error",c))),I.on("error",c),n.add((0,t.toDisposable)(()=>I.removeListener("end",s))),I.on("end",s),n.add((0,t.toDisposable)(()=>I.removeListener("data",a))),I.on("data",a)})}e.peekStream=u;function d(I,v){const i=P(v);return i.end(I),i}e.toStream=d;function p(){const I=P(()=>{throw new Error("not supported")});return I.end(),I}e.emptyStream=p;function f(I){let v=!1;return{read:()=>v?null:(v=!0,I)}}e.toReadable=f;function l(I,v,i){const r=P(i);return y(I,{onData:n=>r.write(v.data(n)),onError:n=>r.error(v.error?v.error(n):n),onEnd:()=>r.end()}),r}e.transform=l;function w(I,v,i){let r=!1;return{read:()=>{const n=v.read();return r?n:(r=!0,n!==null?i([I,n]):I)}}}e.prefixedReadable=w;function C(I,v,i){let r=!1;const n=P(i);return y(v,{onData:o=>r?n.write(o):(r=!0,n.write(i([I,o]))),onError:o=>n.error(o),onEnd:()=>{r||(r=!0,n.write(I)),n.end()}}),n}e.prefixedStream=C}),define(ie[17],re([0,1,59]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,M;class A{static alloc(h){return t?new A(Buffer.allocUnsafe(h)):new A(new Uint8Array(h))}static wrap(h){return t&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new A(h)}static fromString(h,D){return!(D?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(h)):(k||(k=new TextEncoder),new A(k.encode(h)))}static fromByteArray(h){const D=A.alloc(h.length);for(let L=0,T=h.length;L<T;L++)D.buffer[L]=h[L];return D}static concat(h,D){if(typeof D>"u"){D=0;for(let F=0,G=h.length;F<G;F++)D+=h[F].byteLength}const L=A.alloc(D);let T=0;for(let F=0,G=h.length;F<G;F++){const V=h[F];L.set(V,T),T+=V.byteLength}return L}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=A.alloc(this.byteLength);return h.set(this),h}toString(){return t?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(h,D){return new A(this.buffer.subarray(h,D))}set(h,D){if(h instanceof A)this.buffer.set(h.buffer,D);else if(h instanceof Uint8Array)this.buffer.set(h,D);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),D);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return m(this.buffer,h)}writeUInt32BE(h,D){b(this.buffer,h,D)}readUInt32LE(h){return S(this.buffer,h)}writeUInt32LE(h,D){y(this.buffer,h,D)}readUInt8(h){return u(this.buffer,h)}writeUInt8(h,D){d(this.buffer,h,D)}}e.VSBuffer=A;function P(s,h){return s[h+0]<<0>>>0|s[h+1]<<8>>>0}e.readUInt16LE=P;function g(s,h,D){s[D+0]=h&255,h=h>>>8,s[D+1]=h&255}e.writeUInt16LE=g;function m(s,h){return s[h]*2**24+s[h+1]*2**16+s[h+2]*2**8+s[h+3]}e.readUInt32BE=m;function b(s,h,D){s[D+3]=h,h=h>>>8,s[D+2]=h,h=h>>>8,s[D+1]=h,h=h>>>8,s[D]=h}e.writeUInt32BE=b;function S(s,h){return s[h+0]<<0>>>0|s[h+1]<<8>>>0|s[h+2]<<16>>>0|s[h+3]<<24>>>0}e.readUInt32LE=S;function y(s,h,D){s[D+0]=h&255,h=h>>>8,s[D+1]=h&255,h=h>>>8,s[D+2]=h&255,h=h>>>8,s[D+3]=h&255}e.writeUInt32LE=y;function u(s,h){return s[h]}e.readUInt8=u;function d(s,h,D){s[D]=h}e.writeUInt8=d;function p(s){return E.consumeReadable(s,h=>A.concat(h))}e.readableToBuffer=p;function f(s){return E.toReadable(s)}e.bufferToReadable=f;function l(s){return E.consumeStream(s,h=>A.concat(h))}e.streamToBuffer=l;async function w(s){return s.ended?A.concat(s.buffer):A.concat([...s.buffer,await l(s.stream)])}e.bufferedStreamToBuffer=w;function C(s){return E.toStream(s,h=>A.concat(h))}e.bufferToStream=C;function I(s){return E.transform(s,{data:h=>typeof h=="string"?A.fromString(h):A.wrap(h)},h=>A.concat(h))}e.streamToBufferReadableStream=I;function v(s){return E.newWriteableStream(h=>A.concat(h),s)}e.newWriteableBufferStream=v;function i(s,h){return E.prefixedReadable(s,h,D=>A.concat(D))}e.prefixedBufferReadable=i;function r(s,h){return E.prefixedStream(s,h,D=>A.concat(D))}e.prefixedBufferStream=r;function n(s){let h=0,D=0,L=0;const T=new Uint8Array(Math.floor(s.length/4*3)),F=V=>{switch(D){case 3:T[L++]=h|V,D=0;break;case 2:T[L++]=h|V>>>2,h=V<<6,D=3;break;case 1:T[L++]=h|V>>>4,h=V<<4,D=2;break;default:h=V<<2,D=1}};for(let V=0;V<s.length;V++){const K=s.charCodeAt(V);if(K>=65&&K<=90)F(K-65);else if(K>=97&&K<=122)F(K-97+26);else if(K>=48&&K<=57)F(K-48+52);else if(K===43||K===45)F(62);else if(K===47||K===95)F(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${s[V]}`)}}const G=L;for(;D>0;)F(0);return A.wrap(T).slice(0,G)}e.decodeBase64=n;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:s},h=!0,D=!1){const L=D?a:o;let T="";const F=s.byteLength%3;let G=0;for(;G<s.byteLength-F;G+=3){const V=s[G+0],K=s[G+1],_=s[G+2];T+=L[V>>>2],T+=L[(V<<4|K>>>4)&63],T+=L[(K<<2|_>>>6)&63],T+=L[_&63]}if(F===1){const V=s[G+0];T+=L[V>>>2],T+=L[V<<4&63],h&&(T+="==")}else if(F===2){const V=s[G+0],K=s[G+1];T+=L[V>>>2],T+=L[(V<<4|K>>>4)&63],T+=L[K<<2&63],h&&(T+="=")}return T}e.encodeBase64=c}),define(ie[11],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(r){return typeof r=="string"}e.isString=E;function t(r){return Array.isArray(r)&&r.every(n=>E(n))}e.isStringArray=t;function k(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=k;function M(r){const n=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof n}e.isTypedArray=M;function A(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=A;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function g(r){return r===!0||r===!1}e.isBoolean=g;function m(r){return typeof r>"u"}e.isUndefined=m;function b(r){return!S(r)}e.isDefined=b;function S(r){return m(r)||r===null}e.isUndefinedOrNull=S;function y(r,n){if(!r)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=y;function u(r){if(S(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=u;function d(...r){const n=[];for(let o=0;o<r.length;o++){const a=r[o];if(S(a))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);n.push(a)}return n}e.assertAllDefined=d;const p=Object.prototype.hasOwnProperty;function f(r){if(!k(r))return!1;for(const n in r)if(p.call(r,n))return!1;return!0}e.isEmptyObject=f;function l(r){return typeof r=="function"}e.isFunction=l;function w(...r){return r.length>0&&r.every(l)}e.areFunctions=w;function C(r,n){const o=Math.min(r.length,n.length);for(let a=0;a<o;a++)I(r[a],n[a])}e.validateConstraints=C;function I(r,n){if(E(n)){if(typeof r!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(l(n)){try{if(r instanceof n)return}catch{}if(!S(r)&&r.constructor===n||n.length===1&&n.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=I;function v(r){return r===null?void 0:r}e.withNullAsUndefined=v;function i(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=i}),define(ie[44],re([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const w=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([C,I])=>{w[C]=I&&typeof I=="object"?t(I):I}),w}e.deepClone=t;function k(l){if(!l||typeof l!="object")return l;const w=[l];for(;w.length>0;){const C=w.shift();Object.freeze(C);for(const I in C)if(M.call(C,I)){const v=C[I];typeof v=="object"&&!Object.isFrozen(v)&&!(0,E.isTypedArray)(v)&&w.push(v)}}return l}e.deepFreeze=k;const M=Object.prototype.hasOwnProperty;function A(l,w){return P(l,w,new Set)}e.cloneAndChange=A;function P(l,w,C){if((0,E.isUndefinedOrNull)(l))return l;const I=w(l);if(typeof I<"u")return I;if(Array.isArray(l)){const v=[];for(const i of l)v.push(P(i,w,C));return v}if((0,E.isObject)(l)){if(C.has(l))throw new Error("Cannot clone recursive data-structure");C.add(l);const v={};for(const i in l)M.call(l,i)&&(v[i]=P(l[i],w,C));return C.delete(l),v}return l}function g(l,w,C=!0){return(0,E.isObject)(l)?((0,E.isObject)(w)&&Object.keys(w).forEach(I=>{I in l?C&&((0,E.isObject)(l[I])&&(0,E.isObject)(w[I])?g(l[I],w[I],C):l[I]=w[I]):l[I]=w[I]}),l):w}e.mixin=g;function m(l,w){if(l===w)return!0;if(l==null||w===null||w===void 0||typeof l!=typeof w||typeof l!="object"||Array.isArray(l)!==Array.isArray(w))return!1;let C,I;if(Array.isArray(l)){if(l.length!==w.length)return!1;for(C=0;C<l.length;C++)if(!m(l[C],w[C]))return!1}else{const v=[];for(I in l)v.push(I);v.sort();const i=[];for(I in w)i.push(I);if(i.sort(),!m(v,i))return!1;for(C=0;C<v.length;C++)if(!m(l[v[C]],w[v[C]]))return!1}return!0}e.equals=m;function b(l){const w=new Set;return JSON.stringify(l,(C,I)=>{if((0,E.isObject)(I)||Array.isArray(I)){if(w.has(I))return"[Circular]";w.add(I)}return I})}e.safeStringify=b;function S(l,w){const C=Object.create(null);return!l||!w||Object.keys(w).forEach(v=>{const i=l[v],r=w[v];m(i,r)||(C[v]=r)}),C}e.distinct=S;function y(l,w){const C=w.toLowerCase(),I=Object.keys(l).find(v=>v.toLowerCase()===C);return I?l[I]:l[w]}e.getCaseInsensitive=y;function u(l,w){const C=Object.create(null);for(const[I,v]of Object.entries(l))w(I,v)&&(C[I]=v);return C}e.filter=u;function d(l){let w=[],C=Object.getPrototypeOf(l);for(;Object.prototype!==C;)w=w.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return w}e.getAllPropertyNames=d;function p(l){const w=[];for(const C of d(l))typeof l[C]=="function"&&w.push(C);return w}e.getAllMethodNames=p;function f(l,w){const C=v=>function(){const i=Array.prototype.slice.call(arguments,0);return w(v,i)},I={};for(const v of l)I[v]=C(v);return I}e.createProxyObject=f}),define(ie[30],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return E.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(P){for(let g=0;g<P.length;g++)P[g]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){k(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let g=0,m="";return m+=A[M[g++]],m+=A[M[g++]],m+=A[M[g++]],m+=A[M[g++]],m+="-",m+=A[M[g++]],m+=A[M[g++]],m+="-",m+=A[M[g++]],m+=A[M[g++]],m+="-",m+=A[M[g++]],m+=A[M[g++]],m+="-",m+=A[M[g++]],m+=A[M[g++]],m+=A[M[g++]],m+=A[M[g++]],m+=A[M[g++]],m+=A[M[g++]],m}}()}),define(ie[128],re([0,1,78,40,50]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(A,P){if(await new Promise((b,S)=>{const y=t.createReadStream(A),u=E.createHash("sha1");y.pipe(u);const d=(0,k.once)((p,f)=>{y.removeAllListeners(),u.removeAllListeners(),p?S(p):b(f)});y.once("error",d),y.once("end",d),u.once("error",d),u.once("data",p=>d(void 0,p.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=M}),define(ie[129],re([0,1,25]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const P=A.replace(/\-/g,":").toLowerCase();return!t.has(P)}function M(){const A=(0,E.networkInterfaces)();for(const P in A){const g=A[P];if(g){for(const{mac:m}of g)if(k(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=M}),define(ie[97],re([0,1,79]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(P,g,m,b=1){let S=!1;return new Promise(y=>{const u=setTimeout(()=>{if(!S)return S=!0,y(0)},m);k(P,g,b,d=>{if(!S)return S=!0,clearTimeout(u),y(d)})})}e.findFreePort=t;function k(P,g,m,b){if(g===0)return b(0);const S=new E.Socket;S.once("connect",()=>(A(S),k(P+m,g-1,m,b))),S.once("data",()=>{}),S.once("error",y=>(A(S),y.code!=="ECONNREFUSED"?k(P+m,g-1,m,b):b(P))),S.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(P,g,m,b="127.0.0.1"){let S=!1,y,u=1;const d=E.createServer({pauseOnConnect:!0});function p(f,l){S||(S=!0,d.removeAllListeners(),d.close(),y&&clearTimeout(y),l(f))}return new Promise(f=>{y=setTimeout(()=>{p(0,f)},m),d.on("listening",()=>{p(P,f)}),d.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&u<g?(P++,u++,d.listen(P,b)):p(0,f)}),d.on("close",()=>{p(0,f)}),d.listen(P,b)})}e.findFreePortFaster=M;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(g){console.error(g)}}}),define(ie[130],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ie[131],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(k,M){this.a=k,this.onMessage=M}send(k){try{this.a.send("vscode:message",k.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=E}),define(ie[41],re([0,1,14,13]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.a=new WeakMap}on(A,P){const g=(m,...b)=>{this.b(A,m)&&P(m,...b)};return this.a.set(P,g),E.ipcMain.on(A,g),this}once(A,P){return E.ipcMain.once(A,(g,...m)=>{this.b(A,g)&&P(g,...m)}),this}handle(A,P){return E.ipcMain.handle(A,(g,...m)=>this.b(A,g)?P(g,...m):Promise.reject(`Invalid channel '${A}' or sender for ipcMain.handle() usage.`)),this}removeHandler(A){return E.ipcMain.removeHandler(A),this}removeListener(A,P){const g=this.a.get(P);return g&&(E.ipcMain.removeListener(A,g),this.a.delete(P)),this}b(A,P){if(!A||!A.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because the channel is unknown.`),!1;const g=P.senderFrame,m=g.url;if(!m)return!0;let b="unknown";try{b=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a malformed URL '${m}'.`),!1}return b!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a bad origin of '${b}'.`),!1):g.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(ie[132],re([0,1,14,41,11,130]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function A(){t.validatedIpcMain.on(M.CONTEXT_MENU_CHANNEL,(g,m,b,S,y)=>{const u=P(g,S,b);u.popup({window:(0,k.withNullAsUndefined)(E.BrowserWindow.fromWebContents(g.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{u&&g.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=A;function P(g,m,b){const S=new E.Menu;return b.forEach(y=>{let u;y.type==="separator"?u=new E.MenuItem({type:y.type}):Array.isArray(y.submenu)?u=new E.MenuItem({submenu:P(g,m,y.submenu),label:y.label}):u=new E.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(d,p,f)=>g.sender.send(m,y.id,f)}),S.append(u)}),S}}),define(ie[133],re([12,10]),function(H,e){return H.create("vs/base/common/date",e)}),define(ie[134],re([0,1,133]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,M=k*24,A=M*7,P=M*30,g=M*365;function m(S,y,u){typeof S!="number"&&(S=S.getTime());const d=Math.round((new Date().getTime()-S)/1e3);if(d<-30)return(0,E.localize)(0,null,m(new Date().getTime()+d*1e3,!1));if(d<30)return(0,E.localize)(1,null);let p;return d<t?(p=d,y?p===1?u?(0,E.localize)(2,null,p):(0,E.localize)(3,null,p):u?(0,E.localize)(4,null,p):(0,E.localize)(5,null,p):p===1?u?(0,E.localize)(6,null,p):(0,E.localize)(7,null,p):u?(0,E.localize)(8,null,p):(0,E.localize)(9,null,p)):d<k?(p=Math.floor(d/t),y?p===1?u?(0,E.localize)(10,null,p):(0,E.localize)(11,null,p):u?(0,E.localize)(12,null,p):(0,E.localize)(13,null,p):p===1?u?(0,E.localize)(14,null,p):(0,E.localize)(15,null,p):u?(0,E.localize)(16,null,p):(0,E.localize)(17,null,p)):d<M?(p=Math.floor(d/k),y?p===1?u?(0,E.localize)(18,null,p):(0,E.localize)(19,null,p):u?(0,E.localize)(20,null,p):(0,E.localize)(21,null,p):p===1?u?(0,E.localize)(22,null,p):(0,E.localize)(23,null,p):u?(0,E.localize)(24,null,p):(0,E.localize)(25,null,p)):d<A?(p=Math.floor(d/M),y?p===1?(0,E.localize)(26,null,p):(0,E.localize)(27,null,p):p===1?(0,E.localize)(28,null,p):(0,E.localize)(29,null,p)):d<P?(p=Math.floor(d/A),y?p===1?u?(0,E.localize)(30,null,p):(0,E.localize)(31,null,p):u?(0,E.localize)(32,null,p):(0,E.localize)(33,null,p):p===1?u?(0,E.localize)(34,null,p):(0,E.localize)(35,null,p):u?(0,E.localize)(36,null,p):(0,E.localize)(37,null,p)):d<g?(p=Math.floor(d/P),y?p===1?u?(0,E.localize)(38,null,p):(0,E.localize)(39,null,p):u?(0,E.localize)(40,null,p):(0,E.localize)(41,null,p):p===1?u?(0,E.localize)(42,null,p):(0,E.localize)(43,null,p):u?(0,E.localize)(44,null,p):(0,E.localize)(45,null,p)):(p=Math.floor(d/g),y?p===1?u?(0,E.localize)(46,null,p):(0,E.localize)(47,null,p):u?(0,E.localize)(48,null,p):(0,E.localize)(49,null,p):p===1?u?(0,E.localize)(50,null,p):(0,E.localize)(51,null,p):u?(0,E.localize)(52,null,p):(0,E.localize)(53,null,p))}e.fromNow=m;function b(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ie[135],re([12,10]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(ie[45],re([0,1,24,11,135]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(S,y){return y&&(S.stack||S.stacktrace)?k.localize(0,null,P(S),A(S.stack)||A(S.stacktrace)):P(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function P(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?k.localize(1,null,S.message):S.message||k.localize(2,null)}function g(S=null,y=!1){if(!S)return k.localize(3,null);if(Array.isArray(S)){const u=E.coalesce(S),d=g(u[0],y);return u.length>1?k.localize(4,null,d,u.length):d}if(t.isString(S))return S;if(S.detail){const u=S.detail;if(u.error)return M(u.error,y);if(u.exception)return M(u.exception,y)}return S.stack?M(S,y):S.message?S.message:k.localize(5,null)}e.toErrorMessage=g;function m(S){const y=S;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=m;function b(S,y){let u;return typeof S=="string"?u=new Error(S):u=S,u.actions=y,u}e.createErrorWithActions=b}),define(ie[136],re([12,10]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(ie[137],re([0,1,136]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ie[138],re([12,10]),function(H,e){return H.create("vs/base/common/platform",e)}),define(ie[4],re([0,1,138]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,M=!1,A=!1,P=!1,g=!1,m=!1,b=!1,S=!1,y=!1,u,d=e.LANGUAGE_DEFAULT,p,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const w=typeof l?.versions?.electron=="string",C=w&&l?.type==="renderer";if(typeof navigator=="object"&&!C)f=navigator.userAgent,t=f.indexOf("Windows")>=0,k=f.indexOf("Macintosh")>=0,b=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=f.indexOf("Linux")>=0,y=f?.indexOf("Mobi")>=0,g=!0,u=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,d=u;else if(typeof l=="object"){t=l.platform==="win32",k=l.platform==="darwin",M=l.platform==="linux",A=M&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,m=w,S=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const s=l.env.VSCODE_NLS_CONFIG;if(s)try{const h=JSON.parse(s),D=h.availableLanguages["*"];u=h.locale,d=D||e.LANGUAGE_DEFAULT,p=h._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var I;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function v(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let i=0;k?i=1:t?i=3:M&&(i=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=M,e.isLinuxSnap=A,e.isNative=P,e.isElectron=m,e.isWeb=g,e.isWebWorker=g&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=y,e.isCI=S,e.platform=i,e.userAgent=f,e.language=d;var r;(function(s){function h(){return e.language}s.value=h;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=D;function L(){return e.language==="en"}s.isDefault=L})(r=e.Language||(e.Language={})),e.locale=u,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let L=0,T=s.length;L<T;L++){const F=s[L];if(F.id===D.data.vscodeScheduleAsyncWork){s.splice(L,1),F.callback();return}}});let h=0;return D=>{const L=++h;s.push({id:L,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return s=>setTimeout(s)})();var n;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||b?2:t?1:3;let o=!0,a=!1;function c(){if(!a){a=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,o=new Uint16Array(s.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ie[33],re([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const k=E.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ie[9],re([0,1,33]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,M=90,A=122,P=46,g=47,m=92,b=58,S=63;class y extends Error{constructor(r,n,o){let a;typeof n=="string"&&n.indexOf("not ")===0?(a="must not be",n=n.replace(/^not /,"")):a="must be";const c=r.indexOf(".")!==-1?"property":"argument";let s=`The "${r}" ${c} ${a} of type ${n}`;s+=`. Received type ${typeof o}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function u(i,r){if(i===null||typeof i!="object")throw new y(r,"Object",i)}function d(i,r){if(typeof i!="string")throw new y(r,"string",i)}const p=E.platform==="win32";function f(i){return i===g||i===m}function l(i){return i===g}function w(i){return i>=t&&i<=M||i>=k&&i<=A}function C(i,r,n,o){let a="",c=0,s=-1,h=0,D=0;for(let L=0;L<=i.length;++L){if(L<i.length)D=i.charCodeAt(L);else{if(o(D))break;D=g}if(o(D)){if(!(s===L-1||h===1))if(h===2){if(a.length<2||c!==2||a.charCodeAt(a.length-1)!==P||a.charCodeAt(a.length-2)!==P){if(a.length>2){const T=a.lastIndexOf(n);T===-1?(a="",c=0):(a=a.slice(0,T),c=a.length-1-a.lastIndexOf(n)),s=L,h=0;continue}else if(a.length!==0){a="",c=0,s=L,h=0;continue}}r&&(a+=a.length>0?`${n}..`:"..",c=2)}else a.length>0?a+=`${n}${i.slice(s+1,L)}`:a=i.slice(s+1,L),c=L-s-1;s=L,h=0}else D===P&&h!==-1?++h:h=-1}return a}function I(i,r){u(r,"pathObject");const n=r.dir||r.root,o=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${o}`:`${n}${i}${o}`:o}e.win32={resolve(...i){let r="",n="",o=!1;for(let a=i.length-1;a>=-1;a--){let c;if(a>=0){if(c=i[a],d(c,"path"),c.length===0)continue}else r.length===0?c=E.cwd():(c=E.env[`=${r}`]||E.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==r.toLowerCase()&&c.charCodeAt(2)===m)&&(c=`${r}\\`));const s=c.length;let h=0,D="",L=!1;const T=c.charCodeAt(0);if(s===1)f(T)&&(h=1,L=!0);else if(f(T))if(L=!0,f(c.charCodeAt(1))){let F=2,G=F;for(;F<s&&!f(c.charCodeAt(F));)F++;if(F<s&&F!==G){const V=c.slice(G,F);for(G=F;F<s&&f(c.charCodeAt(F));)F++;if(F<s&&F!==G){for(G=F;F<s&&!f(c.charCodeAt(F));)F++;(F===s||F!==G)&&(D=`\\\\${V}\\${c.slice(G,F)}`,h=F)}}}else h=1;else w(T)&&c.charCodeAt(1)===b&&(D=c.slice(0,2),h=2,s>2&&f(c.charCodeAt(2))&&(L=!0,h=3));if(D.length>0)if(r.length>0){if(D.toLowerCase()!==r.toLowerCase())continue}else r=D;if(o){if(r.length>0)break}else if(n=`${c.slice(h)}\\${n}`,o=L,L&&r.length>0)break}return n=C(n,!o,"\\",f),o?`${r}\\${n}`:`${r}${n}`||"."},normalize(i){d(i,"path");const r=i.length;if(r===0)return".";let n=0,o,a=!1;const c=i.charCodeAt(0);if(r===1)return l(c)?"\\":i;if(f(c))if(a=!0,f(i.charCodeAt(1))){let h=2,D=h;for(;h<r&&!f(i.charCodeAt(h));)h++;if(h<r&&h!==D){const L=i.slice(D,h);for(D=h;h<r&&f(i.charCodeAt(h));)h++;if(h<r&&h!==D){for(D=h;h<r&&!f(i.charCodeAt(h));)h++;if(h===r)return`\\\\${L}\\${i.slice(D)}\\`;h!==D&&(o=`\\\\${L}\\${i.slice(D,h)}`,n=h)}}}else n=1;else w(c)&&i.charCodeAt(1)===b&&(o=i.slice(0,2),n=2,r>2&&f(i.charCodeAt(2))&&(a=!0,n=3));let s=n<r?C(i.slice(n),!a,"\\",f):"";return s.length===0&&!a&&(s="."),s.length>0&&f(i.charCodeAt(r-1))&&(s+="\\"),o===void 0?a?`\\${s}`:s:a?`${o}\\${s}`:`${o}${s}`},isAbsolute(i){d(i,"path");const r=i.length;if(r===0)return!1;const n=i.charCodeAt(0);return f(n)||r>2&&w(n)&&i.charCodeAt(1)===b&&f(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,n;for(let c=0;c<i.length;++c){const s=i[c];d(s,"path"),s.length>0&&(r===void 0?r=n=s:r+=`\\${s}`)}if(r===void 0)return".";let o=!0,a=0;if(typeof n=="string"&&f(n.charCodeAt(0))){++a;const c=n.length;c>1&&f(n.charCodeAt(1))&&(++a,c>2&&(f(n.charCodeAt(2))?++a:o=!1))}if(o){for(;a<r.length&&f(r.charCodeAt(a));)a++;a>=2&&(r=`\\${r.slice(a)}`)}return e.win32.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r)return"";const n=e.win32.resolve(i),o=e.win32.resolve(r);if(n===o||(i=n.toLowerCase(),r=o.toLowerCase(),i===r))return"";let a=0;for(;a<i.length&&i.charCodeAt(a)===m;)a++;let c=i.length;for(;c-1>a&&i.charCodeAt(c-1)===m;)c--;const s=c-a;let h=0;for(;h<r.length&&r.charCodeAt(h)===m;)h++;let D=r.length;for(;D-1>h&&r.charCodeAt(D-1)===m;)D--;const L=D-h,T=s<L?s:L;let F=-1,G=0;for(;G<T;G++){const K=i.charCodeAt(a+G);if(K!==r.charCodeAt(h+G))break;K===m&&(F=G)}if(G!==T){if(F===-1)return o}else{if(L>T){if(r.charCodeAt(h+G)===m)return o.slice(h+G+1);if(G===2)return o.slice(h+G)}s>T&&(i.charCodeAt(a+G)===m?F=G:G===2&&(F=3)),F===-1&&(F=0)}let V="";for(G=a+F+1;G<=c;++G)(G===c||i.charCodeAt(G)===m)&&(V+=V.length===0?"..":"\\..");return h+=F,V.length>0?`${V}${o.slice(h,D)}`:(o.charCodeAt(h)===m&&++h,o.slice(h,D))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const r=e.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===m){if(r.charCodeAt(1)===m){const n=r.charCodeAt(2);if(n!==S&&n!==P)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(w(r.charCodeAt(0))&&r.charCodeAt(1)===b&&r.charCodeAt(2)===m)return`\\\\?\\${r}`;return i},dirname(i){d(i,"path");const r=i.length;if(r===0)return".";let n=-1,o=0;const a=i.charCodeAt(0);if(r===1)return f(a)?i:".";if(f(a)){if(n=o=1,f(i.charCodeAt(1))){let h=2,D=h;for(;h<r&&!f(i.charCodeAt(h));)h++;if(h<r&&h!==D){for(D=h;h<r&&f(i.charCodeAt(h));)h++;if(h<r&&h!==D){for(D=h;h<r&&!f(i.charCodeAt(h));)h++;if(h===r)return i;h!==D&&(n=o=h+1)}}}}else w(a)&&i.charCodeAt(1)===b&&(n=r>2&&f(i.charCodeAt(2))?3:2,o=n);let c=-1,s=!0;for(let h=r-1;h>=o;--h)if(f(i.charCodeAt(h))){if(!s){c=h;break}}else s=!1;if(c===-1){if(n===-1)return".";c=n}return i.slice(0,c)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let n=0,o=-1,a=!0,c;if(i.length>=2&&w(i.charCodeAt(0))&&i.charCodeAt(1)===b&&(n=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let s=r.length-1,h=-1;for(c=i.length-1;c>=n;--c){const D=i.charCodeAt(c);if(f(D)){if(!a){n=c+1;break}}else h===-1&&(a=!1,h=c+1),s>=0&&(D===r.charCodeAt(s)?--s===-1&&(o=c):(s=-1,o=h))}return n===o?o=h:o===-1&&(o=i.length),i.slice(n,o)}for(c=i.length-1;c>=n;--c)if(f(i.charCodeAt(c))){if(!a){n=c+1;break}}else o===-1&&(a=!1,o=c+1);return o===-1?"":i.slice(n,o)},extname(i){d(i,"path");let r=0,n=-1,o=0,a=-1,c=!0,s=0;i.length>=2&&i.charCodeAt(1)===b&&w(i.charCodeAt(0))&&(r=o=2);for(let h=i.length-1;h>=r;--h){const D=i.charCodeAt(h);if(f(D)){if(!c){o=h+1;break}continue}a===-1&&(c=!1,a=h+1),D===P?n===-1?n=h:s!==1&&(s=1):n!==-1&&(s=-1)}return n===-1||a===-1||s===0||s===1&&n===a-1&&n===o+1?"":i.slice(n,a)},format:I.bind(null,"\\"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const n=i.length;let o=0,a=i.charCodeAt(0);if(n===1)return f(a)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(f(a)){if(o=1,f(i.charCodeAt(1))){let F=2,G=F;for(;F<n&&!f(i.charCodeAt(F));)F++;if(F<n&&F!==G){for(G=F;F<n&&f(i.charCodeAt(F));)F++;if(F<n&&F!==G){for(G=F;F<n&&!f(i.charCodeAt(F));)F++;F===n?o=F:F!==G&&(o=F+1)}}}}else if(w(a)&&i.charCodeAt(1)===b){if(n<=2)return r.root=r.dir=i,r;if(o=2,f(i.charCodeAt(2))){if(n===3)return r.root=r.dir=i,r;o=3}}o>0&&(r.root=i.slice(0,o));let c=-1,s=o,h=-1,D=!0,L=i.length-1,T=0;for(;L>=o;--L){if(a=i.charCodeAt(L),f(a)){if(!D){s=L+1;break}continue}h===-1&&(D=!1,h=L+1),a===P?c===-1?c=L:T!==1&&(T=1):c!==-1&&(T=-1)}return h!==-1&&(c===-1||T===0||T===1&&c===h-1&&c===s+1?r.base=r.name=i.slice(s,h):(r.name=i.slice(s,c),r.base=i.slice(s,h),r.ext=i.slice(c,h))),s>0&&s!==o?r.dir=i.slice(0,s-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const v=(()=>{if(p){const i=/\\/g;return()=>{const r=E.cwd().replace(i,"/");return r.slice(r.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...i){let r="",n=!1;for(let o=i.length-1;o>=-1&&!n;o--){const a=o>=0?i[o]:v();d(a,"path"),a.length!==0&&(r=`${a}/${r}`,n=a.charCodeAt(0)===g)}return r=C(r,!n,"/",l),n?`/${r}`:r.length>0?r:"."},normalize(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===g,n=i.charCodeAt(i.length-1)===g;return i=C(i,!r,"/",l),i.length===0?r?"/":n?"./":".":(n&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return d(i,"path"),i.length>0&&i.charCodeAt(0)===g},join(...i){if(i.length===0)return".";let r;for(let n=0;n<i.length;++n){const o=i[n];d(o,"path"),o.length>0&&(r===void 0?r=o:r+=`/${o}`)}return r===void 0?".":e.posix.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r||(i=e.posix.resolve(i),r=e.posix.resolve(r),i===r))return"";const n=1,o=i.length,a=o-n,c=1,s=r.length-c,h=a<s?a:s;let D=-1,L=0;for(;L<h;L++){const F=i.charCodeAt(n+L);if(F!==r.charCodeAt(c+L))break;F===g&&(D=L)}if(L===h)if(s>h){if(r.charCodeAt(c+L)===g)return r.slice(c+L+1);if(L===0)return r.slice(c+L)}else a>h&&(i.charCodeAt(n+L)===g?D=L:L===0&&(D=0));let T="";for(L=n+D+1;L<=o;++L)(L===o||i.charCodeAt(L)===g)&&(T+=T.length===0?"..":"/..");return`${T}${r.slice(c+D)}`},toNamespacedPath(i){return i},dirname(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===g;let n=-1,o=!0;for(let a=i.length-1;a>=1;--a)if(i.charCodeAt(a)===g){if(!o){n=a;break}}else o=!1;return n===-1?r?"/":".":r&&n===1?"//":i.slice(0,n)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let n=0,o=-1,a=!0,c;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let s=r.length-1,h=-1;for(c=i.length-1;c>=0;--c){const D=i.charCodeAt(c);if(D===g){if(!a){n=c+1;break}}else h===-1&&(a=!1,h=c+1),s>=0&&(D===r.charCodeAt(s)?--s===-1&&(o=c):(s=-1,o=h))}return n===o?o=h:o===-1&&(o=i.length),i.slice(n,o)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===g){if(!a){n=c+1;break}}else o===-1&&(a=!1,o=c+1);return o===-1?"":i.slice(n,o)},extname(i){d(i,"path");let r=-1,n=0,o=-1,a=!0,c=0;for(let s=i.length-1;s>=0;--s){const h=i.charCodeAt(s);if(h===g){if(!a){n=s+1;break}continue}o===-1&&(a=!1,o=s+1),h===P?r===-1?r=s:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||o===-1||c===0||c===1&&r===o-1&&r===n+1?"":i.slice(r,o)},format:I.bind(null,"/"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const n=i.charCodeAt(0)===g;let o;n?(r.root="/",o=1):o=0;let a=-1,c=0,s=-1,h=!0,D=i.length-1,L=0;for(;D>=o;--D){const T=i.charCodeAt(D);if(T===g){if(!h){c=D+1;break}continue}s===-1&&(h=!1,s=D+1),T===P?a===-1?a=D:L!==1&&(L=1):a!==-1&&(L=-1)}if(s!==-1){const T=c===0&&n?1:c;a===-1||L===0||L===1&&a===s-1&&a===c+1?r.base=r.name=i.slice(T,s):(r.name=i.slice(T,a),r.base=i.slice(T,s),r.ext=i.slice(a,s))}return c>0?r.dir=i.slice(0,c-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(ie[80],re([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function M(P,...g){const m=g.reduce((y,u)=>(y[u]=!0,y),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!m[y]).forEach(y=>{for(let u=0;u<b.length;u++)if(y.search(b[u])!==-1){delete P[y];break}})}e.sanitizeProcessEnvironment=M;function A(P){!P||(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ie[81],re([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=E.globals.performance&&typeof E.globals.performance.now=="function";class k{static create(A=!0){return new k(A)}constructor(A){this.a=t&&A,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ie[3],re([0,1,13,50,2,96,81]),function(H,e,E,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,g=!1;var m;(function(c){c.None=()=>k.Disposable.None;function s(j){if(g){const{onDidAddListener:$}=j,Y=d.create();let B=0;j.onDidAddListener=()=>{++B===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),$?.()}}}function h(j,$){return se(j,()=>{},0,void 0,void 0,$)}c.defer=h;function D(j){return($,Y=null,B)=>{let Z=!1,te;return te=j(ae=>{if(!Z)return te?te.dispose():Z=!0,$.call(Y,ae)},null,B),Z&&te.dispose(),te}}c.once=D;function L(j,$,Y){return _((B,Z=null,te)=>j(ae=>B.call(Z,$(ae)),null,te),Y)}c.map=L;function T(j,$,Y){return _((B,Z=null,te)=>j(ae=>{$(ae),B.call(Z,ae)},null,te),Y)}c.forEach=T;function F(j,$,Y){return _((B,Z=null,te)=>j(ae=>$(ae)&&B.call(Z,ae),null,te),Y)}c.filter=F;function G(j){return j}c.signal=G;function V(...j){return($,Y=null,B)=>(0,k.combinedDisposable)(...j.map(Z=>Z(te=>$.call(Y,te),null,B)))}c.any=V;function K(j,$,Y,B){let Z=Y;return L(j,te=>(Z=$(Z,te),Z),B)}c.reduce=K;function _(j,$){let Y;const B={onWillAddFirstListener(){Y=j(Z.fire,Z)},onDidRemoveLastListener(){Y?.dispose()}};$||s(B);const Z=new f(B);return $?.add(Z),Z.event}function se(j,$,Y=100,B=!1,Z,te){let ae,ge,ke,Oe=0;const De={leakWarningThreshold:Z,onWillAddFirstListener(){ae=j(ve=>{Oe++,ge=$(ge,ve),B&&!ke&&(Me.fire(ge),ge=void 0),clearTimeout(ke),ke=setTimeout(()=>{const we=ge;ge=void 0,ke=void 0,(!B||Oe>1)&&Me.fire(we),Oe=0},Y)})},onDidRemoveLastListener(){ae.dispose()}};te||s(De);const Me=new f(De);return te?.add(Me),Me.event}c.debounce=se;function ce(j,$=0,Y){return c.debounce(j,(B,Z)=>B?(B.push(Z),B):[Z],$,void 0,void 0,Y)}c.accumulate=ce;function X(j,$=(B,Z)=>B===Z,Y){let B=!0,Z;return F(j,te=>{const ae=B||!$(te,Z);return B=!1,Z=te,ae},Y)}c.latch=X;function ue(j,$,Y){return[c.filter(j,$,Y),c.filter(j,B=>!$(B),Y)]}c.split=ue;function z(j,$=!1,Y=[]){let B=Y.slice(),Z=j(ge=>{B?B.push(ge):ae.fire(ge)});const te=()=>{B?.forEach(ge=>ae.fire(ge)),B=null},ae=new f({onWillAddFirstListener(){Z||(Z=j(ge=>ae.fire(ge)))},onDidAddFirstListener(){B&&($?setTimeout(te):te())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return ae.event}c.buffer=z;class N{constructor($){this.event=$,this.c=new k.DisposableStore}map($){return new N(L(this.event,$,this.c))}forEach($){return new N(T(this.event,$,this.c))}filter($){return new N(F(this.event,$,this.c))}reduce($,Y){return new N(K(this.event,$,Y,this.c))}latch(){return new N(X(this.event,void 0,this.c))}debounce($,Y=100,B=!1,Z){return new N(se(this.event,$,Y,B,Z,this.c))}on($,Y,B){return this.event($,Y,B)}once($,Y,B){return D(this.event)($,Y,B)}dispose(){this.c.dispose()}}function U(j){return new N(j)}c.chain=U;function q(j,$,Y=B=>B){const B=(...ge)=>ae.fire(Y(...ge)),Z=()=>j.on($,B),te=()=>j.removeListener($,B),ae=new f({onWillAddFirstListener:Z,onDidRemoveLastListener:te});return ae.event}c.fromNodeEventEmitter=q;function Q(j,$,Y=B=>B){const B=(...ge)=>ae.fire(Y(...ge)),Z=()=>j.addEventListener($,B),te=()=>j.removeEventListener($,B),ae=new f({onWillAddFirstListener:Z,onDidRemoveLastListener:te});return ae.event}c.fromDOMEventEmitter=Q;function oe(j){return new Promise($=>D(j)($))}c.toPromise=oe;function x(j,$){return $(void 0),j(Y=>$(Y))}c.runAndSubscribe=x;function R(j,$){let Y=null;function B(te){Y?.dispose(),Y=new k.DisposableStore,$(te,Y)}B(void 0);const Z=j(te=>B(te));return(0,k.toDisposable)(()=>{Z.dispose(),Y?.dispose()})}c.runAndSubscribeWithStore=R;class O{constructor($,Y){this.obs=$,this.c=0,this.d=!1;const B={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Y||s(B),this.emitter=new f(B),Y&&Y.add(this.emitter)}beginUpdate($){this.c++}handleChange($,Y){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(j,$){return new O(j,$).emitter.event}c.fromObservable=W})(m=e.Event||(e.Event={}));class b{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${b.c++}`,b.all.add(this)}start(s){this.d=new A.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=b,b.all=new Set,b.c=0;let S=-1;function y(c){const s=S;return S=c,{dispose(){S=s}}}e.setGlobalLeakWarningThreshold=y;class u{constructor(s,h=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=h,this.d=0}dispose(){this.c?.clear()}check(s,h){const D=this.threshold;if(D<=0||h<D)return;this.c||(this.c=new Map);const L=this.c.get(s.value)||0;if(this.c.set(s.value,L+1),this.d-=1,this.d<=0){this.d=D*.5;let T,F=0;for(const[G,V]of this.c)(!T||F<V)&&(T=G,F=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${F}):`),console.warn(T)}return()=>{const T=this.c.get(s.value)||0;this.c.set(s.value,T-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(s,h,D){this.callback=s,this.callbackThis=h,this.stack=D,this.subscription=new k.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class f{constructor(s){this.j=!1,this.d=s,this.f=S>0||this.d?.leakWarningThreshold?new u(this.d?.leakWarningThreshold??S):void 0,this.g=this.d?._profName?new b(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const s=Array.from(this.q);queueMicrotask(()=>{for(const h of s)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,h,D)=>{if(this.q||(this.q=new M.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const L=this.q.isEmpty();L&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,F;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(F=d.create(),T=this.f.check(F,this.q.size+1)),P&&(F=F??d.create());const G=new p(s,h,F),V=this.q.push(G);L&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,h);const K=G.subscription.set(()=>{T?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return D instanceof k.DisposableStore?D.add(K):Array.isArray(D)&&D.push(K),K}),this.l}fire(s){if(this.q){this.m||(this.m=new w);for(const h of this.q)this.m.push(this,h,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=f;class l{constructor(){this.c=new M.LinkedList}get size(){return this.c.size}push(s,h,D){this.c.push(new C(s,h,D))}clear(s){const h=new M.LinkedList;for(const D of this.c)D.emitter!==s&&h.push(D);this.c=h}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(h){(0,E.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=l;class w extends l{clear(s){this.c.clear()}}class C{constructor(s,h,D){this.emitter=s,this.listener=h,this.event=D}}class I extends f{async fireAsync(s,h,D){if(!!this.q){this.c||(this.c=new M.LinkedList);for(const L of this.q)this.c.push([L,s]);for(;this.c.size>0&&!h.isCancellationRequested;){const[L,T]=this.c.shift(),F=[],G={...T,token:h,waitUntil:V=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");D&&(V=D(V,L.callback)),F.push(V)}};try{L.invoke(G)}catch(V){(0,E.onUnexpectedError)(V);continue}Object.freeze(F),await Promise.allSettled(F).then(V=>{for(const K of V)K.status==="rejected"&&(0,E.onUnexpectedError)(K.reason)})}}}}e.AsyncEmitter=I;class v extends f{constructor(s){super(s),this.h=0,this.s=new M.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=v;class i extends v{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=i;class r extends f{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(h=>super.fire(h)),this.c=[]}))}}e.MicrotaskEmitter=r;class n{constructor(){this.d=!1,this.f=[],this.c=new f({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const h={event:s,listener:null};this.f.push(h),this.d&&this.j(h);const D=()=>{this.d&&this.k(h);const L=this.f.indexOf(h);this.f.splice(L,1)};return(0,k.toDisposable)((0,t.once)(D))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(h=>this.c.fire(h))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=n;class o{constructor(){this.c=[]}wrapEvent(s){return(h,D,L)=>s(T=>{const F=this.c[this.c.length-1];F?F.push(()=>h.call(D,T)):h.call(D,T)},void 0,L)}bufferEvents(s){const h=[];this.c.push(h);const D=s();return this.c.pop(),h.forEach(L=>L()),D}}e.EventBufferer=o;class a{constructor(){this.c=!1,this.d=m.None,this.f=k.Disposable.None,this.g=new f({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=a}),define(ie[22],re([0,1,3]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,g){const m=setTimeout(P.bind(g),0);return{dispose(){clearTimeout(m)}}});var k;(function(P){function g(m){return m===P.None||m===P.Cancelled||m instanceof M?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}P.isCancellationToken=g,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(g){this.a=void 0,this.b=void 0,this.b=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new M),this.a}cancel(){this.a?this.a instanceof M&&this.a.cancel():this.a=k.Cancelled}dispose(g=!1){g&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof M&&this.a.dispose():this.a=k.None}}e.CancellationTokenSource=A}),define(ie[139],re([0,1,22]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new E.CancellationTokenSource,g=this.b(P.token);return this.a={promise:g,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=t;class k{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const g=JSON.stringify(P);return this.b!==g&&(this.b=g,this.a=this.c(P)),this.a}}e.LRUCachedFunction=k;class M{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const g=this.b(P);return this.a.set(P,g),g}}e.CachedFunction=M}),define(ie[26],re([0,1,139,125]),function(H,e,E,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function M(J){return!J||typeof J!="string"?!0:J.trim().length===0}e.isFalsyOrWhitespace=M;const A=/{(\d+)}/g;function P(J,...le){return le.length===0?J:J.replace(A,function(he,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=le.length?he:le[Se]})}e.format=P;const g=/{([^}]+)}/g;function m(J,le){return J.replace(g,(he,me)=>le[me]??he)}e.format2=m;function b(J){return J.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=b;function S(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function y(J,le){let he=0;const me=le.charCodeAt(0);for(let Se=J.length-1;Se>=0;Se--)J.charCodeAt(Se)===me&&he++;return he}e.count=y;function u(J,le,he="\u2026"){return J.length<=le?J:`${J.substr(0,le)}${he}`}e.truncate=u;function d(J,le=" "){const he=p(J,le);return f(he,le)}e.trim=d;function p(J,le){if(!J||!le)return J;const he=le.length;if(he===0||J.length===0)return J;let me=0;for(;J.indexOf(le,me)===me;)me=me+he;return J.substring(me)}e.ltrim=p;function f(J,le){if(!J||!le)return J;const he=le.length,me=J.length;if(he===0||me===0)return J;let Se=me,Le=-1;for(;Le=J.lastIndexOf(le,Se-1),!(Le===-1||Le+he!==Se);){if(Le===0)return"";Se=Le}return J.substring(0,Se)}e.rtrim=f;function l(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function w(J){return J.replace(/\*/g,"")}e.stripWildcards=w;function C(J,le,he={}){if(!J)throw new Error("Cannot create regex from empty string");le||(J=S(J)),he.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(J,me)}e.createRegExp=C;function I(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function v(J){return!!J.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function i(J){return(J.global?"g":"")+(J.ignoreCase?"i":"")+(J.multiline?"m":"")+(J.unicode?"u":"")}e.regExpFlags=i;function r(J){return J.split(/\r\n|\r|\n/)}e.splitLines=r;function n(J){for(let le=0,he=J.length;le<he;le++){const me=J.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=n;function o(J,le=0,he=J.length){for(let me=le;me<he;me++){const Se=J.charCodeAt(me);if(Se!==32&&Se!==9)return J.substring(le,me)}return J.substring(le,he)}e.getLeadingWhitespace=o;function a(J,le=J.length-1){for(let he=le;he>=0;he--){const me=J.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=a;function c(J,le,he){const me=[];let Se=0;for(const Le of J.matchAll(le)){if(me.push(J.slice(Se,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Se=Le.index+Le[0].length,me.push(he(Le[0],...Le.slice(1),Le.index,J,Le.groups))}return me.push(J.slice(Se)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=c;function s(J,le){return J<le?-1:J>le?1:0}e.compare=s;function h(J,le,he=0,me=J.length,Se=0,Le=le.length){for(;he<me&&Se<Le;he++,Se++){const xe=J.charCodeAt(he),He=le.charCodeAt(Se);if(xe<He)return-1;if(xe>He)return 1}const Be=me-he,it=Le-Se;return Be<it?-1:Be>it?1:0}e.compareSubstring=h;function D(J,le){return L(J,le,0,J.length,0,le.length)}e.compareIgnoreCase=D;function L(J,le,he=0,me=J.length,Se=0,Le=le.length){for(;he<me&&Se<Le;he++,Se++){let xe=J.charCodeAt(he),He=le.charCodeAt(Se);if(xe===He)continue;if(xe>=128||He>=128)return h(J.toLowerCase(),le.toLowerCase(),he,me,Se,Le);F(xe)&&(xe-=32),F(He)&&(He-=32);const tt=xe-He;if(tt!==0)return tt}const Be=me-he,it=Le-Se;return Be<it?-1:Be>it?1:0}e.compareSubstringIgnoreCase=L;function T(J){return J>=48&&J<=57}e.isAsciiDigit=T;function F(J){return J>=97&&J<=122}e.isLowerAsciiLetter=F;function G(J){return J>=65&&J<=90}e.isUpperAsciiLetter=G;function V(J,le){return J.length===le.length&&L(J,le)===0}e.equalsIgnoreCase=V;function K(J,le){const he=le.length;return le.length>J.length?!1:L(J,le,0,he)===0}e.startsWithIgnoreCase=K;function _(J,le){const he=Math.min(J.length,le.length);let me;for(me=0;me<he;me++)if(J.charCodeAt(me)!==le.charCodeAt(me))return me;return he}e.commonPrefixLength=_;function se(J,le){const he=Math.min(J.length,le.length);let me;const Se=J.length-1,Le=le.length-1;for(me=0;me<he;me++)if(J.charCodeAt(Se-me)!==le.charCodeAt(Le-me))return me;return he}e.commonSuffixLength=se;function ce(J){return 55296<=J&&J<=56319}e.isHighSurrogate=ce;function X(J){return 56320<=J&&J<=57343}e.isLowSurrogate=X;function ue(J,le){return(J-55296<<10)+(le-56320)+65536}e.computeCodePoint=ue;function z(J,le,he){const me=J.charCodeAt(he);if(ce(me)&&he+1<le){const Se=J.charCodeAt(he+1);if(X(Se))return ue(me,Se)}return me}e.getNextCodePoint=z;function N(J,le){const he=J.charCodeAt(le-1);if(X(he)&&le>1){const me=J.charCodeAt(le-2);if(ce(me))return ue(me,he)}return he}class U{get offset(){return this.e}constructor(le,he=0){this.c=le,this.d=le.length,this.e=he}setOffset(le){this.e=le}prevCodePoint(){const le=N(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=z(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.CodePointIterator=U;class q{get offset(){return this.c.offset}constructor(le,he=0){this.c=new U(le,he)}nextGraphemeLength(){const le=We.getInstance(),he=this.c,me=he.offset;let Se=le.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Le=he.offset,Be=le.getGraphemeBreakType(he.nextCodePoint());if(be(Se,Be)){he.setOffset(Le);break}Se=Be}return he.offset-me}prevGraphemeLength(){const le=We.getInstance(),he=this.c,me=he.offset;let Se=le.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Le=he.offset,Be=le.getGraphemeBreakType(he.prevCodePoint());if(be(Be,Se)){he.setOffset(Le);break}Se=Be}return me-he.offset}eol(){return this.c.eol()}}e.GraphemeIterator=q;function Q(J,le){return new q(J,le).nextGraphemeLength()}e.nextCharLength=Q;function oe(J,le){return new q(J,le).prevGraphemeLength()}e.prevCharLength=oe;function x(J,le){le>0&&X(J.charCodeAt(le))&&le--;const he=le+Q(J,le);return[he-oe(J,he),he]}e.getCharContainingOffset=x;function R(J){const le=new q(J);let he=0;for(;!le.eol();)he++,le.nextGraphemeLength();return he}e.charCount=R;let O;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(J){return O||(O=W()),O.test(J)}e.containsRTL=j;const $=/^[\t\n\r\x20-\x7E]*$/;function Y(J){return $.test(J)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(J){return e.UNUSUAL_LINE_TERMINATORS.test(J)}e.containsUnusualLineTerminators=B;function Z(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}e.isFullWidthCharacter=Z;function te(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}e.isEmojiImprecise=te;function ae(J,le){if(J.length<le)return J;const he=/\b/g;let me=0;for(;he.test(J)&&!(J.length-he.lastIndex<le);)me=he.lastIndex,he.lastIndex+=1;return J.substring(me).replace(/^\s/,"")}e.lcut=ae;const ge=/\x1B\x5B[12]?K/g,ke=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function De(J){return J&&(J=J.replace(ge,""),J=J.replace(ke,""),J=J.replace(Oe,"")),J}e.removeAnsiEscapeCodes=De,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Me(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Me;function ve(J){return Me(J)?J.substr(1):J}e.stripUTF8BOM=ve;function we(J,le){if(!J||!le||J.length<le.length)return!1;const he=le.length,me=J.toLowerCase();let Se=0,Le=-1;for(;Se<he;){const Be=me.indexOf(le[Se],Le+1);if(Be<0)return!1;Le=Be,Se++}return!0}e.fuzzyContains=we;function ye(J,le=!1){return J?(le&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}e.containsUppercaseCharacter=ye;function Re(J){return J.charAt(0).toUpperCase()+J.slice(1)}e.uppercaseFirstLetter=Re;function ne(J,le=1){if(le===0)return"";let he=-1;do he=J.indexOf(`
`,he+1),le--;while(le>0&&he>=0);return he===-1?J:(J[he-1]==="\r"&&he--,J.substr(0,he))}e.getNLines=ne;function fe(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}e.singleLetterHash=fe;function de(J){return We.getInstance().getGraphemeBreakType(J)}e.getGraphemeBreakType=de;function be(J,le){return J===0?le!==5&&le!==7:J===2&&le===3?!1:J===4||J===2||J===3||le===4||le===2||le===3?!0:!(J===8&&(le===8||le===9||le===11||le===12)||(J===11||J===9)&&(le===9||le===10)||(J===12||J===10)&&le===10||le===5||le===13||le===7||J===1||J===13&&le===14||J===6&&le===6)}var Pe;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Te()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const he=this.d,me=he.length/3;let Se=1;for(;Se<=me;)if(le<he[3*Se])Se=2*Se;else if(le>he[3*Se+1])Se=2*Se+1;else return he[3*Se+2];return 0}}We.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(J,le){if(J===0)return 0;const he=Ue(J,le);if(he!==void 0)return he;const me=new U(le,J);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=qe;function Ue(J,le){const he=new U(le,J);let me=he.prevCodePoint();for(;je(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!te(me))return;let Se=he.offset;return Se>0&&he.prevCodePoint()===8205&&(Se=he.offset),Se}function je(J){return 127995<=J&&J<=127999}var Xe;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.noBreakWhitespace="\xA0";class $e{static getInstance(le){return $e.d.get(Array.from(le))}static getLocales(){return $e.e.getValue()}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=$e,k=$e,$e.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.d=new E.LRUCachedFunction(J=>{function le(He){const tt=new Map;for(let nt=0;nt<He.length;nt+=2)tt.set(He[nt],He[nt+1]);return tt}function he(He,tt){const nt=new Map(He);for(const[lt,at]of tt)nt.set(lt,at);return nt}function me(He,tt){if(!He)return tt;const nt=new Map;for(const[lt,at]of He)tt.has(lt)&&nt.set(lt,at);return nt}const Se=k.c.getValue();let Le=J.filter(He=>!He.startsWith("_")&&He in Se);Le.length===0&&(Le=["_default"]);let Be;for(const He of Le){const tt=le(Se[He]);Be=me(Be,tt)}const it=le(Se._common),xe=he(it,Be);return new $e(xe)}),$e.e=new t.Lazy(()=>Object.keys($e.c.getValue()).filter(J=>!J.startsWith("_")));class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(le){return Ke.e().has(le)}static get codePoints(){return Ke.e()}}e.InvisibleCharacters=Ke,Ke.d=void 0}),define(ie[31],re([0,1,9,4,26,11]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(a){return a===47||a===92}e.isPathSeparator=A;function P(a){return a.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function g(a){return a.indexOf("/")===-1&&(a=P(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=g;function m(a,c=E.posix.sep){if(!a)return"";const s=a.length,h=a.charCodeAt(0);if(A(h)){if(A(a.charCodeAt(1))&&!A(a.charCodeAt(2))){let L=3;const T=L;for(;L<s&&!A(a.charCodeAt(L));L++);if(T!==L&&!A(a.charCodeAt(L+1))){for(L+=1;L<s;L++)if(A(a.charCodeAt(L)))return a.slice(0,L+1).replace(/[\\/]/g,c)}}return c}else if(l(h)&&a.charCodeAt(1)===58)return A(a.charCodeAt(2))?a.slice(0,2)+c:a.slice(0,2);let D=a.indexOf("://");if(D!==-1){for(D+=3;D<s;D++)if(A(a.charCodeAt(D)))return a.slice(0,D+1)}return""}e.getRoot=m;function b(a){if(!t.isWindows||!a||a.length<5)return!1;let c=a.charCodeAt(0);if(c!==92||(c=a.charCodeAt(1),c!==92))return!1;let s=2;const h=s;for(;s<a.length&&(c=a.charCodeAt(s),c!==92);s++);return!(h===s||(c=a.charCodeAt(s+1),isNaN(c)||c===92))}e.isUNC=b;const S=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(a,c=t.isWindows){const s=c?S:y;return!(!a||a.length===0||/^\s+$/.test(a)||(s.lastIndex=0,s.test(a))||c&&u.test(a)||a==="."||a===".."||c&&a[a.length-1]==="."||c&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=d;function p(a,c,s){const h=a===c;return!s||h?h:!a||!c?!1:(0,k.equalsIgnoreCase)(a,c)}e.isEqual=p;function f(a,c,s,h=E.sep){if(a===c)return!0;if(!a||!c||c.length>a.length)return!1;if(s){if(!(0,k.startsWithIgnoreCase)(a,c))return!1;if(c.length===a.length)return!0;let L=c.length;return c.charAt(c.length-1)===h&&L--,a.charAt(L)===h}return c.charAt(c.length-1)!==h&&(c+=h),a.indexOf(c)===0}e.isEqualOrParent=f;function l(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=l;function w(a,c){return t.isWindows&&a.endsWith(":")&&(a+=E.sep),(0,E.isAbsolute)(a)||(a=(0,E.join)(c,a)),a=(0,E.normalize)(a),t.isWindows?(a=(0,k.rtrim)(a,E.sep),a.endsWith(":")&&(a+=E.sep)):(a=(0,k.rtrim)(a,E.sep),a||(a=E.sep)),a}e.sanitizeFilePath=w;function C(a){const c=(0,E.normalize)(a);return t.isWindows?a.length>3?!1:I(c)&&(a.length===2||c.charCodeAt(2)===92):c===E.posix.sep}e.isRootOrDriveLetter=C;function I(a,c=t.isWindows){return c?l(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=I;function v(a){return I(a)?a[0]:void 0}e.getDriveLetter=v;function i(a,c,s){return c.length>a.length?-1:a===c?0:(s&&(a=a.toLowerCase(),c=c.toLowerCase()),a.indexOf(c))}e.indexOfPath=i;function r(a){const c=a.split(":");let s,h,D;for(const L of c){const T=Number(L);(0,M.isNumber)(T)?h===void 0?h=T:D===void 0&&(D=T):s=s?[s,L].join(":"):L}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:h!==void 0?h:void 0,column:D!==void 0?D:h!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(a,c,s=8){let h="";for(let L=0;L<s;L++)h+=n.charAt(Math.floor(Math.random()*n.length));let D;return c?D=`${c}-${h}`:D=h,a?(0,E.join)(a,D):D}e.randomPath=o}),define(ie[68],re([0,1,26]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(l){return k(l,0)}e.hash=t;function k(l,w){switch(typeof l){case"object":return l===null?M(349,w):Array.isArray(l)?g(l,w):m(l,w);case"string":return P(l,w);case"boolean":return A(l,w);case"number":return M(l,w);case"undefined":return M(937,w);default:return M(617,w)}}e.doHash=k;function M(l,w){return(w<<5)-w+l|0}e.numberHash=M;function A(l,w){return M(l?433:863,w)}function P(l,w){w=M(149417,w);for(let C=0,I=l.length;C<I;C++)w=M(l.charCodeAt(C),w);return w}e.stringHash=P;function g(l,w){return w=M(104579,w),l.reduce((C,I)=>k(I,C),w)}function m(l,w){return w=M(181387,w),Object.keys(l).sort().reduce((C,I)=>(C=P(I,C),k(l[I],C)),w)}class b{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=k(w,this.g),this.g}}e.Hasher=b;var S;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function y(l,w,C=32){const I=C-w,v=~((1<<I)-1);return(l<<w|(v&l)>>>I)>>>0}function u(l,w=0,C=l.byteLength,I=0){for(let v=0;v<C;v++)l[w+v]=I}function d(l,w,C="0"){for(;l.length<w;)l=C+l;return l}function p(l,w=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(C=>C.toString(16).padStart(2,"0")).join(""):d((l>>>0).toString(16),w/4)}e.toHexString=p;class f{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const C=w.length;if(C===0)return;const I=this.p;let v=this.r,i=this.u,r,n;for(i!==0?(r=i,n=-1,i=0):(r=w.charCodeAt(0),n=0);;){let o=r;if(E.isHighSurrogate(r))if(n+1<C){const a=w.charCodeAt(n+1);E.isLowSurrogate(a)?(n++,o=E.computeCodePoint(r,a)):o=65533}else{i=r;break}else E.isLowSurrogate(r)&&(o=65533);if(v=this.w(I,v,o),n++,n<C)r=w.charCodeAt(n);else break}this.r=v,this.u=i}w(w,C,I){return I<128?w[C++]=I:I<2048?(w[C++]=192|(I&1984)>>>6,w[C++]=128|(I&63)>>>0):I<65536?(w[C++]=224|(I&61440)>>>12,w[C++]=128|(I&4032)>>>6,w[C++]=128|(I&63)>>>0):(w[C++]=240|(I&1835008)>>>18,w[C++]=128|(I&258048)>>>12,w[C++]=128|(I&4032)>>>6,w[C++]=128|(I&63)>>>0),C>=64&&(this.y(),C-=64,this.t+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),C}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=f.g,C=this.q;for(let s=0;s<64;s+=4)w.setUint32(s,C.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)w.setUint32(s,y(w.getUint32(s-12,!1)^w.getUint32(s-32,!1)^w.getUint32(s-56,!1)^w.getUint32(s-64,!1),1),!1);let I=this.h,v=this.l,i=this.m,r=this.n,n=this.o,o,a,c;for(let s=0;s<80;s++)s<20?(o=v&i|~v&r,a=1518500249):s<40?(o=v^i^r,a=1859775393):s<60?(o=v&i|v&r|i&r,a=2400959708):(o=v^i^r,a=3395469782),c=y(I,5)+o+n+a+w.getUint32(s*4,!1)&4294967295,n=r,r=i,i=y(v,30),v=I,I=c;this.h=this.h+I&4294967295,this.l=this.l+v&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+n&4294967295}}e.StringSHA1=f,f.g=new DataView(new ArrayBuffer(320))}),define(ie[98],re([0,1,26]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const M="error",A="warning",P="warn",g="info",m="ignore";function b(y){return y?E.equalsIgnoreCase(M,y)?k.Error:E.equalsIgnoreCase(A,y)||E.equalsIgnoreCase(P,y)?k.Warning:E.equalsIgnoreCase(g,y)?k.Info:k.Ignore:k.Ignore}k.fromValue=b;function S(y){switch(y){case k.Error:return M;case k.Warning:return A;case k.Info:return g;default:return m}}k.toString=S}(t||(t={})),e.default=t}),define(ie[60],re([0,1,24,26]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const d=u.charCodeAt(0),p=this.b.charCodeAt(this.c);return d-p}value(){return this.b[this.c]}}e.StringIterator=k;class M{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,t.compareSubstring)(u,this.b,0,u.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class A{constructor(u=!0,d=!0){this.f=u,this.g=d}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let d=u.length-1;d>=0;d--,this.c--){const p=this.b.charCodeAt(d);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,t.compareSubstring)(u,this.b,0,u.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=A;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class g{constructor(u,d){this.f=u,this.g=d,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(u,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,t.compare)(u,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=g;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(b||(b={}));class S{static forUris(u=()=>!1,d=()=>!1){return new S(new g(u,d))}static forPaths(u=!1){return new S(new A(void 0,!u))}static forStrings(){return new S(new k)}static forConfigKeys(){return new S(new M)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,d){if(d){const p=d.slice(0);(0,E.shuffle)(p);for(const f of p)this.set(f,u)}else{const p=u.slice(0);(0,E.shuffle)(p);for(const f of p)this.set(f[0],f[1])}}set(u,d){const p=this.b.reset(u);let f;this.c||(this.c=new m,this.c.segment=p.value());const l=[];for(f=this.c;;){const C=p.cmp(f.segment);if(C>0)f.left||(f.left=new m,f.left.segment=p.value()),l.push([-1,f]),f=f.left;else if(C<0)f.right||(f.right=new m,f.right.segment=p.value()),l.push([1,f]),f=f.right;else if(p.hasNext())p.next(),f.mid||(f.mid=new m,f.mid.segment=p.value()),l.push([0,f]),f=f.mid;else break}const w=f.value;f.value=d,f.key=u;for(let C=l.length-1;C>=0;C--){const I=l[C][1];I.updateHeight();const v=I.balanceFactor();if(v<-1||v>1){const i=l[C][0],r=l[C+1][0];if(i===1&&r===1)l[C][1]=I.rotateLeft();else if(i===-1&&r===-1)l[C][1]=I.rotateRight();else if(i===1&&r===-1)I.right=l[C+1][1]=l[C+1][1].rotateRight(),l[C][1]=I.rotateLeft();else if(i===-1&&r===1)I.left=l[C+1][1]=l[C+1][1].rotateLeft(),l[C][1]=I.rotateRight();else throw new Error;if(C>0)switch(l[C-1][0]){case-1:l[C-1][1].left=l[C][1];break;case 1:l[C-1][1].right=l[C][1];break;case 0:l[C-1][1].mid=l[C][1];break}else this.c=l[0][1]}}return w}get(u){return this.d(u)?.value}d(u){const d=this.b.reset(u);let p=this.c;for(;p;){const f=d.cmp(p.segment);if(f>0)p=p.left;else if(f<0)p=p.right;else if(d.hasNext())d.next(),p=p.mid;else break}return p}has(u){const d=this.d(u);return!(d?.value===void 0&&d?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,d){const p=this.b.reset(u),f=[];let l=this.c;for(;l;){const w=p.cmp(l.segment);if(w>0)f.push([-1,l]),l=l.left;else if(w<0)f.push([1,l]),l=l.right;else if(p.hasNext())p.next(),f.push([0,l]),l=l.mid;else break}if(!!l){if(d?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const w=this.f(l.right);if(w.key){const{key:C,value:I,segment:v}=w;this.e(w.key,!1),l.key=C,l.value=I,l.segment=v}}else{const w=l.left??l.right;if(f.length>0){const[C,I]=f[f.length-1];switch(C){case-1:I.left=w;break;case 0:I.mid=w;break;case 1:I.right=w;break}}else this.c=w}for(let w=f.length-1;w>=0;w--){const C=f[w][1];C.updateHeight();const I=C.balanceFactor();if(I>1?(C.right.balanceFactor()>=0||(C.right=C.right.rotateRight()),f[w][1]=C.rotateLeft()):I<-1&&(C.left.balanceFactor()<=0||(C.left=C.left.rotateLeft()),f[w][1]=C.rotateRight()),w>0)switch(f[w-1][0]){case-1:f[w-1][1].left=f[w][1];break;case 1:f[w-1][1].right=f[w][1];break;case 0:f[w-1][1].mid=f[w][1];break}else this.c=f[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const d=this.b.reset(u);let p=this.c,f;for(;p;){const l=d.cmp(p.segment);if(l>0)p=p.left;else if(l<0)p=p.right;else if(d.hasNext())d.next(),f=p.value||f,p=p.mid;else break}return p&&p.value||f}findSuperstr(u){return this.g(u,!1)}g(u,d){const p=this.b.reset(u);let f=this.c;for(;f;){const l=p.cmp(f.segment);if(l>0)f=f.left;else if(l<0)f=f.right;else if(p.hasNext())p.next(),f=f.mid;else return f.mid?this.h(f.mid):d?f.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[d,p]of this)u(p,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const d=[];return this.j(u,d),d[Symbol.iterator]()}j(u,d){!u||(u.left&&this.j(u.left,d),u.value&&d.push([u.key,u.value]),u.mid&&this.j(u.mid,d),u.right&&this.j(u.right,d))}_isBalanced(){const u=d=>{if(!d)return!0;const p=d.balanceFactor();return p<-1||p>1?!1:u(d.left)&&u(d.right)};return u(this.c)}}e.TernarySearchTree=S}),define(ie[7],re([0,1,9,4]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,M=/^\//,A=/^\/\//;function P(n,o){if(!n.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!M.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(n,o){return!n&&!o?"file":n}function m(n,o){switch(n){case"https":case"http":case"file":o?o[0]!==S&&(o=S+o):o=S;break}return o}const b="",S="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(o){return o instanceof u?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,a,c,s,h,D=!1){typeof o=="object"?(this.scheme=o.scheme||b,this.authority=o.authority||b,this.path=o.path||b,this.query=o.query||b,this.fragment=o.fragment||b):(this.scheme=g(o,D),this.authority=a||b,this.path=m(this.scheme,c||b),this.query=s||b,this.fragment=h||b,P(this,D))}get fsPath(){return C(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:c,path:s,query:h,fragment:D}=o;return a===void 0?a=this.scheme:a===null&&(a=b),c===void 0?c=this.authority:c===null&&(c=b),s===void 0?s=this.path:s===null&&(s=b),h===void 0?h=this.query:h===null&&(h=b),D===void 0?D=this.fragment:D===null&&(D=b),a===this.scheme&&c===this.authority&&s===this.path&&h===this.query&&D===this.fragment?this:new p(a,c,s,h,D)}static parse(o,a=!1){const c=y.exec(o);return c?new p(c[2]||b,r(c[4]||b),r(c[5]||b),r(c[7]||b),r(c[9]||b),a):new p(b,b,b,b,b)}static file(o){let a=b;if(t.isWindows&&(o=o.replace(/\\/g,S)),o[0]===S&&o[1]===S){const c=o.indexOf(S,2);c===-1?(a=o.substring(2),o=S):(a=o.substring(2,c),o=o.substring(c)||S)}return new p("file",a,o,b,b)}static from(o){const a=new p(o.scheme,o.authority,o.path,o.query,o.fragment);return P(a,!0),a}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&o.scheme==="file"?c=u.file(E.win32.join(C(o,!0),...a)).path:c=E.posix.join(o.path,...a),o.with({path:c})}toString(o=!1){return I(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof u)return o;{const a=new p(o);return a._formatted=o.external,a._fsPath=o._sep===d?o.fsPath:null,a}}else return o}}e.URI=u;const d=t.isWindows?1:void 0;class p extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=C(this,!1)),this._fsPath}toString(o=!1){return o?I(this,!0):(this._formatted||(this._formatted=I(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=d),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(n,o,a){let c,s=-1;for(let h=0;h<n.length;h++){const D=n.charCodeAt(h);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||o&&D===47||a&&D===91||a&&D===93||a&&D===58)s!==-1&&(c+=encodeURIComponent(n.substring(s,h)),s=-1),c!==void 0&&(c+=n.charAt(h));else{c===void 0&&(c=n.substr(0,h));const L=f[D];L!==void 0?(s!==-1&&(c+=encodeURIComponent(n.substring(s,h)),s=-1),c+=L):s===-1&&(s=h)}}return s!==-1&&(c+=encodeURIComponent(n.substring(s))),c!==void 0?c:n}function w(n){let o;for(let a=0;a<n.length;a++){const c=n.charCodeAt(a);c===35||c===63?(o===void 0&&(o=n.substr(0,a)),o+=f[c]):o!==void 0&&(o+=n[a])}return o!==void 0?o:n}function C(n,o){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?o?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,t.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=C;function I(n,o){const a=o?w:l;let c="",{scheme:s,authority:h,path:D,query:L,fragment:T}=n;if(s&&(c+=s,c+=":"),(h||s==="file")&&(c+=S,c+=S),h){let F=h.indexOf("@");if(F!==-1){const G=h.substr(0,F);h=h.substr(F+1),F=G.lastIndexOf(":"),F===-1?c+=a(G,!1,!1):(c+=a(G.substr(0,F),!1,!1),c+=":",c+=a(G.substr(F+1),!1,!0)),c+="@"}h=h.toLowerCase(),F=h.lastIndexOf(":"),F===-1?c+=a(h,!1,!0):(c+=a(h.substr(0,F),!1,!0),c+=h.substr(F))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const F=D.charCodeAt(1);F>=65&&F<=90&&(D=`/${String.fromCharCode(F+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const F=D.charCodeAt(0);F>=65&&F<=90&&(D=`${String.fromCharCode(F+32)}:${D.substr(2)}`)}c+=a(D,!0,!1)}return L&&(c+="?",c+=a(L,!1,!1)),T&&(c+="#",c+=o?T:l(T,!1,!1)),c}function v(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+v(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(i)?n.replace(i,o=>v(o)):n}}),define(ie[140],re([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const b=m;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=t;function k(m){const b=[];let S;try{const y=JSON.parse(m.arguments),u=y[y.length-1];u&&u.__$stack&&(y.pop(),S=u.__$stack),b.push(...y)}catch{b.push("Unable to log remote console arguments",m.arguments)}return{args:b,stack:S}}e.parse=k;function M(m){if(typeof m!="string")return M(k(m).stack);const b=m;if(b){const S=A(b),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(y&&y.length===4)return{uri:E.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=M;function A(m){if(!m)return m;const b=m.indexOf(`
`);return b===-1?m:m.substring(0,b)}function P(m,b){const{args:S,stack:y}=k(m),u=typeof S[0]=="string"&&S.length===1;let d=A(y);d&&(d=`(${d.trim()})`);let p=[];if(typeof S[0]=="string"?d&&u?p=[`%c[${b}] %c${S[0]} %c${d}`,g("blue"),g(""),g("grey")]:p=[`%c[${b}] %c${S[0]}`,g("blue"),g(""),...S.slice(1)]:p=[`%c[${b}]%`,g("blue"),...S],d&&!u&&p.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,p)}e.log=P;function g(m){return`color: ${m}`}}),define(ie[69],re([0,1,17,26,7]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(m){return JSON.stringify(m,P)}e.stringify=M;function A(m){let b=JSON.parse(m);return b=g(b),b}e.parse=A;function P(m,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,t.regExpFlags)(b)}:b}function g(m,b=0){if(!m||b>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof E.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let S=0;S<m.length;++S)m[S]=g(m[S],b+1);else for(const S in m)Object.hasOwnProperty.call(m,S)&&(m[S]=g(m[S],b+1))}return m}e.revive=g}),define(ie[15],re([0,1,4,7]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebook="vscode-notebook",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractive="vscode-interactive",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${k.vscodeRemoteResource}`}set(m,b,S){this.a[m]=b,this.b[m]=S}setConnectionToken(m,b){this.c[m]=b}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)return this.e(m);const b=m.authority;let S=this.a[b];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const y=this.b[b],u=this.c[b];let d=`path=${encodeURIComponent(m.path)}`;return typeof u=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(u)}`),t.URI.from({scheme:E.isWeb?this.d:k.vscodeRemoteResource,authority:`${S}:${y}`,path:this.f,query:d})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(m){const b=this.b(m,H);return this.uriToBrowserUri(b)}uriToBrowserUri(m){return m.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(m):m.scheme===k.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${k.vscodeFileResource}://${A.a}`)?m.with({scheme:k.vscodeFileResource,authority:m.authority||A.a,query:null,fragment:null}):m}asFileUri(m){const b=this.b(m,H);return this.uriToFileUri(b)}uriToFileUri(m){return m.scheme===k.vscodeFileResource?m.with({scheme:k.file,authority:m.authority!==A.a?m.authority:null,query:null,fragment:null}):m}b(m,b){return t.URI.isUri(m)?m:t.URI.parse(b.toUrl(m))}}A.a="vscode-app",e.FileAccess=new A;var P;(function(g){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(m.get("3"));const b="vscode-coi";function S(u){let d;typeof u=="string"?d=new URL(u).searchParams:u instanceof URL?d=u.searchParams:t.URI.isUri(u)&&(d=new URL(u.toString(!0)).searchParams);const p=d?.get(b);if(!!p)return m.get(p)}g.getHeadersFromQuery=S;function y(u,d,p){if(!globalThis.crossOriginIsolated)return;const f=d&&p?"3":p?"2":"1";u instanceof URLSearchParams?u.set(b,f):u[b]=f}g.addSearchParam=y})(P=e.COI||(e.COI={}))}),define(ie[20],re([0,1,31,15,9,4,26,7]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(u){return(0,P.uriToFsPath)(u,!0)}e.originalFSPath=g;class m{constructor(d){this.a=d}compare(d,p,f=!1){return d===p?0:(0,A.compare)(this.getComparisonKey(d,f),this.getComparisonKey(p,f))}isEqual(d,p,f=!1){return d===p?!0:!d||!p?!1:this.getComparisonKey(d,f)===this.getComparisonKey(p,f)}getComparisonKey(d,p=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,p,f=!1){if(d.scheme===p.scheme){if(d.scheme===t.Schemas.file)return E.isEqualOrParent(g(d),g(p),this.a(d))&&d.query===p.query&&(f||d.fragment===p.fragment);if((0,e.isEqualAuthority)(d.authority,p.authority))return E.isEqualOrParent(d.path,p.path,this.a(d),"/")&&d.query===p.query&&(f||d.fragment===p.fragment)}return!1}joinPath(d,...p){return P.URI.joinPath(d,...p)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let p;return d.scheme===t.Schemas.file?p=P.URI.file(k.dirname(g(d))).path:(p=k.posix.dirname(d.path),d.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),p="/")),d.with({path:p})}normalizePath(d){if(!d.path.length)return d;let p;return d.scheme===t.Schemas.file?p=P.URI.file(k.normalize(g(d))).path:p=k.posix.normalize(d.path),d.with({path:p})}relativePath(d,p){if(d.scheme!==p.scheme||!(0,e.isEqualAuthority)(d.authority,p.authority))return;if(d.scheme===t.Schemas.file){const w=k.relative(g(d),g(p));return M.isWindows?E.toSlashes(w):w}let f=d.path||"/";const l=p.path||"/";if(this.a(d)){let w=0;for(const C=Math.min(f.length,l.length);w<C&&!(f.charCodeAt(w)!==l.charCodeAt(w)&&f.charAt(w).toLowerCase()!==l.charAt(w).toLowerCase());w++);f=l.substr(0,w)+f.substr(w)}return k.posix.relative(f,l)}resolvePath(d,p){if(d.scheme===t.Schemas.file){const f=P.URI.file(k.resolve(g(d),p));return d.with({authority:f.authority,path:f.path})}return p=E.toPosixPath(p),d.with({path:k.posix.resolve(d.path,p)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,p){return d===p||d!==void 0&&p!==void 0&&(0,A.equalsIgnoreCase)(d,p)}hasTrailingPathSeparator(d,p=k.sep){if(d.scheme===t.Schemas.file){const f=g(d);return f.length>E.getRoot(f).length&&f[f.length-1]===p}else{const f=d.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,p=k.sep){return(0,e.hasTrailingPathSeparator)(d,p)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,p=k.sep){let f=!1;if(d.scheme===t.Schemas.file){const l=g(d);f=l!==void 0&&l.length===E.getRoot(l).length&&l[l.length-1]===p}else{p="/";const l=d.path;f=l.length===1&&l.charCodeAt(l.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(d,p)?d.with({path:d.path+"/"}):d}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(u=>u.scheme===t.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new m(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(u,d){const p=[];for(let f=0;f<u.length;f++){const l=d(u[f]);u.some((w,C)=>C===f?!1:(0,e.isEqualOrParent)(l,d(w)))||p.push(u[f])}return p}e.distinctParents=b;var S;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function d(p){const f=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(C=>{const[I,v]=C.split(":");I&&v&&f.set(I,v)});const w=p.path.substring(0,p.path.indexOf(";"));return w&&f.set(u.META_DATA_MIME,w),f}u.parseMetaData=d})(S=e.DataUri||(e.DataUri={}));function y(u,d,p){if(d){let f=u.path;return f&&f[0]!==k.posix.sep&&(f=k.posix.sep+f),u.with({scheme:p,authority:d,path:f})}return u.with({scheme:p})}e.toLocalResource=y}),define(ie[8],re([0,1,22,13,3,2,20,4]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(x){return!!x&&typeof x.then=="function"}e.isThenable=g;function m(x){const R=new E.CancellationTokenSource,O=x(R.token),W=new Promise((j,$)=>{const Y=R.token.onCancellationRequested(()=>{Y.dispose(),R.dispose(),$(new t.CancellationError)});Promise.resolve(O).then(B=>{Y.dispose(),R.dispose(),j(B)},B=>{Y.dispose(),R.dispose(),$(B)})});return new class{cancel(){R.cancel()}then(j,$){return W.then(j,$)}catch(j){return this.then(void 0,j)}finally(j){return W.finally(j)}}}e.createCancelablePromise=m;function b(x,R,O){return new Promise((W,j)=>{const $=R.onCancellationRequested(()=>{$.dispose(),W(O)});x.then(W,j).finally(()=>$.dispose())})}e.raceCancellation=b;function S(x,R){return new Promise((O,W)=>{const j=R.onCancellationRequested(()=>{j.dispose(),W(new t.CancellationError)});x.then(O,W).finally(()=>j.dispose())})}e.raceCancellationError=S;async function y(x){let R=-1;const O=x.map((j,$)=>j.then(Y=>(R=$,Y))),W=await Promise.race(O);return x.forEach((j,$)=>{$!==R&&j.cancel()}),W}e.raceCancellablePromises=y;function u(x,R,O){let W;const j=setTimeout(()=>{W?.(void 0),O?.()},R);return Promise.race([x.finally(()=>clearTimeout(j)),new Promise($=>W=$)])}e.raceTimeout=u;function d(x){return new Promise((R,O)=>{const W=x();g(W)?W.then(R,O):R(W)})}e.asPromise=d;class p{constructor(){this.a=null,this.b=null,this.d=null}queue(R){if(this.a){if(this.d=R,!this.b){const O=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(O,O).then(W)})}return new Promise((O,W)=>{this.b.then(O,W)})}return this.a=R(),new Promise((O,W)=>{this.a.then(j=>{this.a=null,O(j)},j=>{this.a=null,W(j)})})}}e.Throttler=p;class f{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.Sequencer=f;class l{constructor(){this.a=new Map}queue(R,O){const j=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.a.get(R)===j&&this.a.delete(R)});return this.a.set(R,j),j}}e.SequencerByKey=l;const w=(x,R)=>{let O=!0;const W=setTimeout(()=>{O=!1,R()},x);return{isTriggered:()=>O,dispose:()=>{clearTimeout(W),O=!1}}},C=x=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,x())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class I{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,O=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((j,$)=>{this.d=j,this.f=$}).then(()=>{if(this.b=null,this.d=null,this.g){const j=this.g;return this.g=null,j()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=O===e.MicrotaskDelay?C(W):w(O,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=I;class v{constructor(R){this.a=new I(R),this.b=new p}trigger(R,O){return this.a.trigger(()=>this.b.queue(R),O)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=v;class i{constructor(){this.a=!1,this.b=new Promise((R,O)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class r extends i{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function n(x,R){return R?new Promise((O,W)=>{const j=setTimeout(()=>{$.dispose(),O()},x),$=R.onCancellationRequested(()=>{clearTimeout(j),$.dispose(),W(new t.CancellationError)})}):m(O=>n(x,O))}e.timeout=n;function o(x,R=0){const O=setTimeout(x,R);return(0,M.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=o;function a(x){const R=[];let O=0;const W=x.length;function j(){return O<W?x[O++]():null}function $(Y){Y!=null&&R.push(Y);const B=j();return B?B.then($):Promise.resolve(R)}return Promise.resolve(null).then($)}e.sequence=a;function c(x,R=W=>!!W,O=null){let W=0;const j=x.length,$=()=>{if(W>=j)return Promise.resolve(O);const Y=x[W++];return Promise.resolve(Y()).then(Z=>R(Z)?Promise.resolve(Z):$())};return $()}e.first=c;function s(x,R=W=>!!W,O=null){if(x.length===0)return Promise.resolve(O);let W=x.length;const j=()=>{W=-1;for(const $ of x)$.cancel?.()};return new Promise(($,Y)=>{for(const B of x)B.then(Z=>{--W>=0&&R(Z)?(j(),$(Z)):W===0&&$(O)}).catch(Z=>{--W>=0&&(j(),Y(Z))})})}e.firstParallel=s;class h{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((O,W)=>{this.f.push({factory:R,c:O,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const O=R.factory();O.then(R.c,R.e),O.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class D extends h{constructor(){super(1)}}e.Queue=D;class L{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const R=new z;return this.b.add(R),R.p}d(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,O=A.extUri){const W=O.getComparisonKey(R);let j=this.a.get(W);return j||(j=new D,k.Event.once(j.onDrained)(()=>{j?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,j)),j}f(){!this.d()||this.g()}g(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.g()}}e.ResourceQueue=L;class T{constructor(R,O){this.a=-1,typeof R=="function"&&typeof O=="number"&&this.setIfNotSet(R,O)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,O){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},O)}setIfNotSet(R,O){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},O))}}e.TimeoutTimer=T;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,O){this.cancel(),this.a=setInterval(()=>{R()},O)}}e.IntervalTimer=F;class G{constructor(R,O){this.b=-1,this.a=R,this.d=O,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=G;class V{constructor(R,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.a=R,this.b=O,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class K extends G{constructor(R,O){super(R,O),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=K;class _ extends M.Disposable{constructor(R,O){super(),this.g=R,this.h=O,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const O of R)this.a.push(O);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=_,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,P.setTimeout0)(()=>{if(R)return;const O=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.runWhenIdle=(x,R)=>{const O=requestIdleCallback(x,typeof R=="number"?{timeout:R}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(O))}}}}();class se{constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(O){this.g=O}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=se;async function ce(x,R,O){let W;for(let j=0;j<O;j++)try{return await x()}catch($){W=$,await n(R)}throw W}e.retry=ce;class X{hasPending(R){return this.a?typeof R=="number"?this.a.taskId===R:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(R,O,W){return this.a={taskId:R,cancel:()=>W?.(),promise:O},O.then(()=>this.d(R),()=>this.d(R)),O}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this.b)this.b.run=R;else{let O,W;const j=new Promise(($,Y)=>{O=$,W=Y});this.b={run:R,promise:j,promiseResolve:O,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class ue{constructor(R,O=()=>Date.now()){this.d=R,this.f=O,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.IntervalCounter=ue;class z{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((R,O)=>{this.a=R,this.b=O})}complete(R){return new Promise(O=>{this.a(R),this.f=!0,O()})}error(R){return new Promise(O=>{this.b(R),this.d=!0,O()})}cancel(){new Promise(R=>{this.b(new t.CancellationError),this.d=!0,R()})}}e.DeferredPromise=z;var N;(function(x){async function R(W){let j;const $=await Promise.all(W.map(Y=>Y.then(B=>B,B=>{j||(j=B)})));if(typeof j<"u")throw j;return $}x.settled=R;function O(W){return new Promise(async(j,$)=>{try{await W(j,$)}catch(Y){$(Y)}})}x.withAsyncBody=O})(N=e.Promises||(e.Promises={}));var U;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(U||(U={}));class q{static fromArray(R){return new q(O=>{O.emitMany(R)})}static fromPromise(R){return new q(async O=>{O.emitMany(await R)})}static fromPromises(R){return new q(async O=>{await Promise.all(R.map(async W=>O.emitOne(await W)))})}static merge(R){return new q(async O=>{await Promise.all(R.map(async W=>{for await(const j of W)O.emitOne(j)}))})}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(R(O)),this.j()}catch(W){this.k(W)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(R,O){return new q(async W=>{for await(const j of R)W.emitOne(O(j))})}map(R){return q.map(this,R)}static filter(R,O){return new q(async W=>{for await(const j of R)O(j)&&W.emitOne(j)})}filter(R){return q.filter(this,R)}static coalesce(R){return q.filter(R,O=>!!O)}coalesce(){return q.coalesce(this)}static async toPromise(R){const O=[];for await(const W of R)O.push(W);return O}toPromise(){return q.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}e.AsyncIterableObject=q,q.EMPTY=q.fromArray([]);class Q extends q{constructor(R,O){super(O),this.l=R}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Q;function oe(x){const R=new E.CancellationTokenSource,O=x(R.token);return new Q(R,async W=>{const j=R.token.onCancellationRequested(()=>{j.dispose(),R.dispose(),W.reject(new t.CancellationError)});try{for await(const $ of O){if(R.token.isCancellationRequested)return;W.emitOne($)}j.dispose(),R.dispose()}catch($){j.dispose(),R.dispose(),W.reject($)}})}e.createCancelableAsyncIterable=oe}),define(ie[99],re([0,1,24,8,31,39,9,4,26]),function(H,e,E,t,k,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",S="[^/\\\\]",y=/\//g;function u(z,N){switch(z){case 0:return"";case 1:return`${S}*?`;default:return`(?:${b}|${S}+${b}${N?`|${b}${S}+`:""})*?`}}function d(z,N){if(!z)return[];const U=[];let q=!1,Q=!1,oe="";for(const x of z){switch(x){case N:if(!q&&!Q){U.push(oe),oe="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}oe+=x}return oe&&U.push(oe),U}e.splitGlobAware=d;function p(z){if(!z)return"";let N="";const U=d(z,e.GLOB_SPLIT);if(U.every(q=>q===e.GLOBSTAR))N=".*";else{let q=!1;U.forEach((Q,oe)=>{if(Q===e.GLOBSTAR){if(q)return;N+=u(2,oe===U.length-1)}else{let x=!1,R="",O=!1,W="";for(const j of Q){if(j!=="}"&&x){R+=j;continue}if(O&&(j!=="]"||!W)){let $;j==="-"?$=j:(j==="^"||j==="!")&&!W?$="^":j===e.GLOB_SPLIT?$="":$=(0,g.escapeRegExpCharacters)(j),W+=$;continue}switch(j){case"{":x=!0;continue;case"[":O=!0;continue;case"}":{N+=`(?:${d(R,",").map(B=>p(B)).join("|")})`,x=!1,R="";break}case"]":{N+="["+W+"]",O=!1,W="";break}case"?":N+=S;continue;case"*":N+=u(1);continue;default:N+=(0,g.escapeRegExpCharacters)(j)}}oe<U.length-1&&(U[oe+1]!==e.GLOBSTAR||oe+2<U.length)&&(N+=b)}q=Q===e.GLOBSTAR})}return N}const f=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,C=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,I=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.LRUCache(1e4),r=function(){return!1},n=function(){return null};function o(z,N){if(!z)return n;let U;typeof z!="string"?U=z.pattern:U=z,U=U.trim();const q=`${U}_${!!N.trimForExclusions}`;let Q=i.get(q);if(Q)return a(Q,z);let oe;return f.test(U)?Q=s(U.substr(4),U):(oe=l.exec(c(U,N)))?Q=h(oe[1],U):(N.trimForExclusions?C:w).test(U)?Q=D(U,N):(oe=I.exec(c(U,N)))?Q=L(oe[1].substr(1),U,!0):(oe=v.exec(c(U,N)))?Q=L(oe[1],U,!1):Q=T(U),i.set(q,Q),a(Q,z)}function a(z,N){if(typeof N=="string")return z;const U=function(q,Q){return(0,k.isEqualOrParent)(q,N.base,!P.isLinux)?z((0,g.ltrim)(q.substr(N.base.length),A.sep),Q):null};return U.allBasenames=z.allBasenames,U.allPaths=z.allPaths,U.basenames=z.basenames,U.patterns=z.patterns,U}function c(z,N){return N.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function s(z,N){return function(U,q){return typeof U=="string"&&U.endsWith(z)?N:null}}function h(z,N){const U=`/${z}`,q=`\\${z}`,Q=function(x,R){return typeof x!="string"?null:R?R===z?N:null:x===z||x.endsWith(U)||x.endsWith(q)?N:null},oe=[z];return Q.basenames=oe,Q.patterns=[N],Q.allBasenames=oe,Q}function D(z,N){const U=X(z.slice(1,-1).split(",").map(R=>o(R,N)).filter(R=>R!==n),z),q=U.length;if(!q)return n;if(q===1)return U[0];const Q=function(R,O){for(let W=0,j=U.length;W<j;W++)if(U[W](R,O))return z;return null},oe=U.find(R=>!!R.allBasenames);oe&&(Q.allBasenames=oe.allBasenames);const x=U.reduce((R,O)=>O.allPaths?R.concat(O.allPaths):R,[]);return x.length&&(Q.allPaths=x),Q}function L(z,N,U){const q=A.sep===A.posix.sep,Q=q?z:z.replace(y,A.sep),oe=A.sep+Q,x=A.posix.sep+z;let R;return U?R=function(O,W){return typeof O=="string"&&(O===Q||O.endsWith(oe)||!q&&(O===z||O.endsWith(x)))?N:null}:R=function(O,W){return typeof O=="string"&&(O===Q||!q&&O===z)?N:null},R.allPaths=[(U?"*/":"./")+z],R}function T(z){try{const N=new RegExp(`^${p(z)}$`);return function(U){return N.lastIndex=0,typeof U=="string"&&N.test(U)?z:null}}catch{return n}}function F(z,N,U){return!z||typeof N!="string"?!1:G(z)(N,void 0,U)}e.match=F;function G(z,N={}){if(!z)return r;if(typeof z=="string"||V(z)){const U=o(z,N);if(U===n)return r;const q=function(Q,oe){return!!U(Q,oe)};return U.allBasenames&&(q.allBasenames=U.allBasenames),U.allPaths&&(q.allPaths=U.allPaths),q}return se(z,N)}e.parse=G;function V(z){const N=z;return N?typeof N.base=="string"&&typeof N.pattern=="string":!1}e.isRelativePattern=V;function K(z){return z.allBasenames||[]}e.getBasenameTerms=K;function _(z){return z.allPaths||[]}e.getPathTerms=_;function se(z,N){const U=X(Object.getOwnPropertyNames(z).map(R=>ce(R,z[R],N)).filter(R=>R!==n)),q=U.length;if(!q)return n;if(!U.some(R=>!!R.requiresSiblings)){if(q===1)return U[0];const R=function(j,$){let Y;for(let B=0,Z=U.length;B<Z;B++){const te=U[B](j,$);if(typeof te=="string")return te;(0,t.isThenable)(te)&&(Y||(Y=[]),Y.push(te))}return Y?(async()=>{for(const B of Y){const Z=await B;if(typeof Z=="string")return Z}return null})():null},O=U.find(j=>!!j.allBasenames);O&&(R.allBasenames=O.allBasenames);const W=U.reduce((j,$)=>$.allPaths?j.concat($.allPaths):j,[]);return W.length&&(R.allPaths=W),R}const Q=function(R,O,W){let j,$;for(let Y=0,B=U.length;Y<B;Y++){const Z=U[Y];Z.requiresSiblings&&W&&(O||(O=(0,A.basename)(R)),j||(j=O.substr(0,O.length-(0,A.extname)(R).length)));const te=Z(R,O,j,W);if(typeof te=="string")return te;(0,t.isThenable)(te)&&($||($=[]),$.push(te))}return $?(async()=>{for(const Y of $){const B=await Y;if(typeof B=="string")return B}return null})():null},oe=U.find(R=>!!R.allBasenames);oe&&(Q.allBasenames=oe.allBasenames);const x=U.reduce((R,O)=>O.allPaths?R.concat(O.allPaths):R,[]);return x.length&&(Q.allPaths=x),Q}function ce(z,N,U){if(N===!1)return n;const q=o(z,U);if(q===n)return n;if(typeof N=="boolean")return q;if(N){const Q=N.when;if(typeof Q=="string"){const oe=(x,R,O,W)=>{if(!W||!q(x,R))return null;const j=Q.replace("$(basename)",()=>O),$=W(j);return(0,t.isThenable)($)?$.then(Y=>Y?z:null):$?z:null};return oe.requiresSiblings=!0,oe}}return q}function X(z,N){const U=z.filter(R=>!!R.basenames);if(U.length<2)return z;const q=U.reduce((R,O)=>{const W=O.basenames;return W?R.concat(W):R},[]);let Q;if(N){Q=[];for(let R=0,O=q.length;R<O;R++)Q.push(N)}else Q=U.reduce((R,O)=>{const W=O.patterns;return W?R.concat(W):R},[]);const oe=function(R,O){if(typeof R!="string")return null;if(!O){let j;for(j=R.length;j>0;j--){const $=R.charCodeAt(j-1);if($===47||$===92)break}O=R.substr(j)}const W=q.indexOf(O);return W!==-1?Q[W]:null};oe.basenames=q,oe.patterns=Q,oe.allBasenames=q;const x=z.filter(R=>!R.basenames);return x.push(oe),x}function ue(z,N){return(0,E.equals)(z,N,(U,q)=>typeof U=="string"&&typeof q=="string"?U===q:typeof U!="string"&&typeof q!="string"?U.base===q.base&&U.pattern===q.pattern:!1)}e.patternsEquals=ue}),define(ie[34],re([0,1,24,31,9,4,20,26]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function g(n,o){const{os:a,tildify:c,relative:s}=o;if(s){const L=m(n,s,a);if(typeof L=="string")return L}let h=n.fsPath;if(a===1&&!M.isWindows?h=h.replace(/\//g,"\\"):a!==1&&M.isWindows&&(h=h.replace(/\\/g,"/")),a!==1&&c?.userHome){const L=c.userHome.fsPath;let T;n.scheme!==c.userHome.scheme&&n.path.startsWith(k.posix.sep)?T=c.userHome.with({path:n.path}).fsPath:T=n.fsPath,h=y(T,L,a)}return(a===1?k.win32:k.posix).normalize(b(h,a===1))}e.getPathLabel=g;function m(n,o,a){const c=a===1?k.win32:k.posix,s=a===3?A.extUri:A.extUriIgnorePathCase,h=o.getWorkspace(),D=(0,E.firstOrDefault)(h.folders);if(!D)return;n.scheme!==D.uri.scheme&&n.path.startsWith(k.posix.sep)&&(n=D.uri.with({path:n.path}));const L=o.getWorkspaceFolder(n);if(!L)return;let T;if(s.isEqual(L.uri,n)?T="":T=s.relativePath(L.uri,n)??"",T&&(T=c.normalize(T)),h.folders.length>1&&!o.noPrefix){const F=L.name?L.name:s.basenameOrAuthority(L.uri);T=T?`${F} \u2022 ${T}`:F}return T}function b(n,o=M.isWindows){return(0,t.hasDriveLetter)(n,o)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=b;let S=Object.create(null);function y(n,o,a=M.OS){if(a===1||!n||!o)return n;let c=S.original===o?S.normalized:void 0;c||(c=o,M.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,P.rtrim)(c,k.posix.sep)}${k.posix.sep}`,S={original:o,normalized:c});let s=n;return M.isWindows&&(s=(0,t.toSlashes)(s)),(a===3?s.startsWith(c):(0,P.startsWithIgnoreCase)(s,c))?`~/${s.substr(c.length)}`:n}e.tildify=y;function u(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=u;const d="\u2026",p="\\\\",f="~";function l(n,o=k.sep){const a=new Array(n.length);let c=!1;for(let s=0;s<n.length;s++){const h=n[s];if(h===""){a[s]=`.${o}`;continue}if(!h){a[s]=h;continue}c=!0;let D="",L=h;L.indexOf(p)===0?(D=L.substr(0,L.indexOf(p)+p.length),L=L.substr(L.indexOf(p)+p.length)):L.indexOf(o)===0?(D=L.substr(0,L.indexOf(o)+o.length),L=L.substr(L.indexOf(o)+o.length)):L.indexOf(f)===0&&(D=L.substr(0,L.indexOf(f)+f.length),L=L.substr(L.indexOf(f)+f.length));const T=L.split(o);for(let F=1;c&&F<=T.length;F++)for(let G=T.length-F;c&&G>=0;G--){c=!1;let V=T.slice(G,G+F).join(o);for(let K=0;!c&&K<n.length;K++)if(K!==s&&n[K]&&n[K].indexOf(V)>-1){const _=G+F===T.length,se=G>0&&n[K].indexOf(o)>-1?o+V:V,ce=n[K].endsWith(se);c=!_||ce}if(!c){let K="";(T[0].endsWith(":")||D!=="")&&(G===1&&(G=0,F++,V=T[0]+o+V),G>0&&(K=T[0]+o),K=D+K),G>0&&(K=K+d+o),K=K+V,G+F<T.length&&(K=K+o+d),a[s]=K}}c&&(a[s]=h)}return a}e.shorten=l;var w;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function C(n,o=Object.create(null)){const a=[];let c=!1,s="";for(const h of n)if(h==="$"||c&&h==="{")s&&a.push({value:s,type:w.TEXT}),s="",c=!0;else if(h==="}"&&c){const D=o[s];if(typeof D=="string")D.length&&a.push({value:D,type:w.VARIABLE});else if(D){const L=a[a.length-1];(!L||L.type!==w.SEPARATOR)&&a.push({value:D.label,type:w.SEPARATOR})}s="",c=!1}else s+=h;return s&&!c&&a.push({value:s,type:w.TEXT}),a.filter((h,D)=>{if(h.type===w.SEPARATOR){const L=a[D-1],T=a[D+1];return[L,T].every(F=>F&&(F.type===w.VARIABLE||F.type===w.TEXT)&&F.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=C;function I(n,o){return M.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=I;function v(n,o){return M.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):M.isWindows?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function r(n){const o=n.indexOf("/")!==-1?k.posix:k.win32,a=o.basename(n),c=o.dirname(n);return a.length?{name:a,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(ie[141],re([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(b){return b.toJSON()}class k{constructor(S){this.a=S}transformIncoming(S){const y=this.a.transformIncoming(S);return y===S?S:t(E.URI.from(y))}transformOutgoing(S){const y=this.a.transformOutgoing(S);return y===S?S:t(E.URI.from(y))}transformOutgoingURI(S){const y=this.a.transformOutgoing(S);return y===S?S:E.URI.from(y)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function M(b,S,y){if(!b||y>200)return null;if(typeof b=="object"){if(b instanceof E.URI)return S.transformOutgoing(b);for(const u in b)if(Object.hasOwnProperty.call(b,u)){const d=M(b[u],S,y+1);d!==null&&(b[u]=d)}}return null}function A(b,S){const y=M(b,S,0);return y===null?b:y}e.transformOutgoingURIs=A;function P(b,S,y,u){if(!b||u>200)return null;if(typeof b=="object"){if(b.$mid===1)return y?E.URI.revive(S.transformIncoming(b)):S.transformIncoming(b);for(const d in b)if(Object.hasOwnProperty.call(b,d)){const p=P(b[d],S,y,u+1);p!==null&&(b[d]=p)}}return null}function g(b,S){const y=P(b,S,!1,0);return y===null?b:y}e.transformIncomingURIs=g;function m(b,S){const y=P(b,S,!0,0);return y===null?b:y}e.transformAndReviveIncomingURIs=m}),define(ie[82],re([0,1,25,13,60,30,129]),function(H,e,E,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,S=0;const y=(0,E.networkInterfaces)();for(const u in y){const d=y[u];if(d)for(const{mac:p,internal:f}of d)f||(S+=1,this.c(p.toUpperCase())&&(b+=1))}this.b=S>0?b/S:0}return this.b}};let P;async function g(){return P||(P=(async()=>await m()||M.generateUuid())()),P}e.getMachineId=g;async function m(){try{const b=await new Promise((y,u)=>{H(["crypto"],y,u)}),S=(0,A.getMac)();return b.createHash("sha256").update(S,"utf8").digest("hex")}catch(b){t.onUnexpectedError(b);return}}}),define(ie[23],re([0,1,40,25,142,8,31,77,9,4,20,7]),function(H,e,E,t,k,M,A,P,g,m,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function u(se,ce=y.UNLINK){if((0,A.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ce===y.UNLINK?p(se):d(se)}async function d(se){try{const ce=(0,A.randomPath)((0,t.tmpdir)());try{await E.promises.rename(se,ce)}catch(X){return X.code==="ENOENT"?void 0:p(se)}p(ce).catch(X=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function p(se){return(0,k.promisify)(E.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function f(se){if((0,A.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function l(se,ce){return I(await(ce?w(se):(0,k.promisify)(E.readdir)(se)))}async function w(se){try{return await(0,k.promisify)(E.readdir)(se,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const ce=[],X=await l(se);for(const ue of X){let z=!1,N=!1,U=!1;try{const q=await e.Promises.lstat((0,g.join)(se,ue));z=q.isFile(),N=q.isDirectory(),U=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}ce.push({name:ue,isFile:()=>z,isDirectory:()=>N,isSymbolicLink:()=>U})}return ce}function C(se){return I(E.readdirSync(se))}e.readdirSync=C;function I(se){return se.map(ce=>typeof ce=="string"?m.isMacintosh?(0,P.normalizeNFC)(ce):ce:(ce.name=m.isMacintosh?(0,P.normalizeNFC)(ce.name):ce.name,ce))}async function v(se){const ce=await l(se),X=[];for(const ue of ce)await r.existsDirectory((0,g.join)(se,ue))&&X.push(ue);return X}function i(se,ce=1e3){return new Promise(X=>{let ue=!1;const z=setInterval(()=>{ue||(ue=!0,E.access(se,N=>{ue=!1,N&&(clearInterval(z),X(void 0))}))},ce)})}e.whenDeleted=i;var r;(function(se){async function ce(z){let N;try{if(N=await e.Promises.lstat(z),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(m.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw q}throw U}}se.stat=ce;async function X(z){try{const{stat:N,symbolicLink:U}=await se.stat(z);return N.isFile()&&U?.dangling!==!0}catch{}return!1}se.existsFile=X;async function ue(z){try{const{stat:N,symbolicLink:U}=await se.stat(z);return N.isDirectory()&&U?.dangling!==!0}catch{}return!1}se.existsDirectory=ue})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new M.ResourceQueue;function o(se,ce,X){return n.queueFor(S.URI.file(se),b.extUriBiasedIgnorePathCase).queue(()=>{const ue=D(X);return new Promise((z,N)=>s(se,ce,ue,U=>U?N(U):z()))})}let a=!0;function c(se){a=se}e.configureFlushOnWrite=c;function s(se,ce,X,ue){if(!a)return E.writeFile(se,ce,{mode:X.mode,flag:X.flag},ue);E.open(se,X.flag,X.mode,(z,N)=>{if(z)return ue(z);E.writeFile(N,ce,U=>{if(U)return E.close(N,()=>ue(U));E.fdatasync(N,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),c(!1)),E.close(N,Q=>ue(Q))))})})}function h(se,ce,X){const ue=D(X);if(!a)return E.writeFileSync(se,ce,{mode:ue.mode,flag:ue.flag});const z=E.openSync(se,ue.flag,ue.mode);try{E.writeFileSync(z,ce);try{E.fdatasyncSync(z)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),c(!1)}}finally{E.closeSync(z)}}e.writeFileSync=h;function D(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function L(se,ce){if(se!==ce)try{await e.Promises.rename(se,ce)}catch(X){if(se.toLowerCase()!==ce.toLowerCase()&&X.code==="EXDEV"||se.endsWith("."))await T(se,ce,{preserveSymlinks:!1}),await u(se,y.MOVE);else throw X}}async function T(se,ce,X){return G(se,ce,{root:{source:se,target:ce},options:X,handledSourcePaths:new Set})}const F=511;async function G(se,ce,X){if(X.handledSourcePaths.has(se))return;X.handledSourcePaths.add(se);const{stat:ue,symbolicLink:z}=await r.stat(se);if(z){if(X.options.preserveSymlinks)try{return await _(se,ce,X)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(z.dangling)return}return ue.isDirectory()?V(se,ce,ue.mode&F,X):K(se,ce,ue.mode&F)}async function V(se,ce,X,ue){await e.Promises.mkdir(ce,{recursive:!0,mode:X});const z=await l(se);for(const N of z)await G((0,g.join)(se,N),(0,g.join)(ce,N),ue)}async function K(se,ce,X){await e.Promises.copyFile(se,ce),await e.Promises.chmod(ce,X)}async function _(se,ce,X){let ue=await e.Promises.readlink(se);(0,A.isEqualOrParent)(ue,X.root.source,!m.isLinux)&&(ue=(0,g.join)(X.root.target,ue.substr(X.root.source.length+1))),await e.Promises.symlink(ue,ce)}e.Promises=new class{get access(){return(0,k.promisify)(E.access)}get stat(){return(0,k.promisify)(E.stat)}get lstat(){return(0,k.promisify)(E.lstat)}get utimes(){return(0,k.promisify)(E.utimes)}get read(){return(se,ce,X,ue,z)=>new Promise((N,U)=>{E.read(se,ce,X,ue,z,(q,Q,oe)=>q?U(q):N({bytesRead:Q,buffer:oe}))})}get readFile(){return(0,k.promisify)(E.readFile)}get write(){return(se,ce,X,ue,z)=>new Promise((N,U)=>{E.write(se,ce,X,ue,z,(q,Q,oe)=>q?U(q):N({bytesWritten:Q,buffer:oe}))})}get appendFile(){return(0,k.promisify)(E.appendFile)}get fdatasync(){return(0,k.promisify)(E.fdatasync)}get truncate(){return(0,k.promisify)(E.truncate)}get rename(){return(0,k.promisify)(E.rename)}get copyFile(){return(0,k.promisify)(E.copyFile)}get open(){return(0,k.promisify)(E.open)}get close(){return(0,k.promisify)(E.close)}get symlink(){return(0,k.promisify)(E.symlink)}get readlink(){return(0,k.promisify)(E.readlink)}get chmod(){return(0,k.promisify)(E.chmod)}get mkdir(){return(0,k.promisify)(E.mkdir)}get unlink(){return(0,k.promisify)(E.unlink)}get rmdir(){return(0,k.promisify)(E.rmdir)}get realpath(){return(0,k.promisify)(E.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return v}get writeFile(){return o}get rm(){return u}get move(){return L}get copy(){return T}}}),define(ie[100],re([0,1,40,9,4,26,23]),function(H,e,E,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(y){if(k.isLinux)return y;const u=(0,t.dirname)(y);if(y===u)return y;const d=((0,t.basename)(y)||y).toLowerCase();try{const f=(0,A.readdirSync)(u).filter(l=>l.toLowerCase()===d);if(f.length===1){const l=P(u);if(l)return(0,t.join)(l,f[0])}else if(f.length>1){const l=f.indexOf(d);if(l>=0){const w=P(u);if(w)return(0,t.join)(w,f[l])}}}catch{}return null}e.realcaseSync=P;async function g(y){if(k.isLinux)return y;const u=(0,t.dirname)(y);if(y===u)return y;const d=((0,t.basename)(y)||y).toLowerCase();try{const f=(await A.Promises.readdir(u)).filter(l=>l.toLowerCase()===d);if(f.length===1){const l=await g(u);if(l)return(0,t.join)(l,f[0])}else if(f.length>1){const l=f.indexOf(d);if(l>=0){const w=await g(u);if(w)return(0,t.join)(w,f[l])}}}catch{}return null}e.realcase=g;async function m(y){try{return await A.Promises.realpath(y)}catch{const d=S(y);return await A.Promises.access(d,E.constants.R_OK),d}}e.realpath=m;function b(y){try{return E.realpathSync(y)}catch{const d=S(y);return E.accessSync(d,E.constants.R_OK),d}}e.realpathSync=b;function S(y){return(0,M.rtrim)((0,t.normalize)(y),t.sep)}}),define(ie[143],re([0,1,25,9,23]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var g;(function(I){I[I.x64=0]="x64",I[I.x86=1]="x86",I[I.ARM=2]="ARM"})(g||(g={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class S{constructor(v,i,r){this.exePath=v,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:I=!1}={}){return I?m===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:I=!1,findPreview:v=!1}={}){const i=y({useAlternateBitness:I});if(!i)return null;const r=t.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let n=-1,o=null;for(const s of await k.Promises.readdir(r)){let h=-1;if(v){const L=s.indexOf("-");if(L<0)continue;const T=s.substring(0,L);if(!M.test(T)||s.substring(L+1)!=="preview")continue;h=parseInt(T,10)}else{if(!M.test(s))continue;h=parseInt(s,10)}if(h<=n)continue;const D=t.join(r,s,"pwsh.exe");!await k.SymlinkSupport.existsFile(D)||(o=D,n=h)}if(!o)return null;const a=i.includes("x86")?" (x86)":"",c=v?" Preview":"";return new S(o,`PowerShell${c}${a}`,!0)}async function d({findPreview:I}={}){if(!process.env.LOCALAPPDATA)return null;const v=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(v))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=I?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(v))if(i.test(n)){const o=t.join(v,n,"pwsh.exe");return new S(o,r)}return null}function p(){const I=t.join(E.homedir(),".dotnet","tools","pwsh.exe");return new S(I,".NET Core PowerShell Global Tool")}function f(){const I=t.join(process.env.windir,m===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(I,"Windows PowerShell",!0)}async function*l(){let I=await u();I&&(yield I),I=await u({useAlternateBitness:!0}),I&&(yield I),I=await d(),I&&(yield I),I=p(),I&&(yield I),I=await u({findPreview:!0}),I&&(yield I),I=await d({findPreview:!0}),I&&(yield I),I=await u({useAlternateBitness:!0,findPreview:!0}),I&&(yield I),I=f(),I&&(yield I)}async function*w(){for await(const I of l())await I.exists()&&(yield I)}e.enumeratePowerShellInstallations=w;async function C(){for await(const I of w())return I;return null}e.getFirstAvailablePowerShellInstallation=C}),define(ie[83],re([0,1,9,4,33,80,11,23]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function g(S=k.env){return S.comspec||"cmd.exe"}e.getWindowsShell=g;function m(S){let y=[],u=!1;const d=function(p){if(u){y.push(p);return}(!S.send(p,l=>{if(l&&console.error(l),u=!1,y.length>0){const w=y.slice(0);y=[],w.forEach(C=>d(C))}})||t.isWindows)&&(u=!0)};return{send:d}}e.createQueuedSender=m;var b;(function(S){async function y(u,d,p){if(E.isAbsolute(u))return u;if(d===void 0&&(d=k.cwd()),E.dirname(u)!=="."||(p===void 0&&A.isString(k.env.PATH)&&(p=k.env.PATH.split(E.delimiter)),p===void 0||p.length===0))return E.join(d,u);async function l(w){if(await P.Promises.exists(w)){let C;try{C=await P.Promises.stat(w)}catch(I){I.message.startsWith("EACCES")&&(C=await P.Promises.lstat(w))}return C?!C.isDirectory():!1}return!1}for(const w of p){let C;if(E.isAbsolute(w)?C=E.join(w,u):C=E.join(d,w,u),await l(C))return C;let I=C+".com";if(await l(I)||(I=C+".exe",await l(I)))return I}return E.join(d,u)}S.findExecutable=y})(b=e.win32||(e.win32={}))}),define(ie[101],re([0,1,46,15]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(A){return new Promise((P,g)=>{let m;const b=new Map;function S(u,d,p,f,l){const w=b.get(d);if(u===A||w){const C={name:y(p),cmd:p,pid:u,ppid:d,load:f,mem:l};b.set(u,C),u===A&&(m=C),w&&(w.children||(w.children=[]),w.children.push(C),w.children.length>1&&(w.children=w.children.sort((I,v)=>I.pid-v.pid)))}}function y(u){const d=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,w=/--utility-sub-type=node.mojom.NodeService/,C=/--crashes-directory/,I=/\\pipe\\winpty-control/,v=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(C.exec(u))return"electron-crash-reporter";if(I.exec(u))return"winpty-process";if(v.exec(u))return"console-window-host (Windows internal process)";let r=i.exec(u);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(u)?"shared-process":p.exec(u)?"issue-reporter":f.exec(u)?"process-explorer":"window";if(r[1]==="utility"){if(l.exec(u))return"utility-network-service";if(w.exec(u))return"extension-host"}return r[1]}const n=/[a-zA-Z-]+\.js/g;let o="";do r=n.exec(u),r&&(o+=r+" ");while(r);return o&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron_node ${o}`:u}if(process.platform==="win32"){const u=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,p)=>{H(["windows-process-tree"],d,p)}).then(d=>{d.getProcessList(A,p=>{if(!p){g(new Error(`Root process ${A} not found`));return}d.getProcessCpuUsage(p,f=>{const l=new Map;f.forEach(w=>{const C=u(w.commandLine||"");l.set(w.pid,{name:y(C),cmd:C,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),m=l.get(A),m?(l.forEach(w=>{const C=l.get(w.ppid);C&&(C.children||(C.children=[]),C.children.push(w))}),l.forEach(w=>{w.children&&(w.children=w.children.sort((C,I)=>C.pid-I.pid))}),P(m)):g(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let u=function(){let d=[m];const p=[];for(;d.length;){const l=d.shift();l&&(p.push(l.pid),l.children&&(d=d.concat(l.children)))}let f=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+p.join(" "),(0,E.exec)(f,{},(l,w,C)=>{if(l||C)g(l||new Error(C.toString()));else{const I=w.toString().split(`
`);for(let v=0;v<p.length;v++){const i=b.get(p[v]);i.load=parseFloat(I[v])}if(!m){g(new Error(`Root process ${A} not found`));return}P(m)}})};(0,E.exec)("which ps",{},(d,p,f)=>{if(d||f)if(process.platform!=="linux")g(d||new Error(f.toString()));else{const l=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(l,{},(w,C,I)=>{w||I?g(w||new Error(I.toString())):(M(C,S),u())})}else{const l=p.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${l} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(C,I,v)=>{C||v&&!v.includes("screen size is bogus")?g(C||new Error(v.toString())):(M(I,S),process.platform==="linux"?u():m?P(m):g(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=k;function M(A,P){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=A.toString().split(`
`);for(const b of m){const S=g.exec(b.trim());S&&S.length===6&&P(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(ie[144],re([0,1,25,4,143,83]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function A(S,y){return S===1?t.isWindows?b():M.getWindowsShell(y):g(S,y)}e.getSystemShell=A;let P=null;function g(S,y){if(t.isLinux&&S===2||t.isMacintosh&&S===3)return"/bin/bash";if(!P){let u;if(t.isWindows)u="/bin/bash";else{if(u=y.SHELL,!u)try{u=(0,E.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}P=u}return P}let m=null;async function b(){return m||(m=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),m}});var pe=this&&this.__decorate||function(H,e,E,t){var k=arguments.length,M=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,E):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(H,e,E,t);else for(var P=H.length-1;P>=0;P--)(A=H[P])&&(M=(k<3?A(M):k>3?A(e,E,M):A(e,E))||M);return k>3&&M&&Object.defineProperty(e,E,M),M};define(ie[47],re([0,1,24,8,17,22,54,13,3,2,69,26,11]),function(H,e,E,t,k,M,A,P,g,m,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var u;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(u||(u={}));function d(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(p||(p={}));function f(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(l||(l={}));function w(N){let U=0;for(let q=0;;q+=7){const Q=N.read(1);if(U|=(Q.buffer[0]&127)<<q,!(Q.buffer[0]&128))return U}}const C=n(0);function I(N,U){if(U===0){N.write(C);return}let q=0;for(let oe=U;oe!==0;oe=oe>>>7)q++;const Q=k.VSBuffer.alloc(q);for(let oe=0;U!==0;oe++)Q.buffer[oe]=U&127,U=U>>>7,U>0&&(Q.buffer[oe]|=128);N.write(Q)}class v{constructor(U){this.b=U,this.a=0}read(U){const q=this.b.slice(this.a,this.a+U);return this.a+=q.byteLength,q}}e.BufferReader=v;class i{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=i;var r;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object",N[N.Int=6]="Int"})(r||(r={}));function n(N){const U=k.VSBuffer.alloc(1);return U.writeUInt8(N,0),U}const o={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},a=typeof Buffer<"u";function c(N,U){if(typeof U>"u")N.write(o.Undefined);else if(typeof U=="string"){const q=k.VSBuffer.fromString(U);N.write(o.String),I(N,q.byteLength),N.write(q)}else if(a&&Buffer.isBuffer(U)){const q=k.VSBuffer.wrap(U);N.write(o.Buffer),I(N,q.byteLength),N.write(q)}else if(U instanceof k.VSBuffer)N.write(o.VSBuffer),I(N,U.byteLength),N.write(U);else if(Array.isArray(U)){N.write(o.Array),I(N,U.length);for(const q of U)c(N,q)}else if(typeof U=="number"&&(U|0)===U)N.write(o.Uint),I(N,U);else{const q=k.VSBuffer.fromString(JSON.stringify(U));N.write(o.Object),I(N,q.byteLength),N.write(q)}}e.serialize=c;function s(N){switch(N.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return N.read(w(N)).toString();case r.Buffer:return N.read(w(N)).buffer;case r.VSBuffer:return N.read(w(N));case r.Array:{const q=w(N),Q=[];for(let oe=0;oe<q;oe++)Q.push(s(N));return Q}case r.Object:return JSON.parse(N.read(w(N)).toString());case r.Int:return w(N)}}e.deserialize=s;class h{constructor(U,q,Q=null,oe=1e3){this.h=U,this.j=q,this.k=Q,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(U,q){this.b.set(U,q),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const q=this.o([U.type]);this.k?.logOutgoing(q,0,1,f(U.type));return}case 201:case 202:case 204:case 203:{const q=this.o([U.type,U.id],U.data);this.k?.logOutgoing(q,U.id,1,f(U.type),U.data);return}}}o(U,q=void 0){const Q=new i;return c(Q,U),c(Q,q),this.p(Q.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const q=new v(U),Q=s(q),oe=s(q),x=Q[0];switch(x){case 100:return this.k?.logIncoming(U.byteLength,Q[1],1,`${d(x)}: ${Q[2]}.${Q[3]}`,oe),this.s({type:x,id:Q[1],channelName:Q[2],name:Q[3],arg:oe});case 102:return this.k?.logIncoming(U.byteLength,Q[1],1,`${d(x)}: ${Q[2]}.${Q[3]}`,oe),this.t({type:x,id:Q[1],channelName:Q[2],name:Q[3],arg:oe});case 101:return this.k?.logIncoming(U.byteLength,Q[1],1,`${d(x)}`),this.u({type:x,id:Q[1]});case 103:return this.k?.logIncoming(U.byteLength,Q[1],1,`${d(x)}`),this.u({type:x,id:Q[1]})}}s(U){const q=this.b.get(U.channelName);if(!q){this.v(U);return}const Q=new M.CancellationTokenSource;let oe;try{oe=q.call(this.j,U.name,U.arg,Q.token)}catch(O){oe=Promise.reject(O)}const x=U.id;oe.then(O=>{this.m({id:x,data:O,type:201}),this.d.delete(U.id)},O=>{O instanceof Error?this.m({id:x,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.m({id:x,data:O,type:203}),this.d.delete(U.id)});const R=(0,m.toDisposable)(()=>Q.cancel());this.d.set(U.id,R)}t(U){const q=this.b.get(U.channelName);if(!q){this.v(U);return}const Q=U.id,x=q.listen(this.j,U.name,U.arg)(R=>this.m({id:Q,data:R,type:204}));this.d.set(U.id,x)}u(U){const q=this.d.get(U.id);q&&(q.dispose(),this.d.delete(U.id))}v(U){let q=this.g.get(U.channelName);q||(q=[],this.g.set(U.channelName,q));const Q=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:U,timeoutTimer:Q})}w(U){const q=this.g.get(U);if(q){for(const Q of q)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=h;var D;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(U,q=null){this.l=U,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=q}getChannel(U){const q=this;return{call(Q,oe,x){return q.a?Promise.reject(new P.CancellationError):q.m(U,Q,oe,x)},listen(Q,oe){return q.a?g.Event.None:q.o(U,Q,oe)}}}m(U,q,Q,oe=M.CancellationToken.None){const x=this.g++,O={id:x,type:100,channelName:U,name:q,arg:Q};if(oe.isCancellationRequested)return Promise.reject(new P.CancellationError);let W;return new Promise(($,Y)=>{if(oe.isCancellationRequested)return Y(new P.CancellationError);const B=()=>{const ge=ke=>{switch(ke.type){case 201:this.f.delete(x),$(ke.data);break;case 202:{this.f.delete(x);const Oe=new Error(ke.data.message);Oe.stack=Array.isArray(ke.data.stack)?ke.data.stack.join(`
`):ke.data.stack,Oe.name=ke.data.name,Y(Oe);break}case 203:this.f.delete(x),Y(ke.data);break}};this.f.set(x,ge),this.p(O)};let Z=null;this.b===l.Idle?B():(Z=(0,t.createCancelablePromise)(ge=>this.u()),Z.then(()=>{Z=null,B()}));const te=()=>{Z?(Z.cancel(),Z=null):this.p({id:x,type:101}),Y(new P.CancellationError)},ae=oe.onCancellationRequested(te);W=(0,m.combinedDisposable)((0,m.toDisposable)(te),ae),this.d.add(W)}).finally(()=>{this.d.delete(W)})}o(U,q,Q){const oe=this.g++,R={id:oe,type:102,channelName:U,name:q,arg:Q};let O=null;const W=new g.Emitter({onWillAddFirstListener:()=>{O=(0,t.createCancelablePromise)($=>this.u()),O.then(()=>{O=null,this.d.add(W),this.p(R)})},onDidRemoveLastListener:()=>{O?(O.cancel(),O=null):(this.d.delete(W),this.p({id:oe,type:103}))}}),j=$=>W.fire($.data);return this.f.set(oe,j),W.event}p(U){switch(U.type){case 100:case 102:{const q=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(q,U.id,0,`${d(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const q=this.q([U.type,U.id]);this.j?.logOutgoing(q,U.id,0,d(U.type));return}}}q(U,q=void 0){const Q=new i;return c(Q,U),c(Q,q),this.r(Q.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const q=new v(U),Q=s(q),oe=s(q),x=Q[0];switch(x){case 200:return this.j?.logIncoming(U.byteLength,0,0,f(x)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,Q[1],0,f(x),oe),this.t({type:Q[0],id:Q[1],data:oe})}}t(U){if(U.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}pe([A.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class T{get connections(){const U=[];return this.f.forEach(q=>U.push(q)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:q,onDidClientDisconnect:Q})=>{g.Event.once(q.onMessage)(x=>{const R=new v(x),O=s(R),W=new h(q,O),j=new L(q);this.a.forEach((Y,B)=>W.registerChannel(B,Y));const $={channelServer:W,channelClient:j,ctx:O};this.f.add($),this.g.fire($),Q(()=>{W.dispose(),j.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(U,q){const Q=this;return{call(oe,x,R){let O;if((0,y.isFunction)(q)){const j=(0,E.getRandomElement)(Q.connections.filter(q));O=j?Promise.resolve(j):g.Event.toPromise(g.Event.filter(Q.onDidAddConnection,q))}else O=q.routeCall(Q,oe,x);const W=O.then(j=>j.channelClient.getChannel(U));return G(W).call(oe,x,R)},listen(oe,x){if((0,y.isFunction)(q))return Q.j(U,q,oe,x);const R=q.routeEvent(Q,oe,x).then(O=>O.channelClient.getChannel(U));return G(R).listen(oe,x)}}}j(U,q,Q,oe){const x=this;let R=new m.DisposableStore;const O=new g.Emitter({onWillAddFirstListener:()=>{R=new m.DisposableStore;const W=new g.EventMultiplexer,j=new Map,$=B=>{const te=B.channelClient.getChannel(U).listen(Q,oe),ae=W.add(te);j.set(B,ae)},Y=B=>{const Z=j.get(B);!Z||(Z.dispose(),j.delete(B))};x.connections.filter(q).forEach($),g.Event.filter(x.onDidAddConnection,q)($,void 0,R),x.onDidRemoveConnection(Y,void 0,R),W.event(O.fire,O,R),R.add(W)},onDidRemoveLastListener:()=>{R.dispose()}});return O.event}registerChannel(U,q){this.a.set(U,q),this.f.forEach(Q=>{Q.channelServer.registerChannel(U,q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class F{constructor(U,q,Q=null){const oe=new i;c(oe,q),U.send(oe.buffer),this.a=new L(U,Q),this.d=new h(U,q,Q)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,q){this.d.registerChannel(U,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=F;function G(N){return{call(U,q,Q){return N.then(oe=>oe.call(U,q,Q))},listen(U,q){const Q=new g.Relay;return N.then(oe=>Q.input=oe.listen(U,q)),Q.event}}}e.getDelayedChannel=G;function V(N){let U=!1;return{call(q,Q,oe){return U?N.call(q,Q,oe):(0,t.timeout)(0).then(()=>U=!0).then(()=>N.call(q,Q,oe))},listen(q,Q){if(U)return N.listen(q,Q);const oe=new g.Relay;return(0,t.timeout)(0).then(()=>U=!0).then(()=>oe.input=N.listen(q,Q)),oe.event}}}e.getNextTickChannel=V;class K{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const q of U.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await g.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=K;var _;(function(N){function U(x,R){const O=x,W=R&&R.disableMarshalling,j=new Map;for(const $ in O)Q($)&&j.set($,g.Event.buffer(O[$],!0));return new class{listen($,Y,B){const Z=j.get(Y);if(Z)return Z;if(oe(Y)){const te=O[Y];if(typeof te=="function")return te.call(O,B)}throw new Error(`Event not found: ${Y}`)}call($,Y,B){const Z=O[Y];if(typeof Z=="function"){if(!W&&Array.isArray(B))for(let te=0;te<B.length;te++)B[te]=(0,b.revive)(B[te]);return Z.apply(O,B)}throw new Error(`Method not found: ${Y}`)}}}N.fromService=U;function q(x,R){const O=R&&R.disableMarshalling;return new Proxy({},{get(W,j){if(typeof j=="string")return R?.properties?.has(j)?R.properties.get(j):oe(j)?function($){return x.listen(j,$)}:Q(j)?x.listen(j):async function(...$){let Y;R&&!(0,y.isUndefinedOrNull)(R.context)?Y=[R.context,...$]:Y=$;const B=await x.call(j,Y);return O?B:(0,b.revive)(B)};throw new Error(`Property not found: ${String(j)}`)}})}N.toService=q;function Q(x){return x[0]==="o"&&x[1]==="n"&&S.isUpperAsciiLetter(x.charCodeAt(2))}function oe(x){return/^onDynamic/.test(x)&&S.isUpperAsciiLetter(x.charCodeAt(9))}})(_=e.ProxyChannel||(e.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const U=N.toString();if(U!=="[object Object]")return U}return N}function X(N){return Array.isArray(N)?N.map(ce):ce(N)}function ue(N,U,q,Q,oe,x,R){R=X(R);const O=se[oe],W=O[Q%O.length];let j=[`%c[${N}]%c[${String(U).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(x)?(j=j.concat(R),j.push(")")):j.push(R),console.log.apply(console,j)}class z{constructor(U,q){this.d=U,this.f=q,this.a=0,this.b=0}logOutgoing(U,q,Q,oe,x){this.b+=U,ue(this.d,this.b,U,q,Q,oe,x)}logIncoming(U,q,Q,oe,x){this.a+=U,ue(this.f,this.a,U,q,Q,oe,x)}}e.IPCLogger=z}),define(ie[145],re([0,1,17,3,47]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(g){this.a=g,this.onMessage=t.Event.fromDOMEventEmitter(this.a,"message",m=>E.VSBuffer.wrap(m.data)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}e.Protocol=M;class A extends k.IPCClient{constructor(g,m){const b=new M(g);super(b,m),this.b=b}dispose(){this.b.disconnect()}}e.Client=A}),define(ie[102],re([0,1,8,17,3,2,47]),function(H,e,E,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(L){L.Created="created",L.Read="read",L.Write="write",L.Open="open",L.Error="error",L.Close="close",L.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",L.NodeEndReceived="nodeEndReceived",L.NodeEndSent="nodeEndSent",L.NodeDrainBegin="nodeDrainBegin",L.NodeDrainEnd="nodeDrainEnd",L.zlibInflateError="zlibInflateError",L.zlibInflateData="zlibInflateData",L.zlibInflateInitialWrite="zlibInflateInitialWrite",L.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",L.zlibInflateWrite="zlibInflateWrite",L.zlibInflateFlushFired="zlibInflateFlushFired",L.zlibDeflateError="zlibDeflateError",L.zlibDeflateData="zlibDeflateData",L.zlibDeflateWrite="zlibDeflateWrite",L.zlibDeflateFlushFired="zlibDeflateFlushFired",L.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",L.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",L.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",L.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",L.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",L.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",L.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",L.ProtocolHeaderRead="protocolHeaderRead",L.ProtocolMessageRead="protocolMessageRead",L.ProtocolHeaderWrite="protocolHeaderWrite",L.ProtocolMessageWrite="protocolMessageWrite",L.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var g;(function(L){L.enableDiagnostics=!1,L.records=[];const T=new WeakMap;let F=0;function G(K,_){if(!T.has(K)){const se=String(++F);T.set(K,se)}return T.get(K)}function V(K,_,se,ce){if(!L.enableDiagnostics)return;const X=G(K,_);if(ce instanceof t.VSBuffer||ce instanceof Uint8Array||ce instanceof ArrayBuffer||ArrayBuffer.isView(ce)){const ue=t.VSBuffer.alloc(ce.byteLength);ue.set(ce),L.records.push({timestamp:Date.now(),id:X,label:_,type:se,buff:ue})}else L.records.push({timestamp:Date.now(),id:X,label:_,type:se,data:ce})}L.traceSocketEvent=V})(g=e.SocketDiagnostics||(e.SocketDiagnostics={}));var m;(function(L){L[L.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",L[L.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function S(){return b||(b=t.VSBuffer.alloc(0)),b}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,F){if(T===0)return S();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const _=this.a[0];return F&&(this.a.shift(),this.b-=T),_}if(this.a[0].byteLength>T){const _=this.a[0].slice(0,T);return F&&(this.a[0]=this.a[0].slice(T),this.b-=T),_}const G=t.VSBuffer.alloc(T);let V=0,K=0;for(;T>0;){const _=this.a[K];if(_.byteLength>T){const se=_.slice(0,T);G.set(se,V),V+=T,F&&(this.a[K]=_.slice(T),this.b-=T),T-=T}else G.set(_,V),V+=_.byteLength,F?(this.a.shift(),this.b-=_.byteLength):K++,T-=_.byteLength}return G}}e.ChunkStream=y;var u;(function(L){L[L.None=0]="None",L[L.Regular=1]="Regular",L[L.Control=2]="Control",L[L.Ack=3]="Ack",L[L.Disconnect=5]="Disconnect",L[L.ReplayRequest=6]="ReplayRequest",L[L.Pause=7]="Pause",L[L.Resume=8]="Resume",L[L.KeepAlive=9]="KeepAlive",L[L.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",L[L.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(u||(u={}));function d(L){switch(L){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(L){L[L.HeaderLength=13]="HeaderLength",L[L.AcknowledgeTime=2e3]="AcknowledgeTime",L[L.TimeoutTime=2e4]="TimeoutTime",L[L.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",L[L.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",L[L.KeepAliveSendTime=5e3]="KeepAliveSendTime",L[L.LatencySampleTime=6e4]="LatencySampleTime",L[L.LatencySampleCount=5]="LatencySampleCount",L[L.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",L[L.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(T,F,G,V){this.type=T,this.id=F,this.ack=G,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends M.Disposable{constructor(T){super(),this.f=this.B(new k.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new y,this.B(this.a.onData(F=>this.acceptChunk(F))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const F=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=F.readUInt32BE(9),this.g.messageType=F.readUInt8(0),this.g.id=F.readUInt32BE(1),this.g.ack=F.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const G=this.g.messageType,V=this.g.id,K=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",F),this.f.fire(new f(G,V,K,F)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class w{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const F=t.VSBuffer.alloc(13);F.writeUInt8(T.type,0),F.writeUInt32BE(T.id,1),F.writeUInt32BE(T.ack,5),F.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(F,T.data)}g(T,F){const G=this.f===0;return this.d.push(T,F),this.f+=T.byteLength+F.byteLength,G}h(){const T=t.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,F){this.g(T,F)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class C extends M.Disposable{constructor(T){super(),this.f=new k.Emitter,this.onMessage=this.f.event,this.g=new k.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.B(new w(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(F=>{F.type===1&&this.f.fire(F.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new f(1,0,0,T))}}e.Protocol=C;class I extends A.IPCClient{static fromSocket(T,F){return new I(new C(T),F)}get onDidDispose(){return this.b.onDidDispose}constructor(T,F,G=null){super(T,F,G),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=I;class v{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new k.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=v;class i{constructor(T){this.data=T,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let T=0,F=this.a;for(;F;)F=F.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let F=0,G=this.a;for(;G;)T[F++]=G.data,G=G.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const F=new i(T);if(!this.a){this.a=F,this.b=F;return}this.b.next=F,this.b=F}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const T=Date.now();for(let F=0;F<n.a;F++)this.c[F]=T-1e3*F;setInterval(()=>{for(let F=n.a;F>=1;F--)this.c[F]=this.c[F-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),F=(1+n.a)*1e3;let G=0;for(let V=0;V<n.a;V++)T-this.c[V]<=F&&G++;return 1-G/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;var o;(function(L){L[L.Good=0]="Good",L[L.Poor=1]="Poor"})(o=e.ConnectionHealth||(e.ConnectionHealth={}));function a(L){switch(L){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=a;class c{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=c;class s{constructor(T,F){this.roundTripTime=T,this.recentHighRoundTripCount=F}}e.HighRoundTripTimeEvent=s;class h{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new v,this.onControlMessage=this.x.event,this.y=new v,this.onMessage=this.y.event,this.z=new v,this.onDidDispose=this.z.event,this.A=new v,this.onSocketClose=this.A.event,this.B=new v,this.onSocketTimeout=this.B.event,this.C=new v,this.onHighRoundTripTime=this.C.event,this.D=new v,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??n.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new M.DisposableStore,this.o=T.socket,this.p=this.t.add(new w(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new D),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new f(5,0,0,S());this.p.write(T),this.p.flush()}sendPause(){const T=new f(7,0,0,S());this.p.write(T)}sendResume(){const T=new f(8,0,0,S());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,F){this.a=!0,this.t.dispose(),this.t=new M.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new w(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(G=>this.E(G))),this.t.add(this.o.onClose(G=>this.A.fire(G))),this.r=this.t.add(new D),this.t.add(this.r.onSendLatencyRequest(G=>this.J(G))),this.t.add(this.r.onHighRoundTripTime(G=>this.C.fire(G))),this.t.add(this.r.onDidChangeConnectionHealth(G=>this.D.fire(G))),this.q.acceptChunk(F)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new f(3,0,this.h,S());this.p.write(T);const F=this.b.toArray();for(let G=0,V=F.length;G<V;G++)this.p.write(F[G]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const F=this.b.peek();if(F&&F.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const F=Date.now();F-this.m>1e4&&(this.m=F,this.p.write(new f(6,0,0,S())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const F=this.b.toArray();for(let G=0,V=F.length;G<V;G++)this.p.write(F[G]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const F=++this.c;this.h=this.g;const G=new f(1,F,this.h,T);this.b.push(G),this.a||(this.p.write(G),this.G())}sendControl(T){const F=new f(2,0,0,T);this.p.write(F)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),F=Date.now()-T.writtenTime,G=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(F>=2e4&&G>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:F,timeSinceLastReceivedSomeData:G});return}const K=Math.max(2e4-F,2e4-G,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},K)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new f(3,0,this.h,S());this.p.write(T)}I(){this.h=this.g;const T=new f(9,0,this.h,S());this.p.write(T)}J(T){this.h=this.g;const F=new f(10,0,this.h,T);this.p.write(F)}K(T){this.h=this.g;const F=new f(11,0,this.h,T);this.p.write(F)}}e.PersistentProtocol=h;class D extends M.Disposable{constructor(){super(),this.a=this.B(new k.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new k.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new k.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new E.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,F=t.VSBuffer.alloc(4);F.writeUInt32BE(T,0),this.a.fire(F)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const F=T.readUInt32BE(0);if(this.g<=0||F!==this.h)return;const G=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=G;const K=this.l,_=this.j.filter(se=>se>=1e3).length;this.l=_>=3?1:0,G>1e3&&this.b.fire(new s(G,_)),K!==this.l&&this.c.fire(this.l)}}}),define(ie[146],re([0,1,41,17,3,2,47,131]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(b,S){const y=k.Event.fromNodeEventEmitter(E.validatedIpcMain,S,(d,p)=>({event:d,message:p})),u=k.Event.filter(y,({event:d})=>d.sender.id===b);return k.Event.map(u,({message:d})=>d&&t.VSBuffer.wrap(d))}class m extends A.IPCServer{static d(){const S=k.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:y})=>y);return k.Event.map(S,y=>{const u=y.id;m.b.get(u)?.dispose();const p=new k.Emitter;m.b.set(u,(0,M.toDisposable)(()=>p.fire()));const f=g(u,"vscode:message"),l=k.Event.any(k.Event.signal(g(u,"vscode:disconnect")),p.event);return{protocol:new P.Protocol(y,f),onDidClientDisconnect:l}})}constructor(){super(m.d())}}e.Server=m,m.b=new Map}),define(ie[103],re([0,1,41,3,30,145]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class A extends M.Client{constructor(m,b){super({addEventListener:(S,y)=>m.addListener(S,y),removeEventListener:(S,y)=>m.removeListener(S,y),postMessage:S=>m.postMessage(S),start:()=>m.start(),close:()=>m.close()},b)}}e.Client=A;async function P(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();g.webContents.send("vscode:createMessageChannel",m);const b=t.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(y,u)=>({nonce:u,port:y.ports[0]})),{port:S}=await t.Event.toPromise(t.Event.once(t.Event.filter(b,y=>y.nonce===m)));return S}e.connect=P}),define(ie[147],re([0,1,46,8,17,22,140,13,3,2,44,83,80,47]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends u.ChannelServer{constructor(l){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",w=>k.VSBuffer.wrap(Buffer.from(w,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=d;class p{constructor(l,w){this.i=l,this.j=w,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const C=w&&w.timeout?w.timeout:6e4;this.b=new t.Delayer(C),this.d=null,this.f=null}getChannel(l){const w=this;return{call(C,I,v){return w.k(l,C,I,v)},listen(C,I){return w.l(l,C,I)}}}k(l,w,C,I=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(I.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const v=this.n(l),i=(0,t.createCancelablePromise)(o=>v.call(w,C,o)),r=I.onCancellationRequested(()=>i.cancel()),n=(0,m.toDisposable)(()=>i.cancel());return this.c.add(n),i.finally(()=>{r.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,w,C){if(!this.b)return g.Event.None;this.b.cancel();let I;const v=new g.Emitter({onWillAddFirstListener:()=>{I=this.n(l).listen(w,C)(v.fire,v),this.c.add(I)},onDidRemoveLastListener:()=>{this.c.delete(I),I.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return v.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),(0,y.removeDangerousEnvVariables)(w.env),this.d=(0,E.fork)(this.i,l,w);const C=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,A.isRemoteConsoleLog)(a)){(0,A.log)(a,`IPC Library: ${this.j.serverName}`);return}C.fire(k.VSBuffer.wrap(Buffer.from(a,"base64")))});const v=this.j.useQueue?(0,S.createQueuedSender)(this.d):this.d,i=a=>this.d&&this.d.connected&&v.send(a.buffer.toString("base64")),r=C.event,n={send:i,onMessage:r};this.f=new u.ChannelClient(n);const o=()=>this.o();process.once("exit",o),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,c)=>{process.removeListener("exit",o),this.c.forEach(s=>(0,m.dispose)(s)),this.c.clear(),a!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:c})})}return this.f}n(l){let w=this.g.get(l);return w||(w=this.m.getChannel(l),this.g.set(l,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=p}),define(ie[84],re([0,1,17,13,3,2,9,4,30,47,102]),function(H,e,E,t,k,M,A,P,g,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function S(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class y{traceSocketEvent(s,h){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,h)}constructor(s,h=""){this.f=!0,this.debugLabel=h,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,t.onUnexpectedError)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const h=D=>{this.traceSocketEvent("read",D),s(E.VSBuffer.wrap(D))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(s){const h=D=>{s({type:0,hadError:D,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(s){const h=()=>{s()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=y;var u;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(u||(u={}));var d;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(d||(d={}));class p extends M.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,h){this.socket.traceSocketEvent(s,h)}constructor(s,h,D,L){super(),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:D?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new f(this,h,D,L,this.f,(T,F)=>this.k(T,F))),this.B(this.a.onError(T=>{console.error(T),(0,t.onUnexpectedError)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new b.ChunkStream,this.B(this.socket.onData(T=>this.l(T))),this.B(this.socket.onClose(T=>this.g.fire(T)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,h){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let D=2;s.byteLength<126?D+=0:s.byteLength<2**16?D+=2:D+=8;const L=E.VSBuffer.alloc(D);if(h?L.writeUInt8(194,0):L.writeUInt8(130,0),s.byteLength<126)L.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){L.writeUInt8(126,1);let T=1;L.writeUInt8(s.byteLength>>>8&255,++T),L.writeUInt8(s.byteLength>>>0&255,++T)}else{L.writeUInt8(127,1);let T=1;L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(s.byteLength>>>24&255,++T),L.writeUInt8(s.byteLength>>>16&255,++T),L.writeUInt8(s.byteLength>>>8&255,++T),L.writeUInt8(s.byteLength>>>0&255,++T)}this.socket.write(E.VSBuffer.concat([L,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const h=this.b.peek(this.j.readLen),D=h.readUInt8(0),L=(D&128)>>>7,T=(D&64)>>>6,F=h.readUInt8(1),G=(F&128)>>>7,V=F&127;this.j.state=2,this.j.readLen=2+(G?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(T)),this.j.firstFrameOfMessage=Boolean(L),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const h=this.b.read(this.j.readLen),D=h.readUInt8(1),L=(D&128)>>>7;let T=D&127,F=1;T===126?T=h.readUInt8(++F)*2**8+h.readUInt8(++F):T===127&&(T=h.readUInt8(++F)*0+h.readUInt8(++F)*0+h.readUInt8(++F)*0+h.readUInt8(++F)*0+h.readUInt8(++F)*2**24+h.readUInt8(++F)*2**16+h.readUInt8(++F)*2**8+h.readUInt8(++F));let G=0;L&&(G=h.readUInt8(++F)*2**24+h.readUInt8(++F)*2**16+h.readUInt8(++F)*2**8+h.readUInt8(++F)),this.j.state=3,this.j.readLen=T,this.j.mask=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const h=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),C(h,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(h,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class f extends M.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(s,h,D,L,T,F){super(),this.k=s,this.l=T,this.m=F,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,h?(this.b=this.B(new l(this.k,L,D,{windowBits:15})),this.f=this.B(new w(this.k,{windowBits:15})),this.B(this.b.onError(G=>this.a.fire(G))),this.B(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const h=await this.r(this.f,s);this.m(h,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,h){return new Promise((D,L)=>{s.write(h),s.flush(T=>D(T))})}acceptFrame(s,h,D){this.h.push({data:s,isCompressed:h,isLastFrameOfMessage:D}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const h=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(h)}else this.l.fire(s.data)}this.s=!1}}u(s,h,D){return new Promise((L,T)=>{s.write(h),D&&s.write(E.VSBuffer.fromByteArray([0,0,255,255])),s.flush(F=>L(F))})}}class l extends M.Disposable{get recordedInflateBytes(){return this.j?E.VSBuffer.concat(this.f):E.VSBuffer.alloc(0)}constructor(s,h,D,L){super(),this.h=s,this.j=h,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=S().zlib.createInflateRaw(L),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(E.VSBuffer.wrap(T))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const h=E.VSBuffer.concat(this.g);this.g.length=0,s(h)})}}class w extends M.Disposable{constructor(s,h){super(),this.g=s,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.b=S().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(E.VSBuffer.wrap(D))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let h=E.VSBuffer.concat(this.f);this.f.length=0,h=h.slice(0,h.byteLength-4),s(h)})}}function C(c,s){if(s===0)return;const h=c.byteLength>>>2;for(let V=0;V<h;V++){const K=c.readUInt32BE(V*4);c.writeUInt32BE(K^s,V*4)}const D=h*4,L=c.byteLength-D,T=s>>>24&255,F=s>>>16&255,G=s>>>8&255;L>=1&&c.writeUInt8(c.readUInt8(D)^T,D),L>=2&&c.writeUInt8(c.readUInt8(D+1)^F,D+1),L>=3&&c.writeUInt8(c.readUInt8(D+2)^G,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const I={[2]:107,[1]:103};function v(){const c=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):s=(0,A.join)(S().os.tmpdir(),`vscode-ipc-${c}.sock`),r(s),s}e.createRandomIPCHandle=v;function i(c,s,h){const D=S().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${h}-${s}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${h}-${s}.sock`):L=(0,A.join)(c,`${h}-${s}.sock`),r(L),L}e.createStaticIPCHandle=i;function r(c){const s=I[P.platform];typeof s=="number"&&c.length>=s&&console.warn(`WARNING: IPC handle "${c}" is longer than ${s} chars, try a shorter --user-data-dir`)}class n extends m.IPCServer{static b(s){const h=k.Event.fromNodeEventEmitter(s,"connection");return k.Event.map(h,D=>({protocol:new b.Protocol(new y(D,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(D,"close"))}))}constructor(s){super(n.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=n;function o(c){return new Promise((s,h)=>{const D=S().net.createServer();D.on("error",h),D.listen(c,()=>{D.removeListener("error",h),s(new n(D))})})}e.serve=o;function a(c,s){return new Promise((h,D)=>{const L=S().net.createConnection(c,()=>{L.removeListener("error",D),h(b.Client.fromSocket(new y(L,`ipc-client${s}`),s))});L.once("error",D)})}e.connect=a}),define(ie[104],re([0,1,8,3,2,11]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A=e.StorageHint||(e.StorageHint={}));function P(S){const y=S;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var g;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class m extends k.Disposable{constructor(y,u=Object.create(null)){super(),this.m=y,this.n=u,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new E.ThrottledDelayer(m.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(y=>this.r(y)))}r(y){y.changed?.forEach((u,d)=>this.s(d,u)),y.deleted?.forEach(u=>this.s(u,void 0))}s(y,u){if(this.c===g.Closed)return;let d=!1;(0,M.isUndefinedOrNull)(u)?d=this.f.delete(y):this.f.get(y)!==u&&(this.f.set(y,u),d=!0),d&&this.b.fire(y)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(y,u){const d=this.f.get(y);return(0,M.isUndefinedOrNull)(d)?u:d}getBoolean(y,u){const d=this.get(y);return(0,M.isUndefinedOrNull)(d)?u:d==="true"}getNumber(y,u){const d=this.get(y);return(0,M.isUndefinedOrNull)(d)?u:parseInt(d,10)}async set(y,u){if(this.c===g.Closed)return;if((0,M.isUndefinedOrNull)(u))return this.delete(y);const d=String(u);if(this.f.get(y)!==d)return this.f.set(y,d),this.j.set(y,d),this.h.delete(y),this.b.fire(y),this.w()}async delete(y){if(!(this.c===g.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire(y),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(y).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(y){if(!!this.u)return this.w(y)}async w(y){return this.g.trigger(()=>this.v(),y)}async whenFlushed(){if(!!this.u)return new Promise(y=>this.l.push(y))}isInMemory(){return this.n.hint===A.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=m,m.a=100;class b{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((u,d)=>this.a.set(d,u)),y.delete?.forEach(u=>this.a.delete(u))}async close(){}}e.InMemoryStorageDatabase=b}),define(ie[148],re([0,1,8,3,39,9,23]),function(H,e,E,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return t.Event.None}constructor(b,S=Object.create(null)){this.g=b,this.h=S,this.c=(0,M.basename)(this.g),this.d=new g(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,S=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(u=>S.set(u.key,u.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${S.size} rows`),S}async updateItems(b){const S=await this.f;return this.j(S,b)}j(b,S){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${S.insert?(0,k.mapToString)(S.insert):"0"}), delete(${S.delete?(0,k.setToString)(S.delete):"0"})`),this.t(b,()=>{const y=S.insert,u=S.delete;if(y&&y.size>0){const d=[];d.push([]);let p=0;y.forEach((f,l)=>{let w=d[p];w.length>P.b&&(p++,w=[],d.push(w)),w.push(l,f)}),d.forEach(f=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(f.length/2).fill("(?,?)").join(",")}`,l=>l.run(f),()=>{const l=[];let w=0;return y.forEach((C,I)=>{l.push(I),w+=C.length}),`Keys: ${l.join(", ")} Length: ${w}`})})}if(u&&u.size){const d=[];d.push([]);let p=0;u.forEach(f=>{let l=d[p];l.length>P.b&&(p++,l=[],d.push(l)),l.push(f)}),d.forEach(f=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(f.length).fill("?").join(",")})`,l=>l.run(f),()=>{const l=[];return u.forEach(w=>{l.push(w)}),`Keys: ${l.join(", ")}`})})}})}async close(b){this.d.trace(`[storage ${this.c}] close()`);const S=await this.f;return this.k(S,b)}k(b,S){return new Promise((y,u)=>{b.db.close(d=>(d&&this.o(b,`[storage ${this.c}] close(): ${d}`),this.g===P.IN_MEMORY_PATH?y():!b.isErroneous&&!b.isInMemory?this.l().then(y,p=>(this.d.error(`[storage ${this.c}] backup(): ${p}`),y())):typeof S=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(p=>{const f=()=>this.k(p,void 0);return this.j(p,{insert:S()}).then(()=>f(),l=>(f(),Promise.reject(l)))})).then(y,u):u(d||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return A.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const S=await this.f,y=await this.r(S,b?"PRAGMA integrity_check":"PRAGMA quick_check"),u=b?y.integrity_check:y.quick_check;return S.isErroneous?`${u} (last error: ${S.lastError})`:S.isInMemory?`${u} (in-memory!)`:u}async n(b,S=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${S})`);try{return await this.p(b)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&S)return await(0,E.timeout)(P.a),this.n(b,!1);try{await A.Promises.unlink(b);try{await A.Promises.rename(this.m(b),b)}catch{}return await this.p(b)}catch(u){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${u}`),this.p(P.IN_MEMORY_PATH)}}}o(b,S){b.isErroneous=!0,b.lastError=S,this.d.error(S)}p(b){return new Promise((S,y)=>{new Promise((u,d)=>{H(["@vscode/sqlite3"],u,d)}).then(u=>{const d={db:new(this.d.isTracing?u.verbose().Database:u.Database)(b,p=>p?d.db&&p.code!=="SQLITE_CANTOPEN"?d.db.close(()=>y(p)):y(p):this.q(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>S(d),f=>d.db.close(()=>y(f)))),isInMemory:b===P.IN_MEMORY_PATH};d.db.on("error",p=>this.o(d,`[storage ${this.c}] Error (event): ${p}`)),this.d.isTracing&&d.db.on("trace",p=>this.d.trace(`[storage ${this.c}] Trace (event): ${p}`))},y)})}q(b,S){return new Promise((y,u)=>{b.db.exec(S,d=>d?(this.o(b,`[storage ${this.c}] exec(): ${d}`),u(d)):y())})}r(b,S){return new Promise((y,u)=>{b.db.get(S,(d,p)=>d?(this.o(b,`[storage ${this.c}] get(): ${d}`),u(d)):y(p))})}s(b,S){return new Promise((y,u)=>{b.db.all(S,(d,p)=>d?(this.o(b,`[storage ${this.c}] all(): ${d}`),u(d)):y(p))})}t(b,S){return new Promise((y,u)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),S(),b.db.run("END TRANSACTION",d=>d?(this.o(b,`[storage ${this.c}] transaction(): ${d}`),u(d)):y())})})}u(b,S,y,u){const d=b.db.prepare(S),p=f=>{this.o(b,`[storage ${this.c}] prepare(): ${f} (${S}). Details: ${u()}`)};d.on("error",p),y(d),d.finalize(f=>{f&&p(f),d.removeListener("error",p)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.a=2e3,P.b=256;class g{constructor(b){b&&typeof b.logTrace=="function"&&process.env[g.VSCODE_TRACE_STORAGE]&&(this.a=b.logTrace),b&&typeof b.logError=="function"&&(this.b=b.logError)}get isTracing(){return!!this.a}trace(b){this.a?.(b)}error(b){this.b?.(b)}}g.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ie[149],re([12,10]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(ie[150],re([12,10]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[151],re([12,10]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ie[152],re([12,10]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(ie[153],re([12,10]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(ie[154],re([12,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[155],re([12,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[156],re([12,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[157],re([12,10]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[158],re([12,10]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ie[159],re([12,10]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(ie[160],re([12,10]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(ie[161],re([12,10]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(ie[162],re([12,10]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ie[163],re([12,10]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[164],re([12,10]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ie[165],re([12,10]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(ie[166],re([12,10]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ie[167],re([12,10]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(ie[168],re([12,10]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(ie[169],re([12,10]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[170],re([12,10]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(ie[171],re([12,10]),function(H,e){return H.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[172],re([12,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ie[173],re([12,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ie[174],re([12,10]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(ie[175],re([12,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ie[176],re([12,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ie[177],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ie[178],re([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(A){return typeof A?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(A){let P=[];try{Array.isArray(A.workspaces)&&(P=A.workspaces.map(g=>({workspace:{id:g.id,configPath:E.URI.parse(g.configURIPath)},remoteAuthority:g.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=k;function M(A){let P=[];try{Array.isArray(A.folders)&&(P=A.folders.map(g=>({folderUri:E.URI.parse(g.folderUri),remoteAuthority:g.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=M}),define(ie[179],re([0,1,3,2]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(P,g,m){switch(g){case"close":return Promise.resolve(this.a.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(P,g,m){switch(g){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class M extends t.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,g,m){this.b.call("attach",[P,g,m])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,g){this.b.call("terminate",[P,g])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,g){return this.b.call("openExtensionDevelopmentHostWindow",[P,g])}}e.ExtensionHostDebugChannelClient=M}),define(ie[180],re([0,1,134,54,15,9,33,20,7]),function(H,e,E,t,k,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,M.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,M.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(g.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=A.env.VSCODE_PORTABLE;return d?g.URI.file((0,M.join)(d,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,M.resolve)(d):(0,M.normalize)((0,M.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?g.URI.file((0,M.resolve)(d)):g.URI.file((0,M.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,M.resolve)(d);const p=A.env.VSCODE_EXTENSIONS;if(p)return p;const f=A.env.VSCODE_PORTABLE;return f?(0,M.join)(f,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(p=>/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,M.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?g.URI.parse(d):g.URI.file((0,M.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const p of this.args.log||[]){const f=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);f&&f[1]&&f[2]&&d.push([f[1],f[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=A.env.VSCODE_PORTABLE;return d?g.URI.file((0,M.join)(d,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,p,f){this.a=d,this.b=p,this.c=f,this.editSessionId=this.args.editSessionId}}pe([t.memoize],m.prototype,"appRoot",null),pe([t.memoize],m.prototype,"userHome",null),pe([t.memoize],m.prototype,"userDataPath",null),pe([t.memoize],m.prototype,"appSettingsHome",null),pe([t.memoize],m.prototype,"tmpDir",null),pe([t.memoize],m.prototype,"cacheHome",null),pe([t.memoize],m.prototype,"stateResource",null),pe([t.memoize],m.prototype,"userRoamingDataHome",null),pe([t.memoize],m.prototype,"userDataSyncHome",null),pe([t.memoize],m.prototype,"userDataSyncLogResource",null),pe([t.memoize],m.prototype,"editSessionsLogResource",null),pe([t.memoize],m.prototype,"sync",null),pe([t.memoize],m.prototype,"machineSettingsResource",null),pe([t.memoize],m.prototype,"workspaceStorageHome",null),pe([t.memoize],m.prototype,"localHistoryHome",null),pe([t.memoize],m.prototype,"keyboardLayoutResource",null),pe([t.memoize],m.prototype,"argvResource",null),pe([t.memoize],m.prototype,"isExtensionDevelopment",null),pe([t.memoize],m.prototype,"untitledWorkspacesHome",null),pe([t.memoize],m.prototype,"installSourcePath",null),pe([t.memoize],m.prototype,"builtinExtensionsPath",null),pe([t.memoize],m.prototype,"extensionsPath",null),pe([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],m.prototype,"extensionDevelopmentKind",null),pe([t.memoize],m.prototype,"extensionTestsLocationURI",null),pe([t.memoize],m.prototype,"debugExtensionHost",null),pe([t.memoize],m.prototype,"logLevel",null),pe([t.memoize],m.prototype,"extensionLogLevel",null),pe([t.memoize],m.prototype,"serviceMachineIdResource",null),pe([t.memoize],m.prototype,"telemetryLogResource",null),pe([t.memoize],m.prototype,"disableWorkspaceTrust",null),pe([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function b(u,d){return y(u["inspect-extensions"],u["inspect-brk-extensions"],5870,d,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=b;function S(u,d){return y(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,d,u.extensionEnvironment)}e.parsePtyHostPort=S;function y(u,d,p,f,l,w){const I=Number(d||u)||(f?null:p),v=I?Boolean(!!d):!1;let i;if(w)try{i=JSON.parse(w)}catch{}return{port:I,break:v,debugId:l,env:i}}}),define(ie[105],re([0,1,280,4,152]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},category:{type:"string",cat:"e",description:(0,k.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(p,f,l=A){const w=p.find(c=>c.length>0&&c[0]!=="-"),C={},I=["_"],v=[],i={};let r;for(const c in f){const s=f[c];s.type==="subcommand"?c===w&&(r=s):(s.alias&&(C[c]=s.alias),s.type==="string"||s.type==="string[]"?(I.push(c),s.deprecates&&I.push(...s.deprecates)):s.type==="boolean"&&(v.push(c),s.deprecates&&v.push(...s.deprecates)),s.global&&(i[c]=s))}if(r&&w){const c=i;for(const L in r.options)c[L]=r.options[L];const s=p.filter(L=>L!==w),h=l.getSubcommandReporter?l.getSubcommandReporter(w):void 0,D=P(s,c,h);return{[w]:D,_:[]}}const n=E(p,{string:I,boolean:v,alias:C}),o={},a=n;o._=n._.map(c=>String(c)).filter(c=>c.length>0),delete a._;for(const c in f){const s=f[c];if(s.type==="subcommand")continue;s.alias&&delete a[s.alias];let h=a[c];if(s.deprecates)for(const D of s.deprecates)a.hasOwnProperty(D)&&(h||(h=a[D],h&&l.onDeprecatedOption(D,s.deprecationMessage||(0,k.localize)(36,null,c))),delete a[D]);if(typeof h<"u"){if(s.type==="string[]"){if(Array.isArray(h)||(h=[h]),!s.allowEmptyValue){const D=h.filter(L=>L.length>0);D.length!==h.length&&(l.onEmptyValue(c),h=D.length>0?D:void 0)}}else s.type==="string"&&(Array.isArray(h)?(h=h.pop(),l.onMultipleValues(c,h)):!h&&!s.allowEmptyValue&&(l.onEmptyValue(c),h=void 0));o[c]=h,s.deprecationMessage&&l.onDeprecatedOption(c,s.deprecationMessage)}delete a[c]}for(const c in a)l.onUnknownOption(c);return o}e.parseArgs=P;function g(p,f){let l="";return f.args&&(Array.isArray(f.args)?l=` <${f.args.join("> <")}>`:l=` <${f.args}>`),f.alias?`-${f.alias} --${p}${l}`:`--${p}${l}`}function m(p,f){const l=[];for(const w in p){const C=p[w],I=g(w,C);l.push([I,C.description])}return b(l,f)}e.formatOptions=m;function b(p,f){const w=p.reduce((v,i)=>Math.max(v,i[0].length),12)+2+1;if(f-w<25)return p.reduce((v,i)=>v.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const C=f-w-1,I=[];for(const v of p){const i=v[0],r=y(v[1],C),n=S(w-i.length-2);I.push("  "+i+n+r[0]);for(let o=1;o<r.length;o++)I.push(S(w)+r[o])}return I}function S(p){return" ".repeat(p)}function y(p,f){const l=[];for(;p.length;){const w=p.length<f?p.length:p.lastIndexOf(" ",f),C=p.slice(0,w).trim();p=p.slice(w),l.push(C)}return l}function u(p,f,l,w,C){const I=process.stdout.isTTY&&process.stdout.columns||80,v=C?.noInputFiles!==!0?`[${(0,k.localize)(37,null)}...]`:"",i=[`${p} ${l}`];i.push(""),i.push(`${(0,k.localize)(38,null)}: ${f} [${(0,k.localize)(39,null)}]${v}`),i.push(""),C?.noPipe!==!0&&(t.isWindows?i.push((0,k.localize)(40,null,f)):i.push((0,k.localize)(41,null,f)),i.push(""));const r={},n=[];for(const o in w){const a=w[o];if(a.type==="subcommand")a.description&&n.push({command:o,description:a.description});else if(a.description&&a.cat){let c=r[a.cat];c||(r[a.cat]=c={}),c[o]=a}}for(const o in r){const a=o,c=r[a];c&&(i.push(M[a]),i.push(...m(c,I)),i.push(""))}return n.length&&(i.push((0,k.localize)(42,null)),i.push(...b(n.map(o=>[o.command,o.description]),I)),i.push("")),i.join(`
`)}e.buildHelpMessage=u;function d(p,f){return`${p||(0,k.localize)(43,null)}
${f||(0,k.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(ie[181],re([0,1,79,179,105]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends t.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.f=P}call(P,g,m){return g==="openExtensionDevelopmentHostWindow"?this.g(m[0],m[1]):super.call(P,g,m)}async g(P,g){const m=(0,k.parseArgs)(P,k.OPTIONS);m.debugRenderer=g;const b=m.extensionDevelopmentPath;if(!b)return{success:!1};const[S]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!g)return{success:!0};const y=S.win;if(!y)return{success:!0};const u=y.webContents.debugger;let d=u.isAttached()?1/0:0;const p=(0,E.createServer)(f=>{d++===0&&u.attach();let l=!1;const w=v=>{l||f.write(JSON.stringify(v)+"\0")},C=(v,i,r,n)=>w({method:i,params:r,sessionId:n});y.on("close",()=>{u.removeListener("message",C),f.end(),l=!0}),u.addListener("message",C);let I=Buffer.alloc(0);f.on("data",v=>{I=Buffer.concat([I,v]);for(let i=I.indexOf(0);i!==-1;i=I.indexOf(0)){let r;try{const n=I.slice(0,i).toString("utf8");I=I.slice(i+1),r=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}u.sendCommand(r.method,r.params,r.sessionId).then(n=>w({id:r.id,sessionId:r.sessionId,result:n})).catch(n=>w({id:r.id,sessionId:r.sessionId,error:{code:0,message:n.message}}))}}),f.on("error",v=>{console.error("error on cdp pipe:",v)}),f.on("close",()=>{l=!0,--d===0&&u.detach()})});return await new Promise(f=>p.listen(0,f)),y.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),define(ie[61],re([0,1,281,153,105]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const M=2048;function A(y,u){const d=(I,v)=>{console.warn((0,t.localize)(0,null,I,v))},p=I=>{console.warn((0,t.localize)(1,null,I))},f=(I,v)=>{console.warn((0,t.localize)(2,null,I,v))},l=I=>({onUnknownOption:v=>{I!=="tunnel"&&console.warn((0,t.localize)(3,null,v,I))},onMultipleValues:d,onEmptyValue:p,onDeprecatedOption:f,getSubcommandReporter:I!=="tunnel"?l:void 0}),w={onUnknownOption:I=>{console.warn((0,t.localize)(4,null,I))},onMultipleValues:d,onEmptyValue:p,onDeprecatedOption:f,getSubcommandReporter:l},C=(0,k.parseArgs)(y,k.OPTIONS,u?w:void 0);return C.goto&&C._.forEach(I=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,t.localize)(5,null))),C["max-memory"]&&E(parseInt(C["max-memory"])>=M,`The max-memory argument cannot be specified lower than ${M} MB.`),C}function P(y){const u=y.findIndex(d=>!/^-/.test(d));if(u>-1)return[...y.slice(0,u),...y.slice(u+1)]}function g(y){let[,...u]=y;process.env.VSCODE_DEV&&(u=P(u)||[]);const d=!S(process.env);return A(u,d)}e.parseMainProcessArgv=g;function m(y){let[,,...u]=y;return process.env.VSCODE_DEV&&(u=P(u)||[]),A(u,!0)}e.parseCLIProcessArgv=m;function b(y,...u){const d=y.indexOf("--");return d===-1?y.push(...u):y.splice(d,0,...u),y}e.addArg=b;function S(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),function(){"use strict";function H(e,E,t){function k(A,P){const g=M(A,P),m=[g];return e.isAbsolute(g)||m.unshift(t),e.resolve(...m)}function M(A,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,P);const b=A["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(S,"AppData","Roaming")}break;case"darwin":m=e.join(E.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,P)}return{getUserDataPath:k}}if(typeof define=="function")define(ie[182],re([183,25,33]),function(e,E,t){return H(e,E,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=H(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[184],re([0,1,25,180,182]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends t.AbstractNativeEnvironmentService{constructor(P,g){super(P,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,k.getUserDataPath)(P,g.nameShort)},g)}}e.NativeEnvironmentService=M}),define(ie[185],re([0,1,40,25,31]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function M(A){const P=(0,k.randomPath)((0,t.tmpdir)());try{return(0,E.writeFileSync)(P,""),A&&console.log(`Marker file for --wait created: ${P}`),P}catch(g){A&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFileSync=M}),define(ie[186],re([0,1,11,155]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(A,P,g){try{M(A,P,g)}catch(m){console.error(m?.message??m)}return A}e.localizeManifest=k;function M(A,P,g){const m=(b,S,y)=>{const u=b[S];if((0,E.isString)(u)){const d=u,p=d.length;if(p>1&&d[0]==="%"&&d[p-1]==="%"){const f=d.substr(1,p-2);let l=P[f];l===void 0&&g&&(l=g[f]);const w=typeof l=="string"?l:l?.message,C=g?.[f],I=typeof C=="string"?C:C?.message;if(!w){I||console.warn(`[${A.name}]: ${(0,t.localize)(0,null,f)}`);return}if(y&&(S==="title"||S==="category")&&I&&I!==w){const v={value:w,original:I};b[S]=v}else b[S]=w}}else if((0,E.isObject)(u))for(const d in u)u.hasOwnProperty(d)&&(d==="commands"?m(u,d,!0):m(u,d,y));else if(Array.isArray(u))for(let d=0;d<u.length;d++)m(u,d,y)};for(const b in A)A.hasOwnProperty(b)&&m(A,b)}}),define(ie[187],re([0,1,13]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(M,A){this.a.set(M,A)}updateManifest(M){if(!(typeof M.main>"u"&&typeof M.browser>"u")&&(M.activationEvents===void 0&&Object.assign(M,{activationEvents:[]}),!(!Array.isArray(M.activationEvents)||!M.contributes)))for(const A in M.contributes){const P=this.a.get(A);if(!P)continue;const g=M.contributes[A],m=Array.isArray(g)?g:[g];try{P(m,M.activationEvents)}catch(b){(0,E.onUnexpectedError)(b)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ie[188],re([0,1,20,98,157,189]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function g(l){return l=l.trim(),l==="*"||A.test(l)}e.isValidVersionStr=g;function m(l){if(!g(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=l.match(A);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=m;function b(l){if(!l)return null;const w=l.majorBase,C=l.majorMustEqual,I=l.minorBase;let v=l.minorMustEqual;const i=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(w===0||(v=!1),r=!1);let n=0;if(l.preRelease){const o=P.exec(l.preRelease);if(o){const[,a,c,s]=o;n=Date.UTC(Number(a),Number(c)-1,Number(s))}}return{majorBase:w,majorMustEqual:C,minorBase:I,minorMustEqual:v,patchBase:i,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:n}}e.normalizeVersion=b;function S(l,w,C){let I;typeof l=="string"?I=b(m(l)):I=l;let v;w instanceof Date?v=w.getTime():typeof w=="string"&&(v=new Date(w).getTime());let i;if(typeof C=="string"?i=b(m(C)):i=C,!I||!i)return!1;const r=I.majorBase,n=I.minorBase,o=I.patchBase;let a=i.majorBase,c=i.minorBase,s=i.patchBase;const h=i.notBefore;let D=i.majorMustEqual,L=i.minorMustEqual,T=i.patchMustEqual;return i.isMinimum?r>a?!0:r<a?!1:n>c?!0:n<c||v&&v<h?!1:o>=s:(r===1&&a===0&&(!D||!L||!T)&&(a=1,c=0,s=0,D=!0,L=!1,T=!1),r<a?!1:r>a?!D:n<c?!1:n>c?!L:o<s?!1:o>s?!T:!(v&&v<h))}e.isValidVersion=S;function y(l,w,C,I,v){const i=[];if(typeof I.publisher<"u"&&typeof I.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof I.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof I.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!I.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof I.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof I.extensionDependencies<"u"&&!f(I.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof I.activationEvents<"u"){if(!f(I.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof I.main>"u"&&typeof I.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof I.extensionKind<"u"&&typeof I.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof I.main<"u"){if(typeof I.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const o=(0,E.joinPath)(C,I.main);(0,E.isEqualOrParent)(o,C)||i.push([t.default.Warning,k.localize(10,null,o.path,C.path)])}if(typeof I.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof I.browser<"u"){if(typeof I.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const o=(0,E.joinPath)(C,I.browser);(0,E.isEqualOrParent)(o,C)||i.push([t.default.Warning,k.localize(13,null,o.path,C.path)])}if(typeof I.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!M.valid(I.version))return i.push([t.default.Error,k.localize(15,null)]),i;const r=[];if(!u(l,w,I,v,r))for(const o of r)i.push([t.default.Error,o]);return i}e.validateExtensionManifest=y;function u(l,w,C,I,v){return I||typeof C.main>"u"&&typeof C.browser>"u"?!0:p(l,w,C.engines.vscode,v)}e.isValidExtensionVersion=u;function d(l,w,C){return l==="*"||p(w,C,l)}e.isEngineValid=d;function p(l,w,C,I=[]){const v=b(m(C));if(!v)return I.push(k.localize(16,null,C)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return I.push(k.localize(17,null,C)),!1}else if(!v.majorMustEqual)return I.push(k.localize(18,null,C)),!1;return S(l,w,v)?!0:(I.push(k.localize(19,null,l,C)),!1)}function f(l){if(!Array.isArray(l))return!1;for(let w=0,C=l.length;w<C;w++)if(typeof l[w]!="string")return!1;return!0}}),define(ie[190],re([0,1,17,30]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(M,A,P){let g=P&&P.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const b=(await A.readFile(M.serviceMachineIdResource)).value.toString();g=(0,t.isUUID)(b)?b:null}catch{g=null}if(!g){g=(0,t.generateUuid)();try{await A.writeFile(M.serviceMachineIdResource,E.VSBuffer.fromString(g))}catch{}}return P?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=k}),define(ie[70],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(k,M=[],A=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=E}),define(ie[191],re([0,1,70]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function M(P,g,m){g instanceof E.SyncDescriptor||(g=new E.SyncDescriptor(g,[],Boolean(m))),t.push([P,g])}e.registerSingleton=M;function A(){return t}e.getSingletonServiceDescriptors=A}),define(ie[192],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class t{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const P=this.lookupOrInsertNode(M),g=this.lookupOrInsertNode(A);P.outgoing.set(g.key,g),g.incoming.set(P.key,P)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const P of this.a.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let P=this.a.get(A);return P||(P=new E(A,M),this.a.set(A,P)),P}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,P]of this.a)M.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const P=new Set([M]),g=this.c(A,P);if(g)return g}}c(M,A){for(const[P,g]of M.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const m=this.c(g,A);if(m)return m;A.delete(P)}}}e.Graph=t}),define(ie[5],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(g){return g[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(E=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(A,P,g){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:A,index:g}):(P[E.DI_DEPENDENCIES]=[{id:A,index:g}],P[E.DI_TARGET]=P)}function k(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const P=function(g,m,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,g,b)};return P.toString=()=>A,E.serviceIds.set(A,P),P}e.createDecorator=k;function M(A){return A}e.refineServiceDecorator=M}),define(ie[62],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(ie[18],re([0,1,11,7,5]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function M(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof t.URI)}e.isConfigurationOverrides=M;function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function m(l,w){const C=Object.create(null);for(const I in l)b(C,I,l[I],w);return C}e.toValuesTree=m;function b(l,w,C,I){const v=w.split("."),i=v.pop();let r=l;for(let n=0;n<v.length;n++){const o=v[n];let a=r[o];switch(typeof a){case"undefined":a=r[o]=Object.create(null);break;case"object":break;default:I(`Ignoring ${w} as ${v.slice(0,n+1).join(".")} is ${JSON.stringify(a)}`);return}r=a}if(typeof r=="object"&&r!==null)try{r[i]=C}catch{I(`Ignoring ${w} as ${v.join(".")} is ${JSON.stringify(r)}`)}else I(`Ignoring ${w} as ${v.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=b;function S(l,w){const C=w.split(".");y(l,C)}e.removeFromValueTree=S;function y(l,w){const C=w.shift();if(w.length===0){delete l[C];return}if(Object.keys(l).indexOf(C)!==-1){const I=l[C];typeof I=="object"&&!Array.isArray(I)&&(y(I,w),Object.keys(I).length===0&&delete l[C])}}function u(l,w,C){function I(r,n){let o=r;for(const a of n){if(typeof o!="object"||o===null)return;o=o[a]}return o}const v=w.split("."),i=I(l,v);return typeof i>"u"?C:i}e.getConfigurationValue=u;function d(l,w,C){Object.keys(w).forEach(I=>{I!=="__proto__"&&(I in l?E.isObject(l[I])&&E.isObject(w[I])?d(l[I],w[I],C):C&&(l[I]=w[I]):l[I]=w[I])})}e.merge=d;function p(l,w,C){const I=l.inspect(w),v=l.inspect(C);return typeof I.userValue<"u"||typeof I.workspaceValue<"u"||typeof I.workspaceFolderValue<"u"?I.value:typeof v.userValue<"u"||typeof v.workspaceValue<"u"||typeof v.workspaceFolderValue<"u"?v.value:I.defaultValue}e.getMigratedSettingValue=p;function f(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(ie[71],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(M,A){return this.a[M]?.[A]??null}async setPassword(M,A,P){this.a[M]=this.a[M]??{},this.a[M][A]=P}async deletePassword(M,A){return this.a[M]?.[A]?(delete this.a[M][A],Object.keys(this.a[M]).length===0&&delete this.a[M],!0):!1}async findPassword(M){return JSON.stringify(this.a[M])??null}async findCredentials(M){const A=[];for(const P of Object.keys(this.a[M]||{}))A.push({account:P,password:this.a[M][P]});return A}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(ie[85],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function t(M){return!!M.hostName&&!!M.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(A,P){return{}}async getSystemInfo(A,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,P){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=k}),define(ie[106],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ie[35],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[27],re([0,1,54,9,84,35,184,5]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(M.IEnvironmentService);class g extends A.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}pe([E.memoize],g.prototype,"cachedLanguagesPath",null),pe([E.memoize],g.prototype,"backupHome",null),pe([E.memoize],g.prototype,"mainIPCHandle",null),pe([E.memoize],g.prototype,"mainLockfile",null),pe([E.memoize],g.prototype,"disableUpdates",null),pe([E.memoize],g.prototype,"disableKeytar",null),pe([E.memoize],g.prototype,"crossOriginIsolated",null),pe([E.memoize],g.prototype,"codeCachePath",null),pe([E.memoize],g.prototype,"useCodeCache",null),e.EnvironmentMainService=g}),define(ie[193],re([0,1,154,5]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function M(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function A(l,w){switch(l){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function P(l,w){return w==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function g(l,w,C){return P(w,C)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===C?!0:m(C).includes(l)}e.isTargetPlatformCompatible=g;function m(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function b(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=b;var S;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var y;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var u;(function(l){l.Install="install",l.Uninstall="uninstall"})(u=e.StatisticType||(e.StatisticType={}));var d;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var p;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(w,C){super(w),this.code=C,this.name=C}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ie[194],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(ie[195],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ie[107],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(ie[196],re([0,1,46,15,9,4,80,23,83,158,107]),function(H,e,E,t,k,M,A,P,g,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const S=m.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:u.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class u extends y{openTerminal(I,v){return this.spawnTerminal(E,I,g.getWindowsShell(),v)}spawnTerminal(I,v,i,r){const n=v.windowsExec||u.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const o=k.basename(n).toLowerCase();if(o==="cmder"||o==="cmder.exe")return I.spawn(n,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return n.indexOf(" ")>=0&&a.push('""'),a.push(n),(o==="wt"||o==="wt.exe")&&a.push("-d ."),new Promise((c,s)=>{const h=f(process),D=I.spawn(i,a,{cwd:r,env:h});D.on("error",s),D.on("exit",()=>c())})}runInTerminal(I,v,i,r,n){const o="windowsExec"in n&&n.windowsExec?n.windowsExec:u.getDefaultTerminalWindows();return new Promise((a,c)=>{const s=`"${v} - ${S}"`,h=`""${i.join('" "')}" & pause"`,D=["/c","start",s,"/wait",o,"/c",h],L=Object.assign({},f(process),r);Object.keys(L).filter(G=>L[G]===null).forEach(G=>delete L[G]);const T={cwd:v,env:L,windowsVerbatimArguments:!0};E.spawn(u.b,D,T).on("error",G=>{c(l(G))}),a(void 0)})}static getDefaultTerminalWindows(){if(!u.d){const I=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${I?"Sysnative":"System32"}\\cmd.exe`}return u.d}}e.WindowsExternalTerminalService=u,u.b="cmd.exe";class d extends y{openTerminal(I,v){return this.spawnTerminal(E,I,v)}runInTerminal(I,v,i,r,n){const o=n.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((a,c)=>{if(o===b.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const s=o===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`).fsPath,"-t",I||S,"-w",v];for(const F of i)D.push("-a"),D.push(F);if(r){const F=Object.assign({},f(process),r);for(const G in F){const V=F[G];V===null?(D.push("-u"),D.push(G)):(D.push("-e"),D.push(`${G}=${V}`))}}let L="";const T=E.spawn(d.b,D);T.on("error",F=>{c(l(F))}),T.stderr.on("data",F=>{L+=F.toString()}),T.on("exit",F=>{if(F===0)a(void 0);else if(L){const G=L.split(`
`,1);c(new Error(G[0]))}else c(new Error(m.localize(1,null,s,F)))})}else c(new Error(m.localize(2,null,o)))})}spawnTerminal(I,v,i){const r=v.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((n,o)=>{const a=["-a",r];i&&a.push(i);const c=f(process),s=I.spawn("/usr/bin/open",a,{cwd:i,env:c});s.on("error",o),s.on("exit",()=>n())})}}e.MacExternalTerminalService=d,d.b="/usr/bin/osascript";class p extends y{openTerminal(I,v){return this.spawnTerminal(E,I,v)}runInTerminal(I,v,i,r,n){const o=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((a,c)=>{const s=[];o.then(h=>{h.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const D=`${w(i)}; echo; read -p "${p.b}" -n1;`;s.push(`''${D}''`);const L=Object.assign({},f(process),r);Object.keys(L).filter(V=>L[V]===null).forEach(V=>delete L[V]);const T={cwd:v,env:L};let F="";const G=E.spawn(h,s,T);G.on("error",V=>{c(l(V))}),G.stderr.on("data",V=>{F+=V.toString()}),G.on("exit",V=>{if(V===0)a(void 0);else if(F){const K=F.split(`
`,1);c(new Error(K[0]))}else c(new Error(m.localize(4,null,h,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!M.isLinux)p.d=Promise.resolve("xterm");else{const I=await P.Promises.exists("/etc/debian_version");p.d=new Promise(v=>{I?v("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?v("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?v("konsole"):process.env.COLORTERM?v(process.env.COLORTERM):process.env.TERM?v(process.env.TERM):v("xterm")})}return p.d}spawnTerminal(I,v,i){const r=v.linuxExec?Promise.resolve(v.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{r.then(a=>{const c=f(process),s=I.spawn(a,[],{cwd:i,env:c});s.on("error",o),s.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=p,p.b=m.localize(3,null);function f(C){const I={...C.env};return(0,A.sanitizeProcessEnvironment)(I),I}function l(C){return"errno"in C&&C.errno==="ENOENT"&&"path"in C&&typeof C.path=="string"?new Error(m.localize(5,null,C.path)):C}function w(C){let I="";for(const v of C)v.indexOf(" ")>=0?I+='"'+v+'"':I+=v,I+=" ";return I}}),define(ie[16],re([0,1,60,9,26,11,7,160,5]),function(H,e,E,t,k,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,g.createDecorator)("fileService");function m(X){return X.create===!0}e.isFileOpenForWriteOptions=m;var b;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var S;(function(X){X[X.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var y;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(X){return!!(X.capabilities&2)}e.hasReadWriteCapability=u;function d(X){return!!(X.capabilities&8)}e.hasFileFolderCopyCapability=d;function p(X){return!!(X.capabilities&32768)}e.hasFileCloneCapability=p;function f(X){return!!(X.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function l(X){return!!(X.capabilities&16)}e.hasFileReadStreamCapability=l;function w(X){return u(X)?!!(X.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var C;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(ue,z){super(ue),this.code=z}}e.FileSystemProviderError=I;function v(X,ue){const z=new I(X.toString(),ue);return r(z,ue),z}e.createFileSystemProviderError=v;function i(X){return X||v((0,P.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=i;function r(X,ue){return X.name=ue?`${ue} (FileSystemError)`:"FileSystemError",X}e.markAsFileSystemProviderError=r;function n(X){if(!X)return C.Unknown;if(X instanceof I)return X.code;const ue=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!ue)return C.Unknown;switch(ue[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=n;function o(X){if(X instanceof L)return X.fileOperationResult;switch(n(X)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var a;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class c{constructor(ue,z,N){this.resource=ue,this.operation=z,this.target=N}isOperation(ue){return this.operation===ue}}e.FileOperationEvent=c;var s;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class h{constructor(ue,z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const N=new Map;for(const U of ue){const q=N.get(U.type);switch(q?q.push([U.resource,U]):N.set(U.type,[[U.resource,U]]),U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}}for(const[U,q]of N)switch(U){case 1:this.a=E.TernarySearchTree.forUris(()=>z),this.a.fill(q);break;case 0:this.b=E.TernarySearchTree.forUris(()=>z),this.b.fill(q);break;case 2:this.c=E.TernarySearchTree.forUris(()=>z),this.c.fill(q);break}}contains(ue,...z){return this.d(ue,{includeChildren:!1},...z)}affects(ue,...z){return this.d(ue,{includeChildren:!0},...z)}d(ue,z,...N){if(!ue)return!1;const U=N.length>0;return!!((!U||N.includes(1))&&(this.a?.get(ue)||z.includeChildren&&this.a?.findSuperstr(ue))||(!U||N.includes(0))&&(this.b?.get(ue)||z.includeChildren&&this.b?.findSuperstr(ue))||(!U||N.includes(2))&&(this.c?.findSubstr(ue)||z.includeChildren&&this.c?.findSuperstr(ue)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=h;function D(X,ue,z){return!X||!ue||X===ue||ue.length>X.length?!1:(ue.charAt(ue.length-1)!==t.sep&&(ue+=t.sep),z?(0,k.startsWithIgnoreCase)(X,ue):X.indexOf(ue)===0)}e.isParent=D;class L extends Error{constructor(ue,z,N){super(ue),this.fileOperationResult=z,this.options=N}}e.FileOperationError=L;class T extends L{constructor(ue,z,N){super(ue,2,N),this.stat=z}}e.NotModifiedSinceFileOperationError=T;var F;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",X[X.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var G;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(G=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.etag=V;async function K(X,ue){if(!ue.hasProvider(A.URI.from({scheme:X.scheme})))return new Promise(z=>{const N=ue.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===X.scheme&&U.added&&(N.dispose(),z())})})}e.whenProviderRegistered=K,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class _{static formatSize(ue){return(0,M.isNumber)(ue)||(ue=0),ue<_.KB?(0,P.localize)(1,null,ue.toFixed(0)):ue<_.MB?(0,P.localize)(2,null,(ue/_.KB).toFixed(2)):ue<_.GB?(0,P.localize)(3,null,(ue/_.MB).toFixed(2)):ue<_.TB?(0,P.localize)(4,null,(ue/_.GB).toFixed(2)):(0,P.localize)(5,null,(ue/_.TB).toFixed(2))}}e.ByteSize=_,_.KB=1024,_.MB=_.KB*_.KB,_.GB=_.MB*_.KB,_.TB=_.GB*_.KB;var se;(function(X){X[X.IA32=0]="IA32",X[X.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function ce(X){return{maxFileSize:X===0?300*_.MB:16*_.GB,maxHeapSize:X===0?700*_.MB:2*700*_.MB}}e.getPlatformLimits=ce}),define(ie[197],re([0,1,17,45,13,3,2,59,7,30,16]),function(H,e,E,t,k,M,A,P,g,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends A.Disposable{constructor(u,d){super(),this.a=u,this.b=d,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new M.Emitter),this.onDidWatchError=this.g.event,this.h=(0,m.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,d){const{buffer:p}=await this.a.call("readFile",[u,d]);return p}readFileStream(u,d,p){const f=(0,P.newWriteableStream)(w=>E.VSBuffer.concat(w.map(C=>E.VSBuffer.wrap(C))).buffer),l=this.a.listen("readFileStream",[u,d])(w=>{if(w instanceof E.VSBuffer)f.write(w.buffer);else{if(w==="end")f.end();else{let C;if(w instanceof Error)C=w;else{const I=w;C=(0,b.createFileSystemProviderError)(I.message??(0,t.toErrorMessage)(I),I.code??b.FileSystemProviderErrorCode.Unknown)}f.error(C),f.end()}l.dispose()}});return p.onCancellationRequested(()=>{f.error((0,k.canceled)()),f.end(),l.dispose()}),f}writeFile(u,d,p){return this.a.call("writeFile",[u,E.VSBuffer.wrap(d),p])}open(u,d){return this.a.call("open",[u,d])}close(u){return this.a.call("close",[u])}async read(u,d,p,f,l){const[w,C]=await this.a.call("read",[u,d,l]);return p.set(w.buffer.slice(0,C),f),C}write(u,d,p,f,l){return this.a.call("write",[u,d,E.VSBuffer.wrap(p),f,l])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,d){return this.a.call("delete",[u,d])}rename(u,d,p){return this.a.call("rename",[u,d,p])}copy(u,d,p){return this.a.call("copy",[u,d,p])}cloneFile(u,d){return this.a.call("cloneFile",[u,d])}i(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const d=u;this.f.fire(d.map(p=>({resource:g.URI.revive(p.resource),type:p.type})))}else{const d=u;this.g.fire(d)}}))}watch(u,d){const p=(0,m.generateUuid)();return this.a.call("watch",[this.h,p,u,d]),(0,A.toDisposable)(()=>this.a.call("unwatch",[this.h,p]))}}e.DiskFileSystemProviderClient=S}),define(ie[108],re([0,1,17,13,161,16]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(b,S,y,u,d,p){let f;try{await P(b,S,y,u,d,p)}catch(l){f=l}finally{f&&d.errorTransformer&&(f=d.errorTransformer(f)),typeof f<"u"&&y.error(f),y.end()}}e.readFileIntoStream=A;async function P(b,S,y,u,d,p){g(p);const f=await b.open(S,{create:!1});try{g(p);let l=0,w=0,C=d&&typeof d.length=="number"?d.length:void 0,I=E.VSBuffer.alloc(Math.min(d.bufferSize,typeof C=="number"?C:d.bufferSize)),v=d&&typeof d.position=="number"?d.position:0,i=0;do w=await b.read(f,v,I.buffer,i,I.byteLength-i),v+=w,i+=w,l+=w,typeof C=="number"&&(C-=w),i===I.byteLength&&(await y.write(u(I)),I=E.VSBuffer.alloc(Math.min(d.bufferSize,typeof C=="number"?C:d.bufferSize)),i=0);while(w>0&&(typeof C!="number"||C>0)&&g(p)&&m(l,d));if(i>0){let r=i;typeof C=="number"&&(r=Math.min(i,C)),y.write(u(I.slice(0,r)))}}catch(l){throw(0,M.ensureFileSystemProviderError)(l)}finally{await b.close(f)}}function g(b){if(b.isCancellationRequested)throw(0,t.canceled)();return!0}function m(b,S){if(S?.limits){if(typeof S.limits.memory=="number"&&b>S.limits.memory)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&b>S.limits.size)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ie[72],re([0,1,99,2,9,4,7,16]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function g(l){return l.recursive===!0}e.isRecursiveWatchRequest=g;class m extends t.Disposable{constructor(w,C,I,v){super(),this.h=w,this.i=C,this.j=I,this.k=v,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const w=new t.DisposableStore;this.c.value=w,this.b=this.l(w),this.b.setVerboseLogging(this.j),w.add(this.b.onDidChangeFile(C=>this.h(C))),w.add(this.b.onDidLogMessage(C=>this.i(C))),w.add(this.b.onDidError(C=>this.n(C)))}n(w){this.k.restartOnError?this.g<m.a&&this.f?(this.r(`restarting watcher after error: ${w}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${w}`):this.r(w)}p(w){this.g++,this.m(),this.watch(w)}async watch(w){this.f=w,await this.b?.watch(w)}async setVerboseLogging(w){this.j=w,await this.b?.setVerboseLogging(w)}r(w){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${w}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.a=5;class b extends m{constructor(w,C,I){super(w,C,I,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class S extends m{constructor(w,C,I){super(w,C,I,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function y(l){return l.map(w=>({type:w.type,resource:A.URI.file(w.path)}))}e.toFileChanges=y;function u(l){const w=new f;for(const C of l)w.processEvent(C);return w.coalesce()}e.coalesceEvents=u;function d(l,w){return typeof w=="string"&&!w.startsWith(E.GLOBSTAR)&&!(0,k.isAbsolute)(w)?{base:l,pattern:w}:w}e.normalizeWatcherPattern=d;function p(l,w){const C=[];for(const I of w)C.push((0,E.parse)(d(l,I)));return C}e.parseWatcherPatterns=p;class f{constructor(){this.a=new Set,this.b=new Map}c(w){return M.isLinux?w.path:w.path.toLowerCase()}processEvent(w){const C=this.b.get(this.c(w));let I=!1;if(C){const v=C.type,i=w.type;C.path!==w.path&&(w.type===2||w.type===1)?I=!0:v===1&&i===2?(this.b.delete(this.c(w)),this.a.delete(C)):v===2&&i===1?C.type=0:v===1&&i===0||(C.type=i)}else I=!0;I&&(this.a.add(w),this.b.set(this.c(w),w))}coalesce(){const w=[],C=[];return Array.from(this.a).filter(I=>I.type!==2?(w.push(I),!1):!0).sort((I,v)=>I.path.length-v.path.length).filter(I=>C.some(v=>(0,P.isParent)(I.path,v,!M.isLinux))?!1:(C.push(I.path),!0)).concat(w)}}}),define(ie[198],re([0,1,40,8,22,31,2,77,9,4,100,23,72]),function(H,e,E,t,k,M,A,P,g,m,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends A.Disposable{constructor(f,l,w,C){super(),this.j=f,this.k=l,this.l=w,this.m=C,this.c=this.B(new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},I=>this.k(I))),this.f=this.B(new t.RunOnceWorker(I=>this.u(I),u.b)),this.g=(0,y.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,y.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new k.CancellationTokenSource,this.ready=this.n()}async n(){try{const f=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const l=await S.Promises.stat(f);this.B(await this.s(f,l.isDirectory()))}catch(f){f.code!=="ENOENT"?this.w(f):this.z(f)}}async r(f){let l=f.path;try{l=await S.Promises.realpath(f.path),f.path===l&&(l=await(0,b.realcase)(f.path)??f.path),f.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${l})`)}catch{}return l}async s(f,l){if(m.isMacintosh&&(0,M.isEqualOrParent)(f,"/Volumes/",!0))return this.w(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const w=new k.CancellationTokenSource(this.i.token),C=new A.DisposableStore;try{const I=(0,g.basename)(f),v=(0,E.watch)(f);C.add((0,A.toDisposable)(()=>{v.removeAllListeners(),v.close()})),this.z(`Started watching: '${f}'`);const i=new Set;if(l)try{for(const n of await S.Promises.readdir(f))i.add(n)}catch(n){this.w(n)}const r=new Map;C.add((0,A.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),v.on("error",(n,o)=>{this.w(`Failed to watch ${f} for changes using fs.watch() (${n}, ${o})`),this.dispose()}),v.on("change",(n,o)=>{if(w.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${o}`);let a="";if(o&&(a=o.toString(),m.isMacintosh&&(a=(0,P.normalizeNFC)(a))),!(!a||n!=="change"&&n!=="rename"))if(l)if(n==="rename"){r.get(a)?.dispose();const c=setTimeout(async()=>{if(r.delete(a),a===I&&!await S.Promises.exists(f)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,g.join)(f,a));if(w.token.isCancellationRequested)return;let h;s?i.has(a)?h=0:(h=1,i.add(a)):(i.delete(a),h=2),this.t({path:(0,g.join)(this.j.path,a),type:h})},u.a);r.set(a,(0,A.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(a)?c=0:(c=1,i.add(a)),this.t({path:(0,g.join)(this.j.path,a),type:c})}else if(n==="rename"||a!==I){const c=setTimeout(async()=>{const s=await S.Promises.exists(f);w.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),C.add(await this.s(f,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},u.a);C.clear(),C.add((0,A.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(I){await S.Promises.exists(f)&&!w.token.isCancellationRequested&&this.w(`Failed to watch ${f} for changes using fs.watch() (${I.toString()})`)}return(0,A.toDisposable)(()=>{w.dispose(!0),C.dispose()})}t(f,l=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!l&&this.g.some(w=>w(f.path))?this.m&&this.z(` >> ignored (excluded) ${f.path}`):!l&&this.h&&this.h.length>0&&!this.h.some(w=>w(f.path))?this.m&&this.z(` >> ignored (not included) ${f.path}`):this.f.work(f))}u(f){const l=(0,y.coalesceEvents)(f);if(l.length>0){if(this.m)for(const C of l)this.z(`>> normalized ${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`);this.c.work(l)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(f){if(m.isLinux)return S.Promises.exists(f);try{const l=(0,g.basename)(f);return(await S.Promises.readdir((0,g.dirname)(f))).some(C=>C===l)}catch(l){return this.z(l),!1}}setVerboseLogging(f){this.m=f}w(f){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}y(f){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}z(f){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.a=100,u.b=75;async function d(p,f,l,w,C=512){const I=await S.Promises.open(p,"r"),v=Buffer.allocUnsafe(C),i=new k.CancellationTokenSource(w);let r,n=!1;const o={path:p,excludes:[],recursive:!1},a=new u(o,c=>{(async()=>{for(const{type:s}of c)if(s===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:h}=await S.Promises.read(I,v,0,C,null);if(!h||i.token.isCancellationRequested)break;f(v.slice(0,h))}}catch(h){r=new Error(h),i.dispose(!0)}finally{n=!1}}})()});return await a.ready,l(),new Promise((c,s)=>{i.token.onCancellationRequested(async()=>{a.dispose();try{await S.Promises.close(I)}catch(h){r=new Error(h)}r?s(r):c()})})}e.watchFileContents=d}),define(ie[199],re([0,1,3,99,2,4,198]),function(H,e,E,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(m){const b=this.i(m),S=b.filter(u=>{const d=this.c.get(u.path);return d?!(0,t.patternsEquals)(d.request.excludes,u.excludes)||!(0,t.patternsEquals)(d.request.includes,u.includes):!0}),y=Array.from(this.c.values()).filter(({request:u})=>!b.find(d=>d.path===u.path&&(0,t.patternsEquals)(d.excludes,u.excludes)&&(0,t.patternsEquals)(d.includes,u.includes))).map(({request:u})=>u.path);S.length&&this.j(`Request to start watching: ${S.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),y.length&&this.j(`Request to stop watching: ${y.join(",")}`);for(const u of y)this.h(u);for(const u of S)this.g(u)}g(m){const b=new A.NodeJSFileWatcherLibrary(m,y=>this.a.fire(y),y=>this.b.fire(y),this.f),S={request:m,instance:b};this.c.set(m.path,S)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const b=this.c.get(m);b&&(this.c.delete(m),b.instance.dispose())}i(m){const b=new Map;for(const S of m){const y=M.isLinux?S.path:S.path.toLowerCase();b.set(y,S)}return Array.from(b.values())}async setVerboseLogging(m){this.f=m;for(const[,b]of this.c)b.instance.setVerboseLogging(m)}j(m){this.f&&this.b.fire({type:"trace",message:this.k(m)})}k(m,b){return b?`[File Watcher (node.js)] ${m} (path: ${b.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=P}),define(ie[200],re([0,1,72,199]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends E.AbstractNonRecursiveWatcherClient{constructor(A,P,g){super(A,P,g),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ie[201],re([0,1,15,47,147,72]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends M.AbstractUniversalWatcherClient{constructor(g,m,b){super(g,m,b),this.m()}l(g){const m=g.add(new k.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(m.onDidProcessExit(({code:b,signal:S})=>this.n(`terminated by itself with code ${b}, signal: ${S}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ie[86],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...k){this.a=new Map;for(const[M,A]of k)this.set(M,A)}set(k,M){const A=this.a.get(k);return this.a.set(k,M),A}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=E}),define(ie[202],re([0,1,8,13,2,70,192,5,86,96]),function(H,e,E,t,k,M,A,P,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class S extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class y{constructor(f=new g.ServiceCollection,l=!1,w,C=b){this.f=f,this.g=l,this.h=w,this.i=C,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=C?w?._globalGraph??new A.Graph(I=>I):void 0}createChild(f){return new y(f,this.g,this,this.i)}invokeFunction(f,...l){const w=d.traceInvocation(this.i,f);let C=!1;try{return f({get:v=>{if(C)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(v,w);if(!i)throw new Error(`[invokeFunction] unknown service '${v}'`);return i}},...l)}finally{C=!0,w.stop()}}createInstance(f,...l){let w,C;return f instanceof M.SyncDescriptor?(w=d.traceCreation(this.i,f.ctor),C=this.j(f.ctor,f.staticArguments.concat(l),w)):(w=d.traceCreation(this.i,f),C=this.j(f,l,w)),w.stop(),C}j(f,l=[],w){const C=P._util.getServiceDependencies(f).sort((i,r)=>i.index-r.index),I=[];for(const i of C){const r=this.m(i.id,w);r||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${i.id}.`,!1),I.push(r)}const v=C.length>0?C[0].index:l.length;if(l.length!==v){console.trace(`[createInstance] First service dependency of ${f.name} at position ${v+1} conflicts with ${l.length} static arguments`);const i=v-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,v)}return Reflect.construct(f,l.concat(I))}k(f,l){if(this.f.get(f)instanceof M.SyncDescriptor)this.f.set(f,l);else if(this.h)this.h.k(f,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const l=this.f.get(f);return!l&&this.h?this.h.l(f):l}m(f,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const w=this.l(f);return w instanceof M.SyncDescriptor?this.q(f,w,l.branch(f,!0)):(l.branch(f,!1),w)}q(f,l,w){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,l,w)}finally{this.o.delete(f)}}r(f,l,w){const C=new A.Graph(i=>i.id.toString());let I=0;const v=[{id:f,desc:l,_trace:w}];for(;v.length;){const i=v.pop();if(C.lookupOrInsertNode(i),I++>1e3)throw new S(C);for(const r of P._util.getServiceDependencies(i.desc.ctor)){const n=this.l(r.id);if(n||this.u(`[createInstance] ${f} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),n instanceof M.SyncDescriptor){const o={id:r.id,desc:n,_trace:i._trace.branch(r.id,!0)};C.insertEdge(i,o),v.push(o)}}}for(;;){const i=C.roots();if(i.length===0){if(!C.isEmpty())throw new S(C);break}for(const{data:r}of i){if(this.l(r.id)instanceof M.SyncDescriptor){const o=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,o)}C.removeNode(r)}}return this.l(f)}s(f,l,w=[],C,I){if(this.f.get(f)instanceof M.SyncDescriptor)return this.t(f,l,w,C,I);if(this.h)return this.h.s(f,l,w,C,I);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(f,l,w=[],C,I){if(C){const v=new y(void 0,this.g,this,this.i);v.c=String(f);const i=new Map,r=new E.IdleValue(()=>{const n=v.j(l,w,I);for(const[o,a]of i){const c=n[o];if(typeof c=="function")for(const s of a)c.apply(n,s)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let s=i.get(o);return s||(s=new m.LinkedList,i.set(o,s)),(D,L,T)=>{const F=s.push([D,L,T]);return(0,k.toDisposable)(F)}}if(o in n)return n[o];const a=r.value;let c=a[o];return typeof c!="function"||(c=c.bind(a),n[o]=c),c},set(n,o,a){return r.value[o]=a,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,w,I)}u(f,l){if(l&&console.warn(f),this.g)throw new Error(f)}}e.InstantiationService=y;var u;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(u||(u={}));class d{static traceInvocation(f,l){return f?new d(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(f,l){return f?new d(1,l.name):d.c}constructor(f,l){this.type=f,this.name=l,this.g=Date.now(),this.h=[]}branch(f,l){const w=new d(3,f.toString());return this.h.push([f,l,w]),w}stop(){const f=Date.now()-this.g;d.f+=f;let l=!1;function w(I,v){const i=[],r=new Array(I+1).join("	");for(const[n,o,a]of v.h)if(o&&a){l=!0,i.push(`${r}CREATES -> ${n}`);const c=w(I+1,a);c&&i.push(c)}else i.push(`${r}uses -> ${n}`);return i.join(`
`)}const C=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(f>2||l)&&d.all.add(C.join(`
`))}}e.Trace=d,d.all=new Set,d.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d.f=0}),define(ie[6],re([0,1,45,3,2,39,4,7,5]),function(H,e,E,t,k,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function m(){return new Date().toISOString()}var b;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function S(c,s,h){switch(s){case b.Trace:c.trace(h);break;case b.Debug:c.debug(h);break;case b.Info:c.info(h);break;case b.Warning:c.warn(h);break;case b.Error:c.error(h);break;case b.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=S;function y(c){let s="";for(let h=0;h<c.length;h++){let D=c[h];if(typeof D=="object")try{D=JSON.stringify(D)}catch{}s+=(h>0?" ":"")+D}return s}e.format=y;class u extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==b.Off&&this.b<=s}}e.AbstractLogger=u;class d extends u{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...h){this.f(b.Trace)&&this.g(b.Trace,y([s,...h]))}debug(s,...h){this.f(b.Debug)&&this.g(b.Debug,y([s,...h]))}info(s,...h){this.f(b.Info)&&this.g(b.Info,y([s,...h]))}warn(s,...h){this.f(b.Warning)&&this.g(b.Warning,y([s,...h]))}error(s,...h){if(this.f(b.Error))if(s instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=s.stack,this.g(b.Error,y(D))}else this.g(b.Error,y([s,...h]))}flush(){}}e.AbstractMessageLogger=d;class p extends u{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!A.isWindows}trace(s,...h){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,s,...h):console.log(`[main ${m()}]`,s,...h))}debug(s,...h){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,s,...h):console.log(`[main ${m()}]`,s,...h))}info(s,...h){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,s,...h):console.log(`[main ${m()}]`,s,...h))}warn(s,...h){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,s,...h):console.warn(`[main ${m()}]`,s,...h))}error(s,...h){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,s,...h):console.error(`[main ${m()}]`,s,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class f extends u{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...h){this.f(b.Trace)&&console.log("%cTRACE","color: #888",s,...h)}debug(s,...h){this.f(b.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...h)}info(s,...h){this.f(b.Info)&&console.log("%c INFO","color: #33f",s,...h)}warn(s,...h){this.f(b.Warning)&&console.log("%c WARN","color: #993",s,...h)}error(s,...h){this.f(b.Error)&&console.log("%c  ERR","color: #f33",s,...h)}dispose(){}flush(){}}e.ConsoleLogger=f;class l extends u{constructor(s,h=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(h)}trace(s,...h){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(s),...h])}debug(s,...h){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(s),...h])}info(s,...h){this.f(b.Info)&&this.g.log(b.Info,[this.h(s),...h])}warn(s,...h){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(s),...h])}error(s,...h){this.f(b.Error)&&this.g.log(b.Error,[this.h(s),...h])}h(s){return typeof s=="string"?s:(0,E.toErrorMessage)(s,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class w extends u{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const h of this.g)h.setLevel(s);super.setLevel(s)}trace(s,...h){for(const D of this.g)D.trace(s,...h)}debug(s,...h){for(const D of this.g)D.debug(s,...h)}info(s,...h){for(const D of this.g)D.info(s,...h)}warn(s,...h){for(const D of this.g)D.warn(s,...h)}error(s,...h){for(const D of this.g)D.error(s,...h)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogService=w;class C extends k.Disposable{constructor(s){super(),this.b=s,this.B(s)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(s){this.b.setLevel(s)}getLevel(){return this.b.getLevel()}trace(s,...h){this.b.trace(s,...h)}debug(s,...h){this.b.debug(s,...h)}info(s,...h){this.b.info(s,...h)}warn(s,...h){this.b.warn(s,...h)}error(s,...h){this.b.error(s,...h)}flush(){this.b.flush()}}e.LogService=C;class I extends k.Disposable{constructor(s,h){super(),this.c=s,this.b=new M.ResourceMap,this.B(h(D=>this.setLevel(D)))}getLoggers(){return[...this.b.values()].map(({logger:s})=>s)}getLogger(s){return this.b.get(s)?.logger}createLogger(s,h,D){let L=this.b.get(s)?.logger;return L||(D=h?.always?b.Trace:D,L=this.f(s,D??this.c,h),this.b.set(s,{logger:L,logLevel:D})),L}setLevel(s,h){const D=P.URI.isUri(s)?s:void 0,L=D?h:s;if(D){const T=this.b.get(D);T&&T.logLevel!==L&&(T.logLevel=L,T.logger.setLevel(L))}else this.c=L,this.b.forEach(({logLevel:T,logger:F})=>{T===void 0&&F.setLevel(this.c)})}getLogLevel(s){return this.b.get(s)?.logLevel}dispose(){this.b.forEach(({logger:s})=>s.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=I;class v{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return b.Info}trace(s,...h){}debug(s,...h){}info(s,...h){}warn(s,...h){}error(s,...h){}critical(s,...h){}dispose(){}flush(){}}e.NullLogger=v;class i extends v{}e.NullLogService=i;class r extends I{constructor(){super(b.Info,t.Event.None)}f(s,h,D){return new v}}e.NullLoggerService=r;function n(c){if(c.verbose)return b.Trace;if(typeof c.logLevel=="string"){const s=a(c.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function o(c){switch(c){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=o;function a(c){switch(c){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=a});var ee=this&&this.__param||function(H,e){return function(E,t){e(E,t,H)}};define(ie[203],re([0,1,71,3,2,6,4,8]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let g=class Et extends k.Disposable{constructor(b){super(),this.g=b,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(b,S){this.g.trace("Getting password from keytar:",b,S);let y;try{y=await this.h()}catch{return null}const u=await(0,P.retry)(()=>y.getPassword(b,S),50,3);if(!u)return this.g.trace("Did not get a password from keytar for account:",S),u;let d,p;try{const f=JSON.parse(u);d=f.content,p=f.hasNextChunk}catch{}if(!d||!p)return this.g.trace("Got password from keytar for account:",S),u;try{let f=1;for(;p;){const l=await(0,P.retry)(()=>y.getPassword(b,`${S}-${f}`),50,3),w=JSON.parse(l);d+=w.content,p=w.hasNextChunk,f++}return this.g.trace(`Got ${f}-chunked password from keytar for account:`,S),d}catch(f){return this.g.error(f),u}}async setPassword(b,S,y){this.g.trace("Setting password using keytar:",b,S);let u;try{u=await this.h()}catch(d){throw this.i?.(d),d}if(A.isWindows&&y.length>Et.a){let d=0,p=0,f=!0;for(;f;){const l=y.substring(d,d+Et.b);d+=Et.b,f=y.length-d>0;const w={content:l,hasNextChunk:f};await(0,P.retry)(()=>u.setPassword(b,p?`${S}-${p}`:S,JSON.stringify(w)),50,3),p++}this.g.trace(`Got${p?` ${p}-chunked`:""} password from keytar for account:`,S)}else await(0,P.retry)(()=>u.setPassword(b,S,y),50,3),this.g.trace("Got password from keytar for account:",S);this.c.fire({service:b,account:S})}async deletePassword(b,S){this.g.trace("Deleting password using keytar:",b,S);let y;try{y=await this.h()}catch(l){throw this.i?.(l),l}const u=await y.getPassword(b,S);if(!u)return this.g.trace("Did not get a password to delete from keytar for account:",S),!1;let d,p;try{const l=JSON.parse(u);d=l.content,p=l.hasNextChunk}catch{}let f=0;if(d&&p)try{for(f++;p;){const l=`${S}-${f}`,w=await y.getPassword(b,l);await y.deletePassword(b,l),p=JSON.parse(w).hasNextChunk,f++}}catch(l){this.g.error(l)}return await y.deletePassword(b,S)?(this.c.fire({service:b,account:S}),this.g.trace(`Deleted${f?` ${f}-chunked`:""} password from keytar for account:`,S),!0):(this.g.trace(`Keytar failed to delete${f?` ${f}-chunked`:""} password for account:`,S),!1)}async findPassword(b){let S;try{S=await this.h()}catch{return null}return await S.findPassword(b)}async findCredentials(b){let S;try{S=await this.h()}catch{return[]}return await S.findCredentials(b)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};g.a=2500,g.b=g.a-100,g=pe([ee(0,M.ILogService)],g),e.BaseCredentialsMainService=g}),define(ie[204],re([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(M,A){this.a=M,this.b=A}c(){return new Promise((M,A)=>H(["vscode-encrypt"],M,A))}async encrypt(M){let A;try{A=await this.c()}catch{return M}try{return A.encrypt(this.a,M)}catch(P){return this.b.error(P),M}}async decrypt(M){let A;try{A=await this.c()}catch{return M}try{return A.decrypt(this.a,M)}catch(P){return this.b.error(P),M}}};t=pe([ee(1,E.ILogService)],t),e.EncryptionMainService=t}),define(ie[205],re([0,1,24,8,13,3,2,9,72,6]),function(H,e,E,t,k,M,A,P,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends A.Disposable{constructor(y,u){super(),this.a=y,this.b=u,this.c=this.B(new M.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new M.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(y,u){return u.recursive||this.b?.watcher?.forceUniversal?this.l(y,u):this.u(y,u)}l(y,u){const d={path:this.C(y),excludes:u.excludes,includes:u.includes,recursive:u.recursive},p=(0,E.insert)(this.j,d);return this.m(),(0,A.toDisposable)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(y=>(0,k.onUnexpectedError)(y))}n(){this.h||(this.h=this.B(this.p(u=>this.c.fire((0,g.toFileChanges)(u)),u=>this.z(u),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const u of this.j)(0,g.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const u of this.j)(0,g.isRecursiveWatchRequest)(u)&&y.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(y,u){const d={path:this.C(y),excludes:u.excludes,includes:u.includes,recursive:!1},p=(0,E.insert)(this.s,d);return this.v(),(0,A.toDisposable)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(y=>(0,k.onUnexpectedError)(y))}w(){return this.r||(this.r=this.B(this.y(y=>this.c.fire((0,g.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.r.watch(this.s)}z(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}C(y){return(0,P.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ie[206],re([0,1,24,8,17,22,3,68,67,2,60,15,73,20,59,159,16,108,6]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class extends m.Disposable{constructor(v){super(),this.b=v,this.a=256*1024,this.c=this.B(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new A.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new A.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new A.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new t.ResourceQueue)}registerProvider(v,i){if(this.h.has(v))throw new Error(`A filesystem provider for the scheme '${v}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${v}`);const r=new m.DisposableStore;return this.h.set(v,i),this.c.fire({added:!0,scheme:v,provider:i}),r.add(i.onDidChangeFile(n=>this.Q.fire(new f.FileChangesEvent(n,!this.N(i))))),typeof i.onDidWatchError=="function"&&r.add(i.onDidWatchError(n=>this.R.fire(new Error(n)))),r.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:v}))),(0,m.toDisposable)(()=>{this.c.fire({added:!1,scheme:v,provider:i}),this.h.delete(v),(0,m.dispose)(r)})}getProvider(v){return this.h.get(v)}async activateProvider(v){const i=[];this.f.fire({scheme:v,join(r){i.push(r)}}),!this.h.has(v)&&await t.Promises.settled(i)}async canHandleResource(v){return await this.activateProvider(v.scheme),this.hasProvider(v)}hasProvider(v){return this.h.has(v.scheme)}hasCapability(v,i){const r=this.h.get(v.scheme);return!!(r&&r.capabilities&i)}listCapabilities(){return g.Iterable.map(this.h,([v,i])=>({scheme:v,capabilities:i.capabilities}))}async j(v){if(!(0,u.isAbsolutePath)(v))throw new f.FileOperationError((0,p.localize)(0,null,this.mb(v)),8);await this.activateProvider(v.scheme);const i=this.h.get(v.scheme);if(!i){const r=new Error;throw r.name="ENOPRO",r.message=(0,p.localize)(1,null,v.toString()),r}return i}async k(v){const i=await this.j(v);if((0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasReadWriteCapability)(i)||(0,f.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${v.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(v){const i=await this.j(v);if((0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${v.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(v,i){try{return await this.n(v,i)}catch(r){throw(0,f.toFileSystemProviderErrorCode)(r)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,p.localize)(2,null,this.mb(v)),1):(0,f.ensureFileSystemProviderError)(r)}}async n(v,i){const r=await this.j(v),n=this.N(r),o=i?.resolveTo,a=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,s=await r.stat(v);let h;return this.p(r,v,s,void 0,!!c,(D,L)=>(h||(h=b.TernarySearchTree.forUris(()=>!n),h.set(v,!0),o&&h.fill(!0,o)),h.get(D.resource)||h.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&a?L===1:!1))}async p(v,i,r,n,o,a){const{providerExtUri:c}=this.M(v),s={resource:i,name:c.basename(i),isFile:(r.type&f.FileType.File)!==0,isDirectory:(r.type&f.FileType.Directory)!==0,isSymbolicLink:(r.type&f.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&f.FilePermission.Readonly)||Boolean(v.capabilities&2048),etag:(0,f.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(s.isDirectory&&a(s,n)){try{const h=await v.readdir(i),D=await t.Promises.settled(h.map(async([L,T])=>{try{const F=c.joinPath(i,L),G=o?await v.stat(F):{type:T};return await this.p(v,F,G,h.length,o,a)}catch(F){return this.b.trace(F),null}}));s.children=(0,E.coalesce)(D)}catch(h){this.b.trace(h),s.children=[]}return s}return s}async resolveAll(v){return t.Promises.settled(v.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(v){const i=await this.j(v),r=await i.stat(v);return this.p(i,v,r,void 0,!0,()=>!1)}async exists(v){const i=await this.j(v);try{return!!await i.stat(v)}catch{return!1}}async canCreateFile(v,i){try{await this.r(v,i)}catch(r){return r}return!0}async r(v,i){if(!i?.overwrite&&await this.exists(v))throw new f.FileOperationError((0,p.localize)(3,null,this.mb(v)),3,i)}async createFile(v,i=k.VSBuffer.fromString(""),r){await this.r(v,r);const n=await this.writeFile(v,i);return this.m.fire(new f.FileOperationEvent(v,0,n)),n}async writeFile(v,i,r){const n=this.kb(await this.l(v),v),{providerExtUri:o}=this.M(n);try{await this.s(n,v,r)||await this.O(n,o.dirname(v));let c;if((0,f.hasReadWriteCapability)(n)&&!(i instanceof k.VSBuffer))if((0,d.isReadableStream)(i)){const s=await(0,d.peekStream)(i,3);s.ended?c=k.VSBuffer.concat(s.buffer):c=s}else c=(0,d.peekReadable)(i,s=>k.VSBuffer.concat(s),3);else c=i;!(0,f.hasOpenReadWriteCloseCapability)(n)||(0,f.hasReadWriteCapability)(n)&&c instanceof k.VSBuffer?await this.bb(n,v,r,c):await this.X(n,v,r,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this.m.fire(new f.FileOperationEvent(v,4))}catch(a){throw new f.FileOperationError((0,p.localize)(4,null,this.mb(v),(0,f.ensureFileSystemProviderError)(a).toString()),(0,f.toFileOperationResult)(a),r)}return this.resolve(v,{resolveMetadata:!0})}async s(v,i,r){if(!!r?.unlock&&!(v.capabilities&8192))throw new Error((0,p.localize)(5,null,this.mb(i)));let o;try{o=await v.stat(i)}catch{return}if((o.type&f.FileType.Directory)!==0)throw new f.FileOperationError((0,p.localize)(6,null,this.mb(i)),0,r);if(this.lb(i,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==f.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,f.etag)({mtime:r.mtime,size:o.size}))throw new f.FileOperationError((0,p.localize)(7,null),3,r);return o}async readFile(v,i,r){const n=await this.k(v);return i?.atomic?this.t(n,v,i,r):this.u(n,v,i,r)}async t(v,i,r,n){return new Promise((o,a)=>{this.W.queueFor(i,this.M(v).providerExtUri).queue(async()=>{try{const c=await this.u(v,i,r,n);o(c)}catch(c){a(c)}})})}async u(v,i,r,n){const o=await this.v(v,i,{...r,preferUnbuffered:!0},n);return{...o,value:await(0,k.streamToBuffer)(o.value)}}async readFileStream(v,i,r){const n=await this.k(v);return this.v(n,v,i,r)}async v(v,i,r,n){const o=new M.CancellationTokenSource(n),a=this.D(i,r).then(s=>s,s=>{throw o.cancel(),s});let c;try{return typeof r?.etag=="string"&&r.etag!==f.ETAG_DISABLED&&await a,r?.atomic&&(0,f.hasFileAtomicReadCapability)(v)||!((0,f.hasOpenReadWriteCloseCapability)(v)||(0,f.hasFileReadStreamCapability)(v))||(0,f.hasReadWriteCapability)(v)&&r?.preferUnbuffered?c=this.C(v,i,r):(0,f.hasFileReadStreamCapability)(v)?c=this.w(v,i,o.token,r):c=this.z(v,i,o.token,r),{...await a,value:c}}catch(s){c&&await(0,d.consumeStream)(c);const h=(0,p.localize)(8,null,this.mb(i),(0,f.ensureFileSystemProviderError)(s).toString());throw s instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(h,s.stat,r):new f.FileOperationError(h,(0,f.toFileOperationResult)(s),r)}}w(v,i,r,n=Object.create(null)){const o=v.readFileStream(i,n,r);return(0,d.transform)(o,{data:a=>a instanceof k.VSBuffer?a:k.VSBuffer.wrap(a),error:a=>new f.FileOperationError((0,p.localize)(9,null,this.mb(i),(0,f.ensureFileSystemProviderError)(a).toString()),(0,f.toFileOperationResult)(a),n)},a=>k.VSBuffer.concat(a))}z(v,i,r,n=Object.create(null)){const o=(0,k.newWriteableBufferStream)();return(0,l.readFileIntoStream)(v,i,o,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>new f.FileOperationError((0,p.localize)(10,null,this.mb(i),(0,f.ensureFileSystemProviderError)(a).toString()),(0,f.toFileOperationResult)(a),n)},r),o}C(v,i,r){const n=(0,d.newWriteableStream)(o=>k.VSBuffer.concat(o));return(async()=>{try{let o;r?.atomic&&(0,f.hasFileAtomicReadCapability)(v)?o=await v.readFile(i,{atomic:!0}):o=await v.readFile(i),typeof r?.position=="number"&&(o=o.slice(r.position)),typeof r?.length=="number"&&(o=o.slice(0,r.length)),this.F(i,o.byteLength,r),n.end(k.VSBuffer.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async D(v,i){const r=await this.resolve(v,{resolveMetadata:!0});if(r.isDirectory)throw new f.FileOperationError((0,p.localize)(11,null,this.mb(v)),0,i);if(typeof i?.etag=="string"&&i.etag!==f.ETAG_DISABLED&&i.etag===r.etag)throw new f.NotModifiedSinceFileOperationError((0,p.localize)(12,null),r,i);return this.F(v,r.size,i),r}F(v,i,r){if(r?.limits){let n;if(typeof r.limits.memory=="number"&&i>r.limits.memory&&(n=9),typeof r.limits.size=="number"&&i>r.limits.size&&(n=7),typeof n=="number")throw new f.FileOperationError((0,p.localize)(13,null,this.mb(v)),n)}}async canMove(v,i,r){return this.G(v,i,"move",r)}async canCopy(v,i,r){return this.G(v,i,"copy",r)}async G(v,i,r,n){if(v.toString()!==i.toString())try{const o=r==="move"?this.kb(await this.l(v),v):await this.k(v),a=this.kb(await this.l(i),i);await this.L(o,v,a,i,r,n)}catch(o){return o}return!0}async move(v,i,r){const n=this.kb(await this.l(v),v),o=this.kb(await this.l(i),i),a=await this.H(n,v,o,i,"move",!!r),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(v,a==="move"?2:3,c)),c}async copy(v,i,r){const n=await this.k(v),o=this.kb(await this.l(i),i),a=await this.H(n,v,o,i,"copy",!!r),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(v,a==="copy"?3:2,c)),c}async H(v,i,r,n,o,a){if(i.toString()===n.toString())return o;const{exists:c,isSameResourceWithDifferentPathCase:s}=await this.L(v,i,r,n,o,a);if(c&&!s&&a&&await this.del(n,{recursive:!0}),await this.O(r,this.M(r).providerExtUri.dirname(n)),o==="copy"){if(v===r&&(0,f.hasFileFolderCopyCapability)(v))await v.copy(i,n,{overwrite:a});else{const h=await this.resolve(i);h.isDirectory?await this.J(v,h,r,n):await this.I(v,i,r,n)}return o}else return v===r?(await v.rename(i,n,{overwrite:a}),o):(await this.H(v,i,r,n,"copy",a),await this.del(i,{recursive:!0}),"copy")}async I(v,i,r,n){if((0,f.hasOpenReadWriteCloseCapability)(v)&&(0,f.hasOpenReadWriteCloseCapability)(r))return this.db(v,i,r,n);if((0,f.hasOpenReadWriteCloseCapability)(v)&&(0,f.hasReadWriteCapability)(r))return this.jb(v,i,r,n);if((0,f.hasReadWriteCapability)(v)&&(0,f.hasOpenReadWriteCloseCapability)(r))return this.hb(v,i,r,n);if((0,f.hasReadWriteCapability)(v)&&(0,f.hasReadWriteCapability)(r))return this.fb(v,i,r,n)}async J(v,i,r,n){await r.mkdir(n),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async o=>{const a=this.M(r).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.J(v,await this.resolve(o.resource),r,a):this.I(v,o.resource,r,a)}))}async L(v,i,r,n,o,a){let c=!1;if(v===r){const{providerExtUri:h,isPathCaseSensitive:D}=this.M(v);if(D||(c=h.isEqual(i,n)),c&&o==="copy")throw new Error((0,p.localize)(14,null,this.mb(i),this.mb(n)));if(!c&&h.isEqualOrParent(n,i))throw new Error((0,p.localize)(15,null,this.mb(i),this.mb(n)))}const s=await this.exists(n);if(s&&!c){if(!a)throw new f.FileOperationError((0,p.localize)(16,null,this.mb(i),this.mb(n)),4);if(v===r){const{providerExtUri:h}=this.M(v);if(h.isEqualOrParent(i,n))throw new Error((0,p.localize)(17,null,this.mb(i),this.mb(n)))}}return{exists:s,isSameResourceWithDifferentPathCase:c}}M(v){const i=this.N(v);return{providerExtUri:i?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:i}}N(v){return!!(v.capabilities&1024)}async createFolder(v){const i=this.kb(await this.j(v),v);await this.O(i,v);const r=await this.resolve(v,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(v,0,r)),r}async O(v,i){const r=[],{providerExtUri:n}=this.M(v);for(;!n.isEqual(i,n.dirname(i));)try{if(((await v.stat(i)).type&f.FileType.Directory)===0)throw new Error((0,p.localize)(18,null,this.mb(i)));break}catch(o){if((0,f.toFileSystemProviderErrorCode)(o)!==f.FileSystemProviderErrorCode.FileNotFound)throw o;r.push(n.basename(i)),i=n.dirname(i)}for(let o=r.length-1;o>=0;o--){i=n.joinPath(i,r[o]);try{await v.mkdir(i)}catch(a){if((0,f.toFileSystemProviderErrorCode)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(v,i){try{await this.P(v,i)}catch(r){return r}return!0}async P(v,i){const r=this.kb(await this.j(v),v);if(!!i?.useTrash&&!(r.capabilities&4096))throw new Error((0,p.localize)(19,null,this.mb(v)));let o;try{o=await r.stat(v)}catch{}if(o)this.lb(v,o);else throw new f.FileOperationError((0,p.localize)(20,null,this.mb(v)),1);if(!!!i?.recursive){const c=await this.resolve(v);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,p.localize)(21,null,this.mb(v)))}return r}async del(v,i){const r=await this.P(v,i),n=!!i?.useTrash,o=!!i?.recursive;await r.delete(v,{recursive:o,useTrash:n}),this.m.fire(new f.FileOperationEvent(v,1))}async cloneFile(v,i){const r=await this.j(v),n=this.kb(await this.l(i),i);if(r===n&&this.M(r).providerExtUri.isEqual(v,i))return;if(r===n&&(0,f.hasFileCloneCapability)(r))return r.cloneFile(v,i);await this.O(n,this.M(n).providerExtUri.dirname(i));const o=this.W.queueFor(v,this.M(r).providerExtUri);return r===n&&(0,f.hasFileFolderCopyCapability)(r)?o.queue(()=>r.copy(v,i,{overwrite:!0})):o.queue(()=>this.I(r,v,n,i))}watch(v,i={recursive:!1,excludes:[]}){const r=new m.DisposableStore;let n=!1,o=()=>{n=!0};return r.add((0,m.toDisposable)(()=>o())),(async()=>{try{const a=await this.U(v,i);n?(0,m.dispose)(a):o=()=>(0,m.dispose)(a)}catch(a){this.b.error(a)}})(),r}async U(v,i){const r=await this.j(v),n=(0,P.hash)([this.M(r).providerExtUri.getComparisonKey(v),i]);let o=this.S.get(n);return o||(o={count:0,disposable:r.watch(v,i)},this.S.set(n,o)),o.count+=1,(0,m.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,m.dispose)(o.disposable),this.S.delete(n)))})}dispose(){super.dispose();for(const[,v]of this.S)(0,m.dispose)(v.disposable);this.S.clear()}async X(v,i,r,n){return this.W.queueFor(i,this.M(v).providerExtUri).queue(async()=>{const o=await v.open(i,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(n)||(0,d.isReadableBufferedStream)(n)?await this.Y(v,o,n):await this.Z(v,o,n)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await v.close(o)}})}async Y(v,i,r){let n=0,o;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const a=k.VSBuffer.concat(r.buffer);await this.ab(v,i,a,a.byteLength,n,0),n+=a.byteLength}if(r.ended)return;o=r.stream}else o=r;return new Promise((a,c)=>{(0,d.listenStream)(o,{onData:async s=>{o.pause();try{await this.ab(v,i,s,s.byteLength,n,0)}catch(h){return c(h)}n+=s.byteLength,setTimeout(()=>o.resume())},onError:s=>c(s),onEnd:()=>a()})})}async Z(v,i,r){let n=0,o;for(;(o=r.read())!==null;)await this.ab(v,i,o,o.byteLength,n,0),n+=o.byteLength}async ab(v,i,r,n,o,a){let c=0;for(;c<n;)c+=await v.write(i,o+c,r.buffer,a+c,n-c)}async bb(v,i,r,n){return this.W.queueFor(i,this.M(v).providerExtUri).queue(()=>this.cb(v,i,r,n))}async cb(v,i,r,n){let o;n instanceof k.VSBuffer?o=n:(0,d.isReadableStream)(n)?o=await(0,k.streamToBuffer)(n):(0,d.isReadableBufferedStream)(n)?o=await(0,k.bufferedStreamToBuffer)(n):o=(0,k.readableToBuffer)(n),await v.writeFile(i,o.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async db(v,i,r,n){return this.W.queueFor(n,this.M(r).providerExtUri).queue(()=>this.eb(v,i,r,n))}async eb(v,i,r,n){let o,a;try{o=await v.open(i,{create:!1}),a=await r.open(n,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.a);let s=0,h=0,D=0;do D=await v.read(o,s,c.buffer,h,c.byteLength-h),await this.ab(r,a,c,D,s,h),s+=D,h+=D,h===c.byteLength&&(h=0);while(D>0)}catch(c){throw(0,f.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof o=="number"?v.close(o):Promise.resolve(),typeof a=="number"?r.close(a):Promise.resolve()])}}async fb(v,i,r,n){return this.W.queueFor(n,this.M(r).providerExtUri).queue(()=>this.gb(v,i,r,n))}async gb(v,i,r,n){return r.writeFile(n,await v.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async hb(v,i,r,n){return this.W.queueFor(n,this.M(r).providerExtUri).queue(()=>this.ib(v,i,r,n))}async ib(v,i,r,n){const o=await r.open(n,{create:!0,unlock:!1});try{const a=await v.readFile(i);await this.ab(r,o,k.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await r.close(o)}}async jb(v,i,r,n){const o=await(0,k.streamToBuffer)(this.z(v,i,M.CancellationToken.None));await this.bb(r,n,void 0,o)}kb(v,i){if(v.capabilities&2048)throw new f.FileOperationError((0,p.localize)(22,null,this.mb(i)),6);return v}lb(v,i){if((i.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,p.localize)(23,null,this.mb(v)),6)}mb(v){return v.scheme===S.Schemas.file?v.fsPath:v.toString(!0)}};C=pe([ee(0,w.ILogService)],C),e.FileService=C}),define(ie[87],re([0,1,40,282,8,39,17,3,31,2,9,4,20,59,23,163,16,108,205,45,201,200]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w,C,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(E)}catch(r){console.error(`Error enabling graceful-fs: ${(0,C.toErrorMessage)(r)}`)}})();class i extends w.AbstractDiskFileSystemProvider{constructor(n,o){super(n,o),this.onDidChangeCapabilities=P.Event.None,this.H=new M.ResourceMap(a=>y.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,S.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:o,symbolicLink:a}=await d.SymlinkSupport.stat(this.C(n));return{type:this.G(o,a),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.Y(o)}}async readdir(n){try{const o=await d.Promises.readdir(this.C(n),{withFileTypes:!0}),a=[];return await Promise.all(o.map(async c=>{try{let s;c.isSymbolicLink()?s=(await this.stat((0,y.joinPath)(n,c.name))).type:s=this.G(c),a.push([c.name,s])}catch(s){this.a.trace(s)}})),a}catch(o){throw this.Y(o)}}G(n,o){let a;return o?.dangling?a=f.FileType.Unknown:n.isFile()?a=f.FileType.File:n.isDirectory()?a=f.FileType.Directory:a=f.FileType.Unknown,o&&(a|=f.FileType.SymbolicLink),a}async I(n){const o=this.C(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let a;for(;a=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await a.wait();const c=new k.Barrier;return this.H.set(n,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,m.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.H.get(n)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),c.open()})}async readFile(n,o){let a;try{o?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),a=await this.I(n));const c=this.C(n);return await d.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{a?.dispose()}}J(n){i.D&&this.a.trace(n)}readFileStream(n,o,a){const c=(0,u.newWriteableStream)(s=>A.VSBuffer.concat(s.map(h=>A.VSBuffer.wrap(h))).buffer);return(0,l.readFileIntoStream)(this,n,c,s=>s.buffer,{...o,bufferSize:256*1024},a),c}async writeFile(n,o,a){let c;try{const s=this.C(n);if(!a.create||!a.overwrite){if(await d.Promises.exists(s)){if(!a.overwrite)throw(0,f.createFileSystemProviderError)((0,p.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,f.createFileSystemProviderError)((0,p.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:a.unlock}),await this.write(c,0,o,0,o.byteLength)}catch(s){throw await this.Z(n,s)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){i.O=n}async open(n,o){const a=this.C(n);let c;(0,f.isFileOpenForWriteOptions)(o)&&(c=await this.I(n));let s;try{if((0,f.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:D}=await d.SymlinkSupport.stat(a);D.mode&128||await d.Promises.chmod(a,D.mode|128)}catch(D){this.a.trace(D)}let h;if((0,f.isFileOpenForWriteOptions)(o)){if(S.isWindows)try{await d.Promises.truncate(a,0),h="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}h||(h="w")}else h="r";s=await d.Promises.open(a,h)}catch(h){throw c?.dispose(),(0,f.isFileOpenForWriteOptions)(o)?await this.Z(n,h):this.Y(h)}if(this.L.set(s,0),(0,f.isFileOpenForWriteOptions)(o)&&this.N.set(s,n),c){const h=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${a})`),this.M.set(s,c),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${a})`),h.dispose())}return s}async close(n){const o=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&i.O)try{await d.Promises.fdatasync(n)}catch(a){i.configureFlushOnWrite(!1),this.a.error(a)}return await d.Promises.close(n)}catch(a){throw this.Y(a)}finally{o&&(this.M.get(n)===o&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),o.dispose())}}async read(n,o,a,c,s){const h=this.P(n,o);let D=null;try{D=(await d.Promises.read(n,a,c,s,h)).bytesRead}catch(L){throw this.Y(L)}finally{this.Q(n,h,D)}return D}P(n,o){return o===this.L.get(n)?null:o}Q(n,o,a){const c=this.L.get(n);typeof c=="number"&&(typeof o=="number"||(typeof a=="number"?this.L.set(n,c+a):this.L.delete(n)))}async write(n,o,a,c,s){return(0,k.retry)(()=>this.R(n,o,a,c,s),100,3)}async R(n,o,a,c,s){const h=this.P(n,o);let D=null;try{D=(await d.Promises.write(n,a,c,s,h)).bytesWritten}catch(L){throw await this.Z(this.N.get(n),L)}finally{this.Q(n,h,D)}return D}async mkdir(n){try{await d.Promises.mkdir(this.C(n))}catch(o){throw this.Y(o)}}async delete(n,o){try{const a=this.C(n);o.recursive?await d.Promises.rm(a,d.RimRafMode.MOVE):await d.Promises.unlink(a)}catch(a){throw this.Y(a)}}async rename(n,o,a){const c=this.C(n),s=this.C(o);if(c!==s)try{await this.S(n,o,"move",a.overwrite),await d.Promises.move(c,s)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,p.localize)(2,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(s)),h.toString()))),this.Y(h)}}async copy(n,o,a){const c=this.C(n),s=this.C(o);if(c!==s)try{await this.S(n,o,"copy",a.overwrite),await d.Promises.copy(c,s,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,p.localize)(3,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(s)),h.toString()))),this.Y(h)}}async S(n,o,a,c){const s=this.C(n),h=this.C(o);let D=!1;if(!!(this.capabilities&1024)||(D=(0,g.isEqual)(s,h,!0)),D&&a==="copy")throw(0,f.createFileSystemProviderError)((0,p.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!D&&await d.Promises.exists(h)){if(!c)throw(0,f.createFileSystemProviderError)((0,p.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(n,o){return this.U(n,o,!1)}async U(n,o,a){const c=this.C(n),s=this.C(o),h=!!(this.capabilities&1024);if((0,g.isEqual)(c,s,!h))return;const D=new m.DisposableStore;try{const[L,T]=await Promise.all([this.I(n),this.I(o)]);D.add(L),D.add(T),a&&await d.Promises.mkdir((0,b.dirname)(s),{recursive:!0}),await d.Promises.copyFile(c,s)}catch(L){if(L.code==="ENOENT"&&!a)return this.U(n,o,!0);throw this.Y(L)}finally{D.dispose()}}p(n,o,a){return new I.UniversalWatcherClient(c=>n(c),c=>o(c),a)}y(n,o,a){return new v.NodeJSWatcherClient(c=>n(c),c=>o(c),a)}Y(n){if(n instanceof f.FileSystemProviderError)return n;let o;switch(n.code){case"ENOENT":o=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=f.FileSystemProviderErrorCode.NoPermissions;break;default:o=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(n,o)}async Z(n,o){let a=this.Y(o);if(n&&a.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.C(n));c.mode&128||(a=(0,f.createFileSystemProviderError)(o,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return a}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(ie[207],re([0,1,3,87,2,17,59,22]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class g extends k.Disposable{constructor(S,y){super(),this.a=S,this.b=y,this.w=new Map,this.y=new Map}call(S,y,u){const d=this.c(S);switch(y){case"stat":return this.g(d,u[0]);case"readdir":return this.h(d,u[0]);case"open":return this.l(d,u[0],u[1]);case"close":return this.m(u[0]);case"read":return this.n(u[0],u[1],u[2]);case"readFile":return this.i(d,u[0],u[1]);case"write":return this.p(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.k(d,u[0],u[1],u[2]);case"rename":return this.t(d,u[0],u[1],u[2]);case"copy":return this.u(d,u[0],u[1],u[2]);case"cloneFile":return this.v(d,u[0],u[1]);case"mkdir":return this.r(d,u[0]);case"delete":return this.s(d,u[0],u[1]);case"watch":return this.C(d,u[0],u[1],u[2],u[3]);case"unwatch":return this.D(u[0],u[1])}throw new Error(`IPC Command ${y} not found`)}listen(S,y,u){const d=this.c(S);switch(y){case"fileChange":return this.z(d,u[0]);case"readFileStream":return this.j(d,u[0],u[1])}throw new Error(`Unknown event ${y}`)}g(S,y){const u=this.f(S,y,!0);return this.a.stat(u)}h(S,y){const u=this.f(S,y);return this.a.readdir(u)}async i(S,y,u){const d=this.f(S,y,!0),p=await this.a.readFile(d,u);return M.VSBuffer.wrap(p)}j(S,y,u){const d=this.f(S,y,!0),p=new P.CancellationTokenSource,f=new E.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),l=this.a.readFileStream(d,u,p.token);return(0,A.listenStream)(l,{onData:w=>f.fire(M.VSBuffer.wrap(w)),onError:w=>f.fire(w),onEnd:()=>{f.fire("end"),f.dispose(),p.dispose()}}),f.event}k(S,y,u,d){const p=this.f(S,y);return this.a.writeFile(p,u.buffer,d)}l(S,y,u){const d=this.f(S,y,!0);return this.a.open(d,u)}m(S){return this.a.close(S)}async n(S,y,u){const d=M.VSBuffer.alloc(u),p=0,f=await this.a.read(S,y,d.buffer,p,u);return[d,f]}p(S,y,u,d,p){return this.a.write(S,y,u.buffer,d,p)}r(S,y){const u=this.f(S,y);return this.a.mkdir(u)}s(S,y,u){const d=this.f(S,y);return this.a.delete(d,u)}t(S,y,u,d){const p=this.f(S,y),f=this.f(S,u);return this.a.rename(p,f,d)}u(S,y,u,d){const p=this.f(S,y),f=this.f(S,u);return this.a.copy(p,f,d)}v(S,y,u){const d=this.f(S,y),p=this.f(S,u);return this.a.cloneFile(d,p)}z(S,y){const u=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(y,this.F(S,u))},onDidRemoveLastListener:()=>{(0,k.dispose)(this.w.get(y)),this.w.delete(y)}});return u.event}async C(S,y,u,d,p){const f=this.w.get(y);if(f){const l=this.f(S,d),w=f.watch(u,l,p);this.y.set(y+u,w)}}async D(S,y){const u=S+y,d=this.y.get(u);d&&((0,k.dispose)(d),this.y.delete(u))}dispose(){super.dispose();for(const[,S]of this.y)S.dispose();this.y.clear();for(const[,S]of this.w)S.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=g;class m extends k.Disposable{constructor(S,y,u,d){super(),this.c=S,this.f=u,this.g=d,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(y)}h(S){const y=this.B(new E.Emitter);this.B(y.event(u=>{S.fire(u.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type})))})),this.B(this.b.onDidChangeFile(u=>y.fire(u))),this.B(this.b.onDidWatchError(u=>S.fire(u)))}i(S){}j(S){}watch(S,y,u){const d=this.j(this.g);return Array.isArray(d)&&(u.excludes=[...u.excludes,...d]),this.a.set(S,this.b.watch(y,u)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.a.get(S)),this.a.delete(S)})}dispose(){super.dispose();for(const[,S]of this.a)S.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=m}),define(ie[208],re([0,1,14,162,4,7,16,9,207,141]),function(H,e,E,t,k,M,A,P,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends g.AbstractDiskFileSystemProviderChannel{constructor(u,d,p){super(u,d),this.G=p}c(u){return m.DefaultURITransformer}f(u,d){return M.URI.revive(d)}async s(u,d,p){if(!p.useTrash)return super.s(u,d,p);const f=this.f(u,d),l=(0,P.normalize)(f.fsPath);try{await E.shell.trashItem(l)}catch{throw(0,A.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,P.basename)(l)):(0,t.localize)(1,null,(0,P.basename)(l)),A.FileSystemProviderErrorCode.Unknown)}}F(u,d){return new S(u,d,this.b,this.G)}}e.DiskFileSystemProviderChannel=b;class S extends g.AbstractSessionFileWatcher{watch(u,d,p){if(p.recursive)throw(0,A.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(u,d,p)}}}),define(ie[209],re([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;class t extends E.AbstractMessageLogger{constructor(M=E.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(A=>{this.l?.setLevel(A)}))}set logger(M){this.l=M;for(const{level:A,message:P}of this.k)(0,E.log)(M,A,P);this.k=[]}g(M,A){this.l?(0,E.log)(this.l,M,A):this.getLevel()<=M&&this.k.push({level:M,message:A})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogService=t}),define(ie[210],re([0,1,3,7,6]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(y,u){this.a=y,this.b=u,this.onDidChangeLogLevel=E.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,u){switch(u){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${u}`)}async call(y,u,d){switch(u){case"setLevel":return d[1]?this.b.setLevel(t.URI.revive(d[1]),d[0]):this.a.setLevel(d[0])}throw new Error(`Call not found: ${u}`)}}e.LogLevelChannel=M;class A{constructor(y){this.a=y}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(y,u){A.setLevel(this.a,y,u)}static setLevel(y,u,d){return y.call("setLevel",[u,d])}}e.LogLevelChannelClient=A;class P{constructor(y){this.b=y,this.a=new Map}listen(y,u){throw new Error(`Event not found: ${u}`)}async call(y,u,d){switch(u){case"createLogger":this.c(t.URI.revive(d[0]),d[1]);return;case"log":return this.e(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1])}throw new Error(`Call not found: ${u}`)}c(y,u){this.a.set(y.toString(),this.b.createLogger(y,u))}d(y,u){let d=console.log;switch(y){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...u)}e(y,u){const d=this.a.get(y.toString());if(!d)throw new Error("Create the logger before logging");for(const[p,f]of u)(0,k.log)(d,p,f)}}e.LoggerChannel=P;class g extends k.AbstractLoggerService{constructor(y,u,d){super(y,u),this.g=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(y,u)=>{this.g.call("consoleLog",[y,u])}})}f(y,u,d){return new m(this.g,y,u,d)}}e.LoggerChannelClient=g;class m extends k.AbstractMessageLogger{constructor(y,u,d,p){super(p?.always),this.m=y,this.n=u,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[u,p]).then(()=>{this.r(this.l),this.k=!0})}g(y,u){const d=[[y,u]];this.k?this.r(d):this.l.push(...d)}r(y){this.m.call("log",[this.n,y])}}class b extends k.LogService{constructor(y,u){super(u),this.c=y,this.B(y.onDidChangeLogLevel(d=>u.setLevel(d)))}setLevel(y){super.setLevel(y),this.c.setLevel(y)}}e.FollowerLogService=b}),define(ie[211],re([0,1,16,6]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(k||(k={}));async function M(m,b,S,y,u){try{const d=await new Promise((f,l)=>{H(["spdlog"],f,l)});d.setFlushOn(k.Trace);const p=await d.createAsyncRotatingLogger(m,b,S,y);return u?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(d){console.error(d)}return null}function A(m,b,S){switch(b){case t.LogLevel.Trace:m.trace(S);break;case t.LogLevel.Debug:m.debug(S);break;case t.LogLevel.Info:m.info(S);break;case t.LogLevel.Warning:m.warn(S);break;case t.LogLevel.Error:m.error(S);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function P(m,b){switch(b){case t.LogLevel.Trace:m.setLevel(k.Trace);break;case t.LogLevel.Debug:m.setLevel(k.Debug);break;case t.LogLevel.Info:m.setLevel(k.Info);break;case t.LogLevel.Warning:m.setLevel(k.Warning);break;case t.LogLevel.Error:m.setLevel(k.Error);break;case t.LogLevel.Off:m.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class g extends t.AbstractMessageLogger{constructor(b,S,y,u,d){super(),this.k=[],this.setLevel(d),this.l=this.n(b,S,y,u),this.B(this.onDidChangeLogLevel(p=>{this.m&&P(this.m,p)}))}async n(b,S,y,u){const d=y?6:1,p=30/d*E.ByteSize.MB,f=await M(b,S,p,d,u);if(f){this.m=f,P(this.m,this.getLevel());for(const{level:l,message:w}of this.k)A(this.m,l,w);this.k=[]}}g(b,S){this.m?A(this.m,b,S):this.getLevel()<=b&&this.k.push({level:b,message:S})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=g}),define(ie[212],re([0,1,30,6,211]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let M=class extends t.AbstractLoggerService{constructor(P){super(P.getLevel(),P.onDidChangeLogLevel)}f(P,g,m){return new k.SpdLogLogger(m?.name||(0,E.generateUuid)(),P.fsPath,!m?.donotRotate,!!m?.donotUseFormatters,g)}};M=pe([ee(0,t.ILogService)],M),e.LoggerService=M}),define(ie[213],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(A){return A.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function t(A){return A.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(A){return A.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function M(A){return!E(A)&&!t(A)&&!k(A)}e.isMenubarMenuItemAction=M}),define(ie[37],re([0,1,3,67,2,5]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,M.createDecorator)("policy");class A extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const b=Object.keys(this.f).length;return this.f={...m,...this.f},b!==Object.keys(this.f).length&&await this.i(m),t.Iterable.reduce(this.g.entries(),(S,[y,u])=>({...S,[y]:u}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(m,[b,S])=>({...m,[b]:{definition:S,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=A;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ie[214],re([0,1,8,3,67,11,16,6,37]),function(H,e,E,t,k,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(S,y){const u=[];for(const d of new Set(k.Iterable.concat(S.keys(),y.keys())))S.get(d)!==y.get(d)&&u.push(d);return u}let b=class extends g.AbstractPolicyService{constructor(y,u,d){super(),this.j=y,this.k=u,this.l=d,this.c=this.B(new E.ThrottledDelayer(500));const p=t.Event.filter(u.onDidFilesChange,f=>f.affects(y));this.B(u.watch(y)),this.B(p(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const y=new Map;try{const u=await this.k.readFile(this.j),d=JSON.parse(u.value.toString());if(!(0,M.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(d))this.f[p]&&y.set(p,d[p])}catch(u){u.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",u)}return y}async p(){const y=await this.n(),u=m(this.g,y);this.g=y,u.length>0&&this.h.fire(u)}};b=pe([ee(1,A.IFileService),ee(2,P.ILogService)],b),e.FilePolicyService=b}),define(ie[215],re([0,1,3,2,37]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class M{constructor(g){this.b=g,this.a=new t.DisposableStore}listen(g,m){switch(m){case"onDidChange":return E.Event.map(this.b.onDidChange,b=>b.reduce((S,y)=>({...S,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${m}`)}call(g,m,b){switch(m){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${m}`)}dispose(){this.a.dispose()}}e.PolicyChannel=M;class A extends k.AbstractPolicyService{constructor(g,m){super(),this.a=m;for(const b in g){const{definition:S,value:y}=g[b];this.f[b]=S,y!==void 0&&this.g.set(b,y)}this.a.listen("onDidChange")(b=>{for(const S in b){const y=b[S];y===null?this.g.delete(S):this.g.set(S,y)}this.h.fire(Object.keys(b))})}async i(g){const m=await this.a.call("updatePolicyDefinitions",g);for(const b in m)this.g.set(b,m[b])}}e.PolicyChannelClient=A}),define(ie[63],re([0,1,4,33]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const M=E.globals.vscode.context.configuration();if(M)k=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(k=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:M.version})}}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(ie[19],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[216],re([0,1,78,6,19]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(P,g){this.b=P,this.c=g,this.a=new Map}async isExtensionUrlTrusted(P,g){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(g);if(!m)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",g),!1;const[,b,S]=m;let y=this.a.get(P);if(!y){if(y=this.b.trustedExtensionUrlPublicKeys[P],!y||y.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.a.set(P,[...y])}const u=Buffer.from(decodeURIComponent(S),"base64");if(u.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",g),!1;const d=u.slice(0,6),p=u.readUIntBE(0,6),f=Date.now()-p;if(f<0||f>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",g),!1;const l=u.slice(6),w=E.createVerify("SHA256");w.write(d),w.write(Buffer.from(b)),w.end();for(let C=0;C<y.length;C++){let I=y[C];if(I!==null){if(typeof I=="string")try{I=E.createPublicKey({key:Buffer.from(I,"base64"),format:"der",type:"spki"}),y[C]=I}catch(v){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${C+1} for ${P}:`,v),y[C]=null;continue}if(w.verify(I,l))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",g),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",g),!1}};M=pe([ee(0,k.IProductService),ee(1,t.ILogService)],M),e.ExtensionUrlTrustService=M}),define(ie[217],re([0,1,8,6]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let k=class{constructor(A,P,g){this.a=A,this.b=P,this.c=g}async inspect(A){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.timeout)(A);const g=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),g.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};k=pe([ee(2,t.ILogService)],k),e.WindowProfiler=k}),define(ie[64],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(ie[48],re([0,1,122,11]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(A,P){E.ok(t.isString(A)),E.ok(t.isObject(P)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,P)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.Registry=new k}),define(ie[218],re([0,1,3,48]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,m){this.a[k(g)]=m,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;t.Registry.add(e.Extensions.JSONContribution,A)}),define(ie[65],re([0,1,24,3,11,150,18,218,48]),function(H,e,E,t,k,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=g.Registry.as(P.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const n=new Set;this.n(i,r,n),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const r=new Set;this.o(i,r),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const n=new Set;this.o(r,n),this.n(i,!1,n),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const n=[];for(const{overrides:o,source:a}of i)for(const c in o)if(r.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const s=this.a.get(c),h=s?.valuesSources??new Map;if(a)for(const F of Object.keys(o[c]))h.set(F,a);const D={...s?.value||{},...o[c]};this.a.set(c,{source:a,value:D,valuesSources:h});const L=(0,A.getLanguageTagSettingPlainKey)(c),T={type:"object",default:D,description:M.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:k.isString(a)?void 0:a,defaultValueSource:a};n.push(...p(c)),this.d[c]=T,this.b.properties[c]=T}else{this.a.set(c,{value:o[c],source:a});const s=this.d[c];s&&(this.w(c,s),this.r(c,s))}this.m(n)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:n,source:o}of i)for(const a in n){const c=this.a.get(a),s=k.isString(o)?o:o?.id,h=k.isString(c?.source)?c?.source:c?.source?.id;if(s===h)if(r.add(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const D=this.d[a];D&&(this.w(a,D),this.r(a,D))}}this.u()}deltaConfiguration(i){let r=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,n){i.forEach(o=>{this.p(o,r,o.extensionInfo,o.restrictedProperties,void 0,n),this.c.push(o),this.q(o)})}o(i,r){const n=o=>{if(o.properties)for(const a in o.properties){r.add(a);const c=this.d[a];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[a],this.s(a,o.properties[a])}o.allOf?.forEach(a=>n(a))};for(const o of i){n(o);const a=this.c.indexOf(o);a!==-1&&this.c.splice(a,1)}}p(i,r=!0,n,o,a=3,c){a=k.isUndefinedOrNull(i.scope)?a:i.scope;const s=i.properties;if(s)for(const D in s){const L=s[D];if(r&&C(D,L)){delete s[D];continue}if(L.source=n,L.defaultDefaultValue=s[D].default,this.w(D,L),e.OVERRIDE_PROPERTY_REGEX.test(D)?L.scope=void 0:(L.scope=k.isUndefinedOrNull(L.scope)?a:L.scope,L.restricted=k.isUndefinedOrNull(L.restricted)?!!o?.includes(D):L.restricted),s[D].hasOwnProperty("included")&&!s[D].included){this.f[D]=s[D],delete s[D];continue}else this.d[D]=s[D],s[D].policy?.name&&this.e.set(s[D].policy.name,D);!s[D].deprecationMessage&&s[D].markdownDeprecationMessage&&(s[D].deprecationMessage=s[D].markdownDeprecationMessage),c.add(D)}const h=i.allOf;if(h)for(const D of h)this.p(D,r,n,o,a,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=n=>{const o=n.properties;if(o)for(const c in o)this.r(c,o[c]);n.allOf?.forEach(r)};r(i)}r(i,r){switch(e.allSettings.properties[i]=r,r.scope){case 1:e.applicationSettings.properties[i]=r;break;case 2:e.machineSettings.properties[i]=r;break;case 6:e.machineOverridableSettings.properties[i]=r;break;case 3:e.windowSettings.properties[i]=r;break;case 4:e.resourceSettings.properties[i]=r;break;case 5:e.resourceSettings.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.allSettings.properties[i],r.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,n={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,n),e.allSettings.properties[r]=n,e.applicationSettings.properties[r]=n,e.machineSettings.properties[r]=n,e.machineOverridableSettings.properties[r]=n,e.windowSettings.properties[r]=n,e.resourceSettings.properties[r]=n}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,r){const n=this.a.get(i);let o=n?.value,a=n?.source;k.isUndefined(o)&&(o=r.defaultDefaultValue,a=void 0),k.isUndefined(o)&&(o=l(r.type)),r.default=o,r.defaultValueSource=a}}const u="\\[([^\\]]+)\\]",d=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(v){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let r=d.exec(v);for(;r?.length;){const n=r[1].trim();n&&i.push(n),r=d.exec(v)}}return(0,E.distinct)(i)}e.overrideIdentifiersFromKey=p;function f(v){return v.reduce((i,r)=>`${i}[${r}]`,"")}e.keyFromOverrideIdentifiers=f;function l(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const w=new y;g.Registry.add(e.Extensions.Configuration,w);function C(v,i){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?M.localize(7,null,v):w.getConfigurationProperties()[v]!==void 0?M.localize(8,null,v):i.policy?.name&&w.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,v,i.policy?.name,w.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.validateProperty=C;function I(){const v=[],i=w.getConfigurationProperties();for(const r of Object.keys(i))v.push([r,i[r].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=I}),define(ie[109],re([0,1,24,3,43,2,39,44,11,7,18,65,48]),function(H,e,E,t,k,M,A,P,g,m,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class u{constructor(r={},n=[],o=[],a){this.c=r,this.d=n,this.f=o,this.raw=a,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(n=>{if(n instanceof u)return n;const o=new d("");return o.parseRaw(n),o.configurationModel});this.g=r.reduce((n,o)=>o===n?o:n.merge(o),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,b.getConfigurationValue)(this.contents,r):this.contents}inspect(r,n){const o=this.rawConfiguration.getValue(r),a=n?this.rawConfiguration.getOverrideValue(r,n):void 0,c=n?this.rawConfiguration.override(n).getValue(r):o;return{value:o,override:a,merged:c}}getOverrideValue(r,n){const o=this.l(n);return o?r?(0,b.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const o of this.overrides)o.identifiers.includes(r)&&n.push(...o.keys);return E.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return E.distinct(r)}override(r){let n=this.b.get(r);return n||(n=this.h(r),this.b.set(r,n)),n}merge(...r){const n=P.deepClone(this.contents),o=P.deepClone(this.overrides),a=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const s of r)if(c.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.j(n,s.contents);for(const h of s.overrides){const[D]=o.filter(L=>E.equals(L.identifiers,h.identifiers));D?(this.j(D.contents,h.contents),D.keys.push(...h.keys),D.keys=E.distinct(D.keys)):o.push(P.deepClone(h))}for(const h of s.keys)a.indexOf(h)===-1&&a.push(h)}return new u(n,a,o,c.every(s=>s instanceof u)?void 0:c)}freeze(){return this.a=!0,this}h(r){const n=this.l(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const a of E.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[a];const s=n[a];s&&(typeof c=="object"&&typeof s=="object"?(c=P.deepClone(c),this.j(c,s)):c=s),o[a]=c}return new u(o,this.keys,this.overrides)}j(r,n){for(const o of Object.keys(n)){if(o in r&&g.isObject(r[o])&&g.isObject(n[o])){this.j(r[o],n[o]);continue}r[o]=P.deepClone(n[o])}}k(r){return this.a&&!Object.isFrozen(r)?P.deepFreeze(r):r}l(r){let n=null,o=null;const a=c=>{c&&(o?this.j(o,c):o=P.deepClone(c))};for(const c of this.overrides)E.equals(c.identifiers,[r])?n=c.contents:c.identifiers.includes(r)&&a(c.contents);return a(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.m(r),(0,b.addToValueTree)(this.contents,r,n,o=>{throw new Error(o)})}removeValue(r){this.n(r)&&(0,b.removeFromValueTree)(this.contents,r)}m(r){let n=this.keys.length;for(let o=0;o<n;o++)r.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,r)}n(r){const n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=u;class d{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new u}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,n){if(!g.isUndefinedOrNull(r)){const o=this.g(r);this.parseRaw(o,n)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,n){this.a=r;const{contents:o,keys:a,overrides:c,restricted:s,hasExcludedProperties:h}=this.h(r,n);this.b=new u(o,a,c,h?[r]:void 0),this.c=s||[]}g(r){let n={},o=null,a=[];const c=[],s=[];function h(L){Array.isArray(a)?a.push(L):o!==null&&(a[o]=L)}const D={onObjectBegin:()=>{const L={};h(L),c.push(a),a=L,o=null},onObjectProperty:L=>{o=L},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const L=[];h(L),c.push(a),a=L,o=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:h,onError:(L,T,F)=>{s.push({error:L,offset:T,length:F})}};if(r)try{k.visit(r,D),n=a[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return n}h(r,n){const o=y.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),a=this.j(r,o,!0,n);r=a.raw;const c=(0,b.toValuesTree)(r,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),s=Object.keys(r),h=this.l(r,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:c,keys:s,overrides:h,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}j(r,n,o,a){let c=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const s={},h=[];for(const D in r)if(S.OVERRIDE_PROPERTY_REGEX.test(D)&&o){const L=this.j(r[D],n,!1,a);s[D]=L.raw,c=c||L.hasExcludedProperties,h.push(...L.restricted)}else{const L=n[D],T=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&h.push(D),(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&!(a.skipRestricted&&L?.restricted)?s[D]=r[D]:c=!0}return{raw:s,restricted:h,hasExcludedProperties:c}}l(r,n){const o=[];for(const a of Object.keys(r))if(S.OVERRIDE_PROPERTY_REGEX.test(a)){const c={};for(const s in r[a])c[s]=r[a][s];o.push({identifiers:(0,S.overrideIdentifiersFromKey)(a),keys:Object.keys(c),contents:(0,b.toValuesTree)(c,n)})}return o}}e.ConfigurationModelParser=d;class p extends M.Disposable{constructor(r,n,o,a){super(),this.f=r,this.g=n,this.h=a,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new d(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&o.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new u}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=p;class f{constructor(r,n,o,a,c,s,h,D,L,T,F,G,V){this.a=r,this.b=n,this.value=o,this.overrideIdentifiers=a,this.c=c,this.d=s,this.f=h,this.g=D,this.h=L,this.j=T,this.k=F,this.l=G,this.m=V}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(r,n,o,a,c=new u,s=new u,h=new A.ResourceMap,D=new u,L=new A.ResourceMap,T=!0){this.c=r,this.d=n,this.f=o,this.g=a,this.h=c,this.j=s,this.l=h,this.m=D,this.n=L,this.p=T,this.a=null,this.b=new A.ResourceMap,this.q=null}getValue(r,n,o){return this.s(r,n,o).getValue(r)}updateValue(r,n,o={}){let a;o.resource?(a=this.n.get(o.resource),a||(a=new u,this.n.set(o.resource,a))):a=this.m,n===void 0?a.removeValue(r):a.setValue(r,n),o.resource||(this.a=null)}inspect(r,n,o){const a=this.s(r,n,o),c=this.w(n.resource,o),s=n.resource?this.n.get(n.resource)||this.m:this.m,h=new Set;for(const D of a.overrides)for(const L of D.identifiers)a.getOverrideValue(r,L)!==void 0&&h.add(L);return new f(r,n,a.getValue(r),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),o?this.j.freeze():void 0,c?c.freeze():void 0,s.inspect(r,n.overrideIdentifier))}keys(r){const n=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,n){this.l.set(r,n),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const o=[];if(!n){const{added:a,updated:c,removed:s}=I(this.c,r);n=[...a,...c,...s]}for(const a of n)for(const c of(0,S.overrideIdentifiersFromKey)(a)){const s=this.c.getKeysForOverrideIdentifier(c),h=r.getKeysForOverrideIdentifier(c),D=[...h.filter(L=>s.indexOf(L)===-1),...s.filter(L=>h.indexOf(L)===-1),...s.filter(L=>!P.equals(this.c.override(c).getValue(L),r.override(c).getValue(L)))];o.push([c,D])}return this.updateDefaultConfiguration(r),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:o,removed:a}=I(this.d,r),c=[...n,...o,...a];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:n,updated:o,removed:a,overrides:c}=I(this.applicationConfiguration,r),s=[...n,...o,...a];return s.length&&this.updateApplicationConfiguration(r),{keys:s,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:o,removed:a,overrides:c}=I(this.localUserConfiguration,r),s=[...n,...o,...a];return s.length&&this.updateLocalUserConfiguration(r),{keys:s,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:o,removed:a,overrides:c}=I(this.remoteUserConfiguration,r),s=[...n,...o,...a];return s.length&&this.updateRemoteUserConfiguration(r),{keys:s,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:o,removed:a,overrides:c}=I(this.workspaceConfiguration,r),s=[...n,...o,...a];return s.length&&this.updateWorkspaceConfiguration(r),{keys:s,overrides:c}}compareAndUpdateFolderConfiguration(r,n){const o=this.r.get(r),{added:a,updated:c,removed:s,overrides:h}=I(o,n),D=[...a,...c,...s];return(D.length||!o)&&this.updateFolderConfiguration(r,n),{keys:D,overrides:h}}compareAndDeleteFolderConfiguration(r){const n=this.r.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:a,removed:c,overrides:s}=I(n,void 0);return{keys:[...o,...a,...c],overrides:s}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,n,o){let a=this.t(n,o);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(a=a.merge(this.d)),a}t({resource:r},n){let o=this.u();if(n&&r){const a=n.getFolder(r);a&&(o=this.v(a.uri)||o);const c=this.n.get(r);c&&(o=o.merge(c))}return o}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let n=this.b.get(r);if(!n){const o=this.u(),a=this.l.get(r);a?(n=o.merge(a),this.p&&(n=n.freeze()),this.b.set(r,n)):n=o}return n}w(r,n){if(n&&r){const o=n.getFolder(r);if(o)return this.l.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,n)=>{const{contents:o,overrides:a,keys:c}=this.l.get(n);return r.push([n,{contents:o,overrides:a,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this.j.freeze().keys.forEach(n=>r.add(n)),this.l.forEach(n=>n.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.j.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.l.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}y(r){const n=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.j.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.l.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a))),[...n.values()]}static parse(r){const n=this.z(r.defaults),o=this.z(r.policy),a=this.z(r.application),c=this.z(r.user),s=this.z(r.workspace),h=r.folders.reduce((D,L)=>(D.set(m.URI.revive(L[0]),this.z(L[1])),D),new A.ResourceMap);return new l(n,o,a,c,new u,s,h,new u,new A.ResourceMap,!1)}static z(r){return new u(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=l;function w(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const r=new Set,n=new Map;for(const a of i)a.keys.forEach(c=>r.add(c)),a.overrides.forEach(([c,s])=>{const h=(0,A.getOrSet)(n,c,new Set);s.forEach(D=>h.add(D))});const o=[];return n.forEach((a,c)=>o.push([c,[...a.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=w;class C{constructor(r,n,o,a){this.change=r,this.f=n,this.g=o,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const s of c)this.affectedKeys.add(s);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=l.parse(this.f.data)),this.j}affectsConfiguration(r,n){const o=this.a+r,a=this.d.indexOf(o);if(a<0)return!1;const c=a+o.length;if(c>=this.d.length)return!1;const s=this.d.charCodeAt(c);if(s!==this.b&&s!==this.c)return!1;if(n){const h=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.f?.workspace):void 0,D=this.g.getValue(r,n,this.h);return!P.equals(h,D)}return!0}}e.ConfigurationChangeEvent=C;function I(i,r){const{added:n,removed:o,updated:a}=v(r?.rawConfiguration,i?.rawConfiguration),c=[],s=i?.getAllOverrideIdentifiers()||[],h=r?.getAllOverrideIdentifiers()||[];if(r){const D=h.filter(L=>!s.includes(L));for(const L of D)c.push([L,r.getKeysForOverrideIdentifier(L)])}if(i){const D=s.filter(L=>!h.includes(L));for(const L of D)c.push([L,i.getKeysForOverrideIdentifier(L)])}if(r&&i){for(const D of s)if(h.includes(D)){const L=v({contents:i.getOverrideValue(void 0,D)||{},keys:i.getKeysForOverrideIdentifier(D)},{contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)});c.push([D,[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:o,updated:a,overrides:c}}function v(i,r){const n=i?r?i.keys.filter(c=>r.keys.indexOf(c)===-1):[...i.keys]:[],o=r?i?r.keys.filter(c=>i.keys.indexOf(c)===-1):[...r.keys]:[],a=[];if(i&&r){for(const c of r.keys)if(i.keys.indexOf(c)!==-1){const s=(0,b.getConfigurationValue)(r.contents,c),h=(0,b.getConfigurationValue)(i.contents,c);P.equals(s,h)||a.push(c)}}return{added:n,removed:o,updated:a}}}),define(ie[219],re([0,1,24,3,2,44,11,18,109,65,6,37,48]),function(H,e,E,t,k,M,A,P,g,m,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class u extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new d(this.f())),this.b}async initialize(){return this.b=void 0,this.B(y.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:C})=>this.c(Array.from(w),C))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(w,C){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}}e.DefaultConfiguration=u;class d extends g.ConfigurationModel{constructor(w={}){const C=y.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),I=Object.keys(C),v=Object.create(null),i=[];for(const r in C){const n=w[r],o=n!==void 0?n:C[r].default;(0,P.addToValueTree)(v,r,o,a=>console.error(`Conflict in default settings: ${a}`))}for(const r of Object.keys(v))m.OVERRIDE_PROPERTY_REGEX.test(r)&&i.push({identifiers:(0,m.overrideIdentifiersFromKey)(r),keys:Object.keys(v[r]),contents:(0,P.toValuesTree)(v[r],n=>console.error(`Conflict in default settings file: ${n}`))});super(v,I,i)}}e.DefaultConfigurationModel=d;class p{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new g.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=p;let f=class extends k.Disposable{get configurationModel(){return this.b}constructor(w,C,I){super(),this.c=w,this.f=C,this.g=I,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new g.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.i(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.j(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const C={},I=[],v=y.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const i of w){const r=v[i];if(!r){I.push(i);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}I.push(i),C[r.policy.name]={type:r.type}}}return(0,A.isEmptyObject)(C)||await this.f.updatePolicyDefinitions(C),I}i(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const C=y.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),I=(0,E.coalesce)(w.map(v=>C.get(v)));this.j(I,!0)}j(w,C){this.g.trace("PolicyConfiguration#update",w);const I=y.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),v=[],i=this.b.isEmpty();for(const r of w){const n=I[r]?.policy?.name;if(n){const o=this.f.getPolicyValue(n);(i?o!==void 0:!(0,M.equals)(this.b.getValue(r),o))&&v.push([r,o])}else this.b.getValue(r)!==void 0&&v.push([r,void 0])}if(v.length){this.g.trace("PolicyConfiguration#changed",v);const r=this.b;this.b=new g.ConfigurationModel;for(const n of r.keys)this.b.setValue(n,r.getValue(n));for(const[n,o]of v)o===void 0?this.b.removeValue(n):this.b.setValue(n,o);C&&this.a.fire(this.b)}}};f=pe([ee(1,S.IPolicyService),ee(2,b.ILogService)],f),e.PolicyConfiguration=f}),define(ie[220],re([0,1,8,3,2,20,18,109,219,37]),function(H,e,E,t,k,M,A,P,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends k.Disposable{constructor(y,u,d,p){super(),this.i=y,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=d instanceof m.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,d,p)),this.f=this.B(new P.UserSettings(this.i,void 0,M.extUriBiasedIgnorePathCase,u)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:l})=>this.k(f,l))),this.B(this.c.onDidChangeConfiguration(f=>this.l(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,u,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(y,u,new P.ConfigurationModel,d)}getConfigurationData(){return this.a.toData()}getValue(y,u){const d=typeof y=="string"?y:void 0,p=(0,A.isConfigurationOverrides)(y)?y:(0,A.isConfigurationOverrides)(u)?u:{};return this.a.getValue(d,p,void 0)}updateValue(y,u,d,p){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.j(y)}j(y){const u=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(y);this.m(d,u,2)}k(y,u){const d=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(y,u);this.m(p,d,7)}l(y){const u=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(y);this.m(d,u,7)}m(y,u,d){const p=new P.ConfigurationChangeEvent(y,{data:u},this.a);p.source=d,p.sourceConfig=this.n(d),this.h.fire(p)}n(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ie[221],re([0,1,13,5]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends E.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof M&&P._code===k.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof M&&P._code===k.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof M&&P._code===k.NoResolverFound}static isHandled(P){return P instanceof M&&P.isHandled}constructor(P,g=k.Unknown,m){super(P),this._message=P,this._code=g,this._detail=m,this.isHandled=g===k.NotAvailable&&m===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M}),define(ie[55],re([0,1,15]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===E.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function k(m){if(!m)return;const b=m.indexOf("+");return b<0?m:m.substr(0,b)}e.getRemoteName=k;function M(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=M;function A(m){const{host:b,port:S}=g(m);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:S}}e.parseAuthorityWithPort=A;function P(m,b){let{host:S,port:y}=g(m);return typeof y>"u"&&(y=b),{host:S,port:y}}e.parseAuthorityWithOptionalPort=P;function g(m){const b=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const S=m.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const y=m.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:m,port:void 0}}}),define(ie[88],re([0,1,26,5,55]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=M;function A(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var g;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(g=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(p){this.value=p,this.c=p.toLowerCase()}static equals(p,f){if(typeof p>"u"||p===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof p=="string"||typeof f=="string"){const l=typeof p=="string"?p:p.value,w=typeof f=="string"?f:f.value;return E.equalsIgnoreCase(l,w)}return p.c===f.c}static toKey(p){return typeof p=="string"?p.toLowerCase():p.c}}e.ExtensionIdentifier=m;function b(d){return S(d)}e.isApplicationScopedExtension=b;function S(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function y(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function u(d,p){if(p){const f=`onResolveRemoteAuthority:${(0,k.getRemoteName)(p)}`;return d.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=u,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[222],re([0,1,8,17,22,13,3,2,30,102,221,55]),function(H,e,E,t,k,M,A,P,g,m,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var u;(function(R){R[R.Management=1]="Management",R[R.ExtensionHost=2]="ExtensionHost",R[R.Tunnel=3]="Tunnel"})(u=e.ConnectionType||(e.ConnectionType={}));function d(R){switch(R){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function p(R){const O=new k.CancellationTokenSource;return setTimeout(()=>O.cancel(),R),O.token}function f(R,O){if(R.isCancellationRequested||O.isCancellationRequested)return k.CancellationToken.Cancelled;const W=new k.CancellationTokenSource;return R.onCancellationRequested(()=>W.cancel()),O.onCancellationRequested(()=>W.cancel()),W.token}class l{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((W,j)=>{this.f=W,this.g=j}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function w(R,O){const W=new l(O);return W.registerDisposable(R.onControlMessage(j=>{const $=JSON.parse(j.toString()),Y=N($);Y?W.reject(Y):W.resolve($)})),W.promise}function C(R,O,W,j,$,Y,B,Z){const te=new l(Z);return O.connect(W,j,$,Y,B,(ae,ge)=>{te.didTimeout?(ae&&R.error(ae),ge?.dispose()):ae||!ge?te.reject(ae):te.resolve(ge)}),te.promise}function I(R,O){const W=new l(O);return R.then(j=>{W.didTimeout||W.resolve(j)},j=>{W.didTimeout||W.reject(j)}),W.promise}async function v(R,O,W,j){const $=oe(R,O);R.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await C(R.logService,R.socketFactory,R.host,R.port,(0,S.getRemoteServerRootPath)(R),`reconnectionToken=${R.reconnectionToken}&reconnection=${R.reconnectionProtocol?"true":"false"}`,`renderer-${d(O)}-${R.reconnectionToken}`,j)}catch(ge){throw R.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),R.logService.error(ge),ge}R.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let B,Z;R.reconnectionProtocol?(R.reconnectionProtocol.beginAcceptReconnection(Y,null),B=R.reconnectionProtocol,Z=!1):(B=new m.PersistentProtocol({socket:Y,measureRoundTripTime:!0}),Z=!0),R.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const te=await I(R.signService.createNewMessage((0,g.generateUuid)()),j),ae={type:"auth",auth:R.connectionToken||"00000000000000000000",data:te.data};B.sendControl(t.VSBuffer.fromString(JSON.stringify(ae)));try{const ge=await w(B,f(j,p(1e4)));if(ge.type!=="sign"||typeof ge.data!="string"){const Me=new Error("Unexpected handshake message");throw Me.code="VSCODE_CONNECTION_ERROR",Me}if(R.logService.trace(`${$} 4/6. received SignRequest control message.`),!await I(R.signService.validate(te,ge.signedData),j)){const Me=new Error("Refused to connect to unsupported server");throw Me.code="VSCODE_CONNECTION_ERROR",Me}const Oe=await I(R.signService.sign(ge.data),j),De={type:"connectionType",commit:R.commit,signedData:Oe,desiredConnectionType:O};return W&&(De.args=W),R.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),B.sendControl(t.VSBuffer.fromString(JSON.stringify(De))),{protocol:B,ownsProtocol:Z}}catch(ge){throw ge&&ge.code==="ETIMEDOUT"&&(R.logService.error(`${$} the handshake timed out. Error:`),R.logService.error(ge)),ge&&ge.code==="VSCODE_CONNECTION_ERROR"&&(R.logService.error(`${$} received error control message when negotiating connection. Error:`),R.logService.error(ge)),Z&&z(B),ge}}async function i(R,O,W,j){const $=Date.now(),Y=oe(R,O),{protocol:B,ownsProtocol:Z}=await v(R,O,W,j),te=new l(j);return te.registerDisposable(B.onControlMessage(ae=>{const ge=JSON.parse(ae.toString()),ke=N(ge);ke?(R.logService.error(`${Y} received error control message when negotiating connection. Error:`),R.logService.error(ke),Z&&z(B),te.reject(ke)):(R.reconnectionProtocol?.endAcceptReconnection(),R.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${x($)}!`),te.resolve({protocol:B,firstMessage:ge}))})),te.promise}async function r(R,O){const{protocol:W}=await i(R,1,void 0,O);return{protocol:W}}async function n(R,O,W){const{protocol:j,firstMessage:$}=await i(R,2,O,W),Y=$&&$.debugPort;return{protocol:j,debugPort:Y}}async function o(R,O,W){const j=Date.now(),$=oe(R,3),{protocol:Y}=await v(R,3,O,W);return R.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${x(j)}!`),Y}async function a(R,O,W){const{host:j,port:$,connectionToken:Y}=await R.addressProvider.getAddress();return{commit:R.commit,quality:R.quality,host:j,port:$,connectionToken:Y,reconnectionToken:O,reconnectionProtocol:W,socketFactory:R.socketFactory,signService:R.signService,logService:R.logService}}async function c(R,O,W){return h(R,async j=>{const{protocol:$}=await r(j,k.CancellationToken.None);return new X(R,O,W,j.reconnectionToken,$)})}e.connectRemoteAgentManagement=c;async function s(R,O){return h(R,async W=>{const{protocol:j,debugPort:$}=await n(W,O,k.CancellationToken.None);return new ue(R,O,W.reconnectionToken,j,$)})}e.connectRemoteAgentExtensionHost=s;async function h(R,O){for(let j=1;;j++)try{const $=(0,g.generateUuid)(),Y=await a(R,$,null);return await O(Y)}catch($){if(j<5)R.logService.error(`[remote-connection][attempt ${j}] An error occurred in initial connection! Will retry... Error:`),R.logService.error($);else throw R.logService.error(`[remote-connection][attempt ${j}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),R.logService.error($),ce.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled($)),$}}async function D(R,O,W){const j=await a(R,(0,g.generateUuid)(),null);return await o(j,{host:O,port:W},k.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function L(R){return(0,E.createCancelablePromise)(O=>new Promise((W,j)=>{const $=setTimeout(W,R*1e3);O.onCancellationRequested(()=>{clearTimeout($),W()})}))}var T;(function(R){R[R.ConnectionLost=0]="ConnectionLost",R[R.ReconnectionWait=1]="ReconnectionWait",R[R.ReconnectionRunning=2]="ReconnectionRunning",R[R.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",R[R.ConnectionGain=4]="ConnectionGain",R[R.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class F{constructor(O,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=F;class G{constructor(O,W,j,$){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.durationSeconds=j,this.c=$,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=G;class V{constructor(O,W,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.attempt=j,this.type=2}}e.ReconnectionRunningEvent=V;class K{constructor(O,W,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.attempt=j,this.type=4}}e.ConnectionGainEvent=K;class _{constructor(O,W){this.reconnectionToken=O,this.connectionHealth=W,this.type=5}}e.ConnectionHealthChangedEvent=_;class se{constructor(O,W,j,$){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.attempt=j,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class ce extends P.Disposable{static triggerPermanentFailure(O,W,j){this._permanentFailure=!0,this.f=O,this.g=W,this.h=j,this.i.forEach($=>$.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(O=>O.r())}static debugPauseSocketWriting(){this.i.forEach(O=>O.v())}get k(){return this.c||ce._permanentFailure}constructor(O,W,j,$,Y){super(),this.m=O,this.n=W,this.reconnectionToken=j,this.protocol=$,this.p=Y,this.j=this.B(new A.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new K(this.reconnectionToken,0,0)),this.B($.onSocketClose(B=>{const Z=Q(this.m,this.reconnectionToken,!0);B?B.type===0?(this.n.logService.info(`${Z} received socket close event (hadError: ${B.hadError}).`),B.error&&this.n.logService.error(B.error)):(this.n.logService.info(`${Z} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this.n.logService.error(B.event)):this.n.logService.info(`${Z} received socket close event.`),this.r()})),this.B($.onSocketTimeout(B=>{const Z=Q(this.m,this.reconnectionToken,!0);this.n.logService.info(`${Z} received socket timeout event (unacknowledgedMsgCount: ${B.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${B.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${B.timeSinceLastReceivedSomeData}).`),this.r()})),this.B($.onHighRoundTripTime(B=>{const Z=q(this.m,this.reconnectionToken);this.n.logService.info(`${Z} high roundtrip time: ${B.roundTripTime}ms (${B.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B($.onDidChangeConnectionHealth(B=>{this.j.fire(new _(this.reconnectionToken,B))})),ce.i.push(this),this.B((0,P.toDisposable)(()=>{const B=ce.i.indexOf(this);B>=0&&ce.i.splice(B,1)})),this.k&&this.u(ce.f,ce.g,ce.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const O=Q(this.m,this.reconnectionToken,!0);this.n.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let j=-1;do{j++;const $=j<W.length?W[j]:W[W.length-1];try{if($>0){const B=L($);this.j.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,B)),this.n.logService.info(`${O} waiting for ${$} seconds before reconnecting...`);try{await B}catch{}}if(this.k){this.n.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1)),this.n.logService.info(`${O} resolving connection...`);const Y=await a(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${O} connecting to ${Y.host}:${Y.port}...`),await this.w(Y,p(y)),this.n.logService.info(`${O} reconnected!`),this.j.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(Y),this.t(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(j>360){this.n.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(Y),this.t(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Y)){this.n.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.n.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Y);continue}if((0,M.isCancellationError)(Y)){this.n.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Y);continue}if(Y instanceof b.RemoteAuthorityResolverError){this.n.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(Y),this.t(this.protocol.getMillisSinceLastIncomingData(),j+1,b.RemoteAuthorityResolverError.isHandled(Y));break}this.n.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(Y),this.t(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}}while(!this.k)}t(O,W,j){this.p?ce.triggerPermanentFailure(O,W,j):this.u(O,W,j)}u(O,W,j){this.j.fire(new se(this.reconnectionToken,O,W,j)),z(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ce,ce._permanentFailure=!1,ce.f=0,ce.g=0,ce.h=!1,ce.i=[];class X extends ce{constructor(O,W,j,$,Y){super(1,O,$,Y,!0),this.client=this.B(new m.Client(Y,{remoteAuthority:W,clientId:j},O.ipcLogger))}async w(O,W){await r(O,W)}}e.ManagementPersistentConnection=X;class ue extends ce{constructor(O,W,j,$,Y){super(2,O,j,$,!1),this.y=W,this.debugPort=Y}async w(O,W){await n(O,this.y,W)}}e.ExtensionHostPersistentConnection=ue;function z(R){try{R.acceptDisconnect();const O=R.getSocket();R.dispose(),O.dispose()}catch(O){(0,M.onUnexpectedError)(O)}}function N(R){if(R&&R.type==="error"){const O=new Error(`Connection error: ${R.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function U(R,O){for(;R.length<O;)R+=" ";return R}function q(R,O){return`[remote-connection][${U(d(R),13)}][${O.substr(0,5)}\u2026]`}function Q(R,O,W){return`${q(R,O)}[${W?"reconnect":"initial"}]`}function oe(R,O){return`${Q(O,R.reconnectionToken,!!R.reconnectionProtocol)}[${R.host}:${R.port}]`}function x(R){return`${Date.now()-R} ms`}}),define(ie[223],re([0,1,79,84]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,M,A,P,g,m){const b=y=>m(y,void 0),S=E.createConnection({host:k,port:M},()=>{S.removeListener("error",b);const y=Buffer.alloc(16);for(let f=0;f<16;f++)y[f]=Math.round(Math.random()*256);const u=y.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${M}${A}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${u}`];S.write(d.join(`\r
`)+`\r
\r
`);const p=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",p),m(void 0,new t.NodeSocket(S,g)))};S.on("data",p)});S.setNoDelay(!0),S.once("error",b)}}}),define(ie[224],re([0,1,25,46,40,183]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let A;async function P(u=!1){return(A===void 0||u)&&(A=g()),A}e.hasWSLFeatureInstalled=P;async function g(){const u=m();if(u===void 0)return!1;if(u>=22e3){const d=S();if(d)return new Promise(p=>{t.execFile(d,["--status"],f=>p(!f))})}else{const d=y();if(d)try{if((await k.promises.stat(d)).isFile())return!0}catch{}}return!1}function m(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(u)return parseInt(u[3])}function b(u){const d=process.env.SystemRoot;if(d){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(d,p?"Sysnative":"System32",u)}}function S(){return b("wsl.exe")}function y(){return b("lxss\\LxssManager.dll")}}),define(ie[56],re([0,1,17,167,65,5,48]),function(H,e,E,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function P(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=P;function g(p){return p.res.statusCode===204}async function m(p){return g(p)?null:(await(0,E.streamToBuffer)(p.stream)).toString()}e.asText=m;async function b(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);return m(p)}e.asTextOrError=b;async function S(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);if(g(p))return null;const l=(await(0,E.streamToBuffer)(p.stream)).toString();try{return JSON.parse(l)}catch(w){throw w.message+=`:
`+l,w}}e.asJson=S;function y(p){d(p)}e.updateProxyConfigurationsScope=y;let u;function d(p){const f=A.Registry.as(k.Extensions.Configuration),l=u;u={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[u],remove:l?[l]:[]})}d(2)}),define(ie[225],re([0,1,17,22]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(P){this.a=P}listen(P,g){throw new Error("Invalid listen")}call(P,g,m,b=t.CancellationToken.None){switch(g){case"request":return this.a.request(m[0],b).then(async({res:S,stream:y})=>{const u=await(0,E.streamToBuffer)(y);return[{statusCode:S.statusCode,headers:S.headers},u]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class M{constructor(P){this.a=P}async request(P,g){const[m,b]=await this.a.call("request",[P],g);return{res:m,stream:(0,E.bufferToStream)(b)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=M}),define(ie[226],re([0,1,227,11]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(A,P){return A.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:A.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function M(A,P,g={}){const m=(0,E.parse)(A),b=g.proxyUrl||k(m,P);if(!b)return null;const S=(0,E.parse)(b);if(!/^https?:$/.test(S.protocol||""))return null;const y={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,t.isBoolean)(g.strictSSL)?g.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((u,d)=>{H(["http-proxy-agent"],u,d)}))(y):new(await new Promise((u,d)=>{H(["https-proxy-agent"],u,d)}))(y)}e.getProxyAgent=M}),define(ie[110],re([0,1,46,9,168,22,45,13,4,30,144,61,8,126]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let d;async function p(l,w,C,I){return C["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(I)&&!C["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(I)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=y.Promises.withAsyncBody(async(v,i)=>{const r=new M.CancellationTokenSource;let n=1e4;const o=l.getValue("application.shellEnvironmentResolutionTimeout");typeof o=="number"&&(n=(0,u.clamp)(o,1,120)*1e3);const a=setTimeout(()=>{r.dispose(!0),i(new Error((0,k.localize)(0,null)))},n);try{v(await f(w,r.token))}catch(c){!(0,P.isCancellationError)(c)&&!r.token.isCancellationRequested?i(new Error((0,k.localize)(1,null,(0,A.toErrorMessage)(c)))):v({})}finally{clearTimeout(a),r.dispose()}})),d)}e.getResolvedShellEnv=p;async function f(l,w){const C=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",C);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",I);const v=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(v+"({.*})"+v),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",r);const n=await(0,b.getSystemShell)(g.OS,r);return l.trace("getUnixShellEnvironment#shell",n),new Promise((o,a)=>{if(w.isCancellationRequested)return a(new P.CancellationError);const c=(0,t.basename)(n);let s,h;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(s=`& '${process.execPath}' ${D} -p '''${v}'' + JSON.stringify(process.env) + ''${v}'''`,h=["-Login","-Command"]):(s=`'${process.execPath}' ${D} -p '"${v}" + JSON.stringify(process.env) + "${v}"'`,c==="tcsh"?h=["-ic"]:h=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),s);const L=(0,E.spawn)(n,[...h,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});w.onCancellationRequested(()=>(L.kill(),a(new P.CancellationError))),L.on("error",G=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(G)),a(G)});const T=[];L.stdout.on("data",G=>T.push(G));const F=[];L.stderr.on("data",G=>F.push(G)),L.on("close",(G,V)=>{const K=Buffer.concat(T).toString("utf8");l.trace("getUnixShellEnvironment#raw",K);const _=Buffer.concat(F).toString("utf8");if(_.trim()&&l.trace("getUnixShellEnvironment#stderr",_),G||V)return a(new Error((0,k.localize)(2,null,G,V)));const se=i.exec(K),ce=se?se[1]:"{}";try{const X=JSON.parse(ce);C?X.ELECTRON_RUN_AS_NODE=C:delete X.ELECTRON_RUN_AS_NODE,I?X.ELECTRON_NO_ATTACH_CONSOLE=I:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.VSCODE_RESOLVING_ENVIRONMENT,delete X.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",X),o(X)}catch(X){l.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(X)),a(X)}})})}}),define(ie[89],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(ie[228],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.b=new Map}c(){return new Promise((k,M)=>H(["vsda"],k,M))}async createNewMessage(k){try{const M=await this.c(),A=new M.validator;if(A){const P=String(E.a++);return this.b.set(P,A),{id:P,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,M){if(!k.id)return!0;const A=this.b.get(k.id);if(!A)return!1;this.b.delete(k.id);try{return A.validate(M)==="ok"}catch{return!1}}async sign(k){try{const M=await this.c(),A=new M.signer;if(A)return A.sign(k)}catch{}return k}}e.SignService=E,E.a=1}),define(ie[36],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,E.createDecorator)("stateMainService")}),define(ie[21],re([0,1,14,41,8,3,2,4,33,11,5,6,36,27]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,b.createDecorator)("lifecycleMainService");var d;(function(l){l[l.QUIT=1]="QUIT",l[l.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var p;(function(l){l[l.Starting=1]="Starting",l[l.Ready=2]="Ready",l[l.AfterWindowOpen=3]="AfterWindowOpen",l[l.Eventually=4]="Eventually"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let f=class It extends A.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(w,C,I){super(),this.v=w,this.w=C,this.y=I,this.c=this.B(new M.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new M.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(It.b),this.j&&this.w.removeItem(It.b)}C(){const w=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.isMacintosh&&this.n===0&&this.D(1))};E.app.addListener("before-quit",w);const C=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!P.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",C),E.app.once("will-quit",I=>{this.L("Lifecycle#app.on(will-quit)"),I.preventDefault(),this.D(1).finally(()=>{this.H(!1),E.app.removeListener("before-quit",w),E.app.removeListener("window-all-closed",C),E.app.quit()})})}D(w){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const C=[];return this.f.fire({reason:w,join(I){C.push(I)}}),this.s=(async()=>{try{await k.Promises.settled(C)}catch(I){this.v.error(I)}try{await this.w.close()}catch(I){this.v.error(I)}})(),this.s}set phase(w){if(w<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===w)return;this.L(`lifecycle (main): phase changed (value: ${w})`),this.k=w;const C=this.u.get(this.k);C&&(C.open(),this.u.delete(this.k))}async when(w){if(w<=this.k)return;let C=this.u.get(w);C||(C=new k.Barrier,this.u.set(w,C)),await C.wait()}registerWindow(w){const C=new A.DisposableStore;this.n++,C.add(w.onWillLoad(v=>this.g.fire({window:w,workspace:v.workspace,reason:v.reason})));const I=(0,m.assertIsDefined)(w.win);I.on("close",v=>{const i=w.id;if(this.l.has(i)){this.l.delete(i);return}this.L(`Lifecycle#window.on('close') - window ID ${w.id}`),v.preventDefault(),this.unload(w,1).then(r=>{if(r){this.l.delete(i);return}this.l.add(i),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this.h.fire(w),w.close()})}),I.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${w.id}`),this.n--,C.dispose(),this.n===0&&(!P.isMacintosh||this.i)&&this.D(1)})}async reload(w,C){await this.unload(w,3)||w.reload(C)}unload(w,C){const I=this.t.get(w.id);if(I)return I;const v=this.F(w,C).finally(()=>{this.t.delete(w.id)});return this.t.set(w.id,v),v}async F(w,C){if(!w.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${w.id}`);const I=this.i?2:C,v=await this.I(w,I);return v?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${w.id})`),this.G(v)):(await this.J(w,I),!1)}G(w){return w?(this.H(!0),this.i=!1,!0):!1}H(w){this.r&&(this.r(w),this.r=void 0,this.p=void 0)}I(w,C){return new Promise(I=>{const v=this.m++,i=`vscode:ok${v}`,r=`vscode:cancel${v}`;t.validatedIpcMain.once(i,()=>{I(!1)}),t.validatedIpcMain.once(r,()=>{I(!0)}),w.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:r,reason:C})})}J(w,C){return new Promise(I=>{const i=`vscode:reply${this.m++}`;t.validatedIpcMain.once(i,()=>I()),w.send("vscode:onWillUnload",{replyChannel:i,reason:C})})}quit(w){return this.L(`Lifecycle#quit() - begin (willRestart: ${w})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(w&&this.w.setItem(It.b,!0),this.p=new Promise(C=>{this.r=C,this.L("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}L(w){this.y.args["enable-smoke-test-driver"]?this.v.info(w):this.v.trace(w)}async relaunch(w){this.L("Lifecycle#relaunch()");const C=process.argv.slice(1);if(w?.addArgs&&C.push(...w.addArgs),w?.removeArgs)for(const i of w.removeArgs){const r=C.indexOf(i);r>=0&&C.splice(r,1)}const I=()=>{try{if(P.isWindows){const i=(0,g.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.v.error(i)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:C})};E.app.once("quit",I),await this.quit(!0)&&E.app.removeListener("quit",I)}async kill(w){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const C of E.BrowserWindow.getAllWindows())if(C&&!C.isDestroyed()){let I;C.webContents&&!C.webContents.isDestroyed()?I=new Promise(v=>C.once("closed",v)):I=Promise.resolve(),C.destroy(),await I}})()]),E.app.exit(w)}};f.b="lifecycle.quitAndRestart",f=pe([ee(0,S.ILogService),ee(1,y.IStateMainService),ee(2,u.IEnvironmentMainService)],f),e.LifecycleMainService=f}),define(ie[229],re([0,1,4,3,2,5,21]),function(H,e,E,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let P=class extends k.Disposable{constructor(b){super(),this.a=this.B(new t.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((S,y)=>{H(["native-keymap"],S,y)});this.c=g(b),E.isCI||b.onDidChangeKeyboardLayout(()=>{this.c=g(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};P=pe([ee(0,A.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function g(m){const b=m.getKeyMap(),S=m.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:S}}}),define(ie[230],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(ie[231],re([0,1,8,17,11,35,16,6]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(S,y,u){this.f=S,this.g=y,this.h=u,this.a=Object.create(null),this.b="",this.c=new E.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(S){S.fileOperationResult!==1&&this.g.error(S)}}getItem(S,y){const u=this.a[S];return(0,k.isUndefinedOrNull)(u)?y:u}setItem(S,y){this.setItems([{key:S,data:y}])}setItems(S){let y=!1;for(const{key:u,data:d}of S)this.a[u]!==d&&((0,k.isUndefinedOrNull)(d)?(0,k.isUndefined)(this.a[u])||(this.a[u]=void 0,y=!0):(this.a[u]=d,y=!0));y&&this.j()}removeItem(S){(0,k.isUndefined)(this.a[S])||(this.a[S]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const S=JSON.stringify(this.a,null,4);if(S!==this.b)try{await this.h.writeFile(this.f,t.VSBuffer.fromString(S)),this.b=S}catch(y){this.g.error(y)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=g;let m=class{constructor(S,y,u){this.a=new g(S.stateResource,y,u)}async init(){await this.a.init()}getItem(S,y){return this.a.getItem(S,y)}};m=pe([ee(0,M.IEnvironmentService),ee(1,P.ILogService),ee(2,A.IFileService)],m),e.StateService=m}),define(ie[232],re([0,1,231]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends E.StateService{setItem(M,A){this.a.setItem(M,A)}setItems(M){this.a.setItems(M)}removeItem(M){this.a.removeItem(M)}close(){return this.a.close()}}e.StateMainService=t}),define(ie[90],re([0,1,4,33,7,30]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(m){if(E.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function P(m,b,S,y,u,d,p,f,l,w){const C=Object.create(null);C["common.machineId"]=p,C.sessionID=(0,M.generateUuid)()+Date.now(),C.commitHash=u,C.version=d,C["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),C["common.platform"]=(0,E.PlatformToString)(E.platform),C["common.nodePlatform"]=t.platform,C["common.nodeArch"]=y,C["common.product"]=w||"desktop",f&&(C["common.msftInternal"]=f);let I=0;const v=Date.now();Object.defineProperties(C,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>I++,enumerable:!0}}),E.isLinuxSnap&&(C["common.snap"]="true");const i=A(S);i&&(C["common.platformDetail"]=i);try{const r=await m.readFile(k.URI.file(l));C["common.source"]=r.value.toString().slice(0,30)}catch{}return C}e.resolveCommonProperties=P;function g(m){const b=t.env.USERDNSDOMAIN;if(!b)return!1;const S=b.toLowerCase();return m.some(y=>S===y)}e.verifyMicrosoftInternalDomain=g}),define(ie[29],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ie[233],re([0,1,25,8,43,15,9,4,7,82,23,101,85,16,19,29]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const f=new Map;async function l(i,r){const n=`${i}::${r.join(":")}`,o=f.get(n);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,s=new Map,h=2e4;function D(T,F,G,V){const K=F.substring(T.length+1);return t.Promises.withAsyncBody(async _=>{let se;try{se=await b.Promises.readdir(F,{withFileTypes:!0})}catch{_();return}if(V.count>=h){V.count+=se.length,V.maxReached=!0,_();return}let ce=se.length;if(ce===0){_();return}let X=se;V.count+se.length>h&&(V.maxReached=!0,ce=h-V.count,X=se.slice(0,ce)),V.count+=se.length;for(const ue of X)if(ue.isDirectory()){if(G.includes(ue.name)||await D(T,(0,A.join)(F,ue.name),G,V),--ce===0){_();return}}else{const z=ue.name.lastIndexOf(".");if(z>=0){const N=ue.name.substring(z+1);N&&c.set(N,(c.get(N)??0)+1)}for(const N of a)N.relativePathPattern?.test(K)!==!1&&N.filePattern.test(ue.name)&&s.set(N.tag,(s.get(N.tag)??0)+1);if(--ce===0){_();return}}})}const L=t.Promises.withAsyncBody(async T=>{const F={count:0,maxReached:!1};await D(i,i,r,F);const G=await I(i);T({configFiles:w(s),fileTypes:w(c),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:G})});return f.set(n,L),L}e.collectWorkspaceStats=l;function w(i){return Array.from(i.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function C(){const i={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},r=E.cpus();return r&&r.length>0&&(i.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),i}e.getMachineInfo=C;async function I(i){try{const r=new Map,n=(0,A.join)(i,".vscode","launch.json"),o=await b.Promises.readFile(n),a=[],c=(0,k.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${n}`),[];if((0,k.getNodeType)(c)==="object"&&c.configurations)for(const s of c.configurations){const h=s.type;h&&(r.has(h)?r.set(h,r.get(h)+1):r.set(h,1))}return w(r)}catch{return[]}}e.collectLaunchConfigs=I;let v=class{constructor(r,n){this.c=r,this.d=n}f(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}g(r){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const o=E.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||n.push(`Load (avg):       ${E.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,S.listProcesses)(r.mainPID),this.k(r)]).then(async o=>{let[a,c]=o,s=this.m(r,a);return n.forEach(h=>{if((0,y.isRemoteDiagnosticError)(h))s+=`
${h.errorMessage}`,c+=`
${h.errorMessage}`;else if(s+=`

Remote: ${h.hostName}`,h.processes&&(s+=`
${this.m(r,h.processes)}`),h.workspaceMetadata){c+=`
|  Remote: ${h.hostName}`;for(const D of Object.keys(h.workspaceMetadata)){const L=h.workspaceMetadata[D];let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),c+=`|    Folder (${D}): ${T}`,c+=this.h(L)}}}),{processInfo:s,workspaceInfo:c}})}async getSystemInfo(r,n){const{memory:o,vmHint:a,os:c,cpus:s}=C(),h={os:c,memory:o,cpus:s,vmHint:a,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return P.isWindows||(h.load=`${E.loadavg().map(D=>Math.round(D)).join(", ")}`),P.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(r,n){const o=[];return(0,S.listProcesses)(r.mainPID).then(async a=>(o.push(""),o.push(this.g(r)),o.push(""),o.push(this.m(r,a)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.k(r))),n.forEach(c=>{if((0,y.isRemoteDiagnosticError)(c))o.push(`
${c.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${c.hostName}`),o.push(this.f(c.machineInfo)),c.processes&&o.push(this.m(r,c.processes)),c.workspaceMetadata)for(const s of Object.keys(c.workspaceMetadata)){const h=c.workspaceMetadata[s];let D=`${h.fileCount} files`;h.maxFilesReached&&(D=`more than ${D}`),o.push(`Folder (${s}): ${D}`),o.push(this.h(h))}}),o.push(""),o.push(""),o.join(`
`)))}h(r){const n=[];let a=0;const c=(L,T)=>{const F=` ${L}(${T})`;a+F.length>60?(n.push(s),s="|                 ",a=s.length):a+=F.length,s+=F};let s="|      File types:";const h=10,D=r.fileTypes.length>h?h:r.fileTypes.length;for(let L=0;L<D;L++){const T=r.fileTypes[L];c(T.name,T.count)}if(n.push(s),r.configFiles.length>=0&&(s="|      Conf files:",a=0,r.configFiles.forEach(L=>{c(L.name,L.count)}),n.push(s)),r.launchConfigFiles.length>0){let L="|      Launch Configs:";r.launchConfigFiles.forEach(T=>{L+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),n.push(L)}return n.join(`
`)}j(r){const n=Math.max(...Object.keys(r).map(o=>o.length));return Object.keys(r).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${r[o]}`).join(`
                  `)}k(r){const n=[],o=[];return r.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const s=g.URI.revive(c);if(s.scheme===M.Schemas.file){const h=s.fsPath;o.push(l(h,["node_modules",".git"]).then(D=>{let L=`${D.fileCount} files`;D.maxFilesReached&&(L=`more than ${L}`),n.push(`|    Folder (${(0,A.basename)(h)}): ${L}`),n.push(this.h(D))}).catch(D=>{n.push(`|      Error: Unable to collect workspace stats for folder ${h} (${D.toString()})`)}))}else n.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(r,n){const o=new Map;r.windows.forEach(c=>o.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.n(r.mainPID,o,a,n,0),a.join(`
`)}n(r,n,o,a,c){const s=c===0;let h;s?h=a.pid===r?`${this.d.applicationName} main`:"remote agent":(h=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(h=`${h} (${n.get(a.pid)})`));const D=process.platform==="win32"?a.mem:E.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(D/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(a.children)&&a.children.forEach(L=>this.n(r,n,o,L,c+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:o}of r.folders){const a=g.URI.revive(o);if(a.scheme!==M.Schemas.file)continue;const c=a.fsPath;try{(await l(c,["node_modules",".git"])).fileTypes.forEach(h=>n.add(h.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const o=g.URI.revive(n);if(o.scheme!==M.Schemas.file)continue;const a=o.fsPath;try{const c=await l(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:s.name,count:s.count})}),c.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:s.name,count:s.count})}),c.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};v=pe([ee(0,p.ITelemetryService),ee(1,d.IProductService)],v),e.DiagnosticsService=v}),define(ie[234],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(M){this.b=M}listen(M,A){throw new Error(`Event not found: ${A}`)}call(M,A,{eventName:P,data:g}){return this.b.forEach(m=>m.log(P,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class t{constructor(M){this.b=M}log(M,A){return this.b.call("log",{eventName:M,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ie[51],re([0,1,44,11,3,18,55,90,29]),function(H,e,E,t,k,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class m{constructor(s){this.value=s}}e.TrustedTelemetryValue=m;class b{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,h){return Promise.resolve(void 0)}publicLog2(s,h){return this.publicLog(s,h)}publicLogError(s,h){return Promise.resolve(void 0)}publicLogError2(s,h){return this.publicLogError(s,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class S{async publicLog(s,h,D){}async publicLogError(s,h,D){}}e.NullEndpointTelemetryService=S,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(c,s){return k.Event.debounce(s.onDidChangeConfiguration,(D,L)=>{const T=D?new Set([...D.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:T}},1e3,!0)(D=>{D.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(D.source),configurationKeys:I(D.affectedKeys)})})}e.configurationTelemetry=y;function u(c,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!c.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=u;function d(c,s){return!(s.isBuilt||s.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=d;function p(c){const s=c.getValue(g.TELEMETRY_SETTING_ID),h=c.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function f(c){const s={},h={},D={};C(c,D);for(let L in D){L=L.length>150?L.substr(L.length-149):L;const T=D[L];typeof T=="number"?h[L]=T:typeof T=="boolean"?h[L]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${T.length}`),s[L]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(s[L]=T)}return{properties:s,measurements:h}}e.validateTelemetryData=f;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function w(c){if(!c)return"none";const s=(0,A.getRemoteName)(c);return l.has(s)?s:"other"}e.cleanRemoteAuthority=w;function C(c,s,h=0,D){if(!!c)for(const L of Object.getOwnPropertyNames(c)){const T=c[L],F=D?D+L:L;Array.isArray(T)?s[F]=(0,E.safeStringify)(T):T instanceof Date?s[F]=T.toISOString():(0,t.isObject)(T)?h<2?C(T,s,h+1,F+"."):s[F]=(0,E.safeStringify)(T):s[F]=T}}function I(c){if(!c)return[];const s=[];return v(s,"",c),s}function v(c,s,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(D=>v(c,s?`${s}.${D}`:D,h[D])):c.push(s)}function i(c,s){const h=c.msftInternalDomains||[],D=s.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(h)||D}e.isInternalTelemetry=i;function r(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=r;function n(c,s){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let h=c;const D=[];for(const G of s)for(;;){const V=G.exec(c);if(!V)break;D.push([V.index,G.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let F=0;for(h="";;){const G=T.exec(c);if(!G)break;const V=D.some(([K,_])=>G.index<_&&K<T.lastIndex);!L.test(G[0])&&!V&&(h+=c.substring(F,G.index)+"<REDACTED: user-file-path>",F=T.lastIndex)}return F<c.length&&(h+=c.substr(F)),h}function o(c){if(!c)return c;const s=c.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const D of h)if(D.regex.test(s))return`<REDACTED: ${D.label}>`;return c}function a(c,s){return(0,E.cloneAndChange)(c,h=>{if(h instanceof m)return h.value;if(typeof h=="string"){let D=h.replaceAll("%20"," ");D=n(D,s);for(const L of s)D=D.replace(L,"");return D=o(D),D}})}e.cleanData=a}),define(ie[111],re([0,1,26,193,88,4,7,13,33,51]),function(H,e,E,t,k,M,A,P,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(n,o){return n.uuid&&o.uuid?n.uuid===o.uuid:n.id===o.id?!0:(0,E.compareIgnoreCase)(n.id,o.id)===0}e.areSameExtensions=b;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(o){const a=o.manifest?o.manifest.version:o.version,c=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new y(o.identifier,a,c)}static parse(o){const a=S.exec(o);return a&&a[1]&&a[2]?new y({id:a[1]},a[2],a[4]||void 0):null}constructor(o,a,c="undefined"){this.version=a,this.targetPlatform=c,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof y?b(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=y;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(n){const o=u.exec(n);return o&&o[1]?[f(o[1]),o[2]]:[f(n),void 0]}e.getIdAndVersion=d;function p(n,o){return`${n}.${o}`}e.getExtensionId=p;function f(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=f;function l(n,o){return f(p(n,o))}e.getGalleryExtensionId=l;function w(n,o){const a=[],c=s=>{for(const h of a)if(h.some(D=>b(o(D),o(s))))return h;return null};for(const s of n){const h=c(s);h?h.push(s):a.push([s])}return a}e.groupByExtension=w;function C(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=C;function I(n){return{id:new m.TrustedTelemetryValue(n.identifier.id),name:new m.TrustedTelemetryValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function v(n,o){const a=[],c=o.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const s=c.shift();if(s&&a.every(h=>!b(h.identifier,{id:s}))){const h=n.filter(D=>b(D.identifier,{id:s}));h.length===1&&(a.push(h[0]),c.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=v;async function i(n,o){if(!M.isLinux)return!1;let a;try{a=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){o.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(s))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function r(n,o){const a=await i(n,o),c=(0,t.getTargetPlatform)(a?"alpine":M.platform,g.arch);return o.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=r}),define(ie[235],re([0,1,190,51]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(M,A,P,g,m,b,S){const y={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${A.nameShort})`};if((0,t.supportsTelemetry)(A,P)&&(0,t.getTelemetryLevel)(g)===3){const u=await(0,E.getServiceMachineId)(P,m,b),{machineId:d}=await S.getTelemetryInfo();y["X-Market-User-Id"]=u,y["VSCode-SessionId"]=d||u}return y}e.resolveMarketplaceHeaders=k}),define(ie[236],re([0,1,13,44,51]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const M="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function P(m,b,S){const y=await new Promise((l,w)=>{H(["@microsoft/1ds-core-js"],l,w)}),u=await new Promise((l,w)=>{H(["@microsoft/1ds-post-js"],l,w)}),d=new y.AppInsightsCore,p=new u.PostChannel,f={instrumentationKey:m,endpointUrl:M,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(S){f.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:S};f.extensionConfig[p.identifier]=l}return d.initialize(f,[]),d.addTelemetryInitializer(l=>{b&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),d}class g{constructor(b,S,y,u,d){this.e=b,this.f=S,this.g=y,this.h=d,this.c=M,this.d=A,this.g||(this.g={}),typeof u=="function"?this.a=u():this.a=u,this.b=null}i(b){if(!!this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(S=>{b(S)},S=>{(0,E.onUnexpectedError)(S),console.error(S)})}}log(b,S){if(!this.a)return;S=(0,t.mixin)(S,this.g),S=(0,k.validateTelemetryData)(S);const y=this.f+"/"+b;try{this.i(u=>{u.pluginVersionString=S?.properties.version??"Unknown",u.track({name:y,baseData:{name:y,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(S=>{S.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(ie[112],re([0,1,2,44,4,26,169,18,65,63,19,48,29,51]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(l,w,C){this.k=w,this.l=C,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const I of this.f)this.j.push(new RegExp((0,M.escapeRegExpCharacters)(I),"gi")),I.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.escapeRegExpCharacters)(I.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(I=>{(I.affectsConfiguration(y.TELEMETRY_SETTING_ID)||I.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||I.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(l,w){this.d[l]=w}m(){let l=(0,u.getTelemetryLevel)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const C=w.usage?3:w.error?2:0;l=Math.min(l,C)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,w=l.sessionID,C=l["common.machineId"],I=l["common.firstSessionDate"],v=l["common.msftInternal"];return{sessionId:w,machineId:C,firstSessionDate:I,msftInternal:v}}dispose(){this.i.dispose()}n(l,w,C){return this.g<w?Promise.resolve(void 0):this.c.then(I=>{C=(0,t.mixin)(C,this.d),C=(0,u.cleanData)(C,this.j),C=(0,t.mixin)(C,I),this.b.forEach(v=>v.log(l,C))},I=>{console.error(I)})}publicLog(l,w){return this.n(l,3,w)}publicLog2(l,w){return this.publicLog(l,w)}publicLogError(l,w){return this.h?this.n(l,2,w):Promise.resolve(void 0)}publicLogError2(l,w){return this.publicLogError(l,w)}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=pe([ee(1,P.IConfigurationService),ee(2,b.IProductService)],d),e.TelemetryService=d;function p(){const f=(0,A.localize)(0,null,m.default.nameLong),l=m.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=k.isWeb?"":(0,A.localize)(3,null),C=(0,A.localize)(4,null),I=(0,A.localize)(5,null),v=(0,A.localize)(6,null),i=(0,A.localize)(7,null),r=`
|       | ${C} | ${I} | ${v} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,A.localize)(8,null);return`
${f} ${l} ${w}

&nbsp;

${i}
${r}

&nbsp;

${n}
`}S.Registry.as(g.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(g.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,A.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,A.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[237],re([0,1,283,236]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends t.AbstractOneDataSystemAppender{constructor(A,P,g,m){const b={sendPOST:(S,y)=>{const u={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const d=E.request(S.urlString,u,p=>{p.on("data",function(f){y(p.statusCode??200,p.headers,f.toString())}),p.on("error",function(f){y(0,{})})});d.write(S.data),d.end()}catch{y(0,{})}}};super(A,P,g,m,b)}}e.OneDataSystemAppender=k}),define(ie[238],re([0,1,4,82,29]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function M(A){let P=A.getItem(k.machineIdKey);return(typeof P!="string"||E.isMacintosh&&P==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(P=await(0,t.getMachineId)()),P}e.resolveMachineId=M}),define(ie[113],re([0,1,29,238]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function k(M){const A=await(0,t.resolveMachineId)(M);return M.setItem(E.machineIdKey,A),A}e.resolveMachineId=k}),define(ie[239],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var E;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(E=e.ColorScheme||(e.ColorScheme={}));function t(M){return M===E.HIGH_CONTRAST_DARK||M===E.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(M){return M===E.DARK||M===E.HIGH_CONTRAST_DARK}e.isDark=k}),define(ie[240],re([0,1,120,3,2,5,48,239]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var g;(function(f){function l(w){return w&&typeof w=="object"&&typeof w.id=="string"}f.isThemeColor=l})(g=e.ThemeColor||(e.ThemeColor={}));function m(f){return{id:f}}e.themeColorFromId=m;var b;(function(f){function l(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||g.isThemeColor(o.color))}f.isThemeIcon=l;const w=new RegExp(`^\\$\\((${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?)\\)$`);function C(o){const a=w.exec(o);if(!a)return;const[,c]=a;return{id:c}}f.fromString=C;function I(o){return{id:o}}f.fromId=I;function v(o,a){let c=o.id;const s=c.lastIndexOf("~");return s!==-1&&(c=c.substring(0,s)),a&&(c=`${c}~${a}`),{id:c}}f.modify=v;function i(o){const a=o.id.lastIndexOf("~");if(a!==-1)return o.id.substring(a+1)}f.getModifier=i;function r(o,a){return o.id===a.id&&o.color?.id===a.color?.id}f.isEqual=r;function n(o,a){return{id:o.id,color:a?m(a):void 0}}f.asThemeIcon=n,f.asClassNameArray=E.CSSIcon.asClassNameArray,f.asClassName=E.CSSIcon.asClassName,f.asCSSSelector=E.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=E.Codicon.file,e.FolderThemeIcon=E.Codicon.folder;function S(f){switch(f){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,k.toDisposable)(()=>{const w=this.a.indexOf(l);this.a.splice(w,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const u=new y;A.Registry.add(e.Extensions.ThemingContribution,u);function d(f){return u.onColorThemeChange(f)}e.registerThemingParticipant=d;class p extends k.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(w=>this.n(w)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,w){let C=this.h.getColor(l);return C&&w&&(C=w(C,this.h)),C?C.toString():null}}e.Themable=p}),define(ie[66],re([0,1,14,3,2,4,18,5,36]),function(H,e,E,t,k,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",b="#1E1E1E",S="#000000",y="#FFFFFF",u="theme",d="themeBackground",p="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let f=class extends k.Disposable{constructor(w,C){super(),this.b=w,this.c=C,this.a=this.B(new t.Emitter),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const w=this.getColorScheme();if(w.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return w.dark?S:y;let C=this.b.getItem(d,null);if(!C)switch(this.b.getItem(u,"vs-dark").split(" ")[0]){case"vs":C=m;break;case"hc-black":C=S;break;case"hc-light":C=y;break;default:C=b}return M.isMacintosh&&C.toUpperCase()===b&&(C="#171717"),C}saveWindowSplash(w,C){this.b.setItems([{key:u,data:C.baseTheme},{key:d,data:C.colorInfo.background},{key:p,data:C}]),typeof w=="number"&&this.f(w,C)}f(w,C){for(const I of E.BrowserWindow.getAllWindows())if(I.id===w){I.setBackgroundColor(C.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(p)}};f=pe([ee(0,g.IStateMainService),ee(1,A.IConfigurationService)],f),e.ThemeMainService=f}),define(ie[114],re([0,1,3,18,5,6]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(p){p.Http="http",p.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var g;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(g=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=S;function y(p,f,l,w){if(l===1)return!1;if(l===2&&S(f)){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(w);if(C?.length===4&&parseInt(C[1])>=18)return!1}return p<1024}e.isPortPrivileged=y;class u{constructor(f,l,w){this.remoteAddress=f,this.localAddress=l,this.b=w,this.a=new E.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=u;let d=class{constructor(f,l){this.i=f,this.j=l,this.a=new E.Emitter,this.onTunnelOpened=this.a.event,this.b=new E.Emitter,this.onTunnelClosed=this.b.event,this.c=new E.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const f=this.j.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(f){return this.e=f,f?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(f){this.f=f.elevation,this.g=f.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const f=[],l=Array.from(this.d.values());for(const w of l){const C=Array.from(w.values());for(const I of C){const v=await I.value;v&&f.push(v)}}return f}async dispose(){for(const f of this.d.values()){for(const{value:l}of f.values())await l.then(w=>w?.dispose());f.clear()}this.d.clear()}setEnvironmentTunnel(f,l,w,C,I){this.o(f,l,Promise.resolve({tunnelRemoteHost:f,tunnelRemotePort:l,localAddress:w,privacy:C,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(f,l){(S(f)||b(f))&&(f=e.LOCALHOST_ADDRESSES[0]);const w=this.q(f,l);if(w)return++w.refcount,w.value}openTunnel(f,l,w,C,I=!1,v,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${w} on local port ${C}.`),!f)return;if(l||(l="localhost"),this.e&&this.h.has(w)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(f,l,w,C,I,v,i);return r?r.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,w);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(n);return(n.tunnelRemoteHost!==l||n.tunnelRemotePort!==w)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const l=this.d.get(f.tunnelRemoteHost);if(l){const w=l.get(f.tunnelRemotePort);w&&(w.refcount--,await this.n(f.tunnelRemoteHost,f.tunnelRemotePort,w))}}}}async n(f,l,w){if(w.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${l}.`);const C=w.value.then(async I=>{I&&(await I.dispose(!0),this.b.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this.d.has(f)&&this.d.get(f).delete(l),C}}async closeTunnel(f,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${l} `);const w=this.d.get(f);if(w&&w.has(l)){const C=w.get(l);C.refcount=0,await this.n(f,l,C)}}o(f,l,w){this.d.has(f)||this.d.set(f,new Map),this.d.get(f).set(l,{refcount:1,value:w})}async p(f,l){const w=this.d.get(f);w&&(await w.get(l)||w.delete(l),w.size===0&&this.d.delete(f))}q(f,l){const w=[f];b(f)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):S(f)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const C=w.map(I=>this.d.get(I));for(const I of C){const v=I?.get(l);if(v)return v}}canTunnel(f){return!!m(f)}s(f,l,w,C,I,v,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${w} on local port ${C}.`);const r=w;this.h.add(r);const n=C===void 0?w:C,o={elevationRequired:I?this.isPortPrivileged(n):!1},a={remoteAddress:{host:l,port:w},localAddressPort:C,privacy:v,public:v?v!==P.Private:void 0,protocol:i},c=f.forwardPort(a,o);return c?(this.o(l,w,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),c}};d=pe([ee(0,M.ILogService),ee(1,t.IConfigurationService)],d),e.AbstractTunnelService=d}),define(ie[241],re([0,1,79,25,97,223,8,2,18,6,19,222,114,89,4]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(I,v,i,r,n){let o;for(let a=3;a&&(o?.dispose(),o=await new f(I,v,i,r,n).waitForReady(),!(n&&k.BROWSER_RESTRICTED_PORTS[n]||!k.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));a--);return o}class f extends P.Disposable{constructor(v,i,r,n,o){super(),this.j=i,this.k=o,this.privacy=y.TunnelPrivacyId.Private,this.i=new Map,this.a=v,this.b=E.createServer(),this.c=new A.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.l(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const v=this.k??this.tunnelRemotePort,i=(0,y.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,k.findFreePortFaster)(v,2,1e3,i),n=null;return this.b.listen(r,this.j),await this.c.wait(),n=this.b.address(),n||(r=0,this.b.listen(r,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(v){v.pause();const i=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,S.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),n=r.getSocket().socket,o=r.readEntireBuffer();r.dispose(),o.byteLength>0&&v.write(o.buffer),v.on("end",()=>{v.localAddress&&this.i.delete(v.localAddress),n.end()}),v.on("close",()=>n.end()),v.on("error",()=>{v.localAddress&&this.i.delete(v.localAddress),n.destroy()}),n.on("end",()=>v.end()),n.on("close",()=>v.end()),n.on("error",()=>{v.destroy()}),v.pipe(n),n.pipe(v),v.localAddress&&this.i.set(v.localAddress,()=>{v.end(),n.end()})}}let l=class extends y.AbstractTunnelService{constructor(v,i,r,n,o){super(i,o),this.t=v,this.u=r,this.v=n}isPortPrivileged(v){return(0,y.isPortPrivileged)(v,this.k,d.OS,t.release())}r(v,i,r,n,o,a,c){const s=this.q(i,r);if(s)return++s.refcount,s.value;if(this.e)return this.s(this.e,i,r,n,o,a,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${r} on local port ${n}.`);const h={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:v,signService:this.u,logService:this.i,ipcLogger:null},D=p(h,this.k,i,r,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,r,D),D}}};l=pe([ee(1,m.ILogService),ee(2,u.ISignService),ee(3,b.IProductService),ee(4,g.IConfigurationService)],l),e.BaseTunnelService=l;let w=class extends l{constructor(v,i,r,n){super(M.nodeSocketFactory,v,i,r,n)}};w=pe([ee(0,m.ILogService),ee(1,u.ISignService),ee(2,b.IProductService),ee(3,g.IConfigurationService)],w),e.TunnelService=w;let C=class extends P.Disposable{constructor(v,i,r,n){super(),this.b=v,this.c=i,this.f=r,this.g=n,this.a=new Map}async openTunnel(v,i,r,n,o,a,c,s){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${n} on local port ${o}.`),!this.a.has(v)){const h=new w(this.b,this.f,this.c,this.g);this.B(h),this.a.set(v,h),h.onTunnelClosed(async()=>{(await h.tunnels).length===0&&(h.dispose(),this.a.delete(v))})}return this.a.get(v).openTunnel(i,r,n,o,a,c,s)}};C=pe([ee(0,m.ILogService),ee(1,b.IProductService),ee(2,u.ISignService),ee(3,g.IConfigurationService)],C),e.SharedTunnelsService=C}),define(ie[49],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,A)=>({type:"idle",updateType:M,error:A}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(ie[242],re([0,1,4,170,65,48]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ie[243],re([0,1,3,49]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(P){this.a=P}listen(P,g){switch(g){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${g}`)}call(P,g,m){switch(g){case"checkForUpdates":return this.a.checkForUpdates(m);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(m)}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=k;class M{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new E.Emitter,this.onStateChange=this.a.event,this.b=t.State.Uninitialized,this.c.listen("onStateChange")(g=>this.state=g),this.c.call("_getInitialState").then(g=>this.state=g)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=M}),define(ie[91],re([0,1,8,22,3,18,27,21,6,19,56,49]),function(H,e,E,t,k,M,A,P,g,m,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(d,p,f){return`${f.updateUrl}/api/update/${d}/${p}/${f.commit}`}e.createUpdateURL=y;let u=class{get state(){return this.b}d(p){this.j.info("update#setState",p.type),this.b=p,this.c.fire(p)}constructor(p,f,l,w,C,I){this.f=p,this.g=f,this.h=l,this.i=w,this.j=C,this.k=I,this.b=S.State.Uninitialized,this.c=new k.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.l(),f=this.m(p);if(!f){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(f),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(S.State.Idle(this.q())),p==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,l=>this.j.error(l))}l(){return(0,M.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(p){return p==="none"?void 0:this.k.quality}n(p=60*60*1e3){return(0,E.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(p){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(p)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(p){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(p){}q(){return 1}r(){}};u=pe([ee(0,P.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,A.IEnvironmentMainService),ee(3,b.IRequestService),ee(4,g.ILogService),ee(5,m.IProductService)],u),e.AbstractUpdateService=u}),define(ie[244],re([0,1,14,54,3,2,18,27,21,6,19,56,29,49,91]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let p=class extends d.AbstractUpdateService{get v(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"error",(l,w)=>w)}get w(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(l,w,C)=>({url:w,version:C,productVersion:C}))}get y(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(l,w,C,I)=>({releaseNotes:w,version:C,productVersion:C,date:I}))}constructor(l,w,C,I,v,i,r){super(l,w,I,v,i,r),this.z=C,this.u=new M.DisposableStore}async initialize(){await super.initialize(),this.v(this.A,this,this.u),this.x(this.D,this,this.u),this.y(this.E,this,this.u),this.w(this.F,this,this.u)}A(l){this.j.error("UpdateService error:",l);const C=(this.state.type==="checking for updates"?this.state.explicit:!0)?l:void 0;this.d(u.State.Idle(1,C))}s(l){let w;this.k.darwinUniversalAssetId?w=this.k.darwinUniversalAssetId:w=process.arch==="x64"?"darwin":"darwin-arm64";const C=(0,d.createUpdateURL)(w,l,this.k);try{E.autoUpdater.setFeedURL({url:C})}catch(I){this.j.error("Failed to set update feed URL",I);return}return C}t(l){this.d(u.State.CheckingForUpdates(l)),E.autoUpdater.checkForUpdates()}D(l){this.state.type==="checking for updates"&&this.d(u.State.Downloading(l))}E(l){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:l.version}),this.d(u.State.Ready(l)))}F(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(u.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([t.memoize],p.prototype,"v",null),pe([t.memoize],p.prototype,"w",null),pe([t.memoize],p.prototype,"x",null),pe([t.memoize],p.prototype,"y",null),p=pe([ee(0,g.ILifecycleMainService),ee(1,A.IConfigurationService),ee(2,y.ITelemetryService),ee(3,P.IEnvironmentMainService),ee(4,S.IRequestService),ee(5,m.ILogService),ee(6,b.IProductService)],p),e.DarwinUpdateService=p}),define(ie[245],re([0,1,46,40,8,3,9,27,21,6,29,49]),function(H,e,E,t,k,M,A,P,g,m,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{get state(){return this.a}d(p){this.g.info("update#setState",p.type),this.a=p,this.b.fire(p)}constructor(p,f,l){if(this.f=p,this.g=l,this.a=S.State.Uninitialized,this.b=new M.Emitter,this.onStateChange=this.b.event,f.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(S.State.Idle(this.k())),this.h(30*1e3).then(void 0,w=>this.g.error(w))}h(p=60*60*1e3){return(0,k.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(p){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(p)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(p){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(p){}};y=pe([ee(0,g.ILifecycleMainService),ee(1,P.IEnvironmentMainService),ee(2,m.ILogService)],y);let u=class extends y{constructor(p,f,l,w,C,I){super(l,w,C),this.o=p,this.p=f,this.q=I;const v=(0,t.watch)(A.dirname(this.o)),i=M.Event.fromNodeEventEmitter(v,"change",(a,c)=>c),r=M.Event.filter(i,a=>a==="current"),o=M.Event.debounce(r,(a,c)=>c,2e3)(()=>this.checkForUpdates(!1));l.onWillShutdown(()=>{o.dispose(),v.close()})}m(){this.d(S.State.CheckingForUpdates(!1)),this.u().then(p=>{p?this.d(S.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(S.State.Idle(2)))},p=>{this.g.error(p),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(S.State.Idle(2,p.message||p))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+A.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const p=await new Promise((l,w)=>(0,t.realpath)(`${A.dirname(this.o)}/current`,(C,I)=>C?w(C):l(I))),f=A.basename(p);return this.p!==f}isLatestVersion(){return this.u().then(void 0,p=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};u=pe([ee(2,g.ILifecycleMainService),ee(3,P.IEnvironmentMainService),ee(4,m.ILogService),ee(5,b.ITelemetryService)],u),e.SnapUpdateService=u}),define(ie[42],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ie[246],re([0,1,42,191,16,20,127,3,2]),function(H,e,E,t,k,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(y){this.uri=y,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let b=class{constructor(y){this.g=y,this.c=new g.DisposableStore,this.f=2**16;const u=new Map,d=p=>{let f=u.get(p.scheme);return f===void 0&&(f=y.hasProvider(p)&&!this.g.hasCapability(p,1024),u.set(p.scheme,f)),f};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(p=>{u.delete(p.scheme)})),this.extUri=new M.ExtUri(d),this.d=new A.SkipList((p,f)=>this.extUri.compare(p,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,M.normalizePath)(y));const u=this.d.get(y);return u?u.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new m(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((d,p)=>d[1].touch<p[1].touch?1:d[1].touch>p[1].touch?-1:0);m._clock=0,this.d.clear();const u=this.f*.5;for(let d=0;d<u;d++)this.d.set(y[d][0],y[d][1].touch())}};b=pe([ee(0,k.IFileService)],b),e.UriIdentityService=b,(0,t.registerSingleton)(E.IUriIdentityService,b,1)}),define(ie[115],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(ie[247],re([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(P){this.a=P}listen(P,g){throw new Error(`Event not found: ${g}`)}call(P,g,m){switch(g){case"handleURL":return this.a.handleURL(E.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=t;class k{constructor(P){this.a=P}handleURL(P,g){return this.a.call("handleURL",[P.toJSON(),g])}}e.URLHandlerChannelClient=k;class M{constructor(P){this.a=P}async routeCall(P,g,m,b){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(m){const S=E.URI.revive(m);if(S&&S.query){const y=/\bwindowId=(\d+)/.exec(S.query);if(y){const u=y[1],d=new RegExp(`window:${u}`),p=P.connections.find(f=>d.test(f.ctx));if(p)return p}}}return this.a.routeCall(P,g,m,b)}routeEvent(P,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=M}),define(ie[248],re([0,1,8,2,7,19]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class A extends t.Disposable{constructor(){super(...arguments),this.a=new Set}open(m,b){const S=[...this.a.values()];return(0,E.first)(S.map(y=>()=>y.handleURL(m,b)),void 0,!1).then(y=>y||!1)}registerHandler(m){return this.a.add(m),(0,t.toDisposable)(()=>this.a.delete(m))}}e.AbstractURLService=A;let P=class extends A{constructor(m){super(),this.b=m}create(m){let{authority:b,path:S,query:y,fragment:u}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&S&&S.indexOf("/")!==0&&(S=`/${S}`),k.URI.from({scheme:this.b.urlProtocol,authority:b,path:S,query:y,fragment:u})}};P=pe([ee(0,M.IProductService)],P),e.NativeURLService=P}),define(ie[249],re([0,1,14,8,3,2,4,7]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function g(b){try{return P.URI.parse(b)}catch{return null}}class m{constructor(S,y,u,d,p){if(this.f=y,this.a=[],this.b=0,this.c=M.Disposable.None,this.d=new M.DisposableStore,this.a=S,A.isWindows){const w=d.isBuilt?[]:[`"${d.appRoot}"`];w.push("--open-url","--"),E.app.setAsDefaultProtocolClient(p.urlProtocol,process.execPath,w)}const f=k.Event.map(k.Event.fromNodeEventEmitter(E.app,"open-url",(w,C)=>({event:w,url:C})),({event:w,url:C})=>(w.preventDefault(),C));this.d.add(f(w=>{const C=g(w);!C||this.f.open(C,{originalUrl:w})})),u.getWindows().filter(w=>w.isReady).length>0?this.g():k.Event.once(u.onDidSignalReadyWindow)(this.g,this,this.d)}async g(){if(this.b++>10)return;const S=[];for(const y of this.a)await this.f.open(y.uri,{originalUrl:y.url})||S.push(y);S.length!==0&&(this.a=S,this.c=(0,t.disposableTimeout)(()=>this.g(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=m}),define(ie[250],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(ie[251],re([0,1,14,2,15,7]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class A extends t.Disposable{constructor(){super();const g=this.b.bind(this);E.protocol.registerFileProtocol(k.Schemas.vscodeWebview,g)}b(g,m){try{const b=M.URI.parse(g.url),S=A.a.get(b.path);if(typeof S=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${S}`,u=k.FileAccess.asFileUri(y);return m({path:decodeURIComponent(u.fsPath),headers:{...k.COI.getHeadersFromQuery(g.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=A,A.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ie[74],re([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(b){return!!b.workspaceUri}e.isWorkspaceToOpen=t;function k(b){return!!b.folderUri}e.isFolderToOpen=k;function M(b){return!!b.fileUri}e.isFileToOpen=M;function A(b){const S=P(b),y=b.getValue("window.menuBarVisibility");return y==="default"||S==="native"&&y==="compact"||E.isMacintosh&&E.isNative?"classic":y}e.getMenuBarVisibility=A;function P(b){if(E.isWeb)return"custom";const S=b.getValue("window");if(S){if(E.isMacintosh&&S.nativeTabs===!0||E.isMacintosh&&S.nativeFullScreen===!1)return"native";const d=S.titleBarStyle;if(d==="native"||d==="custom")return d}return E.isLinux?"native":"custom"}e.getTitleBarStyle=P;function g(b){if(!E.isWindows||E.isWeb||P(b)==="native")return!1;const S=b.getValue("window.experimental.windowControlsOverlay.enabled");return typeof S=="boolean"?S:!0}e.useWindowControlsOverlay=g;function m(b=0){return Math.pow(1.2,b)}e.zoomLevelToZoomFactor=m}),define(ie[116],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var t;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=k;var M;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(M=e.WindowMode||(e.WindowMode={}));var A;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(A=e.WindowError||(e.WindowError={}))}),define(ie[32],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ie[252],re([0,1,14,22,3,68,2,30,71,106,6,19,32]),function(H,e,E,t,k,M,A,P,g,m,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var u;(function(p){p[p.Initial=1]="Initial",p[p.StoredCredentialsUsed=2]="StoredCredentialsUsed",p[p.LoginDialogShown=3]="LoginDialogShown"})(u||(u={}));let d=class extends A.Disposable{constructor(f,l,w,C,I){super(),this.g=f,this.h=l,this.i=w,this.j=C,this.k=I,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=u.Initial,this.f=void 0,this.l()}l(){const f=k.Event.fromNodeEventEmitter(E.app,"login",(l,w,C,I,v)=>({event:l,webContents:w,req:C,authInfo:I,callback:v}));this.B(f(this.m,this))}async m({event:f,authInfo:l,req:w,callback:C}){if(!l.isProxy)return;if(!this.b&&this.c===u.LoginDialogShown&&w.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}f.preventDefault();let I;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),I=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(l);try{I=await this.b}finally{this.b=void 0}}C(I?.username,I?.password)}async n(f){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const l=await this.p(f);if(l)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),l;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(f){this.g.trace("auth#doResolveProxyCredentials - enter",f);const l=String((0,M.hash)({scheme:f.scheme,host:f.host,port:f.port}));let w,C;try{const r=await this.i.getPassword(this.a,l);if(r){const n=JSON.parse(await this.j.decrypt(r));w=n.username,C=n.password}}catch(r){this.g.error(r)}if(this.c!==u.StoredCredentialsUsed&&typeof w=="string"&&typeof C=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=u.StoredCredentialsUsed,{username:w,password:C};const I=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!I){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${I.id} to handle proxy login`);const v={authInfo:f,username:this.f?.username??w,password:this.f?.password??C,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};I.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,v),this.c=u.LoginDialogShown;const i=await new Promise(r=>{const n=async(o,a,c)=>{if(a===v.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${I.id}`),I.win?.webContents.off("ipc-message",n),c){const s={username:c.username,password:c.password};try{if(c.remember){const h=await this.j.encrypt(JSON.stringify(s));await this.i.setPassword(this.a,l,h)}else await this.i.deletePassword(this.a,l)}catch(h){this.g.error(h)}r({username:s.username,password:s.password})}else r(void 0)};I.win?.webContents.on("ipc-message",n)});return this.f=i,i}};d=pe([ee(0,b.ILogService),ee(1,y.IWindowsMainService),ee(2,g.ICredentialsMainService),ee(3,m.IEncryptionMainService),ee(4,S.IProductService)],d),e.ProxyAuthHandler=d}),define(ie[253],re([0,1,71,6,35,19,32,203]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let g=class extends P.BaseCredentialsMainService{constructor(b,S,y,u){super(b),this.j=S,this.k=y,this.l=u,this.i=d=>{this.l.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;const b=await new Promise((S,y)=>{H(["keytar"],S,y)});return await b.findCredentials("test-keytar-loads"),this.f=b,this.f}};g=pe([ee(0,t.ILogService),ee(1,k.INativeEnvironmentService),ee(2,M.IProductService),ee(3,A.IWindowsMainService)],g),e.CredentialsNativeMainService=g}),define(ie[254],re([0,1,13,2,3,6,21,81,46,284,8,15,44,4,33,14,32]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const l=p.utilityProcess,w=typeof l<"u";let C=class Nt{constructor(r,n,o){this.d=r,this.f=o,this.c=!1,this.b=new Map,n.onWillShutdown(a=>{this.c=!0,a.join(this._waitForAllExit(6e3))})}dispose(){}g(r){const n=this.b.get(r);if(!n)throw new Error("Unknown extension host!");return n}onDynamicStdout(r){return this.g(r).onStdout}onDynamicStderr(r){return this.g(r).onStderr}onDynamicMessage(r){return this.g(r).onMessage}onDynamicError(r){return this.g(r).onError}onDynamicExit(r){return this.g(r).onExit}async canUseUtilityProcess(){return w}async createExtensionHost(r){if(this.c)throw(0,E.canceled)();const n=String(++Nt.a);let o;if(r){if(!w)throw new Error("Cannot use UtilityProcess!");o=new v(n,this.d,this.f)}else o=new I(n,this.d);return this.b.set(n,o),o.onExit(({pid:a,code:c,signal:s})=>{this.d.info(`Extension host with pid ${a} exited with code: ${c}, signal: ${s}.`),setTimeout(()=>{o.dispose(),this.b.delete(n)})}),{id:n}}async start(r,n){if(this.c)throw(0,E.canceled)();return this.g(r).start(n)}async enableInspectPort(r){if(this.c)throw(0,E.canceled)();const n=this.b.get(r);return n?n.enableInspectPort():!1}async kill(r){if(this.c)throw(0,E.canceled)();const n=this.b.get(r);!n||n.kill()}async _killAllNow(){for(const[,r]of this.b)r.kill()}async _waitForAllExit(r){const n=[];for(const[,o]of this.b)n.push(o.waitForExit(r));return b.Promises.settled(n).then(()=>{})}};C.a=0,C=pe([ee(0,M.ILogService),ee(1,A.ILifecycleMainService),ee(2,f.IWindowsMainService)],C),e.ExtensionHostStarter=C;let I=class extends t.Disposable{constructor(r,n){super(),this.id=r,this.c=n,this._onStdout=this.B(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new k.Emitter),this.onError=this._onError.event,this._onExit=this.B(new k.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(r){u.isCI&&this.c.info("Calling fork to start extension host...");const n=P.StopWatch.create(!1);this.a=(0,g.fork)(S.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,d.cwd)()},r));const o=n.elapsed(),a=this.a.pid;this.c.info(`Starting extension host with pid ${a} (fork() took ${o} ms).`);const c=new m.StringDecoder("utf-8");this.a.stdout?.on("data",h=>{const D=typeof h=="string"?h:c.write(h);this._onStdout.fire(D)});const s=new m.StringDecoder("utf-8");this.a.stderr?.on("data",h=>{const D=typeof h=="string"?h:s.write(h);this._onStderr.fire(D)}),this.a.on("message",h=>{this._onMessage.fire(h)}),this.a.on("error",h=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(h)})}),this.a.on("exit",(h,D)=>{this.b=!0,this._onExit.fire({pid:a,code:h,signal:D})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):u.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(r){if(!this.a)return;const n=this.a.pid;this.c.info(`Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,b.timeout)(r)]),this.b||(this.c.info(`Extension host with pid ${n} did not exit within ${r}ms.`),this.a.kill())}};I=pe([ee(1,M.ILogService)],I);let v=class extends t.Disposable{constructor(r,n,o){super(),this.id=r,this.c=n,this.f=o,this.onError=k.Event.None,this._onStdout=this.B(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this.B(new k.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(r){const n=this.f.getWindowById(r.responseWindowId);if(!n){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=n.win;if(!o||o.isDestroyed()||o.webContents.isDestroyed()){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const a=`extensionHost${this.id}`,c=S.FileAccess.asFileUri("bootstrap-fork.js").fsPath,s=["--type=extensionHost","--skipWorkspaceStorageLock"],h=r.execArgv||[],D={...r.env},L=!0,T="pipe";for(const se of Object.keys(D))D[se]=String(D[se]);this.c.info(`UtilityProcess<${this.id}>: Creating new...`),this.a=l.fork(c,s,{serviceName:a,env:D,execArgv:h,allowLoadingUnsignedLibraries:L,stdio:T});const F=new m.StringDecoder("utf-8");this.a.stdout?.on("data",se=>{const ce=typeof se=="string"?se:F.write(se);this._onStdout.fire(ce)});const G=new m.StringDecoder("utf-8");this.a.stderr?.on("data",se=>{const ce=typeof se=="string"?se:G.write(se);this._onStderr.fire(ce)}),this.a.on("message",se=>{this._onMessage.fire(se)}),this.B(k.Event.fromNodeEventEmitter(this.a,"spawn")(()=>{this.c.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const V=k.Event.fromNodeEventEmitter(this.a,"exit",se=>se);this.B(V(se=>{this.c.info(`UtilityProcess<${this.id}>: received exit event with code ${se}.`),this.b=!0,this._onExit.fire({pid:this.a.pid,code:se,signal:""})}));const{port1:K,port2:_}=new p.MessageChannelMain;this.a.postMessage("null",[_]),o.webContents.postMessage(r.responseChannel,r.responseNonce,[K])}enableInspectPort(){return this.a?(this.c.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):!1):!1}kill(){!this.a||(this.c.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(r){if(!this.a)return;const n=this.a.pid;this.c.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,b.timeout)(r)]),this.b||(this.c.info(`UtilityProcess<${this.id}>: Extension host with pid ${n} did not exit within ${r}ms, will kill it now.`),this.a.kill())}};v=pe([ee(1,M.ILogService),ee(2,f.IWindowsMainService)],v)}),define(ie[255],re([0,1,14,24,4,7,23,18,61,5,6,115,32]),function(H,e,E,t,k,M,A,P,g,m,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,m.createDecorator)(e.ID);let u=class{constructor(p,f,l,w){this.a=p,this.b=f,this.c=l,this.d=w}async start(p,f){this.a.trace("Received data from other instance: ",p,f),k.isMacintosh&&E.app.focus({steal:!0});const l=this.e(p);if(l.length){let w=Promise.resolve();if(this.b.getWindowCount()===0){const C=(0,t.firstOrDefault)(await this.b.openEmptyWindow({context:4}));C&&(w=C.ready())}w.then(()=>{for(const{uri:C,url:I}of l)this.c.open(C,{originalUrl:I})})}else return this.f(p,f)}e(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,t.coalesce)(p._urls.map(f=>{try{return{uri:M.URI.parse(f),url:f}}catch{return null}})):[]}async f(p,f){const l=(0,g.isLaunchedFromCli)(f)?0:4;let w=[];const C=p.wait&&p.waitMarkerFilePath?M.URI.file(p.waitMarkerFilePath):void 0,I=p.remote||void 0,v={context:l,cli:p,userEnv:f,waitMarkerFileURI:C,remoteAuthority:I,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,v);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let i=!1;if(p["new-window"]||p["unity-launch"]||v.forceProfile||v.forceTempProfile)i=!0;else if(p["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!k.isMacintosh}if(i)w=await this.b.open({...v,forceNewWindow:!0,forceEmpty:!0});else{const r=this.b.getLastActiveWindow();r?(this.b.openExistingWindow(r,v),w=[r]):w=await this.b.open({...v,forceEmpty:!0})}}else w=await this.b.open({...v,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(C&&w.length===1&&w[0])return Promise.race([w[0].whenClosedOrLoaded,(0,A.whenDeleted)(C.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};u=pe([ee(0,b.ILogService),ee(1,y.IWindowsMainService),ee(2,S.IURLService),ee(3,P.IConfigurationService)],u),e.LaunchMainService=u}),define(ie[256],re([0,1,14,3,2,251,32]),function(H,e,E,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends k.Disposable{constructor(m){super(),this.b=m,this.a=this.B(new t.Emitter),this.onFoundInFrame=this.a.event,this.B(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,b){let S;if(typeof m.windowId=="number"){const{windowId:y}=m,u=this.b.getWindowById(y);if(!u?.win)throw new Error(`Invalid windowId: ${y}`);S=u.win.webContents}else{const{webContentsId:y}=m;if(S=E.webContents.fromId(y),!S)throw new Error(`Invalid webContentsId: ${y}`)}S.isDestroyed()||S.setIgnoreMenuShortcuts(b)}async findInFrame(m,b,S,y){const d=this.c(m,b);if(typeof d.findInFrame=="function"){d.findInFrame(S,{findNext:y.findNext,forward:y.forward});const p=(f,l)=>{l.finalUpdate&&(this.a.fire(l),d.removeListener("found-in-frame",p))};d.on("found-in-frame",p)}}async stopFindInFrame(m,b,S){const u=this.c(m,b);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(S.keepSelection?"keepSelection":"clearSelection")}c(m,b){const S=this.b.getWindowById(m.windowId);if(!S?.win)throw new Error(`Invalid windowId: ${m}`);const y=S.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===b);if(!y)throw new Error(`Unknown frame: ${b}`);return y}};P=pe([ee(0,A.IWindowsMainService)],P),e.WebviewMainService=P}),define(ie[257],re([0,1,8,3,2]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends k.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:g,getActiveWindowId:m}){super(),this.a=this.B(new k.DisposableStore),t.Event.latch(t.Event.any(P,g))(this.f,this,this.a),this.b=(0,E.createCancelablePromise)(()=>m()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=M}),define(ie[28],re([0,1,174,9,60,20,7,5,15]),function(H,e,E,t,k,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function m(n){const o=n;return typeof o?.id=="string"&&A.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=m;function b(n){return typeof n?.id=="string"&&!m(n)&&!y(n)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(n,o){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,t.basename)(n)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=n;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=S;function y(n){const o=n;return typeof o?.id=="string"&&A.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=y;function u(n){const o=n;if(o?.uri)return{id:o.id,uri:A.URI.revive(o.uri)};const a=n;if(a?.configPath)return{id:a.id,configPath:A.URI.revive(a.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=u;var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d=e.WorkbenchState||(e.WorkbenchState={}));function p(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=p;function f(n){const o=n;return!!(o&&typeof o=="object"&&A.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=f;class l{constructor(o,a,c,s,h){this.h=o,this.j=c,this.k=s,this.l=h,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class w{constructor(o,a){this.raw=a,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,M.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=w;function C(n){return new w({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=C,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(n,o){return M.extUriBiasedIgnorePathCase.isEqualOrParent(n,o.untitledWorkspacesHome)}e.isUntitledWorkspace=I;function v(n){let o;return A.URI.isUri(n)?o=n:o=n.configuration,o?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=v;function i(n,o){return!I(n,o)&&!v(n)}e.isSavedWorkspace=i;function r(n){return(typeof n=="string"?(0,t.extname)(n):(0,M.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(ie[57],re([0,1,14,8,68,34,2,77,4,11,23,151,5,6,28]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let p=class{constructor(l){this.d=l,this.a=new Map,this.b=new Map,this.c=new t.Queue}pickFileFolder(l,w){return this.e({...l,pickFolders:!0,pickFiles:!0,title:(0,S.localize)(0,null)},w)}pickFolder(l,w){return this.e({...l,pickFolders:!0,title:(0,S.localize)(1,null)},w)}pickFile(l,w){return this.e({...l,pickFiles:!0,title:(0,S.localize)(2,null)},w)}pickWorkspace(l,w){const C=(0,S.localize)(3,null),I=(0,M.mnemonicButtonLabel)((0,S.localize)(4,null)),v=d.WORKSPACE_FILTER;return this.e({...l,pickFiles:!0,title:C,filters:v,buttonLabel:I},w)}async e(l,w){const C={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters,defaultPath:l.defaultPath};(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(C.properties=void 0,l.pickFiles&&l.pickFolders&&(C.properties=["multiSelections","openDirectory","openFile","createDirectory"])),C.properties||(C.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&C.properties.push("treatPackageAsDirectory");const I=await this.showOpenDialog(C,(0,m.withNullAsUndefined)(w||E.BrowserWindow.getFocusedWindow()));if(I&&I.filePaths&&I.filePaths.length>0)return I.filePaths}f(l){if(l){let w=this.b.get(l.id);return w||(w=new t.Queue,this.b.set(l.id,w)),w}else return this.c}showMessageBox(l,w){return this.f(w).queue(async()=>w?E.dialog.showMessageBox(w,l):E.dialog.showMessageBox(l))}async showSaveDialog(l,w){const C=this.i(l,w);if(!C)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(w).queue(async()=>{let I;return w?I=await E.dialog.showSaveDialog(w,l):I=await E.dialog.showSaveDialog(l),I.filePath=this.g(I.filePath),I})}finally{(0,A.dispose)(C)}}g(l){return l&&g.isMacintosh&&(l=(0,P.normalizeNFC)(l)),l}h(l){return l.map(w=>this.g(w))}async showOpenDialog(l,w){l.defaultPath&&(await b.Promises.exists(l.defaultPath)||(l.defaultPath=void 0));const C=this.i(l,w);if(!C)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(w).queue(async()=>{let I;return w?I=await E.dialog.showOpenDialog(w,l):I=await E.dialog.showOpenDialog(l),I.filePaths=this.h(I.filePaths),I})}finally{(0,A.dispose)(C)}}i(l,w){if(!w)return A.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",l);let C=this.a.get(w.id);C||(C=new Set,this.a.set(w.id,C));const I=(0,k.hash)(l);if(!C.has(I))return this.d.trace("[DialogMainService]: new file dialog lock created",l),C.add(I),(0,A.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",l),C?.delete(I),C?.size===0&&this.a.delete(w.id)})}};p=pe([ee(0,u.ILogService)],p),e.DialogMainService=p}),define(ie[258],re([0,1,3,2,69,28]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class A extends t.Disposable{constructor(g,m){super(),this.f=g,this.g=m,this.b=this.B(new E.Emitter),this.c=new Map,this.h(m.applicationStorage,this.b)}h(g,m){this.B(E.Event.debounce(g.onDidChangeStorage,(b,S)=>(b?b.push(S):b=[S],b),A.a)(b=>{b.length&&m.fire(this.i(b,g))}))}i(g,m){const b=new Map,S=new Set;return g.forEach(y=>{const u=m.get(y.key);typeof u=="string"?b.set(y.key,u):S.add(y.key)}),{changed:Array.from(b.entries()),deleted:Array.from(S.values())}}listen(g,m,b){switch(m){case"onDidChangeStorage":{const S=b.profile?(0,k.revive)(b.profile):void 0;if(!S)return this.b.event;let y=this.c.get(S.id);return y||(y=this.B(new E.Emitter),this.h(this.g.profileStorage(S),y),this.c.set(S.id,y)),y.event}}throw new Error(`Event not found: ${m}`)}async call(g,m,b){const S=b.profile?(0,k.revive)(b.profile):void 0,y=(0,M.reviveIdentifier)(b.workspace),u=await this.j(S,y);switch(m){case"getItems":return Array.from(u.items.entries());case"updateItems":{const d=b;if(d.insert)for(const[p,f]of d.insert)u.set(p,f);d.delete?.forEach(p=>u.delete(p));break}case"isUsed":{const d=b.payload;if(typeof d=="string")return this.g.isUsed(d)}default:throw new Error(`Call not found: ${m}`)}}async j(g,m){let b;m?b=this.g.workspaceStorage(m):g?b=this.g.profileStorage(g):b=this.g.applicationStorage;try{await b.init()}catch(S){this.f.error(`StorageIPC#init: Unable to init ${m?"workspace":g?"profile":"application"} storage due to ${S}`)}return b}}e.StorageDatabaseChannel=A,A.a=100}),define(ie[38],re([0,1,68,3,2,20,7,171,35,16,5,6,28,39,42,8,30,26,11]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function C(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&A.URI.isUri(o.location)&&A.URI.isUri(o.globalStorageHome)&&A.URI.isUri(o.settingsResource)&&A.URI.isUri(o.keybindingsResource)&&A.URI.isUri(o.tasksResource)&&A.URI.isUri(o.snippetsHome)&&A.URI.isUri(o.extensionsResource))}e.isUserDataProfile=C,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function I(n,o){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:A.URI.revive(n.location).with({scheme:o}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:o}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:o}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:o}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:o}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:o}),extensionsResource:A.URI.revive(n.extensionsResource)?.with({scheme:o}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=I;function v(n,o,a,c){return{id:n,name:o,location:a,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,M.joinPath)(a,"globalStorage"),settingsResource:(0,M.joinPath)(a,"settings.json"),keybindingsResource:(0,M.joinPath)(a,"keybindings.json"),tasksResource:(0,M.joinPath)(a,"tasks.json"),snippetsHome:(0,M.joinPath)(a,"snippets"),extensionsResource:(0,M.joinPath)(a,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=v;let i=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(o,a,c,s){super(),this.m=o,this.n=a,this.r=c,this.s=s,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new u.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,M.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(o){this.f!==o&&(this.t=void 0,this.f=o)}isEnabled(){return this.f}get u(){if(!this.t){const o=[];if(this.f)for(const h of this.G()){if(!h.name||!(0,w.isString)(h.name)||!h.location){this.s.warn("Skipping the invalid stored profile",h.location||h.name);continue}o.push(v((0,M.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}const a=new u.ResourceMap,c=new Map,s=v((0,E.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(o.unshift({...s,extensionsResource:this.L()??s.extensionsResource,isDefault:!0}),o.length){const h=this.I();if(h.workspaces)for(const[D,L]of Object.entries(h.workspaces)){const T=A.URI.parse(D),F=A.URI.parse(L),G=o.find(V=>this.r.extUri.isEqual(V.location,F));G&&a.set(T,G)}if(h.emptyWindows)for(const[D,L]of Object.entries(h.emptyWindows)){const T=A.URI.parse(L),F=o.find(G=>this.r.extUri.isEqual(G.location,T));F&&c.set(D,F)}}this.t={profiles:o,workspaces:a,emptyWindows:c}}return this.t}async createTransientProfile(o){const a="Temp",c=new RegExp(`${(0,l.escapeRegExpCharacters)(a)}\\s(\\d+)`);let s=0;for(const D of this.profiles){const L=c.exec(D.name),T=L?parseInt(L[1]):0;s=T>s?T:s}const h=`${a} ${s+1}`;return this.createProfile((0,E.hash)((0,f.generateUuid)()).toString(16),h,{transient:!0},o)}async createNamedProfile(o,a,c){return this.createProfile((0,E.hash)((0,f.generateUuid)()).toString(16),o,a,c)}async createProfile(o,a,c,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const h=await this.v(o,a,c);return s&&await this.setProfileForWorkspace(s,h),h}async v(o,a,c){if(!(0,w.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(a);return s||(s=(async()=>{try{const h=this.profiles.find(T=>T.name===a||T.id===o);if(h)return h;const D=v(o,a,(0,M.joinPath)(this.profilesHome,o),c);await this.n.createFolder(D.location);const L=[];return this.h.fire({profile:D,join(T){L.push(T)}}),await p.Promises.settled(L),this.z([D],[],[]),D}finally{this.k.delete(a)}})(),this.k.set(a,s)),s}async updateProfile(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(s=>s.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);return c=v(c.id,a.name??c.name,c.location,{shortName:a.shortName??c.shortName,transient:a.transient??c.isTransient,useDefaultFlags:a.useDefaultFlags??c.useDefaultFlags}),this.z([],[],[c]),c}async removeProfile(o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(o.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(s=>s.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);const c=[];this.i.fire({profile:a,join(s){c.push(s)}});try{await Promise.allSettled(c)}catch(s){this.s.error(s)}for(const s of[...this.u.emptyWindows.keys()])a.id===this.u.emptyWindows.get(s)?.id&&this.u.emptyWindows.delete(s);for(const s of[...this.u.workspaces.keys()])a.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.F(),this.z([],[a],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(a.location,{recursive:!0})}catch(s){this.s.error(s)}}async setProfileForWorkspace(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(s=>s.id===a.id);if(!c)throw new Error(`Profile '${a.name}' does not exist`);this.D(o,c)}unsetWorkspace(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(o,void 0,a)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const o=await this.n.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(a=>a.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,a.resource))).map(a=>this.n.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.l.profiles.filter(a=>!this.y(a));await Promise.allSettled(o.map(a=>this.removeProfile(a)))}getProfileForWorkspace(o){const a=this.w(o);return A.URI.isUri(a)?this.l.workspaces.get(a)??this.u.workspaces.get(a):this.l.emptyWindows.get(a)??this.u.emptyWindows.get(a)}w(o){return(0,y.isSingleFolderWorkspaceIdentifier)(o)?o.uri:(0,y.isWorkspaceIdentifier)(o)?o.configPath:o.id}y(o){return!!([...this.l.emptyWindows.values()].some(a=>this.r.extUri.isEqual(a.location,o.location))||[...this.l.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,o.location))||[...this.u.emptyWindows.values()].some(a=>this.r.extUri.isEqual(a.location,o.location))||[...this.u.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,o.location)))}z(o,a,c){const s=[...this.profiles,...o],h=[];this.l.profiles=[];for(let D of s)D.isDefault||a.some(L=>D.id===L.id)||(D=c.find(L=>D.id===L.id)??D,D.isTransient?this.l.profiles.push(D):h.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.H(h),this.t=void 0,this.C(o,a,c)}C(o,a,c){this.g.fire({added:o,removed:a,updated:c,all:this.profiles})}D(o,a,c){c=a?.isTransient?!0:c,c||this.D(o,void 0,!0);const s=this.w(o),h=c?this.l:this.u;A.URI.isUri(s)?(h.workspaces.delete(s),a&&h.workspaces.set(s,a)):(h.emptyWindows.delete(s),a&&h.emptyWindows.set(s,a)),c||this.F()}F(){const o={};for(const[c,s]of this.u.workspaces.entries())o[c.toString()]=s.location.toString();const a={};for(const[c,s]of this.u.emptyWindows.entries())a[c.toString()]=s.location.toString();this.J({workspaces:o,emptyWindows:a}),this.t=void 0}G(){return[]}H(o){throw new Error("not implemented")}I(){return{}}J(o){throw new Error("not implemented")}L(){}};i.b="userDataProfiles",i.c="profileAssociations",i=pe([ee(0,g.IEnvironmentService),ee(1,m.IFileService),ee(2,d.IUriIdentityService),ee(3,S.ILogService)],i),e.UserDataProfilesService=i;class r extends i{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(o){this.a=o}I(){return this.O}J(o){this.O=o}}e.InMemoryUserDataProfilesService=r}),define(ie[92],re([0,1,8,17,2,3,39,7,111,88,16,5,6,38,42,11,15,13,29]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var C;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(C=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class I extends Error{constructor(o,a){super(o),this.code=a}}e.ExtensionsProfileScanningError=I,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let v=class extends k.Disposable{constructor(o,a,c,s,h){super(),this.h=o,this.i=a,this.j=c,this.k=s,this.l=h,this.a=this.B(new M.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new M.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new M.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new M.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new A.ResourceMap}scanProfileExtensions(o,a){return this.m(o,void 0,a)}async addExtensionsToProfile(o,a){const c=[],s=[];try{return await this.m(a,h=>{const D=[];for(const L of h)o.some(([T])=>(0,g.areSameExtensions)(T.identifier,L.identifier)&&T.manifest.version!==L.version)?c.push(L):D.push(L);for(const[L,T]of o)if(!D.some(F=>(0,g.areSameExtensions)(F.identifier,L.identifier)&&F.version===L.manifest.version)){const F={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:T};s.push(F),D.push(F)}return s.length&&this.a.fire({extensions:s,profileLocation:a}),c.length&&this.c.fire({extensions:c,profileLocation:a}),D}),s.length&&this.b.fire({extensions:s,profileLocation:a}),c.length&&this.f.fire({extensions:c,profileLocation:a}),s}catch(h){throw s.length&&this.b.fire({extensions:s,error:h,profileLocation:a}),c.length&&this.f.fire({extensions:c,error:h,profileLocation:a}),h}}async removeExtensionFromProfile(o,a){const c=[];this.c.fire({extensions:c,profileLocation:a});try{await this.m(a,s=>{const h=[];for(const D of s)(0,g.areSameExtensions)(D.identifier,o.identifier)?c.push(D):h.push(D);return c.length&&this.c.fire({extensions:c,profileLocation:a}),h}),c.length&&this.f.fire({extensions:c,profileLocation:a})}catch(s){throw c.length&&this.f.fire({extensions:c,error:s,profileLocation:a}),s}}async m(o,a,c){return this.u(o).queue(async()=>{let s=[],h;try{const D=await this.h.readFile(o);h=JSON.parse(D.value.toString())}catch(D){if((0,b.toFileOperationResult)(D)!==1)throw D;if(this.j.extUri.isEqual(o,this.i.defaultProfile.extensionsResource)&&(h=await this.t()),!h&&c?.bailOutWhenFileNotFound)throw new I((0,l.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(h){Array.isArray(h)||this.n(o);let D=!1;for(const L of h){i(L)||this.n(o);let T;if((0,p.isString)(L.location))T=this.r(o,L.location);else{T=P.URI.revive(L.location);const F=this.p(o,T);F&&(D=!0,L.location=F)}s.push({identifier:L.identifier,location:T,version:L.version,metadata:L.metadata})}D&&await this.h.writeFile(o,t.VSBuffer.fromString(JSON.stringify(h)))}if(a){s=a(s);const D=s.map(L=>({identifier:L.identifier,version:L.version,location:this.p(o,L.location)??L.location.toJSON(),metadata:L.metadata}));await this.h.writeFile(o,t.VSBuffer.fromString(JSON.stringify(D)))}return s})}n(o){const a=new I(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.k.publicLogError2("extensionsProfileScanningError",{code:a.code}),a}p(o,a){const c=this.j.extUri.dirname(o).with({scheme:f.Schemas.file});if(this.j.extUri.isEqualOrParent(a,c))return this.j.extUri.relativePath(c,a)}r(o,a){return this.j.extUri.joinPath(this.j.extUri.dirname(o),a).with({scheme:f.Schemas.file})}async t(){return this.s||(this.s=(async()=>{const o=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let a;try{a=(await this.h.readFile(o)).value.toString()}catch(s){if((0,b.toFileOperationResult)(s)===1)return;throw s}this.l.info("Migrating extensions from old default profile location",o.toString());let c;try{const s=JSON.parse(a);Array.isArray(s)&&s.every(h=>i(h))?c=s:this.l.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.l.error(s)}if(c)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(c)),{overwrite:!1}),this.l.info("Migrated extensions from old default profile location to new location",o.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(s){if((0,b.toFileOperationResult)(s)===3)this.l.info("Migration from old default profile location to new location is done by another window",o.toString(),this.i.defaultProfile.extensionsResource.toString());else throw s}try{await this.h.del(o)}catch(s){(0,b.toFileOperationResult)(s)!==1&&this.l.error(s)}return c})()),this.s}u(o){let a=this.g.get(o);return a||(a=new E.Queue,this.g.set(o,a)),a}};v=pe([ee(0,b.IFileService),ee(1,u.IUserDataProfilesService),ee(2,d.IUriIdentityService),ee(3,w.ITelemetryService),ee(4,y.ILogService)],v),e.ExtensionsProfileScannerService=v;function i(n){return(0,p.isObject)(n)&&(0,m.isIExtensionIdentifier)(n.identifier)&&(r(n.location)||(0,p.isString)(n.location))&&n.version&&(0,p.isString)(n.version)}function r(n){return n?(0,p.isString)(n.path)&&(0,p.isString)(n.scheme):!1}}),define(ie[117],re([0,1,24,8,44,17,13,43,137,2,15,9,4,20,189,98,11,7,156,35,111,88,188,16,5,6,19,3,69,92,38,42,186,187]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w,C,I,v,i,r,n,o,a,c,s,h,D,L,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var G;(function(ue){function z(N,U){if(N===U)return!0;const q=Object.keys(N),Q=new Set;for(const oe of Object.keys(U))Q.add(oe);if(q.length!==Q.size)return!1;for(const oe of q){if(N[oe]!==U[oe])return!1;Q.delete(oe)}return Q.size===0}ue.equals=z})(G=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let V=class extends m.Disposable{constructor(z,N,U,q,Q,oe,x,R,O,W,j,$){super(),this.systemExtensionsLocation=z,this.userExtensionsLocation=N,this.l=U,this.m=q,this.n=Q,this.p=oe,this.r=x,this.s=R,this.t=O,this.u=W,this.v=j,this.w=$,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(se,(0,u.joinPath)(this.m,v.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(se,(0,u.joinPath)(this.m,v.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(_,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,I.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(z,N,U){const[q,Q]=await Promise.all([this.scanSystemExtensions(z),this.scanUserExtensions(N)]),oe=U?await this.scanExtensionsUnderDevelopment(z,[...q,...Q]):[];return this.F(q,Q,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(z){const N=[];N.push(this.G(!!z.useCache,z.language)),N.push(this.H(z.language,!!z.checkControlFile));const[U,q]=await Promise.all(N);return this.D([...U,...q],0,z,!1)}async scanUserExtensions(z){const N=z.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",N);const U=this.v.extUri.isEqual(z.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.J(N,!!z.profileLocation,1,!z.includeUninstalled,z.language,!0,U),Q=z.useCache&&!q.devMode&&q.excludeObsolete?this.j:this.k;let oe;try{oe=await Q.scanExtensions(q)}catch(x){if(x instanceof h.ExtensionsProfileScanningError&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),oe=await Q.scanExtensions(q);else throw x}return oe=await this.D(oe,1,z,!0),this.s.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(z,N){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(q=>q.scheme===b.Schemas.file).map(async q=>{const Q=await this.J(q,!1,1,!0,z.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Q)).map(x=>(x.type=N.find(R=>(0,I.areSameExtensions)(R.identifier,x.identifier))?.type??x.type,this.k.validate(x,Q)))}))).flat();return this.D(U,"development",z,!0)}return[]}async scanExistingExtension(z,N,U){const q=await this.J(z,!1,N,!0,U.language,!0,void 0),Q=await this.k.scanExtension(q);return!Q||!U.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions(z,N,U){const q=await this.J(z,!1,N,!0,U.language,!0,void 0),Q=await this.k.scanOneOrMultipleExtensions(q);return this.D(Q,N,U,!0)}async scanMetadata(z){const N=(0,u.joinPath)(z,"package.json"),U=(await this.r.readFile(N)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(z,N){const U=(0,u.joinPath)(z,"package.json"),q=(await this.r.readFile(U)).value.toString(),Q=JSON.parse(q);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,Q.__metadata={...Q.__metadata,...N},await this.r.writeFile((0,u.joinPath)(z,"package.json"),M.VSBuffer.fromString(JSON.stringify(Q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(z){if(z instanceof h.ExtensionsProfileScanningError&&z.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw z}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const z=await this.scanUserExtensions({includeInvalid:!0});if(z.length)await this.p.addExtensionsToProfile(z.map(N=>[N,N.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,M.VSBuffer.fromString(JSON.stringify([])))}catch(N){(0,r.toFileOperationResult)(N)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.getErrorMessage)(N))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(z){this.s.error(z)}finally{this.z=void 0}})()),this.z}async D(z,N,U,q){return U.includeAllVersions||(z=this.F(N===0?z:void 0,N===1?z:void 0,N==="development"?z:void 0,await this.getTargetPlatform(),q)),U.includeInvalid||(z=z.filter(Q=>Q.isValid)),z.sort((Q,oe)=>{const x=S.basename(Q.location.fsPath),R=S.basename(oe.location.fsPath);return x<R?-1:x>R?1:0})}F(z,N,U,q,Q){const oe=(R,O,W)=>{if(R.isValid&&!O.isValid)return!1;if(R.isValid===O.isValid){if(Q&&d.gt(R.manifest.version,O.manifest.version))return this.s.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${R.location.path} with version ${R.manifest.version}`),!1;if(d.eq(R.manifest.version,O.manifest.version)){if(R.type===0)return this.s.debug(`Skipping extension ${O.location.path} in favour of system extension ${R.location.path} with same version`),!1;if(R.targetPlatform===q)return this.s.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${R.location.path} with ${O.location.path}.`):this.s.debug(`Overwriting user extension ${R.location.path} with ${O.location.path}.`),!0},x=new Map;return z?.forEach(R=>{const O=v.ExtensionIdentifier.toKey(R.identifier.id),W=x.get(O);(!W||oe(W,R,!1))&&x.set(O,R)}),N?.forEach(R=>{const O=v.ExtensionIdentifier.toKey(R.identifier.id),W=x.get(O);if(!W&&z&&R.type===0){this.s.debug(`Skipping obsolete system extension ${R.location.path}.`);return}(!W||oe(W,R,!1))&&x.set(O,R)}),U?.forEach(R=>{const O=v.ExtensionIdentifier.toKey(R.identifier.id),W=x.get(O);(!W||oe(W,R,!0))&&x.set(O,R),x.set(O,R)}),[...x.values()]}async G(z,N){this.s.trace("Started scanning system extensions");const U=await this.J(this.systemExtensionsLocation,!1,0,!0,N,!0,void 0),Q=await(z&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",Q.length),Q}async H(z,N){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const q=N?await this.I():{},Q=[],oe=l.URI.file(S.normalize(S.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const R of U){const O=q[R.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":Q.push((0,u.joinPath)(oe,R.name));break;default:Q.push(l.URI.file(O));break}}const x=await Promise.all(Q.map(async R=>this.k.scanExtension(await this.J(R,!1,0,!0,z,!0,void 0))));return this.s.trace("Scanned dev system extensions:",x.length),(0,E.coalesce)(x)}async I(){try{const z=await this.r.readFile(this.l);return JSON.parse(z.value.toString())}catch{return{}}}async J(z,N,U,q,Q,oe,x){const R=await this.f(Q??y.language),O=await this.L(z),W=N&&!this.v.extUri.isEqual(z,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,j=W?await this.L(W):void 0;return new K(z,O,W,j,N,x,U,q,oe,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Q,R)}async L(z){try{const N=await this.r.stat(z);if(typeof N.mtime=="number")return N.mtime}catch{}}};V=pe([ee(4,D.IUserDataProfilesService),ee(5,h.IExtensionsProfileScannerService),ee(6,r.IFileService),ee(7,o.ILogService),ee(8,C.IEnvironmentService),ee(9,a.IProductService),ee(10,L.IUriIdentityService),ee(11,n.IInstantiationService)],V),e.AbstractExtensionsScannerService=V;class K{constructor(z,N,U,q,Q,oe,x,R,O,W,j,$,Y,B,Z){this.location=z,this.mtime=N,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=q,this.profile=Q,this.profileScanOptions=oe,this.type=x,this.excludeObsolete=R,this.validate=O,this.productVersion=W,this.productDate=j,this.productCommit=$,this.devMode=Y,this.language=B,this.translations=Z}static createNlsConfiguration(z){return{language:z.language,pseudo:z.language==="pseudo",devMode:z.devMode,translations:z.translations}}static equals(z,N){return(0,u.isEqual)(z.location,N.location)&&z.mtime===N.mtime&&(0,u.isEqual)(z.applicationExtensionslocation,N.applicationExtensionslocation)&&z.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&z.profile===N.profile&&z.profileScanOptions===N.profileScanOptions&&z.type===N.type&&z.excludeObsolete===N.excludeObsolete&&z.validate===N.validate&&z.productVersion===N.productVersion&&z.productDate===N.productDate&&z.productCommit===N.productCommit&&z.devMode===N.devMode&&z.language===N.language&&G.equals(z.translations,N.translations)}}let _=class extends m.Disposable{constructor(z,N,U,q,Q){super(),this.f=z,this.g=N,this.h=U,this.i=q,this.j=Q}async scanExtensions(z){const N=z.profile?await this.l(z):await this.k(z);let U={};if(z.excludeObsolete&&z.type===1)try{const q=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(q)}catch{}return(0,f.isEmptyObject)(U)?N:N.filter(q=>!U[I.ExtensionKey.create(q).toString()])}async k(z){const N=await this.i.resolve(z.location);if(!N.children?.length)return[];const U=await Promise.all(N.children.map(async q=>{if(!q.isDirectory||z.type===1&&(0,u.basename)(q.resource).indexOf(".")===0)return null;const Q=new K(q.resource,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(Q)}));return(0,E.coalesce)(U).sort((q,Q)=>q.location.path<Q.location.path?-1:1)}async l(z){let N=await this.m(z.location,()=>!0,z);if(z.applicationExtensionslocation&&!this.h.extUri.isEqual(z.location,z.applicationExtensionslocation)){N=N.filter(q=>!q.metadata?.isApplicationScoped);const U=await this.m(z.applicationExtensionslocation,q=>!!q.metadata?.isApplicationScoped,z);N.push(...U)}return N}async m(z,N,U){const q=await this.g.scanProfileExtensions(z,U.profileScanOptions);if(!q.length)return[];const Q=await Promise.all(q.map(async oe=>{if(N(oe)){const x=new K(oe.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(x,oe.metadata)}return null}));return(0,E.coalesce)(Q)}async scanOneOrMultipleExtensions(z){try{if(await this.i.exists((0,u.joinPath)(z.location,"package.json"))){const N=await this.scanExtension(z);return N?[N]:[]}else return await this.scanExtensions(z)}catch(N){return this.j.error(`Error scanning extensions at ${z.location.path}:`,(0,A.getErrorMessage)(N)),[]}}async scanExtension(z,N){try{let U=await this.scanExtensionManifest(z.location);if(U){U.publisher||(U.publisher=v.UNDEFINED_PUBLISHER),N=N??U.__metadata,delete U.__metadata;const q=(0,I.getGalleryExtensionId)(U.publisher,U.name),Q=N?.id?{id:q,uuid:N.id}:{id:q},oe=N?.isSystem?0:z.type,x=oe===0||!!N?.isBuiltin;F.ImplicitActivationEvents.updateManifest(U),U=await this.n(z.location,U,K.createNlsConfiguration(z));const R={type:oe,identifier:Q,manifest:U,location:z.location,isBuiltin:x,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return z.validate?this.validate(R,z):R}}catch(U){z.type!==0&&this.j.error(U)}return null}validate(z,N){let U=!0;const q=(0,i.validateExtensionManifest)(N.productVersion,N.productDate,N.location,z.manifest,z.isBuiltin);for(const[Q,oe]of q)Q===p.default.Error&&(U=!1,this.j.error(this.t(N.location,oe)));return z.isValid=U,z.validations=q,z}async scanExtensionManifest(z){const N=(0,u.joinPath)(z,"package.json");let U;try{U=(await this.i.readFile(N)).value.toString()}catch(Q){return(0,r.toFileOperationResult)(Q)!==1&&this.j.error(this.t(z,(0,w.localize)(0,null,N.path,Q.message))),null}let q;try{q=JSON.parse(U)}catch{const oe=[];(0,P.parse)(U,oe);for(const x of oe)this.j.error(this.t(z,(0,w.localize)(1,null,N.path,x.offset,x.length,(0,g.getParseErrorMessage)(x.error))));return null}return(0,P.getNodeType)(q)!=="object"?(this.j.error(this.t(z,(0,w.localize)(2,null,N.path))),null):q}async n(z,N,U){const q=await this.p(z,N,U);if(q)try{const Q=[],oe=await this.r(q.default,Q);if(Q.length>0)return Q.forEach(R=>{this.j.error(this.t(z,(0,w.localize)(3,null,q.default?.path,(0,g.getParseErrorMessage)(R.error))))}),N;if((0,P.getNodeType)(q)!=="object")return this.j.error(this.t(z,(0,w.localize)(4,null,q.default?.path))),N;const x=q.values||Object.create(null);return(0,T.localizeManifest)(N,x,oe)}catch{}return N}async p(z,N,U){const q=(0,u.joinPath)(z,"package.nls.json"),Q=(O,W)=>{W.forEach(j=>{this.j.error(this.t(z,(0,w.localize)(5,null,O?.path,(0,g.getParseErrorMessage)(j.error))))})},oe=O=>{this.j.error(this.t(z,(0,w.localize)(6,null,O?.path)))},x=`${N.publisher}.${N.name}`,R=U.translations[x];if(R)try{const O=l.URI.file(R),W=(await this.i.readFile(O)).value.toString(),j=[],$=(0,P.parse)(W,j);return j.length>0?(Q(O,j),{values:void 0,default:q}):(0,P.getNodeType)($)!=="object"?(oe(O),{values:void 0,default:q}):{values:$.contents?$.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.i.exists(q))return;let W;try{W=await this.s(z,U)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const j=(await this.i.readFile(W.localized)).value.toString(),$=[],Y=(0,P.parse)(j,$);return $.length>0?(Q(W.localized,$),{values:void 0,default:W.original}):(0,P.getNodeType)(Y)!=="object"?(oe(W.localized),{values:void 0,default:W.original}):{values:Y,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(z,N){if(z)try{const U=(await this.i.readFile(z)).value.toString();return(0,P.parse)(U,N)}catch{}}s(z,N){return new Promise((U,q)=>{const Q=oe=>{const x=(0,u.joinPath)(z,`package.nls.${oe}.json`);this.i.exists(x).then(R=>{R&&U({localized:x,original:(0,u.joinPath)(z,"package.nls.json")});const O=oe.lastIndexOf("-");O===-1?U({localized:(0,u.joinPath)(z,"package.nls.json"),original:null}):(oe=oe.substring(0,O),Q(oe))})};if(N.devMode||N.pseudo||!N.language)return U({localized:(0,u.joinPath)(z,"package.nls.json"),original:null});Q(N.language)})}t(z,N){return`[${z.path}]: ${N}`}};_=pe([ee(1,h.IExtensionsProfileScannerService),ee(2,L.IUriIdentityService),ee(3,r.IFileService),ee(4,o.ILogService)],_);let se=class extends _{constructor(z,N,U,q,Q,oe){super(N,U,q,Q,oe),this.y=z,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(z){const N=await this.z();if(this.u=z,N&&N.input&&K.equals(N.input,this.u))return this.v.trigger(()=>this.D()),N.result.map(q=>(q.location=l.URI.revive(q.location),q));const U=await super.scanExtensions(z);return await this.C({input:z,result:U}),U}async z(){try{const z=await this.i.readFile(this.y),N=JSON.parse(z.value.toString());return{result:N.result,input:(0,s.revive)(N.input)}}catch(z){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,A.getErrorMessage)(z))}return null}async C(z){try{await this.i.writeFile(this.y,M.VSBuffer.fromString(JSON.stringify(z)))}catch(N){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,A.getErrorMessage)(N))}}async D(){if(!this.u)return;const z=await this.z();if(!z)return;const N=z.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(U,N))try{await this.i.del(this.y),this.w.fire()}catch(q){this.j.error(q)}}};se=pe([ee(2,h.IExtensionsProfileScannerService),ee(3,L.IUriIdentityService),ee(4,r.IFileService),ee(5,o.ILogService)],se);function ce(ue,z){const N=(0,I.getExtensionId)(ue.manifest.publisher,ue.manifest.name);return{id:N,identifier:new v.ExtensionIdentifier(N),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:z,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.toExtensionDescription=ce;class X extends V{constructor(z,N,U,q,Q,oe,x,R,O,W,j,$){super(z,N,(0,u.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,u.joinPath)(q,v.MANIFEST_CACHE_FOLDER),Q,oe,x,R,O,W,j,$),this.M=(async()=>{if(y.translationsConfigFile)try{const Y=await this.r.readFile(l.URI.file(y.translationsConfigFile));return JSON.parse(Y.value.toString())}catch{}return Object.create(null)})()}f(z){return this.M}}e.NativeExtensionsScannerService=X}),define(ie[259],re([0,1,7,35,92,117,16,5,6,19,42,38]),function(H,e,E,t,k,M,A,P,g,m,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends M.NativeExtensionsScannerService{constructor(d,p,f,l,w,C,I,v){super(E.URI.file(w.builtinExtensionsPath),E.URI.file(w.extensionsPath),w.userHome,E.URI.file(w.userDataPath),d,p,f,l,w,C,I,v)}};y=pe([ee(0,S.IUserDataProfilesService),ee(1,k.IExtensionsProfileScannerService),ee(2,A.IFileService),ee(3,g.ILogService),ee(4,t.INativeEnvironmentService),ee(5,m.IProductService),ee(6,b.IUriIdentityService),ee(7,P.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(ie[260],re([0,1,14,2,15,9,4,60,7,30,41,35,6,38]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends t.Disposable{constructor(f,l,w){super(),this.c=f,this.f=w,this.a=P.TernarySearchTree.forPaths(!A.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(f.appRoot),this.addValidFileRoot(f.extensionsPath),this.addValidFileRoot(l.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(f.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:f}=E.session;f.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(l,w)=>this.i(l,w)),f.protocol.interceptFileProtocol(k.Schemas.file,(l,w)=>this.h(l,w)),this.B((0,t.toDisposable)(()=>{f.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),f.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(f){const l=(0,M.normalize)(f);return this.a.get(l)?t.Disposable.None:(this.a.set(l,!0),(0,t.toDisposable)(()=>this.a.delete(l)))}h(f,l){const w=g.URI.parse(f.url);return this.f.error(`Refused to load resource ${w.fsPath} from ${k.Schemas.file}: protocol (original URL: ${f.url})`),l({error:-3})}i(f,l){const w=this.j(f);let C;return this.c.crossOriginIsolated&&((0,M.basename)(w)==="workbench.html"||(0,M.basename)(w)==="workbench-dev.html"?C=k.COI.CoopAndCoep:C=k.COI.getHeadersFromQuery(f.url)),this.a.findSubstr(w)?l({path:w,headers:C}):this.b.has((0,M.extname)(w).toLowerCase())?l({path:w}):(this.f.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${w} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${f.url})`),l({error:-3}))}j(f){const l=g.URI.parse(f.url),w=k.FileAccess.uriToFileUri(l);return(0,M.normalize)(w.fsPath)}createIPCObjectUrl(){let f;const l=g.URI.from({scheme:"vscode",path:(0,m.generateUuid)()}),w=l.toString(),C=async()=>f;return b.validatedIpcMain.handle(w,C),this.f.trace(`IPC Object URL: Registered new channel ${w}.`),{resource:l,update:I=>f=I,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${w}.`),b.validatedIpcMain.removeHandler(w)}}}};d=pe([ee(0,S.INativeEnvironmentService),ee(1,u.IUserDataProfilesService),ee(2,y.ILogService)],d),e.ProtocolMainService=d}),define(ie[261],re([0,1,14,41,8,3,2,15,11,103,27,21,6,63,64,66,45,38,37]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let C=class extends A.Disposable{constructor(v,i,r,n,o,a,c,s,h){super(),this.g=v,this.h=i,this.i=r,this.j=n,this.k=o,this.l=a,this.m=c,this.n=s,this.p=h,this.a=new k.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new M.Emitter),this.onDidError=M.Event.buffer(this.f.event),this.w=void 0,this.y=void 0,this.r()}r(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(v,i)=>this.s(v,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(v,i)=>this.t(v,i)),this.B(this.k.onWillShutdown(()=>this.u()))}async s(v,i){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const r=await this.connect();if(v.sender.isDestroyed())return r.close();v.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[r])}t(v,i){this.l.trace("SharedProcess: onWorkerConnection",i);const r=new A.DisposableStore,n=a=>{!this.F()||(this.l.trace(`SharedProcess: disposing worker (reason: '${a}')`,i),r.dispose(),this.v("vscode:electron-main->shared-process=disposeWorker",i))},o=E.BrowserWindow.fromId(i.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!i.reply.channel){n("unavailable");return}r.add(M.Event.filter(this.k.onWillLoadWindow,a=>a.window.win===o)(()=>n("load"))),r.add(M.Event.fromNodeEventEmitter(o,"closed")(()=>n("closed"))),o.webContents.postMessage(i.reply.channel,i.reply.nonce,v.ports)}u(){const v=this.b;!v||(this.v("vscode:electron-main->shared-process=exit"),this.c&&(v.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{v.close()}catch{}this.b=void 0},0))}v(v,...i){if(!this.F()){this.l.warn(`Sending IPC message to channel '${v}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(v,...i)}catch(r){this.l.warn(`Error sending IPC message to channel '${v}' of shared process: ${(0,f.toErrorMessage)(r)}`)}}whenReady(){return this.w||(this.w=new Promise(v=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),v()}))),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C(),this.D(),await new Promise(v=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),v()}))})()),this.y}C(){const v=this.B(this.p.createIPCObjectUrl());this.b=new E.BrowserWindow({show:!1,backgroundColor:this.n.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${v.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),v.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),product:u.default,policiesData:this.m.serialize()}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}D(){!this.b||(this.c=v=>{this.l.trace("SharedProcess#close prevented"),v.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(v,i)=>this.f.fire({type:2,details:i})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(v,i,r)=>this.f.fire({type:3,details:{reason:r,exitCode:i}})))}async connect(){await this.z;const v=(0,g.assertIsDefined)(this.b);return(0,m.connect)(v)}async toggle(){await this.z,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}F(){const v=this.b;return v?!v.isDestroyed()&&!v.webContents.isDestroyed():!1}};C=pe([ee(2,b.IEnvironmentMainService),ee(3,l.IUserDataProfilesService),ee(4,S.ILifecycleMainService),ee(5,y.ILogService),ee(6,w.IPolicyService),ee(7,p.IThemeMainService),ee(8,d.IProtocolMainService)],C),e.SharedProcess=C}),define(ie[93],re([0,1,8,3,2,73,11,104,5,38]),function(H,e,E,t,k,M,A,P,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var b;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var y;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function u(w){const C=w.get(e.TARGET_KEY);if(C)try{return JSON.parse(C)}catch{}return Object.create(null)}e.loadKeyTargets=u;class d extends k.Disposable{constructor(C={flushInterval:d.a}){super(),this.j=C,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.J()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(C,I){if(I===e.TARGET_KEY){switch(C){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:C})}else this.b.fire({scope:C,key:I,target:this.F(C)[I]})}r(C){this.f.fire({reason:C})}get(C,I,v){return this.L(I)?.get(C,v)}getBoolean(C,I,v){return this.L(I)?.getBoolean(C,v)}getNumber(C,I,v){return this.L(I)?.getNumber(C,v)}store(C,I,v,i){if((0,A.isUndefinedOrNull)(I)){this.remove(C,v);return}this.t(()=>{this.u(C,v,i),this.L(v)?.set(C,I)})}remove(C,I){this.t(()=>{this.u(C,I,void 0),this.L(I)?.delete(C)})}t(C){this.b.pause(),this.c.pause();try{C()}finally{this.b.resume(),this.c.resume()}}keys(C,I){const v=[],i=this.F(C);for(const r of Object.keys(i))i[r]===I&&v.push(r);return v}u(C,I,v){const i=this.F(I);typeof v=="number"?i[C]!==v&&(i[C]=v,this.L(I)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[C]=="number"&&(delete i[C],this.L(I)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(C){switch(C){case-1:return this.D;case 0:return this.z;default:return this.w}}G(C){const I=this.L(C);return I?u(I):Object.create(null)}isNew(C){return this.getBoolean(e.IS_NEW_KEY,C)===!0}async flush(C=b.NONE){this.f.fire({reason:C});const I=this.L(-1),v=this.L(0),i=this.L(1);switch(C){case b.NONE:await E.Promises.settled([I?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await E.Promises.settled([I?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const C=this.L(-1)?.items??new Map,I=this.L(0)?.items??new Map,v=this.L(1)?.items??new Map;return l(C,I,v,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(C,I){return this.r(b.NONE),(0,m.isUserDataProfile)(C)?this.N(C,I):this.O(C,I)}H(C,I){return!(C.id===I.id||p(I)&&p(C))}I(C,I,v,i){this.t(()=>{if(i)for(const[r,n]of C)I.set(r,n);else{const r=new Set;for(const[n,o]of C)r.add(n),I.get(n)!==o&&this.n(v,n);for(const[n]of I.items)r.has(n)||this.n(v,n)}})}}e.AbstractStorageService=d,d.a=60*1e3;function p(w){return w.isDefault||!!w.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class f extends d{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(C=>this.n(1,C))),this.B(this.P.onDidChangeStorage(C=>this.n(0,C))),this.B(this.p.onDidChangeStorage(C=>this.n(-1,C)))}L(C){switch(C){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(C){switch(C){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(C){return!1}}e.InMemoryStorageService=f;async function l(w,C,I,v,i,r){const n=F=>{try{return JSON.parse(F)}catch{return F}},o=new Map,a=new Map;w.forEach((F,G)=>{o.set(G,F),a.set(G,n(F))});const c=new Map,s=new Map;C.forEach((F,G)=>{c.set(G,F),s.set(G,n(F))});const h=new Map,D=new Map;I.forEach((F,G)=>{h.set(G,F),D.set(G,n(F))}),console.group(v!==i?`Storage: Application (path: ${v})`:`Storage: Application & Profile (path: ${v}, default profile)`);const L=[];if(o.forEach((F,G)=>{L.push({key:G,value:F})}),console.table(L),console.groupEnd(),console.log(a),v!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const F=[];c.forEach((G,V)=>{F.push({key:V,value:G})}),console.table(F),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${r})`);const T=[];h.forEach((F,G)=>{T.push({key:G,value:F})}),console.table(T),console.groupEnd(),console.log(D)}e.logStorage=l}),define(ie[262],re([0,1,24,8,3,2,9,81,7,23,104,148,6,93,29,28]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class f extends M.Disposable{get storage(){return this.f}constructor(r,n){super(),this.j=r,this.k=n,this.b=this.B(new k.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new k.Emitter),this.onDidCloseStorage=this.c.event,this.f=new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new t.DeferredPromise,this.whenInit=this.h.p,this.i=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===b.StorageState.None)try{const r=await this.n();this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(o=>this.b.fire({key:o}))),await this.m(r);const n=r.getBoolean(u.IS_NEW_KEY);n===void 0?r.set(u.IS_NEW_KEY,!0):n&&r.set(u.IS_NEW_KEY,!1)}catch(r){this.j.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.i=b.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===y.LogLevel.Trace?r=>this.j.trace(r):void 0,logError:r=>this.j.error(r)}}m(r){return r.init()}get items(){return this.f.items}get(r,n){return this.f.get(r,n)}set(r,n){return this.f.set(r,n)}delete(r){return this.f.delete(r)}async close(){const r=new P.StopWatch(!1);await this.s(),r.stop(),r.elapsed()>f.a&&await this.r(r),this.c.fire()}async r(r){if(!!this.path)try{const n=(0,E.top)(Array.from(this.f.items.entries()).map(([a,c])=>({key:a,length:c.length})),(a,c)=>c.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),o=(await this.k.stat(g.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${o}b, Large Keys: ${n}`)}catch(n){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async s(){this.g&&await this.g,this.i=b.StorageState.Closed,await this.f.close()}}f.a=2e3;class l extends f{get path(){if(!this.v.useInMemoryStorage)return(0,A.join)(this.u.globalStorageHome.fsPath,l.t)}constructor(r,n,o,a){super(o,a),this.u=r,this.v=n}async n(){return new b.Storage(new S.SQLiteStorageDatabase(this.path??S.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}l.t="state.vscdb";class w extends l{constructor(r,n,o,a){super(r,n,o,a)}}e.ProfileStorageMain=w;class C extends l{constructor(r,n,o,a){super(n.defaultProfile,r,o,a)}async m(r){await super.m(r),this.z(r)}z(r){r.get(d.firstSessionDateStorageKey,void 0)===void 0&&r.set(d.firstSessionDateStorageKey,new Date().toUTCString());const o=r.get(d.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();r.set(d.lastSessionDateStorageKey,typeof o>"u"?null:o),r.set(d.currentSessionDateStorageKey,a)}}e.ApplicationStorageMain=C;class I extends f{get path(){if(!this.w.useInMemoryStorage)return(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id,I.t)}constructor(r,n,o,a,c){super(o,c),this.v=r,this.w=n,this.y=a}async n(){const{storageFilePath:r,wasCreated:n}=await this.C();return new b.Storage(new S.SQLiteStorageDatabase(r,{logging:this.l()}),{hint:this.w.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:n?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:S.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id),n=(0,A.join)(r,I.t);return await m.Promises.exists(r)?{storageFilePath:n,wasCreated:!1}:(await m.Promises.mkdir(r,{recursive:!0}),this.D(r),{storageFilePath:n,wasCreated:!0})}async D(r){let n;if((0,p.isSingleFolderWorkspaceIdentifier)(this.v)?n={folder:this.v.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.v)&&(n={workspace:this.v.configPath.toString()}),n)try{const o=(0,A.join)(r,I.u);await m.Promises.exists(o)||await m.Promises.writeFile(o,JSON.stringify(n,void 0,2))}catch(o){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.WorkspaceStorageMain=I,I.t="state.vscdb",I.u="workspace.json";class v extends f{get path(){}async n(){return new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=v}),define(ie[263],re([0,1,3,2,93]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class M extends t.Disposable{constructor(P,g,m){super(),this.b=P,this.c=g,this.f=m;const b=this.B(new t.MutableDisposable);this.a=this.B(new E.Emitter({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new t.DisposableStore;return P.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(g,m)=>(g?g.push(m.key):g=[m.key],g),100)(g=>this.h(g))),P.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(g,m)=>{g||(g=new Map);let b=g.get(m.profile.id);return b||g.set(m.profile.id,b={profile:m.profile,keys:[],storage:m.storage}),b.keys.push(m.key),g},100)(g=>this.i(g))),P}h(P){const g=P.includes(k.TARGET_KEY)?[this.c.defaultProfile]:[],m=[];if(P=P.filter(b=>b!==k.TARGET_KEY),P.length){const b=(0,k.loadKeyTargets)(this.b.applicationStorage.storage);m.push({profile:this.c.defaultProfile,changes:P.map(S=>({key:S,scope:0,target:b[S]}))})}this.j(g,m)}i(P){const g=[],m=new Map;for(const[b,S]of P.entries()){S.keys.includes(k.TARGET_KEY)&&g.push(S.profile);const y=S.keys.filter(u=>u!==k.TARGET_KEY);if(y.length){const u=(0,k.loadKeyTargets)(S.storage.storage);m.set(b,{profile:S.profile,changes:y.map(d=>({key:d,scope:0,target:u[d]}))})}}this.j(g,[...m.values()])}j(P,g){(P.length||g.length)&&this.a.fire({valueChanges:g,targetChanges:P})}listen(P,g,m){switch(g){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${g}`)}async call(P,g){throw new Error(`Call not found: ${g}`)}}e.ProfileStorageChangesListenerChannel=M}),define(ie[264],re([0,1,69,7,35,16,6,230,42,38]),function(H,e,E,t,k,M,A,P,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let b=class extends m.UserDataProfilesService{constructor(u,d,p,f){super(d,p,u,f),this.a=d}L(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};b=pe([ee(0,g.IUriIdentityService),ee(1,k.INativeEnvironmentService),ee(2,M.IFileService),ee(3,A.ILogService)],b),e.ServerUserDataProfilesService=b;let S=class Lt extends b{constructor(u,d,p,f,l){super(d,p,f,l),this.N=u}G(){return(0,E.revive)(this.N.getItem(Lt.b,[]))}I(){return(0,E.revive)(this.N.getItem(Lt.c,{}))}L(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};S=pe([ee(0,P.IStateService),ee(1,g.IUriIdentityService),ee(2,k.INativeEnvironmentService),ee(3,M.IFileService),ee(4,A.ILogService)],S),e.UserDataProfilesService=S}),define(ie[52],re([0,1,7,35,16,5,6,36,42,38,264]),function(H,e,E,t,k,M,A,P,g,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,M.refineServiceDecorator)(m.IUserDataProfilesService);let S=class dt extends b.UserDataProfilesService{constructor(u,d,p,f,l){super(u,d,p,f,l),this.R=u}setEnablement(u){super.setEnablement(u),this.f||(this.H([]),this.J({}))}getAssociatedEmptyWindows(){const u=[];for(const d of this.u.emptyWindows.keys())u.push({id:d});return u}H(u){u.length?this.R.setItem(dt.b,u):this.R.removeItem(dt.b)}J(u){u.emptyWindows||u.workspaces?this.R.setItem(dt.c,u):this.R.removeItem(dt.c)}I(){const u="workspaceAndProfileInfo",d=this.R.getItem(u,void 0);if(d){this.R.removeItem(u);const p=d.reduce((f,{workspace:l,profile:w})=>(f[E.URI.revive(l).toString()]=E.URI.revive(w).toString(),f),{});this.R.setItem(dt.c,{workspaces:p})}return super.I()}};S=pe([ee(0,P.IStateMainService),ee(1,g.IUriIdentityService),ee(2,t.INativeEnvironmentService),ee(3,k.IFileService),ee(4,A.ILogService)],S),e.UserDataProfilesMainService=S}),define(ie[75],re([0,1,7,50,3,2,35,16,5,21,6,93,262,38,52,42]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,g.createDecorator)("storageMainService");let f=class extends M.Disposable{constructor(C,I,v,i,r,n){super(),this.c=C,this.f=I,this.g=v,this.h=i,this.i=r,this.j=n,this.a=void 0,this.b=this.B(new k.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(C=>{C.window.profile&&this.profileStorage(C.window.profile).init(),C.workspace&&this.workspaceStorage(C.workspace).init()})),this.B(this.h.onWillShutdown(C=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=C.reason,C.join(this.applicationStorage.close());for(const[,I]of this.n)C.join(I.close());for(const[,I]of this.r)C.join(I.close())})),this.B(this.g.onWillCreateProfile(C=>{C.join((async()=>{await this.i.exists(C.profile.globalStorageHome)||await this.i.createFolder(C.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(C=>{const I=this.n.get(C.profile.id);I&&C.join(I.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const C=new y.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,t.once)(C.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),C}profileStorage(C){if((0,S.isProfileUsingDefaultStorage)(C))return this.applicationStorage;let I=this.n.get(C.id);if(!I){this.c.trace(`StorageMainService: creating profile storage (${C.name})`),I=this.p(C),this.n.set(C.id,I);const v=this.B(I.onDidChangeStorage(i=>this.b.fire({...i,storage:I,profile:C})));(0,t.once)(I.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${C.name})`),this.n.delete(C.id),v.dispose()})}return I}p(C){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.ProfileStorageMain(C,this.k(),this.c,this.i)}workspaceStorage(C){let I=this.r.get(C.id);return I||(this.c.trace(`StorageMainService: creating workspace storage (${C.id})`),I=this.s(C),this.r.set(C.id,I),(0,t.once)(I.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${C.id})`),this.r.delete(C.id)})),I}s(C){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.WorkspaceStorageMain(C,this.k(),this.c,this.f,this.i)}isUsed(C){const I=E.URI.file(C);for(const v of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!v.path&&this.j.extUri.isEqualOrParent(E.URI.file(v.path),I))return!0;return!1}};f=pe([ee(0,b.ILogService),ee(1,A.IEnvironmentService),ee(2,d.IUserDataProfilesMainService),ee(3,m.ILifecycleMainService),ee(4,P.IFileService),ee(5,p.IUriIdentityService)],f),e.StorageMainService=f,e.IApplicationStorageMainService=(0,g.createDecorator)("applicationStorageMainService");let l=class extends S.AbstractStorageService{constructor(C,I){super(),this.p=C,this.s=I,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(C){if(C===-1)return this.s.applicationStorage.storage}M(C){if(C===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};l=pe([ee(0,u.IUserDataProfilesService),ee(1,e.IStorageMainService)],l),e.ApplicationStorageMainService=l}),define(ie[265],re([0,1,2,21,52,28,8,32]),function(H,e,E,t,k,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let g=class extends E.Disposable{constructor(b,S,y){super(),this.a=S,this.b=y,this.B(b.onWillLoadWindow(u=>{u.reason===2&&this.c(u.window)})),this.B(b.onBeforeCloseWindow(u=>this.c(u))),this.B(new A.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(b){const S=this.f(b),y=this.a.getProfileForWorkspace(S);y&&((0,M.isEmptyWorkspaceIdentifier)(S)||y.isTransient)&&(this.a.unsetWorkspace(S,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,M.toWorkspaceIdentifier)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const S=this.b.getWindows().map(y=>this.f(y));for(const y of b)S.some(u=>u.id===y.id)||this.a.unsetWorkspace(y,!1)}};g=pe([ee(0,t.ILifecycleMainService),ee(1,k.IUserDataProfilesMainService),ee(2,P.IWindowsMainService)],g),e.UserDataProfilesHandler=g}),define(ie[118],re([0,1,20,7,28]),function(H,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function M(g,m,b){for(const y of g){const u=y.openedWorkspace;if((0,k.isWorkspaceIdentifier)(u)){const d=await b(u);if(d){if(d.folders.some(p=>E.extUriBiasedIgnorePathCase.isEqualOrParent(m,p.uri)))return y}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(m,u.configPath))return y}}const S=g.filter(y=>(0,k.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(m,y.openedWorkspace.uri));if(S.length)return S.sort((y,u)=>-(y.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function A(g,m){for(const b of g)if((0,k.isWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,m))return b}e.findWindowOnWorkspaceOrFolder=A;function P(g,m){const b=S=>m.some(y=>E.extUriBiasedIgnorePathCase.isEqual(t.URI.file(y),t.URI.file(S)));for(const S of g)if(S.config?.extensionDevelopmentPath?.some(y=>b(y)))return S}e.findWindowOnExtensionDevelopmentPath=P}),define(ie[266],re([0,1,14,2,4,20,7,18,21,6,36,32,116,28]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class Ot extends t.Disposable{get state(){return this.b}constructor(I,v,i,r,n){super(),this.g=I,this.h=v,this.i=i,this.j=r,this.k=n,this.b=p(this.h.getItem(Ot.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(I=>this.p(I)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(I=>{I.newCount-I.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(I=>this.p(I))}m(){this.f=!0,this.n()}n(){const I=new Set,v={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!v.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(o=>!o.isExtensionDevelopmentHost)),n&&(v.lastActiveWindow=this.r(n),v.lastActiveWindow.uiState.mode===3&&I.add(v.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);i&&(v.lastPluginDevelopmentHostWindow=this.r(i),v.lastPluginDevelopmentHostWindow.uiState.mode===3&&(I.has(v.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!i.win?.isSimpleFullScreen()&&(v.lastPluginDevelopmentHostWindow.uiState.mode=1):I.add(v.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(v.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const o=this.r(n);return o.uiState.mode===3&&(I.has(o.uiState.display)?k.isMacintosh&&o.windowId!==v.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(o.uiState.mode=1):I.add(o.uiState.display)),o}));const r=l(v);this.h.setItem(Ot.a,r),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",r)}p(I){if(this.i.quitRequested)return;const v=this.r(I);I.isExtensionDevelopmentHost&&!I.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=v:!I.isExtensionDevelopmentHost&&I.openedWorkspace&&this.b.openedWindows.forEach(i=>{const r=(0,u.isWorkspaceIdentifier)(I.openedWorkspace)&&i.workspace?.id===I.openedWorkspace.id,n=(0,u.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&i.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(i.folderUri,I.openedWorkspace.uri);(r||n)&&(i.uiState=v.uiState)}),this.g.getWindowCount()===1&&(this.c=v)}r(I){return{windowId:I.id,workspace:(0,u.isWorkspaceIdentifier)(I.openedWorkspace)?I.openedWorkspace:void 0,folderUri:(0,u.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)?I.openedWorkspace.uri:void 0,backupPath:I.backupPath,remoteAuthority:I.remoteAuthority,uiState:I.serializeWindowState()}}getNewWindowState(I){const v=this.s(I),i=this.k.getValue("window");if(v.mode===3){let r;v.hasDefaultState?r=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):r=!!(this.i.wasRestarted||i?.restoreFullscreen),r||(v.mode=1)}return v}s(I){const v=this.g.getLastActiveWindow();if(!I.extensionTestsPath){if(!!I.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=I.workspace;if((0,u.isWorkspaceIdentifier)(c)){const h=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===c.id).map(D=>D.uiState);if(h.length)return h[0]}if((0,u.isSingleFolderWorkspaceIdentifier)(c)){const h=this.state.openedWindows.filter(D=>D.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(D.folderUri,c.uri)).map(D=>D.uiState);if(h.length)return h[0]}else if(I.backupPath){const h=this.state.openedWindows.filter(D=>D.backupPath===I.backupPath).map(D=>D.uiState);if(h.length)return h[0]}const s=this.c||this.state.lastActiveWindow;if(!v&&s)return s.uiState}let i;const r=E.screen.getAllDisplays();if(r.length===1)i=r[0];else{if(k.isMacintosh){const c=E.screen.getCursorScreenPoint();i=E.screen.getDisplayNearestPoint(c)}!i&&v&&(i=E.screen.getDisplayMatching(v.getBounds())),i||(i=E.screen.getPrimaryDisplay()||r[0])}let n=(0,y.defaultWindowState)();n.x=Math.round(i.bounds.x+i.bounds.width/2-n.width/2),n.y=Math.round(i.bounds.y+i.bounds.height/2-n.height/2);const o=this.k.getValue("window");let a=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")n.mode=0,a=!1;else if(o.newWindowDimensions==="fullscreen")n.mode=3,a=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&v){const c=v.serializeWindowState();c.mode===3?n.mode=3:n=c,a=n.mode!==3&&o.newWindowDimensions==="offset"}}return a&&(n=this.t(n)),n.hasDefaultState=!0,n}t(I){if(this.g.getWindows().length===0)return I;I.x=typeof I.x=="number"?I.x:0,I.y=typeof I.y=="number"?I.y:0;const v=this.g.getWindows().map(i=>i.getBounds());for(;v.some(i=>i.x===I.x||i.y===I.y);)I.x+=30,I.y+=30;return I}};d.a="windowsState",d=pe([ee(0,S.IWindowsMainService),ee(1,b.IStateMainService),ee(2,g.ILifecycleMainService),ee(3,m.ILogService),ee(4,P.IConfigurationService)],d),e.WindowsStateHandler=d;function p(C){const I={openedWindows:[]},v=C||{openedWindows:[]};return v.lastActiveWindow&&(I.lastActiveWindow=f(v.lastActiveWindow)),v.lastPluginDevelopmentHostWindow&&(I.lastPluginDevelopmentHostWindow=f(v.lastPluginDevelopmentHostWindow)),Array.isArray(v.openedWindows)&&(I.openedWindows=v.openedWindows.map(i=>f(i))),I}e.restoreWindowsState=p;function f(C){const I={uiState:C.uiState};return C.backupPath&&(I.backupPath=C.backupPath),C.remoteAuthority&&(I.remoteAuthority=C.remoteAuthority),C.folder&&(I.folderUri=A.URI.parse(C.folder)),C.workspaceIdentifier&&(I.workspace={id:C.workspaceIdentifier.id,configPath:A.URI.parse(C.workspaceIdentifier.configURIPath)}),I}function l(C){return{lastActiveWindow:C.lastActiveWindow&&w(C.lastActiveWindow),lastPluginDevelopmentHostWindow:C.lastPluginDevelopmentHostWindow&&w(C.lastPluginDevelopmentHostWindow),openedWindows:C.openedWindows.map(I=>w(I))}}e.getWindowsStateStoreData=l;function w(C){return{workspaceIdentifier:C.workspace&&{id:C.workspace.id,configURIPath:C.workspace.configPath.toString()},folder:C.folderUri&&C.folderUri.toString(),backupPath:C.backupPath,remoteAuthority:C.remoteAuthority,uiState:C.uiState}}}),define(ie[94],re([0,1,31,43,124,34,15,9,4,20,7,5,55,28]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,S.createDecorator)("workspacesService");function d(D){return D.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function p(D){return D.hasOwnProperty("folderUri")}e.isRecentFolder=p;function f(D){return D.hasOwnProperty("fileUri")}e.isRecentFile=f;function l(D){return w(D)||C(D)}e.isStoredWorkspaceFolder=l;function w(D){const L=D;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function C(D){const L=D;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function I(D,L,T,F,G){if(D.scheme!==F.scheme)return{name:T,uri:D.toString(!0)};let V=L?void 0:G.relativePath(F,D);if(V!==void 0)V.length===0?V=".":g.isWindows&&(V=v(V));else if(D.scheme===A.Schemas.file)V=D.fsPath,g.isWindows&&(V=v(V));else if(G.isEqualAuthority(D.authority,F.authority))V=D.path;else return{name:T,uri:D.toString(!0)};return{name:T,path:V}}e.getStoredWorkspaceFolder=I;function v(D){return D=(0,M.normalizeDriveLetter)(D),(0,E.isUNC)(D)||(D=(0,E.toSlashes)(D)),D}function i(D,L,T){const F=[],G=new Set,V=T.dirname(L);for(const K of D){let _;if(w(K))K.path&&(_=T.resolvePath(V,K.path));else if(C(K))try{_=b.URI.parse(K.uri),_.path[0]!==P.posix.sep&&(_=_.with({path:P.posix.sep+_.path}))}catch(se){console.warn(se)}if(_){const se=T.getComparisonKey(_);if(!G.has(se)){G.add(se);const ce=K.name||T.basenameOrAuthority(_);F.push(new u.WorkspaceFolder({uri:_,name:ce,index:F.length},K))}}}return F}e.toWorkspaceFolders=i;function r(D,L,T,F,G){const V=n(L,D),K=G.dirname(L),_=G.dirname(F),se=[];for(const z of V.folders){const N=w(z)?G.resolvePath(K,z.path):b.URI.parse(z.uri);let U;T?U=!1:U=!w(z)||(0,P.isAbsolute)(z.path),se.push(I(N,U,z.name,_,G))}const ce={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},X=k.setProperty(D,["folders"],se,ce);let ue=k.applyEdits(D,X);return(0,m.isEqualAuthority)(V.remoteAuthority,(0,y.getRemoteAuthority)(F))&&(ue=k.applyEdits(ue,k.removeProperty(ue,["remoteAuthority"],ce))),ue}e.rewriteWorkspaceFileForNewLocation=r;function n(D,L){const T=t.parse(L);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(F=>l(F));else throw new Error(`${D} looks like an invalid workspace file.`);return T}function o(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function a(D){return typeof D.folderUri=="string"}function c(D){return typeof D.fileUri=="string"}function s(D,L){const T={workspaces:[],files:[]};if(D){const F=function(V,K){for(let _=0;_<V.length;_++)try{K(V[_],_)}catch(se){L.warn(`Error restoring recent entry ${JSON.stringify(V[_])}: ${se.toString()}. Skip entry.`)}},G=D;Array.isArray(G.entries)&&F(G.entries,V=>{const K=V.label,_=V.remoteAuthority;o(V)?T.workspaces.push({label:K,remoteAuthority:_,workspace:{id:V.workspace.id,configPath:b.URI.parse(V.workspace.configPath)}}):a(V)?T.workspaces.push({label:K,remoteAuthority:_,folderUri:b.URI.parse(V.folderUri)}):c(V)&&T.files.push({label:K,remoteAuthority:_,fileUri:b.URI.parse(V.fileUri)})})}return T}e.restoreRecentlyOpened=s;function h(D){const L={entries:[]};for(const T of D.workspaces)p(T)?L.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):L.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of D.files)L.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return L}e.toStoreData=h}),define(ie[95],re([0,1,78,15,4,20]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function A(m){function b(){let S=m.scheme===t.Schemas.file?(0,M.originalFSPath)(m):m.toString();return k.isLinux||(S=S.toLowerCase()),(0,E.createHash)("md5").update(S).digest("hex")}return{id:b(),configPath:m}}e.getWorkspaceIdentifier=A;function P(m,b){function S(){if(m.scheme!==t.Schemas.file)return(0,E.createHash)("md5").update(m.toString()).digest("hex");if(!b)return;let u;return k.isLinux?u=b.ino:k.isMacintosh?u=b.birthtime.getTime():k.isWindows&&(typeof b.birthtimeMs=="number"?u=Math.floor(b.birthtimeMs):u=b.birthtime.getTime()),(0,E.createHash)("md5").update(m.fsPath).update(u?String(u):"").digest("hex")}const y=S();if(typeof y=="string")return{id:y,uri:m}}e.getSingleFolderWorkspaceIdentifier=P;function g(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=g}),define(ie[267],re([0,1,78,31,15,9,4,20,23,178,18,27,36,16,6,177,28,95]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let w=class Tt{constructor(I,v,i,r){this.j=I,this.k=v,this.l=i,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.extUriBiasedIgnorePathCase,this.i={isEqual:(n,o)=>(0,t.isEqual)(n,o,!A.isLinux)}}async initialize(){const I=this.m.getItem(Tt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(I.emptyWindows),this.d=await this.u((0,m.deserializeWorkspaceInfos)(I)),this.e=await this.v((0,m.deserializeFolderInfos)(I)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==u.HotExitConfiguration.OFF}q(){return this.s()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(I,v){this.d.some(r=>I.workspace.id===r.workspace.id)||(this.d.push(I),this.C());const i=(0,M.join)(this.c,I.workspace.id);return v?this.t(i,v).then(()=>i):i}async t(I,v){if(await g.Promises.exists(I)&&await this.z(I),await g.Promises.exists(v))try{await g.Promises.rename(v,I)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(I){return this.e.some(v=>this.h.isEqual(I.folderUri,v.folderUri))||(this.e.push(I),this.C()),(0,M.join)(this.c,this.D(I))}registerEmptyWindowBackup(I){return this.g.some(v=>!!v.backupFolder&&this.i.isEqual(v.backupFolder,I.backupFolder))||(this.g.push(I),this.C()),(0,M.join)(this.c,I.backupFolder)}async u(I){if(!Array.isArray(I))return[];const v=new Set,i=[];for(const r of I){const n=r.workspace;if(!(0,f.isWorkspaceIdentifier)(n))return[];if(!v.has(n.id)){v.add(n.id);const o=(0,M.join)(this.c,n.id);await this.B(o)?n.configPath.scheme!==k.Schemas.file||await g.Promises.exists(n.configPath.fsPath)?i.push(r):await this.z(o):await this.x(o)}}return i}async v(I){if(!Array.isArray(I))return[];const v=[],i=new Set;for(const r of I){const n=r.folderUri,o=this.h.getComparisonKey(n);if(!i.has(o)){i.add(o);const a=(0,M.join)(this.c,this.D(r));await this.B(a)?n.scheme!==k.Schemas.file||await g.Promises.exists(n.fsPath)?v.push(r):await this.z(a):await this.x(a)}}return v}async w(I){if(!Array.isArray(I))return[];const v=[],i=new Set;for(const r of I){const n=r.backupFolder;if(typeof n!="string")return[];if(!i.has(n)){i.add(n);const o=(0,M.join)(this.c,n);await this.B(o)?v.push(r):await this.x(o)}}return v}async x(I){try{await g.Promises.rm(I,g.RimRafMode.MOVE)}catch(v){this.l.error(`Backup: Could not delete stale backup: ${v.toString()}`)}}y(){let I=(0,l.createEmptyWorkspaceIdentifier)();for(;this.g.some(v=>!!v.backupFolder&&this.i.isEqual(v.backupFolder,I.id));)I=(0,l.createEmptyWorkspaceIdentifier)();return{backupFolder:I.id}}async z(I){const v=this.y(),i=(0,M.join)(this.c,v.backupFolder);try{await g.Promises.rename(I,i)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(v),!0}async getDirtyWorkspaces(){const I=[];for(const v of this.d)await this.A(v)&&I.push(v);for(const v of this.e)await this.A(v)&&I.push(v);return I}A(I){let v;return(0,m.isEmptyWindowBackupInfo)(I)?v=(0,M.join)(this.c,I.backupFolder):(0,p.isFolderBackupInfo)(I)?v=(0,M.join)(this.c,this.D(I)):v=(0,M.join)(this.c,I.workspace.id),this.B(v)}async B(I){try{const v=await g.Promises.readdir(I);for(const i of v)try{if((await g.Promises.readdir((0,M.join)(I,i))).length>0)return!0}catch{}}catch{}return!1}C(){const I={workspaces:this.d.map(({workspace:v,remoteAuthority:i})=>{const r={id:v.id,configURIPath:v.configPath.toString()};return i&&(r.remoteAuthority=i),r}),folders:this.e.map(({folderUri:v,remoteAuthority:i})=>{const r={folderUri:v.toString()};return i&&(r.remoteAuthority=i),r}),emptyWindows:this.g.map(({backupFolder:v,remoteAuthority:i})=>{const r={backupFolder:v};return i&&(r.remoteAuthority=i),r})};this.m.setItem(Tt.a,I)}D(I){const v=I.folderUri;let i;return v.scheme===k.Schemas.file?i=A.isLinux?v.fsPath:v.fsPath.toLowerCase():i=v.toString().toLowerCase(),(0,E.createHash)("md5").update(i).digest("hex")}};w.a="backupWorkspaces",w=pe([ee(0,S.IEnvironmentMainService),ee(1,b.IConfigurationService),ee(2,d.ILogService),ee(3,y.IStateMainService)],w),e.BackupMainService=w}),define(ie[53],re([0,1,14,3,43,34,2,15,9,20,11,23,176,62,57,27,5,6,19,52,118,28,94,95]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w,C,I,v,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,f.createDecorator)("workspacesManagementMainService");let n=class extends A.Disposable{constructor(a,c,s,h,D,L){super(),this.g=a,this.h=c,this.i=s,this.j=h,this.k=D,this.l=L,this.a=this.B(new t.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new t.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const a=(await S.Promises.readdir(this.c.fsPath)).map(c=>(0,m.joinPath)(this.c,c,v.UNTITLED_WORKSPACE_NAME));for(const c of a){const s=(0,r.getWorkspaceIdentifier)(c),h=await this.resolveLocalWorkspace(c);h?this.f.push({workspace:s,remoteAuthority:h.remoteAuthority}):await this.deleteUntitledWorkspace(s)}}catch(a){a.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${a}).`)}}resolveLocalWorkspace(a){return this.m(a,c=>S.Promises.readFile(c,"utf8"))}m(a,c){if(!!this.n(a)&&a.scheme===P.Schemas.file)try{const s=c(a.fsPath);return s instanceof Promise?s.then(h=>this.p(a,h),h=>{}):this.p(a,s)}catch{return}}n(a){return(0,v.isUntitledWorkspace)(a,this.g)||(0,v.hasWorkspaceFileExtension)(a)}p(a,c){try{const s=this.r(a,c),h=(0,r.getWorkspaceIdentifier)(a);return{id:h.id,configPath:h.configPath,folders:(0,i.toWorkspaceFolders)(s.folders,h.configPath,m.extUriBiasedIgnorePathCase),remoteAuthority:s.remoteAuthority,transient:s.transient}}catch(s){this.h.warn(s.toString())}}r(a,c){const s=(0,k.parse)(c);if(s&&Array.isArray(s.folders))s.folders=s.folders.filter(h=>(0,i.isStoredWorkspaceFolder)(h));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return s}async createUntitledWorkspace(a,c){const{workspace:s,storedWorkspace:h}=this.s(a,c),D=s.configPath.fsPath;return await S.Promises.mkdir((0,g.dirname)(D),{recursive:!0}),await S.Promises.writeFile(D,JSON.stringify(h,null,"	")),this.f.push({workspace:s,remoteAuthority:c}),s}s(a=[],c){const s=(Date.now()+Math.round(Math.random()*1e3)).toString(),h=(0,m.joinPath)(this.c,s),D=(0,m.joinPath)(h,v.UNTITLED_WORKSPACE_NAME),L=[];for(const T of a)L.push((0,i.getStoredWorkspaceFolder)(T.uri,!0,T.name,h,m.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(D),storedWorkspace:{folders:L,remoteAuthority:c}}}async getWorkspaceIdentifier(a){return(0,r.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,v.isUntitledWorkspace)(a.configPath,this.g)}async deleteUntitledWorkspace(a){!this.isUntitledWorkspace(a)||(await this.t(a),this.i.isEnabled()&&this.i.unsetWorkspace(a),this.a.fire(a))}async t(a){const c=(0,m.originalFSPath)(a.configPath);try{await S.Promises.rm((0,g.dirname)(c));const s=(0,g.join)(this.g.workspaceStorageHome.fsPath,a.id);await S.Promises.exists(s)&&await S.Promises.writeFile((0,g.join)(s,"obsolete"),""),this.f=this.f.filter(h=>h.workspace.id!==a.id)}catch(s){this.h.warn(`Unable to delete untitled workspace ${c} (${s}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(a,c,s){if(!a||!a.win||!a.isReady||!await this.u(a,c,s))return;const D=await this.v(a,(0,r.getWorkspaceIdentifier)(s));if(!!D)return this.b.fire({window:a,workspace:D.workspace}),D}async u(a,c,s){if(!s)return!0;if((0,v.isWorkspaceIdentifier)(a.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,s))return!1;if((0,I.findWindowOnWorkspaceOrFolder)(c,s)){const h={title:this.l.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,y.localize)(0,null))],message:(0,y.localize)(1,null,(0,m.basename)(s)),detail:(0,y.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(h,(0,b.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1}return!0}async v(a,c){if(!a.config)return;a.focus();let s;return a.config.extensionDevelopmentPath||(a.config.backupPath?s=await this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:a.remoteAuthority},a.config.backupPath):s=this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:a.remoteAuthority})),(0,v.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&await this.deleteUntitledWorkspace(a.openedWorkspace),a.config.workspace=c,a.config.backupPath=s,{workspace:c,backupPath:s}}};n=pe([ee(0,p.IEnvironmentMainService),ee(1,l.ILogService),ee(2,C.IUserDataProfilesMainService),ee(3,u.IBackupMainService),ee(4,d.IDialogMainService),ee(5,w.IProductService)],n),e.WorkspacesManagementMainService=n}),define(ie[119],re([0,1,14,41,22,5,32,28,53,11,6]),function(H,e,E,t,k,M,A,P,g,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,M.createDecorator)(e.ID);let S=class{constructor(u,d,p){this.a=u,this.b=d,this.c=p}async getRemoteDiagnostics(u){const d=this.a.getWindows();return(await Promise.all(d.map(async f=>{const l=f.remoteAuthority;if(!l)return;const w=`vscode:getDiagnosticInfoResponse${f.id}`,C={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?await this.f(f):void 0};return new Promise(I=>{f.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:w,args:C}),t.validatedIpcMain.once(w,(v,i)=>{i||I({hostName:l,errorMessage:`Unable to resolve connection to '${l}'.`}),I(i)}),setTimeout(()=>{I({hostName:l,errorMessage:`Connection to '${l}' could not be established`})},5e3)})}))).filter(f=>!!f)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const u=[];for(const d of E.BrowserWindow.getAllWindows()){const p=this.a.getWindowById(d.id);p?u.push(await this.d(p)):u.push(this.e(d))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(u){const d=await this.f(u),p=(0,m.assertIsDefined)(u.win);return this.e(p,d,u.remoteAuthority)}e(u,d=[],p){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:d,remoteAuthority:p}}async f(u){const d=[],p=u.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(p))d.push(p.uri);else if((0,P.isWorkspaceIdentifier)(p)){const f=await this.b.resolveLocalWorkspace(p.configPath);f&&f.folders.forEach(w=>{d.push(w.uri)})}return d}};S=pe([ee(0,A.IWindowsMainService),ee(1,g.IWorkspacesManagementMainService),ee(2,b.ILogService)],S),e.DiagnosticsMainService=S}),define(ie[58],re([0,1,46,14,25,142,54,3,34,2,15,9,4,7,100,82,23,97,166,57,27,5,21,6,19,66,32,28,53,17,224,217,36]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w,C,I,v,i,r,n,o,a,c,s,h,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,v.createDecorator)("nativeHostMainService");let F=class extends m.Disposable{constructor(V,K,_,se,ce,X,ue,z,N,U){super(),this.a=V,this.b=K,this.c=_,this.f=se,this.g=ce,this.h=X,this.i=ue,this.j=z,this.k=N,this.l=U,this.onDidOpenWindow=P.Event.map(this.b.onDidOpenWindow,q=>q.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:q,x:Q,y:oe})=>({windowId:q.id,x:Q,y:oe})),({windowId:q})=>!!this.b.getWindowById(q)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(q,Q)=>Q.id),q=>!!this.b.getWindowById(q)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(q,Q)=>Q.id),q=>!!this.b.getWindowById(q)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(q,Q)=>Q.id),q=>!!this.b.getWindowById(q)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),q=>!!q),q=>q.id),P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(q,Q)=>Q.id),q=>!!this.b.getWindowById(q))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new P.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(q,Q,oe)=>oe),q=>!(Array.isArray(q)&&q.length===1&&q[0]==="workArea")),P.Event.fromNodeEventEmitter(t.screen,"display-added"),P.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(K=>({id:K.id,workspace:K.openedWorkspace??(0,c.toWorkspaceIdentifier)(K.backupPath,K.isExtensionDevelopmentHost),title:K.win?.getTitle()??"",filename:K.getRepresentedFilename(),dirty:K.isDocumentEdited()}))}async getWindowCount(V){return this.b.getWindowCount()}async getActiveWindowId(V){const K=t.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(K)return K.id}openWindow(V,K,_){return Array.isArray(K)?this.n(V,K,_):this.p(V,K)}async n(V,K,_=Object.create(null)){K.length>0&&await this.b.open({context:5,contextWindowId:V,urisToOpen:K,cli:this.g.args,forceNewWindow:_.forceNewWindow,forceReuseWindow:_.forceReuseWindow,preferNewWindow:_.preferNewWindow,diffMode:_.diffMode,mergeMode:_.mergeMode,addMode:_.addMode,gotoLineMode:_.gotoLineMode,noRecentEntry:_.noRecentEntry,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:_.remoteAuthority||void 0})}async p(V,K){await this.b.openEmptyWindow({context:5,contextWindowId:V},K)}async toggleFullScreen(V){this.w(V)?.toggleFullScreen()}async handleTitleDoubleClick(V){this.w(V)?.handleTitleDoubleClick()}async isMaximized(V){const K=this.w(V);return K?.win?K.win.isMaximized():!1}async maximizeWindow(V){const K=this.w(V);K?.win&&K.win.maximize()}async unmaximizeWindow(V){const K=this.w(V);K?.win&&K.win.unmaximize()}async minimizeWindow(V){const K=this.w(V);K?.win&&K.win.minimize()}async updateWindowControls(V,K){const _=this.w(V);_&&_.updateWindowControls(K)}async focusWindow(V,K){K&&typeof K.windowId=="number"&&(V=K.windowId),this.w(V)?.focus({force:K?.force??!1})}async setMinimumSize(V,K,_){const se=this.w(V);if(se?.win){const[ce,X]=se.win.getSize(),[ue,z]=se.win.getMinimumSize(),[N,U]=[K??ue,_??z],[q,Q]=[Math.max(ce,N),Math.max(X,U)];(ue!==N||z!==U)&&se.win.setMinimumSize(N,U),(ce!==q||X!==Q)&&se.win.setSize(q,Q)}}async saveWindowSplash(V,K){this.j.saveWindowSplash(V,K)}async installShellCommand(V){const{source:K,target:_}=await this.r();try{const{symbolicLink:se}=await f.SymlinkSupport.stat(K);if(se&&!se.dangling){const ce=await(0,d.realpath)(K);if(_===ce)return}await f.Promises.unlink(K)}catch(se){if(se.code!=="ENOENT")throw se}try{await f.Promises.symlink(_,K)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:ce}=await this.showMessageBox(V,{title:this.i.nameLong,type:"info",message:(0,w.localize)(0,null,this.i.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,w.localize)(1,null)),(0,g.mnemonicButtonLabel)((0,w.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ce===0)try{const X=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${_}' '${K}'\\" with administrator privileges"`;await(0,M.promisify)(E.exec)(X)}catch{throw new Error((0,w.localize)(3,null,K))}}}async uninstallShellCommand(V){const{source:K}=await this.r();try{await f.Promises.unlink(K)}catch(_){switch(_.code){case"EACCES":{const{response:se}=await this.showMessageBox(V,{title:this.i.nameLong,type:"info",message:(0,w.localize)(4,null,this.i.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,g.mnemonicButtonLabel)((0,w.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const ce=`osascript -e "do shell script \\"rm '${K}'\\" with administrator privileges"`;await(0,M.promisify)(E.exec)(ce)}catch{throw new Error((0,w.localize)(7,null,K))}break}case"ENOENT":break;default:throw _}}}async r(){const V=(0,S.resolve)(this.g.appRoot,"bin","code"),K=`/usr/local/bin/${this.i.applicationName}`;if(!await f.Promises.exists(V))throw new Error((0,w.localize)(8,null,V));return{source:K,target:V}}async showMessageBox(V,K){return this.c.showMessageBox(K,this.s(V))}async showSaveDialog(V,K){return this.c.showSaveDialog(K,this.s(V))}async showOpenDialog(V,K){return this.c.showOpenDialog(K,this.s(V))}s(V){const K=this.w(V);if(K?.win)return K.win}async pickFileFolderAndOpen(V,K){const _=await this.c.pickFileFolder(K);_&&await this.t(await Promise.all(_.map(async se=>await f.SymlinkSupport.existsDirectory(se)?{folderUri:u.URI.file(se)}:{fileUri:u.URI.file(se)})),K,V)}async pickFolderAndOpen(V,K){const _=await this.c.pickFolder(K);_&&await this.t(_.map(se=>({folderUri:u.URI.file(se)})),K,V)}async pickFileAndOpen(V,K){const _=await this.c.pickFile(K);_&&await this.t(_.map(se=>({fileUri:u.URI.file(se)})),K,V)}async pickWorkspaceAndOpen(V,K){const _=await this.c.pickWorkspace(K);_&&await this.t(_.map(se=>({workspaceUri:u.URI.file(se)})),K,V)}async t(V,K,_){await this.b.open({context:3,contextWindowId:_,cli:this.g.args,urisToOpen:V,forceNewWindow:K.forceNewWindow})}async showItemInFolder(V,K){t.shell.showItemInFolder(K)}async setRepresentedFilename(V,K){this.w(V)?.setRepresentedFilename(K)}async setDocumentEdited(V,K){this.w(V)?.setDocumentEdited(K)}async openExternal(V,K){return y.isLinuxSnap?this.u(K):t.shell.openExternal(K),!0}u(V){const K=process.env.GDK_PIXBUF_MODULE_FILE,_=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(V),process.env.GDK_PIXBUF_MODULE_FILE=K,process.env.GDK_PIXBUF_MODULEDIR=_}moveItemToTrash(V,K){return t.shell.trashItem(K)}async isAdmin(){let V;return y.isWindows?V=(await new Promise((K,_)=>{H(["native-is-elevated"],K,_)}))():V=process.getuid()===0,V}async writeElevated(V,K,_,se){const ce=await new Promise((X,ue)=>{H(["@vscode/sudo-prompt"],X,ue)});return new Promise((X,ue)=>{const z=[`"${this.v}"`];se?.unlock&&z.push("--file-chmod"),z.push("--file-write",`"${K.fsPath}"`,`"${_.fsPath}"`);const N={name:this.i.nameLong.replace("-",""),icns:y.isMacintosh&&this.g.isBuilt?(0,S.join)((0,S.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ce.exec(z.join(" "),N,(U,q,Q)=>{q&&this.h.trace(`[sudo-prompt] received stdout: ${q}`),Q&&this.h.trace(`[sudo-prompt] received stderr: ${Q}`),U?ue(U):X(void 0)})})}get v(){return y.isWindows?this.g.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,S.join)(this.g.appRoot,"scripts","code-cli.bat"):y.isLinux?this.g.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,S.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,S.join)(this.g.appRoot,"bin","code"):(0,S.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return p.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return y.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(V,K,_){process.kill(K,_)}async readClipboardText(V,K){return t.clipboard.readText(K)}async writeClipboardText(V,K,_){return t.clipboard.writeText(K,_)}async readClipboardFindText(V){return t.clipboard.readFindText()}async writeClipboardFindText(V,K){return t.clipboard.writeFindText(K)}async writeClipboardBuffer(V,K,_,se){return t.clipboard.writeBuffer(K,Buffer.from(_.buffer),se)}async readClipboardBuffer(V,K){return h.VSBuffer.wrap(t.clipboard.readBuffer(K))}async hasClipboard(V,K,_){return t.clipboard.has(K,_)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(V,K){this.w(V)?.updateTouchBar(K)}async notifyReady(V){this.w(V)?.setReady()}async relaunch(V,K){return this.f.relaunch(K)}async reload(V,K){const _=this.w(V);if(_){if((0,c.isWorkspaceIdentifier)(_.openedWorkspace)){const se=_.openedWorkspace.configPath;if(se.scheme===b.Schemas.file&&(await this.l.resolveLocalWorkspace(se))?.transient)return this.openWindow(_.id,{forceReuseWindow:!0})}return this.f.reload(_,K?.disableExtensions!==void 0?{_:[],"disable-extensions":K.disableExtensions}:void 0)}}async closeWindow(V){this.closeWindowById(V,V)}async closeWindowById(V,K){const _=this.w(K);if(_?.win)return _.win.close()}async quit(V){const K=this.b.getLastActiveWindow();K?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&K.win?K.win.close():this.f.quit()}async exit(V,K){await this.f.kill(K)}async resolveProxy(V,K){const se=this.w(V)?.win?.webContents?.session;if(se)return se.resolveProxy(K)}findFreePort(V,K,_,se,ce=1){return(0,l.findFreePort)(K,_,se,ce)}async openDevTools(V,K){const _=this.w(V);_?.win&&_.win.webContents.openDevTools(K)}async toggleDevTools(V){const K=this.w(V);K?.win&&K.win.webContents.toggleDevTools()}async sendInputEvent(V,K){const _=this.w(V);_?.win&&(K.type==="mouseDown"||K.type==="mouseUp")&&_.win.webContents.sendInputEvent(K)}async enableSandbox(V,K){K?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(V,K,_){const se=this.w(V);if(!se||!se.win)throw new Error;return await new L.WindowProfiler(se.win,K,this.h).inspect(_)}async windowsGetStringRegKey(V,K,_,se){if(!y.isWindows)return;const ce=await new Promise((X,ue)=>{H(["@vscode/windows-registry"],X,ue)});try{return ce.GetStringRegKey(K,_,se)}catch{return}}w(V){if(typeof V=="number")return this.b.getWindowById(V)}};pe([A.memoize],F.prototype,"v",null),F=pe([ee(1,a.IWindowsMainService),ee(2,C.IDialogMainService),ee(3,i.ILifecycleMainService),ee(4,I.IEnvironmentMainService),ee(5,r.ILogService),ee(6,n.IProductService),ee(7,o.IThemeMainService),ee(8,T.IStateMainService),ee(9,s.IWorkspacesManagementMainService)],F),e.NativeHostMainService=F}),define(ie[268],re([0,1,14,41,25,34,2,15,4,101,164,85,119,57,27,5,6,58,63,19,64,74,31,11,75]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w,C,I,v,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");const o="issue.processExplorerWindowState";let a=class jt{constructor(h,D,L,T,F,G,V,K,_,se){this.g=h,this.h=D,this.i=L,this.j=T,this.k=F,this.l=G,this.m=V,this.n=K,this.o=_,this.p=se,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async h=>{const[D,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),T=await this.j.getSystemInfo(D,L);this.r(h,"vscode:issueSystemInfoResponse",T)}),t.validatedIpcMain.on("vscode:listProcesses",async h=>{const D=[];try{D.push({name:(0,b.localize)(0,null),rootProcess:await(0,m.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(T=>{(0,S.isRemoteDiagnosticError)(T)?D.push({name:T.hostName,rootProcess:T}):T.processes&&D.push({name:T.hostName,rootProcess:T.processes})})}catch(L){this.i.error(`Listing processes failed: ${L}`)}this.r(h,"vscode:listProcessesResponse",D)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async h=>{const D={title:this.o.nameLong,message:(0,b.localize)(1,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,b.localize)(2,null)),(0,M.mnemonicButtonLabel)((0,b.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const L=await this.l.showMessageBox(D,this.b);this.r(h,"vscode:issueReporterClipboardResponse",L.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async h=>{const D=await this.w();this.r(h,"vscode:issuePerformanceInfoResponse",D)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const h={title:this.o.nameLong,message:(0,b.localize)(4,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,b.localize)(5,null)),(0,M.mnemonicButtonLabel)((0,b.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(h,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(h,D)=>{const{id:L,from:T,args:F}=D;let G;switch(T){case"issueReporter":G=this.c;break;case"processExplorer":G=this.f;break;default:throw new Error(`Unexpected command source: ${T}`)}G?.webContents.send("vscode:runAction",{id:L,from:T,args:F})}),t.validatedIpcMain.on("vscode:openExternal",(h,D)=>{this.m.openExternal(void 0,D)}),t.validatedIpcMain.on("vscode:closeIssueReporter",h=>{this.b?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",h=>{this.d?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async h=>{const D=await this.k.getMainDiagnostics();this.r(h,"vscode:windowsInfoResponse",D.windows)})}r(h,D,...L){h.sender.isDestroyed()||h.sender.send(D,...L)}s(h,D){try{return h&&JSON.parse(h)||D}catch{return D}}async openReporter(h){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const D=new A.DisposableStore,L=D.add(this.n.createIPCObjectUrl()),T=this.v(this.c,700,800);this.b=this.u(T,L,{backgroundColor:h.styles.backgroundColor,title:(0,b.localize)(7,null),zoomLevel:h.zoomLevel,alwaysOnTop:!1},"issue-reporter"),L.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:h,disableExtensions:!!this.h.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:w.default}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,D.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,D.dispose())})}this.b&&this.t(this.b)}async openProcessExplorer(h){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const D=new A.DisposableStore,L=D.add(this.n.createIPCObjectUrl()),T=this.s(this.p.get(o,-1),void 0),F=c(T)?T:this.v(this.f,800,500),G=E.screen.getDisplayNearestPoint({x:F.x,y:F.y});F.width/=G.scaleFactor,F.height/=G.scaleFactor,this.d=this.u(F,L,{backgroundColor:h.styles.backgroundColor,title:(0,b.localize)(8,null),zoomLevel:h.zoomLevel,alwaysOnTop:!0},"process-explorer"),L.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:h,product:w.default}),this.d.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,D.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,D.dispose())});const V=()=>{if(!this.d)return;const K=this.d.getSize(),_=this.d.getPosition();if(!K||!_)return;const se={width:K[0],height:K[1],x:_[0],y:_[1]};this.p.store(o,JSON.stringify(se),-1,1)};this.d.on("moved",V),this.d.on("resized",V)}this.d&&this.t(this.d)}t(h){h.isMinimized()&&h.restore(),h.focus()}u(h,D,L,T){const F=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:h.width,height:h.height,minWidth:300,minHeight:200,x:h.x,y:h.y,title:L.title,backgroundColor:L.backgroundColor||jt.a,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${D.resource.toString()}`,`--vscode-window-kind=${T}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,v.zoomLevelToZoomFactor)(L.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:L.alwaysOnTop,experimentalDarkMode:!0});return F.setMenuBarVisibility(!1),F}async getSystemStatus(){const[h,D]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(h,D)}v(h,D,L){let T;const F=E.screen.getAllDisplays();if(F.length===1)T=F[0];else{if(g.isMacintosh){const K=E.screen.getCursorScreenPoint();T=E.screen.getDisplayNearestPoint(K)}!T&&h&&(T=E.screen.getDisplayMatching(h.getBounds())),T||(T=E.screen.getPrimaryDisplay()||F[0])}const G=T.bounds,V={width:D,height:L,x:G.x+G.width/2-D/2,y:G.y+G.height/2-L/2};return G.width>0&&G.height>0&&(V.x<G.x&&(V.x=G.x),V.y<G.y&&(V.y=G.y),V.x>G.x+G.width&&(V.x=G.x),V.y>G.y+G.height&&(V.y=G.y),V.width>G.width&&(V.width=G.width),V.height>G.height&&(V.height=G.height)),V}async w(){try{const[h,D]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(h,D)}catch(h){throw this.i.warn("issueService#getPerformanceInfo ",h.message),h}}async stopTracing(){if(!this.h.args.trace)return;const h=await E.contentTracing.stopRecording(`${(0,i.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,b.localize)(9,null),detail:(0,b.localize)(10,null,h),buttons:[(0,M.mnemonicButtonLabel)((0,b.localize)(11,null))],defaultId:0,noLink:!0},(0,r.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,h)}};a.a="#1E1E1E",a=pe([ee(1,d.IEnvironmentMainService),ee(2,f.ILogService),ee(3,S.IDiagnosticsService),ee(4,y.IDiagnosticsMainService),ee(5,u.IDialogMainService),ee(6,l.INativeHostMainService),ee(7,I.IProtocolMainService),ee(8,C.IProductService),ee(9,n.IApplicationStorageMainService)],a),e.IssueMainService=a;function c(s){return typeof s!="object"||s===null?!1:"x"in s&&"y"in s&&"width"in s&&"height"in s}}),define(ie[269],re([0,1,22,18,27,21,6,58,19,56,29,49,91]),function(H,e,E,t,k,M,A,P,g,m,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let u=class extends y.AbstractUpdateService{constructor(p,f,l,w,C,I,v,i){super(p,f,w,C,I,i),this.e=l,this.u=v}s(p){return(0,y.createUpdateURL)(`linux-${process.arch}`,p,this.k)}t(p){!this.a||(this.d(S.State.CheckingForUpdates(p)),this.i.request({url:this.a},E.CancellationToken.None).then(m.asJson).then(f=>{!f||!f.url||!f.version||!f.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!p}),this.d(S.State.Idle(1))):this.d(S.State.AvailableForDownload(f))}).then(void 0,f=>{this.j.error(f),this.e.publicLog2("update:notAvailable",{explicit:!!p});const l=p?f.message||f:void 0;this.d(S.State.Idle(1,l))}))}async o(p){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):p.update.url&&this.u.openExternal(void 0,p.update.url),this.d(S.State.Idle(1))}};u=pe([ee(0,M.ILifecycleMainService),ee(1,t.IConfigurationService),ee(2,b.ITelemetryService),ee(3,k.IEnvironmentMainService),ee(4,m.IRequestService),ee(5,A.ILogService),ee(6,P.INativeHostMainService),ee(7,g.IProductService)],u),e.LinuxUpdateService=u}),define(ie[270],re([0,1,46,40,25,8,22,54,9,7,128,23,18,27,16,21,6,58,19,56,29,49,91]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w,C,I,v,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(c,s=1e3){for(;!c();)await(0,M.timeout)(s)}let n;function o(){return typeof n>"u"&&(n=t.existsSync(g.join(g.dirname(process.execPath),"unins000.exe"))?0:1),n}let a=class extends i.AbstractUpdateService{get cachePath(){const s=g.join((0,k.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return S.Promises.mkdir(s,{recursive:!0}).then(()=>s)}constructor(s,h,D,L,T,F,G,V,K){super(s,h,L,T,F,K),this.u=D,this.v=G,this.w=V}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(s){let h="win32";return process.arch!=="ia32"&&(h+=`-${process.arch}`),o()===1?h+="-archive":this.k.target==="user"&&(h+="-user"),(0,i.createUpdateURL)(h,s,this.k)}t(s){!this.a||(this.d(v.State.CheckingForUpdates(s)),this.i.request({url:this.a},A.CancellationToken.None).then(C.asJson).then(h=>{const D=o();return!h||!h.url||!h.version||!h.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!s}),this.d(v.State.Idle(D)),Promise.resolve(null)):D===1?(this.d(v.State.AvailableForDownload(h)),Promise.resolve(null)):(this.d(v.State.Downloading(h)),this.B(h.version).then(()=>this.A(h.version).then(L=>S.Promises.exists(L).then(T=>{if(T)return Promise.resolve(L);const F=h.url,G=h.hash,V=`${L}.tmp`;return this.i.request({url:F},A.CancellationToken.None).then(K=>this.v.writeFile(m.URI.file(V),K.stream)).then(G?()=>(0,b.checksum)(V,h.hash):()=>{}).then(()=>S.Promises.rename(V,L)).then(()=>L)})).then(L=>{const T=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:L},T&&h.supportsFastUpdate?this.k.target==="user"?this.p():this.d(v.State.Downloaded(h)):this.d(v.State.Ready(h))})))}).then(void 0,h=>{this.j.error(h),this.u.publicLog2("update:notAvailable",{explicit:!!s});const D=s?h.message||h:void 0;this.d(v.State.Idle(o(),D))}))}async o(s){s.update.url&&this.w.openExternal(void 0,s.update.url),this.d(v.State.Idle(o()))}async A(s){const h=await this.cachePath;return g.join(h,`CodeSetup-${this.k.quality}-${s}.exe`)}async B(s=null){const h=s?F=>!new RegExp(`${this.k.quality}-${s}\\.exe$`).test(F):()=>!0,D=await this.cachePath,T=(await S.Promises.readdir(D)).filter(h).map(async F=>{try{await S.Promises.unlink(g.join(D,F))}catch{}});await Promise.all(T)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const s=this.state.update;this.d(v.State.Updating(s));const h=await this.cachePath;this.e.updateFilePath=g.join(h,`CodeSetup-${this.k.quality}-${s.version}.flag`),await S.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(v.State.Idle(o()))});const L=`${this.k.win32MutexName}-ready`,T=await new Promise((F,G)=>{H(["windows-mutex"],F,G)});r(()=>T.isActive(L)).then(()=>this.d(v.State.Ready(s)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?t.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return o()}async _applySpecificUpdate(s){if(this.state.type!=="idle")return;const h=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!h};this.d(v.State.Downloading(D)),this.e={packagePath:s},h?this.k.target==="user"?this.p():this.d(v.State.Downloaded(D)):this.d(v.State.Ready(D))}};pe([P.memoize],a.prototype,"cachePath",null),a=pe([ee(0,p.ILifecycleMainService),ee(1,y.IConfigurationService),ee(2,I.ITelemetryService),ee(3,u.IEnvironmentMainService),ee(4,C.IRequestService),ee(5,f.ILogService),ee(6,d.IFileService),ee(7,l.INativeHostMainService),ee(8,w.IProductService)],a),e.Win32UpdateService=a}),define(ie[271],re([0,1,14,8,22,45,3,34,2,15,9,73,4,7,172,62,18,57,27,61,16,21,6,19,64,235,75,29,240,66,74,32,28,53,116,121,37,36,52,58,237,112,51,90,25,113]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w,C,I,v,i,r,n,o,a,c,s,h,D,L,T,F,G,V,K,_,se,ce,X,ue,z,N,U,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(x){x[x.NONE=0]="NONE",x[x.NAVIGATING=1]="NAVIGATING",x[x.READY=2]="READY"})(Q||(Q={}));let oe=class gt extends g.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const R=this.O.profiles.find(O=>O.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&R?R:this.O.getProfileForWorkspace(this.config.workspace??(0,T.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.O.defaultProfile}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(R,O,W,j,$,Y,B,Z,te,ae,ge,ke,Oe,De,Me,ve,we,ye,Re,ne){super(),this.L=O,this.M=W,this.N=j,this.O=$,this.P=Y,this.Q=B,this.R=Z,this.S=te,this.U=ae,this.W=ge,this.X=ke,this.Y=Oe,this.Z=De,this.ab=Me,this.bb=ve,this.db=we,this.eb=ye,this.fb=Re,this.gb=ne,this.c=this.B(new A.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new A.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new A.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new A.Emitter),this.onDidClose=this.h.event,this.j=this.B(new A.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.db.createIPCObjectUrl()),this.J=!1,this.hb=0;{const[fe,de]=this.sb(R.state);this.r=fe,this.L.trace("window#ctor: using window state",fe);const be=this.r.mode===0||this.r.mode===3;typeof gt.b>"u"&&(gt.b=this.fb.getItem("window.experimental.useSandbox",!1));const Pe=this.S.getValue("window");let We=!1;typeof Pe?.experimental?.useSandbox=="boolean"?We=Pe.experimental.useSandbox:this.bb.quality==="stable"&&gt.b?We=!0:We=typeof this.bb.quality=="string"&&this.bb.quality!=="stable";const Te={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.U.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!be,title:this.bb.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(Pe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...We?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?Te.icon=(0,b.join)(this.M.appRoot,"resources/linux/code.png"):y.isWindows&&!this.M.isBuilt&&(Te.icon=(0,b.join)(this.M.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.zb()&&(Te.fullscreenable=!1),y.isMacintosh&&(Te.acceptFirstMouse=!0,Pe?.clickThroughInactive===!1&&(Te.acceptFirstMouse=!1));const qe=y.isMacintosh&&Pe?.nativeTabs===!0;qe&&(Te.tabbingIdentifier=this.bb.nameShort);const Ue=(0,D.getTitleBarStyle)(this.S)==="custom";if(Ue&&(Te.titleBarStyle="hidden",y.isMacintosh||(Te.frame=!1),(0,D.useWindowControlsOverlay)(this.S))){const je=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Xe=V.Color.fromHex(je).isDarker()?"#FFFFFF":"#000000";Te.titleBarOverlay={height:29,color:je,symbolColor:Xe},this.z=!0}if((0,S.mark)("code/willCreateCodeBrowserWindow"),this.l=new E.BrowserWindow(Te),(0,S.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,y.isMacintosh&&Ue&&this.l.setSheetOffset(22),Ue&&(y.isWindows&&(0,D.useWindowControlsOverlay)(this.S)||y.isMacintosh)){const je=this.fb.getItem(gt.a);je&&this.updateWindowControls({height:je})}y.isWindows&&Ue&&this.l.hookWindowMessage(278,()=>{const[Xe,$e]=this.l.getPosition(),Ke=E.screen.getCursorScreenPoint(),J=Ke.x-Xe,le=Ke.y-$e;return(()=>!(J>30&&le>=0&&le<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:J,y:le})),0}),(y.isMacintosh||y.isWindows)&&de&&(!qe||E.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(je=>typeof je=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),be&&((0,S.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.vb(!0),this.l.show(),(0,S.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.M.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.pb(),this.Db(),this.ib()}setRepresentedFilename(R){y.isMacintosh?this.l.setRepresentedFilename(R):this.v=R}getRepresentedFilename(){return y.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(R){y.isMacintosh&&this.l.setDocumentEdited(R),this.w=R}isDocumentEdited(){return y.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(R){y.isMacintosh&&R?.force&&E.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.hb=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(R=>{if(this.isReady)return R(this);this.C.push(R)})}get isReady(){return this.hb===2}get whenClosedOrLoaded(){return new Promise(R=>{function O(){W.dispose(),j.dispose(),R()}const W=this.onDidClose(()=>O()),j=this.onWillLoad(()=>O())})}ib(){this.l.on("unresponsive",()=>this.lb(1)),this.l.webContents.on("render-process-gone",(O,W)=>this.lb(2,W)),this.l.webContents.on("did-fail-load",(O,W,j)=>this.lb(3,{reason:j,exitCode:W})),this.l.webContents.on("will-prevent-unload",O=>{O.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",O=>{this.n&&(this.n.maximized=!0),E.app.emit("browser-window-maximize",O,this.l)}),this.l.on("unmaximize",O=>{this.n&&(this.n.maximized=!1),E.app.emit("browser-window-unmaximize",O,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.S.onDidChangeConfiguration(O=>this.pb(O))),this.B(this.W.onDidDeleteUntitledWorkspace(O=>this.ob(O)));const R=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:R},async(O,W)=>{const j=await this.kb();W({cancel:!1,requestHeaders:Object.assign(O.requestHeaders,j)})})}kb(){return this.jb||(this.jb=(0,o.resolveMarketplaceHeaders)(this.bb.version,this.bb,this.M,this.S,this.P,this.Q,this.Y)),this.jb}async lb(R,O){switch(R){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:R,reason:O?.reason,code:O?.exitCode}),R){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ab.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.ab.quit();return}if(R===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const W=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.n?.workspace?(0,d.localize)(5,null):void 0},this.l);if(W.response!==1){const j=W.response===0;await this.nb(j,W.checkboxChecked)}}else if(R===2)if(y.isWindows&&O?.reason==="launch-failed"&&O.exitCode===18&&await this.gb.isAdmin(void 0))await this.mb(O);else{let W;O?W=(0,d.localize)(7,null,O.reason,O.exitCode??"<unknown>"):W=(0,d.localize)(6,null);const j=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[this.n?.workspace?(0,P.mnemonicButtonLabel)((0,d.localize)(8,null)):(0,P.mnemonicButtonLabel)((0,d.localize)(9,null)),(0,P.mnemonicButtonLabel)((0,d.localize)(10,null))],message:W,detail:this.n?.workspace?(0,d.localize)(11,null):(0,d.localize)(12,null),noLink:!0,defaultId:0,checkboxLabel:this.n?.workspace?(0,d.localize)(13,null):void 0},this.l),$=j.response===0;await this.nb($,j.checkboxChecked)}break}}async mb(R){const O=[],W=(0,z.isInternalTelemetry)(this.bb,this.S);if((0,z.supportsTelemetry)(this.bb,this.M)){this.bb.aiConfig&&this.bb.aiConfig.ariaKey&&O.push(new X.OneDataSystemAppender(W,"monacoworkbench",null,this.bb.aiConfig.ariaKey));const{installSourcePath:$}=this.M,Y=await(0,q.resolveMachineId)(this.fb),B={appenders:O,sendErrorTelemetry:!1,commonProperties:(0,N.resolveCommonProperties)(this.P,(0,U.release)(),(0,U.hostname)(),process.arch,this.bb.commit,this.bb.version,Y,W,$),piiPaths:(0,z.getPiiPathsFromEnvironment)(this.M)};await new ue.TelemetryService(B,this.S,this.bb).publicLog2("windowadminerror",{reason:R.reason,code:R.exitCode})}(await this.Z.showMessageBox({title:this.bb.nameLong,type:"error",buttons:[(0,P.mnemonicButtonLabel)((0,d.localize)(14,null)),(0,P.mnemonicButtonLabel)((0,d.localize)(15,null))],message:(0,d.localize)(16,null),detail:(0,d.localize)(17,null,this.bb.nameLong),noLink:!0,defaultId:0},this.l)).response===0&&await this.gb.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(O.map($=>$.flush())),await this.nb(!1,!1)}async nb(R,O){const W=this.n?.workspace;if(O&&W)try{const j=this.R.workspaceStorage(W);await j.init(),j.delete("memento/workbench.parts.editor"),await j.close()}catch(j){this.L.error(j)}if(this.j.fire(),this.l?.destroy(),R&&this.n){let j,$;(0,T.isSingleFolderWorkspaceIdentifier)(W)?j={folderUri:W.uri}:(0,T.isWorkspaceIdentifier)(W)?j={workspaceUri:W.configPath}:$=!0;const[Y]=await this.eb.open({context:5,userEnv:this.n.userEnv,cli:{...this.M.args,_:[]},urisToOpen:j?[j]:void 0,forceEmpty:$,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});Y.focus()}}ob(R){this.n?.workspace?.id===R.id&&(this.n.workspace=void 0)}pb(R){const O=this.Ab();O!==this.s&&(this.s=O,this.Bb(O));let W=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;W?.endsWith("/")&&(W=W.substr(0,W.length-1));const j=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((W||"").indexOf("@")===-1&&(W!==this.F||j!==this.G)){this.F=W,this.G=j;const $=W||"",Y=j?`${j},<local>`:"<local>";this.L.trace(`Setting proxy to '${$}', bypassing '${Y}'`),this.l.webContents.session.setProxy({proxyRules:$,proxyBypassRules:Y,pacScript:""})}}addTabbedWindow(R){y.isMacintosh&&R.win&&this.l.addTabbedWindow(R.win)}load(R,O=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!O.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),O.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.bb.nameLong)),this.qb(R,O),this.hb===0?this.n=R:this.I=R,this.hb=1,this.l.loadURL(m.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const W=this.J;this.J=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new t.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:R.workspace,reason:O.isReload?3:W?2:1})}qb(R,O){const W=(this.n??this.I)?.userEnv;if(W){const j=(0,C.isLaunchedFromCli)(W)&&!(0,C.isLaunchedFromCli)(R.userEnv),$=this.isExtensionDevelopmentHost;(j||$)&&(R.userEnv={...W,...R.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(R.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),O.disableExtensions!==void 0&&(R["disable-extensions"]=O.disableExtensions),R.fullscreen=this.isFullScreen,R.maximized=this.l.isMaximized(),R.partsSplash=this.U.getWindowSplash(),(0,S.mark)("code/willOpenNewWindow"),R.perfMarks=(0,S.getMarks)(),this.H.update(R)}async reload(R){const O=Object.assign({},this.n);O.workspace=await this.rb(O),delete O.filesToOpenOrCreate,delete O.filesToDiff,delete O.filesToMerge,delete O.filesToWait,this.isExtensionDevelopmentHost&&R&&(O.verbose=R.verbose,O.debugId=R.debugId,O.extensionEnvironment=R.extensionEnvironment,O["inspect-extensions"]=R["inspect-extensions"],O["inspect-brk-extensions"]=R["inspect-brk-extensions"],O["extensions-dir"]=R["extensions-dir"]),O.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),O.isInitialStartup=!1,O.policiesData=this.N.serialize(),O.continueOn=this.M.continueOn,O.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile},O.logLevel=this.L.getLevel(),this.load(O,{isReload:!0,disableExtensions:R?.["disable-extensions"]})}async rb(R){if((0,T.isWorkspaceIdentifier)(R.workspace)){const O=R.workspace.configPath;if(O.scheme===m.Schemas.file&&!await this.P.exists(O))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(R.workspace)){const O=R.workspace.uri;if(O.scheme===m.Schemas.file&&!await this.P.exists(O))return}return R.workspace}serializeWindowState(){if(!this.l)return(0,G.defaultWindowState)();if(this.isFullScreen){let W;try{W=E.screen.getDisplayMatching(this.getBounds())}catch{}const j=(0,G.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.r.width||j.width,height:this.r.height||j.height,x:this.r.x||0,y:this.r.y||0}}const R=Object.create(null);let O;if(!y.isMacintosh&&this.l.isMaximized()?O=0:O=1,O===0?R.mode=0:R.mode=1,O===1||O===0){let W;O===1?W=this.getBounds():W=this.l.getNormalBounds(),R.x=W.x,R.y=W.y,R.width=W.width,R.height=W.height}return R}updateWindowControls(R){if(R.height&&this.fb.setItem(gt.a,R.height),y.isWindows&&this.z)this.l.setTitleBarOverlay({color:R.backgroundColor?.trim()===""?void 0:R.backgroundColor,symbolColor:R.foregroundColor?.trim()===""?void 0:R.foregroundColor,height:R.height?R.height-1:void 0});else if(y.isMacintosh&&R.height!==void 0){const O=(R.height-15)/2;this.l.setTrafficLightPosition({x:O,y:O})}}sb(R){(0,S.mark)("code/willRestoreCodeWindowState");let O=!1;if(R)try{const W=E.screen.getAllDisplays();O=W.length>1,R=this.tb(R,W)}catch(W){this.L.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,S.mark)("code/didRestoreCodeWindowState"),[R||(0,G.defaultWindowState)(),O]}tb(R,O){if(this.L.trace(`window#validateWindowState: validating window state on ${O.length} display(s)`,R),typeof R.x!="number"||typeof R.y!="number"||typeof R.width!="number"||typeof R.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(R.width<=0||R.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(O.length===1){const $=this.ub(O[0]);if($){let Y=function(){!R||typeof R.x!="number"||typeof R.y!="number"||!$||(R.x<$.x&&(R.x=$.x),R.y<$.y&&(R.y=$.y))};this.L.trace("window#validateWindowState: 1 monitor working area",$),Y(),R.width>$.width&&(R.width=$.width),R.height>$.height&&(R.height=$.height),R.x>$.x+$.width-128&&(R.x=$.x+$.width-R.width),R.y>$.y+$.height-128&&(R.y=$.y+$.height-R.height),Y()}return R}if(R.display&&R.mode===3){const $=O.find(Y=>Y.id===R.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const Y=(0,G.defaultWindowState)(3);return Y.x=$.bounds.x,Y.y=$.bounds.y,Y}}let W,j;try{W=E.screen.getDisplayMatching({x:R.x,y:R.y,width:R.width,height:R.height}),j=this.ub(W)}catch{}if(W&&j&&R.x+R.width>j.x&&R.y+R.height>j.y&&R.x<j.x+j.width&&R.y<j.y+j.height)return this.L.trace("window#validateWindowState: multi-monitor working area",j),R}ub(R){if(R.workArea.width>0&&R.workArea.height>0)return R.workArea;if(R.bounds.width>0&&R.bounds.height>0)return R.bounds}getBounds(){const[R,O]=this.l.getPosition(),[W,j]=this.l.getSize();return{x:R,y:O,width:W,height:j}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(R){this.zb()?this.wb(R):this.yb(R),this.sendWhenReady(R?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.s&&this.Bb(this.s,!1)}get isFullScreen(){return y.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}wb(R){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.xb(R)}xb(R){y.isMacintosh&&(this.t=R,this.u=new t.DeferredPromise,Promise.race([this.u.p,(0,t.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(R)}yb(R){this.l.isFullScreen()&&this.xb(!1),this.l.setSimpleFullScreen(R),this.l.webContents.focus()}zb(){const R=this.S.getValue("window");return!R||typeof R.nativeFullScreen!="boolean"||R.nativeTabs?!0:R.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Ab(){let R=(0,D.getMenuBarVisibility)(this.S);return["visible","toggle","hidden"].indexOf(R)<0&&(R="classic"),R}Bb(R,O=!0){y.isMacintosh||(R==="toggle"&&O&&this.send("vscode:showInfoMessage",(0,d.localize)(18,null)),R==="hidden"?setTimeout(()=>{this.Cb(R)}):this.Cb(R))}Cb(R){const O=this.isFullScreen;switch(R){case"classic":this.l.setMenuBarVisibility(!O),this.l.autoHideMenuBar=O;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(R,O,...W){this.isReady?this.send(R,...W):this.ready().then(()=>{O.isCancellationRequested||this.send(R,...W)})}send(R,...O){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${R}' for window that is destroyed`);return}try{this.l.webContents.send(R,...O)}catch(W){this.L.warn(`Error sending IPC message to channel '${R}' of window ${this.k}: ${(0,M.toErrorMessage)(W)}`)}}}updateTouchBar(R){!y.isMacintosh||this.D.forEach((O,W)=>{const j=R[W];O.segments=this.Fb(j)})}Db(){if(!!y.isMacintosh){for(let R=0;R<10;R++){const O=this.Eb();this.D.push(O)}this.l.setTouchBar(new E.TouchBar({items:this.D}))}}Eb(R=[]){const O=this.Fb(R),W=new E.TouchBar.TouchBarSegmentedControl({segments:O,mode:"buttons",segmentStyle:"automatic",change:j=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:W.segments[j].id,from:"touchbar"})}});return W}Fb(R=[]){return R.map(W=>{let j;W.icon&&!s.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===m.Schemas.file&&(j=E.nativeImage.createFromPath(u.URI.revive(W.icon.dark).fsPath),j.isEmpty()&&(j=void 0));let $;return typeof W.title=="string"?$=W.title:$=W.title.value,{id:W.id,label:j?void 0:$,icon:j}})}dispose(){super.dispose(),this.l=null}};oe.a="windowControlHeight",oe.b=void 0,oe=pe([ee(1,i.ILogService),ee(2,w.IEnvironmentMainService),ee(3,K.IPolicyService),ee(4,se.IUserDataProfilesMainService),ee(5,I.IFileService),ee(6,a.IApplicationStorageMainService),ee(7,a.IStorageMainService),ee(8,f.IConfigurationService),ee(9,h.IThemeMainService),ee(10,F.IWorkspacesManagementMainService),ee(11,p.IBackupMainService),ee(12,c.ITelemetryService),ee(13,l.IDialogMainService),ee(14,v.ILifecycleMainService),ee(15,r.IProductService),ee(16,n.IProtocolMainService),ee(17,L.IWindowsMainService),ee(18,_.IStateMainService),ee(19,ce.INativeHostMainService)],oe),e.CodeWindow=oe}),define(ie[76],re([0,1,14,24,8,3,34,2,15,4,20,7,23,175,5,21,6,75,94,28,53,39]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w,C,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let i=class rt extends P.Disposable{constructor(n,o,a,c){super(),this.f=n,this.g=o,this.h=a,this.j=c,this.c=this.B(new M.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new k.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let o=[],a=[];for(const s of n)if((0,w.isRecentWorkspace)(s))!this.g.isUntitledWorkspace(s.workspace)&&!this.r(o,s.workspace)&&o.push(s);else if((0,w.isRecentFolder)(s))this.s(o,s.folderUri)||o.push(s);else{const h=this.t(a,s.fileUri),D=s.fileUri.scheme===g.Schemas.file&&rt.y.indexOf((0,b.basename)(s.fileUri))>=0;!h&&!D&&(a.push(s),m.isWindows&&s.fileUri.scheme===g.Schemas.file&&E.app.addRecentDocument(s.fileUri.fsPath))}const c=await this.l({workspaces:o,files:a});o=c.workspaces,a=c.files,o.length>rt.a&&(o.length=rt.a),a.length>rt.a&&(a.length=rt.a),await this.n({workspaces:o,files:a}),this.c.fire(),m.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(n){const o=h=>{const D=this.p(h);for(const L of n)if(b.extUriBiasedIgnorePathCase.isEqual(L,D))return!1;return!0},a=await this.getRecentlyOpened(),c=a.workspaces.filter(o),s=a.files.filter(o);(c.length!==a.workspaces.length||s.length!==a.files.length)&&(await this.n({files:s,workspaces:c}),this.c.fire(),m.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(n){const o=new v.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s));if(n?.workspaces)for(const s of n.workspaces)o.set(this.p(s),s);const a=new v.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s));if(n?.files)for(const s of n.files)a.set(this.p(s),s);const c=await this.m();for(const s of c.workspaces){const h=o.get(this.p(s));h?h.label=h.label??s.label:o.set(this.p(s),s)}for(const s of c.files){const h=a.get(this.p(s));h?h.label=h.label??s.label:a.set(this.p(s),s)}return{workspaces:[...o.values()],files:[...a.values()]}}async m(){await this.j.whenReady;let n;const o=this.j.get(rt.b,-1);if(typeof o=="string")try{n=JSON.parse(o)}catch(a){this.f.error("Unexpected error parsing opened paths list",a)}return(0,w.restoreRecentlyOpened)(n,this.f)}async n(n){await this.j.whenReady,this.j.store(rt.b,JSON.stringify((0,w.toStoreData)(n)),-1,1)}p(n){return(0,w.isRecentFolder)(n)?n.folderUri:(0,w.isRecentFile)(n)?n.fileUri:n.workspace.configPath}r(n,o){return!!n.find(a=>(0,w.isRecentWorkspace)(a)&&a.workspace.id===o.id)}s(n,o){return!!n.find(a=>(0,w.isRecentFolder)(a)&&b.extUriBiasedIgnorePathCase.isEqual(a.folderUri,o))}t(n,o){return!!n.find(a=>b.extUriBiasedIgnorePathCase.isEqual(a.fileUri,o))}async C(){!m.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!m.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(0,null),description:(0,u.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const o=[];for(const s of E.app.getJumpListSettings().removedItems){const h=s.args;if(h){const D=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);D&&o.push(S.URI.parse(D[2]))}}await this.removeRecentlyOpened(o);let a=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.w).map(s=>{const h=(0,w.isRecentWorkspace)(s)?s.workspace:s.folderUri,{title:D,description:L}=this.F(h,s.label);let T;return S.URI.isUri(h)?T=`--folder-uri "${h.toString()}"`:(a=!0,T=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:D.substr(0,255),description:L.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&n.push({type:"custom",name:a?(0,u.localize)(2,null):(0,u.localize)(3,null),items:c})}n.push({type:"recent"});try{const o=E.app.setJumpList(n);o&&o!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${o}`)}catch(o){this.f.warn("updateWindowsJumpList#setJumpList",o)}}F(n,o){if(o)return{title:(0,A.splitName)(o).name,description:o};if(S.URI.isUri(n))return{title:(0,b.basename)(n),description:this.G(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,u.localize)(4,null),description:""};let a=(0,b.basename)(n.configPath);return a.endsWith(C.WORKSPACE_EXTENSION)&&(a=a.substr(0,a.length-C.WORKSPACE_EXTENSION.length-1)),{title:(0,u.localize)(5,null,a),description:this.G(n.configPath)}}G(n){return n.scheme==="file"?(0,A.normalizeDriveLetter)(n.fsPath):n.toString()}async H(){if(!m.isMacintosh)return;E.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),o=[];let a=0;for(let s=0;s<n.workspaces.length&&a<rt.u;s++){const h=this.p(n.workspaces[s]);if(h.scheme===g.Schemas.file){const D=(0,b.originalFSPath)(h);await y.Promises.exists(D)&&(o.push(D),a++)}}const c=[];for(let s=0;s<n.files.length&&a<rt.v;s++){const h=this.p(n.files[s]);if(h.scheme===g.Schemas.file){const D=(0,b.originalFSPath)(h);if(rt.y.includes((0,b.basename)(h))||o.includes(D))continue;await y.Promises.exists(D)&&(c.push(D),a++)}}c.reverse().forEach(s=>E.app.addRecentDocument(s)),o.reverse().forEach(s=>E.app.addRecentDocument(s))}};i.a=500,i.b="history.recentlyOpenedPathsList",i.u=7,i.v=10,i.w=7,i.y=["COMMIT_EDITMSG","MERGE_MSG"],i=pe([ee(0,f.ILogService),ee(1,I.IWorkspacesManagementMainService),ee(2,p.ILifecycleMainService),ee(3,l.IApplicationStorageMainService)],i),e.WorkspacesHistoryMainService=i}),define(ie[272],re([0,1,14,8,22,34,4,7,165,18,27,21,6,213,58,19,36,29,49,74,32,76]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w,C,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let r=class Ft{constructor(a,c,s,h,D,L,T,F,G,V,K){this.n=a,this.o=c,this.p=s,this.q=h,this.r=D,this.s=L,this.t=T,this.u=F,this.v=G,this.w=V,this.x=K,this.m=Object.create(null),this.g=new t.RunOnceScheduler(()=>this.E(),0),this.h=new t.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.isMacintosh||(0,C.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const a=this.t.getItem(Ft.a);a&&(a.menus&&(this.k=a.menus),a.keybindings&&(this.l=a.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(L,T,F)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.newWindow"]=(L,T,F)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(L,T,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(F),telemetryExtraData:{from:i}}),this.m["workbench.action.files.openFolder"]=(L,T,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(F),telemetryExtraData:{from:i}}),this.m["workbench.action.openWorkspace"]=(L,T,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(F),telemetryExtraData:{from:i}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const a=this.x.twitterUrl;a&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(a,"openTwitterUrl"));const c=this.x.requestFeatureUrl;c&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(c,"openUserVoiceUrl"));const s=this.x.reportIssueUrl;s&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(s,"openReportIssues"));const h=this.x.licenseUrl;h&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.language){const L=h.indexOf("?")>0?"&":"?";this.Z(`${h}${L}lang=${A.language}`,"openLicenseUrl")}else this.Z(h,"openLicenseUrl")});const D=this.x.privacyStatementUrl;D&&h&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(D,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(a=>this.F(a)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const a=this.o.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get C(){if(!A.isMacintosh)return!1;const a=this.o.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,c){this.k=a.menus,this.l=a.keybindings,this.t.setItem(Ft.a,a),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(a){!A.isMacintosh||(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.d=a.newCount===0,this.D())}G(){!A.isMacintosh||(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const a=E.Menu.getApplicationMenu();if(a&&this.j.push(a),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(A.isMacintosh?new E.Menu:null);return}const c=new E.Menu;let s;if(A.isMacintosh){const D=new E.Menu;s=new E.MenuItem({label:this.x.nameShort,submenu:D}),this.I(D),c.append(s)}if(A.isMacintosh&&!this.c){this.c=!0;const D=new E.Menu;D.append(new E.MenuItem({label:this.bb(g.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(D)}if(this.K("File")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(1,null)),submenu:D});this.M(D,"File"),c.append(L)}if(this.K("Edit")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(2,null)),submenu:D});this.M(D,"Edit"),c.append(L)}if(this.K("Selection")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(3,null)),submenu:D});this.M(D,"Selection"),c.append(L)}if(this.K("View")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(4,null)),submenu:D});this.M(D,"View"),c.append(L)}if(this.K("Go")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(5,null)),submenu:D});this.M(D,"Go"),c.append(L)}if(this.K("Run")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(6,null)),submenu:D});this.M(D,"Run"),c.append(L)}if(this.K("Terminal")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(7,null)),submenu:D});this.M(D,"Terminal"),c.append(L)}let h;if(this.K("Window")){const D=new E.Menu;h=new E.MenuItem({label:this.bb(g.localize(8,null)),submenu:D,role:"window"}),this.S(D)}if(h&&c.append(h),this.K("Help")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(9,null)),submenu:D,role:"help"});this.M(D,"Help"),c.append(L)}c.items&&c.items.length>0?E.Menu.setApplicationMenu(c):E.Menu.setApplicationMenu(null),this.h.schedule()}I(a){const c=this.U(g.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),s=this.T();let h;if(this.K("Preferences")){const _=new E.Menu;this.M(_,"Preferences"),h=new E.MenuItem({label:this.bb(g.localize(11,null)),submenu:_})}const D=new E.Menu,L=new E.MenuItem({label:g.localize(12,null),role:"services",submenu:D}),T=new E.MenuItem({label:g.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new E.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),G=new E.MenuItem({label:g.localize(15,null),role:"unhide"}),V=new E.MenuItem(this.Y("workbench.action.quit",{label:g.localize(16,null,this.x.nameLong),click:async(_,se,ce)=>{const X=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||X?.isMinimized())&&await this.J(ce)&&this.w.quit(void 0)}})),K=[c];K.push(...s),h&&K.push(n(),h),K.push(n(),L,n(),T,F,G,n(),V),K.forEach(_=>a.append(_))}async J(a){if(this.p.getWindowCount()===0)return!0;const c=this.o.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.Q(a)){const s={title:this.x.nameLong,type:"question",buttons:[(0,M.mnemonicButtonLabel)(g.localize(17,null)),(0,M.mnemonicButtonLabel)(g.localize(18,null))],message:g.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:h}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,s);return h===0}return!0}K(a){if(!A.isMacintosh&&(0,C.getTitleBarStyle)(this.o)==="custom")return!1;switch(a){case"File":case"Help":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[a];case"Window":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[a]}}L(a,c){c.forEach(s=>{if((0,u.isMenubarMenuItemSeparator)(s))a.append(n());else if((0,u.isMenubarMenuItemSubmenu)(s)){const h=new E.Menu,D=new E.MenuItem({label:this.bb(s.label),submenu:h});this.L(h,s.submenu.items),a.append(D)}else(0,u.isMenubarMenuItemRecentAction)(s)?a.append(this.O(s)):(0,u.isMenubarMenuItemAction)(s)&&(s.id==="workbench.action.showAboutDialog"&&this.N(a),A.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[s.id]?a.append(new E.MenuItem(this.Y(s.id,{label:this.bb(s.label),click:this.m[s.id]}))):a.append(this.U(s.label,s.id,!1,s.checked)):a.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)):a.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)))})}M(a,c){this.k&&this.k[c]&&this.L(a,this.k[c].items)}N(a){const c=this.T();c.length&&(c.forEach(s=>a.append(s)),a.append(n()))}O(a){const c=P.URI.revive(a.uri),s=a.id,h=s==="openRecentFile"?{fileUri:c}:s==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new E.MenuItem(this.Y(s,{label:a.label,click:async(D,L,T)=>{const F=this.P(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[h],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:a.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([c])}},!1))}P(a){return!!(a&&(!A.isMacintosh&&(a.ctrlKey||a.shiftKey)||A.isMacintosh&&(a.metaKey||a.altKey)))}Q(a){return!!(a.triggeredByAccelerator||a.altKey||a.ctrlKey||a.metaKey||a.shiftKey)}R(a,c,s){const h={label:this.bb(a),role:s,enabled:!0};return new E.MenuItem(this.X(c,h))}S(a){const c=new E.MenuItem({label:g.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),s=new E.MenuItem({label:g.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),h=new E.MenuItem({label:g.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),D=this.U(g.localize(23,null),"workbench.action.switchWindow"),L=[];this.C&&(L.push(n()),L.push(this.U(g.localize(24,null),"workbench.action.newWindowTab")),L.push(this.R(g.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.R(g.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.R(g.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.R(g.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,s,n(),D,...L,n(),h].forEach(T=>a.append(T))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.bb(g.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:g.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.bb(g.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:g.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.bb(g.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:g.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.bb(g.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(a,c,s,h){const D=this.bb(a),L=typeof c=="function"?c:(K,_,se)=>{const ce=K?K.userSettingsLabel:null;let X=c;Array.isArray(c)&&(X=this.P(se)?c[1]:c[0]),ce&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ce}):this.W({type:"commandId",commandId:X})},T=typeof s=="boolean"?s:this.p.getWindowCount()>0,F=typeof h=="boolean"?h:!1,G={label:D,click:L,enabled:T};F&&(G.type="checkbox",G.checked=F);let V;return typeof c=="string"?V=c:Array.isArray(c)&&(V=c[0]),A.isMacintosh&&(V==="editor.action.clipboardCutAction"?G.role="cut":V==="editor.action.clipboardCopyAction"?G.role="copy":V==="editor.action.clipboardPasteAction"&&(G.role="paste"),V==="undo"?G.click=this.V(L,{inDevTools:K=>K.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):V==="redo"?G.click=this.V(L,{inDevTools:K=>K.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):V==="editor.action.selectAll"&&(G.click=this.V(L,{inDevTools:K=>K.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(V,G))}V(a,c){return(s,h,D)=>{const L=E.BrowserWindow.getFocusedWindow();if(!L)return c.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return c.inDevTools(L.webContents.devToolsWebContents);a(s,h||L,D)}}W(a){let c=E.BrowserWindow.getFocusedWindow();if(!c){const h=this.p.getLastActiveWindow();h?.isMinimized()&&(c=h.win)}const s=c?this.p.getWindowById(c.id):void 0;if(s){if(this.v.trace("menubar#runActionInRenderer",a),A.isMacintosh&&!this.q.isBuilt&&!s.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const h={id:a.commandId,from:"menu"};s.sendWhenReady("vscode:runAction",k.CancellationToken.None,h)}else{const h={userSettingsLabel:a.userSettingsLabel};s.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,h)}}else this.v.trace("menubar#runActionInRenderer: no active window found",a)}X(a,c){const s=typeof a=="string"?this.l[a]:void 0;if(s?.label){if(s.isNative!==!1)c.accelerator=s.label,c.userSettingsLabel=s.userSettingsLabel;else if(typeof c.label=="string"){const h=c.label.indexOf("[");h>=0?c.label=`${c.label.substr(0,h)} [${s.label}]`:c.label=`${c.label} [${s.label}]`}}else c.accelerator=void 0;return c}Y(a,c,s=!c.accelerator){s&&(c=this.X(a,c));const h=c.click;return c.click=(D,L,T)=>{this.ab(a),h?.(D,L,T)},c}Z(a,c){this.w.openExternal(void 0,a),this.ab(c)}ab(a){this.r.publicLog2("workbenchActionExecuted",{id:a,from:i})}bb(a){return(0,M.mnemonicMenuLabel)(a,!this.B)}};r.a="lastKnownMenubarData",r=pe([ee(0,w.IUpdateService),ee(1,m.IConfigurationService),ee(2,I.IWindowsMainService),ee(3,b.IEnvironmentMainService),ee(4,l.ITelemetryService),ee(5,v.IWorkspacesHistoryMainService),ee(6,f.IStateMainService),ee(7,S.ILifecycleMainService),ee(8,y.ILogService),ee(9,d.INativeHostMainService),ee(10,p.IProductService)],r),e.Menubar=r;function n(){return new E.MenuItem({type:"separator"})}}),define(ie[273],re([0,1,5,21,6,272]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let A=class{constructor(g,m,b){this.b=g,this.c=m,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.Menubar)}async updateMenubar(g,m){this.d.trace("menubarService#updateMenubar",g),(await this.a).updateMenu(m,g)}};A=pe([ee(0,E.IInstantiationService),ee(1,t.ILifecycleMainService),ee(2,k.ILogService)],A),e.MenubarMainService=A}),define(ie[274],re([0,1,14,23,25,24,22,3,31,50,34,2,15,9,73,4,33,20,11,7,173,62,18,57,27,16,5,21,6,63,19,64,55,36,74,271,118,266,28,95,76,53,66,37,52]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w,C,I,v,i,r,n,o,a,c,s,h,D,L,T,F,G,V,K,_,se,ce,X,ue,z,N,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function q(x){return(0,se.isWorkspaceIdentifier)(x?.workspace)}function Q(x){return(0,se.isSingleFolderWorkspaceIdentifier)(x?.workspace)}let oe=class mt extends S.Disposable{constructor(R,O,W,j,$,Y,B,Z,te,ae,ge,ke,Oe,De,Me,ve,we,ye){super(),this.k=R,this.l=O,this.m=W,this.n=j,this.r=$,this.s=Y,this.t=B,this.u=Z,this.v=te,this.w=ae,this.z=ge,this.C=ke,this.D=Oe,this.F=De,this.G=Me,this.H=ve,this.I=we,this.J=ye,this.b=this.B(new P.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new P.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new P.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new P.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new P.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new _.WindowsStateHandler(this,this.n,this.u,this.m,this.w)),this.L()}L(){this.B(this.C.onDidEnterWorkspace(R=>this.c.fire(R.window))),this.B(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const O=new S.DisposableStore;if(O.add(P.Event.any(R.onDidClose,R.onDidDestroy)(()=>O.dispose())),R.config.extensionDevelopmentPath)for(const W of R.config.extensionDevelopmentPath)O.add(this.I.addValidFileRoot(W));R.config.extensionTestsPath&&O.add(this.I.addValidFileRoot(R.config.extensionTestsPath))}}))}openEmptyWindow(R,O){const W=this.s.args,j=O?.remoteAuthority||void 0,$=!0,Y=O?.forceReuseWindow,B=!Y;return this.open({...R,cli:W,forceEmpty:$,forceNewWindow:B,forceReuseWindow:Y,remoteAuthority:j})}openExistingWindow(R,O){R.focus(),this.M(O,[R])}async open(R){this.m.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const O=[],W=[],j=[],$=[],Y=[];let B,Z=0;const te=await this.S(R);this.m.trace("windowsManager#open pathsToOpen",te);for(const De of te)Q(De)?R.addMode?O.push(De):W.push(De):q(De)?j.push(De):De.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),B.filesToOpenOrCreate.push(De)):De.backupPath?Y.push({backupFolder:(0,u.basename)(De.backupPath),remoteAuthority:De.remoteAuthority}):Z++;R.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),R.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&R.waitMarkerFileURI&&(B.filesToWait={paths:(0,M.coalesce)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?($.push(...this.C.getUntitledWorkspaces()),j.push(...$),Y.push(...this.v.getEmptyWindowBackups())):Y.length=0;const{windows:ae,filesOpenedInWindow:ge}=await this.N(R,j,W,Y,Z,B,O);if(this.m.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${j.length}, foldersToOpen: ${W.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${Z})`),ae.length>1)if(ge)ge.focus();else{const De=this.j.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let Me=!0,ve=!0;if(De){const we=ae.filter(ye=>this.j.state.lastActiveWindow&&ye.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Me=!1,ve=!1)}if(Me)for(let we=ae.length-1;we>=0;we--){const ye=ae[we];if(!(ye.openedWorkspace&&$.some(Re=>ye.openedWorkspace&&Re.workspace.id===ye.openedWorkspace.id)||ye.backupPath&&Y.some(Re=>ye.backupPath&&Re.backupFolder===(0,u.basename)(ye.backupPath)))){ye.focus(),ve=!1;break}}ve&&ae[ae.length-1].focus()}const ke=B&&B.filesToDiff.length>0,Oe=B&&B.filesToMerge.length>0;if(!ae.some(De=>De.isExtensionDevelopmentHost)&&!ke&&!Oe&&!R.noRecentEntry){const De=[];for(const Me of te)q(Me)&&!Me.transient?De.push({label:Me.label,workspace:Me.workspace,remoteAuthority:Me.remoteAuthority}):Q(Me)?De.push({label:Me.label,folderUri:Me.workspace.uri,remoteAuthority:Me.remoteAuthority}):Me.fileUri&&De.push({label:Me.label,fileUri:Me.fileUri,remoteAuthority:Me.remoteAuthority});this.z.addRecentlyOpened(De)}return this.M(R,ae),ae}M(R,O){const W=R.waitMarkerFileURI;R.context===0&&W&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.G.del(W)}catch{}})()}async N(R,O,W,j,$,Y,B){const Z=[];let te;function ae(we,ye){Z.push(we),ye&&(te=we,Y=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:ke}=this.fb(R);if(!R.initialStartup&&B.length>0){const we=B[0].remoteAuthority,ye=this.kb(we);ye&&ae(this.P(ye,B.map(Re=>Re.workspace.uri)))}const Oe=W.length+O.length+j.length;if(Y&&Oe===0){const we=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0]||Y.filesToMerge[3],ye=this.getWindows().filter(ne=>Y&&(0,l.isEqualAuthority)(ne.remoteAuthority,Y.remoteAuthority));let Re;we?.fileUri&&!ke&&((R.context===4||R.context===0||R.context===1)&&(Re=await(0,K.findWindowOnFile)(ye,we.fileUri,async ne=>ne.configPath.scheme===y.Schemas.file?this.C.resolveLocalWorkspace(ne.configPath):void 0)),Re||(Re=this.lb(ye))),Re?(0,se.isWorkspaceIdentifier)(Re.openedWorkspace)?O.push({workspace:Re.openedWorkspace,remoteAuthority:Re.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Re.openedWorkspace)?W.push({workspace:Re.openedWorkspace,remoteAuthority:Re.remoteAuthority}):ae(this.O(R,Re,Y),!0):ae(await this.gb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile}),!0)}const De=(0,M.distinct)(O,we=>we.workspace.id);if(De.length>0){const we=(0,M.coalesce)(De.map(ye=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.configPath)));if(we.length>0){const ye=we[0],Re=(0,l.isEqualAuthority)(Y?.remoteAuthority,ye.remoteAuthority)?Y:void 0;ae(this.O(R,ye,Re),!!Re),ge=!0}for(const ye of De){if(we.some(fe=>fe.openedWorkspace&&fe.openedWorkspace.id===ye.workspace.id))continue;const Re=ye.remoteAuthority,ne=(0,l.isEqualAuthority)(Y?.remoteAuthority,Re)?Y:void 0;ae(await this.R(R,ye,ge,ne),!!ne),ge=!0}}const Me=(0,M.distinct)(W,we=>l.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Me.length>0){const we=(0,M.coalesce)(Me.map(ye=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.uri)));if(we.length>0){const ye=we[0],Re=(0,l.isEqualAuthority)(Y?.remoteAuthority,ye.remoteAuthority)?Y:void 0;ae(this.O(R,ye,Re),!!Re),ge=!0}for(const ye of Me){if(we.some(fe=>(0,se.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)&&l.extUriBiasedIgnorePathCase.isEqual(fe.openedWorkspace.uri,ye.workspace.uri)))continue;const Re=ye.remoteAuthority,ne=(0,l.isEqualAuthority)(Y?.remoteAuthority,Re)?Y:void 0;ae(await this.R(R,ye,ge,ne),!!ne),ge=!0}}const ve=(0,M.distinct)(j,we=>we.backupFolder);if(ve.length>0)for(const we of ve){const ye=we.remoteAuthority,Re=(0,l.isEqualAuthority)(Y?.remoteAuthority,ye)?Y:void 0;ae(await this.Q(R,!0,ye,Re,we),!!Re),ge=!0}if(Z.length===0||Y){Y&&!$&&$++;const we=Y?Y.remoteAuthority:R.remoteAuthority;for(let ye=0;ye<$;ye++)ae(await this.Q(R,ge,we,Y),!!Y),ge=!0}return{windows:(0,M.distinct)(Z),filesOpenedInWindow:te}}O(R,O,W){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),O.focus();const j={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",A.CancellationToken.None,j),O}P(R,O){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),R.focus();const W={foldersToAdd:O};return R.sendWhenReady("vscode:addFolders",A.CancellationToken.None,W),R}Q(R,O,W,j,$){this.m.trace("windowsManager#doOpenEmpty",{restore:!!$,remoteAuthority:W,filesToOpen:j,forceNewWindow:O});let Y;return!O&&typeof R.contextWindowId=="number"&&(Y=this.getWindowById(R.contextWindowId)),this.gb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:W,forceNewWindow:O,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:j,windowToUse:Y,emptyWindowBackupInfo:$,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}R(R,O,W,j,$){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:j}),!W&&!$&&typeof R.contextWindowId=="number"&&($=this.getWindowById(R.contextWindowId)),this.gb({workspace:O.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:j,windowToUse:$,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}async S(R){let O,W=!1,j=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(O=await this.U(R),W=!0):R.forceEmpty?O=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(O=await this.W(R.cli),O.length===0&&O.push(Object.create(null)),W=!0):(O=await this.Y(),O.length===0&&O.push(Object.create(null)),j=!0),!R.addMode&&W){const $=O.filter(Y=>Q(Y));if($.length>1){const Y=$[0].remoteAuthority;if($.every(B=>(0,l.isEqualAuthority)(B.remoteAuthority,Y))){const B=await this.C.createUntitledWorkspace($.map(Z=>({uri:Z.workspace.uri})));O.push({workspace:B,remoteAuthority:Y}),O=O.filter(Z=>!Q(Z))}}}if(R.initialStartup&&!j&&this.w.getValue("window")?.restoreWindows==="preserve"){const $=await this.Y();O.unshift(...$.filter(Y=>q(Y)||Q(Y)||Y.backupPath))}return O}async U(R){const O={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority},W=await Promise.all((0,M.coalesce)(R.urisToOpen||[]).map(async j=>{const $=await this.ab(j,O);if($)return $.label=j.label,$;const Y=this.cb(j),B={title:this.H.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,I.localize)(0,null))],defaultId:0,message:Y.scheme===y.Schemas.file?(0,I.localize)(1,null):(0,I.localize)(2,null),detail:Y.scheme===y.Schemas.file?(0,I.localize)(3,null,(0,b.getPathLabel)(Y,{os:p.OS,tildify:this.s})):(0,I.localize)(4,null,Y.toString(!0)),noLink:!0};this.F.showMessageBox(B,(0,w.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,M.coalesce)(W)}async W(R){const O=[],W={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:R.diff&&R._.length===2||R.merge&&R._.length===4},j=R["folder-uri"];if(j){const B=await Promise.all(j.map(Z=>{const te=this.X(Z);if(!!te)return this.ab({folderUri:te},W)}));O.push(...(0,M.coalesce)(B))}const $=R["file-uri"];if($){const B=await Promise.all($.map(Z=>{const te=this.X(Z);if(!!te)return this.ab((0,se.hasWorkspaceFileExtension)(Z)?{workspaceUri:te}:{fileUri:te},W)}));O.push(...(0,M.coalesce)(B))}const Y=await Promise.all(R._.map(B=>W.remoteAuthority?this.eb(B,W):this.db(B,W)));return O.push(...(0,M.coalesce)(Y)),O}X(R){try{const O=C.URI.parse(R);if(!O.scheme){this.m.error(`Invalid URI input string, scheme missing: ${R}`);return}return O}catch(O){this.m.error(`Invalid URI input string: ${R}, ${O.message}`)}}async Y(){const R=this.Z();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];R!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const W=await Promise.all(O.map(async j=>{if(j.workspace){const $=await this.ab({workspaceUri:j.workspace.configPath},{remoteAuthority:j.remoteAuthority,rejectTransientWorkspaces:!0});if(q($))return $}else if(j.folderUri){const $=await this.ab({folderUri:j.folderUri},{remoteAuthority:j.remoteAuthority});if(Q($))return $}else if(R!=="folders"&&j.backupPath)return{backupPath:j.backupPath,remoteAuthority:j.remoteAuthority}}));return(0,M.coalesce)(W)}}}Z(){let R;return this.u.wasRestarted?R="all":(R=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}async ab(R,O=Object.create(null)){const W=this.cb(R);return W.scheme===y.Schemas.file?((0,G.isFileToOpen)(R)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.db(W.fsPath,O)):this.bb(R,O)}bb(R,O){let W=this.cb(R);const j=(0,T.getRemoteAuthority)(W)||O.remoteAuthority;if(W=(0,l.removeTrailingPathSeparator)((0,l.normalizePath)(W)),(0,G.isFileToOpen)(R)){if(O.gotoLineMode){const{path:$,line:Y,column:B}=(0,g.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:$}),options:{selection:Y?{startLineNumber:Y,startColumn:B||1}:void 0},remoteAuthority:j}}return{fileUri:W,remoteAuthority:j}}else if((0,G.isWorkspaceToOpen)(R))return{workspace:(0,ce.getWorkspaceIdentifier)(W),remoteAuthority:j};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:j}}cb(R){return(0,G.isWorkspaceToOpen)(R)?R.workspaceUri:(0,G.isFolderToOpen)(R)?R.folderUri:R.fileUri}async db(R,O){let W,j;O.gotoLineMode&&({path:R,line:W,column:j}=(0,g.parseLineAndColumnAware)(R)),R=(0,g.sanitizeFilePath)((0,u.normalize)(R),(0,f.cwd)());try{const $=await t.Promises.stat(R);if($.isFile()){if(!O.forceOpenWorkspaceAsFile){const Y=await this.C.resolveLocalWorkspace(C.URI.file(R));if(Y)return Y.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:Y.id,configPath:Y.configPath},type:o.FileType.File,exists:!0,remoteAuthority:Y.remoteAuthority,transient:Y.transient}}return{fileUri:C.URI.file(R),type:o.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:j||1}:void 0}}}else{if($.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(C.URI.file(R),$),type:o.FileType.Directory,exists:!0};if(!p.isWindows&&R==="/dev/null")return{fileUri:C.URI.file(R),type:o.FileType.File,exists:!0}}}catch{const Y=C.URI.file(R);if(this.z.removeRecentlyOpened([Y]),O.ignoreFileNotFound)return{fileUri:Y,type:o.FileType.File,exists:!1}}}eb(R,O){const W=R.charCodeAt(0),j=O.remoteAuthority;let $,Y;O.gotoLineMode&&({path:R,line:$,column:Y}=(0,g.parseLineAndColumnAware)(R)),W!==47&&((0,g.isWindowsDriveLetter)(W)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,g.toSlashes)(R)),R=`/${R}`);const B=C.URI.from({scheme:y.Schemas.vscodeRemote,authority:j,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(R))return O.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:$?{startLineNumber:$,startColumn:Y||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)(B),remoteAuthority:j};if(O.gotoLineMode||u.posix.basename(R).indexOf(".")!==-1)return{fileUri:B,options:{selection:$?{startLineNumber:$,startColumn:Y||1}:void 0},remoteAuthority:j}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:j}}fb(R){const O=this.w.getValue("window"),W=O?.openFoldersInNewWindow||"default",j=O?.openFilesInNewWindow||"off";let $=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&(W==="on"||W==="off")&&($=W==="on");let Y=!1;return R.forceNewWindow||R.forceReuseWindow?Y=!!R.forceNewWindow&&!R.forceReuseWindow:(p.isMacintosh?R.context===1&&(Y=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!R.cli.extensionDevelopmentPath&&(j==="on"||j==="off")&&(Y=j==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:Y}}async openExtensionDevelopmentHostWindow(R,O){const W=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),R);if(W)return this.u.reload(W,O.cli),W.focus(),[W];let j=O.cli["folder-uri"]||[],$=O.cli["file-uri"]||[],Y=O.cli._;if(!Y.length&&!j.length&&!$.length&&!O.cli.extensionTestsPath){const te=this.j.state.lastPluginDevelopmentHostWindow,ae=te?.workspace??te?.folderUri;ae&&(C.URI.isUri(ae)?ae.scheme===y.Schemas.file?Y=[ae.fsPath]:j=[ae.toString()]:ae.configPath.scheme===y.Schemas.file?Y=[(0,l.originalFSPath)(ae.configPath)]:$=[ae.configPath.toString()])}let B=O.remoteAuthority;for(const te of R)if(te.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=C.URI.parse(te),ge=(0,T.getRemoteAuthority)(ae);ge&&(B?(0,l.isEqualAuthority)(ge,B)||this.m.error("more than one extension development path authority"):B=ge)}Y=Y.filter(te=>{const ae=C.URI.file(te);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:(0,l.isEqualAuthority)((0,T.getRemoteAuthority)(ae),B)}),j=j.filter(te=>{const ae=this.X(te);return ae&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,l.isEqualAuthority)((0,T.getRemoteAuthority)(ae),B):!1}),$=$.filter(te=>{const ae=this.X(te);return ae&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,l.isEqualAuthority)((0,T.getRemoteAuthority)(ae),B):!1}),O.cli._=Y,O.cli["folder-uri"]=j,O.cli["file-uri"]=$;const Z={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!Y.length&&!j.length&&!$.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:B,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(Z)}async gb(R){const O=this.w.getValue("window");let W;!R.forceNewWindow&&!R.forceNewTabbedWindow&&(W=R.windowToUse||this.getLastActiveWindow(),W&&W.focus());const j={...this.s.args,...R.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,u.join)(this.s.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.t.profiles,profile:this.t.defaultProfile},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.l,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToMerge:R.filesToOpen?.filesToMerge,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),logsPath:this.s.logsPath,product:h.default,isInitialStartup:R.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn};if(W){const $=W.config;!j.extensionDevelopmentPath&&$?.extensionDevelopmentPath&&(j.extensionDevelopmentPath=$.extensionDevelopmentPath,j.extensionDevelopmentKind=$.extensionDevelopmentKind,j["enable-proposed-api"]=$["enable-proposed-api"],j.verbose=$.verbose,j["inspect-extensions"]=$["inspect-extensions"],j["inspect-brk-extensions"]=$["inspect-brk-extensions"],j.debugId=$.debugId,j.extensionEnvironment=$.extensionEnvironment,j["extensions-dir"]=$["extensions-dir"],j["disable-extensions"]=$["disable-extensions"])}else{const $=this.j.getNewWindowState(j);(0,d.mark)("code/willCreateCodeWindow");const Y=W=this.D.createInstance(V.CodeWindow,{state:$,extensionDevelopmentPath:j.extensionDevelopmentPath,isExtensionTestHost:!!j.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(Y),mt.a.push(Y),this.b.fire(Y),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(Y.onDidSignalReady)(()=>this.c.fire(Y)),(0,m.once)(Y.onDidClose)(()=>this.jb(Y)),(0,m.once)(Y.onDidDestroy)(()=>this.f.fire(Y)),Y.onDidTriggerSystemContextMenu(({x:Z,y:te})=>this.h.fire({window:Y,x:Z,y:te}));const B=(0,w.assertIsDefined)(Y.win?.webContents);B.removeAllListeners("devtools-reload-page"),B.on("devtools-reload-page",()=>this.u.reload(Y)),this.u.registerWindow(Y)}return j.windowId=W.id,W.isReady?this.u.unload(W,4).then(async $=>{$||await this.hb(W,j,R)}):await this.hb(W,j,R),W}async hb(R,O,W){if(O.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.v.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,ce.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),this.t.isEnabled()){const j=O.workspace??(0,se.toWorkspaceIdentifier)(O.backupPath,!1),$=this.ib(W,j),Y=$ instanceof Promise?await $:$;O.profiles.profile=Y,O.extensionDevelopmentPath||await this.t.setProfileForWorkspace(j,Y)}R.load(O)}ib(R,O){return R.forceProfile?this.t.profiles.find(W=>W.name===R.forceProfile)??this.t.createNamedProfile(R.forceProfile):R.forceTempProfile?this.t.createTransientProfile():this.t.getProfileForWorkspace(O)??this.t.defaultProfile}jb(R){const O=mt.a.indexOf(R);mt.a.splice(O,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=E.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(R){return this.lb(this.getWindows().filter(O=>(0,l.isEqualAuthority)(O.remoteAuthority,R)))}lb(R){const O=Math.max.apply(Math,R.map(W=>W.lastFocusTime));return R.find(W=>W.lastFocusTime===O)}sendToFocused(R,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(R,A.CancellationToken.None,...O)}sendToAll(R,O,W){for(const j of this.getWindows())W&&W.indexOf(j.id)>=0||j.sendWhenReady(R,A.CancellationToken.None,O)}getWindows(){return mt.a}getWindowCount(){return mt.a.length}getWindowById(R){const O=this.getWindows().filter(W=>W.id===R);return(0,M.firstOrDefault)(O)}getWindowByWebContents(R){const O=E.BrowserWindow.fromWebContents(R);if(!!O)return this.getWindowById(O.id)}};oe.a=[],oe=pe([ee(2,s.ILogService),ee(3,F.IStateMainService),ee(4,N.IPolicyService),ee(5,n.IEnvironmentMainService),ee(6,U.IUserDataProfilesMainService),ee(7,c.ILifecycleMainService),ee(8,v.IBackupMainService),ee(9,i.IConfigurationService),ee(10,X.IWorkspacesHistoryMainService),ee(11,ue.IWorkspacesManagementMainService),ee(12,a.IInstantiationService),ee(13,r.IDialogMainService),ee(14,o.IFileService),ee(15,D.IProductService),ee(16,L.IProtocolMainService),ee(17,z.IThemeMainService)],oe),e.WindowsMainService=oe}),define(ie[275],re([0,1,62,32,76,53]),function(H,e,E,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let A=class{constructor(g,m,b,S){this.a=g,this.b=m,this.c=b,this.d=S,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(g,m){const b=this.b.getWindowById(g);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),m)}createUntitledWorkspace(g,m,b){return this.a.createUntitledWorkspace(m,b)}deleteUntitledWorkspace(g,m){return this.a.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(g,m){return this.a.getWorkspaceIdentifier(m)}getRecentlyOpened(g){return this.c.getRecentlyOpened()}addRecentlyOpened(g,m){return this.c.addRecentlyOpened(m)}removeRecentlyOpened(g,m){return this.c.removeRecentlyOpened(m)}clearRecentlyOpened(g){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};A=pe([ee(0,M.IWorkspacesManagementMainService),ee(1,t.IWindowsMainService),ee(2,k.IWorkspacesHistoryMainService),ee(3,E.IBackupMainService)],A),e.WorkspacesMainService=A}),define(ie[276],re([0,1,14,41,25,17,45,13,31,50,43,34,2,15,9,4,11,7,30,132,47,146,103,252,149,62,267,18,71,181,85,119,57,106,204,27,61,110,194,216,195,254,107,196,197,16,208,87,70,5,86,268,229,255,21,6,210,273,58,19,55,261,89,36,258,75,90,29,234,112,51,49,243,244,269,245,270,115,247,248,249,250,256,32,274,257,28,94,76,275,53,253,37,215,52,225,56,92,117,259,265,263,8,113]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w,C,I,v,i,r,n,o,a,c,s,h,D,L,T,F,G,V,K,_,se,ce,X,ue,z,N,U,q,Q,oe,x,R,O,W,j,$,Y,B,Z,te,ae,ge,ke,Oe,De,Me,ve,we,ye,Re,ne,fe,de,be,Pe,We,Te,qe,Ue,je,Xe,$e,Ke,J,le,he,me,Se,Le,Be,it,xe,He,tt,nt,lt,at,Bt,$t,Wt,zt,qt,Ht,Vt,Pt,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends y.Disposable{constructor(Ee,Ce,Ae,Ie,Fe,ze,_e,et,Ne,Ge,Je){super(),this.c=Ee,this.f=Ce,this.g=Ae,this.h=Ie,this.i=Fe,this.j=ze,this.k=_e,this.l=et,this.m=Ne,this.n=Ge,this.p=Je,this.r(),this.s()}r(){const Ee=Ne=>Ne?.startsWith(`${u.Schemas.vscodeWebview}://`),Ce=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Je(Ce.has(Ge)):Je(!1)),E.session.defaultSession.setPermissionCheckHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Ce.has(Ge):!1);const Ae=new Set([u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemoteResource,"devtools"]),Ie=Ne=>{for(let Ge=Ne;Ge;Ge=Ge.parent)if(Ge.url.startsWith(`${u.Schemas.vscodeWebview}://`))return!0;return!1},Fe=Ne=>Ne.resourceType==="xhr"||Ie(Ne.frame),ze=Ne=>{const Ge=Ne.frame;if(!Ge||!this.a)return!1;const Je=E.BrowserWindow.getAllWindows();for(const Ze of Je)if(Ge.processId===Ze.webContents.mainFrame.processId)return!0;return!1},_e=(Ne,Ge)=>{if(Ne.path!=="/index.html")return!0;const Je=Ge.frame;if(!Je||!this.a)return!1;for(const Ze of this.a.getWindows())if(Ze.win&&Je.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ne,Ge)=>{const Je=l.URI.parse(Ne.url);return Je.scheme===u.Schemas.vscodeWebview&&!_e(Je,Ne)?(this.h.error("Blocked vscode-webview request",Ne.url),Ge({cancel:!0})):Je.scheme===u.Schemas.vscodeFileResource&&!ze(Ne)?(this.h.error("Blocked vscode-file request",Ne.url),Ge({cancel:!0})):Je.path.endsWith(".svg")&&!Ae.has(Je.scheme)?Ge({cancel:!Fe(Ne)}):Ge({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ne,Ge)=>{const Je=Ne.responseHeaders,Ze=Je["content-type"]||Je["Content-Type"];if(Ze&&Array.isArray(Ze)){const st=l.URI.parse(Ne.url);if(st.path.endsWith(".svg")&&Ae.has(st.scheme))return Je["Content-Type"]=["image/svg+xml"],Ge({cancel:!1,responseHeaders:Je});if(!st.path.endsWith(u.Schemas.vscodeRemoteResource)&&Ze.some(ct=>ct.toLowerCase().includes("image/svg")))return Ge({cancel:!Fe(Ne)})}return Ge({cancel:!1})});const et=E.session.defaultSession;typeof et.setCodeCachePath=="function"&&this.i.codeCachePath&&et.setCodeCachePath((0,d.join)(this.i.codeCachePath,"chrome"))}s(){(0,P.setUnexpectedErrorHandler)(Ae=>this.u(Ae)),process.on("uncaughtException",Ae=>(0,P.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,P.onUnexpectedError)(Ae)),this.j.onWillShutdown(()=>this.dispose()),(0,C.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(Ae,Ie)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),E.app.on("activate",async(Ae,Ie)=>{this.h.trace("app#activate"),Ie||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(Ae,Ie)=>{Ie.on("will-navigate",Fe=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Ie.setWindowOpenHandler(({url:Fe})=>(this.b?.openExternal(void 0,Fe),{action:"deny"}))});let Ee=[],Ce;E.app.on("open-file",(Ae,Ie)=>{this.h.trace("app#open-file: ",Ie),Ae.preventDefault(),Ee.push((0,Le.hasWorkspaceFileExtension)(Ie)?{workspaceUri:l.URI.file(Ie)}:{fileUri:l.URI.file(Ie)}),Ce!==void 0&&(clearTimeout(Ce),Ce=void 0),Ce=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],Ce=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Ae=>{const Ie=this.a?.getWindowByWebContents(Ae.sender);let Fe,ze;return Ie?.config?(Fe=Ie.config,ze={...process.env,...Ie.config.userEnv}):(Fe=this.i.args,ze=process.env),this.J(Fe,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Ae,Ie,Fe)=>{const ze=this.t([Ie]);if(!ze||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(ze,M.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Ae,...Ie)=>{const Fe=this.t(Ie);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Ae=>Ae.sender.reload())}t(Ee){let Ce;for(const Ae of Ee)typeof Ae=="string"&&(typeof Ce!="string"?Ce=Ae:Ce=(0,d.join)(Ce,Ae));if(!(typeof Ce!="string"||!(0,d.isAbsolute)(Ce)||!(0,g.isEqualOrParent)(Ce,this.i.cachedLanguagesPath,!p.isLinux)))return l.URI.file(Ce)}u(Ee){if(Ee){const Ce={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ce))}this.h.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.h.error(Ee.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Ee=this.n.win32AppUserModelId;p.isWindows&&Ee&&E.app.setAppUserModelId(Ee);try{p.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Ce=new v.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&Ce.dispose()}),this.h.trace("Resolving machine identifier...");const Ae=await(0,Gt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcess:Ie,sharedProcessReady:Fe,sharedProcessClient:ze}=this.w(Ae),_e=await this.y(Ae,Ie,Fe);this.v(_e),_e.invokeFunction(Ne=>this.z(Ne,Ce,ze)),await _e.invokeFunction(Ne=>this.C(Ne,Ce)),_e.invokeFunction(Ne=>this.G(Ne,Ie)),this.B(new Pt.RunOnceScheduler(()=>{this.B((0,Pt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Ee){this.B(Ee.createInstance(r.ProxyAuthHandler)),this.B(Ee.createInstance(Ht.UserDataProfilesHandler))}w(Ee){const Ce=this.B(this.g.createInstance(Oe.SharedProcess,Ee,this.f)),Ae=(async()=>{this.h.trace("Main->SharedProcess#connect");const Fe=await Ce.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new i.Client(Fe,"main")})(),Ie=(async()=>(await Ce.whenReady(),Ae))();return{sharedProcess:Ce,sharedProcessReady:Ie,sharedProcessClient:Ae}}async y(Ee,Ce,Ae){const Ie=new O.ServiceCollection;switch(process.platform){case"win32":Ie.set(be.IUpdateService,new x.SyncDescriptor(Ue.Win32UpdateService));break;case"linux":p.isLinuxSnap?Ie.set(be.IUpdateService,new x.SyncDescriptor(qe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(be.IUpdateService,new x.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Ie.set(be.IUpdateService,new x.SyncDescriptor(We.DarwinUpdateService));break}Ie.set(he.IWindowsMainService,new x.SyncDescriptor(me.WindowsMainService,[Ee,this.f],!1));const Fe=new T.DialogMainService(this.h);Ie.set(T.IDialogMainService,Fe),Ie.set($.ILaunchMainService,new x.SyncDescriptor($.LaunchMainService,void 0,!1)),Ie.set(L.IDiagnosticsMainService,new x.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),Ie.set(D.IDiagnosticsService,I.ProxyChannel.toService((0,I.getDelayedChannel)(Ae.then(et=>et.getChannel("diagnostics"))))),Ie.set(W.IIssueMainService,new x.SyncDescriptor(W.IssueMainService,[this.f])),Ie.set(F.IEncryptionMainService,new x.SyncDescriptor(G.EncryptionMainService,[Ee])),Ie.set(j.IKeyboardLayoutMainService,new x.SyncDescriptor(j.KeyboardLayoutMainService)),Ie.set(ae.INativeHostMainService,new x.SyncDescriptor(ae.NativeHostMainService,[Ce],!1)),Ie.set(s.ICredentialsMainService,new x.SyncDescriptor(tt.CredentialsNativeMainService)),Ie.set(J.IWebviewManagerService,new x.SyncDescriptor(le.WebviewMainService)),Ie.set(te.IMenubarMainService,new x.SyncDescriptor(te.MenubarMainService)),Ie.set(se.IExtensionUrlTrustService,new x.SyncDescriptor(ce.ExtensionUrlTrustService)),Ie.set(X.IExtensionHostStarter,new x.SyncDescriptor(ue.ExtensionHostStarter)),Ie.set(we.IStorageMainService,new x.SyncDescriptor(we.StorageMainService)),Ie.set(we.IApplicationStorageMainService,new x.SyncDescriptor(we.ApplicationStorageMainService)),p.isWindows?Ie.set(z.IExternalTerminalMainService,new x.SyncDescriptor(N.WindowsExternalTerminalService)):p.isMacintosh?Ie.set(z.IExternalTerminalMainService,new x.SyncDescriptor(N.MacExternalTerminalService)):p.isLinux&&Ie.set(z.IExternalTerminalMainService,new x.SyncDescriptor(N.LinuxExternalTerminalService));const ze=new a.BackupMainService(this.i,this.k,this.h,this.l);Ie.set(o.IBackupMainService,ze);const _e=new He.WorkspacesManagementMainService(this.i,this.h,this.p,ze,Fe,this.n);if(Ie.set(He.IWorkspacesManagementMainService,_e),Ie.set(Be.IWorkspacesService,new x.SyncDescriptor(xe.WorkspacesMainService,void 0,!1)),Ie.set(it.IWorkspacesHistoryMainService,new x.SyncDescriptor(it.WorkspacesHistoryMainService,void 0,!1)),Ie.set(je.IURLService,new x.SyncDescriptor($e.NativeURLService,void 0,!1)),(0,de.supportsTelemetry)(this.n,this.i)){const et=(0,de.isInternalTelemetry)(this.n,this.k),Ne=(0,I.getDelayedChannel)(Ae.then(ct=>ct.getChannel("telemetryAppender"))),Ge=new ne.TelemetryAppenderClient(Ne),Je=(0,ye.resolveCommonProperties)(this.m,(0,k.release)(),(0,k.hostname)(),process.arch,this.n.commit,this.n.version,Ee,et,this.i.installSourcePath),Ze=(0,de.getPiiPathsFromEnvironment)(this.i),st={appenders:[Ge],commonProperties:Je,piiPaths:Ze,sendErrorTelemetry:!0};Ie.set(Re.ITelemetryService,new x.SyncDescriptor(fe.TelemetryService,[st],!1))}else Ie.set(Re.ITelemetryService,de.NullTelemetryService);return Ie.set(Wt.IExtensionsProfileScannerService,new x.SyncDescriptor(Wt.ExtensionsProfileScannerService,void 0,!0)),Ie.set(zt.IExtensionsScannerService,new x.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await Pt.Promises.settled([ze.initialize(),_e.initialize()]),this.g.createChild(Ie)}z(Ee,Ce,Ae){const Ie=I.ProxyChannel.fromService(Ee.get($.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ie);const Fe=I.ProxyChannel.fromService(Ee.get(L.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Fe);const ze=new lt.PolicyChannel(Ee.get(nt.IPolicyService));Ce.registerChannel("policy",ze),Ae.then(Ye=>Ye.registerChannel("policy",ze));const _e=this.m.getProvider(u.Schemas.file);(0,f.assertType)(_e instanceof oe.DiskFileSystemProvider);const et=new Q.DiskFileSystemProviderChannel(_e,this.h,this.i);Ce.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et),Ae.then(Ye=>Ye.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et));const Ne=I.ProxyChannel.fromService(Ee.get(at.IUserDataProfilesMainService));Ce.registerChannel("userDataProfiles",Ne),Ae.then(Ye=>Ye.registerChannel("userDataProfiles",Ne));const Ge=new Bt.RequestChannel(Ee.get($t.IRequestService));Ae.then(Ye=>Ye.registerChannel("request",Ge));const Je=new Pe.UpdateChannel(Ee.get(be.IUpdateService));Ce.registerChannel("update",Je);const Ze=I.ProxyChannel.fromService(Ee.get(W.IIssueMainService));Ce.registerChannel("issue",Ze);const st=I.ProxyChannel.fromService(Ee.get(F.IEncryptionMainService));Ce.registerChannel("encryption",st);const ct=I.ProxyChannel.fromService(Ee.get(s.ICredentialsMainService));Ce.registerChannel("credentials",ct);const kt=I.ProxyChannel.fromService(Ee.get(De.ISignService));Ce.registerChannel("sign",kt);const Qe=I.ProxyChannel.fromService(Ee.get(j.IKeyboardLayoutMainService));Ce.registerChannel("keyboardLayout",Qe),this.b=Ee.get(ae.INativeHostMainService);const wt=I.ProxyChannel.fromService(this.b);Ce.registerChannel("nativeHost",wt),Ae.then(Ye=>Ye.registerChannel("nativeHost",wt));const pt=I.ProxyChannel.fromService(Ee.get(Be.IWorkspacesService));Ce.registerChannel("workspaces",pt);const yt=I.ProxyChannel.fromService(Ee.get(te.IMenubarMainService));Ce.registerChannel("menubar",yt);const Dt=I.ProxyChannel.fromService(Ee.get(je.IURLService));Ce.registerChannel("url",Dt);const Rt=I.ProxyChannel.fromService(Ee.get(se.IExtensionUrlTrustService));Ce.registerChannel("extensionUrlTrust",Rt);const vt=I.ProxyChannel.fromService(Ee.get(J.IWebviewManagerService));Ce.registerChannel("webview",vt);const ut=this.B(new ve.StorageDatabaseChannel(this.h,Ee.get(we.IStorageMainService)));Ce.registerChannel("storage",ut),Ae.then(Ye=>Ye.registerChannel("storage",ut));const St=this.B(new Vt.ProfileStorageChangesListenerChannel(Ee.get(we.IStorageMainService),Ee.get(at.IUserDataProfilesMainService),this.h));Ae.then(Ye=>Ye.registerChannel("profileStorageListener",St));const bt=I.ProxyChannel.fromService(Ee.get(z.IExternalTerminalMainService));Ce.registerChannel("externalTerminal",bt);const ht=new Z.LogLevelChannel(Ee.get(B.ILogService),Ee.get(B.ILoggerService));Ce.registerChannel("logLevel",ht),Ae.then(Ye=>Ye.registerChannel("logLevel",ht));const Ve=new Z.LoggerChannel(Ee.get(B.ILoggerService));Ce.registerChannel("logger",Ve),Ae.then(Ye=>Ye.registerChannel("logger",Ve));const ot=new h.ElectronExtensionHostDebugBroadcastChannel(Ee.get(he.IWindowsMainService));Ce.registerChannel("extensionhostdebugservice",ot);const ft=I.ProxyChannel.fromService(Ee.get(X.IExtensionHostStarter));Ce.registerChannel(X.ipcExtensionHostStarterChannelName,ft)}async C(Ee,Ce){const Ae=this.a=Ee.get(he.IWindowsMainService),Ie=Ee.get(je.IURLService),Fe=Ee.get(ae.INativeHostMainService);this.j.phase=2;const ze=[],_e=[...this.i.args["open-url"]?this.i.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ve=>{try{return{uri:l.URI.parse(Ve),url:Ve}}catch{return}}).filter(Ve=>{if(!Ve||this.D(Ve.uri))return!1;const ot=this.F(Ve.uri);return ot?(ze.push(ot),!1):!0}),et=this,Ne=this.i,Ge=this.n,Je=this.h;Ie.registerHandler({async handleURL(Ve,ot){if(Je.trace("app#handleURL: ",Ve.toString(!0),ot),Ve.scheme===Ge.urlProtocol&&Ve.path==="workspace"&&(Ve=Ve.with({authority:"file",path:l.URI.parse(Ve.query).path,query:""})),et.D(Ve))return!0;let ft=!1;const Ye=new URLSearchParams(Ve.query);Ye.get("windowId")==="_blank"&&(Ye.delete("windowId"),Ve=Ve.with({query:Ye.toString()}),ft=!0),ft||=p.isMacintosh&&Ae.getWindowCount()===0;const Ut=Ye.get("continueOn");Ut!==null&&(Ne.continueOn=Ut??void 0,Ye.delete("continueOn"),Ve=Ve.with({query:Ye.toString()}));const Mt=et.F(Ve);if(Je.trace("app#handleURL: windowOpenableFromProtocolLink = ",Mt),Mt){const[At]=await Ae.open({context:5,cli:{...Ne.args},urisToOpen:[Mt],forceNewWindow:ft,gotoLineMode:!0});return At.focus(),!0}if(ft){const[At]=await Ae.open({context:5,cli:{...Ne.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(Ve)});return await At.ready(),Ie.open(Ve,ot)}return!1}});const Ze=this.B(new Se.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),st=new I.StaticRouter(Ve=>Ze.getActiveClientId().then(ot=>Ve===ot)),ct=new Xe.URLHandlerRouter(st),kt=Ce.getChannel("urlHandler",ct);Ie.registerHandler(new Xe.URLHandlerChannelClient(kt)),this.B(new Ke.ElectronURLListener(_e,Ie,Ae,this.i,this.n));const Qe=this.i.args,wt=global.macOpenFiles,pt=(0,K.isLaunchedFromCli)(process.env)?0:4,yt=Qe._.length,Dt=!!Qe["folder-uri"],Rt=!!Qe["file-uri"],vt=Qe["skip-add-to-recently-opened"]===!0,ut=Qe.wait&&Qe.waitMarkerFilePath?l.URI.file(Qe.waitMarkerFilePath):void 0,St=Qe.remote||void 0,bt=Qe.profile,ht=Qe["profile-temp"];if(ze.length>0)return Ae.open({context:pt,cli:Qe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});if(!yt&&!Dt&&!Rt){if(Qe["new-window"]||bt||ht)return Ae.open({context:pt,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:vt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:St,forceProfile:bt,forceTempProfile:ht});if(wt.length)return Ae.open({context:1,cli:Qe,urisToOpen:wt.map(Ve=>(0,Le.hasWorkspaceFileExtension)(Ve)?{workspaceUri:l.URI.file(Ve)}:{fileUri:l.URI.file(Ve)}),noRecentEntry:vt,waitMarkerFileURI:ut,initialStartup:!0})}return Ae.open({context:pt,cli:Qe,forceNewWindow:Qe["new-window"]||!yt&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:vt,waitMarkerFileURI:ut,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:St,forceProfile:bt,forceTempProfile:ht})}D(Ee){return!!(Ee.authority===u.Schemas.file&&p.isWindows&&E.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,S.mnemonicButtonLabel)((0,n.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,n.localize)(1,null))],defaultId:0,cancelId:1,message:(0,n.localize)(2,null,(0,S.getPathLabel)(Ee,{os:p.OS,tildify:this.i}),this.n.nameShort),detail:(0,n.localize)(3,null),noLink:!0})===1)}F(Ee){if(!!Ee.path){if(Ee.authority===u.Schemas.file){const Ce=l.URI.file(Ee.fsPath);return(0,Le.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Ce}:{fileUri:Ce}}else if(Ee.authority===u.Schemas.vscodeRemote){const Ce=Ee.path.indexOf(d.posix.sep,1);if(Ce!==-1){const Ae=Ee.path.substring(1,Ce),Ie=Ee.path.substring(Ce),Fe=l.URI.from({scheme:u.Schemas.vscodeRemote,authority:Ae,path:Ie,query:Ee.query,fragment:Ee.fragment});return(0,Le.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Fe}:/:[\d]+$/.test(Ie)?{fileUri:Fe}:{folderUri:Fe}}}}}G(Ee,Ce){const Ae=Ee.get(Re.ITelemetryService),Ie=Ee.get(be.IUpdateService);this.j.phase=3,this.I(Ae,Ce),this.H(),E.protocol.registerHttpProtocol(u.Schemas.vscodeRemoteResource,(Fe,ze)=>{ze({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(Ie instanceof Ue.Win32UpdateService||Ie instanceof Te.LinuxUpdateService||Ie instanceof We.DarwinUpdateService)&&Ie.initialize(),this.J(this.i.args,process.env,!0),this.L()}async H(){const Ee=this.n.win32MutexName;if(p.isWindows&&Ee)try{const Ce=await new Promise((Ie,Fe)=>{H(["windows-mutex"],Ie,Fe)}),Ae=new Ce.Mutex(Ee);(0,m.once)(this.j.onWillShutdown)(()=>Ae.release())}catch(Ce){this.h.error(Ce)}}I(Ee,Ce){let Ae=!1;(0,m.once)(this.j.onWillShutdown)(()=>Ae=!0),this.B(Ce.onDidError(({type:Ie,details:Fe})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(ze)),Ee.publicLog2("sharedprocesserror",{type:Ie,reason:Fe?.reason,code:Fe?.exitCode,visible:Ce.isVisible(),shuttingdown:Ae})}))}async J(Ee,Ce,Ae){try{return await(0,_.getResolvedShellEnv)(this.k,this.h,Ee,Ce)}catch(Ie){const Fe=(0,A.toErrorMessage)(Ie);Ae?this.a?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.h.error(Fe)}return{}}async L(){try{const Ce=(await this.m.readFile(this.i.argvResource)).value.toString(),Ae=JSON.parse((0,b.stripComments)(Ce)),Fe=(0,de.getTelemetryLevel)(this.k)>=1;if(Ae["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,w.generateUuid)()}"`,"}"],_e=Ce.substring(0,Ce.length-2).concat(`,
`,ze.join(`
`));await this.m.writeFile(this.i.argvResource,M.VSBuffer.fromString(_e))}else{const ze=Ce.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);ze!==Ce&&await this.m.writeFile(this.i.argvResource,M.VSBuffer.fromString(ze))}}catch(Ee){this.h.error(Ee)}}};Ct=pe([ee(2,R.IInstantiationService),ee(3,B.ILogService),ee(4,V.IEnvironmentMainService),ee(5,Y.ILifecycleMainService),ee(6,c.IConfigurationService),ee(7,Me.IStateMainService),ee(8,q.IFileService),ee(9,ge.IProductService),ee(10,at.IUserDataProfilesMainService)],Ct),e.CodeApplication=Ct}),define(ie[277],re([0,1,37,8,285,2,6]),function(H,e,E,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends E.AbstractPolicyService{constructor(m,b){super(),this.j=m,this.k=b,this.a=new t.Throttler,this.b=this.B(new M.MutableDisposable)}async i(m){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(m).length} policy definitions`),await this.a.queue(()=>new Promise((b,S)=>{try{this.b.value=(0,k.createWatcher)(this.k,m,y=>{this.m(y),b()})}catch(y){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),S(y)}}))}m(m){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(m)}`);for(const b in m){const S=m[b];S===void 0?this.g.delete(b):this.g.set(b,S)}this.h.fire(Object.keys(m))}};P=pe([ee(0,A.ILogService)],P),e.NativePolicyService=P}),define(ie[278],re([0,1,227,8,17,13,2,11,18,35,110,6,226,286]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends A.Disposable{constructor(f,l,w){super(),this.h=f,this.i=l,this.j=w,this.k(),this.B(f.onDidChangeConfiguration(C=>{C.affectsConfiguration("http")&&this.k()}))}k(){const f=this.h.getValue("http");this.a=f?.proxy,this.b=!!f?.proxyStrictSSL,this.f=f?.proxyAuthorization}async request(f,l){this.j.trace("RequestService#request (node) - begin",f.url);const{a:w,b:C}=this;let I;try{I=await(0,b.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(r){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",r))}const v={...process.env,...I},i=f.agent?f.agent:await(0,y.getProxyAgent)(f.url||"",v,{proxyUrl:w,strictSSL:C});f.agent=i,f.strictSSL=C,this.f&&(f.headers={...f.headers||{},"Proxy-Authorization":this.f});try{const r=await this.m(f,l);return this.j.trace("RequestService#request (node) - success",f.url),r}catch(r){throw this.j.trace("RequestService#request (node) - error",f.url,r),r}}async l(f){return((0,E.parse)(f.url).protocol==="https:"?await new Promise((C,I)=>{H(["https"],C,I)}):await new Promise((C,I)=>{H(["http"],C,I)})).request}m(f,l){return t.Promises.withAsyncBody(async(w,C)=>{const I=(0,E.parse)(f.url),v=f.getRawRequest?f.getRawRequest(f):await this.l(f),i={hostname:I.hostname,port:I.port?parseInt(I.port):I.protocol==="https:"?443:80,protocol:I.protocol,path:I.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,P.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(i.auth=f.user+":"+f.password);const r=v(i,n=>{const o=(0,P.isNumber)(f.followRedirects)?f.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&o>0&&n.headers.location)this.m({...f,url:n.headers.location,followRedirects:o-1},l).then(w,C);else{let a=n;!f.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(a=n.pipe((0,u.createGunzip)())),w({res:n,stream:(0,k.streamToBufferReadableStream)(a)})}});r.on("error",C),f.timeout&&r.setTimeout(f.timeout),f.isChromiumNetwork&&r.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&r.write(f.data),r.end(),l.onCancellationRequested(()=>{r.abort(),C(new M.CancellationError)})})}async resolveProxy(f){}};d=pe([ee(0,g.IConfigurationService),ee(1,m.INativeEnvironmentService),ee(2,S.ILogService)],d),e.RequestService=d}),define(ie[279],re([0,1,14,278]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(A){return E.net.request}class M extends t.RequestService{request(P,g){return super.request({...P||{},getRawRequest:k,isChromiumNetwork:!0},g)}}e.RequestMainService=M}),define(ie[287],re([0,1,14,40,7,24,8,45,13,31,50,34,15,9,73,4,33,26,23,47,84,276,10,18,220,233,27,61,185,16,206,87,70,202,86,21,209,6,212,63,19,64,260,114,241,56,279,89,228,36,232,51,66,52,37,277,214,2,42,246,38,242]),function(H,e,E,t,k,M,A,P,g,m,b,S,y,u,d,p,f,l,w,C,I,v,i,r,n,o,a,c,s,h,D,L,T,F,G,V,K,_,se,ce,X,ue,z,N,U,q,Q,oe,x,R,O,W,j,$,Y,B,Z,te,ae,ge,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Oe{main(){try{this.a()}catch(ve){console.error(ve.message),E.app.exit(1)}}async a(){(0,g.setUnexpectedErrorHandler)(Pe=>console.error(Pe));const[ve,we,ye,Re,ne,fe,de,be]=this.b();try{try{await this.d(ye,be,Re,ne,de)}catch(Pe){throw this.f(ye,de.nameLong,Pe),Pe}await ve.invokeFunction(async Pe=>{const We=Pe.get(_.ILogService),Te=Pe.get(V.ILifecycleMainService),qe=Pe.get(h.IFileService),Ue=Pe.get(_.ILoggerService),je=await this.e(We,ye,Te,ve,de,!0);return w.Promises.writeFile(ye.mainLockfile,String(process.pid)).catch(Xe=>{We.warn(`Error writing main lockfile: ${Xe.stack}`)}),fe.logger=Ue.createLogger(k.URI.file((0,u.join)(ye.logsPath,"main.log")),{name:"main"}),(0,b.once)(Te.onWillShutdown)(Xe=>{qe.dispose(),Re.dispose(),Xe.join(w.Promises.unlink(ye.mainLockfile).catch(()=>{}))}),ve.createInstance(v.CodeApplication,je,we).startup()})}catch(Pe){ve.invokeFunction(this.i,Pe)}}b(){const ve=new G.ServiceCollection,we=new te.DisposableStore;process.once("exit",()=>we.dispose());const ye={_serviceBrand:void 0,...ce.default};ve.set(X.IProductService,ye);const Re=new a.EnvironmentMainService(this.j(),ye),ne=this.c(Re);ve.set(a.IEnvironmentMainService,Re);const fe=new K.BufferLogService,de=we.add(new _.MultiplexLogService([new _.ConsoleMainLogger((0,_.getLogLevel)(Re)),fe]));ve.set(_.ILogService,de);const be=new D.FileService(de);ve.set(h.IFileService,be);const Pe=new L.DiskFileSystemProvider(de);be.registerProvider(y.Schemas.file,Pe);const We=new ge.UriIdentityService(be);ve.set(ae.IUriIdentityService,We),ve.set(_.ILoggerService,new se.LoggerService(de));const Te=new O.StateMainService(Re,de,be);ve.set(R.IStateMainService,Te);const qe=new $.UserDataProfilesMainService(Te,We,Re,be,de);ve.set($.IUserDataProfilesMainService,qe);const Ue=p.isWindows&&ye.win32RegValueName?we.add(new B.NativePolicyService(de,ye.win32RegValueName)):Re.policyFile?we.add(new Z.FilePolicyService(Re.policyFile,be,de)):new Y.NullPolicyService;ve.set(Y.IPolicyService,Ue);const je=new n.ConfigurationService(qe.defaultProfile.settingsResource,be,Ue,de);return ve.set(r.IConfigurationService,je),ve.set(V.ILifecycleMainService,new T.SyncDescriptor(V.LifecycleMainService,void 0,!1)),ve.set(q.IRequestService,new T.SyncDescriptor(Q.RequestMainService,void 0,!0)),ve.set(j.IThemeMainService,new T.SyncDescriptor(j.ThemeMainService)),ve.set(oe.ISignService,new T.SyncDescriptor(x.SignService,void 0,!1)),ve.set(N.ITunnelService,new T.SyncDescriptor(U.TunnelService)),ve.set(ue.IProtocolMainService,new z.ProtocolMainService(Re,qe,de)),[new F.InstantiationService(ve,!0),ne,Re,je,Te,fe,ye,qe]}c(ve){const we={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ye=>{const Re=process.env[ye];typeof Re=="string"&&(we[ye]=Re)}),Object.assign(process.env,we),we}async d(ve,we,ye,Re,ne){await A.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,we.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(fe=>fe?w.Promises.mkdir(fe,{recursive:!0}):void 0)),Re.init(),ye.initialize()]),we.setEnablement(ne.quality!=="stable"||ye.getValue(ke.PROFILES_ENABLEMENT_CONFIG))}async e(ve,we,ye,Re,ne,fe){let de;try{(0,d.mark)("code/willStartMainServer"),de=await(0,I.serve)(we.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,b.once)(ye.onWillShutdown)(()=>de.dispose())}catch(be){if(be.code!=="EADDRINUSE")throw this.f(we,ne.nameLong,be),be;let Pe;try{Pe=await(0,I.connect)(we.mainIPCHandle,"main")}catch(Ue){if(!fe||p.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.g((0,i.localize)(0,null,ne.nameShort),(0,i.localize)(1,null),ne.nameLong),Ue;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(je){throw ve.warn("Could not delete obsolete instance handle",je),je}return this.e(ve,we,ye,Re,ne,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const Ue=`Running extension tests from the command line is currently only supported if no other instance of ${ne.nameShort} is running.`;throw ve.error(Ue),Pe.dispose(),new Error(Ue)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.g((0,i.localize)(2,null,ne.nameShort),(0,i.localize)(3,null),ne.nameLong)},1e4));const Te=C.ProxyChannel.toService(Pe.getChannel("launch"),{disableMarshalling:!0}),qe=C.ProxyChannel.toService(Pe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return Re.invokeFunction(async()=>{const Ue=new o.DiagnosticsService(W.NullTelemetryService,ne),je=await qe.getMainDiagnostics(),Xe=await qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),$e=await Ue.getDiagnostics(je,Xe);throw console.log($e),new g.ExpectedError});throw p.isWindows&&await this.h(Te,ve),ve.trace("Sending env to running instance..."),await Te.start(we.args,process.env),Pe.dispose(),We&&clearTimeout(We),new g.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw ve.warn(`Warning: The --status argument can only be used if ${ne.nameShort} is already running. Please run it again after {0} has started.`),new g.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}f(ve,we,ye){if(ye.code==="EACCES"||ye.code==="EPERM"){const Re=(0,M.coalesce)([ve.userDataPath,ve.extensionsPath,I.XDG_RUNTIME_DIR]).map(ne=>(0,S.getPathLabel)(k.URI.file(ne),{os:p.OS,tildify:ve}));this.g((0,i.localize)(4,null),(0,i.localize)(5,null,(0,P.toErrorMessage)(ye),Re.join(`
`)),we)}}g(ve,we,ye){E.dialog.showMessageBoxSync({title:ye,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,i.localize)(6,null))],message:ve,detail:we,defaultId:0,noLink:!0})}async h(ve,we){if(p.isWindows){const ye=await ve.getMainProcessId();we.trace("Sending some foreground love to the running instance:",ye);try{(await new Promise((Re,ne)=>{H(["windows-foreground-love"],Re,ne)})).allowSetForegroundWindow(ye)}catch(Re){we.error(Re)}}}i(ve,we){const ye=ve.get(_.ILogService),Re=ve.get(V.ILifecycleMainService);let ne=0;we&&(we.isExpected?we.message&&ye.trace(we.message):(ne=1,we.stack?ye.error(we.stack):ye.error(`Startup error: ${we.toString()}`))),Re.kill(ne)}j(){const ve=this.k((0,c.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const we=(0,s.createWaitMarkerFileSync)(ve.verbose);we&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",we),ve.waitMarkerFilePath=we)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const we=this.l(ve._,ve.goto);ve._=we}return ve}l(ve,we){const ye=(0,f.cwd)(),Re=ve.map(de=>{let be=String(de),Pe;we&&(Pe=(0,m.parseLineAndColumnAware)(be),be=Pe.path),be&&(be=this.m(ye,be));const We=(0,m.sanitizeFilePath)(be,ye),Te=(0,u.basename)(We);return Te&&!(0,m.isValidBasename)(Te)?null:we&&Pe?(Pe.path=We,this.n(Pe)):We}),ne=p.isWindows||p.isMacintosh,fe=(0,M.distinct)(Re,de=>de&&ne?de.toLowerCase():de||"");return(0,M.coalesce)(fe)}m(ve,we){return p.isWindows&&(we=(0,l.rtrim)(we,'"')),we=(0,l.trim)((0,l.trim)(we," "),"	"),p.isWindows&&(we=(0,u.resolve)(ve,we),we=(0,l.rtrim)(we,".")),we}n(ve){const we=[ve.path];return typeof ve.line=="number"&&we.push(String(ve.line)),typeof ve.column=="number"&&we.push(String(ve.column)),we.join(":")}}new Oe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6ed4d436a9b6ae131732f4e2a723868231f4473a/core/vs/code/electron-main/main.js.map
