/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/types","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/userDataProfile/common/userDataProfile","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var e=[],L=0,O=x.length;L<O;L++)e[L]=Z[x[L]];return e};define(Z[49],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(N){return(b,h,u)=>{let p=null,y=null;if(typeof u.value=="function"?(p="value",y=u.value):typeof u.get=="function"&&(p="get",y=u.get),!y)throw new Error("not supported");u[p]=N(y,h)}}function O(N,b,h){let u=null,p=null;if(typeof h.value=="function"?(u="value",p=h.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(u="get",p=h.get),!p)throw new Error("not supported");const y=`$memoize$${b}`;h[u]=function(...m){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,m)}),this[y]}}e.memoize=O;function k(N,b,h){return L((u,p)=>{const y=`$debounce$${p}`,m=`$debounce$result$${p}`;return function(...P){this[m]||(this[m]=h?h():void 0),clearTimeout(this[y]),b&&(this[m]=b(this[m],...P),P=[this[m]]),this[y]=setTimeout(()=>{u.apply(this,P),this[m]=h?h():void 0},N)}})}e.debounce=k;function T(N,b,h){return L((u,p)=>{const y=`$throttle$timer$${p}`,m=`$throttle$result$${p}`,P=`$throttle$lastRun$${p}`,v=`$throttle$pending$${p}`;return function(...D){if(this[m]||(this[m]=h?h():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...D)),this[v])return;const E=this[P]+N;E<=Date.now()?(this[P]=Date.now(),u.apply(this,[this[m]]),this[m]=h?h():void 0):(this[v]=!0,this[y]=setTimeout(()=>{this[v]=!1,this[P]=Date.now(),u.apply(this,[this[m]]),this[m]=h?h():void 0},E-Date.now()))}})}e.throttle=T}),define(Z[70],Q([0,1,9]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(h,u){if(!h)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=O;function k(h,u="Unreachable"){throw new Error(u)}e.assertNever=k;function T(h){if(!h)throw new L.BugIndicatingError("Assertion Failed")}e.assert=T;function N(h){if(!h()){debugger;h(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function b(h,u){let p=0;for(;p<h.length-1;){const y=h[p],m=h[p+1];if(!u(y,m))return!1;p++}return!0}e.checkAdjacentItems=b}),define(Z[50],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function N(t,r=!1){let i=0;const n=t.length;let s="",l=0,a=16,f=0;function S(ee){let pe=0,le=0;for(;pe<ee;){const ae=t.charCodeAt(i);if(ae>=48&&ae<=57)le=le*16+ae-48;else if(ae>=65&&ae<=70)le=le*16+ae-65+10;else if(ae>=97&&ae<=102)le=le*16+ae-97+10;else break;i++,pe++}return pe<ee&&(le=-1),le}function A(ee){i=ee,s="",l=0,a=16,f=0}function $(){const ee=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&u(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&u(t.charCodeAt(i)))for(i++;i<t.length&&u(t.charCodeAt(i));)i++;else return f=3,t.substring(ee,i);let pe=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&u(t.charCodeAt(i))){for(i++;i<t.length&&u(t.charCodeAt(i));)i++;pe=i}else f=3;return t.substring(ee,pe)}function H(){let ee="",pe=i;for(;;){if(i>=n){ee+=t.substring(pe,i),f=2;break}const le=t.charCodeAt(i);if(le===34){ee+=t.substring(pe,i),i++;break}if(le===92){if(ee+=t.substring(pe,i),i++,i>=n){f=2;break}switch(t.charCodeAt(i++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:{const he=S(4);he>=0?ee+=String.fromCharCode(he):f=4;break}default:f=5}pe=i;continue}if(le>=0&&le<=31)if(h(le)){ee+=t.substring(pe,i),f=2;break}else f=6;i++}return ee}function J(){if(s="",f=0,l=i,i>=n)return l=n,a=17;let ee=t.charCodeAt(i);if(b(ee)){do i++,s+=String.fromCharCode(ee),ee=t.charCodeAt(i);while(b(ee));return a=15}if(h(ee))return i++,s+=String.fromCharCode(ee),ee===13&&t.charCodeAt(i)===10&&(i++,s+=`
`),a=14;switch(ee){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,s=H(),a=10;case 47:{const pe=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!h(t.charCodeAt(i));)i++;return s=t.substring(pe,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const le=n-1;let ae=!1;for(;i<le;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ae=!0;break}i++}return ae||(i++,f=1),s=t.substring(pe,i),a=13}return s+=String.fromCharCode(ee),i++,a=16}case 45:if(s+=String.fromCharCode(ee),i++,i===n||!u(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=$(),a=11;default:for(;i<n&&ie(ee);)i++,ee=t.charCodeAt(i);if(l!==i){switch(s=t.substring(l,i),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(ee),i++,a=16}}function ie(ee){if(b(ee)||h(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ee;do ee=J();while(ee>=12&&ee<=15);return ee}return{setPosition:A,getPosition:()=>i,scan:r?re:J,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>f}}e.createScanner=N;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var p;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(p||(p={}));function y(t,r){const i=[],n=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function f(S,A,$,H){l.value=S,l.offset=A,l.length=$,l.type=H,l.colonOffset=void 0,s=l}try{w(t,{onObjectBegin:(S,A)=>{if(r<=S)throw n;s=void 0,a=r>S,i.push("")},onObjectProperty:(S,A,$)=>{if(r<A||(f(S,A,$,"property"),i[i.length-1]=S,r<=A+$))throw n},onObjectEnd:(S,A)=>{if(r<=S)throw n;s=void 0,i.pop()},onArrayBegin:(S,A)=>{if(r<=S)throw n;s=void 0,i.push(0)},onArrayEnd:(S,A)=>{if(r<=S)throw n;s=void 0,i.pop()},onLiteralValue:(S,A,$)=>{if(r<A||(f(S,A,$,o(S)),r<=A+$))throw n},onSeparator:(S,A,$)=>{if(r<=A)throw n;if(S===":"&&s&&s.type==="property")s.colonOffset=A,a=!1,s=void 0;else if(S===","){const H=i[i.length-1];typeof H=="number"?i[i.length-1]=H+1:(a=!0,i[i.length-1]=""),s=void 0}}})}catch(S){if(S!==n)throw S}return{path:i,previousNode:s,isAtPropertyKey:a,matches:S=>{let A=0;for(let $=0;A<S.length&&$<i.length;$++)if(S[A]===i[$]||S[A]==="*")A++;else if(S[A]!=="**")return!1;return A===S.length}}}e.getLocation=y;function m(t,r=[],i=T.DEFAULT){let n=null,s=[];const l=[];function a(S){Array.isArray(s)?s.push(S):n!==null&&(s[n]=S)}return w(t,{onObjectBegin:()=>{const S={};a(S),l.push(s),s=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const S=[];a(S),l.push(s),s=S,n=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:a,onError:(S,A,$)=>{r.push({error:S,offset:A,length:$})}},i),s[0]}e.parse=m;function P(t,r=[],i=T.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function l(S){return n.children.push(S),S}w(t,{onObjectBegin:S=>{n=l({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,A,$)=>{n=l({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:A,length:$,parent:n})},onObjectEnd:(S,A)=>{n.length=S+A-n.offset,n=n.parent,s(S+A)},onArrayBegin:(S,A)=>{n=l({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,A)=>{n.length=S+A-n.offset,n=n.parent,s(S+A)},onLiteralValue:(S,A,$)=>{l({type:o(S),offset:A,length:$,parent:n,value:S}),s(A+$)},onSeparator:(S,A,$)=>{n.type==="property"&&(S===":"?n.colonOffset=A:S===","&&s(A))},onError:(S,A,$)=>{r.push({error:S,offset:A,length:$})}},i);const f=n.children[0];return f&&delete f.parent,f}e.parseTree=P;function v(t,r){if(!t)return;let i=t;for(const n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===n){i=l.children[1],s=!0;break}if(!s)return}else{const s=n;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=v;function D(t){if(!t.parent||!t.parent.children)return[];const r=D(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=D;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":{const r=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(r[i.children[0].value]=E(n))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function c(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=c;function g(t,r,i=!1){if(c(t,r,i)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const l=g(n[s],r,i);if(l)return l}return t}}e.findNodeAtOffset=g;function w(t,r,i=T.DEFAULT){const n=N(t,!1);function s(q){return q?()=>q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function l(q){return q?Y=>q(Y,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=s(r.onObjectBegin),f=l(r.onObjectProperty),S=s(r.onObjectEnd),A=s(r.onArrayBegin),$=s(r.onArrayEnd),H=l(r.onLiteralValue),J=l(r.onSeparator),ie=s(r.onComment),re=l(r.onError),ee=i&&i.disallowComments,pe=i&&i.allowTrailingComma;function le(){for(;;){const q=n.scan();switch(n.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:ee||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(q){case 12:case 13:ee?ae(10):ie();break;case 16:ae(1);break;case 15:case 14:break;default:return q}}}function ae(q,Y=[],R=[]){if(re(q),Y.length+R.length>0){let I=n.getToken();for(;I!==17;){if(Y.indexOf(I)!==-1){le();break}else if(R.indexOf(I)!==-1)break;I=le()}}}function he(q){const Y=n.getTokenValue();return q?H(Y):f(Y),le(),!0}function B(){switch(n.getToken()){case 11:{let q=0;try{q=JSON.parse(n.getTokenValue()),typeof q!="number"&&(ae(2),q=0)}catch{ae(2)}H(q);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return le(),!0}function j(){return n.getToken()!==10?(ae(3,[],[2,5]),!1):(he(!1),n.getToken()===6?(J(":"),le(),W()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function C(){a(),le();let q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(q||ae(4,[],[]),J(","),le(),n.getToken()===2&&pe)break}else q&&ae(6,[],[]);j()||ae(4,[],[2,5]),q=!0}return S(),n.getToken()!==2?ae(7,[2],[]):le(),!0}function z(){A(),le();let q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(q||ae(4,[],[]),J(","),le(),n.getToken()===4&&pe)break}else q&&ae(6,[],[]);W()||ae(4,[],[4,5]),q=!0}return $(),n.getToken()!==4?ae(8,[4],[]):le(),!0}function W(){switch(n.getToken()){case 3:return z();case 1:return C();case 10:return he(!0);default:return B()}}return le(),n.getToken()===17?i.allowEmptyContent?!0:(ae(4,[],[]),!1):W()?(n.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.visit=w;function d(t,r){const i=N(t),n=[];let s,l=0,a;do switch(a=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:l!==a&&n.push(t.substring(l,a)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),l=i.getPosition();break}while(s!==17);return n.join("")}e.stripComments=d;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(Z[71],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function L(b,h,u){return Math.min(Math.max(b,h),u)}e.clamp=L;function O(b,h){return(h+b%h)%h}e.rot=O;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class T{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=T;class N{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const u=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=N}),function(){function x(k){const T=[];typeof k=="number"&&T.push("code/timeOrigin",k);function N(h){T.push(h,Date.now())}function b(){const h=[];for(let u=0;u<T.length;u+=2)h.push({name:T[u],startTime:T[u+1]});return h}return{mark:N,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const N of performance.getEntriesByType("mark"))T.push({name:N.name,startTime:Math.round(k+N.startTime)});return T}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function L(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=L(O))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var O in L)(typeof exports=="object"?exports:x)[O]=L[O]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function L(O){if(e[O])return e[O].exports;var k=e[O]={i:O,l:!1,exports:{}};return x[O].call(k.exports,k,k.exports,L),k.l=!0,k.exports}return L.m=x,L.c=e,L.d=function(O,k,T){L.o(O,k)||Object.defineProperty(O,k,{enumerable:!0,get:T})},L.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},L.t=function(O,k){if(1&k&&(O=L(O)),8&k||4&k&&typeof O=="object"&&O&&O.__esModule)return O;var T=Object.create(null);if(L.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:O}),2&k&&typeof O!="string")for(var N in O)L.d(T,N,function(b){return O[b]}.bind(null,N));return T},L.n=function(O){var k=O&&O.__esModule?function(){return O.default}:function(){return O};return L.d(k,"a",k),k},L.o=function(O,k){return Object.prototype.hasOwnProperty.call(O,k)},L.p="",L(L.s=0)}([function(x,e,L){(function(O){var k;e=x.exports=R,k=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],h=e.src=[],u=0,p=u++;h[p]="0|[1-9]\\d*";var y=u++;h[y]="[0-9]+";var m=u++;h[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=u++;h[P]="("+h[p]+")\\.("+h[p]+")\\.("+h[p]+")";var v=u++;h[v]="("+h[y]+")\\.("+h[y]+")\\.("+h[y]+")";var D=u++;h[D]="(?:"+h[p]+"|"+h[m]+")";var E=u++;h[E]="(?:"+h[y]+"|"+h[m]+")";var c=u++;h[c]="(?:-("+h[D]+"(?:\\."+h[D]+")*))";var g=u++;h[g]="(?:-?("+h[E]+"(?:\\."+h[E]+")*))";var w=u++;h[w]="[0-9A-Za-z-]+";var d=u++;h[d]="(?:\\+("+h[w]+"(?:\\."+h[w]+")*))";var o=u++,t="v?"+h[P]+h[c]+"?"+h[d]+"?";h[o]="^"+t+"$";var r="[v=\\s]*"+h[v]+h[g]+"?"+h[d]+"?",i=u++;h[i]="^"+r+"$";var n=u++;h[n]="((?:<|>)?=?)";var s=u++;h[s]=h[y]+"|x|X|\\*";var l=u++;h[l]=h[p]+"|x|X|\\*";var a=u++;h[a]="[v=\\s]*("+h[l]+")(?:\\.("+h[l]+")(?:\\.("+h[l]+")(?:"+h[c]+")?"+h[d]+"?)?)?";var f=u++;h[f]="[v=\\s]*("+h[s]+")(?:\\.("+h[s]+")(?:\\.("+h[s]+")(?:"+h[g]+")?"+h[d]+"?)?)?";var S=u++;h[S]="^"+h[n]+"\\s*"+h[a]+"$";var A=u++;h[A]="^"+h[n]+"\\s*"+h[f]+"$";var $=u++;h[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=u++;h[H]="(?:~>?)";var J=u++;h[J]="(\\s*)"+h[H]+"\\s+",b[J]=new RegExp(h[J],"g");var ie=u++;h[ie]="^"+h[H]+h[a]+"$";var re=u++;h[re]="^"+h[H]+h[f]+"$";var ee=u++;h[ee]="(?:\\^)";var pe=u++;h[pe]="(\\s*)"+h[ee]+"\\s+",b[pe]=new RegExp(h[pe],"g");var le=u++;h[le]="^"+h[ee]+h[a]+"$";var ae=u++;h[ae]="^"+h[ee]+h[f]+"$";var he=u++;h[he]="^"+h[n]+"\\s*("+r+")$|^$";var B=u++;h[B]="^"+h[n]+"\\s*("+t+")$|^$";var j=u++;h[j]="(\\s*)"+h[n]+"\\s*("+r+"|"+h[a]+")",b[j]=new RegExp(h[j],"g");var C=u++;h[C]="^\\s*("+h[a]+")\\s+-\\s+("+h[a]+")\\s*$";var z=u++;h[z]="^\\s*("+h[f]+")\\s+-\\s+("+h[f]+")\\s*$";var W=u++;h[W]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)k(q,h[q]),b[q]||(b[q]=new RegExp(h[q]));function Y(U,K){if(U instanceof R)return U;if(typeof U!="string"||U.length>T||!(K?b[i]:b[o]).test(U))return null;try{return new R(U,K)}catch{return null}}function R(U,K){if(U instanceof R){if(U.loose===K)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof R))return new R(U,K);k("SemVer",U,K),this.loose=K;var X=U.trim().match(K?b[i]:b[o]);if(!X)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var ve=+de;if(ve>=0&&ve<N)return ve}return de}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=Y,e.valid=function(U,K){var X=Y(U,K);return X?X.version:null},e.clean=function(U,K){var X=Y(U.trim().replace(/^[=v]+/,""),K);return X?X.version:null},e.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(U){return k("SemVer.compare",this.version,this.loose,U),U instanceof R||(U=new R(U,this.loose)),this.compareMain(U)||this.comparePre(U)},R.prototype.compareMain=function(U){return U instanceof R||(U=new R(U,this.loose)),M(this.major,U.major)||M(this.minor,U.minor)||M(this.patch,U.patch)},R.prototype.comparePre=function(U){if(U instanceof R||(U=new R(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var K=0;do{var X=this.prerelease[K],de=U.prerelease[K];if(k("prerelease compare",K,X,de),X===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(X===void 0)return-1;if(X!==de)return M(X,de)}while(++K)},R.prototype.inc=function(U,K){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,K,X,de){typeof X=="string"&&(de=X,X=void 0);try{return new R(U,X).inc(K,de).version}catch{return null}},e.diff=function(U,K){if(te(U,K))return null;var X=Y(U),de=Y(K);if(X.prerelease.length||de.prerelease.length){for(var ve in X)if((ve==="major"||ve==="minor"||ve==="patch")&&X[ve]!==de[ve])return"pre"+ve;return"prerelease"}for(var ve in X)if((ve==="major"||ve==="minor"||ve==="patch")&&X[ve]!==de[ve])return ve},e.compareIdentifiers=M;var I=/^[0-9]+$/;function M(U,K){var X=I.test(U),de=I.test(K);return X&&de&&(U=+U,K=+K),X&&!de?-1:de&&!X?1:U<K?-1:U>K?1:0}function F(U,K,X){return new R(U,X).compare(new R(K,X))}function V(U,K,X){return F(U,K,X)>0}function G(U,K,X){return F(U,K,X)<0}function te(U,K,X){return F(U,K,X)===0}function ne(U,K,X){return F(U,K,X)!==0}function ge(U,K,X){return F(U,K,X)>=0}function ye(U,K,X){return F(U,K,X)<=0}function ue(U,K,X,de){var ve;switch(K){case"===":typeof U=="object"&&(U=U.version),typeof X=="object"&&(X=X.version),ve=U===X;break;case"!==":typeof U=="object"&&(U=U.version),typeof X=="object"&&(X=X.version),ve=U!==X;break;case"":case"=":case"==":ve=te(U,X,de);break;case"!=":ve=ne(U,X,de);break;case">":ve=V(U,X,de);break;case">=":ve=ge(U,X,de);break;case"<":ve=G(U,X,de);break;case"<=":ve=ye(U,X,de);break;default:throw new TypeError("Invalid operator: "+K)}return ve}function ce(U,K){if(U instanceof ce){if(U.loose===K)return U;U=U.value}if(!(this instanceof ce))return new ce(U,K);k("comparator",U,K),this.loose=K,this.parse(U),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(U,K){return M(K,U)},e.major=function(U,K){return new R(U,K).major},e.minor=function(U,K){return new R(U,K).minor},e.patch=function(U,K){return new R(U,K).patch},e.compare=F,e.compareLoose=function(U,K){return F(U,K,!0)},e.rcompare=function(U,K,X){return F(K,U,X)},e.sort=function(U,K){return U.sort(function(X,de){return e.compare(X,de,K)})},e.rsort=function(U,K){return U.sort(function(X,de){return e.rcompare(X,de,K)})},e.gt=V,e.lt=G,e.eq=te,e.neq=ne,e.gte=ge,e.lte=ye,e.cmp=ue,e.Comparator=ce;var oe={};function se(U,K){if(U instanceof se)return U.loose===K?U:new se(U.raw,K);if(U instanceof ce)return new se(U.value,K);if(!(this instanceof se))return new se(U,K);if(this.loose=K,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function fe(U){return!U||U.toLowerCase()==="x"||U==="*"}function Te(U,K,X,de,ve,ke,Se,Le,Pe,De,je,Ie,Ne){return((K=fe(X)?"":fe(de)?">="+X+".0.0":fe(ve)?">="+X+"."+de+".0":">="+K)+" "+(Le=fe(Pe)?"":fe(De)?"<"+(+Pe+1)+".0.0":fe(je)?"<"+Pe+"."+(+De+1)+".0":Ie?"<="+Pe+"."+De+"."+je+"-"+Ie:"<="+Le)).trim()}function Fe(U,K){for(var X=0;X<U.length;X++)if(!U[X].test(K))return!1;if(K.prerelease.length){for(X=0;X<U.length;X++)if(k(U[X].semver),U[X].semver!==oe&&U[X].semver.prerelease.length>0){var de=U[X].semver;if(de.major===K.major&&de.minor===K.minor&&de.patch===K.patch)return!0}return!1}return!0}function Oe(U,K,X){try{K=new se(K,X)}catch{return!1}return K.test(U)}function Me(U,K,X,de){var ve,ke,Se,Le,Pe;switch(U=new R(U,de),K=new se(K,de),X){case">":ve=V,ke=ye,Se=G,Le=">",Pe=">=";break;case"<":ve=G,ke=ge,Se=V,Le="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(U,K,de))return!1;for(var De=0;De<K.set.length;++De){var je=K.set[De],Ie=null,Ne=null;if(je.forEach(function(Ce){Ce.semver===oe&&(Ce=new ce(">=0.0.0")),Ie=Ie||Ce,Ne=Ne||Ce,ve(Ce.semver,Ie.semver,de)?Ie=Ce:Se(Ce.semver,Ne.semver,de)&&(Ne=Ce)}),Ie.operator===Le||Ie.operator===Pe||(!Ne.operator||Ne.operator===Le)&&ke(U,Ne.semver)||Ne.operator===Pe&&Se(U,Ne.semver))return!1}return!0}ce.prototype.parse=function(U){var K=this.loose?b[he]:b[B],X=U.match(K);if(!X)throw new TypeError("Invalid comparator: "+U);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new R(X[2],this.loose):this.semver=oe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(U){return k("Comparator.test",U,this.loose),this.semver===oe||(typeof U=="string"&&(U=new R(U,this.loose)),ue(U,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(U,K){if(!(U instanceof ce))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new se(U.value,K),Oe(this.value,X,K);if(U.operator==="")return X=new se(this.value,K),Oe(U.semver,X,K);var de=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),ke=this.semver.version===U.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Le=ue(this.semver,"<",U.semver,K)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),Pe=ue(this.semver,">",U.semver,K)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return de||ve||ke&&Se||Le||Pe},e.Range=se,se.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},se.prototype.toString=function(){return this.range},se.prototype.parseRange=function(U){var K=this.loose;U=U.trim(),k("range",U,K);var X=K?b[z]:b[C];U=U.replace(X,Te),k("hyphen replace",U),U=U.replace(b[j],"$1$2$3"),k("comparator trim",U,b[j]),U=(U=(U=U.replace(b[J],"$1~")).replace(b[pe],"$1^")).split(/\s+/).join(" ");var de=K?b[he]:b[B],ve=U.split(" ").map(function(ke){return function(Se,Le){return k("comp",Se),Se=function(Pe,De){return Pe.trim().split(/\s+/).map(function(je){return function(Ie,Ne){k("caret",Ie,Ne);var Ce=Ne?b[ae]:b[le];return Ie.replace(Ce,function(Ue,Ee,we,be,Re){var Ae;return k("caret",Ie,Ue,Ee,we,be,Re),fe(Ee)?Ae="":fe(we)?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(be)?Ae=Ee==="0"?">="+Ee+"."+we+".0 <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+".0 <"+(+Ee+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ae=Ee==="0"?we==="0"?">="+Ee+"."+we+"."+be+Re+" <"+Ee+"."+we+"."+(+be+1):">="+Ee+"."+we+"."+be+Re+" <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+"."+be+Re+" <"+(+Ee+1)+".0.0"):(k("no pr"),Ae=Ee==="0"?we==="0"?">="+Ee+"."+we+"."+be+" <"+Ee+"."+we+"."+(+be+1):">="+Ee+"."+we+"."+be+" <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+"."+be+" <"+(+Ee+1)+".0.0"),k("caret return",Ae),Ae})}(je,De)}).join(" ")}(Se,Le),k("caret",Se),Se=function(Pe,De){return Pe.trim().split(/\s+/).map(function(je){return function(Ie,Ne){var Ce=Ne?b[re]:b[ie];return Ie.replace(Ce,function(Ue,Ee,we,be,Re){var Ae;return k("tilde",Ie,Ue,Ee,we,be,Re),fe(Ee)?Ae="":fe(we)?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(be)?Ae=">="+Ee+"."+we+".0 <"+Ee+"."+(+we+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ae=">="+Ee+"."+we+"."+be+Re+" <"+Ee+"."+(+we+1)+".0"):Ae=">="+Ee+"."+we+"."+be+" <"+Ee+"."+(+we+1)+".0",k("tilde return",Ae),Ae})}(je,De)}).join(" ")}(Se,Le),k("tildes",Se),Se=function(Pe,De){return k("replaceXRanges",Pe,De),Pe.split(/\s+/).map(function(je){return function(Ie,Ne){Ie=Ie.trim();var Ce=Ne?b[A]:b[S];return Ie.replace(Ce,function(Ue,Ee,we,be,Re,Ae){k("xRange",Ie,Ue,Ee,we,be,Re,Ae);var We=fe(we),ze=We||fe(be),Be=ze||fe(Re);return Ee==="="&&Be&&(Ee=""),We?Ue=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Be?(ze&&(be=0),Be&&(Re=0),Ee===">"?(Ee=">=",ze?(we=+we+1,be=0,Re=0):Be&&(be=+be+1,Re=0)):Ee==="<="&&(Ee="<",ze?we=+we+1:be=+be+1),Ue=Ee+we+"."+be+"."+Re):ze?Ue=">="+we+".0.0 <"+(+we+1)+".0.0":Be&&(Ue=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0"),k("xRange return",Ue),Ue})}(je,De)}).join(" ")}(Se,Le),k("xrange",Se),Se=function(Pe,De){return k("replaceStars",Pe,De),Pe.trim().replace(b[W],"")}(Se,Le),k("stars",Se),Se}(ke,K)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(ke){return!!ke.match(de)})),ve=ve.map(function(ke){return new ce(ke,K)})},se.prototype.intersects=function(U,K){if(!(U instanceof se))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(de){return U.set.some(function(ve){return ve.every(function(ke){return de.intersects(ke,K)})})})})},e.toComparators=function(U,K){return new se(U,K).set.map(function(X){return X.map(function(de){return de.value}).join(" ").trim().split(" ")})},se.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new R(U,this.loose));for(var K=0;K<this.set.length;K++)if(Fe(this.set[K],U))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(U,K,X){var de=null,ve=null;try{var ke=new se(K,X)}catch{return null}return U.forEach(function(Se){ke.test(Se)&&(de&&ve.compare(Se)!==-1||(ve=new R(de=Se,X)))}),de},e.minSatisfying=function(U,K,X){var de=null,ve=null;try{var ke=new se(K,X)}catch{return null}return U.forEach(function(Se){ke.test(Se)&&(de&&ve.compare(Se)!==1||(ve=new R(de=Se,X)))}),de},e.validRange=function(U,K){try{return new se(U,K).range||"*"}catch{return null}},e.ltr=function(U,K,X){return Me(U,K,"<",X)},e.gtr=function(U,K,X){return Me(U,K,">",X)},e.outside=Me,e.prerelease=function(U,K){var X=Y(U,K);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(U,K,X){return U=new se(U,X),K=new se(K,X),U.intersects(K)},e.coerce=function(U){if(U instanceof R)return U;if(typeof U!="string")return null;var K=U.match(b[$]);return K==null?null:Y((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,L(1))},function(x,e){var L,O,k=x.exports={};function T(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function b(E){if(L===setTimeout)return setTimeout(E,0);if((L===T||!L)&&setTimeout)return L=setTimeout,setTimeout(E,0);try{return L(E,0)}catch{try{return L.call(null,E,0)}catch{return L.call(this,E,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:T}catch{L=T}try{O=typeof clearTimeout=="function"?clearTimeout:N}catch{O=N}})();var h,u=[],p=!1,y=-1;function m(){p&&h&&(p=!1,h.length?u=h.concat(u):y=-1,u.length&&P())}function P(){if(!p){var E=b(m);p=!0;for(var c=u.length;c;){for(h=u,u=[];++y<c;)h&&h[y].run();y=-1,c=u.length}h=null,p=!1,function(g){if(O===clearTimeout)return clearTimeout(g);if((O===N||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(g);try{O(g)}catch{try{return O.call(null,g)}catch{return O.call(this,g)}}}(E)}}function v(E,c){this.fun=E,this.array=c}function D(){}k.nextTick=function(E){var c=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)c[g-1]=arguments[g];u.push(new v(E,c)),u.length!==1||p||b(P)},v.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=D,k.addListener=D,k.once=D,k.off=D,k.removeListener=D,k.removeAllListeners=D,k.emit=D,k.prependListener=D,k.prependOnceListener=D,k.listeners=function(E){return[]},k.binding=function(E){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(E){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Z[72],Q([0,1]),function(x,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(b,h,u){this.level=b,this.key=h,this.value=u,this.forward=[]}}const k=void 0;class T{constructor(b,h=2**16){this.comparator=b,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new O(this.c,k,k)}get size(){return this.f}clear(){this.e=new O(this.c,k,k)}has(b){return Boolean(T.g(this,b,this.comparator))}get(b){return T.g(this,b,this.comparator)?.value}set(b,h){return T.h(this,b,h,this.comparator)&&(this.f+=1),this}delete(b){const h=T.k(this,b,this.comparator);return h&&(this.f-=1),h}forEach(b,h){let u=this.e.forward[0];for(;u;)b.call(h,u.value,u.key,this),u=u.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",h=this.e.forward[0];for(;h;)b+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return b}static g(b,h,u){let p=b.e;for(let y=b.d-1;y>=0;y--)for(;p.forward[y]&&u(p.forward[y].key,h)<0;)p=p.forward[y];if(p=p.forward[0],p&&u(p.key,h)===0)return p}static h(b,h,u,p){const y=[];let m=b.e;for(let P=b.d-1;P>=0;P--){for(;m.forward[P]&&p(m.forward[P].key,h)<0;)m=m.forward[P];y[P]=m}if(m=m.forward[0],m&&p(m.key,h)===0)return m.value=u,!1;{const P=T.j(b);if(P>b.d){for(let v=b.d;v<P;v++)y[v]=b.e;b.d=P}m=new O(P,h,u);for(let v=0;v<P;v++)m.forward[v]=y[v].forward[v],y[v].forward[v]=m;return!0}}static j(b,h=.5){let u=1;for(;Math.random()<h&&u<b.c;)u+=1;return u}static k(b,h,u){const p=[];let y=b.e;for(let m=b.d-1;m>=0;m--){for(;y.forward[m]&&u(y.forward[m].key,h)<0;)y=y.forward[m];p[m]=y}if(y=y.forward[0],!y||u(y.key,h)!==0)return!1;for(let m=0;m<b.d&&p[m].forward[m]===y;m++)p[m].forward[m]=y.forward[m];for(;b.d>0&&b.e.forward[b.d-1]===k;)b.d-=1;return!0}}e.SkipList=T}),define(Z[43],Q([0,1,9,2]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(d){const o=d;return o?typeof o.read=="function":!1}e.isReadable=k;function T(d){const o=d;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=T;function N(d){const o=d;return o?T(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=N;function b(d,o){return new h(d,o)}e.newWriteableStream=b;class h{constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,L.onUnexpectedError)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let r;switch(o){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const i=r.indexOf(t);i>=0&&r.splice(i,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(d,o){const t=[];let r;for(;(r=d.read())!==null;)t.push(r);return o(t)}e.consumeReadable=u;function p(d,o,t){const r=[];let i;for(;(i=d.read())!==null&&r.length<t;)r.push(i);return i===null&&r.length>0?o(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return d.read()}}}e.peekReadable=p;function y(d,o){return new Promise((t,r)=>{const i=[];m(d,{onData:n=>{o&&i.push(n)},onError:n=>{o?r(n):t(void 0)},onEnd:()=>{t(o?o(i):void 0)}})})}e.consumeStream=y;function m(d,o){let t=!1;return d.on("error",r=>{t||o.onError(r)}),d.on("end",()=>{t||o.onEnd()}),d.on("data",r=>{t||o.onData(r)}),(0,O.toDisposable)(()=>t=!0)}e.listenStream=m;function P(d,o){return new Promise((t,r)=>{const i=new O.DisposableStore,n=[],s=f=>{if(n.push(f),n.length>o)return i.dispose(),d.pause(),t({stream:d,buffer:n,ended:!1})},l=f=>r(f),a=()=>t({stream:d,buffer:n,ended:!0});i.add((0,O.toDisposable)(()=>d.removeListener("error",l))),d.on("error",l),i.add((0,O.toDisposable)(()=>d.removeListener("end",a))),d.on("end",a),i.add((0,O.toDisposable)(()=>d.removeListener("data",s))),d.on("data",s)})}e.peekStream=P;function v(d,o){const t=b(o);return t.end(d),t}e.toStream=v;function D(){const d=b(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=D;function E(d){let o=!1;return{read:()=>o?null:(o=!0,d)}}e.toReadable=E;function c(d,o,t){const r=b(t);return m(d,{onData:i=>r.write(o.data(i)),onError:i=>r.error(o.error?o.error(i):i),onEnd:()=>r.end()}),r}e.transform=c;function g(d,o,t){let r=!1;return{read:()=>{const i=o.read();return r?i:(r=!0,i!==null?t([d,i]):d)}}}e.prefixedReadable=g;function w(d,o,t){let r=!1;const i=b(t);return m(o,{onData:n=>r?i.write(n):(r=!0,i.write(t([d,n]))),onError:n=>i.error(n),onEnd:()=>{r||(r=!0,i.write(d)),i.end()}}),i}e.prefixedStream=w}),define(Z[15],Q([0,1,43]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer<"u";let k,T;class N{static alloc(f){return O?new N(Buffer.allocUnsafe(f)):new N(new Uint8Array(f))}static wrap(f){return O&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new N(f)}static fromString(f,S){return!(S?.dontUseNodeBuffer||!1)&&O?new N(Buffer.from(f)):(k||(k=new TextEncoder),new N(k.encode(f)))}static fromByteArray(f){const S=N.alloc(f.length);for(let A=0,$=f.length;A<$;A++)S.buffer[A]=f[A];return S}static concat(f,S){if(typeof S>"u"){S=0;for(let H=0,J=f.length;H<J;H++)S+=f[H].byteLength}const A=N.alloc(S);let $=0;for(let H=0,J=f.length;H<J;H++){const ie=f[H];A.set(ie,$),$+=ie.byteLength}return A}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=N.alloc(this.byteLength);return f.set(this),f}toString(){return O?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(f,S){return new N(this.buffer.subarray(f,S))}set(f,S){if(f instanceof N)this.buffer.set(f.buffer,S);else if(f instanceof Uint8Array)this.buffer.set(f,S);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),S);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return u(this.buffer,f)}writeUInt32BE(f,S){p(this.buffer,f,S)}readUInt32LE(f){return y(this.buffer,f)}writeUInt32LE(f,S){m(this.buffer,f,S)}readUInt8(f){return P(this.buffer,f)}writeUInt8(f,S){v(this.buffer,f,S)}}e.VSBuffer=N;function b(a,f){return a[f+0]<<0>>>0|a[f+1]<<8>>>0}e.readUInt16LE=b;function h(a,f,S){a[S+0]=f&255,f=f>>>8,a[S+1]=f&255}e.writeUInt16LE=h;function u(a,f){return a[f]*2**24+a[f+1]*2**16+a[f+2]*2**8+a[f+3]}e.readUInt32BE=u;function p(a,f,S){a[S+3]=f,f=f>>>8,a[S+2]=f,f=f>>>8,a[S+1]=f,f=f>>>8,a[S]=f}e.writeUInt32BE=p;function y(a,f){return a[f+0]<<0>>>0|a[f+1]<<8>>>0|a[f+2]<<16>>>0|a[f+3]<<24>>>0}e.readUInt32LE=y;function m(a,f,S){a[S+0]=f&255,f=f>>>8,a[S+1]=f&255,f=f>>>8,a[S+2]=f&255,f=f>>>8,a[S+3]=f&255}e.writeUInt32LE=m;function P(a,f){return a[f]}e.readUInt8=P;function v(a,f,S){a[S]=f}e.writeUInt8=v;function D(a){return L.consumeReadable(a,f=>N.concat(f))}e.readableToBuffer=D;function E(a){return L.toReadable(a)}e.bufferToReadable=E;function c(a){return L.consumeStream(a,f=>N.concat(f))}e.streamToBuffer=c;async function g(a){return a.ended?N.concat(a.buffer):N.concat([...a.buffer,await c(a.stream)])}e.bufferedStreamToBuffer=g;function w(a){return L.toStream(a,f=>N.concat(f))}e.bufferToStream=w;function d(a){return L.transform(a,{data:f=>typeof f=="string"?N.fromString(f):N.wrap(f)},f=>N.concat(f))}e.streamToBufferReadableStream=d;function o(a){return L.newWriteableStream(f=>N.concat(f),a)}e.newWriteableBufferStream=o;function t(a,f){return L.prefixedReadable(a,f,S=>N.concat(S))}e.prefixedBufferReadable=t;function r(a,f){return L.prefixedStream(a,f,S=>N.concat(S))}e.prefixedBufferStream=r;function i(a){let f=0,S=0,A=0;const $=new Uint8Array(Math.floor(a.length/4*3)),H=ie=>{switch(S){case 3:$[A++]=f|ie,S=0;break;case 2:$[A++]=f|ie>>>2,f=ie<<6,S=3;break;case 1:$[A++]=f|ie>>>4,f=ie<<4,S=2;break;default:f=ie<<2,S=1}};for(let ie=0;ie<a.length;ie++){const re=a.charCodeAt(ie);if(re>=65&&re<=90)H(re-65);else if(re>=97&&re<=122)H(re-97+26);else if(re>=48&&re<=57)H(re-48+52);else if(re===43||re===45)H(62);else if(re===47||re===95)H(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ie]}`)}}const J=A;for(;S>0;)H(0);return N.wrap($).slice(0,J)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:a},f=!0,S=!1){const A=S?s:n;let $="";const H=a.byteLength%3;let J=0;for(;J<a.byteLength-H;J+=3){const ie=a[J+0],re=a[J+1],ee=a[J+2];$+=A[ie>>>2],$+=A[(ie<<4|re>>>4)&63],$+=A[(re<<2|ee>>>6)&63],$+=A[ee&63]}if(H===1){const ie=a[J+0];$+=A[ie>>>2],$+=A[ie<<4&63],f&&($+="==")}else if(H===2){const ie=a[J+0],re=a[J+1];$+=A[ie>>>2],$+=A[(ie<<4|re>>>4)&63],$+=A[re<<2&63],f&&($+="=")}return $}e.encodeBase64=l}),define(Z[30],Q([0,1,4]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const g=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([w,d])=>{g[w]=d&&typeof d=="object"?O(d):d}),g}e.deepClone=O;function k(c){if(!c||typeof c!="object")return c;const g=[c];for(;g.length>0;){const w=g.shift();Object.freeze(w);for(const d in w)if(T.call(w,d)){const o=w[d];typeof o=="object"&&!Object.isFrozen(o)&&!(0,L.isTypedArray)(o)&&g.push(o)}}return c}e.deepFreeze=k;const T=Object.prototype.hasOwnProperty;function N(c,g){return b(c,g,new Set)}e.cloneAndChange=N;function b(c,g,w){if((0,L.isUndefinedOrNull)(c))return c;const d=g(c);if(typeof d<"u")return d;if(Array.isArray(c)){const o=[];for(const t of c)o.push(b(t,g,w));return o}if((0,L.isObject)(c)){if(w.has(c))throw new Error("Cannot clone recursive data-structure");w.add(c);const o={};for(const t in c)T.call(c,t)&&(o[t]=b(c[t],g,w));return w.delete(c),o}return c}function h(c,g,w=!0){return(0,L.isObject)(c)?((0,L.isObject)(g)&&Object.keys(g).forEach(d=>{d in c?w&&((0,L.isObject)(c[d])&&(0,L.isObject)(g[d])?h(c[d],g[d],w):c[d]=g[d]):c[d]=g[d]}),c):g}e.mixin=h;function u(c,g){if(c===g)return!0;if(c==null||g===null||g===void 0||typeof c!=typeof g||typeof c!="object"||Array.isArray(c)!==Array.isArray(g))return!1;let w,d;if(Array.isArray(c)){if(c.length!==g.length)return!1;for(w=0;w<c.length;w++)if(!u(c[w],g[w]))return!1}else{const o=[];for(d in c)o.push(d);o.sort();const t=[];for(d in g)t.push(d);if(t.sort(),!u(o,t))return!1;for(w=0;w<o.length;w++)if(!u(c[o[w]],g[o[w]]))return!1}return!0}e.equals=u;function p(c){const g=new Set;return JSON.stringify(c,(w,d)=>{if((0,L.isObject)(d)||Array.isArray(d)){if(g.has(d))return"[Circular]";g.add(d)}return d})}e.safeStringify=p;function y(c,g){const w=Object.create(null);return!c||!g||Object.keys(g).forEach(o=>{const t=c[o],r=g[o];u(t,r)||(w[o]=r)}),w}e.distinct=y;function m(c,g){const w=g.toLowerCase(),d=Object.keys(c).find(o=>o.toLowerCase()===w);return d?c[d]:c[g]}e.getCaseInsensitive=m;function P(c,g){const w=Object.create(null);for(const[d,o]of Object.entries(c))g(d,o)&&(w[d]=o);return w}e.filter=P;function v(c){let g=[],w=Object.getPrototypeOf(c);for(;Object.prototype!==w;)g=g.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return g}e.getAllPropertyNames=v;function D(c){const g=[];for(const w of v(c))typeof c[w]=="function"&&g.push(w);return g}e.getAllMethodNames=D;function E(c,g){const w=o=>function(){const t=Array.prototype.slice.call(arguments,0);return g(o,t)},d={};for(const o of c)d[o]=w(o);return d}e.createProxyObject=E}),define(Z[31],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(k){return L.test(k)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let h=0;h<b.length;h++)b[h]=Math.floor(Math.random()*256);return b};const T=new Uint8Array(16),N=[];for(let b=0;b<256;b++)N.push(b.toString(16).padStart(2,"0"));return function(){k(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let h=0,u="";return u+=N[T[h++]],u+=N[T[h++]],u+=N[T[h++]],u+=N[T[h++]],u+="-",u+=N[T[h++]],u+=N[T[h++]],u+="-",u+=N[T[h++]],u+=N[T[h++]],u+="-",u+=N[T[h++]],u+=N[T[h++]],u+="-",u+=N[T[h++]],u+=N[T[h++]],u+=N[T[h++]],u+=N[T[h++]],u+=N[T[h++]],u+=N[T[h++]],u}}()}),define(Z[73],Q([0,1,33]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(N){const b=N.replace(/\-/g,":").toLowerCase();return!O.has(b)}function T(){const N=(0,L.networkInterfaces)();for(const b in N){const h=N[b];if(h){for(const{mac:u}of h)if(k(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(Z[74],Q([6,7]),function(x,e){return x.create("vs/base/common/date",e)}),define(Z[75],Q([0,1,74]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,k=O*60,T=k*24,N=T*7,b=T*30,h=T*365;function u(y,m,P){typeof y!="number"&&(y=y.getTime());const v=Math.round((new Date().getTime()-y)/1e3);if(v<-30)return(0,L.localize)(0,null,u(new Date().getTime()+v*1e3,!1));if(v<30)return(0,L.localize)(1,null);let D;return v<O?(D=v,m?D===1?P?(0,L.localize)(2,null,D):(0,L.localize)(3,null,D):P?(0,L.localize)(4,null,D):(0,L.localize)(5,null,D):D===1?P?(0,L.localize)(6,null,D):(0,L.localize)(7,null,D):P?(0,L.localize)(8,null,D):(0,L.localize)(9,null,D)):v<k?(D=Math.floor(v/O),m?D===1?P?(0,L.localize)(10,null,D):(0,L.localize)(11,null,D):P?(0,L.localize)(12,null,D):(0,L.localize)(13,null,D):D===1?P?(0,L.localize)(14,null,D):(0,L.localize)(15,null,D):P?(0,L.localize)(16,null,D):(0,L.localize)(17,null,D)):v<T?(D=Math.floor(v/k),m?D===1?P?(0,L.localize)(18,null,D):(0,L.localize)(19,null,D):P?(0,L.localize)(20,null,D):(0,L.localize)(21,null,D):D===1?P?(0,L.localize)(22,null,D):(0,L.localize)(23,null,D):P?(0,L.localize)(24,null,D):(0,L.localize)(25,null,D)):v<N?(D=Math.floor(v/T),m?D===1?(0,L.localize)(26,null,D):(0,L.localize)(27,null,D):D===1?(0,L.localize)(28,null,D):(0,L.localize)(29,null,D)):v<b?(D=Math.floor(v/N),m?D===1?P?(0,L.localize)(30,null,D):(0,L.localize)(31,null,D):P?(0,L.localize)(32,null,D):(0,L.localize)(33,null,D):D===1?P?(0,L.localize)(34,null,D):(0,L.localize)(35,null,D):P?(0,L.localize)(36,null,D):(0,L.localize)(37,null,D)):v<h?(D=Math.floor(v/b),m?D===1?P?(0,L.localize)(38,null,D):(0,L.localize)(39,null,D):P?(0,L.localize)(40,null,D):(0,L.localize)(41,null,D):D===1?P?(0,L.localize)(42,null,D):(0,L.localize)(43,null,D):P?(0,L.localize)(44,null,D):(0,L.localize)(45,null,D)):(D=Math.floor(v/h),m?D===1?P?(0,L.localize)(46,null,D):(0,L.localize)(47,null,D):P?(0,L.localize)(48,null,D):(0,L.localize)(49,null,D):D===1?P?(0,L.localize)(50,null,D):(0,L.localize)(51,null,D):P?(0,L.localize)(52,null,D):(0,L.localize)(53,null,D))}e.fromNow=u;function p(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=p}),define(Z[76],Q([6,7]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Z[34],Q([0,1,19,4,76]),function(x,e,L,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(y,m){return m&&(y.stack||y.stacktrace)?k.localize(0,null,b(y),N(y.stack)||N(y.stacktrace)):b(y)}function N(y){return Array.isArray(y)?y.join(`
`):y}function b(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?k.localize(1,null,y.message):y.message||k.localize(2,null)}function h(y=null,m=!1){if(!y)return k.localize(3,null);if(Array.isArray(y)){const P=L.coalesce(y),v=h(P[0],m);return P.length>1?k.localize(4,null,v,P.length):v}if(O.isString(y))return y;if(y.detail){const P=y.detail;if(P.error)return T(P.error,m);if(P.exception)return T(P.exception,m)}return y.stack?T(y,m):y.message?y.message:k.localize(5,null)}e.toErrorMessage=h;function u(y){const m=y;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=u;function p(y,m){let P;return typeof y=="string"?P=new Error(y):P=y,P.actions=m,P}e.createErrorWithActions=p}),define(Z[77],Q([6,7]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Z[78],Q([0,1,77]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(k){switch(k){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(Z[51],Q([0,1,12]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(O=e.Source||(e.Source={}));var k;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(b,...h){const u=h.reduce((m,P)=>(m[P]=!0,m),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!u[m]).forEach(m=>{for(let P=0;P<p.length;P++)if(m.search(p[P])!==-1){delete b[m];break}})}e.sanitizeProcessEnvironment=T;function N(b){!b||(delete b.DEBUG,L.isMacintosh&&delete b.DYLD_LIBRARY_PATH,L.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(Z[52],Q([0,1,32]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(c){return k(c,0)}e.hash=O;function k(c,g){switch(typeof c){case"object":return c===null?T(349,g):Array.isArray(c)?h(c,g):u(c,g);case"string":return b(c,g);case"boolean":return N(c,g);case"number":return T(c,g);case"undefined":return T(937,g);default:return T(617,g)}}e.doHash=k;function T(c,g){return(g<<5)-g+c|0}e.numberHash=T;function N(c,g){return T(c?433:863,g)}function b(c,g){g=T(149417,g);for(let w=0,d=c.length;w<d;w++)g=T(c.charCodeAt(w),g);return g}e.stringHash=b;function h(c,g){return g=T(104579,g),c.reduce((w,d)=>k(d,w),g)}function u(c,g){return g=T(181387,g),Object.keys(c).sort().reduce((w,d)=>(w=b(d,w),k(c[d],w)),g)}class p{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=k(g,this.g),this.g}}e.Hasher=p;var y;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function m(c,g,w=32){const d=w-g,o=~((1<<d)-1);return(c<<g|(o&c)>>>d)>>>0}function P(c,g=0,w=c.byteLength,d=0){for(let o=0;o<w;o++)c[g+o]=d}function v(c,g,w="0"){for(;c.length<g;)c=w+c;return c}function D(c,g=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(w=>w.toString(16).padStart(2,"0")).join(""):v((c>>>0).toString(16),g/4)}e.toHexString=D;class E{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const w=g.length;if(w===0)return;const d=this.p;let o=this.r,t=this.u,r,i;for(t!==0?(r=t,i=-1,t=0):(r=g.charCodeAt(0),i=0);;){let n=r;if(L.isHighSurrogate(r))if(i+1<w){const s=g.charCodeAt(i+1);L.isLowSurrogate(s)?(i++,n=L.computeCodePoint(r,s)):n=65533}else{t=r;break}else L.isLowSurrogate(r)&&(n=65533);if(o=this.w(d,o,n),i++,i<w)r=g.charCodeAt(i);else break}this.r=o,this.u=t}w(g,w,d){return d<128?g[w++]=d:d<2048?(g[w++]=192|(d&1984)>>>6,g[w++]=128|(d&63)>>>0):d<65536?(g[w++]=224|(d&61440)>>>12,g[w++]=128|(d&4032)>>>6,g[w++]=128|(d&63)>>>0):(g[w++]=240|(d&1835008)>>>18,g[w++]=128|(d&258048)>>>12,g[w++]=128|(d&4032)>>>6,g[w++]=128|(d&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),D(this.h)+D(this.l)+D(this.m)+D(this.n)+D(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=E.g,w=this.q;for(let a=0;a<64;a+=4)g.setUint32(a,w.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,m(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let d=this.h,o=this.l,t=this.m,r=this.n,i=this.o,n,s,l;for(let a=0;a<80;a++)a<20?(n=o&t|~o&r,s=1518500249):a<40?(n=o^t^r,s=1859775393):a<60?(n=o&t|o&r|t&r,s=2400959708):(n=o^t^r,s=3395469782),l=m(d,5)+n+i+s+g.getUint32(a*4,!1)&4294967295,i=r,r=t,t=m(o,30),o=d,d=l;this.h=this.h+d&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=E,E.g=new DataView(new ArrayBuffer(320))}),define(Z[53],Q([0,1,32]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(O||(O={})),function(k){const T="error",N="warning",b="warn",h="info",u="ignore";function p(m){return m?L.equalsIgnoreCase(T,m)?k.Error:L.equalsIgnoreCase(N,m)||L.equalsIgnoreCase(b,m)?k.Warning:L.equalsIgnoreCase(h,m)?k.Info:k.Ignore:k.Ignore}k.fromValue=p;function y(m){switch(m){case k.Error:return T;case k.Warning:return N;case k.Info:return h;default:return u}}k.toString=y}(O||(O={})),e.default=O}),define(Z[79],Q([0,1,11]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(u){const p=u;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.isRemoteConsoleLog=O;function k(u){const p=[];let y;try{const m=JSON.parse(u.arguments),P=m[m.length-1];P&&P.__$stack&&(m.pop(),y=P.__$stack),p.push(...m)}catch{p.push("Unable to log remote console arguments",u.arguments)}return{args:p,stack:y}}e.parse=k;function T(u){if(typeof u!="string")return T(k(u).stack);const p=u;if(p){const y=N(p),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(m&&m.length===4)return{uri:L.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=T;function N(u){if(!u)return u;const p=u.indexOf(`
`);return p===-1?u:u.substring(0,p)}function b(u,p){const{args:y,stack:m}=k(u),P=typeof y[0]=="string"&&y.length===1;let v=N(m);v&&(v=`(${v.trim()})`);let D=[];if(typeof y[0]=="string"?v&&P?D=[`%c[${p}] %c${y[0]} %c${v}`,h("blue"),h(""),h("grey")]:D=[`%c[${p}] %c${y[0]}`,h("blue"),h(""),...y.slice(1)]:D=[`%c[${p}]%`,h("blue"),...y],v&&!P&&D.push(v),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,D)}e.log=b;function h(u){return`color: ${u}`}}),define(Z[44],Q([0,1,15,32,11]),function(x,e,L,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(u){return JSON.stringify(u,b)}e.stringify=T;function N(u){let p=JSON.parse(u);return p=h(p),p}e.parse=N;function b(u,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,O.regExpFlags)(p)}:p}function h(u,p=0){if(!u||p>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return k.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof L.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let y=0;y<u.length;++y)u[y]=h(u[y],p+1);else for(const y in u)Object.hasOwnProperty.call(u,y)&&(u[y]=h(u[y],p+1))}return u}e.revive=h}),define(Z[80],Q([0,1,33,9,54,31,73]),function(x,e,L,O,k,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(p){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,y=0;const m=(0,L.networkInterfaces)();for(const P in m){const v=m[P];if(v)for(const{mac:D,internal:E}of v)E||(y+=1,this.c(D.toUpperCase())&&(p+=1))}this.b=y>0?p/y:0}return this.b}};let b;async function h(){return b||(b=(async()=>await u()||T.generateUuid())()),b}e.getMachineId=h;async function u(){try{const p=await new Promise((m,P)=>{x(["crypto"],m,P)}),y=(0,N.getMac)();return p.createHash("sha256").update(y,"utf8").digest("hex")}catch(p){O.onUnexpectedError(p);return}}}),define(Z[81],Q([0,1,33,14,20]),function(x,e,L,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,N=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var h;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(h||(h={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class y{constructor(o,t,r){this.exePath=o,this.displayName=t,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:d=!1}={}){return d?u===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function P({useAlternateBitness:d=!1,findPreview:o=!1}={}){const t=m({useAlternateBitness:d});if(!t)return null;const r=O.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let i=-1,n=null;for(const a of await k.Promises.readdir(r)){let f=-1;if(o){const A=a.indexOf("-");if(A<0)continue;const $=a.substring(0,A);if(!T.test($)||a.substring(A+1)!=="preview")continue;f=parseInt($,10)}else{if(!T.test(a))continue;f=parseInt(a,10)}if(f<=i)continue;const S=O.join(r,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(S)||(n=S,i=f)}if(!n)return null;const s=t.includes("x86")?" (x86)":"",l=o?" Preview":"";return new y(n,`PowerShell${l}${s}`,!0)}async function v({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const o=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=d?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(o))if(t.test(i)){const n=O.join(o,i,"pwsh.exe");return new y(n,r)}return null}function D(){const d=O.join(L.homedir(),".dotnet","tools","pwsh.exe");return new y(d,".NET Core PowerShell Global Tool")}function E(){const d=O.join(process.env.windir,u===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(d,"Windows PowerShell",!0)}async function*c(){let d=await P();d&&(yield d),d=await P({useAlternateBitness:!0}),d&&(yield d),d=await v(),d&&(yield d),d=D(),d&&(yield d),d=await P({findPreview:!0}),d&&(yield d),d=await v({findPreview:!0}),d&&(yield d),d=await P({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=E(),d&&(yield d)}async function*g(){for await(const d of c())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=g;async function w(){for await(const d of g())return d;return null}e.getFirstAvailablePowerShellInstallation=w}),define(Z[55],Q([0,1,14,12,35,51,4,20]),function(x,e,L,O,k,T,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function h(y=k.env){return y.comspec||"cmd.exe"}e.getWindowsShell=h;function u(y){let m=[],P=!1;const v=function(D){if(P){m.push(D);return}(!y.send(D,c=>{if(c&&console.error(c),P=!1,m.length>0){const g=m.slice(0);m=[],g.forEach(w=>v(w))}})||O.isWindows)&&(P=!0)};return{send:v}}e.createQueuedSender=u;var p;(function(y){async function m(P,v,D){if(L.isAbsolute(P))return P;if(v===void 0&&(v=k.cwd()),L.dirname(P)!=="."||(D===void 0&&N.isString(k.env.PATH)&&(D=k.env.PATH.split(L.delimiter)),D===void 0||D.length===0))return L.join(v,P);async function c(g){if(await b.Promises.exists(g)){let w;try{w=await b.Promises.stat(g)}catch(d){d.message.startsWith("EACCES")&&(w=await b.Promises.lstat(g))}return w?!w.isDirectory():!1}return!1}for(const g of D){let w;if(L.isAbsolute(g)?w=L.join(g,P):w=L.join(v,g,P),await c(w))return w;let d=w+".com";if(await c(d)||(d=w+".exe",await c(d)))return d}return L.join(v,P)}y.findExecutable=m})(p=e.win32||(e.win32={}))}),define(Z[82],Q([0,1,33,12,81,55]),function(x,e,L,O,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function N(y,m){return y===1?O.isWindows?p():T.getWindowsShell(m):h(y,m)}e.getSystemShell=N;let b=null;function h(y,m){if(O.isLinux&&y===2||O.isMacintosh&&y===3)return"/bin/bash";if(!b){let P;if(O.isWindows)P="/bin/bash";else{if(P=m.SHELL,!P)try{P=(0,L.userInfo)().shell}catch{}P||(P="sh"),P==="/bin/false"&&(P="/bin/bash")}b=P}return b}let u=null;async function p(){return u||(u=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),u}});var me=this&&this.__decorate||function(x,e,L,O){var k=arguments.length,T=k<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,L):O,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(x,e,L,O);else for(var b=x.length-1;b>=0;b--)(N=x[b])&&(T=(k<3?N(T):k>3?N(e,L,T):N(e,L))||T);return k>3&&T&&Object.defineProperty(e,L,T),T};define(Z[56],Q([0,1,19,5,15,22,49,9,3,2,44,32,4]),function(x,e,L,O,k,T,N,b,h,u,p,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var P;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(P||(P={}));function v(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var D;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(D||(D={}));function E(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(c||(c={}));function g(j){let C=0;for(let z=0;;z+=7){const W=j.read(1);if(C|=(W.buffer[0]&127)<<z,!(W.buffer[0]&128))return C}}const w=i(0);function d(j,C){if(C===0){j.write(w);return}let z=0;for(let q=C;q!==0;q=q>>>7)z++;const W=k.VSBuffer.alloc(z);for(let q=0;C!==0;q++)W.buffer[q]=C&127,C=C>>>7,C>0&&(W.buffer[q]|=128);j.write(W)}class o{constructor(C){this.b=C,this.a=0}read(C){const z=this.b.slice(this.a,this.a+C);return this.a+=z.byteLength,z}}e.BufferReader=o;class t{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(C){this.a.push(C)}}e.BufferWriter=t;var r;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(r||(r={}));function i(j){const C=k.VSBuffer.alloc(1);return C.writeUInt8(j,0),C}const n={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object),Uint:i(r.Int)},s=typeof Buffer<"u";function l(j,C){if(typeof C>"u")j.write(n.Undefined);else if(typeof C=="string"){const z=k.VSBuffer.fromString(C);j.write(n.String),d(j,z.byteLength),j.write(z)}else if(s&&Buffer.isBuffer(C)){const z=k.VSBuffer.wrap(C);j.write(n.Buffer),d(j,z.byteLength),j.write(z)}else if(C instanceof k.VSBuffer)j.write(n.VSBuffer),d(j,C.byteLength),j.write(C);else if(Array.isArray(C)){j.write(n.Array),d(j,C.length);for(const z of C)l(j,z)}else if(typeof C=="number"&&(C|0)===C)j.write(n.Uint),d(j,C);else{const z=k.VSBuffer.fromString(JSON.stringify(C));j.write(n.Object),d(j,z.byteLength),j.write(z)}}e.serialize=l;function a(j){switch(j.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return j.read(g(j)).toString();case r.Buffer:return j.read(g(j)).buffer;case r.VSBuffer:return j.read(g(j));case r.Array:{const z=g(j),W=[];for(let q=0;q<z;q++)W.push(a(j));return W}case r.Object:return JSON.parse(j.read(g(j)).toString());case r.Int:return g(j)}}e.deserialize=a;class f{constructor(C,z,W=null,q=1e3){this.h=C,this.j=z,this.k=W,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(C,z){this.b.set(C,z),setTimeout(()=>this.w(C),0)}m(C){switch(C.type){case 200:{const z=this.o([C.type]);this.k?.logOutgoing(z,0,1,E(C.type));return}case 201:case 202:case 204:case 203:{const z=this.o([C.type,C.id],C.data);this.k?.logOutgoing(z,C.id,1,E(C.type),C.data);return}}}o(C,z=void 0){const W=new t;return l(W,C),l(W,z),this.p(W.buffer)}p(C){try{return this.h.send(C),C.byteLength}catch{return 0}}q(C){const z=new o(C),W=a(z),q=a(z),Y=W[0];switch(Y){case 100:return this.k?.logIncoming(C.byteLength,W[1],1,`${v(Y)}: ${W[2]}.${W[3]}`,q),this.s({type:Y,id:W[1],channelName:W[2],name:W[3],arg:q});case 102:return this.k?.logIncoming(C.byteLength,W[1],1,`${v(Y)}: ${W[2]}.${W[3]}`,q),this.t({type:Y,id:W[1],channelName:W[2],name:W[3],arg:q});case 101:return this.k?.logIncoming(C.byteLength,W[1],1,`${v(Y)}`),this.u({type:Y,id:W[1]});case 103:return this.k?.logIncoming(C.byteLength,W[1],1,`${v(Y)}`),this.u({type:Y,id:W[1]})}}s(C){const z=this.b.get(C.channelName);if(!z){this.v(C);return}const W=new T.CancellationTokenSource;let q;try{q=z.call(this.j,C.name,C.arg,W.token)}catch(I){q=Promise.reject(I)}const Y=C.id;q.then(I=>{this.m({id:Y,data:I,type:201}),this.d.delete(C.id)},I=>{I instanceof Error?this.m({id:Y,data:{message:I.message,name:I.name,stack:I.stack?I.stack.split?I.stack.split(`
`):I.stack:void 0},type:202}):this.m({id:Y,data:I,type:203}),this.d.delete(C.id)});const R=(0,u.toDisposable)(()=>W.cancel());this.d.set(C.id,R)}t(C){const z=this.b.get(C.channelName);if(!z){this.v(C);return}const W=C.id,Y=z.listen(this.j,C.name,C.arg)(R=>this.m({id:W,data:R,type:204}));this.d.set(C.id,Y)}u(C){const z=this.d.get(C.id);z&&(z.dispose(),this.d.delete(C.id))}v(C){let z=this.g.get(C.channelName);z||(z=[],this.g.set(C.channelName,z));const W=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.m({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:C,timeoutTimer:W})}w(C){const z=this.g.get(C);if(z){for(const W of z)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.s(W.request);break;case 102:this.t(W.request);break}this.g.delete(C)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=f;var S;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(C,z=null){this.l=C,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(W=>this.s(W)),this.j=z}getChannel(C){const z=this;return{call(W,q,Y){return z.a?Promise.reject(new b.CancellationError):z.m(C,W,q,Y)},listen(W,q){return z.a?h.Event.None:z.o(C,W,q)}}}m(C,z,W,q=T.CancellationToken.None){const Y=this.g++,I={id:Y,type:100,channelName:C,name:z,arg:W};if(q.isCancellationRequested)return Promise.reject(new b.CancellationError);let M;return new Promise((V,G)=>{if(q.isCancellationRequested)return G(new b.CancellationError);const te=()=>{const ue=ce=>{switch(ce.type){case 201:this.f.delete(Y),V(ce.data);break;case 202:{this.f.delete(Y);const oe=new Error(ce.data.message);oe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,oe.name=ce.data.name,G(oe);break}case 203:this.f.delete(Y),G(ce.data);break}};this.f.set(Y,ue),this.p(I)};let ne=null;this.b===c.Idle?te():(ne=(0,O.createCancelablePromise)(ue=>this.u()),ne.then(()=>{ne=null,te()}));const ge=()=>{ne?(ne.cancel(),ne=null):this.p({id:Y,type:101}),G(new b.CancellationError)},ye=q.onCancellationRequested(ge);M=(0,u.combinedDisposable)((0,u.toDisposable)(ge),ye),this.d.add(M)}).finally(()=>{this.d.delete(M)})}o(C,z,W){const q=this.g++,R={id:q,type:102,channelName:C,name:z,arg:W};let I=null;const M=new h.Emitter({onWillAddFirstListener:()=>{I=(0,O.createCancelablePromise)(V=>this.u()),I.then(()=>{I=null,this.d.add(M),this.p(R)})},onDidRemoveLastListener:()=>{I?(I.cancel(),I=null):(this.d.delete(M),this.p({id:q,type:103}))}}),F=V=>M.fire(V.data);return this.f.set(q,F),M.event}p(C){switch(C.type){case 100:case 102:{const z=this.q([C.type,C.id,C.channelName,C.name],C.arg);this.j?.logOutgoing(z,C.id,0,`${v(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const z=this.q([C.type,C.id]);this.j?.logOutgoing(z,C.id,0,v(C.type));return}}}q(C,z=void 0){const W=new t;return l(W,C),l(W,z),this.r(W.buffer)}r(C){try{return this.l.send(C),C.byteLength}catch{return 0}}s(C){const z=new o(C),W=a(z),q=a(z),Y=W[0];switch(Y){case 200:return this.j?.logIncoming(C.byteLength,0,0,E(Y)),this.t({type:W[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(C.byteLength,W[1],0,E(Y),q),this.t({type:W[0],id:W[1],data:q})}}t(C){if(C.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(C.id)?.(C)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.dispose)(this.d.values()),this.d.clear()}}me([N.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class ${get connections(){const C=[];return this.f.forEach(z=>C.push(z)),C}constructor(C){this.a=new Map,this.f=new Set,this.g=new h.Emitter,this.onDidAddConnection=this.g.event,this.h=new h.Emitter,this.onDidRemoveConnection=this.h.event,C(({protocol:z,onDidClientDisconnect:W})=>{h.Event.once(z.onMessage)(Y=>{const R=new o(Y),I=a(R),M=new f(z,I),F=new A(z);this.a.forEach((G,te)=>M.registerChannel(te,G));const V={channelServer:M,channelClient:F,ctx:I};this.f.add(V),this.g.fire(V),W(()=>{M.dispose(),F.dispose(),this.f.delete(V),this.h.fire(V)})})})}getChannel(C,z){const W=this;return{call(q,Y,R){let I;if((0,m.isFunction)(z)){const F=(0,L.getRandomElement)(W.connections.filter(z));I=F?Promise.resolve(F):h.Event.toPromise(h.Event.filter(W.onDidAddConnection,z))}else I=z.routeCall(W,q,Y);const M=I.then(F=>F.channelClient.getChannel(C));return J(M).call(q,Y,R)},listen(q,Y){if((0,m.isFunction)(z))return W.j(C,z,q,Y);const R=z.routeEvent(W,q,Y).then(I=>I.channelClient.getChannel(C));return J(R).listen(q,Y)}}}j(C,z,W,q){const Y=this;let R=new u.DisposableStore;const I=new h.Emitter({onWillAddFirstListener:()=>{R=new u.DisposableStore;const M=new h.EventMultiplexer,F=new Map,V=te=>{const ge=te.channelClient.getChannel(C).listen(W,q),ye=M.add(ge);F.set(te,ye)},G=te=>{const ne=F.get(te);!ne||(ne.dispose(),F.delete(te))};Y.connections.filter(z).forEach(V),h.Event.filter(Y.onDidAddConnection,z)(V,void 0,R),Y.onDidRemoveConnection(G,void 0,R),M.event(I.fire,I,R),R.add(M)},onDidRemoveLastListener:()=>{R.dispose()}});return I.event}registerChannel(C,z){this.a.set(C,z),this.f.forEach(W=>{W.channelServer.registerChannel(C,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=$;class H{constructor(C,z,W=null){const q=new t;l(q,z),C.send(q.buffer),this.a=new A(C,W),this.d=new f(C,z,W)}getChannel(C){return this.a.getChannel(C)}registerChannel(C,z){this.d.registerChannel(C,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=H;function J(j){return{call(C,z,W){return j.then(q=>q.call(C,z,W))},listen(C,z){const W=new h.Relay;return j.then(q=>W.input=q.listen(C,z)),W.event}}}e.getDelayedChannel=J;function ie(j){let C=!1;return{call(z,W,q){return C?j.call(z,W,q):(0,O.timeout)(0).then(()=>C=!0).then(()=>j.call(z,W,q))},listen(z,W){if(C)return j.listen(z,W);const q=new h.Relay;return(0,O.timeout)(0).then(()=>C=!0).then(()=>q.input=j.listen(z,W)),q.event}}}e.getNextTickChannel=ie;class re{constructor(C){this.a=C}routeCall(C){return this.b(C)}routeEvent(C){return this.b(C)}async b(C){for(const z of C.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await h.Event.toPromise(C.onDidAddConnection),await this.b(C)}}e.StaticRouter=re;var ee;(function(j){function C(Y,R){const I=Y,M=R&&R.disableMarshalling,F=new Map;for(const V in I)W(V)&&F.set(V,h.Event.buffer(I[V],!0));return new class{listen(V,G,te){const ne=F.get(G);if(ne)return ne;if(q(G)){const ge=I[G];if(typeof ge=="function")return ge.call(I,te)}throw new Error(`Event not found: ${G}`)}call(V,G,te){const ne=I[G];if(typeof ne=="function"){if(!M&&Array.isArray(te))for(let ge=0;ge<te.length;ge++)te[ge]=(0,p.revive)(te[ge]);return ne.apply(I,te)}throw new Error(`Method not found: ${G}`)}}}j.fromService=C;function z(Y,R){const I=R&&R.disableMarshalling;return new Proxy({},{get(M,F){if(typeof F=="string")return R?.properties?.has(F)?R.properties.get(F):q(F)?function(V){return Y.listen(F,V)}:W(F)?Y.listen(F):async function(...V){let G;R&&!(0,m.isUndefinedOrNull)(R.context)?G=[R.context,...V]:G=V;const te=await Y.call(F,G);return I?te:(0,p.revive)(te)};throw new Error(`Property not found: ${String(F)}`)}})}j.toService=z;function W(Y){return Y[0]==="o"&&Y[1]==="n"&&y.isUpperAsciiLetter(Y.charCodeAt(2))}function q(Y){return/^onDynamic/.test(Y)&&y.isUpperAsciiLetter(Y.charCodeAt(9))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const pe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const C=j.toString();if(C!=="[object Object]")return C}return j}function ae(j){return Array.isArray(j)?j.map(le):le(j)}function he(j,C,z,W,q,Y,R){R=ae(R);const I=pe[q],M=I[W%I.length];let F=[`%c[${j}]%c[${String(C).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(Y)?(F=F.concat(R),F.push(")")):F.push(R),console.log.apply(console,F)}class B{constructor(C,z){this.d=C,this.f=z,this.a=0,this.b=0}logOutgoing(C,z,W,q,Y){this.b+=C,he(this.d,this.b,C,z,W,q,Y)}logIncoming(C,z,W,q,Y){this.a+=C,he(this.f,this.a,C,z,W,q,Y)}}e.IPCLogger=B}),define(Z[83],Q([0,1,57,5,15,22,79,9,3,2,30,55,51,56]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends P.ChannelServer{constructor(c){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",g=>k.VSBuffer.wrap(Buffer.from(g,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.Server=v;class D{constructor(c,g){this.i=c,this.j=g,this.c=new Set,this.g=new Map,this.h=new h.Emitter,this.onDidProcessExit=this.h.event;const w=g&&g.timeout?g.timeout:6e4;this.b=new O.Delayer(w),this.d=null,this.f=null}getChannel(c){const g=this;return{call(w,d,o){return g.k(c,w,d,o)},listen(w,d){return g.l(c,w,d)}}}k(c,g,w,d=T.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(b.canceled());this.b.cancel();const o=this.n(c),t=(0,O.createCancelablePromise)(n=>o.call(g,w,n)),r=d.onCancellationRequested(()=>t.cancel()),i=(0,u.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{r.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,g,w){if(!this.b)return h.Event.None;this.b.cancel();let d;const o=new h.Emitter({onWillAddFirstListener:()=>{d=this.n(c).listen(g,w)(o.fire,o),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,m.removeDangerousEnvVariables)(g.env),this.d=(0,L.fork)(this.i,c,g);const w=new h.Emitter;h.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,N.isRemoteConsoleLog)(s)){(0,N.log)(s,`IPC Library: ${this.j.serverName}`);return}w.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const o=this.j.useQueue?(0,y.createQueuedSender)(this.d):this.d,t=s=>this.d&&this.d.connected&&o.send(s.buffer.toString("base64")),r=w.event,i={send:t,onMessage:r};this.f=new P.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,l)=>{process.removeListener("exit",n),this.c.forEach(a=>(0,u.dispose)(a)),this.c.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:l})})}return this.f}n(c){let g=this.g.get(c);return g||(g=this.m.getChannel(c),this.g.set(c,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=D}),define(Z[84],Q([0,1,5,3,2,4]),function(x,e,L,O,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N=e.StorageHint||(e.StorageHint={}));function b(y){const m=y;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var h;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(h=e.StorageState||(e.StorageState={}));class u extends k.Disposable{constructor(m,P=Object.create(null)){super(),this.m=m,this.n=P,this.b=this.B(new O.Emitter),this.onDidChangeStorage=this.b.event,this.c=h.None,this.f=new Map,this.g=new L.ThrottledDelayer(u.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){m.changed?.forEach((P,v)=>this.s(v,P)),m.deleted?.forEach(P=>this.s(P,void 0))}s(m,P){if(this.c===h.Closed)return;let v=!1;(0,T.isUndefinedOrNull)(P)?v=this.f.delete(m):this.f.get(m)!==P&&(this.f.set(m,P),v=!0),v&&this.b.fire(m)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===h.None&&(this.c=h.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,P){const v=this.f.get(m);return(0,T.isUndefinedOrNull)(v)?P:v}getBoolean(m,P){const v=this.get(m);return(0,T.isUndefinedOrNull)(v)?P:v==="true"}getNumber(m,P){const v=this.get(m);return(0,T.isUndefinedOrNull)(v)?P:parseInt(v,10)}async set(m,P){if(this.c===h.Closed)return;if((0,T.isUndefinedOrNull)(P))return this.delete(m);const v=String(P);if(this.f.get(m)!==v)return this.f.set(m,v),this.j.set(m,v),this.h.delete(m),this.b.fire(m),this.w()}async delete(m){if(!(this.c===h.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire(m),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=h.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(!!this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(!!this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===N.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=u,u.a=100;class p{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((P,v)=>this.a.set(v,P)),m.delete?.forEach(P=>this.a.delete(P))}async close(){}}e.InMemoryStorageDatabase=p}),define(Z[85],Q([6,7]),function(x,e){return x.create("vs/base/node/zip",e)}),define(Z[86],Q([6,7]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[87],Q([6,7]),function(x,e){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[88],Q([6,7]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[89],Q([6,7]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Z[90],Q([6,7]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[91],Q([6,7]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[92],Q([6,7]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[93],Q([6,7]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[94],Q([6,7]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[95],Q([6,7]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Z[96],Q([6,7]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Z[97],Q([6,7]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[98],Q([6,7]),function(x,e){return x.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Z[99],Q([6,7]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Z[100],Q([6,7]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Z[101],Q([6,7]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[102],Q([6,7]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[103],Q([6,7]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Z[104],Q([0,1,75,49,16,14,35,17,11]),function(x,e,L,O,k,T,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,T.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return h.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(h.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=N.env.VSCODE_PORTABLE;return v?h.URI.file((0,T.join)(v,"argv.json")):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,T.resolve)(v):(0,T.normalize)((0,T.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?h.URI.file((0,T.resolve)(v)):h.URI.file((0,T.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,T.resolve)(v);const D=N.env.VSCODE_EXTENSIONS;if(D)return D;const E=N.env.VSCODE_PORTABLE;return E?(0,T.join)(E,"extensions"):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(D=>/^[^:/?#]+?:\/\//.test(D)?h.URI.parse(D):h.URI.file((0,T.normalize)(D)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?h.URI.parse(v):h.URI.file((0,T.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const D of this.args.log||[]){const E=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(D);E&&E[1]&&E[2]&&v.push([E[1],E[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,b.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return h.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=N.env.VSCODE_PORTABLE;return v?h.URI.file((0,T.join)(v,"policy.json")):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this.a}constructor(v,D,E){this.a=v,this.b=D,this.c=E,this.editSessionId=this.args.editSessionId}}me([O.memoize],u.prototype,"appRoot",null),me([O.memoize],u.prototype,"userHome",null),me([O.memoize],u.prototype,"userDataPath",null),me([O.memoize],u.prototype,"appSettingsHome",null),me([O.memoize],u.prototype,"tmpDir",null),me([O.memoize],u.prototype,"cacheHome",null),me([O.memoize],u.prototype,"stateResource",null),me([O.memoize],u.prototype,"userRoamingDataHome",null),me([O.memoize],u.prototype,"userDataSyncHome",null),me([O.memoize],u.prototype,"userDataSyncLogResource",null),me([O.memoize],u.prototype,"editSessionsLogResource",null),me([O.memoize],u.prototype,"sync",null),me([O.memoize],u.prototype,"machineSettingsResource",null),me([O.memoize],u.prototype,"workspaceStorageHome",null),me([O.memoize],u.prototype,"localHistoryHome",null),me([O.memoize],u.prototype,"keyboardLayoutResource",null),me([O.memoize],u.prototype,"argvResource",null),me([O.memoize],u.prototype,"isExtensionDevelopment",null),me([O.memoize],u.prototype,"untitledWorkspacesHome",null),me([O.memoize],u.prototype,"installSourcePath",null),me([O.memoize],u.prototype,"builtinExtensionsPath",null),me([O.memoize],u.prototype,"extensionsPath",null),me([O.memoize],u.prototype,"extensionDevelopmentLocationURI",null),me([O.memoize],u.prototype,"extensionDevelopmentKind",null),me([O.memoize],u.prototype,"extensionTestsLocationURI",null),me([O.memoize],u.prototype,"debugExtensionHost",null),me([O.memoize],u.prototype,"logLevel",null),me([O.memoize],u.prototype,"extensionLogLevel",null),me([O.memoize],u.prototype,"serviceMachineIdResource",null),me([O.memoize],u.prototype,"telemetryLogResource",null),me([O.memoize],u.prototype,"disableWorkspaceTrust",null),me([O.memoize],u.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=u;function p(P,v){return m(P["inspect-extensions"],P["inspect-brk-extensions"],5870,v,P.debugId,P.extensionEnvironment)}e.parseExtensionHostPort=p;function y(P,v){return m(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,v,P.extensionEnvironment)}e.parsePtyHostPort=y;function m(P,v,D,E,c,g){const d=Number(v||P)||(E?null:D),o=d?Boolean(!!v):!1;let t;if(g)try{t=JSON.parse(g)}catch{}return{port:d,break:o,debugId:c,env:t}}}),function(){"use strict";function x(e,L,O){function k(N,b){const h=T(N,b),u=[h];return e.isAbsolute(h)||u.unshift(O),e.resolve(...u)}function T(N,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,b);const p=N["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(y,"AppData","Roaming")}break;case"darwin":u=e.join(L.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,b)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[105],Q([155,33,35]),function(e,L,O){return x(e,L,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=x(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[106],Q([0,1,33,104,105]),function(x,e,L,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends O.AbstractNativeEnvironmentService{constructor(b,h){super(b,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,k.getUserDataPath)(b,h.nameShort)},h)}}e.NativeEnvironmentService=T}),define(Z[107],Q([0,1,4,90]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(N,b,h){try{T(N,b,h)}catch(u){console.error(u?.message??u)}return N}e.localizeManifest=k;function T(N,b,h){const u=(p,y,m)=>{const P=p[y];if((0,L.isString)(P)){const v=P,D=v.length;if(D>1&&v[0]==="%"&&v[D-1]==="%"){const E=v.substr(1,D-2);let c=b[E];c===void 0&&h&&(c=h[E]);const g=typeof c=="string"?c:c?.message,w=h?.[E],d=typeof w=="string"?w:w?.message;if(!g){d||console.warn(`[${N.name}]: ${(0,O.localize)(0,null,E)}`);return}if(m&&(y==="title"||y==="category")&&d&&d!==g){const o={value:g,original:d};p[y]=o}else p[y]=g}}else if((0,L.isObject)(P))for(const v in P)P.hasOwnProperty(v)&&(v==="commands"?u(P,v,!0):u(P,v,m));else if(Array.isArray(P))for(let v=0;v<P.length;v++)u(P,v,m)};for(const p in N)N.hasOwnProperty(p)&&u(N,p)}}),define(Z[108],Q([0,1,9]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class O{constructor(){this.a=new Map}register(T,N){this.a.set(T,N)}updateManifest(T){if(!(typeof T.main>"u"&&typeof T.browser>"u")&&(T.activationEvents===void 0&&Object.assign(T,{activationEvents:[]}),!(!Array.isArray(T.activationEvents)||!T.contributes)))for(const N in T.contributes){const b=this.a.get(N);if(!b)continue;const h=T.contributes[N],u=Array.isArray(h)?h:[h];try{b(u,T.activationEvents)}catch(p){(0,L.onUnexpectedError)(p)}}}}e.ImplicitActivationEventsImpl=O,e.ImplicitActivationEvents=new O}),define(Z[45],Q([0,1,17,53,94,40]),function(x,e,L,O,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function h(c){return c=c.trim(),c==="*"||N.test(c)}e.isValidVersionStr=h;function u(c){if(!h(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=c.match(N);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=u;function p(c){if(!c)return null;const g=c.majorBase,w=c.majorMustEqual,d=c.minorBase;let o=c.minorMustEqual;const t=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(g===0||(o=!1),r=!1);let i=0;if(c.preRelease){const n=b.exec(c.preRelease);if(n){const[,s,l,a]=n;i=Date.UTC(Number(s),Number(l)-1,Number(a))}}return{majorBase:g,majorMustEqual:w,minorBase:d,minorMustEqual:o,patchBase:t,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:i}}e.normalizeVersion=p;function y(c,g,w){let d;typeof c=="string"?d=p(u(c)):d=c;let o;g instanceof Date?o=g.getTime():typeof g=="string"&&(o=new Date(g).getTime());let t;if(typeof w=="string"?t=p(u(w)):t=w,!d||!t)return!1;const r=d.majorBase,i=d.minorBase,n=d.patchBase;let s=t.majorBase,l=t.minorBase,a=t.patchBase;const f=t.notBefore;let S=t.majorMustEqual,A=t.minorMustEqual,$=t.patchMustEqual;return t.isMinimum?r>s?!0:r<s?!1:i>l?!0:i<l||o&&o<f?!1:n>=a:(r===1&&s===0&&(!S||!A||!$)&&(s=1,l=0,a=0,S=!0,A=!1,$=!1),r<s?!1:r>s?!S:i<l?!1:i>l?!A:n<a?!1:n>a?!$:!(o&&o<f))}e.isValidVersion=y;function m(c,g,w,d,o){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([O.default.Error,k.localize(0,null)]),t;if(typeof d.name!="string")return t.push([O.default.Error,k.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([O.default.Error,k.localize(2,null,"version")]),t;if(!d.engines)return t.push([O.default.Error,k.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([O.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!E(d.extensionDependencies))return t.push([O.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!E(d.activationEvents))return t.push([O.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([O.default.Error,k.localize(7,null,"activationEvents","main")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([O.default.Warning,k.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([O.default.Error,k.localize(9,null,"main")]),t;{const n=(0,L.joinPath)(w,d.main);(0,L.isEqualOrParent)(n,w)||t.push([O.default.Warning,k.localize(10,null,n.path,w.path)])}if(typeof d.activationEvents>"u")return t.push([O.default.Error,k.localize(11,null,"activationEvents","main")]),t}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([O.default.Error,k.localize(12,null,"browser")]),t;{const n=(0,L.joinPath)(w,d.browser);(0,L.isEqualOrParent)(n,w)||t.push([O.default.Warning,k.localize(13,null,n.path,w.path)])}if(typeof d.activationEvents>"u")return t.push([O.default.Error,k.localize(14,null,"activationEvents","browser")]),t}if(!T.valid(d.version))return t.push([O.default.Error,k.localize(15,null)]),t;const r=[];if(!P(c,g,d,o,r))for(const n of r)t.push([O.default.Error,n]);return t}e.validateExtensionManifest=m;function P(c,g,w,d,o){return d||typeof w.main>"u"&&typeof w.browser>"u"?!0:D(c,g,w.engines.vscode,o)}e.isValidExtensionVersion=P;function v(c,g,w){return c==="*"||D(g,w,c)}e.isEngineValid=v;function D(c,g,w,d=[]){const o=p(u(w));if(!o)return d.push(k.localize(16,null,w)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return d.push(k.localize(17,null,w)),!1}else if(!o.majorMustEqual)return d.push(k.localize(18,null,w)),!1;return y(c,g,o)?!0:(d.push(k.localize(19,null,c,w)),!1)}function E(c){if(!Array.isArray(c))return!1;for(let g=0,w=c.length;g<w;g++)if(typeof c[g]!="string")return!1;return!0}}),define(Z[109],Q([0,1,15,31]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(T,N,b){let h=b&&b.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const p=(await N.readFile(T.serviceMachineIdResource)).value.toString();h=(0,O.isUUID)(p)?p:null}catch{h=null}if(!h){h=(0,O.generateUuid)();try{await N.writeFile(T.serviceMachineIdResource,L.VSBuffer.fromString(h))}catch{}}return b?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=k}),define(Z[46],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(k,T=[],N=!1){this.ctor=k,this.staticArguments=T,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=L}),define(Z[110],Q([0,1,46]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var k;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function T(b,h,u){h instanceof L.SyncDescriptor||(h=new L.SyncDescriptor(h,[],Boolean(u))),O.push([b,h])}e.registerSingleton=T;function N(){return O}e.getSingletonServiceDescriptors=N}),define(Z[111],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(T,N){this.key=T,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class O{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const N of this.a.values())N.outgoing.size===0&&T.push(N);return T}insertEdge(T,N){const b=this.lookupOrInsertNode(T),h=this.lookupOrInsertNode(N);b.outgoing.set(h.key,h),h.incoming.set(b.key,b)}removeNode(T){const N=this.b(T);this.a.delete(N);for(const b of this.a.values())b.outgoing.delete(N),b.incoming.delete(N)}lookupOrInsertNode(T){const N=this.b(T);let b=this.a.get(N);return b||(b=new L(N,T),this.a.set(N,b)),b}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[N,b]of this.a)T.push(`${N}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,N]of this.a){const b=new Set([T]),h=this.c(N,b);if(h)return h}}c(T,N){for(const[b,h]of T.outgoing){if(N.has(b))return[...N,b].join(" -> ");N.add(b);const u=this.c(h,N);if(u)return u;N.delete(b)}}}e.Graph=O}),define(Z[21],Q([0,1,4,11,8]),function(x,e,L,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationOverrides=T;function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=N;var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function h(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function u(c,g){const w=Object.create(null);for(const d in c)p(w,d,c[d],g);return w}e.toValuesTree=u;function p(c,g,w,d){const o=g.split("."),t=o.pop();let r=c;for(let i=0;i<o.length;i++){const n=o[i];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:d(`Ignoring ${g} as ${o.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[t]=w}catch{d(`Ignoring ${g} as ${o.join(".")} is ${JSON.stringify(r)}`)}else d(`Ignoring ${g} as ${o.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=p;function y(c,g){const w=g.split(".");m(c,w)}e.removeFromValueTree=y;function m(c,g){const w=g.shift();if(g.length===0){delete c[w];return}if(Object.keys(c).indexOf(w)!==-1){const d=c[w];typeof d=="object"&&!Array.isArray(d)&&(m(d,g),Object.keys(d).length===0&&delete c[w])}}function P(c,g,w){function d(r,i){let n=r;for(const s of i){if(typeof n!="object"||n===null)return;n=n[s]}return n}const o=g.split("."),t=d(c,o);return typeof t>"u"?w:t}e.getConfigurationValue=P;function v(c,g,w){Object.keys(g).forEach(d=>{d!=="__proto__"&&(d in c?L.isObject(c[d])&&L.isObject(g[d])?v(c[d],g[d],w):w&&(c[d]=g[d]):c[d]=g[d])})}e.merge=v;function D(c,g,w){const d=c.inspect(g),o=c.inspect(w);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof o.userValue<"u"||typeof o.workspaceValue<"u"||typeof o.workspaceFolderValue<"u"?o.value:d.defaultValue}e.getMigratedSettingValue=D;function E(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(Z[58],Q([0,1,8]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(Z[18],Q([0,1,8]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[23],Q([0,1,88,8]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function T(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function N(c,g){switch(c){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function b(c,g){return g==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function h(c,g,w){return b(g,w)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===w?!0:u(w).includes(c)}e.isTargetPlatformCompatible=h;function u(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function p(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=p;var y;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var m;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var P;(function(c){c.Install="install",c.Uninstall="uninstall"})(P=e.StatisticType||(e.StatisticType={}));var v;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var D;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal",c.Signature="Signature"})(D=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class E extends Error{constructor(g,w){super(g),this.code=w,this.name=w}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Z[59],Q([0,1,8]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class O{b(){return this.a||(this.a=new Promise((T,N)=>x(["node-vsce-sign"],async b=>T(b),N))),this.a}async verify(T,N){let b;try{b=await this.b()}catch{return!1}return b.verify(T,N)}}e.ExtensionSignatureVerificationService=O}),define(Z[60],Q([0,1,15,9,96,13]),function(x,e,L,O,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(p,y,m,P,v,D){let E;try{await b(p,y,m,P,v,D)}catch(c){E=c}finally{E&&v.errorTransformer&&(E=v.errorTransformer(E)),typeof E<"u"&&m.error(E),m.end()}}e.readFileIntoStream=N;async function b(p,y,m,P,v,D){h(D);const E=await p.open(y,{create:!1});try{h(D);let c=0,g=0,w=v&&typeof v.length=="number"?v.length:void 0,d=L.VSBuffer.alloc(Math.min(v.bufferSize,typeof w=="number"?w:v.bufferSize)),o=v&&typeof v.position=="number"?v.position:0,t=0;do g=await p.read(E,o,d.buffer,t,d.byteLength-t),o+=g,t+=g,c+=g,typeof w=="number"&&(w-=g),t===d.byteLength&&(await m.write(P(d)),d=L.VSBuffer.alloc(Math.min(v.bufferSize,typeof w=="number"?w:v.bufferSize)),t=0);while(g>0&&(typeof w!="number"||w>0)&&h(D)&&u(c,v));if(t>0){let r=t;typeof w=="number"&&(r=Math.min(t,w)),m.write(P(d.slice(0,r)))}}catch(c){throw(0,T.ensureFileSystemProviderError)(c)}finally{await p.close(E)}}function h(p){if(p.isCancellationRequested)throw(0,O.canceled)();return!0}function u(p,y){if(y?.limits){if(typeof y.limits.memory=="number"&&p>y.limits.memory)throw(0,T.createFileSystemProviderError)((0,k.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&p>y.limits.size)throw(0,T.createFileSystemProviderError)((0,k.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[112],Q([0,1,3,156,2,12,157]),function(x,e,L,O,k,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new L.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(u){const p=this.i(u),y=p.filter(P=>{const v=this.c.get(P.path);return v?!(0,O.patternsEquals)(v.request.excludes,P.excludes)||!(0,O.patternsEquals)(v.request.includes,P.includes):!0}),m=Array.from(this.c.values()).filter(({request:P})=>!p.find(v=>v.path===P.path&&(0,O.patternsEquals)(v.excludes,P.excludes)&&(0,O.patternsEquals)(v.includes,P.includes))).map(({request:P})=>P.path);y.length&&this.j(`Request to start watching: ${y.map(P=>`${P.path} (excludes: ${P.excludes.length>0?P.excludes:"<none>"}, includes: ${P.includes&&P.includes.length>0?JSON.stringify(P.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const P of m)this.h(P);for(const P of y)this.g(P)}g(u){const p=new N.NodeJSFileWatcherLibrary(u,m=>this.a.fire(m),m=>this.b.fire(m),this.f),y={request:u,instance:p};this.c.set(u.path,y)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const p=this.c.get(u);p&&(this.c.delete(u),p.instance.dispose())}i(u){const p=new Map;for(const y of u){const m=T.isLinux?y.path:y.path.toLowerCase();p.set(m,y)}return Array.from(p.values())}async setVerboseLogging(u){this.f=u;for(const[,p]of this.c)p.instance.setVerboseLogging(u)}j(u){this.f&&this.b.fire({type:"trace",message:this.k(u)})}k(u,p){return p?`[File Watcher (node.js)] ${u} (path: ${p.request.path})`:`[File Watcher (node.js)] ${u}`}}e.NodeJSWatcher=b}),define(Z[113],Q([0,1,61,112]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends L.AbstractNonRecursiveWatcherClient{constructor(N,b,h){super(N,b,h),this.m()}l(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Z[114],Q([0,1,16,56,83,61]),function(x,e,L,O,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends T.AbstractUniversalWatcherClient{constructor(h,u,p){super(h,u,p),this.m()}l(h){const u=h.add(new k.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(u.onDidProcessExit(({code:p,signal:y})=>this.n(`terminated by itself with code ${p}, signal: ${y}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(Z[62],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...k){this.a=new Map;for(const[T,N]of k)this.set(T,N)}set(k,T){const N=this.a.get(k);return this.a.set(k,T),N}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=L}),define(Z[115],Q([0,1,5,9,2,46,111,8,62,158]),function(x,e,L,O,k,T,N,b,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class y extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class m{constructor(E=new h.ServiceCollection,c=!1,g,w=p){this.f=E,this.g=c,this.h=g,this.i=w,this.o=new Set,this.f.set(b.IInstantiationService,this),this._globalGraph=w?g?._globalGraph??new N.Graph(d=>d):void 0}createChild(E){return new m(E,this.g,this,this.i)}invokeFunction(E,...c){const g=v.traceInvocation(this.i,E);let w=!1;try{return E({get:o=>{if(w)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(o,g);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...c)}finally{w=!0,g.stop()}}createInstance(E,...c){let g,w;return E instanceof T.SyncDescriptor?(g=v.traceCreation(this.i,E.ctor),w=this.j(E.ctor,E.staticArguments.concat(c),g)):(g=v.traceCreation(this.i,E),w=this.j(E,c,g)),g.stop(),w}j(E,c=[],g){const w=b._util.getServiceDependencies(E).sort((t,r)=>t.index-r.index),d=[];for(const t of w){const r=this.m(t.id,g);r||this.u(`[createInstance] ${E.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(r)}const o=w.length>0?w[0].index:c.length;if(c.length!==o){console.trace(`[createInstance] First service dependency of ${E.name} at position ${o+1} conflicts with ${c.length} static arguments`);const t=o-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,o)}return Reflect.construct(E,c.concat(d))}k(E,c){if(this.f.get(E)instanceof T.SyncDescriptor)this.f.set(E,c);else if(this.h)this.h.k(E,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(E){const c=this.f.get(E);return!c&&this.h?this.h.l(E):c}m(E,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const g=this.l(E);return g instanceof T.SyncDescriptor?this.q(E,g,c.branch(E,!0)):(c.branch(E,!1),g)}q(E,c,g){if(this.o.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.o.add(E);try{return this.r(E,c,g)}finally{this.o.delete(E)}}r(E,c,g){const w=new N.Graph(t=>t.id.toString());let d=0;const o=[{id:E,desc:c,_trace:g}];for(;o.length;){const t=o.pop();if(w.lookupOrInsertNode(t),d++>1e3)throw new y(w);for(const r of b._util.getServiceDependencies(t.desc.ctor)){const i=this.l(r.id);if(i||this.u(`[createInstance] ${E} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),i instanceof T.SyncDescriptor){const n={id:r.id,desc:i,_trace:t._trace.branch(r.id,!0)};w.insertEdge(t,n),o.push(n)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new y(w);break}for(const{data:r}of t){if(this.l(r.id)instanceof T.SyncDescriptor){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}w.removeNode(r)}}return this.l(E)}s(E,c,g=[],w,d){if(this.f.get(E)instanceof T.SyncDescriptor)return this.t(E,c,g,w,d);if(this.h)return this.h.s(E,c,g,w,d);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(E,c,g=[],w,d){if(w){const o=new m(void 0,this.g,this,this.i);o.c=String(E);const t=new Map,r=new L.IdleValue(()=>{const i=o.j(c,g,d);for(const[n,s]of t){const l=i[n];if(typeof l=="function")for(const a of s)l.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=t.get(n);return a||(a=new u.LinkedList,t.set(n,a)),(S,A,$)=>{const H=a.push([S,A,$]);return(0,k.toDisposable)(H)}}if(n in i)return i[n];const s=r.value;let l=s[n];return typeof l!="function"||(l=l.bind(s),i[n]=l),l},set(i,n,s){return r.value[n]=s,!0},getPrototypeOf(i){return c.prototype}})}else return this.j(c,g,d)}u(E,c){if(c&&console.warn(E),this.g)throw new Error(E)}}e.InstantiationService=m;var P;(function(D){D[D.None=0]="None",D[D.Creation=1]="Creation",D[D.Invocation=2]="Invocation",D[D.Branch=3]="Branch"})(P||(P={}));class v{static traceInvocation(E,c){return E?new v(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(E,c){return E?new v(1,c.name):v.c}constructor(E,c){this.type=E,this.name=c,this.g=Date.now(),this.h=[]}branch(E,c){const g=new v(3,E.toString());return this.h.push([E,c,g]),g}stop(){const E=Date.now()-this.g;v.f+=E;let c=!1;function g(d,o){const t=[],r=new Array(d+1).join("	");for(const[i,n,s]of o.h)if(n&&s){c=!0,t.push(`${r}CREATES -> ${i}`);const l=g(d+1,s);l&&t.push(l)}else t.push(`${r}uses -> ${i}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(E>2||c)&&v.all.add(w.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v.f=0});var _=this&&this.__param||function(x,e){return function(L,O){e(L,O,x)}};define(Z[63],Q([0,1,22,2,12,98,23,8]),function(x,e,L,O,k,T,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function h(p){return p.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=h,e.ILanguagePackService=(0,b.createDecorator)("languagePackService");let u=class extends O.Disposable{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new L.CancellationTokenSource;setTimeout(()=>y.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const v=m.firstPage.filter(D=>D.properties.localizedLanguages?.length&&D.tags.some(E=>E.startsWith("lp-"))).map(D=>{const E=D.properties.localizedLanguages?.[0],c=h(D);return{...this.f(c,E,D),extensionId:D.identifier.id,galleryExtension:D}});return v.push({...this.f("en","English"),extensionId:"default"}),v}f(y,m,P){const v=m??y;let D;if(v!==y&&(D=`(${y})`),y.toLowerCase()===k.language.toLowerCase()&&(D??="",D+=(0,T.localize)(0,null)),P?.installCount){D??="";const E=P.installCount;let c;E>1e6?c=`${Math.floor(E/1e5)/10}M`:E>1e3?c=`${Math.floor(E/1e3)}K`:c=String(E),D+=` $(cloud-download) ${c}`}return{id:y,label:v,description:D}}};u=me([_(0,N.IExtensionGalleryService)],u),e.LanguagePackBaseService=u}),define(Z[10],Q([0,1,34,3,2,36,12,11,8]),function(x,e,L,O,k,T,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,h.createDecorator)("logService"),e.ILoggerService=(0,h.createDecorator)("loggerService");function u(){return new Date().toISOString()}var p;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;function y(l,a,f){switch(a){case p.Trace:l.trace(f);break;case p.Debug:l.debug(f);break;case p.Info:l.info(f);break;case p.Warning:l.warn(f);break;case p.Error:l.error(f);break;case p.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=y;function m(l){let a="";for(let f=0;f<l.length;f++){let S=l[f];if(typeof S=="object")try{S=JSON.stringify(S)}catch{}a+=(f>0?" ":"")+S}return a}e.format=m;class P extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new O.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==p.Off&&this.b<=a}}e.AbstractLogger=P;class v extends P{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...f){this.f(p.Trace)&&this.g(p.Trace,m([a,...f]))}debug(a,...f){this.f(p.Debug)&&this.g(p.Debug,m([a,...f]))}info(a,...f){this.f(p.Info)&&this.g(p.Info,m([a,...f]))}warn(a,...f){this.f(p.Warning)&&this.g(p.Warning,m([a,...f]))}error(a,...f){if(this.f(p.Error))if(a instanceof Error){const S=Array.prototype.slice.call(arguments);S[0]=a.stack,this.g(p.Error,m(S))}else this.g(p.Error,m([a,...f]))}flush(){}}e.AbstractMessageLogger=v;class D extends P{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.g=!N.isWindows}trace(a,...f){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...f):console.log(`[main ${u()}]`,a,...f))}debug(a,...f){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...f):console.log(`[main ${u()}]`,a,...f))}info(a,...f){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...f):console.log(`[main ${u()}]`,a,...f))}warn(a,...f){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,a,...f):console.warn(`[main ${u()}]`,a,...f))}error(a,...f){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,a,...f):console.error(`[main ${u()}]`,a,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=D;class E extends P{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...f){this.f(p.Trace)&&console.log("%cTRACE","color: #888",a,...f)}debug(a,...f){this.f(p.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...f)}info(a,...f){this.f(p.Info)&&console.log("%c INFO","color: #33f",a,...f)}warn(a,...f){this.f(p.Warning)&&console.log("%c WARN","color: #993",a,...f)}error(a,...f){this.f(p.Error)&&console.log("%c  ERR","color: #f33",a,...f)}dispose(){}flush(){}}e.ConsoleLogger=E;class c extends P{constructor(a,f=e.DEFAULT_LOG_LEVEL){super(),this.g=a,this.setLevel(f)}trace(a,...f){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(a),...f])}debug(a,...f){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(a),...f])}info(a,...f){this.f(p.Info)&&this.g.log(p.Info,[this.h(a),...f])}warn(a,...f){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(a),...f])}error(a,...f){this.f(p.Error)&&this.g.log(p.Error,[this.h(a),...f])}h(a){return typeof a=="string"?a:(0,L.toErrorMessage)(a,this.f(p.Trace))}dispose(){}flush(){}}e.AdapterLogger=c;class g extends P{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const f of this.g)f.setLevel(a);super.setLevel(a)}trace(a,...f){for(const S of this.g)S.trace(a,...f)}debug(a,...f){for(const S of this.g)S.debug(a,...f)}info(a,...f){for(const S of this.g)S.info(a,...f)}warn(a,...f){for(const S of this.g)S.warn(a,...f)}error(a,...f){for(const S of this.g)S.error(a,...f)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.MultiplexLogService=g;class w extends k.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...f){this.b.trace(a,...f)}debug(a,...f){this.b.debug(a,...f)}info(a,...f){this.b.info(a,...f)}warn(a,...f){this.b.warn(a,...f)}error(a,...f){this.b.error(a,...f)}flush(){this.b.flush()}}e.LogService=w;class d extends k.Disposable{constructor(a,f){super(),this.c=a,this.b=new T.ResourceMap,this.B(f(S=>this.setLevel(S)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,f,S){let A=this.b.get(a)?.logger;return A||(S=f?.always?p.Trace:S,A=this.f(a,S??this.c,f),this.b.set(a,{logger:A,logLevel:S})),A}setLevel(a,f){const S=b.URI.isUri(a)?a:void 0,A=S?f:a;if(S){const $=this.b.get(S);$&&$.logLevel!==A&&($.logLevel=A,$.logger.setLevel(A))}else this.c=A,this.b.forEach(({logLevel:$,logger:H})=>{$===void 0&&H.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=d;class o{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(a){}getLevel(){return p.Info}trace(a,...f){}debug(a,...f){}info(a,...f){}warn(a,...f){}error(a,...f){}critical(a,...f){}dispose(){}flush(){}}e.NullLogger=o;class t extends o{}e.NullLogService=t;class r extends d{constructor(){super(p.Info,O.Event.None)}f(a,f,S){return new o}}e.NullLoggerService=r;function i(l){if(l.verbose)return p.Trace;if(typeof l.logLevel=="string"){const a=s(l.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function n(l){switch(l){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.LogLevelToString=n;function s(l){switch(l){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.parseLogLevel=s}),define(Z[116],Q([0,1,19,5,9,3,2,14,61,10]),function(x,e,L,O,k,T,N,b,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class p extends N.Disposable{constructor(m,P){super(),this.a=m,this.b=P,this.c=this.B(new T.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new T.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new O.ThrottledDelayer(0)),this.s=[],this.t=this.B(new O.ThrottledDelayer(0))}watch(m,P){return P.recursive||this.b?.watcher?.forceUniversal?this.l(m,P):this.u(m,P)}l(m,P){const v={path:this.C(m),excludes:P.excludes,includes:P.includes,recursive:P.recursive},D=(0,L.insert)(this.j,v);return this.m(),(0,N.toDisposable)(()=>{D(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,k.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(P=>this.c.fire((0,h.toFileChanges)(P)),P=>this.z(P),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const P of this.j)(0,h.isRecursiveWatchRequest)(P)&&(P.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const P of this.j)(0,h.isRecursiveWatchRequest)(P)&&m.includes(P.path)&&(P.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,P){const v={path:this.C(m),excludes:P.excludes,includes:P.includes,recursive:!1},D=(0,L.insert)(this.s,v);return this.v(),(0,N.toDisposable)(()=>{D(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,k.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,h.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,b.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=p}),define(Z[117],Q([0,1,19,5,15,22,3,52,64,2,54,16,118,17,43,95,13,60,10]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P,v,D,E,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends u.Disposable{constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new N.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new N.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new O.ResourceQueue)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const r=new u.DisposableStore;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),r.add(t.onDidChangeFile(i=>this.Q.fire(new E.FileChangesEvent(i,!this.N(t))))),typeof t.onDidWatchError=="function"&&r.add(t.onDidWatchError(i=>this.R.fire(new Error(i)))),r.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,u.toDisposable)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,u.dispose)(r)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(r){t.push(r)}}),!this.h.has(o)&&await O.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const r=this.h.get(o.scheme);return!!(r&&r.capabilities&t)}listCapabilities(){return h.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,P.isAbsolutePath)(o))throw new E.FileOperationError((0,D.localize)(0,null,this.mb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const r=new Error;throw r.name="ENOPRO",r.message=(0,D.localize)(1,null,o.toString()),r}return t}async k(o){const t=await this.j(o);if((0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t)||(0,E.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(o){const t=await this.j(o);if((0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.n(o,t)}catch(r){throw(0,E.toFileSystemProviderErrorCode)(r)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,D.localize)(2,null,this.mb(o)),1):(0,E.ensureFileSystemProviderError)(r)}}async n(o,t){const r=await this.j(o),i=this.N(r),n=t?.resolveTo,s=t?.resolveSingleChildDescendants,l=t?.resolveMetadata,a=await r.stat(o);let f;return this.p(r,o,a,void 0,!!l,(S,A)=>(f||(f=p.TernarySearchTree.forUris(()=>!i),f.set(o,!0),n&&f.fill(!0,n)),f.get(S.resource)||f.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&s?A===1:!1))}async p(o,t,r,i,n,s){const{providerExtUri:l}=this.M(o),a={resource:t,name:l.basename(t),isFile:(r.type&E.FileType.File)!==0,isDirectory:(r.type&E.FileType.Directory)!==0,isSymbolicLink:(r.type&E.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&E.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,E.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(a.isDirectory&&s(a,i)){try{const f=await o.readdir(t),S=await O.Promises.settled(f.map(async([A,$])=>{try{const H=l.joinPath(t,A),J=n?await o.stat(H):{type:$};return await this.p(o,H,J,f.length,n,s)}catch(H){return this.b.trace(H),null}}));a.children=(0,L.coalesce)(S)}catch(f){this.b.trace(f),a.children=[]}return a}return a}async resolveAll(o){return O.Promises.settled(o.map(async t=>{try{return{stat:await this.n(t.resource,t.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),r=await t.stat(o);return this.p(t,o,r,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.r(o,t)}catch(r){return r}return!0}async r(o,t){if(!t?.overwrite&&await this.exists(o))throw new E.FileOperationError((0,D.localize)(3,null,this.mb(o)),3,t)}async createFile(o,t=k.VSBuffer.fromString(""),r){await this.r(o,r);const i=await this.writeFile(o,t);return this.m.fire(new E.FileOperationEvent(o,0,i)),i}async writeFile(o,t,r){const i=this.kb(await this.l(o),o),{providerExtUri:n}=this.M(i);try{await this.s(i,o,r)||await this.O(i,n.dirname(o));let l;if((0,E.hasReadWriteCapability)(i)&&!(t instanceof k.VSBuffer))if((0,v.isReadableStream)(t)){const a=await(0,v.peekStream)(t,3);a.ended?l=k.VSBuffer.concat(a.buffer):l=a}else l=(0,v.peekReadable)(t,a=>k.VSBuffer.concat(a),3);else l=t;!(0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)&&l instanceof k.VSBuffer?await this.bb(i,o,r,l):await this.X(i,o,r,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l),this.m.fire(new E.FileOperationEvent(o,4))}catch(s){throw new E.FileOperationError((0,D.localize)(4,null,this.mb(o),(0,E.ensureFileSystemProviderError)(s).toString()),(0,E.toFileOperationResult)(s),r)}return this.resolve(o,{resolveMetadata:!0})}async s(o,t,r){if(!!r?.unlock&&!(o.capabilities&8192))throw new Error((0,D.localize)(5,null,this.mb(t)));let n;try{n=await o.stat(t)}catch{return}if((n.type&E.FileType.Directory)!==0)throw new E.FileOperationError((0,D.localize)(6,null,this.mb(t)),0,r);if(this.lb(t,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==E.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,E.etag)({mtime:r.mtime,size:n.size}))throw new E.FileOperationError((0,D.localize)(7,null),3,r);return n}async readFile(o,t,r){const i=await this.k(o);return t?.atomic?this.t(i,o,t,r):this.u(i,o,t,r)}async t(o,t,r,i){return new Promise((n,s)=>{this.W.queueFor(t,this.M(o).providerExtUri).queue(async()=>{try{const l=await this.u(o,t,r,i);n(l)}catch(l){s(l)}})})}async u(o,t,r,i){const n=await this.v(o,t,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,k.streamToBuffer)(n.value)}}async readFileStream(o,t,r){const i=await this.k(o);return this.v(i,o,t,r)}async v(o,t,r,i){const n=new T.CancellationTokenSource(i),s=this.D(t,r).then(a=>a,a=>{throw n.cancel(),a});let l;try{return typeof r?.etag=="string"&&r.etag!==E.ETAG_DISABLED&&await s,r?.atomic&&(0,E.hasFileAtomicReadCapability)(o)||!((0,E.hasOpenReadWriteCloseCapability)(o)||(0,E.hasFileReadStreamCapability)(o))||(0,E.hasReadWriteCapability)(o)&&r?.preferUnbuffered?l=this.C(o,t,r):(0,E.hasFileReadStreamCapability)(o)?l=this.w(o,t,n.token,r):l=this.z(o,t,n.token,r),{...await s,value:l}}catch(a){l&&await(0,v.consumeStream)(l);const f=(0,D.localize)(8,null,this.mb(t),(0,E.ensureFileSystemProviderError)(a).toString());throw a instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(f,a.stat,r):new E.FileOperationError(f,(0,E.toFileOperationResult)(a),r)}}w(o,t,r,i=Object.create(null)){const n=o.readFileStream(t,i,r);return(0,v.transform)(n,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new E.FileOperationError((0,D.localize)(9,null,this.mb(t),(0,E.ensureFileSystemProviderError)(s).toString()),(0,E.toFileOperationResult)(s),i)},s=>k.VSBuffer.concat(s))}z(o,t,r,i=Object.create(null)){const n=(0,k.newWriteableBufferStream)();return(0,c.readFileIntoStream)(o,t,n,s=>s,{...i,bufferSize:this.a,errorTransformer:s=>new E.FileOperationError((0,D.localize)(10,null,this.mb(t),(0,E.ensureFileSystemProviderError)(s).toString()),(0,E.toFileOperationResult)(s),i)},r),n}C(o,t,r){const i=(0,v.newWriteableStream)(n=>k.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,E.hasFileAtomicReadCapability)(o)?n=await o.readFile(t,{atomic:!0}):n=await o.readFile(t),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.F(t,n.byteLength,r),i.end(k.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async D(o,t){const r=await this.resolve(o,{resolveMetadata:!0});if(r.isDirectory)throw new E.FileOperationError((0,D.localize)(11,null,this.mb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==E.ETAG_DISABLED&&t.etag===r.etag)throw new E.NotModifiedSinceFileOperationError((0,D.localize)(12,null),r,t);return this.F(o,r.size,t),r}F(o,t,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&t>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&t>r.limits.size&&(i=7),typeof i=="number")throw new E.FileOperationError((0,D.localize)(13,null,this.mb(o)),i)}}async canMove(o,t,r){return this.G(o,t,"move",r)}async canCopy(o,t,r){return this.G(o,t,"copy",r)}async G(o,t,r,i){if(o.toString()!==t.toString())try{const n=r==="move"?this.kb(await this.l(o),o):await this.k(o),s=this.kb(await this.l(t),t);await this.L(n,o,s,t,r,i)}catch(n){return n}return!0}async move(o,t,r){const i=this.kb(await this.l(o),o),n=this.kb(await this.l(t),t),s=await this.H(i,o,n,t,"move",!!r),l=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,t,r){const i=await this.k(o),n=this.kb(await this.l(t),t),s=await this.H(i,o,n,t,"copy",!!r),l=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(o,s==="copy"?3:2,l)),l}async H(o,t,r,i,n,s){if(t.toString()===i.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:a}=await this.L(o,t,r,i,n,s);if(l&&!a&&s&&await this.del(i,{recursive:!0}),await this.O(r,this.M(r).providerExtUri.dirname(i)),n==="copy"){if(o===r&&(0,E.hasFileFolderCopyCapability)(o))await o.copy(t,i,{overwrite:s});else{const f=await this.resolve(t);f.isDirectory?await this.J(o,f,r,i):await this.I(o,t,r,i)}return n}else return o===r?(await o.rename(t,i,{overwrite:s}),n):(await this.H(o,t,r,i,"copy",s),await this.del(t,{recursive:!0}),"copy")}async I(o,t,r,i){if((0,E.hasOpenReadWriteCloseCapability)(o)&&(0,E.hasOpenReadWriteCloseCapability)(r))return this.db(o,t,r,i);if((0,E.hasOpenReadWriteCloseCapability)(o)&&(0,E.hasReadWriteCapability)(r))return this.jb(o,t,r,i);if((0,E.hasReadWriteCapability)(o)&&(0,E.hasOpenReadWriteCloseCapability)(r))return this.hb(o,t,r,i);if((0,E.hasReadWriteCapability)(o)&&(0,E.hasReadWriteCapability)(r))return this.fb(o,t,r,i)}async J(o,t,r,i){await r.mkdir(i),Array.isArray(t.children)&&await O.Promises.settled(t.children.map(async n=>{const s=this.M(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.J(o,await this.resolve(n.resource),r,s):this.I(o,n.resource,r,s)}))}async L(o,t,r,i,n,s){let l=!1;if(o===r){const{providerExtUri:f,isPathCaseSensitive:S}=this.M(o);if(S||(l=f.isEqual(t,i)),l&&n==="copy")throw new Error((0,D.localize)(14,null,this.mb(t),this.mb(i)));if(!l&&f.isEqualOrParent(i,t))throw new Error((0,D.localize)(15,null,this.mb(t),this.mb(i)))}const a=await this.exists(i);if(a&&!l){if(!s)throw new E.FileOperationError((0,D.localize)(16,null,this.mb(t),this.mb(i)),4);if(o===r){const{providerExtUri:f}=this.M(o);if(f.isEqualOrParent(t,i))throw new Error((0,D.localize)(17,null,this.mb(t),this.mb(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:l}}M(o){const t=this.N(o);return{providerExtUri:t?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:t}}N(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.kb(await this.j(o),o);await this.O(t,o);const r=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(o,0,r)),r}async O(o,t){const r=[],{providerExtUri:i}=this.M(o);for(;!i.isEqual(t,i.dirname(t));)try{if(((await o.stat(t)).type&E.FileType.Directory)===0)throw new Error((0,D.localize)(18,null,this.mb(t)));break}catch(n){if((0,E.toFileSystemProviderErrorCode)(n)!==E.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(t)),t=i.dirname(t)}for(let n=r.length-1;n>=0;n--){t=i.joinPath(t,r[n]);try{await o.mkdir(t)}catch(s){if((0,E.toFileSystemProviderErrorCode)(s)!==E.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,t){try{await this.P(o,t)}catch(r){return r}return!0}async P(o,t){const r=this.kb(await this.j(o),o);if(!!t?.useTrash&&!(r.capabilities&4096))throw new Error((0,D.localize)(19,null,this.mb(o)));let n;try{n=await r.stat(o)}catch{}if(n)this.lb(o,n);else throw new E.FileOperationError((0,D.localize)(20,null,this.mb(o)),1);if(!!!t?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,D.localize)(21,null,this.mb(o)))}return r}async del(o,t){const r=await this.P(o,t),i=!!t?.useTrash,n=!!t?.recursive;await r.delete(o,{recursive:n,useTrash:i}),this.m.fire(new E.FileOperationEvent(o,1))}async cloneFile(o,t){const r=await this.j(o),i=this.kb(await this.l(t),t);if(r===i&&this.M(r).providerExtUri.isEqual(o,t))return;if(r===i&&(0,E.hasFileCloneCapability)(r))return r.cloneFile(o,t);await this.O(i,this.M(i).providerExtUri.dirname(t));const n=this.W.queueFor(o,this.M(r).providerExtUri);return r===i&&(0,E.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(o,t,{overwrite:!0})):n.queue(()=>this.I(r,o,i,t))}watch(o,t={recursive:!1,excludes:[]}){const r=new u.DisposableStore;let i=!1,n=()=>{i=!0};return r.add((0,u.toDisposable)(()=>n())),(async()=>{try{const s=await this.U(o,t);i?(0,u.dispose)(s):n=()=>(0,u.dispose)(s)}catch(s){this.b.error(s)}})(),r}async U(o,t){const r=await this.j(o),i=(0,b.hash)([this.M(r).providerExtUri.getComparisonKey(o),t]);let n=this.S.get(i);return n||(n={count:0,disposable:r.watch(o,t)},this.S.set(i,n)),n.count+=1,(0,u.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,u.dispose)(n.disposable),this.S.delete(i)))})}dispose(){super.dispose();for(const[,o]of this.S)(0,u.dispose)(o.disposable);this.S.clear()}async X(o,t,r,i){return this.W.queueFor(t,this.M(o).providerExtUri).queue(async()=>{const n=await o.open(t,{create:!0,unlock:r?.unlock??!1});try{(0,v.isReadableStream)(i)||(0,v.isReadableBufferedStream)(i)?await this.Y(o,n,i):await this.Z(o,n,i)}catch(s){throw(0,E.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async Y(o,t,r){let i=0,n;if((0,v.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=k.VSBuffer.concat(r.buffer);await this.ab(o,t,s,s.byteLength,i,0),i+=s.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((s,l)=>{(0,v.listenStream)(n,{onData:async a=>{n.pause();try{await this.ab(o,t,a,a.byteLength,i,0)}catch(f){return l(f)}i+=a.byteLength,setTimeout(()=>n.resume())},onError:a=>l(a),onEnd:()=>s()})})}async Z(o,t,r){let i=0,n;for(;(n=r.read())!==null;)await this.ab(o,t,n,n.byteLength,i,0),i+=n.byteLength}async ab(o,t,r,i,n,s){let l=0;for(;l<i;)l+=await o.write(t,n+l,r.buffer,s+l,i-l)}async bb(o,t,r,i){return this.W.queueFor(t,this.M(o).providerExtUri).queue(()=>this.cb(o,t,r,i))}async cb(o,t,r,i){let n;i instanceof k.VSBuffer?n=i:(0,v.isReadableStream)(i)?n=await(0,k.streamToBuffer)(i):(0,v.isReadableBufferedStream)(i)?n=await(0,k.bufferedStreamToBuffer)(i):n=(0,k.readableToBuffer)(i),await o.writeFile(t,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async db(o,t,r,i){return this.W.queueFor(i,this.M(r).providerExtUri).queue(()=>this.eb(o,t,r,i))}async eb(o,t,r,i){let n,s;try{n=await o.open(t,{create:!1}),s=await r.open(i,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.a);let a=0,f=0,S=0;do S=await o.read(n,a,l.buffer,f,l.byteLength-f),await this.ab(r,s,l,S,a,f),a+=S,f+=S,f===l.byteLength&&(f=0);while(S>0)}catch(l){throw(0,E.ensureFileSystemProviderError)(l)}finally{await O.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async fb(o,t,r,i){return this.W.queueFor(i,this.M(r).providerExtUri).queue(()=>this.gb(o,t,r,i))}async gb(o,t,r,i){return r.writeFile(i,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async hb(o,t,r,i){return this.W.queueFor(i,this.M(r).providerExtUri).queue(()=>this.ib(o,t,r,i))}async ib(o,t,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const s=await o.readFile(t);await this.ab(r,n,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,E.ensureFileSystemProviderError)(s)}finally{await r.close(n)}}async jb(o,t,r,i){const n=await(0,k.streamToBuffer)(this.z(o,t,T.CancellationToken.None));await this.bb(r,i,void 0,n)}kb(o,t){if(o.capabilities&2048)throw new E.FileOperationError((0,D.localize)(22,null,this.mb(t)),6);return o}lb(o,t){if((t.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,D.localize)(23,null,this.mb(o)),6)}mb(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};w=me([_(0,g.ILogService)],w),e.FileService=w}),define(Z[119],Q([0,1,120,159,5,36,15,3,160,2,14,12,17,43,20,97,13,60,116,34,114,113]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P,v,D,E,c,g,w,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(L)}catch(r){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(r)}`)}})();class t extends g.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=b.Event.None,this.H=new T.ResourceMap(s=>m.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,y.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:s}=await v.SymlinkSupport.stat(this.C(i));return{type:this.G(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await v.Promises.readdir(this.C(i),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async l=>{try{let a;l.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(i,l.name))).type:a=this.G(l),s.push([l.name,a])}catch(a){this.a.trace(a)}})),s}catch(n){throw this.Y(n)}}G(i,n){let s;return n?.dangling?s=E.FileType.Unknown:i.isFile()?s=E.FileType.File:i.isDirectory()?s=E.FileType.Directory:s=E.FileType.Unknown,n&&(s|=E.FileType.SymbolicLink),s}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const l=new k.Barrier;return this.H.set(i,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,u.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(i,n){let s;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),s=await this.I(i));const l=this.C(i);return await v.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{s?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,s){const l=(0,P.newWriteableStream)(a=>N.VSBuffer.concat(a.map(f=>N.VSBuffer.wrap(f))).buffer);return(0,c.readFileIntoStream)(this,i,l,a=>a.buffer,{...n,bufferSize:256*1024},s),l}async writeFile(i,n,s){let l;try{const a=this.C(i);if(!s.create||!s.overwrite){if(await v.Promises.exists(a)){if(!s.overwrite)throw(0,E.createFileSystemProviderError)((0,D.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,E.createFileSystemProviderError)((0,D.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(l,0,n,0,n.byteLength)}catch(a){throw await this.Z(i,a)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const s=this.C(i);let l;(0,E.isFileOpenForWriteOptions)(n)&&(l=await this.I(i));let a;try{if((0,E.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:S}=await v.SymlinkSupport.stat(s);S.mode&128||await v.Promises.chmod(s,S.mode|128)}catch(S){this.a.trace(S)}let f;if((0,E.isFileOpenForWriteOptions)(n)){if(y.isWindows)try{await v.Promises.truncate(s,0),f="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}f||(f="w")}else f="r";a=await v.Promises.open(s,f)}catch(f){throw l?.dispose(),(0,E.isFileOpenForWriteOptions)(n)?await this.Z(i,f):this.Y(f)}if(this.L.set(a,0),(0,E.isFileOpenForWriteOptions)(n)&&this.N.set(a,i),l){const f=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.M.set(a,l),f&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),f.dispose())}return a}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await v.Promises.fdatasync(i)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await v.Promises.close(i)}catch(s){throw this.Y(s)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,s,l,a){const f=this.P(i,n);let S=null;try{S=(await v.Promises.read(i,s,l,a,f)).bytesRead}catch(A){throw this.Y(A)}finally{this.Q(i,f,S)}return S}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,s){const l=this.L.get(i);typeof l=="number"&&(typeof n=="number"||(typeof s=="number"?this.L.set(i,l+s):this.L.delete(i)))}async write(i,n,s,l,a){return(0,k.retry)(()=>this.R(i,n,s,l,a),100,3)}async R(i,n,s,l,a){const f=this.P(i,n);let S=null;try{S=(await v.Promises.write(i,s,l,a,f)).bytesWritten}catch(A){throw await this.Z(this.N.get(i),A)}finally{this.Q(i,f,S)}return S}async mkdir(i){try{await v.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const s=this.C(i);n.recursive?await v.Promises.rm(s,v.RimRafMode.MOVE):await v.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(i,n,s){const l=this.C(i),a=this.C(n);if(l!==a)try{await this.S(i,n,"move",s.overwrite),await v.Promises.move(l,a)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,D.localize)(2,null,(0,p.basename)(l),(0,p.basename)((0,p.dirname)(a)),f.toString()))),this.Y(f)}}async copy(i,n,s){const l=this.C(i),a=this.C(n);if(l!==a)try{await this.S(i,n,"copy",s.overwrite),await v.Promises.copy(l,a,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,D.localize)(3,null,(0,p.basename)(l),(0,p.basename)((0,p.dirname)(a)),f.toString()))),this.Y(f)}}async S(i,n,s,l){const a=this.C(i),f=this.C(n);let S=!1;if(!!(this.capabilities&1024)||(S=(0,h.isEqual)(a,f,!0)),S&&s==="copy")throw(0,E.createFileSystemProviderError)((0,D.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!S&&await v.Promises.exists(f)){if(!l)throw(0,E.createFileSystemProviderError)((0,D.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,s){const l=this.C(i),a=this.C(n),f=!!(this.capabilities&1024);if((0,h.isEqual)(l,a,!f))return;const S=new u.DisposableStore;try{const[A,$]=await Promise.all([this.I(i),this.I(n)]);S.add(A),S.add($),s&&await v.Promises.mkdir((0,p.dirname)(a),{recursive:!0}),await v.Promises.copyFile(l,a)}catch(A){if(A.code==="ENOENT"&&!s)return this.U(i,n,!0);throw this.Y(A)}finally{S.dispose()}}p(i,n,s){return new d.UniversalWatcherClient(l=>i(l),l=>n(l),s)}y(i,n,s){return new o.NodeJSWatcherClient(l=>i(l),l=>n(l),s)}Y(i){if(i instanceof E.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=E.FileSystemProviderErrorCode.NoPermissions;break;default:n=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(i,n)}async Z(i,n){let s=this.Y(n);if(i&&s.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await v.SymlinkSupport.stat(this.C(i));l.mode&128||(s=(0,E.createFileSystemProviderError)(n,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return s}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(Z[121],Q([0,1,13,10]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(k||(k={}));async function T(u,p,y,m,P){try{const v=await new Promise((E,c)=>{x(["spdlog"],E,c)});v.setFlushOn(k.Trace);const D=await v.createAsyncRotatingLogger(u,p,y,m);return P?D.clearFormatters():D.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),D}catch(v){console.error(v)}return null}function N(u,p,y){switch(p){case O.LogLevel.Trace:u.trace(y);break;case O.LogLevel.Debug:u.debug(y);break;case O.LogLevel.Info:u.info(y);break;case O.LogLevel.Warning:u.warn(y);break;case O.LogLevel.Error:u.error(y);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function b(u,p){switch(p){case O.LogLevel.Trace:u.setLevel(k.Trace);break;case O.LogLevel.Debug:u.setLevel(k.Debug);break;case O.LogLevel.Info:u.setLevel(k.Info);break;case O.LogLevel.Warning:u.setLevel(k.Warning);break;case O.LogLevel.Error:u.setLevel(k.Error);break;case O.LogLevel.Off:u.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class h extends O.AbstractMessageLogger{constructor(p,y,m,P,v){super(),this.k=[],this.setLevel(v),this.l=this.n(p,y,m,P),this.B(this.onDidChangeLogLevel(D=>{this.m&&b(this.m,D)}))}async n(p,y,m,P){const v=m?6:1,D=30/v*L.ByteSize.MB,E=await T(p,y,D,v,P);if(E){this.m=E,b(this.m,this.getLevel());for(const{level:c,message:g}of this.k)N(this.m,c,g);this.k=[]}}g(p,y){this.m?N(this.m,p,y):this.getLevel()<=p&&this.k.push({level:p,message:y})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=h}),define(Z[38],Q([0,1,3,64,2,8]),function(x,e,L,O,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class N extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const p=Object.keys(this.f).length;return this.f={...u,...this.f},p!==Object.keys(this.f).length&&await this.i(u),O.Iterable.reduce(this.g.entries(),(y,[m,P])=>({...y,[m]:P}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(u,[p,y])=>({...u,[p]:{definition:y,value:this.g.get(p)}}),{})}}e.AbstractPolicyService=N;class b{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(Z[122],Q([0,1,5,3,64,4,13,10,38]),function(x,e,L,O,k,T,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(y,m){const P=[];for(const v of new Set(k.Iterable.concat(y.keys(),m.keys())))y.get(v)!==m.get(v)&&P.push(v);return P}let p=class extends h.AbstractPolicyService{constructor(m,P,v){super(),this.j=m,this.k=P,this.l=v,this.c=this.B(new L.ThrottledDelayer(500));const D=O.Event.filter(P.onDidFilesChange,E=>E.affects(m));this.B(P.watch(m)),this.B(D(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const m=new Map;try{const P=await this.k.readFile(this.j),v=JSON.parse(P.value.toString());if(!(0,T.isObject)(v))throw new Error("Policy file isn't a JSON object");for(const D of Object.keys(v))this.f[D]&&m.set(D,v[D])}catch(P){P.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",P)}return m}async p(){const m=await this.n(),P=u(this.g,m);this.g=m,P.length>0&&this.h.fire(P)}};p=me([_(1,N.IFileService),_(2,b.ILogService)],p),e.FilePolicyService=p}),define(Z[26],Q([0,1,8]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[37],Q([0,1,70,4]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(N,b){L.ok(O.isString(N)),L.ok(O.isObject(b)),L.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,b)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new k}),define(Z[123],Q([0,1,3,37]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class T{constructor(){this.b=new L.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,u){this.a[k(h)]=u,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const N=new T;O.Registry.add(e.Extensions.JSONContribution,N)}),define(Z[41],Q([0,1,19,3,4,86,21,123,37]),function(x,e,L,O,k,T,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var u;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(u=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=h.Registry.as(b.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new O.Emitter,this.onDidSchemaChange=this.i.event,this.j=new O.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const i=new Set;this.n(t,r,i),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const r=new Set;this.o(t,r),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const i=new Set;this.o(r,i),this.n(t,!1,i),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const i=[];for(const{overrides:n,source:s}of t)for(const l in n)if(r.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const a=this.a.get(l),f=a?.valuesSources??new Map;if(s)for(const H of Object.keys(n[l]))f.set(H,s);const S={...a?.value||{},...n[l]};this.a.set(l,{source:s,value:S,valuesSources:f});const A=(0,N.getLanguageTagSettingPlainKey)(l),$={type:"object",default:S,description:T.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:k.isString(s)?void 0:s,defaultValueSource:s};i.push(...D(l)),this.d[l]=$,this.b.properties[l]=$}else{this.a.set(l,{value:n[l],source:s});const a=this.d[l];a&&(this.w(l,a),this.r(l,a))}this.m(i)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:i,source:n}of t)for(const s in i){const l=this.a.get(s),a=k.isString(n)?n:n?.id,f=k.isString(l?.source)?l?.source:l?.source?.id;if(a===f)if(r.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const S=this.d[s];S&&(this.w(s,S),this.r(s,S))}}this.u()}deltaConfiguration(t){let r=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,i){t.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,r){const i=n=>{if(n.properties)for(const s in n.properties){r.add(s);const l=this.d[s];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>i(s))};for(const n of t){i(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(t,r=!0,i,n,s=3,l){s=k.isUndefinedOrNull(t.scope)?s:t.scope;const a=t.properties;if(a)for(const S in a){const A=a[S];if(r&&w(S,A)){delete a[S];continue}if(A.source=i,A.defaultDefaultValue=a[S].default,this.w(S,A),e.OVERRIDE_PROPERTY_REGEX.test(S)?A.scope=void 0:(A.scope=k.isUndefinedOrNull(A.scope)?s:A.scope,A.restricted=k.isUndefinedOrNull(A.restricted)?!!n?.includes(S):A.restricted),a[S].hasOwnProperty("included")&&!a[S].included){this.f[S]=a[S],delete a[S];continue}else this.d[S]=a[S],a[S].policy?.name&&this.e.set(a[S].policy.name,S);!a[S].deprecationMessage&&a[S].markdownDeprecationMessage&&(a[S].deprecationMessage=a[S].markdownDeprecationMessage),l.add(S)}const f=t.allOf;if(f)for(const S of f)this.p(S,r,i,n,s,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=i=>{const n=i.properties;if(n)for(const l in n)this.r(l,n[l]);i.allOf?.forEach(r)};r(t)}r(t,r){switch(e.allSettings.properties[t]=r,r.scope){case 1:e.applicationSettings.properties[t]=r;break;case 2:e.machineSettings.properties[t]=r;break;case 6:e.machineOverridableSettings.properties[t]=r;break;case 3:e.windowSettings.properties[t]=r;break;case 4:e.resourceSettings.properties[t]=r;break;case 5:e.resourceSettings.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.allSettings.properties[t],r.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,i={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}}v(){const t={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,r){const i=this.a.get(t);let n=i?.value,s=i?.source;k.isUndefined(n)&&(n=r.defaultDefaultValue,s=void 0),k.isUndefined(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=s}}const P="\\[([^\\]]+)\\]",v=new RegExp(P,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${P})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function D(o){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(o)){let r=v.exec(o);for(;r?.length;){const i=r[1].trim();i&&t.push(i),r=v.exec(o)}}return(0,L.distinct)(t)}e.overrideIdentifiersFromKey=D;function E(o){return o.reduce((t,r)=>`${t}[${r}]`,"")}e.keyFromOverrideIdentifiers=E;function c(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const g=new m;h.Registry.add(e.Extensions.Configuration,g);function w(o,t){return o.trim()?e.OVERRIDE_PROPERTY_REGEX.test(o)?T.localize(7,null,o):g.getConfigurationProperties()[o]!==void 0?T.localize(8,null,o):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?T.localize(9,null,o,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:T.localize(6,null)}e.validateProperty=w;function d(){const o=[],t=g.getConfigurationProperties();for(const r of Object.keys(t))o.push([r,t[r].scope]);return o.push(["launch",4]),o.push(["task",4]),o}e.getScopes=d}),define(Z[65],Q([0,1,19,3,50,2,36,30,4,11,21,41,37]),function(x,e,L,O,k,T,N,b,h,u,p,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class P{constructor(r={},i=[],n=[],s){this.c=r,this.d=i,this.f=n,this.raw=s,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof P)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this.g=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,p.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),s=i?this.rawConfiguration.getOverrideValue(r,i):void 0,l=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:s,merged:l}}getOverrideValue(r,i){const n=this.l(i);return n?r?(0,p.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return L.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return L.distinct(r)}override(r){let i=this.b.get(r);return i||(i=this.h(r),this.b.set(r,i)),i}merge(...r){const i=b.deepClone(this.contents),n=b.deepClone(this.overrides),s=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const a of r)if(l.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.j(i,a.contents);for(const f of a.overrides){const[S]=n.filter(A=>L.equals(A.identifiers,f.identifiers));S?(this.j(S.contents,f.contents),S.keys.push(...f.keys),S.keys=L.distinct(S.keys)):n.push(b.deepClone(f))}for(const f of a.keys)s.indexOf(f)===-1&&s.push(f)}return new P(i,s,n,l.every(a=>a instanceof P)?void 0:l)}freeze(){return this.a=!0,this}h(r){const i=this.l(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const s of L.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[s];const a=i[s];a&&(typeof l=="object"&&typeof a=="object"?(l=b.deepClone(l),this.j(l,a)):l=a),n[s]=l}return new P(n,this.keys,this.overrides)}j(r,i){for(const n of Object.keys(i)){if(n in r&&h.isObject(r[n])&&h.isObject(i[n])){this.j(r[n],i[n]);continue}r[n]=b.deepClone(i[n])}}k(r){return this.a&&!Object.isFrozen(r)?b.deepFreeze(r):r}l(r){let i=null,n=null;const s=l=>{l&&(n?this.j(n,l):n=b.deepClone(l))};for(const l of this.overrides)L.equals(l.identifiers,[r])?i=l.contents:l.identifiers.includes(r)&&s(l.contents);return s(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.m(r),(0,p.addToValueTree)(this.contents,r,i,n=>{throw new Error(n)})}removeValue(r){this.n(r)&&(0,p.removeFromValueTree)(this.contents,r)}m(r){let i=this.keys.length;for(let n=0;n<i;n++)r.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,r)}n(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=P;class v{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new P}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!h.isUndefinedOrNull(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:s,overrides:l,restricted:a,hasExcludedProperties:f}=this.h(r,i);this.b=new P(n,s,l,f?[r]:void 0),this.c=a||[]}g(r){let i={},n=null,s=[];const l=[],a=[];function f(A){Array.isArray(s)?s.push(A):n!==null&&(s[n]=A)}const S={onObjectBegin:()=>{const A={};f(A),l.push(s),s=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const A=[];f(A),l.push(s),s=A,n=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:f,onError:(A,$,H)=>{a.push({error:A,offset:$,length:H})}};if(r)try{k.visit(r,S),i=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return i}h(r,i){const n=m.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),s=this.j(r,n,!0,i);r=s.raw;const l=(0,p.toValuesTree)(r,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),a=Object.keys(r),f=this.l(r,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:l,keys:a,overrides:f,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}j(r,i,n,s){let l=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:l};const a={},f=[];for(const S in r)if(y.OVERRIDE_PROPERTY_REGEX.test(S)&&n){const A=this.j(r[S],i,!1,s);a[S]=A.raw,l=l||A.hasExcludedProperties,f.push(...A.restricted)}else{const A=i[S],$=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&f.push(S),($===void 0||s.scopes===void 0||s.scopes.includes($))&&!(s.skipRestricted&&A?.restricted)?a[S]=r[S]:l=!0}return{raw:a,restricted:f,hasExcludedProperties:l}}l(r,i){const n=[];for(const s of Object.keys(r))if(y.OVERRIDE_PROPERTY_REGEX.test(s)){const l={};for(const a in r[s])l[a]=r[s][a];n.push({identifiers:(0,y.overrideIdentifiersFromKey)(s),keys:Object.keys(l),contents:(0,p.toValuesTree)(l,i)})}return n}}e.ConfigurationModelParser=v;class D extends T.Disposable{constructor(r,i,n,s){super(),this.f=r,this.g=i,this.h=s,this.c=this.B(new O.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(n.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(O.Event.any(O.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),O.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new P}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=D;class E{constructor(r,i,n,s,l,a,f,S,A,$,H,J,ie){this.a=r,this.b=i,this.value=n,this.overrideIdentifiers=s,this.c=l,this.d=a,this.f=f,this.g=S,this.h=A,this.j=$,this.k=H,this.l=J,this.m=ie}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class c{constructor(r,i,n,s,l=new P,a=new P,f=new N.ResourceMap,S=new P,A=new N.ResourceMap,$=!0){this.c=r,this.d=i,this.f=n,this.g=s,this.h=l,this.j=a,this.l=f,this.m=S,this.n=A,this.p=$,this.a=null,this.b=new N.ResourceMap,this.q=null}getValue(r,i,n){return this.s(r,i,n).getValue(r)}updateValue(r,i,n={}){let s;n.resource?(s=this.n.get(n.resource),s||(s=new P,this.n.set(n.resource,s))):s=this.m,i===void 0?s.removeValue(r):s.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const s=this.s(r,i,n),l=this.w(i.resource,n),a=i.resource?this.n.get(i.resource)||this.m:this.m,f=new Set;for(const S of s.overrides)for(const A of S.identifiers)s.getOverrideValue(r,A)!==void 0&&f.add(A);return new E(r,i,s.getValue(r),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),n?this.j.freeze():void 0,l?l.freeze():void 0,a.inspect(r,i.overrideIdentifier))}keys(r){const i=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.l.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:s,updated:l,removed:a}=d(this.c,r);i=[...s,...l,...a]}for(const s of i)for(const l of(0,y.overrideIdentifiersFromKey)(s)){const a=this.c.getKeysForOverrideIdentifier(l),f=r.getKeysForOverrideIdentifier(l),S=[...f.filter(A=>a.indexOf(A)===-1),...a.filter(A=>f.indexOf(A)===-1),...a.filter(A=>!b.equals(this.c.override(l).getValue(A),r.override(l).getValue(A)))];n.push([l,S])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:s}=d(this.d,r),l=[...i,...n,...s];return l.length&&this.updatePolicyConfiguration(r),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:s,overrides:l}=d(this.applicationConfiguration,r),a=[...i,...n,...s];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:l}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:s,overrides:l}=d(this.localUserConfiguration,r),a=[...i,...n,...s];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:l}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:s,overrides:l}=d(this.remoteUserConfiguration,r),a=[...i,...n,...s];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:l}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:s,overrides:l}=d(this.workspaceConfiguration,r),a=[...i,...n,...s];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:l}}compareAndUpdateFolderConfiguration(r,i){const n=this.r.get(r),{added:s,updated:l,removed:a,overrides:f}=d(n,i),S=[...s,...l,...a];return(S.length||!n)&&this.updateFolderConfiguration(r,i),{keys:S,overrides:f}}compareAndDeleteFolderConfiguration(r){const i=this.r.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:s,removed:l,overrides:a}=d(i,void 0);return{keys:[...n,...s,...l],overrides:a}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,i,n){let s=this.t(i,n);return i.overrideIdentifier&&(s=s.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(s=s.merge(this.d)),s}t({resource:r},i){let n=this.u();if(i&&r){const s=i.getFolder(r);s&&(n=this.v(s.uri)||n);const l=this.n.get(r);l&&(n=n.merge(l))}return n}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let i=this.b.get(r);if(!i){const n=this.u(),s=this.l.get(r);s?(i=n.merge(s),this.p&&(i=i.freeze()),this.b.set(r,i)):i=n}return i}w(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.l.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,i)=>{const{contents:n,overrides:s,keys:l}=this.l.get(i);return r.push([i,{contents:n,overrides:s,keys:l}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this.j.freeze().keys.forEach(i=>r.add(i)),this.l.forEach(i=>i.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.l.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}y(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.l.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s))),[...i.values()]}static parse(r){const i=this.z(r.defaults),n=this.z(r.policy),s=this.z(r.application),l=this.z(r.user),a=this.z(r.workspace),f=r.folders.reduce((S,A)=>(S.set(u.URI.revive(A[0]),this.z(A[1])),S),new N.ResourceMap);return new c(i,n,s,l,new P,a,f,new P,new N.ResourceMap,!1)}static z(r){return new P(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=c;function g(...t){if(t.length===0)return{keys:[],overrides:[]};if(t.length===1)return t[0];const r=new Set,i=new Map;for(const s of t)s.keys.forEach(l=>r.add(l)),s.overrides.forEach(([l,a])=>{const f=(0,N.getOrSet)(i,l,new Set);a.forEach(S=>f.add(S))});const n=[];return i.forEach((s,l)=>n.push([l,[...s.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=g;class w{constructor(r,i,n,s){this.change=r,this.f=i,this.g=n,this.h=s,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const l of r.keys)this.affectedKeys.add(l);for(const[,l]of r.overrides)for(const a of l)this.affectedKeys.add(a);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=c.parse(this.f.data)),this.j}affectsConfiguration(r,i){const n=this.a+r,s=this.d.indexOf(n);if(s<0)return!1;const l=s+n.length;if(l>=this.d.length)return!1;const a=this.d.charCodeAt(l);if(a!==this.b&&a!==this.c)return!1;if(i){const f=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,S=this.g.getValue(r,i,this.h);return!b.equals(f,S)}return!0}}e.ConfigurationChangeEvent=w;function d(t,r){const{added:i,removed:n,updated:s}=o(r?.rawConfiguration,t?.rawConfiguration),l=[],a=t?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const S=f.filter(A=>!a.includes(A));for(const A of S)l.push([A,r.getKeysForOverrideIdentifier(A)])}if(t){const S=a.filter(A=>!f.includes(A));for(const A of S)l.push([A,t.getKeysForOverrideIdentifier(A)])}if(r&&t){for(const S of a)if(f.includes(S)){const A=o({contents:t.getOverrideValue(void 0,S)||{},keys:t.getKeysForOverrideIdentifier(S)},{contents:r.getOverrideValue(void 0,S)||{},keys:r.getKeysForOverrideIdentifier(S)});l.push([S,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:n,updated:s,overrides:l}}function o(t,r){const i=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],n=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=[];if(t&&r){for(const l of r.keys)if(t.keys.indexOf(l)!==-1){const a=(0,p.getConfigurationValue)(r.contents,l),f=(0,p.getConfigurationValue)(t.contents,l);b.equals(a,f)||s.push(l)}}return{added:i,removed:n,updated:s}}}),define(Z[124],Q([0,1,19,3,2,30,4,21,65,41,10,38,37]),function(x,e,L,O,k,T,N,b,h,u,p,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class P extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new v(this.f())),this.b}async initialize(){return this.b=void 0,this.B(m.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:w})=>this.c(Array.from(g),w))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(g,w){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}}e.DefaultConfiguration=P;class v extends h.ConfigurationModel{constructor(g={}){const w=m.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(w),o=Object.create(null),t=[];for(const r in w){const i=g[r],n=i!==void 0?i:w[r].default;(0,b.addToValueTree)(o,r,n,s=>console.error(`Conflict in default settings: ${s}`))}for(const r of Object.keys(o))u.OVERRIDE_PROPERTY_REGEX.test(r)&&t.push({identifiers:(0,u.overrideIdentifiersFromKey)(r),keys:Object.keys(o[r]),contents:(0,b.toValuesTree)(o[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(o,d,t)}}e.DefaultConfigurationModel=v;class D{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new h.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=D;let E=class extends k.Disposable{get configurationModel(){return this.b}constructor(g,w,d){super(),this.c=g,this.f=w,this.g=d,this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new h.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.i(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.j(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const w={},d=[],o=m.Registry.as(u.Extensions.Configuration).getConfigurationProperties();for(const t of g){const r=o[t];if(!r){d.push(t);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}d.push(t),w[r.policy.name]={type:r.type}}}return(0,N.isEmptyObject)(w)||await this.f.updatePolicyDefinitions(w),d}i(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const w=m.Registry.as(u.Extensions.Configuration).getPolicyConfigurations(),d=(0,L.coalesce)(g.map(o=>w.get(o)));this.j(d,!0)}j(g,w){this.g.trace("PolicyConfiguration#update",g);const d=m.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),o=[],t=this.b.isEmpty();for(const r of g){const i=d[r]?.policy?.name;if(i){const n=this.f.getPolicyValue(i);(t?n!==void 0:!(0,T.equals)(this.b.getValue(r),n))&&o.push([r,n])}else this.b.getValue(r)!==void 0&&o.push([r,void 0])}if(o.length){this.g.trace("PolicyConfiguration#changed",o);const r=this.b;this.b=new h.ConfigurationModel;for(const i of r.keys)this.b.setValue(i,r.getValue(i));for(const[i,n]of o)n===void 0?this.b.removeValue(i):this.b.setValue(i,n);w&&this.a.fire(this.b)}}};E=me([_(1,y.IPolicyService),_(2,p.ILogService)],E),e.PolicyConfiguration=E}),define(Z[125],Q([0,1,5,3,2,17,21,65,124,38]),function(x,e,L,O,k,T,N,b,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class p extends k.Disposable{constructor(m,P,v,D){super(),this.i=m,this.h=this.B(new O.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.DefaultConfiguration),this.c=v instanceof u.NullPolicyService?new h.NullPolicyConfiguration:this.B(new h.PolicyConfiguration(this.b,v,D)),this.f=this.B(new b.UserSettings(this.i,void 0,T.extUriBiasedIgnorePathCase,P)),this.a=new b.Configuration(this.b.configurationModel,this.c.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.g=this.B(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:E,properties:c})=>this.k(E,c))),this.B(this.c.onDidChangeConfiguration(E=>this.l(E))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,P,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.Configuration(m,P,new b.ConfigurationModel,v)}getConfigurationData(){return this.a.toData()}getValue(m,P){const v=typeof m=="string"?m:void 0,D=(0,N.isConfigurationOverrides)(m)?m:(0,N.isConfigurationOverrides)(P)?P:{};return this.a.getValue(v,D,void 0)}updateValue(m,P,v,D){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const P=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(v,P,2)}k(m,P){const v=this.a.toData(),D=this.a.compareAndUpdateDefaultConfiguration(m,P);this.m(D,v,7)}l(m){const P=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(m);this.m(v,P,7)}m(m,P,v){const D=new b.ConfigurationChangeEvent(m,{data:P},this.a);D.source=v,D.sourceConfig=this.n(v),this.h.fire(D)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=p}),define(Z[66],Q([0,1,16]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(u){return u.scheme===L.Schemas.vscodeRemote?u.authority:void 0}e.getRemoteAuthority=O;function k(u){if(!u)return;const p=u.indexOf("+");return p<0?u:u.substr(0,p)}e.getRemoteName=k;function T(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.getRemoteServerRootPath=T;function N(u){const{host:p,port:y}=h(u);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:p,port:y}}e.parseAuthorityWithPort=N;function b(u,p){let{host:y,port:m}=h(u);return typeof m>"u"&&(m=p),{host:y,port:m}}e.parseAuthorityWithOptionalPort=b;function h(u){const p=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const y=u.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const m=u.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:u,port:void 0}}}),define(Z[27],Q([0,1,32,8,66]),function(x,e,L,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=T;function N(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));var h;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(h=e.TargetPlatform||(e.TargetPlatform={}));class u{constructor(D){this.value=D,this.c=D.toLowerCase()}static equals(D,E){if(typeof D>"u"||D===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof D=="string"||typeof E=="string"){const c=typeof D=="string"?D:D.value,g=typeof E=="string"?E:E.value;return L.equalsIgnoreCase(c,g)}return D.c===E.c}static toKey(D){return typeof D=="string"?D.toLowerCase():D.c}}e.ExtensionIdentifier=u;function p(v){return y(v)}e.isApplicationScopedExtension=p;function y(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function m(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function P(v,D){if(D){const E=`onResolveRemoteAuthority:${(0,k.getRemoteName)(D)}`;return v.activationEvents?.indexOf(E)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[126],Q([0,1,2,14,20,27]),function(x,e,L,O,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends L.Disposable{constructor(h,u){super(),this.b=h,this.a=(0,O.join)(this.b.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this.B(u.onDidInstallExtensions(p=>this.c(p))),this.B(u.onDidUninstallExtension(p=>this.f(p)))}c(h){h.some(u=>!!u.local)&&this.invalidate()}f(h){h.error||this.invalidate()}invalidate(){k.Promises.rm(this.a,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(Z[47],Q([0,1,15,99,41,8,37]),function(x,e,L,O,k,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function b(D){return D.res.statusCode&&D.res.statusCode>=200&&D.res.statusCode<300||D.res.statusCode===1223}e.isSuccess=b;function h(D){return D.res.statusCode===204}async function u(D){return h(D)?null:(await(0,L.streamToBuffer)(D.stream)).toString()}e.asText=u;async function p(D){if(!b(D))throw new Error("Server returned "+D.res.statusCode);return u(D)}e.asTextOrError=p;async function y(D){if(!b(D))throw new Error("Server returned "+D.res.statusCode);if(h(D))return null;const c=(await(0,L.streamToBuffer)(D.stream)).toString();try{return JSON.parse(c)}catch(g){throw g.message+=`:
`+c,g}}e.asJson=y;function m(D){v(D)}e.updateProxyConfigurationsScope=m;let P;function v(D){const E=N.Registry.as(k.Extensions.Configuration),c=P;P={id:"http",order:15,title:(0,O.localize)(0,null),type:"object",scope:D,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(4,null),(0,O.localize)(5,null),(0,O.localize)(6,null),(0,O.localize)(7,null)],default:"override",description:(0,O.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[P],remove:c?[c]:[]})}v(2)}),define(Z[127],Q([0,1,22,16,13,47]),function(x,e,L,O,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(h,u){this.a=h,this.b=u}async download(h,u,p=L.CancellationToken.None){if(h.scheme===O.Schemas.file||h.scheme===O.Schemas.vscodeRemote){await this.b.copy(h,u);return}const y={type:"GET",url:h.toString(!0)},m=await this.a.request(y,p);if(m.res.statusCode===200)await this.b.writeFile(u,m.stream);else{const P=await(0,T.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${P}`)}}};N=me([_(0,T.IRequestService),_(1,k.IFileService)],N),e.DownloadService=N}),define(Z[128],Q([0,1,129,4]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(N,b){return N.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:N.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function T(N,b,h={}){const u=(0,L.parse)(N),p=h.proxyUrl||k(u,b);if(!p)return null;const y=(0,L.parse)(p);if(!/^https?:$/.test(y.protocol||""))return null;const m={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,O.isBoolean)(h.strictSSL)?h.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((P,v)=>{x(["http-proxy-agent"],P,v)}))(m):new(await new Promise((P,v)=>{x(["https-proxy-agent"],P,v)}))(m)}e.getProxyAgent=T}),define(Z[130],Q([0,1,57,14,100,22,34,9,12,31,82,161,5,71]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let v;async function D(c,g,w,d){return w["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(d)&&!w["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(d)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=m.Promises.withAsyncBody(async(o,t)=>{const r=new T.CancellationTokenSource;let i=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,P.clamp)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),t(new Error((0,k.localize)(0,null)))},i);try{o(await E(g,r.token))}catch(l){!(0,b.isCancellationError)(l)&&!r.token.isCancellationRequested?t(new Error((0,k.localize)(1,null,(0,N.toErrorMessage)(l)))):o({})}finally{clearTimeout(s),r.dispose()}})),v)}e.getResolvedShellEnv=D;async function E(c,g){const w=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",w);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",d);const o=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(o+"({.*})"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const i=await(0,p.getSystemShell)(h.OS,r);return c.trace("getUnixShellEnvironment#shell",i),new Promise((n,s)=>{if(g.isCancellationRequested)return s(new b.CancellationError);const l=(0,O.basename)(i);let a,f;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(a=`& '${process.execPath}' ${S} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,f=["-Login","-Command"]):(a=`'${process.execPath}' ${S} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,l==="tcsh"?f=["-ic"]:f=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),a);const A=(0,L.spawn)(i,[...f,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(A.kill(),s(new b.CancellationError))),A.on("error",J=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(J)),s(J)});const $=[];A.stdout.on("data",J=>$.push(J));const H=[];A.stderr.on("data",J=>H.push(J)),A.on("close",(J,ie)=>{const re=Buffer.concat($).toString("utf8");c.trace("getUnixShellEnvironment#raw",re);const ee=Buffer.concat(H).toString("utf8");if(ee.trim()&&c.trace("getUnixShellEnvironment#stderr",ee),J||ie)return s(new Error((0,k.localize)(2,null,J,ie)));const pe=t.exec(re),le=pe?pe[1]:"{}";try{const ae=JSON.parse(le);w?ae.ELECTRON_RUN_AS_NODE=w:delete ae.ELECTRON_RUN_AS_NODE,d?ae.ELECTRON_NO_ATTACH_CONSOLE=d:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),n(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(ae)),s(ae)}})})}}),define(Z[67],Q([0,1,8]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,L.createDecorator)("stateService")}),define(Z[131],Q([0,1,5,15,4,18,13,10]),function(x,e,L,O,k,T,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class h{constructor(y,m,P){this.f=y,this.g=m,this.h=P,this.a=Object.create(null),this.b="",this.c=new L.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.g.error(y)}}getItem(y,m){const P=this.a[y];return(0,k.isUndefinedOrNull)(P)?m:P}setItem(y,m){this.setItems([{key:y,data:m}])}setItems(y){let m=!1;for(const{key:P,data:v}of y)this.a[P]!==v&&((0,k.isUndefinedOrNull)(v)?(0,k.isUndefined)(this.a[P])||(this.a[P]=void 0,m=!0):(this.a[P]=v,m=!0));m&&this.j()}removeItem(y){(0,k.isUndefined)(this.a[y])||(this.a[y]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.h.writeFile(this.f,O.VSBuffer.fromString(y)),this.b=y}catch(m){this.g.error(m)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=h;let u=class{constructor(y,m,P){this.a=new h(y.stateResource,m,P)}async init(){await this.a.init()}getItem(y,m){return this.a.getItem(y,m)}};u=me([_(0,T.IEnvironmentService),_(1,b.ILogService),_(2,N.IFileService)],u),e.StateService=u}),define(Z[68],Q([0,1,12,35,11,31]),function(x,e,L,O,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(u){if(L.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}async function b(u,p,y,m,P,v,D,E,c,g){const w=Object.create(null);w["common.machineId"]=D,w.sessionID=(0,T.generateUuid)()+Date.now(),w.commitHash=P,w.version=v,w["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,L.PlatformToString)(L.platform),w["common.nodePlatform"]=O.platform,w["common.nodeArch"]=m,w["common.product"]=g||"desktop",E&&(w["common.msftInternal"]=E);let d=0;const o=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),L.isLinuxSnap&&(w["common.snap"]="true");const t=N(y);t&&(w["common.platformDetail"]=t);try{const r=await u.readFile(k.URI.file(c));w["common.source"]=r.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=b;function h(u){const p=O.env.USERDNSDOMAIN;if(!p)return!1;const y=p.toLowerCase();return u.some(m=>y===m)}e.verifyMicrosoftInternalDomain=h}),define(Z[28],Q([0,1,8]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(O=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[39],Q([0,1,30,4,3,21,66,68,28]),function(x,e,L,O,k,T,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class u{constructor(a){this.value=a}}e.TrustedTelemetryValue=u;class p{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,f){return Promise.resolve(void 0)}publicLog2(a,f){return this.publicLog(a,f)}publicLogError(a,f){return Promise.resolve(void 0)}publicLogError2(a,f){return this.publicLogError(a,f)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class y{async publicLog(a,f,S){}async publicLogError(a,f,S){}}e.NullEndpointTelemetryService=y,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(l,a){return k.Event.debounce(a.onDidChangeConfiguration,(S,A)=>{const $=S?new Set([...S.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:$}},1e3,!0)(S=>{S.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(S.source),configurationKeys:d(S.affectedKeys)})})}e.configurationTelemetry=m;function P(l,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!l.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=P;function v(l,a){return!(a.isBuilt||a.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.isLoggingOnly=v;function D(l){const a=l.getValue(h.TELEMETRY_SETTING_ID),f=l.getValue(h.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(l.getValue(h.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=D;function E(l){const a={},f={},S={};w(l,S);for(let A in S){A=A.length>150?A.substr(A.length-149):A;const $=S[A];typeof $=="number"?f[A]=$:typeof $=="boolean"?f[A]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${$.length}`),a[A]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(a[A]=$)}return{properties:a,measurements:f}}e.validateTelemetryData=E;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(l){if(!l)return"none";const a=(0,N.getRemoteName)(l);return c.has(a)?a:"other"}e.cleanRemoteAuthority=g;function w(l,a,f=0,S){if(!!l)for(const A of Object.getOwnPropertyNames(l)){const $=l[A],H=S?S+A:A;Array.isArray($)?a[H]=(0,L.safeStringify)($):$ instanceof Date?a[H]=$.toISOString():(0,O.isObject)($)?f<2?w($,a,f+1,H+"."):a[H]=(0,L.safeStringify)($):a[H]=$}}function d(l){if(!l)return[];const a=[];return o(a,"",l),a}function o(l,a,f){f&&typeof f=="object"&&!Array.isArray(f)?Object.keys(f).forEach(S=>o(l,a?`${a}.${S}`:S,f[S])):l.push(a)}function t(l,a){const f=l.msftInternalDomains||[],S=a.getValue("telemetry.internalTesting");return(0,b.verifyMicrosoftInternalDomain)(f)||S}e.isInternalTelemetry=t;function r(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=r;function i(l,a){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let f=l;const S=[];for(const J of a)for(;;){const ie=J.exec(l);if(!ie)break;S.push([ie.index,J.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let H=0;for(f="";;){const J=$.exec(l);if(!J)break;const ie=S.some(([re,ee])=>J.index<ee&&re<$.lastIndex);!A.test(J[0])&&!ie&&(f+=l.substring(H,J.index)+"<REDACTED: user-file-path>",H=$.lastIndex)}return H<l.length&&(f+=l.substr(H)),f}function n(l){if(!l)return l;const a=l.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const S of f)if(S.regex.test(a))return`<REDACTED: ${S.label}>`;return l}function s(l,a){return(0,L.cloneAndChange)(l,f=>{if(f instanceof u)return f.value;if(typeof f=="string"){let S=f.replaceAll("%20"," ");S=i(S,a);for(const A of a)S=S.replace(A,"");return S=n(S),S}})}e.cleanData=s}),define(Z[24],Q([0,1,32,23,27,12,11,9,35,39]),function(x,e,L,O,k,T,N,b,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,L.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=p;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(n){const s=n.manifest?n.manifest.version:n.version,l=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new m(n.identifier,s,l)}static parse(n){const s=y.exec(n);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,l="undefined"){this.version=s,this.targetPlatform=l,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof m?p(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=m;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(i){const n=P.exec(i);return n&&n[1]?[E(n[1]),n[2]]:[E(i),void 0]}e.getIdAndVersion=v;function D(i,n){return`${i}.${n}`}e.getExtensionId=D;function E(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function c(i,n){return E(D(i,n))}e.getGalleryExtensionId=c;function g(i,n){const s=[],l=a=>{for(const f of s)if(f.some(S=>p(n(S),n(a))))return f;return null};for(const a of i){const f=l(a);f?f.push(a):s.push([a])}return s}e.groupByExtension=g;function w(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function d(i){return{id:new u.TrustedTelemetryValue(i.identifier.id),name:new u.TrustedTelemetryValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function o(i,n){const s=[],l=n.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const a=l.shift();if(a&&s.every(f=>!p(f.identifier,{id:a}))){const f=i.filter(S=>p(S.identifier,{id:a}));f.length===1&&(s.push(f[0]),l.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=o;async function t(i,n){if(!T.isLinux)return!1;let s;try{s=(await i.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await i.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(a))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function r(i,n){const s=await t(i,n),l=(0,O.getTargetPlatform)(s?"alpine":T.platform,h.arch);return n.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=r}),define(Z[132],Q([0,1,22,9,16,17,40,11,89,23,24,27]),function(x,e,L,O,k,T,N,b,h,u,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const m=E=>(0,h.localize)(0,null,E),P=(0,h.localize)(1,null,"ms-dotnettools.csharp");function v(E,c){return c?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}let D=class{constructor(c,g){this.a=c,this.b=g}get d(){}async listExtensions(c,g,w,d=console){let o=await this.a.getInstalled(1,w);const t=y.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(g&&g!==""){if(t.indexOf(g.toLowerCase())<0){d.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}o=o.filter(i=>i.manifest.categories?i.manifest.categories.map(s=>s.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){d.log("Possible Categories: "),t.forEach(i=>{d.log(i)});return}this.d&&d.log((0,h.localize)(2,null,this.d)),o=o.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let r;for(const i of o)r!==i.identifier.id&&(r=i.identifier.id,d.log(v(i.manifest,c)))}async installExtensions(c,g,w,d,o=console){const t=[],r=[];c.length&&o.log(this.d?(0,h.localize)(3,null,this.d):(0,h.localize)(4,null));const i=await this.a.getInstalled(1,w.profileLocation),n=(f,S)=>{const A=i.find($=>(0,p.areSameExtensions)($.identifier,{id:f}));if(A){if(!d&&(!S||S==="prerelease"&&A.preRelease))return o.log((0,h.localize)(5,null,f,A.manifest.version,f)),!1;if(S&&A.manifest.version===S)return o.log((0,h.localize)(6,null,`${f}@${S}`)),!1}return!0},s=(f,S,A)=>{a.push({id:f,version:S!=="prerelease"?S:void 0,installOptions:{...w,isBuiltin:A,installPreReleaseVersion:S==="prerelease"||w.installPreReleaseVersion}})},l=[],a=[];for(const f of c)if(f instanceof b.URI)l.push(f);else{const[S,A]=(0,p.getIdAndVersion)(f);n(S,A)&&s(S,A,!1)}for(const f of g){const[S,A]=(0,p.getIdAndVersion)(f);n(S,A)&&s(S,A,!0)}if(l.length&&await Promise.all(l.map(async f=>{try{const S=await this.f(f,{...w,isBuiltin:!1},d,o);S&&r.push(S)}catch(S){o.error(S.message||S.stack||S),t.push(f.toString())}})),a.length){const f=await this.g(a);await Promise.all(a.map(async S=>{const A=f.get(S.id.toLowerCase());if(A)try{const $=await this.h(S,A,i,d,o);$&&r.push($)}catch($){o.error($.message||$.stack||$),t.push(S.id)}else o.error(`${m(S.version?`${S.id}@${S.version}`:S.id)}
${P}`),t.push(S.id)}))}if(t.length)throw new Error((0,h.localize)(7,null,t.join(", ")))}async f(c,g,w,d){const o=await this.a.getManifest(c);if(!o)throw new Error("Invalid vsix");if(await this.k(o,w,g.profileLocation,d))try{return await this.a.install(c,g),d.log((0,h.localize)(8,null,(0,T.basename)(c))),o}catch(r){if((0,O.isCancellationError)(r))return d.log((0,h.localize)(9,null,(0,T.basename)(c))),null;throw r}return null}async g(c){const g=new Map,w=c.some(o=>o.installOptions.installPreReleaseVersion),d=await this.b.getExtensions(c.map(o=>({...o,preRelease:w})),L.CancellationToken.None);for(const o of d)g.set(o.identifier.id.toLowerCase(),o);return g}async h({id:c,version:g,installOptions:w},d,o,t,r){const i=await this.b.getManifest(d,L.CancellationToken.None);if(i&&!this.j(i,r))return null;const n=o.find(s=>(0,p.areSameExtensions)(s.identifier,d.identifier));if(n){if(d.version===n.manifest.version)return r.log((0,h.localize)(10,null,g?`${c}@${g}`:c)),null;r.log((0,h.localize)(11,null,c,d.version))}try{w.isBuiltin?r.log(g?(0,h.localize)(12,null,c,g):(0,h.localize)(13,null,c)):r.log(g?(0,h.localize)(14,null,c,g):(0,h.localize)(15,null,c));const s=await this.a.installFromGallery(d,{...w,installGivenVersion:!!g});return r.log((0,h.localize)(16,null,c,s.manifest.version)),i}catch(s){if((0,O.isCancellationError)(s))return r.log((0,h.localize)(17,null,c)),null;throw s}}j(c,g){return!0}async k(c,g,w,d){const o={id:(0,p.getGalleryExtensionId)(c.publisher,c.name)},r=(await this.a.getInstalled(1,w)).find(i=>(0,p.areSameExtensions)(o,i.identifier)&&(0,N.gt)(i.manifest.version,c.version));return r&&!g?(d.log((0,h.localize)(18,null,r.identifier.id,r.manifest.version,c.version)),!1):this.j(c,d)}async uninstallExtensions(c,g,w,d=console){const o=async r=>{if(r instanceof b.URI){const i=await this.a.getManifest(r);return v(i)}return r},t=[];for(const r of c){const i=await o(r),s=(await this.a.getInstalled(void 0,w)).filter(l=>(0,p.areSameExtensions)(l.identifier,{id:i}));if(!s.length)throw new Error(`${this.l(i)}
${P}`);if(s.some(l=>l.type===0)){d.log((0,h.localize)(19,null,i));return}if(!g&&s.some(l=>l.isBuiltin)){d.log((0,h.localize)(20,null,i));return}d.log((0,h.localize)(21,null,i));for(const l of s)await this.a.uninstall(l,{profileLocation:w}),t.push(l);this.d?d.log((0,h.localize)(22,null,i,this.d)):d.log((0,h.localize)(23,null,i))}}async locateExtension(c,g=console){const w=await this.a.getInstalled();c.forEach(d=>{w.forEach(o=>{if(o.identifier.id===d&&o.location.scheme===k.Schemas.file){g.log(o.location.fsPath);return}})})}l(c){return this.d?(0,h.localize)(24,null,c,this.d):(0,h.localize)(25,null,c)}};D=me([_(0,u.IExtensionManagementService),_(1,u.IExtensionGalleryService)],D),e.ExtensionManagementCLI=D}),define(Z[133],Q([0,1,5,9,2,16,12,17,40,4,31,20,21,18,23,24,59,13,10,26]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P,v,D,E,c,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let d=class Ve extends k.Disposable{constructor(t,r,i,n,s,l,a,f){super(),this.h=t,this.i=i,this.j=n,this.k=s,this.l=l,this.m=a,this.n=f,this.extensionsDownloadDir=r.extensionsDownloadLocation,this.f=20,this.g=this.w()}async download(t,r){await this.g;const i=(0,b.joinPath)(this.extensionsDownloadDir,this.y(t));try{await this.u(t,i,s=>this.j.download(t,s,r))}catch(s){throw new v.ExtensionManagementError(s.message,v.ExtensionManagementErrorCode.Download)}let n=!1;if(await this.r(t)){const s=await this.t(t);try{n=await this.m.verify(i.fsPath,s.fsPath),this.n.info(`Verified extension: ${t.identifier.id}`,n)}catch(l){throw await this.delete(s),await this.delete(i),new v.ExtensionManagementError(l.code,v.ExtensionManagementErrorCode.Signature)}}return{location:i,verified:n}}async r(t){if(!t.isSigned||await this.h==="linux-armhf")return!1;const i=this.k.getValue("extensions.verifySignature");return(0,u.isBoolean)(i)?i:this.l.quality!=="stable"}async t(t){await this.g;const r=(0,b.joinPath)(this.extensionsDownloadDir,`${this.y(t)}${Ve.c}`);return await this.u(t,r,i=>this.j.downloadSignatureArchive(t,i)),r}async u(t,r,i){if(await this.i.exists(r))return;if(r.scheme!==T.Schemas.file){await i(r);return}const n=(0,b.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`);await this.i.exists(n)||await i(n);try{await this.v(n,r,Date.now()+2*60*1e3)}catch(s){try{await this.i.del(n)}catch{}if(s.code==="ENOTEMPTY")this.n.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,r.path);else throw this.n.info(`Rename failed because of ${(0,O.getErrorMessage)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(t){await this.g,await this.i.del(t)}async v(t,r,i){try{await y.Promises.rename(t.fsPath,r.fsPath)}catch(n){if(N.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.n.info(`Failed renaming ${t} to ${r} with 'EPERM' error. Trying again...`),this.v(t,r,i);throw n}}async w(){try{if(!await this.i.exists(this.extensionsDownloadDir)){this.n.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.i.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const r=[],i=[],n=[];for(const a of t.children)if(a.name.endsWith(Ve.c))n.push(a.resource);else{const f=D.ExtensionKey.parse(a.name);f&&i.push([f,a])}const s=(0,D.groupByExtension)(i,([a])=>a),l=[];for(const a of s)a.sort((f,S)=>h.rcompare(f[0].version,S[0].version)),r.push(...a.slice(1).map(f=>f[1].resource)),l.push(a[0][1]);l.sort((a,f)=>a.mtime-f.mtime),r.push(...l.slice(0,Math.max(0,l.length-this.f)).map(a=>a.resource)),r.push(...n),await L.Promises.settled(r.map(a=>(this.n.trace("Deleting from cache",a.path),this.i.del(a))))}}catch(t){this.n.error(t)}}y(t){return this.f?D.ExtensionKey.create(t).toString().toLowerCase():(0,p.generateUuid)()}};d.c=".sigzip",d=me([_(1,P.INativeEnvironmentService),_(2,c.IFileService),_(3,v.IExtensionGalleryService),_(4,m.IConfigurationService),_(5,w.IProductService),_(6,E.IExtensionSignatureVerificationService),_(7,g.ILogService)],d),e.ExtensionsDownloader=d}),define(Z[134],Q([0,1,3,2,36,24,27]),function(x,e,L,O,k,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class b extends O.Disposable{constructor(u,p,y,m,P,v,D){super(),this.f=u,this.g=p,this.h=y,this.i=m,this.j=P,this.k=v,this.l=D,this.a=this.B(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.DisposableMap),this.m().then(null,E=>D.error(E))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(u=>this.p(u.added,u.removed))),this.B(this.i.onAddExtensions(u=>this.r(u))),this.B(this.i.onDidAddExtensions(u=>this.s(u))),this.B(this.i.onRemoveExtensions(u=>this.t(u))),this.B(this.i.onDidRemoveExtensions(u=>this.u(u))),this.B(this.k.onDidFilesChange(u=>this.v(u)))}async p(u,p){try{await Promise.all(p.map(y=>(this.c.deleteAndDispose(y.id),this.z(y.extensionsResource)))),u.length&&await Promise.all(u.map(y=>(this.c.set(y.id,(0,O.combinedDisposable)(this.k.watch(this.j.extUri.dirname(y.extensionsResource)),this.k.watch(y.extensionsResource))),this.y(y.extensionsResource))))}catch(y){throw this.l.error(y),y}}async r(u){for(const p of u.extensions)this.D(this.G(p.identifier,p.version),u.profileLocation)}async s(u){for(const p of u.extensions){const y=this.G(p.identifier,p.version);u.error?this.F(y,u.profileLocation):this.D(y,u.profileLocation)}}async t(u){for(const p of u.extensions)this.F(this.G(p.identifier,p.version),u.profileLocation)}async u(u){let p=!1;for(const y of u.extensions){const m=this.G(y.identifier,y.version);u.error?this.D(m,u.profileLocation):(this.F(m,u.profileLocation),p=p||!this.b.has(m))}p&&await this.C()}v(u){for(const p of this.h.profiles)u.contains(p.extensionsResource,0,1)&&this.w(p.extensionsResource)}async w(u){const p=[],y=[],m=await this.i.scanProfileExtensions(u),P=new Set,v=new Set;for(const[D,E]of this.b)E.has(u)&&v.add(D);for(const D of m){const E=this.G(D.identifier,D.version);P.add(E),v.has(E)||(p.push(D.identifier),this.D(E,u))}for(const D of v)if(!P.has(D)){const E=this.H(D);E&&(y.push(E.identifier),this.F(D,u))}(p.length||y.length)&&this.a.fire({added:p.length?{extensions:p,profileLocation:u}:void 0,removed:y.length?{extensions:y,profileLocation:u}:void 0})}async y(u){const p=await this.i.scanProfileExtensions(u);for(const y of p)this.D(this.G(y.identifier,y.version),u)}async z(u){for(const p of[...this.b.keys()])this.F(p,u);await this.C()}async C(){const p=(await this.f.getAllUserInstalled()).filter(y=>y.installedTimestamp&&!this.b.has(this.G(y.identifier,y.manifest.version)));p.length&&await this.f.markAsUninstalled(...p)}D(u,p){let y=this.b.get(u);y||this.b.set(u,y=new k.ResourceSet(m=>this.j.extUri.getComparisonKey(m))),y.add(p)}F(u,p){const y=this.b.get(u);y&&y.delete(p),y?.size||this.b.delete(u)}G(u,p){return`${N.ExtensionIdentifier.toKey(u.id)}@${p}`}H(u){const[p,y]=(0,T.getIdAndVersion)(u);return y?{identifier:{id:p},version:y}:void 0}}e.ExtensionsWatcher=b}),define(Z[135],Q([0,1,109,39]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(T,N,b,h,u,p,y){const m={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${N.nameShort})`};if((0,O.supportsTelemetry)(N,b)&&(0,O.getTelemetryLevel)(h)===3){const P=await(0,L.getServiceMachineId)(b,u,p),{machineId:v}=await y.getTelemetryInfo();m["X-Market-User-Id"]=P,m["VSCode-SessionId"]=v||P}return m}e.resolveMarketplaceHeaders=k}),define(Z[136],Q([0,1,162,19,5,2,16,14,20,18,23,24,10,63,12,11]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends P.LanguagePackBaseService{constructor(d,o,t,r){super(t),this.h=d,this.i=r,this.g=this.B(new c(o,r)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(d){const t=(await this.g.getLanguagePacks())[v.Language.value()];if(!t){this.i.warn(`No language pack found for ${v.Language.value()}`);return}const r=t.translations[d];return r?D.URI.file(r):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),o=Object.keys(d).map(t=>{const r=d[t];return{...this.f(t,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return o.push({...this.f("en","English"),extensionId:"default"}),o.sort((t,r)=>t.label.localeCompare(r.label)),o}async j(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",d.identifier.id),await this.update())}async k(d){const o=await this.g.getLanguagePacks();Object.keys(o).some(t=>o[t]&&o[t].extensions.some(r=>(0,y.areSameExtensions)(r.extensionIdentifier,d.identifier)))&&(this.i.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,o]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(o);return!(0,O.equals)(Object.keys(d),Object.keys(t))}};E=me([_(0,p.IExtensionManagementService),_(1,u.INativeEnvironmentService),_(2,p.IExtensionGalleryService),_(3,m.ILogService)],E),e.NativeLanguagePackService=E;let c=class extends T.Disposable{constructor(d,o){super(),this.i=o,this.c={},this.f=(0,b.join)(d.userDataPath,"languagepacks.json"),this.g=new k.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.m(o=>{Object.keys(o).forEach(t=>delete o[t]),this.j(o,...d)}).then(()=>this.c)}j(d,...o){for(const t of o)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(d,t);Object.keys(d).forEach(t=>this.l(d[t]))}k(d,o){const t=o.identifier,r=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const i of r)if(o.location.scheme===N.Schemas.file&&g(i)){let n=d[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},d[i.languageId]=n);const s=n.extensions.filter(l=>(0,y.areSameExtensions)(l.extensionIdentifier,t))[0];s?s.version=o.manifest.version:n.extensions.push({extensionIdentifier:t,version:o.manifest.version});for(const l of i.translations)n.translations[l.id]=(0,b.join)(o.location.fsPath,l.path)}}l(d){if(d){const o=(0,L.createHash)("md5");for(const t of d.extensions)o.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);d.hash=o.digest("hex")}}m(d=()=>null){return this.g.queue(()=>{let o=null;return h.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(o=d(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const r=JSON.stringify(this.c);return this.i.debug("Writing language packs",r),h.Promises.writeFile(this.f,r)}).then(()=>o,t=>this.i.error(t))})}};c=me([_(0,u.INativeEnvironmentService),_(1,m.ILogService)],c);function g(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const d of w.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(Z[137],Q([0,1,9,30,39]),function(x,e,L,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0",N="https://mobile.events.data.microsoft.com/ping";async function b(u,p,y){const m=await new Promise((c,g)=>{x(["@microsoft/1ds-core-js"],c,g)}),P=await new Promise((c,g)=>{x(["@microsoft/1ds-post-js"],c,g)}),v=new m.AppInsightsCore,D=new P.PostChannel,E={instrumentationKey:u,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[D]]};if(y){E.extensionConfig={};const c={alwaysUseXhrOverride:!0,httpXHROverride:y};E.extensionConfig[D.identifier]=c}return v.initialize(E,[]),v.addTelemetryInitializer(c=>{p&&(c.ext=c.ext??{},c.ext.utc=c.ext.utc??{},c.ext.utc.flags=8462029)}),v}class h{constructor(p,y,m,P,v){this.e=p,this.f=y,this.g=m,this.h=v,this.c=T,this.d=N,this.g||(this.g={}),typeof P=="function"?this.a=P():this.a=P,this.b=null}i(p){if(!!this.a){if(typeof this.a!="string"){p(this.a);return}this.b||(this.b=b(this.a,this.e,this.h)),this.b.then(y=>{p(y)},y=>{(0,L.onUnexpectedError)(y),console.error(y)})}}log(p,y){if(!this.a)return;y=(0,O.mixin)(y,this.g),y=(0,k.validateTelemetryData)(y);const m=this.f+"/"+p;try{this.i(P=>{P.pluginVersionString=y?.properties.version??"Unknown",P.track({name:m,baseData:{name:m,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(p=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=h}),define(Z[138],Q([0,1,2,30,12,32,101,21,41,139,26,37,28,39]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(c,g,w){this.k=g,this.l=w,this.d={},this.i=new L.DisposableStore,this.j=[],this.b=c.appenders,this.c=c.commonProperties||Promise.resolve({}),this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,T.escapeRegExpCharacters)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,T.escapeRegExpCharacters)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(m.TELEMETRY_SETTING_ID)||d.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||d.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(c,g){this.d[c]=g}m(){let c=(0,P.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const w=g.usage?3:g.error?2:0;c=Math.min(c,w)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const c=await this.c,g=c.sessionID,w=c["common.machineId"],d=c["common.firstSessionDate"],o=c["common.msftInternal"];return{sessionId:g,machineId:w,firstSessionDate:d,msftInternal:o}}dispose(){this.i.dispose()}n(c,g,w){return this.g<g?Promise.resolve(void 0):this.c.then(d=>{w=(0,O.mixin)(w,this.d),w=(0,P.cleanData)(w,this.j),w=(0,O.mixin)(w,d),this.b.forEach(o=>o.log(c,w))},d=>{console.error(d)})}publicLog(c,g){return this.n(c,3,g)}publicLog2(c,g){return this.publicLog(c,g)}publicLogError(c,g){return this.h?this.n(c,2,g):Promise.resolve(void 0)}publicLogError2(c,g){return this.publicLogError(c,g)}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=me([_(1,b.IConfigurationService),_(2,p.IProductService)],v),e.TelemetryService=v;function D(){const E=(0,N.localize)(0,null,u.default.nameLong),c=u.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=k.isWeb?"":(0,N.localize)(3,null),w=(0,N.localize)(4,null),d=(0,N.localize)(5,null),o=(0,N.localize)(6,null),t=(0,N.localize)(7,null),r=`
|       | ${w} | ${d} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${E} ${c} ${g}

&nbsp;

${t}
${r}

&nbsp;

${i}
`}y.Registry.as(h.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:D(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(h.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,N.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,N.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[140],Q([0,1,163,137]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends O.AbstractOneDataSystemAppender{constructor(N,b,h,u){const p={sendPOST:(y,m)=>{const P={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const v=L.request(y.urlString,P,D=>{D.on("data",function(E){m(D.statusCode??200,D.headers,E.toString())}),D.on("error",function(E){m(0,{})})});v.write(y.data),v.end()}catch{m(0,{})}}};super(N,b,h,u,p)}}e.OneDataSystemAppender=k}),define(Z[141],Q([0,1,14,20]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(T,N){const b=Object.create(null),h=(p,y)=>{const m=JSON.parse(p);b[y]=m};if(N){const p=[],y=await O.Promises.readdir(N);for(const P of y)try{(await O.Promises.stat((0,L.join)(N,P))).isDirectory()&&p.push(P)}catch{}const m=[];for(const P of p)(await O.Promises.readdir((0,L.join)(N,P))).filter(D=>D==="telemetry.json").length===1&&m.push(P);for(const P of m){const v=(await O.Promises.readFile((0,L.join)(N,P,"telemetry.json"))).toString();h(v,P)}}let u=(await O.Promises.readFile((0,L.join)(T,"telemetry-core.json"))).toString();return h(u,"vscode-core"),u=(await O.Promises.readFile((0,L.join)(T,"telemetry-extensions.json"))).toString(),h(u,"vscode-extensions"),JSON.stringify(b,null,4)}e.buildTelemetryMessage=k}),define(Z[142],Q([0,1,12,80,28]),function(x,e,L,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function T(N){let b=N.getItem(k.machineIdKey);return(typeof b!="string"||L.isMacintosh&&b==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(b=await(0,O.getMachineId)()),b}e.resolveMachineId=T}),define(Z[29],Q([0,1,8]),function(x,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(Z[143],Q([0,1,29,110,13,17,72,3,2]),function(x,e,L,O,k,T,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{constructor(m){this.uri=m,this.time=u._clock++}touch(){return this.time=u._clock++,this}}u._clock=0;let p=class{constructor(m){this.g=m,this.c=new h.DisposableStore,this.f=2**16;const P=new Map,v=D=>{let E=P.get(D.scheme);return E===void 0&&(E=m.hasProvider(D)&&!this.g.hasCapability(D,1024),P.set(D.scheme,E)),E};this.c.add(b.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(D=>{P.delete(D.scheme)})),this.extUri=new T.ExtUri(v),this.d=new N.SkipList((D,E)=>this.extUri.compare(D,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,T.normalizePath)(m));const P=this.d.get(m);return P?P.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new u(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((v,D)=>v[1].touch<D[1].touch?1:v[1].touch>D[1].touch?-1:0);u._clock=0,this.d.clear();const P=this.f*.5;for(let v=0;v<P;v++)this.d.set(m[v][0],m[v][1].touch())}};p=me([_(0,k.IFileService)],p),e.UriIdentityService=p,(0,O.registerSingleton)(L.IUriIdentityService,p,1)}),define(Z[144],Q([0,1,103,14,54,17,11,8,16]),function(x,e,L,O,k,T,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function u(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=u;function p(i){return typeof i?.id=="string"&&!u(i)&&!m(i)}e.isEmptyWorkspaceIdentifier=p,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=i;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=y;function m(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=m;function P(i){const n=i;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const s=i;if(s?.configPath)return{id:s.id,configPath:N.URI.revive(s.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=P;var v;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function D(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=D;function E(i){const n=i;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=E;class c{constructor(n,s,l,a,f){this.h=n,this.j=l,this.k=a,this.l=f,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=s}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=c;class g{constructor(n,s){this.raw=s,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,T.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function w(i){return new g({uri:i,index:0,name:(0,T.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function d(i,n){return T.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function o(i){let n;return N.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=o;function t(i,n){return!d(i,n)&&!o(i)}e.isSavedWorkspace=t;function r(i){return(typeof i=="string"?(0,O.extname)(i):(0,T.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Z[25],Q([0,1,52,3,2,17,11,102,18,13,8,10,144,36,29,5,31,32,4]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P,v,D,E,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function w(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.isUserDataProfile=w,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,p.createDecorator)("IUserDataProfilesService");function d(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:N.URI.revive(i.location).with({scheme:n}),globalStorageHome:N.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=d;function o(i,n,s,l){return{id:i,name:n,location:s,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,T.joinPath)(s,"globalStorage"),settingsResource:(0,T.joinPath)(s,"settings.json"),keybindingsResource:(0,T.joinPath)(s,"keybindings.json"),tasksResource:(0,T.joinPath)(s,"tasks.json"),snippetsHome:(0,T.joinPath)(s,"snippets"),extensionsResource:(0,T.joinPath)(s,"extensions.json"),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=o;let t=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,s,l,a){super(),this.m=n,this.n=s,this.r=l,this.s=a,this.f=!1,this.g=this.B(new O.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new O.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new O.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new O.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new P.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,T.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)for(const f of this.G()){if(!f.name||!(0,g.isString)(f.name)||!f.location){this.s.warn("Skipping the invalid stored profile",f.location||f.name);continue}n.push(o((0,T.basename)(f.location),f.name,f.location,{shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}))}const s=new P.ResourceMap,l=new Map,a=o((0,L.hash)(this.m.userRoamingDataHome.path).toString(16),(0,b.localize)(0,null),this.m.userRoamingDataHome);if(n.unshift({...a,extensionsResource:this.L()??a.extensionsResource,isDefault:!0}),n.length){const f=this.I();if(f.workspaces)for(const[S,A]of Object.entries(f.workspaces)){const $=N.URI.parse(S),H=N.URI.parse(A),J=n.find(ie=>this.r.extUri.isEqual(ie.location,H));J&&s.set($,J)}if(f.emptyWindows)for(const[S,A]of Object.entries(f.emptyWindows)){const $=N.URI.parse(A),H=n.find(J=>this.r.extUri.isEqual(J.location,$));H&&l.set(S,H)}}this.t={profiles:n,workspaces:s,emptyWindows:l}}return this.t}async createTransientProfile(n){const s="Temp",l=new RegExp(`${(0,c.escapeRegExpCharacters)(s)}\\s(\\d+)`);let a=0;for(const S of this.profiles){const A=l.exec(S.name),$=A?parseInt(A[1]):0;a=$>a?$:a}const f=`${s} ${a+1}`;return this.createProfile((0,L.hash)((0,E.generateUuid)()).toString(16),f,{transient:!0},n)}async createNamedProfile(n,s,l){return this.createProfile((0,L.hash)((0,E.generateUuid)()).toString(16),n,s,l)}async createProfile(n,s,l,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const f=await this.v(n,s,l);return a&&await this.setProfileForWorkspace(a,f),f}async v(n,s,l){if(!(0,g.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(s);return a||(a=(async()=>{try{const f=this.profiles.find($=>$.name===s||$.id===n);if(f)return f;const S=o(n,s,(0,T.joinPath)(this.profilesHome,n),l);await this.n.createFolder(S.location);const A=[];return this.h.fire({profile:S,join($){A.push($)}}),await D.Promises.settled(A),this.z([S],[],[]),S}finally{this.k.delete(s)}})(),this.k.set(s,a)),a}async updateProfile(n,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let l=this.profiles.find(a=>a.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=o(l.id,s.name??l.name,l.location,{shortName:s.shortName??l.shortName,transient:s.transient??l.isTransient,useDefaultFlags:s.useDefaultFlags??l.useDefaultFlags}),this.z([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(a=>a.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.i.fire({profile:s,join(a){l.push(a)}});try{await Promise.allSettled(l)}catch(a){this.s.error(a)}for(const a of[...this.u.emptyWindows.keys()])s.id===this.u.emptyWindows.get(a)?.id&&this.u.emptyWindows.delete(a);for(const a of[...this.u.workspaces.keys()])s.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.F(),this.z([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(a){this.s.error(a)}}async setProfileForWorkspace(n,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const l=this.profiles.find(a=>a.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);this.D(n,l)}unsetWorkspace(n,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(n,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(l=>!this.r.extUri.isEqual(l.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(s=>!this.y(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.w(n);return N.URI.isUri(s)?this.l.workspaces.get(s)??this.u.workspaces.get(s):this.l.emptyWindows.get(s)??this.u.emptyWindows.get(s)}w(n){return(0,m.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,m.isWorkspaceIdentifier)(n)?n.configPath:n.id}y(n){return!!([...this.l.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.l.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.u.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.u.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,n.location)))}z(n,s,l){const a=[...this.profiles,...n],f=[];this.l.profiles=[];for(let S of a)S.isDefault||s.some(A=>S.id===A.id)||(S=l.find(A=>S.id===A.id)??S,S.isTransient?this.l.profiles.push(S):f.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.H(f),this.t=void 0,this.C(n,s,l)}C(n,s,l){this.g.fire({added:n,removed:s,updated:l,all:this.profiles})}D(n,s,l){l=s?.isTransient?!0:l,l||this.D(n,void 0,!0);const a=this.w(n),f=l?this.l:this.u;N.URI.isUri(a)?(f.workspaces.delete(a),s&&f.workspaces.set(a,s)):(f.emptyWindows.delete(a),s&&f.emptyWindows.set(a,s)),l||this.F()}F(){const n={};for(const[l,a]of this.u.workspaces.entries())n[l.toString()]=a.location.toString();const s={};for(const[l,a]of this.u.emptyWindows.entries())s[l.toString()]=a.location.toString();this.J({workspaces:n,emptyWindows:s}),this.t=void 0}G(){return[]}H(n){throw new Error("not implemented")}I(){return{}}J(n){throw new Error("not implemented")}L(){}};t.b="userDataProfiles",t.c="profileAssociations",t=me([_(0,h.IEnvironmentService),_(1,u.IFileService),_(2,v.IUriIdentityService),_(3,y.ILogService)],t),e.UserDataProfilesService=t;class r extends t{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(n){this.a=n}I(){return this.O}J(n){this.O=n}}e.InMemoryUserDataProfilesService=r}),define(Z[145],Q([0,1,19,5,22,9,3,2,12,11,87,23,24,27,10,26,28,25]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P,v,D,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends b.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,n,s,l,a){super(),this.t=i,this.u=n,this.v=s,this.w=l,this.y=a,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.Emitter),this.m=this.B(new N.Emitter),this.n=this.B(new N.Emitter),this.p=this.B(new N.Emitter),this.s=[],this.B((0,b.toDisposable)(()=>{this.j.forEach(({task:f})=>f.cancel()),this.k.forEach(f=>f.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const n=await this.getTargetPlatform();return i.allTargetPlatforms.some(s=>(0,y.isTargetPlatformCompatible)(s,i.allTargetPlatforms,n))}async installFromGallery(i,n={}){try{if(!this.t.isEnabled())throw new y.ExtensionManagementError(p.localize(0,null),y.ExtensionManagementErrorCode.Internal);const s=await this.G(i,!!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.z(s.manifest,s.extension,n)}catch(s){throw o(this.u,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(i),error:s}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(s),d(s)}}async uninstall(i,n={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,n)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,n,s){const l={...s,installOnlyNewlyAddedFromExtensionPack:u.URI.isUri(n)?s.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,P.isApplicationScopedExtension)(i)?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},a=J=>`${m.ExtensionKey.create(J).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!u.URI.isUri(n)){const J=this.j.get(a(n));if(J){this.v.info("Extensions is already requested to install",n.identifier.id);const{local:ie}=await J.task.waitUntilTaskIsFinished();return ie}}const f=[],S=[],A=[],$=this.Q(i,n,l);u.URI.isUri(n)||this.j.set(a(n),{task:$,waitingTasks:[]}),this.l.fire({identifier:$.identifier,source:n,profileLocation:l.profileLocation}),this.v.info("Installing extension:",$.identifier.id),f.push({task:$,manifest:i});let H=!1;try{if(l.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",$.identifier.id);else try{const ie=await this.F($.identifier,i,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),re=await this.getInstalled(void 0,l.profileLocation);for(const{gallery:ee,manifest:pe}of(0,L.distinct)(ie,({gallery:le})=>le.identifier.id)){H=H||!!pe.extensionDependencies?.some(he=>(0,m.areSameExtensions)({id:he},$.identifier));const le=a(ee),ae=this.j.get(le);if(ae){if(this.C($,ae.task)){const he=ae.task.identifier;this.v.info("Waiting for already requested installing extension",he.id,$.identifier.id),ae.waitingTasks.push($),S.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,B=>B.some(j=>(0,m.areSameExtensions)(j.identifier,he)))).then(B=>{if(this.v.info("Finished waiting for already requested installing extension",he.id,$.identifier.id),!B.find(C=>(0,m.areSameExtensions)(C.identifier,he))?.local)throw new Error(`Extension ${he.id} is not installed`)}))}}else if(!re.some(({identifier:he})=>(0,m.areSameExtensions)(he,ee.identifier))){const he=this.Q(pe,ee,{...l,donotIncludePackAndDependencies:!0});this.j.set(le,{task:he,waitingTasks:[$]}),this.l.fire({identifier:he.identifier,source:ee,profileLocation:l.profileLocation}),this.v.info("Installing extension:",he.identifier.id,$.identifier.id),f.push({task:he,manifest:pe})}}}catch(ie){if(u.URI.isUri($.source))(0,L.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",$.identifier.id,ie.message),(0,L.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",$.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",$.identifier.id),ie}const J=f.reduce((ie,{task:re,manifest:ee})=>(ie.set(re.identifier.id.toLowerCase(),{task:re,manifest:ee}),ie),new Map);for(;J.size;){let ie;const re=[...J.values()].filter(({manifest:ee})=>!ee.extensionDependencies?.some(pe=>J.has(pe.toLowerCase())));re.length?ie=J.size===1?re:re.filter(({task:ee})=>!(ee===$&&!H)):(this.v.info("Found extensions with circular dependencies",re.map(({task:ee})=>ee.identifier.id)),ie=[...J.values()]),await this.D(ie.map(async({task:ee})=>{const pe=new Date().getTime();try{const{local:le}=await ee.run();if(await this.D(this.s.map(ae=>ae.postInstall(le,ee.source,l,k.CancellationToken.None))),!u.URI.isUri(ee.source)){const ae=ee.operation===3,he=ae?void 0:(new Date().getTime()-ee.source.lastUpdated)/1e3;if(o(this.u,ae?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(ee.source),wasVerified:ee.wasVerified,duration:new Date().getTime()-pe,durationSinceUpdate:he}),h.isWeb&&ee.operation!==3)try{await this.t.reportStatistic(le.manifest.publisher,le.manifest.name,le.manifest.version,"install")}catch{}}A.push({local:le,identifier:ee.identifier,operation:ee.operation,source:ee.source,context:l.context,profileLocation:l.profileLocation,applicationScoped:le.isApplicationScoped})}catch(le){throw u.URI.isUri(ee.source)||o(this.u,ee.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(ee.source),wasVerified:ee.wasVerified,duration:new Date().getTime()-pe,error:le}),this.v.error("Error while installing the extension:",ee.identifier.id),le}finally{J.delete(ee.identifier.id.toLowerCase())}}))}return S.length&&await this.D(S),A.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(A),A.filter(({identifier:ie})=>(0,m.areSameExtensions)(ie,$.identifier))[0].local}catch(J){if(f.forEach(({task:ie})=>ie.cancel()),A.length)try{const ie=await Promise.allSettled(A.map(({local:re})=>this.R(re,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let re=0;re<ie.length;re++){const ee=ie[re],{identifier:pe}=A[re];ee.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",pe.id):this.v.warn("Rollback: Error while uninstalling extension",pe.id,(0,T.getErrorMessage)(ee.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,T.getErrorMessage)(ie),A.map(({identifier:re})=>re.id))}throw this.m.fire(f.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:l.context,profileLocation:l.profileLocation}))),J}finally{for(const{task:J}of f)J.source&&!u.URI.isUri(J.source)&&this.j.delete(a(J.source))}}C(i,n){for(const[,{task:s,waitingTasks:l}]of this.j.entries())if(s===i&&(l.includes(n)||l.some(a=>this.C(a,n)))||s===n&&l[0]&&!this.C(i,l[0]))return!1;return!0}async D(i){const n=[],s=[],l=await Promise.allSettled(i);for(const a of l)a.status==="fulfilled"?n.push(a.value):s.push(a.reason);if(s.length)throw w(s);return n}async F(i,n,s,l,a){if(!this.t.isEnabled())return[];const f=await this.getInstalled(void 0,a),S=[],A=[],$=async(H,J)=>{S.push(H);const ie=J.extensionDependencies||[],re=[...ie];if(J.extensionPack){const ee=s?f.find(pe=>(0,m.areSameExtensions)(pe.identifier,H)):void 0;for(const pe of J.extensionPack)ee&&ee.manifest.extensionPack&&ee.manifest.extensionPack.some(le=>(0,m.areSameExtensions)({id:le},{id:pe}))||re.every(le=>!(0,m.areSameExtensions)({id:le},{id:pe}))&&re.push(pe)}if(re.length){const ee=re.filter(pe=>S.every(le=>!(0,m.areSameExtensions)(le,{id:pe})));if(ee.length){const pe=await this.t.getExtensions(ee.map(le=>({id:le,preRelease:l})),k.CancellationToken.None);for(const le of pe){if(S.find(B=>(0,m.areSameExtensions)(B,le.identifier)))continue;const ae=ie.some(B=>(0,m.areSameExtensions)({id:B},le.identifier));let he;try{he=await this.G(le,!1,l)}catch(B){if(B instanceof y.ExtensionManagementError&&B.code===y.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ae){this.v.info("Skipping the packed extension as it cannot be installed",le.identifier.id);continue}else throw B}A.push({gallery:he.extension,manifest:he.manifest}),await $(he.extension.identifier,he.manifest)}}}};return await $(i,n),A}async G(i,n,s){if((await this.getExtensionsControlManifest()).malicious.some(S=>(0,m.areSameExtensions)(i.identifier,S)))throw new y.ExtensionManagementError(p.localize(1,null,i.identifier.id),y.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const S=await this.getTargetPlatform();throw new y.ExtensionManagementError(p.localize(2,null,i.identifier.id,this.w.nameLong,(0,y.TargetPlatformToString)(S)),y.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.H(i,n,s);if(a){if(s&&!n&&i.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new y.ExtensionManagementError(p.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),y.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],k.CancellationToken.None))[0]?new y.ExtensionManagementError(p.localize(4,null,i.identifier.id),y.ExtensionManagementErrorCode.ReleaseVersionNotFound):new y.ExtensionManagementError(p.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),y.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",a.identifier.id);const f=await this.t.getManifest(a,k.CancellationToken.None);if(f===null)throw new y.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,y.ExtensionManagementErrorCode.Invalid);if(f.version!==a.version)throw new y.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,y.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:f}}async H(i,n,s){const l=await this.getTargetPlatform();let a=null;return!n&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==s&&(a=(await this.t.getExtensions([{...i.identifier,preRelease:s}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.t.isExtensionCompatible(i,s,l)&&(a=i),a||(n?a=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null:a=await this.t.getCompatibleExtension(i,s,l)),a}async I(i,n){const s={...n,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:n.profileLocation??this.P()},l=H=>`${H.id.toLowerCase()}${s.versionOnly?`-${i.manifest.version}`:""}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,a=this.k.get(l(i.identifier));if(a)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),a.waitUntilTaskIsFinished();const f=H=>{const J=this.R(H,s);return this.k.set(l(J.extension.identifier),J),s.profileLocation?this.v.info("Uninstalling extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,s.profileLocation.toString()):this.v.info("Uninstalling extension:",`${H.identifier.id}@${H.manifest.version}`),this.n.fire({identifier:H.identifier,profileLocation:s.profileLocation,applicationScoped:H.isApplicationScoped}),J},S=(H,J)=>{J?s.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,s.profileLocation.toString(),J.message):this.v.error("Failed to uninstall extension:",`${H.identifier.id}@${H.manifest.version}`,J.message):s.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${H.identifier.id}@${H.manifest.version}`,s.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${H.identifier.id}@${H.manifest.version}`),o(this.u,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(H),error:J}),this.p.fire({identifier:H.identifier,error:J?.code,profileLocation:s.profileLocation,applicationScoped:H.isApplicationScoped})},A=[],$=[];try{A.push(f(i));const H=await this.getInstalled(1,s.profileLocation);if(s.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const J=this.M(i,H);for(const ie of J)this.k.has(l(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):A.push(f(ie))}s.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(A.map(J=>J.extension),H,i),await this.D(A.map(async J=>{try{if(await J.run(),await this.D(this.s.map(ie=>ie.postUninstall(J.extension,s,k.CancellationToken.None))),J.extension.identifier.uuid)try{await this.t.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}S(J.extension)}catch(ie){const re=ie instanceof y.ExtensionManagementError?ie:new y.ExtensionManagementError((0,T.getErrorMessage)(ie),y.ExtensionManagementErrorCode.Internal);throw S(J.extension,re),re}finally{$.push(J)}}))}catch(H){const J=H instanceof y.ExtensionManagementError?H:new y.ExtensionManagementError((0,T.getErrorMessage)(H),y.ExtensionManagementErrorCode.Internal);for(const ie of A){try{ie.cancel()}catch{}$.includes(ie)||S(ie.extension,J)}throw J}finally{for(const H of A)this.k.delete(l(H.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",H.extension.identifier.id)}}J(i,n,s){for(const l of i){const a=this.N(l,n);if(a.length){const f=a.filter(S=>!i.some(A=>(0,m.areSameExtensions)(A.identifier,S.identifier)));if(f.length)throw new Error(this.L(l,f,s))}}}L(i,n,s){return s===i?n.length===1?p.localize(6,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?p.localize(7,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):p.localize(8,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?p.localize(9,null,s.manifest.displayName||s.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?p.localize(10,null,s.manifest.displayName||s.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):p.localize(11,null,s.manifest.displayName||s.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}M(i,n,s=[]){if(s.indexOf(i)!==-1)return[];s.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const a=n.filter(S=>!S.isBuiltin&&l.some(A=>(0,m.areSameExtensions)({id:A},S.identifier))),f=[];for(const S of a)f.push(...this.M(S,n,s));return[...a,...f]}return[]}N(i,n){return n.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(l=>(0,m.areSameExtensions)({id:l},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};g=me([_(0,y.IExtensionGalleryService),_(1,E.ITelemetryService),_(2,v.ILogService),_(3,D.IProductService),_(4,c.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function w(r){const i=Array.isArray(r)?r:[r];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((n,s)=>new Error(`${n.message}${n.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=w;function d(r){if(r instanceof y.ExtensionManagementError)return r;const i=new y.ExtensionManagementError(r.message,y.ExtensionManagementErrorCode.Internal);return i.stack=r.stack,i}function o(r,i,{extensionData:n,wasVerified:s,duration:l,error:a,durationSinceUpdate:f}){let S,A;a&&(a instanceof y.ExtensionManagementError?(S=a.code,a.code===y.ExtensionManagementErrorCode.Signature&&(A=a.message)):S=y.ExtensionManagementErrorCode.Internal),r.publicLog(i,{...n,wasVerified:s,success:!a,duration:l,errorcode:S,errorcodeDetail:A,durationSinceUpdate:f})}e.reportTelemetry=o;class t{constructor(){this.d=new O.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.createCancelablePromise)(i=>new Promise((n,s)=>{const l=i.onCancellationRequested(()=>{l.dispose(),s(new T.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=t}),define(Z[42],Q([0,1,5,15,2,3,36,11,24,27,13,8,10,25,29,4,16,9,28]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P,v,D,E,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class d extends Error{constructor(n,s){super(n),this.code=s}}e.ExtensionsProfileScanningError=d,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let o=class extends k.Disposable{constructor(n,s,l,a,f){super(),this.h=n,this.i=s,this.j=l,this.k=a,this.l=f,this.a=this.B(new T.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new T.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new T.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new T.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new N.ResourceMap}scanProfileExtensions(n,s){return this.m(n,void 0,s)}async addExtensionsToProfile(n,s){const l=[],a=[];try{return await this.m(s,f=>{const S=[];for(const A of f)n.some(([$])=>(0,h.areSameExtensions)($.identifier,A.identifier)&&$.manifest.version!==A.version)?l.push(A):S.push(A);for(const[A,$]of n)if(!S.some(H=>(0,h.areSameExtensions)(H.identifier,A.identifier)&&H.version===A.manifest.version)){const H={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:$};a.push(H),S.push(H)}return a.length&&this.a.fire({extensions:a,profileLocation:s}),l.length&&this.c.fire({extensions:l,profileLocation:s}),S}),a.length&&this.b.fire({extensions:a,profileLocation:s}),l.length&&this.f.fire({extensions:l,profileLocation:s}),a}catch(f){throw a.length&&this.b.fire({extensions:a,error:f,profileLocation:s}),l.length&&this.f.fire({extensions:l,error:f,profileLocation:s}),f}}async removeExtensionFromProfile(n,s){const l=[];this.c.fire({extensions:l,profileLocation:s});try{await this.m(s,a=>{const f=[];for(const S of a)(0,h.areSameExtensions)(S.identifier,n.identifier)?l.push(S):f.push(S);return l.length&&this.c.fire({extensions:l,profileLocation:s}),f}),l.length&&this.f.fire({extensions:l,profileLocation:s})}catch(a){throw l.length&&this.f.fire({extensions:l,error:a,profileLocation:s}),a}}async m(n,s,l){return this.u(n).queue(async()=>{let a=[],f;try{const S=await this.h.readFile(n);f=JSON.parse(S.value.toString())}catch(S){if((0,p.toFileOperationResult)(S)!==1)throw S;if(this.j.extUri.isEqual(n,this.i.defaultProfile.extensionsResource)&&(f=await this.t()),!f&&l?.bailOutWhenFileNotFound)throw new d((0,c.getErrorMessage)(S),"ERROR_PROFILE_NOT_FOUND")}if(f){Array.isArray(f)||this.n(n);let S=!1;for(const A of f){t(A)||this.n(n);let $;if((0,D.isString)(A.location))$=this.r(n,A.location);else{$=b.URI.revive(A.location);const H=this.p(n,$);H&&(S=!0,A.location=H)}a.push({identifier:A.identifier,location:$,version:A.version,metadata:A.metadata})}S&&await this.h.writeFile(n,O.VSBuffer.fromString(JSON.stringify(f)))}if(s){a=s(a);const S=a.map(A=>({identifier:A.identifier,version:A.version,location:this.p(n,A.location)??A.location.toJSON(),metadata:A.metadata}));await this.h.writeFile(n,O.VSBuffer.fromString(JSON.stringify(S)))}return a})}n(n){const s=new d(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.k.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}p(n,s){const l=this.j.extUri.dirname(n).with({scheme:E.Schemas.file});if(this.j.extUri.isEqualOrParent(s,l))return this.j.extUri.relativePath(l,s)}r(n,s){return this.j.extUri.joinPath(this.j.extUri.dirname(n),s).with({scheme:E.Schemas.file})}async t(){return this.s||(this.s=(async()=>{const n=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let s;try{s=(await this.h.readFile(n)).value.toString()}catch(a){if((0,p.toFileOperationResult)(a)===1)return;throw a}this.l.info("Migrating extensions from old default profile location",n.toString());let l;try{const a=JSON.parse(s);Array.isArray(a)&&a.every(f=>t(f))?l=a:this.l.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.l.error(a)}if(l)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.l.info("Migrated extensions from old default profile location to new location",n.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(a){if((0,p.toFileOperationResult)(a)===3)this.l.info("Migration from old default profile location to new location is done by another window",n.toString(),this.i.defaultProfile.extensionsResource.toString());else throw a}try{await this.h.del(n)}catch(a){(0,p.toFileOperationResult)(a)!==1&&this.l.error(a)}return l})()),this.s}u(n){let s=this.g.get(n);return s||(s=new L.Queue,this.g.set(n,s)),s}};o=me([_(0,p.IFileService),_(1,P.IUserDataProfilesService),_(2,v.IUriIdentityService),_(3,g.ITelemetryService),_(4,m.ILogService)],o),e.ExtensionsProfileScannerService=o;function t(i){return(0,D.isObject)(i)&&(0,u.isIExtensionIdentifier)(i.identifier)&&(r(i.location)||(0,D.isString)(i.location))&&i.version&&(0,D.isString)(i.version)}function r(i){return i?(0,D.isString)(i.path)&&(0,D.isString)(i.scheme):!1}}),define(Z[48],Q([0,1,19,5,30,15,9,50,78,2,16,14,12,17,40,53,4,11,91,18,24,27,45,13,8,10,26,3,44,42,25,29,107,108]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P,v,D,E,c,g,w,d,o,t,r,i,n,s,l,a,f,S,A,$,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var J;(function(he){function B(j,C){if(j===C)return!0;const z=Object.keys(j),W=new Set;for(const q of Object.keys(C))W.add(q);if(z.length!==W.size)return!1;for(const q of z){if(j[q]!==C[q])return!1;W.delete(q)}return W.size===0}he.equals=B})(J=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let ie=class extends u.Disposable{constructor(B,j,C,z,W,q,Y,R,I,M,F,V){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=j,this.l=C,this.m=z,this.n=W,this.p=q,this.r=Y,this.s=R,this.t=I,this.u=M,this.v=F,this.w=V,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,P.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(pe,(0,P.joinPath)(this.m,o.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(pe,(0,P.joinPath)(this.m,o.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ee,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,d.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(B,j,C){const[z,W]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(j)]),q=C?await this.scanExtensionsUnderDevelopment(B,[...z,...W]):[];return this.F(z,W,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const j=[];j.push(this.G(!!B.useCache,B.language)),j.push(this.H(B.language,!!B.checkControlFile));const[C,z]=await Promise.all(j);return this.D([...C,...z],0,B,!1)}async scanUserExtensions(B){const j=B.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const C=this.v.extUri.isEqual(B.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.J(j,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,C),W=B.useCache&&!z.devMode&&z.excludeObsolete?this.j:this.k;let q;try{q=await W.scanExtensions(z)}catch(Y){if(Y instanceof f.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),q=await W.scanExtensions(z);else throw Y}return q=await this.D(q,1,B,!0),this.s.trace("Scanned user extensions:",q.length),q}async scanExtensionsUnderDevelopment(B,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const C=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===p.Schemas.file).map(async z=>{const W=await this.J(z,!1,1,!0,B.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(Y=>(Y.type=j.find(R=>(0,d.areSameExtensions)(R.identifier,Y.identifier))?.type??Y.type,this.k.validate(Y,W)))}))).flat();return this.D(C,"development",B,!0)}return[]}async scanExistingExtension(B,j,C){const z=await this.J(B,!1,j,!0,C.language,!0,void 0),W=await this.k.scanExtension(z);return!W||!C.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(B,j,C){const z=await this.J(B,!1,j,!0,C.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions(z);return this.D(W,j,C,!0)}async scanMetadata(B){const j=(0,P.joinPath)(B,"package.json"),C=(await this.r.readFile(j)).value.toString();return JSON.parse(C).__metadata}async updateMetadata(B,j){const C=(0,P.joinPath)(B,"package.json"),z=(await this.r.readFile(C)).value.toString(),W=JSON.parse(z);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,W.__metadata={...W.__metadata,...j},await this.r.writeFile((0,P.joinPath)(B,"package.json"),T.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof f.ExtensionsProfileScanningError&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw B}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.p.addExtensionsToProfile(B.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,r.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.s.error(B)}finally{this.z=void 0}})()),this.z}async D(B,j,C,z){return C.includeAllVersions||(B=this.F(j===0?B:void 0,j===1?B:void 0,j==="development"?B:void 0,await this.getTargetPlatform(),z)),C.includeInvalid||(B=B.filter(W=>W.isValid)),B.sort((W,q)=>{const Y=y.basename(W.location.fsPath),R=y.basename(q.location.fsPath);return Y<R?-1:Y>R?1:0})}F(B,j,C,z,W){const q=(R,I,M)=>{if(R.isValid&&!I.isValid)return!1;if(R.isValid===I.isValid){if(W&&v.gt(R.manifest.version,I.manifest.version))return this.s.debug(`Skipping extension ${I.location.path} with lower version ${I.manifest.version} in favour of ${R.location.path} with version ${R.manifest.version}`),!1;if(v.eq(R.manifest.version,I.manifest.version)){if(R.type===0)return this.s.debug(`Skipping extension ${I.location.path} in favour of system extension ${R.location.path} with same version`),!1;if(R.targetPlatform===z)return this.s.debug(`Skipping extension ${I.location.path} from different target platform ${I.targetPlatform}`),!1}}return M?this.s.warn(`Overwriting user extension ${R.location.path} with ${I.location.path}.`):this.s.debug(`Overwriting user extension ${R.location.path} with ${I.location.path}.`),!0},Y=new Map;return B?.forEach(R=>{const I=o.ExtensionIdentifier.toKey(R.identifier.id),M=Y.get(I);(!M||q(M,R,!1))&&Y.set(I,R)}),j?.forEach(R=>{const I=o.ExtensionIdentifier.toKey(R.identifier.id),M=Y.get(I);if(!M&&B&&R.type===0){this.s.debug(`Skipping obsolete system extension ${R.location.path}.`);return}(!M||q(M,R,!1))&&Y.set(I,R)}),C?.forEach(R=>{const I=o.ExtensionIdentifier.toKey(R.identifier.id),M=Y.get(I);(!M||q(M,R,!0))&&Y.set(I,R),Y.set(I,R)}),[...Y.values()]}async G(B,j){this.s.trace("Started scanning system extensions");const C=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),W=await(B&&!C.devMode?this.i:this.k).scanExtensions(C);return this.s.trace("Scanned system extensions:",W.length),W}async H(B,j){const C=this.t.isBuilt?[]:this.u.builtInExtensions;if(!C?.length)return[];this.s.trace("Started scanning dev system extensions");const z=j?await this.I():{},W=[],q=c.URI.file(y.normalize(y.join(p.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const R of C){const I=z[R.name]||"marketplace";switch(I){case"disabled":break;case"marketplace":W.push((0,P.joinPath)(q,R.name));break;default:W.push(c.URI.file(I));break}}const Y=await Promise.all(W.map(async R=>this.k.scanExtension(await this.J(R,!1,0,!0,B,!0,void 0))));return this.s.trace("Scanned dev system extensions:",Y.length),(0,L.coalesce)(Y)}async I(){try{const B=await this.r.readFile(this.l);return JSON.parse(B.value.toString())}catch{return{}}}async J(B,j,C,z,W,q,Y){const R=await this.f(W??m.language),I=await this.L(B),M=j&&!this.v.extUri.isEqual(B,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,F=M?await this.L(M):void 0;return new re(B,I,M,F,j,Y,C,z,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,W,R)}async L(B){try{const j=await this.r.stat(B);if(typeof j.mtime=="number")return j.mtime}catch{}}};ie=me([_(4,S.IUserDataProfilesService),_(5,f.IExtensionsProfileScannerService),_(6,r.IFileService),_(7,n.ILogService),_(8,w.IEnvironmentService),_(9,s.IProductService),_(10,A.IUriIdentityService),_(11,i.IInstantiationService)],ie),e.AbstractExtensionsScannerService=ie;class re{constructor(B,j,C,z,W,q,Y,R,I,M,F,V,G,te,ne){this.location=B,this.mtime=j,this.applicationExtensionslocation=C,this.applicationExtensionslocationMtime=z,this.profile=W,this.profileScanOptions=q,this.type=Y,this.excludeObsolete=R,this.validate=I,this.productVersion=M,this.productDate=F,this.productCommit=V,this.devMode=G,this.language=te,this.translations=ne}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,j){return(0,P.isEqual)(B.location,j.location)&&B.mtime===j.mtime&&(0,P.isEqual)(B.applicationExtensionslocation,j.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&B.profile===j.profile&&B.profileScanOptions===j.profileScanOptions&&B.type===j.type&&B.excludeObsolete===j.excludeObsolete&&B.validate===j.validate&&B.productVersion===j.productVersion&&B.productDate===j.productDate&&B.productCommit===j.productCommit&&B.devMode===j.devMode&&B.language===j.language&&J.equals(B.translations,j.translations)}}let ee=class extends u.Disposable{constructor(B,j,C,z,W){super(),this.f=B,this.g=j,this.h=C,this.i=z,this.j=W}async scanExtensions(B){const j=B.profile?await this.l(B):await this.k(B);let C={};if(B.excludeObsolete&&B.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();C=JSON.parse(z)}catch{}return(0,E.isEmptyObject)(C)?j:j.filter(z=>!C[d.ExtensionKey.create(z).toString()])}async k(B){const j=await this.i.resolve(B.location);if(!j.children?.length)return[];const C=await Promise.all(j.children.map(async z=>{if(!z.isDirectory||B.type===1&&(0,P.basename)(z.resource).indexOf(".")===0)return null;const W=new re(z.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(W)}));return(0,L.coalesce)(C).sort((z,W)=>z.location.path<W.location.path?-1:1)}async l(B){let j=await this.m(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){j=j.filter(z=>!z.metadata?.isApplicationScoped);const C=await this.m(B.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,B);j.push(...C)}return j}async m(B,j,C){const z=await this.g.scanProfileExtensions(B,C.profileScanOptions);if(!z.length)return[];const W=await Promise.all(z.map(async q=>{if(j(q)){const Y=new re(q.location,C.mtime,C.applicationExtensionslocation,C.applicationExtensionslocationMtime,C.profile,C.profileScanOptions,C.type,C.excludeObsolete,C.validate,C.productVersion,C.productDate,C.productCommit,C.devMode,C.language,C.translations);return this.scanExtension(Y,q.metadata)}return null}));return(0,L.coalesce)(W)}async scanOneOrMultipleExtensions(B){try{if(await this.i.exists((0,P.joinPath)(B.location,"package.json"))){const j=await this.scanExtension(B);return j?[j]:[]}else return await this.scanExtensions(B)}catch(j){return this.j.error(`Error scanning extensions at ${B.location.path}:`,(0,N.getErrorMessage)(j)),[]}}async scanExtension(B,j){try{let C=await this.scanExtensionManifest(B.location);if(C){C.publisher||(C.publisher=o.UNDEFINED_PUBLISHER),j=j??C.__metadata,delete C.__metadata;const z=(0,d.getGalleryExtensionId)(C.publisher,C.name),W=j?.id?{id:z,uuid:j.id}:{id:z},q=j?.isSystem?0:B.type,Y=q===0||!!j?.isBuiltin;H.ImplicitActivationEvents.updateManifest(C),C=await this.n(B.location,C,re.createNlsConfiguration(B));const R={type:q,identifier:W,manifest:C,location:B.location,isBuiltin:Y,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return B.validate?this.validate(R,B):R}}catch(C){B.type!==0&&this.j.error(C)}return null}validate(B,j){let C=!0;const z=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,B.manifest,B.isBuiltin);for(const[W,q]of z)W===D.default.Error&&(C=!1,this.j.error(this.t(j.location,q)));return B.isValid=C,B.validations=z,B}async scanExtensionManifest(B){const j=(0,P.joinPath)(B,"package.json");let C;try{C=(await this.i.readFile(j)).value.toString()}catch(W){return(0,r.toFileOperationResult)(W)!==1&&this.j.error(this.t(B,(0,g.localize)(0,null,j.path,W.message))),null}let z;try{z=JSON.parse(C)}catch{const q=[];(0,b.parse)(C,q);for(const Y of q)this.j.error(this.t(B,(0,g.localize)(1,null,j.path,Y.offset,Y.length,(0,h.getParseErrorMessage)(Y.error))));return null}return(0,b.getNodeType)(z)!=="object"?(this.j.error(this.t(B,(0,g.localize)(2,null,j.path))),null):z}async n(B,j,C){const z=await this.p(B,j,C);if(z)try{const W=[],q=await this.r(z.default,W);if(W.length>0)return W.forEach(R=>{this.j.error(this.t(B,(0,g.localize)(3,null,z.default?.path,(0,h.getParseErrorMessage)(R.error))))}),j;if((0,b.getNodeType)(z)!=="object")return this.j.error(this.t(B,(0,g.localize)(4,null,z.default?.path))),j;const Y=z.values||Object.create(null);return(0,$.localizeManifest)(j,Y,q)}catch{}return j}async p(B,j,C){const z=(0,P.joinPath)(B,"package.nls.json"),W=(I,M)=>{M.forEach(F=>{this.j.error(this.t(B,(0,g.localize)(5,null,I?.path,(0,h.getParseErrorMessage)(F.error))))})},q=I=>{this.j.error(this.t(B,(0,g.localize)(6,null,I?.path)))},Y=`${j.publisher}.${j.name}`,R=C.translations[Y];if(R)try{const I=c.URI.file(R),M=(await this.i.readFile(I)).value.toString(),F=[],V=(0,b.parse)(M,F);return F.length>0?(W(I,F),{values:void 0,default:z}):(0,b.getNodeType)(V)!=="object"?(q(I),{values:void 0,default:z}):{values:V.contents?V.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let M;try{M=await this.s(B,C)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const F=(await this.i.readFile(M.localized)).value.toString(),V=[],G=(0,b.parse)(F,V);return V.length>0?(W(M.localized,V),{values:void 0,default:M.original}):(0,b.getNodeType)(G)!=="object"?(q(M.localized),{values:void 0,default:M.original}):{values:G,default:M.original}}catch{return{values:void 0,default:M.original}}}}async r(B,j){if(B)try{const C=(await this.i.readFile(B)).value.toString();return(0,b.parse)(C,j)}catch{}}s(B,j){return new Promise((C,z)=>{const W=q=>{const Y=(0,P.joinPath)(B,`package.nls.${q}.json`);this.i.exists(Y).then(R=>{R&&C({localized:Y,original:(0,P.joinPath)(B,"package.nls.json")});const I=q.lastIndexOf("-");I===-1?C({localized:(0,P.joinPath)(B,"package.nls.json"),original:null}):(q=q.substring(0,I),W(q))})};if(j.devMode||j.pseudo||!j.language)return C({localized:(0,P.joinPath)(B,"package.nls.json"),original:null});W(j.language)})}t(B,j){return`[${B.path}]: ${j}`}};ee=me([_(1,f.IExtensionsProfileScannerService),_(2,A.IUriIdentityService),_(3,r.IFileService),_(4,n.ILogService)],ee);let pe=class extends ee{constructor(B,j,C,z,W,q){super(j,C,z,W,q),this.y=B,this.v=this.B(new O.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(B){const j=await this.z();if(this.u=B,j&&j.input&&re.equals(j.input,this.u))return this.v.trigger(()=>this.D()),j.result.map(z=>(z.location=c.URI.revive(z.location),z));const C=await super.scanExtensions(B);return await this.C({input:B,result:C}),C}async z(){try{const B=await this.i.readFile(this.y),j=JSON.parse(B.value.toString());return{result:j.result,input:(0,a.revive)(j.input)}}catch(B){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,N.getErrorMessage)(B))}return null}async C(B){try{await this.i.writeFile(this.y,T.VSBuffer.fromString(JSON.stringify(B)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,N.getErrorMessage)(j))}}async D(){if(!this.u)return;const B=await this.z();if(!B)return;const j=B.result,C=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(C,j))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};pe=me([_(2,f.IExtensionsProfileScannerService),_(3,A.IUriIdentityService),_(4,r.IFileService),_(5,n.ILogService)],pe);function le(he,B){const j=(0,d.getExtensionId)(he.manifest.publisher,he.manifest.name);return{id:j,identifier:new o.ExtensionIdentifier(j),isBuiltin:he.type===0,isUserBuiltin:he.type===1&&he.isBuiltin,isUnderDevelopment:B,extensionLocation:he.location,uuid:he.identifier.uuid,targetPlatform:he.targetPlatform,...he.manifest}}e.toExtensionDescription=le;class ae extends ie{constructor(B,j,C,z,W,q,Y,R,I,M,F,V){super(B,j,(0,P.joinPath)(C,".vscode-oss-dev","extensions","control.json"),(0,P.joinPath)(z,o.MANIFEST_CACHE_FOLDER),W,q,Y,R,I,M,F,V),this.M=(async()=>{if(m.translationsConfigFile)try{const G=await this.r.readFile(c.URI.file(m.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(B){return this.M}}e.NativeExtensionsScannerService=ae}),define(Z[146],Q([0,1,57,5,34,3,2,16,14,20,10,25]),function(x,e,L,O,k,T,N,b,h,u,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends N.Disposable{constructor(v,D){super(),this.b=v,this.f=D,this.a=new O.Limiter(5)}async postUninstall(v){const D=this.g(v,"uninstall");return D&&(this.f.info(v.identifier.id,v.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(D.script,"uninstall",D.args,!0,v).then(()=>this.f.info(v.identifier.id,v.manifest.version,"Finished running post uninstall script"),E=>this.f.error(v.identifier.id,v.manifest.version,`Failed to run post uninstall script: ${E}`)))),u.Promises.rm(this.j(v)).then(void 0,E=>this.f.error("Error while removing extension storage path",E))}g(v,D){const E=`vscode:${D}`;if(v.location.scheme===b.Schemas.file&&v.manifest&&v.manifest.scripts&&typeof v.manifest.scripts[E]=="string"){const c=v.manifest.scripts[E].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(v.identifier.id,v.manifest.version,`${E} should be a node script`),null):{script:(0,h.join)(v.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(v,D,E,c,g){return new Promise((w,d)=>{const o=this.i(v,D,E,g);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?d(i):w(void 0)};o.on("error",i=>{r((0,k.toErrorMessage)(i)||"Unknown")}),o.on("exit",(i,n)=>{r(i?`post-${D} process exited with code ${i}`:void 0)}),c&&(t=setTimeout(()=>{t=null,o.kill(),d("timed out")},5e3))})}i(v,D,E,c){const g={silent:!0,execArgv:void 0},w=(0,L.fork)(v,[`--type=extension-post-${D}`,...E],g);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const d=T.Event.fromNodeEventEmitter(w.stdout,"data"),o=T.Event.fromNodeEventEmitter(w.stderr,"data");d(i=>this.f.info(c.identifier.id,c.manifest.version,`post-${D}`,i)),o(i=>this.f.error(c.identifier.id,c.manifest.version,`post-${D}`,i));const t=T.Event.any(T.Event.map(d,i=>({data:`%c${i}`,format:[""]})),T.Event.map(o,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(c.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),w}j(v){return(0,h.join)(this.b.defaultProfile.globalStorageHome.fsPath,v.identifier.id.toLowerCase())}};m=me([_(0,y.IUserDataProfilesService),_(1,p.ILogService)],m),e.ExtensionsLifecycle=m}),define(Z[147],Q([0,1,11,18,42,48,13,8,10,26,29,25]),function(x,e,L,O,k,T,N,b,h,u,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends T.NativeExtensionsScannerService{constructor(v,D,E,c,g,w,d,o){super(L.URI.file(g.builtinExtensionsPath),L.URI.file(g.extensionsPath),g.userHome,L.URI.file(g.userDataPath),v,D,E,c,g,w,d,o)}};m=me([_(0,y.IUserDataProfilesService),_(1,k.IExtensionsProfileScannerService),_(2,N.IFileService),_(3,h.ILogService),_(4,O.INativeEnvironmentService),_(5,u.IProductService),_(6,p.IUriIdentityService),_(7,b.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(Z[148],Q([0,1,5,3,2,118,4,84,8,25]),function(x,e,L,O,k,T,N,b,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var p;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function P(g){const w=g.get(e.TARGET_KEY);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}e.loadKeyTargets=P;class v extends k.Disposable{constructor(w={flushInterval:v.a}){super(),this.j=w,this.b=this.B(new O.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new O.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new L.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,L.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.J()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(w,d){if(d===e.TARGET_KEY){switch(w){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:d,target:this.F(w)[d]})}r(w){this.f.fire({reason:w})}get(w,d,o){return this.L(d)?.get(w,o)}getBoolean(w,d,o){return this.L(d)?.getBoolean(w,o)}getNumber(w,d,o){return this.L(d)?.getNumber(w,o)}store(w,d,o,t){if((0,N.isUndefinedOrNull)(d)){this.remove(w,o);return}this.t(()=>{this.u(w,o,t),this.L(o)?.set(w,d)})}remove(w,d){this.t(()=>{this.u(w,d,void 0),this.L(d)?.delete(w)})}t(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,d){const o=[],t=this.F(w);for(const r of Object.keys(t))t[r]===d&&o.push(r);return o}u(w,d,o){const t=this.F(d);typeof o=="number"?t[w]!==o&&(t[w]=o,this.L(d)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[w]=="number"&&(delete t[w],this.L(d)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(w){switch(w){case-1:return this.D;case 0:return this.z;default:return this.w}}G(w){const d=this.L(w);return d?P(d):Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=p.NONE){this.f.fire({reason:w});const d=this.L(-1),o=this.L(0),t=this.L(1);switch(w){case p.NONE:await L.Promises.settled([d?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await L.Promises.settled([d?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.L(-1)?.items??new Map,d=this.L(0)?.items??new Map,o=this.L(1)?.items??new Map;return c(w,d,o,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(w,d){return this.r(p.NONE),(0,u.isUserDataProfile)(w)?this.N(w,d):this.O(w,d)}H(w,d){return!(w.id===d.id||D(d)&&D(w))}I(w,d,o,t){this.t(()=>{if(t)for(const[r,i]of w)d.set(r,i);else{const r=new Set;for(const[i,n]of w)r.add(i),d.get(i)!==n&&this.n(o,i);for(const[i]of d.items)r.has(i)||this.n(o,i)}})}}e.AbstractStorageService=v,v.a=60*1e3;function D(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=D;class E extends v{constructor(){super(),this.p=this.B(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(w=>this.n(1,w))),this.B(this.P.onDidChangeStorage(w=>this.n(0,w))),this.B(this.p.onDidChangeStorage(w=>this.n(-1,w)))}L(w){switch(w){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(w){return!1}}e.InMemoryStorageService=E;async function c(g,w,d,o,t,r){const i=H=>{try{return JSON.parse(H)}catch{return H}},n=new Map,s=new Map;g.forEach((H,J)=>{n.set(J,H),s.set(J,i(H))});const l=new Map,a=new Map;w.forEach((H,J)=>{l.set(J,H),a.set(J,i(H))});const f=new Map,S=new Map;d.forEach((H,J)=>{f.set(J,H),S.set(J,i(H))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const A=[];if(n.forEach((H,J)=>{A.push({key:J,value:H})}),console.table(A),console.groupEnd(),console.log(s),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const H=[];l.forEach((J,ie)=>{H.push({key:ie,value:J})}),console.table(H),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const $=[];f.forEach((H,J)=>{$.push({key:J,value:H})}),console.table($),console.groupEnd(),console.log(S)}e.logStorage=c}),define(Z[149],Q([0,1,19,22,9,12,35,4,11,21,18,23,24,45,13,10,26,47,135,148,28]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P,v,D,E,c,g,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const o=T.isWeb?"web":(0,y.getTargetPlatform)(T.platform,N.arch);var t;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function r(...R){return String(R.reduce((I,M)=>I|M,0))}var i;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class f{constructor(I=a){this.d=I}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(I,M=this.d.pageSize){return new f({...this.d,pageNumber:I,pageSize:M})}withFilter(I,...M){const F=[...this.d.criteria,...M.length?M.map(V=>({filterType:I,value:V})):[{filterType:I}]];return new f({...this.d,criteria:F})}withSortBy(I){return new f({...this.d,sortBy:I})}withSortOrder(I){return new f({...this.d,sortOrder:I})}withFlags(...I){return new f({...this.d,flags:I.reduce((M,F)=>M|F,0)})}withAssetTypes(...I){return new f({...this.d,assetTypes:I})}withSource(I){return new f({...this.d,source:I})}get raw(){const{criteria:I,pageNumber:M,pageSize:F,sortBy:V,sortOrder:G,flags:te,assetTypes:ne}=this.d;return{filters:[{criteria:I,pageNumber:M,pageSize:F,sortBy:V,sortOrder:G}],assetTypes:ne,flags:te}}get searchText(){const I=this.d.criteria.filter(M=>M.filterType===i.SearchText)[0];return I&&I.value?I.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(I=>String(I.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function S(R,I){const M=(R||[]).filter(F=>F.statisticName===I)[0];return M?M.value:0}function A(R){const I="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(F=>F.assetType.indexOf(I)===0).reduce((F,V)=>{const G=J(R,V.assetType);return G&&F.push([V.assetType.substring(I.length),G]),F},[])}function $(R){if(R.properties){const I=R.properties.filter(V=>V.key===n.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=I.filter(V=>M.test(V.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return J(R,n.Repository)}function H(R){return{uri:`${R.fallbackAssetUri}/${n.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${n.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function J(R,I){return R.files.filter(F=>F.assetType===I)[0]?{uri:`${R.assetUri}/${I}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${I}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function ie(R,I){const M=R.properties?R.properties.filter(V=>V.key===I):[],F=M.length>0&&M[0].value;return F?F.split(",").map(V=>(0,m.adoptToGalleryExtensionId)(V)):[]}function re(R){const I=R.properties?R.properties.filter(M=>M.key===s.Engine):[];return I.length>0&&I[0].value||""}function ee(R){const I=R.properties?R.properties.filter(M=>M.key===s.PreRelease):[];return I.length>0&&I[0].value==="true"}function pe(R){const I=R.properties?R.properties.filter(F=>F.key===s.LocalizedLanguages):[],M=I.length>0&&I[0].value||"";return M?M.split(","):[]}function le(R){return R.properties?.find(I=>I.key===s.SponsorLink)?.value}function ae(R){return R.indexOf("preview")!==-1}function he(R){return R.targetPlatform?(0,y.toTargetPlatform)(R.targetPlatform):"undefined"}function B(R){const I=(0,L.distinct)(R.versions.map(he)),M=!!R.tags?.includes(y.WEB_EXTENSION_TAG),F=I.indexOf("web");return M?F===-1&&I.push("web"):F!==-1&&I.splice(F,1),I}function j(R,I){const M=(0,y.getFallbackTargetPlarforms)(I);for(let F=0;F<R.length;F++){const V=R[F];if(V.version===R[F-1]?.version){let G=F;const te=he(V);if(te===I)for(;G>0&&R[G-1].version===V.version;)G--;else if(M.includes(te))for(;G>0&&R[G-1].version===V.version&&he(R[G-1])!==I;)G--;G!==F&&(R.splice(F,1),R.splice(G,0,V))}}return R}e.sortExtensionVersions=j;function C(R,I,M){R.telemetryData={index:I,querySource:M}}function z(R,I,M){const F=R.versions[0],V={manifest:J(I,n.Manifest),readme:J(I,n.Details),changelog:J(I,n.Changelog),license:J(I,n.License),repository:$(I),download:H(I),icon:J(I,n.Icon),signature:J(I,n.Signature),coreTranslations:A(I)};return{identifier:{id:(0,m.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:I.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(F),description:R.shortDescription||"",installCount:S(R.statistics,"install"),rating:S(R.statistics,"averagerating"),ratingCount:S(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:M,assets:V,properties:{dependencies:ie(I,s.Dependency),extensionPack:ie(I,s.ExtensionPack),engine:re(I),localizedLanguages:pe(I),targetPlatform:he(I),isPreReleaseVersion:ee(I)},hasPreReleaseVersion:ee(F),hasReleaseVersion:!0,preview:ae(R.flags),isSigned:!!V.signature}}let W=class{constructor(I,M,F,V,G,te,ne,ge){this.k=M,this.l=F,this.n=V,this.o=G,this.q=te,this.u=ne,this.w=ge;const ye=ne.extensionsGallery,ue=ye?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=ue?ye.servicePPEUrl:ye?.serviceUrl,this.g=ue?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,g.resolveMarketplaceHeaders)(ne.version,ne,this.n,this.w,this.q,I,this.o)}x(I=""){return`${this.d}${I}`}isEnabled(){return!!this.d}async getExtensions(I,M,F){const V=O.CancellationToken.isCancellationToken(M)?{}:M,G=O.CancellationToken.isCancellationToken(M)?M:F,te=[],ne=[],ge=[],ye=[];let ue=!0;for(const se of I){se.uuid?ne.push(se.uuid):te.push(se.id);const fe=!!(se.version||se.preRelease);ge.push({id:se.id,uuid:se.uuid,includePreRelease:fe}),se.version&&ye.push({id:se.id,uuid:se.uuid,version:se.version}),ue=ue&&!!se.hasPreRelease&&!fe}if(!ne.length&&!te.length)return[];let ce=new f().withPage(1,I.length);ne.length&&(ce=ce.withFilter(i.ExtensionId,...ne)),te.length&&(ce=ce.withFilter(i.ExtensionName,...te)),(V.queryAllVersions||ue)&&(ce=ce.withFlags(ce.flags,t.IncludeVersions)),V.source&&(ce=ce.withSource(V.source));const{extensions:oe}=await this.z(ce,{targetPlatform:V.targetPlatform??o,includePreRelease:ge,versions:ye,compatible:!!V.compatible},G);return V.source&&oe.forEach((se,fe)=>C(se,fe,V.source)),oe}async getCompatibleExtension(I,M,F){if((0,y.isNotWebExtensionInWebTargetPlatform)(I.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(I,M,F))return I;const V=new f().withFlags(t.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,I.identifier.uuid),{extensions:G}=await this.z(V,{targetPlatform:F,compatible:!0,includePreRelease:M},O.CancellationToken.None);return G[0]||null}async isExtensionCompatible(I,M,F){if(!(0,y.isTargetPlatformCompatible)(I.properties.targetPlatform,I.allTargetPlatforms,F)||!M&&I.properties.isPreReleaseVersion)return!1;let V=I.properties.engine;if(!V){const G=await this.getManifest(I,O.CancellationToken.None);if(!G)throw new Error("Manifest was not found");V=G.engines.vscode}return(0,P.isEngineValid)(V,this.u.version,this.u.date)}async y(I,M,F,V,G){if(!(0,y.isTargetPlatformCompatible)(he(I),V,G)||M!=="any"&&ee(I)!==(M==="prerelease"))return!1;if(F)try{const te=await this.E(I);if(!(0,P.isEngineValid)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${I.version}.`,(0,k.getErrorMessage)(te)),!1}return!0}async query(I,M){let F=I.text||"";const V=I.pageSize??50;let G=new f().withPage(1,V);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ce,oe)=>(G=G.withFilter(i.Category,oe||ce),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ce,oe)=>(G=G.withFilter(i.Tag,oe||ce),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(i.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),G=G.withFilter(i.SearchText,F)),G=G.withSortBy(0)):I.ids?G=G.withFilter(i.ExtensionId,...I.ids):I.names?G=G.withFilter(i.ExtensionName,...I.names):G=G.withSortBy(4),typeof I.sortBy=="number"&&(G=G.withSortBy(I.sortBy)),typeof I.sortOrder=="number"&&(G=G.withSortOrder(I.sortOrder)),I.source&&(G=G.withSource(I.source));const te=async(ue,ce)=>{const{extensions:oe,total:se}=await this.z(ue,{targetPlatform:o,compatible:!1,includePreRelease:!!I.includePreRelease},ce);return oe.forEach((fe,Te)=>C(fe,(ue.pageNumber-1)*ue.pageSize+Te,I.source)),{extensions:oe,total:se}},{extensions:ne,total:ge}=await te(G,M),ye=async(ue,ce)=>{if(ce.isCancellationRequested)throw new k.CancellationError;const{extensions:oe}=await te(G.withPage(ue+1),ce);return oe};return{firstPage:ne,total:ge,pageSize:G.pageSize,getPage:ye}}async z(I,M,F){const V=I.flags;!!(I.flags&t.IncludeLatestVersionOnly)&&!!(I.flags&t.IncludeVersions)&&(I=I.withFlags(I.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(I.flags&t.IncludeLatestVersionOnly)&&!(I.flags&t.IncludeVersions)&&(I=I.withFlags(I.flags,t.IncludeLatestVersionOnly)),M.versions?.length&&(I=I.withFlags(I.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),I=I.withFlags(I.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:G,total:te}=await this.B(I,F);if(!(I.flags&t.IncludeLatestVersionOnly)){const ue=[];for(const ce of G){const oe=await this.A(ce,M);oe&&ue.push(oe)}return{extensions:ue,total:te}}const ge=[],ye=new Map;for(let ue=0;ue<G.length;ue++){const ce=G[ue],oe={id:(0,m.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},se=(0,b.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Te=>(0,m.areSameExtensions)(Te,oe))?.includePreRelease;if(M.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(B(ce),M.targetPlatform))continue;const fe=await this.A(ce,M);!fe||fe.properties.isPreReleaseVersion&&(!se||!fe.hasReleaseVersion)||!fe.properties.isPreReleaseVersion&&fe.properties.targetPlatform!==M.targetPlatform&&fe.hasPreReleaseVersion?ye.set(ce.extensionId,ue):ge.push([ue,fe])}if(ye.size){const ue=new Date().getTime(),ce=new f().withFlags(V&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ye.size).withFilter(i.ExtensionId,...ye.keys()),{extensions:oe}=await this.z(ce,M,F);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:ye.size});for(const se of oe){const fe=ye.get(se.identifier.uuid);ge.push([fe,se])}}return{extensions:ge.sort((ue,ce)=>ue[0]-ce[0]).map(([,ue])=>ue),total:te}}async A(I,M){const F={id:(0,m.getGalleryExtensionId)(I.publisher.publisherName,I.extensionName),uuid:I.extensionId},V=M.versions?.find(ge=>(0,m.areSameExtensions)(ge,F))?.version,G=(0,b.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ge=>(0,m.areSameExtensions)(ge,F))?.includePreRelease,te=B(I),ne=j(I.versions,M.targetPlatform);if(M.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(te,M.targetPlatform))return null;for(let ge=0;ge<ne.length;ge++){const ye=ne[ge];if(!(V&&ye.version!==V)){if(await this.y(ye,G?"any":"release",M.compatible,te,M.targetPlatform))return z(I,ye,te);if(V&&ye.version===V)return null}}return V||M.compatible?null:z(I,I.versions[0],te)}async B(I,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");I=I.withFlags(I.flags,t.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,r(t.Unpublished));const F=await this.j,V=JSON.stringify(I.raw),G={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},te=new Date().getTime();let ne,ge,ye=0;try{if(ne=await this.k.request({type:"POST",url:this.g&&I.criteria.some(ce=>ce.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:V,headers:G},M),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:ye};const ue=await(0,c.asJson)(ne);if(ue){const ce=ue.results[0],oe=ce.extensions,se=ce.resultMetadata&&ce.resultMetadata.filter(fe=>fe.metadataType==="ResultCount")[0];return ye=se&&se.metadataItems.filter(fe=>fe.name==="TotalCount")[0].count||0,{galleryExtensions:oe,total:ye}}return{galleryExtensions:[],total:ye}}catch(ue){throw ge=ue,ue}finally{this.o.publicLog2("galleryService:query",{...I.telemetryData,requestBodySize:String(V.length),duration:new Date().getTime()-te,success:!!ne&&(0,c.isSuccess)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:ge?(0,k.isCancellationError)(ge)?"canceled":(0,k.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(I,M,F,V){if(!this.isEnabled())return;const G=T.isWeb?this.x(`/itemName/${I}.${M}/version/${F}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${I}/extensions/${M}/${F}/stats?statType=${V}`),te=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:G,headers:ge},O.CancellationToken.None)}catch{}}async download(I,M,F){this.l.trace("ExtensionGalleryService#download",I.identifier.id);const V=(0,m.getGalleryExtensionTelemetryData)(I),G=new Date().getTime(),te=ue=>this.o.publicLog("galleryService:downloadVSIX",{...V,duration:ue}),ne=F===2?"install":F===3?"update":"",ge=ne?{uri:`${I.assets.download.uri}${h.URI.parse(I.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${I.assets.download.fallbackUri}${h.URI.parse(I.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:I.assets.download,ye=await this.D(ge);await this.q.writeFile(M,ye.stream),te(new Date().getTime()-G)}async downloadSignatureArchive(I,M){if(!I.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",I.identifier.id);const F=await this.D(I.assets.signature);await this.q.writeFile(M,F.stream)}async getReadme(I,M){if(I.assets.readme){const F=await this.D(I.assets.readme,{},M);return await(0,c.asTextOrError)(F)||""}return""}async getManifest(I,M){if(I.assets.manifest){const F=await this.D(I.assets.manifest,{},M),V=await(0,c.asTextOrError)(F);return V?JSON.parse(V):null}return null}async C(I,M){const F=J(I,n.Manifest);if(!F)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},G=await this.D(F,{headers:V});return await(0,c.asJson)(G)}async getCoreTranslation(I,M){const F=I.assets.coreTranslations.filter(V=>V[0]===M.toUpperCase())[0];if(F){const V=await this.D(F[1]),G=await(0,c.asTextOrError)(V);return G?JSON.parse(G):null}return null}async getChangelog(I,M){if(I.assets.changelog){const F=await this.D(I.assets.changelog,{},M);return await(0,c.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(I,M,F){let V=new f().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);I.identifier.uuid?V=V.withFilter(i.ExtensionId,I.identifier.uuid):V=V.withFilter(i.ExtensionName,I.identifier.id);const{galleryExtensions:G}=await this.B(V,O.CancellationToken.None);if(!G.length)return[];const te=B(G[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)(te,F))return[];const ne=[];await Promise.all(G[0].versions.map(async ue=>{try{await this.y(ue,M?"any":"release",!0,te,F)&&ne.push(ue)}catch{}}));const ge=[],ye=new Set;for(const ue of j(ne,F))ye.has(ue.version)||(ye.add(ue.version),ge.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:ee(ue)}));return ge}async D(I,M={},F=O.CancellationToken.None){const V=await this.j,G={type:"GET"},te={...V,...M.headers||{}};M={...M,...G,headers:te};const ne=I.uri,ge=I.fallbackUri,ye={...M,url:ne};try{const ue=await this.k.request(ye,F);if(ue.res.statusCode===200)return ue;const ce=await(0,c.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ce}`)}catch(ue){if((0,k.isCancellationError)(ue))throw ue;const ce=(0,k.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:ne,message:ce});const oe={...M,url:ge};return this.k.request(oe,F)}}async E(I){let M=re(I);if(!M){const F=await this.C(I,O.CancellationToken.None);if(!F)throw new Error("Manifest was not found");M=F.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const I=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,c.asJson)(I),F=[],V={};if(M){for(const G of M.malicious)F.push({id:G});if(M.migrateToPreRelease)for(const[G,te]of Object.entries(M.migrateToPreRelease))(!te.engine||(0,P.isEngineValid)(te.engine,this.u.version,this.u.date))&&(V[G.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[G,te]of Object.entries(M.deprecated))te&&(V[G.toLowerCase()]=(0,b.isBoolean)(te)?{}:te)}return{malicious:F,deprecated:V}}};W=me([_(1,c.IRequestService),_(2,D.ILogService),_(3,p.IEnvironmentService),_(4,d.ITelemetryService),_(5,v.IFileService),_(6,E.IProductService),_(7,u.IConfigurationService)],W);let q=class extends W{constructor(I,M,F,V,G,te,ne,ge){super(I,M,F,V,G,te,ne,ge)}};q=me([_(0,w.IStorageService),_(1,c.IRequestService),_(2,D.ILogService),_(3,p.IEnvironmentService),_(4,d.ITelemetryService),_(5,v.IFileService),_(6,E.IProductService),_(7,u.IConfigurationService)],q),e.ExtensionGalleryService=q;let Y=class extends W{constructor(I,M,F,V,G,te,ne){super(void 0,I,M,F,V,G,te,ne)}};Y=me([_(0,c.IRequestService),_(1,D.ILogService),_(2,p.IEnvironmentService),_(3,d.ITelemetryService),_(4,v.IFileService),_(5,E.IProductService),_(6,u.IConfigurationService)],Y),e.ExtensionGalleryServiceWithNoStorageService=Y}),define(Z[150],Q([0,1,44,11,18,13,10,67,29,25]),function(x,e,L,O,k,T,N,b,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let p=class extends u.UserDataProfilesService{constructor(P,v,D,E){super(v,D,P,E),this.a=v}L(){return this.r.extUri.joinPath(O.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p=me([_(0,h.IUriIdentityService),_(1,k.INativeEnvironmentService),_(2,T.IFileService),_(3,N.ILogService)],p),e.ServerUserDataProfilesService=p;let y=class $e extends p{constructor(P,v,D,E,c){super(v,D,E,c),this.N=P}G(){return(0,L.revive)(this.N.getItem($e.b,[]))}I(){return(0,L.revive)(this.N.getItem($e.c,{}))}L(){return this.r.extUri.joinPath(O.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y=me([_(0,b.IStateService),_(1,h.IUriIdentityService),_(2,k.INativeEnvironmentService),_(3,T.IFileService),_(4,N.ILogService)],y),e.UserDataProfilesService=y}),define(Z[151],Q([0,1,38,5,164,2,10]),function(x,e,L,O,k,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let b=class extends L.AbstractPolicyService{constructor(u,p){super(),this.j=u,this.k=p,this.a=new O.Throttler,this.b=this.B(new T.MutableDisposable)}async i(u){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.a.queue(()=>new Promise((p,y)=>{try{this.b.value=(0,k.createWatcher)(this.k,u,m=>{this.m(m),p()})}catch(m){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),y(m)}}))}m(u){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const p in u){const y=u[p];y===void 0?this.g.delete(p):this.g.set(p,y)}this.h.fire(Object.keys(u))}};b=me([_(0,N.ILogService)],b),e.NativePolicyService=b}),define(Z[69],Q([0,1,120,5,14,4,20,85,165,166]),function(x,e,L,O,k,T,N,b,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class p extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=r}}e.ExtractError=p;function y(o){const t=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function m(o){if(o instanceof p)return o;let t;return/end of central directory record signature not found/.test(o.message)&&(t="CorruptZip"),new p(t,o)}function P(o,t,r,i,n,s){const l=k.dirname(t),a=k.join(i,l);if(!a.startsWith(i))return Promise.reject(new Error(b.localize(0,null,t)));const f=k.join(i,t);let S;return s.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(N.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((A,$)=>{if(!s.isCancellationRequested)try{S=(0,L.createWriteStream)(f,{mode:r}),S.once("close",()=>A()),S.once("error",$),o.once("error",$),o.pipe(S)}catch(H){$(H)}}))}function v(o,t,r,i){let n=(0,O.createCancelablePromise)(()=>Promise.resolve()),s=0;return i.onCancellationRequested(()=>{n.cancel(),o.close()}),new Promise((l,a)=>{const f=new O.Sequencer,S=A=>{A.isCancellationRequested||(s++,o.readEntry())};o.once("error",a),o.once("close",()=>n.then(()=>{i.isCancellationRequested||o.entryCount===s?l():a(new p("Incomplete",new Error(b.localize(1,null,s,o.entryCount))))},a)),o.readEntry(),o.on("entry",A=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(A.fileName)){S(i);return}const $=A.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test($)){const ie=k.join(t,$);n=(0,O.createCancelablePromise)(re=>N.Promises.mkdir(ie,{recursive:!0}).then(()=>S(re)).then(void 0,a));return}const H=E(o,A),J=y(A);n=(0,O.createCancelablePromise)(ie=>f.queue(()=>H.then(re=>P(re,$,J,t,r,ie).then(()=>S(ie)))).then(null,a))})})}function D(o,t=!1){return new Promise((r,i)=>{(0,h.open)(o,t?{lazyEntries:!0}:void 0,(n,s)=>{n?i(m(n)):r((0,T.assertIsDefined)(s))})})}function E(o,t){return new Promise((r,i)=>{o.openReadStream(t,(n,s)=>{n?i(m(n)):r((0,T.assertIsDefined)(s))})})}function c(o,t){return new Promise((r,i)=>{const n=new u.ZipFile;t.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const s=(0,L.createWriteStream)(o);n.outputStream.pipe(s),n.outputStream.once("error",i),s.once("error",i),s.once("finish",()=>r(o))})}e.zip=c;function g(o,t,r={},i){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=D(o,!0);return r.overwrite&&(s=s.then(l=>N.Promises.rm(t).then(()=>l))),s.then(l=>v(l,t,{sourcePathRegex:n},i))}e.extract=g;function w(o,t){return D(o).then(r=>new Promise((i,n)=>{r.on("entry",s=>{s.fileName===t&&E(r,s).then(l=>i(l),l=>n(l))}),r.once("close",()=>n(new Error(b.localize(2,null,t))))}))}function d(o,t){return w(o,t).then(r=>new Promise((i,n)=>{const s=[];r.once("error",n),r.on("data",l=>s.push(l)),r.on("end",()=>i(Buffer.concat(s)))}))}e.buffer=d}),define(Z[152],Q([0,1,69,93]),function(x,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(T){return(0,L.buffer)(T,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=k}),define(Z[153],Q([0,1,5,22,34,9,3,2,36,16,14,12,17,40,4,11,31,20,69,92,58,18,145,23,24,42,48,133,146,152,126,134,27,45,13,8,10,26,28,29,25]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P,v,D,E,c,g,w,d,o,t,r,i,n,s,l,a,f,S,A,$,H,J,ie,re,ee,pe,le,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ie.refineServiceDecorator)(r.IExtensionManagementService);let he=class extends t.AbstractExtensionManagementService{constructor(R,I,M,F,V,G,te,ne,ge,ye,ue,ce){super(R,I,M,ye,ce),this.Y=V,this.Z=G,this.ab=te,this.bb=ge,this.cb=ue,this.X=new Map,this.kb=new h.ResourceSet;const oe=this.B(ne.createInstance(a.ExtensionsLifecycle));this.S=this.B(ne.createInstance(B,fe=>oe.postUninstall(fe))),this.U=this.B(new S.ExtensionsManifestCache(F,this)),this.W=this.B(ne.createInstance(l.ExtensionsDownloader,this.getTargetPlatform()));const se=this.B(new A.ExtensionsWatcher(this,this.Y,ce,G,ue,ge,M));this.B(se.onDidChangeExtensionsByAnotherSource(fe=>this.jb(fe))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,i.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(R){this.v.trace("ExtensionManagementService#zip",R.identifier.id);const I=await this.ib(R),M=await(0,g.zip)((0,m.joinPath)(this.W.extensionsDownloadDir,(0,E.generateUuid)()).fsPath,I);return D.URI.file(M)}async unzip(R){return this.v.trace("ExtensionManagementService#unzip",R.toString()),(await this.install(R)).identifier}async getManifest(R){const{location:I,cleanup:M}=await this.eb(R),F=p.resolve(I.fsPath);try{return await(0,f.getManifest)(F)}finally{await M()}}getInstalled(R,I){return this.S.scanExtensions(R??null,I)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(R,I={}){this.v.trace("ExtensionManagementService#install",R.toString());const{location:M,cleanup:F}=await this.eb(R);try{const V=await(0,f.getManifest)(p.resolve(M.fsPath));if(V.engines&&V.engines.vscode&&!(0,H.isEngineValid)(V.engines.vscode,this.w.version,this.w.date))throw new Error(w.localize(0,null,(0,i.getGalleryExtensionId)(V.publisher,V.name),this.w.version));return await this.z(V,M,I)}finally{await F()}}async installFromLocation(R,I){this.v.trace("ExtensionManagementService#installFromLocation",R.toString());const M=await this.S.scanUserExtensionAtLocation(R);if(!M)throw new Error(`Cannot find a valid extension from the location ${R.toString()}`);return await this.nb([M],I),this.v.info("Successfully installed extension",M.identifier.id,I.toString()),M}getMetadata(R){return this.Y.scanMetadata(R.location)}async updateMetadata(R,I){this.v.trace("ExtensionManagementService#updateMetadata",R.identifier.id);const M={...I};return I.isPreReleaseVersion&&(M.preRelease=!0),R=await this.S.updateMetadata(R,M),this.U.invalidate(),R}async updateExtensionScope(R,I){return this.v.trace("ExtensionManagementService#updateExtensionScope",R.identifier.id),R=await this.S.updateMetadata(R,{isMachineScoped:I}),this.U.invalidate(),R}async reinstallFromGallery(R){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",R.identifier.id),!this.t.isEnabled())throw new Error(w.localize(1,null));const I=await this.getTargetPlatform(),[M]=await this.t.getExtensions([{...R.identifier,preRelease:R.preRelease}],{targetPlatform:I,compatible:!0},O.CancellationToken.None);if(!M)throw new Error(w.localize(2,null));await this.S.setUninstalled(R);try{await this.S.removeUninstalledExtension(R)}catch(F){throw new Error(w.localize(3,null,(0,k.toErrorMessage)(F)))}await this.installFromGallery(M)}markAsUninstalled(...R){return this.S.setUninstalled(...R)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(R,I){const{location:M}=await this.W.download(R,I);return M}async eb(R){if(R.scheme===u.Schemas.file)return{location:R,async cleanup(){}};this.v.trace("Downloading extension from",R.toString());const I=(0,m.joinPath)(this.W.extensionsDownloadDir,(0,E.generateUuid)());return await this.ab.download(R,I),this.v.info("Downloaded extension to",I.toString()),{location:I,cleanup:async()=>{try{await this.bb.del(I)}catch(F){this.v.error(F)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(R,I,M){let F;if(D.URI.isUri(I))F=new z(R,I,M,this.t,this.S,this.v);else{const V=i.ExtensionKey.create(I).toString();F=this.X.get(V),F||(this.X.set(V,F=new C(R,I,M,this.W,this.S,this.v)),F.waitUntilTaskIsFinished().then(()=>this.X.delete(V)))}return new W(F,M.profileLocation,this.cb,this.y,this.Y,this.Z)}R(R,I){return new q(R,I.profileLocation,this.Z)}async ib(R){const I=async F=>{let V=await c.Promises.readdir(F);V=V.map(ne=>p.join(F,ne));const G=await Promise.all(V.map(ne=>c.Promises.stat(ne)));let te=Promise.resolve([]);return G.forEach((ne,ge)=>{const ye=V[ge];ne.isFile()&&(te=te.then(ue=>[...ue,ye])),ne.isDirectory()&&(te=te.then(ue=>I(ye).then(ce=>[...ue,...ce])))}),te};return(await I(R.location.fsPath)).map(F=>({path:`extension/${p.relative(R.location.fsPath,F)}`,localPath:F}))}async jb({added:R,removed:I}){if(I)for(const M of I.extensions)this.v.info("Extensions removed from another source",M.id,I.profileLocation.toString()),this.p.fire({identifier:M,profileLocation:I.profileLocation});if(R){const F=(await this.S.scanExtensions(1,R.profileLocation)).filter(V=>R.extensions.some(G=>(0,i.areSameExtensions)(G,V.identifier)));this.m.fire(F.map(V=>(this.v.info("Extensions added from another source",V.identifier.id,R.profileLocation.toString()),{identifier:V.identifier,local:V,profileLocation:R.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(I=>this.kb.add(I)));const R=await this.bb.resolve(this.Y.userExtensionsLocation);for(const I of R.children??[])I.isDirectory&&this.kb.add(I.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(I=>this.mb(I)))}async mb(R){if(!R.affects(this.Y.userExtensionsLocation,1))return;const I=[];for(const M of R.rawAdded){if(this.kb.has(M)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(M),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(M,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(M).startsWith(".")||!(await this.bb.stat(M)).isDirectory)continue;const F=await this.S.scanUserExtensionAtLocation(M);F&&F.installedTimestamp===void 0&&(this.kb.add(M),I.push(F))}I.length&&(await this.nb(I,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",I.map(M=>M.identifier.id)))}async nb(R,I){await this.Z.addExtensionsToProfile(R.map(M=>[M,void 0]),I),this.m.fire(R.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:I})))}};he=me([_(0,r.IExtensionGalleryService),_(1,pe.ITelemetryService),_(2,re.ILogService),_(3,o.INativeEnvironmentService),_(4,s.IExtensionsScannerService),_(5,n.IExtensionsProfileScannerService),_(6,d.IDownloadService),_(7,ie.IInstantiationService),_(8,J.IFileService),_(9,ee.IProductService),_(10,le.IUriIdentityService),_(11,ae.IUserDataProfilesService)],he),e.ExtensionManagementService=he;let B=class extends b.Disposable{constructor(R,I,M,F){super(),this.j=R,this.k=I,this.l=M,this.m=F,this.h=this.B(new N.Emitter),this.onExtract=this.h.event,this.c=(0,m.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new L.Queue}async cleanUp(){await this.v()}async scanExtensions(R,I){const M={includeInvalid:!0,profileLocation:I};let F=[];return R===null||R===0?F.push(...await this.l.scanAllExtensions({includeInvalid:!0},M,!1)):R===1&&F.push(...await this.l.scanUserExtensions(M)),F=R!==null?F.filter(V=>V.type===R):F,Promise.all(F.map(V=>this.u(V)))}async scanAllUserExtensions(R){const I=await this.l.scanUserExtensions({includeAllVersions:!R,includeInvalid:!0});return Promise.all(I.map(M=>this.u(M)))}async scanUserExtensionAtLocation(R){try{const I=await this.l.scanExistingExtension(R,1,{includeInvalid:!0});if(I)return await this.u(I)}catch(I){this.m.error(I)}return null}async extractUserExtension(R,I,M,F){const V=R.toString(),G=p.join(this.l.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),te=p.join(this.l.userExtensionsLocation.fsPath,V);try{await c.Promises.rm(te)}catch{throw new r.ExtensionManagementError(w.localize(4,null,te,R.id),r.ExtensionManagementErrorCode.Delete)}await this.p(R,I,G,F),await this.l.updateMetadata(D.URI.file(G),M);try{this.h.fire(D.URI.file(te)),await this.s(R,G,te,Date.now()+2*60*1e3),this.m.info("Renamed to",te)}catch(ne){try{await c.Promises.rm(G)}catch{}if(ne.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",R.id);else throw this.m.info(`Rename failed because of ${(0,T.getErrorMessage)(ne)}. Deleted from extracted location`,G),ne}return this.t(D.URI.file(te),1)}async updateMetadata(R,I){return await this.l.updateMetadata(R.location,I),this.t(R.location,R.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...R){const I=R.map(M=>i.ExtensionKey.create(M));await this.n(M=>I.forEach(F=>{M[F.toString()]=!0,this.m.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(R){await this.n(F=>delete F[R.toString()]);const M=(await this.scanAllUserExtensions(!0)).find(F=>i.ExtensionKey.create(F).equals(R))||null;return M?this.updateMetadata(M,{installedTimestamp:Date.now()}):null}async removeExtension(R,I){this.m.trace(`Deleting ${I} extension from disk`,R.identifier.id,R.location.fsPath),await c.Promises.rm(R.location.fsPath),this.m.info("Deleted from disk",R.identifier.id,R.location.fsPath)}async removeUninstalledExtension(R){await this.removeExtension(R,"uninstalled"),await this.n(I=>delete I[i.ExtensionKey.create(R).toString()])}async n(R){return this.g.queue(async()=>{let I;try{I=await c.Promises.readFile(this.c,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let M={};if(I)try{M=JSON.parse(I)}catch{}return R&&(R(M),Object.keys(M).length?await c.Promises.writeFile(this.c,JSON.stringify(M)):await c.Promises.rm(this.c)),M})}async p(R,I,M,F){this.m.trace(`Started extracting the extension from ${I} to ${M}`);try{await c.Promises.rm(M)}catch(V){throw new r.ExtensionManagementError(this.w(V).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(I,M,{sourcePath:"extension",overwrite:!0},F),this.m.info(`Extracted extension to ${M}:`,R.id)}catch(V){try{await c.Promises.rm(M)}catch{}let G=r.ExtensionManagementErrorCode.Extract;throw V instanceof g.ExtractError&&(V.type==="CorruptZip"?G=r.ExtensionManagementErrorCode.CorruptZip:V.type==="Incomplete"&&(G=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(V.message,G)}}async s(R,I,M,F){try{await c.Promises.rename(I,M)}catch(V){if(y.isWindows&&V&&V.code==="EPERM"&&Date.now()<F)return this.m.info(`Failed renaming ${I} to ${M} with 'EPERM' error. Trying again...`,R.id),this.s(R,I,M,F);throw new r.ExtensionManagementError(V.message||w.localize(5,null,I,M),V.code||r.ExtensionManagementErrorCode.Rename)}}async t(R,I){const M=await this.l.scanExistingExtension(R,I,{includeInvalid:!0});if(M)return this.u(M);throw new Error(w.localize(6,null,R.path))}async u(R){const I=await this.k.resolve(R.location);let M,F;return I.children&&(M=I.children.find(({name:V})=>/^readme(\.txt|\.md|)$/i.test(V))?.resource,F=I.children.find(({name:V})=>/^changelog(\.txt|\.md|)$/i.test(V))?.resource),{identifier:R.identifier,type:R.type,isBuiltin:R.isBuiltin||!!R.metadata?.isBuiltin,location:R.location,manifest:R.manifest,targetPlatform:R.targetPlatform,validations:R.validations,isValid:R.isValid,readmeUrl:M,changelogUrl:F,publisherDisplayName:R.metadata?.publisherDisplayName||null,publisherId:R.metadata?.publisherId||null,isApplicationScoped:!!R.metadata?.isApplicationScoped,isMachineScoped:!!R.metadata?.isMachineScoped,isPreReleaseVersion:!!R.metadata?.isPreReleaseVersion,preRelease:!!R.metadata?.preRelease,installedTimestamp:R.metadata?.installedTimestamp,updated:!!R.metadata?.updated}}async v(){const R=await this.getUninstalledExtensions(),I=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=new Set;for(const G of I)R[i.ExtensionKey.create(G).toString()]||M.add(G.identifier.id.toLowerCase());const F=(0,i.groupByExtension)(I,G=>G.identifier);await L.Promises.settled(F.map(async G=>{const te=G.sort((ne,ge)=>P.rcompare(ne.manifest.version,ge.manifest.version))[0];M.has(te.identifier.id.toLowerCase())||await this.j(await this.u(te))}));const V=I.filter(G=>G.metadata&&R[i.ExtensionKey.create(G).toString()]);await L.Promises.settled(V.map(G=>this.removeUninstalledExtension(G)))}w(R){const I=Array.isArray(R)?R:[R];return I.length===1?I[0]instanceof Error?I[0]:new Error(I[0]):I.reduce((M,F)=>new Error(`${M.message}${M.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}};B=me([_(1,J.IFileService),_(2,s.IExtensionsScannerService),_(3,re.ILogService)],B),e.ExtensionsScanner=B;class j extends t.AbstractExtensionTask{get operation(){return(0,v.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(R,I,M,F,V){super(),this.identifier=R,this.source=I,this.k=M,this.l=F,this.m=V,this.wasVerified=!1,this.j=2}async n(R,I){try{const M=await this.o(R.key);if(M)return this.l.updateMetadata(M,R.metadata)}catch{throw y.isMacintosh?new r.ExtensionManagementError(w.localize(7,null),r.ExtensionManagementErrorCode.Internal):new r.ExtensionManagementError(w.localize(8,null),r.ExtensionManagementErrorCode.Internal)}return this.q(R,I)}async o(R){if(!await this.p(R))return null;this.m.trace("Removing the extension from uninstalled list:",R.id);const M=await this.l.setInstalled(R);return this.m.info("Removed the extension from uninstalled list:",R.id),M}async p(R){return!!(await this.l.getUninstalledExtensions())[R.toString()]}async q({zipPath:R,key:I,metadata:M},F){const V=await this.l.extractUserExtension(I,R,M,F);return this.m.info("Extracting completed.",I.id),V}}class C extends j{constructor(R,I,M,F,V,G){super(I.identifier,I,M,V,G),this.s=R,this.t=I,this.u=F}async h(R){const M=(await this.l.scanExtensions(null,void 0)).find(te=>(0,i.areSameExtensions)(te.identifier,this.t.identifier));M&&(this.j=3);const F={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,$.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||M?.isMachineScoped,isBuiltin:this.k.isBuiltin||M?.isBuiltin,isSystem:M?.type===0?!0:void 0,updated:!!M,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,v.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:M?.preRelease)};if(M?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(M,F),metadata:F};const{location:V,verified:G}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!G,this.w(V.fsPath),{local:await this.n({zipPath:V.fsPath,key:i.ExtensionKey.create(this.t),metadata:F},R),metadata:F}}catch(te){try{await this.u.delete(V)}catch(ne){this.m.warn("Error while deleting the downloaded file",V.toString(),(0,T.getErrorMessage)(ne))}throw te}}async w(R){try{await(0,f.getManifest)(R)}catch(I){throw new r.ExtensionManagementError((0,t.joinErrors)(I).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=C;class z extends j{constructor(R,I,M,F,V,G){super({id:(0,i.getGalleryExtensionId)(R.publisher,R.name)},I,M,V,G),this.s=R,this.t=I,this.u=F}async h(R){const I=new i.ExtensionKey(this.identifier,this.s.version),F=(await this.l.scanExtensions(1,void 0)).find(te=>(0,i.areSameExtensions)(this.identifier,te.identifier)),V=await this.w(this.identifier.id,this.s.version,R);if(V.isApplicationScoped=(0,$.isApplicationScopedExtension)(this.s),V.isMachineScoped=this.k.isMachineScoped||F?.isMachineScoped,V.isBuiltin=this.k.isBuiltin||F?.isBuiltin,V.installedTimestamp=Date.now(),F)if(this.j=3,I.equals(new i.ExtensionKey(F.identifier,F.manifest.version)))try{await this.l.removeExtension(F,"existing")}catch{throw new Error(w.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&P.gt(F.manifest.version,this.s.version)&&await this.l.setUninstalled(F);else{const te=await this.o(I);if(te)try{await this.l.removeExtension(te,"existing")}catch{throw new Error(w.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:p.resolve(this.t.fsPath),key:I,metadata:V},R),metadata:V}}async w(R,I,M){try{let[F]=await this.u.getExtensions([{id:R,version:I}],M);if(F||([F]=await this.u.getExtensions([{id:R}],M)),F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class W{constructor(R,I,M,F,V,G){this.d=R,this.g=I,this.h=M,this.j=F,this.k=V,this.l=G,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.m()}async m(){const R=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[R.local,R.metadata]],this.g),R}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class q extends t.AbstractExtensionTask{constructor(R,I,M){super(),this.extension=R,this.j=I,this.k=M}async h(R){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Z[154],Q([0,1,129,5,15,9,2,4,21,18,130,10,128,167]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends N.Disposable{constructor(E,c,g){super(),this.h=E,this.i=c,this.j=g,this.k(),this.B(E.onDidChangeConfiguration(w=>{w.affectsConfiguration("http")&&this.k()}))}k(){const E=this.h.getValue("http");this.a=E?.proxy,this.b=!!E?.proxyStrictSSL,this.f=E?.proxyAuthorization}async request(E,c){this.j.trace("RequestService#request (node) - begin",E.url);const{a:g,b:w}=this;let d;try{d=await(0,p.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(r){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",r))}const o={...process.env,...d},t=E.agent?E.agent:await(0,m.getProxyAgent)(E.url||"",o,{proxyUrl:g,strictSSL:w});E.agent=t,E.strictSSL=w,this.f&&(E.headers={...E.headers||{},"Proxy-Authorization":this.f});try{const r=await this.m(E,c);return this.j.trace("RequestService#request (node) - success",E.url),r}catch(r){throw this.j.trace("RequestService#request (node) - error",E.url,r),r}}async l(E){return((0,L.parse)(E.url).protocol==="https:"?await new Promise((w,d)=>{x(["https"],w,d)}):await new Promise((w,d)=>{x(["http"],w,d)})).request}m(E,c){return O.Promises.withAsyncBody(async(g,w)=>{const d=(0,L.parse)(E.url),o=E.getRawRequest?E.getRawRequest(E):await this.l(E),t={hostname:d.hostname,port:d.port?parseInt(d.port):d.protocol==="https:"?443:80,protocol:d.protocol,path:d.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,b.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(t.auth=E.user+":"+E.password);const r=o(t,i=>{const n=(0,b.isNumber)(E.followRedirects)?E.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.m({...E,url:i.headers.location,followRedirects:n-1},c).then(g,w);else{let s=i;!E.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,P.createGunzip)())),g({res:i,stream:(0,k.streamToBufferReadableStream)(s)})}});r.on("error",w),E.timeout&&r.setTimeout(E.timeout),E.isChromiumNetwork&&r.removeHeader("Content-Length"),E.data&&typeof E.data=="string"&&r.write(E.data),r.end(),c.onCancellationRequested(()=>{r.abort(),w(new T.CancellationError)})})}async resolveProxy(E){}};v=me([_(0,h.IConfigurationService),_(1,u.INativeEnvironmentService),_(2,y.ILogService)],v),e.RequestService=v}),define(Z[168],Q([0,1,33,5,15,34,9,2,16,14,12,35,11,20,21,125,58,127,18,106,149,23,59,132,42,48,153,147,13,117,119,46,115,62,63,136,10,121,122,38,151,139,26,47,154,67,131,68,28,138,39,140,141,29,143,25,150,142]),function(x,e,L,O,k,T,N,b,h,u,p,y,m,P,v,D,E,c,g,w,d,o,t,r,i,n,s,l,a,f,S,A,$,H,J,ie,re,ee,pe,le,ae,he,B,j,C,z,W,q,Y,R,I,M,F,V,G,te,ne,ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends b.Disposable{constructor(oe){super(),this.b=oe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[oe,se]=await this.f();return oe.invokeFunction(async fe=>{const Te=fe.get(re.ILogService),Fe=fe.get(a.IFileService),Oe=fe.get(g.INativeEnvironmentService),Me=fe.get(te.IUserDataProfilesService);Te.info("CLI main",this.b),this.g(Te),await this.h(Oe,Fe,Me,oe),await Promise.all(se.map(U=>{(0,O.raceTimeout)(U.flush(),1e3)}))})}async f(){const oe=new H.ServiceCollection,se={_serviceBrand:void 0,...he.default};oe.set(B.IProductService,se);const fe=new w.NativeEnvironmentService(this.b,se);oe.set(g.INativeEnvironmentService,fe),await Promise.all([fe.appSettingsHome.fsPath,fe.extensionsPath].map(Pe=>Pe?P.Promises.mkdir(Pe,{recursive:!0}):void 0));const Te=(0,re.getLogLevel)(fe),Fe=[];Fe.push(new ee.SpdLogLogger("cli",(0,u.join)(fe.logsPath,"cli.log"),!0,!1,Te)),Te===re.LogLevel.Trace&&Fe.push(new re.ConsoleLogger(Te));const Oe=this.B(new re.MultiplexLogService(Fe));oe.set(re.ILogService,Oe);const Me=this.B(new f.FileService(Oe));oe.set(a.IFileService,Me);const U=this.B(new S.DiskFileSystemProvider(Oe));Me.registerProvider(h.Schemas.file,U);const K=new W.StateService(fe,Oe,Me);oe.set(z.IStateService,K);const X=new G.UriIdentityService(Me);oe.set(V.IUriIdentityService,X);const de=new ne.UserDataProfilesService(K,X,fe,Me,Oe);oe.set(te.IUserDataProfilesService,de);const ve=p.isWindows&&se.win32RegValueName?this.B(new ae.NativePolicyService(Oe,se.win32RegValueName)):fe.policyFile?this.B(new pe.FilePolicyService(fe.policyFile,Me,Oe)):new le.NullPolicyService;oe.set(le.IPolicyService,ve);const ke=this.B(new D.ConfigurationService(de.defaultProfile.settingsResource,Me,ve,Oe));oe.set(v.IConfigurationService,ke),await Promise.all([K.init(),ke.initialize()]),de.setEnablement(se.quality!=="stable"||ke.getValue(te.PROFILES_ENABLEMENT_CONFIG)),oe.set(V.IUriIdentityService,new G.UriIdentityService(Me)),oe.set(j.IRequestService,new A.SyncDescriptor(C.RequestService,void 0,!0)),oe.set(E.IDownloadService,new A.SyncDescriptor(c.DownloadService,void 0,!0)),oe.set(i.IExtensionsProfileScannerService,new A.SyncDescriptor(i.ExtensionsProfileScannerService,void 0,!0)),oe.set(n.IExtensionsScannerService,new A.SyncDescriptor(l.ExtensionsScannerService,void 0,!0)),oe.set(t.IExtensionSignatureVerificationService,new A.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),oe.set(s.INativeServerExtensionManagementService,new A.SyncDescriptor(s.ExtensionManagementService,void 0,!0)),oe.set(o.IExtensionGalleryService,new A.SyncDescriptor(d.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),oe.set(J.ILanguagePackService,new A.SyncDescriptor(ie.NativeLanguagePackService,void 0,!1));const Se=[],Le=(0,I.isInternalTelemetry)(se,ke);if((0,I.supportsTelemetry)(se,fe)){se.aiConfig&&se.aiConfig.ariaKey&&Se.push(new M.OneDataSystemAppender(Le,"monacoworkbench",null,se.aiConfig.ariaKey));const{installSourcePath:Pe}=fe,De={appenders:Se,sendErrorTelemetry:!1,commonProperties:(async()=>{let je;try{je=await(0,ge.resolveMachineId)(K)}catch(Ie){Ie.code!=="ENOENT"&&Oe.error(Ie)}return(0,q.resolveCommonProperties)(Me,(0,L.release)(),(0,L.hostname)(),process.arch,se.commit,se.version,je,Le,Pe)})(),piiPaths:(0,I.getPiiPathsFromEnvironment)(fe)};oe.set(Y.ITelemetryService,new A.SyncDescriptor(R.TelemetryService,[De],!1))}else oe.set(Y.ITelemetryService,I.NullTelemetryService);return[new $.InstantiationService(oe),Se]}g(oe){(0,N.setUnexpectedErrorHandler)(se=>{const fe=(0,T.toErrorMessage)(se,!0);!fe||oe.error(`[uncaught exception in CLI]: ${fe}`)}),process.on("uncaughtException",se=>(0,N.onUnexpectedError)(se)),process.on("unhandledRejection",se=>(0,N.onUnexpectedError)(se))}async h(oe,se,fe,Te){const Fe=(oe.args.profile?fe.profiles.find(Oe=>Oe.name===oe.args.profile)??fe.defaultProfile:fe.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(oe,se,this.b["install-source"]);if(this.b["list-extensions"])return Te.createInstance(r.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Fe);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Oe={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Fe};return Te.createInstance(r.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],Oe,!!this.b.force)}else{if(this.b["uninstall-extension"])return Te.createInstance(r.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Fe);if(this.b["locate-extension"])return Te.createInstance(r.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.buildTelemetryMessage)(oe.appRoot,oe.extensionsPath))}}i(oe){return oe.map(se=>/\.vsix$/i.test(se)?m.URI.file((0,u.isAbsolute)(se)?se:(0,u.join)((0,y.cwd)(),se)):se)}async j(oe,se,fe){await se.writeFile(m.URI.file(oe.installSourcePath),k.VSBuffer.fromString(fe.slice(0,30)))}}async function ue(ce){const oe=new ye(ce);try{await oe.run()}finally{oe.dispose()}}e.main=ue})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6ed4d436a9b6ae131732f4e2a723868231f4473a/core/vs/code/node/cliProcessMain.js.map
