/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],ke=function(ee){for(var e=[],i=0,T=ee.length;i<T;i++)e[i]=Ce[ee[i]];return e};define(Ce[80],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(C,F){const S=Object.create(null);for(const k of C){const N=F(k);let D=S[N];D||(D=S[N]=[]),D.push(k)}return S}e.groupBy=i;function T(C,F){const S=[],k=[];for(const N of C)F.has(N)||S.push(N);for(const N of F)C.has(N)||k.push(N);return{removed:S,added:k}}e.diffSets=T;function y(C,F){const S=[],k=[];for(const[N,D]of C)F.has(N)||S.push(D);for(const[N,D]of F)C.has(N)||k.push(D);return{removed:S,added:k}}e.diffMaps=y;class L{constructor(){this.a=new Map}add(F,S){let k=this.a.get(F);k||(k=new Set,this.a.set(F,k)),k.add(S)}delete(F,S){const k=this.a.get(F);!k||(k.delete(S),k.size===0&&this.a.delete(F))}forEach(F,S){const k=this.a.get(F);!k||k.forEach(S)}}e.SetMap=L}),define(Ce[61],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(C){return(F,S,k)=>{let N=null,D=null;if(typeof k.value=="function"?(N="value",D=k.value):typeof k.get=="function"&&(N="get",D=k.get),!D)throw new Error("not supported");k[N]=C(D,S)}}function T(C,F,S){let k=null,N=null;if(typeof S.value=="function"?(k="value",N=S.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",N=S.get),!N)throw new Error("not supported");const D=`$memoize$${F}`;S[k]=function(...g){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,g)}),this[D]}}e.memoize=T;function y(C,F,S){return i((k,N)=>{const D=`$debounce$${N}`,g=`$debounce$result$${N}`;return function(...p){this[g]||(this[g]=S?S():void 0),clearTimeout(this[D]),F&&(this[g]=F(this[g],...p),p=[this[g]]),this[D]=setTimeout(()=>{k.apply(this,p),this[g]=S?S():void 0},C)}})}e.debounce=y;function L(C,F,S){return i((k,N)=>{const D=`$throttle$timer$${N}`,g=`$throttle$result$${N}`,p=`$throttle$lastRun$${N}`,f=`$throttle$pending$${N}`;return function(...t){if(this[g]||(this[g]=S?S():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),F&&(this[g]=F(this[g],...t)),this[f])return;const a=this[p]+C;a<=Date.now()?(this[p]=Date.now(),k.apply(this,[this[g]]),this[g]=S?S():void 0):(this[f]=!0,this[D]=setTimeout(()=>{this[f]=!1,this[p]=Date.now(),k.apply(this,[this[g]]),this[g]=S?S():void 0},a-Date.now()))}})}e.throttle=L}),define(Ce[81],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(y){this.a=y,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(Ce[109],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var T;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(r){r.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function C(r,o=!1){let s=0;const d=r.length;let c="",u=0,n=16,h=0;function m(A){let O=0,B=0;for(;O<A;){const z=r.charCodeAt(s);if(z>=48&&z<=57)B=B*16+z-48;else if(z>=65&&z<=70)B=B*16+z-65+10;else if(z>=97&&z<=102)B=B*16+z-97+10;else break;s++,O++}return O<A&&(B=-1),B}function P(A){s=A,c="",u=0,n=16,h=0}function M(){const A=s;if(r.charCodeAt(s)===48)s++;else for(s++;s<r.length&&k(r.charCodeAt(s));)s++;if(s<r.length&&r.charCodeAt(s)===46)if(s++,s<r.length&&k(r.charCodeAt(s)))for(s++;s<r.length&&k(r.charCodeAt(s));)s++;else return h=3,r.substring(A,s);let O=s;if(s<r.length&&(r.charCodeAt(s)===69||r.charCodeAt(s)===101))if(s++,(s<r.length&&r.charCodeAt(s)===43||r.charCodeAt(s)===45)&&s++,s<r.length&&k(r.charCodeAt(s))){for(s++;s<r.length&&k(r.charCodeAt(s));)s++;O=s}else h=3;return r.substring(A,O)}function V(){let A="",O=s;for(;;){if(s>=d){A+=r.substring(O,s),h=2;break}const B=r.charCodeAt(s);if(B===34){A+=r.substring(O,s),s++;break}if(B===92){if(A+=r.substring(O,s),s++,s>=d){h=2;break}switch(r.charCodeAt(s++)){case 34:A+='"';break;case 92:A+="\\";break;case 47:A+="/";break;case 98:A+="\b";break;case 102:A+="\f";break;case 110:A+=`
`;break;case 114:A+="\r";break;case 116:A+="	";break;case 117:{const j=m(4);j>=0?A+=String.fromCharCode(j):h=4;break}default:h=5}O=s;continue}if(B>=0&&B<=31)if(S(B)){A+=r.substring(O,s),h=2;break}else h=6;s++}return A}function Z(){if(c="",h=0,u=s,s>=d)return u=d,n=17;let A=r.charCodeAt(s);if(F(A)){do s++,c+=String.fromCharCode(A),A=r.charCodeAt(s);while(F(A));return n=15}if(S(A))return s++,c+=String.fromCharCode(A),A===13&&r.charCodeAt(s)===10&&(s++,c+=`
`),n=14;switch(A){case 123:return s++,n=1;case 125:return s++,n=2;case 91:return s++,n=3;case 93:return s++,n=4;case 58:return s++,n=6;case 44:return s++,n=5;case 34:return s++,c=V(),n=10;case 47:{const O=s-1;if(r.charCodeAt(s+1)===47){for(s+=2;s<d&&!S(r.charCodeAt(s));)s++;return c=r.substring(O,s),n=12}if(r.charCodeAt(s+1)===42){s+=2;const B=d-1;let z=!1;for(;s<B;){if(r.charCodeAt(s)===42&&r.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,h=1),c=r.substring(O,s),n=13}return c+=String.fromCharCode(A),s++,n=16}case 45:if(c+=String.fromCharCode(A),s++,s===d||!k(r.charCodeAt(s)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=M(),n=11;default:for(;s<d&&G(A);)s++,A=r.charCodeAt(s);if(u!==s){switch(c=r.substring(u,s),c){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return c+=String.fromCharCode(A),s++,n=16}}function G(A){if(F(A)||S(A))return!1;switch(A){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function R(){let A;do A=Z();while(A>=12&&A<=15);return A}return{setPosition:P,getPosition:()=>s,scan:o?R:Z,getToken:()=>n,getTokenValue:()=>c,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>h}}e.createScanner=C;function F(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function S(r){return r===10||r===13||r===8232||r===8233}function k(r){return r>=48&&r<=57}var N;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(N||(N={}));function D(r,o){const s=[],d=new Object;let c;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function h(m,P,M,V){u.value=m,u.offset=P,u.length=M,u.type=V,u.colonOffset=void 0,c=u}try{b(r,{onObjectBegin:(m,P)=>{if(o<=m)throw d;c=void 0,n=o>m,s.push("")},onObjectProperty:(m,P,M)=>{if(o<P||(h(m,P,M,"property"),s[s.length-1]=m,o<=P+M))throw d},onObjectEnd:(m,P)=>{if(o<=m)throw d;c=void 0,s.pop()},onArrayBegin:(m,P)=>{if(o<=m)throw d;c=void 0,s.push(0)},onArrayEnd:(m,P)=>{if(o<=m)throw d;c=void 0,s.pop()},onLiteralValue:(m,P,M)=>{if(o<P||(h(m,P,M,w(m)),o<=P+M))throw d},onSeparator:(m,P,M)=>{if(o<=P)throw d;if(m===":"&&c&&c.type==="property")c.colonOffset=P,n=!1,c=void 0;else if(m===","){const V=s[s.length-1];typeof V=="number"?s[s.length-1]=V+1:(n=!0,s[s.length-1]=""),c=void 0}}})}catch(m){if(m!==d)throw m}return{path:s,previousNode:c,isAtPropertyKey:n,matches:m=>{let P=0;for(let M=0;P<m.length&&M<s.length;M++)if(m[P]===s[M]||m[P]==="*")P++;else if(m[P]!=="**")return!1;return P===m.length}}}e.getLocation=D;function g(r,o=[],s=L.DEFAULT){let d=null,c=[];const u=[];function n(m){Array.isArray(c)?c.push(m):d!==null&&(c[d]=m)}return b(r,{onObjectBegin:()=>{const m={};n(m),u.push(c),c=m,d=null},onObjectProperty:m=>{d=m},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const m=[];n(m),u.push(c),c=m,d=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:n,onError:(m,P,M)=>{o.push({error:m,offset:P,length:M})}},s),c[0]}e.parse=g;function p(r,o=[],s=L.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(m){d.type==="property"&&(d.length=m-d.offset,d=d.parent)}function u(m){return d.children.push(m),m}b(r,{onObjectBegin:m=>{d=u({type:"object",offset:m,length:-1,parent:d,children:[]})},onObjectProperty:(m,P,M)=>{d=u({type:"property",offset:P,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:m,offset:P,length:M,parent:d})},onObjectEnd:(m,P)=>{d.length=m+P-d.offset,d=d.parent,c(m+P)},onArrayBegin:(m,P)=>{d=u({type:"array",offset:m,length:-1,parent:d,children:[]})},onArrayEnd:(m,P)=>{d.length=m+P-d.offset,d=d.parent,c(m+P)},onLiteralValue:(m,P,M)=>{u({type:w(m),offset:P,length:M,parent:d,value:m}),c(P+M)},onSeparator:(m,P,M)=>{d.type==="property"&&(m===":"?d.colonOffset=P:m===","&&c(P))},onError:(m,P,M)=>{o.push({error:m,offset:P,length:M})}},s);const h=d.children[0];return h&&delete h.parent,h}e.parseTree=p;function f(r,o){if(!r)return;let s=r;for(const d of o)if(typeof d=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let c=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===d){s=u.children[1],c=!0;break}if(!c)return}else{const c=d;if(s.type!=="array"||c<0||!Array.isArray(s.children)||c>=s.children.length)return;s=s.children[c]}return s}e.findNodeAtLocation=f;function t(r){if(!r.parent||!r.parent.children)return[];const o=t(r.parent);if(r.parent.type==="property"){const s=r.parent.children[0].value;o.push(s)}else if(r.parent.type==="array"){const s=r.parent.children.indexOf(r);s!==-1&&o.push(s)}return o}e.getNodePath=t;function a(r){switch(r.type){case"array":return r.children.map(a);case"object":{const o=Object.create(null);for(const s of r.children){const d=s.children[1];d&&(o[s.children[0].value]=a(d))}return o}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=a;function l(r,o,s=!1){return o>=r.offset&&o<r.offset+r.length||s&&o===r.offset+r.length}e.contains=l;function v(r,o,s=!1){if(l(r,o,s)){const d=r.children;if(Array.isArray(d))for(let c=0;c<d.length&&d[c].offset<=o;c++){const u=v(d[c],o,s);if(u)return u}return r}}e.findNodeAtOffset=v;function b(r,o,s=L.DEFAULT){const d=C(r,!1);function c(De){return De?()=>De(d.getTokenOffset(),d.getTokenLength()):()=>!0}function u(De){return De?re=>De(re,d.getTokenOffset(),d.getTokenLength()):()=>!0}const n=c(o.onObjectBegin),h=u(o.onObjectProperty),m=c(o.onObjectEnd),P=c(o.onArrayBegin),M=c(o.onArrayEnd),V=u(o.onLiteralValue),Z=u(o.onSeparator),G=c(o.onComment),R=u(o.onError),A=s&&s.disallowComments,O=s&&s.allowTrailingComma;function B(){for(;;){const De=d.scan();switch(d.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:A||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(De){case 12:case 13:A?z(10):G();break;case 16:z(1);break;case 15:case 14:break;default:return De}}}function z(De,re=[],_=[]){if(R(De),re.length+_.length>0){let le=d.getToken();for(;le!==17;){if(re.indexOf(le)!==-1){B();break}else if(_.indexOf(le)!==-1)break;le=B()}}}function j(De){const re=d.getTokenValue();return De?V(re):h(re),B(),!0}function K(){switch(d.getToken()){case 11:{let De=0;try{De=JSON.parse(d.getTokenValue()),typeof De!="number"&&(z(2),De=0)}catch{z(2)}V(De);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return B(),!0}function ie(){return d.getToken()!==10?(z(3,[],[2,5]),!1):(j(!1),d.getToken()===6?(Z(":"),B(),oe()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function me(){n(),B();let De=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(De||z(4,[],[]),Z(","),B(),d.getToken()===2&&O)break}else De&&z(6,[],[]);ie()||z(4,[],[2,5]),De=!0}return m(),d.getToken()!==2?z(7,[2],[]):B(),!0}function ue(){P(),B();let De=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(De||z(4,[],[]),Z(","),B(),d.getToken()===4&&O)break}else De&&z(6,[],[]);oe()||z(4,[],[4,5]),De=!0}return M(),d.getToken()!==4?z(8,[4],[]):B(),!0}function oe(){switch(d.getToken()){case 3:return ue();case 1:return me();case 10:return j(!0);default:return K()}}return B(),d.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):oe()?(d.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=b;function E(r,o){const s=C(r),d=[];let c,u=0,n;do switch(n=s.getPosition(),c=s.scan(),c){case 12:case 13:case 17:u!==n&&d.push(r.substring(u,n)),o!==void 0&&d.push(s.getTokenValue().replace(/[^\r\n]/g,o)),u=s.getPosition();break}while(c!==17);return d.join("")}e.stripComments=E;function w(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(Ce[28],ke([1,0]),function(ee,e){"use strict";var i,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(f,t,a){let l=f.get(t);return l===void 0&&(l=a,f.set(t,l)),l}e.getOrSet=L;function C(f){const t=[];return f.forEach((a,l)=>{t.push(`${l} => ${a}`)}),`Map(${f.size}) {${t.join(", ")}}`}e.mapToString=C;function F(f){const t=[];return f.forEach(a=>{t.push(a)}),`Set(${f.size}) {${t.join(", ")}}`}e.setToString=F;class S{constructor(t,a){this.uri=t,this.value=a}}class k{constructor(t,a){this[i]="ResourceMap",t instanceof k?(this.b=new Map(t.b),this.c=a??k.a):(this.b=new Map,this.c=t??k.a)}set(t,a){return this.b.set(this.c(t),new S(t,a)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,a){typeof a<"u"&&(t=t.bind(a));for(const[l,v]of this.b)t(v.value,v.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.ResourceMap=k,k.a=f=>f.toString();class N{constructor(t,a){this[T]="ResourceSet",!t||typeof t=="function"?this.a=new k(t):(this.a=new k(a),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,a){this.a.forEach((l,v)=>t.call(a,v,v,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=N;var D;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class g{constructor(){this[y]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,a=0){const l=this.a.get(t);if(!!l)return a!==0&&this.j(l,a),l.value}set(t,a,l=0){let v=this.a.get(t);if(v)v.value=a,l!==0&&this.j(v,l);else{switch(v={key:t,value:a,next:void 0,previous:void 0},l){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(t,v),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const a=this.a.get(t);if(!!a)return this.a.delete(t),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,a){const l=this.e;let v=this.b;for(;v;){if(a?t.bind(a)(v.value,v.key,this):t(v.value,v.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const t=this,a=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.key,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return v}values(){const t=this,a=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.value,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return v}entries(){const t=this,a=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:[l.key,l.value],done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return v}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let a=this.b,l=this.size;for(;a&&l>t;)this.a.delete(a.key),a=a.next,l--;this.b=a,this.d=l,a&&(a.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const a=t.next,l=t.previous;if(!a||!l)throw new Error("Invalid list");a.previous=l,l.next=a}t.next=void 0,t.previous=void 0,this.e++}j(t,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(t===this.b)return;const l=t.next,v=t.previous;t===this.c?(v.next=void 0,this.c=v):(l.previous=v,v.next=l),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(a===2){if(t===this.c)return;const l=t.next,v=t.previous;t===this.b?(l.previous=void 0,this.b=l):(l.previous=v,v.next=l),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((a,l)=>{t.push([l,a])}),t}fromJSON(t){this.clear();for(const[a,l]of t)this.set(a,l)}}e.LinkedMap=g;class p extends g{constructor(t,a=1){super(),this.k=t,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,a=2){return super.get(t,a)}peek(t){return super.get(t,0)}set(t,a){return super.set(t,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[110],ke([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(Te,Ie){for(var Se=0;Se<Ie.length;Se++){var se=Ie[Se];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Te,se.key,se)}}function i(Te,Ie,Se){return Ie&&e(Te.prototype,Ie),Se&&e(Te,Se),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function T(Te,Ie){if(!!Te){if(typeof Te=="string")return y(Te,Ie);var Se=Object.prototype.toString.call(Te).slice(8,-1);if(Se==="Object"&&Te.constructor&&(Se=Te.constructor.name),Se==="Map"||Se==="Set")return Array.from(Te);if(Se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Se))return y(Te,Ie)}}function y(Te,Ie){(Ie==null||Ie>Te.length)&&(Ie=Te.length);for(var Se=0,se=new Array(Ie);Se<Ie;Se++)se[Se]=Te[Se];return se}function L(Te,Ie){var Se=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(Se)return(Se=Se.call(Te)).next.bind(Se);if(Array.isArray(Te)||(Se=T(Te))||Ie&&Te&&typeof Te.length=="number"){Se&&(Te=Se);var se=0;return function(){return se>=Te.length?{done:!0}:{done:!1,value:Te[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=C();function F(Te){ee.defaults=Te}var S=/[&<>"']/,k=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(Ie){return g[Ie]};function f(Te,Ie){if(Ie){if(S.test(Te))return Te.replace(k,p)}else if(N.test(Te))return Te.replace(D,p);return Te}var t=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(Te){return Te.replace(t,function(Ie,Se){return Se=Se.toLowerCase(),Se==="colon"?":":Se.charAt(0)==="#"?Se.charAt(1)==="x"?String.fromCharCode(parseInt(Se.substring(2),16)):String.fromCharCode(+Se.substring(1)):""})}var l=/(^|[^\[])\^/g;function v(Te,Ie){Te=typeof Te=="string"?Te:Te.source,Ie=Ie||"";var Se={replace:function(ce,Y){return Y=Y.source||Y,Y=Y.replace(l,"$1"),Te=Te.replace(ce,Y),Se},getRegex:function(){return new RegExp(Te,Ie)}};return Se}var b=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(Te,Ie,Se){if(Te){var se;try{se=decodeURIComponent(a(Se)).replace(b,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Ie&&!E.test(Se)&&(Se=c(Ie,Se));try{Se=encodeURI(Se).replace(/%25/g,"%")}catch{return null}return Se}var r={},o=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Te,Ie){r[" "+Te]||(o.test(Te)?r[" "+Te]=Te+"/":r[" "+Te]=m(Te,"/",!0)),Te=r[" "+Te];var Se=Te.indexOf(":")===-1;return Ie.substring(0,2)==="//"?Se?Ie:Te.replace(s,"$1")+Ie:Ie.charAt(0)==="/"?Se?Ie:Te.replace(d,"$1")+Ie:Te+Ie}var u={exec:function(){}};function n(Te){for(var Ie=1,Se,se;Ie<arguments.length;Ie++){Se=arguments[Ie];for(se in Se)Object.prototype.hasOwnProperty.call(Se,se)&&(Te[se]=Se[se])}return Te}function h(Te,Ie){var Se=Te.replace(/\|/g,function(Y,I,$){for(var H=!1,q=I;--q>=0&&$[q]==="\\";)H=!H;return H?"|":" |"}),se=Se.split(/ \|/),ce=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Ie)se.splice(Ie);else for(;se.length<Ie;)se.push("");for(;ce<se.length;ce++)se[ce]=se[ce].trim().replace(/\\\|/g,"|");return se}function m(Te,Ie,Se){var se=Te.length;if(se===0)return"";for(var ce=0;ce<se;){var Y=Te.charAt(se-ce-1);if(Y===Ie&&!Se)ce++;else if(Y!==Ie&&Se)ce++;else break}return Te.slice(0,se-ce)}function P(Te,Ie){if(Te.indexOf(Ie[1])===-1)return-1;for(var Se=Te.length,se=0,ce=0;ce<Se;ce++)if(Te[ce]==="\\")ce++;else if(Te[ce]===Ie[0])se++;else if(Te[ce]===Ie[1]&&(se--,se<0))return ce;return-1}function M(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function V(Te,Ie){if(Ie<1)return"";for(var Se="";Ie>1;)Ie&1&&(Se+=Te),Ie>>=1,Te+=Te;return Se+Te}function Z(Te,Ie,Se,se){var ce=Ie.href,Y=Ie.title?f(Ie.title):null,I=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){se.state.inLink=!0;var $={type:"link",raw:Se,href:ce,title:Y,text:I,tokens:se.inlineTokens(I)};return se.state.inLink=!1,$}return{type:"image",raw:Se,href:ce,title:Y,text:f(I)}}function G(Te,Ie){var Se=Te.match(/^(\s+)(?:```)/);if(Se===null)return Ie;var se=Se[1];return Ie.split(`
`).map(function(ce){var Y=ce.match(/^\s+/);if(Y===null)return ce;var I=Y[0];return I.length>=se.length?ce.slice(se.length):ce}).join(`
`)}var R=function(){function Te(Se){this.options=Se||ee.defaults}var Ie=Te.prototype;return Ie.space=function(se){var ce=this.rules.block.newline.exec(se);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},Ie.code=function(se){var ce=this.rules.block.code.exec(se);if(ce){var Y=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:m(Y,`
`)}}},Ie.fences=function(se){var ce=this.rules.block.fences.exec(se);if(ce){var Y=ce[0],I=G(Y,ce[3]||"");return{type:"code",raw:Y,lang:ce[2]?ce[2].trim():ce[2],text:I}}},Ie.heading=function(se){var ce=this.rules.block.heading.exec(se);if(ce){var Y=ce[2].trim();if(/#$/.test(Y)){var I=m(Y,"#");(this.options.pedantic||!I||/ $/.test(I))&&(Y=I.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:Y,tokens:this.lexer.inline(Y)}}},Ie.hr=function(se){var ce=this.rules.block.hr.exec(se);if(ce)return{type:"hr",raw:ce[0]}},Ie.blockquote=function(se){var ce=this.rules.block.blockquote.exec(se);if(ce){var Y=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},Ie.list=function(se){var ce=this.rules.block.list.exec(se);if(ce){var Y,I,$,H,q,J,de,we,ae,pe,ve,We,He=ce[1].trim(),tt=He.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(We=!1,!(!(ce=et.exec(se))||this.rules.block.hr.test(se)));){if(Y=ce[0],se=se.substring(Y.length),we=ce[2].split(`
`,1)[0],ae=se.split(`
`,1)[0],this.options.pedantic?(H=2,ve=we.trimLeft()):(H=ce[2].search(/[^ ]/),H=H>4?1:H,ve=we.slice(H),H+=ce[1].length),J=!1,!we&&/^ *$/.test(ae)&&(Y+=ae+`
`,se=se.substring(ae.length+1),We=!0),!We)for(var it=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");se&&(pe=se.split(`
`,1)[0],we=pe,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(we)||st.test(we)||it.test(we)||dt.test(se)));){if(we.search(/[^ ]/)>=H||!we.trim())ve+=`
`+we.slice(H);else if(!J)ve+=`
`+we;else break;!J&&!we.trim()&&(J=!0),Y+=pe+`
`,se=se.substring(pe.length+1)}Xe.loose||(de?Xe.loose=!0:/\n *\n *$/.test(Y)&&(de=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(ve),I&&($=I[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Y,task:!!I,checked:$,loose:!1,text:ve}),Xe.raw+=Y}Xe.items[Xe.items.length-1].raw=Y.trimRight(),Xe.items[Xe.items.length-1].text=ve.trimRight(),Xe.raw=Xe.raw.trimRight();var Q=Xe.items.length;for(q=0;q<Q;q++){this.lexer.state.top=!1,Xe.items[q].tokens=this.lexer.blockTokens(Xe.items[q].text,[]);var X=Xe.items[q].tokens.filter(function(Me){return Me.type==="space"}),ge=X.every(function(Me){for(var $e=Me.raw.split(""),Ve=0,Qe=L($e),nt;!(nt=Qe()).done;){var wt=nt.value;if(wt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Xe.loose&&X.length&&ge&&(Xe.loose=!0,Xe.items[q].loose=!0)}return Xe}},Ie.html=function(se){var ce=this.rules.block.html.exec(se);if(ce){var Y={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]);Y.type="paragraph",Y.text=I,Y.tokens=this.lexer.inline(I)}return Y}},Ie.def=function(se){var ce=this.rules.block.def.exec(se);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var Y=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:ce[0],href:ce[2],title:ce[3]}}},Ie.table=function(se){var ce=this.rules.block.table.exec(se);if(ce){var Y={type:"table",header:h(ce[1]).map(function(de){return{text:de}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=ce[0];var I=Y.align.length,$,H,q,J;for($=0;$<I;$++)/^ *-+: *$/.test(Y.align[$])?Y.align[$]="right":/^ *:-+: *$/.test(Y.align[$])?Y.align[$]="center":/^ *:-+ *$/.test(Y.align[$])?Y.align[$]="left":Y.align[$]=null;for(I=Y.rows.length,$=0;$<I;$++)Y.rows[$]=h(Y.rows[$],Y.header.length).map(function(de){return{text:de}});for(I=Y.header.length,H=0;H<I;H++)Y.header[H].tokens=this.lexer.inline(Y.header[H].text);for(I=Y.rows.length,H=0;H<I;H++)for(J=Y.rows[H],q=0;q<J.length;q++)J[q].tokens=this.lexer.inline(J[q].text);return Y}}},Ie.lheading=function(se){var ce=this.rules.block.lheading.exec(se);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},Ie.paragraph=function(se){var ce=this.rules.block.paragraph.exec(se);if(ce){var Y=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:Y,tokens:this.lexer.inline(Y)}}},Ie.text=function(se){var ce=this.rules.block.text.exec(se);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},Ie.escape=function(se){var ce=this.rules.inline.escape.exec(se);if(ce)return{type:"escape",raw:ce[0],text:f(ce[1])}},Ie.tag=function(se){var ce=this.rules.inline.tag.exec(se);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]}},Ie.link=function(se){var ce=this.rules.inline.link.exec(se);if(ce){var Y=ce[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var I=m(Y.slice(0,-1),"\\");if((Y.length-I.length)%2===0)return}else{var $=P(ce[2],"()");if($>-1){var H=ce[0].indexOf("!")===0?5:4,q=H+ce[1].length+$;ce[2]=ce[2].substring(0,$),ce[0]=ce[0].substring(0,q).trim(),ce[3]=""}}var J=ce[2],de="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);we&&(J=we[1],de=we[3])}else de=ce[3]?ce[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(Y)?J=J.slice(1):J=J.slice(1,-1)),Z(ce,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:de&&de.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},Ie.reflink=function(se,ce){var Y;if((Y=this.rules.inline.reflink.exec(se))||(Y=this.rules.inline.nolink.exec(se))){var I=(Y[2]||Y[1]).replace(/\s+/g," ");if(I=ce[I.toLowerCase()],!I||!I.href){var $=Y[0].charAt(0);return{type:"text",raw:$,text:$}}return Z(Y,I,Y[0],this.lexer)}},Ie.emStrong=function(se,ce,Y){Y===void 0&&(Y="");var I=this.rules.inline.emStrong.lDelim.exec(se);if(!!I&&!(I[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=I[1]||I[2]||"";if(!$||$&&(Y===""||this.rules.inline.punctuation.exec(Y))){var H=I[0].length-1,q,J,de=H,we=0,ae=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,ce=ce.slice(-1*se.length+H);(I=ae.exec(ce))!=null;)if(q=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!q){if(J=q.length,I[3]||I[4]){de+=J;continue}else if((I[5]||I[6])&&H%3&&!((H+J)%3)){we+=J;continue}if(de-=J,!(de>0)){if(J=Math.min(J,J+de+we),Math.min(H,J)%2){var pe=se.slice(1,H+I.index+J);return{type:"em",raw:se.slice(0,H+I.index+J+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}var ve=se.slice(2,H+I.index+J-1);return{type:"strong",raw:se.slice(0,H+I.index+J+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},Ie.codespan=function(se){var ce=this.rules.inline.code.exec(se);if(ce){var Y=ce[2].replace(/\n/g," "),I=/[^ ]/.test(Y),$=/^ /.test(Y)&&/ $/.test(Y);return I&&$&&(Y=Y.substring(1,Y.length-1)),Y=f(Y,!0),{type:"codespan",raw:ce[0],text:Y}}},Ie.br=function(se){var ce=this.rules.inline.br.exec(se);if(ce)return{type:"br",raw:ce[0]}},Ie.del=function(se){var ce=this.rules.inline.del.exec(se);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},Ie.autolink=function(se,ce){var Y=this.rules.inline.autolink.exec(se);if(Y){var I,$;return Y[2]==="@"?(I=f(this.options.mangle?ce(Y[1]):Y[1]),$="mailto:"+I):(I=f(Y[1]),$=I),{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},Ie.url=function(se,ce){var Y;if(Y=this.rules.inline.url.exec(se)){var I,$;if(Y[2]==="@")I=f(this.options.mangle?ce(Y[0]):Y[0]),$="mailto:"+I;else{var H;do H=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while(H!==Y[0]);I=f(Y[0]),Y[1]==="www."?$="http://"+I:$=I}return{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},Ie.inlineText=function(se,ce){var Y=this.rules.inline.text.exec(se);if(Y){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]):Y[0]:I=f(this.options.smartypants?ce(Y[0]):Y[0]),{type:"text",raw:Y[0],text:I}}},Te}(),A={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};A._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,A._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,A.def=v(A.def).replace("label",A._label).replace("title",A._title).getRegex(),A.bullet=/(?:[*+-]|\d{1,9}[.)])/,A.listItemStart=v(/^( *)(bull) */).replace("bull",A.bullet).getRegex(),A.list=v(A.list).replace(/bull/g,A.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+A.def.source+")").getRegex(),A._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",A._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,A.html=v(A.html,"i").replace("comment",A._comment).replace("tag",A._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),A.paragraph=v(A._paragraph).replace("hr",A.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",A._tag).getRegex(),A.blockquote=v(A.blockquote).replace("paragraph",A.paragraph).getRegex(),A.normal=n({},A),A.gfm=n({},A.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),A.gfm.table=v(A.gfm.table).replace("hr",A.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",A._tag).getRegex(),A.gfm.paragraph=v(A._paragraph).replace("hr",A.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",A.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",A._tag).getRegex(),A.pedantic=n({},A.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",A._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:v(A.normal._paragraph).replace("hr",A.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",A.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=v(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=v(A._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=v(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=v(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=v(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=v(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=v(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=v(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=v(O.reflink).replace("label",O._label).replace("ref",A._label).getRegex(),O.nolink=v(O.nolink).replace("ref",A._label).getRegex(),O.reflinkSearch=v(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=n({},O),O.pedantic=n({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=n({},O.normal,{escape:v(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=v(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=n({},O.gfm,{br:v(O.br).replace("{2,}","*").getRegex(),text:v(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Te){var Ie="",Se,se,ce=Te.length;for(Se=0;Se<ce;Se++)se=Te.charCodeAt(Se),Math.random()>.5&&(se="x"+se.toString(16)),Ie+="&#"+se+";";return Ie}var j=function(){function Te(Se){this.tokens=[],this.tokens.links=Object.create(null),this.options=Se||ee.defaults,this.options.tokenizer=this.options.tokenizer||new R,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:A.normal,inline:O.normal};this.options.pedantic?(se.block=A.pedantic,se.inline=O.pedantic):this.options.gfm&&(se.block=A.gfm,this.options.breaks?se.inline=O.breaks:se.inline=O.gfm),this.tokenizer.rules=se}Te.lex=function(se,ce){var Y=new Te(ce);return Y.lex(se)},Te.lexInline=function(se,ce){var Y=new Te(ce);return Y.inlineTokens(se)};var Ie=Te.prototype;return Ie.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},Ie.blockTokens=function(se,ce){var Y=this;ce===void 0&&(ce=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(de,we,ae){return we+"    ".repeat(ae.length)});for(var I,$,H,q;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(de){return(I=de.call({lexer:Y},se,ce))?(se=se.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.space(se)){se=se.substring(I.raw.length),I.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(I);continue}if(I=this.tokenizer.code(se)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(I=this.tokenizer.fences(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.heading(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.hr(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.blockquote(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.list(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.html(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.def(se)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.lheading(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(H=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var de=1/0,we=se.slice(1),ae=void 0;Y.options.extensions.startBlock.forEach(function(pe){ae=pe.call({lexer:this},we),typeof ae=="number"&&ae>=0&&(de=Math.min(de,ae))}),de<1/0&&de>=0&&(H=se.substring(0,de+1))}(),this.state.top&&(I=this.tokenizer.paragraph(H))){$=ce[ce.length-1],q&&$.type==="paragraph"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I),q=H.length!==se.length,se=se.substring(I.raw.length);continue}if(I=this.tokenizer.text(se)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&$.type==="text"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(se){var J="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,ce},Ie.inline=function(se,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:se,tokens:ce}),ce},Ie.inlineTokens=function(se,ce){var Y=this;ce===void 0&&(ce=[]);var I,$,H,q=se,J,de,we;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)ae.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,J.index)+"["+V("a",J[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,J.index)+"["+V("a",J[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,J.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(de||(we=""),de=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(I=ve.call({lexer:Y},se,ce))?(se=se.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.escape(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.tag(se)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.link(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.emStrong(se,q,we)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.codespan(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.br(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.del(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.autolink(se,z)){se=se.substring(I.raw.length),ce.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(se,z))){se=se.substring(I.raw.length),ce.push(I);continue}if(H=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,We=se.slice(1),He=void 0;Y.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},We),typeof He=="number"&&He>=0&&(ve=Math.min(ve,He))}),ve<1/0&&ve>=0&&(H=se.substring(0,ve+1))}(),I=this.tokenizer.inlineText(H,B)){se=se.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(we=I.raw.slice(-1)),de=!0,$=ce[ce.length-1],$&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(se){var pe="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return ce},i(Te,null,[{key:"rules",get:function(){return{block:A,inline:O}}}]),Te}(),K=function(){function Te(Se){this.options=Se||ee.defaults}var Ie=Te.prototype;return Ie.code=function(se,ce,Y){var I=(ce||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(se,I);$!=null&&$!==se&&(Y=!0,se=$)}return se=se.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+f(I,!0)+'">'+(Y?se:f(se,!0))+`</code></pre>
`:"<pre><code>"+(Y?se:f(se,!0))+`</code></pre>
`},Ie.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Ie.html=function(se){return se},Ie.heading=function(se,ce,Y,I){if(this.options.headerIds){var $=this.options.headerPrefix+I.slug(Y);return"<h"+ce+' id="'+$+'">'+se+"</h"+ce+`>
`}return"<h"+ce+">"+se+"</h"+ce+`>
`},Ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ie.list=function(se,ce,Y){var I=ce?"ol":"ul",$=ce&&Y!==1?' start="'+Y+'"':"";return"<"+I+$+`>
`+se+"</"+I+`>
`},Ie.listitem=function(se){return"<li>"+se+`</li>
`},Ie.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ie.paragraph=function(se){return"<p>"+se+`</p>
`},Ie.table=function(se,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ce+`</table>
`},Ie.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Ie.tablecell=function(se,ce){var Y=ce.header?"th":"td",I=ce.align?"<"+Y+' align="'+ce.align+'">':"<"+Y+">";return I+se+("</"+Y+`>
`)},Ie.strong=function(se){return"<strong>"+se+"</strong>"},Ie.em=function(se){return"<em>"+se+"</em>"},Ie.codespan=function(se){return"<code>"+se+"</code>"},Ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ie.del=function(se){return"<del>"+se+"</del>"},Ie.link=function(se,ce,Y){if(se=w(this.options.sanitize,this.options.baseUrl,se),se===null)return Y;var I='<a href="'+f(se)+'"';return ce&&(I+=' title="'+ce+'"'),I+=">"+Y+"</a>",I},Ie.image=function(se,ce,Y){if(se=w(this.options.sanitize,this.options.baseUrl,se),se===null)return Y;var I='<img src="'+se+'" alt="'+Y+'"';return ce&&(I+=' title="'+ce+'"'),I+=this.options.xhtml?"/>":">",I},Ie.text=function(se){return se},Te}(),ie=function(){function Te(){}var Ie=Te.prototype;return Ie.strong=function(se){return se},Ie.em=function(se){return se},Ie.codespan=function(se){return se},Ie.del=function(se){return se},Ie.html=function(se){return se},Ie.text=function(se){return se},Ie.link=function(se,ce,Y){return""+Y},Ie.image=function(se,ce,Y){return""+Y},Ie.br=function(){return""},Te}(),me=function(){function Te(){this.seen={}}var Ie=Te.prototype;return Ie.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ie.getNextSafeSlug=function(se,ce){var Y=se,I=0;if(this.seen.hasOwnProperty(Y)){I=this.seen[se];do I++,Y=se+"-"+I;while(this.seen.hasOwnProperty(Y))}return ce||(this.seen[se]=I,this.seen[Y]=0),Y},Ie.slug=function(se,ce){ce===void 0&&(ce={});var Y=this.serialize(se);return this.getNextSafeSlug(Y,ce.dryrun)},Te}(),ue=function(){function Te(Se){this.options=Se||ee.defaults,this.options.renderer=this.options.renderer||new K,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new me}Te.parse=function(se,ce){var Y=new Te(ce);return Y.parse(se)},Te.parseInline=function(se,ce){var Y=new Te(ce);return Y.parseInline(se)};var Ie=Te.prototype;return Ie.parse=function(se,ce){ce===void 0&&(ce=!0);var Y="",I,$,H,q,J,de,we,ae,pe,ve,We,He,tt,Xe,et,it,dt,Fe,st,Q=se.length;for(I=0;I<Q;I++){if(ve=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(st=this.options.extensions.renderers[ve.type].call({parser:this},ve),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){Y+=st||"";continue}switch(ve.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,a(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(ae="",we="",q=ve.header.length,$=0;$<q;$++)we+=this.renderer.tablecell(this.parseInline(ve.header[$].tokens),{header:!0,align:ve.align[$]});for(ae+=this.renderer.tablerow(we),pe="",q=ve.rows.length,$=0;$<q;$++){for(de=ve.rows[$],we="",J=de.length,H=0;H<J;H++)we+=this.renderer.tablecell(this.parseInline(de[H].tokens),{header:!1,align:ve.align[H]});pe+=this.renderer.tablerow(we)}Y+=this.renderer.table(ae,pe);continue}case"blockquote":{pe=this.parse(ve.tokens),Y+=this.renderer.blockquote(pe);continue}case"list":{for(We=ve.ordered,He=ve.start,tt=ve.loose,q=ve.items.length,pe="",$=0;$<q;$++)et=ve.items[$],it=et.checked,dt=et.task,Xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):Xe+=Fe),Xe+=this.parse(et.tokens,tt),pe+=this.renderer.listitem(Xe,dt,it);Y+=this.renderer.list(pe,We,He);continue}case"html":{Y+=this.renderer.html(ve.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(pe=ve.tokens?this.parseInline(ve.tokens):ve.text;I+1<Q&&se[I+1].type==="text";)ve=se[++I],pe+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);Y+=ce?this.renderer.paragraph(pe):pe;continue}default:{var X='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return Y},Ie.parseInline=function(se,ce){ce=ce||this.renderer;var Y="",I,$,H,q=se.length;for(I=0;I<q;I++){if($=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(H=this.options.extensions.renderers[$.type].call({parser:this},$),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){Y+=H||"";continue}switch($.type){case"escape":{Y+=ce.text($.text);break}case"html":{Y+=ce.html($.text);break}case"link":{Y+=ce.link($.href,$.title,this.parseInline($.tokens,ce));break}case"image":{Y+=ce.image($.href,$.title,$.text);break}case"strong":{Y+=ce.strong(this.parseInline($.tokens,ce));break}case"em":{Y+=ce.em(this.parseInline($.tokens,ce));break}case"codespan":{Y+=ce.codespan($.text);break}case"br":{Y+=ce.br();break}case"del":{Y+=ce.del(this.parseInline($.tokens,ce));break}case"text":{Y+=ce.text($.text);break}default:{var J='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return Y},Te}();function oe(Te,Ie,Se){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof Ie=="function"&&(Se=Ie,Ie=null),Ie=n({},oe.defaults,Ie||{}),M(Ie),Se){var se=Ie.highlight,ce;try{ce=j.lex(Te,Ie)}catch(q){return Se(q)}var Y=function(J){var de;if(!J)try{Ie.walkTokens&&oe.walkTokens(ce,Ie.walkTokens),de=ue.parse(ce,Ie)}catch(we){J=we}return Ie.highlight=se,J?Se(J):Se(null,de)};if(!se||se.length<3||(delete Ie.highlight,!ce.length))return Y();var I=0;oe.walkTokens(ce,function(q){q.type==="code"&&(I++,setTimeout(function(){se(q.text,q.lang,function(J,de){if(J)return Y(J);de!=null&&de!==q.text&&(q.text=de,q.escaped=!0),I--,I===0&&Y()})},0))}),I===0&&Y();return}function $(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+f(q.message+"",!0)+"</pre>";throw q}try{var H=j.lex(Te,Ie);if(Ie.walkTokens){if(Ie.async)return Promise.all(oe.walkTokens(H,Ie.walkTokens)).then(function(){return ue.parse(H,Ie)}).catch($);oe.walkTokens(H,Ie.walkTokens)}return ue.parse(H,Ie)}catch(q){$(q)}}oe.options=oe.setOptions=function(Te){return n(oe.defaults,Te),F(oe.defaults),oe},oe.getDefaults=C,oe.defaults=ee.defaults,oe.use=function(){for(var Te=arguments.length,Ie=new Array(Te),Se=0;Se<Te;Se++)Ie[Se]=arguments[Se];var se=n.apply(void 0,[{}].concat(Ie)),ce=oe.defaults.extensions||{renderers:{},childTokens:{}},Y;Ie.forEach(function(I){if(I.extensions&&(Y=!0,I.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var q=ce.renderers?ce.renderers[H.name]:null;q?ce.renderers[H.name]=function(){for(var J=arguments.length,de=new Array(J),we=0;we<J;we++)de[we]=arguments[we];var ae=H.renderer.apply(this,de);return ae===!1&&(ae=q.apply(this,de)),ae}:ce.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[H.level]?ce[H.level].unshift(H.tokenizer):ce[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ce.startBlock?ce.startBlock.push(H.start):ce.startBlock=[H.start]:H.level==="inline"&&(ce.startInline?ce.startInline.push(H.start):ce.startInline=[H.start]))}H.childTokens&&(ce.childTokens[H.name]=H.childTokens)})),I.renderer&&function(){var H=oe.defaults.renderer||new K,q=function(we){var ae=H[we];H[we]=function(){for(var pe=arguments.length,ve=new Array(pe),We=0;We<pe;We++)ve[We]=arguments[We];var He=I.renderer[we].apply(H,ve);return He===!1&&(He=ae.apply(H,ve)),He}};for(var J in I.renderer)q(J);se.renderer=H}(),I.tokenizer&&function(){var H=oe.defaults.tokenizer||new R,q=function(we){var ae=H[we];H[we]=function(){for(var pe=arguments.length,ve=new Array(pe),We=0;We<pe;We++)ve[We]=arguments[We];var He=I.tokenizer[we].apply(H,ve);return He===!1&&(He=ae.apply(H,ve)),He}};for(var J in I.tokenizer)q(J);se.tokenizer=H}(),I.walkTokens){var $=oe.defaults.walkTokens;se.walkTokens=function(H){var q=[];return q.push(I.walkTokens.call(this,H)),$&&(q=q.concat($.call(this,H))),q}}Y&&(se.extensions=ce),oe.setOptions(se)})},oe.walkTokens=function(Te,Ie){for(var Se=[],se=function(){var $=Y.value;switch(Se=Se.concat(Ie.call(oe,$)),$.type){case"table":{for(var H=L($.header),q;!(q=H()).done;){var J=q.value;Se=Se.concat(oe.walkTokens(J.tokens,Ie))}for(var de=L($.rows),we;!(we=de()).done;)for(var ae=we.value,pe=L(ae),ve;!(ve=pe()).done;){var We=ve.value;Se=Se.concat(oe.walkTokens(We.tokens,Ie))}break}case"list":{Se=Se.concat(oe.walkTokens($.items,Ie));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[$.type]?oe.defaults.extensions.childTokens[$.type].forEach(function(He){Se=Se.concat(oe.walkTokens($[He],Ie))}):$.tokens&&(Se=Se.concat(oe.walkTokens($.tokens,Ie)))}},ce=L(Te),Y;!(Y=ce()).done;)se();return Se},oe.parseInline=function(Te,Ie){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");Ie=n({},oe.defaults,Ie||{}),M(Ie);try{var Se=j.lexInline(Te,Ie);return Ie.walkTokens&&oe.walkTokens(Se,Ie.walkTokens),ue.parseInline(Se,Ie)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+f(se.message+"",!0)+"</pre>";throw se}},oe.Parser=ue,oe.parser=ue.parse,oe.Renderer=K,oe.TextRenderer=ie,oe.Lexer=j,oe.lexer=j.lex,oe.Tokenizer=R,oe.Slugger=me,oe.parse=oe;var De=oe.options,re=oe.setOptions,_=oe.use,le=oe.walkTokens,Ee=oe.parseInline,Ae=oe,Be=ue.parse,xe=j.lex;ee.Lexer=j,ee.Parser=ue,ee.Renderer=K,ee.Slugger=me,ee.TextRenderer=ie,ee.Tokenizer=R,ee.getDefaults=C,ee.lexer=xe,ee.marked=oe,ee.options=De,ee.parse=Ae,ee.parseInline=Ee,ee.parser=Be,ee.setOptions=re,ee.use=_,ee.walkTokens=le,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ce[111],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(F,S,k){return Math.min(Math.max(F,S),k)}e.clamp=i;function T(F,S){return(S+F%S)%S}e.rot=T;class y{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=y;class L{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=L;class C{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const k=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function ee(y){const L=[];typeof y=="number"&&L.push("code/timeOrigin",y);function C(S){L.push(S,Date.now())}function F(){const S=[];for(let k=0;k<L.length;k+=2)S.push({name:L[k],startTime:L[k+1]});return S}return{mark:C,getMarks:F}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const C of performance.getEntriesByType("mark"))L.push({name:C.name,startTime:Math.round(y+C.startTime)});return L}};if(typeof process=="object"){const y=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function i(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=i(T))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var T in i)(typeof exports=="object"?exports:ee)[T]=i[T]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function i(T){if(e[T])return e[T].exports;var y=e[T]={i:T,l:!1,exports:{}};return ee[T].call(y.exports,y,y.exports,i),y.l=!0,y.exports}return i.m=ee,i.c=e,i.d=function(T,y,L){i.o(T,y)||Object.defineProperty(T,y,{enumerable:!0,get:L})},i.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},i.t=function(T,y){if(1&y&&(T=i(T)),8&y||4&y&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(i.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&y&&typeof T!="string")for(var C in T)i.d(L,C,function(F){return T[F]}.bind(null,C));return L},i.n=function(T){var y=T&&T.__esModule?function(){return T.default}:function(){return T};return i.d(y,"a",y),y},i.o=function(T,y){return Object.prototype.hasOwnProperty.call(T,y)},i.p="",i(i.s=0)}([function(ee,e,i){(function(T){var y;e=ee.exports=_,y=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,F=e.re=[],S=e.src=[],k=0,N=k++;S[N]="0|[1-9]\\d*";var D=k++;S[D]="[0-9]+";var g=k++;S[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=k++;S[p]="("+S[N]+")\\.("+S[N]+")\\.("+S[N]+")";var f=k++;S[f]="("+S[D]+")\\.("+S[D]+")\\.("+S[D]+")";var t=k++;S[t]="(?:"+S[N]+"|"+S[g]+")";var a=k++;S[a]="(?:"+S[D]+"|"+S[g]+")";var l=k++;S[l]="(?:-("+S[t]+"(?:\\."+S[t]+")*))";var v=k++;S[v]="(?:-?("+S[a]+"(?:\\."+S[a]+")*))";var b=k++;S[b]="[0-9A-Za-z-]+";var E=k++;S[E]="(?:\\+("+S[b]+"(?:\\."+S[b]+")*))";var w=k++,r="v?"+S[p]+S[l]+"?"+S[E]+"?";S[w]="^"+r+"$";var o="[v=\\s]*"+S[f]+S[v]+"?"+S[E]+"?",s=k++;S[s]="^"+o+"$";var d=k++;S[d]="((?:<|>)?=?)";var c=k++;S[c]=S[D]+"|x|X|\\*";var u=k++;S[u]=S[N]+"|x|X|\\*";var n=k++;S[n]="[v=\\s]*("+S[u]+")(?:\\.("+S[u]+")(?:\\.("+S[u]+")(?:"+S[l]+")?"+S[E]+"?)?)?";var h=k++;S[h]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[v]+")?"+S[E]+"?)?)?";var m=k++;S[m]="^"+S[d]+"\\s*"+S[n]+"$";var P=k++;S[P]="^"+S[d]+"\\s*"+S[h]+"$";var M=k++;S[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=k++;S[V]="(?:~>?)";var Z=k++;S[Z]="(\\s*)"+S[V]+"\\s+",F[Z]=new RegExp(S[Z],"g");var G=k++;S[G]="^"+S[V]+S[n]+"$";var R=k++;S[R]="^"+S[V]+S[h]+"$";var A=k++;S[A]="(?:\\^)";var O=k++;S[O]="(\\s*)"+S[A]+"\\s+",F[O]=new RegExp(S[O],"g");var B=k++;S[B]="^"+S[A]+S[n]+"$";var z=k++;S[z]="^"+S[A]+S[h]+"$";var j=k++;S[j]="^"+S[d]+"\\s*("+o+")$|^$";var K=k++;S[K]="^"+S[d]+"\\s*("+r+")$|^$";var ie=k++;S[ie]="(\\s*)"+S[d]+"\\s*("+o+"|"+S[n]+")",F[ie]=new RegExp(S[ie],"g");var me=k++;S[me]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var ue=k++;S[ue]="^\\s*("+S[h]+")\\s+-\\s+("+S[h]+")\\s*$";var oe=k++;S[oe]="(<|>)?=?\\s*\\*";for(var De=0;De<35;De++)y(De,S[De]),F[De]||(F[De]=new RegExp(S[De]));function re(ae,pe){if(ae instanceof _)return ae;if(typeof ae!="string"||ae.length>L||!(pe?F[s]:F[w]).test(ae))return null;try{return new _(ae,pe)}catch{return null}}function _(ae,pe){if(ae instanceof _){if(ae.loose===pe)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof _))return new _(ae,pe);y("SemVer",ae,pe),this.loose=pe;var ve=ae.trim().match(pe?F[s]:F[w]);if(!ve)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var He=+We;if(He>=0&&He<C)return He}return We}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=re,e.valid=function(ae,pe){var ve=re(ae,pe);return ve?ve.version:null},e.clean=function(ae,pe){var ve=re(ae.trim().replace(/^[=v]+/,""),pe);return ve?ve.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(ae){return y("SemVer.compare",this.version,this.loose,ae),ae instanceof _||(ae=new _(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},_.prototype.compareMain=function(ae){return ae instanceof _||(ae=new _(ae,this.loose)),Ee(this.major,ae.major)||Ee(this.minor,ae.minor)||Ee(this.patch,ae.patch)},_.prototype.comparePre=function(ae){if(ae instanceof _||(ae=new _(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var pe=0;do{var ve=this.prerelease[pe],We=ae.prerelease[pe];if(y("prerelease compare",pe,ve,We),ve===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(ve===void 0)return-1;if(ve!==We)return Ee(ve,We)}while(++pe)},_.prototype.inc=function(ae,pe){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",pe),this.inc("pre",pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",pe),this.inc("pre",pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}pe&&(this.prerelease[0]===pe?isNaN(this.prerelease[1])&&(this.prerelease=[pe,0]):this.prerelease=[pe,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,pe,ve,We){typeof ve=="string"&&(We=ve,ve=void 0);try{return new _(ae,ve).inc(pe,We).version}catch{return null}},e.diff=function(ae,pe){if(Te(ae,pe))return null;var ve=re(ae),We=re(pe);if(ve.prerelease.length||We.prerelease.length){for(var He in ve)if((He==="major"||He==="minor"||He==="patch")&&ve[He]!==We[He])return"pre"+He;return"prerelease"}for(var He in ve)if((He==="major"||He==="minor"||He==="patch")&&ve[He]!==We[He])return He},e.compareIdentifiers=Ee;var le=/^[0-9]+$/;function Ee(ae,pe){var ve=le.test(ae),We=le.test(pe);return ve&&We&&(ae=+ae,pe=+pe),ve&&!We?-1:We&&!ve?1:ae<pe?-1:ae>pe?1:0}function Ae(ae,pe,ve){return new _(ae,ve).compare(new _(pe,ve))}function Be(ae,pe,ve){return Ae(ae,pe,ve)>0}function xe(ae,pe,ve){return Ae(ae,pe,ve)<0}function Te(ae,pe,ve){return Ae(ae,pe,ve)===0}function Ie(ae,pe,ve){return Ae(ae,pe,ve)!==0}function Se(ae,pe,ve){return Ae(ae,pe,ve)>=0}function se(ae,pe,ve){return Ae(ae,pe,ve)<=0}function ce(ae,pe,ve,We){var He;switch(pe){case"===":typeof ae=="object"&&(ae=ae.version),typeof ve=="object"&&(ve=ve.version),He=ae===ve;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof ve=="object"&&(ve=ve.version),He=ae!==ve;break;case"":case"=":case"==":He=Te(ae,ve,We);break;case"!=":He=Ie(ae,ve,We);break;case">":He=Be(ae,ve,We);break;case">=":He=Se(ae,ve,We);break;case"<":He=xe(ae,ve,We);break;case"<=":He=se(ae,ve,We);break;default:throw new TypeError("Invalid operator: "+pe)}return He}function Y(ae,pe){if(ae instanceof Y){if(ae.loose===pe)return ae;ae=ae.value}if(!(this instanceof Y))return new Y(ae,pe);y("comparator",ae,pe),this.loose=pe,this.parse(ae),this.semver===I?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(ae,pe){return Ee(pe,ae)},e.major=function(ae,pe){return new _(ae,pe).major},e.minor=function(ae,pe){return new _(ae,pe).minor},e.patch=function(ae,pe){return new _(ae,pe).patch},e.compare=Ae,e.compareLoose=function(ae,pe){return Ae(ae,pe,!0)},e.rcompare=function(ae,pe,ve){return Ae(pe,ae,ve)},e.sort=function(ae,pe){return ae.sort(function(ve,We){return e.compare(ve,We,pe)})},e.rsort=function(ae,pe){return ae.sort(function(ve,We){return e.rcompare(ve,We,pe)})},e.gt=Be,e.lt=xe,e.eq=Te,e.neq=Ie,e.gte=Se,e.lte=se,e.cmp=ce,e.Comparator=Y;var I={};function $(ae,pe){if(ae instanceof $)return ae.loose===pe?ae:new $(ae.raw,pe);if(ae instanceof Y)return new $(ae.value,pe);if(!(this instanceof $))return new $(ae,pe);if(this.loose=pe,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function H(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function q(ae,pe,ve,We,He,tt,Xe,et,it,dt,Fe,st,Q){return((pe=H(ve)?"":H(We)?">="+ve+".0.0":H(He)?">="+ve+"."+We+".0":">="+pe)+" "+(et=H(it)?"":H(dt)?"<"+(+it+1)+".0.0":H(Fe)?"<"+it+"."+(+dt+1)+".0":st?"<="+it+"."+dt+"."+Fe+"-"+st:"<="+et)).trim()}function J(ae,pe){for(var ve=0;ve<ae.length;ve++)if(!ae[ve].test(pe))return!1;if(pe.prerelease.length){for(ve=0;ve<ae.length;ve++)if(y(ae[ve].semver),ae[ve].semver!==I&&ae[ve].semver.prerelease.length>0){var We=ae[ve].semver;if(We.major===pe.major&&We.minor===pe.minor&&We.patch===pe.patch)return!0}return!1}return!0}function de(ae,pe,ve){try{pe=new $(pe,ve)}catch{return!1}return pe.test(ae)}function we(ae,pe,ve,We){var He,tt,Xe,et,it;switch(ae=new _(ae,We),pe=new $(pe,We),ve){case">":He=Be,tt=se,Xe=xe,et=">",it=">=";break;case"<":He=xe,tt=Se,Xe=Be,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(de(ae,pe,We))return!1;for(var dt=0;dt<pe.set.length;++dt){var Fe=pe.set[dt],st=null,Q=null;if(Fe.forEach(function(X){X.semver===I&&(X=new Y(">=0.0.0")),st=st||X,Q=Q||X,He(X.semver,st.semver,We)?st=X:Xe(X.semver,Q.semver,We)&&(Q=X)}),st.operator===et||st.operator===it||(!Q.operator||Q.operator===et)&&tt(ae,Q.semver)||Q.operator===it&&Xe(ae,Q.semver))return!1}return!0}Y.prototype.parse=function(ae){var pe=this.loose?F[j]:F[K],ve=ae.match(pe);if(!ve)throw new TypeError("Invalid comparator: "+ae);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new _(ve[2],this.loose):this.semver=I},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(ae){return y("Comparator.test",ae,this.loose),this.semver===I||(typeof ae=="string"&&(ae=new _(ae,this.loose)),ce(ae,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(ae,pe){if(!(ae instanceof Y))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new $(ae.value,pe),de(this.value,ve,pe);if(ae.operator==="")return ve=new $(this.value,pe),de(ae.semver,ve,pe);var We=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),tt=this.semver.version===ae.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),et=ce(this.semver,"<",ae.semver,pe)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),it=ce(this.semver,">",ae.semver,pe)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return We||He||tt&&Xe||et||it},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(ae){var pe=this.loose;ae=ae.trim(),y("range",ae,pe);var ve=pe?F[ue]:F[me];ae=ae.replace(ve,q),y("hyphen replace",ae),ae=ae.replace(F[ie],"$1$2$3"),y("comparator trim",ae,F[ie]),ae=(ae=(ae=ae.replace(F[Z],"$1~")).replace(F[O],"$1^")).split(/\s+/).join(" ");var We=pe?F[j]:F[K],He=ae.split(" ").map(function(tt){return function(Xe,et){return y("comp",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,Q){y("caret",st,Q);var X=Q?F[z]:F[B];return st.replace(X,function(ge,Me,$e,Ve,Qe){var nt;return y("caret",st,ge,Me,$e,Ve,Qe),H(Me)?nt="":H($e)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":H(Ve)?nt=Me==="0"?">="+Me+"."+$e+".0 <"+Me+"."+(+$e+1)+".0":">="+Me+"."+$e+".0 <"+(+Me+1)+".0.0":Qe?(y("replaceCaret pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),nt=Me==="0"?$e==="0"?">="+Me+"."+$e+"."+Ve+Qe+" <"+Me+"."+$e+"."+(+Ve+1):">="+Me+"."+$e+"."+Ve+Qe+" <"+Me+"."+(+$e+1)+".0":">="+Me+"."+$e+"."+Ve+Qe+" <"+(+Me+1)+".0.0"):(y("no pr"),nt=Me==="0"?$e==="0"?">="+Me+"."+$e+"."+Ve+" <"+Me+"."+$e+"."+(+Ve+1):">="+Me+"."+$e+"."+Ve+" <"+Me+"."+(+$e+1)+".0":">="+Me+"."+$e+"."+Ve+" <"+(+Me+1)+".0.0"),y("caret return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),y("caret",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,Q){var X=Q?F[R]:F[G];return st.replace(X,function(ge,Me,$e,Ve,Qe){var nt;return y("tilde",st,ge,Me,$e,Ve,Qe),H(Me)?nt="":H($e)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":H(Ve)?nt=">="+Me+"."+$e+".0 <"+Me+"."+(+$e+1)+".0":Qe?(y("replaceTilde pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),nt=">="+Me+"."+$e+"."+Ve+Qe+" <"+Me+"."+(+$e+1)+".0"):nt=">="+Me+"."+$e+"."+Ve+" <"+Me+"."+(+$e+1)+".0",y("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),y("tildes",Xe),Xe=function(it,dt){return y("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(st,Q){st=st.trim();var X=Q?F[P]:F[m];return st.replace(X,function(ge,Me,$e,Ve,Qe,nt){y("xRange",st,ge,Me,$e,Ve,Qe,nt);var wt=H($e),St=wt||H(Ve),Ct=St||H(Qe);return Me==="="&&Ct&&(Me=""),wt?ge=Me===">"||Me==="<"?"<0.0.0":"*":Me&&Ct?(St&&(Ve=0),Ct&&(Qe=0),Me===">"?(Me=">=",St?($e=+$e+1,Ve=0,Qe=0):Ct&&(Ve=+Ve+1,Qe=0)):Me==="<="&&(Me="<",St?$e=+$e+1:Ve=+Ve+1),ge=Me+$e+"."+Ve+"."+Qe):St?ge=">="+$e+".0.0 <"+(+$e+1)+".0.0":Ct&&(ge=">="+$e+"."+Ve+".0 <"+$e+"."+(+Ve+1)+".0"),y("xRange return",ge),ge})}(Fe,dt)}).join(" ")}(Xe,et),y("xrange",Xe),Xe=function(it,dt){return y("replaceStars",it,dt),it.trim().replace(F[oe],"")}(Xe,et),y("stars",Xe),Xe}(tt,pe)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match(We)})),He=He.map(function(tt){return new Y(tt,pe)})},$.prototype.intersects=function(ae,pe){if(!(ae instanceof $))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(We){return ae.set.some(function(He){return He.every(function(tt){return We.intersects(tt,pe)})})})})},e.toComparators=function(ae,pe){return new $(ae,pe).set.map(function(ve){return ve.map(function(We){return We.value}).join(" ").trim().split(" ")})},$.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new _(ae,this.loose));for(var pe=0;pe<this.set.length;pe++)if(J(this.set[pe],ae))return!0;return!1},e.satisfies=de,e.maxSatisfying=function(ae,pe,ve){var We=null,He=null;try{var tt=new $(pe,ve)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==-1||(He=new _(We=Xe,ve)))}),We},e.minSatisfying=function(ae,pe,ve){var We=null,He=null;try{var tt=new $(pe,ve)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==1||(He=new _(We=Xe,ve)))}),We},e.validRange=function(ae,pe){try{return new $(ae,pe).range||"*"}catch{return null}},e.ltr=function(ae,pe,ve){return we(ae,pe,"<",ve)},e.gtr=function(ae,pe,ve){return we(ae,pe,">",ve)},e.outside=we,e.prerelease=function(ae,pe){var ve=re(ae,pe);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(ae,pe,ve){return ae=new $(ae,ve),pe=new $(pe,ve),ae.intersects(pe)},e.coerce=function(ae){if(ae instanceof _)return ae;if(typeof ae!="string")return null;var pe=ae.match(F[M]);return pe==null?null:re((pe[1]||"0")+"."+(pe[2]||"0")+"."+(pe[3]||"0"))}}).call(this,i(1))},function(ee,e){var i,T,y=ee.exports={};function L(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function F(a){if(i===setTimeout)return setTimeout(a,0);if((i===L||!i)&&setTimeout)return i=setTimeout,setTimeout(a,0);try{return i(a,0)}catch{try{return i.call(null,a,0)}catch{return i.call(this,a,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:L}catch{i=L}try{T=typeof clearTimeout=="function"?clearTimeout:C}catch{T=C}})();var S,k=[],N=!1,D=-1;function g(){N&&S&&(N=!1,S.length?k=S.concat(k):D=-1,k.length&&p())}function p(){if(!N){var a=F(g);N=!0;for(var l=k.length;l;){for(S=k,k=[];++D<l;)S&&S[D].run();D=-1,l=k.length}S=null,N=!1,function(v){if(T===clearTimeout)return clearTimeout(v);if((T===C||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(v);try{T(v)}catch{try{return T.call(null,v)}catch{return T.call(this,v)}}}(a)}}function f(a,l){this.fun=a,this.array=l}function t(){}y.nextTick=function(a){var l=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)l[v-1]=arguments[v];k.push(new f(a,l)),k.length!==1||N||F(p)},f.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=t,y.addListener=t,y.once=t,y.off=t,y.removeListener=t,y.removeAllListeners=t,y.emit=t,y.prependListener=t,y.prependOnceListener=t,y.listeners=function(a){return[]},y.binding=function(a){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(a){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Ce[112],ke([1,0,11,7]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(E){const w=E;return w?typeof w.read=="function":!1}e.isReadable=y;function L(E){const w=E;return w?[w.on,w.pause,w.resume,w.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=L;function C(E){const w=E;return w?L(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=C;function F(E,w){return new S(E,w)}e.newWriteableStream=F;class S{constructor(w,r){this.e=w,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(r=>r(w))}h(w){this.c.error.length===0?(0,i.onUnexpectedError)(w):this.c.error.slice(0).forEach(r=>r(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,r){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(w,r){if(this.a.destroyed)return;let o;switch(w){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(r);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(E,w){const r=[];let o;for(;(o=E.read())!==null;)r.push(o);return w(r)}e.consumeReadable=k;function N(E,w,r){const o=[];let s;for(;(s=E.read())!==null&&o.length<r;)o.push(s);return s===null&&o.length>0?w(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const d=s;return s=void 0,d}return E.read()}}}e.peekReadable=N;function D(E,w){return new Promise((r,o)=>{const s=[];g(E,{onData:d=>{w&&s.push(d)},onError:d=>{w?o(d):r(void 0)},onEnd:()=>{r(w?w(s):void 0)}})})}e.consumeStream=D;function g(E,w){let r=!1;return E.on("error",o=>{r||w.onError(o)}),E.on("end",()=>{r||w.onEnd()}),E.on("data",o=>{r||w.onData(o)}),(0,T.toDisposable)(()=>r=!0)}e.listenStream=g;function p(E,w){return new Promise((r,o)=>{const s=new T.DisposableStore,d=[],c=h=>{if(d.push(h),d.length>w)return s.dispose(),E.pause(),r({stream:E,buffer:d,ended:!1})},u=h=>o(h),n=()=>r({stream:E,buffer:d,ended:!0});s.add((0,T.toDisposable)(()=>E.removeListener("error",u))),E.on("error",u),s.add((0,T.toDisposable)(()=>E.removeListener("end",n))),E.on("end",n),s.add((0,T.toDisposable)(()=>E.removeListener("data",c))),E.on("data",c)})}e.peekStream=p;function f(E,w){const r=F(w);return r.end(E),r}e.toStream=f;function t(){const E=F(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=t;function a(E){let w=!1;return{read:()=>w?null:(w=!0,E)}}e.toReadable=a;function l(E,w,r){const o=F(r);return g(E,{onData:s=>o.write(w.data(s)),onError:s=>o.error(w.error?w.error(s):s),onEnd:()=>o.end()}),o}e.transform=l;function v(E,w,r){let o=!1;return{read:()=>{const s=w.read();return o?s:(o=!0,s!==null?r([E,s]):E)}}}e.prefixedReadable=v;function b(E,w,r){let o=!1;const s=F(r);return g(w,{onData:d=>o?s.write(d):(o=!0,s.write(r([E,d]))),onError:d=>s.error(d),onEnd:()=>{o||(o=!0,s.write(E)),s.end()}}),s}e.prefixedStream=b}),define(Ce[24],ke([1,0,112]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let y,L;class C{static alloc(h){return T?new C(Buffer.allocUnsafe(h)):new C(new Uint8Array(h))}static wrap(h){return T&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new C(h)}static fromString(h,m){return!(m?.dontUseNodeBuffer||!1)&&T?new C(Buffer.from(h)):(y||(y=new TextEncoder),new C(y.encode(h)))}static fromByteArray(h){const m=C.alloc(h.length);for(let P=0,M=h.length;P<M;P++)m.buffer[P]=h[P];return m}static concat(h,m){if(typeof m>"u"){m=0;for(let V=0,Z=h.length;V<Z;V++)m+=h[V].byteLength}const P=C.alloc(m);let M=0;for(let V=0,Z=h.length;V<Z;V++){const G=h[V];P.set(G,M),M+=G.byteLength}return P}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=C.alloc(this.byteLength);return h.set(this),h}toString(){return T?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(h,m){return new C(this.buffer.subarray(h,m))}set(h,m){if(h instanceof C)this.buffer.set(h.buffer,m);else if(h instanceof Uint8Array)this.buffer.set(h,m);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),m);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return k(this.buffer,h)}writeUInt32BE(h,m){N(this.buffer,h,m)}readUInt32LE(h){return D(this.buffer,h)}writeUInt32LE(h,m){g(this.buffer,h,m)}readUInt8(h){return p(this.buffer,h)}writeUInt8(h,m){f(this.buffer,h,m)}}e.VSBuffer=C;function F(n,h){return n[h+0]<<0>>>0|n[h+1]<<8>>>0}e.readUInt16LE=F;function S(n,h,m){n[m+0]=h&255,h=h>>>8,n[m+1]=h&255}e.writeUInt16LE=S;function k(n,h){return n[h]*2**24+n[h+1]*2**16+n[h+2]*2**8+n[h+3]}e.readUInt32BE=k;function N(n,h,m){n[m+3]=h,h=h>>>8,n[m+2]=h,h=h>>>8,n[m+1]=h,h=h>>>8,n[m]=h}e.writeUInt32BE=N;function D(n,h){return n[h+0]<<0>>>0|n[h+1]<<8>>>0|n[h+2]<<16>>>0|n[h+3]<<24>>>0}e.readUInt32LE=D;function g(n,h,m){n[m+0]=h&255,h=h>>>8,n[m+1]=h&255,h=h>>>8,n[m+2]=h&255,h=h>>>8,n[m+3]=h&255}e.writeUInt32LE=g;function p(n,h){return n[h]}e.readUInt8=p;function f(n,h,m){n[m]=h}e.writeUInt8=f;function t(n){return i.consumeReadable(n,h=>C.concat(h))}e.readableToBuffer=t;function a(n){return i.toReadable(n)}e.bufferToReadable=a;function l(n){return i.consumeStream(n,h=>C.concat(h))}e.streamToBuffer=l;async function v(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await l(n.stream)])}e.bufferedStreamToBuffer=v;function b(n){return i.toStream(n,h=>C.concat(h))}e.bufferToStream=b;function E(n){return i.transform(n,{data:h=>typeof h=="string"?C.fromString(h):C.wrap(h)},h=>C.concat(h))}e.streamToBufferReadableStream=E;function w(n){return i.newWriteableStream(h=>C.concat(h),n)}e.newWriteableBufferStream=w;function r(n,h){return i.prefixedReadable(n,h,m=>C.concat(m))}e.prefixedBufferReadable=r;function o(n,h){return i.prefixedStream(n,h,m=>C.concat(m))}e.prefixedBufferStream=o;function s(n){let h=0,m=0,P=0;const M=new Uint8Array(Math.floor(n.length/4*3)),V=G=>{switch(m){case 3:M[P++]=h|G,m=0;break;case 2:M[P++]=h|G>>>2,h=G<<6,m=3;break;case 1:M[P++]=h|G>>>4,h=G<<4,m=2;break;default:h=G<<2,m=1}};for(let G=0;G<n.length;G++){const R=n.charCodeAt(G);if(R>=65&&R<=90)V(R-65);else if(R>=97&&R<=122)V(R-97+26);else if(R>=48&&R<=57)V(R-48+52);else if(R===43||R===45)V(62);else if(R===47||R===95)V(63);else{if(R===61)break;throw new SyntaxError(`Unexpected base64 character ${n[G]}`)}}const Z=P;for(;m>0;)V(0);return C.wrap(M).slice(0,Z)}e.decodeBase64=s;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:n},h=!0,m=!1){const P=m?c:d;let M="";const V=n.byteLength%3;let Z=0;for(;Z<n.byteLength-V;Z+=3){const G=n[Z+0],R=n[Z+1],A=n[Z+2];M+=P[G>>>2],M+=P[(G<<4|R>>>4)&63],M+=P[(R<<2|A>>>6)&63],M+=P[A&63]}if(V===1){const G=n[Z+0];M+=P[G>>>2],M+=P[G<<4&63],h&&(M+="==")}else if(V===2){const G=n[Z+0],R=n[Z+1];M+=P[G>>>2],M+=P[(G<<4|R>>>4)&63],M+=P[R<<2&63],h&&(M+="=")}return M}e.encodeBase64=u}),define(Ce[34],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(y){return i.test(y)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(F){for(let S=0;S<F.length;S++)F[S]=Math.floor(Math.random()*256);return F};const L=new Uint8Array(16),C=[];for(let F=0;F<256;F++)C.push(F.toString(16).padStart(2,"0"));return function(){y(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,k="";return k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k}}()}),define(Ce[113],ke([1,0,16,34]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function y(F){return{id:(0,T.generateUuid)(),asString:async()=>F,asFile:()=>{},value:typeof F=="string"?F:void 0}}e.createStringDataTransferItem=y;function L(F,S,k){return{id:(0,T.generateUuid)(),asString:async()=>"",asFile:()=>({name:F,uri:S,data:k}),value:void 0}}e.createFileDataTransferItem=L;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,k){const N=this.a.get(S);N?N.push(k):this.a.set(this.b(S),[k])}replace(S,k){this.a.set(this.b(S),[k])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,k]of this.a.entries())for(const N of k)yield[S,N]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[k,N]of this.entries())S(N,k)}b(S){return S.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:F=>(0,i.distinct)(F.map(S=>S.toString())).join(`\r
`),split:F=>F.split(`\r
`),parse:F=>e.UriList.split(F).filter(S=>!S.startsWith("#"))})}),define(Ce[114],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[115],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class T{constructor(F){if(this.e=null,this.f=!1,this.open=F.open,this.close=F.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(F.notIn))for(let S=0,k=F.notIn.length;S<k;S++)switch(F.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(F){switch(F){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(F,S){if(F.getTokenCount()===0)return!0;const k=F.findTokenIndexAtOffset(S-2),N=F.getStandardTokenType(k);return this.isOK(N)}g(F,S){for(let k=F;k<=S;k++){const N=String.fromCharCode(k);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=T;class y{constructor(F){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of F)L(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),L(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),L(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),L(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&L(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=y;function L(C,F,S){C.has(F)?C.get(F).push(S):C.set(F,[S])}}),define(Ce[116],ke([17,18]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ce[117],ke([1,0,116]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,y=T*60,L=y*24,C=L*7,F=L*30,S=L*365;function k(D,g,p){typeof D!="number"&&(D=D.getTime());const f=Math.round((new Date().getTime()-D)/1e3);if(f<-30)return(0,i.localize)(0,null,k(new Date().getTime()+f*1e3,!1));if(f<30)return(0,i.localize)(1,null);let t;return f<T?(t=f,g?t===1?p?(0,i.localize)(2,null,t):(0,i.localize)(3,null,t):p?(0,i.localize)(4,null,t):(0,i.localize)(5,null,t):t===1?p?(0,i.localize)(6,null,t):(0,i.localize)(7,null,t):p?(0,i.localize)(8,null,t):(0,i.localize)(9,null,t)):f<y?(t=Math.floor(f/T),g?t===1?p?(0,i.localize)(10,null,t):(0,i.localize)(11,null,t):p?(0,i.localize)(12,null,t):(0,i.localize)(13,null,t):t===1?p?(0,i.localize)(14,null,t):(0,i.localize)(15,null,t):p?(0,i.localize)(16,null,t):(0,i.localize)(17,null,t)):f<L?(t=Math.floor(f/y),g?t===1?p?(0,i.localize)(18,null,t):(0,i.localize)(19,null,t):p?(0,i.localize)(20,null,t):(0,i.localize)(21,null,t):t===1?p?(0,i.localize)(22,null,t):(0,i.localize)(23,null,t):p?(0,i.localize)(24,null,t):(0,i.localize)(25,null,t)):f<C?(t=Math.floor(f/L),g?t===1?(0,i.localize)(26,null,t):(0,i.localize)(27,null,t):t===1?(0,i.localize)(28,null,t):(0,i.localize)(29,null,t)):f<F?(t=Math.floor(f/C),g?t===1?p?(0,i.localize)(30,null,t):(0,i.localize)(31,null,t):p?(0,i.localize)(32,null,t):(0,i.localize)(33,null,t):t===1?p?(0,i.localize)(34,null,t):(0,i.localize)(35,null,t):p?(0,i.localize)(36,null,t):(0,i.localize)(37,null,t)):f<S?(t=Math.floor(f/F),g?t===1?p?(0,i.localize)(38,null,t):(0,i.localize)(39,null,t):p?(0,i.localize)(40,null,t):(0,i.localize)(41,null,t):t===1?p?(0,i.localize)(42,null,t):(0,i.localize)(43,null,t):p?(0,i.localize)(44,null,t):(0,i.localize)(45,null,t)):(t=Math.floor(f/S),g?t===1?p?(0,i.localize)(46,null,t):(0,i.localize)(47,null,t):p?(0,i.localize)(48,null,t):(0,i.localize)(49,null,t):t===1?p?(0,i.localize)(50,null,t):(0,i.localize)(51,null,t):p?(0,i.localize)(52,null,t):(0,i.localize)(53,null,t))}e.fromNow=k;function N(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(Ce[118],ke([17,18]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ce[45],ke([1,0,16,9,118]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(D,g){return g&&(D.stack||D.stacktrace)?y.localize(0,null,F(D),C(D.stack)||C(D.stacktrace)):F(D)}function C(D){return Array.isArray(D)?D.join(`
`):D}function F(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?y.localize(1,null,D.message):D.message||y.localize(2,null)}function S(D=null,g=!1){if(!D)return y.localize(3,null);if(Array.isArray(D)){const p=i.coalesce(D),f=S(p[0],g);return p.length>1?y.localize(4,null,f,p.length):f}if(T.isString(D))return D;if(D.detail){const p=D.detail;if(p.error)return L(p.error,g);if(p.exception)return L(p.exception,g)}return D.stack?L(D,g):D.message?D.message:y.localize(5,null)}e.toErrorMessage=S;function k(D){const g=D;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=k;function N(D,g){let p;return typeof D=="string"?p=new Error(D):p=D,p.actions=g,p}e.createErrorWithActions=N}),define(Ce[62],ke([1,0,19]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(N){const D=(0,i.extname)(N),g=T[D.toLowerCase()];return g!==void 0?g:C(N)}e.getMediaOrTextMime=L;function C(N){const D=(0,i.extname)(N);return y[D.toLowerCase()]}e.getMediaMime=C;function F(N){for(const D in y)if(y[D]===N)return D}e.getExtensionForMimeType=F;const S=/^(.+)\/(.+?)(;.+)?$/;function k(N,D){const g=S.exec(N);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:D?void 0:N}e.normalizeMimeType=k}),define(Ce[39],ke([1,0,19,21,10,9]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(c){return c===47||c===92}e.isPathSeparator=C;function F(c){return c.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=F;function S(c){return c.indexOf("/")===-1&&(c=F(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=S;function k(c,u=i.posix.sep){if(!c)return"";const n=c.length,h=c.charCodeAt(0);if(C(h)){if(C(c.charCodeAt(1))&&!C(c.charCodeAt(2))){let P=3;const M=P;for(;P<n&&!C(c.charCodeAt(P));P++);if(M!==P&&!C(c.charCodeAt(P+1))){for(P+=1;P<n;P++)if(C(c.charCodeAt(P)))return c.slice(0,P+1).replace(/[\\/]/g,u)}}return u}else if(l(h)&&c.charCodeAt(1)===58)return C(c.charCodeAt(2))?c.slice(0,2)+u:c.slice(0,2);let m=c.indexOf("://");if(m!==-1){for(m+=3;m<n;m++)if(C(c.charCodeAt(m)))return c.slice(0,m+1)}return""}e.getRoot=k;function N(c){if(!T.isWindows||!c||c.length<5)return!1;let u=c.charCodeAt(0);if(u!==92||(u=c.charCodeAt(1),u!==92))return!1;let n=2;const h=n;for(;n<c.length&&(u=c.charCodeAt(n),u!==92);n++);return!(h===n||(u=c.charCodeAt(n+1),isNaN(u)||u===92))}e.isUNC=N;const D=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(c,u=T.isWindows){const n=u?D:g;return!(!c||c.length===0||/^\s+$/.test(c)||(n.lastIndex=0,n.test(c))||u&&p.test(c)||c==="."||c===".."||u&&c[c.length-1]==="."||u&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=f;function t(c,u,n){const h=c===u;return!n||h?h:!c||!u?!1:(0,y.equalsIgnoreCase)(c,u)}e.isEqual=t;function a(c,u,n,h=i.sep){if(c===u)return!0;if(!c||!u||u.length>c.length)return!1;if(n){if(!(0,y.startsWithIgnoreCase)(c,u))return!1;if(u.length===c.length)return!0;let P=u.length;return u.charAt(u.length-1)===h&&P--,c.charAt(P)===h}return u.charAt(u.length-1)!==h&&(u+=h),c.indexOf(u)===0}e.isEqualOrParent=a;function l(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=l;function v(c,u){return T.isWindows&&c.endsWith(":")&&(c+=i.sep),(0,i.isAbsolute)(c)||(c=(0,i.join)(u,c)),c=(0,i.normalize)(c),T.isWindows?(c=(0,y.rtrim)(c,i.sep),c.endsWith(":")&&(c+=i.sep)):(c=(0,y.rtrim)(c,i.sep),c||(c=i.sep)),c}e.sanitizeFilePath=v;function b(c){const u=(0,i.normalize)(c);return T.isWindows?c.length>3?!1:E(u)&&(c.length===2||u.charCodeAt(2)===92):u===i.posix.sep}e.isRootOrDriveLetter=b;function E(c,u=T.isWindows){return u?l(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function w(c){return E(c)?c[0]:void 0}e.getDriveLetter=w;function r(c,u,n){return u.length>c.length?-1:c===u?0:(n&&(c=c.toLowerCase(),u=u.toLowerCase()),c.indexOf(u))}e.indexOfPath=r;function o(c){const u=c.split(":");let n,h,m;for(const P of u){const M=Number(P);(0,L.isNumber)(M)?h===void 0?h=M:m===void 0&&(m=M):n=n?[n,P].join(":"):P}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:h!==void 0?h:void 0,column:m!==void 0?m:h!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function d(c,u,n=8){let h="";for(let P=0;P<n;P++)h+=s.charAt(Math.floor(Math.random()*s.length));let m;return u?m=`${u}-${h}`:m=h,c?(0,i.join)(c,m):m}e.randomPath=d}),define(Ce[119],ke([1,0,28,10]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Y){return function(I,$){for(let H=0,q=Y.length;H<q;H++){const J=Y[H](I,$);if(J)return J}return null}}e.or=y,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(Y,I,$){if(!$||$.length<I.length)return null;let H;return Y?H=T.startsWithIgnoreCase($,I):H=$.indexOf(I)===0,H?I.length>0?[{start:0,end:I.length}]:[]:null}function C(Y,I){const $=I.toLowerCase().indexOf(Y.toLowerCase());return $===-1?null:[{start:$,end:$+Y.length}]}e.matchesContiguousSubString=C;function F(Y,I){return S(Y.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=F;function S(Y,I,$,H){if($===Y.length)return[];if(H===I.length)return null;if(Y[$]===I[H]){let q=null;return(q=S(Y,I,$+1,H+1))?l({start:H,end:H+1},q):null}return S(Y,I,$,H+1)}function k(Y){return 97<=Y&&Y<=122}function N(Y){return 65<=Y&&Y<=90}e.isUpper=N;function D(Y){return 48<=Y&&Y<=57}function g(Y){return Y===32||Y===9||Y===10||Y===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Y=>p.add(Y.charCodeAt(0)));function f(Y){return g(Y)||p.has(Y)}function t(Y,I){return Y===I||f(Y)&&f(I)}function a(Y){return k(Y)||N(Y)||D(Y)}function l(Y,I){return I.length===0?I=[Y]:Y.end===I[0].start?I[0].start=Y.start:I.unshift(Y),I}function v(Y,I){for(let $=I;$<Y.length;$++){const H=Y.charCodeAt($);if(N(H)||D(H)||$>0&&!a(Y.charCodeAt($-1)))return $}return Y.length}function b(Y,I,$,H){if($===Y.length)return[];if(H===I.length)return null;if(Y[$]!==I[H].toLowerCase())return null;{let q=null,J=H+1;for(q=b(Y,I,$+1,H+1);!q&&(J=v(I,J))<I.length;)q=b(Y,I,$+1,J),J++;return q===null?null:l({start:H,end:H+1},q)}}function E(Y){let I=0,$=0,H=0,q=0,J=0;for(let ve=0;ve<Y.length;ve++)J=Y.charCodeAt(ve),N(J)&&I++,k(J)&&$++,a(J)&&H++,D(J)&&q++;const de=I/Y.length,we=$/Y.length,ae=H/Y.length,pe=q/Y.length;return{upperPercent:de,lowerPercent:we,alphaPercent:ae,numericPercent:pe}}function w(Y){const{upperPercent:I,lowerPercent:$}=Y;return $===0&&I>.6}function r(Y){const{upperPercent:I,lowerPercent:$,alphaPercent:H,numericPercent:q}=Y;return $>.2&&I<.8&&H>.6&&q<.2}function o(Y){let I=0,$=0,H=0,q=0;for(let J=0;J<Y.length;J++)H=Y.charCodeAt(J),N(H)&&I++,k(H)&&$++,g(H)&&q++;return(I===0||$===0)&&q===0?Y.length<=30:I<=5}function s(Y,I){if(!I||(I=I.trim(),I.length===0)||!o(Y)||I.length>60)return null;const $=E(I);if(!r($)){if(!w($))return null;I=I.toLowerCase()}let H=null,q=0;for(Y=Y.toLowerCase();q<I.length&&(H=b(Y,I,0,q))===null;)q=v(I,q+1);return H}e.matchesCamelCase=s;function d(Y,I,$=!1){if(!I||I.length===0)return null;let H=null,q=0;for(Y=Y.toLowerCase(),I=I.toLowerCase();q<I.length&&(H=c(Y,I,0,q,$))===null;)q=u(I,q+1);return H}e.matchesWords=d;function c(Y,I,$,H,q){if($===Y.length)return[];if(H===I.length)return null;if(t(Y.charCodeAt($),I.charCodeAt(H))){let J=null,de=H+1;if(J=c(Y,I,$+1,H+1,q),!q)for(;!J&&(de=u(I,de))<I.length;)J=c(Y,I,$+1,de,q),de++;return J?Y.charCodeAt($)!==I.charCodeAt(H)?J:l({start:H,end:H+1},J):null}else return null}function u(Y,I){for(let $=I;$<Y.length;$++)if(f(Y.charCodeAt($))||$>0&&f(Y.charCodeAt($-1)))return $;return Y.length}const n=y(e.matchesPrefix,s,C),h=y(e.matchesPrefix,s,F),m=new i.LRUCache(1e4);function P(Y,I,$=!1){if(typeof Y!="string"||typeof I!="string")return null;let H=m.get(Y);H||(H=new RegExp(T.convertSimple2RegExpPattern(Y),"i"),m.set(Y,H));const q=H.exec(I);return q?[{start:q.index,end:q.index+q[0].length}]:$?h(Y,I):n(Y,I)}e.matchesFuzzy=P;function M(Y,I){const $=Be(Y,Y.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?Z($):null}e.matchesFuzzy2=M;function V(Y,I,$,H,q,J){const de=Math.min(13,Y.length);for(;$<de;$++){const we=Be(Y,I,$,H,q,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,J]}e.anyScore=V;function Z(Y){if(typeof Y>"u")return[];const I=[],$=Y[1];for(let H=Y.length-1;H>1;H--){const q=Y[H]+$,J=I[I.length-1];J&&J.end===q?J.end=q+1:I.push({start:q,end:q+1})}return I}e.createMatches=Z;const G=128;function R(){const Y=[],I=[];for(let $=0;$<=G;$++)I[$]=0;for(let $=0;$<=G;$++)Y.push(I.slice(0));return Y}function A(Y){const I=[];for(let $=0;$<=Y;$++)I[$]=0;return I}const O=A(2*G),B=A(2*G),z=R(),j=R(),K=R(),ie=!1;function me(Y,I,$,H,q){function J(we,ae,pe=" "){for(;we.length<ae;)we=pe+we;return we}let de=` |   |${H.split("").map(we=>J(we,3)).join("|")}
`;for(let we=0;we<=$;we++)we===0?de+=" |":de+=`${I[we-1]}|`,de+=Y[we].slice(0,q+1).map(ae=>J(ae.toString(),3)).join("|")+`
`;return de}function ue(Y,I,$,H){Y=Y.substr(I),$=$.substr(H),console.log(me(j,Y,Y.length,$,$.length)),console.log(me(K,Y,Y.length,$,$.length)),console.log(me(z,Y,Y.length,$,$.length))}function oe(Y,I){if(I<0||I>=Y.length)return!1;const $=Y.codePointAt(I);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise($)}}function De(Y,I){if(I<0||I>=Y.length)return!1;switch(Y.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function re(Y,I,$){return I[Y]!==$[Y]}function _(Y,I,$,H,q,J,de=!1){for(;I<$&&q<J;)Y[I]===H[q]&&(de&&(O[I]=q),I+=1),q+=1;return I===$}e.isPatternInWord=_;var le;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(le||(le={}));var Ee;(function(Y){Y.Default=[-100,0];function I($){return!$||$.length===2&&$[0]===-100&&$[1]===0}Y.isDefault=I})(Ee=e.FuzzyScore||(e.FuzzyScore={}));class Ae{constructor(I,$){this.firstMatchCanBeWeak=I,this.boostFullMatch=$}}e.FuzzyScoreOptions=Ae,Ae.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Be(Y,I,$,H,q,J,de=Ae.default){const we=Y.length>G?G:Y.length,ae=H.length>G?G:H.length;if($>=we||J>=ae||we-$>ae-J||!_(I,$,we,q,J,ae,!0))return;xe(we,ae,$,J,I,q);let pe=1,ve=1,We=$,He=J;const tt=[!1];for(pe=1,We=$;We<we;pe++,We++){const Fe=O[We],st=B[We],Q=We+1<we?B[We+1]:ae;for(ve=Fe-J+1,He=Fe;He<Q;ve++,He++){let X=Number.MIN_SAFE_INTEGER,ge=!1;He<=st&&(X=Te(Y,I,We,$,H,q,He,ae,J,z[pe-1][ve-1]===0,tt));let Me=0;X!==Number.MAX_SAFE_INTEGER&&(ge=!0,Me=X+j[pe-1][ve-1]);const $e=He>Fe,Ve=$e?j[pe][ve-1]+(z[pe][ve-1]>0?-5:0):0,Qe=He>Fe+1&&z[pe][ve-1]>0,nt=Qe?j[pe][ve-2]+(z[pe][ve-2]>0?-5:0):0;if(Qe&&(!$e||nt>=Ve)&&(!ge||nt>=Me))j[pe][ve]=nt,K[pe][ve]=3,z[pe][ve]=0;else if($e&&(!ge||Ve>=Me))j[pe][ve]=Ve,K[pe][ve]=2,z[pe][ve]=0;else if(ge)j[pe][ve]=Me,K[pe][ve]=1,z[pe][ve]=z[pe-1][ve-1]+1;else throw new Error("not possible")}}if(ie&&ue(Y,$,H,J),!tt[0]&&!de.firstMatchCanBeWeak)return;pe--,ve--;const Xe=[j[pe][ve],J];let et=0,it=0;for(;pe>=1;){let Fe=ve;do{const st=K[pe][Fe];if(st===3)Fe=Fe-2;else if(st===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&I[$+pe-1]===q[J+ve-1]&&!re(Fe+J-1,H,q)&&et+1>z[pe][Fe]&&(Fe=ve),Fe===ve?et++:et=1,it||(it=Fe),pe--,ve=Fe-1,Xe.push(ve)}ae===we&&de.boostFullMatch&&(Xe[0]+=2);const dt=it-we;return Xe[0]-=dt,Xe}e.fuzzyScore=Be;function xe(Y,I,$,H,q,J){let de=Y-1,we=I-1;for(;de>=$&&we>=H;)q[de]===J[we]&&(B[de]=we,de--),we--}function Te(Y,I,$,H,q,J,de,we,ae,pe,ve){if(I[$]!==J[de])return Number.MIN_SAFE_INTEGER;let We=1,He=!1;return de===$-H?We=Y[$]===q[de]?7:5:re(de,q,J)&&(de===0||!re(de-1,q,J))?(We=Y[$]===q[de]?7:5,He=!0):oe(J,de)&&(de===0||!oe(J,de-1))?We=5:(oe(J,de-1)||De(J,de-1))&&(We=5,He=!0),We>1&&$===H&&(ve[0]=!0),He||(He=re(de,q,J)||oe(J,de-1)||De(J,de-1)),$===H?de>ae&&(We-=He?3:5):pe?We+=He?2:0:We+=He?0:1,de+1===we&&(We-=He?3:5),We}function Ie(Y,I,$,H,q,J,de){return se(Y,I,$,H,q,J,!0,de)}e.fuzzyScoreGracefulAggressive=Ie;function Se(Y,I,$,H,q,J,de){return se(Y,I,$,H,q,J,!1,de)}e.fuzzyScoreGraceful=Se;function se(Y,I,$,H,q,J,de,we){let ae=Be(Y,I,$,H,q,J,we);if(ae&&!de)return ae;if(Y.length>=3){const pe=Math.min(7,Y.length-1);for(let ve=$+1;ve<pe;ve++){const We=ce(Y,ve);if(We){const He=Be(We,We.toLowerCase(),$,H,q,J,we);He&&(He[0]-=3,(!ae||He[0]>ae[0])&&(ae=He))}}}return ae}function ce(Y,I){if(I+1>=Y.length)return;const $=Y[I],H=Y[I+1];if($!==H)return Y.slice(0,I)+H+$+Y.slice(I+2)}}),define(Ce[120],ke([1,0,121,119,10]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",C=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${C.source}`,"g");function S(a){return a.replace(F,(l,v)=>v?l:`\\${l}`)}e.escapeIcons=S;const k=new RegExp(`\\\\${C.source}`,"g");function N(a){return a.replace(k,l=>`\\${l}`)}e.markdownEscapeEscapedIcons=N;const D=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function g(a){return a.indexOf(L)===-1?a:a.replace(D,(l,v,b,E)=>b?l:v||E||"")}e.stripIcons=g;const p=new RegExp(`\\$\\(${i.CSSIcon.iconNameCharacter}+\\)`,"g");function f(a){p.lastIndex=0;let l="";const v=[];let b=0;for(;;){const E=p.lastIndex,w=p.exec(a),r=a.substring(E,w?.index);if(r.length>0){l+=r;for(let o=0;o<r.length;o++)v.push(b)}if(!w)break;b+=w[0].length}return{text:l,iconOffsets:v}}e.parseLabelWithIcons=f;function t(a,l,v=!1){const{text:b,iconOffsets:E}=l;if(!E||E.length===0)return(0,T.matchesFuzzy)(a,b,v);const w=(0,y.ltrim)(b," "),r=b.length-w.length,o=(0,T.matchesFuzzy)(a,w,v);if(o)for(const s of o){const d=E[s.start+r]+r;s.start+=d,s.end+=d}return o}e.matchesFuzzyIconAware=t}),define(Ce[29],ke([1,0,10]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(T||(T={})),function(y){const L="error",C="warning",F="warn",S="info",k="ignore";function N(g){return g?i.equalsIgnoreCase(L,g)?y.Error:i.equalsIgnoreCase(C,g)||i.equalsIgnoreCase(F,g)?y.Warning:i.equalsIgnoreCase(S,g)?y.Info:y.Ignore:y.Ignore}y.fromValue=N;function D(g){switch(g){case y.Error:return L;case y.Warning:return C;case y.Info:return S;default:return k}}y.toString=D}(T||(T={})),e.default=T}),define(Ce[46],ke([1,0,16,10]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const f=p.charCodeAt(0),t=this.b.charCodeAt(this.c);return f-t}value(){return this.b[this.c]}}e.StringIterator=y;class L{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,T.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=L;class C{constructor(p=!0,f=!0){this.f=p,this.g=f}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let f=p.length-1;f>=0;f--,this.c--){const t=this.b.charCodeAt(f);if(!(t===47||this.f&&t===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,T.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var F;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(F||(F={}));class S{constructor(p,f){this.f=p,this.g=f,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,T.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(N||(N={}));class D{static forUris(p=()=>!1,f=()=>!1){return new D(new S(p,f))}static forPaths(p=!1){return new D(new C(void 0,!p))}static forStrings(){return new D(new y)}static forConfigKeys(){return new D(new L)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,f){if(f){const t=f.slice(0);(0,i.shuffle)(t);for(const a of t)this.set(a,p)}else{const t=p.slice(0);(0,i.shuffle)(t);for(const a of t)this.set(a[0],a[1])}}set(p,f){const t=this.b.reset(p);let a;this.c||(this.c=new k,this.c.segment=t.value());const l=[];for(a=this.c;;){const b=t.cmp(a.segment);if(b>0)a.left||(a.left=new k,a.left.segment=t.value()),l.push([-1,a]),a=a.left;else if(b<0)a.right||(a.right=new k,a.right.segment=t.value()),l.push([1,a]),a=a.right;else if(t.hasNext())t.next(),a.mid||(a.mid=new k,a.mid.segment=t.value()),l.push([0,a]),a=a.mid;else break}const v=a.value;a.value=f,a.key=p;for(let b=l.length-1;b>=0;b--){const E=l[b][1];E.updateHeight();const w=E.balanceFactor();if(w<-1||w>1){const r=l[b][0],o=l[b+1][0];if(r===1&&o===1)l[b][1]=E.rotateLeft();else if(r===-1&&o===-1)l[b][1]=E.rotateRight();else if(r===1&&o===-1)E.right=l[b+1][1]=l[b+1][1].rotateRight(),l[b][1]=E.rotateLeft();else if(r===-1&&o===1)E.left=l[b+1][1]=l[b+1][1].rotateLeft(),l[b][1]=E.rotateRight();else throw new Error;if(b>0)switch(l[b-1][0]){case-1:l[b-1][1].left=l[b][1];break;case 1:l[b-1][1].right=l[b][1];break;case 0:l[b-1][1].mid=l[b][1];break}else this.c=l[0][1]}}return v}get(p){return this.d(p)?.value}d(p){const f=this.b.reset(p);let t=this.c;for(;t;){const a=f.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else break}return t}has(p){const f=this.d(p);return!(f?.value===void 0&&f?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,f){const t=this.b.reset(p),a=[];let l=this.c;for(;l;){const v=t.cmp(l.segment);if(v>0)a.push([-1,l]),l=l.left;else if(v<0)a.push([1,l]),l=l.right;else if(t.hasNext())t.next(),a.push([0,l]),l=l.mid;else break}if(!!l){if(f?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const v=this.f(l.right);if(v.key){const{key:b,value:E,segment:w}=v;this.e(v.key,!1),l.key=b,l.value=E,l.segment=w}}else{const v=l.left??l.right;if(a.length>0){const[b,E]=a[a.length-1];switch(b){case-1:E.left=v;break;case 0:E.mid=v;break;case 1:E.right=v;break}}else this.c=v}for(let v=a.length-1;v>=0;v--){const b=a[v][1];b.updateHeight();const E=b.balanceFactor();if(E>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),a[v][1]=b.rotateLeft()):E<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),a[v][1]=b.rotateRight()),v>0)switch(a[v-1][0]){case-1:a[v-1][1].left=a[v][1];break;case 1:a[v-1][1].right=a[v][1];break;case 0:a[v-1][1].mid=a[v][1];break}else this.c=a[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const f=this.b.reset(p);let t=this.c,a;for(;t;){const l=f.cmp(t.segment);if(l>0)t=t.left;else if(l<0)t=t.right;else if(f.hasNext())f.next(),a=t.value||a,t=t.mid;else break}return t&&t.value||a}findSuperstr(p){return this.g(p,!1)}g(p,f){const t=this.b.reset(p);let a=this.c;for(;a;){const l=t.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(t.hasNext())t.next(),a=a.mid;else return a.mid?this.h(a.mid):f?a.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[f,t]of this)p(t,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const f=[];return this.j(p,f),f[Symbol.iterator]()}j(p,f){!p||(p.left&&this.j(p.left,f),p.value&&f.push([p.key,p.value]),p.mid&&this.j(p.mid,f),p.right&&this.j(p.right,f))}_isBalanced(){const p=f=>{if(!f)return!0;const t=f.balanceFactor();return t<-1||t>1?!1:p(f.left)&&p(f.right)};return p(this.c)}}e.TernarySearchTree=D}),define(Ce[82],ke([1,0,24,10,2]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(k){return JSON.stringify(k,F)}e.stringify=L;function C(k){let N=JSON.parse(k);return N=S(N),N}e.parse=C;function F(k,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,T.regExpFlags)(N)}:N}function S(k,N=0){if(!k||N>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return y.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof i.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let D=0;D<k.length;++D)k[D]=S(k[D],N+1);else for(const D in k)Object.hasOwnProperty.call(k,D)&&(k[D]=S(k[D],N+1))}return k}e.revive=S}),define(Ce[13],ke([1,0,21,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(y=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(k){this.d=k}setDelegate(k){this.e=k}setServerRootPath(k){this.f=`${k}/${y.vscodeRemoteResource}`}set(k,N,D){this.a[k]=N,this.b[k]=D}setConnectionToken(k,N){this.c[k]=N}getPreferredWebSchema(){return this.d}rewrite(k){if(this.e)return this.e(k);const N=k.authority;let D=this.a[N];D&&D.indexOf(":")!==-1&&D.indexOf("[")===-1&&(D=`[${D}]`);const g=this.b[N],p=this.c[N];let f=`path=${encodeURIComponent(k.path)}`;return typeof p=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),T.URI.from({scheme:i.isWeb?this.d:y.vscodeRemoteResource,authority:`${D}:${g}`,path:this.f,query:f})}}e.RemoteAuthorities=new L,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class C{asBrowserUri(k){const N=this.b(k,ee);return this.uriToBrowserUri(N)}uriToBrowserUri(k){return k.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===y.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${y.vscodeFileResource}://${C.a}`)?k.with({scheme:y.vscodeFileResource,authority:k.authority||C.a,query:null,fragment:null}):k}asFileUri(k){const N=this.b(k,ee);return this.uriToFileUri(N)}uriToFileUri(k){return k.scheme===y.vscodeFileResource?k.with({scheme:y.file,authority:k.authority!==C.a?k.authority:null,query:null,fragment:null}):k}b(k,N){return T.URI.isUri(k)?k:T.URI.parse(N.toUrl(k))}}C.a="vscode-app",e.FileAccess=new C;var F;(function(S){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(k.get("3"));const N="vscode-coi";function D(p){let f;typeof p=="string"?f=new URL(p).searchParams:p instanceof URL?f=p.searchParams:T.URI.isUri(p)&&(f=new URL(p.toString(!0)).searchParams);const t=f?.get(N);if(!!t)return k.get(t)}S.getHeadersFromQuery=D;function g(p,f,t){if(!globalThis.crossOriginIsolated)return;const a=f&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(N,a):p[N]=a}S.addSearchParam=g})(F=e.COI||(e.COI={}))}),define(Ce[22],ke([1,0,39,13,19,21,10,2]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(p){return(0,F.uriToFsPath)(p,!0)}e.originalFSPath=S;class k{constructor(f){this.a=f}compare(f,t,a=!1){return f===t?0:(0,C.compare)(this.getComparisonKey(f,a),this.getComparisonKey(t,a))}isEqual(f,t,a=!1){return f===t?!0:!f||!t?!1:this.getComparisonKey(f,a)===this.getComparisonKey(t,a)}getComparisonKey(f,t=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,t,a=!1){if(f.scheme===t.scheme){if(f.scheme===T.Schemas.file)return i.isEqualOrParent(S(f),S(t),this.a(f))&&f.query===t.query&&(a||f.fragment===t.fragment);if((0,e.isEqualAuthority)(f.authority,t.authority))return i.isEqualOrParent(f.path,t.path,this.a(f),"/")&&f.query===t.query&&(a||f.fragment===t.fragment)}return!1}joinPath(f,...t){return F.URI.joinPath(f,...t)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return y.posix.basename(f.path)}extname(f){return y.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let t;return f.scheme===T.Schemas.file?t=F.URI.file(y.dirname(S(f))).path:(t=y.posix.dirname(f.path),f.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),t="/")),f.with({path:t})}normalizePath(f){if(!f.path.length)return f;let t;return f.scheme===T.Schemas.file?t=F.URI.file(y.normalize(S(f))).path:t=y.posix.normalize(f.path),f.with({path:t})}relativePath(f,t){if(f.scheme!==t.scheme||!(0,e.isEqualAuthority)(f.authority,t.authority))return;if(f.scheme===T.Schemas.file){const v=y.relative(S(f),S(t));return L.isWindows?i.toSlashes(v):v}let a=f.path||"/";const l=t.path||"/";if(this.a(f)){let v=0;for(const b=Math.min(a.length,l.length);v<b&&!(a.charCodeAt(v)!==l.charCodeAt(v)&&a.charAt(v).toLowerCase()!==l.charAt(v).toLowerCase());v++);a=l.substr(0,v)+a.substr(v)}return y.posix.relative(a,l)}resolvePath(f,t){if(f.scheme===T.Schemas.file){const a=F.URI.file(y.resolve(S(f),t));return f.with({authority:a.authority,path:a.path})}return t=i.toPosixPath(t),f.with({path:y.posix.resolve(f.path,t)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,t){return f===t||f!==void 0&&t!==void 0&&(0,C.equalsIgnoreCase)(f,t)}hasTrailingPathSeparator(f,t=y.sep){if(f.scheme===T.Schemas.file){const a=S(f);return a.length>i.getRoot(a).length&&a[a.length-1]===t}else{const a=f.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,t=y.sep){return(0,e.hasTrailingPathSeparator)(f,t)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,t=y.sep){let a=!1;if(f.scheme===T.Schemas.file){const l=S(f);a=l!==void 0&&l.length===i.getRoot(l).length&&l[l.length-1]===t}else{t="/";const l=f.path;a=l.length===1&&l.charCodeAt(l.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(f,t)?f.with({path:f.path+"/"}):f}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(p=>p.scheme===T.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new k(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(p,f){const t=[];for(let a=0;a<p.length;a++){const l=f(p[a]);p.some((v,b)=>b===a?!1:(0,e.isEqualOrParent)(l,f(v)))||t.push(p[a])}return t}e.distinctParents=N;var D;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function f(t){const a=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(b=>{const[E,w]=b.split(":");E&&w&&a.set(E,w)});const v=t.path.substring(0,t.path.indexOf(";"));return v&&a.set(p.META_DATA_MIME,v),a}p.parseMetaData=f})(D=e.DataUri||(e.DataUri={}));function g(p,f,t){if(f){let a=p.path;return a&&a[0]!==y.posix.sep&&(a=y.posix.sep+a),p.with({scheme:t,authority:f,path:a})}return p.with({scheme:t})}e.toLocalResource=g}),define(Ce[14],ke([1,0,20,11,4,7,22,21]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(re){return!!re&&typeof re.then=="function"}e.isThenable=S;function k(re){const _=new i.CancellationTokenSource,le=re(_.token),Ee=new Promise((Ae,Be)=>{const xe=_.token.onCancellationRequested(()=>{xe.dispose(),_.dispose(),Be(new T.CancellationError)});Promise.resolve(le).then(Te=>{xe.dispose(),_.dispose(),Ae(Te)},Te=>{xe.dispose(),_.dispose(),Be(Te)})});return new class{cancel(){_.cancel()}then(Ae,Be){return Ee.then(Ae,Be)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return Ee.finally(Ae)}}}e.createCancelablePromise=k;function N(re,_,le){return new Promise((Ee,Ae)=>{const Be=_.onCancellationRequested(()=>{Be.dispose(),Ee(le)});re.then(Ee,Ae).finally(()=>Be.dispose())})}e.raceCancellation=N;function D(re,_){return new Promise((le,Ee)=>{const Ae=_.onCancellationRequested(()=>{Ae.dispose(),Ee(new T.CancellationError)});re.then(le,Ee).finally(()=>Ae.dispose())})}e.raceCancellationError=D;async function g(re){let _=-1;const le=re.map((Ae,Be)=>Ae.then(xe=>(_=Be,xe))),Ee=await Promise.race(le);return re.forEach((Ae,Be)=>{Be!==_&&Ae.cancel()}),Ee}e.raceCancellablePromises=g;function p(re,_,le){let Ee;const Ae=setTimeout(()=>{Ee?.(void 0),le?.()},_);return Promise.race([re.finally(()=>clearTimeout(Ae)),new Promise(Be=>Ee=Be)])}e.raceTimeout=p;function f(re){return new Promise((_,le)=>{const Ee=re();S(Ee)?Ee.then(_,le):_(Ee)})}e.asPromise=f;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(_){if(this.a){if(this.d=_,!this.b){const le=()=>{this.b=null;const Ee=this.queue(this.d);return this.d=null,Ee};this.b=new Promise(Ee=>{this.a.then(le,le).then(Ee)})}return new Promise((le,Ee)=>{this.b.then(le,Ee)})}return this.a=_(),new Promise((le,Ee)=>{this.a.then(Ae=>{this.a=null,le(Ae)},Ae=>{this.a=null,Ee(Ae)})})}}e.Throttler=t;class a{constructor(){this.a=Promise.resolve(null)}queue(_){return this.a=this.a.then(()=>_(),()=>_())}}e.Sequencer=a;class l{constructor(){this.a=new Map}queue(_,le){const Ae=(this.a.get(_)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(_)===Ae&&this.a.delete(_)});return this.a.set(_,Ae),Ae}}e.SequencerByKey=l;const v=(re,_)=>{let le=!0;const Ee=setTimeout(()=>{le=!1,_()},re);return{isTriggered:()=>le,dispose:()=>{clearTimeout(Ee),le=!1}}},b=re=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,re())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class E{constructor(_){this.defaultDelay=_,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(_,le=this.defaultDelay){this.g=_,this.h(),this.b||(this.b=new Promise((Ae,Be)=>{this.d=Ae,this.f=Be}).then(()=>{if(this.b=null,this.d=null,this.g){const Ae=this.g;return this.g=null,Ae()}}));const Ee=()=>{this.a=null,this.d?.(null)};return this.a=le===e.MicrotaskDelay?b(Ee):v(le,Ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=E;class w{constructor(_){this.a=new E(_),this.b=new t}trigger(_,le){return this.a.trigger(()=>this.b.queue(_),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=w;class r{constructor(){this.a=!1,this.b=new Promise((_,le)=>{this.d=_})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class o extends r{constructor(_){super(),this.f=setTimeout(()=>this.open(),_)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=o;function s(re,_){return _?new Promise((le,Ee)=>{const Ae=setTimeout(()=>{Be.dispose(),le()},re),Be=_.onCancellationRequested(()=>{clearTimeout(Ae),Be.dispose(),Ee(new T.CancellationError)})}):k(le=>s(re,le))}e.timeout=s;function d(re,_=0){const le=setTimeout(re,_);return(0,L.toDisposable)(()=>clearTimeout(le))}e.disposableTimeout=d;function c(re){const _=[];let le=0;const Ee=re.length;function Ae(){return le<Ee?re[le++]():null}function Be(xe){xe!=null&&_.push(xe);const Te=Ae();return Te?Te.then(Be):Promise.resolve(_)}return Promise.resolve(null).then(Be)}e.sequence=c;function u(re,_=Ee=>!!Ee,le=null){let Ee=0;const Ae=re.length,Be=()=>{if(Ee>=Ae)return Promise.resolve(le);const xe=re[Ee++];return Promise.resolve(xe()).then(Ie=>_(Ie)?Promise.resolve(Ie):Be())};return Be()}e.first=u;function n(re,_=Ee=>!!Ee,le=null){if(re.length===0)return Promise.resolve(le);let Ee=re.length;const Ae=()=>{Ee=-1;for(const Be of re)Be.cancel?.()};return new Promise((Be,xe)=>{for(const Te of re)Te.then(Ie=>{--Ee>=0&&_(Ie)?(Ae(),Be(Ie)):Ee===0&&Be(le)}).catch(Ie=>{--Ee>=0&&(Ae(),xe(Ie))})})}e.firstParallel=n;class h{constructor(_){this.a=0,this.d=_,this.f=[],this.b=0,this.g=new y.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(_){return this.a++,new Promise((le,Ee)=>{this.f.push({factory:_,c:le,e:Ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const _=this.f.shift();this.b++;const le=_.factory();le.then(_.c,_.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class m extends h{constructor(){super(1)}}e.Queue=m;class P{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const _=new K;return this.b.add(_),_.p}d(){for(const[,_]of this.a)if(_.size>0)return!1;return!0}queueFor(_,le=C.extUri){const Ee=le.getComparisonKey(_);let Ae=this.a.get(Ee);return Ae||(Ae=new m,y.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(Ee),this.f()}),this.a.set(Ee,Ae)),Ae}f(){!this.d()||this.g()}g(){for(const _ of this.b)_.complete();this.b.clear()}dispose(){for(const[,_]of this.a)_.dispose();this.a.clear(),this.g()}}e.ResourceQueue=P;class M{constructor(_,le){this.a=-1,typeof _=="function"&&typeof le=="number"&&this.setIfNotSet(_,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(_,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,_()},le)}setIfNotSet(_,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,_()},le))}}e.TimeoutTimer=M;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(_,le){this.cancel(),this.a=setInterval(()=>{_()},le)}}e.IntervalTimer=V;class Z{constructor(_,le){this.b=-1,this.a=_,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(_=this.d){this.cancel(),this.b=setTimeout(this.f,_)}get delay(){return this.d}set delay(_){this.d=_}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=Z;class G{constructor(_,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=_,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(_=this.b){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(_/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=G;class R extends Z{constructor(_,le){super(_,le),this.j=[]}work(_){this.j.push(_),this.isScheduled()||this.schedule()}h(){const _=this.j;this.j=[],this.a?.(_)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=R;class A extends L.Disposable{constructor(_,le){super(),this.g=_,this.h=le,this.a=[],this.b=this.B(new L.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(_){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+_.length>this.g.maxBufferedWork)return!1}else if(this.pending+_.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of _)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=A,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=re=>{(0,F.setTimeout0)(()=>{if(_)return;const le=Date.now()+15;re(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(re,_)=>{const le=requestIdleCallback(re,typeof _=="number"?{timeout:_}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(le))}}}}();class O{constructor(_){this.d=!1,this.a=()=>{try{this.f=_()}catch(le){this.g=le}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=O;async function B(re,_,le){let Ee;for(let Ae=0;Ae<le;Ae++)try{return await re()}catch(Be){Ee=Be,await s(_)}throw Ee}e.retry=B;class z{hasPending(_){return this.a?typeof _=="number"?this.a.taskId===_:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(_,le,Ee){return this.a={taskId:_,cancel:()=>Ee?.(),promise:le},le.then(()=>this.d(_),()=>this.d(_)),le}d(_){this.a&&_===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const _=this.b;this.b=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this.b)this.b.run=_;else{let le,Ee;const Ae=new Promise((Be,xe)=>{le=Be,Ee=xe});this.b={run:_,promise:Ae,promiseResolve:le,promiseReject:Ee}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class j{constructor(_,le=()=>Date.now()){this.d=_,this.f=le,this.a=0,this.b=0}increment(){const _=this.f();return _-this.a>this.d&&(this.a=_,this.b=0),this.b++,this.b}}e.IntervalCounter=j;class K{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((_,le)=>{this.a=_,this.b=le})}complete(_){return new Promise(le=>{this.a(_),this.f=!0,le()})}error(_){return new Promise(le=>{this.b(_),this.d=!0,le()})}cancel(){new Promise(_=>{this.b(new T.CancellationError),this.d=!0,_()})}}e.DeferredPromise=K;var ie;(function(re){async function _(Ee){let Ae;const Be=await Promise.all(Ee.map(xe=>xe.then(Te=>Te,Te=>{Ae||(Ae=Te)})));if(typeof Ae<"u")throw Ae;return Be}re.settled=_;function le(Ee){return new Promise(async(Ae,Be)=>{try{await Ee(Ae,Be)}catch(xe){Be(xe)}})}re.withAsyncBody=le})(ie=e.Promises||(e.Promises={}));var me;(function(re){re[re.Initial=0]="Initial",re[re.DoneOK=1]="DoneOK",re[re.DoneError=2]="DoneError"})(me||(me={}));class ue{static fromArray(_){return new ue(le=>{le.emitMany(_)})}static fromPromise(_){return new ue(async le=>{le.emitMany(await _)})}static fromPromises(_){return new ue(async le=>{await Promise.all(_.map(async Ee=>le.emitOne(await Ee)))})}static merge(_){return new ue(async le=>{await Promise.all(_.map(async Ee=>{for await(const Ae of Ee)le.emitOne(Ae)}))})}constructor(_){this.a=0,this.b=[],this.d=null,this.f=new y.Emitter,queueMicrotask(async()=>{const le={emitOne:Ee=>this.g(Ee),emitMany:Ee=>this.h(Ee),reject:Ee=>this.k(Ee)};try{await Promise.resolve(_(le)),this.j()}catch(Ee){this.k(Ee)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(_<this.b.length)return{done:!1,value:this.b[_++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(_,le){return new ue(async Ee=>{for await(const Ae of _)Ee.emitOne(le(Ae))})}map(_){return ue.map(this,_)}static filter(_,le){return new ue(async Ee=>{for await(const Ae of _)le(Ae)&&Ee.emitOne(Ae)})}filter(_){return ue.filter(this,_)}static coalesce(_){return ue.filter(_,le=>!!le)}coalesce(){return ue.coalesce(this)}static async toPromise(_){const le=[];for await(const Ee of _)le.push(Ee);return le}toPromise(){return ue.toPromise(this)}g(_){this.a===0&&(this.b.push(_),this.f.fire())}h(_){this.a===0&&(this.b=this.b.concat(_),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(_){this.a===0&&(this.a=2,this.d=_,this.f.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class oe extends ue{constructor(_,le){super(le),this.l=_}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=oe;function De(re){const _=new i.CancellationTokenSource,le=re(_.token);return new oe(_,async Ee=>{const Ae=_.token.onCancellationRequested(()=>{Ae.dispose(),_.dispose(),Ee.reject(new T.CancellationError)});try{for await(const Be of le){if(_.token.isCancellationRequested)return;Ee.emitOne(Be)}Ae.dispose(),_.dispose()}catch(Be){Ae.dispose(),_.dispose(),Ee.reject(Be)}})}e.createCancelableAsyncIterable=De}),define(Ce[122],ke([1,0,14,19]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new i.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),L=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function F(h,m,P=!1){const M=h||"",V=m||"",Z=y.value.collator.compare(M,V);return y.value.collatorIsNumeric&&Z===0&&M!==V?M<V?-1:1:Z}e.compareFileNames=F;function S(h,m){const P=L.value.collator;return h=h||"",m=m||"",E(P,h,m)}e.compareFileNamesDefault=S;function k(h,m){const P=L.value.collator;return h=h||"",m=m||"",s(h,m)||E(P,h,m)}e.compareFileNamesUpper=k;function N(h,m){const P=L.value.collator;return h=h||"",m=m||"",o(h,m)||E(P,h,m)}e.compareFileNamesLower=N;function D(h,m){return h=h||"",m=m||"",h===m?0:h<m?-1:1}e.compareFileNamesUnicode=D;function g(h,m){const[P,M]=v(h),[V,Z]=v(m);let G=y.value.collator.compare(M,Z);if(G===0){if(y.value.collatorIsNumeric&&M!==Z)return M<Z?-1:1;if(G=y.value.collator.compare(P,V),y.value.collatorIsNumeric&&G===0&&P!==V)return P<V?-1:1}return G}e.compareFileExtensions=g;function p(h,m){h=h||"",m=m||"";const P=b(h),M=b(m),V=L.value.collator,Z=C.value.collator;return E(Z,P,M)||E(V,h,m)}e.compareFileExtensionsDefault=p;function f(h,m){h=h||"",m=m||"";const P=b(h),M=b(m),V=L.value.collator,Z=C.value.collator;return E(Z,P,M)||s(h,m)||E(V,h,m)}e.compareFileExtensionsUpper=f;function t(h,m){h=h||"",m=m||"";const P=b(h),M=b(m),V=L.value.collator,Z=C.value.collator;return E(Z,P,M)||o(h,m)||E(V,h,m)}e.compareFileExtensionsLower=t;function a(h,m){h=h||"",m=m||"";const P=b(h).toLowerCase(),M=b(m).toLowerCase();return P!==M?P<M?-1:1:h!==m?h<m?-1:1:0}e.compareFileExtensionsUnicode=a;const l=/^(.*?)(\.([^.]*))?$/;function v(h,m=!1){const P=h?l.exec(h):[];let M=[P&&P[1]||"",P&&P[3]||""];return m&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function b(h){const m=h?l.exec(h):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function E(h,m,P){const M=h.compare(m,P);return M!==0?M:m.length!==P.length?m.length<P.length?-1:1:0}function w(h){const m=h.charAt(0);return m.toLocaleUpperCase()!==m}function r(h){const m=h.charAt(0);return m.toLocaleLowerCase()!==m}function o(h,m){return w(h)&&r(m)?-1:r(h)&&w(m)?1:0}function s(h,m){return r(h)&&w(m)?-1:w(h)&&r(m)?1:0}function d(h,m,P=!1){return P||(h=h&&h.toLowerCase(),m=m&&m.toLowerCase()),h===m?0:h<m?-1:1}function c(h,m,P=!1){const M=h.split(T.sep),V=m.split(T.sep),Z=M.length-1,G=V.length-1;let R,A;for(let O=0;;O++){if(R=Z===O,A=G===O,R&&A)return F(M[O],V[O],P);if(R)return-1;if(A)return 1;const B=d(M[O],V[O],P);if(B!==0)return B}}e.comparePaths=c;function u(h,m,P){const M=h.toLowerCase(),V=m.toLowerCase(),Z=n(h,m,P);if(Z)return Z;const G=M.endsWith(P),R=V.endsWith(P);if(G!==R)return G?-1:1;const A=F(M,V);return A!==0?A:M.localeCompare(V)}e.compareAnything=u;function n(h,m,P){const M=h.toLowerCase(),V=m.toLowerCase(),Z=M.startsWith(P),G=V.startsWith(P);if(Z!==G)return Z?-1:1;if(Z&&G){if(M.length<V.length)return-1;if(M.length>V.length)return 1}return 0}e.compareByPrefix=n}),define(Ce[35],ke([1,0,16,14,39,28,19,21,10]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const N="[/\\\\]",D="[^/\\\\]",g=/\//g;function p(K,ie){switch(K){case 0:return"";case 1:return`${D}*?`;default:return`(?:${N}|${D}+${N}${ie?`|${N}${D}+`:""})*?`}}function f(K,ie){if(!K)return[];const me=[];let ue=!1,oe=!1,De="";for(const re of K){switch(re){case ie:if(!ue&&!oe){me.push(De),De="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}De+=re}return De&&me.push(De),me}e.splitGlobAware=f;function t(K){if(!K)return"";let ie="";const me=f(K,e.GLOB_SPLIT);if(me.every(ue=>ue===e.GLOBSTAR))ie=".*";else{let ue=!1;me.forEach((oe,De)=>{if(oe===e.GLOBSTAR){if(ue)return;ie+=p(2,De===me.length-1)}else{let re=!1,_="",le=!1,Ee="";for(const Ae of oe){if(Ae!=="}"&&re){_+=Ae;continue}if(le&&(Ae!=="]"||!Ee)){let Be;Ae==="-"?Be=Ae:(Ae==="^"||Ae==="!")&&!Ee?Be="^":Ae===e.GLOB_SPLIT?Be="":Be=(0,S.escapeRegExpCharacters)(Ae),Ee+=Be;continue}switch(Ae){case"{":re=!0;continue;case"[":le=!0;continue;case"}":{ie+=`(?:${f(_,",").map(Te=>t(Te)).join("|")})`,re=!1,_="";break}case"]":{ie+="["+Ee+"]",le=!1,Ee="";break}case"?":ie+=D;continue;case"*":ie+=p(1);continue;default:ie+=(0,S.escapeRegExpCharacters)(Ae)}}De<me.length-1&&(me[De+1]!==e.GLOBSTAR||De+2<me.length)&&(ie+=N)}ue=oe===e.GLOBSTAR})}return ie}const a=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new L.LRUCache(1e4),o=function(){return!1},s=function(){return null};function d(K,ie){if(!K)return s;let me;typeof K!="string"?me=K.pattern:me=K,me=me.trim();const ue=`${me}_${!!ie.trimForExclusions}`;let oe=r.get(ue);if(oe)return c(oe,K);let De;return a.test(me)?oe=n(me.substr(4),me):(De=l.exec(u(me,ie)))?oe=h(De[1],me):(ie.trimForExclusions?b:v).test(me)?oe=m(me,ie):(De=E.exec(u(me,ie)))?oe=P(De[1].substr(1),me,!0):(De=w.exec(u(me,ie)))?oe=P(De[1],me,!1):oe=M(me),r.set(ue,oe),c(oe,K)}function c(K,ie){if(typeof ie=="string")return K;const me=function(ue,oe){return(0,y.isEqualOrParent)(ue,ie.base,!F.isLinux)?K((0,S.ltrim)(ue.substr(ie.base.length),C.sep),oe):null};return me.allBasenames=K.allBasenames,me.allPaths=K.allPaths,me.basenames=K.basenames,me.patterns=K.patterns,me}function u(K,ie){return ie.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function n(K,ie){return function(me,ue){return typeof me=="string"&&me.endsWith(K)?ie:null}}function h(K,ie){const me=`/${K}`,ue=`\\${K}`,oe=function(re,_){return typeof re!="string"?null:_?_===K?ie:null:re===K||re.endsWith(me)||re.endsWith(ue)?ie:null},De=[K];return oe.basenames=De,oe.patterns=[ie],oe.allBasenames=De,oe}function m(K,ie){const me=z(K.slice(1,-1).split(",").map(_=>d(_,ie)).filter(_=>_!==s),K),ue=me.length;if(!ue)return s;if(ue===1)return me[0];const oe=function(_,le){for(let Ee=0,Ae=me.length;Ee<Ae;Ee++)if(me[Ee](_,le))return K;return null},De=me.find(_=>!!_.allBasenames);De&&(oe.allBasenames=De.allBasenames);const re=me.reduce((_,le)=>le.allPaths?_.concat(le.allPaths):_,[]);return re.length&&(oe.allPaths=re),oe}function P(K,ie,me){const ue=C.sep===C.posix.sep,oe=ue?K:K.replace(g,C.sep),De=C.sep+oe,re=C.posix.sep+K;let _;return me?_=function(le,Ee){return typeof le=="string"&&(le===oe||le.endsWith(De)||!ue&&(le===K||le.endsWith(re)))?ie:null}:_=function(le,Ee){return typeof le=="string"&&(le===oe||!ue&&le===K)?ie:null},_.allPaths=[(me?"*/":"./")+K],_}function M(K){try{const ie=new RegExp(`^${t(K)}$`);return function(me){return ie.lastIndex=0,typeof me=="string"&&ie.test(me)?K:null}}catch{return s}}function V(K,ie,me){return!K||typeof ie!="string"?!1:Z(K)(ie,void 0,me)}e.match=V;function Z(K,ie={}){if(!K)return o;if(typeof K=="string"||G(K)){const me=d(K,ie);if(me===s)return o;const ue=function(oe,De){return!!me(oe,De)};return me.allBasenames&&(ue.allBasenames=me.allBasenames),me.allPaths&&(ue.allPaths=me.allPaths),ue}return O(K,ie)}e.parse=Z;function G(K){const ie=K;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=G;function R(K){return K.allBasenames||[]}e.getBasenameTerms=R;function A(K){return K.allPaths||[]}e.getPathTerms=A;function O(K,ie){const me=z(Object.getOwnPropertyNames(K).map(_=>B(_,K[_],ie)).filter(_=>_!==s)),ue=me.length;if(!ue)return s;if(!me.some(_=>!!_.requiresSiblings)){if(ue===1)return me[0];const _=function(Ae,Be){let xe;for(let Te=0,Ie=me.length;Te<Ie;Te++){const Se=me[Te](Ae,Be);if(typeof Se=="string")return Se;(0,T.isThenable)(Se)&&(xe||(xe=[]),xe.push(Se))}return xe?(async()=>{for(const Te of xe){const Ie=await Te;if(typeof Ie=="string")return Ie}return null})():null},le=me.find(Ae=>!!Ae.allBasenames);le&&(_.allBasenames=le.allBasenames);const Ee=me.reduce((Ae,Be)=>Be.allPaths?Ae.concat(Be.allPaths):Ae,[]);return Ee.length&&(_.allPaths=Ee),_}const oe=function(_,le,Ee){let Ae,Be;for(let xe=0,Te=me.length;xe<Te;xe++){const Ie=me[xe];Ie.requiresSiblings&&Ee&&(le||(le=(0,C.basename)(_)),Ae||(Ae=le.substr(0,le.length-(0,C.extname)(_).length)));const Se=Ie(_,le,Ae,Ee);if(typeof Se=="string")return Se;(0,T.isThenable)(Se)&&(Be||(Be=[]),Be.push(Se))}return Be?(async()=>{for(const xe of Be){const Te=await xe;if(typeof Te=="string")return Te}return null})():null},De=me.find(_=>!!_.allBasenames);De&&(oe.allBasenames=De.allBasenames);const re=me.reduce((_,le)=>le.allPaths?_.concat(le.allPaths):_,[]);return re.length&&(oe.allPaths=re),oe}function B(K,ie,me){if(ie===!1)return s;const ue=d(K,me);if(ue===s)return s;if(typeof ie=="boolean")return ue;if(ie){const oe=ie.when;if(typeof oe=="string"){const De=(re,_,le,Ee)=>{if(!Ee||!ue(re,_))return null;const Ae=oe.replace("$(basename)",()=>le),Be=Ee(Ae);return(0,T.isThenable)(Be)?Be.then(xe=>xe?K:null):Be?K:null};return De.requiresSiblings=!0,De}}return ue}function z(K,ie){const me=K.filter(_=>!!_.basenames);if(me.length<2)return K;const ue=me.reduce((_,le)=>{const Ee=le.basenames;return Ee?_.concat(Ee):_},[]);let oe;if(ie){oe=[];for(let _=0,le=ue.length;_<le;_++)oe.push(ie)}else oe=me.reduce((_,le)=>{const Ee=le.patterns;return Ee?_.concat(Ee):_},[]);const De=function(_,le){if(typeof _!="string")return null;if(!le){let Ae;for(Ae=_.length;Ae>0;Ae--){const Be=_.charCodeAt(Ae-1);if(Be===47||Be===92)break}le=_.substr(Ae)}const Ee=ue.indexOf(le);return Ee!==-1?oe[Ee]:null};De.basenames=ue,De.patterns=oe,De.allBasenames=ue;const re=K.filter(_=>!_.basenames);return re.push(De),re}function j(K,ie){return(0,i.equals)(K,ie,(me,ue)=>typeof me=="string"&&typeof ue=="string"?me===ue:typeof me!="string"&&typeof ue!="string"?me.base===ue.base&&me.pattern===ue.pattern:!1)}e.patternsEquals=j}),define(Ce[83],ke([1,0,11,120,22,10,2]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var F;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(F=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(l="",v=!1){if(this.value=l,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(l,v=0){return this.value+=g(this.supportThemeIcons?(0,T.escapeIcons)(l):l).replace(/([ \t]+)/g,(b,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,v){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(l,v,b){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(l),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(l,v){const b=new RegExp((0,L.escapeRegExpCharacters)(v),"g");return l.replace(b,(E,w)=>l.charAt(w-1)!=="\\"?`\\${E}`:E)}}e.MarkdownString=S;function k(a){return N(a)?!a.value:Array.isArray(a)?a.every(k):!0}e.isEmptyMarkdownString=k;function N(a){return a instanceof S?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function D(a,l){return a===l?!0:!a||!l?!1:a.value===l.value&&a.isTrusted===l.isTrusted&&a.supportThemeIcons===l.supportThemeIcons&&a.supportHtml===l.supportHtml&&(a.baseUri===l.baseUri||!!a.baseUri&&!!l.baseUri&&(0,y.isEqual)(C.URI.from(a.baseUri),C.URI.from(l.baseUri)))}e.markdownStringEqual=D;function g(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=g;function p(a){return a.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=p;function f(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=f;function t(a){const l=[],v=a.split("|").map(E=>E.trim());a=v[0];const b=v[1];if(b){const E=/height=(\d+)/.exec(b),w=/width=(\d+)/.exec(b),r=E?E[1]:"",o=w?w[1]:"",s=isFinite(parseInt(o)),d=isFinite(parseInt(r));s&&l.push(`width="${o}"`),d&&l.push(`height="${r}"`)}return{href:a,dimensions:l}}e.parseHrefAndDimensions=t}),define(Ce[84],ke([1,0,16,39,19,21,22,10]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(s,d){const{os:c,tildify:u,relative:n}=d;if(n){const P=k(s,n,c);if(typeof P=="string")return P}let h=s.fsPath;if(c===1&&!L.isWindows?h=h.replace(/\//g,"\\"):c!==1&&L.isWindows&&(h=h.replace(/\\/g,"/")),c!==1&&u?.userHome){const P=u.userHome.fsPath;let M;s.scheme!==u.userHome.scheme&&s.path.startsWith(y.posix.sep)?M=u.userHome.with({path:s.path}).fsPath:M=s.fsPath,h=g(M,P,c)}return(c===1?y.win32:y.posix).normalize(N(h,c===1))}e.getPathLabel=S;function k(s,d,c){const u=c===1?y.win32:y.posix,n=c===3?C.extUri:C.extUriIgnorePathCase,h=d.getWorkspace(),m=(0,i.firstOrDefault)(h.folders);if(!m)return;s.scheme!==m.uri.scheme&&s.path.startsWith(y.posix.sep)&&(s=m.uri.with({path:s.path}));const P=d.getWorkspaceFolder(s);if(!P)return;let M;if(n.isEqual(P.uri,s)?M="":M=n.relativePath(P.uri,s)??"",M&&(M=u.normalize(M)),h.folders.length>1&&!d.noPrefix){const V=P.name?P.name:n.basenameOrAuthority(P.uri);M=M?`${V} \u2022 ${M}`:V}return M}function N(s,d=L.isWindows){return(0,T.hasDriveLetter)(s,d)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=N;let D=Object.create(null);function g(s,d,c=L.OS){if(c===1||!s||!d)return s;let u=D.original===d?D.normalized:void 0;u||(u=d,L.isWindows&&(u=(0,T.toSlashes)(u)),u=`${(0,F.rtrim)(u,y.posix.sep)}${y.posix.sep}`,D={original:d,normalized:u});let n=s;return L.isWindows&&(n=(0,T.toSlashes)(n)),(c===3?n.startsWith(u):(0,F.startsWithIgnoreCase)(n,u))?`~/${n.substr(u.length)}`:s}e.tildify=g;function p(s,d){return s.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=p;const f="\u2026",t="\\\\",a="~";function l(s,d=y.sep){const c=new Array(s.length);let u=!1;for(let n=0;n<s.length;n++){const h=s[n];if(h===""){c[n]=`.${d}`;continue}if(!h){c[n]=h;continue}u=!0;let m="",P=h;P.indexOf(t)===0?(m=P.substr(0,P.indexOf(t)+t.length),P=P.substr(P.indexOf(t)+t.length)):P.indexOf(d)===0?(m=P.substr(0,P.indexOf(d)+d.length),P=P.substr(P.indexOf(d)+d.length)):P.indexOf(a)===0&&(m=P.substr(0,P.indexOf(a)+a.length),P=P.substr(P.indexOf(a)+a.length));const M=P.split(d);for(let V=1;u&&V<=M.length;V++)for(let Z=M.length-V;u&&Z>=0;Z--){u=!1;let G=M.slice(Z,Z+V).join(d);for(let R=0;!u&&R<s.length;R++)if(R!==n&&s[R]&&s[R].indexOf(G)>-1){const A=Z+V===M.length,O=Z>0&&s[R].indexOf(d)>-1?d+G:G,B=s[R].endsWith(O);u=!A||B}if(!u){let R="";(M[0].endsWith(":")||m!=="")&&(Z===1&&(Z=0,V++,G=M[0]+d+G),Z>0&&(R=M[0]+d),R=m+R),Z>0&&(R=R+f+d),R=R+G,Z+V<M.length&&(R=R+d+f),c[n]=R}}u&&(c[n]=h)}return c}e.shorten=l;var v;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function b(s,d=Object.create(null)){const c=[];let u=!1,n="";for(const h of s)if(h==="$"||u&&h==="{")n&&c.push({value:n,type:v.TEXT}),n="",u=!0;else if(h==="}"&&u){const m=d[n];if(typeof m=="string")m.length&&c.push({value:m,type:v.VARIABLE});else if(m){const P=c[c.length-1];(!P||P.type!==v.SEPARATOR)&&c.push({value:m.label,type:v.SEPARATOR})}n="",u=!1}else n+=h;return n&&!u&&c.push({value:n,type:v.TEXT}),c.filter((h,m)=>{if(h.type===v.SEPARATOR){const P=c[m-1],M=c[m+1];return[P,M].every(V=>V&&(V.type===v.VARIABLE||V.type===v.TEXT)&&V.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=b;function E(s,d){return L.isMacintosh||d?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):s.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function w(s,d){return L.isMacintosh||d?s.replace(/\(&&\w\)|&&/g,""):L.isWindows?s.replace(/&&|&/g,c=>c==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function r(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(s){const d=s.indexOf("/")!==-1?y.posix:y.win32,c=d.basename(s),u=d.dirname(s);return c.length?{name:c,parentPath:u}:{name:u,parentPath:""}}e.splitName=o}),define(Ce[123],ke([1,0,2]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(N){return N.toJSON()}class y{constructor(D){this.a=D}transformIncoming(D){const g=this.a.transformIncoming(D);return g===D?D:T(i.URI.from(g))}transformOutgoing(D){const g=this.a.transformOutgoing(D);return g===D?D:T(i.URI.from(g))}transformOutgoingURI(D){const g=this.a.transformOutgoing(D);return g===D?D:i.URI.from(g)}transformOutgoingScheme(D){return this.a.transformOutgoingScheme(D)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(N){return N}transformOutgoing(N){return N}transformOutgoingURI(N){return N}transformOutgoingScheme(N){return N}};function L(N,D,g){if(!N||g>200)return null;if(typeof N=="object"){if(N instanceof i.URI)return D.transformOutgoing(N);for(const p in N)if(Object.hasOwnProperty.call(N,p)){const f=L(N[p],D,g+1);f!==null&&(N[p]=f)}}return null}function C(N,D){const g=L(N,D,0);return g===null?N:g}e.transformOutgoingURIs=C;function F(N,D,g,p){if(!N||p>200)return null;if(typeof N=="object"){if(N.$mid===1)return g?i.URI.revive(D.transformIncoming(N)):D.transformIncoming(N);for(const f in N)if(Object.hasOwnProperty.call(N,f)){const t=F(N[f],D,g,p+1);t!==null&&(N[f]=t)}}return null}function S(N,D){const g=F(N,D,!1,0);return g===null?N:g}e.transformIncomingURIs=S;function k(N,D){const g=F(N,D,!0,0);return g===null?N:g}e.transformAndReviveIncomingURIs=k}),define(Ce[124],ke([1,0,35,19]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(L,C,F,S,k,N){if(Array.isArray(L)){let D=0;for(const g of L){const p=y(g,C,F,S,k,N);if(p===10)return p;p>D&&(D=p)}return D}else{if(typeof L=="string")return S?L==="*"?5:L===F?10:0:0;if(L){const{language:D,pattern:g,scheme:p,hasAccessToAllModels:f,notebookType:t}=L;if(!S&&!f)return 0;t&&k&&(C=k);let a=0;if(p)if(p===C.scheme)a=10;else if(p==="*")a=5;else return 0;if(D)if(D===F)a=10;else if(D==="*")a=Math.max(a,5);else return 0;if(t)if(t===N)a=10;else if(t==="*"&&N!==void 0)a=Math.max(a,5);else return 0;if(g){let l;if(typeof g=="string"?l=g:l={...g,base:(0,T.normalize)(g.base)},l===C.fsPath||(0,i.match)(l,C.fsPath))a=10;else return 0}return a}else return 0}}e.score=y}),define(Ce[85],ke([1,0,24,21]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(y||(y={}));function L(D){for(let g=0,p=D.length;g<p;g+=4){const f=D[g+0],t=D[g+1],a=D[g+2],l=D[g+3];D[g+0]=l,D[g+1]=a,D[g+2]=t,D[g+3]=f}}function C(D){const g=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return T.isLittleEndian()||L(g),i.VSBuffer.wrap(g)}function F(D){const g=D.buffer;if(T.isLittleEndian()||L(g),g.byteOffset%4===0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const p=new Uint8Array(g.byteLength);return p.set(g),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function S(D){const g=new Uint32Array(k(D));let p=0;if(g[p++]=D.id,D.type==="full")g[p++]=1,g[p++]=D.data.length,g.set(D.data,p),p+=D.data.length;else{g[p++]=2,g[p++]=D.deltas.length;for(const f of D.deltas)g[p++]=f.start,g[p++]=f.deleteCount,f.data?(g[p++]=f.data.length,g.set(f.data,p),p+=f.data.length):g[p++]=0}return C(g)}e.encodeSemanticTokensDto=S;function k(D){let g=0;if(g+=1+1,D.type==="full")g+=1+D.data.length;else{g+=1,g+=(1+1+1)*D.deltas.length;for(const p of D.deltas)p.data&&(g+=p.data.length)}return g}function N(D){const g=F(D);let p=0;const f=g[p++];if(g[p++]===1){const v=g[p++],b=g.subarray(p,p+v);return p+=v,{id:f,type:"full",data:b}}const a=g[p++],l=[];for(let v=0;v<a;v++){const b=g[p++],E=g[p++],w=g[p++];let r;w>0&&(r=g.subarray(p,p+w),p+=w),l[v]={start:b,deleteCount:E,data:r}}return{id:f,type:"delta",deltas:l}}e.decodeSemanticTokensDto=N}),define(Ce[125],ke([17,18]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ce[126],ke([1,0,125,21,127,16,23,114]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=k;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class D{constructor(X,ge,Me,$e){this.id=X,this.name=ge,this.defaultValue=Me,this.schema=$e}applyUpdate(X,ge){return p(X,ge)}compute(X,ge,Me){return Me}}class g{constructor(X,ge){this.newValue=X,this.didChange=ge}}e.ApplyUpdateResult=g;function p(Q,X){if(typeof Q!="object"||typeof X!="object"||!Q||!X)return new g(X,Q!==X);if(Array.isArray(Q)||Array.isArray(X)){const Me=Array.isArray(Q)&&Array.isArray(X)&&L.equals(Q,X);return new g(X,!Me)}let ge=!1;for(const Me in X)if(X.hasOwnProperty(Me)){const $e=p(Q[Me],X[Me]);$e.didChange&&(Q[Me]=$e.newValue,ge=!0)}return new g(Q,ge)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,ge){return p(X,ge)}validate(X){return this.defaultValue}}class t{constructor(X,ge,Me,$e){this.id=X,this.name=ge,this.defaultValue=Me,this.schema=$e}applyUpdate(X,ge){return p(X,ge)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,ge,Me){return Me}}function a(Q,X){return typeof Q>"u"?X:Q==="false"?!1:Boolean(Q)}e.boolean=a;class l extends t{constructor(X,ge,Me,$e=void 0){typeof $e<"u"&&($e.type="boolean",$e.default=Me),super(X,ge,Me,$e)}validate(X){return a(X,this.defaultValue)}}function v(Q,X,ge,Me){if(typeof Q>"u")return X;let $e=parseInt(Q,10);return isNaN($e)?X:($e=Math.max(ge,$e),$e=Math.min(Me,$e),$e|0)}e.clampedInt=v;class b extends t{static clampedInt(X,ge,Me,$e){return v(X,ge,Me,$e)}constructor(X,ge,Me,$e,Ve,Qe=void 0){typeof Qe<"u"&&(Qe.type="integer",Qe.default=Me,Qe.minimum=$e,Qe.maximum=Ve),super(X,ge,Me,Qe),this.minimum=$e,this.maximum=Ve}validate(X){return b.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class E extends t{static clamp(X,ge,Me){return X<ge?ge:X>Me?Me:X}static float(X,ge){if(typeof X=="number")return X;if(typeof X>"u")return ge;const Me=parseFloat(X);return isNaN(Me)?ge:Me}constructor(X,ge,Me,$e,Ve){typeof Ve<"u"&&(Ve.type="number",Ve.default=Me),super(X,ge,Me,Ve),this.validationFn=$e}validate(X){return this.validationFn(E.float(X,this.defaultValue))}}class w extends t{static string(X,ge){return typeof X!="string"?ge:X}constructor(X,ge,Me,$e=void 0){typeof $e<"u"&&($e.type="string",$e.default=Me),super(X,ge,Me,$e)}validate(X){return w.string(X,this.defaultValue)}}function r(Q,X,ge){return typeof Q!="string"||ge.indexOf(Q)===-1?X:Q}e.stringSet=r;class o extends t{constructor(X,ge,Me,$e,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=$e,Ve.default=Me),super(X,ge,Me,Ve),this.c=$e}validate(X){return r(X,this.defaultValue,this.c)}}class s extends D{constructor(X,ge,Me,$e,Ve,Qe,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ve,nt.default=$e),super(X,ge,Me,nt),this.c=Ve,this.d=Qe}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function d(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ge,Me){return Me===0?X.accessibilitySupport:Me}}class u extends D{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:i.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertSpace:a(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function P(Q){switch(Q){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=P;function M(Q){switch(Q){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class V extends f{constructor(){super(135)}compute(X,ge,Me){const $e=["monaco-editor"];return ge.get(36)&&$e.push(ge.get(36)),X.extraEditorClassName&&$e.push(X.extraEditorClassName),ge.get(70)==="default"?$e.push("mouse-default"):ge.get(70)==="copy"&&$e.push("mouse-copy"),ge.get(105)&&$e.push("showUnused"),ge.get(133)&&$e.push("showDeprecated"),$e.join(" ")}}class Z extends l{constructor(){super(34,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(X,ge,Me){return Me&&X.emptySelectionClipboard}}class G extends D{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:i.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:i.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{cursorMoveOnType:a(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":r(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":r(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(ge.loop,this.defaultValue.loop)}}}class R extends D{constructor(){super(48,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?R.OFF:X==="true"?R.ON:X:Boolean(X)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class A extends D{constructor(){super(51,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:i.localize(22,null)},{type:"string",description:i.localize(23,null)}],description:i.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?A.OFF:X==="true"?A.TRANSLATE:X:Boolean(X)?A.TRANSLATE:A.OFF}compute(X,ge,Me){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=A,A.OFF="normal",A.TRANSLATE="translate";class O extends f{constructor(){super(47)}compute(X,ge,Me){return X.fontInfo}}class B extends t{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(25,null)})}validate(X){const ge=E.float(X,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:E.clamp(ge,6,100)}compute(X,ge,Me){return X.fontInfo.fontSize}}class z extends D{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:i.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(b.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class j extends D{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[i.localize(28,null),i.localize(29,null),i.localize(30,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:i.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:i.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:i.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Me,description:i.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Me,description:i.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Me,description:i.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Me,description:i.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Me,description:i.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{multiple:r(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??r(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??r(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??r(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??r(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??r(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends D{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:i.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:i.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:i.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:i.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:a(ge.enabled,this.defaultValue.enabled),delay:b.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:a(ge.sticky,this.defaultValue.sticky),above:a(ge.above,this.defaultValue.above)}}}var ie;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(ie=e.RenderMinimap||(e.RenderMinimap={}));class me extends f{constructor(){super(138)}compute(X,ge,Me){return me.computeLayout(ge,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const ge=X.height/X.lineHeight,Me=Math.floor(X.paddingTop/X.lineHeight);let $e=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&($e=Math.max($e,ge-1));const Ve=(Me+X.viewLineCount+$e)/(X.pixelRatio*X.height),Qe=Math.floor(X.viewLineCount/Ve);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:$e,desiredRatio:Ve,minimapLineCount:Qe}}static c(X,ge){const Me=X.outerWidth,$e=X.outerHeight,Ve=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Qe=ge.stableMinimapLayoutInput,nt=Qe&&X.outerHeight===Qe.outerHeight&&X.lineHeight===Qe.lineHeight&&X.typicalHalfwidthCharacterWidth===Qe.typicalHalfwidthCharacterWidth&&X.pixelRatio===Qe.pixelRatio&&X.scrollBeyondLastLine===Qe.scrollBeyondLastLine&&X.paddingTop===Qe.paddingTop&&X.paddingBottom===Qe.paddingBottom&&X.minimap.enabled===Qe.minimap.enabled&&X.minimap.side===Qe.minimap.side&&X.minimap.size===Qe.minimap.size&&X.minimap.showSlider===Qe.minimap.showSlider&&X.minimap.renderCharacters===Qe.minimap.renderCharacters&&X.minimap.maxColumn===Qe.minimap.maxColumn&&X.minimap.scale===Qe.minimap.scale&&X.verticalScrollbarWidth===Qe.verticalScrollbarWidth&&X.isViewportWrapping===Qe.isViewportWrapping,wt=X.lineHeight,St=X.typicalHalfwidthCharacterWidth,Ct=X.scrollBeyondLastLine,lt=X.minimap.renderCharacters;let at=Ve>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Bt=X.minimap.maxColumn,Ot=X.minimap.size,Ft=X.minimap.side,ft=X.verticalScrollbarWidth,Dt=X.viewLineCount,$t=X.remainingWidth,Nt=X.isViewportWrapping,Ge=lt?2:3;let Mt=Math.floor(Ve*$e);const Lt=Mt/Ve;let Ut=!1,mt=!1,kt=Ge*at,ye=at/Ve,Pe=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:bt,extraLinesBeyondLastLine:vt,desiredRatio:At,minimapLineCount:pt}=me.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Ct,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:$e,lineHeight:wt,pixelRatio:Ve});if(Dt/pt>1)Ut=!0,mt=!0,at=1,kt=1,ye=at/Ve;else{let ht=!1,xt=at+1;if(Ot==="fit"){const jt=Math.ceil((bt+Dt+vt)*kt);Nt&&nt&&$t<=ge.stableFitRemainingWidth?(ht=!0,xt=ge.stableFitMaxMinimapScale):ht=jt>Mt}if(Ot==="fill"||ht){Ut=!0;const jt=at;kt=Math.min(wt*Ve,Math.max(1,Math.floor(1/At))),Nt&&nt&&$t<=ge.stableFitRemainingWidth&&(xt=ge.stableFitMaxMinimapScale),at=Math.min(xt,Math.max(1,Math.floor(kt/Ge))),at>jt&&(Pe=Math.min(2,at/jt)),ye=at/Ve/Pe,Mt=Math.ceil(Math.max(Ze,bt+Dt+vt)*kt),Nt?(ge.stableMinimapLayoutInput=X,ge.stableFitRemainingWidth=$t,ge.stableFitMaxMinimapScale=at):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const fe=Math.floor(Bt*ye),x=Math.min(fe,Math.max(0,Math.floor(($t-ft-2)*ye/(St+ye)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(Ve*x);const Le=Re/Ve;Re=Math.floor(Re*Pe);const _e=lt?1:2,ze=Ft==="left"?0:Me-x-ft;return{renderMinimap:_e,minimapLeft:ze,minimapWidth:x,minimapHeightIsEditorHeight:Ut,minimapIsSampling:mt,minimapScale:at,minimapLineHeight:kt,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Lt}}static computeLayout(X,ge){const Me=ge.outerWidth|0,$e=ge.outerHeight|0,Ve=ge.lineHeight|0,Qe=ge.lineNumbersDigitCount|0,nt=ge.typicalHalfwidthCharacterWidth,wt=ge.maxDigitWidth,St=ge.pixelRatio,Ct=ge.viewLineCount,lt=X.get(130),at=lt==="inherit"?X.get(129):lt,Bt=at==="inherit"?X.get(125):at,Ot=X.get(128),Ft=ge.isDominatedByLongLines,ft=X.get(54),Dt=X.get(64).renderType!==0,$t=X.get(65),Nt=X.get(99),Ge=X.get(80),Mt=X.get(69),Lt=X.get(97),Ut=Lt.verticalScrollbarSize,mt=Lt.verticalHasArrows,kt=Lt.arrowSize,ye=Lt.horizontalScrollbarSize,Pe=X.get(40),fe=X.get(104)!=="never";let x=X.get(62);Pe&&fe&&(x+=16);let Re=0;if(Dt){const _t=Math.max(Qe,$t);Re=Math.round(_t*wt)}let Le=0;ft&&(Le=Ve);let _e=0,ze=_e+Le,Ze=ze+Re,bt=Ze+x;const vt=Me-Le-Re-x;let At=!1,pt=!1,It=-1;at==="inherit"&&Ft?(At=!0,pt=!0):Bt==="on"||Bt==="bounded"?pt=!0:Bt==="wordWrapColumn"&&(It=Ot);const ht=me.c({outerWidth:Me,outerHeight:$e,lineHeight:Ve,typicalHalfwidthCharacterWidth:nt,pixelRatio:St,scrollBeyondLastLine:Nt,paddingTop:Ge.top,paddingBottom:Ge.bottom,minimap:Mt,verticalScrollbarWidth:Ut,viewLineCount:Ct,remainingWidth:vt,isViewportWrapping:pt},ge.memory||new N);ht.renderMinimap!==0&&ht.minimapLeft===0&&(_e+=ht.minimapWidth,ze+=ht.minimapWidth,Ze+=ht.minimapWidth,bt+=ht.minimapWidth);const xt=vt-ht.minimapWidth,jt=Math.max(1,Math.floor((xt-Ut-2)/nt)),Et=mt?kt:0;return pt&&(It=Math.max(1,jt),Bt==="bounded"&&(It=Math.min(It,Ot))),{width:Me,height:$e,glyphMarginLeft:_e,glyphMarginWidth:Le,lineNumbersLeft:ze,lineNumbersWidth:Re,decorationsLeft:Ze,decorationsWidth:x,contentLeft:bt,contentWidth:xt,minimap:ht,viewportColumn:jt,isWordWrapMinified:At,isViewportWrapping:pt,wrappingColumn:It,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:ye,overviewRuler:{top:Et,width:Ut,height:$e-2*Et,right:0}}}}e.EditorLayoutInfoComputer=me;class ue extends D{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(46,null),i.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(48,null)}})}validate(X){return r(X,"simple",["simple","advanced"])}compute(X,ge,Me){return ge.get(2)===2?"advanced":Me}}class oe extends D{constructor(){const X={enabled:!0};super(61,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:i.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:a(X.enabled,this.defaultValue.enabled)}}}class De extends D{constructor(){const X={enabled:!1,maxLineCount:5};super(109,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:i.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:i.localize(51,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:a(ge.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class re extends D{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:i.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(53,null),i.localize(54,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(55,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:i.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:i.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:i.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:r(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(ge.fontFamily,this.defaultValue.fontFamily),padding:a(ge.padding,this.defaultValue.padding)}}}class _ extends D{constructor(){super(62,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):b.clampedInt(X,this.defaultValue,0,1e3)}compute(X,ge,Me){return Me<0?b.clampedInt(-Me*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Me}}class le extends E{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>E.clamp(X,0,150),{markdownDescription:i.localize(60,null)})}compute(X,ge,Me){return X.fontInfo.lineHeight}}class Ee extends D{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:i.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:i.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)],default:X.size,description:i.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:i.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:i.localize(68,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:i.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:i.localize(71,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:a(ge.enabled,this.defaultValue.enabled),autohide:a(ge.autohide,this.defaultValue.autohide),size:r(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ge.side,this.defaultValue.side,["right","left"]),showSlider:r(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(ge.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(ge.scale,1,1,3),maxColumn:b.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ae(Q){return Q==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Be extends D{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{top:b.clampedInt(ge.top,0,0,1e3),bottom:b.clampedInt(ge.bottom,0,0,1e3)}}}class xe extends D{constructor(){const X={enabled:!0,cycle:!0};super(81,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:i.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:i.localize(75,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:a(ge.enabled,this.defaultValue.enabled),cycle:a(ge.cycle,this.defaultValue.cycle)}}}class Te extends f{constructor(){super(136)}compute(X,ge,Me){return X.pixelRatio}}class Ie extends D{constructor(){const X={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(76,null),i.localize(77,null),i.localize(78,null)]}];super(84,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:X.strings,description:i.localize(79,null)},comments:{anyOf:ge,default:X.comments,description:i.localize(80,null)},other:{anyOf:ge,default:X.other,description:i.localize(81,null)}},default:X,markdownDescription:i.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const St=X?"on":"off";return{comments:St,strings:St,other:St}}if(!X||typeof X!="object")return this.defaultValue;const{other:ge,comments:Me,strings:$e}=X,Ve=["on","inline","off"];let Qe,nt,wt;return typeof ge=="boolean"?Qe=ge?"on":"off":Qe=r(ge,this.defaultValue.other,Ve),typeof Me=="boolean"?nt=Me?"on":"off":nt=r(Me,this.defaultValue.comments,Ve),typeof $e=="boolean"?wt=$e?"on":"off":wt=r($e,this.defaultValue.strings,Ve),{other:Qe,comments:nt,strings:wt}}}var Se;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(Se=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends D{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(83,null),i.localize(84,null),i.localize(85,null),i.localize(86,null)],default:"on",description:i.localize(87,null)})}validate(X){let ge=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(ge=4,Me=X):X==="interval"?ge=3:X==="relative"?ge=2:X==="on"?ge=1:ge=0),{renderType:ge,renderFn:Me}}}function ce(Q){const X=Q.get(92);return X==="editable"?Q.get(86):X!=="on"}e.filterValidationDecorations=ce;class Y extends D{constructor(){const X=[],ge={type:"number",description:i.localize(88,null)};super(96,"rulers",X,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:i.localize(89,null),format:"color-hex"}}}]},default:X,description:i.localize(90,null)})}validate(X){if(Array.isArray(X)){const ge=[];for(const Me of X)if(typeof Me=="number")ge.push({column:b.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const $e=Me;ge.push({column:b.clampedInt($e.column,0,0,1e4),color:$e.color})}return ge.sort((Me,$e)=>Me.column-$e.column),ge}return this.defaultValue}}function I(Q,X){if(typeof Q!="string")return X;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends D{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(91,null),i.localize(92,null),i.localize(93,null)],default:"auto",description:i.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(95,null),i.localize(96,null),i.localize(97,null)],default:"auto",description:i.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:i.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:i.localize(101,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X,Me=b.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=b.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(ge.vertical,this.defaultValue.vertical),horizontal:I(ge.horizontal,this.defaultValue.horizontal),useShadows:a(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:b.clampedInt(ge.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:b.clampedInt(ge.verticalSliderSize,$e,0,1e3),scrollByPage:a(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends D{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:i.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:i.localize(108,null)}})}applyUpdate(X,ge){let Me=!1;ge.allowedCharacters&&X&&(C.equals(X.allowedCharacters,ge.allowedCharacters)||(X={...X,allowedCharacters:ge.allowedCharacters},Me=!0)),ge.allowedLocales&&X&&(C.equals(X.allowedLocales,ge.allowedLocales)||(X={...X,allowedLocales:ge.allowedLocales},Me=!0));const $e=super.applyUpdate(X,ge);return Me?new g($e.newValue,!0):$e}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{nonBasicASCII:we(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:a(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:a(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:we(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:we(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,ge){if(typeof X!="object"||!X)return ge;const Me={};for(const[$e,Ve]of Object.entries(X))Ve===!0&&(Me[$e]=!0);return Me}}class q extends D{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:i.localize(109,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:a(ge.enabled,this.defaultValue.enabled),mode:r(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class J extends D{constructor(){const X={enabled:F.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:i.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:i.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:a(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:a(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class de extends D{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(112,null),i.localize(113,null),i.localize(114,null)],default:X.bracketPairs,description:i.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(116,null),i.localize(117,null),i.localize(118,null)],default:X.bracketPairsHorizontal,description:i.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:i.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:i.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(122,null),i.localize(123,null),i.localize(124,null)],default:X.highlightActiveIndentation,description:i.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{bracketPairs:we(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:we(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:we(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function we(Q,X,ge){const Me=ge.indexOf(Q);return Me===-1?X:ge[Me]}class ae extends D{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(126,null),i.localize(127,null)],default:X.insertMode,description:i.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:i.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:i.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:i.localize(131,null)},"editor.suggest.selectQuickSuggestions":{type:"boolean",default:X.selectQuickSuggestions,markdownDescription:i.localize(132,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:i.localize(133,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:i.localize(134,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:i.localize(135,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:i.localize(136,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:i.localize(137,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(138,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(139,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(140,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(141,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(142,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(143,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(169,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertMode:r(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:a(ge.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:a(ge.showIcons,this.defaultValue.showIcons),showStatusBar:a(ge.showStatusBar,this.defaultValue.showStatusBar),preview:a(ge.preview,this.defaultValue.preview),previewMode:r(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(ge.showMethods,this.defaultValue.showMethods),showFunctions:a(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:a(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:a(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:a(ge.showFields,this.defaultValue.showFields),showVariables:a(ge.showVariables,this.defaultValue.showVariables),showClasses:a(ge.showClasses,this.defaultValue.showClasses),showStructs:a(ge.showStructs,this.defaultValue.showStructs),showInterfaces:a(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:a(ge.showModules,this.defaultValue.showModules),showProperties:a(ge.showProperties,this.defaultValue.showProperties),showEvents:a(ge.showEvents,this.defaultValue.showEvents),showOperators:a(ge.showOperators,this.defaultValue.showOperators),showUnits:a(ge.showUnits,this.defaultValue.showUnits),showValues:a(ge.showValues,this.defaultValue.showValues),showConstants:a(ge.showConstants,this.defaultValue.showConstants),showEnums:a(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:a(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(ge.showKeywords,this.defaultValue.showKeywords),showWords:a(ge.showWords,this.defaultValue.showWords),showColors:a(ge.showColors,this.defaultValue.showColors),showFiles:a(ge.showFiles,this.defaultValue.showFiles),showReferences:a(ge.showReferences,this.defaultValue.showReferences),showFolders:a(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:a(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(ge.showSnippets,this.defaultValue.showSnippets),showUsers:a(ge.showUsers,this.defaultValue.showUsers),showIssues:a(ge.showIssues,this.defaultValue.showIssues)}}}class pe extends D{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(170,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ve extends f{constructor(){super(137)}compute(X,ge,Me){return ge.get(86)?!0:X.tabFocusMode}}var We;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(We=e.WrappingIndent||(e.WrappingIndent={}));class He extends D{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(171,null),i.localize(172,null),i.localize(173,null),i.localize(174,null)],description:i.localize(175,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,ge,Me){return ge.get(2)===2?0:Me}}class tt extends f{constructor(){super(139)}compute(X,ge,Me){const $e=ge.get(138);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}class Xe extends D{constructor(){const X={enabled:!0};super(33,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:i.localize(176,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:a(X.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?it:T.isLinux?dt:et,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var st;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.guides=13]="guides",Q[Q.codeLens=14]="codeLens",Q[Q.codeLensFontFamily=15]="codeLensFontFamily",Q[Q.codeLensFontSize=16]="codeLensFontSize",Q[Q.colorDecorators=17]="colorDecorators",Q[Q.colorDecoratorsLimit=18]="colorDecoratorsLimit",Q[Q.columnSelection=19]="columnSelection",Q[Q.comments=20]="comments",Q[Q.contextmenu=21]="contextmenu",Q[Q.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=23]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=25]="cursorStyle",Q[Q.cursorSurroundingLines=26]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=28]="cursorWidth",Q[Q.disableLayerHinting=29]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Q[Q.domReadOnly=31]="domReadOnly",Q[Q.dragAndDrop=32]="dragAndDrop",Q[Q.dropIntoEditor=33]="dropIntoEditor",Q[Q.emptySelectionClipboard=34]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=36]="extraEditorClassName",Q[Q.fastScrollSensitivity=37]="fastScrollSensitivity",Q[Q.find=38]="find",Q[Q.fixedOverflowWidgets=39]="fixedOverflowWidgets",Q[Q.folding=40]="folding",Q[Q.foldingStrategy=41]="foldingStrategy",Q[Q.foldingHighlight=42]="foldingHighlight",Q[Q.foldingImportsByDefault=43]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=44]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=46]="fontFamily",Q[Q.fontInfo=47]="fontInfo",Q[Q.fontLigatures=48]="fontLigatures",Q[Q.fontSize=49]="fontSize",Q[Q.fontWeight=50]="fontWeight",Q[Q.fontVariations=51]="fontVariations",Q[Q.formatOnPaste=52]="formatOnPaste",Q[Q.formatOnType=53]="formatOnType",Q[Q.glyphMargin=54]="glyphMargin",Q[Q.gotoLocation=55]="gotoLocation",Q[Q.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Q[Q.hover=57]="hover",Q[Q.inDiffEditor=58]="inDiffEditor",Q[Q.inlineSuggest=59]="inlineSuggest",Q[Q.letterSpacing=60]="letterSpacing",Q[Q.lightbulb=61]="lightbulb",Q[Q.lineDecorationsWidth=62]="lineDecorationsWidth",Q[Q.lineHeight=63]="lineHeight",Q[Q.lineNumbers=64]="lineNumbers",Q[Q.lineNumbersMinChars=65]="lineNumbersMinChars",Q[Q.linkedEditing=66]="linkedEditing",Q[Q.links=67]="links",Q[Q.matchBrackets=68]="matchBrackets",Q[Q.minimap=69]="minimap",Q[Q.mouseStyle=70]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=72]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=74]="multiCursorModifier",Q[Q.multiCursorPaste=75]="multiCursorPaste",Q[Q.multiCursorLimit=76]="multiCursorLimit",Q[Q.occurrencesHighlight=77]="occurrencesHighlight",Q[Q.overviewRulerBorder=78]="overviewRulerBorder",Q[Q.overviewRulerLanes=79]="overviewRulerLanes",Q[Q.padding=80]="padding",Q[Q.parameterHints=81]="parameterHints",Q[Q.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=84]="quickSuggestions",Q[Q.quickSuggestionsDelay=85]="quickSuggestionsDelay",Q[Q.readOnly=86]="readOnly",Q[Q.renameOnType=87]="renameOnType",Q[Q.renderControlCharacters=88]="renderControlCharacters",Q[Q.renderFinalNewline=89]="renderFinalNewline",Q[Q.renderLineHighlight=90]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=92]="renderValidationDecorations",Q[Q.renderWhitespace=93]="renderWhitespace",Q[Q.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Q[Q.roundedSelection=95]="roundedSelection",Q[Q.rulers=96]="rulers",Q[Q.scrollbar=97]="scrollbar",Q[Q.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=99]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=100]="scrollPredominantAxis",Q[Q.selectionClipboard=101]="selectionClipboard",Q[Q.selectionHighlight=102]="selectionHighlight",Q[Q.selectOnLineNumbers=103]="selectOnLineNumbers",Q[Q.showFoldingControls=104]="showFoldingControls",Q[Q.showUnused=105]="showUnused",Q[Q.snippetSuggestions=106]="snippetSuggestions",Q[Q.smartSelect=107]="smartSelect",Q[Q.smoothScrolling=108]="smoothScrolling",Q[Q.stickyScroll=109]="stickyScroll",Q[Q.stickyTabStops=110]="stickyTabStops",Q[Q.stopRenderingLineAfter=111]="stopRenderingLineAfter",Q[Q.suggest=112]="suggest",Q[Q.suggestFontSize=113]="suggestFontSize",Q[Q.suggestLineHeight=114]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Q[Q.suggestSelection=116]="suggestSelection",Q[Q.tabCompletion=117]="tabCompletion",Q[Q.tabIndex=118]="tabIndex",Q[Q.unicodeHighlighting=119]="unicodeHighlighting",Q[Q.unusualLineTerminators=120]="unusualLineTerminators",Q[Q.useShadowDOM=121]="useShadowDOM",Q[Q.useTabStops=122]="useTabStops",Q[Q.wordBreak=123]="wordBreak",Q[Q.wordSeparators=124]="wordSeparators",Q[Q.wordWrap=125]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=128]="wordWrapColumn",Q[Q.wordWrapOverride1=129]="wordWrapOverride1",Q[Q.wordWrapOverride2=130]="wordWrapOverride2",Q[Q.wrappingIndent=131]="wrappingIndent",Q[Q.wrappingStrategy=132]="wrappingStrategy",Q[Q.showDeprecated=133]="showDeprecated",Q[Q.inlayHints=134]="inlayHints",Q[Q.editorClassName=135]="editorClassName",Q[Q.pixelRatio=136]="pixelRatio",Q[Q.tabFocusMode=137]="tabFocusMode",Q[Q.layoutInfo=138]="layoutInfo",Q[Q.wrappingInfo=139]="wrappingInfo"})(st=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(177,null)})),acceptSuggestionOnEnter:Fe(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(178,null),""],markdownDescription:i.localize(179,null)})),accessibilitySupport:Fe(new c),accessibilityPageSize:Fe(new b(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(180,null),tags:["accessibility"]})),ariaLabel:Fe(new w(4,"ariaLabel",i.localize(181,null))),autoClosingBrackets:Fe(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(182,null),i.localize(183,null),""],description:i.localize(184,null)})),autoClosingDelete:Fe(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(185,null),""],description:i.localize(186,null)})),autoClosingOvertype:Fe(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(187,null),""],description:i.localize(188,null)})),autoClosingQuotes:Fe(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(189,null),i.localize(190,null),""],description:i.localize(191,null)})),autoIndent:Fe(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[i.localize(192,null),i.localize(193,null),i.localize(194,null),i.localize(195,null),i.localize(196,null)],description:i.localize(197,null)})),automaticLayout:Fe(new l(10,"automaticLayout",!1)),autoSurround:Fe(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(198,null),i.localize(199,null),i.localize(200,null),""],description:i.localize(201,null)})),bracketPairColorization:Fe(new J),bracketPairGuides:Fe(new de),stickyTabStops:Fe(new l(110,"stickyTabStops",!1,{description:i.localize(202,null)})),codeLens:Fe(new l(14,"codeLens",!0,{description:i.localize(203,null)})),codeLensFontFamily:Fe(new w(15,"codeLensFontFamily","",{description:i.localize(204,null)})),codeLensFontSize:Fe(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(205,null)})),colorDecorators:Fe(new l(17,"colorDecorators",!0,{description:i.localize(206,null)})),colorDecoratorsLimit:Fe(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:i.localize(207,null)})),columnSelection:Fe(new l(19,"columnSelection",!1,{description:i.localize(208,null)})),comments:Fe(new u),contextmenu:Fe(new l(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new l(22,"copyWithSyntaxHighlighting",!0,{description:i.localize(209,null)})),cursorBlinking:Fe(new s(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:i.localize(210,null)})),cursorSmoothCaretAnimation:Fe(new o(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[i.localize(211,null),i.localize(212,null),i.localize(213,null)],description:i.localize(214,null)})),cursorStyle:Fe(new s(25,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:i.localize(215,null)})),cursorSurroundingLines:Fe(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(216,null)})),cursorSurroundingLinesStyle:Fe(new o(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(217,null),i.localize(218,null)],description:i.localize(219,null)})),cursorWidth:Fe(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(220,null)})),disableLayerHinting:Fe(new l(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new l(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new l(31,"domReadOnly",!1)),dragAndDrop:Fe(new l(32,"dragAndDrop",!0,{description:i.localize(221,null)})),emptySelectionClipboard:Fe(new Z),dropIntoEditor:Fe(new Xe),stickyScroll:Fe(new De),experimentalWhitespaceRendering:Fe(new o(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[i.localize(222,null),i.localize(223,null),i.localize(224,null)],description:i.localize(225,null)})),extraEditorClassName:Fe(new w(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new E(37,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:i.localize(226,null)})),find:Fe(new G),fixedOverflowWidgets:Fe(new l(39,"fixedOverflowWidgets",!1)),folding:Fe(new l(40,"folding",!0,{description:i.localize(227,null)})),foldingStrategy:Fe(new o(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(228,null),i.localize(229,null)],description:i.localize(230,null)})),foldingHighlight:Fe(new l(42,"foldingHighlight",!0,{description:i.localize(231,null)})),foldingImportsByDefault:Fe(new l(43,"foldingImportsByDefault",!1,{description:i.localize(232,null)})),foldingMaximumRegions:Fe(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(233,null)})),unfoldOnClickAfterEndOfLine:Fe(new l(45,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(234,null)})),fontFamily:Fe(new w(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(235,null)})),fontInfo:Fe(new O),fontLigatures2:Fe(new R),fontSize:Fe(new B),fontWeight:Fe(new z),fontVariations:Fe(new A),formatOnPaste:Fe(new l(52,"formatOnPaste",!1,{description:i.localize(236,null)})),formatOnType:Fe(new l(53,"formatOnType",!1,{description:i.localize(237,null)})),glyphMargin:Fe(new l(54,"glyphMargin",!0,{description:i.localize(238,null)})),gotoLocation:Fe(new j),hideCursorInOverviewRuler:Fe(new l(56,"hideCursorInOverviewRuler",!1,{description:i.localize(239,null)})),hover:Fe(new K),inDiffEditor:Fe(new l(58,"inDiffEditor",!1)),letterSpacing:Fe(new E(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>E.clamp(Q,-5,20),{description:i.localize(240,null)})),lightbulb:Fe(new oe),lineDecorationsWidth:Fe(new _),lineHeight:Fe(new le),lineNumbers:Fe(new se),lineNumbersMinChars:Fe(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new l(66,"linkedEditing",!1,{description:i.localize(241,null)})),links:Fe(new l(67,"links",!0,{description:i.localize(242,null)})),matchBrackets:Fe(new o(68,"matchBrackets","always",["always","near","never"],{description:i.localize(243,null)})),minimap:Fe(new Ee),mouseStyle:Fe(new o(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new E(71,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:i.localize(244,null)})),mouseWheelZoom:Fe(new l(72,"mouseWheelZoom",!1,{markdownDescription:i.localize(245,null)})),multiCursorMergeOverlapping:Fe(new l(73,"multiCursorMergeOverlapping",!0,{description:i.localize(246,null)})),multiCursorModifier:Fe(new s(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ae,{markdownEnumDescriptions:[i.localize(247,null),i.localize(248,null)],markdownDescription:i.localize(249,null)})),multiCursorPaste:Fe(new o(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(250,null),i.localize(251,null)],markdownDescription:i.localize(252,null)})),multiCursorLimit:Fe(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(253,null)})),occurrencesHighlight:Fe(new l(77,"occurrencesHighlight",!0,{description:i.localize(254,null)})),overviewRulerBorder:Fe(new l(78,"overviewRulerBorder",!0,{description:i.localize(255,null)})),overviewRulerLanes:Fe(new b(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Be),parameterHints:Fe(new xe),peekWidgetDefaultFocus:Fe(new o(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(256,null),i.localize(257,null)],description:i.localize(258,null)})),definitionLinkOpensInPeek:Fe(new l(83,"definitionLinkOpensInPeek",!1,{description:i.localize(259,null)})),quickSuggestions:Fe(new Ie),quickSuggestionsDelay:Fe(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(260,null)})),readOnly:Fe(new l(86,"readOnly",!1)),renameOnType:Fe(new l(87,"renameOnType",!1,{description:i.localize(261,null),markdownDeprecationMessage:i.localize(262,null)})),renderControlCharacters:Fe(new l(88,"renderControlCharacters",!0,{description:i.localize(263,null),restricted:!0})),renderFinalNewline:Fe(new o(89,"renderFinalNewline",T.isLinux?"dimmed":"on",["off","on","dimmed"],{description:i.localize(264,null)})),renderLineHighlight:Fe(new o(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(265,null)],description:i.localize(266,null)})),renderLineHighlightOnlyWhenFocus:Fe(new l(91,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(267,null)})),renderValidationDecorations:Fe(new o(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new o(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(268,null),i.localize(269,null),i.localize(270,null),""],description:i.localize(271,null)})),revealHorizontalRightPadding:Fe(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new l(95,"roundedSelection",!0,{description:i.localize(272,null)})),rulers:Fe(new Y),scrollbar:Fe(new $),scrollBeyondLastColumn:Fe(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(273,null)})),scrollBeyondLastLine:Fe(new l(99,"scrollBeyondLastLine",!0,{description:i.localize(274,null)})),scrollPredominantAxis:Fe(new l(100,"scrollPredominantAxis",!0,{description:i.localize(275,null)})),selectionClipboard:Fe(new l(101,"selectionClipboard",!0,{description:i.localize(276,null),included:T.isLinux})),selectionHighlight:Fe(new l(102,"selectionHighlight",!0,{description:i.localize(277,null)})),selectOnLineNumbers:Fe(new l(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new o(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(278,null),i.localize(279,null),i.localize(280,null)],description:i.localize(281,null)})),showUnused:Fe(new l(105,"showUnused",!0,{description:i.localize(282,null)})),showDeprecated:Fe(new l(133,"showDeprecated",!0,{description:i.localize(283,null)})),inlayHints:Fe(new re),snippetSuggestions:Fe(new o(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(284,null),i.localize(285,null),i.localize(286,null),i.localize(287,null)],description:i.localize(288,null)})),smartSelect:Fe(new pe),smoothScrolling:Fe(new l(108,"smoothScrolling",!1,{description:i.localize(289,null)})),stopRenderingLineAfter:Fe(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ae),inlineSuggest:Fe(new q),suggestFontSize:Fe(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(290,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(291,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new l(115,"suggestOnTriggerCharacters",!0,{description:i.localize(292,null)})),suggestSelection:Fe(new o(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(293,null),i.localize(294,null),i.localize(295,null)],description:i.localize(296,null)})),tabCompletion:Fe(new o(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(297,null),i.localize(298,null),i.localize(299,null)],description:i.localize(300,null)})),tabIndex:Fe(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new H),unusualLineTerminators:Fe(new o(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(301,null),i.localize(302,null),i.localize(303,null)],description:i.localize(304,null)})),useShadowDOM:Fe(new l(121,"useShadowDOM",!0)),useTabStops:Fe(new l(122,"useTabStops",!0,{description:i.localize(305,null)})),wordBreak:Fe(new o(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(306,null),i.localize(307,null)],description:i.localize(308,null)})),wordSeparators:Fe(new w(124,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:i.localize(309,null)})),wordWrap:Fe(new o(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(310,null),i.localize(311,null),i.localize(312,null),i.localize(313,null)],description:i.localize(314,null)})),wordWrapBreakAfterCharacters:Fe(new w(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new w(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(315,null)})),wordWrapOverride1:Fe(new o(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new o(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new V),pixelRatio:Fe(new Te),tabFocusMode:Fe(new ve),layoutInfo:Fe(new me),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new He),wrappingStrategy:Fe(new ue)}}),define(Ce[128],ke([17,18]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[129],ke([17,18]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[130],ke([17,18]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[131],ke([17,18]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ce[132],ke([17,18]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ce[133],ke([17,18]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ce[134],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[135],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[136],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[137],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[138],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[139],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[140],ke([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[141],ke([17,18]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ce[142],ke([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[143],ke([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[144],ke([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[145],ke([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[146],ke([17,18]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[147],ke([17,18]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[148],ke([17,18]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[149],ke([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this.a=new Map}register(L,C){this.a.set(L,C)}updateManifest(L){if(!(typeof L.main>"u"&&typeof L.browser>"u")&&(L.activationEvents===void 0&&Object.assign(L,{activationEvents:[]}),!(!Array.isArray(L.activationEvents)||!L.contributes)))for(const C in L.contributes){const F=this.a.get(C);if(!F)continue;const S=L.contributes[C],k=Array.isArray(S)?S:[S];try{F(k,L.activationEvents)}catch(N){(0,i.onUnexpectedError)(N)}}}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T}),define(Ce[150],ke([1,0,22,29,130,248]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,F=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||C.test(l)}e.isValidVersionStr=S;function k(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=l.match(C);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=k;function N(l){if(!l)return null;const v=l.majorBase,b=l.majorMustEqual,E=l.minorBase;let w=l.minorMustEqual;const r=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(v===0||(w=!1),o=!1);let s=0;if(l.preRelease){const d=F.exec(l.preRelease);if(d){const[,c,u,n]=d;s=Date.UTC(Number(c),Number(u)-1,Number(n))}}return{majorBase:v,majorMustEqual:b,minorBase:E,minorMustEqual:w,patchBase:r,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:s}}e.normalizeVersion=N;function D(l,v,b){let E;typeof l=="string"?E=N(k(l)):E=l;let w;v instanceof Date?w=v.getTime():typeof v=="string"&&(w=new Date(v).getTime());let r;if(typeof b=="string"?r=N(k(b)):r=b,!E||!r)return!1;const o=E.majorBase,s=E.minorBase,d=E.patchBase;let c=r.majorBase,u=r.minorBase,n=r.patchBase;const h=r.notBefore;let m=r.majorMustEqual,P=r.minorMustEqual,M=r.patchMustEqual;return r.isMinimum?o>c?!0:o<c?!1:s>u?!0:s<u||w&&w<h?!1:d>=n:(o===1&&c===0&&(!m||!P||!M)&&(c=1,u=0,n=0,m=!0,P=!1,M=!1),o<c?!1:o>c?!m:s<u?!1:s>u?!P:d<n?!1:d>n?!M:!(w&&w<h))}e.isValidVersion=D;function g(l,v,b,E,w){const r=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return r.push([T.default.Error,y.localize(0,null)]),r;if(typeof E.name!="string")return r.push([T.default.Error,y.localize(1,null,"name")]),r;if(typeof E.version!="string")return r.push([T.default.Error,y.localize(2,null,"version")]),r;if(!E.engines)return r.push([T.default.Error,y.localize(3,null,"engines")]),r;if(typeof E.engines.vscode!="string")return r.push([T.default.Error,y.localize(4,null,"engines.vscode")]),r;if(typeof E.extensionDependencies<"u"&&!a(E.extensionDependencies))return r.push([T.default.Error,y.localize(5,null,"extensionDependencies")]),r;if(typeof E.activationEvents<"u"){if(!a(E.activationEvents))return r.push([T.default.Error,y.localize(6,null,"activationEvents")]),r;if(typeof E.main>"u"&&typeof E.browser>"u")return r.push([T.default.Error,y.localize(7,null,"activationEvents","main")]),r}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&r.push([T.default.Warning,y.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return r.push([T.default.Error,y.localize(9,null,"main")]),r;{const d=(0,i.joinPath)(b,E.main);(0,i.isEqualOrParent)(d,b)||r.push([T.default.Warning,y.localize(10,null,d.path,b.path)])}if(typeof E.activationEvents>"u")return r.push([T.default.Error,y.localize(11,null,"activationEvents","main")]),r}if(typeof E.browser<"u"){if(typeof E.browser!="string")return r.push([T.default.Error,y.localize(12,null,"browser")]),r;{const d=(0,i.joinPath)(b,E.browser);(0,i.isEqualOrParent)(d,b)||r.push([T.default.Warning,y.localize(13,null,d.path,b.path)])}if(typeof E.activationEvents>"u")return r.push([T.default.Error,y.localize(14,null,"activationEvents","browser")]),r}if(!L.valid(E.version))return r.push([T.default.Error,y.localize(15,null)]),r;const o=[];if(!p(l,v,E,w,o))for(const d of o)r.push([T.default.Error,d]);return r}e.validateExtensionManifest=g;function p(l,v,b,E,w){return E||typeof b.main>"u"&&typeof b.browser>"u"?!0:t(l,v,b.engines.vscode,w)}e.isValidExtensionVersion=p;function f(l,v,b){return l==="*"||t(v,b,l)}e.isEngineValid=f;function t(l,v,b,E=[]){const w=N(k(b));if(!w)return E.push(y.localize(16,null,b)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return E.push(y.localize(17,null,b)),!1}else if(!w.majorMustEqual)return E.push(y.localize(18,null,b)),!1;return D(l,v,w)?!0:(E.push(y.localize(19,null,l,b)),!1)}function a(l){if(!Array.isArray(l))return!1;for(let v=0,b=l.length;v<b;v++)if(typeof l[v]!="string")return!1;return!0}}),define(Ce[86],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(y,L=[],C=!1){this.ctor=y,this.staticArguments=L,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=i}),define(Ce[63],ke([1,0,86]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var y;(function(F){F[F.Eager=0]="Eager",F[F.Delayed=1]="Delayed"})(y=e.InstantiationType||(e.InstantiationType={}));function L(F,S,k){S instanceof i.SyncDescriptor||(S=new i.SyncDescriptor(S,[],Boolean(k))),T.push([F,S])}e.registerSingleton=L;function C(){return T}e.getSingletonServiceDescriptors=C}),define(Ce[151],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(L,C){this.key=L,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class T{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const C of this.a.values())C.outgoing.size===0&&L.push(C);return L}insertEdge(L,C){const F=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(C);F.outgoing.set(S.key,S),S.incoming.set(F.key,F)}removeNode(L){const C=this.b(L);this.a.delete(C);for(const F of this.a.values())F.outgoing.delete(C),F.incoming.delete(C)}lookupOrInsertNode(L){const C=this.b(L);let F=this.a.get(C);return F||(F=new i(C,L),this.a.set(C,F)),F}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[C,F]of this.a)L.push(`${C}
	(-> incoming)[${[...F.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...F.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,C]of this.a){const F=new Set([L]),S=this.c(C,F);if(S)return S}}c(L,C){for(const[F,S]of L.outgoing){if(C.has(F))return[...C,F].join(" -> ");C.add(F);const k=this.c(S,C);if(k)return k;C.delete(F)}}}e.Graph=T}),define(Ce[3],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function F(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=F})(i=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function T(C,F,S){F[i.DI_TARGET]===F?F[i.DI_DEPENDENCIES].push({id:C,index:S}):(F[i.DI_DEPENDENCIES]=[{id:C,index:S}],F[i.DI_TARGET]=F)}function y(C){if(i.serviceIds.has(C))return i.serviceIds.get(C);const F=function(S,k,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(F,S,N)};return F.toString=()=>C,i.serviceIds.set(C,F),F}e.createDecorator=y;function L(C){return C}e.refineServiceDecorator=L}),define(Ce[40],ke([1,0,9,2,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationOverrides=L;function C(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=C;var F;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(F=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function k(l,v){const b=Object.create(null);for(const E in l)N(b,E,l[E],v);return b}e.toValuesTree=k;function N(l,v,b,E){const w=v.split("."),r=w.pop();let o=l;for(let s=0;s<w.length;s++){const d=w[s];let c=o[d];switch(typeof c){case"undefined":c=o[d]=Object.create(null);break;case"object":break;default:E(`Ignoring ${v} as ${w.slice(0,s+1).join(".")} is ${JSON.stringify(c)}`);return}o=c}if(typeof o=="object"&&o!==null)try{o[r]=b}catch{E(`Ignoring ${v} as ${w.join(".")} is ${JSON.stringify(o)}`)}else E(`Ignoring ${v} as ${w.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=N;function D(l,v){const b=v.split(".");g(l,b)}e.removeFromValueTree=D;function g(l,v){const b=v.shift();if(v.length===0){delete l[b];return}if(Object.keys(l).indexOf(b)!==-1){const E=l[b];typeof E=="object"&&!Array.isArray(E)&&(g(E,v),Object.keys(E).length===0&&delete l[b])}}function p(l,v,b){function E(o,s){let d=o;for(const c of s){if(typeof d!="object"||d===null)return;d=d[c]}return d}const w=v.split("."),r=E(l,w);return typeof r>"u"?b:r}e.getConfigurationValue=p;function f(l,v,b){Object.keys(v).forEach(E=>{E!=="__proto__"&&(E in l?i.isObject(l[E])&&i.isObject(v[E])?f(l[E],v[E],b):b&&(l[E]=v[E]):l[E]=v[E])})}e.merge=f;function t(l,v,b){const E=l.inspect(v),w=l.inspect(b);return typeof E.userValue<"u"||typeof E.workspaceValue<"u"||typeof E.workspaceFolderValue<"u"?E.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:E.defaultValue}e.getMigratedSettingValue=t;function a(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=a}),define(Ce[41],ke([1,0,21,10,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",i.isMacintosh),L.set("isLinux",i.isLinux),L.set("isWindows",i.isWindows),L.set("isWeb",i.isWeb),L.set("isMacNative",i.isMacintosh&&!i.isWeb),L.set("isEdge",i.isEdge),L.set("isFirefox",i.isFirefox),L.set("isChrome",i.isChrome),L.set("isSafari",i.isSafari);const C=Object.prototype.hasOwnProperty;var F;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(F=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return D.INSTANCE}static true(){return g.INSTANCE}static has(R){return p.create(R)}static equals(R,A){return f.create(R,A)}static notEquals(R,A){return l.create(R,A)}static regex(R,A){return s.create(R,A)}static in(R,A){return t.create(R,A)}static notIn(R,A){return a.create(R,A)}static not(R){return v.create(R)}static and(...R){return u.create(R,null,!0)}static or(...R){return n.create(R,null,!0)}static greater(R,A){return E.create(R,A)}static greaterEquals(R,A){return w.create(R,A)}static smaller(R,A){return r.create(R,A)}static smallerEquals(R,A){return o.create(R,A)}static deserialize(R,A=!1){if(!!R)return this.c(R,A)}static c(R,A){const O=R.split("||");return n.create(O.map(B=>this.d(B,A)),null,!0)}static d(R,A){const O=R.split("&&");return u.create(O.map(B=>this.f(B,A)),null,!0)}static f(R,A){if(R=R.trim(),R.indexOf("!=")>=0){const O=R.split("!=");return l.create(O[0].trim(),this.g(O[1],A))}if(R.indexOf("==")>=0){const O=R.split("==");return f.create(O[0].trim(),this.g(O[1],A))}if(R.indexOf("=~")>=0){const O=R.split("=~");return s.create(O[0].trim(),this.h(O[1],A))}if(R.indexOf(" not in ")>=0){const O=R.split(" not in ");return a.create(O[0].trim(),this.g(O[1],A))}if(R.indexOf(" in ")>=0){const O=R.split(" in ");return t.create(O[0].trim(),this.g(O[1],A))}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const O=R.split(">=");return w.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const O=R.split(">");return E.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const O=R.split("<=");return o.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const O=R.split("<");return r.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(R)?v.create(R.substr(1).trim()):p.create(R)}static g(R,A){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;const O=/^'([^']*)'$/.exec(R);return O?O[1].trim():R}static h(R,A){if((0,T.isFalsyOrWhitespace)(R)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const O=R.indexOf("/"),B=R.lastIndexOf("/");if(O===B||O<0){if(A)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}const z=R.slice(O+1,B),j=R[B+1]==="i"?"i":"";try{return new RegExp(z,j)}catch(K){if(A)throw new Error(`bad regexp-value '${R}', parse error: ${K}`);return console.warn(`bad regexp-value '${R}', parse error: ${K}`),null}}}e.ContextKeyExpr=S;function k(G,R){const A=G?G.substituteConstants():void 0,O=R?R.substituteConstants():void 0;return!A&&!O?!0:!A||!O?!1:A.equals(O)}e.expressionsAreEqualWithConstantSubstitution=k;function N(G,R){return G.cmp(R)}class D{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=D,D.INSTANCE=new D;class g{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return D.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class p{static create(R,A=null){const O=L.get(R);return typeof O=="boolean"?O?g.INSTANCE:D.INSTANCE:new p(R,A)}constructor(R,A){this.key=R,this.c=A,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:m(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=L.get(this.key);return typeof R=="boolean"?R?g.INSTANCE:D.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=v.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=p;class f{static create(R,A,O=null){if(typeof A=="boolean")return A?p.create(R,O):v.create(R,O);const B=L.get(R);return typeof B=="boolean"?A===(B?"true":"false")?g.INSTANCE:D.INSTANCE:new f(R,A,O)}constructor(R,A,O){this.c=R,this.d=A,this.f=O,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=L.get(this.c);if(typeof R=="boolean"){const A=R?"true":"false";return this.d===A?g.INSTANCE:D.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class t{static create(R,A){return new t(R,A)}constructor(R,A){this.d=R,this.f=A,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:P(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const A=R.getValue(this.f),O=R.getValue(this.d);return Array.isArray(A)?A.includes(O):typeof O=="string"&&typeof A=="object"&&A!==null?C.call(A,O):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=a.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=t;class a{static create(R,A){return new a(R,A)}constructor(R,A){this.d=R,this.f=A,this.type=11,this.c=t.create(R,A)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=a;class l{static create(R,A,O=null){if(typeof A=="boolean")return A?v.create(R,O):p.create(R,O);const B=L.get(R);return typeof B=="boolean"?A===(B?"true":"false")?D.INSTANCE:g.INSTANCE:new l(R,A,O)}constructor(R,A,O){this.c=R,this.d=A,this.f=O,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=L.get(this.c);if(typeof R=="boolean"){const A=R?"true":"false";return this.d===A?D.INSTANCE:g.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class v{static create(R,A=null){const O=L.get(R);return typeof O=="boolean"?O?D.INSTANCE:g.INSTANCE:new v(R,A)}constructor(R,A){this.c=R,this.d=A,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:m(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=L.get(this.c);return typeof R=="boolean"?R?D.INSTANCE:g.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.ContextKeyNotExpr=v;function b(G,R){if(typeof G=="string"){const A=parseFloat(G);isNaN(A)||(G=A)}return typeof G=="string"||typeof G=="number"?R(G):D.INSTANCE}class E{static create(R,A,O=null){return b(A,B=>new E(R,B,O))}constructor(R,A,O){this.c=R,this.d=A,this.f=O,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=E;class w{static create(R,A,O=null){return b(A,B=>new w(R,B,O))}constructor(R,A,O){this.c=R,this.d=A,this.f=O,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=w;class r{static create(R,A,O=null){return b(A,B=>new r(R,B,O))}constructor(R,A,O){this.c=R,this.d=A,this.f=O,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=r;class o{static create(R,A,O=null){return b(A,B=>new o(R,B,O))}constructor(R,A,O){this.c=R,this.d=A,this.f=O,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=o;class s{static create(R,A){return new s(R,A)}constructor(R,A){this.d=R,this.f=A,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const A=this.f?this.f.source:"",O=R.f?R.f.source:"";return A<O?-1:A>O?1:0}equals(R){if(R.type===this.type){const A=this.f?this.f.source:"",O=R.f?R.f.source:"";return this.d===R.d&&A===O}return!1}substituteConstants(){return this}evaluate(R){const A=R.getValue(this.d);return this.f?this.f.test(A):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=d.create(this)),this.c}}e.ContextKeyRegexExpr=s;class d{static create(R){return new d(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(R){return new d(this.c.map(R))}negate(){return this.c}}e.ContextKeyNotRegexExpr=d;function c(G){let R=null;for(let A=0,O=G.length;A<O;A++){const B=G[A].substituteConstants();if(G[A]!==B&&R===null){R=[];for(let z=0;z<A;z++)R[z]=G[z]}R!==null&&(R[A]=B)}return R===null?G:R}class u{static create(R,A,O){return u.d(R,A,O)}constructor(R,A){this.expr=R,this.c=A,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let A=0,O=this.expr.length;A<O;A++){const B=N(this.expr[A],R.expr[A]);if(B!==0)return B}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let A=0,O=this.expr.length;A<O;A++)if(!this.expr[A].equals(R.expr[A]))return!1;return!0}return!1}substituteConstants(){const R=c(this.expr);return R===this.expr?this:u.create(R,this.c,!1)}evaluate(R){for(let A=0,O=this.expr.length;A<O;A++)if(!this.expr[A].evaluate(R))return!1;return!0}static d(R,A,O){const B=[];let z=!1;for(const j of R)if(!!j){if(j.type===1){z=!0;continue}if(j.type===0)return D.INSTANCE;if(j.type===6){B.push(...j.expr);continue}B.push(j)}if(B.length===0&&z)return g.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(N);for(let j=1;j<B.length;j++)B[j-1].equals(B[j])&&(B.splice(j,1),j--);if(B.length===1)return B[0];for(;B.length>1;){const j=B[B.length-1];if(j.type!==9)break;B.pop();const K=B.pop(),ie=B.length===0,me=n.create(j.expr.map(ue=>u.create([ue,K],null,O)),null,ie);me&&(B.push(me),B.sort(N))}if(B.length===1)return B[0];if(O){for(let j=0;j<B.length;j++)for(let K=j+1;K<B.length;K++)if(B[j].negate().equals(B[K]))return D.INSTANCE;if(B.length===1)return B[0]}return new u(B,A)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const A of this.expr)R.push(...A.keys());return R}map(R){return new u(this.expr.map(A=>A.map(R)),null)}negate(){if(!this.c){const R=[];for(const A of this.expr)R.push(A.negate());this.c=n.create(R,this,!0)}return this.c}}class n{static create(R,A,O){return n.d(R,A,O)}constructor(R,A){this.expr=R,this.c=A,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let A=0,O=this.expr.length;A<O;A++){const B=N(this.expr[A],R.expr[A]);if(B!==0)return B}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let A=0,O=this.expr.length;A<O;A++)if(!this.expr[A].equals(R.expr[A]))return!1;return!0}return!1}substituteConstants(){const R=c(this.expr);return R===this.expr?this:n.create(R,this.c,!1)}evaluate(R){for(let A=0,O=this.expr.length;A<O;A++)if(this.expr[A].evaluate(R))return!0;return!1}static d(R,A,O){let B=[],z=!1;if(R){for(let j=0,K=R.length;j<K;j++){const ie=R[j];if(!!ie){if(ie.type===0){z=!0;continue}if(ie.type===1)return g.INSTANCE;if(ie.type===9){B=B.concat(ie.expr);continue}B.push(ie)}}if(B.length===0&&z)return D.INSTANCE;B.sort(N)}if(B.length!==0){if(B.length===1)return B[0];for(let j=1;j<B.length;j++)B[j-1].equals(B[j])&&(B.splice(j,1),j--);if(B.length===1)return B[0];if(O){for(let j=0;j<B.length;j++)for(let K=j+1;K<B.length;K++)if(B[j].negate().equals(B[K]))return g.INSTANCE;if(B.length===1)return B[0]}return new n(B,A)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const A of this.expr)R.push(...A.keys());return R}map(R){return new n(this.expr.map(A=>A.map(R)),null)}negate(){if(!this.c){const R=[];for(const A of this.expr)R.push(A.negate());for(;R.length>1;){const A=R.shift(),O=R.shift(),B=[];for(const z of Z(A))for(const j of Z(O))B.push(u.create([z,j],null,!1));R.unshift(n.create(B,null,!1))}this.c=n.create(R,this,!0)}return this.c}}class h extends p{static all(){return h.d.values()}constructor(R,A,O){super(R,null),this.f=A,typeof O=="object"?h.d.push({...O,key:R}):O!==!0&&h.d.push({key:R,description:O,type:A!=null?typeof A:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return f.create(this.key,R)}notEqualsTo(R){return l.create(this.key,R)}}e.RawContextKey=h,h.d=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService");function m(G,R){return G<R?-1:G>R?1:0}function P(G,R,A,O){return G<A?-1:G>A?1:R<O?-1:R>O?1:0}function M(G,R){if(G.type===0||R.type===1)return!0;if(G.type===9)return R.type===9?V(G.expr,R.expr):!1;if(R.type===9){for(const A of R.expr)if(M(G,A))return!0;return!1}if(G.type===6){if(R.type===6)return V(R.expr,G.expr);for(const A of G.expr)if(M(A,R))return!0;return!1}return G.equals(R)}e.implies=M;function V(G,R){let A=0,O=0;for(;A<G.length&&O<R.length;){const B=G[A].cmp(R[O]);if(B<0)return!1;B===0&&A++,O++}return A===G.length}function Z(G){return G.type===9?G.expr:[G]}}),define(Ce[152],ke([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[87],ke([1,0,129,3]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function L(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function C(l,v){switch(l){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function F(l,v){return v==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=F;function S(l,v,b){return F(v,b)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===b?!0:k(b).includes(l)}e.isTargetPlatformCompatible=S;function k(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function N(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=N;var D;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var g;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var p;(function(l){l.Install="install",l.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var t;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(t=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class a extends Error{constructor(v,b){super(v),this.code=b,this.name=b}}e.ExtensionManagementError=a,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[36],ke([1,0,46,19,10,9,2,131,3]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var N;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(N=e.FileType||(e.FileType={}));var D;(function(z){z[z.Readonly=1]="Readonly"})(D=e.FilePermission||(e.FilePermission={}));var g;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=p;function f(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=f;function t(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=t;function a(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function l(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=l;function v(z){return p(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var b;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(j,K){super(j),this.code=K}}e.FileSystemProviderError=E;function w(z,j){const K=new E(z.toString(),j);return o(K,j),K}e.createFileSystemProviderError=w;function r(z){return z||w((0,F.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=r;function o(z,j){return z.name=j?`${j} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=o;function s(z){if(!z)return b.Unknown;if(z instanceof E)return z.code;const j=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!j)return b.Unknown;switch(j[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=s;function d(z){if(z instanceof P)return z.fileOperationResult;switch(s(z)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=d;var c;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class u{constructor(j,K,ie){this.resource=j,this.operation=K,this.target=ie}isOperation(j){return this.operation===j}}e.FileOperationEvent=u;var n;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class h{constructor(j,K){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const me of j){const ue=ie.get(me.type);switch(ue?ue.push([me.resource,me]):ie.set(me.type,[[me.resource,me]]),me.type){case 1:this.rawAdded.push(me.resource);break;case 0:this.rawUpdated.push(me.resource);break;case 2:this.rawDeleted.push(me.resource);break}}for(const[me,ue]of ie)switch(me){case 1:this.a=i.TernarySearchTree.forUris(()=>K),this.a.fill(ue);break;case 0:this.b=i.TernarySearchTree.forUris(()=>K),this.b.fill(ue);break;case 2:this.c=i.TernarySearchTree.forUris(()=>K),this.c.fill(ue);break}}contains(j,...K){return this.d(j,{includeChildren:!1},...K)}affects(j,...K){return this.d(j,{includeChildren:!0},...K)}d(j,K,...ie){if(!j)return!1;const me=ie.length>0;return!!((!me||ie.includes(1))&&(this.a?.get(j)||K.includeChildren&&this.a?.findSuperstr(j))||(!me||ie.includes(0))&&(this.b?.get(j)||K.includeChildren&&this.b?.findSuperstr(j))||(!me||ie.includes(2))&&(this.c?.findSubstr(j)||K.includeChildren&&this.c?.findSuperstr(j)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=h;function m(z,j,K){return!z||!j||z===j||j.length>z.length?!1:(j.charAt(j.length-1)!==T.sep&&(j+=T.sep),K?(0,y.startsWithIgnoreCase)(z,j):z.indexOf(j)===0)}e.isParent=m;class P extends Error{constructor(j,K,ie){super(j),this.fileOperationResult=K,this.options=ie}}e.FileOperationError=P;class M extends P{constructor(j,K,ie){super(j,2,ie),this.stat=K}}e.NotModifiedSinceFileOperationError=M;var V;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var Z;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=G;async function R(z,j){if(!j.hasProvider(C.URI.from({scheme:z.scheme})))return new Promise(K=>{const ie=j.onDidChangeFileSystemProviderRegistrations(me=>{me.scheme===z.scheme&&me.added&&(ie.dispose(),K())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class A{static formatSize(j){return(0,L.isNumber)(j)||(j=0),j<A.KB?(0,F.localize)(1,null,j.toFixed(0)):j<A.MB?(0,F.localize)(2,null,(j/A.KB).toFixed(2)):j<A.GB?(0,F.localize)(3,null,(j/A.MB).toFixed(2)):j<A.TB?(0,F.localize)(4,null,(j/A.GB).toFixed(2)):(0,F.localize)(5,null,(j/A.TB).toFixed(2))}}e.ByteSize=A,A.KB=1024,A.MB=A.KB*A.KB,A.GB=A.MB*A.KB,A.TB=A.GB*A.KB;var O;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function B(z){return{maxFileSize:z===0?300*A.MB:16*A.GB,maxHeapSize:z===0?700*A.MB:2*700*A.MB}}e.getPlatformLimits=B}),define(Ce[64],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...y){this.a=new Map;for(const[L,C]of y)this.set(L,C)}set(y,L){const C=this.a.get(y);return this.a.set(y,L),C}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}e.ServiceCollection=i}),define(Ce[153],ke([1,0,14,11,7,86,151,3,64,154]),function(ee,e,i,T,y,L,C,F,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const N=!1;class D extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class g{constructor(a=new S.ServiceCollection,l=!1,v,b=N){this.f=a,this.g=l,this.h=v,this.i=b,this.o=new Set,this.f.set(F.IInstantiationService,this),this._globalGraph=b?v?._globalGraph??new C.Graph(E=>E):void 0}createChild(a){return new g(a,this.g,this,this.i)}invokeFunction(a,...l){const v=f.traceInvocation(this.i,a);let b=!1;try{return a({get:w=>{if(b)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const r=this.m(w,v);if(!r)throw new Error(`[invokeFunction] unknown service '${w}'`);return r}},...l)}finally{b=!0,v.stop()}}createInstance(a,...l){let v,b;return a instanceof L.SyncDescriptor?(v=f.traceCreation(this.i,a.ctor),b=this.j(a.ctor,a.staticArguments.concat(l),v)):(v=f.traceCreation(this.i,a),b=this.j(a,l,v)),v.stop(),b}j(a,l=[],v){const b=F._util.getServiceDependencies(a).sort((r,o)=>r.index-o.index),E=[];for(const r of b){const o=this.m(r.id,v);o||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${r.id}.`,!1),E.push(o)}const w=b.length>0?b[0].index:l.length;if(l.length!==w){console.trace(`[createInstance] First service dependency of ${a.name} at position ${w+1} conflicts with ${l.length} static arguments`);const r=w-l.length;r>0?l=l.concat(new Array(r)):l=l.slice(0,w)}return Reflect.construct(a,l.concat(E))}k(a,l){if(this.f.get(a)instanceof L.SyncDescriptor)this.f.set(a,l);else if(this.h)this.h.k(a,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const l=this.f.get(a);return!l&&this.h?this.h.l(a):l}m(a,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const v=this.l(a);return v instanceof L.SyncDescriptor?this.q(a,v,l.branch(a,!0)):(l.branch(a,!1),v)}q(a,l,v){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,l,v)}finally{this.o.delete(a)}}r(a,l,v){const b=new C.Graph(r=>r.id.toString());let E=0;const w=[{id:a,desc:l,_trace:v}];for(;w.length;){const r=w.pop();if(b.lookupOrInsertNode(r),E++>1e3)throw new D(b);for(const o of F._util.getServiceDependencies(r.desc.ctor)){const s=this.l(o.id);if(s||this.u(`[createInstance] ${a} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(o.id)),s instanceof L.SyncDescriptor){const d={id:o.id,desc:s,_trace:r._trace.branch(o.id,!0)};b.insertEdge(r,d),w.push(d)}}}for(;;){const r=b.roots();if(r.length===0){if(!b.isEmpty())throw new D(b);break}for(const{data:o}of r){if(this.l(o.id)instanceof L.SyncDescriptor){const d=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,d)}b.removeNode(o)}}return this.l(a)}s(a,l,v=[],b,E){if(this.f.get(a)instanceof L.SyncDescriptor)return this.t(a,l,v,b,E);if(this.h)return this.h.s(a,l,v,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(a,l,v=[],b,E){if(b){const w=new g(void 0,this.g,this,this.i);w.c=String(a);const r=new Map,o=new i.IdleValue(()=>{const s=w.j(l,v,E);for(const[d,c]of r){const u=s[d];if(typeof u=="function")for(const n of c)u.apply(s,n)}return r.clear(),s});return new Proxy(Object.create(null),{get(s,d){if(!o.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let n=r.get(d);return n||(n=new k.LinkedList,r.set(d,n)),(m,P,M)=>{const V=n.push([m,P,M]);return(0,y.toDisposable)(V)}}if(d in s)return s[d];const c=o.value;let u=c[d];return typeof u!="function"||(u=u.bind(c),s[d]=u),u},set(s,d,c){return o.value[d]=c,!0},getPrototypeOf(s){return l.prototype}})}else return this.j(l,v,E)}u(a,l){if(l&&console.warn(a),this.g)throw new Error(a)}}e.InstantiationService=g;var p;(function(t){t[t.None=0]="None",t[t.Creation=1]="Creation",t[t.Invocation=2]="Invocation",t[t.Branch=3]="Branch"})(p||(p={}));class f{static traceInvocation(a,l){return a?new f(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(a,l){return a?new f(1,l.name):f.c}constructor(a,l){this.type=a,this.name=l,this.g=Date.now(),this.h=[]}branch(a,l){const v=new f(3,a.toString());return this.h.push([a,l,v]),v}stop(){const a=Date.now()-this.g;f.f+=a;let l=!1;function v(E,w){const r=[],o=new Array(E+1).join("	");for(const[s,d,c]of w.h)if(d&&c){l=!0,r.push(`${o}CREATES -> ${s}`);const u=v(E+1,c);u&&r.push(u)}else r.push(`${o}uses -> ${s}`);return r.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(a>2||l)&&f.all.add(b.join(`
`))}}e.Trace=f,f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0}),define(Ce[12],ke([1,0,45,4,7,28,21,2,3]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function k(){return new Date().toISOString()}var N;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(N=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=N.Info;function D(u,n,h){switch(n){case N.Trace:u.trace(h);break;case N.Debug:u.debug(h);break;case N.Info:u.info(h);break;case N.Warning:u.warn(h);break;case N.Error:u.error(h);break;case N.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=D;function g(u){let n="";for(let h=0;h<u.length;h++){let m=u[h];if(typeof m=="object")try{m=JSON.stringify(m)}catch{}n+=(h>0?" ":"")+m}return n}e.format=g;class p extends y.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new T.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==N.Off&&this.b<=n}}e.AbstractLogger=p;class f extends p{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...h){this.f(N.Trace)&&this.g(N.Trace,g([n,...h]))}debug(n,...h){this.f(N.Debug)&&this.g(N.Debug,g([n,...h]))}info(n,...h){this.f(N.Info)&&this.g(N.Info,g([n,...h]))}warn(n,...h){this.f(N.Warning)&&this.g(N.Warning,g([n,...h]))}error(n,...h){if(this.f(N.Error))if(n instanceof Error){const m=Array.prototype.slice.call(arguments);m[0]=n.stack,this.g(N.Error,g(m))}else this.g(N.Error,g([n,...h]))}flush(){}}e.AbstractMessageLogger=f;class t extends p{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!C.isWindows}trace(n,...h){this.f(N.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...h):console.log(`[main ${k()}]`,n,...h))}debug(n,...h){this.f(N.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...h):console.log(`[main ${k()}]`,n,...h))}info(n,...h){this.f(N.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...h):console.log(`[main ${k()}]`,n,...h))}warn(n,...h){this.f(N.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,n,...h):console.warn(`[main ${k()}]`,n,...h))}error(n,...h){this.f(N.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,n,...h):console.error(`[main ${k()}]`,n,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=t;class a extends p{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...h){this.f(N.Trace)&&console.log("%cTRACE","color: #888",n,...h)}debug(n,...h){this.f(N.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...h)}info(n,...h){this.f(N.Info)&&console.log("%c INFO","color: #33f",n,...h)}warn(n,...h){this.f(N.Warning)&&console.log("%c WARN","color: #993",n,...h)}error(n,...h){this.f(N.Error)&&console.log("%c  ERR","color: #f33",n,...h)}dispose(){}flush(){}}e.ConsoleLogger=a;class l extends p{constructor(n,h=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(h)}trace(n,...h){this.f(N.Trace)&&this.g.log(N.Trace,[this.h(n),...h])}debug(n,...h){this.f(N.Debug)&&this.g.log(N.Debug,[this.h(n),...h])}info(n,...h){this.f(N.Info)&&this.g.log(N.Info,[this.h(n),...h])}warn(n,...h){this.f(N.Warning)&&this.g.log(N.Warning,[this.h(n),...h])}error(n,...h){this.f(N.Error)&&this.g.log(N.Error,[this.h(n),...h])}h(n){return typeof n=="string"?n:(0,i.toErrorMessage)(n,this.f(N.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class v extends p{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const h of this.g)h.setLevel(n);super.setLevel(n)}trace(n,...h){for(const m of this.g)m.trace(n,...h)}debug(n,...h){for(const m of this.g)m.debug(n,...h)}info(n,...h){for(const m of this.g)m.info(n,...h)}warn(n,...h){for(const m of this.g)m.warn(n,...h)}error(n,...h){for(const m of this.g)m.error(n,...h)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=v;class b extends y.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...h){this.b.trace(n,...h)}debug(n,...h){this.b.debug(n,...h)}info(n,...h){this.b.info(n,...h)}warn(n,...h){this.b.warn(n,...h)}error(n,...h){this.b.error(n,...h)}flush(){this.b.flush()}}e.LogService=b;class E extends y.Disposable{constructor(n,h){super(),this.c=n,this.b=new L.ResourceMap,this.B(h(m=>this.setLevel(m)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,h,m){let P=this.b.get(n)?.logger;return P||(m=h?.always?N.Trace:m,P=this.f(n,m??this.c,h),this.b.set(n,{logger:P,logLevel:m})),P}setLevel(n,h){const m=F.URI.isUri(n)?n:void 0,P=m?h:n;if(m){const M=this.b.get(m);M&&M.logLevel!==P&&(M.logLevel=P,M.logger.setLevel(P))}else this.c=P,this.b.forEach(({logLevel:M,logger:V})=>{M===void 0&&V.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(n){}getLevel(){return N.Info}trace(n,...h){}debug(n,...h){}info(n,...h){}warn(n,...h){}error(n,...h){}critical(n,...h){}dispose(){}flush(){}}e.NullLogger=w;class r extends w{}e.NullLogService=r;class o extends E{constructor(){super(N.Info,T.Event.None)}f(n,h,m){return new w}}e.NullLoggerService=o;function s(u){if(u.verbose)return N.Trace;if(typeof u.logLevel=="string"){const n=c(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function d(u){switch(u){case N.Trace:return"trace";case N.Debug:return"debug";case N.Info:return"info";case N.Warning:return"warn";case N.Error:return"error";case N.Off:return"off"}}e.LogLevelToString=d;function c(u){switch(u){case"trace":return N.Trace;case"debug":return N.Debug;case"info":return N.Info;case"warn":return N.Warning;case"error":return N.Error;case"critical":return N.Error;case"off":return N.Off}}e.parseLogLevel=c}),define(Ce[88],ke([1,0,29,132,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(f,t){return t-f}S.compare=k;const N=Object.create(null);N[S.Error]=(0,T.localize)(0,null),N[S.Warning]=(0,T.localize)(1,null),N[S.Info]=(0,T.localize)(2,null);function D(f){return N[f]||""}S.toString=D;function g(f){switch(f){case i.default.Error:return S.Error;case i.default.Warning:return S.Warning;case i.default.Info:return S.Info;case i.default.Ignore:return S.Hint}}S.fromSeverity=g;function p(f){switch(f){case S.Error:return i.default.Error;case S.Warning:return i.default.Warning;case S.Info:return i.default.Info;case S.Hint:return i.default.Ignore}}S.toSeverity=p}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var F;(function(S){const k="";function N(g){return D(g,!0)}S.makeKey=N;function D(g,p){const f=[k];return g.source?f.push(g.source.replace("\xA6","\\\xA6")):f.push(k),g.code?typeof g.code=="string"?f.push(g.code.replace("\xA6","\\\xA6")):f.push(g.code.value.replace("\xA6","\\\xA6")):f.push(k),g.severity!==void 0&&g.severity!==null?f.push(C.toString(g.severity)):f.push(k),g.message&&p?f.push(g.message.replace("\xA6","\\\xA6")):f.push(k),g.startLineNumber!==void 0&&g.startLineNumber!==null?f.push(g.startLineNumber.toString()):f.push(k),g.startColumn!==void 0&&g.startColumn!==null?f.push(g.startColumn.toString()):f.push(k),g.endLineNumber!==void 0&&g.endLineNumber!==null?f.push(g.endLineNumber.toString()):f.push(k),g.endColumn!==void 0&&g.endColumn!==null?f.push(g.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}S.makeKeyOptionalMessage=D})(F=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(Ce[155],ke([1,0,4,29,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,y.createDecorator)("notificationService");var L;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class F{constructor(){this.progress=new S,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=F;class S{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=S}),define(Ce[89],ke([1,0,10,2,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService");function L(k,N){return T.URI.isUri(k)?(0,i.equalsIgnoreCase)(k.scheme,N):(0,i.startsWithIgnoreCase)(k,N+":")}e.matchesScheme=L;function C(k,...N){return N.some(D=>L(k,D))}e.matchesSomeScheme=C;function F(k,N){return k.with({fragment:`${N.startLineNumber},${N.startColumn}${N.endLineNumber?`-${N.endLineNumber}${N.endColumn?`,${N.endColumn}`:""}`:""}`})}e.withSelection=F;function S(k){let N;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return D&&(N={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},k=k.with({fragment:""})),{selection:N,uri:k}}e.extractSelection=S}),define(Ce[156],ke([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ee,e,i,T){var y=arguments.length,L=y<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,i):T,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ee,e,i,T);else for(var F=ee.length-1;F>=0;F--)(C=ee[F])&&(L=(y<3?C(L):y>3?C(e,i,L):C(e,i))||L);return y>3&&L&&Object.defineProperty(e,i,L),L},je=this&&this.__param||function(ee,e){return function(i,T){e(i,T,ee)}};define(Ce[157],ke([1,0,14,20,7,3]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var C;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class F{get value(){return this.a}constructor(D){this.b=D}report(D){this.a=D,this.b(this.a)}}e.Progress=F,F.None=Object.freeze({report(){}});let S=class extends y.Disposable{constructor(D,g){super(),this.a=new i.DeferredPromise,g.withProgress(D,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,y.toDisposable)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};S=qe([je(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends y.Disposable{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new y.DisposableStore)}start(D){this.stop();const g=++this.a,p=new T.CancellationTokenSource;return this.f=setTimeout(()=>{g===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,y.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,y.toDisposable)(()=>p.cancel())),this.b.add((0,y.toDisposable)(()=>this.c?this.c.done():void 0)),{id:g,token:p.token,stop:()=>this.h(g),isCurrent:()=>this.a===g}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Ce[30],ke([1,0,47,9]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.a=new Map}add(C,F){i.ok(T.isString(C)),i.ok(T.isObject(F)),i.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,F)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new y}),define(Ce[90],ke([1,0,4,30]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(F){return F.length>0&&F.charAt(F.length-1)==="#"?F.substring(0,F.length-1):F}class L{constructor(){this.b=new i.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,k){this.a[y(S)]=k,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const C=new L;T.Registry.add(e.Extensions.JSONContribution,C)}),define(Ce[91],ke([1,0,16,4,9,128,40,90,30]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=S.Registry.as(F.Extensions.JSONContribution);class g{constructor(){this.h=new Set,this.i=new T.Emitter,this.onDidSchemaChange=this.i.event,this.j=new T.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(r,o=!0){this.registerConfigurations([r],o)}registerConfigurations(r,o=!0){const s=new Set;this.n(r,o,s),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(r){const o=new Set;this.o(r,o),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:r,remove:o}){const s=new Set;this.o(o,s),this.n(r,!1,s),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(r){const o=new Set;this.k(r,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(r,o){const s=[];for(const{overrides:d,source:c}of r)for(const u in d)if(o.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const n=this.a.get(u),h=n?.valuesSources??new Map;if(c)for(const V of Object.keys(d[u]))h.set(V,c);const m={...n?.value||{},...d[u]};this.a.set(u,{source:c,value:m,valuesSources:h});const P=(0,C.getLanguageTagSettingPlainKey)(u),M={type:"object",default:m,description:L.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:y.isString(c)?void 0:c,defaultValueSource:c};s.push(...t(u)),this.d[u]=M,this.b.properties[u]=M}else{this.a.set(u,{value:d[u],source:c});const n=this.d[u];n&&(this.w(u,n),this.r(u,n))}this.m(s)}deregisterDefaultConfigurations(r){const o=new Set;this.l(r,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(r,o){for(const{overrides:s,source:d}of r)for(const c in s){const u=this.a.get(c),n=y.isString(d)?d:d?.id,h=y.isString(u?.source)?u?.source:u?.source?.id;if(n===h)if(o.add(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const m=this.d[c];m&&(this.w(c,m),this.r(c,m))}}this.u()}deltaConfiguration(r){let o=!1;const s=new Set;r.removedDefaults&&(this.l(r.removedDefaults,s),o=!0),r.addedDefaults&&(this.k(r.addedDefaults,s),o=!0),r.removedConfigurations&&this.o(r.removedConfigurations,s),r.addedConfigurations&&this.n(r.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const o of r)this.h.add(o);this.u()}n(r,o,s){r.forEach(d=>{this.p(d,o,d.extensionInfo,d.restrictedProperties,void 0,s),this.c.push(d),this.q(d)})}o(r,o){const s=d=>{if(d.properties)for(const c in d.properties){o.add(c);const u=this.d[c];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[c],this.s(c,d.properties[c])}d.allOf?.forEach(c=>s(c))};for(const d of r){s(d);const c=this.c.indexOf(d);c!==-1&&this.c.splice(c,1)}}p(r,o=!0,s,d,c=3,u){c=y.isUndefinedOrNull(r.scope)?c:r.scope;const n=r.properties;if(n)for(const m in n){const P=n[m];if(o&&b(m,P)){delete n[m];continue}if(P.source=s,P.defaultDefaultValue=n[m].default,this.w(m,P),e.OVERRIDE_PROPERTY_REGEX.test(m)?P.scope=void 0:(P.scope=y.isUndefinedOrNull(P.scope)?c:P.scope,P.restricted=y.isUndefinedOrNull(P.restricted)?!!d?.includes(m):P.restricted),n[m].hasOwnProperty("included")&&!n[m].included){this.f[m]=n[m],delete n[m];continue}else this.d[m]=n[m],n[m].policy?.name&&this.e.set(n[m].policy.name,m);!n[m].deprecationMessage&&n[m].markdownDeprecationMessage&&(n[m].deprecationMessage=n[m].markdownDeprecationMessage),u.add(m)}const h=r.allOf;if(h)for(const m of h)this.p(m,o,s,d,c,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const o=s=>{const d=s.properties;if(d)for(const u in d)this.r(u,d[u]);s.allOf?.forEach(o)};o(r)}r(r,o){switch(e.allSettings.properties[r]=o,o.scope){case 1:e.applicationSettings.properties[r]=o;break;case 2:e.machineSettings.properties[r]=o;break;case 6:e.machineOverridableSettings.properties[r]=o;break;case 3:e.windowSettings.properties[r]=o;break;case 4:e.resourceSettings.properties[r]=o;break;case 5:e.resourceSettings.properties[r]=o,this.g.properties[r]=o;break}}s(r,o){switch(delete e.allSettings.properties[r],o.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const o=`[${r}]`,s={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}v(){const r={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this.i.fire()}w(r,o){const s=this.a.get(r);let d=s?.value,c=s?.source;y.isUndefined(d)&&(d=o.defaultDefaultValue,c=void 0),y.isUndefined(d)&&(d=l(o.type)),o.default=d,o.defaultValueSource=c}}const p="\\[([^\\]]+)\\]",f=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(w){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let o=f.exec(w);for(;o?.length;){const s=o[1].trim();s&&r.push(s),o=f.exec(w)}}return(0,i.distinct)(r)}e.overrideIdentifiersFromKey=t;function a(w){return w.reduce((r,o)=>`${r}[${o}]`,"")}e.keyFromOverrideIdentifiers=a;function l(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const v=new g;S.Registry.add(e.Extensions.Configuration,v);function b(w,r){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?L.localize(7,null,w):v.getConfigurationProperties()[w]!==void 0?L.localize(8,null,w):r.policy?.name&&v.getPolicyConfigurations().get(r.policy?.name)!==void 0?L.localize(9,null,w,r.policy?.name,v.getPolicyConfigurations().get(r.policy?.name)):null:L.localize(6,null)}e.validateProperty=b;function E(){const w=[],r=v.getConfigurationProperties();for(const o of Object.keys(r))w.push([o,r[o].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=E}),define(Ce[158],ke([1,0,16,4,109,7,28,23,9,2,40,91,30]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class p{constructor(o={},s=[],d=[],c){this.c=o,this.d=s,this.f=d,this.raw=c,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const o=this.raw.map(s=>{if(s instanceof p)return s;const d=new f("");return d.parseRaw(s),d.configurationModel});this.g=o.reduce((s,d)=>d===s?d:s.merge(d),o[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(o){return o?(0,N.getConfigurationValue)(this.contents,o):this.contents}inspect(o,s){const d=this.rawConfiguration.getValue(o),c=s?this.rawConfiguration.getOverrideValue(o,s):void 0,u=s?this.rawConfiguration.override(s).getValue(o):d;return{value:d,override:c,merged:u}}getOverrideValue(o,s){const d=this.l(s);return d?o?(0,N.getConfigurationValue)(d,o):d:void 0}getKeysForOverrideIdentifier(o){const s=[];for(const d of this.overrides)d.identifiers.includes(o)&&s.push(...d.keys);return i.distinct(s)}getAllOverrideIdentifiers(){const o=[];for(const s of this.overrides)o.push(...s.identifiers);return i.distinct(o)}override(o){let s=this.b.get(o);return s||(s=this.h(o),this.b.set(o,s)),s}merge(...o){const s=F.deepClone(this.contents),d=F.deepClone(this.overrides),c=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const n of o)if(u.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(s,n.contents);for(const h of n.overrides){const[m]=d.filter(P=>i.equals(P.identifiers,h.identifiers));m?(this.j(m.contents,h.contents),m.keys.push(...h.keys),m.keys=i.distinct(m.keys)):d.push(F.deepClone(h))}for(const h of n.keys)c.indexOf(h)===-1&&c.push(h)}return new p(s,c,d,u.every(n=>n instanceof p)?void 0:u)}freeze(){return this.a=!0,this}h(o){const s=this.l(o);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const d={};for(const c of i.distinct([...Object.keys(this.contents),...Object.keys(s)])){let u=this.contents[c];const n=s[c];n&&(typeof u=="object"&&typeof n=="object"?(u=F.deepClone(u),this.j(u,n)):u=n),d[c]=u}return new p(d,this.keys,this.overrides)}j(o,s){for(const d of Object.keys(s)){if(d in o&&S.isObject(o[d])&&S.isObject(s[d])){this.j(o[d],s[d]);continue}o[d]=F.deepClone(s[d])}}k(o){return this.a&&!Object.isFrozen(o)?F.deepFreeze(o):o}l(o){let s=null,d=null;const c=u=>{u&&(d?this.j(d,u):d=F.deepClone(u))};for(const u of this.overrides)i.equals(u.identifiers,[o])?s=u.contents:u.identifiers.includes(o)&&c(u.contents);return c(s),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,s){this.m(o),(0,N.addToValueTree)(this.contents,o,s,d=>{throw new Error(d)})}removeValue(o){this.n(o)&&(0,N.removeFromValueTree)(this.contents,o)}m(o){let s=this.keys.length;for(let d=0;d<s;d++)o.indexOf(this.keys[d])===0&&(s=d);this.keys.splice(s,1,o)}n(o){const s=this.keys.indexOf(o);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=p;class f{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,s){if(!S.isUndefinedOrNull(o)){const d=this.g(o);this.parseRaw(d,s)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,s){this.a=o;const{contents:d,keys:c,overrides:u,restricted:n,hasExcludedProperties:h}=this.h(o,s);this.b=new p(d,c,u,h?[o]:void 0),this.c=n||[]}g(o){let s={},d=null,c=[];const u=[],n=[];function h(P){Array.isArray(c)?c.push(P):d!==null&&(c[d]=P)}const m={onObjectBegin:()=>{const P={};h(P),u.push(c),c=P,d=null},onObjectProperty:P=>{d=P},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const P=[];h(P),u.push(c),c=P,d=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:h,onError:(P,M,V)=>{n.push({error:P,offset:M,length:V})}};if(o)try{y.visit(o,m),s=c[0]||{}}catch(P){console.error(`Error while parsing settings file ${this.f}: ${P}`),this.d=[P]}return s}h(o,s){const d=g.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),c=this.j(o,d,!0,s);o=c.raw;const u=(0,N.toValuesTree)(o,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),n=Object.keys(o),h=this.l(o,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:u,keys:n,overrides:h,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(o,s,d,c){let u=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:o,restricted:[],hasExcludedProperties:u};const n={},h=[];for(const m in o)if(D.OVERRIDE_PROPERTY_REGEX.test(m)&&d){const P=this.j(o[m],s,!1,c);n[m]=P.raw,u=u||P.hasExcludedProperties,h.push(...P.restricted)}else{const P=s[m],M=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&h.push(m),(M===void 0||c.scopes===void 0||c.scopes.includes(M))&&!(c.skipRestricted&&P?.restricted)?n[m]=o[m]:u=!0}return{raw:n,restricted:h,hasExcludedProperties:u}}l(o,s){const d=[];for(const c of Object.keys(o))if(D.OVERRIDE_PROPERTY_REGEX.test(c)){const u={};for(const n in o[c])u[n]=o[c][n];d.push({identifiers:(0,D.overrideIdentifiersFromKey)(c),keys:Object.keys(u),contents:(0,N.toValuesTree)(u,s)})}return d}}e.ConfigurationModelParser=f;class t extends L.Disposable{constructor(o,s,d,c){super(),this.f=o,this.g=s,this.h=c,this.c=this.B(new T.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(d.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(T.Event.any(T.Event.filter(this.h.onDidFilesChange,u=>u.contains(this.f)),T.Event.filter(this.h.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&d.isEqual(u.resource,o)))(()=>this.c.fire()))}async loadConfiguration(){try{const o=await this.h.readFile(this.f);return this.a.parse(o.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class a{constructor(o,s,d,c,u,n,h,m,P,M,V,Z,G){this.a=o,this.b=s,this.value=d,this.overrideIdentifiers=c,this.c=u,this.d=n,this.f=h,this.g=m,this.h=P,this.j=M,this.k=V,this.l=Z,this.m=G}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(o,s,d,c,u=new p,n=new p,h=new C.ResourceMap,m=new p,P=new C.ResourceMap,M=!0){this.c=o,this.d=s,this.f=d,this.g=c,this.h=u,this.j=n,this.l=h,this.m=m,this.n=P,this.p=M,this.a=null,this.b=new C.ResourceMap,this.q=null}getValue(o,s,d){return this.s(o,s,d).getValue(o)}updateValue(o,s,d={}){let c;d.resource?(c=this.n.get(d.resource),c||(c=new p,this.n.set(d.resource,c))):c=this.m,s===void 0?c.removeValue(o):c.setValue(o,s),d.resource||(this.a=null)}inspect(o,s,d){const c=this.s(o,s,d),u=this.w(s.resource,d),n=s.resource?this.n.get(s.resource)||this.m:this.m,h=new Set;for(const m of c.overrides)for(const P of m.identifiers)c.getOverrideValue(o,P)!==void 0&&h.add(P);return new a(o,s,c.getValue(o),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),d?this.j.freeze():void 0,u?u.freeze():void 0,n.inspect(o,s.overrideIdentifier))}keys(o){const s=this.w(void 0,o);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.j=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,s){this.l.set(o,s),this.b.delete(o)}deleteFolderConfiguration(o){this.r.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,s){const d=[];if(!s){const{added:c,updated:u,removed:n}=E(this.c,o);s=[...c,...u,...n]}for(const c of s)for(const u of(0,D.overrideIdentifiersFromKey)(c)){const n=this.c.getKeysForOverrideIdentifier(u),h=o.getKeysForOverrideIdentifier(u),m=[...h.filter(P=>n.indexOf(P)===-1),...n.filter(P=>h.indexOf(P)===-1),...n.filter(P=>!F.equals(this.c.override(u).getValue(P),o.override(u).getValue(P)))];d.push([u,m])}return this.updateDefaultConfiguration(o),{keys:s,overrides:d}}compareAndUpdatePolicyConfiguration(o){const{added:s,updated:d,removed:c}=E(this.d,o),u=[...s,...d,...c];return u.length&&this.updatePolicyConfiguration(o),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:s,updated:d,removed:c,overrides:u}=E(this.applicationConfiguration,o),n=[...s,...d,...c];return n.length&&this.updateApplicationConfiguration(o),{keys:n,overrides:u}}compareAndUpdateLocalUserConfiguration(o){const{added:s,updated:d,removed:c,overrides:u}=E(this.localUserConfiguration,o),n=[...s,...d,...c];return n.length&&this.updateLocalUserConfiguration(o),{keys:n,overrides:u}}compareAndUpdateRemoteUserConfiguration(o){const{added:s,updated:d,removed:c,overrides:u}=E(this.remoteUserConfiguration,o),n=[...s,...d,...c];return n.length&&this.updateRemoteUserConfiguration(o),{keys:n,overrides:u}}compareAndUpdateWorkspaceConfiguration(o){const{added:s,updated:d,removed:c,overrides:u}=E(this.workspaceConfiguration,o),n=[...s,...d,...c];return n.length&&this.updateWorkspaceConfiguration(o),{keys:n,overrides:u}}compareAndUpdateFolderConfiguration(o,s){const d=this.r.get(o),{added:c,updated:u,removed:n,overrides:h}=E(d,s),m=[...c,...u,...n];return(m.length||!d)&&this.updateFolderConfiguration(o,s),{keys:m,overrides:h}}compareAndDeleteFolderConfiguration(o){const s=this.r.get(o);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:d,updated:c,removed:u,overrides:n}=E(s,void 0);return{keys:[...d,...c,...u],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(o,s,d){let c=this.t(s,d);return s.overrideIdentifier&&(c=c.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(c=c.merge(this.d)),c}t({resource:o},s){let d=this.u();if(s&&o){const c=s.getFolder(o);c&&(d=this.v(c.uri)||d);const u=this.n.get(o);u&&(d=d.merge(u))}return d}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(o){let s=this.b.get(o);if(!s){const d=this.u(),c=this.l.get(o);c?(s=d.merge(c),this.p&&(s=s.freeze()),this.b.set(o,s)):s=d}return s}w(o,s){if(s&&o){const d=s.getFolder(o);if(d)return this.l.get(d.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((o,s)=>{const{contents:d,overrides:c,keys:u}=this.l.get(s);return o.push([s,{contents:d,overrides:c,keys:u}]),o},[])}}allKeys(){const o=new Set;return this.c.freeze().keys.forEach(s=>o.add(s)),this.userConfiguration.freeze().keys.forEach(s=>o.add(s)),this.j.freeze().keys.forEach(s=>o.add(s)),this.l.forEach(s=>s.freeze().keys.forEach(d=>o.add(d))),[...o.values()]}x(){const o=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.j.freeze().getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.l.forEach(s=>s.freeze().getAllOverrideIdentifiers().forEach(d=>o.add(d))),[...o.values()]}y(o){const s=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(d=>s.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(d=>s.add(d)),this.j.getKeysForOverrideIdentifier(o).forEach(d=>s.add(d)),this.l.forEach(d=>d.getKeysForOverrideIdentifier(o).forEach(c=>s.add(c))),[...s.values()]}static parse(o){const s=this.z(o.defaults),d=this.z(o.policy),c=this.z(o.application),u=this.z(o.user),n=this.z(o.workspace),h=o.folders.reduce((m,P)=>(m.set(k.URI.revive(P[0]),this.z(P[1])),m),new C.ResourceMap);return new l(s,d,c,u,new p,n,h,new p,new C.ResourceMap,!1)}static z(o){return new p(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=l;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const o=new Set,s=new Map;for(const c of r)c.keys.forEach(u=>o.add(u)),c.overrides.forEach(([u,n])=>{const h=(0,C.getOrSet)(s,u,new Set);n.forEach(m=>h.add(m))});const d=[];return s.forEach((c,u)=>d.push([u,[...c.values()]])),{keys:[...o.values()],overrides:d}}e.mergeChanges=v;class b{constructor(o,s,d,c){this.change=o,this.f=s,this.g=d,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const u of o.keys)this.affectedKeys.add(u);for(const[,u]of o.overrides)for(const n of u)this.affectedKeys.add(n);this.d=this.a;for(const u of this.affectedKeys)this.d+=u+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=l.parse(this.f.data)),this.j}affectsConfiguration(o,s){const d=this.a+o,c=this.d.indexOf(d);if(c<0)return!1;const u=c+d.length;if(u>=this.d.length)return!1;const n=this.d.charCodeAt(u);if(n!==this.b&&n!==this.c)return!1;if(s){const h=this.previousConfiguration?this.previousConfiguration.getValue(o,s,this.f?.workspace):void 0,m=this.g.getValue(o,s,this.h);return!F.equals(h,m)}return!0}}e.ConfigurationChangeEvent=b;function E(r,o){const{added:s,removed:d,updated:c}=w(o?.rawConfiguration,r?.rawConfiguration),u=[],n=r?.getAllOverrideIdentifiers()||[],h=o?.getAllOverrideIdentifiers()||[];if(o){const m=h.filter(P=>!n.includes(P));for(const P of m)u.push([P,o.getKeysForOverrideIdentifier(P)])}if(r){const m=n.filter(P=>!h.includes(P));for(const P of m)u.push([P,r.getKeysForOverrideIdentifier(P)])}if(o&&r){for(const m of n)if(h.includes(m)){const P=w({contents:r.getOverrideValue(void 0,m)||{},keys:r.getKeysForOverrideIdentifier(m)},{contents:o.getOverrideValue(void 0,m)||{},keys:o.getKeysForOverrideIdentifier(m)});u.push([m,[...P.added,...P.removed,...P.updated]])}}return{added:s,removed:d,updated:c,overrides:u}}function w(r,o){const s=r?o?r.keys.filter(u=>o.keys.indexOf(u)===-1):[...r.keys]:[],d=o?r?o.keys.filter(u=>r.keys.indexOf(u)===-1):[...o.keys]:[],c=[];if(r&&o){for(const u of o.keys)if(r.keys.indexOf(u)!==-1){const n=(0,N.getConfigurationValue)(o.contents,u),h=(0,N.getConfigurationValue)(r.contents,u);F.equals(n,h)||c.push(u)}}return{added:s,removed:d,updated:c}}}),define(Ce[92],ke([1,0,11,3]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var y;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends i.ErrorNoTelemetry{static isNotAvailable(F){return F instanceof L&&F._code===y.NotAvailable}static isTemporarilyNotAvailable(F){return F instanceof L&&F._code===y.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof L&&F._code===y.NoResolverFound}static isHandled(F){return F instanceof L&&F.isHandled}constructor(F,S=y.Unknown,k){super(F),this._message=F,this._code=S,this._detail=k,this.isHandled=S===y.NotAvailable&&k===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(Ce[48],ke([1,0,13]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(k){return k.scheme===i.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=T;function y(k){if(!k)return;const N=k.indexOf("+");return N<0?k:k.substr(0,N)}e.getRemoteName=y;function L(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=L;function C(k){const{host:N,port:D}=S(k);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:N,port:D}}e.parseAuthorityWithPort=C;function F(k,N){let{host:D,port:g}=S(k);return typeof g>"u"&&(g=N),{host:D,port:g}}e.parseAuthorityWithOptionalPort=F;function S(k){const N=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(N)return{host:N[1],port:parseInt(N[2],10)};const D=k.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const g=k.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:k,port:void 0}}}),define(Ce[25],ke([1,0,10,3,48]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L;function C(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(F=e.ExtensionType||(e.ExtensionType={}));var S;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(t){this.value=t,this.c=t.toLowerCase()}static equals(t,a){if(typeof t>"u"||t===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof t=="string"||typeof a=="string"){const l=typeof t=="string"?t:t.value,v=typeof a=="string"?a:a.value;return i.equalsIgnoreCase(l,v)}return t.c===a.c}static toKey(t){return typeof t=="string"?t.toLowerCase():t.c}}e.ExtensionIdentifier=k;function N(f){return D(f)}e.isApplicationScopedExtension=N;function D(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function g(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function p(f,t){if(t){const a=`onResolveRemoteAuthority:${(0,y.getRemoteName)(t)}`;return f.activationEvents?.indexOf(a)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[159],ke([1,0,21,49,2,34]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(k){if(i.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function F(k,N,D,g,p,f,t,a,l,v){const b=Object.create(null);b["common.machineId"]=t,b.sessionID=(0,L.generateUuid)()+Date.now(),b.commitHash=p,b.version=f,b["common.platformVersion"]=(N||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,i.PlatformToString)(i.platform),b["common.nodePlatform"]=T.platform,b["common.nodeArch"]=g,b["common.product"]=v||"desktop",a&&(b["common.msftInternal"]=a);let E=0;const w=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),i.isLinuxSnap&&(b["common.snap"]="true");const r=C(D);r&&(b["common.platformDetail"]=r);try{const o=await k.readFile(y.URI.file(l));b["common.source"]=o.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=F;function S(k){const N=T.env.USERDNSDOMAIN;if(!N)return!1;const D=N.toLowerCase();return k.some(g=>D===g)}e.verifyMicrosoftInternalDomain=S}),define(Ce[160],ke([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var y;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(y=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ce[50],ke([1,0,23,9,4,40,48,159,160]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class k{constructor(n){this.value=n}}e.TrustedTelemetryValue=k;class N{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(n,h){return Promise.resolve(void 0)}publicLog2(n,h){return this.publicLog(n,h)}publicLogError(n,h){return Promise.resolve(void 0)}publicLogError2(n,h){return this.publicLogError(n,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=N,e.NullTelemetryService=new N;class D{async publicLog(n,h,m){}async publicLogError(n,h,m){}}e.NullEndpointTelemetryService=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(u,n){return y.Event.debounce(n.onDidChangeConfiguration,(m,P)=>{const M=m?new Set([...m.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:M}},1e3,!0)(m=>{m.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(m.source),configurationKeys:E(m.affectedKeys)})})}e.configurationTelemetry=g;function p(u,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!u.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=p;function f(u,n){return!(n.isBuilt||n.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.isLoggingOnly=f;function t(u){const n=u.getValue(S.TELEMETRY_SETTING_ID),h=u.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(u.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=t;function a(u){const n={},h={},m={};b(u,m);for(let P in m){P=P.length>150?P.substr(P.length-149):P;const M=m[P];typeof M=="number"?h[P]=M:typeof M=="boolean"?h[P]=M?1:0:typeof M=="string"?(M.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${M.length}`),n[P]=M.substring(0,8191)):typeof M<"u"&&M!==null&&(n[P]=M)}return{properties:n,measurements:h}}e.validateTelemetryData=a;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function v(u){if(!u)return"none";const n=(0,C.getRemoteName)(u);return l.has(n)?n:"other"}e.cleanRemoteAuthority=v;function b(u,n,h=0,m){if(!!u)for(const P of Object.getOwnPropertyNames(u)){const M=u[P],V=m?m+P:P;Array.isArray(M)?n[V]=(0,i.safeStringify)(M):M instanceof Date?n[V]=M.toISOString():(0,T.isObject)(M)?h<2?b(M,n,h+1,V+"."):n[V]=(0,i.safeStringify)(M):n[V]=M}}function E(u){if(!u)return[];const n=[];return w(n,"",u),n}function w(u,n,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(m=>w(u,n?`${n}.${m}`:m,h[m])):u.push(n)}function r(u,n){const h=u.msftInternalDomains||[],m=n.getValue("telemetry.internalTesting");return(0,F.verifyMicrosoftInternalDomain)(h)||m}e.isInternalTelemetry=r;function o(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.getPiiPathsFromEnvironment=o;function s(u,n){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let h=u;const m=[];for(const Z of n)for(;;){const G=Z.exec(u);if(!G)break;m.push([G.index,Z.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,M=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let V=0;for(h="";;){const Z=M.exec(u);if(!Z)break;const G=m.some(([R,A])=>Z.index<A&&R<M.lastIndex);!P.test(Z[0])&&!G&&(h+=u.substring(V,Z.index)+"<REDACTED: user-file-path>",V=M.lastIndex)}return V<u.length&&(h+=u.substr(V)),h}function d(u){if(!u)return u;const n=u.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of h)if(m.regex.test(n))return`<REDACTED: ${m.label}>`;return u}function c(u,n){return(0,i.cloneAndChange)(u,h=>{if(h instanceof k)return h.value;if(typeof h=="string"){let m=h.replaceAll("%20"," ");m=s(m,n);for(const P of n)m=m.replace(P,"");return m=d(m),m}})}e.cleanData=c}),define(Ce[161],ke([1,0,10,87,25,21,2,11,49,50]),function(ee,e,i,T,y,L,C,F,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function N(s,d){return s.uuid&&d.uuid?s.uuid===d.uuid:s.id===d.id?!0:(0,i.compareIgnoreCase)(s.id,d.id)===0}e.areSameExtensions=N;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(d){const c=d.manifest?d.manifest.version:d.version,u=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new g(d.identifier,c,u)}static parse(d){const c=D.exec(d);return c&&c[1]&&c[2]?new g({id:c[1]},c[2],c[4]||void 0):null}constructor(d,c,u="undefined"){this.version=c,this.targetPlatform=u,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof g?N(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.ExtensionKey=g;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(s){const d=p.exec(s);return d&&d[1]?[a(d[1]),d[2]]:[a(s),void 0]}e.getIdAndVersion=f;function t(s,d){return`${s}.${d}`}e.getExtensionId=t;function a(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function l(s,d){return a(t(s,d))}e.getGalleryExtensionId=l;function v(s,d){const c=[],u=n=>{for(const h of c)if(h.some(m=>N(d(m),d(n))))return h;return null};for(const n of s){const h=u(n);h?h.push(n):c.push([n])}return c}e.groupByExtension=v;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function E(s){return{id:new k.TrustedTelemetryValue(s.identifier.id),name:new k.TrustedTelemetryValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function w(s,d){const c=[],u=d.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const n=u.shift();if(n&&c.every(h=>!N(h.identifier,{id:n}))){const h=s.filter(m=>N(m.identifier,{id:n}));h.length===1&&(c.push(h[0]),u.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=w;async function r(s,d){if(!L.isLinux)return!1;let c;try{c=(await s.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await s.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){d.debug("Error while getting the os-release file.",(0,F.getErrorMessage)(n))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function o(s,d){const c=await r(s,d),u=(0,T.getTargetPlatform)(c?"alpine":L.platform,S.arch);return d.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=o}),define(Ce[162],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(y){this.b=y,this.a=new Map}dispose(){for(const y of this.a.values())y.dispose()}startBuffering(y,L,C=5){const F=L(S=>{const k=typeof S=="string"?S:S.data;let N=this.a.get(y);if(N){N.data.push(k);return}const D=setTimeout(()=>this.flushBuffer(y),C);N={data:[k],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(y),F.dispose()}},this.a.set(y,N)});return F}stopBuffering(y){this.a.get(y)?.dispose()}flushBuffer(y){const L=this.a.get(y);L&&(this.a.delete(y),this.b(y,L.data.join("")))}}e.TerminalDataBufferer=i}),define(Ce[163],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var i;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(i=e.ColorScheme||(e.ColorScheme={}));function T(L){return L===i.HIGH_CONTRAST_DARK||L===i.HIGH_CONTRAST_LIGHT}e.isHighContrast=T;function y(L){return L===i.DARK||L===i.HIGH_CONTRAST_DARK}e.isDark=y}),define(Ce[65],ke([1,0,121,4,7,3,30,163]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var S;(function(a){function l(v){return v&&typeof v=="object"&&typeof v.id=="string"}a.isThemeColor=l})(S=e.ThemeColor||(e.ThemeColor={}));function k(a){return{id:a}}e.themeColorFromId=k;var N;(function(a){function l(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||S.isThemeColor(d.color))}a.isThemeIcon=l;const v=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function b(d){const c=v.exec(d);if(!c)return;const[,u]=c;return{id:u}}a.fromString=b;function E(d){return{id:d}}a.fromId=E;function w(d,c){let u=d.id;const n=u.lastIndexOf("~");return n!==-1&&(u=u.substring(0,n)),c&&(u=`${u}~${c}`),{id:u}}a.modify=w;function r(d){const c=d.id.lastIndexOf("~");if(c!==-1)return d.id.substring(c+1)}a.getModifier=r;function o(d,c){return d.id===c.id&&d.color?.id===c.color?.id}a.isEqual=o;function s(d,c){return{id:d.id,color:c?k(c):void 0}}a.asThemeIcon=s,a.asClassNameArray=i.CSSIcon.asClassNameArray,a.asClassName=i.CSSIcon.asClassName,a.asCSSSelector=i.CSSIcon.asCSSSelector})(N=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function D(a){switch(a){case F.ColorScheme.DARK:return"vs-dark";case F.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case F.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.a=[],this.a=[],this.b=new T.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,y.toDisposable)(()=>{const v=this.a.indexOf(l);this.a.splice(v,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const p=new g;C.Registry.add(e.Extensions.ThemingContribution,p);function f(a){return p.onColorThemeChange(a)}e.registerThemingParticipant=f;class t extends y.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(v=>this.n(v)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,v){let b=this.h.getColor(l);return b&&v&&(b=v(b,this.h)),b?b.toString():null}}e.Themable=t}),define(Ce[164],ke([1,0,4,40,3,12]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var C;(function(t){t.Http="http",t.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var F;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(F=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=D;function g(t,a,l,v){if(l===1)return!1;if(l===2&&D(a)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(b?.length===4&&parseInt(b[1])>=18)return!1}return t<1024}e.isPortPrivileged=g;class p{constructor(a,l,v){this.remoteAddress=a,this.localAddress=l,this.b=v,this.a=new i.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=p;let f=class{constructor(a,l){this.i=a,this.j=l,this.a=new i.Emitter,this.onTunnelOpened=this.a.event,this.b=new i.Emitter,this.onTunnelClosed=this.b.event,this.c=new i.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const a=this.j.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.e=a,a?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.f=a.elevation,this.g=a.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const a=[],l=Array.from(this.d.values());for(const v of l){const b=Array.from(v.values());for(const E of b){const w=await E.value;w&&a.push(w)}}return a}async dispose(){for(const a of this.d.values()){for(const{value:l}of a.values())await l.then(v=>v?.dispose());a.clear()}this.d.clear()}setEnvironmentTunnel(a,l,v,b,E){this.o(a,l,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:l,localAddress:v,privacy:b,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,l){(D(a)||N(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const v=this.q(a,l);if(v)return++v.refcount,v.value}openTunnel(a,l,v,b,E=!1,w,r){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${v} on local port ${b}.`),!a)return;if(l||(l="localhost"),this.e&&this.h.has(v)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.r(a,l,v,b,E,w,r);return o?o.then(s=>{if(!s){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,v);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.m(s);return(s.tunnelRemoteHost!==l||s.tunnelRemotePort!==v)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(d),d}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}m(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const l=this.d.get(a.tunnelRemoteHost);if(l){const v=l.get(a.tunnelRemotePort);v&&(v.refcount--,await this.n(a.tunnelRemoteHost,a.tunnelRemotePort,v))}}}}async n(a,l,v){if(v.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${l}.`);const b=v.value.then(async E=>{E&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.d.has(a)&&this.d.get(a).delete(l),b}}async closeTunnel(a,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${l} `);const v=this.d.get(a);if(v&&v.has(l)){const b=v.get(l);b.refcount=0,await this.n(a,l,b)}}o(a,l,v){this.d.has(a)||this.d.set(a,new Map),this.d.get(a).set(l,{refcount:1,value:v})}async p(a,l){const v=this.d.get(a);v&&(await v.get(l)||v.delete(l),v.size===0&&this.d.delete(a))}q(a,l){const v=[a];N(a)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):D(a)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const b=v.map(E=>this.d.get(E));for(const E of b){const w=E?.get(l);if(w)return w}}canTunnel(a){return!!k(a)}s(a,l,v,b,E,w,r){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${v} on local port ${b}.`);const o=v;this.h.add(o);const s=b===void 0?v:b,d={elevationRequired:E?this.isPortPrivileged(s):!1},c={remoteAddress:{host:l,port:v},localAddressPort:b,privacy:w,public:w?w!==F.Private:void 0,protocol:r},u=a.forwardPort(c,d);return u?(this.o(l,v,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),u}};f=qe([je(0,L.ILogService),je(1,T.IConfigurationService)],f),e.AbstractTunnelService=f}),define(Ce[165],ke([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var T;(function(y){y[y.Complete=100]="Complete",y[y.Partial=50]="Partial",y[y.None=0]="None"})(T=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ce[166],ke([1,0,13]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(S){return S.scheme!==i.Schemas.file&&S.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=T;function y(S){if(S.folders.length)return S.folders.every(k=>T(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function L(S){return y(S)?.scheme}e.getVirtualWorkspaceScheme=L;function C(S){return y(S)?.authority}e.getVirtualWorkspaceAuthority=C;function F(S){return y(S)!==void 0}e.isVirtualWorkspace=F}),define(Ce[51],ke([1,0,133,19,46,22,2,3,13]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,F.createDecorator)("contextService");function k(s){const d=s;return typeof d?.id=="string"&&C.URI.isUri(d.uri)}e.isSingleFolderWorkspaceIdentifier=k;function N(s){return typeof s?.id=="string"&&!k(s)&&!g(s)}e.isEmptyWorkspaceIdentifier=N,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function D(s,d){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,T.basename)(s)}:d?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=s;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=D;function g(s){const d=s;return typeof d?.id=="string"&&C.URI.isUri(d.configPath)}e.isWorkspaceIdentifier=g;function p(s){const d=s;if(d?.uri)return{id:d.id,uri:C.URI.revive(d.uri)};const c=s;if(c?.configPath)return{id:c.id,configPath:C.URI.revive(c.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=p;var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function t(s){const d=s;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=t;function a(s){const d=s;return!!(d&&typeof d=="object"&&C.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=a;class l{constructor(d,c,u,n,h){this.h=d,this.j=u,this.k=n,this.l=h,this.c=y.TernarySearchTree.forUris(this.l,()=>!0),this.folders=c}update(d){this.h=d.id,this.k=d.configuration,this.j=d.transient,this.l=d.l,this.folders=d.folders}get folders(){return this.g}set folders(d){this.g=d,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(d){this.k=d}getFolder(d){return d&&this.c.findSubstr(d)||null}n(){this.c=y.TernarySearchTree.forUris(this.l,()=>!0);for(const d of this.folders)this.c.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class v{constructor(d,c){this.raw=c,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,L.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function b(s){return new v({uri:s,index:0,name:(0,L.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(s,d){return L.extUriBiasedIgnorePathCase.isEqualOrParent(s,d.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function w(s){let d;return C.URI.isUri(s)?d=s:d=s.configuration,d?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=w;function r(s,d){return!E(s,d)&&!w(s)}e.isSavedWorkspace=r;function o(s){return(typeof s=="string"?(0,T.extname)(s):(0,L.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(Ce[52],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(y){this.d=y,this.b=new Map,this.c=1}add(y){const L=this.c++;return this.b.set(L,y),this.e(),L}get(y,L){return this.b.has(y)?this.b.get(y)[L]:void 0}delete(y){this.b.delete(y),this.e()}e(){!i.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=i,i.a=!1}),define(Ce[37],ke([1,0,13,22,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this.a=new Set(Object.keys(i.Schemas)),this.b=new Map,this.extUri=new T.ExtUri(F=>{const S=this.b.get(F.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(F,S){S===null?this.b.delete(F.scheme):this.b.set(F.scheme,S)}isFreeScheme(F){return!this.b.has(F)&&!this.a.has(F)}getCapabilities(F){return this.b.get(F)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[27],ke([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(Ce[167],ke([1,0,14]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(C,F,S){this.h=new Map,this.a=C,this.b=F,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new i.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of k.values())N.complete()}catch(N){for(const D of k.values())D.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,F){let S=this.f[C];return typeof S>"u"&&(S=F),S}update(C,F){this.f[C]=F;const S=this.h.get(C);if(S!==void 0)return S.p;const k=new i.DeferredPromise;return this.h.set(C,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=T;class y extends T{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,F){super(C.identifier.value,!0,F),this.j=C}}e.ExtensionGlobalMemento=y}),define(Ce[168],ke([1,0,4,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(C){this.c=C,this.a=new i.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new i.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,F,S,k){const D=this.c.getNotebookDocument(T.URI.revive(C)).acceptModelChanged(F.value,S,k);this.b.fire(D)}$acceptDirtyStateChanged(C,F){this.c.getNotebookDocument(T.URI.revive(C)).acceptDirty(F)}$acceptModelSaved(C){const F=this.c.getNotebookDocument(T.URI.revive(C));this.a.fire(F.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(Ce[15],ke([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=T});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[169],ke([1,0,25,4]),function(ee,e,i,T){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(F,S){y.set(this,void 0),this.b=new T.Emitter,this.onDidChange=this.b.event,this.a=i.ExtensionIdentifier.toKey(F.identifier),Je(this,y,S,"f"),Oe(this,y,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(F){return Oe(this,y,"f").get(this.a,F)}store(F,S){return Oe(this,y,"f").store(this.a,F,S)}delete(F){return Oe(this,y,"f").delete(this.a,F)}}e.ExtensionSecrets=L,y=new WeakMap}),define(Ce[66],ke([1,0,3,164,4,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function k(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:D.protocol}}S.fromApiTunnel=k;function N(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==T.TunnelPrivacyId.ConstantPrivate&&D.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}S.fromServiceTunnel=N})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let F=class{constructor(k){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,N){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,N){return{dispose:()=>{}}}async $providePortAttributes(k,N,D,g,p){return[]}async $forwardPort(k,N){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};F=qe([je(0,L.IExtHostRpcService)],F),e.ExtHostTunnelService=F}),define(Ce[53],ke([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=T}),define(Ce[170],ke([1,0,24]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function y(F,S){if(S.serializeBuffersForPostMessage){const k=new T,N=(p,f)=>{if(f instanceof ArrayBuffer){const t=k.add(f);return{$$vscode_array_buffer_reference$$:!0,index:t}}else if(ArrayBuffer.isView(f)){const t=L(f);if(t){const a=k.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:a,view:{type:t,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},D=JSON.stringify(F,N),g=k.buffers.map(p=>{const f=new Uint8Array(p);return i.VSBuffer.wrap(f)});return{message:D,buffers:g}}else return{message:JSON.stringify(F),buffers:[]}}e.serializeWebviewMessage=y;function L(F){switch(F.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(F,S){const k=S.map(g=>{const p=new ArrayBuffer(g.byteLength);return new Uint8Array(p).set(g.buffer),p}),N=S.length?(g,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const f=p,{index:t}=f,a=k[t];if(f.view)switch(f.view.type){case 1:return new Int8Array(a,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(a,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(a,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(a,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(a,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(a,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(a,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(a,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(a,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(a,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(a,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return p}:void 0;return{message:JSON.parse(F,N),arrayBuffers:k}}e.deserializeWebviewMessage=C}),define(Ce[93],ke([1,0,141,9,2,7,3,30,36,13]),function(ee,e,i,T,y,L,C,F,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var N;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(N=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var D;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(D=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function g(K){const ie=K;return!!ie&&typeof ie.getSelection=="function"&&!!ie.onDidChangeSelection}e.isEditorPaneWithSelection=g;function p(K,ie,me){for(const ue of me.visibleEditorPanes)if(ue.group.id===ie&&K.matches(ue.input))return ue.getViewState()}e.findViewStateForEditor=p;function f(K){if(c(K))return!1;const ie=K;return y.URI.isUri(ie?.resource)}e.isResourceEditorInput=f;function t(K){if(c(K))return!1;const ie=K;return ie?.original!==void 0&&ie.modified!==void 0}e.isResourceDiffEditorInput=t;function a(K){if(c(K)||t(K))return!1;const ie=K;return ie?.primary!==void 0&&ie.secondary!==void 0}e.isResourceSideBySideEditorInput=a;function l(K){if(c(K))return!1;const ie=K;return ie?ie.resource===void 0||ie.resource.scheme===k.Schemas.untitled||ie.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;const v=/Untitled-\d+/;function b(K){return K.scheme===k.Schemas.untitled&&K.path.length>1&&!v.test(K.path)}e.isUntitledWithAssociatedResource=b;function E(K){if(c(K))return!1;const ie=K;return y.URI.isUri(ie?.base?.resource)&&y.URI.isUri(ie?.input1?.resource)&&y.URI.isUri(ie?.input2?.resource)&&y.URI.isUri(ie?.result?.resource)}e.isResourceMergeEditorInput=E;var w;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var r;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.a=new Map}registerSource(ie,me){let ue=this.a.get(ie);return ue||(ue={source:ie,label:me},this.a.set(ie,ue)),ue.source}getSourceLabel(ie){return this.a.get(ie)?.label??ie}}e.SaveSourceRegistry=new o;var s;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends L.Disposable{}e.AbstractEditorInput=d;function c(K){return K instanceof d}e.isEditorInput=c;function u(K){const ie=K;return y.URI.isUri(ie?.preferredResource)}function n(K){const ie=K;return c(ie?.primary)&&c(ie?.secondary)}e.isSideBySideEditorInput=n;function h(K){const ie=K;return c(ie?.modified)&&c(ie?.original)}e.isDiffEditorInput=h;function m(K){return c(K?.editor)}e.isEditorInputWithOptions=m;function P(K){const ie=K;return m(K)&&ie?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function M(K){const ie=K;return typeof ie?.groupId=="number"&&c(ie.editor)}e.isEditorIdentifier=M;var V;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(V=e.EditorCloseContext||(e.EditorCloseContext={}));var Z;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(Z=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var G;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(G=e.SideBySideEditor||(e.SideBySideEditor={}));class R{getOriginalUri(ie,me){if(!ie)return;if(E(ie))return e.EditorResourceAccessor.getOriginalUri(ie.result,me);if(me?.supportSideBySide){const{primary:oe,secondary:De}=this.a(ie);if(oe&&De){if(me?.supportSideBySide===G.BOTH)return{primary:this.getOriginalUri(oe,{filterByScheme:me.filterByScheme}),secondary:this.getOriginalUri(De,{filterByScheme:me.filterByScheme})};if(me?.supportSideBySide===G.ANY)return this.getOriginalUri(oe,{filterByScheme:me.filterByScheme})??this.getOriginalUri(De,{filterByScheme:me.filterByScheme});ie=me.supportSideBySide===G.PRIMARY?oe:De}}if(t(ie)||a(ie)||E(ie))return;const ue=u(ie)?ie.preferredResource:ie.resource;return!ue||!me||!me.filterByScheme?ue:this.b(ue,me.filterByScheme)}a(ie){return n(ie)||a(ie)?{primary:ie.primary,secondary:ie.secondary}:h(ie)||t(ie)?{primary:ie.modified,secondary:ie.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ie,me){if(!ie)return;if(E(ie))return e.EditorResourceAccessor.getCanonicalUri(ie.result,me);if(me?.supportSideBySide){const{primary:oe,secondary:De}=this.a(ie);if(oe&&De){if(me?.supportSideBySide===G.BOTH)return{primary:this.getCanonicalUri(oe,{filterByScheme:me.filterByScheme}),secondary:this.getCanonicalUri(De,{filterByScheme:me.filterByScheme})};if(me?.supportSideBySide===G.ANY)return this.getCanonicalUri(oe,{filterByScheme:me.filterByScheme})??this.getCanonicalUri(De,{filterByScheme:me.filterByScheme});ie=me.supportSideBySide===G.PRIMARY?oe:De}}if(t(ie)||a(ie)||E(ie))return;const ue=ie.resource;return!ue||!me||!me.filterByScheme?ue:this.b(ue,me.filterByScheme)}b(ie,me){if(Array.isArray(me)){if(me.some(ue=>ie.scheme===ue))return ie}else if(me===ie.scheme)return ie}}e.EditorResourceAccessor=new R;var A;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(A=e.CloseDirection||(e.CloseDirection={}));class O{constructor(){this.c=new Map,this.d=new Map}start(ie){const me=this.a=ie.get(C.IInstantiationService);for(const[ue,oe]of this.c)this.e(ue,oe,me);this.c.clear()}e(ie,me,ue){const oe=ue.createInstance(me);this.d.set(ie,oe)}registerFileEditorFactory(ie){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ie}getFileEditorFactory(){return(0,T.assertIsDefined)(this.b)}registerEditorSerializer(ie,me){if(this.c.has(ie)||this.d.has(ie))throw new Error(`A editor serializer with type ID '${ie}' was already registered.`);return this.a?this.e(ie,me,this.a):this.c.set(ie,me),(0,L.toDisposable)(()=>{this.c.delete(ie),this.d.delete(ie)})}getEditorSerializer(ie){return this.d.get(typeof ie=="string"?ie:ie.typeId)}}F.Registry.add(e.EditorExtensions.EditorFactory,new O);async function B(K,ie,me){return!K||!K.length?[]:await Promise.all(K.map(async ue=>{const oe=y.URI.revive(ue.fileUri);if(!oe){me.info("Cannot resolve the path because it is not valid.",ue);return}if(!await ie.canHandleResource(oe)){me.info("Cannot resolve the path because it cannot be handled",ue);return}let re=ue.exists,_=ue.type;if(typeof re!="boolean"||typeof _!="number")try{_=(await ie.stat(oe)).isDirectory?S.FileType.Directory:S.FileType.Unknown,re=!0}catch(Ee){me.error(Ee),re=!1}if(!re&&ue.openOnlyIfExists){me.info("Cannot resolve the path because it does not exist",ue);return}if(_===S.FileType.Directory){me.info("Cannot resolve the path because it is a directory",ue);return}const le={...ue.options,pinned:!0};return re?{resource:oe,options:le}:{resource:oe,options:le,forceUntitled:!0}}))}e.pathsToEditors=B;var z;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function j(K){const ie=K;if(!ie)return!1;const me=ie;if(me.modified)return j(me.modified);const ue=ie;return!!(ue.contributionsState&&ue.viewState&&Array.isArray(ue.cursorState))}e.isTextEditorViewState=j}),define(Ce[171],ke([1,0,4,14,142]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new i.Emitter,this.n=new i.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(F){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=F}onEvent(F){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=F}onRequest(F){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=F}sendResponse(F){F.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${F.command}`)):this.s("response",F)}sendRequest(F,S,k,N){const D={command:F};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.s("request",D),typeof N=="number"){const g=setTimeout(()=>{clearTimeout(g);const p=this.f.get(D.seq);if(p){this.f.delete(D.seq);const f={type:"response",seq:0,request_seq:D.seq,success:!1,command:F,message:(0,y.localize)(0,null,N,F)};p(f)}},N)}return k&&this.f.set(D.seq,k),D.seq}acceptMessage(F){this.j?this.j(F):(this.k.push(F),this.k.length===1&&this.q())}o(F,S){return F.type!=="event"||S.type!=="event"}async q(){let F;for(;this.k.length;){if((!F||this.o(this.k[0],F))&&await(0,T.timeout)(0),F=this.k.shift(),!F)return;switch(F.type){case"event":this.i?.(F);break;case"request":this.g?.(F);break;case"response":{const S=F,k=this.f.get(S.request_seq);k&&(this.f.delete(S.request_seq),k(S));break}}}}s(F,S){S.type=F,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const F=new Map;this.f.forEach((S,k)=>F.set(k,S)),await(0,T.timeout)(500),F.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=L}),define(Ce[172],ke([1,0,143,41,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new T.RawContextKey("hasDebugged",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(50,null)});const L=g=>i.localize(51,null,g);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(52,null)};var C;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(C=e.State||(e.State={}));function F(g){switch(g){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=F;var S;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var N;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})(N=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,y.createDecorator)("debugService");var D;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE"})(D=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[173],ke([1,0,10,2,19,23,13]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const F=/{([^}]+)}/g;function S(s,d,c){return s.replace(F,function(u,n){return d&&n.length>0&&n[0]!=="_"?u:c&&c.hasOwnProperty(n)?c[n]:u})}e.formatPII=S;function k(s){const d={};for(const c of Object.keys(s))c.startsWith("!")||(d[c]=s[c]);return d}e.filterExceptionsFromTelemetry=k;function N(s){return s.configuration.request==="attach"&&!D(s)&&(!s.parentSession||N(s.parentSession))}e.isSessionAttach=N;function D(s){let d=s.configuration.type;if(!!d)return d==="vslsShare"&&(d=s.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(d,"extensionhost")||(0,i.equalsIgnoreCase)(d,"pwa-extensionhost")?s:s.parentSession?D(s.parentSession):void 0}e.getExtensionHostDebugSession=D;function g(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=g;function p(s,d,c){let u,n=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let m=null;for(;m=h.exec(s);){const P=m.index+1,M=P+m[0].length;if(P<=d&&M>=c){u=m[0],n=P;break}}if(u){const P=/\w+/g;let M=null;for(;(M=P.exec(u))&&!(M.index+1+n+M[0].length>=c););M&&(u=u.substring(0,P.lastIndex))}return u?{start:n,end:n+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(s){return!!(s&&s.match(f))}e.isUri=t;function a(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(t(s.path))return T.URI.parse(s.path);if((0,y.isAbsolute)(s.path))return T.URI.file(s.path)}return s.path}function l(s){if(typeof s.path=="object"){const d=T.URI.revive(s.path);if(d)return d.scheme===C.Schemas.file?d.fsPath:d.toString()}return s.path}function v(s,d){const c=d?a:l,u=(0,L.deepClone)(s);return E(u,(n,h)=>{n&&h&&(h.path=c(h))}),u}e.convertToDAPaths=v;function b(s,d){const c=d?a:l,u=(0,L.deepClone)(s);return E(u,(n,h)=>{!n&&h&&(h.path=c(h))}),u}e.convertToVSCPaths=b;function E(s,d){switch(s.type){case"event":{const c=s;switch(c.event){case"output":d(!1,c.body.source);break;case"loadedSource":d(!1,c.body.source);break;case"breakpoint":d(!1,c.body.breakpoint.source);break;default:break}break}case"request":{const c=s;switch(c.command){case"setBreakpoints":d(!0,c.arguments.source);break;case"breakpointLocations":d(!0,c.arguments.source);break;case"source":d(!0,c.arguments.source);break;case"gotoTargets":d(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(u=>d(!1,u));break;default:break}break}case"response":{const c=s;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(u=>d(!1,u.source));break;case"loadedSources":c.body.sources.forEach(u=>d(!1,u));break;case"scopes":c.body.scopes.forEach(u=>d(!1,u.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(u=>d(!1,u.source));break;case"setBreakpoints":c.body.breakpoints.forEach(u=>d(!1,u.source));break;case"disassemble":c.body?.instructions.forEach(n=>d(!1,n.location));break;default:break}break}}}function w(s){return s.filter(d=>!d.presentation?.hidden).sort((d,c)=>d.presentation?c.presentation?d.presentation.group?c.presentation.group?d.presentation.group!==c.presentation.group?d.presentation.group.localeCompare(c.presentation.group):r(d.presentation.order,c.presentation.order):-1:c.presentation.group?1:r(d.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=w;function r(s,d){return typeof s!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:s-d}async function o(s,d){const c=s.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(c!=="none"&&(await d.saveAll(),c==="allEditorsInActiveGroup")){const u=d.activeEditorPane;u&&u.input.resource?.scheme===C.Schemas.untitled&&await d.save({editor:u.input,groupId:u.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=o}),define(Ce[67],ke([1,0,24,35,174,62,13,19,21,41]),function(ee,e,i,T,y,L,C,F,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var N;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(N=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={}));var g;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(g=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var p;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(p=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var t;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(t=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var v;(function(B){B.scheme=C.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${z.join("")}]+`),K=7;function ie(_,le){const Ee=le.toString(K),Be=`${Ee.length<z.length?z[Ee.length-1]:"z"}${Ee}s${(0,i.encodeBase64)(i.VSBuffer.fromString(_.scheme),!0,!0)}`;return _.with({scheme:B.scheme,fragment:Be})}B.generate=ie;function me(_){if(_.scheme!==B.scheme)return;const le=_.fragment.indexOf("s");if(le<0)return;const Ee=parseInt(_.fragment.substring(0,le).replace(j,""),K),Ae=(0,i.decodeBase64)(_.fragment.substring(le+1)).toString();if(!isNaN(Ee))return{handle:Ee,notebook:_.with({scheme:Ae,fragment:null})}}B.parse=me;function ue(_,le){return _.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${le??""},${_.scheme!==C.Schemas.file?_.scheme:""}`})}B.generateCellOutputUri=ue;function oe(_){if(_.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const le=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!le)return;const Ee=le[1]&&le[1]!==""?le[1]:void 0,Ae=le[2];return{outputId:Ee,notebook:_.with({scheme:Ae||C.Schemas.file,fragment:null})}}B.parseCellOutputUri=oe;function De(_,le,Ee){return B.generate(_,le).with({scheme:Ee})}B.generateCellPropertyUri=De;function re(_,le){if(_.scheme===le)return B.parse(_.with({scheme:B.scheme}))}B.parseCellPropertyUri=re})(v=e.CellUri||(e.CellUri={}));const b=B=>S.isWindows?B.replace(/\//g,"\\"):B;class E{constructor(z=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(z)].map(K=>({pattern:K,matches:T.parse(b(K))}))}sort(z){const j=new Map(y.Iterable.map(z,ie=>[ie,b(ie)]));let K=[];for(const{matches:ie}of this.d)for(const[me,ue]of j)if(ie(ue)){K.push(me),j.delete(me);break}return j.size&&(K=K.concat([...j.keys()].sort((ie,me)=>this.e.indexOf(ie)-this.e.indexOf(me)))),K}prioritize(z,j){const K=this.f(z);if(K===-1){this.d.unshift({pattern:z,matches:T.parse(b(z))});return}const ie=new Set(j.map(ue=>this.f(ue,K)));ie.delete(-1);const me=Array.from(ie).sort();this.d.splice(K+1,0,...me.map(ue=>this.d[ue]));for(let ue=me.length-1;ue>=0;ue--)this.d.splice(me[ue],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,j=this.d.length){const K=b(z);for(let ie=0;ie<j;ie++)if(this.d[ie].matches(K))return ie;return-1}}e.MimeTypeDisplayOrder=E;function w(B,z,j,K=(ie,me)=>ie===me){const ie=[];function me(De,re,_){if(re===0&&_.length===0)return;const le=ie[ie.length-1];le&&le.start+le.deleteCount===De?(le.deleteCount+=re,le.toInsert.push(..._)):ie.push({start:De,deleteCount:re,toInsert:_})}let ue=0,oe=0;for(;;){if(ue===B.length){me(ue,0,z.slice(oe));break}if(oe===z.length){me(ue,B.length-ue,[]);break}const De=B[ue],re=z[oe];if(K(De,re)){ue+=1,oe+=1;continue}j(re)?(me(ue,1,[]),ue+=1):(me(ue,0,[re]),oe+=1)}return ie}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(B){B.default="default",B.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(B){const z=B;return!!((typeof z.include=="string"||T.isRelativePattern(z.include))&&(typeof z.exclude=="string"||T.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=o;function s(B,z,j){if(Array.isArray(B.viewType)&&B.viewType.indexOf(z)>=0||B.viewType===z)return!0;if(B.filenamePattern){const K=o(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,ie=o(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(T.match(K,(0,F.basename)(j.fsPath).toLowerCase()))return!(ie&&T.match(ie,(0,F.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var d;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(z){return`${c.d}${z}`}static parse(z){if(z.startsWith(c.d))return z.substring(c.d.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c.d="notebook/";function u(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=u;const n=new TextDecoder;function h(B){const z=[];let j=!1;for(const K of B)(z.length===0||j)&&(z.push(K),j=!0);return V(z),O(i.VSBuffer.concat(z.map(K=>i.VSBuffer.wrap(K))))}e.compressOutputItemStreams=h;const m=`${String.fromCharCode(27)}[A`,P=m.split("").map(B=>B.charCodeAt(0)),M=10;function V(B){B.forEach((z,j)=>{if(j===0||z.length<m.length)return;const K=B[j-1],ie=z.subarray(0,m.length);if(ie[0]===P[0]&&ie[1]===P[1]&&ie[2]===P[2]){const me=K.lastIndexOf(M);if(me===-1)return;B[j-1]=K.subarray(0,me),B[j]=z.subarray(m.length)}})}function Z(B){let z=B;do B=z,z=B.replace(/[^\n]\x08/gm,"");while(z.length<B.length);return B}function G(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const z=B.match(/^(.*)\r+/m)[1];let j=B.match(/\r+(.*)$/m)[1];j=j+z.slice(j.length,z.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return B}const R="\b".charCodeAt(0),A="\r".charCodeAt(0);function O(B){return!B.buffer.includes(R)&&!B.buffer.includes(A)?B:i.VSBuffer.fromString(G(Z(n.decode(B.buffer))))}}),define(Ce[175],ke([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(T=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(Ce[176],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=i;function T(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=T;function y(C){return Array.from(C.entries()).map(F=>[F[0],i(F[1].map)])}e.serializeEnvironmentVariableCollections=y;function L(C){return new Map(C.map(F=>[F[0],{map:T(F[1])}]))}e.deserializeEnvironmentVariableCollections=L}),define(Ce[42],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(L){L.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T=e.TestPosition||(e.TestPosition={}));class y{static fromExtHostTestItem(C,F,S=C.parent){if(C._isRoot)return new y([F]);const k=[C.id];for(let N=S;N&&N.id!==F;N=N.parent)k.push(N.id);return k.push(F),new y(k.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const F=C.indexOf("\0");return F===-1?C:C.slice(0,F)}static fromString(C){return new y(C.split("\0"))}static join(C,F){return new y([...C.path,F])}static joinToString(C,F){return C.toString()+"\0"+F}static parentId(C){const F=C.lastIndexOf("\0");return F===-1?void 0:C.slice(0,F)}static compare(C,F){return C===F?0:F.startsWith(C+"\0")?2:C.startsWith(F+"\0")?3:1}constructor(C,F=C.length){if(this.path=C,this.d=F,C.length===0||F<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new y(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new y(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new y(this.path,C)}compare(C){if(typeof C=="string")return y.compare(this.toString(),C);for(let F=0;F<C.d&&F<this.d;F++)if(C.path[F]!==this.path[F])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=y}),define(Ce[54],ke([1,0,2,55,42]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var L;(function(u){u[u.Unset=0]="Unset",u[u.Queued=1]="Queued",u[u.Running=2]="Running",u[u.Passed=3]="Passed",u[u.Failed=4]="Failed",u[u.Skipped=5]="Skipped",u[u.Errored=6]="Errored"})(L=e.TestResultState||(e.TestResultState={}));var C;(function(u){u[u.Run=2]="Run",u[u.Debug=4]="Debug",u[u.Coverage=8]="Coverage",u[u.HasNonDefaultProfile=16]="HasNonDefaultProfile",u[u.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var F;(function(u){u.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),u.deserialize=n=>({range:T.Range.lift(n.range),uri:i.URI.revive(n.uri)})})(F=e.IRichLocation||(e.IRichLocation={}));var S;(function(u){u[u.Error=0]="Error",u[u.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var k;(function(u){u.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&F.serialize(n.location)}),u.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&F.deserialize(n.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const N=(u,n)=>`${n?"s":"e"}${u}`;e.getMarkId=N;var D;(function(u){u.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&F.serialize(n.location)}),u.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&F.deserialize(n.location)})})(D=e.ITestOutputMessage||(e.ITestOutputMessage={}));var g;(function(u){u.serialize=n=>n.type===0?k.serialize(n):D.serialize(n),u.deserialize=n=>n.type===0?k.deserialize(n):D.deserialize(n)})(g=e.ITestMessage||(e.ITestMessage={}));var p;(function(u){u.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),u.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(g.serialize)}),u.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(g.deserialize)})})(p=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",t=(u,n)=>u+f+n;e.namespaceTestTag=t;const a=u=>{const n=u.indexOf(f);return{ctrlId:u.slice(0,n),tagId:u.slice(n+1)}};e.denamespaceTestTag=a;var l;(function(u){u.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),u.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?i.URI.revive(n.uri):void 0,range:n.range?T.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(l=e.ITestItem||(e.ITestItem={}));var v;(function(u){u[u.NotExpandable=0]="NotExpandable",u[u.Expandable=1]="Expandable",u[u.BusyExpanding=2]="BusyExpanding",u[u.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var b;(function(u){u.serialize=n=>({expand:n.expand,item:l.serialize(n.item)}),u.deserialize=n=>({controllerId:y.TestId.root(n.item.extId),expand:n.expand,item:l.deserialize(n.item)})})(b=e.InternalTestItem||(e.InternalTestItem={}));var E;(function(u){u.serialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.uri!==void 0&&(h.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(h.range=n.item.range?.toJSON()),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}},u.deserialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.range!==void 0&&(h.range=n.item.range?T.Range.lift(n.item.range):null),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}}})(E=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(u,n)=>{n.expand!==void 0&&(u.expand=n.expand),n.item!==void 0&&(u.item=u.item?Object.assign(u.item,n.item):n.item)};e.applyTestItemUpdate=w;var r;(function(u){u.serializeWithoutMessages=n=>({...b.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(p.serializeWithoutMessages),retired:n.retired}),u.serialize=n=>({...b.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(p.serialize),retired:n.retired}),u.deserialize=n=>({...b.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(p.deserialize),retired:!0})})(r=e.TestResultItem||(e.TestResultItem={}));var o;(function(u){u[u.Function=0]="Function",u[u.Statement=1]="Statement"})(o=e.DetailType||(e.DetailType={}));var s;(function(u){u[u.Add=0]="Add",u[u.Update=1]="Update",u[u.DocumentSynced=2]="DocumentSynced",u[u.Remove=3]="Remove",u[u.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",u[u.Retire=5]="Retire",u[u.AddTag=6]="AddTag",u[u.RemoveTag=7]="RemoveTag"})(s=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(u){u.deserialize=n=>n.op===0?{op:n.op,item:b.deserialize(n.item)}:n.op===1?{op:n.op,item:E.deserialize(n.item)}:n.op===2?{op:n.op,uri:i.URI.revive(n.uri),docv:n.docv}:n,u.serialize=n=>n.op===0?{op:n.op,item:b.serialize(n.item)}:n.op===1?{op:n.op,item:E.serialize(n.item)}:n})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const h=this.o();for(const m of n)switch(m.op){case 0:this.j(b.deserialize(m.item),h);break;case 1:this.k(E.deserialize(m.item),h);break;case 3:this.l(m.itemId,h);break;case 5:this.m(m.itemId);break;case 4:this.updatePendingRoots(m.amount);break;case 6:this.c.set(m.tag.id,m.tag);break;case 7:this.c.delete(m.id);break}h.complete?.()}j(n,h){const m=y.TestId.parentId(n.item.extId)?.toString();let P;if(!m)P=this.p(n),this.f.add(P),this.d.set(n.item.extId,P);else if(this.d.has(m)){const M=this.d.get(m);M.children.add(n.item.extId),P=this.p(n,M),this.d.set(n.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return h.add?.(P),n.expand===2&&this.g++,P}k(n,h){const m=this.d.get(n.extId);if(!!m)return n.expand!==void 0&&(m.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(m,n),h.update?.(m),m}l(n,h){const m=this.d.get(n);if(!m)return;const P=y.TestId.parentId(m.item.extId)?.toString();P?this.d.get(P).children.delete(m.item.extId):this.f.delete(m);const M=[[n]];for(;M.length;)for(const V of M.pop()){const Z=this.d.get(V);Z&&(M.push(Z.children),this.d.delete(V),h.remove?.(Z,Z!==m),Z.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(Ce[68],ke([1,0,14,4,7,47,54,42]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(v){v[v.Upsert=0]="Upsert",v[v.SetTags=1]="SetTags",v[v.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",v[v.RemoveChild=3]="RemoveChild",v[v.SetProp=4]="SetProp",v[v.Bulk=5]="Bulk",v[v.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(v,b)=>v===b,D=Object.entries({range:(v,b)=>v===b?!0:!v||!b?!1:v.equalsRange(b),busy:k,label:k,description:k,error:k,sortText:k,tags:(v,b)=>!(v.length!==b.length||v.some(E=>!b.includes(E)))}),g=(v,b)=>{let E;for(const[w,r]of D)r(v[w],b[w])||(E?E[w]=b[w]:E={[w]:b[w]});return E};class p extends y.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new T.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const E of this.tree.values())this.G(E)}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const E of this.k)if(E.op===2&&E.uri===b.uri){E.docv=b.docv;return}break}case 1:{const E=this.k[this.k.length-1];if(E){if(E.op===1&&E.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(E.item,b.item);return}if(E.op===0&&E.item.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(E.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,E){const w=this.tree.get(b);if(!!w){if((w.expandLevels===void 0||E>w.expandLevels)&&(w.expandLevels=E),w.expand===1){const r=this.I(w);return r.isOpen()?this.H(w,E-1):r.wait().then(()=>this.H(w,E-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.H(w,E-1)):this.H(w,E-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,E){switch(E.op){case 3:this.L(F.TestId.joinToString(b.fullId,E.id));break;case 0:this.u(E.item,b);break;case 5:for(const w of E.ops)this.p(b,w);break;case 1:this.w(E.new,E.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:E.update}});break;case 6:this.s(b.actual.uri);break;default:(0,L.assertNever)(E)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,E){const w=F.TestId.fromExtHostTestItem(b,this.root.id,E?.actual),r=this.m.getApiFor(b);r.parent&&r.parent!==E?.actual&&this.m.getChildren(r.parent).delete(b.id);let o=this.tree.get(w.toString());if(!o){o={fullId:w,actual:b,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(o.fullId.toString(),o),this.C(b,E),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(b)}}),this.F(b,o,E);return}if(o.actual===b){this.D(b,o,E);return}if(o.actual.uri?.toString()!==b.uri?.toString())return this.L(w.toString()),this.u(b,E);const s=this.m.getChildren(o.actual),d=o.actual,c=g(this.m.toITestItem(d),this.m.toITestItem(b));this.m.getApiFor(d).listener=void 0,o.actual=b,o.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(b.tags,d.tags,w.toString()),delete c.tags),this.p(o,{op:4,update:c})),this.F(b,o,E);for(const[u,n]of s)this.m.getChildren(b).get(n.id)||this.L(F.TestId.joinToString(w,n.id));this.s(o.actual.uri)}w(b,E,w){const r=new Set(E.map(o=>o.id));for(const o of b)r.delete(o.id)||this.y(o);this.pushDiff({op:1,item:{extId:w,item:{tags:b.map(o=>(0,C.namespaceTestTag)(this.m.controllerId,o.id))}}}),r.forEach(this.z,this)}y(b){const E=this.j.get(b.id);E?E.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const E=this.j.get(b);E&&!--E.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,b)}))}C(b,E){this.m.getApiFor(b).parent=E&&E.actual!==this.root?E.actual:void 0}D(b,E,w){this.C(b,w);const r=this.m.getApiFor(b);r.parent=w?.actual,r.listener=o=>this.p(E,o),this.G(E)}F(b,E,w){this.D(b,E,w);for(const[r,o]of this.m.getChildren(b))this.u(o,E)}G(b){let E;this.h?b.resolveBarrier?E=b.resolveBarrier.isOpen()?3:2:E=b.actual.canResolveChildren?1:0:E=0,E!==b.expand&&(b.expand=E,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:E}}),E===1&&b.expandLevels!==void 0&&this.I(b))}H(b,E){if(E<0)return;const w=[];for(const[r,o]of this.m.getChildren(b.actual)){const s=this.expand(F.TestId.joinToString(b.fullId,o.id),E);(0,i.isThenable)(s)&&w.push(s)}if(w.length)return Promise.all(w).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const o=new i.Barrier;return o.open(),o}b.expand=2,this.J(b);const E=b.resolveBarrier=new i.Barrier,w=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let r;try{r=this.h(b.actual===this.root?void 0:b.actual)}catch(o){w(o)}return(0,i.isThenable)(r)?r.catch(w).then(()=>{E.open(),this.G(b)}):(E.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const E=this.tree.get(b);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const w=[E];for(;w.length;){const r=w.pop();if(!!r){this.m.getApiFor(r.actual).listener=void 0;for(const o of r.actual.tags)this.z(o.id);this.tree.delete(r.fullId.toString());for(const[o,s]of this.m.getChildren(r.actual))w.push(this.tree.get(F.TestId.joinToString(r.fullId,s.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=p;class f extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=f;class t extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=t;class a extends Error{constructor(b,E,w){super(`TestItem with ID "${b}" is from controller "${E}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=a;const l=(v,b,E)=>{let w=new Map;return{get size(){return w.size},forEach(r,o){for(const s of w.values())r.call(o,s,this)},[Symbol.iterator](){return w.entries()},replace(r){const o=new Map,s=new Set(w.keys()),d={op:5,ops:[]};for(const c of r){if(!(c instanceof E))throw new t(c.id);const u=b(c).controllerId;if(u!==v.controllerId)throw new a(c.id,u,v.controllerId);if(o.has(c.id))throw new f(c.id);o.set(c.id,c),s.delete(c.id),d.ops.push({op:0,item:c})}for(const c of s.keys())d.ops.push({op:3,id:c});v.listener?.(d),w=o},add(r){if(!(r instanceof E))throw new t(r.id);w.set(r.id,r),v.listener?.({op:0,item:r})},delete(r){w.delete(r)&&v.listener?.({op:3,id:r})},get(r){return w.get(r)},toJSON(){return Array.from(w.values())}}};e.createTestItemChildren=l}),define(Ce[94],ke([1,0,68]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,y=(C,F)=>{const S={controllerId:F};return T.set(C,S),S};e.createPrivateApiFor=y;const L=C=>{const F=T.get(C);if(!F)throw new i.InvalidTestItemError(C?.id||"<unknown>");return F};e.getPrivateApiFor=L}),define(Ce[69],ke([1,0,13,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(F,S){return F.scheme===i.Schemas.http||F.scheme===i.Schemas.https?F:(S&&S.authority&&S.isRemote&&F.scheme===i.Schemas.file&&(F=T.URI.from({scheme:i.Schemas.vscodeRemote,authority:S.authority,path:F.path})),T.URI.from({scheme:i.Schemas.https,authority:`${F.scheme}+${L(F.authority)}.${e.webviewRootResourceAuthority}`,path:F.path,fragment:F.fragment,query:F.query}))}e.asWebviewUri=y;function L(F){return F.replace(/./g,S=>{const k=S.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?S:"-"+k.toString(16).padStart(4,"0")})}function C(F){return F.replace(/-([0-9a-f]{4})/g,(S,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=C}),define(Ce[177],ke([1,0,4,7,69]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(F,S,k){this.d=F,this.e=S,this.f=k,this.a=0,this.b=new T.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const N=S.getVisibleTextEditors();for(const D of this.c.values())N.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(F=>F.inset.dispose()),this.b.dispose()}createWebviewEditorInset(F,S,k,N,D){let g;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===F){g=b;break}if(!g)throw new Error("not a visible editor");const p=this,f=this.a++,t=new i.Emitter,a=new i.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,y.asWebviewUri)(b,p.f)}get cspSource(){return y.webviewGenericCspSource}set options(b){this.b=b,p.d.$setOptions(f,b)}get options(){return this.b}set html(b){this.a=b,p.d.$setHtml(f,b)}get html(){return this.a}get onDidReceiveMessage(){return t.event}postMessage(b){return p.d.$postMessage(f,b)}},v=new class{constructor(){this.editor=F,this.line=S,this.height=k,this.webview=l,this.onDidDispose=a.event}dispose(){p.c.has(f)&&(p.c.delete(f),p.d.$disposeEditorInset(f),a.fire(),a.dispose(),t.dispose())}};return this.d.$createEditorInset(f,g.id,g.value.document.uri,S+1,k,N||{},D.identifier,D.extensionLocation),this.c.set(f,{editor:F,inset:v,onDidReceiveMessage:t}),v}$onDidDispose(F){const S=this.c.get(F);S&&S.inset.dispose()}$onDidReceiveMessage(F,S){this.c.get(F)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=L}),define(Ce[178],ke([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(T=e.VariableKind||(e.VariableKind={}));class y extends Error{constructor(C,F){super(F),this.variable=C}}e.VariableError=y}),define(Ce[179],ke([1,0,19,49,9,23,21,84,146,178,10]),function(ee,e,i,T,y,L,C,F,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(p,f,t,a){this.g=new Map,this.a=p,this.b=f,this.d=t,a&&(this.c=a.then(l=>this.h(l)))}h(p){if(C.isWindows){const f=Object.create(null);return Object.keys(p).forEach(t=>{f[t.toLowerCase()]=p[t]}),f}return p}resolveWithEnvironment(p,f,t){return this.j({env:this.h(p),userHome:void 0},f?f.uri:void 0,t)}async resolveAsync(p,f){const t={env:await this.c,userHome:await this.d};return this.j(t,p?p.uri:void 0,f)}async i(p,f,t,a){const l=L.deepClone(f);C.isWindows&&l.windows?Object.keys(l.windows).forEach(b=>l[b]=l.windows[b]):C.isMacintosh&&l.osx?Object.keys(l.osx).forEach(b=>l[b]=l.osx[b]):C.isLinux&&l.linux&&Object.keys(l.linux).forEach(b=>l[b]=l.linux[b]),delete l.windows,delete l.osx,delete l.linux;const v={env:await this.c,userHome:await this.d};return this.j(v,p?p.uri:void 0,l,t,a)}async resolveAnyAsync(p,f,t){return this.i(p,f,t)}async resolveAnyMap(p,f,t){const a=new Map;return{newConfig:await this.i(p,f,t,a),resolvedVariables:a}}resolveWithInteractionReplace(p,f,t,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,f,t,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,f){if(this.g.has(p))throw new Error("Variable "+p+" is contributed twice.");this.g.set(p,f)}async j(p,f,t,a,l){if(y.isString(t))return this.l(p,f,t,a,l);if(Array.isArray(t))return Promise.all(t.map(v=>this.j(p,f,v,a,l)));if(y.isObject(t)){const v=Object.create(null),b=await Promise.all(Object.keys(t).map(async E=>[await this.l(p,f,E,a,l),await this.j(p,f,t[E],a,l)]));for(const[E,w]of b)v[E]=w;return v}return t}l(p,f,t,a,l){return(0,N.replaceAsync)(t,D.VARIABLE_REGEXP,async(v,b)=>{if(b.includes(D.VARIABLE_LHS))return v;let E=await this.n(p,v,b,f,a);return l?.set(b,E),E!==v&&y.isString(E)&&E.match(D.VARIABLE_REGEXP)&&(E=await this.l(p,f,E,a,l)),E})}m(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async n(p,f,t,a,l){let v;const b=t.split(":");b.length>1&&(t=b[0],v=b[1]);const E=o=>{const s=this.a.getFilePath();if(s)return(0,F.normalizeDriveLetter)(s);throw new k.VariableError(o,(0,S.localize)(0,null,f))},w=o=>{const s=E(o);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,F.normalizeDriveLetter)(d)}throw new k.VariableError(o,(0,S.localize)(1,null,f,i.basename(s)))},r=o=>{if(v){const s=this.a.getFolderUri(v);if(s)return s;throw new k.VariableError(o,(0,S.localize)(2,null,f,v))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(o,(0,S.localize)(3,null,f)):new k.VariableError(o,(0,S.localize)(4,null,f))};switch(t){case"env":if(v){if(p.env){const o=p.env[C.isWindows?v.toLowerCase():v];if(y.isString(o))return o}return""}throw new k.VariableError(k.VariableKind.Env,(0,S.localize)(5,null,f));case"config":if(v){const o=this.a.getConfigurationValue(a,v);if(y.isUndefinedOrNull(o))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(6,null,f,v));if(y.isObject(o))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(7,null,f,v));return o}throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(8,null,f));case"command":return this.o(k.VariableKind.Command,f,v,l,"command");case"input":return this.o(k.VariableKind.Input,f,v,l,"input");case"extensionInstallFolder":if(v){const o=await this.a.getExtension(v);if(!o)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,f,v));return this.m(o.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,f));default:switch(t){case"workspaceRoot":case"workspaceFolder":return(0,F.normalizeDriveLetter)(this.m(r(k.VariableKind.WorkspaceFolder)));case"cwd":return a||v?(0,F.normalizeDriveLetter)(this.m(r(k.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,F.normalizeDriveLetter)(i.basename(this.m(r(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,S.localize)(11,null,f))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new k.VariableError(k.VariableKind.LineNumber,(0,S.localize)(12,null,f))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new k.VariableError(k.VariableKind.SelectedText,(0,S.localize)(13,null,f))}case"file":return E(k.VariableKind.File);case"fileWorkspaceFolder":return w(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return a||v?i.relative(this.m(r(k.VariableKind.RelativeFile)),E(k.VariableKind.RelativeFile)):E(k.VariableKind.RelativeFile);case"relativeFileDirname":{const o=i.dirname(E(k.VariableKind.RelativeFileDirname));if(a||v){const s=i.relative(this.m(r(k.VariableKind.RelativeFileDirname)),o);return s.length===0?".":s}return o}case"fileDirname":return i.dirname(E(k.VariableKind.FileDirname));case"fileExtname":return i.extname(E(k.VariableKind.FileExtname));case"fileBasename":return i.basename(E(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=i.basename(E(k.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-i.extname(o).length)}case"fileDirnameBasename":return i.basename(i.dirname(E(k.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||f}case"execInstallFolder":{const o=this.a.getAppRoot();return o||f}case"pathSeparator":return i.sep;default:try{const o=v?`${t}:${v}`:t;return this.o(k.VariableKind.Unknown,f,o,l,void 0)}catch{return f}}}}o(p,f,t,a,l){if(t&&a){const v=l===void 0?a[t]:a[l+":"+t];if(typeof v=="string")return v;throw new k.VariableError(p,(0,S.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[95],ke([1,0,3,93]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var y;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var L;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var F;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(F=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function k(f){const t=f;return(0,T.isEditorInput)(t?.editor)&&(0,T.isEditorInput)(t?.replacement)}e.isEditorReplacement=k;var N;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function g(f){const t=f;return!!t&&typeof t.id=="number"&&Array.isArray(t.editors)}e.isEditorGroup=g;function p(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(Ce[180],ke([1,0,3,95]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(L){const C=L;return typeof L=="number"||(0,T.isEditorGroup)(C)}e.isPreferredGroup=y}),define(Ce[181],ke([1,0,3,152]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(T.IEnvironmentService)}),define(Ce[96],ke([1,0,25,4,19]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(D){this.removedDueToLooping=D}}e.DeltaExtensionsResult=L;class C{static isHostExtension(D,g,p){if(g.getExtensionDescription(D))return!1;const f=p.getExtensionDescription(D);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(D){this.c=new T.Emitter,this.onDidChange=this.c.event,this.d=D,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const D of this.d){if(this.e.has(i.ExtensionIdentifier.toKey(D.identifier))){console.error("Extension `"+D.identifier.value+"` is already registered");continue}if(this.e.set(i.ExtensionIdentifier.toKey(D.identifier),D),this.f.push(D),Array.isArray(D.activationEvents))for(let g of D.activationEvents)g==="onUri"&&(g=`onUri:${i.ExtensionIdentifier.toKey(D.identifier)}`),this.g.has(g)||this.g.set(g,[]),this.g.get(g).push(D)}}set(D){this.d=D,this.h(),this.c.fire(void 0)}deltaExtensions(D,g){this.d=k(this.d,g),this.d=this.d.concat(D);const p=C.j(this.d);return this.d=k(this.d,p.map(f=>f.identifier)),this.h(),this.c.fire(void 0),new L(p)}static j(D){const g=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,v){this.addNode(l),this.addNode(v),this.c.has(l)?this.c.get(l).push(v):this.c.set(l,[v])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,v){const b=g.getArcs(l);for(let E=0;E<b.length;E++)if(!v.has(b[E]))return!1;return!0}getNodes(){return this.e}},p=new Map;for(const l of D){const v=i.ExtensionIdentifier.toKey(l.identifier);if(p.set(v,l),l.extensionDependencies)for(const b of l.extensionDependencies){const E=i.ExtensionIdentifier.toKey(b);g.addArc(v,E)}}const f=new Set;g.getNodes().filter(l=>g.getArcs(l).length===0).forEach(l=>f.add(l));const t=g.getNodes().filter(l=>!f.has(l));let a;do{a=!1;for(let l=0;l<t.length;l++){const v=t[l];g.hasOnlyGoodArcs(v,f)&&(t.splice(l,1),l--,f.add(v),a=!0)}}while(a);return t.map(l=>p.get(l))}containsActivationEvent(D){return this.g.has(D)}containsExtension(D){return this.e.has(i.ExtensionIdentifier.toKey(D))}getExtensionDescriptionsForActivationEvent(D){const g=this.g.get(D);return g?g.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(D){const g=this.e.get(i.ExtensionIdentifier.toKey(D));return g||void 0}getExtensionDescriptionByUUID(D){for(const g of this.f)if(g.uuid===D)return g}getExtensionDescriptionByIdOrUUID(D,g){return this.getExtensionDescription(D)??(g?this.getExtensionDescriptionByUUID(g):void 0)}}e.ExtensionDescriptionRegistry=C;var F;(function(N){N[N.Builtin=0]="Builtin",N[N.User=1]="User",N[N.Dev=2]="Dev"})(F||(F={}));function S(N,D){const g=N.isBuiltin?0:N.isUnderDevelopment?2:1,p=D.isBuiltin?0:D.isUnderDevelopment?2:1;if(g!==p)return g-p;const f=y.posix.basename(N.extensionLocation.path),t=y.posix.basename(D.extensionLocation.path);return f<t?-1:f>t?1:0}function k(N,D){const g=new Set;return D.forEach(p=>g.add(i.ExtensionIdentifier.toKey(p))),N.filter(p=>!g.has(i.ExtensionIdentifier.toKey(p.identifier)))}}),define(Ce[70],ke([1,0,24]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function C(k){const N=i.VSBuffer.alloc(1);switch(k){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}e.createMessageOfType=C;function F(k,N){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}e.isMessageOfType=F;var S;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[71],ke([1,0,3,4,12,27,70,48,50,23,2]),function(ee,e,i,T,y,L,C,F,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let D=class{constructor(t,a){this.i=t,this.a=new T.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new T.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=a.createLogger(N.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(t,a,l){const v=this.getTelemetryDetails(),b=new g(a,l,t,this.g,this.f,this.getBuiltInCommonProperties(t),{isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled});return this.h.set(t.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(t,a,l){this.d=t,this.f=a,this.c=l??{usage:!0,error:!0}}getBuiltInCommonProperties(t){const a={};switch(a["common.extname"]=t.name,a["common.extversion"]=t.version,a["common.vscodemachineid"]=this.i.telemetryInfo.machineId,a["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,a["common.vscodeversion"]=this.i.version,a["common.isnewappinstall"]=p(this.i.telemetryInfo.firstSessionDate),a["common.product"]=this.i.environment.appHost,this.i.uiKind){case C.UIKind.Web:a["common.uikind"]="web";break;case C.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,F.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),a}$onDidChangeTelemetryLevel(t){this.e=this.getTelemetryConfiguration(),this.d=t;const a=this.getTelemetryDetails();this.h.forEach(l=>{l.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(t,a){const l=this.h.get(t.value);return!l||l.ignoreUnhandledExtHostErrors?!1:(l.logError(a),!0)}};D=qe([je(0,L.IExtHostInitDataService),je(1,y.ILoggerService)],D),e.ExtHostTelemetry=D;class g{constructor(t,a,l,v,b,E,w){this.g=l,this.h=v,this.i=b,this.j=E,this.b=new T.Emitter,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this.e=a?.ignoreBuiltInCommonProperties??!1,this.f=a?.additionalCommonProperties,this.a=t,this.c={isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}}updateTelemetryEnablements(t,a){this.d&&(this.c={isUsageEnabled:t,isErrorsEnabled:a},this.b.fire(this.d))}mixInCommonPropsAndCleanData(t){let a=t.properties??t;return a=(0,S.cleanData)(a,[]),this.f&&(a=(0,k.mixin)(a,this.f)),this.e||(a=(0,k.mixin)(a,this.j)),t.properties?t.properties=a:t=a,t}k(t,a){this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.a.logEvent(t,a),this.h.trace(t,a)}logUsage(t,a){!this.c.isUsageEnabled||this.k(t,a)}logError(t,a){!this.c.isErrorsEnabled||(typeof t=="string"?this.k(t,a):this.a.logError(t,a))}get apiTelemetryLogger(){if(!this.d){const t=this,a={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.c.isUsageEnabled},get isErrorsEnabled(){return t.c.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.b.event.bind(t)};this.d=Object.freeze(a)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=g;function p(f){const t=Date.now()-new Date(f).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.isNewAppInstall=p,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(Ce[26],ke([1,0,4,2,3,25,161]),function(ee,e,i,T,y,L,C){"use strict";var F;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class S{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class k{constructor(u){this.affinity=u,this.kind=2}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class N{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=N;class D{constructor(u){this.dependency=u}}e.MissingExtensionDependency=D;var g;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(g=e.ExtensionHostKind||(e.ExtensionHostKind={}));function p(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=p;class f{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(u,n){const h=[],m=[],P=[],M=[],V=l(this.c),Z=l(u),G=(B,z)=>B.extensionLocation.toString()===z.extensionLocation.toString()||B.isBuiltin===z.isBuiltin||B.isUserBuiltin===z.isUserBuiltin||B.isUnderDevelopment===z.isUnderDevelopment;for(const B of this.c){const z=Z.get(L.ExtensionIdentifier.toKey(B.identifier));if(!z){h.push(B.identifier),V.delete(L.ExtensionIdentifier.toKey(B.identifier));continue}if(!G(B,z)){h.push(B.identifier),V.delete(L.ExtensionIdentifier.toKey(B.identifier));continue}}for(const B of u){const z=V.get(L.ExtensionIdentifier.toKey(B.identifier));if(!z){m.push(B);continue}if(!G(z,B)){h.push(z.identifier),V.delete(L.ExtensionIdentifier.toKey(z.identifier));continue}}const R=a(this.d),A=a(n);for(const B of this.d)A.has(L.ExtensionIdentifier.toKey(B))||P.push(B);for(const B of n)R.has(L.ExtensionIdentifier.toKey(B))||M.push(B);const O={toRemove:h,toAdd:m,myToRemove:P,myToAdd:M};return this.delta(O),O}delta(u){const{toRemove:n,toAdd:h,myToRemove:m,myToAdd:P}=u,M=a(n),V=a(m);for(let Z=0;Z<this.c.length;Z++)M.has(L.ExtensionIdentifier.toKey(this.c[Z].identifier))&&(this.c.splice(Z,1),Z--);for(let Z=0;Z<this.d.length;Z++)V.has(L.ExtensionIdentifier.toKey(this.d[Z]))&&(this.d.splice(Z,1),Z--);for(const Z of h)this.c.push(Z);for(const Z of P)this.d.push(Z)}containsExtension(u){for(const n of this.d)if(L.ExtensionIdentifier.equals(n,u))return!0;return!1}}e.ExtensionHostExtensions=f;class t{constructor(u){if(this[F]="ExtensionIdentifierSet",this.c=new Map,this.d=L.ExtensionIdentifier.toKey,u)for(const n of u)this.add(n)}get size(){return this.c.size}add(u){return this.c.set(this.d(u),u),this}clear(){this.c.clear()}delete(u){return this.c.delete(this.d(u))}has(u){return this.c.has(this.d(u))}forEach(u,n){this.c.forEach(h=>u.call(n,h,h,this))}*entries(){for(const[u,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=t;function a(c){const u=new Set;for(const n of c)u.add(L.ExtensionIdentifier.toKey(n));return u}e.extensionIdentifiersArrayToSet=a;function l(c){const u=new Map;for(const n of c)u.set(L.ExtensionIdentifier.toKey(n.identifier),n);return u}function v(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=v;function b(c,u){if(!v(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=b;class E{constructor(u,n,h,m){this.codeLoadingTime=u,this.activateCallTime=n,this.activateResolvedTime=h,this.activationReason=m}}e.ActivationTimes=E;class w{constructor(u,n){this.description=u,this.value=n}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var r;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function o(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function s(c,u){return{identifier:new L.ExtensionIdentifier((0,C.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=s;class d{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,n){return Promise.resolve(0)}getInspectPorts(u,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=d}),define(Ce[182],ke([1,0,11,96,25,26,12,14]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(l,v,b,E){this.startup=l,this.codeLoadingTime=v,this.activateCallTime=b,this.activateResolvedTime=E}}e.ExtensionActivationTimes=S,S.NONE=new S(!1,-1,-1,-1);class k{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,v){return l===-1||v===-1?-1:v-l}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class N{constructor(l,v,b,E,w,r){this.activationFailed=l,this.activationFailedError=v,this.activationTimes=b,this.module=E,this.exports=w,this.subscriptions=r}}e.ActivatedExtension=N;class D extends N{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class g extends N{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=g;class p extends N{constructor(l){super(!0,l,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(l,v,b,E){this.g=E,this.a=l,this.b=v,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[l,v]of this.d)v.dispose()}isActivated(l){const v=this.d.get(y.ExtensionIdentifier.toKey(l));return Boolean(v&&v.value)}getActivatedExtension(l){const v=this.d.get(y.ExtensionIdentifier.toKey(l));if(!v||!v.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return v.value}async activateByEvent(l,v){if(this.f[l])return;const b=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(b.map(E=>({id:E.identifier,reason:{startup:v,extensionId:E.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,v){const b=this.a.getExtensionDescription(l);if(!b)throw new Error(`Extension '${l}' is not known`);return this.h([{id:b.identifier,reason:v}])}async h(l){const v=l.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(v.map(b=>b.wait()))}j(l){if(this.d.has(y.ExtensionIdentifier.toKey(l.id)))return this.d.get(y.ExtensionIdentifier.toKey(l.id));if(this.l(l.id))return this.k(l,null,[],null);const v=this.a.getExtensionDescription(l.id);if(!v){const w=new Error(`Cannot activate unknown extension '${l.id.value}'`),r=this.k(l,null,[],new p(w));return this.c.onExtensionActivationError(l.id,w,new L.MissingExtensionDependency(l.id.value)),r}const b=[],E=typeof v.extensionDependencies>"u"?[]:v.extensionDependencies;for(const w of E){if(this.m(w))continue;const r=this.d.get(y.ExtensionIdentifier.toKey(w));if(r){b.push(r);continue}if(this.l(w)){b.push(this.j({id:this.b.getExtensionDescription(w).identifier,reason:l.reason}));continue}const o=this.a.getExtensionDescription(w);if(o){if(!o.main&&!o.browser)continue;b.push(this.j({id:o.identifier,reason:l.reason}));continue}const s=v.displayName||v.identifier.value,d=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${w}'`),c=this.k(l,v.displayName,[],new p(d));return this.c.onExtensionActivationError(v.identifier,d,new L.MissingExtensionDependency(w)),c}return this.k(l,v.displayName,b,null)}k(l,v,b,E){const w=new t(l.id,v,l.reason,b,E,this.c,this.g);return this.d.set(y.ExtensionIdentifier.toKey(l.id),w),w}l(l){return T.ExtensionDescriptionRegistry.isHostExtension(l,this.a,this.b)}m(l){const v=this.b.getExtensionDescription(l);return v?!v.main&&!v.browser:!1}};f=qe([je(3,C.ILogService)],f),e.ExtensionsActivator=f;let t=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,v,b,E,w,r,o){this.c=l,this.d=v,this.f=b,this.g=E,this.h=w,this.j=r,this.k=o,this.a=new F.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const v=this.g[l];if(v.value&&!v.value.activationFailed){this.g.splice(l,1),l--;continue}if(v.value&&v.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${v.friendlyName}' failed to activate`);b.detail=v.value.activationFailedError,this.h=new p(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const v=new Error;if(l&&l.name&&(v.name=l.name),l&&l.message?v.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:v.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(v.stack=l.stack),this.h=new p(v),this.b&&i.isCancellationError(l))return;this.j.onExtensionActivationError(this.c,v,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};t=qe([je(6,C.ILogService)],t)}),define(Ce[183],ke([1,0,12,27,26]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends i.LogService{constructor(F,S){super(F.createLogger(S.logFile,{name:y.ExtensionHostLogFileName}))}};L=qe([je(0,i.ILoggerService),je(1,T.IExtHostInitDataService)],L),e.ExtHostLogService=L});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[6],ke([1,0,16,11,83,28,62,10,9,2,34,36,92,67,26]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f){"use strict";var t,a,l,v,b,E,w,r,o,s,d,c,u,n,h,m,P,M,V,Z,G,R,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(W){return Object.assign(W,{apply:function(){const te=arguments.length===1?[]:arguments[1];return Reflect.construct(W,te,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(W,[]);{const[te,...be]=arguments;return Reflect.construct(W,be,te.constructor)}}})}var B;(function(W){W[W.Top=0]="Top",W[W.Bottom=1]="Bottom"})(B=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function(W){W[W.Command=0]="Command",W[W.Opener=1]="Opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=E=class{static from(...U){let te=U;return new E(function(){if(te){for(const be of te)be&&typeof be.dispose=="function"&&be.dispose();te=void 0}})}constructor(U){t.set(this,void 0),Je(this,t,U,"f")}dispose(){typeof Oe(this,t,"f")=="function"&&(Oe(this,t,"f").call(this),Je(this,t,void 0,"f"))}};t=new WeakMap,j=E=qe([O],j),e.Disposable=j;let K=w=class{static Min(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let be=1;be<U.length;be++){const Ke=U[be];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let be=1;be<U.length;be++){const Ke=U[be];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(U){if(!U)return!1;if(U instanceof w)return!0;const{line:te,character:be}=U;return typeof te=="number"&&typeof be=="number"}static of(U){if(U instanceof w)return U;if(this.isPosition(U))return new w(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,te){if(U<0)throw(0,T.illegalArgument)("line must be non-negative");if(te<0)throw(0,T.illegalArgument)("character must be non-negative");this.c=U,this.e=te}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,te=0){if(U===null||te===null)throw(0,T.illegalArgument)();let be;return typeof U>"u"?be=0:typeof U=="number"?be=U:(be=typeof U.lineDelta=="number"?U.lineDelta:0,te=typeof U.characterDelta=="number"?U.characterDelta:0),be===0&&te===0?this:new w(this.line+be,this.character+te)}with(U,te=this.character){if(U===null||te===null)throw(0,T.illegalArgument)();let be;return typeof U>"u"?be=this.line:typeof U=="number"?be=U:(be=typeof U.line=="number"?U.line:this.line,te=typeof U.character=="number"?U.character:this.character),be===this.line&&te===this.character?this:new w(be,te)}toJSON(){return{line:this.line,character:this.character}}};K=w=qe([O],K),e.Position=K;let ie=r=class{static isRange(U){return U instanceof r?!0:U?K.isPosition(U.start)&&K.isPosition(U.end):!1}static of(U){if(U instanceof r)return U;if(this.isRange(U))return new r(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,te,be,Ke){let Ye,ot;if(typeof U=="number"&&typeof te=="number"&&typeof be=="number"&&typeof Ke=="number"?(Ye=new K(U,te),ot=new K(be,Ke)):K.isPosition(U)&&K.isPosition(te)&&(Ye=K.of(U),ot=K.of(te)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this.c=Ye,this.e=ot):(this.c=ot,this.e=Ye)}contains(U){return r.isRange(U)?this.contains(U.start)&&this.contains(U.end):K.isPosition(U)?!(K.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const te=K.Max(U.start,this.c),be=K.Min(U.end,this.e);if(!te.isAfter(be))return new r(te,be)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const te=K.Min(U.start,this.c),be=K.Max(U.end,this.end);return new r(te,be)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,te=this.end){if(U===null||te===null)throw(0,T.illegalArgument)();let be;return U?K.isPosition(U)?be=U:(be=U.start||this.start,te=U.end||this.end):be=this.start,be.isEqual(this.c)&&te.isEqual(this.end)?this:new r(be,te)}toJSON(){return[this.start,this.end]}};ie=r=qe([O],ie),e.Range=ie;let me=o=class extends ie{static isSelection(U){return U instanceof o?!0:U?ie.isRange(U)&&K.isPosition(U.anchor)&&K.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,te,be,Ke){let Ye,ot;if(typeof U=="number"&&typeof te=="number"&&typeof be=="number"&&typeof Ke=="number"?(Ye=new K(U,te),ot=new K(be,Ke)):K.isPosition(U)&&K.isPosition(te)&&(Ye=K.of(U),ot=K.of(te)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this.f=Ye,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};me=o=qe([O],me),e.Selection=me;class ue{constructor(U,te,be){if(typeof U!="string"||U.length===0)throw(0,T.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,T.illegalArgument)("port");if(typeof be<"u"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z_\-]+$/.test(be)))throw(0,T.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(te),this.connectionToken=be}}e.ResolvedAuthority=ue;class oe extends Error{static NotAvailable(U,te){return new oe(U,g.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(U){return new oe(U,g.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,te=g.RemoteAuthorityResolverErrorCode.Unknown,be){super(U),this._message=U,this._code=te,this._detail=be,Object.setPrototypeOf(this,oe.prototype)}}e.RemoteAuthorityResolverError=oe;var De;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(De=e.EndOfLine||(e.EndOfLine={}));var re;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(re=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let _=s=class{static isTextEdit(U){return U instanceof s?!0:U?ie.isRange(U)&&typeof U.newText=="string":!1}static replace(U,te){return new s(U,te)}static insert(U,te){return s.replace(new ie(U,U),te)}static delete(U){return s.replace(U,"")}static setEndOfLine(U){const te=new s(new ie(new K(0,0),new K(0,0)),"");return te.newEol=U,te}get range(){return this.c}set range(U){if(U&&!ie.isRange(U))throw(0,T.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,T.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,T.illegalArgument)("newEol");this.f=U}constructor(U,te){this.c=U,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};_=s=qe([O],_),e.TextEdit=_;let le=d=class{static isNotebookCellEdit(U){return U instanceof d?!0:U?Kt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,te){return new d(U,te)}static insertCells(U,te){return new d(new Kt(U,U),te)}static deleteCells(U){return new d(U,[])}static updateCellMetadata(U,te){const be=new d(new Kt(U,U),[]);return be.newCellMetadata=te,be}static updateNotebookMetadata(U){const te=new d(new Kt(0,0),[]);return te.newNotebookMetadata=U,te}constructor(U,te){this.range=U,this.newCells=te}};le=d=qe([O],le),e.NotebookEdit=le;class Ee{static isSnippetTextEdit(U){return U instanceof Ee?!0:U?ie.isRange(U.range)&&xe.isSnippetString(U.snippet):!1}static replace(U,te){return new Ee(U,te)}static insert(U,te){return Ee.replace(new ie(U,U),te)}constructor(U,te){this.range=U,this.snippet=te}}e.SnippetTextEdit=Ee;var Ae;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(Ae=e.FileEditType||(e.FileEditType={}));let Be=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,te,be,Ke){this.c.push({_type:1,from:U,to:te,options:be,metadata:Ke})}createFile(U,te,be){this.c.push({_type:1,from:void 0,to:U,options:te,metadata:be})}deleteFile(U,te,be){this.c.push({_type:1,from:U,to:void 0,options:te,metadata:be})}e(U,te,be){this.c.push({_type:3,metadata:be,uri:U,edit:{editType:5,metadata:te},notebookMetadata:te})}f(U,te,be,Ke){const Ye=te.start,ot=te.end;(Ye!==ot||be.length>0)&&this.c.push({_type:5,uri:U,index:Ye,count:ot-Ye,cells:be,metadata:Ke})}g(U,te,be,Ke){this.c.push({_type:3,metadata:Ke,uri:U,edit:{editType:8,index:te,metadata:be}})}replace(U,te,be,Ke){this.c.push({_type:2,uri:U,edit:new _(te,be),metadata:Ke})}insert(U,te,be,Ke){this.replace(U,new ie(te,te),be,Ke)}delete(U,te,be){this.replace(U,te,"",be)}has(U){return this.c.some(te=>te._type===2&&te.uri.toString()===U.toString())}set(U,te){if(te)for(const be of te){if(!be)continue;let Ke,Ye;if(Array.isArray(be)?(Ke=be[0],Ye=be[1]):Ke=be,le.isNotebookCellEdit(Ke)){if(U.scheme===p.CellUri.scheme)throw new Error("set must be called with a notebook document URI, not a cell URI.");Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,Ye):this.f(U,Ke.range,Ke.newCells,Ye)}else Ee.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:U,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:U,edit:Ke,metadata:Ye})}else{for(let be=0;be<this.c.length;be++){const Ke=this.c[be];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===U.toString()&&(this.c[be]=void 0);break}}(0,i.coalesceInPlace)(this.c)}}get(U){const te=[];for(const be of this.c)be._type===2&&be.uri.toString()===U.toString()&&te.push(be.edit);return te}entries(){const U=new L.ResourceMap;for(const te of this.c)if(te._type===2){let be=U.get(te.uri);be||(be=[te.uri,[]],U.set(te.uri,be)),be[1].push(te.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Be=qe([O],Be),e.WorkspaceEdit=Be;let xe=c=class{static isSnippetString(U){return U instanceof c?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=c.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,te=this.e++){if(typeof U=="function"){const be=new c;be.e=this.e,U(be),this.e=be.e,U=be.value}else U=c.c(U);return this.value+="${",this.value+=te,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,te=this.e++){const be=U.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(U,te){if(typeof te=="function"){const be=new c;be.e=this.e,te(be),this.e=be.e,te=be.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,te&&(this.value+=":",this.value+=te),this.value+="}",this}};xe=c=qe([O],xe),e.SnippetString=xe;var Te;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var Ie;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(Ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Se=u=class{static isLocation(U){return U instanceof u?!0:U?ie.isRange(U.range)&&k.URI.isUri(U.uri):!1}constructor(U,te){if(this.uri=U,te)if(ie.isRange(te))this.range=ie.of(te);else if(K.isPosition(te))this.range=new ie(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};Se=u=qe([O],Se),e.Location=Se;let se=class{static is(U){return U?typeof U.message=="string"&&U.location&&ie.isRange(U.location.range)&&k.URI.isUri(U.location.uri):!1}constructor(U,te){this.location=U,this.message=te}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.location.range.isEqual(te.location.range)&&U.location.uri.toString()===te.location.uri.toString()}};se=qe([O],se),e.DiagnosticRelatedInformation=se;let ce=class{constructor(U,te,be=Ie.Error){if(!ie.isRange(U))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=U,this.message=te,this.severity=be}toJSON(){return{severity:Ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.severity===te.severity&&U.code===te.code&&U.severity===te.severity&&U.source===te.source&&U.range.isEqual(te.range)&&(0,i.equals)(U.tags,te.tags)&&(0,i.equals)(U.relatedInformation,te.relatedInformation,se.isEqual)}};ce=qe([O],ce),e.Diagnostic=ce;let Y=class{constructor(U,te){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=te}};Y=qe([O],Y),e.Hover=Y;var I;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(U,te=I.Text){this.range=U,this.kind=te}toJSON(){return{range:this.range,kind:I[this.kind]}}};$=qe([O],$),e.DocumentHighlight=$;var H;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(H=e.SymbolKind||(e.SymbolKind={}));var q;(function(W){W[W.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let J=n=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,te,be,Ke,Ye){this.name=U,this.kind=te,this.containerName=Ye,typeof be=="string"&&(this.containerName=be),Ke instanceof Se?this.location=Ke:be instanceof ie&&(this.location=new Se(Ke,be)),n.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};J=n=qe([O],J),e.SymbolInformation=J;let de=h=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(h.validate)}constructor(U,te,be,Ke,Ye){this.name=U,this.detail=te,this.kind=be,this.range=Ke,this.selectionRange=Ye,this.children=[],h.validate(this)}};de=h=qe([O],de),e.DocumentSymbol=de;var we;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(we=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(U,te){this.title=U,this.kind=te}};ae=qe([O],ae),e.CodeAction=ae;let pe=m=class{constructor(U){this.value=U}append(U){return new m(this.value?this.value+m.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+m.c)}};pe.c=".",pe=m=qe([O],pe),e.CodeActionKind=pe,pe.Empty=new pe(""),pe.QuickFix=pe.Empty.append("quickfix"),pe.Refactor=pe.Empty.append("refactor"),pe.RefactorExtract=pe.Refactor.append("extract"),pe.RefactorInline=pe.Refactor.append("inline"),pe.RefactorMove=pe.Refactor.append("move"),pe.RefactorRewrite=pe.Refactor.append("rewrite"),pe.Source=pe.Empty.append("source"),pe.SourceOrganizeImports=pe.Source.append("organizeImports"),pe.SourceFixAll=pe.Source.append("fixAll");let ve=class{constructor(U,te){if(this.range=U,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ve=qe([O],ve),e.SelectionRange=ve;class We{constructor(U,te,be,Ke,Ye,ot){this.kind=U,this.name=te,this.detail=be,this.uri=Ke,this.range=Ye,this.selectionRange=ot}}e.CallHierarchyItem=We;class He{constructor(U,te){this.fromRanges=te,this.from=U}}e.CallHierarchyIncomingCall=He;class tt{constructor(U,te){this.fromRanges=te,this.to=U}}e.CallHierarchyOutgoingCall=tt;var Xe;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,te){this.range=U,this.command=te}get isResolved(){return!!this.command}};et=qe([O],et),e.CodeLens=et;let it=P=class{static isMarkdownString(U){return U instanceof P?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,te=!1){a.set(this,void 0),Je(this,a,new y.MarkdownString(U,{supportThemeIcons:te}),"f")}get value(){return Oe(this,a,"f").value}set value(U){Oe(this,a,"f").value=U}get isTrusted(){return Oe(this,a,"f").isTrusted}set isTrusted(U){Oe(this,a,"f").isTrusted=U}get supportThemeIcons(){return Oe(this,a,"f").supportThemeIcons}set supportThemeIcons(U){Oe(this,a,"f").supportThemeIcons=U}get supportHtml(){return Oe(this,a,"f").supportHtml}set supportHtml(U){Oe(this,a,"f").supportHtml=U}get baseUri(){return Oe(this,a,"f").baseUri}set baseUri(U){Oe(this,a,"f").baseUri=U}appendText(U){return Oe(this,a,"f").appendText(U),this}appendMarkdown(U){return Oe(this,a,"f").appendMarkdown(U),this}appendCodeblock(U,te){return Oe(this,a,"f").appendCodeblock(te??"",U),this}};a=new WeakMap,it=P=qe([O],it),e.MarkdownString=it;let dt=class{constructor(U,te){this.label=U,this.documentation=te}};dt=qe([O],dt),e.ParameterInformation=dt;let Fe=class{constructor(U,te){this.label=U,this.documentation=te,this.parameters=[]}};Fe=qe([O],Fe),e.SignatureInformation=Fe;let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};st=qe([O],st),e.SignatureHelp=st;var Q;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(Q=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var X;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(X=e.InlayHintKind||(e.InlayHintKind={}));let ge=class{constructor(U){this.value=U}};ge=qe([O],ge),e.InlayHintLabelPart=ge;let Me=class{constructor(U,te,be){this.position=U,this.label=te,this.kind=be}};Me=qe([O],Me),e.InlayHint=Me;var $e;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(Ve=e.CompletionItemKind||(e.CompletionItemKind={}));var Qe;(function(W){W[W.Deprecated=1]="Deprecated"})(Qe=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,te){this.label=U,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([O],nt),e.CompletionItem=nt;let wt=class{constructor(U=[],te=!1){this.items=U,this.isIncomplete=te}};wt=qe([O],wt),e.CompletionList=wt;let St=class{constructor(U,te,be){this.insertText=U,this.range=te,this.command=be}};St=qe([O],St),e.InlineSuggestion=St;let Ct=class{constructor(U){this.commands=void 0,this.items=U}};Ct=qe([O],Ct),e.InlineSuggestionList=Ct;var lt;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var at;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(at=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Bt;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(Bt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ot;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(Ot=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var $t;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})($t=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function U(te){switch(te){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=U}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor(U,te){if(te&&!k.URI.isUri(te))throw(0,T.illegalArgument)("target");if(!ie.isRange(U)||U.isEmpty)throw(0,T.illegalArgument)("range");this.range=U,this.target=te}};Nt=qe([O],Nt),e.DocumentLink=Nt;let Ge=class{constructor(U,te,be,Ke){this.red=U,this.green=te,this.blue=be,this.alpha=Ke}};Ge=qe([O],Ge),e.Color=Ge;let Mt=class{constructor(U,te){if(te&&!(te instanceof Ge))throw(0,T.illegalArgument)("color");if(!ie.isRange(U)||U.isEmpty)throw(0,T.illegalArgument)("range");this.range=U,this.color=te}};Mt=qe([O],Mt),e.ColorInformation=Mt;let Lt=class{constructor(U){if(!U||typeof U!="string")throw(0,T.illegalArgument)("label");this.label=U}};Lt=qe([O],Lt),e.ColorPresentation=Lt;var Ut;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Ut=e.ColorFormat||(e.ColorFormat={}));var mt;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(mt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var kt;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(kt=e.TerminalExitReason||(e.TerminalExitReason={}));class ye{constructor(U,te,be){if(this.startIndex=U,this.length=te,this.tooltip=be,typeof U!="number"||U<0)throw(0,T.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,T.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=ye;class Pe{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Pe;class fe{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=fe;var x;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(x=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=Re;var Le;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(Le=e.TaskRevealKind||(e.TaskRevealKind={}));var _e;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(_e=e.TaskPanelKind||(e.TaskPanelKind={}));let ze=M=class{static from(U){switch(U){case"clean":return M.Clean;case"build":return M.Build;case"rebuild":return M.Rebuild;case"test":return M.Test;default:return}}constructor(U,te){if(this.label=te,typeof U!="string"||typeof te!="string")throw(0,T.illegalArgument)("name");this.c=U}get id(){return this.c}};ze.Clean=new M("clean","Clean"),ze.Build=new M("build","Build"),ze.Rebuild=new M("rebuild","Rebuild"),ze.Test=new M("test","Test"),ze=M=qe([O],ze),e.TaskGroup=ze;function Ze(W){let U="";for(let te=0;te<W.length;te++)U+=W[te].replace(/,/g,",,")+",";return U}let bt=class{constructor(U,te,be){if(typeof U!="string")throw(0,T.illegalArgument)("process");this.e=[],this.c=U,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=be):this.f=te)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,T.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const te of this.e)U.push(te);return Ze(U)}};bt=qe([O],bt),e.ProcessExecution=bt;let vt=class{constructor(U,te,be){if(this.f=[],Array.isArray(te)){if(!U)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,T.illegalArgument)("command");this.e=U,this.f=te,this.g=be}else{if(typeof U!="string")throw(0,T.illegalArgument)("commandLine");this.c=U,this.g=te}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,T.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,T.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)U.push(typeof te=="string"?te:te.value);return Ze(U)}};vt=qe([O],vt),e.ShellExecution=vt;var At;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(At=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class It{constructor(U){this.c=U}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=It;let ht=V=class{constructor(U,te,be,Ke,Ye,ot){this.j=!1,this.k=this.definition=U;let ut;typeof te=="string"?(this.m=this.name=te,this.t=this.source=be,this.execution=Ke,ut=Ye,this.j=!0):te===pt.Global||te===pt.Workspace?(this.target=te,this.m=this.name=be,this.t=this.source=Ke,this.execution=Ye,ut=ot):(this.target=te,this.m=this.name=be,this.t=this.source=Ke,this.execution=Ye,ut=ot),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof bt?this.k={type:V.e,id:this.n.computeId()}:this.n instanceof vt?this.k={type:V.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:V.c,id:this.n.computeId()}:this.k={type:V.g,id:(0,N.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,T.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const te=this.k.type;(V.g===te||V.e===te||V.f===te||V.c===te)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};ht.c="customExecution",ht.e="process",ht.f="shell",ht.g="$empty",ht=V=qe([O],ht),e.Task=ht;var xt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(xt=e.ProgressLocation||(e.ProgressLocation={}));var jt;(function(W){function U(te){const be=te;return(0,S.isNumber)(be.value)?be.tooltip&&!(0,S.isString)(be.tooltip)?(console.log("INVALID view badge, invalid tooltip",be.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",be.value),!1)}W.isViewBadge=U})(jt=e.ViewBadge||(e.ViewBadge={}));let Et=Z=class{static isTreeItem(U,te){if(U instanceof Z)return!0;const be=U;if(be.label!==void 0&&!(0,S.isString)(be.label)&&!be.label?.label)return console.log("INVALID tree item, invalid label",be.label),!1;if(be.id!==void 0&&!(0,S.isString)(be.id))return console.log("INVALID tree item, invalid id",be.id),!1;if(be.iconPath!==void 0&&!(0,S.isString)(be.iconPath)&&!k.URI.isUri(be.iconPath)&&(!be.iconPath||!(0,S.isString)(be.iconPath.id))){const Ke=be.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",be.iconPath),!1}if(be.description!==void 0&&!(0,S.isString)(be.description)&&typeof be.description!="boolean")return console.log("INVALID tree item, invalid description",be.description),!1;if(be.resourceUri!==void 0&&!k.URI.isUri(be.resourceUri))return console.log("INVALID tree item, invalid resourceUri",be.resourceUri),!1;if(be.tooltip!==void 0&&!(0,S.isString)(be.tooltip)&&!(be.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",be.tooltip),!1;if(be.command!==void 0&&!be.command.command)return console.log("INVALID tree item, invalid command",be.command),!1;if(be.collapsibleState!==void 0&&be.collapsibleState<_t.None&&be.collapsibleState>_t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",be.collapsibleState),!1;if(be.contextValue!==void 0&&!(0,S.isString)(be.contextValue))return console.log("INVALID tree item, invalid contextValue",be.contextValue),!1;if(be.accessibilityInformation!==void 0&&!be.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",be.accessibilityInformation),!1;if(be.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(te,"treeItemCheckbox");const Ke=(0,S.isNumber)(be.checkboxState)?be.checkboxState:(0,S.isObject)(be.checkboxState)&&(0,S.isNumber)(be.checkboxState.state)?be.checkboxState.state:void 0,Ye=!(0,S.isNumber)(be.checkboxState)&&(0,S.isObject)(be.checkboxState)?be.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==oi.Checked&&Ke!==oi.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",be.checkboxState),!1}return!0}constructor(U,te=_t.None){this.collapsibleState=te,k.URI.isUri(U)?this.resourceUri=U:this.label=U}};Et=Z=qe([O],Et),e.TreeItem=Et;var _t;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var oi;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})(oi=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Zt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,te){this.value=U,this.id=te??(0,N.generateUuid)()}};Zt=qe([O],Zt),e.DataTransferItem=Zt;let bi=class{constructor(U){l.set(this,new Map);for(const[te,be]of U??[]){const Ke=Oe(this,l,"f").get(te);Ke?Ke.push(be):Oe(this,l,"f").set(te,[be])}}get(U){return Oe(this,l,"f").get(U)?.[0]}set(U,te){Oe(this,l,"f").set(U,[te])}forEach(U,te){for(const[be,Ke]of Oe(this,l,"f"))for(const Ye of Ke)U.call(te,Ye,be,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[U,te]of Oe(this,l,"f"))for(const be of te)yield[U,be]}};bi=qe([O],bi),e.DataTransfer=bi;let Tt=class{constructor(U){this.insertText=U}};Tt=qe([O],Tt),e.DocumentDropEdit=Tt;let ai=class{constructor(U){this.insertText=U}};ai=qe([O],ai),e.DocumentPasteEdit=ai;let Vt=class{constructor(U,te){this.id=U,this.color=te}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};Vt=qe([O],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let ei=class{constructor(U){this.id=U}};ei=qe([O],ei),e.ThemeColor=ei;var ci;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(ci=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ct=class{get base(){return this.c}set base(U){this.c=U,this.e=k.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,te){if(typeof U!="string"&&(!U||!k.URI.isUri(U)&&!k.URI.isUri(U.uri)))throw(0,T.illegalArgument)("base");if(typeof te!="string")throw(0,T.illegalArgument)("pattern");typeof U=="string"?this.baseUri=k.URI.file(U):k.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ct=qe([O],ct),e.RelativePattern=ct;let ti=class{constructor(U,te,be,Ke){this.enabled=typeof U=="boolean"?U:!0,typeof te=="string"&&(this.condition=te),typeof be=="string"&&(this.hitCondition=be),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,N.generateUuid)()),this.c}};ti=qe([O],ti),e.Breakpoint=ti;let qt=class extends ti{constructor(U,te,be,Ke,Ye){if(super(te,be,Ke,Ye),U===null)throw(0,T.illegalArgument)("location");this.location=U}};qt=qe([O],qt),e.SourceBreakpoint=qt;let Qt=class extends ti{constructor(U,te,be,Ke,Ye){super(te,be,Ke,Ye),this.functionName=U}};Qt=qe([O],Qt),e.FunctionBreakpoint=Qt;let ui=class extends ti{constructor(U,te,be,Ke,Ye,ot,ut){if(super(Ke,Ye,ot,ut),!te)throw(0,T.illegalArgument)("dataId");this.label=U,this.dataId=te,this.canPersist=be}};ui=qe([O],ui),e.DataBreakpoint=ui;let Ei=class{constructor(U,te,be){this.command=U,this.args=te||[],this.options=be}};Ei=qe([O],Ei),e.DebugAdapterExecutable=Ei;let li=class{constructor(U,te){this.port=U,this.host=te}};li=qe([O],li),e.DebugAdapterServer=li;let wi=class{constructor(U){this.path=U}};wi=qe([O],wi),e.DebugAdapterNamedPipeServer=wi;let di=class{constructor(U){this.implementation=U}};di=qe([O],di),e.DebugAdapterInlineImplementation=di;let ii=class{constructor(U,te){this.range=U,this.expression=te}};ii=qe([O],ii),e.EvaluatableExpression=ii;var Li;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(Li=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ni=class{constructor(U,te){this.range=U,this.text=te}};ni=qe([O],ni),e.InlineValueText=ni;let ri=class{constructor(U,te,be=!0){this.range=U,this.variableName=te,this.caseSensitiveLookup=be}};ri=qe([O],ri),e.InlineValueVariableLookup=ri;let Si=class{constructor(U,te){this.range=U,this.expression=te}};Si=qe([O],Si),e.InlineValueEvaluatableExpression=Si;let yi=class{constructor(U,te){this.frameId=U,this.stoppedLocation=te}};yi=qe([O],yi),e.InlineValueContext=yi;var si;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(si=e.FileChangeType||(e.FileChangeType={}));let Di=G=class extends Error{static FileExists(U){return new G(U,D.FileSystemProviderErrorCode.FileExists,G.FileExists)}static FileNotFound(U){return new G(U,D.FileSystemProviderErrorCode.FileNotFound,G.FileNotFound)}static FileNotADirectory(U){return new G(U,D.FileSystemProviderErrorCode.FileNotADirectory,G.FileNotADirectory)}static FileIsADirectory(U){return new G(U,D.FileSystemProviderErrorCode.FileIsADirectory,G.FileIsADirectory)}static NoPermissions(U){return new G(U,D.FileSystemProviderErrorCode.NoPermissions,G.NoPermissions)}static Unavailable(U){return new G(U,D.FileSystemProviderErrorCode.Unavailable,G.Unavailable)}constructor(U,te=D.FileSystemProviderErrorCode.Unknown,be){super(k.URI.isUri(U)?U.toString(!0):U),this.code=be?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,te),Object.setPrototypeOf(this,G.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}};Di=G=qe([O],Di),e.FileSystemError=Di;let Ii=class{constructor(U,te,be){this.start=U,this.end=te,this.kind=be}};Ii=qe([O],Ii),e.FoldingRange=Ii;var Ui;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(Ui=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Bi;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(Bi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var $i;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})($i=e.CommentMode||(e.CommentMode={}));var Ci;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(Ci=e.CommentThreadState||(e.CommentThreadState={}));class Ai{constructor(U,te=[]){this.tokenTypes=U,this.tokenModifiers=te}}e.SemanticTokensLegend=Ai;function Ri(W){return typeof W>"u"||(0,S.isStringArray)(W)}class Ue{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let te=0,be=U.tokenTypes.length;te<be;te++)this.j.set(U.tokenTypes[te],te);for(let te=0,be=U.tokenModifiers.length;te<be;te++)this.k.set(U.tokenModifiers[te],te)}}push(U,te,be,Ke,Ye){if(typeof U=="number"&&typeof te=="number"&&typeof be=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(U,te,be,Ke,Ye);if(ie.isRange(U)&&typeof te=="string"&&Ri(be))return this.m(U,te,be);throw(0,T.illegalArgument)()}m(U,te,be){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,Ye=U.start.character,ot=U.end.character-U.start.character,ut=this.j.get(te);let Rt=0;if(be)for(const Ht of be){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(Ht);Rt|=1<<Gt>>>0}this.n(Ke,Ye,ot,ut,Rt)}n(U,te,be,Ke,Ye){if(this.f&&(U<this.c||U===this.c&&te<this.e)){this.f=!1;const Rt=this.g.length/5|0;let Ht=0,Gt=0;for(let Xt=0;Xt<Rt;Xt++){let Yt=this.g[5*Xt],Ti=this.g[5*Xt+1];Yt===0?(Yt=Ht,Ti+=Gt):Yt+=Ht,this.g[5*Xt]=Yt,this.g[5*Xt+1]=Ti,Ht=Yt,Gt=Ti}}let ot=U,ut=te;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ut-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ut,this.g[this.h++]=be,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=U,this.e=te}static o(U){const te=[],be=U.length/5|0;for(let ut=0;ut<be;ut++)te[ut]=ut;te.sort((ut,Rt)=>{const Ht=U[5*ut],Gt=U[5*Rt];if(Ht===Gt){const Xt=U[5*ut+1],Yt=U[5*Rt+1];return Xt-Yt}return Ht-Gt});const Ke=new Uint32Array(U.length);let Ye=0,ot=0;for(let ut=0;ut<be;ut++){const Rt=5*te[ut],Ht=U[Rt+0],Gt=U[Rt+1],Xt=U[Rt+2],Yt=U[Rt+3],Ti=U[Rt+4],tn=Ht-Ye,Tn=tn===0?Gt-ot:Gt,Pi=5*ut;Ke[Pi+0]=tn,Ke[Pi+1]=Tn,Ke[Pi+2]=Xt,Ke[Pi+3]=Yt,Ke[Pi+4]=Ti,Ye=Ht,ot=Gt}return Ke}build(U){return this.f?new Wt(new Uint32Array(this.g),U):new Wt(Ue.o(this.g),U)}}e.SemanticTokensBuilder=Ue;class Wt{constructor(U,te){this.resultId=te,this.data=U}}e.SemanticTokens=Wt;class Oi{constructor(U,te,be){this.start=U,this.deleteCount=te,this.data=be}}e.SemanticTokensEdit=Oi;class gt{constructor(U,te){this.resultId=te,this.edits=U}}e.SemanticTokensEdits=gt;var zi;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(zi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let hi=class{constructor(){}};hi.Back={iconPath:new Vt("arrow-left")},hi=qe([O],hi),e.QuickInputButtons=hi;var Fi;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})(Fi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Wi;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(Wi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var fi;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class Hi{static validate(U){if(typeof U.badge=="string"){let te=(0,F.nextCharLength)(U.badge,0);if(te<U.badge.length&&(te+=(0,F.nextCharLength)(U.badge,te)),U.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!Vt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,te,be){this.badge=U,this.tooltip=te,this.color=be}}e.FileDecoration=Hi;let ki=class{constructor(U){this.kind=U}};ki=qe([O],ki),e.ColorTheme=ki;var ji;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(ji=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(U){return U instanceof Kt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,te){if(U<0)throw(0,T.illegalArgument)("start must be positive");if(te<0)throw(0,T.illegalArgument)("end must be positive");U<=te?(this.c=U,this.e=te):(this.c=te,this.e=U)}with(U){let te=this.c,be=this.e;return U.start!==void 0&&(te=U.start),U.end!==void 0&&(be=U.end),te===this.c&&be===this.e?this:new Kt(te,be)}}e.NotebookRange=Kt;class mi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(te=>mi.isNotebookCellData(te))}static isNotebookCellData(U){return!0}constructor(U,te,be,Ke,Ye,ot,ut){this.kind=U,this.value=te,this.languageId=be,this.mime=Ke,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=ut,mi.validate(this)}}e.NotebookCellData=mi;class Vi{constructor(U){this.cells=U}}e.NotebookData=Vi;class zt{static isNotebookCellOutputItem(U){return U instanceof zt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const te={name:U.name,message:U.message,stack:U.stack};return zt.json(te,"application/vnd.code.notebook.error")}static stdout(U){return zt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return zt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,te="application/octet-stream"){return new zt(U,te)}static text(U,te=C.Mimes.text){const be=Oe(zt,v,"f",b).encode(String(U));return new zt(be,te)}static json(U,te="text/x-json"){const be=JSON.stringify(U,void 0,"	");return zt.text(be,te)}constructor(U,te){this.data=U,this.mime=te;const be=(0,C.normalizeMimeType)(te,!0);if(!be)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}}e.NotebookCellOutputItem=zt,v=zt,b={value:new TextEncoder};class gi{static isNotebookCellOutput(U){return U instanceof gi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,te=!1){const be=new Set,Ke=new Set;for(let Ye=0;Ye<U.length;Ye++){const ot=U[Ye],ut=(0,C.normalizeMimeType)(ot.mime);if(!be.has(ut)||(0,p.isTextStreamMime)(ut)){be.add(ut);continue}Ke.add(Ye),te&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?U:U.filter((Ye,ot)=>!Ke.has(ot))}constructor(U,te,be){this.items=gi.ensureUniqueMimeTypes(U,!0),typeof te=="string"?(this.id=te,this.metadata=be):(this.id=(0,N.generateUuid)(),this.metadata=te??be)}}e.NotebookCellOutput=gi;var qi;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(qi=e.NotebookCellKind||(e.NotebookCellKind={}));var Ki;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(Ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ne;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(ne=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var he;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(he=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ne{constructor(U,te){this.text=U,this.alignment=te}}e.NotebookCellStatusBarItem=Ne;var rt;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(rt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var yt;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(yt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Pt{constructor(U,te=[]){this.uri=U,this.provides=(0,i.asArray)(te)}}e.NotebookRendererScript=Pt;class on{constructor(U){this.label=U}}e.NotebookKernelSourceAction=on;let Gi=class{constructor(U,te){this.label=U,this.timestamp=te}};Gi=qe([O],Gi),e.TimelineItem=Gi;var an;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(an=e.ExtensionMode||(e.ExtensionMode={}));var cn;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(cn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var un;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(un=e.StandardTokenType||(e.StandardTokenType={}));class ln{constructor(U,te){this.ranges=U,this.wordPattern=te}}e.LinkedEditingRanges=ln;class dn{constructor(U,te){this.c=U,this.e=te}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=dn;var hn;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(hn=e.TestResultState||(e.TestResultState={}));var fn;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(fn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let xi=class{constructor(U=void 0,te=void 0,be=void 0){this.include=U,this.exclude=te,this.profile=be}};xi=qe([O],xi),e.TestRunRequest=xi;let Xi=R=class{static diff(U,te,be){const Ke=new R(U);return Ke.expectedOutput=te,Ke.actualOutput=be,Ke}constructor(U){this.message=U}};Xi=R=qe([O],Xi),e.TestMessage=Xi;let _i=class{constructor(U){this.id=U}};_i=qe([O],_i),e.TestTag=_i;let pi=class{constructor(U,te){this.covered=U,this.total=te}};pi=qe([O],pi),e.CoveredCount=pi;let Qi=A=class{static fromDetails(U,te){const be=new pi(0,0),Ke=new pi(0,0),Ye=new pi(0,0);for(const ut of te)if("branches"in ut){be.total+=1,be.covered+=ut.executionCount>0?1:0;for(const Rt of ut.branches)Ke.total+=1,Ke.covered+=Rt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ut.executionCount>0?1:0;const ot=new A(U,be,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=te,ot}constructor(U,te,be,Ke){this.uri=U,this.statementCoverage=te,this.branchCoverage=be,this.functionCoverage=Ke}};Qi=A=qe([O],Qi),e.FileCoverage=Qi;let Yi=class{constructor(U,te,be=[]){this.executionCount=U,this.location=te,this.branches=be}};Yi=qe([O],Yi),e.StatementCoverage=Yi;let Ji=class{constructor(U,te){this.executionCount=U,this.location=te}};Ji=qe([O],Ji),e.BranchCoverage=Ji;let Zi=class{constructor(U,te){this.executionCount=U,this.location=te}};Zi=qe([O],Zi),e.FunctionCoverage=Zi;var mn;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(mn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var gn;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(gn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var pn;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(pn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class vn{constructor(U,te,be,Ke,Ye,ot){this.kind=U,this.name=te,this.detail=be,this.uri=Ke,this.range=Ye,this.selectionRange=ot}}e.TypeHierarchyItem=vn;class bn{constructor(U){this.uri=U}}e.TextTabInput=bn;class En{constructor(U,te){this.original=U,this.modified=te}}e.TextDiffTabInput=En;class wn{constructor(U,te,be,Ke){this.base=U,this.input1=te,this.input2=be,this.result=Ke}}e.TextMergeTabInput=wn;class Sn{constructor(U,te){this.uri=U,this.viewType=te}}e.CustomEditorTabInput=Sn;class yn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=yn;class Dn{constructor(U,te){this.uri=U,this.notebookType=te}}e.NotebookEditorTabInput=Dn;class In{constructor(U,te,be){this.original=U,this.modified=te,this.notebookType=be}}e.NotebookDiffEditorTabInput=In;class Cn{constructor(){}}e.TerminalEditorTabInput=Cn;class kn{constructor(U,te){this.uri=U,this.inputBoxUri=te}}e.InteractiveWindowInput=kn}),define(Ce[97],ke([1,0,47,13,10,249,127,6,16]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function N(f,t){t?k.set(f,t):k.delete(f)}e.setWordDefinitionFor=N;function D(f){return k.get(f)}class g extends L.MirrorTextModel{constructor(t,a,l,v,b,E,w,r){super(a,l,v,b),this.m=t,this.p=E,this.q=w,this.notebook=r,this.b=!1}dispose(){(0,i.ok)(!this.b),this.b=!0,this.q=!1}equalLines(t){return(0,S.equals)(this.d,t)}get document(){if(!this.a){const t=this;this.a={get uri(){return t.c},get fileName(){return t.c.fsPath},get isUntitled(){return t.c.scheme===T.Schemas.untitled},get languageId(){return t.p},get version(){return t.g},get isClosed(){return t.b},get isDirty(){return t.q},save(){return t.r()},getText(a){return a?t.s(a):t.getText()},get eol(){return t.f===`
`?F.EndOfLine.LF:F.EndOfLine.CRLF},get lineCount(){return t.d.length},lineAt(a){return t.t(a)},offsetAt(a){return t.u(a)},positionAt(a){return t.v(a)},validateRange(a){return t.w(a)},validatePosition(a){return t.x(a)},getWordRangeAtPosition(a,l){return t.y(a,l)}}}return Object.freeze(this.a)}_acceptLanguageId(t){(0,i.ok)(!this.b),this.p=t}_acceptIsDirty(t){(0,i.ok)(!this.b),this.q=t}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(t){const a=this.w(t);if(a.isEmpty)return"";if(a.isSingleLine)return this.d[a.start.line].substring(a.start.character,a.end.character);const l=this.f,v=a.start.line,b=a.end.line,E=[];E.push(this.d[v].substring(a.start.character));for(let w=v+1;w<b;w++)E.push(this.d[w]);return E.push(this.d[b].substring(0,a.end.character)),E.join(l)}t(t){let a;if(t instanceof F.Position?a=t.line:typeof t=="number"&&(a=t),typeof a!="number"||a<0||a>=this.d.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new p(a,this.d[a],a===this.d.length-1)}u(t){return t=this.x(t),this.k(),this.h.getPrefixSum(t.line-1)+t.character}v(t){t=Math.floor(t),t=Math.max(0,t),this.k();const a=this.h.getIndexOf(t),l=this.d[a.index].length;return new F.Position(a.index,Math.min(a.remainder,l))}w(t){if(!(t instanceof F.Range))throw new Error("Invalid argument");const a=this.x(t.start),l=this.x(t.end);return a===t.start&&l===t.end?t:new F.Range(a.line,a.character,l.line,l.character)}x(t){if(!(t instanceof F.Position))throw new Error("Invalid argument");if(this.d.length===0)return t.with(0,0);let{line:a,character:l}=t,v=!1;if(a<0)a=0,l=0,v=!0;else if(a>=this.d.length)a=this.d.length-1,l=this.d[a].length,v=!0;else{const b=this.d[a].length;l<0?(l=0,v=!0):l>b&&(l=b,v=!0)}return v?new F.Position(a,l):t}y(t,a){const l=this.x(t);if(!a)a=D(this.p);else if((0,y.regExpLeadsToEndlessLoop)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const v=(0,C.getWordAtText)(l.character+1,(0,C.ensureValidWordDefinition)(a),this.d[l.line],0);if(v)return new F.Range(l.line,v.startColumn-1,l.line,v.endColumn-1)}}e.ExtHostDocumentData=g;class p{constructor(t,a,l){this.a=t,this.b=a,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new F.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new F.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=p}),define(Ce[184],ke([1,0,6,15,4]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(F){this.a=new i.ColorTheme(i.ColorThemeKind.Dark),this.b=new y.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(F){let S;switch(F){case"light":S=i.ColorThemeKind.Light;break;case"hcDark":S=i.ColorThemeKind.HighContrast;break;case"hcLight":S=i.ColorThemeKind.HighContrastLight;break;default:S=i.ColorThemeKind.Dark}this.a=new i.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};L=qe([je(0,T.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(Ce[8],ke([1,0,16,24,113,185,83,28,110,82,62,23,9,2,55,72,88,94,93,67,42,54,180,6]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a,l,v,b,E,w,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ye){function Pe(x){const{selectionStartLineNumber:Re,selectionStartColumn:Le,positionLineNumber:_e,positionColumn:ze}=x,Ze=new o.Position(Re-1,Le-1),bt=new o.Position(_e-1,ze-1);return new o.Selection(Ze,bt)}ye.to=Pe;function fe(x){const{anchor:Re,active:Le}=x;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ye.from=fe})(s=e.Selection||(e.Selection={}));var d;(function(ye){function Pe(x){if(!x)return;const{start:Re,end:Le}=x;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ye.from=Pe;function fe(x){if(!x)return;const{startLineNumber:Re,startColumn:Le,endLineNumber:_e,endColumn:ze}=x;return new o.Range(Re-1,Le-1,_e-1,ze-1)}ye.to=fe})(d=e.Range||(e.Range={}));var c;(function(ye){function Pe(fe){switch(fe){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}ye.to=Pe})(c=e.TokenType||(e.TokenType={}));var u;(function(ye){function Pe(x){return new o.Position(x.lineNumber-1,x.column-1)}ye.to=Pe;function fe(x){return{lineNumber:x.line+1,column:x.character+1}}ye.from=fe})(u=e.Position||(e.Position={}));var n;(function(ye){function Pe(Re,Le){return(0,i.coalesce)((0,i.asArray)(Re).map(_e=>fe(_e,Le)))}ye.from=Pe;function fe(Re,Le){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:x(Re.scheme,Le),pattern:X.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function x(Re,Le){return Le&&typeof Re=="string"?Le.transformOutgoingScheme(Re):Re}})(n=e.DocumentSelector||(e.DocumentSelector={}));var h;(function(ye){function Pe(x){switch(x){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}ye.from=Pe;function fe(x){switch(x){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}ye.to=fe})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var m;(function(ye){function Pe(x){let Re;return x.code&&((0,g.isString)(x.code)||(0,g.isNumber)(x.code)?Re=String(x.code):Re={value:String(x.code.value),target:x.code.target}),{...d.from(x.range),message:x.message,source:x.source,code:Re,severity:M.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(P.from),tags:Array.isArray(x.tags)?(0,i.coalesce)(x.tags.map(h.from)):void 0}}ye.from=Pe;function fe(x){const Re=new o.Diagnostic(d.to(x),x.message,M.to(x.severity));return Re.source=x.source,Re.code=(0,g.isString)(x.code)?x.code:x.code?.value,Re.relatedInformation=x.relatedInformation&&x.relatedInformation.map(P.to),Re.tags=x.tags&&(0,i.coalesce)(x.tags.map(h.to)),Re}ye.to=fe})(m=e.Diagnostic||(e.Diagnostic={}));var P;(function(ye){function Pe(x){return{...d.from(x.location.range),message:x.message,resource:x.location.uri}}ye.from=Pe;function fe(x){return new o.DiagnosticRelatedInformation(new o.Location(x.resource,d.to(x)),x.message)}ye.to=fe})(P=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var M;(function(ye){function Pe(x){switch(x){case o.DiagnosticSeverity.Error:return a.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return a.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return a.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return a.MarkerSeverity.Hint}return a.MarkerSeverity.Error}ye.from=Pe;function fe(x){switch(x){case a.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case a.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case a.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case a.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}ye.to=fe})(M=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var V;(function(ye){function Pe(x){return typeof x=="number"&&x>=o.ViewColumn.One?x-1:x===o.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}ye.from=Pe;function fe(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=fe})(V=e.ViewColumn||(e.ViewColumn={}));function Z(ye){return typeof ye.range<"u"}function G(ye){return ye.length===0?!0:!!Z(ye[0])}e.isDecorationOptionsArr=G;var R;(function(ye){function Pe(ze){return ze.map(ye.from)}ye.fromMany=Pe;function fe(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function x(ze){let Ze;if(fe(ze)){const{language:pt,value:It}=ze;Ze={value:"```"+pt+`
`+It+"\n```\n"}}else o.MarkdownString.isMarkdownString(ze)?Ze={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Ze={value:ze}:Ze={value:""};const bt=Object.create(null);Ze.uris=bt;const vt=pt=>{try{let It=p.URI.parse(pt,!0);It=It.with({query:Re(It.query,bt)}),bt[pt]=It}catch{}return""},At=new S.marked.Renderer;return At.link=vt,At.image=pt=>typeof pt=="string"?vt(C.parseHrefAndDimensions(pt).href):"",(0,S.marked)(Ze.value,{renderer:At}),Ze}ye.from=x;function Re(ze,Ze){if(!ze)return ze;let bt;try{bt=(0,k.parse)(ze)}catch{}if(!bt)return ze;let vt=!1;return bt=(0,D.cloneAndChange)(bt,At=>{if(p.URI.isUri(At)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[pt]=At,vt=!0,pt}else return}),vt?JSON.stringify(bt):ze}function Le(ze){const Ze=new o.MarkdownString(ze.value,ze.supportThemeIcons);return Ze.isTrusted=ze.isTrusted,Ze.supportHtml=ze.supportHtml,Ze.baseUri=ze.baseUri?p.URI.from(ze.baseUri):void 0,Ze}ye.to=Le;function _e(ze){if(!!ze)return typeof ze=="string"?ze:ye.from(ze)}ye.fromStrict=_e})(R=e.MarkdownString||(e.MarkdownString={}));function A(ye){return G(ye)?ye.map(Pe=>({range:d.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?R.fromMany(Pe.hoverMessage):Pe.hoverMessage?R.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):ye.map(Pe=>({range:d.from(Pe)}))}e.fromRangeOrRangeWithMessage=A;function O(ye){return typeof ye>"u"?ye:typeof ye=="string"?p.URI.file(ye):ye}e.pathOrURIToURI=O;var B;(function(ye){function Pe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?O(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ye.from=Pe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(ye){function Pe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?O(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?B.from(fe.before):void 0,after:fe.after?B.from(fe.after):void 0}}ye.from=Pe})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(ye){function Pe(fe){if(typeof fe>"u")return fe;switch(fe){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Pe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var K;(function(ye){function Pe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?j.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?z.from(fe.light):void 0,dark:fe.dark?z.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?O(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?B.from(fe.before):void 0,after:fe.after?B.from(fe.after):void 0}}ye.from=Pe})(K=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ie;(function(ye){function Pe(x){return{text:x.newText,eol:x.newEol&&it.from(x.newEol),range:d.from(x.range)}}ye.from=Pe;function fe(x){const Re=new o.TextEdit(d.to(x.range),x.text);return Re.newEol=typeof x.eol>"u"?void 0:it.to(x.eol),Re}ye.to=fe})(ie=e.TextEdit||(e.TextEdit={}));var me;(function(ye){function Pe(x,Re){const Le={edits:[]};if(x instanceof o.WorkspaceEdit){const _e=new F.ResourceSet;for(const ze of x._allEntries())ze._type===1&&p.URI.isUri(ze.to)&&ze.from===void 0&&_e.add(ze.to);for(const ze of x._allEntries())ze._type===1?Le.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contentsBase64:ze.options?.contents&&(0,T.encodeBase64)(T.VSBuffer.wrap(ze.options.contents))},metadata:ze.metadata}):ze._type===2?Le.edits.push({resource:ze.uri,textEdit:ie.from(ze.edit),versionId:_e.has(ze.uri)?void 0:Re?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Le.edits.push({resource:ze.uri,textEdit:{range:d.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:_e.has(ze.uri)?void 0:Re?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Le.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Le.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Re?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(wt.from)}})}return Le}ye.from=Pe;function fe(x){const Re=new o.WorkspaceEdit;for(const Le of x.edits)Le.textEdit?Re.replace(p.URI.revive(Le.resource),d.to(Le.textEdit.range),Le.textEdit.text):Re.renameFile(p.URI.revive(Le.oldResource),p.URI.revive(Le.newResource),Le.options);return Re}ye.to=fe})(me=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(ye){const Pe=Object.create(null);Pe[o.SymbolKind.File]=0,Pe[o.SymbolKind.Module]=1,Pe[o.SymbolKind.Namespace]=2,Pe[o.SymbolKind.Package]=3,Pe[o.SymbolKind.Class]=4,Pe[o.SymbolKind.Method]=5,Pe[o.SymbolKind.Property]=6,Pe[o.SymbolKind.Field]=7,Pe[o.SymbolKind.Constructor]=8,Pe[o.SymbolKind.Enum]=9,Pe[o.SymbolKind.Interface]=10,Pe[o.SymbolKind.Function]=11,Pe[o.SymbolKind.Variable]=12,Pe[o.SymbolKind.Constant]=13,Pe[o.SymbolKind.String]=14,Pe[o.SymbolKind.Number]=15,Pe[o.SymbolKind.Boolean]=16,Pe[o.SymbolKind.Array]=17,Pe[o.SymbolKind.Object]=18,Pe[o.SymbolKind.Key]=19,Pe[o.SymbolKind.Null]=20,Pe[o.SymbolKind.EnumMember]=21,Pe[o.SymbolKind.Struct]=22,Pe[o.SymbolKind.Event]=23,Pe[o.SymbolKind.Operator]=24,Pe[o.SymbolKind.TypeParameter]=25;function fe(Re){return typeof Pe[Re]=="number"?Pe[Re]:6}ye.from=fe;function x(Re){for(const Le in Pe)if(Pe[Le]===Re)return Number(Le);return o.SymbolKind.Property}ye.to=x})(ue=e.SymbolKind||(e.SymbolKind={}));var oe;(function(ye){function Pe(x){switch(x){case o.SymbolTag.Deprecated:return 1}}ye.from=Pe;function fe(x){switch(x){case 1:return o.SymbolTag.Deprecated}}ye.to=fe})(oe=e.SymbolTag||(e.SymbolTag={}));var De;(function(ye){function Pe(x){return{name:x.name,kind:ue.from(x.kind),tags:x.tags&&x.tags.map(oe.from),containerName:x.containerName,location:Ae.from(x.location)}}ye.from=Pe;function fe(x){const Re=new o.SymbolInformation(x.name,ue.to(x.kind),x.containerName,Ae.to(x.location));return Re.tags=x.tags&&x.tags.map(oe.to),Re}ye.to=fe})(De=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var re;(function(ye){function Pe(x){const Re={name:x.name||"!!MISSING: name!!",detail:x.detail,range:d.from(x.range),selectionRange:d.from(x.selectionRange),kind:ue.from(x.kind),tags:x.tags?.map(oe.from)??[]};return x.children&&(Re.children=x.children.map(Pe)),Re}ye.from=Pe;function fe(x){const Re=new o.DocumentSymbol(x.name,x.detail,ue.to(x.kind),d.to(x.range),d.to(x.selectionRange));return(0,i.isNonEmptyArray)(x.tags)&&(Re.tags=x.tags.map(oe.to)),x.children&&(Re.children=x.children.map(fe)),Re}ye.to=fe})(re=e.DocumentSymbol||(e.DocumentSymbol={}));var _;(function(ye){function Pe(x){const Re=new o.CallHierarchyItem(ue.to(x.kind),x.name,x.detail||"",p.URI.revive(x.uri),d.to(x.range),d.to(x.selectionRange));return Re._sessionId=x._sessionId,Re._itemId=x._itemId,Re}ye.to=Pe;function fe(x,Re,Le){if(Re=Re??x._sessionId,Le=Le??x._itemId,Re===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Le,name:x.name,detail:x.detail,kind:ue.from(x.kind),uri:x.uri,range:d.from(x.range),selectionRange:d.from(x.selectionRange),tags:x.tags?.map(oe.from)}}ye.from=fe})(_=e.CallHierarchyItem||(e.CallHierarchyItem={}));var le;(function(ye){function Pe(fe){return new o.CallHierarchyIncomingCall(_.to(fe.from),fe.fromRanges.map(x=>d.to(x)))}ye.to=Pe})(le=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Ee;(function(ye){function Pe(fe){return new o.CallHierarchyOutgoingCall(_.to(fe.to),fe.fromRanges.map(x=>d.to(x)))}ye.to=Pe})(Ee=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ae;(function(ye){function Pe(x){return{range:x.range&&d.from(x.range),uri:x.uri}}ye.from=Pe;function fe(x){return new o.Location(p.URI.revive(x.uri),d.to(x.range))}ye.to=fe})(Ae=e.location||(e.location={}));var Be;(function(ye){function Pe(x){const Re=x,Le=x;return{originSelectionRange:Re.originSelectionRange?d.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Le.uri,range:d.from(Re.targetRange?Re.targetRange:Le.range),targetSelectionRange:Re.targetSelectionRange?d.from(Re.targetSelectionRange):void 0}}ye.from=Pe;function fe(x){return{targetUri:p.URI.revive(x.uri),targetRange:d.to(x.range),targetSelectionRange:x.targetSelectionRange?d.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?d.to(x.originSelectionRange):void 0}}ye.to=fe})(Be=e.DefinitionLink||(e.DefinitionLink={}));var xe;(function(ye){function Pe(x){return{range:d.from(x.range),contents:R.fromMany(x.contents)}}ye.from=Pe;function fe(x){return new o.Hover(x.contents.map(R.to),d.to(x.range))}ye.to=fe})(xe=e.Hover||(e.Hover={}));var Te;(function(ye){function Pe(x){return{range:d.from(x.range),expression:x.expression}}ye.from=Pe;function fe(x){return new o.EvaluatableExpression(d.to(x.range),x.expression)}ye.to=fe})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ie;(function(ye){function Pe(x){if(x instanceof o.InlineValueText)return{type:"text",range:d.from(x.range),text:x.text};if(x instanceof o.InlineValueVariableLookup)return{type:"variable",range:d.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Pe;function fe(x){switch(x.type){case"text":return{range:d.to(x.range),text:x.text};case"variable":return{range:d.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:d.to(x.range),expression:x.expression}}}ye.to=fe})(Ie=e.InlineValue||(e.InlineValue={}));var Se;(function(ye){function Pe(x){return{frameId:x.frameId,stoppedLocation:d.from(x.stoppedLocation)}}ye.from=Pe;function fe(x){return new o.InlineValueContext(x.frameId,d.to(x.stoppedLocation))}ye.to=fe})(Se=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(ye){function Pe(x){return{range:d.from(x.range),kind:x.kind}}ye.from=Pe;function fe(x){return new o.DocumentHighlight(d.to(x.range),x.kind)}ye.to=fe})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(ye){function Pe(fe){switch(fe){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}ye.to=Pe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(ye){function Pe(fe){return{triggerKind:ce.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ye.to=Pe})(Y=e.CompletionContext||(e.CompletionContext={}));var I;(function(ye){function Pe(x){switch(x){case o.CompletionItemTag.Deprecated:return 1}}ye.from=Pe;function fe(x){switch(x){case 1:return o.CompletionItemTag.Deprecated}}ye.to=fe})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(ye){const Pe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function fe(Le){return Pe.get(Le)??9}ye.from=fe;const x=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Re(Le){return x.get(Le)??o.CompletionItemKind.Property}ye.to=Re})($=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(ye){function Pe(fe,x){const Re=new o.CompletionItem(fe.label);return Re.insertText=fe.insertText,Re.kind=$.to(fe.kind),Re.tags=fe.tags?.map(I.to),Re.detail=fe.detail,Re.documentation=C.isMarkdownString(fe.documentation)?R.to(fe.documentation):fe.documentation,Re.sortText=fe.sortText,Re.filterText=fe.filterText,Re.preselect=fe.preselect,Re.commitCharacters=fe.commitCharacters,f.Range.isIRange(fe.range)?Re.range=d.to(fe.range):typeof fe.range=="object"&&(Re.range={inserting:d.to(fe.range.insert),replacing:d.to(fe.range.replace)}),Re.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Re.insertText=new o.SnippetString(fe.insertText):(Re.insertText=fe.insertText,Re.textEdit=Re.range instanceof o.Range?new o.TextEdit(Re.range,Re.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Re.additionalTextEdits=fe.additionalTextEdits.map(Le=>ie.to(Le))),Re.command=x&&fe.command?x.fromInternal(fe.command):void 0,Re}ye.to=Pe})(H=e.CompletionItem||(e.CompletionItem={}));var q;(function(ye){function Pe(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:R.fromStrict(x.documentation)}}ye.from=Pe;function fe(x){return{label:x.label,documentation:C.isMarkdownString(x.documentation)?R.to(x.documentation):x.documentation}}ye.to=fe})(q=e.ParameterInformation||(e.ParameterInformation={}));var J;(function(ye){function Pe(x){return{label:x.label,documentation:R.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(q.from):[],activeParameter:x.activeParameter}}ye.from=Pe;function fe(x){return{label:x.label,documentation:C.isMarkdownString(x.documentation)?R.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(q.to):[],activeParameter:x.activeParameter}}ye.to=fe})(J=e.SignatureInformation||(e.SignatureInformation={}));var de;(function(ye){function Pe(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(J.from):[]}}ye.from=Pe;function fe(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(J.to):[]}}ye.to=fe})(de=e.SignatureHelp||(e.SignatureHelp={}));var we;(function(ye){function Pe(fe,x){const Re=new o.InlayHint(u.to(x.position),typeof x.label=="string"?x.label:x.label.map(ae.to.bind(void 0,fe)),x.kind&&pe.to(x.kind));return Re.textEdits=x.textEdits&&x.textEdits.map(ie.to),Re.tooltip=C.isMarkdownString(x.tooltip)?R.to(x.tooltip):x.tooltip,Re.paddingLeft=x.paddingLeft,Re.paddingRight=x.paddingRight,Re}ye.to=Pe})(we=e.InlayHint||(e.InlayHint={}));var ae;(function(ye){function Pe(fe,x){const Re=new o.InlayHintLabelPart(x.label);return Re.tooltip=C.isMarkdownString(x.tooltip)?R.to(x.tooltip):x.tooltip,t.Command.is(x.command)&&(Re.command=fe.fromInternal(x.command)),x.location&&(Re.location=Ae.to(x.location)),Re}ye.to=Pe})(ae=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var pe;(function(ye){function Pe(x){return x}ye.from=Pe;function fe(x){return x}ye.to=fe})(pe=e.InlayHintKind||(e.InlayHintKind={}));var ve;(function(ye){function Pe(x){return{range:d.from(x.range),url:x.target,tooltip:x.tooltip}}ye.from=Pe;function fe(x){let Re;if(x.url)try{Re=typeof x.url=="string"?p.URI.parse(x.url,!0):p.URI.revive(x.url)}catch{}return new o.DocumentLink(d.to(x.range),Re)}ye.to=fe})(ve=e.DocumentLink||(e.DocumentLink={}));var We;(function(ye){function Pe(x){const Re=new o.ColorPresentation(x.label);return x.textEdit&&(Re.textEdit=ie.to(x.textEdit)),x.additionalTextEdits&&(Re.additionalTextEdits=x.additionalTextEdits.map(Le=>ie.to(Le))),Re}ye.to=Pe;function fe(x){return{label:x.label,textEdit:x.textEdit?ie.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Re=>ie.from(Re)):void 0}}ye.from=fe})(We=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(ye){function Pe(x){return new o.Color(x[0],x[1],x[2],x[3])}ye.to=Pe;function fe(x){return[x.red,x.green,x.blue,x.alpha]}ye.from=fe})(He=e.Color||(e.Color={}));var tt;(function(ye){function Pe(x){return{range:d.from(x.range)}}ye.from=Pe;function fe(x){return new o.SelectionRange(d.to(x.range))}ye.to=fe})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(ye){function Pe(fe){switch(fe){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}ye.to=Pe})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(ye){function Pe(x){switch(x){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Pe;function fe(x){switch(x){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}ye.to=fe})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(ye){function Pe(x){if(x===o.EndOfLine.CRLF)return 1;if(x===o.EndOfLine.LF)return 0}ye.from=Pe;function fe(x){if(x===1)return o.EndOfLine.CRLF;if(x===0)return o.EndOfLine.LF}ye.to=fe})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(ye){function Pe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(ye){function Pe(fe){const x={start:fe.start+1,end:fe.end+1};return fe.kind&&(x.kind=st.from(fe.kind)),x}ye.from=Pe})(Fe=e.FoldingRange||(e.FoldingRange={}));var st;(function(ye){function Pe(fe){if(fe)switch(fe){case o.FoldingRangeKind.Comment:return t.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return t.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return t.FoldingRangeKind.Region}}ye.from=Pe})(st=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(ye){function Pe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?d.from(fe.selection):void 0,override:typeof fe.override=="boolean"?v.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=Pe})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var X;(function(ye){function Pe(Le){return Le instanceof o.RelativePattern?Le.toJSON():typeof Le=="string"?Le:fe(Le)||x(Le)?new o.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}ye.from=Pe;function fe(Le){const _e=Le;return _e?p.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function x(Le){const _e=Le;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Re(Le){return typeof Le=="string"?Le:new o.RelativePattern(p.URI.revive(Le.baseUri),Le.pattern)}ye.to=Re})(X=e.GlobPattern||(e.GlobPattern={}));var ge;(function(ye){function Pe(fe){if(fe){if(Array.isArray(fe))return fe.map(Pe);if(typeof fe=="string")return fe;{const x=fe;return{language:x.language,scheme:x.scheme,pattern:X.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}ye.from=Pe})(ge=e.LanguageSelector||(e.LanguageSelector={}));var Me;(function(ye){function Pe(x){return{start:x.start,end:x.end}}ye.from=Pe;function fe(x){return new o.NotebookRange(x.start,x.end)}ye.to=fe})(Me=e.NotebookRange||(e.NotebookRange={}));var $e;(function(ye){function Pe(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}ye.to=Pe;function fe(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}ye.from=fe})($e=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ve;(function(ye){function Pe(fe){if(fe===b.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(fe===b.NotebookCellExecutionState.Pending)return;if(fe===b.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ye.to=Pe})(Ve=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Qe;(function(ye){function Pe(x){switch(x){case o.NotebookCellKind.Markup:return b.CellKind.Markup;case o.NotebookCellKind.Code:default:return b.CellKind.Code}}ye.from=Pe;function fe(x){switch(x){case b.CellKind.Markup:return o.NotebookCellKind.Markup;case b.CellKind.Code:default:return o.NotebookCellKind.Code}}ye.to=fe})(Qe=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(ye){function Pe(x){const Re={metadata:x.metadata??Object.create(null),cells:[]};for(const Le of x.cells)o.NotebookCellData.validate(Le),Re.cells.push(wt.from(Le));return Re}ye.from=Pe;function fe(x){const Re=new o.NotebookData(x.cells.map(wt.to));return(0,g.isEmptyObject)(x.metadata)||(Re.metadata=x.metadata),Re}ye.to=fe})(nt=e.NotebookData||(e.NotebookData={}));var wt;(function(ye){function Pe(x){return{cellKind:Qe.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:$e.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(Ct.from):[]}}ye.from=Pe;function fe(x){return new o.NotebookCellData(Qe.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(Ct.to):void 0,x.metadata,x.internalMetadata?$e.to(x.internalMetadata):void 0)}ye.to=fe})(wt=e.NotebookCellData||(e.NotebookCellData={}));var St;(function(ye){function Pe(x){return{mime:x.mime,valueBytes:T.VSBuffer.wrap(x.data)}}ye.from=Pe;function fe(x){return new o.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}ye.to=fe})(St=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(ye){function Pe(x){return{outputId:x.id,items:x.items.map(St.from),metadata:x.metadata}}ye.from=Pe;function fe(x){const Re=x.items.map(St.to);return new o.NotebookCellOutput(Re,x.outputId,x.metadata)}ye.to=fe})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var lt;(function(ye){function Pe(Re){return x(Re)?{include:(0,g.withNullAsUndefined)(X.from(Re.include)),exclude:(0,g.withNullAsUndefined)(X.from(Re.exclude))}:(0,g.withNullAsUndefined)(X.from(Re))}ye.from=Pe;function fe(Re){return x(Re)?{include:X.to(Re.include),exclude:X.to(Re.exclude)}:X.to(Re)}ye.to=fe;function x(Re){const Le=Re;return Le?!(0,g.isUndefinedOrNull)(Le.include)&&!(0,g.isUndefinedOrNull)(Le.exclude):!1}})(lt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(ye){function Pe(fe,x,Re){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(Le,Re),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ye.from=Pe})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Bt;(function(ye){function Pe(fe,x,Re){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:x.toInternal(Le,Re),label:fe.label,description:fe.description,detail:fe.detail}}ye.from=Pe})(Bt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ot;(function(ye){function Pe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ye.from=Pe})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(ye){function Pe(x){return{uri:x.uri,provides:x.provides}}ye.from=Pe;function fe(x){return new o.NotebookRendererScript(p.URI.revive(x.uri),x.provides)}ye.to=fe})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(ye){function Pe(x){return{message:R.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:d.from(x.location.range),uri:x.location.uri}}}ye.from=Pe;function fe(x){const Re=new o.TestMessage(typeof x.message=="string"?x.message:R.to(x.message));return Re.actualOutput=x.actual,Re.expectedOutput=x.expected,Re.location=x.location?Ae.to(x.location):void 0,Re}ye.to=fe})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(ye){ye.namespace=w.namespaceTestTag,ye.denamespace=w.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var $t;(function(ye){function Pe(x){const Re=(0,l.getPrivateApiFor)(x).controllerId;return{extId:E.TestId.fromExtHostTestItem(x,Re).toString(),label:x.label,uri:p.URI.revive(x.uri),busy:x.busy,tags:x.tags.map(Le=>Dt.namespace(Re,Le.id)),range:f.Range.lift(d.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&R.fromStrict(x.error)||null}}ye.from=Pe;function fe(x){return{parent:void 0,error:void 0,id:E.TestId.fromString(x.extId).localId,label:x.label,uri:p.URI.revive(x.uri),tags:(x.tags||[]).map(Re=>{const{tagId:Le}=Dt.denamespace(Re);return new o.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}ye.toPlain=fe})($t=e.TestItem||(e.TestItem={})),function(ye){function Pe(x){return{id:x.id}}ye.from=Pe;function fe(x){return new o.TestTag(x.id)}ye.to=fe}(Dt=e.TestTag||(e.TestTag={}));var Nt;(function(ye){const Pe=(x,Re)=>{const Le=[];for(const[ze,Ze]of Re)E.TestId.compare(Ze.item.extId,ze)===2&&(Re.delete(ze),Le.push(Ze));const _e={...$t.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ze=>Ze.type===0).map(ft.to)})),children:Le.map(ze=>Pe(ze,Re))};for(const ze of _e.children)ze.parent=_e;return _e};function fe(x){const Re=[],Le=new Map;for(const _e of x.items){Le.set(_e.item.extId,_e);const ze=E.TestId.root(_e.item.extId);x.request.targets.some(Ze=>Ze.controllerId===ze&&Ze.testIds.includes(_e.item.extId))&&Re.push(_e)}return{completedAt:x.completedAt,results:Re.map(_e=>Pe(_e,Le))}}ye.to=fe})(Nt=e.TestResults||(e.TestResults={}));var Ge;(function(ye){function Pe(Le){return{covered:Le.covered,total:Le.covered}}function fe(Le){return"line"in Le?u.from(Le):d.from(Le)}function x(Le){return"branches"in Le?{count:Le.executionCount,location:fe(Le.location),type:1,branches:Le.branches.length?Le.branches.map(_e=>({count:_e.executionCount,location:_e.location&&fe(_e.location)})):void 0}:{type:0,count:Le.executionCount,location:fe(Le.location)}}ye.fromDetailed=x;function Re(Le){return{uri:Le.uri,statement:Pe(Le.statementCoverage),branch:Le.branchCoverage&&Pe(Le.branchCoverage),function:Le.functionCoverage&&Pe(Le.functionCoverage),details:Le.detailedCoverage?.map(x)}}ye.fromFile=Re})(Ge=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(ye){function Pe(fe){switch(fe){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}ye.to=Pe})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(ye){function Pe(x){const Re=new o.TypeHierarchyItem(ue.to(x.kind),x.name,x.detail||"",p.URI.revive(x.uri),d.to(x.range),d.to(x.selectionRange));return Re._sessionId=x._sessionId,Re._itemId=x._itemId,Re}ye.to=Pe;function fe(x,Re,Le){if(Re=Re??x._sessionId,Le=Le??x._itemId,Re===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Le,kind:ue.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:d.from(x.range),selectionRange:d.from(x.selectionRange),tags:x.tags?.map(oe.from)}}ye.from=fe})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ut;(function(ye){function Pe(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}ye.from=Pe})(Ut=e.ViewBadge||(e.ViewBadge={}));var mt;(function(ye){function Pe(Le,_e,ze){const Ze=_e.fileData;return Ze?new class extends o.DataTransferItem{asFile(){return{name:Ze.name,uri:p.URI.revive(Ze.uri),data:(0,L.once)(()=>ze())}}}("",_e.id):Le===N.Mimes.uriList&&_e.uriListData?new o.DataTransferItem(Re(_e.uriListData)):new o.DataTransferItem(_e.asString)}ye.to=Pe;async function fe(Le,_e){const ze=await _e.asString();if(Le===N.Mimes.uriList)return{id:_e.id,asString:"",fileData:void 0,uriListData:x(ze)};const Ze=_e.asFile();return{id:_e.id,asString:ze,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}ye.from=fe;function x(Le){return y.UriList.split(Le).map(_e=>{if(_e.startsWith("#"))return _e;try{return p.URI.parse(_e)}catch{}return _e})}function Re(Le){return y.UriList.create(Le.map(_e=>typeof _e=="string"?_e:p.URI.revive(_e)))}})(mt=e.DataTransferItem||(e.DataTransferItem={}));var kt;(function(ye){function Pe(x,Re){const Le=x.items.map(([_e,ze])=>[_e,mt.to(_e,ze,()=>Re(ze.id))]);return new o.DataTransfer(Le)}ye.toDataTransfer=Pe;async function fe(x){const Re={items:[]},Le=[];return x.forEach((_e,ze)=>{Le.push((async()=>{Re.items.push([ze,await mt.from(ze,_e)])})())}),await Promise.all(Le),Re}ye.toDataTransferDTO=fe})(kt=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[186],ke([1,0,2,11,6,8,154]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class F{constructor(k,N,D,g={timeout:1500,errors:3}){this.c=k,this.d=N,this.f=D,this.g=g,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(N,D,g)=>{const f={dispose:this.a.push([N,D,k])};return Array.isArray(g)&&g.push(f),f}}async $participateInSave(k,N){const D=i.URI.revive(k);let g=!1;const p=setTimeout(()=>g=!0,this.g.timeout),f=[];try{for(const t of[...this.a]){if(g)break;const a=this.d.getDocument(D),l=await this.h(t,{document:a,reason:L.TextDocumentSaveReason.to(N)});f.push(l)}}finally{clearTimeout(p)}return f}h([k,N,D],g){const p=this.b.get(k);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(D,k,N,g).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const t=this.b.get(k);this.b.set(k,t?t+1:1),typeof t=="number"&&t>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,N,D,g){const p=[],f=Date.now(),{document:t,reason:a}=g,{version:l}=t,v=Object.freeze({document:t,reason:a,waitUntil(b){if(Object.isFrozen(p))throw(0,T.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(b))}});try{N.apply(D,[v])}catch(b){return Promise.reject(b)}return Object.freeze(p),new Promise((b,E)=>{const w=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(p).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(w),b(r)}).catch(r=>{clearTimeout(w),E(r)})}).then(b=>{const E={edits:[]};for(const w of b)if(Array.isArray(w)&&w.every(r=>r instanceof y.TextEdit))for(const{newText:r,newEol:o,range:s}of w)E.edits.push({resource:t.uri,versionId:void 0,textEdit:{range:s&&L.Range.from(s),text:r,eol:o&&L.EndOfLine.from(o)}});if(E.edits.length!==0)return l===t.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=F}),define(Ce[187],ke([1,0,13,2,8,6,67]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class F{constructor(D,g,p,f){this.start=D,this.deletedCount=g,this.deletedItems=p,this.items=f}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(D,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,g,p){this.notebook=D,this.h=g,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(y.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(y.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,g=this.h.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:y.NotebookCellKind.to(this.j.cellKind),document:g.document,get mime(){return D.g},set mime(f){D.g=f},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(p)}return this.f}setOutputs(D){this.a=D.map(y.NotebookCellOutput.to)}setOutputItems(D,g,p){const f=p.map(y.NotebookCellOutputItem.to),t=this.a.find(a=>a.id===D);if(t&&(g||(t.items.length=0),t.items.push(...f),t.items.length>1&&t.items.every(a=>C.isTextStreamMime(a.mime)))){const a=new Map,l=[];t.items.forEach(v=>{let b;a.has(v.mime)?b=a.get(v.mime):(b=[],a.set(v.mime,b),l.push(v.mime)),b.push(v.data)}),t.items.length=0,l.forEach(v=>{const b=C.compressOutputItemStreams(a.get(v));t.items.push({mime:v,data:b.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(y.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=S;class k{constructor(D,g,p,f,t){this.k=D,this.l=g,this.m=p,this.uri=f,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=t.viewType,this.f=Object.freeze(t.metadata??Object.create(null)),this.r([[0,0,t.cells]],!0,void 0),this.g=t.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const D=this,g={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===i.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(p){return p=D.n(p),D.b[p].apiCell},getCells(p){return(p?D.p(p):D.b).map(t=>t.apiCell)},save(){return D.q()}};this.e=Object.freeze(g)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,g,p){this.g=D.versionId,this.h=g,this.acceptDocumentPropertiesChanged({metadata:p});const f={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},t=[];for(const l of D.rawEvents)l.kind===C.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,f.contentChanges):l.kind===C.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,f.contentChanges):l.kind===C.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),t.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===C.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),t.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),t.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===C.NotebookCellsChangeType.ChangeCellContent?t.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),t.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),t.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const a=new Map;for(let l=0;l<t.length;l++){const v=t[l],b=a.get(v.cell);if(b===void 0){const E=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});a.set(v.cell,E-1)}else f.cellChanges[b]={...f.cellChanges[b],...v}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let g=D.start|0,p=D.end|0;return g<0&&(g=0),p>this.b.length&&(p=this.b.length),D.with({start:g,end:p})}p(D){D=this.o(D);const g=[];for(let p=D.start;p<D.end;p++)g.push(this.b[p]);return g}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,g,p){if(this.j)return;const f=[],t=[],a=[];if(D.reverse().forEach(l=>{const b=l[2].map(r=>{const o=new S(this,this.l,r);return g||t.push(S.asModelAddData(this.apiNotebook,r)),o}),E=new F(l[0],l[1],[],b),w=this.b.splice(l[0],l[1],...b);for(const r of w)a.push(r.uri),E.deletedItems.push(r.apiCell);f.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:t,removedDocuments:a}),p)for(const l of f)p.push(l.asApiEvent())}s(D,g,p,f){const t=this.b.splice(D,g);this.b.splice(p,0,...t);const a=[new F(D,g,t.map(l=>l.apiCell),[]),new F(p,0,[],t)];for(const l of a)f.push(l.asApiEvent())}t(D,g){this.b[D].setOutputs(g)}u(D,g,p,f){this.b[D].setOutputItems(g,p,f)}v(D,g){const p=this.b[D];p.apiCell.document.languageId!==g&&this.m.$acceptModelLanguageChanged(p.uri,g)}w(D,g){const p=this.b[D];p.apiCell.mime=g}x(D,g){this.b[D].setMetadata(g)}y(D,g){this.b[D].setInternalMetadata(g)}getCellFromApiCell(D){return this.b.find(g=>g.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(g=>g.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.ExtHostNotebookDocument=k,k.a=0}),define(Ce[98],ke([1,0,11,8,6]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(F,S,k,N,D,g){this.id=F,this.f=S,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=N,this.c=g}get apiEditor(){if(!this.e){const F=this;this.e={get notebook(){return F.notebookData.apiNotebook},get selection(){return F.a[0]},set selection(S){this.selections=[S]},get selections(){return F.a},set selections(S){if(!Array.isArray(S)||!S.every(y.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");F.a=S,F.g(S)},get visibleRanges(){return F.b},revealRange(S,k){F.f.$tryRevealRange(F.id,T.NotebookRange.from(S),k??y.NotebookEditorRevealType.Default)},get viewColumn(){return F.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(F){this.d=F}_acceptVisibleRanges(F){this.b=F}_acceptSelections(F){this.a=F}g(F){this.f.$trySetSelections(this.id,F.map(T.NotebookRange.from))}_acceptViewColumn(F){this.c=F}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(Ce[188],ke([1,0,4,12,8]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=class{constructor(F,S){this.c=F,this.d=S,this.a=new i.Emitter,this.b=new i.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(F,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",F,S);const k=this.d.getEditorById(F);S.visibleRanges&&k._acceptVisibleRanges(S.visibleRanges.ranges.map(y.NotebookRange.to)),S.selections&&k._acceptSelections(S.selections.selections.map(y.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(F){for(const S in F)this.d.getEditorById(S)._acceptViewColumn(y.ViewColumn.to(F[S]))}};L=qe([je(0,T.ILogService)],L),e.ExtHostNotebookEditors=L}),define(Ce[189],ke([1,0,8,157,136,20,61,11]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(g){this.b=0,this.c=new Map,this.a=g}async withProgress(g,p,f){const t=this.b++,{title:a,location:l,cancellable:v}=p,b={label:(0,y.localize)(0,null,g.displayName||g.name),id:g.identifier.value};return this.a.$startProgress(t,{location:i.ProgressLocation.from(l),title:a,source:b,cancellable:v},g.isUnderDevelopment?void 0:g.identifier.value).catch(F.onUnexpectedExternalError),this.d(t,f,!!v)}d(g,p,f){let t;f&&(t=new L.CancellationTokenSource,this.c.set(g,t));const a=v=>{this.a.$progressEnd(v),this.c.delete(v),t?.dispose()};let l;try{l=p(new N(this.a,g),f&&t?t.token:L.CancellationToken.None)}catch(v){throw a(g),v}return l.then(v=>a(g),v=>a(g)),l}$acceptProgressCanceled(g){const p=this.c.get(g);p&&(p.cancel(),this.c.delete(g))}}e.ExtHostProgress=S;function k(D,g){return D.message=g.message,typeof g.increment=="number"&&(typeof D.increment=="number"?D.increment+=g.increment:D.increment=g.increment),D}class N extends T.Progress{constructor(g,p){super(f=>this.throttledReport(f)),this.c=g,this.d=p}throttledReport(g){this.c.$progressReport(this.d,g)}}qe([(0,C.throttle)(100,(D,g)=>k(D,g),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(Ce[99],ke([1,0,55,94,42,68,54,8,2]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(b,E,w,r)=>{let o=E;return{enumerable:!0,configurable:!1,get(){return o},set(s){if(!w(o,s)){const d=o;o=s,b.listener?.(r(s,d))}}}},N=(b,E)=>b===E,D={range:(b,E)=>b===E?!0:!b||!E?!1:b.isEqual(E),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(b,E)=>!(b.length!==E.length||b.some(w=>!E.find(r=>w.id===r.id)))},g=b=>E=>({op:4,update:b(E)}),p=(b,E)=>({range:(()=>{let w;const r=g(o=>({range:i.Range.lift(F.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return w},set(o){b.listener?.({op:6}),D.range(w,o)||(w=o,b.listener?.(r(o)))}}})(),label:k(b,E,D.label,g(w=>({label:w}))),description:k(b,void 0,D.description,g(w=>({description:w}))),sortText:k(b,void 0,D.sortText,g(w=>({sortText:w}))),canResolveChildren:k(b,!1,D.canResolveChildren,w=>({op:2,state:w})),busy:k(b,!1,D.busy,g(w=>({busy:w}))),error:k(b,void 0,D.error,g(w=>({error:F.MarkdownString.fromStrict(w)||null}))),tags:k(b,[],D.tags,(w,r)=>({op:1,new:w.map(F.TestTag.from),old:r.map(F.TestTag.from)}))}),f=b=>{const E=y.TestId.fromString(b.extId),w=new a(E.controllerId,E.localId,b.label,S.URI.revive(b.uri)||void 0);return w.range=F.Range.to(b.range||void 0),w.description=b.description||void 0,w.sortText=b.sortText||void 0,w.tags=b.tags.map(r=>F.TestTag.to({id:(0,C.denamespaceTestTag)(r).tagId})),w},t=b=>{let E;for(const w of b.tests){const r=f(w.item);(0,T.getPrivateApiFor)(r).parent=E,E=r}return E};e.toItemFromContext=t;class a{constructor(E,w,r,o){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const s=(0,T.createPrivateApiFor)(this,E);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof l?void 0:s.parent}},children:{value:(0,L.createTestItemChildren)(s,T.getPrivateApiFor,a),enumerable:!0,writable:!1},...p(s,r)})}}e.TestItemImpl=a;class l extends a{constructor(E,w){super(E,E,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class v extends L.TestItemCollection{constructor(E,w,r){super({controllerId:E,getDocumentVersion:o=>o&&r.getDocument(o)?.version,getApiFor:T.getPrivateApiFor,getChildren:o=>o.children,root:new l(E,w),toITestItem:F.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ce[100],ke([1,0,47,11,81,8,6]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class F{constructor(g,p,f){const t=F.c.nextId();g.$registerTextEditorDecorationType(p.identifier,t,L.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:t,dispose(){g.$removeTextEditorDecorationType(t)}})}}e.TextEditorDecorationType=F,F.c=new y.IdGenerator("TextEditorDecorationType");class S{constructor(g,p){this.g=[],this.h=void 0,this.j=!1,this.c=g,this.d=g.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(g,p){this.k();let f=null;if(g instanceof C.Position)f=new C.Range(g,g);else if(g instanceof C.Range)f=g;else throw new Error("Unrecognized location");this.l(f,p,!1)}insert(g,p){this.k(),this.l(new C.Range(g,g),p,!0)}delete(g){this.k();let p=null;if(g instanceof C.Range)p=g;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(g,p,f){const t=this.c.validateRange(g);this.g.push({range:t,text:p,forceMoveMarkers:f})}setEndOfLine(g){if(this.k(),g!==C.EndOfLine.LF&&g!==C.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this.h=g}}class k{constructor(g,p,f,t){this.c=g,this.d=p,this._accept(f),this.e=t;const a=this;this.value={get tabSize(){return a.f},set tabSize(l){a.m(l)},get indentSize(){return a.g},set indentSize(l){a.o(l)},get insertSpaces(){return a.h},set insertSpaces(l){a.q(l)},get cursorStyle(){return a.j},set cursorStyle(l){a.s(l)},get lineNumbers(){return a.k},set lineNumbers(l){a.t(l)}}}_accept(g){this.f=g.tabSize,this.g=g.indentSize,this.h=g.insertSpaces,this.j=g.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(g.lineNumbers)}l(g){if(g==="auto")return"auto";if(typeof g=="number"){const p=Math.floor(g);return p>0?p:null}if(typeof g=="string"){const p=parseInt(g,10);return isNaN(p)?null:p>0?p:null}return null}m(g){const p=this.l(g);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(g){if(g==="tabSize")return"tabSize";if(typeof g=="number"){const p=Math.floor(g);return p>0?p:null}if(typeof g=="string"){const p=parseInt(g,10);return isNaN(p)?null:p>0?p:null}return null}o(g){const p=this.n(g);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}q(g){const p=this.p(g);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(g){this.j!==g&&(this.j=g,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:g})))}t(g){this.k!==g&&(this.k=g,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(g)})))}assign(g){const p={};let f=!1;if(typeof g.tabSize<"u"){const t=this.l(g.tabSize);t==="auto"?(f=!0,p.tabSize=t):typeof t=="number"&&this.f!==t&&(this.f=t,f=!0,p.tabSize=t)}if(typeof g.indentSize<"u"){const t=this.n(g.indentSize);t==="tabSize"?(f=!0,p.indentSize=t):typeof t=="number"&&this.g!==t&&(this.g=t,f=!0,p.indentSize=t)}if(typeof g.insertSpaces<"u"){const t=this.p(g.insertSpaces);t==="auto"?(f=!0,p.insertSpaces=t):this.h!==t&&(this.h=t,f=!0,p.insertSpaces=t)}typeof g.cursorStyle<"u"&&this.j!==g.cursorStyle&&(this.j=g.cursorStyle,f=!0,p.cursorStyle=g.cursorStyle),typeof g.lineNumbers<"u"&&this.k!==g.lineNumbers&&(this.k=g.lineNumbers,f=!0,p.lineNumbers=L.TextEditorLineNumbersStyle.from(g.lineNumbers)),f&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(g,p){p.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this.e.warn(f)})}}e.ExtHostTextEditorOptions=k;class N{constructor(g,p,f,t,a,l,v,b){this.id=g,this.j=p,this.k=f,this.g=!1,this.h=new Set,this.c=a,this.d=new k(this.j,this.id,l,f),this.e=v,this.f=b;const E=this;this.value=Object.freeze({get document(){return t.getValue()},set document(w){throw(0,T.readonly)("document")},get selection(){return E.c&&E.c[0]},set selection(w){if(!(w instanceof C.Selection))throw(0,T.illegalArgument)("selection");E.c=[w],E.l()},get selections(){return E.c},set selections(w){if(!Array.isArray(w)||w.some(r=>!(r instanceof C.Selection)))throw(0,T.illegalArgument)("selections");E.c=w,E.l()},get visibleRanges(){return E.e},set visibleRanges(w){throw(0,T.readonly)("visibleRanges")},get options(){return E.d.value},set options(w){E.g||E.d.assign(w)},get viewColumn(){return E.f},set viewColumn(w){throw(0,T.readonly)("viewColumn")},edit(w,r={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new S(t.getValue(),r);return w(o),E.m(o)},insertSnippet(w,r,o={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!r||Array.isArray(r)&&r.length===0)s=E.c.map(d=>L.Range.from(d));else if(r instanceof C.Position){const{lineNumber:d,column:c}=L.Position.from(r);s=[{startLineNumber:d,startColumn:c,endLineNumber:d,endColumn:c}]}else if(r instanceof C.Range)s=[L.Range.from(r)];else{s=[];for(const d of r)if(d instanceof C.Range)s.push(L.Range.from(d));else{const{lineNumber:c,column:u}=L.Position.from(d);s.push({startLineNumber:c,startColumn:u,endLineNumber:c,endColumn:u})}}return p.$tryInsertSnippet(g,t.getValue().version,w.value,s,o)},setDecorations(w,r){const o=r.length===0;o&&!E.h.has(w.key)||(o?E.h.delete(w.key):E.h.add(w.key),E.n(()=>{if(L.isDecorationOptionsArr(r))return p.$trySetDecorations(g,w.key,L.fromRangeOrRangeWithMessage(r));{const s=new Array(4*r.length);for(let d=0,c=r.length;d<c;d++){const u=r[d];s[4*d]=u.start.line+1,s[4*d+1]=u.start.character+1,s[4*d+2]=u.end.line+1,s[4*d+3]=u.end.character+1}return p.$trySetDecorationsFast(g,w.key,s)}}))},revealRange(w,r){E.n(()=>p.$tryRevealRange(g,L.Range.from(w),r||C.TextEditorRevealType.Default))},show(w){p.$tryShowEditor(g,L.ViewColumn.from(w))},hide(){p.$tryHideEditor(g)}})}dispose(){(0,i.ok)(!this.g),this.g=!0}_acceptOptions(g){(0,i.ok)(!this.g),this.d._accept(g)}_acceptVisibleRanges(g){(0,i.ok)(!this.g),this.e=g}_acceptViewColumn(g){(0,i.ok)(!this.g),this.f=g}_acceptSelections(g){(0,i.ok)(!this.g),this.c=g}async l(){const g=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,g)),this.value}m(g){const p=g.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const f=p.edits.map(a=>a.range);f.sort((a,l)=>a.end.line===l.end.line?a.end.character===l.end.character?a.start.line===l.start.line?a.start.character-l.start.character:a.start.line-l.start.line:a.end.character-l.end.character:a.end.line-l.end.line);for(let a=0,l=f.length-1;a<l;a++){const v=f[a].end;if(f[a+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const t=p.edits.map(a=>({range:L.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,t,{setEndOfLine:typeof p.setEndOfLine=="number"?L.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(g){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.ExtHostTextEditor=N}),define(Ce[190],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[191],ke([1,0,147,11,29,87,90,30,25,190,156,149]),function(ee,e,i,T,y,L,C,F,S,k,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const g=F.Registry.as(C.Extensions.JSONContribution);class p{constructor(w,r,o){this.a=w,this.b=r,this.c=o}d(w,r){this.a({type:w,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(w){this.d(y.default.Error,w)}warn(w){this.d(y.default.Warning,w)}info(w){this.d(y.default.Info,w)}}e.ExtensionMessageCollector=p;class f{static a(w){const r=new Set;for(let o=0,s=w.length;o<s;o++)r.add(S.ExtensionIdentifier.toKey(w[o].description.identifier));return r}static compute(w,r){if(!w||!w.length)return new f(r,[]);if(!r||!r.length)return new f([],w);const o=this.a(w),s=this.a(r),d=r.filter(u=>!o.has(S.ExtensionIdentifier.toKey(u.description.identifier))),c=w.filter(u=>!s.has(S.ExtensionIdentifier.toKey(u.description.identifier)));return new f(d,c)}constructor(w,r){this.added=w,this.removed=r}}e.ExtensionPointUserDelta=f;class t{constructor(w,r){this.name=w,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(w){if(this.a!==null)throw new Error("Handler already set!");this.a=w,this.d()}acceptUsers(w){this.c=f.compute(this.b,w),this.b=w,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(w){(0,T.onUnexpectedError)(w)}}}e.ExtensionPoint=t;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:i.localize(15,null),type:"string",enum:["none"],enumDescriptions:[i.localize(16,null)]},activationEvents:{description:i.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(32,null)},{label:"onUri",body:"onUri",description:i.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(37,null)},{label:"onRenderer",description:i.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(41,null)},{label:"*",description:i.localize(42,null),body:"*"}]}},badges:{type:"array",description:i.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(44,null)},href:{type:"string",description:i.localize(45,null)},description:{type:"string",description:i.localize(46,null)}}}},markdown:{type:"string",description:i.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(51,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(52,null)},{body:["workspace"],description:i.localize(53,null)},{body:["ui","workspace"],description:i.localize(54,null)},{body:["workspace","ui"],description:i.localize(55,null)},{body:[],description:i.localize(56,null)}]},capabilities:{description:i.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)]},description:{type:"string",markdownDescription:i.localize(63,null)}}},untrustedWorkspaces:{description:i.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(66,null),i.localize(67,null),i.localize(68,null)]},restrictedConfigurations:{description:i.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(70,null)}}}}},sponsor:{description:i.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(73,null),type:"string"},"vscode:uninstall":{description:i.localize(74,null),type:"string"}}},icon:{type:"string",description:i.localize(75,null)},l10n:{type:"string",description:i.localize(76,null)}}};class v{constructor(){this.a=new Map}registerExtensionPoint(w){if(this.a.has(w.extensionPoint))throw new Error("Duplicate extension point: "+w.extensionPoint);const r=new t(w.extensionPoint,w.defaultExtensionKind);return this.a.set(w.extensionPoint,r),w.activationEventsGenerator&&D.ImplicitActivationEvents.register(w.extensionPoint,w.activationEventsGenerator),e.schema.properties.contributes.properties[w.extensionPoint]=w.jsonSchema,g.registerSchema(l,e.schema),r}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=v;const b={ExtensionsRegistry:"ExtensionsRegistry"};F.Registry.add(b.ExtensionsRegistry,new v),e.ExtensionsRegistry=F.Registry.as(b.ExtensionsRegistry),g.registerSchema(l,e.schema),g.registerSchema(N.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ce[192],ke([1,0,144,9,23,191,41,4]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var k;(function(g){function p(f,t,a){if(!f)return;const l=T.isString(f.type)?f.type:void 0;if(!l||l.length===0){a.error(i.localize(3,null));return}const v=[];if(Array.isArray(f.required))for(const b of f.required)T.isString(b)&&v.push(b);return{extensionId:t.value,taskType:l,required:v,properties:f.properties?y.deepClone(f.properties):{},when:f.when?C.ContextKeyExpr.deserialize(f.when):void 0}}g.from=p})(k||(k={}));const N=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:i.localize(4,null),type:"array",items:S}});class D{constructor(){this.d=new F.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,f)=>{N.setHandler((t,a)=>{this.c=void 0;try{for(const l of a.removed){const v=l.value;for(const b of v)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const l of a.added){const v=l.value;for(const b of v){const E=k.from(b,l.description.identifier,l.collector);E&&(this.a[E.taskType]=E)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const f of this.all()){const t={type:"object",additionalProperties:!1};f.required.length>0&&(t.required=f.required.slice(0)),f.properties!==void 0?t.properties=y.deepClone(f.properties):t.properties=Object.create(null),t.properties.type={type:"string",enum:[f.taskType]},p.push(t)}this.c={oneOf:p}}return this.c}}e.TaskDefinitionRegistry=new D}),define(Ce[193],ke([1,0,145,9,22,23,41,192]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var S;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function B(z){if(!z)return O.Strong;switch(z.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=B}(S=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var N;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(N=e.RevealKind||(e.RevealKind={})),function(O){function B(z){switch(z.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=B}(N=e.RevealKind||(e.RevealKind={}));var D;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(D=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function B(z){switch(z.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=B}(D=e.RevealProblemKind||(e.RevealProblemKind={}));var g;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(g=e.PanelKind||(e.PanelKind={})),function(O){function B(z){switch(z.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=B}(g=e.PanelKind||(e.PanelKind={}));var p;(function(O){O.defaults={echo:!0,reveal:N.Always,revealProblems:D.Never,focus:!1,panel:g.Shared,showReuseMessage:!0,clear:!1}})(p=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(O){function B(j){switch(j.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=B;function z(j){switch(j){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=z}(f=e.RuntimeType||(e.RuntimeType={}));var t;(function(O){function B(z){return T.isString(z)?z:z.value}O.value=B})(t=e.CommandString||(e.CommandString={}));var a;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function B(j){return j===O.Clean._id||j===O.Build._id||j===O.Rebuild._id||j===O.Test._id}O.is=B;function z(j){if(j!==void 0)return T.isString(j)?B(j)?{_id:j,isDefault:!1}:void 0:j}O.from=z})(a=e.TaskGroup||(e.TaskGroup={}));var l;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var v;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function B(z){switch(z){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=B})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(O){O.parallel="parallel",O.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var E;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(E=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class r{constructor(B,z,j,K,ie,me){this._label="",this._id=B,z&&(this._label=z),j&&(this.type=j),this.runOptions=K,this.configurationProperties=ie,this._source=me}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,z=!1){if(B===void 0)return!1;if(T.isString(B))return B===this._label||B===this.configurationProperties.identifier||z&&B===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.CommonTask=r;class o extends r{constructor(B,z,j,K,ie,me,ue,oe){super(B,j,void 0,ue,oe,z),this.command={},this._source=z,this.hasDefinedMatchers=me,ie&&(this.command=ie)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case f.Shell:z="shell";break;case f.Process:z="process";break;case f.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(B){return B instanceof o}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let z=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:z};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new o(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=o;class s extends r{constructor(B,z,j,K,ie,me,ue){super(B,j,K,me,ue,z),this._source=z,this.configures=ie}static is(B){return B instanceof s}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let z=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:z};return JSON.stringify(j)}}e.ConfiguringTask=s;class d extends r{constructor(B,z,j,K,ie,me,ue,oe,De){super(B,j,K,oe,De,z),this.defines=ie,this.hasDefinedMatchers=ue,this.command=me,this.icon=De.icon,this.hide=De.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof d}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new d(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=d;class c extends r{constructor(B,z,j,K,ie,me){super(B,j,K,ie,me,z),this._source=z}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new c(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=c;var u;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class h{constructor(B){this.c=new Map;for(let z=0;z<B.length;z++)this.c.set(B[z].uri.toString(),z)}compare(B,z){const j=B.getWorkspaceFolder(),K=z.getWorkspaceFolder();if(j&&K){let ie=this.c.get(j.uri.toString());ie=ie===void 0?0:ie+1;let me=this.c.get(K.uri.toString());return me=me===void 0?0:me+1,ie===me?B._label.localeCompare(z._label):ie-me}else return!j&&K?-1:j&&!K?1:0}}e.TaskSorter=h;var m;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(m=e.TaskEventKind||(e.TaskEventKind={}));var P;(function(O){O.SingleRun="singleRun",O.Background="background"})(P=e.TaskRunType||(e.TaskRunType={}));var M;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(M=e.TaskRunSource||(e.TaskRunSource={}));var V;(function(O){function B(z,j,K,ie){if(j){const me={kind:z,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:K,__task:j};return z==="start"?me.resolvedVariables=ie:z==="processStarted"?me.processId=ie:z==="processEnded"&&(me.exitCode=ie),Object.freeze(me)}else return Object.freeze({kind:"changed"})}O.create=B})(V=e.TaskEvent||(e.TaskEvent={}));var Z;(function(O){function B(j){const K=Object.keys(j).sort();let ie="";for(const me of K){let ue=j[me];ue instanceof Object?ue=B(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ie+=me+","+ue+","}return ie}function z(j){const ie={_key:B(j),type:j.taskType};return Object.assign(ie,j),ie}O.create=z})(Z=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var G;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(G=e.TaskSettingId||(e.TaskSettingId={}));var R;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(R=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var A;(function(O){function B(z,j){const K=F.TaskDefinitionRegistry.get(z.type);if(K===void 0){const oe=L.deepClone(z);return delete oe._key,Z.create(oe)}const ie=Object.create(null);ie.type=K.taskType;const me=new Set;K.required.forEach(oe=>me.add(oe));const ue=K.properties;for(const oe of Object.keys(ue)){const De=z[oe];if(De!=null)ie[oe]=De;else if(me.has(oe)){const re=ue[oe];if(re.default!==void 0)ie[oe]=L.deepClone(re.default);else switch(re.type){case"boolean":ie[oe]=!1;break;case"number":case"integer":ie[oe]=0;break;case"string":ie[oe]="";break;default:j.error(i.localize(2,null,JSON.stringify(z,void 0,0),oe));return}}}return Z.create(ie)}O.createTaskIdentifier=B})(A=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[194],ke([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,F)=>{this.b=C,this.d=F,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,i.onUnexpectedError)(C))}then(C,F){return this.j().then(C,F)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=T;class y extends T{constructor(){super(),this.h=!0,this.i=new i.CancellationError}}e.CanceledLazyPromise=y}),define(Ce[43],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const T=[];function y(F){const S=new i(F);return T[S.nid]=S,S}e.createProxyIdentifier=y;function L(F){return T[F].sid}e.getStringIdentifierForProxy=L;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(Ce[5],ke([1,0,43]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(t){t[t.UnknownInput=0]="UnknownInput",t[t.TextInput=1]="TextInput",t[t.TextDiffInput=2]="TextDiffInput",t[t.TextMergeInput=3]="TextMergeInput",t[t.NotebookInput=4]="NotebookInput",t[t.NotebookDiffInput=5]="NotebookDiffInput",t[t.CustomEditorInput=6]="CustomEditorInput",t[t.WebviewEditorInput=7]="WebviewEditorInput",t[t.TerminalEditorInput=8]="TerminalEditorInput",t[t.InteractiveEditorInput=9]="InteractiveEditorInput"})(y=e.TabInputKind||(e.TabInputKind={}));var L;(function(t){t[t.TAB_OPEN=0]="TAB_OPEN",t[t.TAB_CLOSE=1]="TAB_CLOSE",t[t.TAB_UPDATE=2]="TAB_UPDATE",t[t.TAB_MOVE=3]="TAB_MOVE"})(L=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(t){t[t.Editable=0]="Editable",t[t.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var F;(function(t){t[t.Int8Array=1]="Int8Array",t[t.Uint8Array=2]="Uint8Array",t[t.Uint8ClampedArray=3]="Uint8ClampedArray",t[t.Int16Array=4]="Int16Array",t[t.Uint16Array=5]="Uint16Array",t[t.Int32Array=6]="Int32Array",t[t.Uint32Array=7]="Uint32Array",t[t.Float32Array=8]="Float32Array",t[t.Float64Array=9]="Float64Array",t[t.BigInt64Array=10]="BigInt64Array",t[t.BigUint64Array=11]="BigUint64Array"})(F=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(t){t[t.Text=1]="Text",t[t.Error=2]="Error",t[t.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(t){t[t.None=0]="None",t[t.Process=1]="Process",t[t.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class D{static mixin(a){return a._id=D.a++,a}}e.IdObject=D,D.a=0;var g;(function(t){t.label="a",t.kind="b",t.detail="c",t.documentation="d",t.sortText="e",t.filterText="f",t.preselect="g",t.insertText="h",t.insertTextRules="i",t.range="j",t.commitCharacters="k",t.additionalTextEdits="l",t.kindModifier="m",t.commandIdent="n",t.commandId="o",t.commandArguments="p"})(g=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(t){t.defaultRanges="a",t.completions="b",t.isIncomplete="c",t.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(t){t[t.Workspace=0]="Workspace",t[t.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[73],ke([1,0,3,12,5,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,k){this.c=k,this.a=new Set,this.b=S.getProxy(y.MainContext.MainThreadTelemetry)}report(S,k,N){const D=this.d(S,k);this.a.has(D)||(this.a.add(D),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}d(S,k){return`${S}-${k.identifier.value}`}};C=qe([je(0,L.IExtHostRpcService),je(1,T.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(F,S,k){}})}),define(Ce[195],ke([1,0,4,5,6,25]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this.b=new Map,this.c=[],this.d=new i.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,k,N,D={}){const g=L.ExtensionIdentifier.toKey(S.identifier),p=this.f.get(g)||[],f=[...N].sort().join(" ");let t=p.find(a=>a.providerId===k&&a.scopes===f);if(t)return t.result;{const a=this.g(S,g,k,N,D);t={providerId:k,scopes:f,result:a},p.push(t),this.f.set(g,p);try{await a}finally{const l=p.findIndex(v=>v.providerId===k&&v.scopes===f);l>-1&&(p.splice(l),this.f.set(g,p))}return a}}async g(S,k,N,D,g={}){await this.a.$ensureProvider(N);const p=S.displayName||S.name;return this.a.$getSession(N,D,k,p,g)}async removeSession(S,k){const N=this.b.get(S);return N?N.provider.removeSession(k):this.a.$removeSession(S,k)}registerAuthenticationProvider(S,k,N,D){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:k,provider:N,options:D??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===S)||this.c.push({id:S,label:k});const g=N.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(S,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(S,k,D?.supportsMultipleAccounts??!1),new y.Disposable(()=>{g.dispose(),this.b.delete(S);const p=this.c.findIndex(f=>f.id===S);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this.d.fire({provider:{id:S,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(Ce[196],ke([1,0,5,15,8]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(F,S){this.a=F.getProxy(i.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>S.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(F,S,k){const N=y.WorkspaceEdit.from(F,this.b);return this.a.$tryApplyWorkspaceEdit(N,void 0,k?.isRefactoring??!1)}};L=qe([je(0,T.IExtHostRpcService)],L),e.ExtHostBulkEdits=L}),define(Ce[197],ke([1,0,5]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(L){const C=L.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(F){return C.$writeText(F)}})}}e.ExtHostClipboard=T});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[38],ke([1,0,9,6,8,23,5,16,12,82,55,250,2,7,3,15,99,24,43,45,74,50]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a,l,v,b,E,w){"use strict";var r,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(m,P){r.set(this,void 0),this.b=new Map,this.c=new Map,o.set(this,void 0),Je(this,r,m.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=P,Je(this,o,m.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,M=>{const V=this.c.get(M);return V?.result===u.Void?V:void 0},P),this.f=[{processArgument(M){return(0,k.revive)(M)}},{processArgument(M){return(0,L.cloneAndChange)(M,function(V){if(N.Range.isIRange(V))return y.Range.to(V);if(D.Position.isIPosition(V))return y.Position.to(V);if(N.Range.isIRange(V.range)&&g.URI.isUri(V.uri))return y.location.to(V);if(V instanceof l.VSBuffer)return V.buffer.buffer;if(!Array.isArray(V))return V})}}]}registerArgumentProcessor(m){this.f.push(m)}registerApiCommand(m){const P=this.registerCommand(!1,m.id,async(...M)=>{const V=m.args.map((G,R)=>{if(!G.validate(M[R]))throw new Error(`Invalid argument '${G.name}' when running '${m.id}', received: ${M[R]}`);return G.convert(M[R])}),Z=await this.executeCommand(m.internalId,...V);return m.result.convert(Z,M,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this.c.set(m.id,m),new T.Disposable(()=>{P.dispose(),this.c.delete(m.id)})}registerCommand(m,P,M,V,Z,G){if(this.d.trace("ExtHostCommands#registerCommand",P),!P.trim().length)throw new Error("invalid id");if(this.b.has(P))throw new Error(`command '${P}' already exists`);return this.b.set(P,{callback:M,thisArg:V,description:Z,extension:G}),m&&Oe(this,r,"f").$registerCommand(P),new T.Disposable(()=>{this.b.delete(P)&&m&&Oe(this,r,"f").$unregisterCommand(P)})}executeCommand(m,...P){return this.d.trace("ExtHostCommands#executeCommand",m),this.g(m,P,!0)}async g(m,P,M){if(this.b.has(m))return Oe(this,r,"f").$fireCommandActivationEvent(m),this.h(m,P,!1);{let V=!1;const Z=(0,L.cloneAndChange)(P,function(G){if(G instanceof T.Position)return y.Position.from(G);if(G instanceof T.Range)return y.Range.from(G);if(G instanceof T.Location)return y.location.from(G);if(T.NotebookRange.isNotebookRange(G))return y.NotebookRange.from(G);if(G instanceof ArrayBuffer)return V=!0,l.VSBuffer.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return V=!0,l.VSBuffer.wrap(G);if(G instanceof l.VSBuffer)return V=!0,G;if(!Array.isArray(G))return G});try{const G=await Oe(this,r,"f").$executeCommand(m,V?new v.SerializableObjectWithBuffers(Z):Z,M);return(0,k.revive)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(m,P,!1);throw G}}}async h(m,P,M){const V=this.b.get(m);if(!V)throw new Error("Unknown command");const{callback:Z,thisArg:G,description:R}=V;if(R)for(let O=0;O<R.args.length;O++)try{(0,i.validateConstraint)(P[O],R.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${R.args[O].name}' - ${R.args[O].description}`)}const A=E.StopWatch.create();try{return await Z.apply(G,P)}catch(O){if(m===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...P);B&&(m=B.command)}throw this.d.error(O,m,V.extension?.identifier),M?new class extends Error{constructor(){super((0,b.toErrorMessage)(O)),this.id=m,this.source=V.extension?.displayName??V.extension?.name}}:O}finally{this.j(V,m,A.elapsed())}}j(m,P,M){!m.extension||Oe(this,o,"f").$publicLog2("Extension:ActionExecuted",{extensionId:m.extension.identifier.value,id:new w.TrustedTelemetryValue(P),duration:M})}$executeContributedCommand(m,...P){this.d.trace("ExtHostCommands#$executeContributedCommand",m);const M=this.b.get(m);return M?(P=P.map(V=>this.f.reduce((Z,G)=>G.processArgument(Z,M.extension?.identifier),V)),this.h(m,P,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this.d.trace("ExtHostCommands#getCommands",m),Oe(this,r,"f").$getCommands().then(P=>(m&&(P=P.filter(M=>M[0]!=="_")),P))}$getContributedCommandHandlerDescriptions(){const m=Object.create(null);for(const[P,M]of this.b){const{description:V}=M;V&&(m[P]=V)}return Promise.resolve(m)}};r=new WeakMap,o=new WeakMap,s=qe([je(0,t.IExtHostRpcService),je(1,S.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class d{constructor(m,P,M){this.d=m,this.f=P,this.g=M,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(m,P){if(!m)return;const M={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return M;const V=this.f(m.command);if(V)M.id=V.internalId,M.arguments=V.args.map((Z,G)=>Z.convert(m.arguments&&m.arguments[G]));else if((0,F.isNonEmptyArray)(m.arguments)){const Z=`${m.command}/${++this.c}`;this.b.set(Z,m),P.add((0,p.toDisposable)(()=>{this.b.delete(Z),this.g.trace("CommandsConverter#DISPOSE",Z)})),M.$ident=Z,M.id=this.delegatingCommandId,M.arguments=[Z],this.g.trace("CommandsConverter#CREATE",m.command,Z)}return M}fromInternal(m){return typeof m.$ident=="string"?this.b.get(m.$ident):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this.b.get(m[0])}h(...m){const P=this.getActualCommand(...m);return this.g.trace("CommandsConverter#EXECUTE",m[0],P?P.command:"MISSING"),P?this.d.executeCommand(P.command,...P.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${m[0]}`)}}e.CommandsConverter=d;class c{constructor(m,P,M,V){this.name=m,this.description=P,this.validate=M,this.convert=V}optional(){return new c(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,P){return new c(m??this.name,P??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",h=>g.URI.isUri(h),h=>h),c.Position=new c("position","A position in a text document",h=>T.Position.isPosition(h),y.Position.from),c.Range=new c("range","A range in a text document",h=>T.Range.isRange(h),y.Range.from),c.Selection=new c("selection","A selection in a text document",h=>T.Selection.isSelection(h),y.Selection.from),c.Number=new c("number","",h=>typeof h=="number",h=>h),c.String=new c("string","",h=>typeof h=="string",h=>h),c.CallHierarchyItem=new c("item","A call hierarchy item",h=>h instanceof T.CallHierarchyItem,y.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",h=>h instanceof T.TypeHierarchyItem,y.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",h=>h instanceof a.TestItemImpl,y.TestItem.from);class u{constructor(m,P){this.description=m,this.convert=P}}e.ApiCommandResult=u,u.Void=new u("no result",h=>h);class n{constructor(m,P,M,V,Z){this.id=m,this.internalId=P,this.description=M,this.args=V,this.result=Z}}e.ApiCommand=n}),define(Ce[198],ke([1,0,2,8,6,72,38,16,85,89,13]),function(ee,e,i,T,y,L,C,F,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(T.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,a)=>{if((0,F.isFalsyOrEmpty)(t))return;class l extends y.SymbolInformation{static to(b){const E=new l(b.name,T.SymbolKind.to(b.kind),b.containerName||"",new y.Location(a[0],T.Range.to(b.range)));return E.detail=b.detail,E.range=E.location.range,E.selectionRange=T.Range.to(b.selectionRange),E.children=b.children?b.children.map(l.to):[],E}}return t.map(l.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(T.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(T.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(T.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(a=>y.Position.isPosition(a)),t=>t.map(T.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(a=>{let l;for(const v of a.reverse())l=new y.SelectionRange(T.Range.to(v),l);return l}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(T.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(T.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(T.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(T.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:T.Range.to(t.range),placeholder:t.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return T.WorkspaceEdit.to(t)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(T.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const a=(0,S.decodeSemanticTokensDto)(t);if(a.type==="full")return new y.SemanticTokens(a.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const a=(0,S.decodeSemanticTokensDto)(t);if(a.type==="full")return new y.SemanticTokens(a.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,a,l)=>{if(!t)return new y.CompletionList([]);const v=t.suggestions.map(b=>T.CompletionItem.to(b,l));return new y.CompletionList(v,t.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return T.SignatureHelp.to(t)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,a,l)=>p(v=>new y.CodeLens(T.Range.to(v.range),v.command&&l.fromInternal(v.command)))(t))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>y.Range.isRange(t),t=>y.Selection.isSelection(t)?T.Selection.from(t):T.Range.from(t)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,a,l)=>p(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(v.command)}else{const b=new y.CodeAction(v.title,v.kind?new y.CodeActionKind(v.kind):void 0);return v.edit&&(b.edit=T.WorkspaceEdit.to(v.edit)),v.command&&(b.command=l.fromInternal(v.command)),b.isPreferred=v.isPreferred,b}})(t))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(a=>new y.ColorInformation(T.Range.to(a.range),T.Color.to(a.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",t=>t instanceof y.Color,T.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:T.Range.from(t.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(T.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,a,l)=>t.map(T.InlayHint.to.bind(void 0,l)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(a=>T.NotebookExclusiveDocumentPattern.to(a))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(T.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>i.URI.isUri(t)||typeof t=="string"&&(0,k.matchesSomeScheme)(t,N.Schemas.http,N.Schemas.https),t=>t),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[T.ViewColumn.from(t),void 0]:[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[T.ViewColumn.from(t),void 0]:[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void),new C.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[C.ApiCommandArgument.String.with("name","The context key name"),new C.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],C.ApiCommandResult.Void)];class g{static register(a){D.forEach(a.registerApiCommand,a)}}e.ExtHostApiCommands=g;function p(t){return a=>{if(Array.isArray(a))return a.map(t)}}function f(t){if(!Array.isArray(t))return;const a=[];for(const l of t)L.isLocationLink(l)?a.push(T.DefinitionLink.to(l)):a.push(T.location.to(l));return a}}),define(Ce[199],ke([1,0,14,61,4,7,2,72,25,8,6,26,5]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(f,t,a){const l=f.getProxy(g.MainContext.MainThreadComments);class v{constructor(){this.b=new Map,this.c=new Map,t.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const n=this.b.get(u.handle);return n?n.value:u}else if(u&&u.$mid===7){const n=this.b.get(u.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.commentThreadHandle);return h?h.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.thread.commentThreadHandle);return h?u.$mid===8?h.value:{thread:h.value,text:u.text}:u}else if(u&&u.$mid===10){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.thread.commentThreadHandle);if(!h)return u;const m=u.commentUniqueId,P=h.getCommentByUniqueId(m);return P||u}else if(u&&u.$mid===11){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.thread.commentThreadHandle);if(!h)return u;const m=u.text,P=u.commentUniqueId,M=h.getCommentByUniqueId(P);return M?(typeof M.body=="string"?M.body=m:M.body=new N.MarkdownString(m),M):u}return u}})}createCommentController(u,n,h){const m=v.a++,P=new E(u,m,n,h);this.b.set(P.handle,P);const M=this.c.get(S.ExtensionIdentifier.toKey(u.identifier))||[];return M.push(P),this.c.set(S.ExtensionIdentifier.toKey(u.identifier),M),P.value}$createCommentThreadTemplate(u,n,h){const m=this.b.get(u);!m||m.$createCommentThreadTemplate(n,h)}async $updateCommentThreadTemplate(u,n,h){const m=this.b.get(u);!m||m.$updateCommentThreadTemplate(n,h)}$deleteCommentThread(u,n){this.b.get(u)?.$deleteCommentThread(n)}$provideCommentingRanges(u,n,h){const m=this.b.get(u);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const P=a.getDocument(C.URI.revive(n));return(0,i.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(P,h)).then(M=>M?M.map(V=>k.Range.from(V)):void 0)}$toggleReaction(u,n,h,m,P){const M=this.b.get(u);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const V=M.getCommentThread(n);if(V){const Z=V.getCommentByUniqueId(m.uniqueIdInThread);if(M!==void 0&&Z&&M.reactionHandler)return M.reactionHandler(Z,o(P))}return Promise.resolve(void 0)})}dispose(){}}v.a=0;class b{set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){u.isEqual(this.p)||(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(u){(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,n,h,m,P,M,V,Z){this.m=n,this.n=h,this.o=m,this.p=P,this.q=M,this.extensionDescription=V,this.r=Z,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new y.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.MutableDisposable,this.l.value=new L.DisposableStore,this.n===void 0&&(this.n=`${u}.${this.handle}`),l.$createCommentThread(n,this.handle,this.n,this.o,k.Range.from(this.p),V.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=M,this.i.push({dispose:()=>{l.$deleteCommentThread(n,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(R){G.range=R},get comments(){return G.comments},set comments(R){G.comments=R},get collapsibleState(){return G.collapsibleState},set collapsibleState(R){G.collapsibleState=R},get canReply(){return G.canReply},set canReply(R){G.canReply=R},get contextValue(){return G.contextValue},set contextValue(R){G.contextValue=R},get label(){return G.label},set label(R){G.label=R},get state(){return G.state},set state(R){G.state=R},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.DisposableStore);const u=h=>Object.prototype.hasOwnProperty.call(this.b,h),n={};u("range")&&(n.range=k.Range.from(this.p)),u("label")&&(n.label=this.label),u("contextValue")&&(n.contextValue=this.contextValue??null),u("comments")&&(n.comments=this.q.map(h=>w(this,h,this.k))),u("collapsibleState")&&(n.collapseState=s(this.g)),u("canReply")&&(n.canReply=this.canReply),u("state")&&(n.state=d(this.h)),u("isTemplate")&&(n.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(u){for(const n of this.k){const h=n[0],m=n[1];if(u===m)return h}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}b.a=0,qe([(0,T.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,l.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,n,h,m){this.f=u,this.g=n,this.h=h,this.i=m,this.a=new Map,l.$registerCommentController(this.handle,h,m);const P=this;this.value=Object.freeze({id:P.id,label:P.label,get options(){return P.options},set options(M){P.options=M},get commentingRangeProvider(){return P.commentingRangeProvider},set commentingRangeProvider(M){P.commentingRangeProvider=M},get reactionHandler(){return P.reactionHandler},set reactionHandler(M){P.reactionHandler=M},createCommentThread(M,V,Z){return P.createCommentThread(M,V,Z).value},dispose:()=>{P.dispose()}}),this.e=[],this.e.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(u,n,h,m){if(typeof u=="string"){const P=new b(this.id,this.handle,u,n,h,m,this.f,!1);return this.a.set(P.handle,P),P}else{const P=new b(this.id,this.handle,void 0,u,n,h,this.f,!1);return this.a.set(P.handle,P),P}}$createCommentThreadTemplate(u,n){const h=new b(this.id,this.handle,void 0,C.URI.revive(u),k.Range.to(n),[],this.f,!0);return h.collapsibleState=F.CommentThreadCollapsibleState.Expanded,this.a.set(h.handle,h),h}$updateCommentThreadTemplate(u,n){const h=this.a.get(u);h&&(h.range=k.Range.to(n))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function w(c,u,n){let h=n.get(u);h||(h=++c.commentHandle,n.set(u,h));const m=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:h,body:typeof u.body=="string"?u.body:k.MarkdownString.from(u.body),userName:u.author.name,userIconPath:m,label:u.label,commentReactions:u.reactions?u.reactions.map(P=>r(P)):void 0,timestamp:u.timestamp?.toJSON()}}function r(c){return{label:c.label,iconPath:c.iconPath?k.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function o(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?C.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function s(c){if(c!==void 0)switch(c){case N.CommentThreadCollapsibleState.Expanded:return F.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return F.CommentThreadCollapsibleState.Collapsed}return F.CommentThreadCollapsibleState.Collapsed}function d(c){if(c!==void 0)switch(c){case N.CommentThreadState.Unresolved:return F.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return F.CommentThreadState.Resolved}return F.CommentThreadState.Unresolved}return new v}e.createExtHostComments=p}),define(Ce[200],ke([1,0,23,5,27,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(N,D){this.a=N.getProxy(T.MainContext.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(N,D){const g=this,p=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){g.e(N,D,p,arguments)}})}e(N,D,g,p){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:S(p,this.b)}),this.c&&this.f(N,g,p)}};C=qe([je(0,L.IExtHostRpcService),je(1,y.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const F=1e5;function S(k,N){const D=[];if(k.length)for(let g=0;g<k.length;g++){let p=k[g];if(typeof p>"u")p="undefined";else if(p instanceof Error){const f=p;f.stack?p=f.stack:p=f.toString()}D.push(p)}if(N){const g=new Error().stack;g&&D.push({__$stack:g.split(`
`).slice(3).join(`
`)})}try{const g=(0,i.safeStringify)(D);return g.length>F?"Output omitted for a large object that exceeds the limits":g}catch(g){return`Output omitted for an object that cannot be inspected ('${g.toString()}')`}}}),define(Ce[101],ke([1,0,2,5,6,3,15,12,16,10,19,26]),function(ee,e,i,T,y,L,C,F,S,k,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let g=class Ni{constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,t){const a=Ni.c++;this.f.set(a,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(a,t.identifier.value);const l=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(v=>{if(!v){this.g.$onDidChange(a,null);return}const b=(0,S.asArray)(v);if(b.length<=Ni.d){this.g.$onDidChange(a,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,b.length);const E=b.map(o=>({uri:o,rank:(0,k.count)(o.path,"/")})),w=(0,S.groupBy)(E,(o,s)=>o.rank-s.rank||(0,k.compare)(o.uri.path,s.uri.path)),r=[];e:for(const o of w){let s;for(const d of o){const c=(0,N.dirname)(d.uri.path);if(s!==c&&(s=c,r.push(d.uri)>=Ni.d))break e}}this.g.$onDidChange(a,r)});return new y.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(f,t,a){if(!this.f.has(f))return Object.create(null);const l=Object.create(null),{provider:v,extensionDescription:b}=this.f.get(f);return await Promise.all(t.map(async E=>{try{const{uri:w,id:r}=E,o=await Promise.resolve(v.provideFileDecoration(i.URI.revive(w),a));if(!o)return;try{y.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,D.checkProposedApiEnabled)(b,"codiconDecoration"),l[r]=[o.propagate,o.tooltip,o.badge,o.color]}catch(s){this.h.warn(`INVALID decoration from extension '${b}': ${s}`)}}catch(w){this.h.error(w)}})),l}};g.c=0,g.d=250,g=qe([je(0,C.IExtHostRpcService),je(1,F.ILogService)],g),e.ExtHostDecorations=g,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[201],ke([1,0,134,88,2,5,6,8,4,12,28,37]),function(ee,e,i,T,y,L,C,F,S,k,N,D){"use strict";var g,p,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class t{constructor(v,b,E,w,r,o,s){this.d=v,this.e=b,this.f=E,this.g=w,g.set(this,void 0),p.set(this,void 0),f.set(this,void 0),this.c=!1,Je(this,f,new N.ResourceMap(d=>r.getComparisonKey(d)),"f"),Je(this,g,o,"f"),Je(this,p,s,"f")}dispose(){this.c||(Oe(this,p,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,g,"f")?.$clear(this.e),Oe(this,f,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(v,b){if(!v){this.clear();return}this.h();let E=[];if(y.URI.isUri(v)){if(!b){this.delete(v);return}Oe(this,f,"f").set(v,b.slice()),E=[v]}else if(Array.isArray(v)){E=[];let r;v=[...v].sort(t.j);for(const o of v){const[s,d]=o;if((!r||s.toString()!==r.toString())&&(r&&Oe(this,f,"f").get(r).length===0&&Oe(this,f,"f").delete(r),r=s,E.push(s),Oe(this,f,"f").set(s,[])),d)Oe(this,f,"f").get(s)?.push(...d);else{const c=Oe(this,f,"f").get(s);c&&(c.length=0)}}}if(Oe(this,p,"f").fire(E),!Oe(this,g,"f"))return;const w=[];for(const r of E){let o=[];const s=Oe(this,f,"f").get(r);if(s)if(s.length>this.f){o=[];const d=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const u of s)if(u.severity===d[c]&&o.push({...F.Diagnostic.from(u),modelVersionId:this.g(r)})===this.f)break e;o.push({severity:T.MarkerSeverity.Info,message:(0,i.localize)(0,null,s.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=s.map(d=>({...F.Diagnostic.from(d),modelVersionId:this.g(r)}));w.push([r,o])}Oe(this,g,"f").$changeMany(this.e,w)}delete(v){this.h(),Oe(this,p,"f").fire([v]),Oe(this,f,"f").delete(v),Oe(this,g,"f")?.$changeMany(this.e,[[v,void 0]])}clear(){this.h(),Oe(this,p,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,g,"f")?.$clear(this.e)}forEach(v,b){this.h();for(const[E,w]of this)v.call(b,E,w,this)}*[(g=new WeakMap,p=new WeakMap,f=new WeakMap,Symbol.iterator)](){this.h();for(const v of Oe(this,f,"f").keys())yield[v,this.get(v)]}get(v){this.h();const b=Oe(this,f,"f").get(v);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(v){return this.h(),Array.isArray(Oe(this,f,"f").get(v))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(v,b){return v[0].toString()<b[0].toString()?-1:v[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=t;let a=class vi{static _mapper(v){const b=new N.ResourceMap;for(const E of v)b.set(E,E);return{uris:Object.freeze(Array.from(b.values()))}}constructor(v,b,E,w){this.h=b,this.j=E,this.k=w,this.f=new Map,this.g=new S.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,vi._mapper),this.e=v.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,b){const{f:E,e:w,g:r,h:o,j:s,k:d}=this,c=new class{$changeMany(h,m){w.$changeMany(h,m),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,h,m.length===0?"CLEARING":m)}$clear(h){w.$clear(h),o.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,h)}dispose(){w.dispose()}};let u;if(!b)b="_generated_diagnostic_collection_name_#"+vi.c++,u=b;else if(!E.has(b))u=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do u=b+vi.c++;while(E.has(u))}return new class extends t{constructor(){super(b,u,vi.d,h=>d.getDocument(h)?.version,s.extUri,c,r),E.set(u,this)}dispose(){super.dispose(),E.delete(u)}}}getDiagnostics(v){if(v)return this.l(v);{const b=new Map,E=[];for(const w of this.f.values())w.forEach((r,o)=>{let s=b.get(r.toString());typeof s>"u"&&(s=E.length,b.set(r.toString(),s),E.push([r,[]])),E[s][1]=E[s][1].concat(...o)});return E}}l(v){let b=[];for(const E of this.f.values())E.has(v)&&(b=b.concat(E.get(v)));return b}$acceptMarkersChange(v){if(!this.m){const b="_generated_mirror",E=new t(b,b,vi.d,w=>{},this.j.extUri,void 0,this.g);this.f.set(b,E),this.m=E}for(const[b,E]of v)this.m.set(y.URI.revive(b),E.map(F.Diagnostic.to))}};a.c=0,a.d=1e3,a=qe([je(1,k.ILogService),je(2,D.IExtHostFileSystemInfo)],a),e.ExtHostDiagnostics=a}),define(Ce[202],ke([1,0,2,5]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(C){this.a=C.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(F=>F?F.map(S=>i.URI.revive(S)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(F=>F?i.URI.revive(F):void 0)}}e.ExtHostDialogs=y}),define(Ce[203],ke([1,0,11,2,6,5,13,20,10]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(D,g,p){this.d=g,this.e=p,this.b=new Map,this.c=D.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,g){if(Object.keys(C.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const p=k.a++;this.b.set(p,g),this.c.$registerTextContentProvider(p,D);let f;return typeof g.onDidChange=="function"&&(f=g.onDidChange(t=>{if(t.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${t.scheme}' which will be IGNORED`);return}this.d.getDocument(t)&&this.$provideTextDocumentContent(p,t).then(a=>{if(!a&&typeof a!="string")return;const l=this.d.getDocument(t);if(!l)return;const v=(0,S.splitLines)(a);if(!l.equalLines(v))return this.c.$onVirtualDocumentChange(t,a)},i.onUnexpectedError)})),new y.Disposable(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(D,g){const p=this.b.get(D);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(g),F.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=k,k.a=0}),define(Ce[204],ke([1,0,4,7,2,5,97,8,9,23,6]),function(ee,e,i,T,y,L,C,F,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(p,f){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.DisposableStore,this.h=new Map,this.f=p.getProxy(L.MainContext.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const a of t)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const a of t)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const f=this.g.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this.g.getDocument(p);if(f)return Promise.resolve(f);let t=this.h.get(p.toString());return t||(t=this.f.$tryOpenDocument(p).then(a=>{this.h.delete(p.toString());const l=y.URI.revive(a);return(0,S.assertIsDefined)(this.g.getDocument(l))},a=>(this.h.delete(p.toString()),Promise.reject(a))),this.h.set(p.toString(),t)),t}createDocumentData(p){return this.f.$tryCreateDocument(p).then(f=>y.URI.revive(f))}$acceptModelLanguageChanged(p,f){const t=y.URI.revive(p),a=this.g.getDocument(t);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId(f),this.a.fire(a.document)}$acceptModelSaved(p){const f=y.URI.revive(p),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(p,f){const t=y.URI.revive(p),a=this.g.getDocument(t);if(!a)throw new Error("unknown document");a._acceptIsDirty(f),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,t){const a=y.URI.revive(p),l=this.g.getDocument(a);if(!l)throw new Error("unknown document");l._acceptIsDirty(t),l.onEvents(f);let v;f.isUndoing?v=N.TextDocumentChangeReason.Undo:f.isRedoing&&(v=N.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:l.document,contentChanges:f.changes.map(b=>({range:F.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:v}))}setWordDefinitionFor(p,f){(0,C.setWordDefinitionFor)(p,f)}}e.ExtHostDocuments=D}),define(Ce[56],ke([1,0,47,4,7,2,3,5,97,15,100,8,12,28,13,174,205]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let v=class{constructor(E,w){this.h=E,this.i=w,this.a=null,this.b=new Map,this.c=new p.ResourceMap,this.d=new T.Emitter,this.e=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const w=[],r=[],o=[];if(E.removedDocuments)for(const s of E.removedDocuments){const d=L.URI.revive(s),c=this.c.get(d);c?.unref()&&(this.c.delete(d),w.push(c.value))}if(E.addedDocuments)for(const s of E.addedDocuments){const d=L.URI.revive(s.uri);let c=this.c.get(d);if(c&&d.scheme!==f.Schemas.vscodeNotebookCell&&d.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);c||(c=new l(new S.ExtHostDocumentData(this.h.getProxy(F.MainContext.MainThreadDocuments),d,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(d,c),r.push(c.value)),c.ref()}if(E.removedEditors)for(const s of E.removedEditors){const d=this.b.get(s);this.b.delete(s),d&&o.push(d)}if(E.addedEditors)for(const s of E.addedEditors){const d=L.URI.revive(s.documentUri);i.ok(this.c.has(d),`document '${d}' does not exist`),i.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const c=this.c.get(d).value,u=new N.ExtHostTextEditor(s.id,this.h.getProxy(F.MainContext.MainThreadTextEditors),this.i,new a.Lazy(()=>c.document),s.selections.map(D.Selection.to),s.options,s.visibleRanges.map(n=>D.Range.to(n)),typeof s.editorPosition=="number"?D.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,u)}E.newActiveEditor!==void 0&&(i.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,y.dispose)(w),(0,y.dispose)(o),E.removedDocuments&&this.e.fire(w),E.addedDocuments&&this.d.fire(r),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return t.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const w=this.b.get(this.a);return E?w:w?.value}allEditors(){return[...this.b.values()]}};v=qe([je(0,k.IExtHostRpcService),je(1,g.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[57],ke([1,0,8,5,2,4,3,6,15,9,80]),function(ee,e,i,T,y,L,C,F,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class D{constructor(a,l,v){this.e=v,this.d=l,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,l={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new F.TextTabInput(y.URI.revive(this.b.input.uri));case 2:return new F.TextDiffTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified));case 3:return new F.TextMergeTabInput(y.URI.revive(this.b.input.base),y.URI.revive(this.b.input.input1),y.URI.revive(this.b.input.input2),y.URI.revive(this.b.input.result));case 6:return new F.CustomEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new F.WebviewEditorTabInput(this.b.input.viewType);case 4:return new F.NotebookEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new F.NotebookDiffEditorTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new F.TerminalEditorTabInput;case 9:return new F.InteractiveWindowInput(y.URI.revive(this.b.input.uri),y.URI.revive(this.b.input.inputBoxUri));default:return}}}class g{constructor(a,l){this.c=[],this.d="",this.b=a,this.e=l;for(const v of a.tabs)v.isActive&&(this.d=v.id),this.c.push(new D(v,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,l={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return i.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(v=>v.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(v=>v.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===0){const v=new D(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,v),a.tabDto.isActive&&(this.d=v.tabId),v}else if(a.kind===1){const v=this.c.splice(a.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return v.tabId===this.d&&(this.d=""),v}else if(a.kind===3){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this.c.splice(a.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,v),v}const l=this.c.find(v=>v.tabId===a.tabDto.id);if(!l)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(a.tabDto),l}activeTabId(){return this.d}}let p=class{constructor(a){this.b=new L.Emitter,this.c=new L.Emitter,this.e=[],this.a=a.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,l={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(v=>v.apiObject))},get activeTabGroup(){const v=a.d;return(0,k.assertIsDefined)(a.e.find(E=>E.groupId===v)?.apiObject)},close:async(v,b)=>{const E=Array.isArray(v)?v:[v];return E.length?f(E[0])?this.j(E,b):this.i(E,b):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(a){const l=new Set(this.e.map(s=>s.groupId)),v=new Set(a.map(s=>s.groupId)),b=(0,N.diffSets)(l,v),E=this.e.filter(s=>b.removed.includes(s.groupId)).map(s=>s.apiObject),w=[],r=[];this.e=a.map(s=>{const d=new g(s,()=>this.d);return b.added.includes(d.groupId)?w.push(d.apiObject):r.push(d.apiObject),d});const o=(0,k.assertIsDefined)(a.find(s=>s.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:w,closed:E,changed:r}))}$acceptTabGroupUpdate(a){const l=this.e.find(v=>v.groupId===a.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const l=this.e.find(b=>b.groupId===a.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const v=l.acceptTabOperation(a);switch(a.kind){case 0:this.b.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}g(a){for(const l of this.e)for(const v of l.tabs)if(v.apiObject===a)return v}h(a){return this.e.find(l=>l.apiObject===a)}async i(a,l){const v=[];for(const b of a){const E=this.g(b);if(!E)throw new Error("Tab close: Invalid tab not found!");v.push(E.tabId)}return this.a.$closeTab(v,l)}async j(a,l){const v=[];for(const b of a){const E=this.h(b);if(!E)throw new Error("Group close: Invalid group not found!");v.push(E.groupId)}return this.a.$closeGroup(v,l)}};p=qe([je(0,S.IExtHostRpcService)],p),e.ExtHostEditorTabs=p;function f(t){return t.tabs!==void 0}}),define(Ce[206],ke([1,0,2,5,7,6,8,251,10,24,26]),function(ee,e,i,T,y,L,C,F,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let a,l,v=14,b=14;for(const E of f){let w=a?(0,S.commonPrefixLength)(a,E):0;for(w===0?l=1:l=b;w<E.length;w++)w+1===E.length?(v=b,b=9):b+=1,t.push([l,E.toUpperCase().charCodeAt(w),b]),t.push([l,E.toLowerCase().charCodeAt(w),b]),l=b;a=E,b=v}t.push([9,58,10]),t.push([10,47,12]),this.b=new F.StateMachine(t)}}provideDocumentLinks(f){this.c();const t=[],a=F.LinkComputer.computeLinks({getLineContent(l){return f.lineAt(l-1).text},getLineCount(){return f.lineCount}},this.b);for(const l of a){const v=C.DocumentLink.to(l);v.target&&t.push(v)}return t}}class g{constructor(f,t){this.i=t,this.b=new D,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,a,l={}){if(this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const v=this.h++;this.b.add(t),this.d.add(t),this.c.set(v,a);let b=2;l.isCaseSensitive&&(b+=1024),l.isReadonly&&(b+=2048),typeof a.copy=="function"&&(b+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,N.checkProposedApiEnabled)(f,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(v,t,b).catch(w=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(w)});const E=a.onDidChangeFile(w=>{const r=[];for(const o of w){const{uri:s,type:d}=o;if(s.scheme!==t)continue;let c;switch(d){case L.FileChangeType.Changed:c=0;break;case L.FileChangeType.Created:c=1;break;case L.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:s,type:c})}this.a.$onFileSystemChange(v,r)});return(0,y.toDisposable)(()=>{E.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(f){const{type:t,ctime:a,mtime:l,size:v,permissions:b}=f;return{type:t,ctime:a,mtime:l,size:v,permissions:b}}$stat(f,t){return Promise.resolve(this.k(f).stat(i.URI.revive(t))).then(a=>g.j(a))}$readdir(f,t){return Promise.resolve(this.k(f).readDirectory(i.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.k(f).readFile(i.URI.revive(t))).then(a=>k.VSBuffer.wrap(a))}$writeFile(f,t,a,l){return Promise.resolve(this.k(f).writeFile(i.URI.revive(t),a.buffer,l))}$delete(f,t,a){return Promise.resolve(this.k(f).delete(i.URI.revive(t),a))}$rename(f,t,a,l){return Promise.resolve(this.k(f).rename(i.URI.revive(t),i.URI.revive(a),l))}$copy(f,t,a,l){const v=this.k(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(i.URI.revive(t),i.URI.revive(a),l))}$mkdir(f,t){return Promise.resolve(this.k(f).createDirectory(i.URI.revive(t)))}$watch(f,t,a,l){const v=this.k(f).watch(i.URI.revive(a),l);this.f.set(t,v)}$unwatch(f,t){const a=this.f.get(t);a&&(a.dispose(),this.f.delete(t))}$open(f,t,a){const l=this.k(f);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(i.URI.revive(t),a))}$close(f,t){const a=this.k(f);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(t))}$read(f,t,a,l){const v=this.k(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(l);return Promise.resolve(v.read(t,a,b.buffer,0,l)).then(E=>b.slice(0,E))}$write(f,t,a,l){const v=this.k(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(t,a,l.buffer,0,l.byteLength))}k(f){const t=this.c.get(f);if(!t){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return t}}e.ExtHostFileSystem=g}),define(Ce[58],ke([1,0,5,36,6,24,3,15,37,7]),function(ee,e,i,T,y,L,C,F,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class Jt{constructor(g,p){this.b=new Map,this.a=g.getProxy(i.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(t){try{const a=f.b.get(t.scheme);if(!a)return await f.a.$stat(t);await f.a.$ensureActivation(t.scheme);const l=await a.stat(t);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(a){Jt.c(a)}},async readDirectory(t){try{const a=f.b.get(t.scheme);return a?(await f.a.$ensureActivation(t.scheme),(await a.readDirectory(t)).slice()):await f.a.$readdir(t)}catch(a){return Jt.c(a)}},async createDirectory(t){try{return await f.a.$mkdir(t)}catch(a){return Jt.c(a)}},async readFile(t){try{const a=f.b.get(t.scheme);return a?(await f.a.$ensureActivation(t.scheme),(await a.readFile(t)).slice()):(await f.a.$readFile(t)).buffer}catch(a){return Jt.c(a)}},async writeFile(t,a){try{return await f.a.$writeFile(t,L.VSBuffer.wrap(a))}catch(l){return Jt.c(l)}},async delete(t,a){try{const l=f.b.get(t.scheme);return l?(await f.a.$ensureActivation(t.scheme),await l.delete(t,{recursive:!1,...a})):await f.a.$delete(t,{recursive:!1,useTrash:!1,...a})}catch(l){return Jt.c(l)}},async rename(t,a,l){try{return await f.a.$rename(t,a,{overwrite:!1,...l})}catch(v){return Jt.c(v)}},async copy(t,a,l){try{return await f.a.$copy(t,a,{overwrite:!1,...l})}catch(v){return Jt.c(v)}},isWritableFileSystem(t){const a=p.getCapabilities(t);if(typeof a=="number")return!(a&2048)}})}static c(g){if(g instanceof y.FileSystemError)throw g;if(!(g instanceof Error))throw new y.FileSystemError(String(g));if(g.name==="ENOPRO")throw y.FileSystemError.Unavailable(g.message);switch(g.name){case T.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(g.message);case T.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(g.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(g.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(g.message);case T.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(g.message);case T.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(g.message);default:throw new y.FileSystemError(g.message,g.name)}}addFileSystemProvider(g,p){return this.b.set(g,p),(0,k.toDisposable)(()=>this.b.delete(g))}};N=qe([je(0,F.IExtHostRpcService),je(1,S.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[207],ke([1,0,4,35,2,5,8,6]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(D,g,p,f,t,a,l,v){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter;const b=this.h(D,p,t);this.g=0,a&&(this.g+=1),l&&(this.g+=2),v&&(this.g+=4);const E=(0,T.parse)(t),w=typeof t=="string",r=f(o=>{if(!a)for(const s of o.created){const d=y.URI.revive(s);E(d.fsPath)&&(!w||g.getWorkspaceFolder(d))&&this.a.fire(d)}if(!l)for(const s of o.changed){const d=y.URI.revive(s);E(d.fsPath)&&(!w||g.getWorkspaceFolder(d))&&this.b.fire(d)}if(!v)for(const s of o.deleted){const d=y.URI.revive(s);E(d.fsPath)&&(!w||g.getWorkspaceFolder(d))&&this.c.fire(d)}});this.d=F.Disposable.from(b,this.a,this.b,this.c,r)}h(D,g,p){const f=F.Disposable.from();if(typeof p=="string")return f;const t=D.getProxy(L.MainContext.MainThreadFileSystem);let a=!1;(p.pattern.includes(T.GLOBSTAR)||p.pattern.includes(T.GLOB_SPLIT))&&(a=!0);const l=Math.random();return t.$watch(g.identifier.value,l,p.baseUri,{recursive:a,excludes:[]}),F.Disposable.from({dispose:()=>t.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(D,g,p){this.j=D,this.k=g,this.l=p,this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.g=new i.AsyncEmitter,this.h=new i.AsyncEmitter,this.i=new i.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,g,p,f,t,a){return new S(this.j,D,g,this.a.event,C.GlobPattern.from(p),f,t,a)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,g){switch(D){case 2:this.b.fire(Object.freeze({files:g.map(p=>({oldUri:y.URI.revive(p.source),newUri:y.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:g.map(p=>y.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:g.map(p=>y.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,g){return(p,f,t)=>{const a=function(v){p.call(f,v)};return a.extension=D,g.event(a,void 0,t)}}async $onWillRunFileOperation(D,g,p,f){switch(D){case 2:return await this.n(this.g,{files:g.map(t=>({oldUri:y.URI.revive(t.source),newUri:y.URI.revive(t.target)}))},p,f);case 1:return await this.n(this.i,{files:g.map(t=>y.URI.revive(t.target))},p,f);case 0:case 3:return await this.n(this.h,{files:g.map(t=>y.URI.revive(t.target))},p,f)}}async n(D,g,p,f){const t=new Set,a=[];if(await D.fireAsync(g,f,async(v,b)=>{const E=Date.now(),w=await Promise.resolve(v);w instanceof F.WorkspaceEdit&&(a.push([b.extension,w]),t.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-E>p&&this.k.warn("SLOW file-participant",b.extension.identifier)}),f.isCancellationRequested||a.length===0)return;const l={edits:[]};for(const[,v]of a){const{edits:b}=C.WorkspaceEdit.from(v,{getTextDocumentVersion:E=>this.l.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(b)}return{edit:l,extensionNames:Array.from(t)}}}e.ExtHostFileSystemEventService=k}),define(Ce[208],ke([1,0,2,38]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(C,F,S,k,N){this.a=F,this.b=S,this.c=k;const D=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",g=>!0,g=>g),new T.ApiCommandArgument("resource","Interactive resource Uri",g=>!0,g=>g),new T.ApiCommandArgument("controllerId","Notebook controller Id",g=>!0,g=>g),new T.ApiCommandArgument("title","Interactive editor title",g=>!0,g=>g)],new T.ApiCommandResult("Notebook and input URI",g=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",g.notebookEditorId),g.notebookEditorId!==void 0){const p=this.a.getEditorById(g.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:i.URI.revive(g.notebookUri),inputUri:i.URI.revive(g.inputUri),notebookEditor:p.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",g.notebookUri,g.inputUri),{notebookUri:i.URI.revive(g.notebookUri),inputUri:i.URI.revive(g.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(C,F,S,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:F,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(i.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,F){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=y}),define(Ce[209],ke([1,0,7,5]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(C){this.b=0,this.a=C.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const F=this.b++;return this.a.$registerResourceLabelFormatter(F,C),(0,i.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(F)})}}e.ExtHostLabelService=y}),define(Ce[210],ke([1,0,2,23,8,6,72,5,10,55,16,9,252,20,7,85,81,52,74,11,14,26]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a,l,v,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class r{constructor(I,$){this.d=I,this.e=$}async provideDocumentSymbols(I,$){const H=this.d.getDocument(I),q=await this.e.provideDocumentSymbols(H,$);if(!(0,N.isFalsyOrEmpty)(q))return q[0]instanceof L.DocumentSymbol?q.map(y.DocumentSymbol.from):r.f(q)}static f(I){I=I.slice(0).sort((q,J)=>{let de=q.location.range.start.compareTo(J.location.range.start);return de===0&&(de=J.location.range.end.compareTo(q.location.range.end)),de});const $=[],H=[];for(const q of I){const J={name:q.name||"!!MISSING: name!!",kind:y.SymbolKind.from(q.kind),tags:q.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:y.Range.from(q.location.range),selectionRange:y.Range.from(q.location.range),children:[]};for(;;){if(H.length===0){H.push(J),$.push(J);break}const de=H[H.length-1];if(k.Range.containsRange(de.range,J.range)&&!k.Range.equalsRange(de.range,J.range)){de.children?.push(J),H.push(J);break}H.pop()}}return $}}class o{constructor(I,$,H){this.g=I,this.h=$,this.j=H,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,$){const H=this.g.getDocument(I),q=await this.j.provideCodeLenses(H,$);if(!q||$.isCancellationRequested)return;const J=this.e.add(q),de=new f.DisposableStore;this.f.set(J,de);const we={cacheId:J,lenses:[]};for(let ae=0;ae<q.length;ae++)we.lenses.push({cacheId:[J,ae],range:y.Range.from(q[ae].range),command:this.h.toInternal(q[ae].command,de)});return we}async resolveCodeLens(I,$){const H=I.cacheId&&this.e.get(...I.cacheId);if(!H)return;let q;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?q=H:q=await this.j.resolveCodeLens(H,$),q||(q=H),$.isCancellationRequested)return;const J=I.cacheId&&this.f.get(I.cacheId[0]);if(!!J)return I.command=this.h.toInternal(q.command??o.d,J),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}o.d={command:"missing",title:"!!MISSING: command!!"};function s(Y){return Array.isArray(Y)?Y.map(y.DefinitionLink.from):Y?[y.DefinitionLink.from(Y)]:[]}class d{constructor(I,$){this.d=I,this.e=$}async provideDefinition(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideDefinition(q,J,H);return s(de)}}class c{constructor(I,$){this.d=I,this.e=$}async provideDeclaration(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideDeclaration(q,J,H);return s(de)}}class u{constructor(I,$){this.d=I,this.e=$}async provideImplementation(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideImplementation(q,J,H);return s(de)}}class n{constructor(I,$){this.d=I,this.e=$}async provideTypeDefinition(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideTypeDefinition(q,J,H);return s(de)}}class h{constructor(I,$){this.d=I,this.e=$}async provideHover(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideHover(q,J,H);if(!(!de||(0,N.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=q.getWordRangeAtPosition(J)),de.range||(de.range=new L.Range(J,J)),y.Hover.from(de)}}class m{constructor(I,$){this.d=I,this.e=$}async provideEvaluatableExpression(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideEvaluatableExpression(q,J,H);if(de)return y.EvaluatableExpression.from(de)}}class P{constructor(I,$){this.d=I,this.e=$}async provideInlineValues(I,$,H,q){const J=this.d.getDocument(I),de=await this.e.provideInlineValues(J,y.Range.to($),y.InlineValueContext.to(H),q);if(Array.isArray(de))return de.map(we=>y.InlineValue.from(we))}}class M{constructor(I,$){this.d=I,this.e=$}async provideDocumentHighlights(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideDocumentHighlights(q,J,H);if(Array.isArray(de))return de.map(y.DocumentHighlight.from)}}class V{constructor(I,$){this.d=I,this.e=$}async provideLinkedEditingRanges(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideLinkedEditingRanges(q,J,H);if(de&&Array.isArray(de.ranges))return{ranges:(0,N.coalesce)(de.ranges.map(y.Range.from)),wordPattern:de.wordPattern}}}class Z{constructor(I,$){this.d=I,this.e=$}async provideReferences(I,$,H,q){const J=this.d.getDocument(I),de=y.Position.to($),we=await this.e.provideReferences(J,de,H,q);if(Array.isArray(we))return we.map(y.location.from)}}class G{constructor(I,$,H,q,J,de,we){this.g=I,this.h=$,this.j=H,this.k=q,this.l=J,this.m=de,this.n=we,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,$,H,q){const J=this.g.getDocument(I),de=g.Selection.isISelection($)?y.Selection.to($):y.Range.to($),we=[];for(const tt of this.j.getDiagnostics(I))if(de.intersection(tt.range)&&we.push(tt)>G.d)break;const ae={diagnostics:we,only:H.only?new L.CodeActionKind(H.only):void 0,triggerKind:y.CodeActionTriggerKind.to(H.trigger)},pe=await this.k.provideCodeActions(J,de,ae,q);if(!(0,N.isNonEmptyArray)(pe)||q.isCancellationRequested)return;const ve=this.e.add(pe),We=new f.DisposableStore;this.f.set(ve,We);const He=[];for(let tt=0;tt<pe.length;tt++){const Xe=pe[tt];!Xe||(G.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,We)})):(ae.only&&(Xe.kind?ae.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[ve,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,We),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(y.Diagnostic.from),edit:Xe.edit&&y.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:ve,actions:He}}async resolveCodeAction(I,$){const[H,q]=I,J=this.e.get(H,q);if(!J||G.o(J)||!this.k.resolveCodeAction)return;const de=await this.k.resolveCodeAction(J,$)??J;return de?.edit?y.WorkspaceEdit.from(de.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}G.d=1e3;class R{constructor(I,$,H,q){this.d=I,this.e=$,this.f=H,this.g=q}async prepareDocumentPaste(I,$,H,q){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(I),de=$.map(ae=>y.Range.to(ae)),we=y.DataTransfer.toDataTransfer(H,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(J,de,we,q),y.DataTransfer.toDataTransferDTO(we)}async providePasteEdits(I,$,H,q,J){const de=this.e.getDocument($),we=H.map(ve=>y.Range.to(ve)),ae=y.DataTransfer.toDataTransfer(q,async ve=>(await this.d.$resolvePasteFileData(this.g,I,ve)).buffer),pe=await this.f.provideDocumentPasteEdits(de,we,ae,J);if(!!pe)return{insertText:typeof pe.insertText=="string"?pe.insertText:{snippet:pe.insertText.value},additionalEdit:pe.additionalEdit?y.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}}class A{constructor(I,$){this.d=I,this.e=$}async provideDocumentFormattingEdits(I,$,H){const q=this.d.getDocument(I),J=await this.e.provideDocumentFormattingEdits(q,$,H);if(Array.isArray(J))return J.map(y.TextEdit.from)}}class O{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeFormattingEdits(I,$,H,q){const J=this.d.getDocument(I),de=y.Range.to($),we=await this.e.provideDocumentRangeFormattingEdits(J,de,H,q);if(Array.isArray(we))return we.map(y.TextEdit.from)}}class B{constructor(I,$){this.d=I,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,$,H,q,J){const de=this.d.getDocument(I),we=y.Position.to($),ae=await this.e.provideOnTypeFormattingEdits(de,we,H,q,J);if(Array.isArray(ae))return ae.map(y.TextEdit.from)}}class z{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,$){const H=await this.e.provideWorkspaceSymbols(I,$);if(!(0,N.isNonEmptyArray)(H))return{symbols:[]};const q=this.d.add(H),J={cacheId:q,symbols:[]};for(let de=0;de<H.length;de++){const we=H[de];if(!we||!we.name){this.f.warn("INVALID SymbolInformation",we);continue}J.symbols.push({...y.WorkspaceSymbol.from(we),cacheId:[q,de]})}return J}async resolveWorkspaceSymbol(I,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this.d.get(...I.cacheId);if(H){const q=await this.e.resolveWorkspaceSymbol(H,$);return q&&(0,T.mixin)(I,y.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class j{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,$,H){this.d=I,this.e=$,this.f=H}async provideRenameEdits(I,$,H,q){const J=this.d.getDocument(I),de=y.Position.to($);try{const we=await this.e.provideRenameEdits(J,de,H,q);return we?y.WorkspaceEdit.from(we):void 0}catch(we){const ae=j.g(we);return ae?{rejectReason:ae,edits:void 0}:Promise.reject(we)}}async resolveRenameLocation(I,$,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(I),J=y.Position.to($);try{const de=await this.e.prepareRename(q,J,H);let we,ae;if(L.Range.isRange(de)?(we=de,ae=q.getText(de)):(0,D.isObject)(de)&&(we=de.range,ae=de.placeholder),!we||!ae)return;if(we.start.line>J.line||we.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(we),text:ae}}catch(de){const we=j.g(de);return we?{rejectReason:we,range:void 0,text:void 0}:Promise.reject(de)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class K{constructor(I,$){this.resultId=I,this.tokens=$}}class ie{constructor(I,$){this.f=I,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,$,H){const q=this.f.getDocument(I),J=$!==0?this.d.get($):null;let de=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,J.resultId,H):await this.g.provideDocumentSemanticTokens(q,H);return J&&this.d.delete($),de?(de=ie.h(de),this.o(ie.n(J,de),de)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return ie.j(I)?ie.k(I)?I:new L.SemanticTokens(new Uint32Array(I.data),I.resultId):ie.l(I)?ie.m(I)?I:new L.SemanticTokensEdits(I.edits.map($=>new L.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const $ of I.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(I,$){if(!ie.j($)||!I||!I.tokens)return $;const H=I.tokens,q=H.length,J=$.data,de=J.length;let we=0;const ae=Math.min(q,de);for(;we<ae&&H[we]===J[we];)we++;if(we===q&&we===de)return new L.SemanticTokensEdits([],$.resultId);let pe=0;const ve=ae-we;for(;pe<ve&&H[q-pe-1]===J[de-pe-1];)pe++;return new L.SemanticTokensEdits([{start:we,deleteCount:q-we-pe,data:J.subarray(we,de-pe)}],$.resultId)}o(I,$){if(ie.j(I)){const H=this.e++;return this.d.set(H,new K(I.resultId,I.data)),(0,t.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(ie.l(I)){const H=this.e++;return ie.j($)?this.d.set(H,new K($.resultId,$.data)):this.d.set(H,new K(I.resultId)),(0,t.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class me{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeSemanticTokens(I,$,H){const q=this.d.getDocument(I),J=await this.e.provideDocumentRangeSemanticTokens(q,y.Range.to($),H);return J?this.f(J):null}f(I){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class ue{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,$,H,q,J){this.f=I,this.g=$,this.h=H,this.j=q,this.k=J,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,$,H,q){const J=this.f.getDocument(I),de=y.Position.to($),we=J.getWordRangeAtPosition(de)||new L.Range(de,de),ae=we.with({end:de}),pe=new v.StopWatch(!0),ve=await this.h.provideCompletionItems(J,de,q,y.CompletionContext.to(H));if(!ve||q.isCancellationRequested)return;const We=Array.isArray(ve)?new L.CompletionList(ve):ve,He=ue.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),tt=new f.DisposableStore;this.e.set(He,tt);const Xe=[],et={x:He,b:Xe,a:{replace:y.Range.from(we),insert:y.Range.from(ae)},c:We.isIncomplete||void 0,d:pe.elapsed()};for(let it=0;it<We.items.length;it++){const dt=We.items[it],Fe=this.l(dt,[He,it],ae,we);Xe.push(Fe)}return et}async resolveCompletionItem(I,$){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...I);if(!H)return;const q=await this.h.resolveCompletionItem(H,$);if(!!q)return this.l(q,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$,H,q){const J=this.e.get($[0]);if(!J)throw Error("DisposableStore is missing...");const de=this.g.toInternal(I.command,J),we={x:$,a:I.label,b:I.kind!==void 0?y.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(y.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:y.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(y.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=I.textEdit.newText):typeof I.insertText=="string"?we.h=I.insertText:I.insertText instanceof L.SnippetString&&(we.h=I.insertText.value,we.i|=4);let ae;return I.textEdit?ae=I.textEdit.range:I.range&&(ae=I.range),L.Range.isRange(ae)?we.j=y.Range.from(ae):ae&&(!H?.isEqual(ae.inserting)||!q?.isEqual(ae.replacing))&&(we.j={insert:y.Range.from(ae.inserting),replace:y.Range.from(ae.replacing)}),we}}class oe{async provideInlineCompletions(I,$,H,q){}disposeCompletions(I){}handleDidShowCompletionItem(I,$){}}class De extends oe{constructor(I,$,H,q){super(),this.f=I,this.g=$,this.h=H,this.j=q,this.d=new re,this.e=(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,$,H,q){const J=this.g.getDocument(I),de=y.Position.to($),we=await this.h.provideInlineCompletionItems(J,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:y.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},q);if(!we||q.isCancellationRequested)return;const ae=Array.isArray(we)?we:we.items,pe=this.e?Array.isArray(we)?[]:we.commands||[]:[];let ve;return{pid:this.d.createReferenceId({dispose(){ve?.dispose()},items:ae}),items:ae.map((He,tt)=>{let Xe;He.command&&(ve||(ve=new f.DisposableStore),Xe=this.j.toInternal(He.command,ve));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?y.Range.from(He.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:pe.map(He=>(ve||(ve=new f.DisposableStore),this.j.toInternal(He,ve)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,$){const H=this.d.get(I)?.items[$];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H)}}class re{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const $=this.e++;return this.d.set($,I),$}disposeReferenceId(I){const $=this.d.get(I);return this.d.delete(I),$}get(I){return this.d.get(I)}}class _{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(I,$,H,q){const J=this.e.getDocument(I),de=y.Position.to($),we=this.g(H),ae=await this.f.provideSignatureHelp(J,de,q,we);if(ae){const pe=this.d.add([ae]);return{...y.SignatureHelp.from(ae),id:pe}}}g(I){let $;if(I.activeSignatureHelp){const H=y.SignatureHelp.to(I.activeSignatureHelp),q=this.d.get(I.activeSignatureHelp.id,0);q?($=q,$.activeSignature=H.activeSignature,$.activeParameter=H.activeParameter):$=H}return{...I,activeSignatureHelp:$}}releaseSignatureHelp(I){this.d.delete(I)}}class le{constructor(I,$,H,q,J){this.f=I,this.g=$,this.h=H,this.j=q,this.k=J,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,$,H){const q=this.f.getDocument(I),J=y.Range.to($),de=await this.h.provideInlayHints(q,J,H);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(H.isCancellationRequested)return;const we=this.d.add(de);this.e.set(we,new f.DisposableStore);const ae={hints:[],cacheId:we};for(let pe=0;pe<de.length;pe++)this.l(de[pe],J)&&ae.hints.push(this.m(de[pe],[we,pe]));return this.j.trace(`[InlayHints] ${ae.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),ae}async resolveInlayHint(I,$){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...I);if(!H)return;const q=await this.h.resolveInlayHint(H,$);if(!!q&&!!this.l(q))return this.m(q,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!($&&!$.contains(I.position))}m(I,$){const H=this.e.get($[0]);if(!H)throw Error("DisposableStore is missing...");const q={label:"",cacheId:$,tooltip:y.MarkdownString.fromStrict(I.tooltip),position:y.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(y.TextEdit.from),kind:I.kind&&y.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?q.label=I.label:q.label=I.label.map(J=>{const de={label:J.value};return de.tooltip=y.MarkdownString.fromStrict(J.tooltip),L.Location.isLocation(J.location)&&(de.location=y.location.from(J.location)),J.command&&(de.command=this.g.toInternal(J.command,H)),de}),q}}class Ee{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("DocumentLink")}async provideLinks(I,$){const H=this.e.getDocument(I),q=await this.f.provideDocumentLinks(H,$);if(!(!Array.isArray(q)||q.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(Ee.g).map(y.DocumentLink.from)};{const J=this.d.add(q),de={links:[],cacheId:J};for(let we=0;we<q.length;we++){if(!Ee.g(q[we]))continue;const ae=y.DocumentLink.from(q[we]);ae.cacheId=[J,we],de.links.push(ae)}return de}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,$){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...I);if(!H)return;const q=await this.f.resolveDocumentLink(H,$);if(!(!q||!Ee.g(q)))return y.DocumentLink.from(q)}releaseLinks(I){this.d.delete(I)}}class Ae{constructor(I,$){this.d=I,this.e=$}async provideColors(I,$){const H=this.d.getDocument(I),q=await this.e.provideDocumentColors(H,$);return Array.isArray(q)?q.map(de=>({color:y.Color.from(de.color),range:y.Range.from(de.range)})):[]}async provideColorPresentations(I,$,H){const q=this.d.getDocument(I),J=y.Range.to($.range),de=y.Color.to($.color),we=await this.e.provideColorPresentations(de,{document:q,range:J},H);if(!!Array.isArray(we))return we.map(y.ColorPresentation.from)}}class Be{constructor(I,$){this.d=I,this.e=$}async provideFoldingRanges(I,$,H){const q=this.d.getDocument(I),J=await this.e.provideFoldingRanges(q,$,H);if(!!Array.isArray(J))return J.map(y.FoldingRange.from)}}class xe{constructor(I,$,H){this.d=I,this.e=$,this.f=H}async provideSelectionRanges(I,$,H){const q=this.d.getDocument(I),J=$.map(y.Position.to),de=await this.e.provideSelectionRanges(q,J,H);if(!(0,N.isNonEmptyArray)(de))return[];if(de.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const we=[];for(let ae=0;ae<J.length;ae++){const pe=[];we.push(pe);let ve=J[ae],We=de[ae];for(;;){if(!We.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(pe.push(y.SelectionRange.from(We)),!We.parent)break;ve=We.range,We=We.parent}}return we}}class Te{constructor(I,$){this.f=I,this.g=$,this.d=new a.IdGenerator(""),this.e=new Map}async prepareSession(I,$,H){const q=this.f.getDocument(I),J=y.Position.to($),de=await this.g.prepareCallHierarchy(q,J,H);if(!de)return;const we=this.d.nextId();return this.e.set(we,new Map),Array.isArray(de)?de.map(ae=>this.h(we,ae)):[this.h(we,de)]}async provideCallsTo(I,$,H){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(q,H);if(!!J)return J.map(de=>({from:this.h(I,de.from),fromRanges:de.fromRanges.map(we=>y.Range.from(we))}))}async provideCallsFrom(I,$,H){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(q,H);if(!!J)return J.map(de=>({to:this.h(I,de.to),fromRanges:de.fromRanges.map(we=>y.Range.from(we))}))}releaseSession(I){this.e.delete(I)}h(I,$){const H=this.e.get(I),q=y.CallHierarchyItem.from($,I,H.size.toString(36));return H.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class Ie{constructor(I,$){this.f=I,this.g=$,this.d=new a.IdGenerator(""),this.e=new Map}async prepareSession(I,$,H){const q=this.f.getDocument(I),J=y.Position.to($),de=await this.g.prepareTypeHierarchy(q,J,H);if(!de)return;const we=this.d.nextId();return this.e.set(we,new Map),Array.isArray(de)?de.map(ae=>this.h(we,ae)):[this.h(we,de)]}async provideSupertypes(I,$,H){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(q,H);if(!!J)return J.map(de=>this.h(I,de))}async provideSubtypes(I,$,H){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(q,H);if(!!J)return J.map(de=>this.h(I,de))}releaseSession(I){this.e.delete(I)}h(I,$){const H=this.e.get(I),q=y.TypeHierarchyItem.from($,I,H.size.toString(36));return H.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class Se{constructor(I,$,H,q){this.d=I,this.e=$,this.f=H,this.g=q}async provideDocumentOnDropEdits(I,$,H,q,J){const de=this.e.getDocument($),we=y.Position.to(H),ae=y.DataTransfer.toDataTransfer(q,async ve=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,ve)).buffer),pe=await this.f.provideDocumentDropEdits(de,we,ae,J);if(!!pe)return{insertText:typeof pe.insertText=="string"?pe.insertText:{snippet:pe.insertText.value},additionalEdit:pe.additionalEdit?y.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}}class se{constructor(I,$){this.adapter=I,this.extension=$}}class ce{constructor(I,$,H,q,J,de,we,ae){this.g=$,this.h=H,this.j=q,this.k=J,this.l=de,this.m=we,this.n=ae,this.f=new Map,this.e=I.getProxy(F.MainContext.MainThreadLanguageFeatures)}o(I){return y.DocumentSelector.from(I,this.g)}p(I){return new L.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ce.d++}async s(I,$,H,q,J,de=!1){const we=this.f.get(I);if(!we||!(we.adapter instanceof $))return q;const ae=Date.now();de||this.l.trace(`[${we.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const pe=H(we.adapter,we.extension);return Promise.resolve(pe).catch(ve=>{(0,b.isCancellationError)(ve)||(this.l.error(`[${we.extension.identifier.value}] provider FAILED`),this.l.error(ve),this.n.onExtensionError(we.extension.identifier,ve))}).finally(()=>{de||this.l.trace(`[${we.extension.identifier.value}] provider DONE after ${Date.now()-ae}ms`)}),p.CancellationToken.isCancellationToken(J)?(0,E.raceCancellationError)(pe,J):pe}t(I,$){const H=this.q();return this.f.set(H,new se(I,$)),H}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,$,H,q){const J=this.t(new r(this.h,H),I),de=q&&q.label||ce.u(I);return this.e.$registerDocumentSymbolProvider(J,this.o($),de),this.p(J)}$provideDocumentSymbols(I,$,H){return this.s(I,r,q=>q.provideDocumentSymbols(i.URI.revive($),H),void 0,H)}registerCodeLensProvider(I,$,H){const q=this.q(),J=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new se(new o(this.h,this.j.converter,H),I)),this.e.$registerCodeLensSupport(q,this.o($),J);let de=this.p(q);if(J!==void 0){const we=H.onDidChangeCodeLenses(ae=>this.e.$emitCodeLensEvent(J));de=L.Disposable.from(de,we)}return de}$provideCodeLenses(I,$,H){return this.s(I,o,q=>q.provideCodeLenses(i.URI.revive($),H),void 0,H)}$resolveCodeLens(I,$,H){return this.s(I,o,q=>q.resolveCodeLens($,H),void 0,void 0)}$releaseCodeLenses(I,$){this.s(I,o,H=>Promise.resolve(H.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(I,$,H){const q=this.t(new d(this.h,H),I);return this.e.$registerDefinitionSupport(q,this.o($)),this.p(q)}$provideDefinition(I,$,H,q){return this.s(I,d,J=>J.provideDefinition(i.URI.revive($),H,q),[],q)}registerDeclarationProvider(I,$,H){const q=this.t(new c(this.h,H),I);return this.e.$registerDeclarationSupport(q,this.o($)),this.p(q)}$provideDeclaration(I,$,H,q){return this.s(I,c,J=>J.provideDeclaration(i.URI.revive($),H,q),[],q)}registerImplementationProvider(I,$,H){const q=this.t(new u(this.h,H),I);return this.e.$registerImplementationSupport(q,this.o($)),this.p(q)}$provideImplementation(I,$,H,q){return this.s(I,u,J=>J.provideImplementation(i.URI.revive($),H,q),[],q)}registerTypeDefinitionProvider(I,$,H){const q=this.t(new n(this.h,H),I);return this.e.$registerTypeDefinitionSupport(q,this.o($)),this.p(q)}$provideTypeDefinition(I,$,H,q){return this.s(I,n,J=>J.provideTypeDefinition(i.URI.revive($),H,q),[],q)}registerHoverProvider(I,$,H,q){const J=this.t(new h(this.h,H),I);return this.e.$registerHoverProvider(J,this.o($)),this.p(J)}$provideHover(I,$,H,q){return this.s(I,h,J=>J.provideHover(i.URI.revive($),H,q),void 0,q)}registerEvaluatableExpressionProvider(I,$,H,q){const J=this.t(new m(this.h,H),I);return this.e.$registerEvaluatableExpressionProvider(J,this.o($)),this.p(J)}$provideEvaluatableExpression(I,$,H,q){return this.s(I,m,J=>J.provideEvaluatableExpression(i.URI.revive($),H,q),void 0,q)}registerInlineValuesProvider(I,$,H,q){const J=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new P(this.h,H),I);this.e.$registerInlineValuesProvider(de,this.o($),J);let we=this.p(de);if(J!==void 0){const ae=H.onDidChangeInlineValues(pe=>this.e.$emitInlineValuesEvent(J));we=L.Disposable.from(we,ae)}return we}$provideInlineValues(I,$,H,q,J){return this.s(I,P,de=>de.provideInlineValues(i.URI.revive($),H,q,J),void 0,J)}registerDocumentHighlightProvider(I,$,H){const q=this.t(new M(this.h,H),I);return this.e.$registerDocumentHighlightProvider(q,this.o($)),this.p(q)}$provideDocumentHighlights(I,$,H,q){return this.s(I,M,J=>J.provideDocumentHighlights(i.URI.revive($),H,q),void 0,q)}registerLinkedEditingRangeProvider(I,$,H){const q=this.t(new V(this.h,H),I);return this.e.$registerLinkedEditingRangeProvider(q,this.o($)),this.p(q)}$provideLinkedEditingRanges(I,$,H,q){return this.s(I,V,async J=>{const de=await J.provideLinkedEditingRanges(i.URI.revive($),H,q);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?ce.w(de.wordPattern):void 0}},void 0,q)}registerReferenceProvider(I,$,H){const q=this.t(new Z(this.h,H),I);return this.e.$registerReferenceSupport(q,this.o($)),this.p(q)}$provideReferences(I,$,H,q,J){return this.s(I,Z,de=>de.provideReferences(i.URI.revive($),H,q,J),void 0,J)}registerCodeActionProvider(I,$,H,q){const J=new f.DisposableStore,de=this.t(new G(this.h,this.j.converter,this.k,H,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(de,this.o($),{providedKinds:q?.providedCodeActionKinds?.map(we=>we.value),documentation:q?.documentation?.map(we=>({kind:we.kind.value,command:this.j.converter.toInternal(we.command,J)}))},ce.u(I),Boolean(H.resolveCodeAction)),J.add(this.p(de)),J}$provideCodeActions(I,$,H,q,J){return this.s(I,G,de=>de.provideCodeActions(i.URI.revive($),H,q,J),void 0,J)}$resolveCodeAction(I,$,H){return this.s(I,G,q=>q.resolveCodeAction($,H),void 0,void 0)}$releaseCodeActions(I,$){this.s(I,G,H=>Promise.resolve(H.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(I,$,H){const q=this.t(new A(this.h,H),I);return this.e.$registerDocumentFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentFormattingEdits(I,$,H,q){return this.s(I,A,J=>J.provideDocumentFormattingEdits(i.URI.revive($),H,q),void 0,q)}registerDocumentRangeFormattingEditProvider(I,$,H){const q=this.t(new O(this.h,H),I);return this.e.$registerRangeFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentRangeFormattingEdits(I,$,H,q,J){return this.s(I,O,de=>de.provideDocumentRangeFormattingEdits(i.URI.revive($),H,q,J),void 0,J)}registerOnTypeFormattingEditProvider(I,$,H,q){const J=this.t(new B(this.h,H),I);return this.e.$registerOnTypeFormattingSupport(J,this.o($),q,I.identifier),this.p(J)}$provideOnTypeFormattingEdits(I,$,H,q,J,de){return this.s(I,B,we=>we.provideOnTypeFormattingEdits(i.URI.revive($),H,q,J,de),void 0,de)}registerWorkspaceSymbolProvider(I,$){const H=this.t(new z($,this.l),I);return this.e.$registerNavigateTypeSupport(H,typeof $.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(I,$,H){return this.s(I,z,q=>q.provideWorkspaceSymbols($,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,$,H){return this.s(I,z,q=>q.resolveWorkspaceSymbol($,H),void 0,void 0)}$releaseWorkspaceSymbols(I,$){this.s(I,z,H=>H.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(I,$,H){const q=this.t(new j(this.h,H,this.l),I);return this.e.$registerRenameSupport(q,this.o($),j.supportsResolving(H)),this.p(q)}$provideRenameEdits(I,$,H,q,J){return this.s(I,j,de=>de.provideRenameEdits(i.URI.revive($),H,q,J),void 0,J)}$resolveRenameLocation(I,$,H,q){return this.s(I,j,J=>J.resolveRenameLocation(i.URI.revive($),H,q),void 0,q)}registerDocumentSemanticTokensProvider(I,$,H,q){const J=this.t(new ie(this.h,H),I),de=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o($),q,de);let we=this.p(J);if(de){const ae=H.onDidChangeSemanticTokens(pe=>this.e.$emitDocumentSemanticTokensEvent(de));we=L.Disposable.from(we,ae)}return we}$provideDocumentSemanticTokens(I,$,H,q){return this.s(I,ie,J=>J.provideDocumentSemanticTokens(i.URI.revive($),H,q),null,q)}$releaseDocumentSemanticTokens(I,$){this.s(I,ie,H=>H.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,$,H,q){const J=this.t(new me(this.h,H),I);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o($),q),this.p(J)}$provideDocumentRangeSemanticTokens(I,$,H,q){return this.s(I,me,J=>J.provideDocumentRangeSemanticTokens(i.URI.revive($),H,q),null,q)}registerCompletionItemProvider(I,$,H,q){const J=this.t(new ue(this.h,this.j.converter,H,this.m,I),I);return this.e.$registerCompletionsProvider(J,this.o($),q,ue.supportsResolving(H),`${I.identifier.value}(${q.join("")})`),this.p(J)}$provideCompletionItems(I,$,H,q,J){return this.s(I,ue,de=>de.provideCompletionItems(i.URI.revive($),H,q,J),void 0,J)}$resolveCompletionItem(I,$,H){return this.s(I,ue,q=>q.resolveCompletionItem($,H),void 0,H)}$releaseCompletionItems(I,$){this.s(I,ue,H=>H.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(I,$,H){const q=new De(I,this.h,H,this.j.converter),J=this.t(q,I);return this.e.$registerInlineCompletionsSupport(J,this.o($),q.supportsHandleDidShowCompletionItem),this.p(J)}$provideInlineCompletions(I,$,H,q,J){return this.s(I,oe,de=>de.provideInlineCompletions(i.URI.revive($),H,q,J),void 0,J)}$handleInlineCompletionDidShow(I,$,H){this.s(I,oe,async q=>{q.handleDidShowCompletionItem($,H)},void 0,void 0)}$freeInlineCompletionsList(I,$){this.s(I,oe,async H=>{H.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(I,$,H,q){const J=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,de=this.t(new _(this.h,H),I);return this.e.$registerSignatureHelpProvider(de,this.o($),J),this.p(de)}$provideSignatureHelp(I,$,H,q,J){return this.s(I,_,de=>de.provideSignatureHelp(i.URI.revive($),H,q,J),void 0,J)}$releaseSignatureHelp(I,$){this.s(I,_,H=>H.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(I,$,H){const q=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,J=this.t(new le(this.h,this.j.converter,H,this.l,I),I);this.e.$registerInlayHintsProvider(J,this.o($),typeof H.resolveInlayHint=="function",q,ce.u(I));let de=this.p(J);if(q!==void 0){const we=H.onDidChangeInlayHints(ae=>this.e.$emitInlayHintsEvent(q));de=L.Disposable.from(de,we)}return de}$provideInlayHints(I,$,H,q){return this.s(I,le,J=>J.provideInlayHints(i.URI.revive($),H,q),void 0,q)}$resolveInlayHint(I,$,H){return this.s(I,le,q=>q.resolveInlayHint($,H),void 0,H)}$releaseInlayHints(I,$){this.s(I,le,H=>H.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(I,$,H){const q=this.t(new Ee(this.h,H),I);return this.e.$registerDocumentLinkProvider(q,this.o($),typeof H.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(I,$,H){return this.s(I,Ee,q=>q.provideLinks(i.URI.revive($),H),void 0,H,$.scheme==="output")}$resolveDocumentLink(I,$,H){return this.s(I,Ee,q=>q.resolveLink($,H),void 0,void 0,!0)}$releaseDocumentLinks(I,$){this.s(I,Ee,H=>H.releaseLinks($),void 0,void 0,!0)}registerColorProvider(I,$,H){const q=this.t(new Ae(this.h,H),I);return this.e.$registerDocumentColorProvider(q,this.o($)),this.p(q)}$provideDocumentColors(I,$,H){return this.s(I,Ae,q=>q.provideColors(i.URI.revive($),H),[],H)}$provideColorPresentations(I,$,H,q){return this.s(I,Ae,J=>J.provideColorPresentations(i.URI.revive($),H,q),void 0,q)}registerFoldingRangeProvider(I,$,H){const q=this.q(),J=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new se(new Be(this.h,H),I)),this.e.$registerFoldingRangeProvider(q,this.o($),I.identifier,J);let de=this.p(q);if(J!==void 0){const we=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));de=L.Disposable.from(de,we)}return de}$provideFoldingRanges(I,$,H,q){return this.s(I,Be,J=>J.provideFoldingRanges(i.URI.revive($),H,q),void 0,q)}registerSelectionRangeProvider(I,$,H){const q=this.t(new xe(this.h,H,this.l),I);return this.e.$registerSelectionRangeProvider(q,this.o($)),this.p(q)}$provideSelectionRanges(I,$,H,q){return this.s(I,xe,J=>J.provideSelectionRanges(i.URI.revive($),H,q),[],q)}registerCallHierarchyProvider(I,$,H){const q=this.t(new Te(this.h,H),I);return this.e.$registerCallHierarchyProvider(q,this.o($)),this.p(q)}$prepareCallHierarchy(I,$,H,q){return this.s(I,Te,J=>Promise.resolve(J.prepareSession(i.URI.revive($),H,q)),void 0,q)}$provideCallHierarchyIncomingCalls(I,$,H,q){return this.s(I,Te,J=>J.provideCallsTo($,H,q),void 0,q)}$provideCallHierarchyOutgoingCalls(I,$,H,q){return this.s(I,Te,J=>J.provideCallsFrom($,H,q),void 0,q)}$releaseCallHierarchy(I,$){this.s(I,Te,H=>Promise.resolve(H.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(I,$,H){const q=this.t(new Ie(this.h,H),I);return this.e.$registerTypeHierarchyProvider(q,this.o($)),this.p(q)}$prepareTypeHierarchy(I,$,H,q){return this.s(I,Ie,J=>Promise.resolve(J.prepareSession(i.URI.revive($),H,q)),void 0,q)}$provideTypeHierarchySupertypes(I,$,H,q){return this.s(I,Ie,J=>J.provideSupertypes($,H,q),void 0,q)}$provideTypeHierarchySubtypes(I,$,H,q){return this.s(I,Ie,J=>J.provideSubtypes($,H,q),void 0,q)}$releaseTypeHierarchy(I,$){this.s(I,Ie,H=>Promise.resolve(H.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(I,$,H){const q=this.q();return this.f.set(q,new se(new Se(this.e,this.h,H,q),I)),this.e.$registerDocumentOnDropEditProvider(q,this.o($)),this.p(q)}$provideDocumentOnDropEdits(I,$,H,q,J,de){return this.s(I,Se,we=>Promise.resolve(we.provideDocumentOnDropEdits($,i.URI.revive(H),q,J,de)),void 0,void 0)}registerDocumentPasteEditProvider(I,$,H,q){const J=this.q();return this.f.set(J,new se(new R(this.e,this.h,H,J),I)),this.e.$registerPasteEditProvider(J,this.o($),!!H.prepareDocumentPaste,q.pasteMimeTypes),this.p(J)}$prepareDocumentPaste(I,$,H,q,J){return this.s(I,R,de=>de.prepareDocumentPaste(i.URI.revive($),H,q,J),void 0,J)}$providePasteEdits(I,$,H,q,J,de){return this.s(I,R,we=>we.providePasteEdits($,i.URI.revive(H),q,J,de),void 0,de)}static w(I){return{pattern:I.source,flags:(0,S.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ce.w(I.decreaseIndentPattern),increaseIndentPattern:ce.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ce.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ce.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ce.w(I.beforeText),afterText:I.afterText?ce.w(I.afterText):void 0,previousLineText:I.previousLineText?ce.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ce.z)}setLanguageConfiguration(I,$,H){const{wordPattern:q}=H;if(q&&(0,S.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor($,q):this.h.setWordDefinitionFor($,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const J=this.q(),de={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ce.w(H.wordPattern):void 0,indentationRules:H.indentationRules?ce.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ce.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this.e.$setLanguageConfiguration(J,$,de),this.p(J)}$setWordDefinitions(I){for(const $ of I)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(Ce[211],ke([1,0,5,8,6,29,14,7]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(N,D,g,p){this.c=D,this.d=g,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=N.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this.b=N}async getLanguages(){return this.b.slice(0)}async changeLanguage(N,D){await this.a.$changeLanguage(N,D);const g=this.c.getDocumentData(N);if(!g)throw new Error(`document '${N.toString()}' NOT found`);return g.document}async tokenAtPosition(N,D){const g=N.version,p=T.Position.from(D),f=await this.a.$tokensAtPosition(N.uri,p),t={type:y.StandardTokenType.Other,range:N.getWordRangeAtPosition(D)??new y.Range(D.line,D.character,D.line,D.character)};if(!f)return t;const a={range:T.Range.to(f.range),type:T.TokenType.to(f.type)};return!a.range.contains(D)||g!==N.version?t:a}createLanguageStatusItem(N,D,g){const p=this.f++,f=this.a,t=this.g,a=`${N.identifier.value}/${D}`;if(t.has(a))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);t.add(a);const l={selector:g,id:D,name:N.displayName??N.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const b=new F.DisposableStore,E=()=>{v?.dispose(),v=(0,C.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(p,{id:a,name:l.name??N.displayName??N.name,source:N.displayName??N.name,selector:T.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===y.LanguageStatusSeverity.Error?L.default.Error:l.severity===y.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:l.command&&this.d.toInternal(l.command,b),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},w={dispose(){b.dispose(),v?.dispose(),f.$removeLanguageStatus(p),t.delete(a)},get id(){return l.id},get name(){return l.name},set name(r){l.name=r,E()},get selector(){return l.selector},set selector(r){l.selector=r,E()},get text(){return l.text},set text(r){l.text=r,E()},get detail(){return l.detail},set detail(r){l.detail=r,E()},get severity(){return l.severity},set severity(r){l.severity=r,E()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(r){l.accessibilityInformation=r,E()},get command(){return l.command},set command(r){l.command=r,E()},get busy(){return l.busy},set busy(r){l.busy=r,E()}};return E(),w}}e.ExtHostLanguages=S}),define(Ce[75],ke([1,0,21,10,2,3,12,5,27,15]),function(ee,e,i,T,y,L,C,F,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let N=class{constructor(g,p,f){this.f=f,this.d=new Map,this.a=p.getProxy(F.MainContext.MainThreadLocalization),this.b=g.environment.appLanguage,this.c=this.b===i.LANGUAGE_DEFAULT}getMessage(g,p){const{message:f,args:t,comment:a}=p;if(this.c)return(0,T.format2)(f,t??{});let l=f;a&&a.length>0&&(l+=`/${Array.isArray(a)?a.join():a}`);const v=this.d.get(g)?.contents[l];return v||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,T.format2)(v??f,t??{})}getBundle(g){return this.d.get(g)?.contents}getBundleUri(g){return this.d.get(g)?.uri}async initializeLocalizedMessages(g){if(this.c||!g.l10n&&!g.isBuiltin||this.d.has(g.identifier.value))return;let p;const f=await this.g(g);if(!f){this.f.error(`No bundle location found for extension ${g.identifier.value}`);return}try{const t=await this.a.$fetchBundleContents(f),a=JSON.parse(t);p=g.isBuiltin?a.contents?.bundle:a}catch(t){this.f.error(`Failed to load translations for ${g.identifier.value} from ${f}: ${t.message}`);return}p&&this.d.set(g.identifier.value,{contents:p,uri:f})}async g(g){if(g.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(g.identifier.value);return y.URI.revive(p)}return g.l10n?y.URI.joinPath(g.extensionLocation,g.l10n,`bundle.l10n.${this.b}.json`):void 0}};N=qe([je(0,S.IExtHostInitDataService),je(1,k.IExtHostRpcService),je(2,C.ILogService)],N),e.ExtHostLocalizationService=N,e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(Ce[212],ke([1,0,12,5,27,15,2,4,9]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends i.AbstractLoggerService{constructor(g,p){super(p.logLevel,F.Event.None),this.g=g.getProxy(T.MainContext.MainThreadLogger)}$setLevel(g,p){p?this.setLevel(C.URI.revive(p),g):(0,S.isUndefined)(g)||this.setLevel(g)}f(g,p,f){return new N(this.g,g,p,f)}};k=qe([je(0,L.IExtHostRpcService),je(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class N extends i.AbstractMessageLogger{constructor(g,p,f,t){super(t?.always),this.m=g,this.n=p,this.k=!1,this.l=[],this.setLevel(f),this.m.$createLogger(p,t).then(()=>{this.r(this.l),this.k=!0})}g(g,p){const f=[[g,p]];this.k?this.r(f):this.l.push(...f)}r(g){this.m.$log(this.n,g)}}}),define(Ce[213],ke([1,0,5,12,26]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(F){return F&&F.title}let C=class{constructor(S,k){this.b=k,this.a=S.getProxy(i.MainContext.MainThreadMessageService)}showMessage(S,k,N,D,g){const p={source:{identifier:S.identifier,label:S.displayName||S.name}};let f;typeof D=="string"||L(D)?f=[D,...g]:(p.modal=D?.modal,p.useCustom=D?.useCustom,p.detail=D?.detail,f=g),p.useCustom&&(0,y.checkProposedApiEnabled)(S,"resolvers");const t=[];for(let a=0;a<f.length;a++){const l=f[a];if(typeof l=="string")t.push({title:l,handle:a,isCloseAffordance:!1});else if(typeof l=="object"){const{title:v,isCloseAffordance:b}=l;t.push({title:v,isCloseAffordance:!!b,handle:a})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(k,N,p,t).then(a=>{if(typeof a=="number")return f[a]})}};C=qe([je(1,T.ILogService)],C),e.ExtHostMessageService=C}),define(Ce[214],ke([1,0,24,4,7,28,10,9,2,52,5,38,8,6,43,187,98]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,E,w,r){this.q=w,this.r=r,this.f=new Map,this.g=new L.ResourceMap,this.h=new Map,this.j=new T.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new T.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new T.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(N.MainContext.MainThreadNotebook),this.c=b.getProxy(N.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(N.MainContext.MainThreadNotebookEditors),this.i=E.converter,E.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===13){const s=o.notebookEditor?.notebookUri,d=o.cell.handle,u=this.g.get(s)?.getCell(d);if(u)return u.apiCell}if(o&&o.$mid===14){const s=o.uri,d=this.g.get(s);if(d)return d.apiNotebook}return o}}),l.x(E)}getEditorById(b){const E=this.h.get(b);if(!E)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return E}getIdByEditor(b){for(const[E,w]of this.h)if(w.apiEditor===b)return E}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,E){const w=this.g.get(b);if(!w&&!E)throw new Error(`NO notebook document for '${b}'`);return w}static s(b,E){if(!E)return;const w=E.filenamePattern.map(r=>g.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(E.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:E.displayName,filenamePattern:w,exclusive:E.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,E,w){const r=l.a++,o=typeof w.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(r,w),this.b.$registerNotebookCellStatusBarItemProvider(r,o,E);let s;return o!==void 0&&(s=w.onDidChangeCellStatusBarItems(d=>this.b.$emitCellStatusBarEvent(o))),new p.Disposable(()=>{this.f.delete(r),this.b.$unregisterNotebookCellStatusBarItemProvider(r,o),s?.dispose()})}async createNotebookDocument(b){const E=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&g.NotebookData.from(b.content)});return S.URI.revive(E)}async openNotebookDocument(b){const E=this.g.get(b);if(E)return E.apiNotebook;const w=await this.c.$tryOpenNotebook(b),r=this.g.get(S.URI.revive(w));return(0,F.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(b,E){S.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let w;typeof E=="object"?w={position:g.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(g.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:w={preserveFocus:!1};const r=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,w),o=r&&this.h.get(r)?.apiEditor;if(o)return o;throw r?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,E,w,r){const o=this.f.get(b),s=S.URI.revive(E),d=this.g.get(s);if(!d||!o)return;const c=d.getCellFromIndex(w);if(!c)return;const u=await o.provideCellStatusBarItems(c.apiCell,r);if(!u)return;const n=new y.DisposableStore,h=this.p.add([n]),P=(Array.isArray(u)?u:[u]).map(M=>g.NotebookStatusBarItem.from(M,this.i,n));return{cacheId:h,items:P}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,E,w,r,o){if((0,C.isFalsyOrWhitespace)(E))throw new Error("viewType cannot be empty or just whitespace");const s=this.t++;return this.u.set(s,w),this.b.$registerNotebookSerializer(s,{id:b.identifier,location:b.extensionLocation},E,g.NotebookDocumentContentOptions.from(r),l.s(b,o)),(0,y.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(s)})}async $dataToNotebook(b,E,w){const r=this.u.get(b);if(!r)throw new Error("NO serializer found");const o=await r.deserializeNotebook(E.buffer,w);return new f.SerializableObjectWithBuffers(g.NotebookData.from(o))}async $notebookToData(b,E,w){const r=this.u.get(b);if(!r)throw new Error("NO serializer found");const o=await r.serializeNotebook(g.NotebookData.to(E.value),w);return i.VSBuffer.wrap(o)}w(b,E,w){if(this.h.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const r=new a.ExtHostNotebookEditor(E,this.d,b,w.visibleRanges.map(g.NotebookRange.to),w.selections.map(g.NotebookRange.to),typeof w.viewColumn=="number"?g.ViewColumn.to(w.viewColumn):void 0);this.h.set(E,r)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const w of b.value.removedDocuments){const r=S.URI.revive(w),o=this.g.get(r);o&&(o.dispose(),this.g.delete(r),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(s=>s.document.uri)}),this.n.fire(o.apiNotebook));for(const s of this.h.values())s.notebookData.uri.toString()===r.toString()&&this.h.delete(s.id)}if(b.value.addedDocuments){const w=[];for(const r of b.value.addedDocuments){const o=S.URI.revive(r.uri);if(this.g.has(o))throw new Error(`adding EXISTING notebook ${o} `);const s=new t.ExtHostNotebookDocument(this.c,this.q,this.r,o,r);w.push(...r.cells.map(d=>t.ExtHostCell.asModelAddData(s.apiNotebook,d))),this.g.get(o)?.dispose(),this.g.set(o,s),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(s.apiNotebook)}}if(b.value.addedEditors)for(const w of b.value.addedEditors){if(this.h.has(w.id))return;const r=S.URI.revive(w.documentUri),o=this.g.get(r);o&&this.w(o,w.id,w)}const E=[];if(b.value.removedEditors)for(const w of b.value.removedEditors){const r=this.h.get(w);r&&(this.h.delete(w),this.k?.id===r.id&&(this.k=void 0),E.push(r))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(r=>this.h.get(r)).filter(r=>!!r);const w=new Set;this.l.forEach(r=>w.add(r.id));for(const r of this.h.values()){const o=w.has(r.id);r._acceptVisibility(o)}this.l=[...this.h.values()].map(r=>r).filter(r=>r.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const E=D.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new D.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[E,new D.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>i.VSBuffer.wrap(o))],new D.ApiCommandResult("Notebook Data",o=>g.NotebookData.to(o.value))),r=new D.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[E,new D.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new f.SerializableObjectWithBuffers(g.NotebookData.from(o)))],new D.ApiCommandResult("Bytes",o=>o.buffer));b.registerApiCommand(w),b.registerApiCommand(r)}}e.ExtHostNotebookController=l,l.a=0}),define(Ce[215],ke([1,0,16,14,20,4,7,28,2,25,12,52,5,38,8,6,69,175,26,43]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a,l,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let E=class{constructor(c,u,n,h,m){this.k=u,this.l=n,this.m=h,this.n=m,this.b=new F.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new D.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=c.getProxy(g.MainContext.MainThreadNotebookKernels);const P=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",M=>!0,M=>{if(M&&"notebookEditor"in M&&"id"in M){const V=this.l.getIdByEditor(M.notebookEditor);return{id:M.id,extension:M.extension,notebookEditorId:V}}else if(M&&"notebookEditor"in M){const V=this.l.getIdByEditor(M.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${M.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return M})],p.ApiCommandResult.Void);this.m.registerApiCommand(P)}createNotebookController(c,u,n,h,m,P){for(const oe of this.h.values())if(oe.controller.id===u&&k.ExtensionIdentifier.equals(c.identifier,oe.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const M=this.i++,V=this;this.n.trace(`NotebookController[${M}], CREATED by ${c.identifier.value}, ${u}`);const Z=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${c.identifier}'`);let G=!1;const R=new C.DisposableStore,A=new L.Emitter,O=new L.Emitter,B={id:s(c.identifier,u),notebookType:n,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:h||c.identifier.value,preloads:P?P.map(f.NotebookRendererScript.from):[]};let z=m??Z,j;this.a.$addKernel(M,B).catch(oe=>{console.log(oe),G=!0});let K=0;const ie=()=>{if(G)return;const oe=++K;Promise.resolve().then(()=>{oe===K&&this.a.$updateKernel(M,B)})},me=new F.ResourceMap,ue={get id(){return u},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return B.label},set label(oe){B.label=oe??c.displayName??c.name,ie()},get detail(){return B.detail??""},set detail(oe){B.detail=oe,ie()},get description(){return B.description??""},set description(oe){B.description=oe,ie()},get kind(){return(0,v.checkProposedApiEnabled)(c,"notebookControllerKind"),B.kind??""},set kind(oe){(0,v.checkProposedApiEnabled)(c,"notebookControllerKind"),B.kind=oe,ie()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(oe){B.supportedLanguages=oe,ie()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){B.supportsExecutionOrder=oe,ie()},get rendererScripts(){return B.preloads?B.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(oe){z=oe??Z},get interruptHandler(){return j},set interruptHandler(oe){j=oe,B.supportsInterrupt=Boolean(oe),ie()},createNotebookCellExecution(oe){if(G)throw new Error("notebook controller is DISPOSED");if(!me.has(oe.notebook.uri))throw V.n.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return V._createNotebookCellExecution(oe,s(c.identifier,this.id))},dispose:()=>{G||(this.n.trace(`NotebookController[${M}], DISPOSED`),G=!0,this.h.delete(M),R.dispose(),A.dispose(),O.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(oe,De){De===t.NotebookControllerAffinity2.Hidden&&(0,v.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(M,oe.uri,De)},onDidReceiveMessage:O.event,postMessage(oe,De){return(0,v.checkProposedApiEnabled)(c,"notebookMessaging"),V.a.$postMessage(M,De&&V.l.getIdByEditor(De),oe)},asWebviewUri(oe){return(0,v.checkProposedApiEnabled)(c,"notebookMessaging"),(0,a.asWebviewUri)(oe,V.k.remote)}};return this.h.set(M,{extensionId:c.identifier,controller:ue,onDidReceiveMessage:O,onDidChangeSelection:A,associatedNotebooks:me}),ue}getIdByController(c){for(const[u,n]of this.h)if(n.controller===c)return s(n.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,u){const n=this.d++,h=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(n,u);const m={dispose:()=>{this.c.delete(n),h.a.$removeKernelDetectionTask(n)}};return this.c.set(n,m),m}registerKernelSourceActionProvider(c,u,n){const h=this.f++,m=this;return this.e.set(h,n),this.n.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(h,u),{dispose:()=>{this.e.delete(h),m.a.$removeKernelSourceActionProvider(h)}}}async $provideKernelSourceActions(c,u){const n=this.e.get(c);if(n){const h=new C.DisposableStore;return this.g.add([h]),(await n.provideNotebookKernelSourceActions(u)??[]).map(P=>f.NotebookKernelSourceAction.from(P,this.m.converter,h))}return[]}$acceptNotebookAssociation(c,u,n){const h=this.h.get(c);if(h){const m=this.l.getNotebookDocument(S.URI.revive(u));n?h.associatedNotebooks.set(m.uri,!0):h.associatedNotebooks.delete(m.uri),this.n.trace(`NotebookController[${c}] ASSOCIATE notebook`,m.uri.toString(),n),h.onDidChangeSelection.fire({selected:n,notebook:m.apiNotebook})}}async $executeCells(c,u,n){const h=this.h.get(c);if(!h)return;const m=this.l.getNotebookDocument(S.URI.revive(u)),P=[];for(const M of n){const V=m.getCell(M);V&&P.push(V.apiCell)}try{this.n.trace(`NotebookController[${c}] EXECUTE cells`,m.uri.toString(),P.length),await h.controller.executeHandler.call(h.controller,P,m.apiNotebook,h.controller)}catch(M){this.n.error(`NotebookController[${c}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(c,u,n){const h=this.h.get(c);if(!h)return;const m=this.l.getNotebookDocument(S.URI.revive(u));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,m.apiNotebook);else for(const P of n){const M=m.getCell(P);M&&this.b.get(M.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,u,n){const h=this.h.get(c);if(!h)return;const m=this.l.getEditorById(u);h.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:n}))}$cellExecutionChanged(c,u,n){const m=this.l.getNotebookDocument(S.URI.revive(c)).getCell(u);if(m){const P=n?f.NotebookCellExecutionState.to(n):t.NotebookCellExecutionState.Idle;P!==void 0&&this.j.fire({cell:m.apiCell,state:P})}}_createNotebookCellExecution(c,u){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.l.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const m=new r(u,h,this.a);this.b.set(h.uri,m);const P=m.onDidChangeState(()=>{m.state===w.Resolved&&(m.dispose(),P.dispose(),this.b.delete(h.uri))});return m.asApiObject()}};E=qe([je(4,N.ILogService)],E),e.ExtHostNotebookKernels=E;var w;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(w||(w={}));class r extends C.Disposable{get state(){return this.f}constructor(c,u,n){super(),this.j=u,this.k=n,this.b=r.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new y.CancellationTokenSource),this.h=new o(10,h=>this.m(h)),this.i=u.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const u=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(u))}n(){if(this.f===w.Init)throw new Error("Must call start before modifying cell output");if(this.f===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let u=this.j;if(c&&(u=this.j.notebook.getCellFromApiCell(c)),!u)throw new Error("INVALID cell");return u.handle}s(c){return c.map(u=>{const n=t.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return n===u.items?f.NotebookCellOutput.from(u):f.NotebookCellOutput.from({items:n,id:u.id,metadata:u.metadata})})}async t(c,u,n){const h=this.r(u),m=this.s((0,i.asArray)(c));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:h,append:n,outputs:m})}async w(c,u,n){return c=t.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(c),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:c.map(f.NotebookCellOutputItem.from),outputId:u.id,append:n})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(n){c.i=n,c.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(n){if(c.f===w.Resolved||c.f===w.Started)throw new Error("Cannot call start again");c.f=w.Started,c.c.fire(),c.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,h){if(c.f===w.Resolved)throw new Error("Cannot call resolve twice");c.f=w.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new b.SerializableObjectWithBuffers({runEndTime:h,lastRunSuccess:n}))},clearOutput(n){return c.n(),c.t([],n,!1)},appendOutput(n,h){return c.n(),c.t(n,h,!0)},replaceOutput(n,h){return c.n(),c.t(n,h,!1)},appendOutputItems(n,h){return c.n(),c.w(n,h,!0)},replaceOutputItems(n,h){return c.n(),c.w(n,h,!1)}})}}r.a=0;class o{constructor(c,u){this.d=c,this.e=u,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new T.DeferredPromise,this.b=Date.now(),(0,T.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const u=this.a;return this.a=[],this.e(u).finally(()=>c.complete())}}function s(d,c){return`${d.value}/${c}`}e.createKernelId=s}),define(Ce[216],ke([1,0,4,5,98]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(F,S){this.c=S,this.a=new Map,this.b=F.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(F,S,k){const N=this.c.getEditorById(F);this.a.get(S)?.fire({editor:N.apiEditor,message:k})}createRendererMessaging(F,S){if(!F.contributes?.notebookRenderer?.some(N=>N.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(N,D,g)=>this.d(S).event(N,D,g),postMessage:(N,D)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(N)&&([N,D]=[D,N]);const g=D&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.b.$postMessage(g?.id,S,N)}}}d(F){let S=this.a.get(F);return S||(S=new i.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(F)}}),this.a.set(F,S),S)}}e.ExtHostNotebookRenderers=L}),define(Ce[217],ke([1,0,7,2,26,5]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class C{constructor(S){this.b=new Map,this.a=S.getProxy(L.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,k,N){if((0,y.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(k))throw new Error(`Handler with id '${k}' already registered`);return this.b.set(k,N),this.a.$registerProfileContentHandler(k,N.name,S.identifier.value),(0,i.toDisposable)(()=>{this.b.delete(k),this.a.$unregisterProfileContentHandler(k)})}async $saveProfile(S,k,N,D){const g=this.b.get(S);if(!g)throw new Error(`Unknown handler with id: ${S}`);return g.saveProfile(k,N,D)}async $readProfile(S,k,N){const D=this.b.get(S);if(!D)throw new Error(`Unknown handler with id: ${S}`);return D.readProfile(T.URI.revive(k),N)}}e.ExtHostProfileContentHandlers=C}),define(Ce[218],ke([1,0,20,4,7,5,2,6,11,16,29,65]),function(ee,e,i,T,y,L,C,F,S,k,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(p,f,t){const a=p.getProxy(L.MainContext.MainThreadQuickOpen);class l{constructor(c,u){this.e=new Map,this.f=0,this.a=c,this.b=u}showQuickPick(c,u,n=i.CancellationToken.None){this.c=void 0;const h=Promise.resolve(c),m=++this.f,P=a.$show(m,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},n),M={},V=P.then(()=>M);return Promise.race([V,h]).then(Z=>{if(Z!==M)return h.then(G=>{const R=[];for(let A=0;A<G.length;A++){const O=G[A];typeof O=="string"?R.push({label:O,handle:A}):O.kind===F.QuickPickItemKind.Separator?R.push({type:"separator",label:O.label}):R.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:A})}return u&&typeof u.onDidSelectItem=="function"&&(this.c=A=>{u.onDidSelectItem(G[A])}),a.$setItems(m,R),P.then(A=>{if(typeof A=="number")return G[A];if(Array.isArray(A))return A.map(O=>G[O])})})}).then(void 0,Z=>{if(!(0,S.isCancellationError)(Z))return a.$setError(m,Z),Promise.reject(Z)})}$onItemSelected(c){this.c?.(c)}showInput(c,u=i.CancellationToken.None){return this.d=c?.validateInput,a.$input(c,typeof this.d=="function",u).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(c){if(!this.d)return;const u=await this.d(c);if(!u||typeof u=="string")return u;let n;switch(u.severity){case F.InputBoxValidationSeverity.Info:n=N.default.Info;break;case F.InputBoxValidationSeverity.Warning:n=N.default.Warning;break;case F.InputBoxValidationSeverity.Error:n=N.default.Error;break;default:n=u.message?N.default.Error:N.default.Ignore;break}return{content:u.message,severity:n}}async showWorkspaceFolderPick(c,u=i.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!n)return;const h=await this.a.getWorkspaceFolders2();if(!!h)return h.find(m=>m.uri.toString()===n.uri.toString())}createQuickPick(c){const u=new o(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(c){const u=new s(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(c,u){this.e.get(c)?._fireDidChangeValue(u)}$onDidAccept(c){this.e.get(c)?._fireDidAccept()}$onDidChangeActive(c,u){const n=this.e.get(c);n instanceof o&&n._fireDidChangeActive(u)}$onDidChangeSelection(c,u){const n=this.e.get(c);n instanceof o&&n._fireDidChangeSelection(u)}$onDidTriggerButton(c,u){this.e.get(c)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(c,u,n){const h=this.e.get(c);h instanceof o&&h._fireDidTriggerItemButton(u,n)}$onDidHide(c){this.e.get(c)?._fireDidHide()}}class v{constructor(c,u){this.x=c,this.y=u,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.Emitter,this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(c){this.b=c,this.z({title:c})}get step(){return this.c}set step(c){this.c=c,this.z({step:c})}get totalSteps(){return this.d}set totalSteps(c){this.d=c,this.z({totalSteps:c})}get enabled(){return this.g}set enabled(c){this.g=c,this.z({enabled:c})}get busy(){return this.j}set busy(c){this.j=c,this.z({busy:c})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(c){this.k=c,this.z({ignoreFocusOut:c})}get value(){return this.l}set value(c){this.l=c,this.z({value:c})}get placeholder(){return this.m}set placeholder(c){this.m=c,this.z({placeholder:c})}get buttons(){return this.n}set buttons(c){this.n=c.slice(),this.o.clear(),c.forEach((u,n)=>{const h=u===F.QuickInputButtons.Back?-1:n;this.o.set(h,u)}),this.z({buttons:c.map((u,n)=>({...r(u),tooltip:u.tooltip,handle:u===F.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(c){this.l=c,this.q.fire(c)}_fireDidTriggerButton(c){const u=this.o.get(c);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,y.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),a.$dispose(this._id))}z(c){if(!this.v){for(const u of Object.keys(c)){const n=c[u];this.u[u]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){a.$createOrUpdate(this.u),this.u={id:this._id}}}v.a=1;function b(d){if(d instanceof F.ThemeIcon)return{id:d.id};const c=w(d),u=E(d);return{dark:typeof c=="string"?C.URI.file(c):c,light:typeof u=="string"?C.URI.file(u):u}}function E(d){return typeof d=="object"&&"light"in d?d.light:d}function w(d){return typeof d=="object"&&"dark"in d?d.dark:d}function r(d){const c=b(d.iconPath);let u,n;return"id"in c?n=D.ThemeIcon.asClassName(c):u=c,{iconPath:u,iconClass:n}}class o extends v{constructor(c,u){super(c.identifier,u),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.Emitter,this.L=[],this.M=new T.Emitter,this.N=new T.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(c){this.B=c.slice(),this.C.clear(),this.D.clear(),c.forEach((n,h)=>{this.C.set(h,n),this.D.set(n,h)});const u=[];for(let n=0;n<c.length;n++){const h=c[n];h.kind===F.QuickPickItemKind.Separator?u.push({type:"separator",label:h.label}):u.push({handle:n,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((m,P)=>({...r(m),tooltip:m.tooltip,handle:P}))})}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(c){this.E=c,this.z({canSelectMany:c})}get matchOnDescription(){return this.F}set matchOnDescription(c){this.F=c,this.z({matchOnDescription:c})}get matchOnDetail(){return this.G}set matchOnDetail(c){this.G=c,this.z({matchOnDetail:c})}get sortByLabel(){return this.H}set sortByLabel(c){this.H=c,this.z({sortByLabel:c})}get keepScrollPosition(){return this.I}set keepScrollPosition(c){this.I=c,this.z({keepScrollPosition:c})}get activeItems(){return this.J}set activeItems(c){this.J=c.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(c){this.L=c.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(c){const u=(0,k.coalesce)(c.map(n=>this.C.get(n)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(c){const u=(0,k.coalesce)(c.map(n=>this.C.get(n)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(c,u){const n=this.C.get(c);if(!n||!n.buttons||!n.buttons.length)return;const h=n.buttons[u];h&&this.N.fire({button:h,item:n})}}class s extends v{constructor(c,u){super(c.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(c){this.B=c,this.z({password:c})}get prompt(){return this.C}set prompt(c){this.C=c,this.z({prompt:c})}get valueSelection(){return this.D}set valueSelection(c){this.D=c,this.z({valueSelection:c})}get validationMessage(){return this.E}set validationMessage(c){this.E=c,c?typeof c=="string"?this.z({validationMessage:c,severity:N.default.Error}):this.z({validationMessage:c.message,severity:c.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new l(f,t)}e.createExtHostQuickOpen=g});var Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i};define(Ce[219],ke([1,0,2,4,61,7,14,5,16,122,12,25,65,8,26]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f){"use strict";var t,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(h){if(h)return typeof h.iconPath=="string"?i.URI.file(h.iconPath):i.URI.isUri(h.iconPath)||g.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function v(h,m){if(!h.iconPath&&!m.iconPath)return 0;if(h.iconPath){if(!m.iconPath)return 1}else return-1;const P=typeof h.iconPath=="string"?h.iconPath:i.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,M=typeof m.iconPath=="string"?m.iconPath:i.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,k.comparePaths)(P,M)}function b(h,m){let P=0;if(h.strikeThrough!==m.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==m.faded)return h.faded?1:-1;if(h.tooltip!==m.tooltip)return(h.tooltip||"").localeCompare(m.tooltip||"");if(P=v(h,m),P!==0)return P;if(h.light&&m.light)P=v(h.light,m.light);else{if(h.light)return 1;if(m.light)return-1}if(P!==0)return P;if(h.dark&&m.dark)P=v(h.dark,m.dark);else{if(h.dark)return 1;if(m.dark)return-1}return P}function E(h,m){if(h.command!==m.command)return h.command<m.command?-1:1;if(h.title!==m.title)return h.title<m.title?-1:1;if(h.tooltip!==m.tooltip){if(h.tooltip!==void 0&&m.tooltip!==void 0)return h.tooltip<m.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(h.arguments===m.arguments)return 0;if(h.arguments)if(m.arguments){if(h.arguments.length!==m.arguments.length)return h.arguments.length-m.arguments.length}else return 1;else return-1;for(let P=0;P<h.arguments.length;P++){const M=h.arguments[P],V=m.arguments[P];if(M!==V)return M<V?-1:1}return 0}function w(h,m){let P=(0,k.comparePaths)(h.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(P!==0)return P;if(h.command&&m.command)P=E(h.command,m.command);else{if(h.command)return 1;if(m.command)return-1}if(P!==0)return P;if(h.decorations&&m.decorations)P=b(h.decorations,m.decorations);else{if(h.decorations)return 1;if(m.decorations)return-1}return P}function r(h,m){for(let P=0;P<h.length;P++)if(h[P]!==m[P])return!1;return!0}function o(h,m){return h.command===m.command&&h.title===m.title&&h.tooltip===m.tooltip&&(h.arguments&&m.arguments?r(h.arguments,m.arguments):h.arguments===m.arguments)}function s(h,m){return(0,S.equals)(h,m,o)}class d{get value(){return this.d}set value(m){m=m??"",Oe(this,t,"f").$setInputBoxValue(this.l,m),this.m(m)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(m){Oe(this,t,"f").$setInputBoxPlaceholder(this.l,m),this.f=m}get validateInput(){return(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(m){if((0,f.checkProposedApiEnabled)(this.k,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=m,Oe(this,t,"f").$setValidationProviderIsEnabled(this.l,!!m)}get enabled(){return this.h}set enabled(m){m=!!m,this.h!==m&&(this.h=m,Oe(this,t,"f").$setInputBoxEnablement(this.l,m))}get visible(){return this.j}set visible(m){m=!!m,this.j!==m&&(this.j=m,Oe(this,t,"f").$setInputBoxVisibility(this.l,m))}constructor(m,P,M){this.k=m,this.l=M,t.set(this,void 0),this.d="",this.e=new T.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,t,P,"f")}showValidationMessage(m,P){(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),Oe(this,t,"f").$showValidationMessage(this.l,m,P)}$onInputBoxValueChange(m){this.m(m)}m(m){this.d=m,this.e.fire(m)}}e.ExtHostSCMInputBox=d,t=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(m){this.v=m,this.q.$updateGroupLabel(this.t,this.handle,m)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(m){this.p=m,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(m){this.f=[...m],this.k.fire()}constructor(m,P,M,V,Z){this.q=m,this.s=P,this.t=M,this.u=V,this.v=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(m){return this.g.get(m)}$executeResourceCommand(m,P){const M=this.h.get(m);return M?(0,C.asPromise)(()=>this.s.executeCommand(M.command,...M.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this.f].sort(w),M=(0,S.sortedDiff)(this.o,m,w).map(G=>{const R=G.toInsert.map(A=>{const O=this.e++;this.g.set(O,A);const B=A.resourceUri;let z;if(A.command)if(A.command.command==="vscode.open"||A.command.command==="vscode.diff"){const le=new L.DisposableStore;z=this.s.converter.toInternal(A.command,le),this.j.set(O,le)}else this.h.set(O,A.command);const j=l(A.decorations),K=A.decorations&&l(A.decorations.light)||j,ie=A.decorations&&l(A.decorations.dark)||j,me=[K,ie],ue=A.decorations&&A.decorations.tooltip||"",oe=A.decorations&&!!A.decorations.strikeThrough,De=A.decorations&&!!A.decorations.faded,re=A.contextValue||"";return{rawResource:[O,B,me,ue,oe,De,re,z],handle:O}});return{start:G.start,deleteCount:G.deleteCount,toInsert:R}}),V=M.map(({start:G,deleteCount:R,toInsert:A})=>[G,R,A.map(O=>O.rawResource)]),Z=M.reverse();for(const{start:G,deleteCount:R,toInsert:A}of Z){const O=A.map(z=>z.handle),B=this.n.splice(G,R,...O);for(const z of B)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=m,V}dispose(){this.l=!0,this.m.fire()}}c.d=0;class u{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(m){this.g!==m&&(this.g=m,Oe(this,a,"f").$updateSourceControl(this.t,{count:m}))}get quickDiffProvider(){return this.h}set quickDiffProvider(m){this.h=m,Oe(this,a,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this.j}set commitTemplate(m){m!==this.j&&(this.j=m,Oe(this,a,"f").$updateSourceControl(this.t,{commitTemplate:m}))}get acceptInputCommand(){return this.l}set acceptInputCommand(m){this.k.value=new L.DisposableStore,this.l=m;const P=this.v.converter.toInternal(m,this.k.value);Oe(this,a,"f").$updateSourceControl(this.t,{acceptInputCommand:P})}get actionButton(){return(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(m){(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new L.DisposableStore,this.n=m;const P=m!==void 0?{command:this.v.converter.toInternal(m.command,this.m.value),secondaryCommands:m.secondaryCommands?.map(M=>M.map(V=>this.v.converter.toInternal(V,this.m.value))),description:m.description,enabled:m.enabled}:void 0;Oe(this,a,"f").$updateSourceControl(this.t,{actionButton:P??null})}get statusBarCommands(){return this.p}set statusBarCommands(m){if(this.p&&m&&s(this.p,m))return;this.o.value=new L.DisposableStore,this.p=m;const P=(m||[]).map(M=>this.v.converter.toInternal(M,this.o.value));Oe(this,a,"f").$updateSourceControl(this.t,{statusBarCommands:P})}get selected(){return this.q}constructor(m,P,M,V,Z,G){this.u=m,this.v=M,this.w=V,this.x=Z,this.y=G,a.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.MutableDisposable,this.l=void 0,this.m=new L.MutableDisposable,this.o=new L.MutableDisposable,this.p=void 0,this.q=!1,this.s=new T.Emitter,this.onDidChangeSelection=this.s.event,this.t=u.d++,this.z=new Map,this.A=new Set,Je(this,a,P,"f"),this.f=new d(m,Oe(this,a,"f"),this.t),Oe(this,a,"f").$registerSourceControl(this.t,V,Z,G)}createResourceGroup(m,P){const M=new c(Oe(this,a,"f"),this.v,this.t,m,P),V=T.Event.once(M.onDidDispose)(()=>this.z.delete(M));return this.z.set(M,V),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const m=[],P=[];for(const[M,V]of this.z){V.dispose();const Z=M.onDidUpdateResourceStates(()=>{this.A.add(M),this.eventuallyUpdateResourceStates()});T.Event.once(M.onDidDispose)(()=>{this.A.delete(M),Z.dispose(),this.e.delete(M.handle),Oe(this,a,"f").$unregisterGroup(this.t,M.handle)}),m.push([M.handle,M.id,M.label,M.features]);const G=M._takeResourceStateSnapshot();G.length>0&&P.push([M.handle,G]),this.e.set(M.handle,M)}Oe(this,a,"f").$registerGroups(this.t,m,P),this.z.clear()}eventuallyUpdateResourceStates(){const m=[];this.A.forEach(P=>{const M=P._takeResourceStateSnapshot();M.length!==0&&m.push([P.handle,M])}),m.length>0&&Oe(this,a,"f").$spliceResourceStates(this.t,m),this.A.clear()}getResourceGroup(m){return this.e.get(m)}setSelectionState(m){this.q=m,this.s.fire(m)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(m=>m.dispose()),Oe(this,a,"f").$unregisterSourceControl(this.t)}}a=new WeakMap,u.d=0,qe([(0,y.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),qe([(0,y.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let n=class nn{get onDidChangeActiveProvider(){return this.j.event}constructor(m,P,M){this.l=P,this.m=M,this.g=new Map,this.h=new Map,this.j=new T.Emitter,this.e=m.getProxy(F.MainContext.MainThreadSCM),this.f=m.getProxy(F.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const Z=this.g.get(V.sourceControlHandle);if(!Z)return V;const G=Z.getResourceGroup(V.groupHandle);return G?G.getResourceState(V.handle):V}else if(V&&V.$mid===4){const Z=this.g.get(V.sourceControlHandle);return Z?Z.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const Z=this.g.get(V.handle);return Z||V}return V}})}createSourceControl(m,P,M,V){this.m.trace("ExtHostSCM#createSourceControl",m.identifier.value,P,M,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const Z=nn.d++,G=new u(m,this.e,this.l,P,M,V);this.g.set(Z,G);const R=this.h.get(D.ExtensionIdentifier.toKey(m.identifier))||[];return R.push(G),this.h.set(D.ExtensionIdentifier.toKey(m.identifier),R),G}getLastInputBox(m){this.m.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const P=this.h.get(D.ExtensionIdentifier.toKey(m.identifier)),M=P&&P[P.length-1];return M&&M.inputBox}$provideOriginalResource(m,P,M){const V=i.URI.revive(P);this.m.trace("ExtHostSCM#$provideOriginalResource",m,V.toString());const Z=this.g.get(m);return!Z||!Z.quickDiffProvider||!Z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>Z.quickDiffProvider.provideOriginalResource(V,M)).then(G=>G||null)}$onInputBoxValueChange(m,P){this.m.trace("ExtHostSCM#$onInputBoxValueChange",m);const M=this.g.get(m);return M&&M.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(m,P,M,V){this.m.trace("ExtHostSCM#$executeResourceCommand",m,P,M);const Z=this.g.get(m);if(!Z)return Promise.resolve(void 0);const G=Z.getResourceGroup(P);return G?G.$executeResourceCommand(M,V):Promise.resolve(void 0)}$validateInput(m,P,M){this.m.trace("ExtHostSCM#$validateInput",m);const V=this.g.get(m);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>V.inputBox.validateInput(P,M)).then(Z=>{if(!Z)return Promise.resolve(void 0);const G=p.MarkdownString.fromStrict(Z.message);return G?Promise.resolve([G,Z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this.g.get(m)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=m,Promise.resolve(void 0)}};n.d=0,n=qe([je(2,N.ILogService)],n),e.ExtHostSCM=n}),define(Ce[76],ke([1,0,5,4,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(F){this.b=new T.Emitter,this.onDidChangePassword=this.b.event,this.a=F.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(F){this.b.fire(F)}get(F,S){return this.a.$getPassword(F,S)}store(F,S,k){return this.a.$setPassword(F,S,k)}delete(F,S){return this.a.$deletePassword(F,S)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[220],ke([1,0,6,5,137,7,8,9]),function(ee,e,i,T,y,L,C,F){"use strict";var S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(f,t,a,l,v=i.StatusBarAlignment.Left,b){S.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new L.DisposableStore,Je(this,S,f,"f"),Je(this,k,t,"f"),this.c=N.a++,this.e=a,this.f=l,this.g=v,this.h=this.t(b)}t(f){if(!!(0,F.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(f){this.k=f,this.u()}set name(f){this.m=f,this.u()}set tooltip(f){this.l=f,this.u()}set color(f){this.n=f,this.u()}set backgroundColor(f){f&&!N.b.has(f.id)&&(f=void 0),this.o=f,this.u()}set command(f){this.q?.fromApi!==f&&(this.p.clear(),typeof f=="string"?this.q={fromApi:f,internal:Oe(this,k,"f").toInternal({title:"",command:f},this.p)}:f?this.q={fromApi:f,internal:Oe(this,k,"f").toInternal(f,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(f){this.s=f,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Oe(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let t;this.m?t=this.m:t=(0,y.localize)(0,null,this.e.displayName||this.e.name);let a=this.n;this.o&&(a=N.b.get(this.o.id));const l=C.MarkdownString.fromStrict(this.l);Oe(this,S,"f").$setEntry(this.c,f,t,this.k,l,this.q?.internal,a,this.o,this.g===i.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=N,S=new WeakMap,k=new WeakMap,N.a=0,N.b=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class D{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,y.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const t={message:f};return this.b.unshift(t),this.c(),new i.Disposable(()=>{const a=this.b.indexOf(t);a>=0&&(this.b.splice(a,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class g{constructor(f,t){this.a=f.getProxy(T.MainContext.MainThreadStatusBar),this.b=t,this.c=new D(this)}createStatusBarEntry(f,t,a,l){return new N(this.a,this.b,f,t,a,l)}setStatusBarMessage(f,t){const a=this.c.setMessage(f);let l;return typeof t=="number"?l=setTimeout(()=>a.dispose(),t):typeof t<"u"&&t.then(()=>a.dispose(),()=>a.dispose()),new i.Disposable(()=>{a.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=g}),define(Ce[77],ke([1,0,5,4,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(F,S){this.c=S,this.b=new T.Emitter,this.onDidChangeStorage=this.b.event,this.a=F.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(F,S){this.a.$registerExtensionStorageKeysToSync(F,S)}async initializeExtensionStorage(F,S,k){const N=await this.a.$initializeExtensionStorage(F,S);let D;return N&&(D=this.d(F,S,N)),D||k}setValue(F,S,k){return this.a.$setValue(F,S,k)}$acceptValue(F,S,k){const N=this.d(F,S,k);N&&this.b.fire({shared:F,key:S,value:N})}d(F,S,k){try{return JSON.parse(k)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${F}): ${N}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(Ce[78],ke([1,0,3,27,12,58,2]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let F=class{constructor(k,N,D){this.d=N,this.f=D,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(g=>this.c=g)}async g(k){return C.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,N=await this.g(k);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(C.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(k){if(this.c)return C.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return C.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};F=qe([je(0,T.IExtHostInitDataService),je(1,y.ILogService),je(2,L.IExtHostConsumerFileSystem)],F),e.ExtensionStoragePaths=F}),define(Ce[59],ke([1,0,4,5,3,2,15,7,6,138,11,176,20,34,162,65,9,14,8]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class b{constructor(n,h,m,P){this.k=n,this._id=h,this.l=m,this.m=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const M=this;this.value={get name(){return M.m||""},get processId(){return M.b},get creationOptions(){return M.l},get exitStatus(){return M.h},get state(){return M.j},sendText(V,Z=!0){M.o(),M.k.$sendText(M._id,V,Z)},show(V){M.o(),M.k.$show(M._id,V)},hide(){M.o(),M.k.$hide(M._id)},dispose(){M.a||(M.a=!0,M.k.$dispose(M._id))},get dimensions(){if(!(M.d===void 0||M.g===void 0))return{columns:M.d,rows:M.g}}}}async create(n,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,a.withNullAsUndefined)(n.shellPath),shellArgs:(0,a.withNullAsUndefined)(n.shellArgs),cwd:(0,a.withNullAsUndefined)(n.cwd),env:(0,a.withNullAsUndefined)(n.env),icon:(0,a.withNullAsUndefined)(d(n.iconPath)),color:t.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,a.withNullAsUndefined)(n.message),strictEnv:(0,a.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,a.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,a.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,a.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this.n(n.location,h?.resolvedExtHostIdentifier),isTransient:(0,a.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,h,m,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:m,color:t.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.n(n,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,h){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in n?{viewColumn:v.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,h){this.h=Object.freeze({code:n,reason:h})}setDimensions(n,h){return n===this.d&&h===this.g||n===0||h===0?!1:(this.d=n,this.g=h,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(h=>{h!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=b;class E{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new i.Emitter,this.onProcessData=this.a.event,this.b=new i.Emitter,this.d=new i.Emitter,this.onDidChangeProperty=this.d.event,this.f=new i.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${h}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,h){this.g.setDimensions?.({columns:n,rows:h})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(h=>this.a.fire(h)),this.g.onDidClose?.((h=void 0)=>{this.f.fire(h===void 0?void 0:h)}),this.g.onDidOverrideDimensions?.(h=>{h&&this.d.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this.g.onDidChangeName?.(h=>{this.d.fire({type:"title",value:h})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let w=1,r=class extends F.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,h){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new i.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new i.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new i.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new i.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new i.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new i.Emitter,this.onDidChangeShell=this.J.event,this.a=h.getProxy(T.MainContext.MainThreadTerminalService),this.s=new f.TerminalDataBufferer(this.a.$sendProcessData),this.I=new i.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[m,P]of this.g)P.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,h){const m=new b(this.a,(0,p.generateUuid)(),n,n.name),P=new E(n.pty);return m.createExtensionTerminal(n.location,this.L(n,h).resolvedExtHostIdentifier,d(n.iconPath),c(n.color)).then(M=>{const V=this.M(M,P);this.h[M]=V}),this.f.push(m),m.value}L(n,h){if(h=h||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const m=n.location.parentTerminal;if(m){const P=this.f.find(M=>M.value===m);P&&(h.resolvedExtHostIdentifier=P._id)}}else n.location&&typeof n.location!="object"?h.location=n.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(n,h){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const P=new E(h),M=this.M(n,P);this.h[n]=M}async $acceptActiveTerminalChanged(n){const h=this.b;if(n===null){this.b=void 0,h!==this.b&&this.F.fire(this.b);return}const m=this.O(n);m&&(this.b=m,h!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,h){const m=this.O(n);m&&this.I.fire({terminal:m.value,data:h})}async $acceptTerminalDimensions(n,h,m){const P=this.O(n);P&&P.setDimensions(h,m)&&this.G.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptTerminalMaximumDimensions(n,h,m){this.g.get(n)?.resize(h,m)}async $acceptTerminalTitleChange(n,h){const m=this.O(n);m&&(m.name=h)}async $acceptTerminalClosed(n,h,m){const P=this.Q(this.f,n);if(P!==null){const M=this.f.splice(P,1)[0];M.setExitStatus(h,m),this.C.fire(M.value)}}$acceptTerminalOpened(n,h,m,P){if(h){const Z=this.Q(this.f,h);if(Z!==null){this.f[Z]._id=n,this.D.fire(this.terminals[Z]),this.f[Z].isOpen=!0;return}}const M={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},V=new b(this.a,n,M,m);this.f.push(V),this.D.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(n,h){this.O(n)?._setProcessId(h)}async $startExtensionTerminal(n,h){const m=this.O(n);if(!m)return{message:(0,k.localize)(0,null,n)};m.isOpen||await new Promise(M=>{const V=this.onDidOpenTerminal(async Z=>{Z===m.value&&(V.dispose(),M())})});const P=this.g.get(n);P?P.startSendingEvents(h):this.j[n]={initialDimensions:h}}M(n,h){const m=new F.DisposableStore;m.add(h.onProcessReady(M=>this.a.$sendProcessReady(n,M.pid,M.cwd))),m.add(h.onDidChangeProperty(M=>this.a.$sendProcessProperty(n,M))),this.s.startBuffering(n,h.onProcessData),m.add(h.onProcessExit(M=>this.N(n,M))),this.g.set(n,h);const P=this.j[n];return P&&h instanceof E&&(h.startSendingEvents(P.initialDimensions),delete this.j[n]),m}$acceptProcessAckDataEvent(n,h){this.g.get(n)?.acknowledgeDataEvent(h)}$acceptProcessInput(n,h){this.g.get(n)?.input(h)}$acceptTerminalInteraction(n){const h=this.O(n);h?.setInteractedWith()&&this.H.fire(h.value)}$acceptProcessResize(n,h,m){try{this.g.get(n)?.resize(h,m)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(n,h){this.g.get(n)?.shutdown(h)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(h=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(h=>this.a.$sendProcessProperty(n,{type:"cwd",value:h}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,h,m){if(this.v.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this.v.set(h,m),this.a.$registerProfileProvider(h,n.identifier.value),new S.Disposable(()=>{this.v.delete(h),this.a.$unregisterProfileProvider(h)})}registerTerminalQuickFixProvider(n,h,m){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,m),this.a.$registerQuickFixProvider(n,h),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,h){const m=new g.CancellationTokenSource().token;if(m.isCancellationRequested)return;const P=this.w.get(n);if(!P)return;const M=await P.provideTerminalQuickFixes(h,m);if(M!==null)return M}async $createContributedProfileTerminal(n,h){const m=new g.CancellationTokenSource().token;let P=await this.v.get(n)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,h);return}this.createTerminalFromOptions(P.options,h)}}async $provideLinks(n,h){const m=this.O(n);if(!m)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const M=new g.CancellationTokenSource;this.z.set(n,M);const V=[],Z={terminal:m.value,line:h},G=[];for(const O of this.u)G.push(l.Promises.withAsyncBody(async B=>{M.token.onCancellationRequested(()=>B({provider:O,links:[]}));const z=await O.provideTerminalLinks(Z,M.token)||[];M.token.isCancellationRequested||B({provider:O,links:z})}));const R=await Promise.all(G);if(M.token.isCancellationRequested)return[];const A=new Map;for(const O of R)O&&O.links.length>0&&V.push(...O.links.map(B=>{const z={id:w++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return A.set(z.id,{provider:O.provider,link:B}),z}));return this.y.set(n,A),V}$activateLink(n,h){const m=this.y.get(n)?.get(h);!m||m.provider.handleTerminalLink(m.link)}N(n,h){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const m=this.h[n];m&&(m.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,h)}O(n){return this.P(this.f,n)}P(n,h){const m=this.Q(n,h);return m!==null?n[m]:null}Q(n,h){let m=null;return n.some((P,M)=>P._id===h?(m=M,!0):!1),m}getEnvironmentVariableCollection(n){let h=this.l.get(n.identifier.value);return h||(h=new o,this.S(n.identifier.value,h)),h}R(n,h){const m=(0,D.serializeEnvironmentVariableCollection)(h.map);this.a.$setEnvironmentVariableCollection(n,h.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(n){n.forEach(h=>{const m=h[0],P=new o(h[1]);this.S(m,P)})}$acceptDefaultProfile(n,h){const m=this.m;this.m=n,this.n=h,m?.path!==n.path&&this.J.fire(n.path)}S(n,h){this.l.set(n,h),h.onDidChangeCollection(()=>{this.R(n,h)})}};r=qe([je(1,C.IExtHostRpcService)],r),e.BaseExtHostTerminalService=r;class o{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new i.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,h){this.d(n,{value:h,type:S.EnvironmentVariableMutatorType.Replace})}append(n,h){this.d(n,{value:h,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,h){this.d(n,{value:h,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,h){const m=this.map.get(n);(!m||m.value!==h.value||m.type!==h.type)&&(this.map.set(n,h),this.b.fire())}get(n){return this.map.get(n)}forEach(n,h){this.map.forEach((m,P)=>n.call(h,P,m,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let s=class extends r{constructor(n){super(!1,n)}createTerminal(n,h,m){throw new N.NotSupportedError}createTerminalFromOptions(n,h){throw new N.NotSupportedError}};s=qe([je(0,C.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function d(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function c(u){return t.ThemeColor.isThemeColor(u)?u:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i};define(Ce[221],ke([1,0,16,14,24,20,4,185,222,7,23,9,34,5,15,99,8,6,42,68,54]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a,l,v,b,E){"use strict";var w,r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(A,O,B){this.j=B,this.c=new C.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=A.getProxy(p.MainContext.MainThreadTesting),this.h=new V(this.f),this.g=new u(this.f),O.registerArgumentProcessor({processArgument:z=>{if(z?.$mid!==15)return z;const j=z,K=j.tests[j.tests.length-1].item.extId;return this.d.get(v.TestId.root(K))?.collection.tree.get(K)?.actual??(0,t.toItemFromContext)(z)}})}createTestController(A,O,B){if(this.d.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const z=new k.DisposableStore,j=z.add(new t.ExtHostTestItemCollection(A,O,this.j));j.root.label=O;const K=new Map,ie=this.f,me={items:j.root.children,get label(){return O},set label(oe){O=oe,j.root.label=oe,ie.$updateController(A,{label:O})},get refreshHandler(){return B},set refreshHandler(oe){B=oe,ie.$updateController(A,{canRefresh:!!oe})},get id(){return A},createRunProfile:(oe,De,re,_,le)=>{let Ee=(0,S.hash)(oe);for(;K.has(Ee);)Ee++;return new Z(this.f,K,A,Ee,oe,De,re,_,le)},createTestItem(oe,De,re){return new t.TestItemImpl(A,oe,De,re)},createTestRun:(oe,De,re=!0)=>this.g.createTestRun(A,j,oe,De,re),set resolveHandler(oe){j.resolveHandler=oe},get resolveHandler(){return j.resolveHandler},dispose:()=>{z.dispose()}};ie.$registerTestController(A,O,!!B),z.add((0,k.toDisposable)(()=>ie.$unregisterTestController(A)));const ue={controller:me,collection:j,profiles:K};return this.d.set(A,ue),z.add((0,k.toDisposable)(()=>this.d.delete(A))),z.add(j.onDidGenerateDiff(oe=>ie.$publishDiff(A,oe.map(E.TestsDiffOp.serialize)))),me}createTestObserver(){return this.h.checkout()}async runTests(A,O=L.CancellationToken.None){const B=n(A);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.d.get(B.controllerId);if(!z)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:A.include?.map(j=>v.TestId.fromExtHostTestItem(j,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:G[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:A.exclude?.map(j=>j.id)},O)}$syncTests(){for(const{collection:A}of this.d.values())A.flushDiff();return Promise.resolve()}$provideFileCoverage(A,O,B){return(0,i.mapFind)(this.g.trackers,j=>j.id===A?j.getCoverage(O):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(A,O,B,z){return(0,i.mapFind)(this.g.trackers,K=>K.id===A?K.getCoverage(O):void 0)?.resolveFileCoverage(B,z)??Promise.resolve([])}$configureRunProfile(A,O){this.d.get(A)?.profiles.get(O)?.configureHandler?.()}async $refreshTests(A,O){await this.d.get(A)?.controller.refreshHandler?.(O)}$publishTestResults(A){this.results=Object.freeze(A.map(O=>(0,N.deepFreeze)(a.TestResults.to(O))).concat(this.results).sort((O,B)=>B.completedAt-O.completedAt).slice(0,32)),this.c.fire()}async $expandTest(A,O){const B=this.d.get(v.TestId.fromString(A).controllerId)?.collection;B&&(await B.expand(A,O<0?1/0:O),B.flushDiff())}$acceptDiff(A){this.h.applyDiff(A.map(E.TestsDiffOp.deserialize))}async $runControllerTests(A,O){return Promise.all(A.map(B=>this.runControllerTestRequest(B,O)))}async runControllerTestRequest(A,O){const B=this.d.get(A.controllerId);if(!B)return{};const{collection:z,profiles:j}=B,K=j.get(A.profileId);if(!K)return{};const ie=A.testIds.map(De=>z.tree.get(De)).filter(D.isDefined),me=A.excludeExtIds.map(De=>B.collection.tree.get(De)).filter(D.isDefined).filter(De=>ie.some(re=>re.fullId.compare(De.fullId)===2));if(!ie.length)return{};const ue=new l.TestRunRequest(ie.some(De=>De.actual instanceof t.TestItemRootImpl)?void 0:ie.map(De=>De.actual),me.map(De=>De.actual),K),oe=this.g.prepareForMainThreadTestRun(ue,h.fromInternal(A,B.collection),O);try{return await K.runHandler(ue,O),{}}catch(De){return{error:String(De)}}finally{oe.hasRunningTasks&&!O.isCancellationRequested&&await C.Event.toPromise(oe.onEnd),oe.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.g.cancelAllRuns():this.g.cancelRunById(A)}};o=qe([je(0,f.IExtHostRpcService)],o),e.ExtHostTesting=o;const s=1e4;var d;(function(R){R[R.Running=0]="Running",R[R.Cancelling=1]="Cancelling",R[R.Ended=2]="Ended"})(d||(d={}));class c extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(A,O,B){super(),this.k=A,this.l=O,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new C.Emitter),this.onEnd=this.j.event,this.h=this.B(new L.CancellationTokenSource(B));const z=this.B(new T.RunOnceScheduler(()=>this.m(),s));this.B(this.h.token.onCancellationRequested(()=>z.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(A){return this.f.get(A)?.coverage}createRun(A){const O=this.k.id,B=this.k.controllerId,z=(0,g.generateUuid)(),j=new m(this.l,O,z),K=oe=>(De,...re)=>{if(me){console.warn(`Setting the state of test "${De.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(De)||(this.s(De),oe(De,...re))},ie=(oe,De)=>{const re=De instanceof Array?De.map(a.TestMessage.from):[a.TestMessage.from(De)];if(oe.uri&&oe.range){const _={range:a.Range.from(oe.range),uri:oe.uri};for(const le of re)le.location=le.location||_}this.l.$appendTestMessagesInRun(O,z,v.TestId.fromExtHostTestItem(oe,B).toString(),re)};let me=!1;const ue={isPersisted:this.k.isPersisted,token:this.h.token,name:A,get coverageProvider(){return j.coverageProvider},set coverageProvider(oe){j.coverageProvider=oe},enqueued:K(oe=>{this.l.$updateTestStateInRun(O,z,v.TestId.fromExtHostTestItem(oe,B).toString(),1)}),skipped:K(oe=>{this.l.$updateTestStateInRun(O,z,v.TestId.fromExtHostTestItem(oe,B).toString(),5)}),started:K(oe=>{this.l.$updateTestStateInRun(O,z,v.TestId.fromExtHostTestItem(oe,B).toString(),2)}),errored:K((oe,De,re)=>{ie(oe,De),this.l.$updateTestStateInRun(O,z,v.TestId.fromExtHostTestItem(oe,B).toString(),6,re)}),failed:K((oe,De,re)=>{ie(oe,De),this.l.$updateTestStateInRun(O,z,v.TestId.fromExtHostTestItem(oe,B).toString(),4,re)}),passed:K((oe,De)=>{this.l.$updateTestStateInRun(O,z,v.TestId.fromExtHostTestItem(oe,this.k.controllerId).toString(),3,De)}),appendOutput:(oe,De,re)=>{me||(re&&(this.k.isIncluded(re)?this.s(re):re=void 0),this.l.$appendOutputToRun(O,z,y.VSBuffer.fromString(oe),De&&a.location.from(De),re&&v.TestId.fromExtHostTestItem(re,B).toString()))},end:()=>{me||(me=!0,this.l.$finishedTestRunTask(O,z),this.f.delete(z),this.f.size||this.p())}};return this.f.set(z,{run:ue,coverage:j}),this.l.$startedTestRunTask(O,{id:z,name:A,running:!0}),ue}m(){for(const{run:A}of this.f.values())A.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(A){if(!(A instanceof t.TestItemImpl))throw new b.InvalidTestItemError(A.id);if(this.g.has(v.TestId.fromExtHostTestItem(A,this.k.controllerId).toString()))return;const O=[],B=this.k.colllection.root;for(;;){const z=a.TestItem.from(A);if(O.unshift(z),this.g.has(z.extId)||(this.g.add(z.extId),A===B))break;A=A.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,O)}}class u{get trackers(){return this.c.values()}constructor(A){this.d=A,this.c=new Map}prepareForMainThreadTestRun(A,O,B){return this.f(A,O,B)}cancelRunById(A){for(const O of this.c.values())if(O.id===A){O.cancel();return}}cancelAllRuns(){for(const A of this.c.values())A.cancel()}createTestRun(A,O,B,z,j){const K=this.c.get(B);if(K)return K.createRun(z);const ie=h.fromPublic(A,O,B,j),me=n(B);this.d.$startedExtensionTestRun({controllerId:A,profile:me&&{group:G[me.kind],id:me.profileId},exclude:B.exclude?.map(oe=>v.TestId.fromExtHostTestItem(oe,O.root.id).toString())??[],id:ie.id,include:B.include?.map(oe=>v.TestId.fromExtHostTestItem(oe,O.root.id).toString())??[O.root.id],persist:j});const ue=this.f(B,ie);return ue.onEnd(()=>{this.d.$finishedExtensionTestRun(ie.id),ue.dispose()}),ue.createRun(z)}f(A,O,B){const z=new c(O,this.d,B);return this.c.set(A,z),z.onEnd(()=>this.c.delete(A)),z}}e.TestRunCoordinator=u;const n=R=>{if(!!R.profile){if(!(R.profile instanceof Z))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class h{static fromPublic(A,O,B,z){return new h(A,(0,g.generateUuid)(),B.include?.map(j=>v.TestId.fromExtHostTestItem(j,A).toString())??[A],B.exclude?.map(j=>v.TestId.fromExtHostTestItem(j,A).toString())??[],z,O)}static fromInternal(A,O){return new h(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,O)}constructor(A,O,B,z,j,K){this.controllerId=A,this.id=O,this.isPersisted=j,this.colllection=K,this.c=B.map(ie=>ie+"\0"),this.d=z.map(ie=>ie+"\0")}isIncluded(A){const O=v.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const B of this.d)if(O===B||O.startsWith(B))return!1;for(const B of this.c)if(O===B||O.startsWith(B))return!0;return!1}}e.TestRunDto=h;class m{set coverageProvider(A){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this.c=A,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(A,O,B){this.f=A,this.g=O,this.h=B}async provideFileCoverage(A){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(A))());try{return(await this.d)?.map(a.TestCoverage.fromFile)??[]}catch(O){throw this.d=void 0,O}}async resolveFileCoverage(A,O){const B=await this.d;let z=B?.[A];return!this.c||!B||!z?[]:(z.detailedCoverage||(z=B[A]=await this.c.resolveFileCoverage?.(z,O)??z),z.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class P{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(A){this.h=A,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(A){this.c.add(A)}update(A){Object.assign(A.revived,a.TestItem.toPlain(A.item)),this.c.has(A)||this.d.add(A)}remove(A){if(this.c.has(A)){this.c.delete(A);return}this.d.delete(A);const O=v.TestId.parentId(A.item.extId);if(O&&this.g.has(O.toString())){this.g.add(A.item.extId);return}this.f.add(A)}getChangeEvent(){const{c:A,d:O,f:B}=this;return{get added(){return[...A].map(z=>z.revived)},get updated(){return[...O].map(z=>z.revived)},get removed(){return[...B].map(z=>z.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class M extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new C.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(A){return this.d.get(A)}getMirroredTestDataByReference(A){return this.d.get(A.id)}p(A,O){return{...A,revived:a.TestItem.toPlain(A.item),depth:O?O.depth+1:0,children:new Set}}o(){return new P(this.q)}}e.MirroredTestCollection=M;class V{constructor(A){this.d=A}checkout(){this.c||(this.c=this.f());const A=this.c;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(O=>O.revived)},dispose:(0,F.once)(()=>{--A.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(A){return this.c?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.c?.tests.apply(A)}f(){const A=new M;return this.d.$subscribeToDiffs(),{observers:0,tests:A}}}class Z{get label(){return this.d}set label(A){A!==this.d&&(this.d=A,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this.f}set isDefault(A){A!==this.f&&(this.f=A,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?a.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this.c}set configureHandler(A){A!==this.c&&(this.c=A,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}constructor(A,O,B,z,j,K,ie,me=!1,ue=void 0){this.controllerId=B,this.profileId=z,this.d=j,this.kind=K,this.runHandler=ie,this.f=me,this._tag=ue,w.set(this,void 0),r.set(this,void 0),Je(this,w,A,"f"),Je(this,r,O,"f"),O.set(z,this);const oe=G[K];if(typeof oe!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,w,"f").$publishTestRunProfile({profileId:z,controllerId:B,tag:ue?a.TestTag.namespace(this.controllerId,ue.id):null,label:j,group:oe,isDefault:me,hasConfigurationHandler:!1})}dispose(){Oe(this,r,"f")?.delete(this.profileId)&&(Je(this,r,void 0,"f"),Oe(this,w,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=Z,w=new WeakMap,r=new WeakMap;const G={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Ce[223],ke([1,0,16,4,5,100,8,6]),function(ee,e,i,T,y,L,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(N,D){this.i=D,this.a=new T.Emitter,this.b=new T.Emitter,this.c=new T.Emitter,this.d=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(y.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(g=>this.g.fire(g)),this.i.onDidChangeActiveTextEditor(g=>this.f.fire(g))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const D=this.i.allEditors();return N?D:D.map(g=>g.value)}async showTextDocument(N,D,g){let p;typeof D=="number"?p={position:C.ViewColumn.from(D),preserveFocus:g}:typeof D=="object"?p={position:C.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?C.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:p={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(N.uri,p),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,D){return new L.TextEditorDecorationType(this.h,N,D).value}$acceptEditorPropertiesChanged(N,D){const g=this.i.getEditor(N);if(!g)throw new Error("unknown text editor");if(D.options&&g._acceptOptions(D.options),D.selections){const p=D.selections.selections.map(C.Selection.to);g._acceptSelections(p)}if(D.visibleRanges){const p=i.coalesce(D.visibleRanges.map(C.Range.to));g._acceptVisibleRanges(p)}if(D.options&&this.b.fire({textEditor:g.value,options:{...D.options,lineNumbers:C.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const p=F.TextEditorSelectionChangeKind.fromValue(D.selections.source),f=D.selections.selections.map(C.Selection.to);this.a.fire({textEditor:g.value,selections:f,kind:p})}if(D.visibleRanges){const p=i.coalesce(D.visibleRanges.map(C.Range.to));this.c.fire({textEditor:g.value,visibleRanges:p})}}$acceptEditorPositionData(N){for(const D in N){const g=this.i.getEditor(D);if(!g)throw new Error("Unknown text editor");const p=C.ViewColumn.to(N[D]);g.value.viewColumn!==p&&(g._acceptViewColumn(p),this.d.fire({textEditor:g.value,viewColumn:p}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.ExtHostEditors=S}),define(Ce[224],ke([1,0,2,3,5,7,6,8,25,9]),function(ee,e,i,T,y,L,C,F,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class N{constructor(p,f){this.b=new Map,this.c=new Map,this.a=p.getProxy(y.MainContext.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(t,a)=>{if(t&&t.$mid===12)if(this.b.get(t.source)&&S.ExtensionIdentifier.equals(a,this.b.get(t.source)?.extension)){const l=t.uri===void 0?void 0:i.URI.revive(t.uri);return this.c.get(t.source)?.get(D(l))?.get(t.handle)}else return;return t}})}async $getTimeline(p,f,t,a){return this.b.get(p)?.provider.provideTimeline(i.URI.revive(f),t,a)}registerTimelineProvider(p,f,t,a){const l=new L.DisposableStore,v=this.d(f.id,a,l).bind(this);let b;f.onDidChange&&(b=f.onDidChange(w=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:f.id}),this));const E=this.c;return this.f({...f,scheme:p,onDidChange:void 0,async provideTimeline(w,r,o){r?.resetCache&&(l.clear(),E.get(f.id)?.clear());const s=await f.provideTimeline(w,r,o);if(s==null)return;const d=v(w,r);return{...s,source:f.id,items:s.items.map(d)}},dispose(){for(const w of E.values())w.get(f.id)?.clear();b?.dispose(),l.dispose()}},t)}d(p,f,t){return(a,l)=>{let v;if(l?.cacheResults){let b=this.c.get(p);b===void 0&&(b=new Map,this.c.set(p,b));const E=D(a);v=b.get(E),v===void 0&&(v=new Map,b.set(E,v))}return b=>{const{iconPath:E,...w}=b,r=`${p}|${b.id??b.timestamp}`;v?.set(r,b);let o,s,d;b.iconPath&&(E instanceof C.ThemeIcon?d={id:E.id,color:E.color}:i.URI.isUri(E)?(o=E,s=E):{light:o,dark:s}=E);let c;return C.MarkdownString.isMarkdownString(w.tooltip)?c=F.MarkdownString.from(w.tooltip):(0,k.isString)(w.tooltip)?c=w.tooltip:C.MarkdownString.isMarkdownString(w.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=F.MarkdownString.from(w.detail)):(0,k.isString)(w.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=w.detail),{...w,id:w.id??void 0,handle:r,source:p,command:b.command?f.toInternal(b.command,t):void 0,icon:o,iconDark:s,themeIcon:d,tooltip:c,accessibilityInformation:b.accessibilityInformation}}}}f(p,f){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:f}),(0,L.toDisposable)(()=>{for(const a of this.c.values())a.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=N;function D(g){return g?.toString()}}),define(Ce[225],ke([1,0,7,13,2,5]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this.c=new Map,this.b=S.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,N,D){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const g=D.schemes.find(p=>!C.a.has(p));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this.c.set(k,N),this.b.$registerUriOpener(k,D.schemes,S,D.label),(0,i.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(S,k,N){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const g=y.URI.revive(k);return D.canOpenExternalUri(g,N)}async $openUri(S,k,N){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(y.URI.revive(k.resolvedUri),{sourceUri:y.URI.revive(k.sourceUri)},N)}}e.ExtHostUriOpeners=C,C.a=new Set([T.Schemas.http,T.Schemas.https])}),define(Ce[226],ke([1,0,5,2,7,11,25]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class F{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(k,N){if(this.c.has(C.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const D=F.a++;return this.c.add(C.ExtensionIdentifier.toKey(k)),this.d.set(D,N),this.b.$registerUriHandler(D,k),(0,y.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(k)),this.d.delete(D),this.b.$unregisterUriHandler(D)})}$handleExternalUri(k,N){const D=this.d.get(k);if(!D)return Promise.resolve(void 0);try{D.handleUri(T.URI.revive(N))}catch(g){(0,L.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(k){return T.URI.revive(await this.b.$createAppUri(k))}}e.ExtHostUrls=F,F.a=0});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[60],ke([1,0,4,13,23,2,150,170,69,5]),function(ee,e,i,T,y,L,C,F,S,k){"use strict";var N,D,g,p,f,t,a,l,v,b,E,w,r;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(M,V,Z,G,R,A,O){N.set(this,void 0),D.set(this,void 0),g.set(this,void 0),p.set(this,void 0),f.set(this,void 0),t.set(this,void 0),a.set(this,""),l.set(this,void 0),v.set(this,!1),b.set(this,!1),E.set(this,void 0),w.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new i.Emitter),this._onDidDispose=Oe(this,r,"f").event,Je(this,N,M,"f"),Je(this,D,V,"f"),Je(this,l,Z,"f"),Je(this,p,G,"f"),Je(this,f,R,"f"),Je(this,t,A,"f"),Je(this,E,s(A),"f"),Je(this,w,d(A),"f"),Je(this,g,O,"f")}dispose(){Je(this,v,!0,"f"),Oe(this,r,"f").fire(),Oe(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(M){return Je(this,b,!0,"f"),(0,S.asWebviewUri)(M,Oe(this,p,"f"))}get cspSource(){const M=Oe(this,t,"f").extensionLocation;if(M.scheme===T.Schemas.https||M.scheme===T.Schemas.http){let V=M.toString();return V.endsWith("/")||(V+="/"),V+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Oe(this,a,"f")}set html(M){this.a(),Oe(this,a,"f")!==M&&(Je(this,a,M,"f"),Oe(this,w,"f")&&!Oe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(M)&&(Je(this,b,!0,"f"),Oe(this,g,"f").report("Webview vscode-resource: uris",Oe(this,t,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,D,"f").$setHtml(Oe(this,N,"f"),this.b(M)))}get options(){return this.a(),Oe(this,l,"f")}set options(M){this.a(),y.equals(Oe(this,l,"f"),M)||Oe(this,D,"f").$setOptions(Oe(this,N,"f"),n(Oe(this,t,"f"),Oe(this,f,"f"),M)),Je(this,l,M,"f")}async postMessage(M){if(Oe(this,v,"f"))return!1;const V=(0,F.serializeWebviewMessage)(M,{serializeBuffersForPostMessage:Oe(this,E,"f")});return Oe(this,D,"f").$postMessage(Oe(this,N,"f"),V.message,...V.buffers)}a(){if(Oe(this,v,"f"))throw new Error("Webview is disposed")}b(M){if(!Oe(this,w,"f"))return M;const V=Oe(this,t,"f").extensionLocation?.scheme===T.Schemas.vscodeRemote,Z=Oe(this,t,"f").extensionLocation.scheme===T.Schemas.vscodeRemote?Oe(this,t,"f").extensionLocation.authority:void 0;return M.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,R,A,O,B,z)=>{const j=L.URI.from({scheme:O||"file",path:decodeURIComponent(B)}),K=(0,S.asWebviewUri)(j,{isRemote:V,authority:Z}).toString();return`${R}${K}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,R,A,O,B,z)=>{const j=L.URI.from({scheme:O||"file",path:decodeURIComponent(B)}),K=(0,S.asWebviewUri)(j,{isRemote:V,authority:Z}).toString();return`${R}${K}${z}`})}}e.ExtHostWebview=o,N=new WeakMap,D=new WeakMap,g=new WeakMap,p=new WeakMap,f=new WeakMap,t=new WeakMap,a=new WeakMap,l=new WeakMap,v=new WeakMap,b=new WeakMap,E=new WeakMap,w=new WeakMap,r=new WeakMap;function s(P){try{const M=(0,C.normalizeVersion)((0,C.parseVersion)(P.engines.vscode));return!!M&&M.majorBase>=1&&M.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function d(P){try{const M=(0,C.normalizeVersion)((0,C.parseVersion)(P.engines.vscode));return M?M.majorBase<1||M.majorBase===1&&M.minorBase<60:!1}catch{return!1}}class c{constructor(M,V,Z,G,R){this.c=V,this.d=Z,this.e=G,this.f=R,this.b=new Map,this.a=M.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(M,V,Z){const G=this.g(M);if(G){const{message:R}=(0,F.deserializeWebviewMessage)(V,Z.value);G._onMessageEmitter.fire(R)}}$onMissingCsp(M,V){this.e.warn(`${V} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(M,V,Z){const G=new o(M,this.a,h(V),this.c,this.d,Z,this.f);return this.b.set(M,G),G._onDidDispose(()=>{this.b.delete(M)}),G}deleteWebview(M){this.b.delete(M)}g(M){return this.b.get(M)}}e.ExtHostWebviews=c;function u(P){return{id:P.identifier,location:P.extensionLocation}}e.toExtensionData=u;function n(P,M,V){return{enableCommandUris:V.enableCommandUris,enableScripts:V.enableScripts,enableForms:V.enableForms,portMapping:V.portMapping,localResourceRoots:V.localResourceRoots||m(P,M)}}e.serializeWebviewOptions=n;function h(P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots?.map(M=>L.URI.from(M))}}function m(P,M){return[...(M?.getWorkspaceFolders()||[]).map(V=>V.uri),P.extensionLocation]}}),define(Ce[227],ke([1,0,20,222,7,13,22,2,8,60,52,5,6]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(o,s){this.document=o,this.b=s,this.a=1,this.c=new N.Cache("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,s){await this.f(o).undo(),s||this.disposeBackup()}async redo(o,s){await this.f(o).redo(),s||this.disposeBackup()}disposeEdits(o){for(const s of o)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=w(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const s=this.c.get(o,0);if(!s)throw new Error("No edit found");return s}}class f{constructor(){this.a=new Map}get(o,s){return this.a.get(this.b(o,s))}add(o,s,d){const c=this.b(o,s.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${o} resource:${s.uri}`);const u=new p(s,d);return this.a.set(c,u),u}delete(o,s){const d=this.b(o,s.uri);this.a.delete(d)}b(o,s){return`${o}@@@${s}`}}var t;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(t||(t={}));class a{constructor(){this.a=new Map}addTextProvider(o,s,d){return this.b(0,o,s,d)}addCustomProvider(o,s,d){return this.b(1,o,s,d)}get(o){return this.a.get(o)}b(o,s,d,c){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:o,extension:d,provider:c}),new g.Disposable(()=>this.a.delete(s))}}class l{constructor(o,s,d,c,u){this.d=s,this.f=d,this.g=c,this.h=u,this.b=new a,this.c=new f,this.a=o.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,s,d,c){const u=new y.DisposableStore;return b(d)?(u.add(this.b.addTextProvider(s,o,d)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(o),s,c.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(o))):(u.add(this.b.addCustomProvider(s,o,d)),v(d)&&u.add(d.onDidChangeCustomDocument(n=>{const h=this.i(s,n.document.uri);if(E(n)){const m=h.addEdit(n);this.a.$onDidEdit(n.document.uri,s,m,n.label)}else this.a.$onContentChange(n.document.uri,s)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(o),s,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(o))),g.Disposable.from(u,new g.Disposable(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(o,s,d,c,u){const n=this.b.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${s}'`);const h=F.URI.revive(o),m=await n.provider.openCustomDocument(h,{backupId:d,untitledDocumentData:c?.buffer},u);let P;return v(n.provider)&&this.f&&(P=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(s,m,P),{editable:v(n.provider)}}async $disposeCustomDocument(o,s){const d=this.b.get(s);if(!d)throw new Error(`No provider found for '${s}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${s}'`);const c=F.URI.revive(o),{document:u}=this.i(s,c);this.c.delete(s,u),u.dispose()}async $resolveCustomEditor(o,s,d,c,u,n){console.log("xxxx");const h=this.b.get(d);if(!h)throw new Error(`No provider found for '${d}'`);const m=S.ViewColumn.to(u),P=this.g.createNewWebview(s,c.contentOptions,h.extension),M=this.h.createNewWebviewPanel(s,d,c.title,m,c.options,P,!0),V=F.URI.revive(o);switch(h.type){case 1:{const{document:Z}=this.i(d,V);return h.provider.resolveCustomEditor(Z,M,n)}case 0:{const Z=this.d.getDocument(V);return h.provider.resolveCustomTextEditor(Z,M,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,s,d){this.i(s,o).disposeEdits(d)}async $onMoveCustomEditor(o,s,d){const c=this.b.get(d);if(!c)throw new Error(`No provider found for '${d}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const u=this.h.getWebviewPanel(o);if(!u)throw new Error("No webview found");const n=F.URI.revive(s),h=this.d.getDocument(n);await c.provider.moveCustomTextEditor(h,u,i.CancellationToken.None)}async $undo(o,s,d,c){return this.i(s,o).undo(d,c)}async $redo(o,s,d,c){return this.i(s,o).redo(d,c)}async $revert(o,s,d){const c=this.i(s,o);await this.j(s).revertCustomDocument(c.document,d),c.disposeBackup()}async $onSave(o,s,d){const c=this.i(s,o);await this.j(s).saveCustomDocument(c.document,d),c.disposeBackup()}async $onSaveAs(o,s,d,c){const u=this.i(s,o);return this.j(s).saveCustomDocumentAs(u.document,F.URI.revive(d),c)}async $backup(o,s,d){const c=this.i(s,o),n=await this.j(s).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},d);return c.updateBackup(n),n.id}i(o,s){const d=this.c.get(o,F.URI.revive(s));if(!d)throw new Error("No custom document found");return d}j(o){const d=this.b.get(o)?.provider;if(!d||!v(d))throw new Error("Custom document is not editable");return d}}e.ExtHostCustomEditors=l;function v(r){return!!r.onDidChangeCustomDocument}function b(r){return typeof r.resolveCustomTextEditor=="function"}function E(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function w(r){const o=r.scheme===L.Schemas.file||r.scheme===L.Schemas.untitled?r.fsPath:r.toString();return(0,T.hash)(o)+""}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[228],ke([1,0,4,7,2,34,8,60,5,6]),function(ee,e,i,T,y,L,C,F,S,k){"use strict";var N,D,g,p,f,t,a,l,v,b,E,w,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends T.Disposable{constructor(u,n,h,m){super(),N.set(this,void 0),D.set(this,void 0),g.set(this,void 0),p.set(this,void 0),f.set(this,void 0),t.set(this,void 0),a.set(this,void 0),l.set(this,void 0),v.set(this,!0),b.set(this,void 0),E.set(this,!1),w.set(this,this.B(new i.Emitter)),this.onDidDispose=Oe(this,w,"f").event,r.set(this,this.B(new i.Emitter)),this.onDidChangeViewState=Oe(this,r,"f").event,Je(this,N,u,"f"),Je(this,D,n,"f"),Je(this,p,h,"f"),Je(this,g,m.viewType,"f"),Je(this,f,m.panelOptions,"f"),Je(this,l,m.viewColumn,"f"),Je(this,t,m.title,"f"),Je(this,b,m.active,"f")}dispose(){Oe(this,E,"f")||(Je(this,E,!0,"f"),Oe(this,w,"f").fire(),Oe(this,D,"f").$disposeWebview(Oe(this,N,"f")),Oe(this,p,"f").dispose(),super.dispose())}get webview(){return this.c(),Oe(this,p,"f")}get viewType(){return this.c(),Oe(this,g,"f")}get title(){return this.c(),Oe(this,t,"f")}set title(u){this.c(),Oe(this,t,"f")!==u&&(Je(this,t,u,"f"),Oe(this,D,"f").$setTitle(Oe(this,N,"f"),u))}get iconPath(){return this.c(),Oe(this,a,"f")}set iconPath(u){this.c(),Oe(this,a,"f")!==u&&(Je(this,a,u,"f"),Oe(this,D,"f").$setIconPath(Oe(this,N,"f"),y.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.c(),!(typeof Oe(this,l,"f")=="number"&&Oe(this,l,"f")<0))return Oe(this,l,"f")}get active(){return this.c(),Oe(this,b,"f")}get visible(){return this.c(),Oe(this,v,"f")}_updateViewState(u){Oe(this,E,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Je(this,b,u.active,"f"),Je(this,v,u.visible,"f"),Je(this,l,u.viewColumn,"f"),Oe(this,r,"f").fire({webviewPanel:this}))}reveal(u,n){this.c(),Oe(this,D,"f").$reveal(Oe(this,N,"f"),{viewColumn:typeof u>"u"?void 0:C.ViewColumn.from(u),preserveFocus:!!n})}c(){if(Oe(this,E,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,D=new WeakMap,g=new WeakMap,p=new WeakMap,f=new WeakMap,t=new WeakMap,a=new WeakMap,l=new WeakMap,v=new WeakMap,b=new WeakMap,E=new WeakMap,w=new WeakMap,r=new WeakMap;class s{static c(){return(0,L.generateUuid)()}constructor(u,n,h){this.g=n,this.h=h,this.e=new Map,this.f=new Map,this.d=u.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,n,h,m,P={}){const M=typeof m=="object"?m.viewColumn:m,V={viewColumn:C.ViewColumn.from(M),preserveFocus:typeof m=="object"&&!!m.preserveFocus},Z=(0,F.shouldSerializeBuffersForPostMessage)(u),G=s.c();this.d.$createWebviewPanel((0,F.toExtensionData)(u),G,n,{title:h,panelOptions:d(P),webviewOptions:(0,F.serializeWebviewOptions)(u,this.h,P),serializeBuffersForPostMessage:Z},V);const R=this.g.createNewWebview(G,P,u);return this.createNewWebviewPanel(G,n,h,M,P,R,!0)}$onDidChangeWebviewPanelViewStates(u){const n=Object.keys(u);n.sort((h,m)=>{const P=u[h],M=u[m];return P.active?1:M.active?-1:+P.visible-+M.visible});for(const h of n){const m=this.getWebviewPanel(h);if(!m)continue;const P=u[h];m._updateViewState({active:P.active,visible:P.visible,viewColumn:C.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this.e.delete(u),this.g.deleteWebview(u)}registerWebviewPanelSerializer(u,n,h){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:h,extension:u}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,F.shouldSerializeBuffersForPostMessage)(u)}),new k.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(u,n,h,m){const P=this.f.get(n);if(!P)throw new Error(`No serializer found for '${n}'`);const{serializer:M,extension:V}=P,Z=this.g.createNewWebview(u,h.webviewOptions,V),G=this.createNewWebviewPanel(u,n,h.title,m,h.panelOptions,Z,h.active);await M.deserializeWebviewPanel(G,h.state)}createNewWebviewPanel(u,n,h,m,P,M,V){const Z=new o(u,this.d,M,{viewType:n,title:h,viewColumn:m,panelOptions:P,active:V});return this.e.set(u,Z),Z}getWebviewPanel(u){return this.e.get(u)}}e.ExtHostWebviewPanels=s;function d(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[229],ke([1,0,4,7,60,8,5,6]),function(ee,e,i,T,y,L,C,F){"use strict";var S,k,N,D,g,p,f,t,a,l,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends T.Disposable{constructor(r,o,s,d,c,u){super(),S.set(this,void 0),k.set(this,void 0),N.set(this,void 0),D.set(this,void 0),g.set(this,!1),p.set(this,void 0),f.set(this,void 0),t.set(this,void 0),a.set(this,void 0),l.set(this,this.B(new i.Emitter)),this.onDidChangeVisibility=Oe(this,l,"f").event,v.set(this,this.B(new i.Emitter)),this.onDidDispose=Oe(this,v,"f").event,Je(this,N,s,"f"),Je(this,f,d,"f"),Je(this,S,r,"f"),Je(this,k,o,"f"),Je(this,D,c,"f"),Je(this,p,u,"f")}dispose(){Oe(this,g,"f")||(Je(this,g,!0,"f"),Oe(this,v,"f").fire(),Oe(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Oe(this,f,"f")}set title(r){this.a(),Oe(this,f,"f")!==r&&(Je(this,f,r,"f"),Oe(this,k,"f").$setWebviewViewTitle(Oe(this,S,"f"),r))}get description(){return this.a(),Oe(this,t,"f")}set description(r){this.a(),Oe(this,t,"f")!==r&&(Je(this,t,r,"f"),Oe(this,k,"f").$setWebviewViewDescription(Oe(this,S,"f"),r))}get visible(){return Oe(this,p,"f")}get webview(){return Oe(this,D,"f")}get viewType(){return Oe(this,N,"f")}_setVisible(r){r===Oe(this,p,"f")||Oe(this,g,"f")||(Je(this,p,r,"f"),Oe(this,l,"f").fire())}get badge(){return this.a(),Oe(this,a,"f")}set badge(r){this.a(),!(r?.value===Oe(this,a,"f")?.value&&r?.tooltip===Oe(this,a,"f")?.tooltip)&&(Je(this,a,L.ViewBadge.from(r),"f"),Oe(this,k,"f").$setWebviewViewBadge(Oe(this,S,"f"),r))}show(r){this.a(),Oe(this,k,"f").$show(Oe(this,S,"f"),!!r)}a(){if(Oe(this,g,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,k=new WeakMap,N=new WeakMap,D=new WeakMap,g=new WeakMap,p=new WeakMap,f=new WeakMap,t=new WeakMap,a=new WeakMap,l=new WeakMap,v=new WeakMap;class E{constructor(r,o){this.d=o,this.b=new Map,this.c=new Map,this.a=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,o,s,d){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:s,extension:r}),this.a.$registerWebviewViewProvider((0,y.toExtensionData)(r),o,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(r)}),new F.Disposable(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(r,o,s,d,c){const u=this.b.get(o);if(!u)throw new Error(`No view provider found for '${o}'`);const{provider:n,extension:h}=u,m=this.d.createNewWebview(r,{},h),P=new b(r,this.a,o,s,m,!0);this.c.set(r,P),await n.resolveWebviewView(P,{state:d},c)}async $onDidChangeWebviewViewVisibility(r,o){this.e(r)._setVisible(o)}async $disposeWebviewView(r){const o=this.e(r);this.c.delete(r),o.dispose(),this.d.deleteWebview(r)}e(r){const o=this.c.get(r);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=E}),define(Ce[102],ke([1,0,4,5,2,13,10,3,15]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class rn{get state(){return this.d}constructor(D){this.c=new i.Emitter,this.onDidChangeWindowState=this.c.event,this.d=rn.a,this.b=D.getProxy(T.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}$onDidChangeWindowFocus(D){D!==this.d.focused&&(this.d={...this.d,focused:D},this.c.fire(this.d))}openUri(D,g){let p;if(typeof D=="string"){p=D;try{D=y.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,C.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this.b.$openUri(D,p,g)}async asExternalUri(D,g){if((0,C.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(D,g);return y.URI.from(p)}};k.a={focused:!0},k=qe([je(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,F.createDecorator)("IExtHostWindow")}),define(Ce[230],ke([1,0,200,27,15]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends i.AbstractExtHostConsoleForwarder{constructor(F,S){super(F,S)}f(F,S,k){S.apply(console,k)}};L=qe([je(0,y.IExtHostRpcService),je(1,T.IExtHostInitDataService)],L),e.ExtHostConsoleForwarder=L}),define(Ce[231],ke([1,0,14,24,20,11,4,7,123,194,43]),function(ee,e,i,T,y,L,C,F,S,k,N){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function g(P,M){try{return JSON.stringify(P,M)}catch{return"null"}}const p="$$ref$$",f={[p]:-1};class t{constructor(M,V){this.jsonString=M,this.referencedBuffers=V}}function a(P,M=null,V=!1){const Z=[];return{jsonString:(V?g:JSON.stringify)(P,(R,A)=>{if(typeof A>"u")return f;if(typeof A=="object"){if(A instanceof T.VSBuffer){const O=Z.push(A)-1;return{[p]:O}}if(M)return M(R,A)}return A}),referencedBuffers:Z}}e.stringifyJsonWithBufferRefs=a;function l(P,M,V){return JSON.parse(P,(Z,G)=>{if(G){const R=G[p];if(typeof R=="number")return M[R];if(V&&G.$mid===1)return V.transformIncoming(G)}return G})}e.parseJsonAndRestoreBufferRefs=l;function v(P,M){return JSON.stringify(P,M)}function b(P){return P?(M,V)=>V&&V.$mid===1?P.transformOutgoing(V):V:null}var E;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},o=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class d extends F.Disposable{constructor(M,V=null,Z=null){super(),this[D]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=M,this.f=V,this.g=Z,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let G=0,R=N.ProxyIdentifier.count;G<R;G++)this.k[G]=null,this.l[G]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new i.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(G=>this.G(G))}dispose(){this.j=!0,Object.keys(this.s).forEach(M=>{this.s[M].resolveErr(L.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(M){this.u===0&&(this.v=Date.now()+d.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(M){this.v=Date.now()+d.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(M){this.t!==M&&(this.t=M,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(M){return this.g?(0,S.transformIncomingURIs)(M,this.g):M}getProxy(M){const{nid:V,sid:Z}=M;return this.l[V]||(this.l[V]=this.F(V,Z)),this.l[V]}F(M,V){const Z={get:(G,R)=>(typeof R=="string"&&!G[R]&&R.charCodeAt(0)===36&&(G[R]=(...A)=>this.O(M,R,A)),R===s?V:G[R])};return new Proxy(Object.create(null),Z)}set(M,V){return this.k[M.nid]=V,V}assertRegistered(M){for(let V=0,Z=M.length;V<Z;V++){const G=M[V];if(!this.k[G.nid])throw new Error(`Missing proxy instance ${G.sid}`)}}G(M){if(this.j)return;const V=M.byteLength,Z=c.read(M,0),G=Z.readUInt8(),R=Z.readUInt32();switch(G){case 1:case 2:{let{rpcId:A,method:O,args:B}=n.deserializeRequestJSONArgs(Z);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.H(V,R,A,O,B,G===2);break}case 3:case 4:{let{rpcId:A,method:O,args:B}=n.deserializeRequestMixedArgs(Z);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.H(V,R,A,O,B,G===4);break}case 5:{this.f?.logIncoming(V,R,0,"ack"),this.z(R);break}case 6:{this.I(V,R);break}case 7:{this.J(V,R,void 0);break}case 9:{let A=n.deserializeReplyOKJSON(Z);this.g&&(A=(0,S.transformIncomingURIs)(A,this.g)),this.J(V,R,A);break}case 10:{const A=n.deserializeReplyOKJSONWithBuffers(Z,this.g);this.J(V,R,A);break}case 8:{const A=n.deserializeReplyOKVSBuffer(Z);this.J(V,R,A);break}case 11:{let A=n.deserializeReplyErrError(Z);this.g&&(A=(0,S.transformIncomingURIs)(A,this.g)),this.L(V,R,A);break}case 12:{this.L(V,R,void 0);break}default:console.error("received unexpected message"),console.error(M)}}H(M,V,Z,G,R,A){this.f?.logIncoming(M,V,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(Z)}.${G}(`,R);const O=String(V);let B,z;if(A){const K=new y.CancellationTokenSource;R.push(K.token),B=this.M(Z,G,R),z=()=>K.cancel()}else B=this.M(Z,G,R),z=r;this.p[O]=z;const j=n.serializeAcknowledged(V);this.f?.logOutgoing(j.byteLength,V,1,"ack"),this.c.send(j),B.then(K=>{delete this.p[O];const ie=n.serializeReplyOK(V,K,this.h);this.f?.logOutgoing(ie.byteLength,V,1,"reply:",K),this.c.send(ie)},K=>{delete this.p[O];const ie=n.serializeReplyErr(V,K);this.f?.logOutgoing(ie.byteLength,V,1,"replyErr:",K),this.c.send(ie)})}I(M,V){this.f?.logIncoming(M,V,1,"receiveCancel");const Z=String(V);this.p[Z]?.()}J(M,V,Z){this.f?.logIncoming(M,V,0,"receiveReply:",Z);const G=String(V);if(!this.s.hasOwnProperty(G))return;const R=this.s[G];delete this.s[G],R.resolveOk(Z)}L(M,V,Z){this.f?.logIncoming(M,V,0,"receiveReplyErr:",Z);const G=String(V);if(!this.s.hasOwnProperty(G))return;const R=this.s[G];delete this.s[G];let A;Z&&(Z.$isError?(A=new Error,A.name=Z.name,A.message=Z.message,A.stack=Z.stack):A=Z),R.resolveErr(A)}M(M,V,Z){try{return Promise.resolve(this.N(M,V,Z))}catch(G){return Promise.reject(G)}}N(M,V,Z){const G=this.k[M];if(!G)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(M));const R=G[V];if(typeof R!="function")throw new Error("Unknown method "+V+" on actor "+(0,N.getStringIdentifierForProxy)(M));return R.apply(G,Z)}O(M,V,Z){if(this.j)return new k.CanceledLazyPromise;let G=null;if(Z.length>0&&y.CancellationToken.isCancellationToken(Z[Z.length-1])&&(G=Z.pop()),G&&G.isCancellationRequested)return Promise.reject(L.canceled());const R=n.serializeRequestArguments(Z,this.h),A=++this.m,O=String(A),B=new k.LazyPromise;G&&G.onCancellationRequested(()=>{const j=n.serializeCancel(A);this.f?.logOutgoing(j.byteLength,A,0,"cancel"),this.c.send(n.serializeCancel(A))}),this.s[O]=B,this.y(A);const z=n.serializeRequest(A,M,V,R,!!G);return this.f?.logOutgoing(z.byteLength,A,0,`request: ${(0,N.getStringIdentifierForProxy)(M)}.${V}(`,Z),this.c.send(z),B}}e.RPCProtocol=d,D=o,d.a=3*1e3;class c{static alloc(M,V,Z){const G=new c(T.VSBuffer.alloc(Z+1+4),0);return G.writeUInt8(M),G.writeUInt32(V),G}static read(M,V){return new c(M,V)}get buffer(){return this.a}constructor(M,V){this.a=M,this.b=V}static sizeUInt8(){return 1}writeUInt8(M){this.a.writeUInt8(M,this.b),this.b+=1}readUInt8(){const M=this.a.readUInt8(this.b);return this.b+=1,M}writeUInt32(M){this.a.writeUInt32BE(M,this.b),this.b+=4}readUInt32(){const M=this.a.readUInt32BE(this.b);return this.b+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this.a.writeUInt8(M.byteLength,this.b),this.b+=1,this.a.set(M,this.b),this.b+=M.byteLength}readShortString(){const M=this.a.readUInt8(this.b);this.b+=1;const Z=this.a.slice(this.b,this.b+M).toString();return this.b+=M,Z}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readLongString(){const M=this.a.readUInt32BE(this.b);this.b+=4;const Z=this.a.slice(this.b,this.b+M).toString();return this.b+=M,Z}writeBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readVSBuffer(){const M=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+M);return this.b+=M,V}static sizeMixedArray(M){let V=0;V+=1;for(let Z=0,G=M.length;Z<G;Z++){const R=M[Z];switch(V+=1,R.type){case 1:V+=this.sizeLongString(R.value);break;case 2:V+=this.sizeVSBuffer(R.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(R.value);for(let A=0;A<R.buffers.length;++A)V+=this.sizeVSBuffer(R.buffers[A]);break;case 4:break}}return V}writeMixedArray(M){this.a.writeUInt8(M.length,this.b),this.b+=1;for(let V=0,Z=M.length;V<Z;V++){const G=M[V];switch(G.type){case 1:this.writeUInt8(1),this.writeLongString(G.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(G.value);break;case 3:this.writeUInt8(3),this.writeUInt32(G.buffers.length),this.writeLongString(G.value);for(let R=0;R<G.buffers.length;++R)this.writeBuffer(G.buffers[R]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const M=this.a.readUInt8(this.b);this.b+=1;const V=new Array(M);for(let Z=0;Z<M;Z++)switch(this.readUInt8()){case 1:V[Z]=this.readLongString();break;case 2:V[Z]=this.readVSBuffer();break;case 3:{const R=this.readUInt32(),A=this.readLongString(),O=[];for(let B=0;B<R;++B)O.push(this.readVSBuffer());V[Z]=new N.SerializableObjectWithBuffers(l(A,O,null));break}case 4:V[Z]=void 0;break}return V}}c.sizeUInt32=4;var u;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(u||(u={}));class n{static a(M){for(let V=0,Z=M.length;V<Z;V++)if(M[V]instanceof T.VSBuffer||M[V]instanceof N.SerializableObjectWithBuffers||typeof M[V]>"u")return!0;return!1}static serializeRequestArguments(M,V){if(this.a(M)){const Z=[];for(let G=0,R=M.length;G<R;G++){const A=M[G];if(A instanceof T.VSBuffer)Z[G]={type:2,value:A};else if(typeof A>"u")Z[G]={type:4};else if(A instanceof N.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:B}=a(A.value,V);Z[G]={type:3,value:T.VSBuffer.fromString(O),buffers:B}}else Z[G]={type:1,value:T.VSBuffer.fromString(v(A,V))}}return{type:1,args:Z}}return{type:0,args:v(M,V)}}static serializeRequest(M,V,Z,G,R){switch(G.type){case 0:return this.b(M,V,Z,G.args,R);case 1:return this.c(M,V,Z,G.args,R)}}static b(M,V,Z,G,R){const A=T.VSBuffer.fromString(Z),O=T.VSBuffer.fromString(G);let B=0;B+=c.sizeUInt8(),B+=c.sizeShortString(A),B+=c.sizeLongString(O);const z=c.alloc(R?2:1,M,B);return z.writeUInt8(V),z.writeShortString(A),z.writeLongString(O),z.buffer}static deserializeRequestJSONArgs(M){const V=M.readUInt8(),Z=M.readShortString(),G=M.readLongString();return{rpcId:V,method:Z,args:JSON.parse(G)}}static c(M,V,Z,G,R){const A=T.VSBuffer.fromString(Z);let O=0;O+=c.sizeUInt8(),O+=c.sizeShortString(A),O+=c.sizeMixedArray(G);const B=c.alloc(R?4:3,M,O);return B.writeUInt8(V),B.writeShortString(A),B.writeMixedArray(G),B.buffer}static deserializeRequestMixedArgs(M){const V=M.readUInt8(),Z=M.readShortString(),G=M.readMixedArray(),R=new Array(G.length);for(let A=0,O=G.length;A<O;A++){const B=G[A];typeof B=="string"?R[A]=JSON.parse(B):R[A]=B}return{rpcId:V,method:Z,args:R}}static serializeAcknowledged(M){return c.alloc(5,M,0).buffer}static serializeCancel(M){return c.alloc(6,M,0).buffer}static serializeReplyOK(M,V,Z){if(typeof V>"u")return this.d(M);if(V instanceof T.VSBuffer)return this.e(M,V);if(V instanceof N.SerializableObjectWithBuffers){const{jsonString:G,referencedBuffers:R}=a(V.value,Z,!0);return this.g(M,G,R)}else return this.f(M,g(V,Z))}static d(M){return c.alloc(7,M,0).buffer}static e(M,V){let Z=0;Z+=c.sizeVSBuffer(V);const G=c.alloc(8,M,Z);return G.writeVSBuffer(V),G.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static f(M,V){const Z=T.VSBuffer.fromString(V);let G=0;G+=c.sizeLongString(Z);const R=c.alloc(9,M,G);return R.writeLongString(Z),R.buffer}static g(M,V,Z){const G=T.VSBuffer.fromString(V);let R=0;R+=c.sizeUInt32,R+=c.sizeLongString(G);for(const O of Z)R+=c.sizeVSBuffer(O);const A=c.alloc(10,M,R);A.writeUInt32(Z.length),A.writeLongString(G);for(const O of Z)A.writeBuffer(O);return A.buffer}static deserializeReplyOKJSON(M){const V=M.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(M,V){const Z=M.readUInt32(),G=M.readLongString(),R=[];for(let A=0;A<Z;++A)R.push(M.readVSBuffer());return new N.SerializableObjectWithBuffers(l(G,R,V))}static serializeReplyErr(M,V){const Z=V?g(L.transformErrorForSerialization(V),null):void 0;if(typeof Z!="string")return this.h(M);const G=T.VSBuffer.fromString(Z);let R=0;R+=c.sizeLongString(G);const A=c.alloc(11,M,R);return A.writeLongString(G),A.buffer}static deserializeReplyErrError(M){const V=M.readLongString();return JSON.parse(V)}static h(M){return c.alloc(12,M,0).buffer}}var h;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var m;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(m||(m={}))}),define(Ce[232],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(L){const C=F=>{self.removeEventListener("message",C);const S=F.data;Object.defineProperties(self,{postMessage:{value(k,N){S.postMessage(k,N)}},onmessage:{get(){return S.onmessage},set(k){S.onmessage=k}}}),S.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};self.addEventListener("message",C)}.toString();class T extends EventTarget{constructor(L,C,F){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${i})('${C}'))`,k=new Blob([S],{type:"application/javascript"}),N=URL.createObjectURL(k),D=new MessageChannel,g=N,p={type:"_newWorker",id:g,port:D.port2,url:N,options:F};L(p,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{L({type:"_terminateWorker",id:g}),URL.revokeObjectURL(N),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(f){D.port1.onmessage=f}},onmessageerror:{get(){return D.port1.onmessageerror},set(f){D.port1.onmessageerror=f}}}),D.port1.addEventListener("messageerror",f=>{const t=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(t)}),D.port1.addEventListener("message",f=>{const t=new MessageEvent("message",{data:f.data});this.dispatchEvent(t)}),D.port1.start()}}e.NestedWorker=T}),define(Ce[233],ke([1,0,4,30,41,3,36,11,14]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class N{constructor(){this.a=new Map,this.b=new i.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new i.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(t=>f.push(t)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}T.Registry.add(e.Extensions.OutputChannels,new N);function D(p,f,t,a,l){return(0,S.createCancelablePromise)(async v=>{await(0,C.whenProviderRegistered)(t,a);const b=T.Registry.as(e.Extensions.OutputChannels);try{await g(t,1,a,l,v),b.registerChannel({id:p,label:f,file:t,log:!0})}catch(E){(0,F.isCancellationError)(E)||l.error("Error while registering log channel",t.toString(),(0,F.getErrorMessage)(E))}})}e.registerLogChannel=D;async function g(p,f,t,a,l){if(!await t.exists(p)){if(l.isCancellationRequested)throw new F.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");a.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",p.toString()),await(0,S.timeout)(1e3,l),await g(p,f+1,t,a,l)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new y.RawContextKey("activeOutputChannel","")}),define(Ce[103],ke([1,0,5,3,15,25,12,233,58,27,37,117,24,9,36,4,7]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(w,r,o,s,d){super(),this.id=w,this.name=r,this.m=o,this.n=s,this.extension=d,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(w){this.append(w+`
`)}append(w){this.info(w)}clear(){const w=this.k;this.m.flush(),this.n.$update(this.id,F.OutputChannelUpdateMode.Clear,w)}replace(w){const r=this.k;this.info(w),this.n.$update(this.id,F.OutputChannelUpdateMode.Replace,r),this.visible&&this.m.flush()}show(w,r){this.m.flush(),this.n.$reveal(this.id,!!(typeof w=="boolean"?w:r))}hide(){this.n.$close(this.id)}g(w,r){this.k+=g.VSBuffer.fromString(r).byteLength,(0,C.log)(this.m,w,r),this.visible&&(this.m.flush(),this.n.$update(this.id,F.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class v extends l{appendLine(w){this.append(w)}}let b=class{constructor(w,r,o,s,d,c){this.i=r,this.j=o,this.k=s,this.l=d,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=w.getProxy(i.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.h=w;for(const[r,o]of this.g)o.visible=r===this.h}createOutputChannel(w,r,o){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const s=typeof r=="object"&&r.log,d=(0,p.isString)(r)?r:void 0;if((0,p.isString)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const u=this.i.environment.extensionLogLevel?.find(([h])=>L.ExtensionIdentifier.equals(o.identifier,h))?.[1];u&&(c=(0,C.parseLogLevel)(u));const n=s?this.o(w,c,o):this.n(w,d,o);return n.then(h=>{this.g.set(h.id,h),h.visible=h.id===this.h}),s?this.r(w,c??this.m.getLevel(),n):this.q(w,n)}async n(w,r,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,d=this.k.extUri.joinPath(s,`${this.f++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(d,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.a.$register(w,d,!1,r,o.identifier.value);return new l(u,w,c,this.a,o)}async o(w,r,o){const s=await this.p(o),d=this.k.extUri.joinPath(s,`${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(d,{name:w},r),u=await this.a.$register(w,d,!0,void 0,o.identifier.value);return new v(u,w,c,this.a,o)}p(w){let r=this.d.get(w.identifier.value);if(!r){const o=this.k.extUri.joinPath(this.i.logsLocation,w.identifier.value);this.d.set(w.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(o)}catch(s){if((0,f.toFileSystemProviderErrorCode)(s)!==f.FileSystemProviderErrorCode.FileExists)throw s}return o})())}return r}q(w,r){let o=!1;const s=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return w},append(d){s(),r.then(c=>c.append(d))},appendLine(d){s(),r.then(c=>c.appendLine(d))},clear(){s(),r.then(d=>d.clear())},replace(d){s(),r.then(c=>c.replace(d))},show(d,c){s(),r.then(u=>u.show(d,c))},hide(){s(),r.then(d=>d.hide())},dispose(){o=!0,r.then(d=>d.dispose())}}}r(w,r,o){const s=new a.DisposableStore,d=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},c=s.add(new t.Emitter);return o.then(u=>{s.add(u),s.add(u.onDidChangeLogLevel(n=>{r=n,c.fire(n)}))}),{...this.q(w,o),get logLevel(){return r},onDidChangeLogLevel:c.event,trace(u,...n){d(),o.then(h=>h.trace(u,...n))},debug(u,...n){d(),o.then(h=>h.debug(u,...n))},info(u,...n){d(),o.then(h=>h.info(u,...n))},warn(u,...n){d(),o.then(h=>h.warn(u,...n))},error(u,...n){d(),o.then(h=>h.error(u,...n))},dispose(){s.dispose()}}}};b=qe([je(0,y.IExtHostRpcService),je(1,k.IExtHostInitDataService),je(2,S.IExtHostConsumerFileSystem),je(3,N.IExtHostFileSystemInfo),je(4,C.ILoggerService),je(5,C.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(Ce[234],ke([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(Ce[235],ke([1,0,39,13,19,21,22,2,3,166,51,181,234]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let p=class sn{constructor(t,a,l,v){this.d=t,this.e=a,this.f=l,this.g=v,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??t})()}hasValidBasename(t,a,l){return typeof a=="string"||typeof a>"u"?this.a.then(v=>this.h(t,v,a)):this.h(t,a,l)}h(t,a,l){return t.scheme===T.Schemas.file||t.scheme===T.Schemas.vscodeRemote?(0,i.isValidBasename)(l??(0,C.basename)(t),a===1):!0}get defaultUriScheme(){return sn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,a){if(t.remoteAuthority)return T.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(a.getWorkspace());if(l)return l;const v=a.getWorkspace().folders[0];if(v)return v.uri.scheme;const b=a.getWorkspace().configuration;return b?b.scheme:T.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?y.win32:y.posix)}async fileURI(t){let a="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const v=t.indexOf("/",2);v===-1?(a=t.substring(2),t="/"):(a=t.substring(2,v),t=t.substring(v)||"/")}return F.URI.from({scheme:T.Schemas.file,authority:a,path:t,query:"",fragment:""})}};p=qe([je(1,g.IRemoteAgentService),je(2,D.IWorkbenchEnvironmentService),je(3,N.IWorkspaceContextService)],p),e.AbstractPathService=p}),define(Ce[104],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(C,F){this.line=C,this.character=F}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,F){return new i(0,0)}with(C){return new i(0,0)}}e.Position=i;class T{constructor(C,F,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(C,F),this.end=new i(S,k)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new T(0,0,0,0)}with(C){return new T(0,0,0,0)}}e.Range=T;var y;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[44],ke([1,0,16,35,23,39,10,3,19,11,104,14]),function(ee,e,i,T,y,L,C,F,S,k,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const g="\u27EA ",p=" characters skipped \u27EB",f=(g.length+p.length+5)*2;e.ISearchService=(0,F.createDecorator)("searchService");var t;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(t=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function l(ue){return!!ue.preview}e.resultIsMatch=l;function v(ue){return!!ue.resource}e.isFileMatch=v;function b(ue){return!!ue.message}e.isProgressMessage=b;var E;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(E=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(oe){this.resource=oe,this.results=[]}}e.FileMatch=w;class r{constructor(oe,De,re){this.ranges=De;const _=Array.isArray(De)?De:[De];if(re&&re.matchLines===1&&o(_)){oe=(0,C.getNLines)(oe,re.matchLines);let le="",Ee=0,Ae=0;const Be=Math.floor(re.charsPerLine/5),xe=[];for(const Te of _){const Ie=Math.max(Te.startColumn-Be,0),Se=Te.startColumn+re.charsPerLine;if(Ie>Ae+Be+f){const se=g+(Ie-Ae)+p;le+=se+oe.slice(Ie,Se),Ee+=Ie-(Ae+se.length)}else le+=oe.slice(Ae,Se);xe.push(new d(0,Te.startColumn-Ee,Te.endColumn-Ee)),Ae=Se}this.preview={text:le,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const le=Array.isArray(De)?De[0].startLineNumber:De.startLineNumber;this.preview={text:oe,matches:(0,i.mapArrayOrNot)(De,Ee=>new s(Ee.startLineNumber-le,Ee.startColumn,Ee.endLineNumber-le,Ee.endColumn))}}}}e.TextSearchMatch=r;function o(ue){const oe=ue[0].startLineNumber;for(const De of ue)if(De.startLineNumber!==oe||De.endLineNumber!==oe)return!1;return!0}class s{constructor(oe,De,re,_){this.startLineNumber=oe,this.startColumn=De,this.endLineNumber=re,this.endColumn=_}}e.SearchRange=s;class d extends s{constructor(oe,De,re){super(oe,De,oe,re)}}e.OneLineRange=d;var c;(function(ue){ue.List="list",ue.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var u;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function n(ue,oe=!0){const De=ue&&ue.files&&ue.files.exclude,re=oe&&ue&&ue.search&&ue.search.exclude;if(!De&&!re)return;if(!De||!re)return De||re;let _=Object.create(null);return _=y.mixin(_,y.deepClone(De)),_=y.mixin(_,y.deepClone(re),!0),_}e.getExcludes=n;function h(ue,oe){return ue.excludePattern&&T.match(ue.excludePattern,oe)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&T.match(ue.includePattern,oe)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(De=>{const re=De.folder.fsPath;if(L.isEqualOrParent(oe,re)){const _=S.relative(re,oe);return!De.includePattern||!!T.match(De.includePattern,_)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var m;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(oe,De){super(oe),this.code=De}}e.SearchError=P;function M(ue){const oe=ue.message;if((0,k.isCancellationError)(ue))return new P(oe,m.canceled);try{const De=JSON.parse(oe);return new P(De.message,De.code)}catch{return new P(oe,m.other)}}e.deserializeSearchError=M;function V(ue){const oe={message:ue.message,code:ue.code};return new Error(JSON.stringify(oe))}e.serializeSearchError=V;function Z(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=Z;function G(ue){return ue.type==="success"}e.isSerializedSearchSuccess=G;function R(ue){return!!ue.path}e.isSerializedFileMatch=R;function A(ue,oe){const De=ue.searchPath?ue.searchPath:ue.relativePath;return(0,C.fuzzyContains)(De,oe)}e.isFilePatternMatch=A;class O{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function B(ue,oe){const De={...ue||{},...oe||{}};return Object.keys(De).filter(re=>{const _=De[re];return typeof _=="boolean"&&_})}e.resolvePatternsForProvider=B;class z{constructor(oe,De){this.c=null,this.a={...oe.excludePattern||{},...De.excludePattern||{}},this.b=T.parse(this.a);let re=oe.includePattern;De.includePattern&&(re?re={...re,...De.includePattern}:re=De.includePattern),re&&(this.c=T.parse(re))}matchesExcludesSync(oe,De,re){return!!(this.b&&this.b(oe,De,re))}includedInQuerySync(oe,De,re){return!(this.b&&this.b(oe,De,re)||this.c&&!this.c(oe,De,re))}includedInQuery(oe,De,re){const _=this.b(oe,De,re),le=()=>this.c?!!this.c(oe,De,re):!0;return(0,D.isThenable)(_)?_.then(Ee=>Ee?!1:le()):le()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=z;function j(ue){for(const oe in ue)if(typeof ue[oe]!="boolean")return!0;return!1}function K(ue){if(!ue)return;let oe;return De=>(oe||(oe=(ue()||Promise.resolve([])).then(re=>re?me(re):{})),oe.then(re=>!!re[De]))}e.hasSiblingPromiseFn=K;function ie(ue){if(!ue)return;let oe;return De=>{if(!oe){const re=ue();oe=re?me(re):{}}return!!oe[De]}}e.hasSiblingFn=ie;function me(ue){const oe={};for(const De of ue)oe[De]=!0;return oe}}),define(Ce[31],ke([1,0,16,14,20,4,7,46,13,111,22,10,9,2,140,3,12,155,51,37,27,15,8,6,53,44,5]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a,l,v,b,E,w,r,o,s,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(G,R,A){return new N.ExtUri(O=>P(O,A)).isEqual(G,R)}function n(G,R,A){return u(G.uri,R.uri,A)?0:(0,D.compare)(G.uri.toString(),R.uri.toString())}function h(G,R,A){return G.index!==R.index?G.index<R.index?-1:1:u(G.uri,R.uri,A)?(0,D.compare)(G.name,R.name):(0,D.compare)(G.uri.toString(),R.uri.toString())}function m(G,R,A,O){const B=G.slice(0).sort((j,K)=>A(j,K,O)),z=R.slice(0).sort((j,K)=>A(j,K,O));return(0,i.delta)(B,z,(j,K)=>A(j,K,O))}function P(G,R){const A=R.getCapabilities(G.scheme);return!(A&&A&1024)}class M extends v.Workspace{static toExtHostWorkspace(R,A,O,B){if(!R)return{workspace:null,added:[],removed:[]};const{id:z,name:j,folders:K,configuration:ie,transient:me,isUntitled:ue}=R,oe=[],De=A;A?K.forEach((Ee,Ae)=>{const Be=p.URI.revive(Ee.uri),xe=M.e(O||A,Be,B);xe?(xe.name=Ee.name,xe.index=Ee.index,oe.push(xe)):oe.push({uri:Be,name:Ee.name,index:Ae})}):oe.push(...K.map(({uri:Ee,name:Ae,index:Be})=>({uri:p.URI.revive(Ee),name:Ae,index:Be}))),oe.sort((Ee,Ae)=>Ee.index<Ae.index?-1:1);const re=new M(z,j,oe,!!me,ie?p.URI.revive(ie):null,!!ue,Ee=>P(Ee,B)),{added:_,removed:le}=m(De?De.workspaceFolders:[],re.workspaceFolders,n,B);return{workspace:re,added:_,removed:le}}static e(R,A,O){for(let B=0;B<R.folders.length;B++){const z=R.workspaceFolders[B];if(u(z.uri,A,O))return z}}constructor(R,A,O,B,z,j,K){super(R,O.map(ie=>new v.WorkspaceFolder(ie)),B,z,K),this.s=A,this.t=j,this.o=[],this.q=F.TernarySearchTree.forUris(K),O.forEach(ie=>{this.o.push(ie),this.q.set(ie.uri,ie)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(R,A){return A&&this.q.get(R)&&(R=(0,N.dirname)(R)),this.q.findSubstr(R)}resolveWorkspaceFolder(R){return this.q.get(R)}}let V=class{constructor(R,A,O,B,z){this.c=new L.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new L.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=B,this.q=O,this.s=z,this.h=new k.Counter,this.j=new T.Barrier,this.n=R.getProxy(c.MainContext.MainThreadWorkspace),this.o=R.getProxy(c.MainContext.MainThreadMessageService);const j=A.workspace;this.k=j?new M(j.id,j.name,[],!!j.transient,j.configuration?p.URI.revive(j.configuration):null,!!j.isUntitled,K=>P(K,O)):void 0}$initializeWorkspace(R,A){this.u=A,this.$acceptWorkspaceData(R),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?p.URI.from({scheme:S.Schemas.untitled,path:(0,N.basename)((0,N.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(R,A,O,...B){const z=[];if(Array.isArray(B)&&B.forEach(ue=>{p.URI.isUri(ue.uri)&&!z.some(oe=>u(oe.uri,ue.uri,this.q))&&z.push({uri:ue.uri,name:ue.name||(0,N.basenameOrAuthority)(ue.uri)})}),this.l||[A,O].some(ue=>typeof ue!="number"||ue<0)||O===0&&z.length===0)return!1;const j=this.w?this.w.workspaceFolders:[];if(A+O>j.length)return!1;const K=j.slice(0);K.splice(A,O,...z.map(ue=>({uri:ue.uri,name:ue.name||(0,N.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<K.length;ue++){const oe=K[ue];if(K.some((De,re)=>re!==ue&&u(oe.uri,De.uri,this.q)))return!1}K.forEach((ue,oe)=>ue.index=oe);const{added:ie,removed:me}=m(j,K,h,this.q);if(ie.length===0&&me.length===0)return!1;if(this.n){const ue=R.displayName||R.name;this.n.$updateWorkspaceFolders(ue,A,O,z).then(void 0,oe=>{this.l=void 0;const De={source:{identifier:R.identifier,label:R.displayName||R.name}};this.o.$showMessage(l.Severity.Error,(0,f.localize)(0,null,ue,oe.toString()),De,[])})}return this.x(K),!0}getWorkspaceFolder(R,A){if(!!this.w)return this.w.getWorkspaceFolder(R,A)}async getWorkspaceFolder2(R,A){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(R,A)}async resolveWorkspaceFolder(R){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(R)}getPath(){if(!this.w)return;const{folders:R}=this.w;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,A){let O,B="";if(typeof R=="string"?(O=p.URI.file(R),B=R):typeof R<"u"&&(O=R,B=R.fsPath),!O)return B;const z=this.getWorkspaceFolder(O,!0);if(!z)return B;typeof A>"u"&&this.w&&(A=this.w.folders.length>1);let j=(0,N.relativePath)(z.uri,O);return A&&z.name&&(j=`${z.name}/${j}`),j}x(R){this.w&&(this.l=M.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:R,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:A,added:O,removed:B}=M.toExtHostWorkspace(R,this.k,this.l,this.q);this.k=A||void 0,this.l=void 0,this.c.fire(Object.freeze({added:O,removed:B}))}findFiles(R,A,O,B,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let j;if(A===null?j=!1:A&&(typeof A=="string"?j=A:j=A.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:ie}=Z(r.GlobPattern.from(R));return this.n.$startFileSearch((0,g.withUndefinedAsNull)(K),(0,g.withUndefinedAsNull)(ie),(0,g.withUndefinedAsNull)(j),(0,g.withUndefinedAsNull)(O),z).then(me=>Array.isArray(me)?me.map(ue=>p.URI.revive(ue)):[])}async findTextInFiles(R,A,O,B,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const j=this.h.getNext(),K=typeof A.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:A.previewOptions,{includePattern:ie,folder:me}=Z(r.GlobPattern.from(A.include)),ue=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,oe={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!0,fileEncoding:A.encoding,maxResults:A.maxResults,previewOptions:K,afterContext:A.afterContext,beforeContext:A.beforeContext,includePattern:ie,excludePattern:ue},De=!1;if(this.t[j]=re=>{if(De)return;const _=p.URI.revive(re.resource);re.results.forEach(le=>{(0,d.resultIsMatch)(le)?O({uri:_,preview:{text:le.preview.text,matches:(0,i.mapArrayOrNot)(le.preview.matches,Ee=>new o.Range(Ee.startLineNumber,Ee.startColumn,Ee.endLineNumber,Ee.endColumn))},ranges:(0,i.mapArrayOrNot)(le.ranges,Ee=>new o.Range(Ee.startLineNumber,Ee.startColumn,Ee.endLineNumber,Ee.endColumn))}):O({uri:_,text:le.text,lineNumber:le.lineNumber})})},z.isCancellationRequested)return{};try{const re=await this.n.$startTextSearch(R,(0,g.withUndefinedAsNull)(me),oe,j,z);return delete this.t[j],re||{}}catch(re){throw delete this.t[j],re}}$handleTextSearchResult(R,A){this.t[A]?.(R)}saveAll(R){return this.n.$saveAll(R)}resolveProxy(R){return this.n.$resolveProxy(R)}get trusted(){return this.u}requestWorkspaceTrust(R){return this.n.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(R,A){if(this.v.has(R))throw new Error(`A provider has already been registered for scheme ${R}`);this.v.set(R,A);const O=this.s.transformOutgoingScheme(R),B=this.y++;return this.n.$registerEditSessionIdentityProvider(B,O),(0,C.toDisposable)(()=>{this.v.delete(R),this.n.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(R,A){this.g.info("Getting edit session identifier for workspaceFolder",R);const O=await this.resolveWorkspaceFolder(p.URI.revive(R));if(!O){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const B=this.v.get(O.uri.scheme);if(this.g.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!B),!B)return;const z=await B.provideEditSessionIdentity(O,A);if(this.g.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(R,A,O,B){this.g.info("Getting edit session identifier for workspaceFolder",R);const z=await this.resolveWorkspaceFolder(p.URI.revive(R));if(!z){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const j=this.v.get(z.uri.scheme);if(this.g.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!j),!j)return;const K=await j.provideEditSessionIdentityMatch?.(A,O,B);if(this.g.info("Provider returned edit session identifier match result: ",K),!!K)return K}};V=qe([je(0,w.IExtHostRpcService),je(1,E.IExtHostInitDataService),je(2,b.IExtHostFileSystemInfo),je(3,a.ILogService),je(4,s.IURITransformerService)],V),e.ExtHostWorkspace=V,e.IExtHostWorkspace=(0,t.createDecorator)("IExtHostWorkspace");function Z(G){let R,A;return G&&(typeof G=="string"?R=G:(R=G.pattern,A=p.URI.revive(G.baseUri))),{includePattern:R,folder:A}}}),define(Ce[32],ke([1,0,23,4,31,5,6,158,91,9,14,3,15,12,2]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function t(o,s){if(s){const d=s.split(".");let c=o;for(let u=0;c&&u<d.length;u++)c=c[d[u]];return c}}function a(o){return o instanceof f.URI}function l(o){return o&&o.uri instanceof f.URI&&o.languageId&&typeof o.languageId=="string"}function v(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function b(o){return o&&o.uri instanceof f.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function E(o){if(a(o))return{resource:o};if(l(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(v(o))return{overrideIdentifier:o.languageId};if(b(o))return{resource:o.uri};if(o===null)return{resource:null}}let w=class{constructor(s,d,c){this.a=s.getProxy(L.MainContext.MainThreadConfiguration),this.c=d,this.b=c,this.d=new N.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new r(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,d){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(s,d))}};w=qe([je(0,g.IExtHostRpcService),je(1,y.IExtHostWorkspace),je(2,p.ILogService)],w),e.ExtHostConfiguration=w;class r{constructor(s,d,c,u){this.a=new T.Emitter,this.b=s,this.f=u,this.c=d,this.e=F.Configuration.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,d){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=F.Configuration.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(d,c))}getConfiguration(s,d,c){const u=E(d)||{},n=this.g(s?t(this.e.getValue(void 0,u,this.c.workspace),s):this.e.getValue(void 0,u,this.c.workspace));s&&this.h(s,u,c?.identifier);function h(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(P){return typeof t(n,P)<"u"},get:(P,M)=>{this.h(s?`${s}.${P}`:P,u,c?.identifier);let V=t(n,P);if(typeof V>"u")V=M;else{let Z;const G=(R,A)=>{let O;const B=()=>{Z=Z||(0,i.deepClone)(n),O=O||t(Z,A)};return(0,k.isObject)(R)?new Proxy(R,{get:(z,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return B(),()=>O;if(Z)return O=O||t(Z,A),O[j];const K=z[j];return typeof j=="string"?G(K,`${A}.${j}`):K},set:(z,j,K)=>(B(),O&&(O[j]=K),!0),deleteProperty:(z,j)=>(B(),O&&delete O[j],!0),defineProperty:(z,j,K)=>(B(),O&&Object.defineProperty(O,j,K),!0)}):R};V=G(V,P)}return V},update:(P,M,V,Z)=>{P=s?`${s}.${P}`:P;const G=h(V);return M!==void 0?this.b.$updateConfigurationOption(G,P,M,u,Z):this.b.$removeConfigurationOption(G,P,u,Z)},inspect:P=>{P=s?`${s}.${P}`:P;const M=this.e.inspect(P,u,this.c.workspace);if(M)return{key:P,defaultValue:(0,i.deepClone)(M.policy?.value??M.default?.value),globalValue:(0,i.deepClone)(M.user?.value??M.application?.value),workspaceValue:(0,i.deepClone)(M.workspace?.value),workspaceFolderValue:(0,i.deepClone)(M.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(M.default?.override),globalLanguageValue:(0,i.deepClone)(M.user?.override??M.application?.override),workspaceLanguageValue:(0,i.deepClone)(M.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(M.workspaceFolder?.override),languageIds:(0,i.deepClone)(M.overrideIdentifiers)}}};return typeof n=="object"&&(0,i.mixin)(m,n,!1),Object.freeze(m)}g(s){const d=c=>(0,k.isObject)(c)?new Proxy(c,{get:(u,n)=>d(u[n]),set:(u,n,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(u,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(u,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return d(s)}h(s,d,c){const u=S.OVERRIDE_PROPERTY_REGEX.test(s)?4:this.d.get(s),n=c?`[${c.value}] `:"";if(u===4){typeof d?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){d?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,d){const c=new F.ConfigurationChangeEvent(s,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,n)=>c.affectsConfiguration(u,E(n))})}k(s){return s.reduce((d,c)=>(d.set(c[0],c[1]),d),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[105],ke([1,0,2,14,4,5,6,31,56,32,20,59,15,27,3,13,21,12,73,193,11]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a,l,v,b,E){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var r;(function(R){function A(B){if(B!=null)return B}R.from=A;function O(B){if(B!=null)return B}R.to=O})(r||(r={}));var o;(function(R){function A(B){if(B!=null)return B}R.from=A;function O(B){if(B!=null)return B}R.to=O})(o||(o={}));var s;(function(R){function A(B){if(B!=null)return B}R.from=A;function O(B){if(B!=null)return B}R.to=O})(s||(s={}));var d;(function(R){function A(z){if(z){const j=z;return j&&!!j.process}else return!1}R.is=A;function O(z){if(z==null)return;const j={process:z.process,args:z.args};return z.options&&(j.options=s.from(z.options)),j}R.from=O;function B(z){if(z!=null)return new C.ProcessExecution(z.process,z.args,z.options)}R.to=B})(d||(d={}));var c;(function(R){function A(B){if(B!=null)return B}R.from=A;function O(B){if(B!=null)return B}R.to=O})(c||(c={}));var u;(function(R){function A(z){if(z){const j=z;return j&&(!!j.commandLine||!!j.command)}else return!1}R.is=A;function O(z){if(z==null)return;const j={};return z.commandLine!==void 0?j.commandLine=z.commandLine:(j.command=z.command,j.args=z.args),z.options&&(j.options=c.from(z.options)),j}R.from=O;function B(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new C.ShellExecution(z.commandLine,z.options):new C.ShellExecution(z.command,z.args?z.args:[],z.options)}R.to=B})(u||(u={}));var n;(function(R){function A(z){if(z){const j=z;return j&&j.customExecution==="customExecution"}else return!1}R.is=A;function O(z){return{customExecution:"customExecution"}}R.from=O;function B(z,j){return j.get(z)}R.to=B})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(R){function A(O,B){let z;return O.scope!==void 0&&typeof O.scope!="number"?z=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===C.TaskScope.Workspace&&B&&B.workspaceFile?z=B.workspaceFile:z=b.USER_TASKS_GROUP_KEY),{id:O._id,workspaceFolder:z}}R.from=A})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(R){function A(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}R.from=A})(m||(m={}));var P;(function(R){function A(z,j){if(z==null)return[];const K=[];for(const ie of z){const me=O(ie,j);me&&K.push(me)}return K}R.fromMany=A;function O(z,j){if(z==null)return;let K;z.execution instanceof C.ProcessExecution?K=d.from(z.execution):z.execution instanceof C.ShellExecution?K=u.from(z.execution):z.execution&&z.execution instanceof C.CustomExecution&&(K=n.from(z.execution));const ie=r.from(z.definition);let me;return z.scope?typeof z.scope=="number"?me=z.scope:me=z.scope.uri:me=C.TaskScope.Workspace,!ie||!me?void 0:{_id:z._id,definition:ie,name:z.name,source:{extensionId:j.identifier.value,label:z.source,scope:me},execution:K,isBackground:z.isBackground,group:m.from(z.group),presentationOptions:o.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}R.from=O;async function B(z,j,K){if(z==null)return;let ie;d.is(z.execution)?ie=d.to(z.execution):u.is(z.execution)?ie=u.to(z.execution):n.is(z.execution)&&(ie=n.to(z._id,K));const me=r.to(z.definition);let ue;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?ue=z.source.scope:ue=await j.resolveWorkspaceFolder(i.URI.revive(z.source.scope)):ue=C.TaskScope.Workspace),!me||!ue)return;const oe=new C.Task(me,ue,z.name,z.source.label,ie,z.problemMatchers);return z.isBackground!==void 0&&(oe.isBackground=z.isBackground),z.group!==void 0&&(oe.group=C.TaskGroup.from(z.group._id),oe.group&&z.group.isDefault&&(oe.group=new C.TaskGroup(oe.group.id,oe.group.label),z.group.isDefault===!0&&(oe.group.isDefault=z.group.isDefault))),z.presentationOptions&&(oe.presentationOptions=o.to(z.presentationOptions)),z._id&&(oe._id=z._id),z.detail&&(oe.detail=z.detail),oe}R.to=B})(P=e.TaskDTO||(e.TaskDTO={}));var M;(function(R){function A(B){return B}R.from=A;function O(B){if(!!B)return Object.assign(Object.create(null),B)}R.to=O})(M||(M={}));class V{constructor(A,O,B){this._id=O,this.a=B,w.set(this,void 0),Je(this,w,A,"f")}get task(){return this.a}terminate(){Oe(this,w,"f").terminateTask(this)}fireDidStartProcess(A){}fireDidEndProcess(A){}}w=new WeakMap;let Z=class{constructor(A,O,B,z,j,K,ie,me){this.q=new y.Emitter,this.r=new y.Emitter,this.s=new y.Emitter,this.t=new y.Emitter,this.a=A.getProxy(L.MainContext.MainThreadTask),this.b=B,this.c=z,this.d=j,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=me,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(A,O,B){if(!B)return new C.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:O,provider:B,extension:A}),this.a.$registerTaskProvider(z,O),new C.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(A,O){this.a.$registerTaskSystem(A,O)}fetchTasks(A){return this.a.$fetchTasks(M.from(A)).then(async O=>{const B=[];for(const z of O){const j=await P.to(z,this.b,this.m);j&&B.push(j)}return B})}get taskExecutions(){const A=[];return this.k.forEach(O=>A.push(O)),A}terminateTask(A){if(!(A instanceof V))throw new Error("No valid task execution provided");return this.a.$terminateTask(A._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(A,O,B){const z=this.m.get(A.id);z&&(this.o.set(A.id,z),this.e.attachPtyToTerminal(O,await z.callback(B))),this.p=A.id,this.q.fire({execution:await this.y(A)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(A){const O=await this.y(A);this.l.delete(A.id),this.k.delete(A.id),this.A(A),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(A){const O=await this.y(A.id);this.s.fire({execution:O,processId:A.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(A){const O=await this.y(A.id);this.t.fire({execution:O,exitCode:A.exitCode})}$provideTasks(A,O){const B=this.j.get(A);if(!B)return Promise.reject(new Error("no handler found"));const z=[],j=(0,T.asPromise)(()=>B.provider.provideTasks(N.CancellationToken.None)).then(K=>this.u(O,z,B,K));return new Promise(K=>{j.then(ie=>{Promise.all(z).then(()=>{K(ie)})})})}async $resolveTask(A,O){const B=this.j.get(A);if(!B)return Promise.reject(new Error("no handler found"));if(O.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${B.type}].`);const z=await P.to(O,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const j=await B.provider.resolveTask(z,N.CancellationToken.None);if(!j)return;this.z(j,B);const K=P.from(j,B.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(K.execution)&&await this.x(K,j,!0),await this.v(K)}w(){return this.h++}async x(A,O,B){const z=await this.a.$createTaskId(A);!B&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,O.execution)),this.m.set(z,O.execution)}async y(A,O){if(typeof A=="string"){const j=this.l.get(A);if(!j)throw new E.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const B=this.l.get(A.id);if(B)return B;const z=new Promise((j,K)=>{function ie(me,ue,oe){oe?j(new V(me,ue.id,oe)):K("Unexpected: Task does not exist.")}O?ie(this,A,O):P.to(A.task,this.b,this.m).then(me=>ie(this,A,me))});return this.l.set(A.id,z),z.then(j=>(this.k.set(A.id,j),j),j=>Promise.reject(j))}z(A,O){A._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(A){this.o.get(A.id)&&this.o.delete(A.id),this.n.has(A.id)&&this.p!==A.id&&(this.m.delete(A.id),this.n.delete(A.id));const B=this.n.values();let z=B.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=B.next()}};Z=qe([je(0,g.IExtHostRpcService),je(1,p.IExtHostInitDataService),je(2,F.IExtHostWorkspace),je(3,S.IExtHostDocumentsAndEditors),je(4,k.IExtHostConfiguration),je(5,D.IExtHostTerminalService),je(6,l.ILogService),je(7,v.IExtHostApiDeprecationService)],Z),e.ExtHostTaskBase=Z;let G=class extends Z{constructor(A,O,B,z,j,K,ie,me){super(A,O,B,z,j,K,ie,me),this.registerTaskSystem(t.Schemas.vscodeRemote,{scheme:t.Schemas.vscodeRemote,authority:"",platform:a.PlatformToString(0)})}async executeTask(A,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const B=P.from(O,A);if(B===void 0)throw new Error("Task is not valid");if(n.is(B.execution))await this.x(B,O,!1);else throw new E.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution(B),O);return this.a.$executeTask(B).catch(j=>{throw new Error(j)}),z}u(A,O,B,z){const j=[];if(z)for(const K of z){this.z(K,B),(!K.definition||!A[K.definition.type])&&this.f.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const ie=P.from(K,B.extension);ie&&n.is(ie.execution)?(j.push(ie),O.push(this.x(ie,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:B.extension}}async v(A){if(n.is(A.execution))return A;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(A,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(A,O,B){}};G=qe([je(0,g.IExtHostRpcService),je(1,p.IExtHostInitDataService),je(2,F.IExtHostWorkspace),je(3,S.IExtHostDocumentsAndEditors),je(4,k.IExtHostConfiguration),je(5,D.IExtHostTerminalService),je(6,l.ILogService),je(7,v.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ce[236],ke([1,0,19,20,45,35,22,74,44]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(g,p,f){this.k=g,this.l=p,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=g.filePattern,this.b=g.includePattern&&L.parse(g.includePattern),this.c=g.maxResults||void 0,this.d=g.exists,this.h=new Set,this.j=g.excludePattern&&L.parse(g.excludePattern)}cancel(){this.g=!0,this.h.forEach(g=>g.cancel()),this.h=new Set}search(g){const p=this.k.folderQueries||[];return new Promise((f,t)=>{const a=l=>{this.f++,g(l)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const v=l.toString(),b=i.basename(v);this.j&&this.j(v,b)||this.v(a,{base:l,basename:b})}),Promise.all(p.map(l=>this.p(l,a))).then(l=>{f({limitHit:this.e,stats:l[0]||void 0})},l=>{t(new Error((0,y.toErrorMessage)(l)))})})}async p(g,p){const f=new T.CancellationTokenSource,t=this.q(g),a=this.r(),l=new S.QueryGlobTester(this.k,g),v=!l.hasSiblingExcludeClauses();let b;try{this.h.add(f),b=F.StopWatch.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},t,f.token),w=b.elapsed(),r=F.StopWatch.create();return this.g&&!this.e||(E&&E.forEach(o=>{const s=i.posix.relative(g.folder.path,o.path);if(v){const d=i.basename(o.path);this.v(p,{base:g.folder,relativePath:s,basename:d});return}this.s(a,g.folder,s,p)}),this.g&&!this.e)?null:(this.u(a,l,p),{providerTime:w,postProcessTime:r.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(g){const p=(0,S.resolvePatternsForProvider)(this.k.includePattern,g.includePattern),f=(0,S.resolvePatternsForProvider)(this.k.excludePattern,g.excludePattern);return{folder:g.folder,excludes:f,includes:p,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}s({pathToEntries:g},p,f,t){if(f===this.a){const l=i.basename(this.a);this.v(t,{base:p,relativePath:this.a,basename:l})}function a(l){const v=i.basename(l),b=i.dirname(l);let E=g[b];E||(E=g[b]=[],a(b)),E.push({base:p,relativePath:l,basename:v})}a(f)}u({rootEntries:g,pathToEntries:p},f,t){const a=this,l=this.a;function v(b){const E=(0,S.hasSiblingFn)(()=>b.map(w=>w.basename));for(let w=0,r=b.length;w<r;w++){const o=b[w],{relativePath:s,basename:d}=o;if(f.matchesExcludesSync(s,d,l!==d?E:void 0))continue;const c=p[s];if(c)v(c);else{if(s===l)continue;a.v(t,o)}if(a.e)break}}v(g)}v(g,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||g(p))}}class N{constructor(){this.b=new Map}fileSearch(g,p,f,t){const a=this.c(g.cacheKey),l=new k(g,p,a&&a.token);let v=0;const b=E=>{v+=E.length,f(E.map(w=>this.d(w)))};return this.e(l,N.a,b,t).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:E.stats}}))}clearCache(g){this.c(g)?.cancel()}c(g){if(!!g)return this.b.has(g)||this.b.set(g,new T.CancellationTokenSource),this.b.get(g)}d(g){return g.relativePath?{resource:C.joinPath(g.base,g.relativePath)}:{resource:g.base}}e(g,p,f,t){t.onCancellationRequested(()=>{g.cancel()});const a=v=>{v&&(l.push(v),p>0&&l.length>=p&&(f(l),l=[]))};let l=[];return g.search(a).then(v=>(l.length&&f(l),v),v=>(l.length&&f(l),Promise.reject(v)))}}e.FileSearchManager=N,N.a=512}),define(Ce[237],ke([1,0,16,80,35,84,28,13,19,22,10,9,2,253,148,40,12,51,95,235,44]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a,l,v,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(m,P,M,V,Z){this.a=m,this.b=P,this.c=M,this.d=V,this.e=Z}text(m,P,M={}){m=this.f(m,M);const V=this.a.getValue(),Z=P&&P.some(R=>!this.a.getValue({resource:R}).search.useRipgrep);return{...this.h(P?.map(l.toWorkspaceFolder),M),type:2,contentPattern:m,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:V.search.usePCRE2||Z||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}f(m,P){const M=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const V={...m,wordSeparators:M.editor.wordSeparators};return this.j(m,P)&&(V.isCaseSensitive=!0),this.k(m)&&(V.isMultiline=!0),V}file(m,P={}){return{...this.h(m,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}g(m,P){return m?(m=Array.isArray(m)?m.map(c):c(m),P?this.parseSearchPaths(m):{pattern:o(...Array.isArray(m)?m:[m])}):{}}h(m=[],P={}){const M=this.g(P.includePattern,P.expandPatterns),V=this.g(P.excludePattern,P.expandPatterns),Z=m.length>1,G=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(O=>this.q(O,P,V)):m.map(O=>this.r(O,P,V,Z))).filter(O=>!!O),R={_reason:P._reason,folderQueries:G,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:V.pattern,includePattern:M.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const O=i.coalesce(i.flatten(this.c.groups.map(j=>j.editors.map(K=>K.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const B=O.filter(j=>(0,E.pathIncludedInQuery)(R,j.fsPath)),z=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...R,...z}}const A=P.extraFileResources&&P.extraFileResources.filter(O=>(0,E.pathIncludedInQuery)(R,O.fsPath));return R.extraFileResources=A&&A.length?A:void 0,R}i(m){const P=[],M=new C.ResourceMap,V={};let Z=!1;return m.forEach(G=>{if(G.scheme===F.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(G)){const A=this.b.getWorkspaceFolder(G)?.uri??G.with({path:S.dirname(G.fsPath)});let O=M.get(A);O||(Z=!0,O={folder:A,includePattern:{}},P.push(O),M.set(A,O));const B=S.relative(A.fsPath,G.fsPath);(0,D.assertIsDefined)(O.includePattern)[B.replace(/\\/g,"/")]=!0}else G.fsPath&&(Z=!0,V[G.fsPath]=!0)}),{folderQueries:P,includePattern:V,usingSearchPaths:!0,excludePattern:Z?void 0:{"**/*":!0}}}j(m,P){if(P.isSmartCase){if(m.isRegExp){if(N.containsUppercaseCharacter(m.pattern,!0))return!0}else if(N.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,p.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const P=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),V=(Array.isArray(m)?m:s(m)).map(z=>{const j=this.e.resolvedUserHome;return j?(0,L.untildify)(z,j.scheme===F.Schemas.file?j.fsPath:j.path):z}),Z=T.groupBy(V,z=>P(z)?"searchPaths":"exprSegments"),G=(Z.exprSegments||[]).map(z=>N.rtrim(z,"/")).map(z=>N.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),d(z))),R={},A=this.m(Z.searchPaths||[]);A&&A.length&&(R.searchPaths=A);const O=i.flatten(G),B=o(...O);return B&&(R.pattern=B),R}l(m,P){return P.disregardExcludeSettings?void 0:(0,E.getExcludes)(m,!P.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const P=m.flatMap(V=>{let{pathPortion:Z,globPortion:G}=r(V);return G&&(G=u(G)),this.n(Z).flatMap(A=>this.o(A,G))}),M=new Map;return P.forEach(V=>{const Z=V.searchPath.toString(),G=M.get(Z);G?V.pattern&&(G.pattern=G.pattern||{},G.pattern[V.pattern]=!0):M.set(Z,{searchPath:V.searchPath,pattern:V.pattern?o(V.pattern):void 0})}),Array.from(M.values())}n(m){if(S.isAbsolute(m)){const P=this.b.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==F.Schemas.file?[{searchPath:P[0].uri.with({path:m})}]:[{searchPath:g.URI.file(S.normalize(m))}]}if(this.b.getWorkbenchState()===2){const P=this.b.getWorkspace().folders[0].uri;if(m=c(m),m.startsWith("../")||m===".."){const V=S.posix.resolve(P.path,m);return[{searchPath:P.with({path:V})}]}const M=u(m);return[{searchPath:P,pattern:M}]}else{if(m==="./"||m===".\\")return[];{const P=m.replace(/^\.[\/\\]/,""),V=this.b.getWorkspace().folders.map(Z=>{const G=P.match(new RegExp(`^${N.escapeRegExpCharacters(Z.name)}(?:/(.*)|$)`));return G?{match:G,folder:Z}:null}).filter(D.isDefined);if(V.length)return V.map(Z=>{const G=Z.match[1];return{searchPath:Z.folder.uri,pattern:G&&u(G)}});{const Z=m.match(/\.[\/\\](.+)[\/\\]?/),G=Z?Z[1]:m,R=f.localize(0,null,G);throw new Error(R)}}}}o(m,P){const M=m.pattern&&P?`${m.pattern}/${P}`:m.pattern||P,V=[{searchPath:m.searchPath,pattern:M}];return M&&!M.endsWith("**")&&V.push({searchPath:m.searchPath,pattern:M+"/**"}),V}q(m,P,M){const V=this.r((0,l.toWorkspaceFolder)(m.searchPath),P,M,!1);return V?{...V,includePattern:m.pattern}:null}r(m,P,M,V){let Z;const G=g.URI.isUri(m)?m:m.uri;if(M.searchPaths){const z=M.searchPaths.filter(j=>(0,k.isEqual)(j.searchPath,G))[0];if(z&&!z.pattern)return null;z&&(Z=z.pattern)}const R=this.a.getValue({resource:G}),O={...this.l(R,P)||{},...Z||{}},B=g.URI.isUri(m)?(0,k.basename)(m):m.name;return{folder:G,folderName:V?B:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:R.files&&R.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!R.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!R.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof P.disregardParentIgnoreFiles=="boolean"?P.disregardParentIgnoreFiles:!R.search.useParentIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!R.search.followSymlinks}}};w=qe([je(0,t.IConfigurationService),je(1,l.IWorkspaceContextService),je(2,v.IEditorGroupsService),je(3,a.ILogService),je(4,b.IPathService)],w),e.QueryBuilder=w;function r(h){const m=h.match(/[\*\{\}\(\)\[\]\?]/);if(m){const P=m.index,M=h.substr(0,P).match(/[/|\\][^/\\]*$/);if(M){let V=h.substr(0,M.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:h.substr((M.index||0)+1)}}}return{pathPortion:h}}function o(...h){return h.length?h.reduce((m,P)=>(m[P]=!0,m),Object.create(null)):void 0}function s(h){return y.splitGlobAware(h,",").map(m=>m.trim()).filter(m=>!!m.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function c(h){return h.replace(/\\/g,"/")}function u(h){return c(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(h,m){h=i.distinct(h,V=>V.toString());const P=[],M=m.getWorkspace();return h&&h.forEach(V=>{let Z;if(m.getWorkbenchState()===2)Z=(0,k.relativePath)(M.folders[0].uri,V),Z&&Z!=="."&&(Z="./"+Z);else{const G=m.getWorkspaceFolder(V);if(G){const R=G.name;if(M.folders.filter(O=>O.name===R).length===1){const O=(0,k.relativePath)(G.uri,V);O===""?Z=`./${G.name}`:Z=`./${G.name}/${O}`}else Z=V.fsPath}}Z&&P.push(Z)}),P}e.resolveResourcesForSearchIncludes=n}),define(Ce[238],ke([1,0,22,2,20,11,3,237,44,51]),function(ee,e,i,T,y,L,C,F,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function D(t,a){const l=a.activationEvents;if(!l)return Promise.resolve(void 0);const v=[],b=[];for(const d of l)if(/^workspaceContains:/.test(d)){const c=d.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||t.forceUsingSearch?b.push(c):v.push(c)}if(v.length===0&&b.length===0)return Promise.resolve(void 0);let E;const w=new Promise((d,c)=>{E=d}),r=d=>E({activationEvent:d}),o=Promise.all(v.map(d=>g(t,d,r))).then(()=>{}),s=p(t,a.identifier,b,r);return Promise.all([o,s]).then(()=>{E(void 0)}),w}e.checkActivateWorkspaceContainsExtension=D;async function g(t,a,l){for(const v of t.folders)if(await t.exists(i.joinPath(T.URI.revive(v),a))){l(`workspaceContains:${a}`);return}}async function p(t,a,l,v){if(l.length===0)return Promise.resolve(void 0);const b=new y.CancellationTokenSource,E=t.checkExists(t.folders,l,b.token),w=setTimeout(async()=>{b.cancel(),t.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},N);let r=!1;try{r=await E}catch(o){L.isCancellationError(o)||L.onUnexpectedError(o)}b.dispose(),clearTimeout(w),r&&v(`workspaceContains:${l.join(",")}`)}function f(t,a,l,v){const b=t.get(C.IInstantiationService),E=t.get(S.ISearchService),r=b.createInstance(F.QueryBuilder).file(a.map(o=>(0,k.toWorkspaceFolder)(T.URI.revive(o))),{_reason:"checkExists",includePattern:l,exists:!0});return E.fileSearch(r,v).then(o=>!!o.limitHit,o=>L.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ce[33],ke([1,0,135,19,79,22,14,7,46,2,12,5,32,182,77,31,26,96,11,25,24,167,6,92,3,27,78,15,64,66,59,4,238,76,169,13,75,74]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a,l,v,b,E,w,r,o,s,d,c,u,n,h,m,P,M,V,Z,G,R,A){"use strict";var O,B,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let j=class Mi extends F.Disposable{constructor(re,_,le,Ee,Ae,Be,xe,Te,Ie,Se,se){super(),this.a=this.B(new P.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=_,this.g=le,this.f=xe,this.j=Ee,this.k=Ae,this.l=Be,this.m=Ie,this.p=Se,this.s=se,this.t=this.g.getProxy(D.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(D.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(D.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const ce=(0,a.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new l.ExtensionDescriptionRegistry(me(this.F,ce)),this.G=new f.ExtHostStorage(this.g,this.l),this.H=new V.ExtHostSecretState(this.g),this.I=Te,this.h=re.createChild(new n.ServiceCollection([f.IExtHostStorage,this.G],[V.IExtHostSecretState,this.H])),this.J=this.B(new p.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(Y,I,$)=>{this.v.$onExtensionActivationError(Y,v.transformErrorForSerialization(I),$)},actualActivateExtension:async(Y,I)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(Y,this.D,this.F))return await this.v.$activateExtension(Y,I),new p.HostExtension;const $=this.D.getExtensionDescription(Y);return this.Y($,I)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),y.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(re){v.onUnexpectedError(re)}}async Q(){this.I.onWillDeactivateAll();let re=[];try{re=this.D.getAllExtensionDescriptions().map(Ae=>Ae.identifier).filter(Ae=>this.isActivated(Ae)).map(Ae=>this.X(Ae))}catch{}await Promise.all(re)}terminate(re,_=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${re}`),this.l.flush(),this.p.dispose(),this.J.dispose(),v.setUnexpectedErrorHandler(Ee=>{this.l.error(Ee)}),this.g.dispose();const le=this.Q();Promise.race([(0,C.timeout)(5e3),le]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${_}`):this.l.info(`Extension host exiting with code ${_}`),this.l.flush(),this.l.dispose(),this.c.exit(_)})}isActivated(re){return this.z.isOpen()?this.J.isActivated(re):!1}async getExtension(re){const _=await this.v.$getExtension(re);let le;if(_?.browserNlsBundleUris){le={};for(const Ee of Object.keys(_.browserNlsBundleUris))le[Ee]=k.URI.revive(_.browserNlsBundleUris[Ee])}return _&&{..._,identifier:new b.ExtensionIdentifier(_.identifier.value),extensionLocation:k.URI.revive(_.extensionLocation),browserNlsBundleUris:le}}R(re,_){return this.J.activateByEvent(re,_)}S(re,_){return this.J.activateById(re,_)}activateByIdWithErrors(re,_){return this.S(re,_).then(()=>{const le=this.J.getActivatedExtension(re);if(le.activationFailed)return Promise.reject(le.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(re=>this.D)}getExtensionExports(re){return this.z.isOpen()?this.J.getActivatedExtension(re).exports:null}async U(re){if(re.scheme!==G.Schemas.file)return re;const _=await this.c.realpath(re.fsPath);return k.URI.file(_)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(re=>new oe(re))),this.L}async W(re){const _=S.TernarySearchTree.forUris(le=>L.extUriBiasedIgnorePathCase.ignorePathCasing(le));return await Promise.all(re.map(async le=>{if(this.ob(le)){const Ee=await this.U(le.extensionLocation);_.set(Ee,le)}})),_}X(re){let _=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(re))return _;const le=this.J.getActivatedExtension(re);if(!le)return _;try{typeof le.module.deactivate=="function"&&(_=Promise.resolve(le.module.deactivate()).then(void 0,Ee=>(this.l.error(Ee),Promise.resolve(void 0))))}catch(Ee){this.l.error(`An error occurred when deactivating the extension '${re.value}':`),this.l.error(Ee)}try{(0,F.dispose)(le.subscriptions)}catch(Ee){this.l.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this.l.error(Ee)}return _}async Y(re,_){return this.f.remote.isRemote?this.v.$onWillActivateExtension(re.identifier):await this.v.$onWillActivateExtension(re.identifier),this.ab(re,_).then(le=>{const Ee=le.activationTimes;return this.v.$onDidActivateExtension(re.identifier,Ee.codeLoadingTime,Ee.activateCallTime,Ee.activateResolvedTime,_),this.Z(re,_,"success",Ee),le},le=>{throw this.Z(re,_,"failure"),le})}Z(re,_,le,Ee){const Ae=K(re,_);this.u.$publicLog2("extensionActivationTimes",{...Ae,...Ee||{},outcome:le})}ab(re,_){const le=K(re,_);this.u.$publicLog2("activatePlugin",le);const Ee=this.ob(re);if(!Ee)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${_.startup}, activationEvent: '${_.activationEvent}'${re.identifier.value!==_.extensionId.value?`, root cause: ${_.extensionId.value}`:""}`),this.l.flush();const Ae=new p.ExtensionActivationTimesBuilder(_.startup);return Promise.all([this.pb(re,(0,L.joinPath)(re.extensionLocation,Ee),Ae),this.bb(re)]).then(Be=>(y.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Mi.cb(this.l,re.identifier,Be[0],Be[1],Ae))).then(Be=>(y.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),Be))}bb(re){const _=new w.ExtensionGlobalMemento(re,this.G),le=new w.ExtensionMemento(re.identifier.value,!1,this.G),Ee=new Z.ExtensionSecrets(re,this.H),Ae=re.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Be=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([_.whenReady,le.whenReady,this.I.whenReady]).then(()=>{const xe=this;let Te,Ie;const Se=(0,a.isProposedApiEnabled)(re,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:_,workspaceState:le,secrets:Ee,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(se){return T.join(re.extensionLocation.fsPath,se)},get storagePath(){return xe.I.workspaceValue(re)?.fsPath},get globalStoragePath(){return xe.I.globalValue(re).fsPath},get logPath(){return T.join(xe.f.logsLocation.fsPath,re.identifier.value)},get logUri(){return k.URI.joinPath(xe.f.logsLocation,re.identifier.value)},get storageUri(){return xe.I.workspaceValue(re)},get globalStorageUri(){return xe.I.globalValue(re)},get extensionMode(){return Ae},get extension(){return Te===void 0&&(Te=new ie(xe,re.identifier,re,Be,!1)),Te},get extensionRuntime(){return(0,a.checkProposedApiEnabled)(re,"extensionRuntime"),xe.extensionRuntime},get environmentVariableCollection(){return xe.p.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!Ie){if(!Se)return;const se=P.Event.buffer(P.Event.fromDOMEventEmitter(Se,"message",ce=>ce.data));Se.start(),Ie={onDidReceiveMessage:se,postMessage:Se.postMessage.bind(Se)}}return Ie}})})}static cb(re,_,le,Ee,Ae){return le=le||{activate:void 0,deactivate:void 0},this.db(re,_,le,Ee,Ae).then(Be=>new p.ActivatedExtension(!1,null,Ae.build(),le,Be,Ee.subscriptions))}static db(re,_,le,Ee,Ae){if(typeof le.activate=="function")try{Ae.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${_.value}`);const Be=typeof global=="object"?global:self,xe=le.activate.apply(Be,[Ee]);return Ae.activateCallStop(),Ae.activateResolveStart(),Promise.resolve(xe).then(Te=>(Ae.activateResolveStop(),Te))}catch(Be){return Promise.reject(Be)}else return Promise.resolve(le)}eb(re,_){this.S(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:_}).then(void 0,le=>{this.l.error(le)})}fb(){this.v.$setPerformanceMarks(y.getMarks());for(const re of this.D.getAllExtensionDescriptions())if(re.activationEvents)for(const _ of re.activationEvents)_==="onStartupFinished"&&this.eb(re,_)}gb(){const re=this.R("*",!0).then(void 0,Ae=>{this.l.error(Ae)});this.B(this.j.onDidChangeWorkspace(Ae=>this.hb(Ae.added)));const _=this.j.workspace?this.j.workspace.folders:[],le=this.hb(_),Ee=Promise.all([re,le]).then(()=>{});return Promise.race([Ee,(0,C.timeout)(1e4)]).then(()=>{this.fb()}),Ee}hb(re){return re.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(_=>this.ib(re,_))).then(()=>{})}async ib(re,_){if(this.isActivated(_.identifier))return;const le=!this.f.remote.isRemote&&!!this.f.remote.authority,Ee={logService:this.l,folders:re.map(Be=>Be.uri),forceUsingSearch:le,exists:Be=>this.c.exists(Be.fsPath),checkExists:(Be,xe,Te)=>this.t.$checkExists(Be,xe,Te)},Ae=await(0,M.checkActivateWorkspaceContainsExtension)(Ee,_);if(!!Ae)return this.S(_.identifier,{startup:!0,extensionId:_.identifier,activationEvent:Ae.activationEvent}).then(void 0,Be=>this.l.error(Be))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(re){throw console.error(re),re}}async jb(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:_}=this.f.environment;if(!re||!_)throw new Error(i.localize(0,null));const le=await this.pb(null,_,new p.ExtensionActivationTimesBuilder(!1));if(!le||typeof le.run!="function")throw new Error(i.localize(1,null,_.toString()));return new Promise((Ee,Ae)=>{const Be=(Ie,Se)=>{Ie?Ae(Ie):Ee(typeof Se=="number"&&Se>0?1:0)},xe=(0,L.originalFSPath)(_),Te=le.run(xe,Be);Te&&Te.then&&Te.then(()=>{Ee(0)}).catch(Ie=>{Ae(Ie instanceof Error&&Ie.stack?Ie.stack:String(Ie))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,_){return this.M[re]=_,(0,F.toDisposable)(()=>{delete this.M[re]})}async lb(re){const _=re.indexOf("+");if(_===-1)throw new Error("Not an authority that can be resolved!");const le=re.substr(0,_);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${le}`,!1),{authorityPrefix:le,resolver:this.M[le]}}async $resolveAuthority(re,_){const le=A.StopWatch.create(!1),Ee=()=>`[resolveAuthority(${ue(re)},${_})][${le.elapsed()}ms] `,Ae=Se=>this.l.info(`${Ee()}${Se}`),Be=(Se,se=void 0)=>this.l.error(`${Ee()}${Se}`,se);Ae("activating resolver...");const{authorityPrefix:xe,resolver:Te}=await this.lb(re);if(!Te)return Be("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${xe}.`,detail:void 0}};const Ie=new C.IntervalTimer;try{Ae("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Te)),Ie.cancelAndSet(()=>Ae("waiting..."),1e3),Ae("invoking resolve()..."),y.mark(`code/extHost/willResolveAuthority/${xe}`);const Se=await Te.resolve(re,{resolveAttempt:_});y.mark(`code/extHost/didResolveAuthorityOK/${xe}`),Ie.dispose(),Ae(`returned ${Se.host}:${Se.port}`);const se={authority:re,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},ce={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:se,options:ce,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(y.mark(`code/extHost/didResolveAuthorityError/${xe}`),Ie.dispose(),Be("returned an error",Se),Se instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(re,_){this.l.info(`$getCanonicalURI invoked for authority (${ue(re)})`);const{resolver:le}=await this.lb(re);if(!le)return null;const Ee=k.URI.revive(_);if(typeof le.getCanonicalURI>"u")return Ee;const Ae=await(0,C.asPromise)(()=>le.getCanonicalURI(Ee));return Ae||Ee}static mb(re,_,le){const Ee=new l.ExtensionDescriptionRegistry(re.getAllExtensionDescriptions());Ee.deltaExtensions(le.toAdd,le.toRemove);const Ae=(0,a.extensionIdentifiersArrayToSet)(_.getAllExtensionDescriptions().map(xe=>xe.identifier));for(const xe of le.myToRemove)Ae.delete(b.ExtensionIdentifier.toKey(xe));for(const xe of le.myToAdd)Ae.add(b.ExtensionIdentifier.toKey(xe));const Be=me(Ee,Ae);return{globalRegistry:Ee,myExtensions:Be}}$startExtensionHost(re){re.toAdd.forEach(Ee=>Ee.extensionLocation=k.URI.revive(Ee.extensionLocation));const{globalRegistry:_,myExtensions:le}=Mi.mb(this.F,this.D,re);return this.F.set(_.getAllExtensionDescriptions()),this.D.set(le),this.kb()}$activateByEvent(re,_){return _===1?this.R(re,!1):this.z.wait().then(le=>this.R(re,!1))}async $activate(re,_){return await this.z.wait(),this.D.getExtensionDescription(re)?(await this.S(re,_),!0):!1}async $deltaExtensions(re){re.toAdd.forEach(Be=>Be.extensionLocation=k.URI.revive(Be.extensionLocation));const{globalRegistry:_,myExtensions:le}=Mi.mb(this.F,this.D,re),Ee=await this.W(le);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this.F.set(_.getAllExtensionDescriptions()),this.D.set(le),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){const _=E.VSBuffer.alloc(re),le=Math.random()%256;for(let Ee=0;Ee<re;Ee++)_.writeUInt8(le,Ee);return _}async $updateRemoteConnectionData(re){this.P=re,this.a.fire()}};j=qe([je(0,s.IInstantiationService),je(1,e.IHostUtils),je(2,u.IExtHostRpcService),je(3,t.IExtHostWorkspace),je(4,g.IExtHostConfiguration),je(5,N.ILogService),je(6,d.IExtHostInitDataService),je(7,c.IExtensionStoragePaths),je(8,h.IExtHostTunnelService),je(9,m.IExtHostTerminalService),je(10,R.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function K(De,re){return{id:De.identifier.value,name:De.name,extensionVersion:De.version,publisherDisplayName:De.publisher,activationEvents:De.activationEvents?De.activationEvents.join(","):null,isBuiltin:De.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class ie{constructor(re,_,le,Ee,Ae){O.set(this,void 0),B.set(this,void 0),z.set(this,void 0),Je(this,O,re,"f"),Je(this,B,_,"f"),Je(this,z,le.identifier,"f"),this.id=le.identifier.value,this.extensionUri=le.extensionLocation,this.extensionPath=T.normalize((0,L.originalFSPath)(le.extensionLocation)),this.packageJSON=le,this.extensionKind=Ee,this.isFromDifferentExtensionHost=Ae}get isActive(){return Oe(this,O,"f").isActivated(Oe(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,O,"f").getExtensionExports(Oe(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,O,"f").activateByIdWithErrors(Oe(this,z,"f"),{startup:!1,extensionId:Oe(this,B,"f"),activationEvent:"api"}),this.exports}}e.Extension=ie,O=new WeakMap,B=new WeakMap,z=new WeakMap;function me(De,re){return De.getAllExtensionDescriptions().filter(_=>re.has(b.ExtensionIdentifier.toKey(_.identifier)))}function ue(De){const re=De.indexOf("+");return re===-1?De:De.substring(0,re)}class oe{constructor(re){this.a=re}setSearchTree(re){this.a=re}findSubstr(re){return this.a.findSubstr(re)}forEach(re){return this.a.forEach(re)}}e.ExtensionPaths=oe}),define(Ce[239],ke([1,0,79,2,5,32,26,25,15,27,3,33,49,12,10]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let t=class{constructor(w,r,o,s,d,c,u){this.c=w,this.d=r,this.e=o,this.f=s,this.g=d,this.h=c,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),i.mark("code/extHost/willWaitForConfig");const w=await this.f.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const r=await this.g.getExtensionPathIndex();this.register(new l(this.c,r,this.d,w,this.i)),this.register(this.e.createInstance(v,r)),this.register(this.e.createInstance(a)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,r,this.h.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const r of w.nodeModuleName)this.a.set(r,w);else this.a.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this.b.push(r=>w.alternativeModuleName(r))}};t=qe([je(2,N.IInstantiationService),je(3,L.IExtHostConfiguration),je(4,D.IExtHostExtensionService),je(5,k.IExtHostInitDataService),je(6,p.ILogService)],t),e.RequireInterceptor=t;let a=class en{constructor(w){if(w.environment.appRoot&&en.a.size){const r=(0,f.escapeRegExpCharacters)(this.c(w.environment.appRoot.fsPath)),o="[a-z0-9_.-]",s=`@${o}+\\/${o}+|${o}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${r}/${d}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(w){if(!this.b)return;const r=this.b.exec(this.c(w));if(!r)return;const[,o,s,d]=r,c=en.a.get(s);if(c!==void 0)return console.warn(`${s} as been renamed to ${c}, please update your imports`),o+c+d}c(w){return w.replace(/\\/g,"/")}};a.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),a=qe([je(0,k.IExtHostInitDataService)],a);class l{constructor(w,r,o,s,d){this.c=w,this.d=r,this.e=o,this.f=s,this.g=d,this.nodeModuleName="vscode",this.a=new Map}load(w,r){const o=this.d.findSubstr(r);if(o){let s=this.a.get(F.ExtensionIdentifier.toKey(o.identifier));return s||(s=this.c(o,this.e,this.f),this.a.set(F.ExtensionIdentifier.toKey(o.identifier),s)),s}if(!this.b){let s="";this.d.forEach((d,c)=>s+=`	${c} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${s}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let v=class{constructor(w,r,o){this.d=w,this.nodeModuleName="keytar",this.a=r.getProxy(y.MainContext.MainThreadTelemetry);const{environment:s}=o,d=r.getProxy(y.MainContext.MainThreadKeytar);if(s.appRoot){let c=s.appRoot.fsPath;g.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.b=new Set,this.b.add(`${c}/node_modules.asar/keytar`),this.b.add(`${c}/node_modules/keytar`)}this.c={getPassword:(c,u)=>d.$getPassword(c,u),setPassword:(c,u,n)=>d.$setPassword(c,u,n),deletePassword:(c,u)=>d.$deletePassword(c,u),findPassword:c=>d.$findPassword(c),findCredentials(c){return d.$findCredentials(c)}}}load(w,r){const o=this.d.findSubstr(r);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(w){const r=w.length;if(r<=7||!this.b)return;const o=r-7;if((w.charAt(o)==="/"||w.charAt(o)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.b.has(w)))return"keytar"}};v=qe([je(1,S.IExtHostRpcService),je(2,k.IExtHostInitDataService)],v);let b=class{constructor(w,r,o){this.e=w,this.f=r,this.nodeModuleName=["open","opn"],this.d=o.getProxy(y.MainContext.MainThreadTelemetry);const s=o.getProxy(y.MainContext.MainThreadWindow);this.c=(d,c)=>{const u=T.URI.parse(d);return c?this.g(d,c):u.scheme==="http"||u.scheme==="https"?s.$openUri(u,d,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?s.$openUri(u,d,{}):this.g(d,c)}}load(w,r,o){const s=this.e.findSubstr(r);return s&&(this.a=s.identifier.value,this.h()),this.b=o(w),this.c}g(w,r){return this.i(),this.b(w,r)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=qe([je(2,S.IExtHostRpcService)],b)}),define(Ce[106],ke([1,0,205,7,19,49,3,56,57,33,6,31,179,32]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class f extends g.AbstractVariableResolverService{constructor(l,v,b,E,w,r,o){function s(){if(b){const d=b.activeEditor();if(d)return d.document.uri;const c=E.tabGroups.all.find(u=>u.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof N.TextDiffTabInput||c.input instanceof N.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof N.TextTabInput||c.input instanceof N.NotebookEditorTabInput||c.input instanceof N.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:d=>{const c=r.folders.filter(u=>u.name===d);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(d,c)=>w.getConfiguration(void 0,d).get(c),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=s();if(d)return y.normalize(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const d=s();if(d){const c=v.getWorkspaceFolder(d);if(c)return y.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(b){const d=b.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(b){const d=b.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>l.getExtension(d)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(L.env))}}let t=class extends T.Disposable{constructor(l,v,b,E,w){super(),this.b=l,this.c=v,this.g=b,this.h=E,this.i=w,this.a=new i.Lazy(async()=>{const r=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.i,r,s,this.j())})}getResolver(){return this.a.getValue()}j(){}};t=qe([je(0,k.IExtHostExtensionService),je(1,D.IExtHostWorkspace),je(2,F.IExtHostDocumentsAndEditors),je(3,p.IExtHostConfiguration),je(4,S.IExtHostEditorTabs)],t),e.ExtHostVariableResolverProviderService=t}),define(Ce[107],ke([1,0,14,4,9,2,3,5,57,33,15,6,31,171,173,32,106]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,d,c,u,n,h){this.D=d,this.E=c,this.F=u,this.G=n,this.H=h,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new T.Emitter,this.n=new T.Emitter,this.o=new T.Emitter,this.u=new T.Emitter,this.k=s.getProxy(F.MainContext.MainThreadDebugService),this.z=new T.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(m=>{m.onDidChange(P=>{this.I(m)}),this.I(m)})}asDebugSourceUri(s,d){const c=s;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let u=`debug:${encodeURIComponent(c.path||"")}`,n="?";return d&&(u+=`${n}session=${encodeURIComponent(d.id)}`,n="&"),u+=`${n}ref=${c.sourceReference}`,L.URI.parse(u)}else{if(c.path)return L.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(s){const d=[];for(const c of s.getAllExtensionDescriptions())if(c.contributes){const u=c.contributes.debuggers;if(u&&u.length>0)for(const n of u)(0,f.isDebuggerMainContribution)(n)&&d.push(n.type)}this.k.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const s=[];return this.w.forEach(d=>s.push(d)),s}addBreakpoints(s){this.T();const d=s.filter(n=>{const h=n.id;return this.w.has(h)?!1:(this.w.set(h,n),!0)});this.U(d,[],[]);const c=[],u=new Map;for(const n of d)if(n instanceof D.SourceBreakpoint){let h=u.get(n.location.uri.toString());h||(h={type:"sourceMulti",uri:n.location.uri,lines:[]},u.set(n.location.uri.toString(),h),c.push(h)),h.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof D.FunctionBreakpoint&&c.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(s){this.T();const d=s.filter(h=>this.w.delete(h.id));this.U([],d,[]);const c=d.filter(h=>h instanceof D.SourceBreakpoint).map(h=>h.id),u=d.filter(h=>h instanceof D.FunctionBreakpoint).map(h=>h.id),n=d.filter(h=>h instanceof D.DataBreakpoint).map(h=>h.id);return this.k.$unregisterBreakpoints(c,u,n)}startDebugging(s,d,c){return this.k.$startDebugging(s?s.uri:void 0,d,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,d,c){if(!d)return new D.Disposable(()=>{});const u=this.d++;return this.f.push({type:s,handle:u,provider:d}),this.k.$registerDebugConfigurationProvider(s,c,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,u),new D.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==d),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(s,d,c){if(!c)return new D.Disposable(()=>{});if(!this.P(s,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.M(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:d,handle:u,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(d,u),new D.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(s,d){if(!d)return new D.Disposable(()=>{});const c=this.i++;return this.j.push({type:s,handle:c,factory:d}),new D.Disposable(()=>{this.j=this.j.filter(u=>u.factory!==d)})}async $runInTerminal(s,d){return Promise.resolve(void 0)}async $substituteVariables(s,d){let c;const u=await this.W(s);return u&&(c={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(c,d)}J(s,d){if(s.type==="implementation")return new w(s.implementation)}K(){}async $startDASession(s,d){const c=this,u=await this.V(d);return this.R(this.M(u.type),u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const h=this.L(n),m=this.J(h,u);if(!m)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const P=m;return this.A.set(s,P),this.Q(u).then(M=>(M&&this.B.set(s,M),P.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const Z=V,G={type:"response",seq:0,command:Z.command,request_seq:Z.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const R=await this.C.sign(Z.arguments.value);G.body={signature:R},P.sendResponse(G)}else throw new Error("no signer")}catch(R){G.success=!1,G.message=R.message,P.sendResponse(G)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(V),V=(0,f.convertToVSCPaths)(V,!0),c.k.$acceptDAMessage(s,V)}),P.onError(V=>{M&&M.onError&&M.onError(V),this.k.$acceptDAError(s,V.name,V.message,V.stack)}),P.onExit(V=>{M&&M.onExit&&M.onExit((0,y.withNullAsUndefined)(V),void 0),this.k.$acceptDAExit(s,(0,y.withNullAsUndefined)(V),void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),P.startSession()))})}$sendDAMessage(s,d){d=(0,f.convertToDAPaths)(d,!1);const c=this.B.get(s);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(d),this.A.get(s)?.sendMessage(d)}$stopDASession(s){const d=this.B.get(s);this.B.delete(s),d&&d.onWillStopSession&&d.onWillStopSession();const c=this.A.get(s);return this.A.delete(s),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const d=[],c=[],u=[];if(s.added)for(const n of s.added){const h=n.id;if(h&&!this.w.has(h)){let m;if(n.type==="function")m=new D.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")m=new D.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const P=L.URI.revive(n.uri);m=new D.SourceBreakpoint(new D.Location(P,new D.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}m._id=h,this.w.set(h,m),d.push(m)}}if(s.removed)for(const n of s.removed){const h=this.w.get(n);h&&(this.w.delete(n),c.push(h))}if(s.changed){for(const n of s.changed)if(n.id){const h=this.w.get(n.id);if(h){if(h instanceof D.FunctionBreakpoint&&n.type==="function"){const m=h;m.enabled=n.enabled,m.condition=n.condition,m.hitCondition=n.hitCondition,m.logMessage=n.logMessage,m.functionName=n.functionName}else if(h instanceof D.SourceBreakpoint&&n.type==="source"){const m=h;m.enabled=n.enabled,m.condition=n.condition,m.hitCondition=n.hitCondition,m.logMessage=n.logMessage,m.location=new D.Location(L.URI.revive(n.uri),new D.Position(n.line,n.character))}u.push(h)}}}this.U(d,c,u)}$provideDebugConfigurations(s,d,c){return(0,i.asPromise)(async()=>{const u=this.O(s);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(d);return u.provideDebugConfigurations(n,c)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(s,d,c,u){return(0,i.asPromise)(async()=>{const n=this.O(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.W(d);return n.resolveDebugConfiguration(h,c,u)})}$resolveDebugConfigurationWithSubstitutedVariables(s,d,c,u){return(0,i.asPromise)(async()=>{const n=this.O(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.W(d);return n.resolveDebugConfigurationWithSubstitutedVariables(h,c,u)})}async $provideDebugAdapter(s,d){const c=this.N(s);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.V(d);return this.R(c,u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(s){const d=await this.V(s);this.m.fire(d)}async $acceptDebugSessionTerminated(s){const d=await this.V(s);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,d){(await this.V(s))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(s,d){const u={session:await this.V(s),event:d.event,body:d.body};this.u.fire(u)}L(s){if(s instanceof D.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof D.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}M(s){const d=this.h.filter(c=>c.type===s);if(d.length>0)return d[0].factory}N(s){const d=this.h.filter(c=>c.handle===s);if(d.length>0)return d[0].factory}O(s){const d=this.f.filter(c=>c.handle===s);if(d.length>0)return d[0].provider}P(s,d){if(s.contributes){const c=s.contributes.debuggers;if(c&&c.length>0){for(const u of c)if(u.label&&u.type&&u.type===d)return!0}}return!1}Q(s){const c=s.configuration.type,u=this.j.filter(n=>n.type===c||n.type==="*").map(n=>(0,i.asPromise)(()=>n.factory.createDebugAdapterTracker(s)).then(h=>h,h=>null));return Promise.race([Promise.all(u).then(n=>{const h=n.filter(m=>!!m);if(h.length>0)return new E(h)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(s,d){const c=d.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new D.DebugAdapterServer(c));if(s){const n=await this.E.getExtensionRegistry();return(0,i.asPromise)(()=>s.createDebugAdapterDescriptor(d,this.S(d,n))).then(h=>{if(h)return h})}const u=await this.E.getExtensionRegistry();return Promise.resolve(this.S(d,u))}S(s,d){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(s,d,c){(s.length>0||d.length>0||c.length>0)&&this.z.fire(Object.freeze({added:s,removed:d,changed:c}))}async V(s){if(s)if(typeof s=="string"){const d=this.l.get(s);if(d)return d}else{let d=this.l.get(s.id);if(!d){const c=await this.W(s.folderUri),u=s.parent?this.l.get(s.parent):void 0;d=new v(this.k,s.id,s.type,s.name,c,s.configuration,u),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(s){if(s){const d=L.URI.revive(s);return this.D.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};l=qe([je(0,N.IExtHostRpcService),je(1,g.IExtHostWorkspace),je(2,k.IExtHostExtensionService),je(3,t.IExtHostConfiguration),je(4,S.IExtHostEditorTabs),je(5,a.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class v{constructor(s,d,c,u,n,h,m){this.d=s,this.f=d,this.g=c,this.h=u,this.i=n,this.j=h,this.k=m}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,d){return this.d.$customDebugAdapterRequest(this.f,s,d)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.ExtHostDebugSession=v;class b{constructor(s){this.value=Object.freeze({append(d){s.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=b;class E{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(d=>d.onError?d.onError(s):void 0)}onExit(s,d){this.d.forEach(c=>c.onExit?c.onExit(s,d):void 0)}}class w extends p.AbstractDebugAdapter{constructor(s){super(),this.h=s,s.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let r=class extends l{constructor(s,d,c,u,n,h){super(s,d,c,u,n,h)}};r=qe([je(0,N.IExtHostRpcService),je(1,g.IExtHostWorkspace),je(2,k.IExtHostExtensionService),je(3,t.IExtHostConfiguration),je(4,S.IExtHostEditorTabs),je(5,a.IExtHostVariableResolverProvider)],r),e.WorkerExtHostDebugService=r}),define(Ce[240],ke([1,0,11,79,2,5,231,12,63,64,27,153,15,53,33,71]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class a{static async installEarlyHandler(b){const E=b.get(F.ILogService),r=b.get(g.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(o=>{E.error(o);const s=i.transformErrorForSerialization(o);r.$onUnexpectedError(s)})}static async installFullHandler(b){const E=b.get(F.ILogService),w=b.get(g.IExtHostRpcService),r=b.get(f.IExtHostExtensionService),o=b.get(t.IExtHostTelemetry),s=w.getProxy(L.MainContext.MainThreadExtensionService),d=w.getProxy(L.MainContext.MainThreadErrors),c=await r.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(n,h)=>{let m="",P,M;for(const V of h)m+=`
	at ${V.toString()}`,M=V.getFileName(),!P&&M&&(P=c.findSubstr(y.URI.file(M)));return u.set(n,P?.identifier),`${n.name||"Error"}: ${n.message||""}${m}`},i.setUnexpectedErrorHandler(n=>{E.error(n);const h=i.transformErrorForSerialization(n),m=u.get(n);if(!m){d.$onUnexpectedError(h);return}s.$onExtensionRuntimeError(m,h);const P=o.onExtensionError(m,n);E.trace("forwarded error to extension?",P,m)})}}Error.stackTraceLimit=100;class l{constructor(b,E,w,r,o){this.a=w,this.b=new C.RPCProtocol(b,null,r),E=l.e(E,this.b);const s=new k.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());s.set(N.IExtHostInitDataService,{_serviceBrand:void 0,...E,messagePorts:o}),s.set(g.IExtHostRpcService,new g.ExtHostRpcService(this.b)),s.set(p.IURITransformerService,new p.URITransformerService(r)),s.set(f.IHostUtils,w);const d=new D.InstantiationService(s,!0);d.invokeFunction(a.installEarlyHandler),this.d=d.invokeFunction(c=>c.get(F.ILogService)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=d.invokeFunction(c=>c.get(f.IExtHostExtensionService)),this.c.initialize(),d.invokeFunction(a.installFullHandler)}async asBrowserUri(b){const E=this.b.getProxy(L.MainContext.MainThreadExtensionService);return y.URI.revive(await E.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,E){b.allExtensions.forEach(r=>{r.extensionLocation=y.URI.revive(E.transformIncomingURIs(r.extensionLocation));const o={};r.browserNlsBundleUris&&(Object.keys(r.browserNlsBundleUris).forEach(s=>o[s]=y.URI.revive(E.transformIncomingURIs(r.browserNlsBundleUris[s]))),r.browserNlsBundleUris=o)}),b.environment.appRoot=y.URI.revive(E.transformIncomingURIs(b.environment.appRoot));const w=b.environment.extensionDevelopmentLocationURI;return w&&(b.environment.extensionDevelopmentLocationURI=w.map(r=>y.URI.revive(E.transformIncomingURIs(r)))),b.environment.extensionTestsLocationURI=y.URI.revive(E.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=y.URI.revive(E.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=y.URI.revive(E.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=y.URI.revive(E.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=y.URI.revive(E.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=y.URI.revive(E.transformIncomingURIs(b.logsLocation)),b.logFile=y.URI.revive(E.transformIncomingURIs(b.logFile)),b.workspace=E.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=l}),define(Ce[241],ke([1,0,16,14,20,45,13,19,22,2,44]),function(ee,e,i,T,y,L,C,F,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(v,b,E,w){this.d=v,this.e=b,this.f=E,this.g=w,this.a=null,this.b=!1,this.c=0}search(v,b){const E=this.d.folderQueries||[],w=new y.CancellationTokenSource;return b.onCancellationRequested(()=>w.cancel()),new Promise((r,o)=>{this.a=new p(v);let s=!1;const d=(c,u)=>{if(!s&&!this.b){const n=this.h(c);t(c)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,s=!0,w.cancel(),c=this.j(c,this.d.maxResults-this.c));const h=this.h(c);this.c+=h,(h>0||!t(c))&&this.a.add(c,u)}};Promise.all(E.map((c,u)=>this.k(c,n=>d(n,u),w.token))).then(c=>{w.dispose(),this.a.flush();const u=c.some(n=>!!n&&!!n.limitHit);r({limitHit:this.b||u,messages:(0,i.flatten)(c.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},c=>{w.dispose();const u=(0,L.toErrorMessage)(c);o(new Error(u))})})}h(v){return t(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}j(v,b){const E=Array.isArray(v.ranges)?v.ranges:[v.ranges],w=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:E.slice(0,b),preview:{matches:w.slice(0,b),text:v.preview.text},uri:v.uri}}async k(v,b,E){const w=new N.QueryGlobTester(this.d,v),r=[],o={report:c=>{if(!this.l(c))return;const u=v.folder.scheme===C.Schemas.file?(0,N.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(c.uri))):void 0,n=S.relativePath(v.folder,c.uri);if(n){const h=w.includedInQuery(n,F.basename(n),u);(0,T.isThenable)(h)?r.push(h.then(m=>{m&&b(c)})):h&&b(c)}}},s=this.n(v),d=await this.e.provideTextSearchResults(g(this.d.contentPattern),s,o,E);return r.length&&await Promise.all(r),d}l(v){if(t(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(v){const b=(0,N.resolvePatternsForProvider)(this.d.includePattern,v.includePattern),E=(0,N.resolvePatternsForProvider)(this.d.excludePattern,v.excludePattern),w={folder:k.URI.from(v.folder),excludes:E,includes:b,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.f.toCanonicalName(v.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return w.usePCRE2=this.d.usePCRE2,w}}e.TextSearchManager=D;function g(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class p{constructor(v){this.e=v,this.b=-1,this.d=null,this.a=new a(512,b=>this.g(b))}add(v,b){this.d&&(this.b!==b||!S.isEqual(this.c,v.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:v.uri,results:[]}),this.d.results.push(f(v))}f(){const v=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,v)}flush(){this.f(),this.a.flush()}g(v){this.e(v)}}e.TextSearchResultsCollector=p;function f(l){return t(l)?{preview:{matches:(0,i.mapArrayOrNot)(l.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:l.preview.text},ranges:(0,i.mapArrayOrNot)(l.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function t(l){return!!l.preview}e.extensionResultIsMatch=t;class a{constructor(v,b){this.g=v,this.h=b,this.c=0,this.d=[],this.e=0}addItem(v,b){!v||this.j(v,b)}addItems(v,b){!v||this.k(v,b)}j(v,b){this.d.push(v),this.e+=b,this.l()}k(v,b){this.d=this.d.concat(v),this.e+=b,this.l()}l(){this.c<a.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},a.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=a,a.a=4e3,a.b=50}),define(Ce[108],ke([1,0,7,5,3,236,15,53,12,2,241]),function(ee,e,i,T,y,L,C,F,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let D=class{constructor(t,a,l){this.k=t,this.l=a,this.n=l,this.c=this.k.getProxy(T.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.FileSearchManager}o(t){return this.l.transformOutgoingScheme(t)}registerTextSearchProvider(t,a){if(this.g.has(t))throw new Error(`a text search provider for the scheme '${t}' is already registered`);this.g.add(t);const l=this.d++;return this.e.set(l,a),this.c.$registerTextSearchProvider(l,this.o(t)),(0,i.toDisposable)(()=>{this.g.delete(t),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(t,a){if(this.i.has(t))throw new Error(`a file search provider for the scheme '${t}' is already registered`);this.i.add(t);const l=this.d++;return this.h.set(l,a),this.c.$registerFileSearchProvider(l,this.o(t)),(0,i.toDisposable)(()=>{this.i.delete(t),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(t,a,l,v){const b=g(l),E=this.h.get(t);if(E)return this.j.fileSearch(b,E,w=>{this.c.$handleFileMatch(t,a,w.map(r=>r.resource))},v);throw new Error("unknown provider: "+t)}$clearCache(t){return this.j.clearCache(t),Promise.resolve(void 0)}$provideTextSearchResults(t,a,l,v){const b=this.e.get(t);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${t}`);const E=g(l);return this.q(E,b).search(r=>this.c.$handleTextMatch(t,a,r),v)}$enableExtensionHostSearch(){}q(t,a){return new N.TextSearchManager(t,a,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};D=qe([je(0,C.IExtHostRpcService),je(1,F.IURITransformerService),je(2,S.ILogService)],D),e.ExtHostSearch=D;function g(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(p),extraFileResources:f.extraFileResources&&f.extraFileResources.map(t=>k.URI.revive(t))}}e.reviveQuery=g;function p(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Ce[242],ke([1,0,63,103,31,101,32,38,56,59,105,107,108,77,66,73,102,58,37,76,71,57,212,12,183,106,75]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a,l,v,b,E,w,r,o,s,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,i.registerSingleton)(o.ILoggerService,r.ExtHostLoggerService,1),(0,i.registerSingleton)(o.ILogService,s.ExtHostLogService,1),(0,i.registerSingleton)(t.IExtHostApiDeprecationService,t.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(F.IExtHostCommands,F.ExtHostCommands,0),(0,i.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,i.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,i.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,i.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,1),(0,i.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch,0),(0,i.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage,0),(0,i.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask,0),(0,i.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,0),(0,i.registerSingleton)(a.IExtHostWindow,a.ExtHostWindow,0),(0,i.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace,0),(0,i.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,i.registerSingleton)(E.IExtHostTelemetry,E.ExtHostTelemetry,0),(0,i.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,0),(0,i.registerSingleton)(d.IExtHostVariableResolverProvider,d.ExtHostVariableResolverProviderService,0)}),define(Ce[243],ke([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(y){if(y&&this.a.has(y)){const L=this.a.get(y);return this.a.delete(y),L}}addDragOperationTransfer(y,L){this.a.set(y,L)}getRenderedTreeElement(y){if(this.b.has(y))return this.b.get(y)}addRenderedTreeItemElement(y,L){this.b.set(y,L)}removeRenderedTreeItemElement(y){this.b.has(y)&&this.b.delete(y)}}e.TreeviewsService=i}),define(Ce[244],ke([1,0,139,6,22,2,4,7,14,6,9,16,8,20,243,26]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(b,E){if((0,N.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let w;return Array.isArray(b.highlights)&&(w=b.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),w=w.length?w:void 0),{label:b.label,highlights:w}}}class l{constructor(E,w,r){this.d=E,this.e=w,this.f=r,this.a=new Map,this.b=new f.TreeviewsService;function o(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:s=>o(s)?this.i(s):Array.isArray(s)&&s.length>0?s.map(d=>o(d)?this.i(d):d):s})}registerTreeDataProvider(E,w,r){const o=this.createTreeView(E,{treeDataProvider:w},r);return{dispose:()=>o.dispose()}}createTreeView(E,w,r){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=w.dragAndDropController?.dropMimeTypes??[],s=w.dragAndDropController?.dragMimeTypes??[],d=!!w.dragAndDropController?.handleDrag,c=!!w.dragAndDropController?.handleDrop,u=this.h(E,w,r),n=this.d.$registerTreeViewDataProvider(E,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:o,dragMimeTypes:s,hasHandleDrag:d,hasHandleDrop:c});return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(r,"treeItemCheckbox"),u.onDidChangeCheckboxState},get message(){return u.message},set message(h){u.message=h},get title(){return u.title},set title(h){u.title=h},get description(){return u.description},set description(h){u.description=h},get badge(){return u.badge},set badge(h){h!==void 0&&k.ViewBadge.isViewBadge(h)?u.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(u.badge=void 0)},reveal:(h,m)=>u.reveal(h,m),dispose:async()=>{await n,this.a.delete(E),u.dispose()}}}$getChildren(E,w){const r=this.a.get(E);return r?r.getChildren(w):Promise.reject(new Error((0,i.localize)(0,null,E)))}async $handleDrop(E,w,r,o,s,d,c,u){const n=this.a.get(E);if(!n)return Promise.reject(new Error((0,i.localize)(1,null,E)));const h=g.DataTransfer.toDataTransfer(r,async m=>(await this.d.$resolveDropFileData(E,w,m)).buffer);return c===E&&u&&await this.g(h,n,u,s,d),n.onDrop(h,o,s)}async g(E,w,r,o,s){const d=this.b.removeDragOperationTransfer(s);if(d)(await d)?.forEach((c,u)=>{c&&E.set(u,c)});else if(s&&w.handleDrag){const c=w.handleDrag(r,E,o);this.b.addDragOperationTransfer(s,c),await c}return E}async $handleDrag(E,w,r,o){const s=this.a.get(E);if(!s)return Promise.reject(new Error((0,i.localize)(2,null,E)));const d=await this.g(new T.DataTransfer,s,w,o,r);if(!!d)return g.DataTransfer.toDataTransferDTO(d)}async $hasResolve(E){const w=this.a.get(E);if(!w)throw new Error((0,i.localize)(3,null,E));return w.hasResolve}$resolve(E,w,r){const o=this.a.get(E);if(!o)throw new Error((0,i.localize)(4,null,E));return o.resolveTreeItem(w,r)}$setExpanded(E,w,r){const o=this.a.get(E);if(!o)throw new Error((0,i.localize)(5,null,E));o.setExpanded(w,r)}$setSelection(E,w){const r=this.a.get(E);if(!r)throw new Error((0,i.localize)(6,null,E));r.setSelection(w)}$setFocus(E,w){const r=this.a.get(E);if(!r)throw new Error((0,i.localize)(7,null,E));r.setFocus(w)}$setVisible(E,w){const r=this.a.get(E);if(!r)throw new Error((0,i.localize)(8,null,E));r.setVisible(w)}$changeCheckboxState(E,w){const r=this.a.get(E);if(!r)throw new Error((0,i.localize)(9,null,E));r.setCheckboxState(w)}h(E,w,r){const o=new v(E,w,this.d,this.e.converter,this.f,r);return this.a.set(E,o),o}i(E){const w=this.a.get(E.$treeViewId);return w&&"$treeItemHandle"in E?w.getExtensionElement(E.$treeItemHandle):w&&"$focusedTreeItem"in E&&E.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=l;class v extends F.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(E=>this.getExtensionElement(E)).filter(E=>!(0,N.isUndefinedOrNull)(E))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(E,w,r,o,s,d){if(super(),this.C=E,this.D=r,this.F=o,this.G=s,this.H=d,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new p.CancellationTokenSource,d.contributes&&d.contributes.views)for(const n in d.contributes.views)for(const h of d.contributes.views[n])h.id===E&&(this.J=h.name);this.f=w.treeDataProvider,this.g=w.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let c,u;this.B(C.Event.debounce(this.w.event,(n,h)=>(n||(n={message:!1,elements:[]}),h.element!==!1&&(c||(c=new Promise(m=>u=m),this.y=this.y.then(()=>c)),Array.isArray(h.element)?n.elements.push(...h.element):n.elements.push(h.element)),h.message&&(n.message=!0),n),200,!0)(({message:n,elements:h})=>{h.length&&(this.z=this.z.then(()=>{const m=u;return c=null,this.U(h).then(()=>m())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(E){const w=E?this.getExtensionElement(E):void 0;if(E&&!w)return this.G.error(`No tree item with id '${E}' found.`),Promise.resolve([]);let r=this.Q(E);return r||(r=await this.R(w)),r?r.map(o=>o.item):void 0}getExtensionElement(E){return this.i.get(E)}reveal(E,w){w=w||{select:!0,focus:!1};const r=(0,N.isUndefinedOrNull)(w.select)?!0:w.select,o=(0,N.isUndefinedOrNull)(w.focus)?!1:w.focus,s=(0,N.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):E?this.y.then(()=>this.N(E)).then(d=>this.P(E,d[d.length-1]).then(c=>this.D.$reveal(this.C,{item:c.item,parentChain:d.map(u=>u.item)},{select:r,focus:o,expand:s})),d=>this.G.error(d)):this.D.$reveal(this.C,void 0,{select:r,focus:o,expand:s})}get message(){return this.I}set message(E){this.I=E,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(E){this.J=E,this.D.$setTitle(this.C,E,this.L)}get description(){return this.L}set description(E){this.L=E,this.D.$setTitle(this.C,this.J,E)}get badge(){return this.M}set badge(E){this.M?.value===E?.value&&this.M?.tooltip===E?.tooltip||(this.M=g.ViewBadge.from(E),this.D.$setBadge(this.C,E))}setExpanded(E,w){const r=this.getExtensionElement(E);r&&(w?this.r.fire(Object.freeze({element:r})):this.s.fire(Object.freeze({element:r})))}setSelection(E){(0,D.equals)(this.l,E)||(this.l=E,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(E){this.m=E}setVisible(E){E!==this.k&&(this.k=E,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(E){const w=(await Promise.all(E.map(async r=>{const o=this.getExtensionElement(r.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:r.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);w.forEach(r=>{r.treeItem.checkboxState=r.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.v.fire({items:w.map(r=>[r.extensionItem,r.newState])})}async handleDrag(E,w,r){const o=[];for(const s of E){const d=this.getExtensionElement(s);d&&o.push(d)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,w,r),w}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(E,w,r){const o=w?this.getExtensionElement(w):void 0;if(!(!o&&w||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(o,E,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(E,w){if(!this.f.resolveTreeItem)return;const r=this.i.get(E);if(r){const o=this.j.get(r);if(o){const s=await this.f.resolveTreeItem(o.extensionItem,r,w)??o.extensionItem;return this.db(s),o.item.tooltip=this.ab(s.tooltip),o.item.command=this.bb(o.disposableStore,s.command),o.item}}}N(E){return this.O(E).then(w=>w?this.N(w).then(r=>this.P(w,r[r.length-1]).then(o=>(r.push(o),r))):Promise.resolve([]))}O(E){const w=this.j.get(E);return w?Promise.resolve(w.parent?this.i.get(w.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(E))}P(E,w){const r=this.j.get(E);return r?Promise.resolve(r):(0,S.asPromise)(()=>this.f.getTreeItem(E)).then(o=>this.gb(E,o,w,!0)).then(o=>this.getChildren(w?w.item.handle:void 0).then(()=>{const s=this.getExtensionElement(o);if(s){const d=this.j.get(s);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}Q(E){if(E){let w;if(typeof E=="string"){const r=this.getExtensionElement(E);w=r?this.j.get(r):void 0}else w=E;return w&&w.children||void 0}return this.h}async R(E){this.nb(E);const w=new p.CancellationTokenSource(this.S.token);try{const r=E?this.j.get(E):void 0,o=await this.f.getChildren(E);if(w.token.isCancellationRequested)return;const s=await Promise.all((0,D.coalesce)(o||[]).map(async d=>{const c=await this.f.getTreeItem(d);return c&&!w.token.isCancellationRequested?this.Z(d,c,r):null}));return w.token.isCancellationRequested?void 0:(0,D.coalesce)(s)}finally{w.dispose()}}U(E){if(E.some(r=>!r))return this.S.dispose(!0),this.S=new p.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const r=this.W(E);if(r.length)return this.X(r)}return Promise.resolve(void 0)}W(E){const w=new Set,r=E.map(s=>this.j.get(s));for(const s of r)if(s&&!w.has(s.item.handle)){let d=s;for(;d&&d.parent&&r.findIndex(c=>d&&d.parent&&c&&c.item.handle===d.parent.item.handle)===-1;){const c=this.i.get(d.parent.item.handle);d=c?this.j.get(c):void 0}d&&!d.parent&&w.add(s.item.handle)}const o=[];return w.forEach(s=>{const d=this.i.get(s);if(d){const c=this.j.get(d);c&&(!c.parent||!w.has(c.parent.item.handle))&&o.push(s)}}),o}X(E){const w={};return Promise.all(E.map(r=>this.Y(r).then(o=>{o&&(w[r]=o.item)}))).then(()=>Object.keys(w).length?this.D.$refresh(this.C,w):void 0)}Y(E){const w=this.getExtensionElement(E);if(w){const r=this.j.get(w);if(r)return this.nb(w),(0,S.asPromise)(()=>this.f.getTreeItem(w)).then(o=>{if(o){const s=this.eb(w,o,r.parent);return this.lb(w,s,r,r.parent),r.dispose(),s}return null})}return Promise.resolve(null)}Z(E,w,r){const o=this.eb(E,w,r);if(w.id&&this.i.has(o.item.handle))throw new Error((0,i.localize)(10,null,w.id));return this.kb(E,o),this.mb(o,r),o}ab(E){return k.MarkdownString.isMarkdownString(E)?g.MarkdownString.from(E):E}bb(E,w){return w?{...this.F.toInternal(w,E),originalId:w.command}:void 0}cb(E){if(!E.checkboxState)return;let w,r;return typeof E.checkboxState=="number"?w=E.checkboxState:(w=E.checkboxState.state,r=E.checkboxState.tooltip),{isChecked:w===k.TreeItemCheckboxState.Checked,tooltip:r}}db(E){if(!k.TreeItem.isTreeItem(E,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(E,w,r){this.db(w);const o=new F.DisposableStore,s=this.gb(E,w,r),d=this.hb(w);return{item:{handle:s,parentHandle:r?r.item.handle:void 0,label:a(w.label,this.H),description:w.description,resourceUri:w.resourceUri,tooltip:this.ab(w.tooltip),command:this.bb(o,w.command),contextValue:w.contextValue,icon:d,iconDark:this.ib(w)||d,themeIcon:this.fb(w),collapsibleState:(0,N.isUndefinedOrNull)(w.collapsibleState)?k.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.cb(w)},extensionItem:w,parent:r,children:void 0,disposableStore:o,dispose(){o.dispose()}}}fb(E){return E.iconPath instanceof k.ThemeIcon?E.iconPath:void 0}gb(E,{id:w,label:r,resourceUri:o},s,d){if(w)return`${v.b}/${w}`;const c=a(r,this.H),u=s?s.item.handle:v.a;let n=c?c.label:o?(0,y.basename)(o):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const h=this.j.has(E)?this.j.get(E).item.handle:void 0,m=this.Q(s)||[];let P,M=0;do{if(P=`${u}/${M}:${n}`,d||!this.i.has(P)||h===P)break;M++}while(M<=m.length);return P}hb(E){if(E.iconPath&&!(E.iconPath instanceof k.ThemeIcon))return typeof E.iconPath=="string"||L.URI.isUri(E.iconPath)?this.jb(E.iconPath):this.jb(E.iconPath.light)}ib(E){if(E.iconPath&&!(E.iconPath instanceof k.ThemeIcon)&&E.iconPath.dark)return this.jb(E.iconPath.dark)}jb(E){return L.URI.isUri(E)?E:L.URI.file(E)}kb(E,w){this.i.set(w.item.handle,E),this.j.set(E,w)}lb(E,w,r,o){this.i.delete(w.item.handle),this.j.delete(E),w.item.handle!==r.item.handle&&this.i.delete(r.item.handle),this.kb(E,w);const s=this.Q(o)||[],d=s.filter(c=>c.item.handle===r.item.handle)[0];d&&s.splice(s.indexOf(d),1,w)}mb(E,w){w?(w.children||(w.children=[]),w.children.push(E)):(this.h||(this.h=[]),this.h.push(E))}nb(E){if(E){const w=this.j.get(E);if(w){if(w.children)for(const r of w.children){const o=this.i.get(r.item.handle);o&&this.ob(o)}w.children=void 0}}else this.pb()}ob(E){const w=this.j.get(E);if(w){if(w.children)for(const r of w.children){const o=this.i.get(r.item.handle);o&&this.ob(o)}this.j.delete(E),this.i.delete(w.item.handle),w.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(E=>E.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}v.a="0",v.b="1"}),define(Ce[245],ke([1,0,20,11,4,29,2,126,254,115,124,36,5,70,198,197,38,199,32,201,202,203,186,204,56,33,206,207,210,211,213,103,189,218,219,220,77,59,223,244,8,6,50,226,60,102,31,177,209,48,101,105,107,108,12,53,15,27,214,184,66,73,195,224,78,58,229,227,228,196,37,221,225,76,57,71,215,104,216,13,89,188,168,208,7,26,172,75,165,217]),function(ee,e,i,T,y,L,C,F,S,k,N,D,g,p,f,t,a,l,v,b,E,w,r,o,s,d,c,u,n,h,m,P,M,V,Z,G,R,A,O,B,z,j,K,ie,me,ue,oe,De,re,_,le,Ee,Ae,Be,xe,Te,Ie,Se,se,ce,Y,I,$,H,q,J,de,we,ae,pe,ve,We,He,tt,Xe,et,it,dt,Fe,st,Q,X,ge,Me,$e,Ve,Qe,nt,wt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ct(lt){const at=lt.get(Se.IExtHostInitDataService),Bt=lt.get(ve.IExtHostFileSystemInfo),Ot=lt.get(J.IExtHostConsumerFileSystem),Ft=lt.get(d.IExtHostExtensionService),ft=lt.get(oe.IExtHostWorkspace),Dt=lt.get(et.IExtHostTelemetry),$t=lt.get(v.IExtHostConfiguration),Nt=lt.get(Te.IURITransformerService),Ge=lt.get(Ie.IExtHostRpcService),Mt=lt.get(R.IExtHostStorage),Lt=lt.get(q.IExtensionStoragePaths),Ut=lt.get(xe.ILoggerService),mt=lt.get(xe.ILogService),kt=lt.get(Y.IExtHostTunnelService),ye=lt.get(I.IExtHostApiDeprecationService),Pe=lt.get(ue.IExtHostWindow),fe=lt.get(tt.IExtHostSecretState),x=lt.get(Xe.IExtHostEditorTabs);Ge.set(g.ExtHostContext.ExtHostFileSystemInfo,Bt),Ge.set(g.ExtHostContext.ExtHostLogLevelServiceShape,Ut),Ge.set(g.ExtHostContext.ExtHostWorkspace,ft),Ge.set(g.ExtHostContext.ExtHostConfiguration,$t),Ge.set(g.ExtHostContext.ExtHostExtensionService,Ft),Ge.set(g.ExtHostContext.ExtHostStorage,Mt),Ge.set(g.ExtHostContext.ExtHostTunnelService,kt),Ge.set(g.ExtHostContext.ExtHostWindow,Pe),Ge.set(g.ExtHostContext.ExtHostSecretState,fe),Ge.set(g.ExtHostContext.ExtHostTelemetry,Dt),Ge.set(g.ExtHostContext.ExtHostEditorTabs,x);const Re=Ge.set(g.ExtHostContext.ExtHostDecorations,lt.get(le.IExtHostDecorations)),Le=Ge.set(g.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(s.IExtHostDocumentsAndEditors)),_e=Ge.set(g.ExtHostContext.ExtHostCommands,lt.get(a.IExtHostCommands)),ze=Ge.set(g.ExtHostContext.ExtHostTerminalService,lt.get(A.IExtHostTerminalService)),Ze=Ge.set(g.ExtHostContext.ExtHostDebugService,lt.get(Ae.IExtHostDebugService)),bt=Ge.set(g.ExtHostContext.ExtHostSearch,lt.get(Be.IExtHostSearch)),vt=Ge.set(g.ExtHostContext.ExtHostTask,lt.get(Ee.IExtHostTask)),At=Ge.set(g.ExtHostContext.ExtHostOutputService,lt.get(P.IExtHostOutputService)),pt=Ge.set(g.ExtHostContext.ExtHostLocalization,lt.get(nt.IExtHostLocalizationService)),It=Ge.set(g.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(Ge)),ht=Ge.set(g.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Ge,Le)),xt=Ge.set(g.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Ge,Le,mt)),jt=Ge.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(mt,ht,Ge.getProxy(g.MainContext.MainThreadBulkEdits))),Et=Ge.set(g.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Ge,_e,Le,ht)),_t=Ge.set(g.ExtHostContext.ExtHostNotebookDocuments,new ge.ExtHostNotebookDocuments(Et)),oi=Ge.set(g.ExtHostContext.ExtHostNotebookEditors,new X.ExtHostNotebookEditors(mt,Et)),Zt=Ge.set(g.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,at,Et,_e,mt)),bi=Ge.set(g.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ge,Et)),Tt=Ge.set(g.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(Ge,Le)),ai=Ge.set(g.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Ge.getProxy(g.MainContext.MainThreadTreeViews),_e,mt)),Vt=Ge.set(g.ExtHostContext.ExtHostEditorInsets,new De.ExtHostEditorInsets(Ge.getProxy(g.MainContext.MainThreadEditorInsets),Tt,at.remote)),ei=Ge.set(g.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Ge,mt,Bt,Le)),ci=Ge.set(g.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(Ge,ht,_e.converter,Nt)),ct=Ge.set(g.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Ge,Nt,ht,_e,ei,mt,ye,Dt)),ti=Ge.set(g.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Ge,ct)),qt=Ge.set(g.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Ge,mt,Le)),Qt=Ge.set(g.ExtHostContext.ExtHostQuickOpen,(0,V.createExtHostQuickOpen)(Ge,ft,_e)),ui=Ge.set(g.ExtHostContext.ExtHostSCM,new Z.ExtHostSCM(Ge,_e,mt)),Ei=Ge.set(g.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ge,_e,ht)),li=Ge.set(g.ExtHostContext.ExtHostProgress,new M.ExtHostProgress(Ge.getProxy(g.MainContext.MainThreadProgress))),wi=Ge.set(g.ExtHostContext.ExtHosLabelService,new re.ExtHostLabelService(Ge)),di=Ge.set(g.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Ge)),ii=Ge.set(g.ExtHostContext.ExtHostAuthentication,new $.ExtHostAuthentication(Ge)),Li=Ge.set(g.ExtHostContext.ExtHostTimeline,new H.ExtHostTimeline(Ge,_e)),ni=Ge.set(g.ExtHostContext.ExtHostWebviews,new me.ExtHostWebviews(Ge,at.remote,ft,mt,ye)),ri=Ge.set(g.ExtHostContext.ExtHostWebviewPanels,new ae.ExtHostWebviewPanels(Ge,ni,ft)),Si=Ge.set(g.ExtHostContext.ExtHostCustomEditors,new we.ExtHostCustomEditors(Ge,ht,Lt,ni,ri)),yi=Ge.set(g.ExtHostContext.ExtHostWebviewViews,new de.ExtHostWebviewViews(Ge,ni)),si=Ge.set(g.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Ge,_e,Le)),Di=Ge.set(g.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ge)),Ii=Ge.set(g.ExtHostContext.ExtHostProfileContentHandlers,new St.ExtHostProfileContentHandlers(Ge));Ge.set(g.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ge,Et,Le,_e,mt));const Ui=Object.values(g.ExtHostContext);Ge.assertRegistered(Ui);const Bi=new pe.ExtHostBulkEdits(Ge,Le),$i=new t.ExtHostClipboard(Ge),Ci=new m.ExtHostMessageService(Ge,mt),Ai=new E.ExtHostDialogs(Ge),Ri=new G.ExtHostStatusBar(Ge,_e.converter);return f.ExtHostApiCommands.register(_e),function(Ue,Wt,Oi){const gt=function(){let ne=!Ue.isUnderDevelopment;function he(){ne||(mt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ne(rt){if(Array.isArray(rt))rt.forEach(Ne);else if(typeof rt=="string")he();else{const yt=rt;typeof yt.scheme>"u"&&he(),typeof yt.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return rt}}(),zi={getSession(ne,he,Ne){return ii.getSession(Ue,ne,he,Ne)},async hasSession(ne,he){return(0,Ve.checkProposedApiEnabled)(Ue,"authSession"),!!await ii.getSession(Ue,ne,he,{silent:!0})},get onDidChangeSessions(){return ii.onDidChangeSessions},registerAuthenticationProvider(ne,he,Ne,rt){return ii.registerAuthenticationProvider(ne,he,Ne,rt)}},hi={registerCommand(ne,he,Ne){return _e.registerCommand(!0,ne,he,Ne,void 0,Ue)},registerTextEditorCommand(ne,he,Ne){return _e.registerCommand(!0,ne,(...rt)=>{const yt=Tt.getActiveTextEditor();if(!yt){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return yt.edit(Pt=>{he.apply(Ne,[yt,Pt,...rt])}).then(Pt=>{Pt||mt.warn("Edits from command "+ne+" were not applied.")},Pt=>{mt.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,he,Ne)=>((0,Ve.checkProposedApiEnabled)(Ue,"diffCommand"),_e.registerCommand(!0,ne,async(...rt)=>{const yt=Le.activeEditor(!0);if(!yt){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(yt.id);he.apply(Ne,[Pt,...rt])},void 0,void 0,Ue)),executeCommand(ne,...he){return _e.executeCommand(ne,...he)},getCommands(ne=!1){return _e.getCommands(ne)}},Fi={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return $i.value},get shell(){return ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)(Ue,"envShellEvent"),ze.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ue,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ue,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(at.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,Ve.checkProposedApiEnabled)(Ue,"telemetryLogger"),Dt.instantiateLogger(Ue,ne)},openExternal(ne,he){return Pe.openUri(ne,{allowTunneling:!!at.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===at.environment.appUriScheme)return It.createAppUri(ne);try{return await Pe.asExternalUri(ne,{allowTunneling:!!at.remote.authority})}catch(he){if((0,Q.matchesScheme)(ne,st.Schemas.http)||(0,Q.matchesScheme)(ne,st.Schemas.https))return ne;throw he}},get remoteName(){return(0,_.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return mt.onDidChangeLogLevel}};at.environment.extensionTestsLocationURI||Object.freeze(Fi);const Wi={createTestController(ne,he,Ne){return si.createTestController(ne,he,Ne)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),si.createTestObserver()},runTests(ne){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),si.runTests(ne)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),si.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),si.results}},fi=at.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Hi={getExtension(ne,he){(0,Ve.isProposedApiEnabled)(Ue,"extensionsAny")||(he=!1);const Ne=Wt.mine.getExtensionDescription(ne);if(Ne)return new d.Extension(Ft,Ue.identifier,Ne,fi,!1);if(he){const rt=Wt.all.getExtensionDescription(ne);if(rt)return new d.Extension(Ft,Ue.identifier,rt,fi,!0)}},get all(){const ne=[];for(const he of Wt.mine.getAllExtensionDescriptions())ne.push(new d.Extension(Ft,Ue.identifier,he,fi,!1));return ne},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new Ve.ExtensionIdentifierSet(Wt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),he=[];for(const Ne of Wt.all.getAllExtensionDescriptions()){const rt=!ne.has(Ne.identifier);he.push(new d.Extension(Ft,Ue.identifier,Ne,fi,rt))}return he},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Ue,"extensionsAny")?y.Event.any(Wt.mine.onDidChange,Wt.all.onDidChange):Wt.mine.onDidChange}},ki={createDiagnosticCollection(ne){return ei.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:ne=>ei.getDiagnostics(ne),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ne,he){return ci.changeLanguage(ne.uri,he)},match(ne,he){const Ne=ht.getDocumentData(he.uri)?.notebook;return(0,N.score)(z.LanguageSelector.from(ne),he.uri,he.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ne,he,Ne){return ct.registerCodeActionProvider(Ue,gt(ne),he,Ne)},registerDocumentPasteEditProvider(ne,he,Ne){return(0,Ve.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,gt(ne),he,Ne)},registerCodeLensProvider(ne,he){return ct.registerCodeLensProvider(Ue,gt(ne),he)},registerDefinitionProvider(ne,he){return ct.registerDefinitionProvider(Ue,gt(ne),he)},registerDeclarationProvider(ne,he){return ct.registerDeclarationProvider(Ue,gt(ne),he)},registerImplementationProvider(ne,he){return ct.registerImplementationProvider(Ue,gt(ne),he)},registerTypeDefinitionProvider(ne,he){return ct.registerTypeDefinitionProvider(Ue,gt(ne),he)},registerHoverProvider(ne,he){return ct.registerHoverProvider(Ue,gt(ne),he,Ue.identifier)},registerEvaluatableExpressionProvider(ne,he){return ct.registerEvaluatableExpressionProvider(Ue,gt(ne),he,Ue.identifier)},registerInlineValuesProvider(ne,he){return ct.registerInlineValuesProvider(Ue,gt(ne),he,Ue.identifier)},registerDocumentHighlightProvider(ne,he){return ct.registerDocumentHighlightProvider(Ue,gt(ne),he)},registerLinkedEditingRangeProvider(ne,he){return ct.registerLinkedEditingRangeProvider(Ue,gt(ne),he)},registerReferenceProvider(ne,he){return ct.registerReferenceProvider(Ue,gt(ne),he)},registerRenameProvider(ne,he){return ct.registerRenameProvider(Ue,gt(ne),he)},registerDocumentSymbolProvider(ne,he,Ne){return ct.registerDocumentSymbolProvider(Ue,gt(ne),he,Ne)},registerWorkspaceSymbolProvider(ne){return ct.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,he){return ct.registerDocumentFormattingEditProvider(Ue,gt(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return ct.registerDocumentRangeFormattingEditProvider(Ue,gt(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Ne,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,gt(ne),he,[Ne].concat(rt))},registerDocumentSemanticTokensProvider(ne,he,Ne){return ct.registerDocumentSemanticTokensProvider(Ue,gt(ne),he,Ne)},registerDocumentRangeSemanticTokensProvider(ne,he,Ne){return ct.registerDocumentRangeSemanticTokensProvider(Ue,gt(ne),he,Ne)},registerSignatureHelpProvider(ne,he,Ne,...rt){return typeof Ne=="object"?ct.registerSignatureHelpProvider(Ue,gt(ne),he,Ne):ct.registerSignatureHelpProvider(Ue,gt(ne),he,typeof Ne>"u"?[]:[Ne,...rt])},registerCompletionItemProvider(ne,he,...Ne){return ct.registerCompletionItemProvider(Ue,gt(ne),he,Ne)},registerInlineCompletionItemProvider(ne,he){return he.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,gt(ne),he)},registerDocumentLinkProvider(ne,he){return ct.registerDocumentLinkProvider(Ue,gt(ne),he)},registerColorProvider(ne,he){return ct.registerColorProvider(Ue,gt(ne),he)},registerFoldingRangeProvider(ne,he){return ct.registerFoldingRangeProvider(Ue,gt(ne),he)},registerSelectionRangeProvider(ne,he){return ct.registerSelectionRangeProvider(Ue,ne,he)},registerCallHierarchyProvider(ne,he){return ct.registerCallHierarchyProvider(Ue,ne,he)},registerTypeHierarchyProvider(ne,he){return ct.registerTypeHierarchyProvider(Ue,ne,he)},setLanguageConfiguration:(ne,he)=>ct.setLanguageConfiguration(Ue,ne,he),getTokenInformationAtPosition(ne,he){return(0,Ve.checkProposedApiEnabled)(Ue,"tokenInformation"),ci.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return ct.registerInlayHintsProvider(Ue,ne,he)},createLanguageStatusItem(ne,he){return ci.createLanguageStatusItem(Ue,ne,he)},registerDocumentDropEditProvider(ne,he){return ct.registerDocumentOnDropEditProvider(Ue,ne,he)}},ji={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ze.activeTerminal},get terminals(){return ze.terminals},async showTextDocument(ne,he,Ne){const rt=await(C.URI.isUri(ne)?Promise.resolve(Kt.openTextDocument(ne)):Promise.resolve(ne));return Tt.showTextDocument(rt,he,Ne)},createTextEditorDecorationType(ne){return Tt.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,he,Ne){return Tt.onDidChangeActiveTextEditor(ne,he,Ne)},onDidChangeVisibleTextEditors(ne,he,Ne){return Tt.onDidChangeVisibleTextEditors(ne,he,Ne)},onDidChangeTextEditorSelection(ne,he,Ne){return Tt.onDidChangeTextEditorSelection(ne,he,Ne)},onDidChangeTextEditorOptions(ne,he,Ne){return Tt.onDidChangeTextEditorOptions(ne,he,Ne)},onDidChangeTextEditorVisibleRanges(ne,he,Ne){return Tt.onDidChangeTextEditorVisibleRanges(ne,he,Ne)},onDidChangeTextEditorViewColumn(ne,he,Ne){return Tt.onDidChangeTextEditorViewColumn(ne,he,Ne)},onDidCloseTerminal(ne,he,Ne){return ze.onDidCloseTerminal(ne,he,Ne)},onDidOpenTerminal(ne,he,Ne){return ze.onDidOpenTerminal(ne,he,Ne)},onDidChangeActiveTerminal(ne,he,Ne){return ze.onDidChangeActiveTerminal(ne,he,Ne)},onDidChangeTerminalDimensions(ne,he,Ne){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalDimensions"),ze.onDidChangeTerminalDimensions(ne,he,Ne)},onDidChangeTerminalState(ne,he,Ne){return ze.onDidChangeTerminalState(ne,he,Ne)},onDidWriteTerminalData(ne,he,Ne){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),ze.onDidWriteTerminalData(ne,he,Ne)},get state(){return Pe.state},onDidChangeWindowState(ne,he,Ne){return Pe.onDidChangeWindowState(ne,he,Ne)},showInformationMessage(ne,...he){return Ci.showMessage(Ue,L.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return Ci.showMessage(Ue,L.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return Ci.showMessage(Ue,L.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Ne){return Qt.showQuickPick(ne,he,Ne)},showWorkspaceFolderPick(ne){return Qt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Qt.showInput(ne,he)},showOpenDialog(ne){return Ai.showOpenDialog(ne)},showSaveDialog(ne){return Ai.showSaveDialog(ne)},createStatusBarItem(ne,he,Ne){let rt,yt,Pt;return typeof ne=="string"?(rt=ne,yt=he,Pt=Ne):(yt=ne,Pt=he),Ri.createStatusBarEntry(Ue,rt,yt,Pt)},setStatusBarMessage(ne,he){return Ri.setStatusBarMessage(ne,he)},withScmProgress(ne){return ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),li.withProgress(Ue,{location:j.ProgressLocation.SourceControl},(he,Ne)=>ne({report(rt){}}))},withProgress(ne,he){return li.withProgress(Ue,ne,he)},createOutputChannel(ne,he){return At.createOutputChannel(ne,he,Ue)},createWebviewPanel(ne,he,Ne,rt){return ri.createWebviewPanel(Ue,ne,he,Ne,rt)},createWebviewTextEditorInset(ne,he,Ne,rt){return(0,Ve.checkProposedApiEnabled)(Ue,"editorInsets"),Vt.createWebviewEditorInset(ne,he,Ne,rt,Ue)},createTerminal(ne,he,Ne){return typeof ne=="object"?"pty"in ne?ze.createExtensionTerminal(ne):ze.createTerminalFromOptions(ne):ze.createTerminal(ne,he,Ne)},registerTerminalLinkProvider(ne){return ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return ze.registerProfileProvider(Ue,ne,he)},registerTerminalQuickFixProvider(ne,he){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),ze.registerTerminalQuickFixProvider(ne,Ue.identifier.value,he)},registerTreeDataProvider(ne,he){return ai.registerTreeDataProvider(ne,he,Ue)},createTreeView(ne,he){return ai.createTreeView(ne,he,Ue)},registerWebviewPanelSerializer:(ne,he)=>ri.registerWebviewPanelSerializer(Ue,ne,he),registerCustomEditorProvider:(ne,he,Ne={})=>Si.registerCustomEditorProvider(Ue,ne,he,Ne),registerFileDecorationProvider(ne){return Re.registerFileDecorationProvider(ne,Ue)},registerUriHandler(ne){return It.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return Qt.createQuickPick(Ue)},createInputBox(){return Qt.createInputBox(Ue)},get activeColorTheme(){return di.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Ne){return di.onDidChangeActiveColorTheme(ne,he,Ne)},registerWebviewViewProvider(ne,he,Ne){return yi.registerWebviewViewProvider(Ue,ne,he,Ne?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Ne){return Et.onDidChangeActiveNotebookEditor(ne,he,Ne)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Ne){return oi.onDidChangeNotebookEditorSelection(ne,he,Ne)},onDidChangeNotebookEditorVisibleRanges(ne,he,Ne){return oi.onDidChangeNotebookEditorVisibleRanges(ne,he,Ne)},showNotebookDocument(ne,he){return Et.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Ne){return(0,Ve.checkProposedApiEnabled)(Ue,"externalUriOpener"),Di.registerExternalUriOpener(Ue.identifier,ne,he,Ne)},registerProfileContentHandler(ne,he){return(0,Ve.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Ii.registrProfileContentHandler(Ue,ne,he)},get tabGroups(){return x.tabGroups}},Kt={get rootPath(){return ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw T.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw T.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw T.readonly()},updateWorkspaceFolders:(ne,he,...Ne)=>ft.updateWorkspaceFolders(Ue,ne,he||0,...Ne),onDidChangeWorkspaceFolders:function(ne,he,Ne){return ft.onDidChangeWorkspace(ne,he,Ne)},asRelativePath:(ne,he)=>ft.getRelativePath(ne,he),findFiles:(ne,he,Ne,rt)=>ft.findFiles(ne,he,Ne,Ue.identifier,rt),findTextInFiles:(ne,he,Ne,rt)=>{(0,Ve.checkProposedApiEnabled)(Ue,"findTextInFiles");let yt,Pt;return typeof he=="object"?(yt=he,Pt=Ne):(yt={},Pt=he,rt=Ne),ft.findTextInFiles(ne,yt||{},Pt,Ue.identifier,rt)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne,he){return Bi.applyWorkspaceEdit(ne,Ue,he)},createFileSystemWatcher:(ne,he,Ne,rt)=>qt.createFileSystemWatcher(ft,Ue,ne,he,Ne,rt),get textDocuments(){return ht.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw T.readonly()},openTextDocument(ne){let he;const Ne=ne;if(typeof ne=="string")he=Promise.resolve(C.URI.file(ne));else if(C.URI.isUri(ne))he=Promise.resolve(ne);else if(!Ne||typeof Ne=="object")he=ht.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(rt=>ht.ensureDocumentData(rt).then(yt=>yt.document))},onDidOpenTextDocument:(ne,he,Ne)=>ht.onDidAddDocument(ne,he,Ne),onDidCloseTextDocument:(ne,he,Ne)=>ht.onDidRemoveDocument(ne,he,Ne),onDidChangeTextDocument:(ne,he,Ne)=>ht.onDidChangeDocument(ne,he,Ne),onDidSaveTextDocument:(ne,he,Ne)=>ht.onDidSaveDocument(ne,he,Ne),onWillSaveTextDocument:(ne,he,Ne)=>jt.getOnWillSaveTextDocumentEvent(Ue)(ne,he,Ne),get notebookDocuments(){return Et.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Ne;if(C.URI.isUri(ne))Ne=ne,await Et.openNotebookDocument(ne);else if(typeof ne=="string")Ne=C.URI.revive(await Et.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ne,he,Ne){return _t.onDidSaveNotebookDocument(ne,he,Ne)},onDidChangeNotebookDocument(ne,he,Ne){return _t.onDidChangeNotebookDocument(ne,he,Ne)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Ne,rt){return Et.registerNotebookSerializer(Ue,ne,he,Ne,(0,Ve.isProposedApiEnabled)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ne,he,Ne)=>Oi.onDidChangeConfiguration(ne,he,Ne),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,Oi.getConfiguration(ne,he,Ue)},registerTextDocumentContentProvider(ne,he){return xt.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Ue,ne,he)),registerFileSystemProvider(ne,he,Ne){return(0,$e.combinedDisposable)(ti.registerFileSystemProvider(Ue,ne,he,Ne),Ot.addFileSystemProvider(ne,he))},get fs(){return Ot.value},registerFileSearchProvider:(ne,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"fileSearchProvider"),bt.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"textSearchProvider"),bt.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),Ft.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),wi.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Ne)=>qt.onDidCreateFile(ne,he,Ne),onDidDeleteFiles:(ne,he,Ne)=>qt.onDidDeleteFile(ne,he,Ne),onDidRenameFiles:(ne,he,Ne)=>qt.onDidRenameFile(ne,he,Ne),onWillCreateFiles:(ne,he,Ne)=>qt.getOnWillCreateFileEvent(Ue)(ne,he,Ne),onWillDeleteFiles:(ne,he,Ne)=>qt.getOnWillDeleteFileEvent(Ue)(ne,he,Ne),onWillRenameFiles:(ne,he,Ne)=>qt.getOnWillRenameFileEvent(Ue)(ne,he,Ne),openTunnel:ne=>((0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),kt.openTunnel(Ue,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),kt.getTunnels()},onDidChangeTunnels:(ne,he,Ne)=>((0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),kt.onDidChangeTunnels(ne,he,Ne)),registerPortAttributesProvider:(ne,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"portsAttributes"),kt.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"timeline"),Li.registerTimelineProvider(ne,he,Ue.identifier,_e.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,Ve.checkProposedApiEnabled)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Ne)=>ft.onDidGrantWorkspaceTrust(ne,he,Ne),registerEditSessionIdentityProvider:(ne,he)=>((0,Ve.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,he))},mi={get inputBox(){return ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ui.getLastInputBox(Ue)},createSourceControl(ne,he,Ne){return ui.createSourceControl(Ue,ne,he,Ne)}},Vi={createCommentController(ne,he){return Ei.createCommentController(Ue,ne,he)}},zt={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(ne,he,Ne){return Ze.onDidStartDebugSession(ne,he,Ne)},onDidTerminateDebugSession(ne,he,Ne){return Ze.onDidTerminateDebugSession(ne,he,Ne)},onDidChangeActiveDebugSession(ne,he,Ne){return Ze.onDidChangeActiveDebugSession(ne,he,Ne)},onDidReceiveDebugSessionCustomEvent(ne,he,Ne){return Ze.onDidReceiveDebugSessionCustomEvent(ne,he,Ne)},onDidChangeBreakpoints(ne,he,Ne){return Ze.onDidChangeBreakpoints(ne,he,Ne)},registerDebugConfigurationProvider(ne,he,Ne){return Ze.registerDebugConfigurationProvider(ne,he,Ne||Qe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return Ze.registerDebugAdapterDescriptorFactory(Ue,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return Ze.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?Ze.startDebugging(ne,he,{parentSession:Ne}):Ze.startDebugging(ne,he,Ne||{})},stopDebugging(ne){return Ze.stopDebugging(ne)},addBreakpoints(ne){return Ze.addBreakpoints(ne)},removeBreakpoints(ne){return Ze.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return Ze.asDebugSourceUri(ne,he)}},gi={registerTaskProvider:(ne,he)=>vt.registerTaskProvider(Ue,ne,he),fetchTasks:ne=>vt.fetchTasks(ne),executeTask:ne=>vt.executeTask(Ue,ne),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ne,he,Ne)=>vt.onDidStartTask(ne,he,Ne),onDidEndTask:(ne,he,Ne)=>vt.onDidEndTask(ne,he,Ne),onDidStartTaskProcess:(ne,he,Ne)=>vt.onDidStartTaskProcess(ne,he,Ne),onDidEndTaskProcess:(ne,he,Ne)=>vt.onDidEndTaskProcess(ne,he,Ne)},qi={createNotebookController(ne,he,Ne,rt,yt){return Zt.createNotebookController(Ue,ne,he,Ne,rt,(0,Ve.isProposedApiEnabled)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>Et.registerNotebookCellStatusBarItemProvider(Ue,ne,he),createRendererMessaging(ne){return bi.createRendererMessaging(Ue,ne)},createNotebookControllerDetectionTask(ne){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ue,ne)},registerKernelSourceActionProvider(ne,he){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ue,ne,he)},onDidChangeNotebookCellExecutionState(ne,he,Ne){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ne,he,Ne)}},Ki={t(...ne){if(typeof ne[0]=="string"){const he=ne.shift(),Ne=!ne||typeof ne[0]!="object"?ne:ne[0];return pt.getMessage(Ue.identifier.value,{message:he,args:Ne})}return pt.getMessage(Ue.identifier.value,ne[0])},get bundle(){return pt.getBundle(Ue.identifier.value)},get uri(){return pt.getBundleUri(Ue.identifier.value)}};return{version:at.version,authentication:zi,commands:hi,comments:Vi,debug:zt,env:Fi,extensions:Hi,l10n:Ki,languages:ki,notebooks:qi,scm:mi,tasks:gi,tests:Wi,window:ji,workspace:Kt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Qe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:k.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:F.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:p.UIKind,Uri:C.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TrustedTelemetryValue:K.TrustedTelemetryValue,LogLevel:xe.LogLevel,EditSessionIdentityMatch:wt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Ct}),define(Ce[246],ke([1,0,245,33,2,239,6,14,230]),function(ee,e,i,T,y,L,C,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends L.RequireInterceptor{j(){}getModule(p,f){for(const t of this.b){const a=t(p);if(a){p=a;break}}if(this.a.has(p))return this.a.get(p).load(p,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(S.ExtHostConsoleForwarder);const p=this.h.invokeFunction(i.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,p,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(p){return p.browser}async pb(p,f,t){f=f.with({path:D(f.path,".js")});const a=p?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const l=y.URI.revive(await this.v.$asBrowserUri(f)),v=await fetch(l.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),v.status!==200)throw new Error(v.statusText);const b=await v.text(),E=`${f.toString(!0)}#vscode-extension`,w=`${b}
//# sourceURL=${E}`;let r;try{r=new Function("module","exports","require",w)}catch(c){throw console.error(a?`Loading code for extension ${a} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${f.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}p&&await this.s.initializeLocalizedMessages(p);const o={},s={exports:o},d=c=>{const u=this.r.getModule(c,f);if(u===void 0)throw new Error(`Cannot load module '${c}'`);return u};try{return t.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),r(s,o,d),s.exports!==o?s.exports:o}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),t.codeLoadingStop()}}async $setRemoteEnvironment(p){}async tb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+p;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=N;function D(g,p){return g.endsWith(p)?g:g+p}}),define(Ce[247],ke([1,0,63,33,78,246]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(T.IExtHostExtensionService,L.ExtHostExtensionService,0),(0,i.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths,0)}),define(Ce[255],ke([1,0,24,4,70,240,232,19,79,13,2,242,247]),function(ee,e,i,T,y,L,C,F,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const g=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(r){return/^(file|vscode-remote):/i.test(r)}const f=fetch.bind(self);function t(r){self.fetch=async function(o,s){return o instanceof Request||p(String(o))&&(o=(await r(N.URI.parse(String(o)))).toString(!0)),f(o,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,s,d,c,u){(async()=>(p(s.toString())&&(s=(await r(N.URI.parse(s.toString()))).toString(!0)),super.open(o,s,d??!0,c,u)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(o,s){if(/^file:/i.test(o.toString()))o=k.FileAccess.uriToBrowserUri(N.URI.parse(o.toString())).toString(!0);else if(/^vscode-remote:/i.test(o.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const c=`(${function(m){function P(Z){return typeof Z=="string"||Z instanceof URL?String(Z).replace(/^file:\/\//i,"vscode-file://vscode-app"):Z}const M=fetch.bind(self);self.fetch=function(Z,G){return Z instanceof Request?M(Z,G):M(P(Z),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(Z,G,R,A,O){return super.open(Z,P(G),R??!0,A,O)}};const V=importScripts.bind(self);self.importScripts=(...Z)=>{V(...Z.map(P))},V(m)}.toString()}('${o}'))`;s=s||{},s.name=s.name||F.basename(o.toString());const u=new Blob([c],{type:"application/javascript"}),n=URL.createObjectURL(u);return new r(n,s)}}else self.Worker=class extends C.NestedWorker{constructor(r,o){super(g,r,{name:F.basename(r.toString()),...o})}};const a=new class{constructor(){this.pid=void 0}exit(r){D()}async exists(r){return!0}async realpath(r){return r}};class l{constructor(){const o=new MessageChannel,s=new T.Emitter;let d=!1;g(o.port2,[o.port2]),o.port1.onmessage=c=>{const{data:u}=c;if(!(u instanceof ArrayBuffer)){console.warn("UNKNOWN data received",u);return}const n=i.VSBuffer.wrap(new Uint8Array(u,0,u.byteLength));if((0,y.isMessageOfType)(n,2)){d=!0,b("received terminate message from renderer");return}s.fire(n)},this.protocol={onMessage:s.event,send:c=>{if(!d){const u=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);o.port1.postMessage(u,[u])}}}}}function v(r){return new Promise(o=>{const s=r.onMessage(d=>{s.dispose();const c=JSON.parse(d.toString());r.send((0,y.createMessageOfType)(0)),o({protocol:r,initData:c})});r.send((0,y.createMessageOfType)(1))})}let b=r=>D();function E(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function w(){S.mark("code/extHost/willConnectToRenderer");const r=new l;return{onmessage(o){!E(o)||v(r.protocol).then(s=>{S.mark("code/extHost/didWaitForInitData");const d=new L.ExtensionHostMain(s.protocol,s.initData,a,null,o.data);t(c=>d.asBrowserUri(c)),b=c=>d.terminate(c)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6ed4d436a9b6ae131732f4e2a723868231f4473a/core/vs/workbench/api/worker/extensionHostWorker.js.map
